package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:act:
*/
@Table("act")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Act extends AbstractModule
{

        public Act(){
            super();
        }

        public Act(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "act";
        }

        //账户主键
        private String inr ;
        //账户 ID
        private String actid ;
        //账户行主键
        private String actbnkinr ;
        //币种
        private String cur ;
        //账户类别
        private String actcls ;
        //余额
        private BigDecimal bln  = new BigDecimal("0.00");
        //余额上限
        private BigDecimal toplit  = new BigDecimal("0.00");
        //余额下限
        private BigDecimal lowlit  = new BigDecimal("0.00");
        //内部账号
        private String innerid ;
        //合同帐号
        private String ctraid ;
        //格式化帐号
        private String formid ;
        //账户行中文名称monly
        private String chsnam ;
        //账户行英文名称monly
        private String engnam ;
        //Swift Code   monly
        private String scd ;
        //发报比例
        private BigDecimal per  = new BigDecimal("0.00");
        //是否参与清算
        private String actflg ;
        //参与国结清算
        private String gjsactflg ;
        //参与国际汇兑清算
        private String ghdactflg ;
        //是否直接清算
        private String drcflg ;
        //国结直接清算
        private String gjsdrcflg ;
        //国际汇兑直接清算
        private String ghddrcflg ;
        //全额到账标志
        private String fulrcvflg ;
        //小币种兑付标志
        private String minrcvflg ;
        //全额到账文本
        private String fulrcvtxt ;
        //小币种兑付文本
        private String minrcvtxt ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //地区分布
        private String aredtr ;
        //账户属性
        private String actpro ;
        //账户行类型
        private String acttyp ;



         public void setBln(Object o){
            if (o instanceof String) {
                this.bln = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.bln = (BigDecimal) o;
            }
        }
         public void setToplit(Object o){
            if (o instanceof String) {
                this.toplit = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.toplit = (BigDecimal) o;
            }
        }
         public void setLowlit(Object o){
            if (o instanceof String) {
                this.lowlit = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.lowlit = (BigDecimal) o;
            }
        }
         public void setPer(Object o){
            if (o instanceof String) {
                this.per = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.per = (BigDecimal) o;
            }
        }

}