package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:agb:代理行专属信息
*/
@Table("agb")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Agb extends AbstractModule
{

        public Agb(){
            super();
        }

        public Agb(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "agb";
        }

        //inr
        private String inr ;
        //是否为黑名单
        private String blkflg ;
        //是否参与国结双报
        private String chaflg ;
        //是否参与零售双报
        private String selflg ;
        //我行对代理行是否有授信关系
        private String mtaflg ;
        //我行对代理行授信额度
        private BigDecimal mtaamt  = new BigDecimal("0.00");
        //代理行对我行是否有授信关系
        private String atmflg ;
        //代理行对我行授信额度
        private BigDecimal atmamt  = new BigDecimal("0.00");
        //密押关系
        private String sceret ;
        //是否为全密押
        private String ascflg ;
        //建立时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //数据状态
        private String flg ;
        //发报比例
        private BigDecimal per  = new BigDecimal("0.00");
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;



         public void setMtaamt(Object o){
            if (o instanceof String) {
                this.mtaamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.mtaamt = (BigDecimal) o;
            }
        }
         public void setAtmamt(Object o){
            if (o instanceof String) {
                this.atmamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.atmamt = (BigDecimal) o;
            }
        }
         public void setPer(Object o){
            if (o instanceof String) {
                this.per = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.per = (BigDecimal) o;
            }
        }

}