package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:cad:
*/
@Table("cad")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cad extends AbstractModule
{

        public Cad(){
            super();
        }

        public Cad(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "cad";
        }

        //头寸记录主键
        private String inr ;
        //账户行BIC
        private String abnkbic ;
        //交易行BIC
        private String tbnkbic ;
        //业务编号
        private String ref ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //出入账标识
        private String io ;
        //业务类型
        private String bustyp ;
        //交易行名称
        private String tbnknam ;
        //账户行名称
        private String abnknam ;
        //选择框monly
        private String sel ;
        //交易行英文名称
        private String tbnkeng ;
        //账户行英文名称
        private String abnkeng ;
        //状态
        private String vewflg ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}