package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* TABLE:cdt:报文关联条件参数模型
*/
@Table("cdt")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cdt extends AbstractModule
{
		private static Logger log = LoggerFactory.getLogger(Cdt.class);

        public Cdt(){
            super();
        }

        public Cdt(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "cdt";
        }

        //惟一编号
        private String inr ;
        //账户行
        private String accpty ;
        //当前报文类型
        private String cutmsgtyp ;
        //关联报文类型
        private String relmsgtyp ;
        //类型
        private String reltyp ;
        //参与关联条件
        private String cdt ;
        //账户行名称
        private String act ;
        //建立时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //当前报文方向
        private String dir ;
        //关联报文方向
        private String rdir ;
        //是否有效
        private String valid ;
        //参号匹配产度
        private String reflen ;

        /**
        *   source:cdt.@0000.script
        */
        @Check(target="relmsgtyp",order=100)
        public boolean checkRelmsgtypN100(IContext ctx, int evtOrder)
        {
    
			if(MdaUtils.isEmpty(this.getRelmsgtyp()))
			{
			  ctx.setFieldError(this,"relmsgtyp",MdaUtils.getI18NString("cdt","CT000000"));
			}

			return true;
        }
        /**
        *   source:cdt.@0001.script
        */
        @Check(target="reltyp",order=100)
        public boolean checkReltypN100(IContext ctx, int evtOrder)
        {
    
			if(MdaUtils.isEmpty(this.getReltyp()))
			  ctx.setFieldError(this,"reltyp",MdaUtils.getI18NString("cdt","CT000001"));

			return true;
        }



}