package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:cfd:资金下拨申请与上划预报表
*/
@Table("cfd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cfd extends AbstractModule
{

        public Cfd(){
            super();
        }

        public Cfd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "cfd";
        }

        //主键
        private String inr ;
        //银行BIC码
        private String bchcod ;
        //分行名称
        private String bchnam ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //预报日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date dat;
        //上划和下拨标识
        private String flg ;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date credat;
        //选择框monly
        private String sel ;
        //状态
        private String vewflg ;
        //机构主键
        private String bchinr ;
        //汇入账号
        private String innact ;
        //汇出账号
        private String outact ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}