package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:fee:账户行扣费信息数据模型
*/
@Table("fee")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fee extends AbstractModule
{

        public Fee(){
            super();
        }

        public Fee(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "fee";
        }

        //
        private String inr ;
        //币种
        private String cur ;
        //汇款区间下限
        private BigDecimal minamt  = new BigDecimal("0.00");
        //汇款区间上限
        private BigDecimal maxamt  = new BigDecimal("0.00");
        //扣费
        private BigDecimal fee  = new BigDecimal("0.00");
        //账户ID
        private String actid ;
        //所属账户行主键
        private String ptyinr ;
        //操作类型monly
        private String oprtyp ;



         public void setMinamt(Object o){
            if (o instanceof String) {
                this.minamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.minamt = (BigDecimal) o;
            }
        }
         public void setMaxamt(Object o){
            if (o instanceof String) {
                this.maxamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.maxamt = (BigDecimal) o;
            }
        }
         public void setFee(Object o){
            if (o instanceof String) {
                this.fee = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.fee = (BigDecimal) o;
            }
        }

}