package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:grd:预报评级表
*/
@Table("grd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Grd extends AbstractModule
{

        public Grd(){
            super();
        }

        public Grd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "grd";
        }

        //主键
        private String inr ;
        //上划预报或下拨申请记录INR
        private String cfdinr ;
        //头寸记录INR
        private String cadinr ;
        //预报评级
        private String lev ;
        //分行BIC monly
        private String bchcod ;
        //分行名称monly
        private String bchnam ;
        //选择monly
        private String sel ;
        //币种monly
        private String cur ;
        //预报金额
        private BigDecimal famt  = new BigDecimal("0.00");
        //上划金额
        private BigDecimal iamt  = new BigDecimal("0.00");
        //预报日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date dat;



         public void setFamt(Object o){
            if (o instanceof String) {
                this.famt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.famt = (BigDecimal) o;
            }
        }
         public void setIamt(Object o){
            if (o instanceof String) {
                this.iamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.iamt = (BigDecimal) o;
            }
        }

}