package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:hkz:划款指令表
*/
@Table("hkz")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Hkz extends AbstractModule
{

        public Hkz(){
            super();
        }

        public Hkz(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "hkz";
        }

        //inr
        private String inr ;
        //汇入行
        private String inswif ;
        //汇入银行英文名称
        private String iegnam ;
        //汇入银行中文名称
        private String ichnnam ;
        //汇入账号
        private String innact ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //币种
        private String cur ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //状态
        private String sta ;
        //汇出行
        private String ouswif ;
        //汇出银行英文名称
        private String oegnam ;
        //汇出银行中文名称
        private String ochnam ;
        //汇出账号
        private String outact ;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}