package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:kpa:记账信息表
*/
@Table("kpa")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Kpa extends AbstractModule
{

        public Kpa(){
            super();
        }

        public Kpa(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "kpa";
        }

        //惟一编号
        private String inr ;
        //offinr
        private String offinr ;
        //被记反账的kpa inr
        private String pntinr ;
        //记账方向
        private String dir ;
        //记账类型
        private String typ ;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date crpdat;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //附言
        private String adc ;
        //收支
        private String dc ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date vludat;
        //账户行BIC
        private String actbic ;
        //记账状态
        private String sta ;
        //系统间交易流水
        private String sysref ;
        //记账日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date accdat;
        //上下级开户局代码，只有在选择了上下级往来的时候，即类型为7，必须填入
        private String ptycod ;
        //手工还是自动
        private String style ;
        //记账柜员
        private String usrnam ;
        //勾销日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date offdat;
        //发送柜员
        private String sndnam ;
        //是否是差异账
        private String isdif ;
        //前参考号
        private String ownref ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //未记账成功原因
        private String errinf ;
        //是否选中标志
        private String chkflg ;
        //关联CIPS的报文信息
        private String mpiinr ;
        //发送状态
        private String sndsta ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}