package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:ktl:记账类型映射表
*/
@Table("ktl")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ktl extends AbstractModule
{

        public Ktl(){
            super();
        }

        public Ktl(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "ktl";
        }

        //主键
        private String inr ;
        //账户行BIC
        private String bic ;
        //币种
        private String cur ;
        //业务参考号
        private String ownref ;
        //相关参考号
        private String othref ;
        //详细信息
        private String inf ;
        //记账类型编号
        private String ktpno ;
        //记账名称monly
        private String ktpnam ;
        //借贷
        private String dc ;
        //机构
        private String ptycod ;
        //金额下限
        private BigDecimal frmamt  = new BigDecimal("0.00");
        //金额上限
        private BigDecimal toamt  = new BigDecimal("0.00");
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //操作人员
        private String nam ;
        //操作时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date optdat;
        //删除状态
        private String delsta ;
        //附言
        private String infs ;
        //记账状态
        private String sta ;



         public void setFrmamt(Object o){
            if (o instanceof String) {
                this.frmamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.frmamt = (BigDecimal) o;
            }
        }
         public void setToamt(Object o){
            if (o instanceof String) {
                this.toamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.toamt = (BigDecimal) o;
            }
        }

}