package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:mpi:Message Process Information
*/
@Table("mpi")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Mpi extends AbstractModule
{

        public Mpi(){
            super();
        }

        public Mpi(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "mpi";
        }

        //
        private String inr ;
        //收发方向
        private String dir ;
        //我方编号
        private String ownref ;
        //对方编码
        private String othref ;
        //发报流水号
        private String sndnum ;
        //发报机构代码
        private String sndbic ;
        //收报机构代码
        private String rcvbic ;
        //发报行的代理行
        private String t53bic ;
        //账户行
        private String actbic ;
        //账号
        private String act ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //有效期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //除Tag20外的SHA1值
        private String n20sha ;
        //指定域集合SHA1值
        private String tagsha ;
        //指定域集合
        private String taglst ;
        //生成信息日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date gendat;
        //消息类型(如:sf2)
        private String msgtyp ;
        //消息格式类型(如:MT103)
        private String subtyp ;
        //报文处理信息
        private String excmsg ;
        //NAK/NCK错误响应代码
        private String rpscod ;
        //勾选标志monly
        private String ckflg ;
        //原流水号，例如资金清算的发报流水号过长，存在此字段
        private String srcnum ;
        //操作员
        private String usrnam ;
        //费用明细
        private String dtlchg ;
        //数字签名标志
        private String flg ;
        //对账状态
        private String actsta ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //转发报文20域
        private String fwdref ;
        //转发保文20域（双报）
        private String fwdref2 ;
        //交易机构代码
        private String branch ;
        //记账状态
        private String cjzsta ;
        //gpi报文标识
        private String gpi ;
        //uetr
        private String uetr ;
        //系统跟踪号
        private String systrackn ;
        //会计日期
        private String accdat ;
        //GPI值
        private String gpival ;
        //33B金额
        private BigDecimal selamt  = new BigDecimal("0.00");
        //33B币种
        private String selcur ;
        //71F收费信息，组装199s使用
        private String msg71f ;
        //信用证编号
        private String lcnb ;
        //通讯级标识号（电证报文头）
        private String msgid ;
        //CIPS日间/夜间标识
        private String biztyp ;
        //是否已发送明细信息
        private String sndflg ;
        //期望结算日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date expsetdat;
        //收报间参行
        private String rcvindbic ;
        //发报间参行
        private String sndindbic ;
        //付款人开户行行号
        private String paybic ;
        //收款人开户行行号
        private String recbic ;
        //系统间对账状态
        private String xdzsta ;
        //是否是mx报文
        private int ismx ;
        //MX报文类型
        private String dettyp ;
        //端对端编号(EndToEndId)
        private String endtid ;
        //登录状态
        private String loginoprtp ;
        //系统编号
        private String sid ;
        //报文编号
        private String mtp ;
        //业务类型编码
        private String txtpcd ;
        //业务种类编码
        private String ctgpcd ;
        //报文标识号
        private String mid ;
        //报文发送时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date credat;
        //发起直接参与机构
        private String insgdp ;
        //发起直接参与机构LEI码
        private String insdpl ;
        //发起参与机构
        private String insgty ;
        //发起参与机构LEI码
        private String insgpl ;
        //接收直接参与机构
        private String insddp ;
        //接收直接参与机构LEI码
        private String insddl ;
        //接收参与机构
        private String insdty ;
        //接收参与机构LEI码
        private String inspdl ;
        //系统编号
        private String syscod ;
        //备注
        private String rmk ;
        //原申请报文标识号
        private String orgmid ;
        //原申请发起参与机构
        private String orginspty ;
        //原申请接收机构标识
        private String orginapty ;
        //原报文类型
        private String orgmsgtyp ;
        //原报文发起时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date orgsnddat;
        //业务状态
        private String stscod ;
        //处理信息摘要
        private String prcmsgdig ;
        //应答信息
        private String rspmsg ;
        //处理状态
        private String prcsts ;
        //处理码
        private String proccd ;
        //拒绝信息
        private String rjcinf ;
        //终态日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date sstdat;
        //接收时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date rcvdat;
        //转发时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date trndat;
        //原被查询报文标识号
        private String orpmid ;
        //原被查询发起参与机构
        private String orpinspty ;
        //原被查询报文类型
        private String orpinapty ;
        //原业务类型代码
        private String orityp ;
        //原账务日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date oridat;
        //原账务处理状态
        private String orists ;
        //处理描述
        private String opinfo ;
        //账务日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date oriaccdat;
        //被查询业务状态
        private String trasts ;
        //订单状态
        private String bllpaysts ;
        //附言
        private String remark ;
        //系统当前状态
        private String cursyssts ;
        //业务处理码+业务拒绝信息
        private String prccod ;
        //信封内报文类型
        private String envmsgtyp ;
        //信息内容
        private String msgcnt ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }
         public void setSelamt(Object o){
            if (o instanceof String) {
                this.selamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.selamt = (BigDecimal) o;
            }
        }

}