package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:msd:
*/
@Table("msd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Msd extends AbstractModule
{

        public Msd(){
            super();
        }

        public Msd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "msd";
        }

        //主键
        private String inr ;
        //原始报文外键，0为原始报
        private String oriinr ;
        //收报/发报
        private String debdir ;
        //收发时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date rsptim;
        //参考号
        private String ref ;
        //相关参考号
        private String tscref ;
        //报文标准
        private String std ;
        //报文路径
        private String pth ;
        //报文类型
        private String mty ;
        //服务类型
        private String sty ;
        //清算行BIC
        private String clrbak ;
        //发报行BIC
        private String sedbak ;
        //收报行BIC
        private String revbak ;
        //相关渠道名
        private String chnnam ;
        //帐号
        private String act ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //币种
        private String cur ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date vludat;
        //发送状态monly
        private String seocas ;
        //失败次数monly
        private int seonum ;
        //关注原因monly
        private String ktycau ;
        //报文状态monly
        private String msgsta ;
        //回执状态monly
        private String rptsta ;
        //monly
        private String chk ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}