package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:msmlst:
*/
@Table("msmlst")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Msmlst extends AbstractModule
{

        public Msmlst(){
            super();
        }

        public Msmlst(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "msmlst";
        }

        //选择框monly
        private String chk ;
        //错误类型
        private String errmsg ;
        //收报日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date recdat;
        //起息日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //账户行
        private String chnnam ;
        //账户行BIC
        private String bic ;
        //账号
        private String acc ;
        //币种
        private String cur ;
        //对账单参考号
        private String ref ;
        //对账单编号
        private String smtno ;
        //期初余额
        private BigDecimal begamt  = new BigDecimal("0.00");
        //期末余额
        private BigDecimal endamt  = new BigDecimal("0.00");
        //期末可用余额
        private BigDecimal endvalamt  = new BigDecimal("0.00");
        //问题对账单类型
        private String typ ;
        //页数
        private int pag ;
        //明细条数
        private int dtl ;
        //对方编码
        private String othref ;
        //发报行BIC
        private String sndbic ;
        //接收日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date gendat;
        //异常信息
        private String excmsg ;
        //收报行BIC
        private String rcvbic ;
        //序列号
        private String inr ;
        //账户行主键
        private String accpty ;
        //修改后对账单号
        private String smtameno ;
        //对账单状态
        private String sta ;
        //问题类型
        private String errtyp ;
        //年份
        private String yea ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //mpsinr
        private String mpsinr ;
        //异常对账单账号
        private String act ;
        //异常对账单类型
        private String subtyp ;



         public void setBegamt(Object o){
            if (o instanceof String) {
                this.begamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.begamt = (BigDecimal) o;
            }
        }
         public void setEndamt(Object o){
            if (o instanceof String) {
                this.endamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.endamt = (BigDecimal) o;
            }
        }
         public void setEndvalamt(Object o){
            if (o instanceof String) {
                this.endvalamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.endvalamt = (BigDecimal) o;
            }
        }

}