package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:off:对账勾销表
*/
@Table("off")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Off extends AbstractModule
{

        public Off(){
            super();
        }

        public Off(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "off";
        }

        //序列号
        private String inr ;
        //勾销时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date offdat;
        //勾销类型
        private String offtyp ;
        //记账标志
        private String recsta ;
        //勾销原因
        private String offrsn ;
        //币种
        private String offcur ;
        //金额
        private BigDecimal offamt  = new BigDecimal("0.00");
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //交易日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date tradat;
        //业务参号
        private String offref ;
        //20域编号
        private String ownref ;
        //21域编号
        private String othref ;
        //交易对手
        private String oppbic ;
        //收发日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rsptim;
        //记账类型
        private String kpatyp ;
        //借贷方向
        private String offdc ;
        //差异金额
        private BigDecimal offdif  = new BigDecimal("0.00");
        //勾销方向
        private String offdir ;
        //记账日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date accdat;
        //操作人/或系统 
        private String opusr ;
        //详细信息
        private String inf ;
        //chk
        private String chk ;
        //机构
        private String ptytyp ;
        //附言monly
        private String adc ;
        //差异记账类型mon
        private String diftyp ;
        //差异机构mon
        private String diforg ;
        //差异附言mom
        private String difadc ;
        //操作状态(mom）
        private String opsta ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //渠道代码
        private String chncod ;



         public void setOffamt(Object o){
            if (o instanceof String) {
                this.offamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.offamt = (BigDecimal) o;
            }
        }
         public void setOffdif(Object o){
            if (o instanceof String) {
                this.offdif = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.offdif = (BigDecimal) o;
            }
        }

}