package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:ptyaut:(系统表)企业授权表
*/
@Table("ptyaut")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ptyaut extends AbstractModule
{

        public Ptyaut(){
            super();
        }

        public Ptyaut(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "ptyaut";
        }

        //主键
        private String inr ;
        //是否可跨步
        private String flg1 ;
        //实体类型
        private String objtyp ;
        //实体编号
        private String objinr ;
        //交易所需权限标志
        private String flg ;
        //是否完全签字
        private String flg2 ;
        //交易
        private String frm ;
        //币种
        private String cur ;
        //下限授权金额
        private BigDecimal lowamt  = new BigDecimal("0.00");
        //授权级别
        private String lvl ;
        //上限授权金额
        private BigDecimal uppamt  = new BigDecimal("0.00");
        //是否需要复核
        private String chkflg ;
        //经办标志(舍弃)
        private String oprflg ;
        //是否需要主管授权
        private String megflg ;



         public void setLowamt(Object o){
            if (o instanceof String) {
                this.lowamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.lowamt = (BigDecimal) o;
            }
        }
         public void setUppamt(Object o){
            if (o instanceof String) {
                this.uppamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.uppamt = (BigDecimal) o;
            }
        }

}