package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:rmb:人民币交易信息表
*/
@Table("rmb")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rmb extends AbstractModule
{

        public Rmb(){
            super();
        }

        public Rmb(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "rmb";
        }

        //NewField
        private String inr ;
        //发报行
        private String sedbak ;
        //收报行
        private String revbak ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //币种
        private String cur ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //业务参引号
        private String ownref ;
        //相关参引号
        private String othref ;
        //报文关联外键
        private String relinr ;
        //报文类型
        private String mty ;
        //收支
        private String dcflg ;
        //记账类型
        private String typ ;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //发报流水号
        private String sndnum ;
        //附言
        private String supdlt ;
        //isbak
        private String isbak ;
        //接收日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rsptim;
        //类型
        private String objtyp ;
        //objinr
        private String objinr ;
        //tradat
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date tradat;
        //选中memonly
        private String chk ;
        //账户行
        private String actbic ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}