package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* TABLE:smd:对账单详情表
*/
@Table("smd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Smd extends AbstractModule
{
		private static Logger log = LoggerFactory.getLogger(Smd.class);

        public Smd(){
            super();
        }

        public Smd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "smd";
        }

        //序列号
        private String inr ;
        //所属对账单INR
        private String smtinr ;
        //所属页INR
        private String smpinr ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //入账日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date accdat;
        //借贷标志
        private String dcflg ;
        //货币代码
        private String funcod ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //业务标识
        private String busflg ;
        //开户行参号
        private String ownref ;
        //服务行参号
        private String othref ;
        //详细信息
        private String inf ;
        //所属对账单编号monly
        private String smtno ;
        //修改后金额monly
        private BigDecimal newamt  = new BigDecimal("0.00");
        //收报日期monly
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date recdat;
        //账户行monly
        private String chnnam ;
        //BIC    monly
        private String bic ;
        //所属页码monly
        private String pagnum ;
        //勾销状态monly
        private String offsta ;
        //记账状态
        private String sta ;
        //记账类型
        private String typ ;
        //对账单参考号monly
        private String smtref ;
        //选中复选框monly
        private String chk ;
        //帐号
        private String act ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;

        /**
        *   source:smd.@0001.script
        */
        @Rule(target="othref",order=100)
        public boolean ruleOthrefN100(IContext ctx,int evtOrder)
        {
    
			Platform.transAndCheckRef(MdaDriver.getDatafield(this,"othref"));

			return true;
        }


         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }
         public void setNewamt(Object o){
            if (o instanceof String) {
                this.newamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.newamt = (BigDecimal) o;
            }
        }

}