package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:smp:对账单页信息表
*/
@Table("smp")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Smp extends AbstractModule
{

        public Smp(){
            super();
        }

        public Smp(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "smp";
        }

        //序列号
        private String inr ;
        //所属对账单inr
        private String smtinr ;
        //对账单参考号
        private String ref ;
        //币种
        private String cur ;
        //期初金额
        private BigDecimal begamt  = new BigDecimal("0.00");
        //期末金额
        private BigDecimal endamt  = new BigDecimal("0.00");
        //期末可用金额
        private BigDecimal endvalamt  = new BigDecimal("0.00");
        //页内试算金额
        private BigDecimal pagamt  = new BigDecimal("0.00");
        //修改后期初余额
        private BigDecimal newbegamt  = new BigDecimal("0.00");
        //修改后期末余额
        private BigDecimal newendamt  = new BigDecimal("0.00");
        //报文路径INR
        private String msdinr ;
        //分页号
        private String pagnum ;
        //修改后页号
        private String pagamenum ;
        //状态
        private String sta ;
        //问题类型
        private String errtyp ;
        //描述
        private String des ;
        //所属对账单编号
        private String smtno ;
        //选择框monly
        private String chk ;
        //收报日期monly
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date recdat;
        //账户行名称monly
        private String chnnam ;
        //BIC    monly
        private String bic ;
        //明细条数monly
        private int dtlamt ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //错误消息monly
        private String errmsg ;
        //帐号monly
        private String act ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;



         public void setBegamt(Object o){
            if (o instanceof String) {
                this.begamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.begamt = (BigDecimal) o;
            }
        }
         public void setEndamt(Object o){
            if (o instanceof String) {
                this.endamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.endamt = (BigDecimal) o;
            }
        }
         public void setEndvalamt(Object o){
            if (o instanceof String) {
                this.endvalamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.endvalamt = (BigDecimal) o;
            }
        }
         public void setPagamt(Object o){
            if (o instanceof String) {
                this.pagamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.pagamt = (BigDecimal) o;
            }
        }
         public void setNewbegamt(Object o){
            if (o instanceof String) {
                this.newbegamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.newbegamt = (BigDecimal) o;
            }
        }
         public void setNewendamt(Object o){
            if (o instanceof String) {
                this.newendamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.newendamt = (BigDecimal) o;
            }
        }

}