package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:smt:对账单信息表
*/
@Table("smt")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Smt extends AbstractModule
{

        public Smt(){
            super();
        }

        public Smt(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "smt";
        }

        //序列号
        private String inr ;
        //对账类型
        private String typ ;
        //账户行主键
        private String accpty ;
        //账户行BIC
        private String bic ;
        //账户
        private String acc ;
        //对账单参考号
        private String ref ;
        //接收日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date recdat;
        //币种
        private String cur ;
        //期初余额
        private BigDecimal begamt  = new BigDecimal("0.00");
        //期末余额
        private BigDecimal endamt  = new BigDecimal("0.00");
        //期末可用余额
        private BigDecimal endvalamt  = new BigDecimal("0.00");
        //对账单号
        private String smtno ;
        //修改后对账单号
        private String smtameno ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //对账单状态
        private String sta ;
        //问题类型
        private String errtyp ;
        //账户行中文名称monly
        private String chnnam ;
        //页数monly
        private int pag ;
        //选择框monly
        private String chk ;
        //错误信息monly
        private String errmsg ;
        //明细条数(monly)
        private int dtl ;
        //年份
        private String yea ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;



         public void setBegamt(Object o){
            if (o instanceof String) {
                this.begamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.begamt = (BigDecimal) o;
            }
        }
         public void setEndamt(Object o){
            if (o instanceof String) {
                this.endamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.endamt = (BigDecimal) o;
            }
        }
         public void setEndvalamt(Object o){
            if (o instanceof String) {
                this.endvalamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.endvalamt = (BigDecimal) o;
            }
        }

}