package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:trn:(系统表)业务流水表
*/
@Table("trn")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Trn extends AbstractModule
{

        public Trn(){
            super();
        }

        public Trn(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "trn";
        }

        //唯一编号
        private String inr ;
        //已经授权的标志码标志，当前状态
        private String relres ;
        //需要授权的标志码，目标状态
        private String relreq ;
        //交易原始币种
        private String reloricur ;
        //交易原始金额
        private BigDecimal reloriamt  = new BigDecimal("0.00");
        //经办机构
        private String optptyinr ;
        //授权币种
        private String relcur ;
        //授权金额
        private BigDecimal relamt  = new BigDecimal("0.00");
        //所属机构编号
        private String ptyinr ;
        //参考号
        private String ownref ;
        //ORD编号
        private String ordinr ;
        //经办实体
        private String optetyinr ;
        //经办实体组
        private String optetginr ;
        //对象类型
        private String objtyp ;
        //业务名称
        private String objnam ;
        //对象编号
        private String objinr ;
        //当前需要的级别
        private String nxtlev ;
        //当前需要的标志位
        private String nxtreq ;
        //交易名称
        private String nam ;
        //创建用户
        private String iniusr ;
        //交易名称
        private String inifrm ;
        //交易创建时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date inidattim;
        //业务所属实体
        private String etyinr ;
        //交易完成时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date cpldattim;
        //通知确认时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date cfmdattim;
        //所属兴业机构
        private String bnkinr ;
        //所属实体组编号
        private String etginr ;
        //业务状态
        private String sta ;
        //业务提交机构
        private String subptyinr ;
        //WFD编号
        private String wfdinr ;
        //交易用户名称
        private String usrnam ;
        //业务种类类型
        private String trntyp ;
        //经办机构主键
        private String bchinr ;
        //业务所属机构主键
        private String bchkeyinr ;
        //需要授权的标识码，目标状态
        private String sigreq ;
        //已经授权的标识码标志，当前状态
        private String sigres ;
        //操作类型
        private String oprtyp ;
        //业务所属机构名称
        private String bchnam ;
        //交易复核授权子类型
        private String frmsubtyp ;



         public void setReloriamt(Object o){
            if (o instanceof String) {
                this.reloriamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.reloriamt = (BigDecimal) o;
            }
        }
         public void setRelamt(Object o){
            if (o instanceof String) {
                this.relamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.relamt = (BigDecimal) o;
            }
        }

}