package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:yyd:银邮汇款详细信息存储表
*/
@Table("yyd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Yyd extends AbstractModule
{

        public Yyd(){
            super();
        }

        public Yyd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "yyd";
        }

        //主键索引
        private String inr ;
        //本系统编码
        private String ownref ;
        //汇票号码
        private String bilnum ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //本地时间
        private String loctim ;
        //本地日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date locdat;
        //会计日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date accdat;
        //附言
        private String addinf ;
        //交易机构代码
        private String bchkey ;
        //交易柜员编号
        private String teller ;
        //发汇人姓名
        private String paynam ;
        //发汇人证件类型
        private String payidtype ;
        //发汇人证件号码
        private String payidnum ;
        //发汇人证件到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date payidexpr;
        //发汇人地址
        private String payadr ;
        //发汇人邮政编码
        private String paypos ;
        //发汇人联系电话
        private String paypho ;
        //发汇人性别
        private String paysex ;
        //发汇人国籍
        private String paycty ;
        //发汇人职业
        private String payjob ;
        //发汇人中文姓名
        private String paynamcn ;
        //发汇人城市
        private String payciy ;
        //发汇人省份
        private String paypov ;
        //发汇人出生日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date paybriday;
        //发汇人出生国家
        private String paybricty ;
        //发汇人证件发证机构
        private String payidgov ;
        //发汇人账号
        private String payact ;
        //收汇人姓名
        private String pyenam ;
        //收汇人地址
        private String pyeadr ;
        //收汇人邮编
        private String pyepos ;
        //收汇人联系电话
        private String pyepho ;
        //收汇人账号
        private String pyeact ;
        //收汇人城市
        private String pyeciy ;
        //收汇人省
        private String pyepov ;
        //收汇银行名称
        private String pyebnknam ;
        //收汇银行所在城市
        private String pyebnkciy ;
        //收汇银行地址
        private String pyebnkadr ;
        //收汇银行bic
        private String pyebnkbic ;
        //收汇银行aba
        private String pyebnkaba ;
        //代理银行bic
        private String corbnkbic ;
        //代理银行ABA
        private String corbnkaba ;
        //SORT CODE
        private String sorcod ;
        //证明材料
        private String proinf ;
        //国际收支交易附言
        private String bopinf ;
        //其他收支交易附言
        private String othinf ;
        //标志
        private String flg ;
        //收汇国家
        private String pyecty ;
        //手续费币种
        private String feecur ;
        //MAC校验码
        private String mac ;
        //生成时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credattim;
        //发汇金额
        private BigDecimal payamt  = new BigDecimal("0.00");
        //发汇币种
        private String paycur ;
        //返回码
        private String rspcod ;
        //返回描述
        private String rspinf ;
        //发报行BIC
        private String sndbic ;
        //账户行BIC
        private String actbic ;
        //收汇人中文姓名
        private String pyenamcn ;
        //境外系统编码
        private String othref ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //退汇原因
        private String errinf ;
        //退汇币种
        private String retcur ;
        //退汇金额
        private BigDecimal retamt  = new BigDecimal("0.00");
        //原交易日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date oridat;
        //原交易流水
        private String oriseqnum ;
        //选择monly
        private String chkflg ;
        //YYT表主键
        private String yytinr ;
        //账户行BIC（54域）
        private String t54bic ;
        //账户行bic(53域)
        private String t53bic ;
        //发汇人地址1
        private String payadr1 ;
        //收汇人地址1
        private String pyeadr1 ;
        //小币种兑付币种
        private String mincur ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //审核状态
        private String chksta ;
        //待核查
        private String chkflg1 ;
        //uetr
        private String uetr ;
        //原报文33B金额
        private BigDecimal selamt  = new BigDecimal("0.00");
        //原报文33B币种
        private String selcur ;
        //费用类别
        private String dtlchg ;
        //原报文71F扣费信息
        private String msg71f ;
        //标识为境内外币还是SWIFT汇款
        private String typflg ;
        //批量新建CASE
        private String newflg ;
        //G渠道标识
        private String sweflg ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }
         public void setPayamt(Object o){
            if (o instanceof String) {
                this.payamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.payamt = (BigDecimal) o;
            }
        }
         public void setRetamt(Object o){
            if (o instanceof String) {
                this.retamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.retamt = (BigDecimal) o;
            }
        }
         public void setSelamt(Object o){
            if (o instanceof String) {
                this.selamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.selamt = (BigDecimal) o;
            }
        }

}