package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CsnselVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Csngrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Csnp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 数字证书处理
*/
@Transaction(vo= CsnselVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Csnsel extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Csnsel.class);

		@BDGetter
		private Csngrp csngrp;

		@BDGetter
		private Csnp csnp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;


		public Csnsel()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCsnp().setCsngrpHolder(()->this.getCsngrp());
           this.getCsnp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getCsngrp());
        }

        /**
        *   source:csnsel.@0000.script
        */
        @Rule(target="csnp.sel",order=100)
        public boolean ruleCsnpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","[TRANS_NAME]"+ctx.getTransName());
			if("csnsel,elcs".equals(ctx.getTransName()))
			{
			  this.getCsnp().searchCetcsn();
			}
			else if("csnsel,fxps".equals(ctx.getTransName())) //境内外币 证书查询
			{
			  this.getCsnp().searchCetcsn();
			}
			else
			{
			  MdaUtils.clear(this.getCsngrp().getCsnlst());
			  //Platform.clear($csngrp\\csn);
			  String sql = "SELECT * FROM CSN WHERE 1=1";
			  if(!MdaUtils.isEmpty(this.getCsngrp().getCsn().getCsntyp()))
			  {
			    sql +=" AND csntyp = '"+this.getCsngrp().getCsn().getCsntyp()+"'";
			  }
			  if(!MdaUtils.isEmpty(this.getCsnp().getCfixbankcode()))
			  {
			    sql +=" AND cfixbankcode like "+"'%"+this.getCsnp().getCfixbankcode()+"%'";
			  }
			  /*if(!Platform.isEmpty($csnp\\ownref.getValue()))
			    {
			    sql +=" AND ownref like "+"'%"+$csnp\\ownref.getValue()+"%'";
			    }*/
			  int datflg = 0;
			  if(!MdaUtils.isEmpty(this.getCsnp().getBegdat()))
			  {
			    sql +=" AND gendat >= ?";
			    datflg += 1;
			  }
			  if(!MdaUtils.isEmpty(this.getCsnp().getEnddat()))
			  {
			    sql +=" AND gendat <= ?";
			    datflg += 2;
			  }
			  //人民币跨境
			  if("csnsel,cps".equals(ctx.getTransName()))
			  {
			    sql += " AND TYP = '1' ";
			    if(!MdaUtils.isEmpty(this.getCsnp().getChgbic()))
			    {
			      sql += " AND chgbic = "+this.getCsnp().getChgbic();
			    }
			  }
			  else
			  {
			    sql += " AND typ = '0' ";
			  }
			  if(!MdaUtils.isEmpty(this.getCsngrp().getCsn().getSubtyp()))
			  {
			    sql += " AND subtyp = '"+this.getCsngrp().getCsn().getSubtyp()+"'";
			  }
			  sql +=" ORDER BY inr DESC";
			  if(datflg == 0)
			    Platform.mdbExecuteSQL(sql);
			  else if(datflg == 1)
			    Platform.mdbExecuteSQL(sql,Platform.formatDateTime(this.getCsnp().getBegdat(),null));
			  else if(datflg == 2)
			    Platform.mdbExecuteSQL(sql,Platform.formatDateTime(this.getCsnp().getEnddat(),"235959"));
			  else
			    Platform.mdbExecuteSQL(sql,Platform.formatDateTime(this.getCsnp().getBegdat(),null),Platform.formatDateTime(this.getCsnp().getEnddat(),"235959"));
			  Argument<String>  inr = new Argument<String>("inr");
			  Argument<String>  csntyp = new Argument<String>("csntyp");
			  Argument<String>  cfixbankcode = new Argument<String>("cfixbankcode");
			  Argument<String>  cn = new Argument<String>("cn");
			  Argument<String>  sn = new Argument<String>("sn");
			  Argument<String>  sta = new Argument<String>("sta");
			  Argument<String>  relinr = new Argument<String>("relinr");
			  Argument<String>  subtyp = new Argument<String>("subtyp");
			  Argument<Date>  gendat = new Argument<Date>("gendat");
			  Argument<String>  rem = new Argument<String>("rem");
			  log.info("{}","csntyp!!!!!!!"+csntyp);
			  while(true)
			  {
			    Platform.mdbFetchFields(inr,csntyp,cfixbankcode,cn,sn,relinr,sta,subtyp,gendat,rem);
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      this.getCsngrp().getCsnlst().add(inr,csntyp,cfixbankcode,cn,sn,sta,relinr,subtyp,gendat,rem);
			      //$csngrp\\csn.add(inr,csntyp,cfixbankcode,cn,sn,sta,relinr,subtyp,gendat,rem);
			    }
			    else
			      break;
			  }
			  Platform.mdbCloseCursor();
			  
			  //Platform.clearDatafield($csnp\\csntyp);
			  //Platform.setModified($csngrp\\csn);
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getCsngrp().getCsn(),"csntyp"));
			  if(this.getCsngrp().getCsnlst().size() == 0)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("csnsel","CT000014"),MdaUtils.getI18NString("csnsel","CT000015"));
			    return true;
			  }
			}

			return true;
        }

        /**
        *   source:csnsel.@0001.script
        */
        @Rule(target="csnp.del",order=100)
        public boolean ruleCsnpDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.clearDatafield(MdaDriver.getDatafield(this.getCsnp(),"csntyp"));
			//Platform.clearDatafield($csnp\\chgtyp);
			Platform.clearDatafield(MdaDriver.getDatafield(this.getCsngrp().getCsn(),"csntyp"));
			Platform.clearDatafield(MdaDriver.getDatafield(this.getCsnp(),"cfixbankcode"));
			Platform.clearDatafield(MdaDriver.getDatafield(this.getCsnp(),"ownref"));
			Platform.clearDatafield(MdaDriver.getDatafield(this.getCsngrp().getCsn(),"subtyp"));
			Platform.clearDatafield(MdaDriver.getDatafield(this.getCsnp(),"chgbic"));

			return true;
        }

        /**
        *   source:csnsel.@0002.script
        */
        @Rule(target="csnp.relbud",order=100)
        public boolean ruleCsnpRelbudN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*Platform.clear($csngrp\\csn);
			  if("csnsel".equals(Platform.getTransName()))
			  {
			  String own = "F" + Platform.format(Platform.today(), "yyMMddHHmmssSSS");
			  $csnp\\ownref = own;//申请序号
			  $csngrp\\csn\\subtyp = "088";//报文类型
			  $csngrp\\csn\\csntyp = "1";//变更类型
			  $csngrp\\csn\\bnkbic = "PSBCCNBJXXX";//发起节点
			  $csngrp\\csn\\rem = "数字证书新增操作";
			  Platform.disableDatafield($csnp\\ownref);
			  Platform.disableDatafield($csngrp\\csn\\subtyp);
			  Platform.disableDatafield($csngrp\\csn\\csntyp);
			  Platform.disableDatafield($csngrp\\csn\\bnkbic);
			  Platform.popup($csnp\\shwpnl);
			  }
			  else if("csnsel,cps".equals(Platform.getTransName()))
			  {
			  String own = "C" + Platform.format(Platform.today(), "yyMMddHHmmssSSS");
			  $csnp\\msgcod = own;
			  $csnp\\sndnam = "PSBCCNBJXXX";
			  $csnp\\valdat = Platform.parseDate(Platform.format(Platform.today(),"yyyyMMdd"),"yyyyMMdd");
			  $csnp\\csngrp\\csn\\subtyp = "cips.903.001.01";
			  $csnp\\subtyp="cips.903.001.01";
			  Platform.setModified( $csnp\\subtyp);
			  List<CodetableItem> lst = new ArrayList<CodetableItem>();
			  lst.add(new CodetableItem("新增","ADDD"));
			  lst.add(new CodetableItem("撤销","DELE"));
			  Platform.setValues($csnp\\csntyp,lst);
			  $csnp\\csntyp = "ADDD";
			  Platform.disableDatafield($csnp\\msgcod);
			  Platform.disableDatafield($csnp\\sndnam);
			  Platform.disableDatafield($csnp\\subtyp);
			  Platform.clearDatafield($csnp\\rcvnam);
			  Platform.popup($csnp\\cpspnl);
			  }
			  //新增电子信用证证书绑定
			  else if("csnsel,elcs".equals(Platform.getTransName()))
			  {
			  Platform.setModified($csnp\\snddirpty);
			  $csnp\\chgtp = "CC00";
			  $csnp\\msgcod =Platform.format(Platform.today(), "yyyyMMddHHmmssSSS");
			  $csnp\\sndnam = "403100000004";
			  $csnp\\rcvnam = "0000";
			  $csnp\\snddirpty = "403100000004";
			  $csnp\\sndpty = "403100000004";
			  $csnp\\rcvdirpty = "000000000000";
			  $csnp\\rcvpty = "000000000000";
			  Platform.disableDatafield($csnp\\msgcod);
			  Platform.disable($csnp\\snddirpty);
			  Platform.disable($csnp\\msgcod);
			  Platform.disable($csnp\\sndnam);
			  Platform.disable($csnp\\rcvnam);
			  Platform.disableDatafield($csnp\\subtyp);
			  Platform.clearDatafield($csnp\\rcvnam);
			  Platform.popup($csnp\\elcpnl);
			  }*/

			

			return true;
        }

        /**
        *   source:csnsel.@0003.script
        */
        @Rule(target="csnp.mtabut.exp",order=100)
        public boolean ruleCsnpMtabutExpN100(){
            IContext ctx = MdaEnv.getContext();
            
			//下载申请
			//判断当前接入机构是否能够下载
			/*String path = Platform.catPath(Platform.getRootPath(), "cfg");
			  String propertyPath = Platform.catPath(path,"rcvsndmsg.properties");
			  String cfixbankcode = Platform.getPropertyValue(propertyPath,"OrigSender");
			  Platform.clear($csngrp\\csn);
			  Platform.errorCode();*/
			//查询数据库
			//Platform.mdbRead($csngrp\\csn,new Argument<String>("cfixbankcode",cfixbankcode),new Argument<String>("csntyp","3"),new Argument<String>("sta","02"));
			//if(Platform.errorCode()==NO_ERROR)
			//{
			log.debug("{}","[Export_To_Excel]");
			IStream is = this.getCsnp().getMtabut().getExp();
			is.setType("xls");
			is.setName("Csn"+MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss")+".xls");
			log.debug("{}","[Trans_Name]"+ctx.getTransName());
			if("csnsel,elcs".equals(ctx.getTransName()))
			{
			  List<Object[]> lst = new ArrayList<Object[]>();
			  String [] title= new String[14];
			  title[0] = MdaUtils.getI18NString("csnsel","CT000032") ;
			  title[1] = MdaUtils.getI18NString("csnsel","CT000033");
			  title[2] = MdaUtils.getI18NString("csnsel","CT000034");
			  title[3] = MdaUtils.getI18NString("csnsel","CT000035");
			  title[4] = MdaUtils.getI18NString("csnsel","CT000576");
			  title[5] = MdaUtils.getI18NString("csnsel","CT000577") ;
			  title[6] = MdaUtils.getI18NString("csnsel","CT000578") ;
			  title[7] = MdaUtils.getI18NString("csnsel","CT000579") ;
			  title[8] = MdaUtils.getI18NString("csnsel","CT000587") ;
			  title[9] = MdaUtils.getI18NString("csnsel","CT000588") ;
			  title[10] = MdaUtils.getI18NString("csnsel","CT000589") ;
			  title[11] = MdaUtils.getI18NString("csnsel","CT000590") ;
			  title[12] = MdaUtils.getI18NString("csnsel","CT000591") ;
			  title[13] = MdaUtils.getI18NString("csnsel","CT000592") ;
			  lst.add(title);
			  for(int i=0;i<this.getCsnp().getCsngrp().getCetcsnlst().fullSize();i++)
			  {
			    Object [] line = new Object[14];
			    Date dattim = this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getGendat();
			    line[0] = MdaUtils.format(dattim,"yyyy/MM/dd HH:mm:ss");
			    line[1]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getCertdn();
			    line[2]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getCertsn();
			    line[3]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getSta();
			    String sta = this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getSta();
			    if(MdaUtils.isEmpty(sta))
			      line[3] = "";
			    else
			      line[3] = MdaUtils.getCodetableLabel("bnksta",sta);
			    line[4]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getSnddirpty();
			    line[5]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getSndpty();
			    line[6]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getRcvdirpty();
			    line[7]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getRcvpty();
			    String chnsta = this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getCsntyp();
			    log.info("{}","[csntyp csntyp.values]"+chnsta+" "+this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getCsntyp());
			    if(MdaUtils.isEmpty(chnsta))
			    {
			      line[8] = "";
			    }
			    else
			    {
			      line[8] = MdaUtils.getCodetableLabel("chgtyp",chnsta);
			    }
			    line[9]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getRem();
			    line[10]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getSubtyp();
			    line[11]=this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getCerbdy();
			    line[12]= this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getCertefdat();
			    line[13] = this.getCsnp().getCsngrp().getCetcsnlst().getElement(i).getCertindat();
			    lst.add(line);
			  }
			  MdaUtils.unloadExcel(lst,is,false);
			}
			else
			{
			  List<Object[]> lst = new ArrayList<Object[]>();
			  String [] title= new String[10];
			  title[0] = MdaUtils.getI18NString("csnsel","CT000600") ;
			  title[1] = MdaUtils.getI18NString("csnsel","CT000601");
			  title[2] = MdaUtils.getI18NString("csnsel","CT000602");
			  title[3] = MdaUtils.getI18NString("csnsel","CT000603");
			  title[4] = MdaUtils.getI18NString("csnsel","CT000597");
			  title[5] = MdaUtils.getI18NString("csnsel","CT000598") ;
			  title[6] = MdaUtils.getI18NString("csnsel","CT000593") ;
			  title[7] = MdaUtils.getI18NString("csnsel","CT000594") ;
			  title[8] = MdaUtils.getI18NString("csnsel","CT000595") ;
			  title[9] = MdaUtils.getI18NString("csnsel","CT000596") ;

			  lst.add(title);
			  for(int i=0;i<this.getCsnp().getCsngrp().getCsnlst().fullSize();i++)
			  {
			    Object [] line = new Object[10];
			    Date dattim = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getGendat();
			    line[0] = MdaUtils.format(dattim,"yyyy/MM/dd HH:mm:ss");
			    line[1] = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getBnkbic();
			    String chnsta = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getCsntyp();
			    if(MdaUtils.isEmpty(chnsta))
			      line[2] = "";
			    else
			      line[2] = MdaUtils.getCodetableLabel("csntyp",chnsta);
			    line[3] = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getCn();
			    line[4] = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getSn();
			    line[5] = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getSubtyp();
			    String sta = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getSta();
			    if(MdaUtils.isEmpty(sta))
			      line[6] = "";
			    else
			      line[6] = MdaUtils.getCodetableLabel("bnksta",sta);
			    line[7] = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getRem();
			    line[8] = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getBnknam();
			    line[9] = this.getCsnp().getCsngrp().getCsnlst().getElement(i).getLstdat();
			    lst.add(line);
			  }
			  MdaUtils.unloadExcel(lst,is,false);
			}
			// }
			/* else
			  {
			  Platform.message(#CT000591,#CT000592);
			  }*/

			return true;
        }

        /**
        *   source:csnsel.@0006.script
        */
        @Rule(target="csngrp.csnlst",order=100)
        public boolean ruleCsngrpCsnlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("csnsel".equals(ctx.getTransName()))
			{
			  int index = 0;
			  if(index > -1)
			  {
			    if("2".equals(this.getCsngrp().getCsnlst().getElement(index).getCsntyp()))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("csnsel","CT000160"),MdaUtils.getI18NString("csnsel","CT000161"));
			      return true;
			    }
			    else
			    {
			      String inr = this.getCsngrp().getCsnlst().getElement(index).getInr();
			      ctx.storeData("csninr",inr);
			      Platform.mchain("csndtl");
			    }
			  }
			  else
			  {
			    ctx.setMessage(MdaUtils.getI18NString("csnsel","CT000542"),MdaUtils.getI18NString("csnsel","CT000543"));
			    return true;
			  }
			}

			return true;
        }

        /**
        *   source:csnsel.@0012.script
        */
        @Rule(target="csnp.fftadd",order=100)
        public boolean ruleCsnpFftaddN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","fftadd fftpnl pop1");
			MdaUtils.clear(this.getCsngrp().getCsn());
			
			this.getCsnp().setChgtp( "CC00");
			this.getCsnp().setMsgcod(MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmssSSS"));
			this.getCsnp().setSndnam( "403100000004");
			this.getCsnp().setRcvnam( "0000");
			this.getCsnp().setSnddirpty( "403100000004");
			this.getCsnp().setSndpty( "403100000004");
			this.getCsnp().setRcvdirpty( "000000000000");
			this.getCsnp().setRcvpty( "000000000000");
			Platform.disableDatafield(MdaDriver.getDatafield(this.getCsnp(),"msgcod"));
			
			
			
			
			Platform.disableDatafield(MdaDriver.getDatafield(this.getCsnp(),"subtyp"));
			Platform.clearDatafield(MdaDriver.getDatafield(this.getCsnp(),"rcvnam"));
			
			log.info("{}","fftadd fftpnl pop2");

			return true;
        }

        /**
        *   source:csnsel.@0014.script
        */
        @Rule(target="csnp.kt903",order=100)
        public boolean ruleCsnpKt903N100(){
            IContext ctx = MdaEnv.getContext();
            
			
			this.getCsnp().setRmk(NULLSTR);
			this.getCsnp().setMsgid(NULLSTR);

			String s =MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmssSS");
			this.getCsnp().setMsgid( s.substring(0,16));

			log.debug("{}","903 msgid = "+ this.getCsnp().getMsgid());
			this.getCsnp().setInstgdrctpty( "PSBCCNBJXXX");
			this.getCsnp().setInstgpty( "PSBCCNBJXXX");
			this.getCsnp().setInstddrctpty( "00000000000");
			this.getCsnp().setInstdpty( "00000000000");
			this.getCsnp().setSyscd("FXPS");

			List<CodetableItem> lst = new ArrayList<CodetableItem>();
			lst.add(new CodetableItem("新增","CC00"));
			lst.add(new CodetableItem("撤销","CC02"));
			MdaUtils.setValues(this.getCsnp(),"chgtyp",lst);

			this.getCsnp().setChgtyp("CC00");

			Platform.disableDatafield(MdaDriver.getDatafield(this.getCsnp(),"msgid"));
			
			
			
			
			
			Platform.disableDatafield(MdaDriver.getDatafield(this.getCsnp(),"type"));

			


			return true;
        }


        /**
        *   source:csnsel.@0010.script
        */
        @Check(target="csnp.bnkbic",order=100)
        public boolean checkCsnpBnkbicN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCsnp().getBnkbic()))
			  return true;
			String bic = this.getCsnp().getBnkbic();
			bic = bic.toUpperCase();
			if(!bic.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"csnp.bnkbic",MdaUtils.getI18NString("csnsel","CT000580"));
			}
			this.getCsnp().setBnkbic( bic);
			

			return true;
        }


        /**
        *   source:csnsel.@0009.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","[TRANS_NAME]"+ctx.getTransName());
			
			this.getCsnp().setBegdat( Platform.formatDateTime(MdaUtils.add(MdaUtils.today(),-3),"0"));
			this.getCsnp().setEnddat( Platform.formatDateTime(MdaUtils.today(),"235959"));
			
			
			this.getCsnp().setDypanel(this.getCsnp().getCsnlst());
			
			if("csnsel,cps".equals(ctx.getTransName()))
			{
			  this.getCsnp().setTyp( "人民币跨境支付");
			  this.getCsnp().setChgtxt( "参与机构行号：");
			  
			  List<CodetableItem> lst = new ArrayList<CodetableItem>();
			  lst.add(new CodetableItem("新增","ADDD"));
			  lst.add(new CodetableItem("撤销","DELE"));
			  MdaUtils.setValues(this.getCsngrp().getCsn(),"csntyp",lst);
			  
			  //sulike CIPS隐藏此按钮 20210120
			  //daixuan CIPS隐藏此按钮 20210325
			
			  
			  
			  
			  

			  
			  
			}
			else if("csnsel,elcs".equals(ctx.getTransName()))
			{
			  Platform.setDefaultDB("fxd");
			  this.getCsnp().setTyp( "电子信用证");
			  this.getCsnp().setChgtxt( "直接发起参与机构：");
			  this.getCsnp().setCfixbankcode("403100000004");
			  this.getCsnp().setChgbic("403100000004");
			  this.getCsnp().setDypanel(this.getCsnp().getElclst());
			  this.getCsnp().setChgtp("");
			  
			  
			  //Platform.disable($csnp\\bnkbic);
			  
			  
			  
			  //sulike ELCS显示此按钮 20210120
			  //daixuan ELCS显示此按钮 20210325
			
			  
			  
			  
			  

			  
			  

			}
			else if("csnsel,fxps".equals(ctx.getTransName()))//境内外币管理-证书查询
			{
			  Platform.setDefaultDB("swd");
			  this.getCsnp().setTyp( "境内外币");
			  // $csnp\\chgtxt = "直接发起参与机构：";
			
			  
			  
			  //$csnp\\bnkbic="PSBCCNBJXX";
			  this.getCsnp().setChgbic("PSBCCNBJXX");
			  this.getCsnp().getCsngrp().getCsn().setSubtyp("903");
			  this.getCsnp().setDypanel(this.getCsnp().getElclst());

			  List<CodetableItem> lst1 = new ArrayList<CodetableItem>();
			  lst1.add(new CodetableItem("新增","CC00"));
			  lst1.add(new CodetableItem("撤销","CC02"));
			  MdaUtils.setValues(this.getCsnp(),"chgtp",lst1);

			  log.debug("{}","=========lst1========");
			  this.getCsnp().setChgtp( "CC00");

			  

			  //Platform.disable($csnp\\csngrp\\csn\\subtyp);
			  Platform.disableDatafield(MdaDriver.getDatafield(this.getCsnp().getCsngrp().getCsn(),"subtyp"));

			  
			  //Platform.disable($csnp\\bnkbic);
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  

			}
			else
			{
			  this.getCsnp().setTyp( "境内外币");
			  
			  
			  //Platform.invisible($csnp\\upload);//sulike FMT隐藏此按钮 20210120
			  //daixuan FMT显示此按钮 20210325
			  

			  
			  
			  
			  

			  
			  

			}


			return true;
        }







}