package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbabrcVO;

import com.ceb.gjjs.mda.manager.module.Ptygrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Brcp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 机构注册
*/
@Transaction(vo= DbabrcVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbabrc extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbabrc.class);

		@BDGetter
		private Ptygrp ptygrp;

		@BDGetter
		private Brcp brcp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;


		public Dbabrc()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBrcp().setMtabutHolder(()->this.getMtabut());
           this.getBrcp().setPtygrpHolder(()->this.getPtygrp());
           this.getMtabut().setMtagrpHolder(()->this.getPtygrp());
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbabrc.this.getFieldPath("ptygrp.rec.inr");}
 				public void setValue(String arg){Dbabrc.this.getPtygrp().getRec().setInr(arg);}
 				public String getValue(){return Dbabrc.this.getPtygrp().getRec().getInr();}}
			 );
        }

        /**
        *   source:dbabrc.@0001.script
        */
        @Rule(target="brcp.submit",order=100)
        public boolean ruleBrcpSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*log.debug("提交");
			  if("0".equals($brcgrp\\rec\\brhlvl.getValue()) && checkRootBranchIsExists())
			  {
			  Platform.error($brcgrp\\rec\\brhlvl,#CT000020);
			  return;
			  }
			  if(!$brcp.dataChecked())
			  return;
			  $brcgrp\\rec\\inr = Platform.sdbCounter("pty");
			  log.debug("@@@@ pty-inr:" + $brcgrp\\rec\\inr.getValue() + " @@@@");
			  $brcgrp\\rec\\status.setValue("0");
			  $brcgrp\\rec\\ptytyp.setValue("A");
			  String adrinr = Platform.sdbCounter("adr");
			  $brcgrp\\adr\\inr.setValue(adrinr);
			  //log.debug("@@@@ adr-inr:" + adrinr + " @@@@");
			  String ptainr = Platform.sdbCounter("pta");
			  $brcgrp\\pta\\inr.setValue(ptainr);
			  //log.debug("@@@@ pta-inr:" + ptainr + " @@@@");
			  $brcgrp\\pta\\ptyinr.setValue($brcgrp\\rec\\inr.getValue());
			  $brcgrp\\pta\\ptytyp.setValue("2");
			  $brcgrp\\pta\\ptyextkey.setValue($brcgrp\\rec\\extkey.getValue());
			  $brcgrp\\pta\\objinr.setValue(adrinr);
			  $brcgrp\\pta\\objtyp.setValue("adr");
			  //==============设置BCH表的值==================
			  $brcp.setBranchData();
			  //===========================================
			  int errorcode = Platform.errorCode();
			  Platform.mdbBegin();
			  Platform.mdbInsert($brcgrp\\rec);
			  errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT000021,#CT000045);
			  Platform.mdbRollback();
			  return;
			  }
			  Platform.mdbInsert($brcgrp\\adr);
			  errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT000046,#CT000128);
			  Platform.mdbRollback();
			  return;
			  }
			  Platform.mdbInsert($brcgrp\\pta);
			  errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT000189,#CT000190);
			  Platform.mdbRollback();
			  return;
			  }
			  Platform.mdbInsert($brcgrp\\bch);
			  errorcode = Platform.errorCode();
			  if(errorcode == NO_ERROR)
			  {
			  Platform.mdbCommit();
			  Platform.message(#CT000191,#CT000192);
			  Platform.mchain("dblbrc");
			  }
			  else
			  {
			  Platform.message(#CT000193,#CT000194);
			  Platform.mdbRollback();
			  return;
			  }*/

			return true;
        }

        /**
        *   source:dbabrc.@0002.script
        */
        @Rule(target="brcp.cancel",order=100)
        public boolean ruleBrcpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*Platform.returnToCaller();*/

			return true;
        }

        /**
        *   source:dbabrc.@0005.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			//$trnmod.trnSetFromStaticContract("机构管理","新增",$usdgrp\\rec\\nam.getValue());
			this.getTrnmod().trnSetFromContract("机构管理","新增",this.getPtygrp().getRec().getNam());
			///保存页面快照
			//$trnmod.savTrnDsp($brcp\\edip,$trnmod\\trn\\inr.getValue());
			this.getTrnmod().savePanelDisplay(this.getBrcp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }


        /**
        *   source:dbabrc.@0007.script
        */
        @Check(target="ptygrp.rec.brhlvl",order=100)
        public boolean checkPtygrpRecBrhlvlN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("0".equals(this.getPtygrp().getRec().getBrhlvl()) && checkRootBranchIsExists())
			{
			  ctx.setFieldError(this,"ptygrp.rec.brhlvl",MdaUtils.getI18NString("dbabrc","CT000197"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbabrc.@0008.script
        */
        @Check(target="ptygrp.rec.cid",order=100)
        public boolean checkPtygrpRecCidN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getRec().getCid()))
			{
			  ctx.setFieldError(this,"ptygrp.rec.cid",MdaUtils.getI18NString("dbabrc","CT000198"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbabrc.@0009.script
        */
        @Check(target="ptygrp.rec.chnnam",order=100)
        public boolean checkPtygrpRecChnnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getRec().getChnnam()))
			{
			  ctx.setFieldError(this,"ptygrp.rec.chnnam",MdaUtils.getI18NString("dbabrc","CT000199"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbabrc.@0010.script
        */
        @Check(target="ptygrp.bch.cnadr1",order=100)
        public boolean checkPtygrpBchCnadr1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getCnadr1()))
			{
			  ctx.setFieldError(this,"ptygrp.bch.cnadr1",MdaUtils.getI18NString("dbabrc","CT000201"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbabrc.@0011.script
        */
        @Check(target="ptygrp.adr.adr",order=100)
        public boolean checkPtygrpAdrAdrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getAdr().getAdr()))
			{
			  ctx.setFieldError(this,"ptygrp.adr.adr",MdaUtils.getI18NString("dbabrc","CT000203"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbabrc.@0013.script
        */
        @Check(target="ptygrp.bch.branch",order=100)
        public boolean checkPtygrpBchBranchN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getBranch()))
			{
			  ctx.setFieldError(this,"ptygrp.bch.branch",MdaUtils.getI18NString("dbabrc","CT000207"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbabrc.@0014.script
        */
        @Check(target="ptygrp.rec.etyinr",order=100)
        public boolean checkPtygrpRecEtyinrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getRec().getEtyinr()))
			{
			  ctx.setFieldError(this,"ptygrp.rec.etyinr",MdaUtils.getI18NString("dbabrc","CT000208"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbabrc.@0015.script
        */
        @Check(target="ptygrp.rec.extkey",order=100)
        public boolean checkPtygrpRecExtkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getRec().getExtkey()))
			{
			  ctx.setFieldError(this,"ptygrp.rec.extkey",MdaUtils.getI18NString("dbabrc","CT000211"));
			  return false;
			}
			else
			{
			  String bic =this.getPtygrp().getRec().getExtkey();
			  //int bic1 = Integer.parseInt(bic);
			  int bic1 = bic.length();

			  if(bic1<8||bic1>11)
			  {
			    ctx.setFieldError(this,"ptygrp.rec.extkey",MdaUtils.getI18NString("dbabrc","CT000212"));
			    return false;
			  }
			}

			return true;
        }


        /**
        *   source:dbabrc.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> cts = this.getBrcp().getPtyCT();
			MdaUtils.setValues(this.getBrcp(),"pntinr",cts);
			MdaUtils.setValues(this.getPtygrp().getRec(),"pntinr",cts);

			//20181220注释，由于下拉框未能正常显示
			//Platform.setValues($ptygrp\\rec\\brhlvl,$sysmod.getBranchLevelCodetable());
			
			log.debug("{}","@@@@ 机构注册 dbabrc @@@@");
			this.getBrcp().setTit("机构注册交易");
			

			return true;
        }


        /**
        *   source:dbabrc.@0004.script
        */
        public boolean checkRootBranchIsExists()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument<String> inr = new Argument<String>("inr");
			Platform.mdbExecuteSQL("select inr from bch where lev = '0'");
			Platform.mdbFetchFields(inr);
			Platform.mdbCloseCursor();
			log.debug("{}","inr:" + inr.value);
			if(!MdaUtils.isEmpty(inr))
			  return true;
			else
			  return false;
		}






}