package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbaetgVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etggrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Etgp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体组注册
*/
@Transaction(vo= DbaetgVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbaetg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbaetg.class);

		@BDGetter
		private Etggrp etggrp;

		@BDGetter
		private Etgp etgp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dbaetg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtgp().setEtggrpHolder(()->this.getEtggrp());
           this.getEtgp().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbaetg.this.getFieldPath("etggrp.rec.inr");}
 				public void setValue(String arg){Dbaetg.this.getEtggrp().getRec().setInr(arg);}
 				public String getValue(){return Dbaetg.this.getEtggrp().getRec().getInr();}}
			 );
           this.getMtabut().setMtagrpHolder(()->this.getEtggrp());
        }

        /**
        *   source:dbaetg.@0001.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			this.getTrnmod().trnSetFromContract("实体组管理","新增",this.getEtggrp().getRec().getNam());
			///保存页面快照
			this.getTrnmod().savePanelDisplay(this.getEtgp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }


        /**
        *   source:dbaetg.@0002.script
        */
        @Check(target="etggrp.rec.nam",order=100)
        public boolean checkEtggrpRecNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtggrp().getRec().getNam()))
			{
			  ctx.setFieldError(this,"etggrp.rec.nam",MdaUtils.getI18NString("dbaetg","CT000000"));
			  return false;
			}
			else
			{
			  if(this.getEtggrp().checkEtgIsExists(MdaDriver.getDatafield(this.getEtggrp().getRec(),"nam")))
			  {
			    ctx.setFieldError(this,"etggrp.rec.nam",MdaUtils.getI18NString("dbaetg","CT000003"));
			    return false;
			  }
			}

			return true;
        }


        /**
        *   source:dbaetg.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			log.debug("{}","@@@@ 实体组注册 dbaetg @@@@");
			this.getEtgp().setTit("实体组注册交易");
			

			return true;
        }








}