package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbaetyVO;

import com.ceb.gjjs.mda.manager.module.Etygrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etyp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体注册
*/
@Transaction(vo= DbaetyVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbaety extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbaety.class);

		@BDGetter
		private Etygrp etygrp;

		@BDGetter
		private Etyp etyp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dbaety()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtyp().setEtygrpHolder(()->this.getEtygrp());
           this.getEtyp().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbaety.this.getFieldPath("etygrp.rec.inr");}
 				public void setValue(String arg){Dbaety.this.getEtygrp().getRec().setInr(arg);}
 				public String getValue(){return Dbaety.this.getEtygrp().getRec().getInr();}}
			 );
           this.getMtabut().setMtagrpHolder(()->this.getEtygrp());
        }

        /**
        *   source:dbaety.@0001.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			this.getTrnmod().trnSetFromContract("实体管理","新增",this.getEtygrp().getRec().getRef());
			///保存页面快照
			this.getTrnmod().savePanelDisplay(this.getEtyp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }


        /**
        *   source:dbaety.@0002.script
        */
        @Check(target="etygrp.rec.ref",order=100)
        public boolean checkEtygrpRecRefN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtygrp().getRec().getRef()))
			{
			  ctx.setFieldError(this,"etygrp.rec.ref",MdaUtils.getI18NString("dbaety","CT000000"));
			  return false;
			}
			else
			{
			  if(this.getEtygrp().checkEtyIsExists(MdaDriver.getDatafield(this.getEtygrp().getRec(),"ref")))
			  {
			    ctx.setFieldError(this,"etygrp.rec.ref",MdaUtils.getI18NString("dbaety","CT000003"));
			    return false;
			  }
			}

			return true;
        }

        /**
        *   source:dbaety.@0004.script
        */
        @Check(target="etygrp.rec.etginr",order=100)
        public boolean checkEtygrpRecEtginrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtygrp().getRec().getEtginr()))
			{
			  ctx.setFieldError(this,"etygrp.rec.etginr",MdaUtils.getI18NString("dbaety","CT000004"));
			  return false;
			}

			return true;
        }


        /**
        *   source:dbaety.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			log.debug("{}","@@@@ 实体注册 dbaety @@@@");
			this.getEtyp().setTit("实体注册交易");
			

			return true;
        }








}