package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbarolVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rolp;
import com.ceb.gjjs.mda.manager.module.Rolgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 角色新增
*/
@Transaction(vo= DbarolVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbarol extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbarol.class);

		@BDGetter
		private Rolgrp rolgrp;

		@BDGetter
		private Rolp rolp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Dbarol()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getRolp().setRolgrpHolder(()->this.getRolgrp());
           this.getRolp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getRolgrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbarol.this.getFieldPath("rolgrp.rec.inr");}
 				public void setValue(String arg){Dbarol.this.getRolgrp().getRec().setInr(arg);}
 				public String getValue(){return Dbarol.this.getRolgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dbarol.@0002.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			/*log.debug("submit 200");
			  $rolgrp\\recsavflg="new";
			  String rolinr=Platform.sdbCounter("rol");
			  $rolgrp\\rec\\inr=rolinr;
			  $rolgrp\\rec\\flg="0";
			  Platform.clear($rolgrp\\oldlst);
			  Platform.clear($rolgrp\\newlst);
			  $rolp.addVisibleFrm(rolinr);
			  $rolp.addOftenFrm(rolinr);
			  $rolp.addOriList(rolinr);*/
			///保存交易流水
			//$trnmod.trnSetFromStaticContract("角色维护","新增",$rolgrp\\rec\\nam.getValue());
			this.getTrnmod().trnSetFromContract("参数管理","角色信息新增",this.getRolgrp().getRec().getNam());
			///保存页面快照
			//$trnmod.savTrnDsp($rolp\\dbarolpnl,$trnmod\\trn\\inr.getValue());
			this.getTrnmod().savePanelDisplay(this.getRolp().getDbarol(),this.getTrnmod().getTrn().getInr());

			return true;
        }

        /**
        *   source:dbarol.@0007.script
        */
        @Rule(target="mtabut.add",order=100)
        public boolean ruleMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  for(int i=$rolgrp\\frmlst1.fullSize() - 1;i>=0;i--)
			  {
			  if("X".equals($rolgrp\\frmlst1[i]\\chk.getValue()))
			  {
			  $rolgrp\\frmlst1[i]\\chk.setValue("");
			  $rolgrp\\frmlst2.add($rolgrp\\frmlst1[i]);
			  $rolgrp\\frmlst1.remove(i);
			  }
			  }
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  //未分配
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;
			  Platform.setModified($rolp\\number1);
			  Platform.setModified($rolp\\number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);*/

			return true;
        }

        /**
        *   source:dbarol.@0008.script
        */
        @Rule(target="rolp.addall",order=100)
        public boolean ruleRolpAddallN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  for(int i=0;i<$rolgrp\\frmlst1.fullSize();i++)
			  {
			  $rolgrp\\frmlst2.add($rolgrp\\frmlst1[i]);
			  }
			  Platform.clear($rolgrp\\frmlst1);
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;
			  Platform.setModified($rolp\\number1);
			  Platform.setModified($rolp\\number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);*/

			return true;
        }

        /**
        *   source:dbarol.@0009.script
        */
        @Rule(target="rolp.rev",order=100)
        public boolean ruleRolpRevN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  for(int i=$rolgrp\\frmlst2.fullSize() - 1;i>=0;i--)
			  {
			  if("X".equals($rolgrp\\frmlst2[i]\\chk.getValue()))
			  {
			  $rolgrp\\frmlst2[i]\\chk.setValue("");
			  $rolgrp\\frmlst1.add($rolgrp\\frmlst2[i]);
			  $rolgrp\\frmlst2.remove(i);
			  }
			  }
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  //未分配
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;
			  Platform.setModified($rolp\\number1);
			  Platform.setModified($rolp\\number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);*/

			return true;
        }

        /**
        *   source:dbarol.@0010.script
        */
        @Rule(target="rolp.revall",order=100)
        public boolean ruleRolpRevallN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.clear($rolgrp\\newlst);
			  for(int i=0;i<$rolgrp\\frmlst2.fullSize();i++)
			  {
			  $rolgrp\\frmlst1.add($rolgrp\\frmlst2[i]);
			  }
			  Platform.clear($rolgrp\\frmlst2);
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;
			  Platform.setModified($rolp\\number1);
			  Platform.setModified($rolp\\number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);*/

			return true;
        }

        /**
        *   source:dbarol.@0013.script
        */
        @Rule(target="rolp.mtabut.rtn",order=50)
        public boolean ruleRolpMtabutRtnN50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("rolinr",this.getRolgrp().getRec().getInr());

			return true;
        }



        /**
        *   source:dbarol.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//禁用复核授权级别查询下拉框，避免出现不匹配问题。
			

			return true;
        }

        /**
        *   source:dbarol.@0004.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  初始化未分配交易列表
			  **/
			/*log.debug("init 200");
			  //获取全部交易
			  Argument arg=new Argument();
			  arg = new Argument<String>("frmtyp","A");
			  arg = arg.or(new Argument<String>("frmtyp","B"));
			  //初始化可视列表
			  Argument arg0 = Argument.and(arg,new Argument<String>("typ","0"));
			  //初始化不可视列表
			  Argument arg1 = Argument.and(arg,new Argument<String>("typ","1"));
			  //初始化常用列表
			  Argument arg2 = Argument.and(arg,new Argument<String>("typ","2"));
			  Platform.mdbReadset($rolgrp\\frmlst1,arg1);
			  Platform.mdbReadset($rolgrp\\frmlst2,arg0);
			  Platform.mdbReadset($rolgrp\\oftlst, arg2);*/

			return true;
        }

        /**
        *   source:dbarol.@0006.script
        */
        @Init(order=3000)
        public boolean	init3000(){
            IContext ctx = MdaEnv.getContext();
            
			/*String name1=Platform.getI18nValue("eibs","menu.dbrusr");
			  log.debug("name1 is:"+name1);
			  for(#frm frm: $rolgrp\\frmlst2)
			  {
			  String key=$$frm\\dsp;
			  String name=Platform.getI18nValue("eibs",key);
			  $$frm\\dsp=name;
			  }
			  for(#frm frm: $rolgrp\\frmlst1)
			  {
			  String key=$$frm\\dsp;
			  String name=Platform.getI18nValue("eibs",key);
			  $$frm\\dsp=name;
			  }
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;*/

			return true;
        }









}