package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbdbrcVO;

import com.ceb.gjjs.mda.manager.module.Ptygrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Brcp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 机构注销
*/
@Transaction(vo= DbdbrcVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbdbrc extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbdbrc.class);

		@BDGetter
		private Ptygrp ptygrp;

		@BDGetter
		private Brcp brcp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;


		public Dbdbrc()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBrcp().setMtabutHolder(()->this.getMtabut());
           this.getBrcp().setPtygrpHolder(()->this.getPtygrp());
           this.getMtabut().setMtagrpHolder(()->this.getPtygrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbdbrc.this.getFieldPath("ptygrp.rec.inr");}
 				public void setValue(String arg){Dbdbrc.this.getPtygrp().getRec().setInr(arg);}
 				public String getValue(){return Dbdbrc.this.getPtygrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dbdbrc.@0001.script
        */
        @Rule(target="brcp.submit",order=100)
        public boolean ruleBrcpSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*$brcgrp\\rec\\status.setValue("1");
			  int errorcode = Platform.errorCode();
			  Platform.mdbBegin();
			  Platform.mdbUpdate($brcgrp\\rec);
			  errorcode = Platform.errorCode();
			  if(errorcode == NO_ERROR)
			  {
			  if(!Platform.isEmpty($brcgrp\\bch\\inr))
			  {
			  $brcgrp\\bch\\sta = $brcgrp\\rec\\status.getValue();
			  Platform.mdbUpdate($brcgrp\\bch);
			  errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT000022,#CT000023);
			  Platform.mdbRollback();
			  return;
			  }
			  }
			  Platform.mdbCommit();
			  Platform.message(#CT000026,#CT000027);
			  Platform.mchain("dblbrc");
			  //Platform.returnToCaller();
			  }
			  else
			  {
			  Platform.message(#CT000028,#CT000029);
			  Platform.mdbRollback();
			  }*/

			return true;
        }

        /**
        *   source:dbdbrc.@0002.script
        */
        @Rule(target="brcp.cancel",order=100)
        public boolean ruleBrcpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr = this.getPtygrp().getRec().getInr();
			ctx.storeData("ptyinr",ptyinr);
			

			return true;
        }

        /**
        *   source:dbdbrc.@0003.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			//$trnmod.trnSetFromStaticContract("机构管理","删除",$usdgrp\\rec\\nam.getValue());
			this.getTrnmod().trnSetFromContract("机构管理","删除",this.getPtygrp().getRec().getNam());
			///保存页面快照
			//$trnmod.savTrnDsp($brcp\\edip,$trnmod\\trn\\inr.getValue());
			this.getTrnmod().savePanelDisplay(this.getBrcp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }



        /**
        *   source:dbdbrc.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBrcp().setTit("机构注销交易");
			
			List<CodetableItem> cts = this.getBrcp().getPtyCT();
			
			
			
			
			
			
			
			
			Object ptyinr = ctx.restoreData("ptyinr");
			MdaUtils.setValues(this.getBrcp(),"pntinr",cts);
			if(MdaUtils.isEmpty(ptyinr))
			{
			  
			}
			else
			{
			  Platform.mdbRead(this.getPtygrp().getRec(),new Argument<String>("inr",ptyinr.toString()));
			  Platform.mdbRead(this.getPtygrp().getPta(),new Argument<String>("ptyinr",ptyinr.toString()),new Argument<String>("objtyp","adr"));
			  String adrinr = this.getPtygrp().getPta().getObjinr();
			  Platform.mdbRead(this.getPtygrp().getAdr(),new Argument<String>("inr",adrinr));
			  Platform.mdbRead(this.getPtygrp().getBch(),new Argument<String>("ptyinr",ptyinr.toString()));
			  String pntinr = this.getPtygrp().getRec().getPntinr();
			  this.getBrcp().setPntinr(pntinr);
			  
			}

			return true;
        }








}