package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbdetgVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etggrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Etgp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体组注销
*/
@Transaction(vo= DbdetgVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbdetg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbdetg.class);

		@BDGetter
		private Etggrp etggrp;

		@BDGetter
		private Etgp etgp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dbdetg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtgp().setMtabutHolder(()->this.getMtabut());
           this.getEtgp().setEtggrpHolder(()->this.getEtggrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbdetg.this.getFieldPath("etggrp.rec.inr");}
 				public void setValue(String arg){Dbdetg.this.getEtggrp().getRec().setInr(arg);}
 				public String getValue(){return Dbdetg.this.getEtggrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getEtggrp());
        }

        /**
        *   source:dbdetg.@0001.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			this.getTrnmod().trnSetFromContract("实体组管理","删除",this.getEtggrp().getRec().getNam());
			///保存页面快照
			this.getTrnmod().savePanelDisplay(this.getEtgp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }


        /**
        *   source:dbdetg.@0002.script
        */
        @Check(target="etggrp.rec.inr",order=100)
        public boolean checkEtggrpRecInrN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($etggrp\\rec\\inr))
			  {
			  if($etggrp.isEtgIsUsed($etggrp\\rec\\inr))
			  {
			  Platform.error($etggrp\\rec\\nam,#CT000004);
			  return false;
			  }
			  }
			  else
			  {
			  Platform.error($etggrp\\rec\\nam,#CT000005);
			  return false;
			  }
			  */

			return true;
        }


        /**
        *   source:dbdetg.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getEtgp().setTit("实体组注销交易");
			

			
			

			Object etginr = ctx.restoreData("etginr");

			if(MdaUtils.isEmpty(etginr))
			{
			  
			}
			else
			{
			  Platform.mdbRead(this.getEtggrp().getRec(),new Argument<String>("inr",etginr.toString()));
			}

			return true;
        }








}