package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbdetyVO;

import com.ceb.gjjs.mda.manager.module.Etygrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etyp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体注销
*/
@Transaction(vo= DbdetyVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbdety extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbdety.class);

		@BDGetter
		private Etygrp etygrp;

		@BDGetter
		private Etyp etyp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dbdety()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtyp().setMtabutHolder(()->this.getMtabut());
           this.getEtyp().setEtygrpHolder(()->this.getEtygrp());
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbdety.this.getFieldPath("etygrp.rec.inr");}
 				public void setValue(String arg){Dbdety.this.getEtygrp().getRec().setInr(arg);}
 				public String getValue(){return Dbdety.this.getEtygrp().getRec().getInr();}}
			 );
           this.getMtabut().setMtagrpHolder(()->this.getEtygrp());
        }

        /**
        *   source:dbdety.@0003.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			this.getTrnmod().trnSetFromContract("实体管理","注销",this.getEtygrp().getRec().getRef());
			///保存页面快照
			this.getTrnmod().savePanelDisplay(this.getEtyp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }


        /**
        *   source:dbdety.@0001.script
        */
        @Check(target="etygrp.rec.etginr",order=100)
        public boolean checkEtygrpRecEtginrN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($etygrp\\rec\\etginr))
			  {
			  Platform.error($etygrp\\rec\\etginr,#CT000000);
			  return false;
			  }
			  */

			return true;
        }

        /**
        *   source:dbdety.@0002.script
        */
        @Check(target="etygrp.rec.ref",order=100)
        public boolean checkEtygrpRecRefN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($etygrp\\rec\\ref))
			  {
			  Platform.error($etygrp\\rec\\ref,#CT000001);
			  return false;
			  }
			  else
			  {
			  if($etygrp.checkEtyIsExists($etygrp\\rec\\ref,$etygrp\\rec\\inr))
			  {
			  Platform.error($etygrp\\rec\\ref,#CT000002);
			  return false;
			  }
			  }
			  */

			return true;
        }

        /**
        *   source:dbdety.@0004.script
        */
        @Check(target="etygrp.rec.inr",order=100)
        public boolean checkEtygrpRecInrN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($etygrp\\rec\\inr))
			  {
			  if($etygrp.isEtyIsUsed($etygrp\\rec\\inr))
			  {
			  Platform.error($etygrp\\rec\\ref,#CT000003);
			  return false;
			  }
			  }
			  else
			  {
			  Platform.error($etygrp\\rec\\ref,#CT000004);
			  return false;
			  }
			  */

			return true;
        }


        /**
        *   source:dbdety.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getEtyp().setTit("实体信息注销交易");
			
			Object etyinr = ctx.restoreData("etyinr");

			
			
			
			

			if(MdaUtils.isEmpty(etyinr))
			{
			  
			}
			else
			{
			  log.debug("{}","etyinr:" + etyinr);
			  Platform.mdbRead(this.getEtygrp().getRec(),new Argument<String>("inr",etyinr.toString()));
			  Platform.mdbRead(this.getEtygrp().getEtg(),new Argument<String>("inr",this.getEtygrp().getRec().getEtginr()));

			}

			return true;
        }








}