package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbdjgxVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jgxgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jgxp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 机构信息注销
*/
@Transaction(vo= DbdjgxVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbdjgx extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbdjgx.class);

		@BDGetter
		private Jgxgrp jgxgrp;

		@BDGetter
		private Jgxp jgxp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;


		public Dbdjgx()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJgxp().setJgxgrpHolder(()->this.getJgxgrp());
           this.getJgxp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getJgxgrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbdjgx.this.getFieldPath("jgxgrp.rec.inr");}
 				public void setValue(String arg){Dbdjgx.this.getJgxgrp().getRec().setInr(arg);}
 				public String getValue(){return Dbdjgx.this.getJgxgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dbdjgx.@0002.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			this.getTrnmod().trnSetFromContract("机构管理","删除","null");
			///保存页面快照
			this.getTrnmod().savePanelDisplay(this.getJgxp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }



        /**
        *   source:dbdjgx.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getJgxp().setTit("机构信息注销交易");
			
			Object jgxinr = ctx.restoreData("jgxinr");

			//Platform.disable();
			
			if(MdaUtils.isEmpty(jgxinr))
			{
			  
			}
			else
			{
			  log.debug("{}","jgxinr:" + jgxinr);
			  Platform.mdbRead(this.getJgxgrp().getRec(),new Argument<String>("inr",jgxinr.toString()));

			}

			return true;
        }








}