package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbdrolVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rolp;
import com.ceb.gjjs.mda.manager.module.Rolgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 角色删除
*/
@Transaction(vo= DbdrolVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbdrol extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbdrol.class);

		@BDGetter
		private Rolgrp rolgrp;

		@BDGetter
		private Rolp rolp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Dbdrol()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getRolp().setRolgrpHolder(()->this.getRolgrp());
           this.getRolp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getRolgrp());
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbdrol.this.getFieldPath("rolgrp.rec.inr");}
 				public void setValue(String arg){Dbdrol.this.getRolgrp().getRec().setInr(arg);}
 				public String getValue(){return Dbdrol.this.getRolgrp().getRec().getInr();}}
			 );
        }

        /**
        *   source:dbdrol.@0001.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			/* log.debug("submit 200");
			  if(rolfrmExist($rolgrp\\rec\\inr.getValue())||usrrolExist($rolgrp\\rec\\inr.getValue()))
			  {
			  Platform.message(#CT000002,#CT000003);
			  return false;
			  }
			  else
			  {
			  $rolgrp\\recsavflg="save";
			  $rolgrp\\rec\\flg="1";*/
			this.getRolgrp().getRec().setFlg( "1");
			///保存交易流水
			this.getTrnmod().trnSetFromContract("参数维护","角色管理删除",this.getRolgrp().getRec().getNam());
			///保存页面快照
			this.getTrnmod().savTrnDsp(this.getRolp().getDbdrol(),this.getTrnmod().getTrn().getInr());

			return true;
        }

        /**
        *   source:dbdrol.@0006.script
        */
        @Rule(target="rolp.mtabut.rtn",order=50)
        public boolean ruleRolpMtabutRtnN50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("rolinr",this.getRolgrp().getRec().getInr());

			return true;
        }



        /**
        *   source:dbdrol.@0000.script
        */
        @Init(order=110)
        public boolean	init110(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  *1.初始化不可见，可见和常用列表，读取frr，
			  *是1的填充到不可见列表，2的填充到常用列表，0的填充到可见的交易列表
			  *2.frr表中记录的角色---交易信息保存在list中
			  *3.通过读取全部的交易alllist和保存的list，得到剩下的leftlist,把leftlist中的数据按照原样保存
			  到各个list中。
			  **/
			/*  $rolgrp\\flg=2;
			  String rolinr = (String)Platform.restoreData("rol");
			  Platform.mdbRead($rolgrp\\rec,new Argument<String>("inr",EQ,rolinr));
			  //读取该角色的交易信息
			  Platform.mdbReadset($rolp\\tmplst,new Argument<String>("objtyp","rol"),new Argument<String>("objinr",rolinr));
			  Platform.clear($rolgrp\\frmlst1);
			  Platform.clear($rolgrp\\frmlst2);
			  Platform.clear($rolgrp\\oftlst);
			  List<String> list=new ArrayList<String>();
			  for(int i=0;i<$rolp\\tmplst.fullSize();i++)
			  {
			  list.add($rolp\\tmplst[i]\\frminr.getValue());
			  Platform.mdbRead($rolgrp\\frm,new Argument<String>("inr",$rolp\\tmplst[i]\\frminr.getValue()));
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frm=new Argument<String>("frm");
			  Argument<String>dsp=new Argument<String>("dsp");
			  Argument<String>frmtyp=new Argument<String>("frmtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  inr.setValue($rolgrp\\frm\\inr.getValue());
			  frm.setValue($rolgrp\\frm\\frm.getValue());
			  dsp.setValue($rolgrp\\frm\\dsp.getValue());
			  frmtyp.setValue($rolgrp\\frm\\frmtyp.getValue());
			  typ.setValue($rolgrp\\frm\\typ.getValue());
			  if("1".equals($rolp\\tmplst[i]\\typ.getValue()))
			  {
			  $rolgrp\\frmlst1.add(inr,frm,frmtyp,typ,dsp);
			  }
			  else if("0".equals($rolp\\tmplst[i]\\typ.getValue()))
			  {
			  $rolgrp\\frmlst2.add(inr,frm,dsp,frmtyp,typ,dsp);
			  }
			  else if("2".equals($rolp\\tmplst[i]\\typ.getValue()))
			  {
			  $rolgrp\\oftlst.add(inr,frm,dsp,frmtyp,typ,dsp);
			  }
			  }
			  List<String> allist=new ArrayList<String>();
			  //获取全部交易
			  Platform.mdbReadset($rolp\\alllst,Argument.or(new Argument<String>("frmtyp","A"),new Argument<String>("frmtyp","B")));
			  for(int i=0;i<$rolp\\alllst.fullSize();i++)
			  {
			  allist.add($rolp\\alllst[i]\\inr.getValue());
			  }
			  //处理剩余的交易列表进行填充
			  $rolp.addLeft(list,allist);
			  Object dbdinr = Platform.restoreData("rolinr");
			  log.debug("跳转后inr:"+dbdinr);
			  if(Platform.isEmpty(dbdinr))
			  {
			  Platform.message(#CT000008,#CT000009);
			  return;
			  }
			  else
			  Platform.mdbRead($rolgrp\\rec,new Argument<String>("inr",dbdinr.toString()));
			  if("0".equals($rolgrp\\rec\\lev.getValue()))
			  Platform.setValues($rolgrp\\rec\\rellev,Platform.getCodetable("rellev0"));
			  else if("1".equals($rolgrp\\rec\\lev.getValue()))
			  Platform.setValues($rolgrp\\rec\\rellev,Platform.getCodetable("rellev1"));
			  else if("2".equals($rolgrp\\rec\\lev.getValue()))
			  Platform.setValues($rolgrp\\rec\\rellev,Platform.getCodetable("rellev2"));
			  Platform.disable($rolgrp\\rec\\nam);
			  Platform.disable($rolgrp\\rec\\flg);
			  Platform.disable($rolgrp\\rec\\lev);
			  Platform.disable($rolgrp\\rec\\rellev);*/

			return true;
        }

        /**
        *   source:dbdrol.@0004.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			/*Platform.invisible($rolp\\add);
			  Platform.invisible($rolp\\addall);
			  Platform.invisible($rolp\\rev);
			  Platform.invisible($rolp\\revall);
			  Platform.invisible($rolp\\oftadd);
			  Platform.invisible($rolp\\oftadl);
			  Platform.invisible($rolp\\oftrev);
			  Platform.invisible($rolp\\oftrel);*/

			return true;
        }

        /**
        *   source:dbdrol.@0005.script
        */
        @Init(order=3000)
        public boolean	init3000(){
            IContext ctx = MdaEnv.getContext();
            
			/* String name1=Platform.getI18nValue("eibs","menu.dbrusr");
			  log.debug("name1 is:"+name1);
			  for(#frm frm: $rolgrp\\frmlst2)
			  {
			  String key=$$frm\\dsp;
			  String name=Platform.getI18nValue("eibs",key);
			  $$frm\\dsp=name;
			  }
			  for(#frm frm: $rolgrp\\frmlst1)
			  {
			  String key=$$frm\\dsp;
			  String name=Platform.getI18nValue("eibs",key);
			  $$frm\\dsp=name;
			  }*/

			return true;
        }

        /**
        *   source:dbdrol.@0007.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Object rolinr=ctx.restoreData("rolinr");
			if(rolinr != null)
			  Platform.mdbRead(this.getRolp().getRolgrp().getRec(),new Argument("inr",rolinr.toString()));
			

			return true;
        }


        /**
        *   source:dbdrol.@0002.script
        */
        public boolean  rolfrmExist(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(ctx.getErrorCode()==NO_ERROR)
			  return true;
			else
			  return false;
			//判断该rolfrm中是否存在角色
			/*boolean exist=false;
			  String sql="SELECT inr FROM frr WHERE objinr='"+rolinr+"' AND objtyp='rol' ";
			  Argument<String>inr=new Argument<String>("inr");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  exist=true;
			  break;
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  return exist;*/
		}
        /**
        *   source:dbdrol.@0003.script
        */
        public boolean usrrolExist(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(ctx.getErrorCode()==NO_ERROR)
			  return true;
			else
			  return false;
			//判断该usrrol中是否存在角色
			/*boolean exist=false;
			  String sql="SELECT inr FROM url WHERE rolinr='"+rolinr+"'";
			  Argument<String>inr=new Argument<String>("inr");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  exist=true;
			  break;
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  return exist;*/
		}







}