package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbebrcVO;

import com.ceb.gjjs.mda.manager.module.Ptygrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Brcp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 机构修改
*/
@Transaction(vo= DbebrcVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbebrc extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbebrc.class);

		@BDGetter
		private Ptygrp ptygrp;

		@BDGetter
		private Brcp brcp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;


		public Dbebrc()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBrcp().setMtabutHolder(()->this.getMtabut());
           this.getBrcp().setPtygrpHolder(()->this.getPtygrp());
           this.getMtabut().setMtagrpHolder(()->this.getPtygrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbebrc.this.getFieldPath("ptygrp.rec.inr");}
 				public void setValue(String arg){Dbebrc.this.getPtygrp().getRec().setInr(arg);}
 				public String getValue(){return Dbebrc.this.getPtygrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dbebrc.@0001.script
        */
        @Rule(target="brcp.submit",order=100)
        public boolean ruleBrcpSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(!$brcp.dataChecked())
			  return;
			  boolean insertBch = false;
			  if(Platform.isEmpty($brcgrp\\bch\\inr))
			  insertBch = true;
			  $brcp.setBranchData();
			  int errorcode = Platform.errorCode();
			  Platform.mdbBegin();
			  Platform.mdbUpdate($brcgrp\\rec);
			  errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("update pty with errorcode:" + errorcode);
			  Platform.message(#CT000014,#CT000015);
			  Platform.mdbRollback();
			  return;
			  }
			  Platform.mdbUpdate($brcgrp\\adr);
			  errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("update adr with errorcode:" + errorcode);
			  Platform.message(#CT000043,#CT000044);
			  Platform.mdbRollback();
			  return;
			  }
			  if(insertBch)
			  Platform.mdbInsert($brcgrp\\bch);
			  else
			  Platform.mdbUpdate($brcgrp\\bch);
			  errorcode = Platform.errorCode();
			  if(errorcode == NO_ERROR)
			  {
			  Platform.message(#CT000045,#CT000054);
			  Platform.mdbCommit();
			  Platform.mchain("dblbrc");
			  }
			  else
			  {
			  Platform.message(#CT000055,#CT000056);
			  Platform.mdbRollback();
			  return;
			  }*/

			return true;
        }

        /**
        *   source:dbebrc.@0002.script
        */
        @Rule(target="brcp.cancel",order=100)
        public boolean ruleBrcpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr = this.getPtygrp().getRec().getInr();
			ctx.storeData("ptyinr",ptyinr);
			

			return true;
        }

        /**
        *   source:dbebrc.@0003.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			//$trnmod.trnSetFromStaticContract("机构管理","修改",$usdgrp\\rec\\nam.getValue());
			this.getTrnmod().trnSetFromContract("机构管理","修改",this.getPtygrp().getRec().getNam());
			///保存页面快照
			//$trnmod.savTrnDsp($brcp\\edip,$trnmod\\trn\\inr.getValue());
			this.getTrnmod().savePanelDisplay(this.getBrcp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }


        /**
        *   source:dbebrc.@0004.script
        */
        @Check(target="ptygrp.rec.cid",order=100)
        public boolean checkPtygrpRecCidN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getRec().getCid()))
			{
			  ctx.setFieldError(this,"ptygrp.rec.cid",MdaUtils.getI18NString("dbebrc","CT000058"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbebrc.@0005.script
        */
        @Check(target="ptygrp.rec.chnnam",order=100)
        public boolean checkPtygrpRecChnnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getRec().getChnnam()))
			{
			  ctx.setFieldError(this,"ptygrp.rec.chnnam",MdaUtils.getI18NString("dbebrc","CT000060"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbebrc.@0006.script
        */
        @Check(target="ptygrp.bch.cnadr1",order=100)
        public boolean checkPtygrpBchCnadr1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getCnadr1()))
			{
			  ctx.setFieldError(this,"ptygrp.bch.cnadr1",MdaUtils.getI18NString("dbebrc","CT000062"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbebrc.@0007.script
        */
        @Check(target="ptygrp.adr.adr",order=100)
        public boolean checkPtygrpAdrAdrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getAdr().getAdr()))
			{
			  ctx.setFieldError(this,"ptygrp.adr.adr",MdaUtils.getI18NString("dbebrc","CT000064"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbebrc.@0009.script
        */
        @Check(target="ptygrp.bch.branch",order=100)
        public boolean checkPtygrpBchBranchN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getBranch()))
			{
			  ctx.setFieldError(this,"ptygrp.bch.branch",MdaUtils.getI18NString("dbebrc","CT000066"));
			  return false;
			}

			return true;
        }

        /**
        *   source:dbebrc.@0010.script
        */
        @Check(target="ptygrp.rec.etyinr",order=100)
        public boolean checkPtygrpRecEtyinrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getRec().getEtyinr()))
			{
			  ctx.setFieldError(this,"ptygrp.rec.etyinr",MdaUtils.getI18NString("dbebrc","CT000067"));
			  return false;
			}

			return true;
        }


        /**
        *   source:dbebrc.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBrcp().setTit("机构信息修改交易");
			
			Object ptyinr = ctx.restoreData("ptyinr");
			List<CodetableItem> cts = this.getBrcp().getPtyCT();
			MdaUtils.setValues(this.getBrcp(),"pntinr",cts);
			if(MdaUtils.isEmpty(ptyinr))
			{
			  
			}
			else
			{
			  log.debug("{}","ptyinr:" + ptyinr);
			  Platform.mdbRead(this.getPtygrp().getRec(),new Argument<String>("inr",ptyinr.toString()));
			  Platform.mdbRead(this.getPtygrp().getPta(),new Argument<String>("ptyinr",ptyinr.toString()),new Argument<String>("objtyp","adr"));
			  String adrinr = this.getPtygrp().getPta().getObjinr();
			  Platform.mdbRead(this.getPtygrp().getAdr(),new Argument<String>("inr",adrinr));
			  Platform.mdbRead(this.getPtygrp().getBch(),new Argument<String>("ptyinr",ptyinr.toString()));

			  //20181230注释，由于下拉框不能正常显示
			  /*if("0".equals($ptygrp\\rec\\brhlvl.getValue()))
			    {
			    Platform.setValues($ptygrp\\rec\\brhlvl,$sysmod.getRootBranchLevelCodetable());
			    Platform.disable($ptygrp\\rec\\brhlvl);
			    }
			    else
			    Platform.setValues($ptygrp\\rec\\brhlvl,$sysmod.getBranchLevelCodetable());*/

			  //String pntinr = $brcgrp\\rec\\pntinr.getValue();
			  //$brcp\\pntinr.setValue(pntinr);
			  //Platform.setModified($brcp\\pntinr);
			  //Platform.clear($brcgrp\\rec\\cid);
			  //Platform.setModified($brcgrp\\rec\\cid);
			  //Platform.clear($brcgrp\\rec\\nam);
			  //Platform.setModified($brcgrp\\rec\\nam);
			  //Platform.clear($brcgrp\\adr\\adr);
			  //Platform.setModified($brcgrp\\adr\\adr);
			}

			return true;
        }








}