package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbeetgVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etggrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Etgp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体组修改
*/
@Transaction(vo= DbeetgVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbeetg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbeetg.class);

		@BDGetter
		private Etggrp etggrp;

		@BDGetter
		private Etgp etgp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dbeetg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtgp().setEtggrpHolder(()->this.getEtggrp());
           this.getEtgp().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbeetg.this.getFieldPath("etggrp.rec.inr");}
 				public void setValue(String arg){Dbeetg.this.getEtggrp().getRec().setInr(arg);}
 				public String getValue(){return Dbeetg.this.getEtggrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getEtggrp());
        }

        /**
        *   source:dbeetg.@0001.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			this.getTrnmod().trnSetFromContract("实体组管理","修改",this.getEtggrp().getRec().getNam());
			///保存页面快照
			this.getTrnmod().savePanelDisplay(this.getEtgp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }



        /**
        *   source:dbeetg.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getEtgp().setTit("实体组修改交易");
			

			//Platform.disable($etggrp\\rec\\nam);
			//Platform.disable($etggrp\\rec\\des);
			
			Object etginr = ctx.restoreData("etginr");

			if(MdaUtils.isEmpty(etginr))
			{
			  
			}
			else
			{
			  Platform.mdbRead(this.getEtggrp().getRec(),new Argument<String>("inr",etginr.toString()));
			}

			return true;
        }








}