package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbeetyVO;

import com.ceb.gjjs.mda.manager.module.Etygrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etyp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体修改
*/
@Transaction(vo= DbeetyVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbeety extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbeety.class);

		@BDGetter
		private Etygrp etygrp;

		@BDGetter
		private Etyp etyp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;


		public Dbeety()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtyp().setEtygrpHolder(()->this.getEtygrp());
           this.getEtyp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getEtygrp());
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbeety.this.getFieldPath("etygrp.rec.inr");}
 				public void setValue(String arg){Dbeety.this.getEtygrp().getRec().setInr(arg);}
 				public String getValue(){return Dbeety.this.getEtygrp().getRec().getInr();}}
			 );
        }

        /**
        *   source:dbeety.@0001.script
        */
        @Rule(target="mtabut.submit",order=100)
        public boolean ruleMtabutSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			//保存交易流水
			this.getTrnmod().trnSetFromContract("实体管理","注销",this.getEtygrp().getRec().getRef());
			///保存页面快照
			this.getTrnmod().savePanelDisplay(this.getEtyp().getEdip(),this.getTrnmod().getTrn().getInr());

			return true;
        }



        /**
        *   source:dbeety.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getEtyp().setTit("实体信息修改交易");
			
			Object etyinr = ctx.restoreData("etyinr");

			if(MdaUtils.isEmpty(etyinr))
			{
			  
			}
			else
			{
			  log.debug("{}","etyinr:" + etyinr);
			  Platform.mdbRead(this.getEtygrp().getRec(),new Argument<String>("inr",etyinr.toString()));
			  Platform.mdbRead(this.getEtygrp().getEtg(),new Argument<String>("inr",this.getEtygrp().getRec().getEtginr()));
			}

			return true;
        }








}