package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbefrrVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Frrgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Frrp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 角色交易定制修改
*/
@Transaction(vo= DbefrrVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbefrr extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbefrr.class);

        //左侧折叠菜单MAP
        private Map lftmap;
        //右侧折叠菜单MAP
        private Map rgtmap;
		@BDGetter
		private Frrgrp frrgrp;

		@BDGetter
		private Frrp frrp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;


		public Dbefrr()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFrrp().setFrrgrpHolder(()->this.getFrrgrp());
           this.getMtabut().setMtagrpHolder(()->this.getFrrgrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbefrr.this.getFieldPath("frrgrp.rec.inr");}
 				public void setValue(String arg){Dbefrr.this.getFrrgrp().getRec().setInr(arg);}
 				public String getValue(){return Dbefrr.this.getFrrgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dbefrr.@0001.script
        */
        @Rule(target="frrp.add",order=100)
        public boolean ruleFrrpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			StreamGrid addgrd = this.getFrrgrp().getAddgrd();
			for(int i=0;i<lftgrd.size();i++)
			{
			  AttributeValue attr0 = (AttributeValue)lftgrd.get(i)[0];
			  String str = attr0.getValue().toString().trim();
			  if("+".equals(str))
			  {
			    this.lftaddBeforeAddAndRemove(i);
			  }
			}
			for(int i=0;i<lftgrd.size();i++)
			{

			  AttributeValue lftchkval = (AttributeValue)lftgrd.get(i)[0];
			  String lftchk = (String)lftchkval.getValue();
			  if("X".equals(lftchk))
			  {
			    log.debug("{}","lft to rgt chk...");
			    AttributeValue lftval = (AttributeValue)lftgrd.get(i)[1];
			    String lftkey = (String)lftval.getAttribute("path");
			    String lftfrminr = (String)lftval.getAttribute("frminr");
			    AttributeValue newchk = new AttributeValue("");
			    
			    
			    lftval.setAttribute("flg","A");
			    lftval.setAttribute("typ","0");
			    IValue[] lfttmp = new IValue[]{newchk,lftval};
			    //if(!$this.genPntMenu(lftkey,lfttmp))
			    //  $this.findMenuPlaceAndAdd(lfttmp,lftkey,lftfrminr);
			    this.gridInsertNode(lftgrd,rgtgrd,lftkey,lfttmp,"A");
			    addgrd.add(lftgrd.remove(i));
			    i--;
			  }
			}

			this.checkGridMenu(lftgrd);
			this.checkGridMenu(rgtgrd);
			this.getFrrp().setNumyet( this.caculatetransaction(lftgrd));
			this.getFrrp().setNumral( this.caculatetransaction(rgtgrd));
			
			
			
			

			return true;
        }

        /**
        *   source:dbefrr.@0002.script
        */
        @Rule(target="frrp.addall",order=100)
        public boolean ruleFrrpAddallN100(){
            IContext ctx = MdaEnv.getContext();
            
			StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			StreamGrid addgrd = this.getFrrgrp().getAddgrd();
			for(int i=0;i<lftgrd.size();i++)
			{
			  AttributeValue attr0 = (AttributeValue)lftgrd.get(i)[0];
			  String str = attr0.getValue().toString().trim();
			  if("+".equals(str))
			  {
			    this.lftaddBeforeAddAndRemove(i);
			  }
			}
			for(int i=0;i<lftgrd.size();i++)
			{
			  AttributeValue lftval = (AttributeValue)lftgrd.get(i)[1];
			  String lftfrm = (String)lftval.getAttribute("frm");
			  if(!MdaUtils.isEmpty(lftfrm))
			  {
			    String lftkey = (String)lftval.getAttribute("path");
			    String lftfrminr = (String)lftval.getAttribute("frminr");
			    AttributeValue newchk = new AttributeValue("");
			    
			    
			    lftval.setAttribute("flg","A");
			    lftval.setAttribute("typ","0");
			    IValue[] lfttmp = new IValue[]{newchk,lftval};
			    //rgtgrd = $frrp\\rgtgrd.getValue();
			    //if(!$this.genPntMenu(lftkey,lfttmp))
			    //$this.findMenuPlaceAndAdd(lfttmp,lftkey,lftfrminr);
			    this.gridInsertNode(lftgrd,rgtgrd,lftkey,lfttmp,"A");
			    addgrd.add(lftgrd.remove(i));
			    i--;
			  }
			}
			this.checkGridMenu(lftgrd);
			this.checkGridMenu(rgtgrd);
			this.getFrrp().setNumyet( this.caculatetransaction(lftgrd));
			this.getFrrp().setNumral( this.caculatetransaction(rgtgrd));
			
			
			
			

			return true;
        }

        /**
        *   source:dbefrr.@0003.script
        */
        @Rule(target="frrp.rev",order=100)
        public boolean ruleFrrpRevN100(){
            IContext ctx = MdaEnv.getContext();
            
			StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			StreamGrid rmvgrd = this.getFrrgrp().getRmvgrd();
			for(int i=0;i<rgtgrd.size();i++)
			{
			  AttributeValue attr0 = (AttributeValue)rgtgrd.get(i)[0];
			  String str = attr0.getValue().toString().trim();
			  if("+".equals(str))
			  {
			    this.rgtaddBeforeAddAndRemove(i);
			  }
			}
			for(int i=0;i<rgtgrd.size();i++)
			{
			  AttributeValue rgtchkval = (AttributeValue)rgtgrd.get(i)[0];
			  String rgtchk = (String)rgtchkval.getValue();
			  if("X".equals(rgtchk))
			  {
			    AttributeValue rgtval = (AttributeValue)rgtgrd.get(i)[1];
			    String rgtkey = (String)rgtval.getAttribute("path");
			    String rgtfrminr = (String)rgtval.getAttribute("frminr");
			    AttributeValue newchk = new AttributeValue("");
			    
			    
			    rgtval.setAttribute("flg","D");
			    rgtval.setAttribute("typ","1");
			    IValue[] rgttmp = new IValue[]{newchk,rgtval};
			    //if(!$this.genPntMenu(rgtkey,rgttmp))
			    //$this.findMenuPlaceAndAdd(rgttmp,rgtkey,rgtfrminr);
			    this.gridInsertNode(rgtgrd,lftgrd,rgtkey,rgttmp,"D");
			    rmvgrd.add(rgtgrd.remove(i));
			    i--;
			  }
			}
			this.checkGridMenu(lftgrd);
			this.checkGridMenu(rgtgrd);
			this.getFrrp().setNumyet( this.caculatetransaction(lftgrd));
			this.getFrrp().setNumral( this.caculatetransaction(rgtgrd));
			
			
			
			

			return true;
        }

        /**
        *   source:dbefrr.@0004.script
        */
        @Rule(target="frrp.revall",order=100)
        public boolean ruleFrrpRevallN100(){
            IContext ctx = MdaEnv.getContext();
            
			StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			StreamGrid rmvgrd = this.getFrrgrp().getRmvgrd();
			for(int i=0;i<rgtgrd.size();i++)
			{
			  AttributeValue attr0 = (AttributeValue)rgtgrd.get(i)[0];
			  String str = attr0.getValue().toString().trim();
			  if("+".equals(str))
			  {
			    this.rgtaddBeforeAddAndRemove(i);
			  }
			}
			for(int i=0;i<rgtgrd.size();i++)
			{
			  AttributeValue rgtval = (AttributeValue)rgtgrd.get(i)[1];
			  String rgtfrm = (String)rgtval.getAttribute("frm");
			  if(!MdaUtils.isEmpty(rgtfrm))
			  {
			    String rgtkey = (String)rgtval.getAttribute("path");
			    String rgtfrminr = (String)rgtval.getAttribute("frminr");
			    AttributeValue newchk = new AttributeValue("");
			    
			    
			    rgtval.setAttribute("flg","D");
			    rgtval.setAttribute("typ","1");
			    IValue[] rgttmp = new IValue[]{newchk,rgtval};
			    //if(!$this.genPntMenu(rgtkey,rgttmp))
			    //$this.findMenuPlaceAndAdd(rgttmp,rgtkey,rgtfrminr);
			    this.gridInsertNode(rgtgrd,lftgrd,rgtkey,rgttmp,"D");
			    rmvgrd.add(rgtgrd.remove(i));
			    i--;
			  }
			}
			this.checkGridMenu(lftgrd);
			this.checkGridMenu(rgtgrd);
			this.getFrrp().setNumyet( this.caculatetransaction(lftgrd));
			this.getFrrp().setNumral( this.caculatetransaction(rgtgrd));
			
			
			
			

			return true;
        }

        /**
        *   source:dbefrr.@0005.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			//设置TRN数据
			this.getTrnmod().trnSetFromContract("角色产品关联管理","修改",this.getFrrp().getRolnam());
			//保存界面截图
			this.getTrnmod().savePanelDisplay(this.getFrrp().getDbefrr(),this.getTrnmod().getTrn().getInr());

			return true;
        }

        /**
        *   source:dbefrr.@0026.script
        */
        @Rule(target="frrgrp.lftgrd",order=100)
        public boolean ruleFrrgrpLftgrdN100(){
            IContext ctx = MdaEnv.getContext();
            
			StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			int index = lftgrd.getIndex();
			log.debug("{}","left grid selected index:" + index);
			if(index > -1)
			{
			  AttributeValue attr0 = (AttributeValue)lftgrd.get(index)[0];
			  String str = attr0.getValue().toString().trim();
			  log.debug("{}","str:" + str);
			  if("-".equals(str) || "+".equals(str))
			  {
			    AttributeValue attr1 = (AttributeValue)lftgrd.get(index)[1];
			    String nodePath = (String)attr1.getAttribute("path");
			    Map<String,LinkedHashMap<String,IValue[]> > lftExtendMap = this.getLftmap();
			    //收缩菜单
			    if("-".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = new LinkedHashMap<String,IValue[]>();
			      addAllChildrenNodesIntoMap(addExtendMap,lftgrd,nodePath);
			      lftExtendMap.put(nodePath,addExtendMap);
			      attr0.setValue("+");
			    }
			    else if("+".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = lftExtendMap.get(nodePath);
			      addAllChildrenNodesFromMap(addExtendMap,lftgrd,nodePath);
			      lftExtendMap.remove(nodePath);
			      attr0.setValue("-");
			    }
			  }
			  
			}

			return true;
        }

        /**
        *   source:dbefrr.@0029.script
        */
        @Rule(target="frrgrp.rgtgrd",order=100)
        public boolean ruleFrrgrpRgtgrdN100(){
            IContext ctx = MdaEnv.getContext();
            
			StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			int index = rgtgrd.getIndex();
			log.debug("{}","right grid selected index:" + index);
			if(index > -1)
			{
			  AttributeValue attr0 = (AttributeValue)rgtgrd.get(index)[0];
			  String str = attr0.getValue().toString().trim();
			  log.debug("{}","str:" + str);
			  if("-".equals(str) || "+".equals(str))
			  {
			    AttributeValue attr1 = (AttributeValue)rgtgrd.get(index)[1];
			    String nodePath = (String)attr1.getAttribute("path");
			    Map<String,LinkedHashMap<String,IValue[]> > rgtExtendMap = this.getRgtmap();
			    //收缩菜单
			    if("-".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = new LinkedHashMap<String,IValue[]>();
			      addAllChildrenNodesIntoMap(addExtendMap,rgtgrd,nodePath);
			      rgtExtendMap.put(nodePath,addExtendMap);
			      attr0.setValue("+");
			    }
			    else if("+".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = rgtExtendMap.get(nodePath);
			      addAllChildrenNodesFromMap(addExtendMap,rgtgrd,nodePath);
			      rgtExtendMap.remove(nodePath);
			      attr0.setValue("-");
			    }
			  }
			  
			}

			return true;
        }

        /**
        *   source:dbefrr.@0033.script
        */
        @Rule(target="frrp.copmnu",order=100)
        public boolean ruleFrrpCopmnuN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			MdaUtils.setValues(this.getFrrp(),"coprolnam",this.getFrrp().getRolnamList());

			return true;
        }

        /**
        *   source:dbefrr.@0035.script
        */
        @Rule(target="frrp.coprol",order=100)
        public boolean ruleFrrpCoprolN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getFrrgrp().getFrrlst());
			MdaUtils.clear(this.getFrrgrp().getFrrlst1());
			MdaUtils.clear(this.getFrrgrp().getFrrlst2());
			MdaUtils.clear(this.getFrrgrp().getLfttmplst());
			MdaUtils.clear(this.getFrrgrp().getRgttmplst());
			//组合查询
			String sql = "SELECT frr.inr,frm.inr AS frminr,frm.pntinr AS pntinr,frr.objinr,frr.typ,frm.frm,frm.dsp,frm.frmtyp,frm.typ AS frmviwtyp FROM frm LEFT JOIN frr ON frr.frminr = frm.inr";
			//根据选择的角色进行查询
			sql = sql+" AND frr.objinr = ? and frr.objtyp = 'rol' where frm.typ='0' order by frm.inr ASC";
			//WHERE FRM.FRM IS NOT NULL ";
			log.debug("{}","sql"+sql);
			//组合显示交易列表
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> frminr = new Argument<String>("frminr");
			Argument<String> pntinr = new Argument<String>("pntinr");
			Argument<String> rolinr = new Argument<String>("objinr");
			Argument<String> typ = new Argument<String>("typ");
			Argument<String> frm = new Argument<String>("frm");
			Argument<String> dsp = new Argument<String>("dsp");
			Argument<String> frmtyp = new Argument<String>("frmtyp");
			Argument<String> frmviwtyp = new Argument<String>("frmviwtyp");
			Platform.mdbExecuteSQL(sql,this.getFrrp().getCoprolnam());
			while(true)
			{
			  Platform.mdbFetchFields(inr,frminr,pntinr,rolinr,typ,frm,dsp,frmtyp,frmviwtyp);
			  if(ctx.getErrorCode() == NO_ERROR)
			    this.getFrrgrp().getFrrlst().add(inr,frminr,pntinr,rolinr,typ,frm,dsp,frmtyp,frmviwtyp);
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			log.debug("{}","查出frrlst记录"+this.getFrrgrp().getFrrlst().fullSize());
			for(com.ceb.gjjs.mda.bo.Frr frr:this.getFrrgrp().getFrrlst())
			{
			  String key = frr.getDsp();
			  String nam = MdaUtils.getI18nValue("eibs",key);
			  frr.setDsp( nam);
			}
			for(int i=0;i<this.getFrrgrp().getFrrlst().fullSize();i++)
			{
			  if("office".equals(this.getFrrgrp().getFrrlst().getElement(i).getFrm()))
			  {
			    this.getFrrgrp().getFrrlst().remove(i);
			    i--;
			    continue;
			  }
			  if("0".equals(this.getFrrgrp().getFrrlst().getElement(i).getTyp()))
			  {
			    this.getFrrgrp().getFrrlst2().add(this.getFrrgrp().getFrrlst().getElement(i));//frrlst2 right
			  }
			  else //if("1".equals($frrgrp\\frrlst[i]\\typ)) typ为1的和typ为空的都是未分配的菜单交易
			  {
			    this.getFrrgrp().getFrrlst1().add(this.getFrrgrp().getFrrlst().getElement(i));//frrlst1 left
			  }
			}
			log.debug("{}","dbifrr check rulnam before sort frrlst2 size:"+this.getFrrgrp().getFrrlst2().size());
			log.debug("{}","dbifrr check rulnam before sort frrlst1 size:"+this.getFrrgrp().getFrrlst1().size());
			LinkedHashMap<String,Map> lftmap = sortAndGenerLeftGridMenuMap();
			LinkedHashMap<String,Map> rgtmap = sortAndGenerRightGridMenuMap();
			LinkedHashMap<String,Map> lftrmvmap = checkGridMenu(lftmap);
			LinkedHashMap<String,Map> rgtrmvmap = checkGridMenu(rgtmap);
			this.getFrrgrp().setLfttmpgrd(null);
			this.getFrrgrp().setRgttmpgrd(null);
			StreamGrid lfttmpgrd = this.getFrrgrp().getLfttmpgrd();
			StreamGrid rgttmpgrd = this.getFrrgrp().getRgttmpgrd();
			generGrid(lftmap,lfttmpgrd);
			generGrid(rgtmap,rgttmpgrd);
			int a=0;
			int b=0;
			for(int i=0;i<this.getFrrgrp().getLfttmplst().size();i++)
			{
			  if(!MdaUtils.isEmpty(this.getFrrgrp().getLfttmplst().getElement(i).getFrm()))
			    a++;
			}
			for(int i=0;i<this.getFrrgrp().getRgttmplst().size();i++)
			{
			  if(!MdaUtils.isEmpty(this.getFrrgrp().getRgttmplst().getElement(i).getFrm()))
			    b++;
			}
			String num1 = String.valueOf(a);
			String num2 = String.valueOf(b);
			this.getFrrp().setNumyet( num1);
			this.getFrrp().setNumral( num2);
			this.getFrrgrp().setOprtyp( "true");

			this.getFrrgrp().setLftgrd(null);
			this.getFrrgrp().setRgtgrd(null);
			StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			this.initLeftRightGrid(lftgrd,lfttmpgrd);
			this.initLeftRightGrid(rgtgrd,rgttmpgrd);

			
			
			
			

			return true;
        }



        /**
        *   source:dbefrr.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			/*Platform.clear($frrgrp\\frrlst);
			  Platform.clear($frrgrp\\frrlst1);
			  Platform.clear($frrgrp\\frrlst2);
			  Object numyet = Platform.restoreData("numyet");
			  $frrp\\numyet = numyet.toString();
			  Object numral = Platform.restoreData("numral");
			  $frrp\\numral = numral.toString();
			  Object rolnam = Platform.restoreData("rolnam");
			  $frrp\\rolnam = rolnam.toString();
			  Platform.disable($frrp\\rolnam);
			  IModuleList frrlst = (IModuleList)Platform.restoreData("frrlst");
			  $frrgrp\\frrlst.addAll(frrlst);
			  IModuleList frrlst1 = (IModuleList)Platform.restoreData("frrlst1");
			  $frrgrp\\frrlst1.addAll(frrlst1);
			  IModuleList frrlst2 = (IModuleList)Platform.restoreData("frrlst2");
			  $frrgrp\\frrlst2.addAll(frrlst2);*/

			return true;
        }

        /**
        *   source:dbefrr.@0006.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFrrgrp().setLftgrd(null);
			this.getFrrgrp().setRgtgrd(null);
			
			
			this.getFrrgrp().setOprtyp( "false");
			Object numyet = ctx.restoreData("numyet");
			this.getFrrp().setNumyet( numyet.toString());
			Object numral = ctx.restoreData("numral");
			this.getFrrp().setNumral( numral.toString());
			Object rolnam = ctx.restoreData("rolnam");
			this.getFrrgrp().setRolnam( rolnam.toString());
			
			StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			StreamGrid lfttmpgrd = (StreamGrid)ctx.restoreData("lftgrd");
			StreamGrid rgttmpgrd = (StreamGrid)ctx.restoreData("rgtgrd");
			this.initLeftRightGrid(lftgrd,lfttmpgrd);
			this.initLeftRightGrid(rgtgrd,rgttmpgrd);

			return true;
        }


        /**
        *   source:dbefrr.@0007.script
        */
        public void initLeftRightGrid(StreamGrid grd,StreamGrid tmpgrd)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//StreamGrid lftgrd = $frrp\\lftgrd;
			//StreamGrid rgtgrd = $frrp\\rgtgrd;
			//StreamGrid lfttmpgrd = (StreamGrid)Platform.restoreData("lftgrd");
			//StreamGrid rgttmpgrd = (StreamGrid)Platform.restoreData("rgtgrd");
			AttributeValue h0 = new AttributeValue("");
			
			AttributeValue h1 = new AttributeValue("菜单名称");
			
			grd.setHeaders(new IAttributeValue[]{h0,h1});
			//rgtgrd.setHeaders(new IAttributeValue[]{h0,h1});
			for(int i=0;i<tmpgrd.size();i++)
			{
			  AttributeValue keyval = (AttributeValue)tmpgrd.get(i)[0];
			  String key0 = (String)keyval.getAttribute("path");
			  AttributeValue frmval = (AttributeValue)tmpgrd.get(i)[0];
			  String frm = (String)frmval.getAttribute("frm");
			  AttributeValue frminrval = (AttributeValue)tmpgrd.get(i)[0];
			  String frminr = (String)frminrval.getAttribute("frminr");
			  AttributeValue pntinrval = (AttributeValue)tmpgrd.get(i)[0];
			  String pntinr = (String)pntinrval.getAttribute("pntinr");
			  AttributeValue flgval = (AttributeValue)tmpgrd.get(i)[0];
			  String flg = (String)flgval.getAttribute("flg");
			  AttributeValue typval = (AttributeValue)tmpgrd.get(i)[0];
			  String typ = (String)typval.getAttribute("typ");
			  AttributeValue frrinrval = (AttributeValue)tmpgrd.get(i)[0];
			  String frrinr = (String)frrinrval.getAttribute("inr");
			  AttributeValue objinrval = (AttributeValue)tmpgrd.get(i)[0];
			  String objinr = (String)objinrval.getAttribute("objinr");
			  AttributeValue objtypval = (AttributeValue)tmpgrd.get(i)[0];
			  String objtyp = (String)objtypval.getAttribute("objtyp");
			  AttributeValue chk0 = new AttributeValue("");
			  
			  
			  AttributeValue chk1 = new AttributeValue("-");
			  
			  if(MdaUtils.isEmpty(frm))
			  {
			    if(!key0.contains("/"))
			    {
			      AttributeValue val0 = new AttributeValue(tmpgrd.get(i)[0].getValue());
			      val0.setAttribute("path",key0);
			      val0.setAttribute("frminr",frminr);
			      val0.setAttribute("frm",frm);
			      val0.setAttribute("pntinr",pntinr);
			      val0.setAttribute("flg",flg);
			      val0.setAttribute("typ",typ);
			      val0.setAttribute("frrinr",frrinr);
			      val0.setAttribute("objinr",objinr);
			      val0.setAttribute("objtyp",objtyp);
			      
			      
			      grd.add(new IValue[]{chk1,val0});
			    }
			    else
			    {
			      AttributeValue val1 = new AttributeValue(tmpgrd.get(i)[0].getValue());
			      val1.setAttribute("path",key0);
			      val1.setAttribute("frminr",frminr);
			      val1.setAttribute("frm",frm);
			      val1.setAttribute("pntinr",pntinr);
			      val1.setAttribute("flg",flg);
			      val1.setAttribute("typ",typ);
			      val1.setAttribute("frrinr",frrinr);
			      val1.setAttribute("objinr",objinr);
			      val1.setAttribute("objtyp",objtyp);
			      
			      
			      grd.add(new IValue[]{chk1,val1});
			    }
			  }
			  else
			  {
			    String[] str = key0.split("/");
			    if(str.length == 2)
			    {
			      AttributeValue val2 = new AttributeValue(tmpgrd.get(i)[0].getValue());
			      val2.setAttribute("path",key0);
			      val2.setAttribute("frminr",frminr);
			      val2.setAttribute("frm",frm);
			      val2.setAttribute("pntinr",pntinr);
			      val2.setAttribute("flg",flg);
			      val2.setAttribute("typ",typ);
			      val2.setAttribute("frrinr",frrinr);
			      val2.setAttribute("objinr",objinr);
			      val2.setAttribute("objtyp",objtyp);
			      
			      
			      grd.add(new IValue[]{chk0,val2});
			    }
			    if(str.length == 3)
			    {
			      AttributeValue val3 = new AttributeValue(tmpgrd.get(i)[0].getValue());
			      val3.setAttribute("path",key0);
			      val3.setAttribute("frminr",frminr);
			      val3.setAttribute("frm",frm);
			      val3.setAttribute("pntinr",pntinr);
			      val3.setAttribute("flg",flg);
			      val3.setAttribute("typ",typ);
			      val3.setAttribute("frrinr",frrinr);
			      val3.setAttribute("objinr",objinr);
			      val3.setAttribute("objtyp",objtyp);
			      
			      
			      grd.add(new IValue[]{chk0,val3});
			    }
			  }
			}
		}
        /**
        *   source:dbefrr.@0008.script
        */
        public String caculatetransaction(StreamGrid grid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			int a=0;
			for(int i=0;i<grid.size();i++)
			{
			  AttributeValue val = (AttributeValue)grid.get(i)[1];
			  String frm = (String)val.getAttribute("frm");
			  if(!MdaUtils.isEmpty(frm))
			    a++;
			}
			return String.valueOf(a);
		}
        /**
        *   source:dbefrr.@0010.script
        */
        public Boolean genPntMenu(String path,IValue[] tmp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  - path 交易菜单路径
			  - grd 已分配菜单
			  - srcgrd 未分配菜单
			  @ 无返回值 在已分配菜单中生成要分配的交易的父菜单
			  */
			//左右移动菜单时若目标菜单没有该子菜单的父菜单，则要做如下工作：
			//1、将该子菜单的父菜单也添加到目标菜单，父菜单要考虑一级菜单和二级菜单，共三种情况：
			//      将二级菜单交易分配给角色，只需生成一级菜单移到右边；
			//      将三级菜单交易分配给角色且该角色下已分配了该三级菜单交易对应的一级菜单，只需生成对应二级菜单移到右边；
			//      将三级菜单交易分配给角色且该角色下没有分配过该交易对应的一级、二级菜单，则需生成对应的一级菜单、二级菜单移到右边。
			//2、检查原菜单该父菜单下面是否还有子菜单，若有则不做操作；若没有则要删除这个空菜单
			StreamGrid srcgrd = this.getFrrgrp().getLftgrd();
			StreamGrid grd = this.getFrrgrp().getRgtgrd();
			ArrayList pntmen = new ArrayList();
			for(int i=0;i<grd.size();i++)
			{
			  AttributeValue val = (AttributeValue)grd.get(i)[1];
			  String frm = (String)val.getAttribute("frm");
			  if(MdaUtils.isEmpty(frm))
			  {
			    String topth = (String)val.getAttribute("path");
			    log.debug("{}","pntmen topth:"+topth);
			    pntmen.add(topth);
			  }
			}
			log.debug("{}","pntmen list size:"+pntmen.size());
			String[] str = path.split("/");
			if(java.lang.reflect.Array.getLength(str) == 2)
			{
			  log.debug("{}","所要分配的交易只有一级父菜单。。");
			  String pntone = str[0];
			  log.debug("{}","pntone:"+pntone);
			  IValue[] pnttmp = new IValue[]{};
			  for(int j=0;j<srcgrd.size();j++)
			  {
			    AttributeValue pntval = (AttributeValue)srcgrd.get(j)[1];
			    String srcfrminr = (String)pntval.getAttribute("frminr");
			    if(pntone.equals(srcfrminr))
			    {
			      log.debug("{}","findParentMenuPlace srcfrminr:"+srcfrminr);
			      AttributeValue newchk = new AttributeValue("");
			      
			      
			      pnttmp = new IValue[]{newchk,pntval};
			    }
			  }
			  if(!pntmen.contains(pntone))
			  {
			    log.debug("{}","T OR FF:"+pntmen.contains(pntone));
			    int x = findParentMenuPlace(pntone);
			    log.debug("{}","genPntMenu length2 x:"+x);
			    grd.add(x,pnttmp);
			    grd.add(x+1,tmp);
			    return true;
			  }
			  log.debug("{}","TT OR F:"+pntmen.contains(pntone));
			}
			if(java.lang.reflect.Array.getLength(str) == 3)
			{
			  log.debug("{}","所要分配的交易有二级父菜单。。");
			  String pnttwo = str[0];
			  String pntthr = str[0] + "/" +str[1];
			  String thrfrm = str[1];
			  IValue[] twotmp = new IValue[]{};
			  IValue[] thrtmp = new IValue[]{};
			  log.debug("{}","path str len 3 pntthr:"+pntthr);
			  for(int k=0;k<srcgrd.size();k++)
			  {
			    AttributeValue pntval = (AttributeValue)srcgrd.get(k)[1];
			    String srcfrminr = (String)pntval.getAttribute("frminr");
			    if(pnttwo.equals(srcfrminr))
			    {
			      log.debug("{}","findParentMenuPlace srcfrminr:"+srcfrminr);
			      AttributeValue newchk = new AttributeValue("");
			      
			      
			      twotmp = new IValue[]{newchk,pntval};
			    }
			    if(thrfrm.equals(srcfrminr))
			    {
			      log.debug("{}","findParentMenuPlace srcfrminr:"+srcfrminr);
			      AttributeValue newchk = new AttributeValue("");
			      
			      
			      thrtmp = new IValue[]{newchk,pntval};
			    }
			  }
			  if(!pntmen.contains(pnttwo))
			  {
			    log.debug("{}","pntmen not contain pnttwo...");
			    int y = findParentMenuPlace(pnttwo);
			    pntmen.add(pnttwo);
			    grd.add(y,twotmp);
			    grd.add(y+1,thrtmp);
			    grd.add(y+2,tmp);
			  }
			  else if(pntmen.contains(pnttwo) && !pntmen.contains(pntthr))
			  {
			    log.debug("{}","pntmen contains pnttwo not contains pntthr...");
			    int z = findParentMenuPlace(thrfrm);
			    log.debug("{}","genParentMenu grd size:"+grd.size());
			    log.debug("{}","genParentMenu z:"+z);
			    if(z == grd.size())
			    {
			      grd.add(thrtmp);
			      grd.add(tmp);
			    }
			    else
			    {
			      grd.add(z,thrtmp);
			      grd.add(z+1,tmp);
			    }
			    return true;
			  }
			}
			pntmen.clear();
			return false;
		}
        /**
        *   source:dbefrr.@0011.script
        */
        public int findParentMenuPlace(String pntpth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","findParentMenuPlace pntpth:"+pntpth);
			StreamGrid srcgrd = this.getFrrgrp().getLftgrd();
			StreamGrid grd = this.getFrrgrp().getRgtgrd();
			int b=0;
			int c=0;
			int a=0;
			int d=0;
			for(int l=0;l<grd.size();l++)
			{
			  AttributeValue tgtval = (AttributeValue)grd.get(l)[1];
			  String tgtfrminr = (String)tgtval.getAttribute("frminr");
			  String tgtfrm = (String)tgtval.getAttribute("frm");
			  if(MdaUtils.isEmpty(tgtfrm))
			  {
			    log.debug("{}","findParentMenuPlace tgtfrminr:"+tgtfrminr);
			    a = pntpth.compareTo(tgtfrminr);
			    if(a<0)
			    {
			      log.debug("{}","findParentMenuPlace l:"+l);
			      //grd.add(l,pnttmp);
			      return l;
			      //break;
			    }
			    else
			    {
			      b++;
			      d = l;
			    }
			    c++;
			  }
			}
			log.debug("{}","findParentMenuPlace a:"+a);
			log.debug("{}","findParentMenuPlace b:"+b);
			log.debug("{}","findParentMenuPlace c:"+c);
			if( a>0 && b == c && d+1 < grd.size())
			{
			  log.debug("{}","findParentMenuPlace b=c return:"+ d);
			  int e=0;
			  AttributeValue val1 = (AttributeValue)grd.get(d)[1];
			  String pth1 = (String)val1.getAttribute("path");
			  String frm1 = (String)val1.getAttribute("frm");
			  for (int n=0;n<grd.size();n++)
			  {
			    AttributeValue val3 = (AttributeValue)grd.get(n)[1];
			    String pth3 = (String)val3.getAttribute("path");
			    String frm3 = (String)val3.getAttribute("frm");
			    if(!MdaUtils.isEmpty(frm3) && pth3.startsWith(pth1))
			    {
			      e++;
			    }
			  }
			  return d+e+1;
			}
			/*if( a>0 && b == c && d+1 == grd.size())
			  {
			  return grd.size();
			  }*/
			return 0;
		}
        /**
        *   source:dbefrr.@0012.script
        */
        public void findMenuPlaceAndAdd(IValue[] tmp,String lftkey,String srcfrminr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","findMenuPlaceAndAdd srcfrminr:"+srcfrminr);
			StreamGrid grd = this.getFrrgrp().getRgtgrd();
			log.debug("{}","findMenuPlaceAndAdd rgtgrd size:"+grd.size());
			int b=0;
			int c=0;
			int a=0;
			int d=0;
			int e=0;
			int endidx = lftkey.lastIndexOf("/");
			log.debug("{}","add last index of /:"+endidx);
			String pntpth = lftkey.substring(0,endidx);
			log.debug("{}","add pntpth:"+pntpth);
			for(int j=0;j<grd.size();j++)
			{
			  AttributeValue rgtkeyval = (AttributeValue)grd.get(j)[1];
			  String rgtkey = (String)rgtkeyval.getAttribute("path");
			  String rgtfrminr = (String)rgtkeyval.getAttribute("frminr");
			  if(rgtkey.startsWith(pntpth) && !rgtkey.equals(pntpth))
			  {
			    log.debug("{}","add rgtkey:"+rgtkey);
			    a = srcfrminr.compareTo(rgtfrminr);
			    log.debug("{}","findMenuPlaceAndAdd a:"+a);
			    if(a<0)
			    {
			      log.debug("{}","findMenuPlaceAndAdd j:"+j);
			      grd.add(j,tmp);
			      break;
			    }
			    else
			    {
			      b++;
			      d = j;
			      log.debug("{}","findMenuPlaceAndAdd d:"+d);
			    }
			    c++;
			  }
			}
			log.debug("{}","findMenuPlaceAndAdd b:"+b);
			log.debug("{}","findMenuPlaceAndAdd c:"+c);
			if( a>0 && b == c && d+1 < grd.size())
			{
			  //grd.add(d+1,tmp);
			  AttributeValue rgttmpval = (AttributeValue)grd.get(d)[1];
			  String rgttmp = (String)rgttmpval.getAttribute("path");
			  String rgttmpfrm = (String)rgttmpval.getAttribute("frm");
			  if(MdaUtils.isEmpty(rgttmpfrm))
			  {
			    for(int k=0;k<grd.size();k++)
			    {
			      AttributeValue val = (AttributeValue)grd.get(k)[1];
			      String valkey = (String)val.getAttribute("path");
			      if(!valkey.equals(rgttmp) && valkey.startsWith(rgttmp))
			        e++;
			    }
			  }
			  grd.add(d+e+1,tmp);
			}
			/*if( a>0 && b == c && d+1 == grd.size())
			  {
			  grd.add(tmp);
			  }*/
		}
        /**
        *   source:dbefrr.@0013.script
        */
        public void checkGridMenu(StreamGrid grd)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<grd.size();i++)
			{
			  AttributeValue val1 = (AttributeValue)grd.get(i)[1];
			  String frm1 = (String)val1.getAttribute("frm");
			  if(MdaUtils.isEmpty(frm1))
			  {
			    int a=0;
			    String pth1 = (String)val1.getAttribute("path");
			    for(int j=0;j<grd.size();j++)
			    {
			      AttributeValue val2 = (AttributeValue)grd.get(j)[1];
			      String pth2 = (String)val2.getAttribute("path");
			      String frm2 = (String)val2.getAttribute("frm");
			      if(!MdaUtils.isEmpty(frm2) && pth2.startsWith(pth1))
			        a++;
			    }
			    if(a<=0)
			    {
			      grd.remove(i);
			      i--;
			    }
			  }
			}
		}
        /**
        *   source:dbefrr.@0014.script
        */
        public String [] getPathNodes(String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(nodePath))
			  return null;
			else
			  return nodePath.split("/");
		}
        /**
        *   source:dbefrr.@0015.script
        */
        public int getPathNodeLevel(String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String [] nodes = getPathNodes(nodePath);
			if(nodes == null)
			  return -1;
			else
			  return nodes.length - 1;
		}
        /**
        *   source:dbefrr.@0016.script
        */
        public void gridInsertNode(StreamGrid srcGrid,StreamGrid targetGrid,String nodePath,IValue[] nodeValue,String oprType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  - nodePath 交易菜单路径
			  - grd 已分配菜单
			  - srcgrd 未分配菜单
			  @ 无返回值 在已分配菜单中生成要分配的交易的父菜单
			  */
			//先获取父节点的层级路径
			String parentNodePath = this.getParentNodePath(nodePath);

			//如果当前菜单没有父级，否则就是0级根菜单，0级根菜单不需要做父级处理
			if(parentNodePath != null)
			{
			  //判断父级菜单是否存在
			  if( !this.isNodePathExist(targetGrid,parentNodePath) )
			  {
			    //如果父级菜单不存在，则递归操作父级菜单
			    IValue[] parentNodeValue = getSourceNodeValue(srcGrid,parentNodePath,oprType);
			    //log.debug("parentNodeValue:");
			    //log.debug(parentNodeValue);
			    this.gridInsertNode(srcGrid,targetGrid,parentNodePath,parentNodeValue,oprType);
			  }
			}

			LinkedHashMap<String,IValue[]> parentChildrenNodeMap = null;
			if(parentNodePath != null)
			{
			  parentChildrenNodeMap = this.getNodeChildrenNodes(targetGrid,parentNodePath);
			  if(parentChildrenNodeMap.size() == 0)
			  {
			    //如果父菜单没有子节点，则直接插入
			    int nodeIndex = this.getNodeIndex(targetGrid,parentNodePath);
			    targetGrid.add(nodeIndex+1,nodeValue);
			  }
			  else
			  {
			    //如果父菜单有子节点，则需要排序
			    String preKey = this.sortNodes(parentChildrenNodeMap,nodePath);
			    //如果节点是排序第一个,则加在父菜单下面的第一个菜单位
			    if(preKey.equals(nodePath))
			      targetGrid.add(this.getNodeIndex(targetGrid,parentNodePath) + 1,nodeValue);
			    else
			    {
			      //否则获取要跟在后面的根节点的最后一个子节点位置
			      String lastKey = getLastLevelNodePath(targetGrid,preKey);
			      if(lastKey != null)
			        targetGrid.add(this.getNodeIndex(targetGrid,lastKey) + 1,nodeValue);
			    }
			  }
			}
			else
			{
			  log.debug("{}","gridInsert nodePath:"+nodePath);
			  LinkedHashMap<String,IValue[]> rootNodeMap = this.getRootNodes(targetGrid);
			  //如果没有根菜单，随便加
			  if(rootNodeMap.size() == 0)
			    targetGrid.add(targetGrid.size(),nodeValue);
			  else
			  {
			    //排序
			    String preKey = this.sortNodes(rootNodeMap,nodePath);
			    //如果节点是排序第一个,则加在第一个菜单位
			    if(preKey.equals(nodePath))
			      targetGrid.add(0,nodeValue);
			    else
			    {
			      //否则获取要跟在后面的根节点的最后一个子节点位置
			      String lastKey = getLastLevelNodePath(targetGrid,preKey);
			      if(lastKey != null)
			        targetGrid.add(this.getNodeIndex(targetGrid,lastKey) + 1,nodeValue);
			    }
			  }
			}
		}
        /**
        *   source:dbefrr.@0017.script
        */
        public String getParentNodePath(String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!nodePath.contains("/"))
			  return null;

			String [] nodes = getPathNodes(nodePath);
			String parentNodePath = "";
			if(nodes == null)
			  return null;
			else
			{
			  for(int i = 0;i < nodes.length - 1; i++)
			  {
			    if(i != nodes.length - 2)
			      parentNodePath += nodes[i] + "/";
			    else
			      parentNodePath += nodes[i];
			  }
			}
			return parentNodePath;
		}
        /**
        *   source:dbefrr.@0018.script
        */
        public boolean isNodePathExist(StreamGrid grid,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<grid.size();i++)
			{
			  AttributeValue val = (AttributeValue)grid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if(key.equals(nodePath))
			    return true;
			}
			return false;
		}
        /**
        *   source:dbefrr.@0019.script
        */
        public IValue[] getSourceNodeValue(StreamGrid srcGrid,String nodePath,String oprType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<srcGrid.size();i++)
			{
			  AttributeValue val = (AttributeValue)srcGrid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if(key.equals(nodePath))
			  {
			    String frminr = (String)val.getAttribute("frminr");
			    String frm = (String)val.getAttribute("frm");
			    AttributeValue newchk = new AttributeValue("");
			    if(MdaUtils.isEmpty(frm))
			    {
			      newchk.setValue("-");
			      
			      
			      /*val.setAttribute("flg",oprType);
			        if("A".equals(oprType))
			        val.setAttribute("typ","0");
			        else if("D".equals(oprType))
			        val.setAttribute("typ","1");*/
			    }
			    else
			    {
			      
			      
			      val.setAttribute("flg",oprType);
			      /*if("A".equals(oprType))
			        val.setAttribute("typ","0");
			        else if("D".equals(oprType))
			        val.setAttribute("typ","1");*/
			    }
			    IValue[] nodeValue = new IValue[]{newchk,val};
			    return nodeValue;
			  }
			}
			return null;
		}
        /**
        *   source:dbefrr.@0020.script
        */
        public LinkedHashMap<String,IValue[]> getNodeChildrenNodes(StreamGrid targetGrid,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,IValue[]> valueMap = new LinkedHashMap<String,IValue[]>();
			//log.debug("targetGrid size:" + targetGrid.size());
			//log.debug(targetGrid);
			for(int i=0;i<targetGrid.size();i++)
			{
			  AttributeValue val = (AttributeValue)targetGrid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if( !key.equals(nodePath) && key.startsWith(nodePath))
			    valueMap.put(key,targetGrid.get(i));
			}
			return valueMap;
		}
        /**
        *   source:dbefrr.@0021.script
        */
        public int getNodeIndex(StreamGrid grid,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<grid.size();i++)
			{
			  AttributeValue val = (AttributeValue)grid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if(key.equals(nodePath))
			    return i;
			}
			return -1;
		}
        /**
        *   source:dbefrr.@0022.script
        */
        public LinkedHashMap<String,IValue[]> getRootNodes(StreamGrid targetGrid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,IValue[]> valueMap = new LinkedHashMap<String,IValue[]>();
			for(int i=0;i<targetGrid.size();i++)
			{
			  AttributeValue val = (AttributeValue)targetGrid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if( !key.contains("/") )
			    valueMap.put(key,targetGrid.get(i));
			}
			return valueMap;
		}
        /**
        *   source:dbefrr.@0023.script
        */
        public String sortNodes(LinkedHashMap<String,IValue[]> sameLevelNodesMap,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object [] keyset = sameLevelNodesMap.keySet().toArray();
			List<String> keys = new ArrayList<String>();
			String key = this.getLastKeyString(nodePath);
			log.debug("{}","sortNodes key:"+key);
			keys.add(key);
			for(int i = 0 ; i < keyset.length;i++)
			  keys.add(this.getLastKeyString(keyset[i].toString()));

			log.debug("{}",keys);
			Collections.sort(keys);
			log.debug("{}",keys);

			String preKey = "";
			for(int i = 0; i < keys.size(); i++)
			{
			  if(keys.get(i).equals(key))
			  {
			    if(MdaUtils.isEmpty(preKey))
			      preKey = key;
			    break;
			  }
			  else
			    preKey = keys.get(i);
			}
			log.debug("{}","preKey:" + preKey);

			if(preKey.equals(key))
			  preKey = nodePath;
			else
			{
			  for(int i = 0 ; i < keyset.length;i++)
			  {
			    if(preKey.equals(this.getLastKeyString(keyset[i].toString())))
			    {
			      preKey = keyset[i].toString();
			      break;
			    }
			  }
			}
			log.debug("{}","preKey:" + preKey);
			return preKey;
		}
        /**
        *   source:dbefrr.@0024.script
        */
        public String getLastKeyString(String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String [] nodes = getPathNodes(nodePath);
			if(MdaUtils.isEmpty(nodes))
			  return null;
			else
			  return nodes[nodes.length - 1];
		}
        /**
        *   source:dbefrr.@0025.script
        */
        public String getLastLevelNodePath(StreamGrid targetGrid,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,IValue[]> childrenNodeMap = getNodeChildrenNodes(targetGrid,nodePath);
			if(childrenNodeMap.size() == 0)
			  return nodePath;
			else
			{
			  Object [] keyset = childrenNodeMap.keySet().toArray();
			  String lastKey = keyset[keyset.length - 1].toString();
			  return getLastLevelNodePath(targetGrid,lastKey);
			}
		}
        /**
        *   source:dbefrr.@0027.script
        */
        public void addAllChildrenNodesIntoMap(LinkedHashMap<String,IValue[]> extendMap,StreamGrid sourceGrid,String newNodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,IValue[]> childrenNodes = this.getNodeChildrenNodes(sourceGrid,newNodePath);
			log.debug("{}",childrenNodes);
			if(childrenNodes.size() > 0)
			{
			  Object [] keyset = childrenNodes.keySet().toArray();
			  for(int i = 0 ; i < keyset.length;i++)
			  {
			    String nodePath = keyset[i].toString();
			    //addAllChildrenNodesIntoMap(extendMap,sourceGrid,nodePath);
			    IValue [] nodeValues = childrenNodes.get(nodePath);
			    extendMap.put(nodePath,nodeValues);
			    int index = this.getNodeIndex(sourceGrid,nodePath);
			    sourceGrid.remove(index);
			  }
			}
		}
        /**
        *   source:dbefrr.@0028.script
        */
        public void addAllChildrenNodesFromMap(LinkedHashMap<String,IValue[]> extendMap,StreamGrid sourceGrid,String newNodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}",extendMap);
			if(extendMap.size() > 0)
			{
			  Object [] keyset = extendMap.keySet().toArray();
			  int index = this.getNodeIndex(sourceGrid,newNodePath);
			  for(int i = keyset.length - 1 ; i >= 0 ;i--)
			  {
			    String nodePath = keyset[i].toString();
			    IValue [] nodeValues = extendMap.get(nodePath);
			    sourceGrid.add(index+1,nodeValues);
			  }
			}
		}
        /**
        *   source:dbefrr.@0031.script
        */
        public void lftaddBeforeAddAndRemove(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			log.debug("{}","left grid selected index:" + index);
			if(index > -1)
			{
			  AttributeValue attr0 = (AttributeValue)lftgrd.get(index)[0];
			  String str = attr0.getValue().toString().trim();
			  log.debug("{}","str:" + str);
			  if("-".equals(str) || "+".equals(str))
			  {
			    AttributeValue attr1 = (AttributeValue)lftgrd.get(index)[1];
			    String nodePath = (String)attr1.getAttribute("path");
			    Map<String,LinkedHashMap<String,IValue[]> > lftExtendMap = this.getLftmap();
			    //收缩菜单
			    if("-".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = new LinkedHashMap<String,IValue[]>();
			      addAllChildrenNodesIntoMap(addExtendMap,lftgrd,nodePath);
			      lftExtendMap.put(nodePath,addExtendMap);
			      attr0.setValue("+");
			    }
			    else if("+".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = lftExtendMap.get(nodePath);
			      addAllChildrenNodesFromMap(addExtendMap,lftgrd,nodePath);
			      lftExtendMap.remove(nodePath);
			      attr0.setValue("-");
			    }
			  }
			  //Platform.setModified($frrp\\lftgrd);
			}
		}
        /**
        *   source:dbefrr.@0032.script
        */
        public void rgtaddBeforeAddAndRemove(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			log.debug("{}","right grid selected index:" + index);
			if(index > -1)
			{
			  AttributeValue attr0 = (AttributeValue)rgtgrd.get(index)[0];
			  String str = attr0.getValue().toString().trim();
			  log.debug("{}","str:" + str);
			  if("-".equals(str) || "+".equals(str))
			  {
			    AttributeValue attr1 = (AttributeValue)rgtgrd.get(index)[1];
			    String nodePath = (String)attr1.getAttribute("path");
			    Map<String,LinkedHashMap<String,IValue[]> > rgtExtendMap = this.getRgtmap();
			    //收缩菜单
			    if("-".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = new LinkedHashMap<String,IValue[]>();
			      addAllChildrenNodesIntoMap(addExtendMap,rgtgrd,nodePath);
			      rgtExtendMap.put(nodePath,addExtendMap);
			      attr0.setValue("+");
			    }
			    else if("+".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = rgtExtendMap.get(nodePath);
			      addAllChildrenNodesFromMap(addExtendMap,rgtgrd,nodePath);
			      rgtExtendMap.remove(nodePath);
			      attr0.setValue("-");
			    }
			  }
			  //Platform.setModified($frrp\\rgtgrd);
			}
		}
        /**
        *   source:dbefrr.@0036.script
        */
        public LinkedHashMap<String,Map> checkGridMenu(LinkedHashMap<String,Map> map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,Map> rmvmap=new LinkedHashMap();
			for(String key : map.keySet())
			{
			  if(MdaUtils.isEmpty(map.get(key).get("3")))
			  {
			    int a=0;
			    for(String key0 : map.keySet())
			    {
			      if(!key0.equals(key))
			      {
			        if(key0.startsWith(key) && !MdaUtils.isEmpty(map.get(key0).get("3")))
			          a++;
			      }
			    }
			    if(a<=0)
			    {
			      Map<String,String> val = map.get(key);
			      rmvmap.put(key,val);
			    }
			  }
			}
			log.debug("{}","check menu rmvmap size:"+rmvmap.size());
			for(String key1 : rmvmap.keySet())
			{
			  map.remove(key1);
			}
			return rmvmap;
		}
        /**
        *   source:dbefrr.@0037.script
        */
        public LinkedHashMap<String,Map> sortAndGenerLeftGridMenuMap()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//未分配菜单交易列表排序并生成MAP
			LinkedHashMap<String,Map> lftmap = new LinkedHashMap();
			for(int l=0;l<this.getFrrgrp().getFrrlst1().fullSize();l++)
			{
			  Map<String,String> lft0 = new HashMap();
			  lft0.put("1",this.getFrrgrp().getFrrlst1().getElement(l).getFrminr());
			  lft0.put("2",this.getFrrgrp().getFrrlst1().getElement(l).getDsp());
			  lft0.put("3",this.getFrrgrp().getFrrlst1().getElement(l).getFrm());
			  lft0.put("4",this.getFrrgrp().getFrrlst1().getElement(l).getPntinr());
			  lft0.put("5",this.getFrrgrp().getFrrlst1().getElement(l).getFlg());
			  lft0.put("6",this.getFrrgrp().getFrrlst1().getElement(l).getTyp());
			  lft0.put("7",this.getFrrgrp().getFrrlst1().getElement(l).getInr());
			  lft0.put("8",this.getFrrgrp().getFrrlst1().getElement(l).getObjinr());
			  lft0.put("9",this.getFrrgrp().getFrrlst1().getElement(l).getObjtyp());
			  if(MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(l).getPntinr()))
			  {
			    this.getFrrgrp().getLfttmplst().add(this.getFrrgrp().getFrrlst1().getElement(l));
			    String pth0 = null;
			    pth0 = this.getFrrgrp().getFrrlst1().getElement(l).getFrminr();
			    lftmap.put(pth0,lft0);
			    log.debug("{}","sortAndGenerRightGridMenuMap lpth0:"+pth0);
			    for(int m=0;m<this.getFrrgrp().getFrrlst1().fullSize();m++)
			    {
			      Map<String,String> lft1 = new HashMap();
			      lft1.put("1",this.getFrrgrp().getFrrlst1().getElement(m).getFrminr());
			      lft1.put("2",this.getFrrgrp().getFrrlst1().getElement(m).getDsp());
			      lft1.put("3",this.getFrrgrp().getFrrlst1().getElement(m).getFrm());
			      lft1.put("4",this.getFrrgrp().getFrrlst1().getElement(m).getPntinr());
			      lft1.put("5",this.getFrrgrp().getFrrlst1().getElement(m).getFlg());
			      lft1.put("6",this.getFrrgrp().getFrrlst1().getElement(m).getTyp());
			      lft1.put("7",this.getFrrgrp().getFrrlst1().getElement(m).getInr());
			      lft1.put("8",this.getFrrgrp().getFrrlst1().getElement(m).getObjinr());
			      lft1.put("9",this.getFrrgrp().getFrrlst1().getElement(m).getObjtyp());
			      if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(m).getPntinr()))
			      {
			        if(this.getFrrgrp().getFrrlst1().getElement(m).getPntinr().equals(this.getFrrgrp().getFrrlst1().getElement(l).getFrminr()))
			        {
			          this.getFrrgrp().getLfttmplst().add(this.getFrrgrp().getFrrlst1().getElement(m));
			          String pth1 = null;
			          pth1 = this.getFrrgrp().getFrrlst1().getElement(l).getFrminr() + "/" + this.getFrrgrp().getFrrlst1().getElement(m).getFrminr();
			          lftmap.put(pth1,lft1);
			          log.debug("{}","sortAndGenerRightGridMenuMap lpth1:"+pth1);
			          for(int n=0;n<this.getFrrgrp().getFrrlst1().fullSize();n++)
			          {
			            Map<String,String> lft2 = new HashMap();
			            lft2.put("1",this.getFrrgrp().getFrrlst1().getElement(n).getFrminr());
			            lft2.put("2",this.getFrrgrp().getFrrlst1().getElement(n).getDsp());
			            lft2.put("3",this.getFrrgrp().getFrrlst1().getElement(n).getFrm());
			            lft2.put("4",this.getFrrgrp().getFrrlst1().getElement(n).getPntinr());
			            lft2.put("5",this.getFrrgrp().getFrrlst1().getElement(n).getFlg());
			            lft2.put("6",this.getFrrgrp().getFrrlst1().getElement(n).getTyp());
			            lft2.put("7",this.getFrrgrp().getFrrlst1().getElement(n).getInr());
			            lft2.put("8",this.getFrrgrp().getFrrlst1().getElement(n).getObjinr());
			            lft2.put("9",this.getFrrgrp().getFrrlst1().getElement(n).getObjtyp());
			            if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(n).getPntinr()))
			            {
			              if(this.getFrrgrp().getFrrlst1().getElement(n).getPntinr().equals(this.getFrrgrp().getFrrlst1().getElement(m).getFrminr()))
			              {
			                this.getFrrgrp().getLfttmplst().add(this.getFrrgrp().getFrrlst1().getElement(n));
			                String pth2 = null;
			                pth2 = this.getFrrgrp().getFrrlst1().getElement(l).getFrminr() + "/" + this.getFrrgrp().getFrrlst1().getElement(m).getFrminr() + "/" + this.getFrrgrp().getFrrlst1().getElement(n).getFrminr();
			                lftmap.put(pth2,lft2);
			                log.debug("{}","sortAndGenerRightGridMenuMap lpth2:"+pth2);
			              }
			            }
			          }
			        }
			      }
			    }
			  }
			}
			log.debug("{}","frr check rolnam lfttmplst size:"+this.getFrrgrp().getLfttmplst().size());

			/*
			  while($frrgrp\\frrlst1.fullSize()>0)
			  $frrgrp\\frrlst1.removeAll();
			  for(int b=0;b<$frrgrp\\lfttmplst.size();b++)
			  $frrgrp\\frrlst1.add($frrgrp\\lfttmplst[b]);
			  log.debug("After sort frrlst1 size:"+$frrgrp\\frrlst1.size());
			  while($frrgrp\\lfttmplst.fullSize()>0)
			  $frrgrp\\lfttmplst.removeAll();
			  for(int x=0;x<$frrgrp\\frrlst1.size();x++)
			  {
			  if(!Platform.isEmpty($frrgrp\\frrlst1[x]\\frm))
			  $frrgrp\\lfttmplst.add($frrgrp\\frrlst1[x]);
			  }
			  log.debug("After sort lfttmplst frm not null size:" + $frrgrp\\lfttmplst.size());
			  */
			return lftmap;
		}
        /**
        *   source:dbefrr.@0038.script
        */
        public LinkedHashMap<String,Map> sortAndGenerRightGridMenuMap()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//已分配交易列表排序并生成MAP
			LinkedHashMap<String,Map> rgtmap = new LinkedHashMap();
			for(int i=0;i<this.getFrrgrp().getFrrlst2().fullSize();i++)
			{
			  Map<String,String> rgt0 = new HashMap();
			  rgt0.put("1",this.getFrrgrp().getFrrlst2().getElement(i).getFrminr());
			  rgt0.put("2",this.getFrrgrp().getFrrlst2().getElement(i).getDsp());
			  rgt0.put("3",this.getFrrgrp().getFrrlst2().getElement(i).getFrm());
			  rgt0.put("4",this.getFrrgrp().getFrrlst2().getElement(i).getPntinr());
			  rgt0.put("5",this.getFrrgrp().getFrrlst2().getElement(i).getFlg());
			  rgt0.put("6",this.getFrrgrp().getFrrlst2().getElement(i).getTyp());
			  rgt0.put("7",this.getFrrgrp().getFrrlst2().getElement(i).getInr());
			  rgt0.put("8",this.getFrrgrp().getFrrlst2().getElement(i).getObjinr());
			  rgt0.put("9",this.getFrrgrp().getFrrlst2().getElement(i).getObjtyp());
			  if(MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(i).getPntinr()))
			  {
			    this.getFrrgrp().getRgttmplst().add(this.getFrrgrp().getFrrlst2().getElement(i));
			    String pth0 = null;
			    pth0 = this.getFrrgrp().getFrrlst2().getElement(i).getFrminr();
			    rgtmap.put(pth0,rgt0);
			    log.debug("{}","sortAndGenerRightGridMenuMap rpth0:"+pth0);
			    for(int j=0;j<this.getFrrgrp().getFrrlst2().fullSize();j++)
			    {
			      Map<String,String> rgt1 = new HashMap();
			      rgt1.put("1",this.getFrrgrp().getFrrlst2().getElement(j).getFrminr());
			      rgt1.put("2",this.getFrrgrp().getFrrlst2().getElement(j).getDsp());
			      rgt1.put("3",this.getFrrgrp().getFrrlst2().getElement(j).getFrm());
			      rgt1.put("4",this.getFrrgrp().getFrrlst2().getElement(j).getPntinr());
			      rgt1.put("5",this.getFrrgrp().getFrrlst2().getElement(j).getFlg());
			      rgt1.put("6",this.getFrrgrp().getFrrlst2().getElement(j).getTyp());
			      rgt1.put("7",this.getFrrgrp().getFrrlst2().getElement(j).getInr());
			      rgt1.put("8",this.getFrrgrp().getFrrlst2().getElement(j).getObjinr());
			      rgt1.put("9",this.getFrrgrp().getFrrlst2().getElement(j).getObjtyp());
			      if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(j).getPntinr()))
			      {
			        if(this.getFrrgrp().getFrrlst2().getElement(j).getPntinr().equals(this.getFrrgrp().getFrrlst2().getElement(i).getFrminr()))
			        {
			          this.getFrrgrp().getRgttmplst().add(this.getFrrgrp().getFrrlst2().getElement(j));
			          String pth1 = null;
			          pth1 = this.getFrrgrp().getFrrlst2().getElement(i).getFrminr() + "/" + this.getFrrgrp().getFrrlst2().getElement(j).getFrminr();
			          rgtmap.put(pth1,rgt1);
			          log.debug("{}","sortAndGenerRightGridMenuMap rpth1:"+pth1);
			          for(int z=0;z<this.getFrrgrp().getFrrlst2().fullSize();z++)
			          {
			            Map<String,String> rgt2 = new HashMap();
			            rgt2.put("1",this.getFrrgrp().getFrrlst2().getElement(z).getFrminr());
			            rgt2.put("2",this.getFrrgrp().getFrrlst2().getElement(z).getDsp());
			            rgt2.put("3",this.getFrrgrp().getFrrlst2().getElement(z).getFrm());
			            rgt2.put("4",this.getFrrgrp().getFrrlst2().getElement(z).getPntinr());
			            rgt2.put("5",this.getFrrgrp().getFrrlst2().getElement(z).getFlg());
			            rgt2.put("6",this.getFrrgrp().getFrrlst2().getElement(z).getTyp());
			            rgt2.put("7",this.getFrrgrp().getFrrlst2().getElement(z).getInr());
			            rgt2.put("8",this.getFrrgrp().getFrrlst2().getElement(z).getObjinr());
			            rgt2.put("9",this.getFrrgrp().getFrrlst2().getElement(z).getObjtyp());
			            if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(z).getPntinr()))
			            {
			              if(this.getFrrgrp().getFrrlst2().getElement(z).getPntinr().equals(this.getFrrgrp().getFrrlst2().getElement(j).getFrminr()))
			              {
			                this.getFrrgrp().getRgttmplst().add(this.getFrrgrp().getFrrlst2().getElement(z));
			                String pth2 = null;
			                pth2 = this.getFrrgrp().getFrrlst2().getElement(i).getFrminr() + "/" + this.getFrrgrp().getFrrlst2().getElement(j).getFrminr() + "/" + this.getFrrgrp().getFrrlst2().getElement(z).getFrminr();
			                rgtmap.put(pth2,rgt2);
			                log.debug("{}","sortAndGenerRightGridMenuMap rpth2:"+pth2);
			              }
			            }
			          }
			        }
			      }
			    }
			  }
			}
			log.debug("{}","frr check rolnam rgttmplst size:"+this.getFrrgrp().getRgttmplst().size());
			/*
			  while($frrgrp\\frrlst2.fullSize()>0)
			  $frrgrp\\frrlst2.removeAll();
			  for(int a=0;a<$frrgrp\\rgttmplst.size();a++)
			  $frrgrp\\frrlst2.add($frrgrp\\rgttmplst[a]);
			  log.debug("After sort frrlst2 size:"+$frrgrp\\frrlst2.size());
			  while($frrgrp\\rgttmplst.fullSize()>0)
			  $frrgrp\\rgttmplst.removeAll();
			  for(int y=0;y<$frrgrp\\frrlst2.size();y++)
			  {
			  if(!Platform.isEmpty($frrgrp\\frrlst2[y]\\frm))
			  $frrgrp\\rgttmplst.add($frrgrp\\frrlst2[y]);
			  }
			  log.debug("After sort rgttmplst frm not null size:" + $frrgrp\\rgttmplst.size());
			  */
			return rgtmap;
		}
        /**
        *   source:dbefrr.@0039.script
        */
        public void generGrid(LinkedHashMap<String,Map> map,StreamGrid grid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IAttributeValue h = new AttributeValue("菜单名称");
			
			grid.setHeaders(new IAttributeValue[]{h});
			LinkedHashMap<String,Map> rmvmap=new LinkedHashMap();
			for(String key : map.keySet())
			{
			  if(!key.contains("/"))
			  {
			    log.debug("{}","key0:"+map.get(key));
			    AttributeValue val1= new AttributeValue(map.get(key).get("2"));
			    val1.setAttribute("path",key);
			    val1.setAttribute("frminr",map.get(key).get("1"));
			    val1.setAttribute("frm",map.get(key).get("3"));
			    val1.setAttribute("pntinr",map.get(key).get("4"));
			    val1.setAttribute("flg",map.get(key).get("5"));
			    val1.setAttribute("typ",map.get(key).get("6"));
			    val1.setAttribute("inr",map.get(key).get("7"));
			    val1.setAttribute("objinr",map.get(key).get("8"));
			    val1.setAttribute("objtyp",map.get(key).get("9"));
			    
			    
			    grid.add(new IValue[]{val1});
			  }
			  else
			  {
			    String[] str = key.split("/");
			    if(java.lang.reflect.Array.getLength(str) == 2)
			    {
			      AttributeValue val2 = new AttributeValue(map.get(key).get("2"));
			      val2.setAttribute("path",key);
			      val2.setAttribute("frminr",map.get(key).get("1"));
			      val2.setAttribute("frm",map.get(key).get("3"));
			      val2.setAttribute("pntinr",map.get(key).get("4"));
			      val2.setAttribute("flg",map.get(key).get("5"));
			      val2.setAttribute("typ",map.get(key).get("6"));
			      val2.setAttribute("inr",map.get(key).get("7"));
			      val2.setAttribute("objinr",map.get(key).get("8"));
			      val2.setAttribute("objtyp",map.get(key).get("9"));
			      
			      
			      grid.add(new IValue[]{val2});
			    }
			    if(java.lang.reflect.Array.getLength(str) == 3)
			    {
			      log.debug("{}","key2:"+map.get(key));
			      AttributeValue val3 = new AttributeValue(map.get(key).get("2"));
			      val3.setAttribute("path",key);
			      val3.setAttribute("frminr",map.get(key).get("1"));
			      val3.setAttribute("frm",map.get(key).get("3"));
			      val3.setAttribute("pntinr",map.get(key).get("4"));
			      val3.setAttribute("flg",map.get(key).get("5"));
			      val3.setAttribute("typ",map.get(key).get("6"));
			      val3.setAttribute("inr",map.get(key).get("7"));
			      val3.setAttribute("objinr",map.get(key).get("8"));
			      val3.setAttribute("objtyp",map.get(key).get("9"));
			      
			      
			      grid.add(new IValue[]{val3});
			    }
			  }
			}
		}








}