package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DberolVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rolp;
import com.ceb.gjjs.mda.manager.module.Rolgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 角色修改
*/
@Transaction(vo= DberolVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dberol extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dberol.class);

		@BDGetter
		private Rolgrp rolgrp;

		@BDGetter
		private Rolp rolp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Dberol()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getRolp().setRolgrpHolder(()->this.getRolgrp());
           this.getRolp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getRolgrp());
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dberol.this.getFieldPath("rolgrp.rec.inr");}
 				public void setValue(String arg){Dberol.this.getRolgrp().getRec().setInr(arg);}
 				public String getValue(){return Dberol.this.getRolgrp().getRec().getInr();}}
			 );
        }

        /**
        *   source:dberol.@0001.script
        */
        @Rule(target="mtabut.submit",order=200)
        public boolean ruleMtabutSubmitN200(){
            IContext ctx = MdaEnv.getContext();
            
			/* log.debug("submit 200");
			  $rolgrp\\recsavflg="save";
			  String rolinr=$rolgrp\\rec\\inr.getValue();
			  Platform.clear($rolgrp\\oldlst);
			  Platform.clear($rolgrp\\newlst);
			  $rolp.addVisibleFrm(rolinr);
			  $rolp.addOftenFrm(rolinr);
			  $rolp.addOriList(rolinr);
			  //保存到oldlst中
			  //Platform.mdbReadset($rolgrp\\oldlst,new Argument<String>("objinr",rolinr),new Argument<String>("objtyp","rol"));
			  ///保存交易流水
			  //$trnmod.trnSetFromStaticContract("角色维护","修改",$rolgrp\\rec\\nam.getValue());
			  //$trnmod.trnSetFromContract("角色维护","修改",$rolgrp\\rec\\nam.getValue());
			  ///保存页面快照
			  //$trnmod.savTrnDsp($rolp\\rolp12a,$trnmod\\trn\\inr.getValue());
			  //$trnmod.savePanelDisplay($rolp\\rolp12a,$trnmod\\trn\\inr.getValue());*/

			return true;
        }

        /**
        *   source:dberol.@0003.script
        */
        @Rule(target="rolp.sav",order=100)
        public boolean ruleRolpSavN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  List<String>newlist = new ArrayList<String>();
			  List<String>oftlist = new ArrayList<String>();
			  for(int i=0;i<$rolgrp\\frmlst2.fullSize();i++)
			  {
			  String frm = $rolgrp\\frmlst2[i]\\frm.getValue();
			  newlist.add(frm);
			  }
			  for(int i=0;i<$rolgrp\\oftlst.size();i++)
			  {
			  String frm=$rolgrp\\oftlst[i]\\frm.getValue();
			  oftlist.add(frm);
			  }
			  Platform.storeData("dblgetrol",$rolgrp\\rec\\inr.getValue());
			  Platform.storeData("newlist",newlist);
			  Platform.storeData("oftlist",oftlist);
			  Platform.mchain("dberam");*/

			return true;
        }

        /**
        *   source:dberol.@0010.script
        */
        @Rule(target="rolp.addall",order=500)
        public boolean ruleRolpAddallN500(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  for(int i=$rolgrp\\frmlst1.fullSize() - 1;i>=0;i--)
			  {
			  if("X".equals($rolgrp\\frmlst1[i]\\chk.getValue()))
			  {
			  $rolgrp\\frmlst1[i]\\chk.setValue("");
			  $rolgrp\\frmlst2.add($rolgrp\\frmlst1[i]);
			  $rolgrp\\frmlst1.remove(i);
			  }
			  }
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  //未分配
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;
			  Platform.setModified($rolp\\number1);
			  Platform.setModified($rolp\\number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);*/

			return true;
        }

        /**
        *   source:dberol.@0011.script
        */
        @Rule(target="rolp.addall",order=100)
        public boolean ruleRolpAddallN100(){
            IContext ctx = MdaEnv.getContext();
            
			/* for(int i=0;i<$rolgrp\\frmlst1.fullSize();i++)
			  {
			  $rolgrp\\frmlst2.add($rolgrp\\frmlst1[i]);
			  }
			  Platform.clear($rolgrp\\frmlst1);
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;
			  Platform.setModified($rolp\\number1);
			  Platform.setModified($rolp\\number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);*/

			return true;
        }

        /**
        *   source:dberol.@0012.script
        */
        @Rule(target="rolp.rev",order=100)
        public boolean ruleRolpRevN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  for(int i=$rolgrp\\frmlst2.fullSize() - 1;i>=0;i--)
			  {
			  if("X".equals($rolgrp\\frmlst2[i]\\chk.getValue()))
			  {
			  $rolgrp\\frmlst2[i]\\chk.setValue("");
			  $rolgrp\\frmlst1.add($rolgrp\\frmlst2[i]);
			  $rolgrp\\frmlst2.remove(i);
			  }
			  }
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  //未分配
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;
			  Platform.setModified($rolp\\number1);
			  Platform.setModified($rolp\\number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);*/

			return true;
        }

        /**
        *   source:dberol.@0013.script
        */
        @Rule(target="rolp.revall",order=100)
        public boolean ruleRolpRevallN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.clear($rolgrp\\newlst);
			  for(int i=0;i<$rolgrp\\frmlst2.fullSize();i++)
			  {
			  $rolgrp\\frmlst1.add($rolgrp\\frmlst2[i]);
			  }
			  Platform.clear($rolgrp\\frmlst2);
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;
			  Platform.setModified($rolp\\number1);
			  Platform.setModified($rolp\\number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);*/

			return true;
        }

        /**
        *   source:dberol.@0014.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTrnmod().trnSetFromContract("参数维护","角色信息修改",this.getRolgrp().getRec().getNam());
			this.getTrnmod().savePanelDisplay(this.getRolp().getAmerol(),this.getTrnmod().getTrn().getInr());

			return true;
        }

        /**
        *   source:dberol.@0017.script
        */
        @Rule(target="rolgrp.rec.lev",order=100)
        public boolean ruleRolgrpRecLevN100(){
            IContext ctx = MdaEnv.getContext();
            

			ctx.setFieldError(this,"rolgrp.rec.rellev",MdaUtils.getI18NString("dberol","CT000011"));

			return true;
        }



        /**
        *   source:dberol.@0000.script
        */
        @Init(order=110)
        public boolean	init110(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  *1.初始化不可见，可见和常用列表，读取frr，
			  *是1的填充到不可见列表，2的填充到常用列表，0的填充到可见的交易列表
			  *2.frr表中记录的角色---交易信息保存在list中
			  *3.通过读取全部的交易alllist和保存的list，得到剩下的leftlist,把leftlist中的数据按照原样保存
			  到各个list中。
			  **/
			/*$rolgrp\\flg=1;
			  String rolinr = (String)Platform.restoreData("rol");
			  Platform.mdbRead($rolgrp\\rec,new Argument<String>("inr",EQ,rolinr));
			  //读取该角色的交易信息
			  Platform.mdbReadset($rolp\\tmplst,new Argument<String>("objtyp","rol"),new Argument<String>("objinr",rolinr));
			  Platform.clear($rolgrp\\frmlst1);
			  Platform.clear($rolgrp\\frmlst2);
			  Platform.clear($rolgrp\\oftlst);
			  List<String> list=new ArrayList<String>();
			  for(int i=0;i<$rolp\\tmplst.fullSize();i++)
			  {
			  list.add($rolp\\tmplst[i]\\frminr.getValue());
			  Platform.mdbRead($rolgrp\\frm,new Argument<String>("inr",$rolp\\tmplst[i]\\frminr.getValue()));
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frm=new Argument<String>("frm");
			  Argument<String>dsp=new Argument<String>("dsp");
			  Argument<String>frmtyp=new Argument<String>("frmtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  inr.setValue($rolgrp\\frm\\inr.getValue());
			  frm.setValue($rolgrp\\frm\\frm.getValue());
			  frmtyp.setValue($rolgrp\\frm\\frmtyp.getValue());
			  typ.setValue($rolgrp\\frm\\typ.getValue());
			  dsp.setValue($rolgrp\\frm\\dsp.getValue());
			  if("1".equals($rolp\\tmplst[i]\\typ.getValue()))
			  {
			  $rolgrp\\frmlst1.add(inr,frm,frmtyp,typ,dsp);
			  }
			  else if("0".equals($rolp\\tmplst[i]\\typ.getValue()))
			  {
			  $rolgrp\\frmlst2.add(inr,frm,dsp,frmtyp,typ,dsp);
			  }
			  else if("2".equals($rolp\\tmplst[i]\\typ.getValue()))
			  {
			  $rolgrp\\oftlst.add(inr,frm,dsp,frmtyp,typ,dsp);
			  }
			  }
			  List<String> allist=new ArrayList<String>();
			  //获取全部交易
			  Platform.mdbReadset($rolp\\alllst,Argument.or(new Argument<String>("frmtyp","A"),new Argument<String>("frmtyp","B")));
			  for(int i=0;i<$rolp\\alllst.fullSize();i++)
			  {
			  allist.add($rolp\\alllst[i]\\inr.getValue());
			  }
			  //处理剩余的交易列表，按照原样填充list
			  $rolp.addLeft(list,allist);*/

			return true;
        }

        /**
        *   source:dberol.@0004.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			if("0".equals(this.getRolgrp().getRec().getLev()))
			  MdaUtils.setValues(this.getRolgrp().getRec(),"rellev",MdaUtils.getCodetable("rellev0"));
			else if("1".equals(this.getRolgrp().getRec().getLev()))
			  MdaUtils.setValues(this.getRolgrp().getRec(),"rellev",MdaUtils.getCodetable("rellev1"));
			else if("2".equals(this.getRolgrp().getRec().getLev()))
			  MdaUtils.setValues(this.getRolgrp().getRec(),"rellev",MdaUtils.getCodetable("rellev2"));

			return true;
        }

        /**
        *   source:dberol.@0008.script
        */
        @Init(order=3000)
        public boolean	init3000(){
            IContext ctx = MdaEnv.getContext();
            
			/*String name1=Platform.getI18nValue("eibs","menu.dbrusr");
			  log.debug("name1 is:"+name1);
			  for(#frm frm: $rolgrp\\frmlst2)
			  {
			  String key=$$frm\\dsp;
			  String name=Platform.getI18nValue("eibs",key);
			  $$frm\\dsp=name;
			  }
			  for(#frm frm: $rolgrp\\frmlst1)
			  {
			  String key=$$frm\\dsp;
			  String name=Platform.getI18nValue("eibs",key);
			  $$frm\\dsp=name;
			  }
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;*/

			return true;
        }

        /**
        *   source:dberol.@0016.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Object rolinr=ctx.restoreData("rolinr");
			if(rolinr != null)
			  Platform.mdbRead(this.getRolp().getRolgrp().getRec(),new Argument("inr",rolinr.toString()));
			

			return true;
        }









}