package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbesrlVO;

import com.ceb.gjjs.mda.manager.module.Urlgrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Srlp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 用户角色修改
*/
@Transaction(vo= DbesrlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbesrl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbesrl.class);

		@BDGetter
		private Urlgrp urlgrp;

		@BDGetter
		private Srlp srlp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;


		public Dbesrl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getSrlp().setUrlgrpHolder(()->this.getUrlgrp());
           this.getMtabut().setMtagrpHolder(()->this.getUrlgrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbesrl.this.getFieldPath("urlgrp.rec.inr");}
 				public void setValue(String arg){Dbesrl.this.getUrlgrp().getRec().setInr(arg);}
 				public String getValue(){return Dbesrl.this.getUrlgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dbesrl.@0006.script
        */
        @Rule(target="mtabut.submit",order=200)
        public boolean ruleMtabutSubmitN200(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  *提交保存，保存快照，执行order 200
			  **/
			/* log.debug("submit 200");
			  String usrinr1=$srlgrp\\usr\\inr.getValue();
			  Platform.clear($srlgrp\\newlst);
			  for(int i=0;i<$srlgrp\\rollst2.fullSize();i++)
			  {
			  log.debug("rolinr is:"+$srlgrp\\rollst2.fullSize());
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String> usrinr=new Argument<String>("usrinr");
			  Argument<String> rolinr=new Argument<String>("rolinr");
			  inr.setValue(Platform.sdbCounter("url"));
			  usrinr.setValue(usrinr1);
			  rolinr.setValue($srlgrp\\rollst2[i]\\inr.getValue());
			  $srlgrp\\newlst.add(inr,usrinr,rolinr);
			  }
			  //序列化模型数据
			  $dbxmod\\sub.setValue("用户角色关联");
			  $dbxmod\\dtl.setValue("用户角色关联");
			  String autinr = $dbxmod.setAut();
			  log.debug("set aut="+autinr);
			  $dbxmod.savAutDsp($srlp\\usrrolpanel,autinr);*/

			return true;
        }

        /**
        *   source:dbesrl.@0013.script
        */
        @Rule(target="mtabut.submit",order=500)
        public boolean ruleMtabutSubmitN500(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","submit 500");
			//保存交易流水
			this.getTrnmod().trnSetFromContract("用户角色维护","修改",this.getUrlgrp().getRec().getUsrinr());
			///保存页面快照
			this.getTrnmod().savePanelDisplay(this.getSrlp().getDbep12(),this.getTrnmod().getTrn().getInr());

			return true;
        }

        /**
        *   source:dbesrl.@0016.script
        */
        @Rule(target="mtabut.rtn",order=50)
        public boolean ruleMtabutRtnN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","rtn order 50 usrinr:"+this.getUrlgrp().getUsr().getInr());
			ctx.storeData("usrinr",this.getUrlgrp().getUsr().getInr());

			return true;
        }

        /**
        *   source:dbesrl.@0017.script
        */
        @Rule(target="srlp.ret",order=100)
        public boolean ruleSrlpRetN100(){
            IContext ctx = MdaEnv.getContext();
            

			String usrinr = this.getUrlgrp().getUsr().getInr();//获取选中的用户惟一编
			log.info("{}","行柜员INR : "+usrinr);
			ctx.storeData("usrinr",usrinr);//将此编号存入session
			Platform.mchain("dblsrl");//跳转到详情查看交易sbiusr
			
			return true;
        }



        /**
        *   source:dbesrl.@0000.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            

			/*
			  获取用户信息
			  */
			/*String usrinr=(String)Platform.restoreData("usrinr");
			  Platform.mdbRead($urlgrp\\usr,new Argument<String>("inr",usrinr));
			  $srlp\\lognam.setValue($urlgrp\\usr\\nam.getValue());
			  $srlp\\oprnam.setValue($urlgrp\\usr\\dspnam.getValue());*/
			/*
			  通过得到的usrinr和rolinr对比，显示本次操作新增和删除的rolinr
			  */
			/*
			  String usrinr=(String)Platform.restoreData("usr");
			  List<String> oldlist=(List)Platform.restoreData("oldlist");
			  Platform.storeData("oldlist",oldlist);
			  List<String> newlist=(List)Platform.restoreData("newlist");
			  //现在的角色列表：
			  Platform.clear($srlgrp\\oldlst);
			  Platform.mdbReadset($srlgrp\\oldlst,new Argument<String>("usrinr",usrinr));
			  Platform.clear($srlgrp\\newlst);
			  Platform.clear($srlgrp\\rollst1);
			  Platform.clear($srlgrp\\rollst2);
			  Platform.clear($srlp\\detlst);
			  $this.getNowRollist(newlist);
			  //获取新增列表
			  List<String> getnewlist=new ArrayList<String>();
			  for(int i=0;i<newlist.size();i++)
			  {
			  if($this.getAddOrDel(newlist.get(i),oldlist))
			  {
			  log.debug("str="+newlist.get(i));
			  getnewlist.add(newlist.get(i));
			  }
			  }
			  $this.getNewList(getnewlist);
			  //获取删除列表
			  List<String> getoldlist=new ArrayList<String>();
			  for(int i=0;i<oldlist.size();i++)
			  {
			  if($this.getAddOrDel(oldlist.get(i),newlist))
			  {
			  getoldlist.add(oldlist.get(i));
			  }
			  }
			  getOldList(getoldlist);
			  //得到当前newlst
			  $this.oldAndnewList(usrinr,newlist);
			  Platform.setModified($srlgrp\\oldlst);
			  Platform.setModified($srlgrp\\newlst);
			  */

			return true;
        }

        /**
        *   source:dbesrl.@0009.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  初始化用户已经分配的角色列表
			  */
			/*List<String> oldlist=new ArrayList<String>();
			  Platform.clear($urlgrp\\rollst2);
			  String sql="SELECT r.inr inr ,r.nam nam FROM rol r,url ur WHERE r.inr=ur.rolinr AND r.flg!='1' AND ur.usrinr='"+$urlgrp\\usr\\inr.getValue()+"'";
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>nam=new Argument<String>("nam");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr,nam);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  $urlgrp\\rollst2.add(inr,nam);
			  // oldlist.add(inr.getValue());
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  // Platform.storeData("oldlist",oldlist);//保存用户的原有角色
			  Platform.setModified($urlgrp\\rollst2);*/

			return true;
        }

        /**
        *   source:dbesrl.@0010.script
        */
        @Init(order=300)
        public boolean	init300(){
            IContext ctx = MdaEnv.getContext();
            
			/*Platform.clear($urlgrp\\rollst1);
			  String sql="SELECT r.inr inr ,r.nam nam FROM rol r where r.flg!='1' AND r.inr NOT IN (SELECT rolinr from url WHERE  usrinr='"+$urlgrp\\usr\\inr.getValue()+"')";
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>nam=new Argument<String>("nam");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr,nam);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  $urlgrp\\rollst1.add(inr,nam);
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  Platform.setModified($urlgrp\\rollst1);*/

			return true;
        }

        /**
        *   source:dbesrl.@0011.script
        */
        @Init(order=400)
        public boolean	init400(){
            IContext ctx = MdaEnv.getContext();
            

			/*
			  清空oldlst和newlst
			  */
			/*
			  Platform.clear($urlgrp\\oldlst);
			  Platform.clear($urlgrp\\newlst);
			  Platform.mdbReadset($urlgrp\\oldlst,new Argument<String>("usrinr",$urlgrp\\usr\\inr.getValue()));
			  //Platform.mdbReadset($srlgrp\\newlst,new Argument<String>("usrinr",$srlgrp\\usr\\inr.getValue()));
			  */

			return true;
        }

        /**
        *   source:dbesrl.@0012.script
        */
        @Init(order=1000)
        public boolean	init1000(){
            IContext ctx = MdaEnv.getContext();
            
			/*String number1=String.valueOf($urlgrp\\rollst1.fullSize());
			  String number2=String.valueOf($urlgrp\\rollst2.fullSize());
			  $srlp\\number1=number1;
			  $srlp\\number2=number2;*/

			return true;
        }

        /**
        *   source:dbesrl.@0014.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.clears(this.getUrlgrp().getUrllst());
			Platform.clears(this.getUrlgrp().getUrllst1());
			Platform.clears(this.getUrlgrp().getUrllst2());
			Object lognam = ctx.restoreData("lognam");
			if(lognam == null )
			  return true;
			this.getSrlp().setLognam( lognam.toString());
			Platform.mdbRead(this.getUrlgrp().getUsr(),new Argument("nam",this.getSrlp().getLognam()));
			Object oprnam = ctx.restoreData("oprnam");
			this.getSrlp().setOprnam( oprnam.toString());
			Object num1 = ctx.restoreData("number1");
			this.getSrlp().setNumber1( num1.toString());
			Object num2 = ctx.restoreData("number2");
			this.getSrlp().setNumber2( num2.toString());
			IModuleList urllst = (IModuleList)ctx.restoreData("urllst");
			this.getUrlgrp().getUrllst().addAll(urllst);
			IModuleList urllst1 = (IModuleList)ctx.restoreData("urllst1");
			this.getUrlgrp().getUrllst1().addAll(urllst1);
			IModuleList urllst2 = (IModuleList)ctx.restoreData("urllst2");
			this.getUrlgrp().getUrllst2().addAll(urllst2);
			
			
			
			
			
			

			return true;
        }


        /**
        *   source:dbesrl.@0001.script
        */
        public void getNowRollist(List<String> newlist)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 展示用户现在的所有角色
			  */
			for(int i=0;i<newlist.size();i++)
			{
			  Platform.mdbRead(this.getUrlgrp().getRol(),new Argument<String>("inr",newlist.get(i)));
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>nam=new Argument<String>("nam");
			  inr.setValue(this.getUrlgrp().getRol().getInr());
			  nam.setValue(this.getUrlgrp().getRol().getNam());
			  this.getUrlgrp().getRollst1().add(inr,nam);
			}
			
		}
        /**
        *   source:dbesrl.@0002.script
        */
        public boolean getAddOrDel(String str,List<String> list)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *获取新增或者删除角色列表
			  */
			boolean isNew=false;
			List<String>getlist=new ArrayList<String>();
			int k=0;
			if(list.size()==0)
			{
			  isNew=true;
			}
			for(int i=0;i<list.size();i++)
			{
			  if(!str.equals(list.get(i)))
			  {
			    k++;
			  }
			  if(k==list.size())
			  {
			    isNew=true;
			    break;
			  }
			}
			return isNew;
		}
        /**
        *   source:dbesrl.@0003.script
        */
        public void getNewList(List<String> newlist)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  得到新增的角色列表
			  */
			for(int i=0;i<newlist.size();i++)
			{
			  Platform.mdbRead(this.getUrlgrp().getRol(),new Argument<String>("inr",newlist.get(i)));
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>nam=new Argument<String>("nam");
			  inr.setValue(this.getUrlgrp().getRol().getInr());
			  nam.setValue(this.getUrlgrp().getRol().getNam());
			  this.getUrlgrp().getRollst2().add(inr,nam);
			}
			
		}
        /**
        *   source:dbesrl.@0004.script
        */
        public void getOldList(List<String> newlist)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 得到删除的角色列表
			  */
			for(int i=0;i<newlist.size();i++)
			{
			  Platform.mdbRead(this.getUrlgrp().getRol(),new Argument<String>("inr",newlist.get(i)));
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>nam=new Argument<String>("nam");
			  inr.setValue(this.getUrlgrp().getRol().getInr());
			  nam.setValue(this.getUrlgrp().getRol().getNam());
			  this.getSrlp().getDetlst().add(inr,nam);
			}
			
		}
        /**
        *   source:dbesrl.@0005.script
        */
        public void oldAndnewList(String userinr,List<String>list)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *将用户角色信息保存在newlst中
			  **/
			for(int i=0;i<list.size();i++)
			{
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>usrinr=new Argument<String>("usrinr");
			  Argument<String>rolinr=new Argument<String>("rolinr");
			  inr.setValue(Platform.sdbCounter("usrrol"));
			  usrinr.setValue(userinr);
			  rolinr.setValue(list.get(i));
			  //初始化newlst
			  this.getUrlgrp().getNewlst().add(inr,usrinr,rolinr);
			}

		}







}