package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbibrcVO;

import com.ceb.gjjs.mda.manager.module.Ptygrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Brcp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 机构信息详情
*/
@Transaction(vo= DbibrcVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbibrc extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbibrc.class);

		@BDGetter
		private Ptygrp ptygrp;

		@BDGetter
		private Brcp brcp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dbibrc()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBrcp().setMtabutHolder(()->this.getMtabut());
           this.getBrcp().setPtygrpHolder(()->this.getPtygrp());
           this.getMtabut().setMtagrpHolder(()->this.getPtygrp());
        }

        /**
        *   source:dbibrc.@0005.script
        */
        @Rule(target="brcp.ame",order=100)
        public boolean ruleBrcpAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr = this.getPtygrp().getRec().getInr();
			ctx.storeData("ptyinr",ptyinr);
			Platform.mchain("dbebrc");

			return true;
        }

        /**
        *   source:dbibrc.@0006.script
        */
        @Rule(target="brcp.del",order=100)
        public boolean ruleBrcpDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr = this.getPtygrp().getRec().getInr();
			ctx.storeData("ptyinr",ptyinr);
			Platform.mchain("dbdbrc");

			return true;
        }

        /**
        *   source:dbibrc.@0007.script
        */
        @Rule(target="brcp.cancel",order=100)
        public boolean ruleBrcpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			String key="handleTemp";
			ctx.storeData(key,key);
			

			return true;
        }

        /**
        *   source:dbibrc.@0008.script
        */
        @Rule(target="brcp.next",order=100)
        public boolean ruleBrcpNextN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr = this.getPtygrp().getRec().getInr();
			ctx.storeData("ptyinr",ptyinr);
			Platform.mchain("dbiagb");

			return true;
        }



        /**
        *   source:dbibrc.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> cts = this.getBrcp().getPtyCT();
			MdaUtils.setValues(this.getBrcp().getPtyshw(),"pntinr",cts);
			MdaUtils.setValues(this.getPtygrp().getRec(),"pntinr",cts);
			Object ptyinr = ctx.restoreData("ptyinr");
			if(MdaUtils.isEmpty(ptyinr))
			{
			  //Platform.message(#CT000074,#CT000075);
			  
			  return false;
			}
			else
			{
			  Platform.mdbRead(this.getPtygrp().getRec(),new Argument<String>("inr",ptyinr.toString()));
			  Platform.mdbRead(this.getPtygrp().getPta(),new Argument<String>("ptyinr",ptyinr.toString()),new Argument<String>("objtyp","adr"));
			  String adrinr = this.getPtygrp().getPta().getObjinr();
			  Platform.mdbRead(this.getPtygrp().getAdr(),new Argument<String>("inr",adrinr));
			  Platform.mdbRead(this.getPtygrp().getBch(),new Argument<String>("ptyinr",ptyinr.toString()));
			}

			return true;
        }







}