package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbietgVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etggrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Etgp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体组信息详情
*/
@Transaction(vo= DbietgVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbietg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbietg.class);

		@BDGetter
		private Etggrp etggrp;

		@BDGetter
		private Etgp etgp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dbietg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtgp().setEtggrpHolder(()->this.getEtggrp());
           this.getEtgp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getEtggrp());
        }

        /**
        *   source:dbietg.@0000.script
        */
        @Rule(target="etgp.ame",order=100)
        public boolean ruleEtgpAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			String etginr = this.getEtggrp().getRec().getInr();
			ctx.storeData("etginr",etginr);
			Platform.mchain("dbeetg");

			return true;
        }

        /**
        *   source:dbietg.@0001.script
        */
        @Rule(target="etgp.cancel",order=100)
        public boolean ruleEtgpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.returnToFirst();

			return true;
        }

        /**
        *   source:dbietg.@0002.script
        */
        @Rule(target="etgp.del",order=100)
        public boolean ruleEtgpDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			String etginr = this.getEtggrp().getRec().getInr();
			ctx.storeData("etginr",etginr);
			Platform.mchain("dbdetg");

			return true;
        }



        /**
        *   source:dbietg.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Object etginr = ctx.restoreData("etginr");
			if(MdaUtils.isEmpty(etginr))
			{
			  //Platform.message(#CT000000,#CT000001);
			  
			  return false;
			}
			else
			{
			  Platform.mdbRead(this.getEtggrp().getRec(),new Argument<String>("inr",etginr.toString()));
			}

			return true;
        }







}