package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbietyVO;

import com.ceb.gjjs.mda.manager.module.Etygrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etyp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体信息详情
*/
@Transaction(vo= DbietyVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbiety extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbiety.class);

		@BDGetter
		private Etygrp etygrp;

		@BDGetter
		private Etyp etyp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dbiety()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtyp().setMtabutHolder(()->this.getMtabut());
           this.getEtyp().setEtygrpHolder(()->this.getEtygrp());
           this.getMtabut().setMtagrpHolder(()->this.getEtygrp());
        }

        /**
        *   source:dbiety.@0001.script
        */
        @Rule(target="etyp.ame",order=100)
        public boolean ruleEtypAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			String etyinr = this.getEtygrp().getRec().getInr();
			ctx.storeData("etyinr",etyinr);
			Platform.mchain("dbeety");

			return true;
        }

        /**
        *   source:dbiety.@0002.script
        */
        @Rule(target="etyp.cancel",order=100)
        public boolean ruleEtypCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			//刷新查询界面并返回
			String key="handleTemp";
			ctx.storeData(key,key);
			MdaUtils.returnToFirst();

			return true;
        }

        /**
        *   source:dbiety.@0003.script
        */
        @Rule(target="etyp.del",order=100)
        public boolean ruleEtypDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			String etyinr = this.getEtygrp().getRec().getInr();
			ctx.storeData("etyinr",etyinr);
			Platform.mchain("dbdety");

			return true;
        }



        /**
        *   source:dbiety.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Object etyinr = ctx.restoreData("etyinr");
			if(MdaUtils.isEmpty(etyinr))
			{
			  //Platform.message(#CT000000,#CT000001);
			  
			  return false;
			}
			else
			{
			  Platform.mdbRead(this.getEtygrp().getRec(),new Argument<String>("inr",etyinr.toString()));
			  Platform.mdbRead(this.getEtygrp().getEtg(),new Argument<String>("inr",this.getEtygrp().getRec().getEtginr()));
			}

			return true;
        }







}