package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbifrrVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Frrgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Frrp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 角色交易定制查询
*/
@Transaction(vo= DbifrrVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbifrr extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbifrr.class);

		@BDGetter
		private Frrgrp frrgrp;

		@BDGetter
		private Frrp frrp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;


		public Dbifrr()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFrrp().setFrrgrpHolder(()->this.getFrrgrp());
           this.getMtabut().setMtagrpHolder(()->this.getFrrgrp());
        }

        /**
        *   source:dbifrr.@0002.script
        */
        @Rule(target="mtabut.argbut.ame",order=100)
        public boolean ruleMtabutArgbutAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getFrrgrp().getRolnam()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbifrr","CT000000"),MdaUtils.getI18NString("dbifrr","CT000001"));
			  return false;
			}
			else
			{
			  log.debug("{}","跳转到dbefrr。。。。");
			  StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			  StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			  ctx.storeData("lftgrd",lftgrd);
			  ctx.storeData("rgtgrd",rgtgrd);
			  ctx.storeData("numyet",this.getFrrp().getNumyet());
			  ctx.storeData("numral",this.getFrrp().getNumral());
			  ctx.storeData("rolnam",this.getFrrgrp().getRolnam());
			  Platform.mchain("dbefrr");
			}

			return true;
        }


        /**
        *   source:dbifrr.@0003.script
        */
        @Check(target="frrgrp.rolnam",order=100)
        public boolean checkFrrgrpRolnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getFrrgrp().getFrrlst());
			MdaUtils.clear(this.getFrrgrp().getFrrlst1());
			MdaUtils.clear(this.getFrrgrp().getFrrlst2());
			MdaUtils.clear(this.getFrrgrp().getLfttmplst());
			MdaUtils.clear(this.getFrrgrp().getRgttmplst());
			//组合查询
			String sql = "SELECT frr.inr,frm.inr AS frminr,frm.pntinr AS pntinr,frr.objinr,frr.typ,frm.frm,frm.dsp,frm.frmtyp,frm.typ AS frmviwtyp FROM frm LEFT JOIN frr ON frr.frminr = frm.inr";
			//根据选择的角色进行查询
			sql = sql+" AND frr.objinr = ? and frr.objtyp = 'rol' where frm.typ='0' order by frm.inr ASC";
			//WHERE FRM.FRM IS NOT NULL ";
			log.debug("{}","sql"+sql);
			//组合显示交易列表
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> frminr = new Argument<String>("frminr");
			Argument<String> pntinr = new Argument<String>("pntinr");
			Argument<String> rolinr = new Argument<String>("objinr");
			Argument<String> typ = new Argument<String>("typ");
			Argument<String> frm = new Argument<String>("frm");
			Argument<String> dsp = new Argument<String>("dsp");
			Argument<String> frmtyp = new Argument<String>("frmtyp");
			Argument<String> frmviwtyp = new Argument<String>("frmviwtyp");
			Platform.mdbExecuteSQL(sql,this.getFrrgrp().getRolnam());
			while(true)
			{
			  Platform.mdbFetchFields(inr,frminr,pntinr,rolinr,typ,frm,dsp,frmtyp,frmviwtyp);
			  if(ctx.getErrorCode() == NO_ERROR)
			    this.getFrrgrp().getFrrlst().add(inr,frminr,pntinr,rolinr,typ,frm,dsp,frmtyp,frmviwtyp);
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			log.debug("{}","查出frrlst记录"+this.getFrrgrp().getFrrlst().fullSize());
			for(com.ceb.gjjs.mda.bo.Frr frr:this.getFrrgrp().getFrrlst())
			{
			  String key = frr.getDsp();
			  String nam = MdaUtils.getI18nValue("eibs",key);
			  frr.setDsp( nam);
			}
			for(int i=0;i<this.getFrrgrp().getFrrlst().fullSize();i++)
			{
			  if("office".equals(this.getFrrgrp().getFrrlst().getElement(i).getFrm()))
			  {
			    this.getFrrgrp().getFrrlst().remove(i);
			    i--;
			    continue;
			  }
			  /*if(Platform.isEmpty($frrgrp\\frrlst[i]\\frm))
			    {
			    $frrgrp\\frrlst1.add($frrgrp\\frrlst[i]);
			    $frrgrp\\frrlst2.add($frrgrp\\frrlst[i]);
			    }
			    else
			    {*/
			  if("0".equals(this.getFrrgrp().getFrrlst().getElement(i).getTyp()))
			  {
			    this.getFrrgrp().getFrrlst2().add(this.getFrrgrp().getFrrlst().getElement(i));//frrlst2 right
			  }
			  else if (MdaUtils.isEmpty(this.getFrrgrp().getFrrlst().getElement(i).getFrm()) && MdaUtils.isEmpty(this.getFrrgrp().getFrrlst().getElement(i).getInr()))
			  {
			    this.getFrrgrp().getFrrlst1().add(this.getFrrgrp().getFrrlst().getElement(i));
			    this.getFrrgrp().getFrrlst2().add(this.getFrrgrp().getFrrlst().getElement(i));
			  }
			  else //if("1".equals($frrgrp\\frrlst[i]\\typ)) typ为1的和typ为空的都是未分配的菜单交易
			  {
			    this.getFrrgrp().getFrrlst1().add(this.getFrrgrp().getFrrlst().getElement(i));//frrlst1 left
			  }
			  //}
			}
			log.debug("{}","dbifrr check rulnam before sort frrlst2 size:"+this.getFrrgrp().getFrrlst2().size());
			log.debug("{}","dbifrr check rulnam before sort frrlst1 size:"+this.getFrrgrp().getFrrlst1().size());
			LinkedHashMap<String,Map> lftmap = sortAndGenerLeftGridMenuMap();
			LinkedHashMap<String,Map> rgtmap = sortAndGenerRightGridMenuMap();
			LinkedHashMap<String,Map> lftrmvmap = checkGridMenu(lftmap);
			LinkedHashMap<String,Map> rgtrmvmap = checkGridMenu(rgtmap);
			this.getFrrgrp().setLftgrd(null);
			this.getFrrgrp().setRgtgrd(null);
			StreamGrid lftgrd = this.getFrrgrp().getLftgrd();
			StreamGrid rgtgrd = this.getFrrgrp().getRgtgrd();
			generGrid(lftmap,lftgrd);
			generGrid(rgtmap,rgtgrd);
			int a=0;
			int b=0;
			for(int i=0;i<this.getFrrgrp().getLfttmplst().size();i++)
			{
			  if(!MdaUtils.isEmpty(this.getFrrgrp().getLfttmplst().getElement(i).getFrm()))
			    a++;
			}
			for(int i=0;i<this.getFrrgrp().getRgttmplst().size();i++)
			{
			  if(!MdaUtils.isEmpty(this.getFrrgrp().getRgttmplst().getElement(i).getFrm()))
			    b++;
			}
			String num1 = String.valueOf(a);
			String num2 = String.valueOf(b);
			this.getFrrp().setNumyet( num1);
			this.getFrrp().setNumral( num2);
			//Platform.setModified($frrgrp\\frrlst1);
			//Platform.setModified($frrgrp\\frrlst2);
			
			
			
			

			return true;
        }


        /**
        *   source:dbifrr.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			Platform.clears(this.getFrrgrp().getFrrlst());
			Platform.clears(this.getFrrgrp().getFrrlst1());
			Platform.clears(this.getFrrgrp().getFrrlst2());
			this.getFrrp().setNumral(NULLSTR);
			this.getFrrp().setNumyet(NULLSTR);
			this.getFrrgrp().setRolnam(NULLSTR);

			return true;
        }


        /**
        *   source:dbifrr.@0006.script
        */
        public LinkedHashMap<String,Map> generLeftGridMenuMap()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//未分配交易列表生成MAP
			LinkedHashMap<String,Map> lftmap = new LinkedHashMap();
			String lftpth=null;
			for(int i=0;i<this.getFrrgrp().getFrrlst1().fullSize();i++)
			{
			  Map<String,String> lft = new HashMap();
			  lft.put("1",this.getFrrgrp().getFrrlst1().getElement(i).getFrminr());
			  lft.put("2",this.getFrrgrp().getFrrlst1().getElement(i).getDsp());
			  lft.put("3",this.getFrrgrp().getFrrlst1().getElement(i).getFrm());
			  lft.put("4",this.getFrrgrp().getFrrlst1().getElement(i).getPntinr());
			  lft.put("5",this.getFrrgrp().getFrrlst1().getElement(i).getFlg());
			  lft.put("6",this.getFrrgrp().getFrrlst1().getElement(i).getTyp());
			  lft.put("7",this.getFrrgrp().getFrrlst1().getElement(i).getInr());
			  lft.put("8",this.getFrrgrp().getFrrlst1().getElement(i).getObjinr());
			  lft.put("9",this.getFrrgrp().getFrrlst1().getElement(i).getObjtyp());
			  if(MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(i).getFrm()) && MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(i).getPntinr()))
			  {
			    lftpth = this.getFrrgrp().getFrrlst1().getElement(i).getFrminr();
			    lftmap.put(lftpth,lft);
			  }
			  if(MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(i).getFrm()) && !MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(i).getPntinr()))
			  {
			    lftpth = this.getFrrgrp().getFrrlst1().getElement(i).getPntinr() + "/" + this.getFrrgrp().getFrrlst1().getElement(i).getFrminr();
			    lftmap.put(lftpth,lft);
			  }
			  if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(i).getFrm()))
			  {
			    for(int j=0;j<this.getFrrgrp().getFrrlst1().fullSize();j++)
			    {
			      if(this.getFrrgrp().getFrrlst1().getElement(i).getPntinr().equals(this.getFrrgrp().getFrrlst1().getElement(j).getFrminr()) && !MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(j).getPntinr()))
			        lftpth = this.getFrrgrp().getFrrlst1().getElement(j).getPntinr() + "/" + this.getFrrgrp().getFrrlst1().getElement(j).getFrminr() + "/" + this.getFrrgrp().getFrrlst1().getElement(i).getFrminr();
			      else if(this.getFrrgrp().getFrrlst1().getElement(i).getPntinr().equals(this.getFrrgrp().getFrrlst1().getElement(j).getFrminr()) && MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(j).getPntinr()))
			        lftpth = this.getFrrgrp().getFrrlst1().getElement(j).getFrminr() + "/" + this.getFrrgrp().getFrrlst1().getElement(i).getFrminr();

			    }
			    lftmap.put(lftpth,lft);
			  }
			  log.debug("{}","generGridMenuMap lft path:"+lftpth);
			}
			return lftmap;
		}
        /**
        *   source:dbifrr.@0007.script
        */
        public LinkedHashMap<String,Map> generRightGridMenuMap()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//已分配交易列表生成MAP
			LinkedHashMap<String,Map> rgtmap = new LinkedHashMap();
			String rgtpth=null;
			for(int i=0;i<this.getFrrgrp().getFrrlst2().fullSize();i++)
			{
			  Map<String,String> rgt = new HashMap();
			  rgt.put("1",this.getFrrgrp().getFrrlst2().getElement(i).getFrminr());
			  rgt.put("2",this.getFrrgrp().getFrrlst2().getElement(i).getDsp());
			  rgt.put("3",this.getFrrgrp().getFrrlst2().getElement(i).getFrm());
			  rgt.put("4",this.getFrrgrp().getFrrlst2().getElement(i).getPntinr());
			  rgt.put("5",this.getFrrgrp().getFrrlst1().getElement(i).getFlg());
			  rgt.put("6",this.getFrrgrp().getFrrlst1().getElement(i).getTyp());
			  rgt.put("7",this.getFrrgrp().getFrrlst1().getElement(i).getInr());
			  rgt.put("8",this.getFrrgrp().getFrrlst1().getElement(i).getObjinr());
			  rgt.put("9",this.getFrrgrp().getFrrlst1().getElement(i).getObjtyp());
			  if(MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(i).getFrm()) && MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(i).getPntinr()))
			  {
			    log.debug("{}","rptpth put0:"+this.getFrrgrp().getFrrlst2().getElement(i).getDsp());
			    rgtpth = this.getFrrgrp().getFrrlst2().getElement(i).getFrminr();
			    rgtmap.put(rgtpth,rgt);
			    log.debug("{}","generGridMenuMap 1pth rgtpth:"+rgtpth);
			  }
			  if(MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(i).getFrm()) && !MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(i).getPntinr()))
			  {
			    String pth1=this.getFrrgrp().getFrrlst2().getElement(i).getPntinr();
			    String pth2=this.getFrrgrp().getFrrlst2().getElement(i).getFrminr();
			    rgtpth = pth1 + "/" + pth2;
			    log.debug("{}","generGridMenuMap 2pth rgtpth:"+rgtpth);
			    rgtmap.put(rgtpth,rgt);
			  }
			  if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(i).getFrm()))
			  {
			    for(int j=0;j<this.getFrrgrp().getFrrlst2().fullSize();j++)
			    {
			      String path1=this.getFrrgrp().getFrrlst2().getElement(j).getPntinr();
			      String path2=this.getFrrgrp().getFrrlst2().getElement(j).getFrminr();
			      String path3=this.getFrrgrp().getFrrlst2().getElement(i).getFrminr();
			      if(this.getFrrgrp().getFrrlst2().getElement(j).getFrminr().equals(this.getFrrgrp().getFrrlst2().getElement(i).getPntinr()) && !MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(j).getPntinr()))
			      {
			        rgtpth = path1 + "/" + path2 + "/" + path3;
			        log.debug("{}","generGridMenuMap 3pth-3 rgtpth:"+rgtpth);
			      }
			      else if(this.getFrrgrp().getFrrlst2().getElement(j).getFrminr().equals(this.getFrrgrp().getFrrlst2().getElement(i).getPntinr()) && MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(j).getPntinr()))
			      {
			        rgtpth = path2 + "/" + path3;
			        log.debug("{}","generGridMenuMap 3pth-2 rgtpth:"+rgtpth);
			      }
			    }
			    rgtmap.put(rgtpth,rgt);
			  }
			}
			return rgtmap;
		}
        /**
        *   source:dbifrr.@0008.script
        */
        public void generGrid(LinkedHashMap<String,Map> map,StreamGrid grid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IAttributeValue h = new AttributeValue("菜单名称");
			
			grid.setHeaders(new IAttributeValue[]{h});
			LinkedHashMap<String,Map> rmvmap=new LinkedHashMap();
			for(String key : map.keySet())
			{
			  if(!key.contains("/"))
			  {
			    log.debug("{}","key0:"+map.get(key));
			    AttributeValue val1= new AttributeValue(map.get(key).get("2"));
			    val1.setAttribute("path",key);
			    val1.setAttribute("frminr",map.get(key).get("1"));
			    val1.setAttribute("frm",map.get(key).get("3"));
			    val1.setAttribute("pntinr",map.get(key).get("4"));
			    val1.setAttribute("flg",map.get(key).get("5"));
			    val1.setAttribute("typ",map.get(key).get("6"));
			    val1.setAttribute("inr",map.get(key).get("7"));
			    val1.setAttribute("objinr",map.get(key).get("8"));
			    val1.setAttribute("objtyp",map.get(key).get("9"));
			    
			    
			    grid.add(new IValue[]{val1});
			  }
			  else
			  {
			    String[] str = key.split("/");
			    if(java.lang.reflect.Array.getLength(str) == 2)
			    {
			      AttributeValue val2 = new AttributeValue(map.get(key).get("2"));
			      val2.setAttribute("path",key);
			      val2.setAttribute("frminr",map.get(key).get("1"));
			      val2.setAttribute("frm",map.get(key).get("3"));
			      val2.setAttribute("pntinr",map.get(key).get("4"));
			      val2.setAttribute("flg",map.get(key).get("5"));
			      val2.setAttribute("typ",map.get(key).get("6"));
			      val2.setAttribute("inr",map.get(key).get("7"));
			      val2.setAttribute("objinr",map.get(key).get("8"));
			      val2.setAttribute("objtyp",map.get(key).get("9"));
			      
			      
			      grid.add(new IValue[]{val2});
			    }
			    if(java.lang.reflect.Array.getLength(str) == 3)
			    {
			      log.debug("{}","key2:"+map.get(key));
			      AttributeValue val3 = new AttributeValue(map.get(key).get("2"));
			      val3.setAttribute("path",key);
			      val3.setAttribute("frminr",map.get(key).get("1"));
			      val3.setAttribute("frm",map.get(key).get("3"));
			      val3.setAttribute("pntinr",map.get(key).get("4"));
			      val3.setAttribute("flg",map.get(key).get("5"));
			      val3.setAttribute("typ",map.get(key).get("6"));
			      val3.setAttribute("inr",map.get(key).get("7"));
			      val3.setAttribute("objinr",map.get(key).get("8"));
			      val3.setAttribute("objtyp",map.get(key).get("9"));
			      
			      
			      grid.add(new IValue[]{val3});
			    }
			  }
			}
		}
        /**
        *   source:dbifrr.@0009.script
        */
        public LinkedHashMap<String,Map> checkGridMenu(LinkedHashMap<String,Map> map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,Map> rmvmap=new LinkedHashMap();
			for(String key : map.keySet())
			{
			  if(MdaUtils.isEmpty(map.get(key).get("3")))
			  {
			    int a=0;
			    for(String key0 : map.keySet())
			    {
			      if(!key0.equals(key))
			      {
			        if(key0.startsWith(key) && !MdaUtils.isEmpty(map.get(key0).get("3")))
			          a++;
			      }
			    }
			    if(a<=0)
			    {
			      Map<String,String> val = map.get(key);
			      rmvmap.put(key,val);
			    }
			  }
			}
			log.debug("{}","check menu rmvmap size:"+rmvmap.size());
			for(String key1 : rmvmap.keySet())
			{
			  map.remove(key1);
			}
			return rmvmap;
		}
        /**
        *   source:dbifrr.@0010.script
        */
        public LinkedHashMap<String,Map> sortAndGenerRightGridMenuMap()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//已分配交易列表排序并生成MAP
			LinkedHashMap<String,Map> rgtmap = new LinkedHashMap();
			for(int i=0;i<this.getFrrgrp().getFrrlst2().fullSize();i++)
			{
			  Map<String,String> rgt0 = new HashMap();
			  rgt0.put("1",this.getFrrgrp().getFrrlst2().getElement(i).getFrminr());
			  rgt0.put("2",this.getFrrgrp().getFrrlst2().getElement(i).getDsp());
			  rgt0.put("3",this.getFrrgrp().getFrrlst2().getElement(i).getFrm());
			  rgt0.put("4",this.getFrrgrp().getFrrlst2().getElement(i).getPntinr());
			  rgt0.put("5",this.getFrrgrp().getFrrlst2().getElement(i).getFlg());
			  rgt0.put("6",this.getFrrgrp().getFrrlst2().getElement(i).getTyp());
			  rgt0.put("7",this.getFrrgrp().getFrrlst2().getElement(i).getInr());
			  rgt0.put("8",this.getFrrgrp().getFrrlst2().getElement(i).getObjinr());
			  rgt0.put("9",this.getFrrgrp().getFrrlst2().getElement(i).getObjtyp());
			  if(MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(i).getPntinr()))
			  {
			    this.getFrrgrp().getRgttmplst().add(this.getFrrgrp().getFrrlst2().getElement(i));
			    String pth0 = null;
			    pth0 = this.getFrrgrp().getFrrlst2().getElement(i).getFrminr();
			    rgtmap.put(pth0,rgt0);
			    log.debug("{}","sortAndGenerRightGridMenuMap rpth0:"+pth0);
			    for(int j=0;j<this.getFrrgrp().getFrrlst2().fullSize();j++)
			    {
			      Map<String,String> rgt1 = new HashMap();
			      rgt1.put("1",this.getFrrgrp().getFrrlst2().getElement(j).getFrminr());
			      rgt1.put("2",this.getFrrgrp().getFrrlst2().getElement(j).getDsp());
			      rgt1.put("3",this.getFrrgrp().getFrrlst2().getElement(j).getFrm());
			      rgt1.put("4",this.getFrrgrp().getFrrlst2().getElement(j).getPntinr());
			      rgt1.put("5",this.getFrrgrp().getFrrlst2().getElement(j).getFlg());
			      rgt1.put("6",this.getFrrgrp().getFrrlst2().getElement(j).getTyp());
			      rgt1.put("7",this.getFrrgrp().getFrrlst2().getElement(j).getInr());
			      rgt1.put("8",this.getFrrgrp().getFrrlst2().getElement(j).getObjinr());
			      rgt1.put("9",this.getFrrgrp().getFrrlst2().getElement(j).getObjtyp());
			      if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(j).getPntinr()))
			      {
			        if(this.getFrrgrp().getFrrlst2().getElement(j).getPntinr().equals(this.getFrrgrp().getFrrlst2().getElement(i).getFrminr()))
			        {
			          this.getFrrgrp().getRgttmplst().add(this.getFrrgrp().getFrrlst2().getElement(j));
			          String pth1 = null;
			          pth1 = this.getFrrgrp().getFrrlst2().getElement(i).getFrminr() + "/" + this.getFrrgrp().getFrrlst2().getElement(j).getFrminr();
			          rgtmap.put(pth1,rgt1);
			          log.debug("{}","sortAndGenerRightGridMenuMap rpth1:"+pth1);
			          for(int z=0;z<this.getFrrgrp().getFrrlst2().fullSize();z++)
			          {
			            Map<String,String> rgt2 = new HashMap();
			            rgt2.put("1",this.getFrrgrp().getFrrlst2().getElement(z).getFrminr());
			            rgt2.put("2",this.getFrrgrp().getFrrlst2().getElement(z).getDsp());
			            rgt2.put("3",this.getFrrgrp().getFrrlst2().getElement(z).getFrm());
			            rgt2.put("4",this.getFrrgrp().getFrrlst2().getElement(z).getPntinr());
			            rgt2.put("5",this.getFrrgrp().getFrrlst2().getElement(z).getFlg());
			            rgt2.put("6",this.getFrrgrp().getFrrlst2().getElement(z).getTyp());
			            rgt2.put("7",this.getFrrgrp().getFrrlst2().getElement(z).getInr());
			            rgt2.put("8",this.getFrrgrp().getFrrlst2().getElement(z).getObjinr());
			            rgt2.put("9",this.getFrrgrp().getFrrlst2().getElement(z).getObjtyp());
			            if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(z).getPntinr()))
			            {
			              if(this.getFrrgrp().getFrrlst2().getElement(z).getPntinr().equals(this.getFrrgrp().getFrrlst2().getElement(j).getFrminr()))
			              {
			                this.getFrrgrp().getRgttmplst().add(this.getFrrgrp().getFrrlst2().getElement(z));
			                String pth2 = null;
			                pth2 = this.getFrrgrp().getFrrlst2().getElement(i).getFrminr() + "/" + this.getFrrgrp().getFrrlst2().getElement(j).getFrminr() + "/" + this.getFrrgrp().getFrrlst2().getElement(z).getFrminr();
			                rgtmap.put(pth2,rgt2);
			                log.debug("{}","sortAndGenerRightGridMenuMap rpth2:"+pth2);
			              }
			            }
			          }
			        }
			      }
			    }
			  }
			}
			log.debug("{}","frr check rolnam rgttmplst size:"+this.getFrrgrp().getRgttmplst().size());
			//Platform.clear($frrgrp\\frrlst2);
			while(this.getFrrgrp().getFrrlst2().fullSize()>0)
			  this.getFrrgrp().getFrrlst2().removeAll();
			for(int a=0;a<this.getFrrgrp().getRgttmplst().size();a++)
			  this.getFrrgrp().getFrrlst2().add(this.getFrrgrp().getRgttmplst().getElement(a));
			log.debug("{}","After sort frrlst2 size:"+this.getFrrgrp().getFrrlst2().size());
			//Platform.clear($frrgrp\\rgttmplst);
			while(this.getFrrgrp().getRgttmplst().fullSize()>0)
			  this.getFrrgrp().getRgttmplst().removeAll();
			for(int y=0;y<this.getFrrgrp().getFrrlst2().size();y++)
			{
			  if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst2().getElement(y).getFrm()))
			    this.getFrrgrp().getRgttmplst().add(this.getFrrgrp().getFrrlst2().getElement(y));
			}
			log.debug("{}","After sort rgttmplst frm not null size:" + this.getFrrgrp().getRgttmplst().size());
			return rgtmap;
		}
        /**
        *   source:dbifrr.@0011.script
        */
        public LinkedHashMap<String,Map> sortAndGenerLeftGridMenuMap()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//未分配菜单交易列表排序并生成MAP
			LinkedHashMap<String,Map> lftmap = new LinkedHashMap();
			for(int l=0;l<this.getFrrgrp().getFrrlst1().fullSize();l++)
			{
			  Map<String,String> lft0 = new HashMap();
			  lft0.put("1",this.getFrrgrp().getFrrlst1().getElement(l).getFrminr());
			  lft0.put("2",this.getFrrgrp().getFrrlst1().getElement(l).getDsp());
			  lft0.put("3",this.getFrrgrp().getFrrlst1().getElement(l).getFrm());
			  lft0.put("4",this.getFrrgrp().getFrrlst1().getElement(l).getPntinr());
			  lft0.put("5",this.getFrrgrp().getFrrlst1().getElement(l).getFlg());
			  lft0.put("6",this.getFrrgrp().getFrrlst1().getElement(l).getTyp());
			  lft0.put("7",this.getFrrgrp().getFrrlst1().getElement(l).getInr());
			  lft0.put("8",this.getFrrgrp().getFrrlst1().getElement(l).getObjinr());
			  lft0.put("9",this.getFrrgrp().getFrrlst1().getElement(l).getObjtyp());
			  if(MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(l).getPntinr()))
			  {
			    this.getFrrgrp().getLfttmplst().add(this.getFrrgrp().getFrrlst1().getElement(l));
			    String pth0 = null;
			    pth0 = this.getFrrgrp().getFrrlst1().getElement(l).getFrminr();
			    lftmap.put(pth0,lft0);
			    log.debug("{}","sortAndGenerRightGridMenuMap lpth0:"+pth0);
			    for(int m=0;m<this.getFrrgrp().getFrrlst1().fullSize();m++)
			    {
			      Map<String,String> lft1 = new HashMap();
			      lft1.put("1",this.getFrrgrp().getFrrlst1().getElement(m).getFrminr());
			      lft1.put("2",this.getFrrgrp().getFrrlst1().getElement(m).getDsp());
			      lft1.put("3",this.getFrrgrp().getFrrlst1().getElement(m).getFrm());
			      lft1.put("4",this.getFrrgrp().getFrrlst1().getElement(m).getPntinr());
			      lft1.put("5",this.getFrrgrp().getFrrlst1().getElement(m).getFlg());
			      lft1.put("6",this.getFrrgrp().getFrrlst1().getElement(m).getTyp());
			      lft1.put("7",this.getFrrgrp().getFrrlst1().getElement(m).getInr());
			      lft1.put("8",this.getFrrgrp().getFrrlst1().getElement(m).getObjinr());
			      lft1.put("9",this.getFrrgrp().getFrrlst1().getElement(m).getObjtyp());
			      if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(m).getPntinr()))
			      {
			        if(this.getFrrgrp().getFrrlst1().getElement(m).getPntinr().equals(this.getFrrgrp().getFrrlst1().getElement(l).getFrminr()))
			        {
			          this.getFrrgrp().getLfttmplst().add(this.getFrrgrp().getFrrlst1().getElement(m));
			          String pth1 = null;
			          pth1 = this.getFrrgrp().getFrrlst1().getElement(l).getFrminr() + "/" + this.getFrrgrp().getFrrlst1().getElement(m).getFrminr();
			          lftmap.put(pth1,lft1);
			          log.debug("{}","sortAndGenerRightGridMenuMap lpth1:"+pth1);
			          for(int n=0;n<this.getFrrgrp().getFrrlst1().fullSize();n++)
			          {
			            Map<String,String> lft2 = new HashMap();
			            lft2.put("1",this.getFrrgrp().getFrrlst1().getElement(n).getFrminr());
			            lft2.put("2",this.getFrrgrp().getFrrlst1().getElement(n).getDsp());
			            lft2.put("3",this.getFrrgrp().getFrrlst1().getElement(n).getFrm());
			            lft2.put("4",this.getFrrgrp().getFrrlst1().getElement(n).getPntinr());
			            lft2.put("5",this.getFrrgrp().getFrrlst1().getElement(n).getFlg());
			            lft2.put("6",this.getFrrgrp().getFrrlst1().getElement(n).getTyp());
			            lft2.put("7",this.getFrrgrp().getFrrlst1().getElement(n).getInr());
			            lft2.put("8",this.getFrrgrp().getFrrlst1().getElement(n).getObjinr());
			            lft2.put("9",this.getFrrgrp().getFrrlst1().getElement(n).getObjtyp());
			            if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(n).getPntinr()))
			            {
			              if(this.getFrrgrp().getFrrlst1().getElement(n).getPntinr().equals(this.getFrrgrp().getFrrlst1().getElement(m).getFrminr()))
			              {
			                this.getFrrgrp().getLfttmplst().add(this.getFrrgrp().getFrrlst1().getElement(n));
			                String pth2 = null;
			                pth2 = this.getFrrgrp().getFrrlst1().getElement(l).getFrminr() + "/" + this.getFrrgrp().getFrrlst1().getElement(m).getFrminr() + "/" + this.getFrrgrp().getFrrlst1().getElement(n).getFrminr();
			                lftmap.put(pth2,lft2);
			                log.debug("{}","sortAndGenerRightGridMenuMap lpth2:"+pth2);
			              }
			            }
			          }
			        }
			      }
			    }
			  }
			}
			log.debug("{}","frr check rolnam lfttmplst size:"+this.getFrrgrp().getLfttmplst().size());
			//Platform.clear($frrgrp\\frrlst1);
			while(this.getFrrgrp().getFrrlst1().fullSize()>0)
			  this.getFrrgrp().getFrrlst1().removeAll();
			for(int b=0;b<this.getFrrgrp().getLfttmplst().size();b++)
			  this.getFrrgrp().getFrrlst1().add(this.getFrrgrp().getLfttmplst().getElement(b));
			log.debug("{}","After sort frrlst1 size:"+this.getFrrgrp().getFrrlst1().size());
			//Platform.clear($frrgrp\\lfttmplst);
			while(this.getFrrgrp().getLfttmplst().fullSize()>0)
			  this.getFrrgrp().getLfttmplst().removeAll();
			for(int x=0;x<this.getFrrgrp().getFrrlst1().size();x++)
			{
			  if(!MdaUtils.isEmpty(this.getFrrgrp().getFrrlst1().getElement(x).getFrm()))
			    this.getFrrgrp().getLfttmplst().add(this.getFrrgrp().getFrrlst1().getElement(x));
			}
			log.debug("{}","After sort lfttmplst frm not null size:" + this.getFrrgrp().getLfttmplst().size());
			return lftmap;
		}





}