package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbijgxVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jgxgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jgxp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 机构信息详情
*/
@Transaction(vo= DbijgxVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbijgx extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbijgx.class);

		@BDGetter
		private Jgxgrp jgxgrp;

		@BDGetter
		private Jgxp jgxp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;


		public Dbijgx()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJgxp().setJgxgrpHolder(()->this.getJgxgrp());
           this.getJgxp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getJgxgrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbijgx.this.getFieldPath("jgxgrp.rec.inr");}
 				public void setValue(String arg){Dbijgx.this.getJgxgrp().getRec().setInr(arg);}
 				public String getValue(){return Dbijgx.this.getJgxgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dbijgx.@0000.script
        */
        @Rule(target="jgxp.ame",order=100)
        public boolean ruleJgxpAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			String jgxinr = this.getJgxgrp().getRec().getInr();
			ctx.storeData("jgxinr",jgxinr);
			Platform.mchain("dbejgx");

			return true;
        }

        /**
        *   source:dbijgx.@0001.script
        */
        @Rule(target="jgxp.cancel",order=100)
        public boolean ruleJgxpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.returnToFirst();

			return true;
        }

        /**
        *   source:dbijgx.@0002.script
        */
        @Rule(target="jgxp.del",order=100)
        public boolean ruleJgxpDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			String jgxinr = this.getJgxgrp().getRec().getInr();
			ctx.storeData("jgxinr",jgxinr);
			Platform.mchain("dbdjgx");

			return true;
        }



        /**
        *   source:dbijgx.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Object jgxinr = ctx.restoreData("jgxinr");
			if(MdaUtils.isEmpty(jgxinr))
			{
			  //Platform.message(#CT000000,#CT000001);
			  
			  return false;
			}
			else
			{
			  Platform.mdbRead(this.getJgxgrp().getRec(),new Argument<String>("inr",jgxinr.toString()));
			}

			return true;
        }








}