package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbirolVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rolp;
import com.ceb.gjjs.mda.manager.module.Rolgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 角色详情
*/
@Transaction(vo= DbirolVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbirol extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbirol.class);

		@BDGetter
		private Rolgrp rolgrp;

		@BDGetter
		private Rolp rolp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Dbirol()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getRolp().setRolgrpHolder(()->this.getRolgrp());
           this.getRolp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getRolgrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbirol.this.getFieldPath("rolgrp.rec.inr");}
 				public void setValue(String arg){Dbirol.this.getRolgrp().getRec().setInr(arg);}
 				public String getValue(){return Dbirol.this.getRolgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dbirol.@0001.script
        */
        @Rule(target="rolp.mtabut.ame",order=100)
        public boolean ruleRolpMtabutAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("rolinr",this.getRolgrp().getRec().getInr());
			Platform.mchain("dberol");

			return true;
        }

        /**
        *   source:dbirol.@0002.script
        */
        @Rule(target="rolp.mtabut.delete",order=100)
        public boolean ruleRolpMtabutDeleteN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("rolinr",this.getRolgrp().getRec().getInr());
			Platform.mchain("dbdrol");

			return true;
        }

        /**
        *   source:dbirol.@0009.script
        */
        @Rule(target="rolp.mtabut.add",order=100)
        public boolean ruleRolpMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.storeData("rolinr",$rolgrp\\rec\\inr.getValue());
			Platform.mchain("dbarol");

			return true;
        }

        /**
        *   source:dbirol.@0010.script
        */
        @Rule(target="rolp.mtabut.rtn",order=100)
        public boolean ruleRolpMtabutRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			String key="handleTemp";
			ctx.storeData(key,key);
			

			return true;
        }



        /**
        *   source:dbirol.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  *1.初始化不可见，可见和常用列表，读取frr，
			  *是1的填充到不可见列表，2的填充到常用列表，0的填充到可见的交易列表
			  *2.frr表中记录的角色---交易信息保存在list中
			  *3.通过读取全部的交易alllist和保存的list，得到剩下的leftlist,把leftlist中的数据按照原样保存
			  到各个list中。
			  **/
			/*Platform.disable($rolgrp\\rec\\nam);
			  $rolgrp\\flg=1;
			  String rolinr = (String)Platform.restoreData("rol");
			  Platform.mdbRead($rolgrp\\rec,new Argument<String>("inr",EQ,rolinr));
			  //读取该角色的交易信息
			  Platform.mdbReadset($rolp\\tmplst,new Argument<String>("objtyp","rol"),new Argument<String>("objinr",rolinr));
			  Platform.clear($rolgrp\\frmlst1);
			  Platform.clear($rolgrp\\frmlst2);
			  Platform.clear($rolgrp\\oftlst);
			  List<String> list=new ArrayList<String>();
			  for(int i=0;i<$rolp\\tmplst.fullSize();i++)
			  {
			  list.add($rolp\\tmplst[i]\\frminr.getValue());
			  Platform.mdbRead($rolgrp\\frm,new Argument<String>("inr",$rolp\\tmplst[i]\\frminr.getValue()));
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frm=new Argument<String>("frm");
			  Argument<String>dsp=new Argument<String>("dsp");
			  Argument<String>frmtyp=new Argument<String>("frmtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  inr.setValue($rolgrp\\frm\\inr.getValue());
			  frm.setValue($rolgrp\\frm\\frm.getValue());
			  dsp.setValue($rolgrp\\frm\\dsp.getValue());
			  frmtyp.setValue($rolgrp\\frm\\frmtyp.getValue());
			  typ.setValue($rolgrp\\frm\\typ.getValue());
			  if("1".equals($rolp\\tmplst[i]\\typ.getValue()))
			  {
			  $rolgrp\\frmlst1.add(inr,frm,frmtyp,typ,dsp);
			  }
			  else if("0".equals($rolp\\tmplst[i]\\typ.getValue()))
			  {
			  $rolgrp\\frmlst2.add(inr,frm,dsp,frmtyp,typ,dsp);
			  }
			  else if("2".equals($rolp\\tmplst[i]\\typ.getValue()))
			  {
			  $rolgrp\\oftlst.add(inr,frm,dsp,frmtyp,typ,dsp);
			  }
			  }
			  List<String> allist=new ArrayList<String>();
			  //获取全部交易
			  Platform.mdbReadset($rolp\\alllst,Argument.or(new Argument<String>("frmtyp","A"),new Argument<String>("frmtyp","B")));
			  for(int i=0;i<$rolp\\alllst.fullSize();i++)
			  {
			  allist.add($rolp\\alllst[i]\\inr.getValue());
			  }
			  $rolp.addLeft(list,allist);
			  Object rolinr = Platform.restoreData("rolinr");
			  if(Platform.isEmpty(rolinr))
			  {
			  Platform.message(#CT000002,#CT000003);
			  Platform.returnToCaller();
			  return false;
			  }
			  else
			  Platform.mdbRead($rolgrp\\rec,new Argument<String>("inr",rolinr.toString()));
			  if("0".equals($rolgrp\\rec\\lev.getValue()))
			  Platform.setValues($rolgrp\\rec\\rellev,Platform.getCodetable("rellev0"));
			  else if("1".equals($rolgrp\\rec\\lev.getValue()))
			  Platform.setValues($rolgrp\\rec\\rellev,Platform.getCodetable("rellev1"));
			  else if("2".equals($rolgrp\\rec\\lev.getValue()))
			  Platform.setValues($rolgrp\\rec\\rellev,Platform.getCodetable("rellev2"));
			  Platform.disable($rolgrp\\rec\\nam);
			  Platform.disable($rolgrp\\rec\\flg);
			  Platform.disable($rolgrp\\rec\\lev);
			  Platform.disable($rolgrp\\rec\\rellev);*/

			return true;
        }

        /**
        *   source:dbirol.@0005.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  //操作按钮不可见
			  Platform.invisible($rolp\\add);
			  Platform.invisible($rolp\\addall);
			  Platform.invisible($rolp\\rev);
			  Platform.invisible($rolp\\revall);
			  Platform.invisible($rolp\\oftadd);
			  Platform.invisible($rolp\\oftadl);
			  Platform.invisible($rolp\\oftrev);
			  Platform.invisible($rolp\\oftrel);*/

			return true;
        }

        /**
        *   source:dbirol.@0007.script
        */
        @Init(order=3000)
        public boolean	init3000(){
            IContext ctx = MdaEnv.getContext();
            
			/* String name1=Platform.getI18nValue("eibs","menu.dbrusr");
			  log.debug("name1 is:"+name1);
			  for(#frm frm: $rolgrp\\frmlst2)
			  {
			  String key=$$frm\\dsp;
			  String name=Platform.getI18nValue("eibs",key);
			  $$frm\\dsp=name;
			  }
			  for(#frm frm: $rolgrp\\frmlst1)
			  {
			  String key=$$frm\\dsp;
			  String name=Platform.getI18nValue("eibs",key);
			  $$frm\\dsp=name;
			  }
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $rolp\\number1=number1;
			  $rolp\\number2=number2;
			  Platform.invisible($mtabut\\argbut\\del);*/

			return true;
        }

        /**
        *   source:dbirol.@0008.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			//List<CodetableItem> bchlev = $rolgrp.getUsrLev();
			//Platform.setValues($rolgrp\\rec\\lev,bchlev);
			/*Platform.invisible($mtabut\\add);
			  if(!$\\sysmod.isManager())
			  {
			  Platform.invisible($mtabut\\argbut\\ame);
			  Platform.invisible($mtabut\\argbut\\del);
			  }*/

			return true;
        }

        /**
        *   source:dbirol.@0011.script
        */
        @Init(order=110)
        public boolean	init110(){
            IContext ctx = MdaEnv.getContext();
            
			Object rolinr = ctx.restoreData("rolinr");
			if(rolinr != null)
			  Platform.mdbRead(this.getRolgrp().getRec(),new Argument("inr",rolinr.toString()));
			//String rel = $rolp\\rolgrp\\rec\\rellev.getValue();
			//$rolgrp\\rec\\rellev = rel;
			if("0".equals(this.getRolgrp().getRec().getLev()))
			  MdaUtils.setValues(this.getRolgrp().getRec(),"rellev",MdaUtils.getCodetable("rellev0"));
			else if("1".equals(this.getRolgrp().getRec().getLev()))
			  MdaUtils.setValues(this.getRolgrp().getRec(),"rellev",MdaUtils.getCodetable("rellev1"));
			else if("2".equals(this.getRolgrp().getRec().getLev()))
			  MdaUtils.setValues(this.getRolgrp().getRec(),"rellev",MdaUtils.getCodetable("rellev2"));
			
			
			
			
			
			

			return true;
        }


        /**
        *   source:dbirol.@0003.script
        */
        public void initFrmlst2()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  List<String> oldlist = new ArrayList<String>();
			  Platform.clear($rolgrp\\frmlst2);
			  String sql=null;
			  sql="SELECT f.inr inr,f.frm frm,f.nam nam,f.typ typ FROM frm f,frr rf"
			  +" WHERE rf.objinr='"+$rolgrp\\rec\\inr.getValue()+"' AND rf.frm=f.frm AND rf.objtyp='rol' AND rf.typ='0'";
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frm=new Argument<String>("frm");
			  Argument<String>nam=new Argument<String>("nam");
			  Argument<String>typ=new Argument<String>("typ");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr,frm,nam,typ);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  $rolgrp\\frmlst2.add(inr,frm,nam,typ);
			  oldlist.add(frm.getValue());
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  Platform.storeData("oldlist",oldlist);
			  Platform.setModified($rolgrp\\frmlst2);*/
		}
        /**
        *   source:dbirol.@0004.script
        */
        public void initOftList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  Platform.clear($rolgrp\\frmlst2);
			  String sql=null;
			  sql="SELECT f.inr inr,f.frm frm,f.nam nam,f.typ typ FROM frm f,frr rf"
			  +" WHERE rf.objinr='"+$rolgrp\\rec\\inr.getValue()+"' AND rf.frm=f.frm AND rf.objtyp='rol' AND rf.typ='2'";
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frm=new Argument<String>("frm");
			  Argument<String>nam=new Argument<String>("nam");
			  Argument<String>typ=new Argument<String>("typ");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr,frm,nam,typ);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  $rolgrp\\oftlst.add(inr,frm,nam,typ);
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  Platform.setModified($rolgrp\\oftlst);*/
		}







}