package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbisrlVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Usrgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Usrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 用户查询
*/
@Transaction(vo= DbisrlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbisrl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbisrl.class);

		@BDGetter
		private Usrgrp usrgrp;

		@BDGetter
		private Usrp usrp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Sysmod sysmod;


		public Dbisrl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getUsrp().setUsrgrpHolder(()->this.getUsrgrp());
           this.getUsrp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getUsrgrp());
        }

        /**
        *   source:dbisrl.@0005.script
        */
        @Rule(target="usrp.sel",order=100)
        public boolean ruleUsrpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  *	用户信息查询
			  *	根据用户号进行查询
			  */
			query();
			int count = this.getUsrp().getUsrlst().fullSize();
			if(count == 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbisrl","CT000041"),MdaUtils.getI18NString("dbisrl","CT000042"));
			}

			return true;
        }

        /**
        *   source:dbisrl.@0007.script
        */
        @Rule(target="usrp.usrlst",order=100)
        public boolean ruleUsrpUsrlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index>-1)
			{
			  ctx.storeData("usrinr",this.getUsrp().getUsrlst().getElement(index).getInr());
			  Platform.mchain("dblsrl");
			}

			return true;
        }



        /**
        *   source:dbisrl.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.clear($ustp\\usrlst);
			Argument arg=new Argument();
			arg=arg.and("usrflg",EQ,"0");
			//  Platform.mdbReadset($ustp\\usrlst,arg);
			//Platform.setModified($ustp\\usrlst);
			
			return true;
        }


        /**
        *   source:dbisrl.@0006.script
        */
        public void query()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  Platform.clear($usrp\\usrlst);
			  Argument arg = new Argument();
			  String[] nams = {"nam","dspnam"};
			  arg = Platform.addStringArgumentOfLIKE(nams,
			  $usrp\\nam,$usrp\\dspnam);
			  //arg.and(new Argument<String>("sta","0"));
			  Platform.mdbReadset($usrp\\usrlst,arg,new Argument<String>("sta","0"));
			  Platform.setModified($usrp\\usrlst);
			  */
			MdaUtils.clear(this.getUsrp().getUsrlst());
			Argument arg = new Argument();
			String[] nams = {"nam","dspnam"};
			arg = Platform.addStringArgumentOfLIKE(nams,MdaDriver.getDatafield(this.getUsrgrp().getRec(),"nam"),MdaDriver.getDatafield(this.getUsrgrp().getRec(),"dspnam"));

			//增加实体查询条件
			arg = arg.and(ctx.absGet(Sysmod.class).getEtyArg());

			Platform.mdbReadset(this.getUsrp().getUsrlst(),arg,new Argument<String>("sta","0"));
			
		}






}