package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DblbrcVO;

import com.ceb.gjjs.mda.manager.module.Ptygrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Brcp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 银行信息查询
*/
@Transaction(vo= DblbrcVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dblbrc extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dblbrc.class);

		@BDGetter
		private Ptygrp ptygrp;

		@BDGetter
		private Brcp brcp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dblbrc()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBrcp().setMtabutHolder(()->this.getMtabut());
           this.getBrcp().setPtygrpHolder(()->this.getPtygrp());
           this.getMtabut().setMtagrpHolder(()->this.getPtygrp());
        }

        /**
        *   source:dblbrc.@0000.script
        */
        @Rule(target="brcp.sel",order=100)
        public boolean ruleBrcpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  * 机构信息查询处理
			  */
			MdaUtils.clear(this.getBrcp().getPtyshwlst());
			
			String cid = this.getBrcp().getCid();
			String extkey = this.getBrcp().getExtkey();
			String typ = "A";
			/*
			  if(!Platform.isEmpty($brcp\\ptytyp))
			  {
			  typ = $brcp\\ptytyp;
			  }
			  */
			String sql = "SELECT p.inr ptyinr,p.cid,p.extkey,p.nam,p.chnnam,"+
			  "x.adrinr,x.adr,x.lnknam,x.tel FROM  pty p LEFT JOIN "+
			  "(SELECT a.ptyinr,b.inr adrinr,b.adr,b.lnknam,b.tel "+
			  "FROM pta a,adr b WHERE a.objinr=b.inr) x  "+
			  "ON x.ptyinr = p.inr WHERE p.ptytyp LIKE '%" + typ + "%' AND p.status= '0'";
			if(!MdaUtils.isEmpty(cid))
			{
			  sql += " AND p.cid LIKE '%" + cid + "%'";
			}
			if(!MdaUtils.isEmpty(extkey))
			{
			  extkey = extkey.toUpperCase();
			  sql += " AND p.extkey LIKE '%" + extkey + "%'";
			}
			if(!MdaUtils.isEmpty(this.getBrcp().getNam()))
			{
			  String nam = this.getBrcp().getNam();
			  sql += " AND p.chnnam LIKE  '%" + nam + "%'";
			}

			//增加实体查询条件
			sql = sql+ctx.absGet(Sysmod.class).getEtySql("p");

			Argument<String> ptyinrarg = new Argument<String>("ptyinr");
			Argument<String> adrinrarg = new Argument<String>("adrinr");
			Argument<String> cidarg = new Argument<String>("cid");
			Argument<String> extkeyarg = new Argument<String>("extkey");
			Argument<String> namarg = new Argument<String>("nam");
			Argument<String> chnnamarg = new Argument<String>("chnnam");
			Argument<String> adrarg = new Argument<String>("adr");
			Argument<String> lnknamarg = new Argument<String>("lnknam");
			Argument<String> telarg = new Argument<String>("tel");
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(ptyinrarg,cidarg,extkeyarg,namarg,chnnamarg,adrarg,lnknamarg,telarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    this.getBrcp().getPtyshwlst().add(ptyinrarg,cidarg,extkeyarg,chnnamarg,namarg,
			      adrinrarg,adrarg,lnknamarg,telarg);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			
			if(this.getBrcp().getPtyshwlst().fullSize()==0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dblbrc","CT000119"),MdaUtils.getI18NString("dblbrc","CT000120"));
			}

			return true;
        }

        /**
        *   source:dblbrc.@0001.script
        */
        @Rule(target="brcp.clr",order=100)
        public boolean ruleBrcpClrN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBrcp().setCid(NULLSTR);
			
			this.getBrcp().setExtkey(NULLSTR);
			
			this.getBrcp().setNam(NULLSTR);
			

			return true;
        }

        /**
        *   source:dblbrc.@0002.script
        */
        @Rule(target="brcp.add",order=100)
        public boolean ruleBrcpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("dbabrc");

			return true;
        }

        /**
        *   source:dblbrc.@0004.script
        */
        @Rule(target="brcp.inf",order=100)
        public boolean ruleBrcpInfN100(){
            IContext ctx = MdaEnv.getContext();
            
			int i = 0;
			if(i<0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dblbrc","CT000046"),MdaUtils.getI18NString("dblbrc","CT000047"));
			}
			else
			{
			  String ptyinr = this.getBrcp().getPtyshwlst().getElement(i).getPtyinr();
			  ctx.storeData("ptyinr",ptyinr);
			  Platform.mchain("dbibrc");
			}

			return true;
        }

        /**
        *   source:dblbrc.@0005.script
        */
        @Rule(target="brcp.ptyshwlst",order=100)
        public boolean ruleBrcpPtyshwlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int i = 0;
			if(i<0)
			{
			  return true;
			}
			else
			{
			  String ptyinr = this.getBrcp().getPtyshwlst().getElement(i).getPtyinr();
			  ctx.storeData("ptyinr",ptyinr);
			  Platform.mchain("dbibrc");
			}


			return true;
        }

        /**
        *   source:dblbrc.@0006.script
        */
        @Rule(target="brcp.imp",order=100)
        public boolean ruleBrcpImpN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","imp");
			IStream is = this.getBrcp().getImp();
			String filePath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"bankInfo.txt");
			Platform.mstreamSave(is,filePath);
			Boolean res = (Boolean)MdaUtils.invokeEx("com.brilliance.swift.imp.BankImporter","ImpbnkInfo",filePath);
			if(!res)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dblbrc","CT000114"),MdaUtils.getI18NString("dblbrc","CT000115"));
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("dblbrc","CT000116"),MdaUtils.getI18NString("dblbrc","CT000117"));
			}

			return true;
        }

        /**
        *   source:dblbrc.@0007.script
        */
        @Rule(target="brcp.txt",order=100)
        public boolean ruleBrcpTxtN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","imp");
			String filePath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"bankInfo.txt");
			// Platform.mstreamSave(is,filePath);
			MdaUtils.invokeEx("com.brilliance.swift.imp.BankImporter","ImpbnkInfo",filePath);
			//Object str = Platform.invokeEx("cn.com.brilliance.eibs.ConnectionUtils","test",
			//  "arg1","arg2");
			//log.debug("result string :" + str);
			
			return true;
        }


        /**
        *   source:dblbrc.@0008.script
        */
        @Check(target="brcp.extkey",order=100)
        public boolean checkBrcpExtkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBrcp().getExtkey()))
			  return true;
			String bic = this.getBrcp().getExtkey();
			bic = bic.toUpperCase();
			if(!bic.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"brcp.extkey",MdaUtils.getI18NString("dblbrc","CT000118"));
			}
			this.getBrcp().setExtkey( bic);
			

			return true;
        }


        /**
        *   source:dblbrc.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> cts = this.getBrcp().getPtyCT();
			MdaUtils.setValues(this.getBrcp().getPtyshw(),"pntinr",cts);
			MdaUtils.setValues(this.getPtygrp().getRec(),"pntinr",cts);
			List<CodetableItem> cts2  = new ArrayList<CodetableItem>();
			//cts2.add(new CodetableItem("机构","A"));
			cts2.add(new CodetableItem("银行","B"));
			MdaUtils.setValues(this.getBrcp(),"ptytyp",cts2);
			this.getBrcp().setPtytyp( "B");
			
			//Platform.clear($brcp\\ptyshw);
			//Platform.setModified($brcp\\ptyshw);
			//Platform.clear($brcp\\ptyshwlst);
			//Platform.setModified($brcp\\ptyshwlst);
			
			return true;
        }







}