package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbletgVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etggrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Etgp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体组信息查询
*/
@Transaction(vo= DbletgVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbletg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbletg.class);

		@BDGetter
		private Etggrp etggrp;

		@BDGetter
		private Etgp etgp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dbletg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtgp().setEtggrpHolder(()->this.getEtggrp());
           this.getEtgp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getEtggrp());
        }

        /**
        *   source:dbletg.@0000.script
        */
        @Rule(target="etgp.add",order=100)
        public boolean ruleEtgpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("dbaetg");

			return true;
        }

        /**
        *   source:dbletg.@0001.script
        */
        @Rule(target="etgp.clr",order=100)
        public boolean ruleEtgpClrN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getEtgp().setNam(NULLSTR);
			
			this.getEtgp().setDes(NULLSTR);
			

			return true;
        }

        /**
        *   source:dbletg.@0002.script
        */
        @Rule(target="etgp.etgshwlst",order=100)
        public boolean ruleEtgpEtgshwlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int i = 0;
			if(i<0)
			{
			  return true;
			}
			else
			{
			  String etginr = this.getEtgp().getEtgshwlst().getElement(i).getInr();
			  ctx.storeData("etginr",etginr);
			  Platform.mchain("dbietg");
			}


			return true;
        }

        /**
        *   source:dbletg.@0003.script
        */
        @Rule(target="etgp.sel",order=100)
        public boolean ruleEtgpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  * 机构信息查询处理
			  */
			MdaUtils.clear(this.getEtgp().getEtgshwlst());
			

			String etgnam = this.getEtgp().getNam();
			String etgdes = this.getEtgp().getDes();

			String sql = "SELECT inr,nam,des FROM etg WHERE sta='0' ";
			if(!MdaUtils.isEmpty(etgnam))
			{
			  etgnam = etgnam.toUpperCase();
			  sql += " AND UPPER(nam) LIKE '%" + etgnam + "%'";
			}
			if(!MdaUtils.isEmpty(etgdes))
			{
			  etgdes = etgdes.toUpperCase();
			  sql += " AND UPPER(des) LIKE '%" + etgdes + "%'";
			}

			Argument<String> inr = new Argument<String>("inr");
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> des = new Argument<String>("des");

			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(inr,nam,des);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    this.getEtgp().getEtgshwlst().add(inr,nam,des);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			

			return true;
        }









}