package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbletyVO;

import com.ceb.gjjs.mda.manager.module.Etygrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Etyp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 实体信息查询
*/
@Transaction(vo= DbletyVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dblety extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dblety.class);

		@BDGetter
		private Etygrp etygrp;

		@BDGetter
		private Etyp etyp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dblety()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEtyp().setMtabutHolder(()->this.getMtabut());
           this.getEtyp().setEtygrpHolder(()->this.getEtygrp());
           this.getMtabut().setMtagrpHolder(()->this.getEtygrp());
        }

        /**
        *   source:dblety.@0000.script
        */
        @Rule(target="etyp.add",order=100)
        public boolean ruleEtypAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("dbaety");

			return true;
        }

        /**
        *   source:dblety.@0001.script
        */
        @Rule(target="etyp.clr",order=100)
        public boolean ruleEtypClrN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getEtyp().setRef(NULLSTR);
			
			this.getEtyp().setEtynam(NULLSTR);
			
			this.getEtyp().setEtyeng(NULLSTR);
			
			this.getEtyp().setDes(NULLSTR);
			
			this.getEtyp().setEtginr(NULLSTR);
			

			return true;
        }

        /**
        *   source:dblety.@0002.script
        */
        @Rule(target="etyp.etyshwlst",order=100)
        public boolean ruleEtypEtyshwlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int i = 0;
			if(i<0)
			{
			  return true;
			}
			else
			{
			  String etyinr = this.getEtyp().getEtyshwlst().getElement(i).getInr();
			  ctx.storeData("etyinr",etyinr);
			  Platform.mchain("dbiety");
			}


			return true;
        }

        /**
        *   source:dblety.@0003.script
        */
        @Rule(target="etyp.sel",order=100)
        public boolean ruleEtypSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  * 机构信息查询处理
			  */
			MdaUtils.clear(this.getEtyp().getEtyshwlst());
			
			String ref = this.getEtyp().getRef();
			String etynam = this.getEtyp().getEtynam();
			String etyeng = this.getEtyp().getEtyeng();
			String des = this.getEtyp().getDes();
			String etginr = this.getEtyp().getEtginr();

			String sql = "SELECT inr,ref,etynam,etyeng,des,etginr FROM ety WHERE sta = '0' ";
			if(!MdaUtils.isEmpty(ref))
			{
			  ref = ref.toUpperCase();
			  sql += " AND UPPER(ref) LIKE '%" + ref + "%'";
			}
			if(!MdaUtils.isEmpty(etynam))
			{
			  etynam = etynam.toUpperCase();
			  sql += " AND UPPER(etynam) LIKE '%" + etynam + "%'";
			}
			if(!MdaUtils.isEmpty(etyeng))
			{
			  etyeng = etyeng.toUpperCase();
			  sql += " AND UPPER(etyeng) LIKE '%" + etyeng + "%'";
			}
			if(!MdaUtils.isEmpty(des))
			{
			  des = des.toUpperCase();
			  sql += " AND UPPER(des) LIKE '%" + des + "%'";
			}
			if(!MdaUtils.isEmpty(etginr))
			{
			  sql += " AND UPPER(etginr) = '" + etginr + "'";
			}

			Map<String,String> map = this.getEtyp().getEtgMap();

			Argument<String> inrarg = new Argument<String>("inr");
			Argument<String> refarg = new Argument<String>("ref");
			Argument<String> etynamarg = new Argument<String>("etynam");
			Argument<String> etyengarg = new Argument<String>("etyeng");
			Argument<String> desarg = new Argument<String>("des");
			Argument<String> etginrarg = new Argument<String>("etginr");
			Argument<String> etgnamarg = new Argument<String>("etgnam");

			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(inrarg,refarg,etynamarg,etyengarg,desarg,etginrarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    etgnamarg.value=map.get(etginrarg.value);
			    this.getEtyp().getEtyshwlst().add(inrarg,refarg,etynamarg,etyengarg,desarg,etgnamarg);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			

			return true;
        }



        /**
        *   source:dblety.@0004.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> cts = this.getEtyp().getEtgCT();
			MdaUtils.setValues(this.getEtyp(),"etginr",cts);

			return true;
        }







}