package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbljgxVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jgxgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jgxp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 机构信息查询
*/
@Transaction(vo= DbljgxVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbljgx extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbljgx.class);

		@BDGetter
		private Jgxgrp jgxgrp;

		@BDGetter
		private Jgxp jgxp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;


		public Dbljgx()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJgxp().setJgxgrpHolder(()->this.getJgxgrp());
           this.getJgxp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getJgxgrp());
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Dbljgx.this.getFieldPath("jgxgrp.rec.inr");}
 				public void setValue(String arg){Dbljgx.this.getJgxgrp().getRec().setInr(arg);}
 				public String getValue(){return Dbljgx.this.getJgxgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dbljgx.@0000.script
        */
        @Rule(target="jgxgrp.jgxlst",order=100)
        public boolean ruleJgxgrpJgxlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int i = 0;
			if(i<0)
			{
			  return true;
			}
			else
			{
			  String jgxinr = this.getJgxgrp().getJgxlst().getElement(i).getInr();
			  ctx.storeData("jgxinr",jgxinr);
			  Platform.mchain("dbijgx");
			}


			return true;
        }

        /**
        *   source:dbljgx.@0001.script
        */
        @Rule(target="jgxp.add",order=100)
        public boolean ruleJgxpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("dbajgx");

			return true;
        }










}