package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DblrolVO;

import com.ceb.gjjs.mda.manager.module.Dbxmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rolp;
import com.ceb.gjjs.mda.manager.module.Rolgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 角色查询
*/
@Transaction(vo= DblrolVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dblrol extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dblrol.class);

		@BDGetter
		private Rolgrp rolgrp;

		@BDGetter
		private Rolp rolp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Dbxmod dbxmod;

		@BDGetter
		private Sysmod sysmod;


		public Dblrol()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getRolp().setRolgrpHolder(()->this.getRolgrp());
           this.getRolp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getRolgrp());
           this.getDbxmod().setMtabutHolder(()->this.getMtabut());
        }

        /**
        *   source:dblrol.@0000.script
        */
        @Rule(target="rolp.search",order=100)
        public boolean ruleRolpSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.clear($rolp\\rollst);
			  Platform.setModified($rolp\\rollst);
			  String sql="SELECT inr,nam,flg FROM rol WHERE flg!='1'";
			  if(!Platform.isEmpty($rolp\\rolnam.getValue()))
			  {
			  sql+=" AND nam LIKE '%"+$rolp\\rolnam.getValue()+"%'";
			  }
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>nam=new Argument<String>("nam");
			  Argument<String>flg=new Argument<String>("flg");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr,nam,flg);
			  if(Platform.errorCode()==NO_ERROR)
			  {
			  $rolp\\rollst.add(inr,nam,flg);
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  Platform.setModified($rolp\\rollst);
			  */
			log.debug("{}","rol search...");
			ctx.getErrorCode();
			MdaUtils.clear(this.getRolp().getRolgrp().getRollst());
			Argument arg = new Argument();
			String[] arr = {"nam","flg","rellev","lev"};
			/*//获取当前用户所属机构级次
			Integer curlev=this.getSysmod().rolOfUsr(this.getSysmod().getUsr().getBchcod());
			String curlevstring=curlev.toString();
			arg = Platform.addArgumentNotEmpty(arr,MdaDriver.getDatafield(this.getRolp(),"nam"),MdaDriver.getDatafield(this.getRolp(),"sta"),MdaDriver.getDatafield(this.getRolp(),"rellev"),MdaDriver.getDatafield(this.getRolp(),"lev"));
			if (MdaUtils.isEmpty(this.getRolp().getLev()))
			{
			Argument arg0=new Argument<String>("lev",curlevstring);
			if("0".equals(curlevstring))
			arg0=arg0.or(new Argument<String>("lev","1"));
			if("1".equals(curlevstring)||"0".equals(curlevstring))
			arg0=arg0.or(new Argument<String>("lev","2"));
			arg=arg.and(arg0);
			}*/
			arg = Platform.addArgumentNotEmpty(arr,MdaDriver.getDatafield(this.getRolp(),"nam"),MdaDriver.getDatafield(this.getRolp(),"flg"),MdaDriver.getDatafield(this.getRolp(),"rellev"),MdaDriver.getDatafield(this.getRolp(),"lev"));

			//增加实体查询条件
			arg=arg.and(ctx.absGet(Sysmod.class).getEtyArg());

			Platform.mdbReadset(this.getRolp().getRolgrp().getRollst(),arg);
			
			if(this.getRolp().getRolgrp().getRollst().fullSize() == 0)
			  ctx.setMessage(MdaUtils.getI18NString("dblrol","CT000014"),MdaUtils.getI18NString("dblrol","CT000015"));

			return true;
        }

        /**
        *   source:dblrol.@0002.script
        */
        @Rule(target="rolp.mtabut.sel",order=100)
        public boolean ruleRolpMtabutSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","rol search...");
			ctx.getErrorCode();
			MdaUtils.clear(this.getRolp().getRolgrp().getRollst());
			Argument arg = new Argument();
			String[] arr = {"nam","flg","rellev","lev"};
			/*//获取当前用户所属机构级次
			Integer curlev=this.getSysmod().rolOfUsr(this.getSysmod().getUsr().getBchcod());
			String curlevstring=curlev.toString();
			arg = Platform.addArgumentNotEmpty(arr,MdaDriver.getDatafield(this.getRolp(),"nam"),MdaDriver.getDatafield(this.getRolp(),"sta"),MdaDriver.getDatafield(this.getRolp(),"rellev"),MdaDriver.getDatafield(this.getRolp(),"lev"));
			if (MdaUtils.isEmpty(this.getRolp().getLev()))
			{
			Argument arg0=new Argument<String>("lev",curlevstring);
			if("0".equals(curlevstring))
			arg0=arg0.or(new Argument<String>("lev","1"));
			if("1".equals(curlevstring)||"0".equals(curlevstring))
			arg0=arg0.or(new Argument<String>("lev","2"));
			arg=arg.and(arg0);
			}*/
			arg = Platform.addArgumentNotEmpty(arr,MdaDriver.getDatafield(this.getRolp(),"nam"),MdaDriver.getDatafield(this.getRolp(),"flg"),MdaDriver.getDatafield(this.getRolp(),"rellev"),MdaDriver.getDatafield(this.getRolp(),"lev"));

			//增加实体查询条件
			arg=arg.and(ctx.absGet(Sysmod.class).getEtyArg());

			Platform.mdbReadset(this.getRolp().getRolgrp().getRollst(),arg);
			
			if(this.getRolp().getRolgrp().getRollst().fullSize() == 0)
			  ctx.setMessage(MdaUtils.getI18NString("dblrol","CT000008"),MdaUtils.getI18NString("dblrol","CT000009"));

			return true;
        }

        /**
        *   source:dblrol.@0003.script
        */
        @Rule(target="rolp.mtabut.reset",order=100)
        public boolean ruleRolpMtabutResetN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getRolp().setNam(NULLSTR);
			this.getRolp().setFlg(NULLSTR);
			this.getRolp().setLev(NULLSTR);
			this.getRolp().setRellev(NULLSTR);
			
			
			
			

			return true;
        }

        /**
        *   source:dblrol.@0004.script
        */
        @Rule(target="rolp.mtabut.add",order=100)
        public boolean ruleRolpMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("dbarol");

			return true;
        }

        /**
        *   source:dblrol.@0005.script
        */
        @Rule(target="rolgrp.rollst",order=100)
        public boolean ruleRolgrpRollstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			log.info("{}","index:"+index);
			if(index<0 || index>=this.getRolgrp().getRollst().fullSize())
			  return true;
			String rolinr = this.getRolgrp().getRollst().getElement(index).getInr();
			ctx.storeData("rolinr",rolinr);
			Platform.mchain("dbirol");

			return true;
        }

        /**
        *   source:dblrol.@0008.script
        */
        @Rule(target="rolp.exp",order=100)
        public boolean ruleRolpExpN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream is = this.getRolp().getExp();
			is.setType("xls");
			is.setName("Roler"+MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss")+".xls");
			List<Object[]> lst = new ArrayList<Object[]>();
			String [] title= new String[12];
			title[0]=MdaUtils.getI18NString("dblrol","CT000010");
			title[1]=MdaUtils.getI18NString("dblrol","CT000011");
			title[2]=MdaUtils.getI18NString("dblrol","CT000012");
			title[3]=MdaUtils.getI18NString("dblrol","CT000013");
			lst.add(title);
			for(int i=0;i<this.getRolgrp().getRollst().fullSize();i++)
			{
			  Object [] line = new Object[4];
			  line[0] = this.getRolgrp().getRollst().getElement(i).getNam();
			  String flg = this.getRolgrp().getRollst().getElement(i).getFlg();
			  if(MdaUtils.isEmpty(flg))
			    line[1]="";
			  else
			    line[1] = MdaUtils.getCodetableLabel("rolsta",flg);
			  String rellev = this.getRolgrp().getRollst().getElement(i).getRellev();
			  if(MdaUtils.isEmpty(rellev))
			    line[2]="";
			  else
			    line[2] = MdaUtils.getCodetableLabel("rellev",rellev);
			  String lev = this.getRolgrp().getRollst().getElement(i).getLev();
			  if(MdaUtils.isEmpty(lev))
			    line[3] = "";
			  else
			    line[3] = MdaUtils.getCodetableLabel("bchlev",lev);
			  lst.add(line);
			}
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }



        /**
        *   source:dblrol.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.invisible($mtabut\\argbut\\ame);
			  Platform.invisible($mtabut\\argbut\\del);
			  */

			return true;
        }

        /**
        *   source:dblrol.@0007.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			//List<CodetableItem> bchlev = $rolgrp.getUsrLev();
			//Platform.setValues($rolp\\lev,bchlev);
			//$rolp\\sta = "0";
			//int curlev = $\\sysmod.rolOfUsr($\\sysmod\\tlr\\bchcod.getValue());
			//$rolp\\lev = curlev.toString();
			//if(!$sysmod.isManager())
			//{
			//  Platform.invisible($mtabut\\add);
			//}
			
			return true;
        }








}