package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DblsrlVO;

import com.ceb.gjjs.mda.manager.module.Urlgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Srlp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 用户角色展示页面
*/
@Transaction(vo= DblsrlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dblsrl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dblsrl.class);

		@BDGetter
		private Urlgrp urlgrp;

		@BDGetter
		private Srlp srlp;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;


		public Dblsrl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getSrlp().setUrlgrpHolder(()->this.getUrlgrp());
           this.getMtabut().setMtagrpHolder(()->this.getUrlgrp());
        }

        /**
        *   source:dblsrl.@0005.script
        */
        @Rule(target="mtabut.argbut.ame",order=100)
        public boolean ruleMtabutArgbutAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  *  点击修改按钮，进入角色详情，提交页面
			  */
			/*List<String>newlist=new ArrayList<String>();
			  for(int i=0;i<$urlgrp\\rollst2.fullSize();i++)
			  {
			  String rolinr=$urlgrp\\rollst2[i]\\inr.getValue();
			  newlist.add(rolinr);
			  }*/
			//Platform.storeData("usrinr",$urlgrp\\usr\\inr.getValue());//保存用户inr
			//Platform.storeData("newlist",newlist);//保存修改后的角色inr
			ctx.storeData("urllst",this.getUrlgrp().getUrllst());
			ctx.storeData("urllst1",this.getUrlgrp().getUrllst1());
			ctx.storeData("urllst2",this.getUrlgrp().getUrllst2());
			ctx.storeData("lognam",this.getSrlp().getLognam());
			ctx.storeData("oprnam",this.getSrlp().getOprnam());
			ctx.storeData("number1",this.getSrlp().getNumber1());
			ctx.storeData("number2",this.getSrlp().getNumber2());
			Platform.mchain("dbesrl");

			return true;
        }



        /**
        *   source:dblsrl.@0006.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  初始化用户已经分配的角色列表
			  */
			if(MdaUtils.isEmpty(this.getUrlgrp().getUsr().getInr()))
			  return true;
			List<String> oldlist=new ArrayList<String>();
			Platform.clears(this.getUrlgrp().getRollst2());
			//String sql="SELECT r.inr inr ,r.nam nam FROM rol r,url ur WHERE r.inr=ur.rolinr AND r.flg!='1' AND ur.usrinr='"+$urlgrp\\usr\\inr.getValue()+"'";
			String sql="SELECT ROL.INR AS ROLINR,ROL.NAM AS ROLNAM,URL.INR,URL.USRINR FROM ROL LEFT JOIN URL ON ROL.INR = URL.ROLINR";
			sql = sql + " AND URL.USRINR = ?";
			Argument<String>inr=new Argument<String>("inr");
			Argument<String>rolnam=new Argument<String>("rolnam");
			Argument<String>rolinr=new Argument<String>("rolinr");
			Argument<String>usrinr=new Argument<String>("usrinr");

			//增加实体查询条件
			sql = sql+" WHERE 1=1 ";
			sql = sql+ctx.absGet(Sysmod.class).getEtySql("ROL");
			//排除已注销角色
			sql = sql + "AND ROL.FLG = '0' ";

			Platform.mdbExecuteSQL(sql,this.getUrlgrp().getUsr().getInr());
			log.debug("{}","usr inr:"+this.getUrlgrp().getUsr().getInr());
			while(true)
			{
			  Platform.mdbFetchFields(inr,rolnam,rolinr,usrinr);
			  int err=ctx.getErrorCode();
			  if(err==NO_ERROR)
			  {
			    this.getUrlgrp().getUrllst().add(inr,rolnam,rolinr,usrinr);
			    oldlist.add(inr.getValue());
			  }
			  else
			  {
			    break;
			  }
			}
			for(int i=0;i<this.getUrlgrp().getUrllst().fullSize();i++)
			{
			  if(!MdaUtils.isEmpty(this.getUrlgrp().getUrllst().getElement(i).getInr()))
			    this.getUrlgrp().getUrllst2().add(this.getUrlgrp().getUrllst().getElement(i));
			  else
			    this.getUrlgrp().getUrllst1().add(this.getUrlgrp().getUrllst().getElement(i));
			}
			Platform.mdbCloseCursor();
			//Platform.storeData("oldlist",oldlist);//保存用户的原有角色
			//Platform.setModified($urlgrp\\rollst2);
			
			return true;
        }

        /**
        *   source:dblsrl.@0007.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  获取用户信息
			  */
			String usrinr=(String)ctx.restoreData("usrinr");
			if(usrinr == null)
			  return true;
			Platform.mdbRead(this.getUrlgrp().getUsr(),new Argument<String>("inr",usrinr));
			this.getSrlp().setLognam(this.getUrlgrp().getUsr().getNam());
			this.getSrlp().setOprnam(this.getUrlgrp().getUsr().getDspnam());

			return true;
        }

        /**
        *   source:dblsrl.@0009.script
        */
        @Init(order=400)
        public boolean	init400(){
            IContext ctx = MdaEnv.getContext();
            

			log.debug("{}","the trade name is:"+ctx.getTransName()+".....");
			/*
			  清空oldlst和newlst
			  */
			/*Platform.clear($urlgrp\\oldlst);
			  Platform.clear($urlgrp\\newlst);
			  Platform.mdbReadset($urlgrp\\oldlst,new Argument<String>("usrinr",$urlgrp\\usr\\inr.getValue()));
			  Platform.mdbReadset($urlgrp\\newlst,new Argument<String>("usrinr",$urlgrp\\usr\\inr.getValue()));*/

			return true;
        }

        /**
        *   source:dblsrl.@0010.script
        */
        @Init(order=300)
        public boolean	init300(){
            IContext ctx = MdaEnv.getContext();
            
			/*Platform.clear($urlgrp\\rollst1);
			  String sql="SELECT r.inr inr ,r.nam nam FROM rol r where r.flg!='1' AND r.inr NOT IN (SELECT rolinr from url WHERE  usrinr='"+$urlgrp\\usr\\inr.getValue()+"')";
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>nam=new Argument<String>("nam");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr,nam);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  $urlgrp\\rollst1.add(inr,nam);
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  Platform.setModified($urlgrp\\rollst1);*/

			return true;
        }

        /**
        *   source:dblsrl.@0013.script
        */
        @Init(order=1000)
        public boolean	init1000(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			//String number1=String.valueOf($urlgrp\\rollst1.fullSize());
			//String number2=String.valueOf($urlgrp\\rollst2.fullSize());
			String number1=String.valueOf(this.getUrlgrp().getUrllst1().fullSize());
			String number2=String.valueOf(this.getUrlgrp().getUrllst2().fullSize());
			this.getSrlp().setNumber1(number1);
			this.getSrlp().setNumber2(number2);

			return true;
        }








}