package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbltelVO;

import com.ceb.gjjs.mda.manager.module.Telgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Telp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 柜员信息查询
*/
@Transaction(vo= DbltelVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbltel extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbltel.class);

		@BDGetter
		private Telgrp telgrp;

		@BDGetter
		private Telp telp;

		@BDGetter
		private Sysmod sysmod;


		public Dbltel()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTelp().setTelgrpHolder(()->this.getTelgrp());
        }

        /**
        *   source:dbltel.@0001.script
        */
        @Rule(target="telp.confirm",order=50)
        public boolean ruleTelpConfirmN50(){
            IContext ctx = MdaEnv.getContext();
            

			//  if(!Platform.checkAll($telgrp\\usr))
			// {
			
			//  log.warn("页面校验未通过，退出！");
			//Platform.message(#CT000000,#CT000001);
			//   return false;
			//  }
			

			return true;
        }



        /**
        *   source:dbltel.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> tinstLst = new ArrayList<CodetableItem>();
			Argument<String> tininr = new Argument<String>("inr");
			Argument<String> tinnam = new Argument<String>("brhnam");
			String tinsql = "select inr ,brhnam from jgx";
			ctx.getDaoSession().dbExecuteSQL(tinsql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(tininr,tinnam);
			  int error=ctx.getErrorCode();

			  if(error==NO_ERROR)
			  {
			    tinstLst.add(new CodetableItem(tinnam.getValue(),tininr.getValue()));
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			//Platform.storeData("tinnammap",tinnammap);
			// tinstLst.add(new CodetableItem("台州银行总行", "11005293"));
			//查询角色下拉框
			List<CodetableItem> rolLst = new ArrayList<CodetableItem>();
			String sql = "select inr,nam from rol";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> nam = new Argument<String>("nam");
			log.info("{}","Execute SQL "+sql);
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,nam);
			  log.info("{}","Fetching "+nam.getValue());
			  int error=ctx.getErrorCode();
			  log.info("{}","Fetch complete "+error);

			  if(error==NO_ERROR)
			  {
			    rolLst.add(new CodetableItem(nam.getValue(),inr.getValue()));
			    log.debug("{}","NAM:" + nam.getValue());
			    log.debug("{}","INR:" + inr.getValue());
			  }
			  else
			  {
			    break;
			  }
			}
			log.info("{}","closing cursor for usr");
			Platform.mdbCloseCursor();
			MdaUtils.setValues(this.getTelgrp().getUsr(),"tinst",tinstLst);
			MdaUtils.setValues(this.getTelp(),"initrole",rolLst);

			//刷新查询界面
			Object obj = ctx.restoreData("handleTemp");
			log.debug("{}","is obj null:" + obj == null);
			if (obj != null)
			{
			  ctx.postRule(this,"telp.searchbutton");
			}

			return true;
        }






}