package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbpusrVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Usdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Usrgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Usrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 个人详细信息展示
*/
@Transaction(vo= DbpusrVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbpusr extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbpusr.class);

		@BDGetter
		private Usdgrp usdgrp;

		@BDGetter
		private Usrp usrp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Usrgrp usrgrp;


		public Dbpusr()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getUsrp().setUsrgrpHolder(()->this.getUsrgrp());
           this.getUsrp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getUsrgrp());
        }

        /**
        *   source:dbpusr.@0003.script
        */
        @Rule(target="usrp.amepas",order=100)
        public boolean ruleUsrpAmepasN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:dbpusr.@0004.script
        */
        @Rule(target="usrp.ameinf",order=100)
        public boolean ruleUsrpAmeinfN100(){
            IContext ctx = MdaEnv.getContext();
            
			String usrinr = this.getUsrgrp().getRec().getInr();
			ctx.storeData("usrinr",usrinr);
			

			return true;
        }

        /**
        *   source:dbpusr.@0005.script
        */
        @Rule(target="usrp.comtra",order=100)
        public boolean ruleUsrpComtraN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("usrinr",this.getSysmod().getUsr().getInr());
			log.debug("{}","dbpusr usrinr:"+this.getSysmod().getUsr().getInr());
			ctx.storeData("trnnam",ctx.getTransName());
			Platform.mchain("dbiusm");

			return true;
        }



        /**
        *   source:dbpusr.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getUsrgrp().getRec().setInr( this.getSysmod().getUsr().getInr());
			log.debug("{}","dbpusr init usrinr:"+this.getSysmod().getUsr().getInr());
			this.getUsrgrp().getRec().setNam( this.getSysmod().getUsr().getNam());
			this.getUsrgrp().getRec().setPtynam( this.getSysmod().getUsr().getPtynam());
			this.getUsrgrp().getRec().setLstdattim( this.getSysmod().getUsr().getLstdattim());
			this.getUsrgrp().getRec().setDspnam( this.getSysmod().getUsr().getDspnam());
			this.getUsrgrp().getRec().setPtyinr( this.getSysmod().getUsr().getPtyinr());
			this.getUsrgrp().getRec().setTinst( this.getSysmod().getUsr().getTinst());
			this.getUsrgrp().getRec().setUsrnum( this.getSysmod().getUsr().getUsrnum());
			this.getUsrgrp().getRec().setTel( this.getSysmod().getUsr().getTel());
			this.getUsrgrp().getRec().setEml( this.getSysmod().getUsr().getEml());
			this.getUsrgrp().getRec().setTpersoncode( this.getSysmod().getUsr().getTpersoncode());
			

			return true;
        }









}