package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FmtdtlVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fmpp;
import com.ceb.gjjs.mda.manager.module.Qrtmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Smpmod;
import com.ceb.gjjs.mda.manager.module.Fmtgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 境内外币报文详情
*/
@Transaction(vo= FmtdtlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fmtdtl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fmtdtl.class);

        //数据流
        private IStream filstm = new StreamImpl();
		@BDGetter
		private Fmtgrp fmtgrp;

		@BDGetter
		private Fmpp fmpp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Qrtmod qrtmod;

		@BDGetter
		private Smpmod smpmod;


		public Fmtdtl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFmpp().setFmtgrpHolder(()->this.getFmtgrp());
        }

        /**
        *   source:fmtdtl.@0001.script
        */
        @Rule(target="fmpp.sigsel",order=100)
        public boolean ruleFmppSigselN100(){
            IContext ctx = MdaEnv.getContext();
            
			//调用接口平台，传递参数类型Object[]
			/*String result = null;
			  Object[] usr = new Object[3];
			  usr[0] = "0023";//任务号
			  String inr = Platform.sdbCounter("FMT023","000000");//报文序号
			  int dbInr = Platform.parseInt(inr);
			  dbInr = dbInr +1;
			  usr[1] = String.format("%06d",dbInr);*/

			Map<String,Object> map = new HashMap<String,Object>();
			map.put("PCODE","100010");
			map.put("FMTTYP","023");
			map.put("SENDLT","PSBCCNBJAXXX");//发报行行号
			String bic = this.getFmtgrp().getMpi().getSndbic();
			String ls = bic.substring(0,8)+"A"+bic.substring(8);
			map.put("RECVLT",ls);//收报行行号
			map.put("SEQNO","F" + MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS"));//数字签名查询序号
			String dattim = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			map.put("VAL_DATE",dattim);//委托日期，当前日期
			map.put("QUERY_CLEARING_BANK","PSBCCNBJXXX");//查询清算行
			map.put("RESPONSE_CLEARING_BANK",bic);//答复清算行
			String dat1 = MdaUtils.format(this.getFmtgrp().getMpi().getGendat(),"yyyyMMdd");
			map.put("ORI_VAL_DATE",dat1);//原委托日期
			map.put("ORI_SEND_BANK",this.getFmtgrp().getMpi().getSndbic());//原发报行
			map.put("ORI_FMTTYP",this.getFmtgrp().getMpi().getSubtyp());//原FMT报文类型
			String seq = this.getFmtgrp().getMpi().getOthref();
			if(MdaUtils.isEmpty(seq))
			{
			  seq = this.getFmtgrp().getMpi().getOwnref();
			}
			map.put("ORI_SEQNO",seq);//原支付交易序号
			
			String dtl = this.getFmtgrp().getMpi().getCur();
			BigDecimal amt = this.getFmtgrp().getMpi().getAmt();
			amt = amt.setScale(2,1);
			String str = amt.toString().replace(".",",");
			map.put("CA",dtl.concat(str));//原货币符号金额
			map.put("POSTSCRIPT","数字签名查询报文");//
			this.getFmpp().setMsgdtl(NULLSTR);
			//map信息
			this.getFmpp().setMap(map);
			this.getFmpp().setMsgdtl( this.getSmpmod().packageFmt(map));
			//弹出报文内容面板
			
			/* usr[2] = map;
			
			  Object rtn = Platform.invoke("com.brilliance.eibs.main.Client","scall","PackageFmt","023",usr);
			  Boolean msg = (Boolean)Platform.invoke(rtn,"isSuccess");
			  log.debug("msg-------"+msg);
			  if(!msg)
			  {
			  Platform.message(#CT000000,#CT000001);
			  return false;
			  }
			  //获取接口平台返回的内容
			  Object data = Platform.invoke(rtn,"getContent");//报文内容
			  log.debug("return msg："+data);
			  //存储报文内容至指定目录，并生成mps，mpi，smh信息
			  if(!$this.storeMsgFromPlat(data))
			  {
			  Platform.message(#CT000008,#CT000009);
			  return false;
			  }
			  else
			  {
			  Platform.message(#CT000112,#CT000113);
			  Platform.returnToCaller();
			  }*/

			return true;
        }

        /**
        *   source:fmtdtl.@0002.script
        */
        @Rule(target="fmpp.sigrtn",order=100)
        public boolean ruleFmppSigrtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//生成数字签名查复报文FMT024
			//调用接口平台，传递参数类型Object[]
			/*log.info("generate 024 message");
			  String result = null;
			  Object[] usr = new Object[3];
			  usr[0] = "0024";//任务号
			  String inr = Platform.sdbCounter("FMT024","000000");//报文序号
			  int dbInr = Platform.parseInt(inr);
			  dbInr = dbInr + 1;
			  usr[1] = String.format("%06d",dbInr);*/

			Map<String,Object> map = new HashMap<String,Object>();
			map.put("PCODE","100010");
			map.put("FMTTYP","024");
			map.put("SENDLT","PSBCCNBJAXXX");//发报行行号
			String bic = this.getFmtgrp().getMpi().getSndbic();
			String ls = bic.substring(0,8)+"A"+bic.substring(8);
			map.put("RECVLT",ls);//收报行行号
			map.put("SEQNO","F" + MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS"));//数字签名答复序号
			String dattim = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			//Date dat = Platform.parseDate(dattim,"yyyyMMdd");
			map.put("VAL_DATE",dattim);//委托日期
			map.put("RESPONSE_CLEARING_BANK",bic);//答复清算行
			map.put("QUERY_CLEARING_BANK","PSBCCNBJXXX");//查询清算行
			
			String seq = this.getFmtgrp().getMpi().getOthref();
			if(MdaUtils.isEmpty(seq))
			{
			  seq = this.getFmtgrp().getMpi().getOwnref();
			}
			map.put("ORI_SEQNO",seq);//原查询序号
			String dat1 = MdaUtils.format(this.getFmtgrp().getMpi().getGendat(),"yyyyMMdd");
			map.put("ORI_VAL_DATE",dat1);//原查询日期
			//解析原023报文，获取所需信息块
			String path023 = this.getSmpmod().getStoreFileFullPathName(this.getFmtgrp().getSmh().getDocfil(),this.getFmtgrp().getSmh().getDocfxt());
			String path = handle023Msg(path023);
			map.put("Filepath",path);//原报文路径
			//map信息
			this.getFmpp().setMap(map);
			this.getFmpp().setMsgdtl( this.getSmpmod().packageFmt(map));
			//弹出报文内容面板
			
			/*usr[2] = map;
			  Object rtn = Platform.invoke("com.brilliance.eibs.main.Client","scall","PackageFmt","024",usr);
			  Boolean msg = (Boolean)Platform.invoke(rtn,"isSuccess");
			  log.debug("msg-------"+msg);
			  if(!msg)
			  {
			  Platform.message(#CT000002,#CT000003);
			  return false;
			  }
			  //获取接口平台返回的内容
			  Object data = Platform.invoke(rtn,"getContent");//报文内容
			  log.debug("return msg："+data);
			  //存储报文内容至指定目录，并生成mps，mpi，smh信息
			  if(!$this.storeMsgFromPlat(data))
			  {
			  Platform.message(#CT000018,#CT000019);
			  return false;
			  }
			  else
			  {
			  Platform.message(#CT000122,#CT000123);
			  Platform.returnToCaller();
			  }*/

			return true;
        }

        /**
        *   source:fmtdtl.@0004.script
        */
        @Rule(target="fmpp.rtn",order=100)
        public boolean ruleFmppRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:fmtdtl.@0006.script
        */
        @Rule(target="fmpp.snd",order=100)
        public boolean ruleFmppSndN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.prompt(MdaUtils.getI18NString("fmtdtl","CT000030"),MdaUtils.getI18NString("fmtdtl","CT000031")))
			{
			  return true;
			}
			Platform.mdbBegin();
			if(!Platform.sdbLock(this.getFmtgrp().getMps()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000032"),MdaUtils.getI18NString("fmtdtl","CT000033"));
			  return true;
			}
			Platform.mdbRead(this.getFmtgrp().getMps(),new Argument<String>("inr",EQ,this.getFmtgrp().getMps().getInr()));
			if(!"V".equals(this.getFmtgrp().getMps().getSta()))
			{
			  Platform.sdbUnLock(this.getFmtgrp().getMps());
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000034"),MdaUtils.getI18NString("fmtdtl","CT000035"));
			  return true;
			}
			//$fmtgrp\\mps\\smhinr = $this.insertFmtSndnumBeforeSend();
			String prvsta = this.getFmtgrp().getMps().getSta();
			this.getFmtgrp().getMps().setSta( "A");
			this.getFmtgrp().getMps().setLstdattim( MdaUtils.today());
			Platform.mdbUpdate(this.getFmtgrp().getMps());
			log.debug("{}","mps smhinr:"+this.getFmtgrp().getMps().getSmhinr());
			//新建MPE
			MdaUtils.clear(this.getFmtgrp().getMpe());
			this.getFmtgrp().getMpe().setUsr( MdaEnv.getLoginUser());
			this.getFmtgrp().getMpe().setFrmnam( ctx.getTransName());
			this.getFmtgrp().getMpe().setMpsinr( this.getFmtgrp().getMps().getInr());
			this.getFmtgrp().getMpe().setChncod( this.getFmtgrp().getMps().getChncod());
			this.getFmtgrp().getMpe().setNxtchncod( this.getFmtgrp().getMps().getNxtchncod());
			this.getFmtgrp().getMpe().setSmhinr( this.getFmpp().getMdtmod().getSmpmod().getSmh().getInr());
			this.getFmtgrp().getMpe().setNxtsmhinr( this.getFmtgrp().getMps().getSmhinr());
			this.getFmtgrp().getMpe().setDattim( MdaUtils.today());
			this.getFmtgrp().getMpe().setPrvsta( prvsta);
			this.getFmtgrp().getMpe().setSta( this.getFmtgrp().getMps().getSta());
			this.getFmtgrp().getMpe().setTxt( "人工复查境内外币报文通过，进入自动处理");
			this.getFmtgrp().getMpe().setRspsta( this.getFmtgrp().getMps().getRspsta());
			Platform.sdbInsert(this.getFmtgrp().getMpe());
			//若为查询查复报文，新建查询查复处理记录QRE
			log.debug("{}","smpmod smh inr:"+this.getFmpp().getMdtmod().getSmpmod().getSmh().getInr());
			MdaUtils.clear(this.getQrtmod().getRof());
			Platform.mdbRead(this.getQrtmod().getRof(),new Argument("megnum",EQ,this.getFmpp().getMdtmod().getSmpmod().getSmh().getInr()));
			if(!MdaUtils.isEmpty(this.getQrtmod().getRof().getInr()))
			{
			  this.getQrtmod().createQreInfo(this.getQrtmod().getRof().getCasnum(),"境内外币报文复核通过","X");
			  String rem = this.getQrtmod().getRof().getRem();
			  String newrem = rem + ";境内外币报文复核通过";
			  log.debug("{}","fmtdtl.更新rof"+newrem);
			  this.getQrtmod().getRof().setRem( newrem);
			  this.getQrtmod().getRof().setMegnum( this.getFmtgrp().getMps().getSmhinr());//经过格式转化后，最终发出报文的smhinr
			  Platform.mdbUpdate(this.getQrtmod().getRof());
			}
			else
			{
			  ctx.getErrorCode();//清除dbRead查询无记录时的errorcode:228
			}
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000036"),MdaUtils.getI18NString("fmtdtl","CT000037"));
			  Platform.mdbCommit();
			  Platform.sdbUnLock(this.getFmtgrp().getMps());
			  ctx.storeData("pcdsta","Y");
			  
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000038"),MdaUtils.getI18NString("fmtdtl","CT000039"));
			  Platform.mdbRollback();
			  Platform.sdbUnLock(this.getFmtgrp().getMps());
			}

			return true;
        }

        /**
        *   source:fmtdtl.@0007.script
        */
        @Rule(target="fmpp.giv",order=100)
        public boolean ruleFmppGivN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.prompt(MdaUtils.getI18NString("fmtdtl","CT000050"),MdaUtils.getI18NString("fmtdtl","CT000051")))
			{
			  return true;
			}
			Platform.mdbBegin();
			if(!Platform.sdbLock(this.getFmtgrp().getMps()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000052"),MdaUtils.getI18NString("fmtdtl","CT000053"));
			  return true;
			}
			Platform.mdbRead(this.getFmtgrp().getMps(),new Argument<String>("inr",EQ,this.getFmtgrp().getMps().getInr()));
			if(!"V".equals(this.getFmtgrp().getMps().getSta()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000054"),MdaUtils.getI18NString("fmtdtl","CT000055"));
			  Platform.sdbUnLock(this.getFmtgrp().getMps());
			  return true;
			}
			this.getFmtgrp().getMps().setSta( "G");
			this.getFmtgrp().getMps().setNxtsta( "G");
			this.getFmtgrp().getMps().setNxtchncod( "");
			this.getFmtgrp().getMps().setTgtchncod( "");
			this.getFmtgrp().getMps().setLstdattim( MdaUtils.today());
			Platform.mdbUpdate(this.getFmtgrp().getMps());
			//新建MPE
			this.getFmtgrp().getMpe().setUsr( MdaEnv.getLoginUser());
			this.getFmtgrp().getMpe().setFrmnam( ctx.getTransName());
			this.getFmtgrp().getMpe().setMpsinr( this.getFmtgrp().getMps().getInr());
			this.getFmtgrp().getMpe().setChncod( this.getFmtgrp().getMps().getChncod());
			this.getFmtgrp().getMpe().setSmhinr( this.getFmtgrp().getMps().getSmhinr());
			this.getFmtgrp().getMpe().setDattim( MdaUtils.today());
			this.getFmtgrp().getMpe().setPrvsta( "V");
			this.getFmtgrp().getMpe().setTxt( "人工复查境内外币报文时丢弃");
			this.getFmtgrp().getMpe().setSta( this.getFmtgrp().getMps().getSta());
			Platform.sdbInsert(this.getFmtgrp().getMpe());
			//若为查询查复报文，新建查询查复处理记录QRE
			MdaUtils.clear(this.getQrtmod().getRof());
			Platform.mdbRead(this.getQrtmod().getRof(),new Argument("megnum",EQ,this.getFmtgrp().getMps().getSmhinr()));
			if(!MdaUtils.isEmpty(this.getQrtmod().getRof().getInr()))
			{
			  this.getQrtmod().createQreInfo(this.getQrtmod().getRof().getCasnum(),"境内外币报文复核丢弃","X");
			  String rem = this.getQrtmod().getRof().getRem();
			  String newrem = rem + ";境内外币报文复核丢弃";
			  log.debug("{}","fmtdtl.更新rof"+newrem);
			  this.getQrtmod().getRof().setRem( newrem);
			  Platform.mdbUpdate(this.getQrtmod().getRof());

			  MdaUtils.clear(this.getQrtmod().getQrd());
			  Platform.mdbRead(this.getQrtmod().getQrd(),new Argument("casnum",this.getQrtmod().getRof().getCasnum()));
			  if(!MdaUtils.isEmpty(this.getQrtmod().getQrd().getInr()))
			  {
			    this.getQrtmod().getQrd().setCassta( "B");
			    Platform.mdbUpdate(this.getQrtmod().getQrd());
			  }
			}
			else
			{
			  ctx.getErrorCode();//清除查询无记录时的errorcode
			}
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000056"),MdaUtils.getI18NString("fmtdtl","CT000057"));
			  Platform.mdbCommit();
			  Platform.sdbUnLock(this.getFmtgrp().getMps());
			  ctx.storeData("pcdsta","Y");
			  
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000058"),MdaUtils.getI18NString("fmtdtl","CT000059"));
			  Platform.mdbRollback();
			  Platform.sdbUnLock(this.getFmtgrp().getMps());
			}

			return true;
        }

        /**
        *   source:fmtdtl.@0008.script
        */
        @Rule(target="fmpp.rtnedt",order=100)
        public boolean ruleFmppRtnedtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.prompt(MdaUtils.getI18NString("fmtdtl","CT000100"),MdaUtils.getI18NString("fmtdtl","CT000101")))
			{
			  return true;
			}
			Platform.mdbBegin();
			if(!Platform.sdbLock(this.getFmtgrp().getMps()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000102"),MdaUtils.getI18NString("fmtdtl","CT000103"));
			  return true;
			}
			Platform.mdbRead(this.getFmtgrp().getMps(),new Argument<String>("inr",EQ,this.getFmtgrp().getMps().getInr()));
			if(!"V".equals(this.getFmtgrp().getMps().getSta()))
			{
			  Platform.sdbUnLock(this.getFmtgrp().getMps());
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000104"),MdaUtils.getI18NString("fmtdtl","CT000105"));
			  return true;
			}
			this.getFmtgrp().getMps().setSta( "C"); //退回编辑
			//$fmtgrp\\mps\\nxtsta = "V";
			this.getFmtgrp().getMps().setNxtchncod( "HWE");
			this.getFmtgrp().getMps().setTgtchncod( "");
			this.getFmtgrp().getMps().setLstdattim( MdaUtils.today());
			Platform.mdbUpdate(this.getFmtgrp().getMps());
			//新建MPE
			this.getFmtgrp().getMpe().setUsr( MdaEnv.getLoginUser());
			this.getFmtgrp().getMpe().setFrmnam( ctx.getTransName());
			this.getFmtgrp().getMpe().setMpsinr( this.getFmtgrp().getMps().getInr());
			this.getFmtgrp().getMpe().setChncod( this.getFmtgrp().getMps().getChncod());
			this.getFmtgrp().getMpe().setNxtchncod( this.getFmtgrp().getMps().getNxtchncod());
			this.getFmtgrp().getMpe().setSmhinr( this.getFmtgrp().getMps().getSmhinr());
			this.getFmtgrp().getMpe().setDattim( MdaUtils.today());
			this.getFmtgrp().getMpe().setPrvsta( "V");
			this.getFmtgrp().getMpe().setSta( this.getFmtgrp().getMps().getSta());
			this.getFmtgrp().getMpe().setTxt( "人工复查境内外币报文时退回报文编辑");
			this.getFmtgrp().getMpe().setRspsta( this.getFmtgrp().getMps().getRspsta());
			Platform.sdbInsert(this.getFmtgrp().getMpe());
			//若为查询查复报文，新建查询查复处理记录QRE
			MdaUtils.clear(this.getQrtmod().getRof());
			Platform.mdbRead(this.getQrtmod().getRof(),new Argument("megnum",EQ,this.getFmtgrp().getMps().getSmhinr()));
			if(!MdaUtils.isEmpty(this.getQrtmod().getRof().getInr()))
			{
			  this.getQrtmod().createQreInfo(this.getQrtmod().getRof().getCasnum(),"境内外币报文复核退回编辑","X");
			  MdaUtils.clear(this.getQrtmod().getQrd());
			  Platform.mdbRead(this.getQrtmod().getQrd(),new Argument("casnum",this.getQrtmod().getRof().getCasnum()));
			  if(!MdaUtils.isEmpty(this.getQrtmod().getQrd().getInr()))
			  {
			    this.getQrtmod().getQrd().setCassta( "B");
			    Platform.mdbUpdate(this.getQrtmod().getQrd());
			  }
			}
			else
			  ctx.getErrorCode();//清除查询无记录时的errorcode
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000106"),MdaUtils.getI18NString("fmtdtl","CT000107"));
			  Platform.mdbCommit();
			  if(!Platform.sdbUnLock(this.getFmtgrp().getMps()))
			  {
			    log.debug("{}","sdbunlock failed...");
			  }
			  ctx.storeData("pcdsta","Y");
			  
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000108"),MdaUtils.getI18NString("fmtdtl","CT000109"));
			  Platform.mdbRollback();
			  Platform.sdbUnLock(this.getFmtgrp().getMps());
			}

			return true;
        }

        /**
        *   source:fmtdtl.@0009.script
        */
        @Rule(target="fmpp.chksig",order=100)
        public boolean ruleFmppChksigN100(){
            IContext ctx = MdaEnv.getContext();
            
			//核对收到024查复签名内容和原报文签名内容
			
			this.getFmpp().setNewtxt(NULLSTR);
			this.getFmpp().setOldtxt(NULLSTR);
			this.getFmpp().setNewtxt( this.getFmpp().getMdtmod().getMsgdtl());
			

			MdaUtils.clear(this.getFmtgrp().getOrimpi());
			MdaUtils.clear(this.getFmtgrp().getOrimps());
			MdaUtils.clear(this.getFmtgrp().getOrismh());
			String own = this.getFmtgrp().getMpi().getOwnref();//关联编号
			Argument arg = new Argument("ownref",own);
			arg = arg.and(new Argument("subtyp",NE,"023"));
			arg = arg.and(new Argument("subtyp",NE,"024"));
			Platform.mdbRead(this.getFmtgrp().getOrimpi(),arg);
			if(!MdaUtils.isEmpty(this.getFmtgrp().getOrimpi().getInr()))
			{
			  Platform.mdbRead(this.getFmtgrp().getOrimps(),new Argument<String>("inr",EQ,this.getFmtgrp().getOrimpi().getInr()));
			  String smhinr = this.getFmtgrp().getOrimps().getSmhinr();
			  Platform.mdbRead(this.getFmtgrp().getOrismh(),new Argument<String>("inr",EQ,smhinr));
			  String path = this.getFmpp().getMdtmod().getSmpmod().getStoreFileFullPathName(this.getFmtgrp().getOrismh().getDocfil(),this.getFmtgrp().getOrismh().getDocfxt());
			  log.debug("{}",path);
			  if(!MdaUtils.isEmpty(path))
			  {
			    log.debug("{}","打印原数字签名报文内容...");
			    String msg = getSwfMsg(path);
			    this.getFmpp().setOldtxt(msg);
			    this.getFmpp().getMdtmod().setMsg(msg);//保存获取到的报文原文
			    log.trace("{}",msg);
			  }
			}

			return true;
        }

        /**
        *   source:fmtdtl.@0011.script
        */
        @Rule(target="fmpp.qur",order=100)
        public boolean ruleFmppQurN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:fmtdtl.@0014.script
        */
        @Rule(target="fmpp.sur",order=100)
        public boolean ruleFmppSurN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.clearDatafield(MdaDriver.getDatafield(this,"filstm"));

			//$smpmod.transfromStringToStream($fmpp\\msgdtl.getValue(),$filstm.getValue());
			String msg = this.getFmpp().getMsgdtl();
			if(msg.indexOf("\r")<0 && msg.indexOf("\n")>=0)
			{
			  msg = msg.replaceAll("\n","\r\n");
			}
			this.getSmpmod().transfromStringToStream(msg,this.getFilstm());

			Platform.mdbBegin();
			//保存报文信息
			Map<String,Object> map = (Map<String,Object>)this.getFmpp().getMap();
			//String trnref = (String)map.get("SEQNO");
			//$smpmod.txtCreateMpsAndMpiForAuto($filstm.getValue(),"AUT",trnref,"手工生成数字签名管理报文");
			this.getSmpmod().txtCreateMpsAndMpiForAuto(this.getFilstm(),"AUT","手工生成数字签名管理报文");
			Platform.mdbCommit();
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000150"),MdaUtils.getI18NString("fmtdtl","CT000151"));
			  log.debug("{}","dbCommit error...");
			  return false;
			}
			log.debug("{}","message save successfull...");
			ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000152"),MdaUtils.getI18NString("fmtdtl","CT000153"));
			


			return true;
        }



        /**
        *   source:fmtdtl.@0000.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			String mpsinr = (String)ctx.restoreData("inr");
			log.debug("{}","mpsinr is "+mpsinr);
			Platform.mdbRead(this.getFmtgrp().getMps(),new Argument<String>("inr",EQ,mpsinr));
			Platform.mdbRead(this.getFmtgrp().getMpi(),new Argument<String>("inr",EQ,mpsinr));
			String smhinr = this.getFmtgrp().getMps().getSmhinr();
			Platform.mdbRead(this.getFmtgrp().getSmh(),new Argument<String>("inr",EQ,smhinr));
			log.debug("{}","md5: "+this.getFmtgrp().getSmh().getDocmd5());
			/*Platform.invisible($fmpp\\resend);
			  if("E".equals($fmtgrp\\mps\\sta.getValue()))
			  Platform.visible($fmpp\\resend);
			  */
			this.getFmpp().getMdtmod().initMdt(this.getFmtgrp().getSmh().getInr());
			
			
			
			
			
			

			if("V".equals(this.getFmtgrp().getMps().getSta()))
			{
			  
			  
			  
			}
			if("1".equals(this.getFmtgrp().getMps().getFlg())&&">".equals(this.getFmtgrp().getMps().getDir()))
			{
			  //发起数字签名查询023
			  //Platform.visible($fmpp\\sigrtn);
			}
			if("023".equals(this.getFmtgrp().getMpi().getSubtyp())&&">".equals(this.getFmtgrp().getMps().getDir()))//收023查询，返回查复报文
			{
			  //Platform.visible($fmpp\\sigsel);
			  
			}
			/*if("024".equals($fmtgrp\\mpi\\subtyp.getValue())&&">".equals($fmtgrp\\mps\\dir.getValue()))//收024查复，对比签名内容
			  {
			  //Platform.visible($fmpp\\sigsel);
			  Platform.visible($fmpp\\chksig);
			  }*/

			return true;
        }


        /**
        *   source:fmtdtl.@0005.script
        */
        public boolean storeMsgFromPlat(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			//IStream is = new IStream(str.getBytes("GB18030"));//String转换为IStream流
			Platform.mdbBegin();
			MdaUtils.clear(this.getFmpp().getMdtmod().getSmpmod().getFilstm());
			IStream is = this.getFmpp().getMdtmod().getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GB18030"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getFmpp().getMdtmod().getSmpmod().createMessageProcessSubjectForMan(is,"HWE","txt","FMT","境内外币数字签名管理待审核报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  log.debug("{}","fmtdtl smhinr:"+this.getFmpp().getMdtmod().getSmpmod().getSmh().getInr());
			  log.debug("{}","mps inr:"+this.getFmpp().getMdtmod().getSmpmod().getMps().getInr());
			  String fileName = this.getFmpp().getMdtmod().getSmpmod().getStoreFileFullPathName(this.getFmpp().getMdtmod().getSmpmod().getSmh().getDocfil(),this.getFmpp().getMdtmod().getSmpmod().getSmh().getDocfxt());
			  log.debug("{}","fileName:"+fileName);
			  if(!Platform.mfileExists(fileName))
			  { // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			    log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			    this.getFmpp().getMdtmod().getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getFmpp().getMdtmod().getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			    return false;
			  }
			  MdaUtils.clear(this.getFmpp().getMdtmod().getSmpmod().getMpi());
			  
			  if(!this.getFmpp().getMdtmod().getSmpmod().txtCreateMessageInformation(fileName,"txt"))
			  {
			    log.debug("{}","store mpi failed");
			    return false;
			  }
			}
			int errorCode = ctx.getErrorCode();
			if(errorCode == NO_ERROR)
			{
			  Platform.mdbCommit();
			  log.debug("{}","fmtdtl commit... ");
			}
			else
			{
			  Platform.mdbRollback();
			  return false;
			}
			return true;
		}
        /**
        *   source:fmtdtl.@0010.script
        */
        public String getSwfMsg(String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(pth == null)
			  return null;
			Object obj = MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsg",pth);
			if(obj == null)
			  return null;
			else
			  return obj.toString();
		}
        /**
        *   source:fmtdtl.@0013.script
        */
        public String insertFmtSndnumBeforeSend()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 注：这里很特殊，非正常的格式转换（正常格式转换通过相应状态变迁实现）
			String nextSmhInr = Platform.sdbCounter("smh");
			String sendNumber = "GJZFQZ" + nextSmhInr;
			//String orgFileName = $fmpp\\mdtmod\\smpmod.getMessageFullPathName();
			String orgFileName = this.getFmpp().getMdtmod().getSmpmod().getStoreFileFullPathName(
			  this.getFmpp().getMdtmod().getSmh().getDocfil(),this.getFmpp().getMdtmod().getSmh().getDocfxt());
			log.debug("{}","txt orgFileName:"+orgFileName);
			MdaUtils.clear(this.getFmpp().getMdtmod().getSmpmod().getFilstm());
			Object result=MdaUtils.invoke("cn.com.brilliance.eibs.SwiftUtils","insertSendNumber",orgFileName,this.getFmpp().getMdtmod().getSmpmod().getFilstm(),sendNumber);
			if(result instanceof Boolean && (Boolean)result)
			{
			  /// 记录MPE处理信息
			  /*
			    Platform.clear($mpe);
			    $mpe\\mpsinr = $mps\\inr;
			    $mpe\\chncod = $mps\\chncod;
			    $mpe\\nxtchncod = $mps\\chncod;
			    $mpe\\smhinr = $smh\\inr;
			    $mpe\\nxtsmhinr = nextSmhInr;
			    $mpe\\dattim = new Date();
			    $mpe\\prvsta = $mps\\sta;
			    $mpe\\sta =  "A";
			    $mpe\\txt = "自动添加FMT报文发送流水号.";
			    $mpe\\usr = Platform.getLoginUser();
			    $mpe\\frmnam = Platform.getTransName();
			    Platform.sdbInsert($mpe);
			    */
			  /// 记录SMH信息
			  MdaUtils.clear(this.getFmpp().getMdtmod().getSmpmod().getNxtsmh());
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setInr( nextSmhInr);
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setObjtyp( "mpe");
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setObjinr( this.getFmpp().getMdtmod().getSmpmod().getMpe().getInr());
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setCrtfrm( ctx.getTransName());
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setDattim( new Date());
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setDocpth( this.getFmpp().getMdtmod().getSmpmod().getDatapath());
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setDocfil( nextSmhInr);
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setDocfxt( "txt");
			  String nextFileName = this.getFmpp().getMdtmod().getSmpmod().getStoreFileFullPathName(nextSmhInr,"txt");
			  Platform.mstreamSave(this.getFmpp().getMdtmod().getSmpmod().getFilstm(),nextFileName);
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			  this.getFmpp().getMdtmod().getSmpmod().getNxtsmh().setMpiinr( this.getFmpp().getMdtmod().getSmpmod().getMpi().getInr());
			  Platform.mdbInsert(this.getFmpp().getMdtmod().getSmpmod().getNxtsmh());
			  /// 更新MPS信息（Update在unlock为执行）
			  //$mps\\smhinr = nextSmhInr;
			  //Platform.mdbUpdate($mps);
			  /// 更新MPI信息
			  this.getFmpp().getMdtmod().getSmpmod().getMpi().setSndnum( sendNumber);
			  log.debug("{}","Fmt mpi sndnum:"+this.getFmpp().getMdtmod().getSmpmod().getMpi().getSndnum());
			  Platform.mdbUpdate(this.getFmpp().getMdtmod().getSmpmod().getMpi());
			}
			/*if(Platform.errorCode() == NO_ERROR)
			  {
			  log.debug("insertFmtSndnumBeforeSend commit no error...");
			  return true;
			  }
			  else
			  {
			  log.debug("insertFmtSndnumBeforeSend commit error...");
			  return false;
			  }*/
			log.debug("{}","insertFmtSndnumBeforeSend errorcode:"+ctx.getErrorCode());
			return nextSmhInr;
		}
        /**
        *   source:fmtdtl.@0015.script
        */
        public String handle023Msg(String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(path))
			{
			  log.info("{}","路径为空");
			  return null;
			}
			Object[] filname = new Object[1];
			filname[0] = path;
			Object object = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","HandleFmt","HandleFmt",filname);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000236"),MdaUtils.getI18NString("fmtdtl","CT000237"));
			  return null;
			}
			//获取接口平台返回的内容
			Object[] objs = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			log.debug("{}","报文内容: "+objs);
			Object[] objs1 = (Object[])objs;
			Map<String,String> map0 = (Map<String,String>)objs1[0];
			log.debug("{}","map0:"+map0);
			Map<String,String> map1 = (Map<String,String>)objs1[1];
			log.debug("{}","map1:"+map1);
			ctx.storeData("map1",map1);
			Map<String,String> map2 = (Map<String,String>)objs1[2];
			log.debug("{}","map2:"+map2);
			ctx.storeData("map2",map2);
			List<List> lst = (List<List>)objs1[3];
			log.debug("{}","lst:"+lst);

			String own = (String)map2.get("/D90/");//原支付交易序号
			String typ = (String)map2.get("/F31/");//原报文类型
			
			Argument arg = new Argument("ownref",own);
			/*arg = arg.or(new Argument("othref",$fmtgrp\\mpi\\ownref.getValue()));
			  arg = arg.or(new Argument("othref",$fmtgrp\\mpi\\othref.getValue()));
			  arg = arg.or(new Argument("ownref",$fmtgrp\\mpi\\othref.getValue()));
			  Argument argnam = arg.and(new Argument("subtyp",NE,"023"));
			  argnam = argnam.and(new Argument("subtyp",NE,"024"));*/
			arg = arg.and(new Argument("dir","<"));//对于原汇出类报文的签名回复
			arg = arg.and(new Argument("subtyp",typ));
			MdaUtils.clear(this.getFmtgrp().getOrimpi());
			Platform.mdbRead(this.getFmtgrp().getOrimpi(),arg);
			String rtnPth = null;
			if(!MdaUtils.isEmpty(this.getFmtgrp().getOrimpi().getInr()))
			{
			  Platform.sdbRead(this.getFmtgrp().getOrimps(),this.getFmtgrp().getOrimpi().getInr());
			  if(!MdaUtils.isEmpty(this.getFmtgrp().getOrimps().getSmhinr()))
			    Platform.sdbRead(this.getFmtgrp().getOrismh(),this.getFmtgrp().getOrimps().getSmhinr());
			  if(!MdaUtils.isEmpty(this.getFmtgrp().getOrismh().getInr()))
			  {
			    rtnPth = this.getSmpmod().getStoreFileFullPathName(this.getFmtgrp().getOrismh().getDocfil(),this.getFmtgrp().getOrismh().getDocfxt());
			  }
			  else
			  {
			    ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000238"),MdaUtils.getI18NString("fmtdtl","CT000239"));
			    rtnPth = null;
			  }
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("fmtdtl","CT000240"),MdaUtils.getI18NString("fmtdtl","CT000241"));
			  return null;
			}
			return rtnPth;
		}







}