package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.MsgdtlVO;

import com.ceb.gjjs.mda.manager.module.Mdtp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Msggrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 报文原文展示
*/
@Transaction(vo= MsgdtlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Msgdtl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Msgdtl.class);

		@BDGetter
		private Msggrp msggrp;

		@BDGetter
		private Mdtp mdtp;

		@BDGetter
		private Sysmod sysmod;


		public Msgdtl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMdtp().setMsggrpHolder(()->this.getMsggrp());
        }

        /**
        *   source:msgdtl.@0001.script
        */
        @Rule(target="mdtp.mdtmod.g990btn",order=100)
        public boolean ruleMdtpMdtmodG990btnN100(){
            IContext ctx = MdaEnv.getContext();
            
			showSweMessage("990");

			return true;
        }

        /**
        *   source:msgdtl.@0004.script
        */
        @Rule(target="mdtp.mdtmod.g930btn",order=100)
        public boolean ruleMdtpMdtmodG930btnN100(){
            IContext ctx = MdaEnv.getContext();
            
			showSweMessage("");

			return true;
        }

        /**
        *   source:msgdtl.@0005.script
        */
        @Rule(target="mdtp.mdtmod.g900btn",order=100)
        public boolean ruleMdtpMdtmodG900btnN100(){
            IContext ctx = MdaEnv.getContext();
            
			showSweMessage("900");

			return true;
        }



        /**
        *   source:msgdtl.@0000.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			//20190106新加判断
			
			
			Object nam = ctx.restoreData("namecaller");
			if(!MdaUtils.isEmpty(nam))
			{
			  String frmnam = (String)nam;
			  this.getMdtp().getMdtmod().setFrmnam(frmnam);
			  log.info("{}","上一交易为:"+frmnam);
			  if("gcvsel".equals(frmnam) || "gndsel".equals(frmnam) || "ggvsel".equals(frmnam) || "pndsel".equals(frmnam))
			  {
			    
			  }
			  else
			  {
			    
			  }
			}
			else
			{
			  
			}
			String mpsinr = (String)ctx.restoreData("mpsinr");
			log.debug("{}","mpsinr is "+mpsinr);
			this.getMdtp().getMdtmod().getSmpmod().getMps().setInr( mpsinr);
			Platform.mdbRead(this.getMsggrp().getMps(),new Argument<String>("inr",EQ,mpsinr));
			Platform.mdbRead(this.getMsggrp().getMpi(),new Argument<String>("inr",EQ,mpsinr));
			if(MdaUtils.isEmpty(this.getMsggrp().getMpi().getUetr()))
			{
			  
			}
			String smhinr = this.getMsggrp().getMps().getSmhinr();
			Platform.mdbRead(this.getMsggrp().getSmh(),new Argument<String>("inr",EQ,smhinr));
			log.debug("{}","md5: "+this.getMsggrp().getSmh().getDocmd5());
			
			if("E".equals(this.getMsggrp().getMps().getSta()))
			  

			if(!("SWE".equals(this.getMsggrp().getMps().getSrcchncod()) || "SWE".equals(this.getMsggrp().getMps().getTgtchncod())))
			{
			  
			  
			  
			}

			return true;
        }


        /**
        *   source:msgdtl.@0002.script
        */
        public void showSweMessage(String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			try
			{
			  this.getMdtp().getMdtmod().setSwemsg(NULLSTR);
			  this.getMdtp().getMdtmod().setSweencmsg(NULLSTR);
			  String msg = loadSweMessage(messageType,true);
			  //log.debug("showSweMessage:" + msg);
			  String encMsg = loadSweMessage(messageType,false);
			  this.getMdtp().getMdtmod().setSwemsg( msg);
			  this.getMdtp().getMdtmod().setSweencmsg( encMsg);
			  
			  
			  
			}
			catch(Exception e)
			{
			  log.error("{}",e);
			}
		}
        /**
        *   source:msgdtl.@0003.script
        */
        public String loadSweMessage(String messageType, boolean origMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String path = this.getMdtp().getMdtmod().getMsgpth();
			log.debug("{}","[SF2 MESSAGE PATH]:"+path);
			if("930".equals(messageType))
			  messageType = "";
			if(origMsg)
			{
			  path = path.replace(".sf2",".gisp" + messageType);
			}
			else
			{
			  path = path.replace(".sf2",".gisp" + messageType + "x");
			}
			log.debug("{}","[MESSAGE PATH]:"+path);
			if(!MdaUtils.fileExists(path))
			{
			  //调用接口平台或JAVA方法获取文件服务器上;对应目录的文件
			  log.debug("{}","getMessageFromFileServer:" + path);
			  if(MdaUtils.isEmpty(this.getSysmod().getMessageFromFileTransfer(path)))
			  {
			    log.error("{}","报文文件不存在:" + path);
			    return "";
			  }
			}

			IStream is = this.getMdtp().getMdtmod().getSwemsgstm();
			MdaUtils.streamClear(is);
			Platform.mstreamLoad(is,path);
			return Platform.convertIStream2String(is);
		}




}