package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.PbtaddVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Smpmod;
import com.ceb.gjjs.mda.manager.module.Pbtp;
import com.ceb.gjjs.mda.manager.module.Pbtgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 行号信息新增
*/
@Transaction(vo= PbtaddVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Pbtadd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Pbtadd.class);

		@BDGetter
		private Pbtgrp pbtgrp;

		@BDGetter
		private Pbtp pbtp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Smpmod smpmod;


		public Pbtadd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getPbtp().setPbtgrpHolder(()->this.getPbtgrp());
        }

        /**
        *   source:pbtadd.@0000.script
        */
        @Rule(target="pbtp.ret",order=100)
        public boolean rulePbtpRetN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:pbtadd.@0001.script
        */
        @Rule(target="pbtp.add",order=100)
        public boolean rulePbtpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getPbtp()))
			  return false;
			Object[] obj = new Object[8];
			obj[0] = "0083";
			//obj[1] = (Object)Platform.sdbCounter("FMT083","000000");
			String inr = Platform.sdbCounter("FMT083","000000");
			int dbInr = MdaUtils.parseInt(inr);
			dbInr = dbInr +1;
			obj[1] = String.format("%06d",dbInr);
			obj[2] = (Object)("F"+MdaUtils.format(MdaUtils.today(),"yyMMddhhmmssSSS"));
			//obj[3] = (Object)Platform.format(Platform.today(),"yyyyMMdd");
			obj[3] = (Object)MdaUtils.format(this.getPbtp().getGendat(),"yyyyMMdd");
			obj[4] = "PSBCCNBJXXX";
			//obj[5] = Platform.sdbCounter("JJCYZHHBGSQ","00000000");//间接参与者行号变更申请
			String bgsInr = Platform.sdbCounter("JJCYZHHBGSQ","00000000");
			int bgInr = MdaUtils.parseInt(bgsInr);
			bgInr = bgInr +1;
			obj[5] = String.format("%08d",bgInr);
			obj[6] = "1";
			String[][] str = new String[1][13];
			str[0][0] = this.getPbtp().getBnkbic();
			str[0][1] = this.getPbtp().getBnknam();
			str[0][2] = this.getPbtp().getBnkallnam();
			str[0][3] = this.getPbtp().getBnkadr();
			str[0][4] = this.getPbtp().getTel();
			str[0][5] = this.getPbtp().getNam();
			str[0][6] = this.getPbtp().getZipcod();
			str[0][7] = this.getPbtp().getEmail();
			str[0][8] = "1";//1 新增 ，2 撤销，3 变更
			str[0][9] = this.getPbtp().getPvccod();
			str[0][10] = this.getPbtp().getCtycod();
			str[0][11] = this.getPbtp().getPtycod();
			if(!MdaUtils.isEmpty(this.getPbtp().getRem()))
			{
			  str[0][12] = this.getPbtp().getRem();
			}
			else
			  str[0][12] = "";
			obj[7] = str;

			Object rtnMsg = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","PackageFmt","083",obj);
			Boolean msg = (Boolean)MdaUtils.invoke(rtnMsg,"isSuccess");
			log.debug("{}","msg-------"+msg);
			if(!msg)
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtadd","CT000044"),MdaUtils.getI18NString("pbtadd","CT000045"));
			  return false;
			}
			//获取接口平台返回的内容
			Object data = MdaUtils.invoke(rtnMsg,"getContent");//报文内容
			log.debug("{}","data========"+data);
			Platform.mdbBegin();
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			if(!this.storeMsgFromPlat(data))
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtadd","CT000194"),MdaUtils.getI18NString("pbtadd","CT000195"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtadd","CT000196"),MdaUtils.getI18NString("pbtadd","CT000197"));
			  //Platform.returnToCaller();
			}
			this.getPbtgrp().getFxbank().setBic( this.getPbtp().getBnkbic());
			this.getPbtgrp().getFxbank().setBnktyp( "4");//4 间接参与者
			this.getPbtgrp().getFxbank().setHbcod( this.getPbtp().getHbcod());
			this.getPbtgrp().getFxbank().setDirectbic( "PSBCCNBJXXX");
			this.getPbtgrp().getFxbank().setProvcod( this.getPbtp().getPvccod());
			this.getPbtgrp().getFxbank().setCitycod( this.getPbtp().getCtycod());
			this.getPbtgrp().getFxbank().setBnkcod( this.getPbtp().getPtycod());
			this.getPbtgrp().getFxbank().setHafnam( this.getPbtp().getBnknam());
			this.getPbtgrp().getFxbank().setFulnam( this.getPbtp().getBnkallnam());
			this.getPbtgrp().getFxbank().setAddress( this.getPbtp().getBnkadr());
			this.getPbtgrp().getFxbank().setPoscod( this.getPbtp().getZipcod());
			this.getPbtgrp().getFxbank().setPhone( this.getPbtp().getTel());
			this.getPbtgrp().getFxbank().setEmail( this.getPbtp().getEmail());
			this.getPbtgrp().getFxbank().setLnkman( this.getPbtp().getNam());
			if(!MdaUtils.isEmpty(this.getPbtp().getRem()))
			{
			  this.getPbtgrp().getFxbank().setPostscript( this.getPbtp().getRem());
			}
			if(!MdaUtils.isEmpty(this.getSmpmod().getMpi().getInr()))
			{
			  this.getPbtgrp().getFxbank().setRelinr( "pbtadd:"+this.getSmpmod().getMpi().getInr());
			}
			this.getPbtgrp().getFxbank().setTime( MdaUtils.today());
			this.getPbtgrp().getFxbank().setLstupdate( "1");
			this.getPbtgrp().getFxbank().setSta( "00");//未审核
			Platform.sdbInsert(this.getPbtgrp().getFxbank());
			int errcod = ctx.getErrorCode();
			if(errcod != NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtadd","CT000242"),MdaUtils.getI18NString("pbtadd","CT000243"));
			  return false;
			}
			Platform.mdbCommit();
			errcod = ctx.getErrorCode();
			if(errcod != NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtadd","CT000244"),MdaUtils.getI18NString("pbtadd","CT000245"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  //Platform.message(#CT000278,#CT000279);
			  log.debug("{}","间接参与者行号信息存储成功");
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"bnkbic"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"bnknam"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"bnkallnam"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"bnkadr"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"hbcod"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"nam"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"tel"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"zipcod"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"email"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"pvccod"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"ctycod"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"ptycod"));
			  Platform.clearDatafield(MdaDriver.getDatafield(this.getPbtp(),"rem"));
			}

			/*Object[] sndMap = new Object[1];
			  sndMap[0] = data;
			
			  Object rtn = Platform.invoke("com.brilliance.eibs.main.Client","scall","SendFmt","SendFmt",sndMap);
			  Boolean obt = (Boolean)Platform.invoke(rtn,"isSuccess");
			  log.debug("obt-------"+obt);
			  if(!obt)
			  {
			  Platform.message(#CT000322,#CT000323);
			  return false;
			  }
			  //获取接口平台返回的内容
			  Object code = Platform.invoke(rtn,"getContent");//报文内容
			  log.debug("code========"+code);
			  Object[] strcod = (Object[])code;
			  String rspcod = (String)strcod[0];//返回码
			  int errorcode = Platform.errorCode();
			  if(!Platform.isEmpty(rspcod)&&"0000".equals(rspcod))
			  {
			  Platform.mdbBegin();
			  $pbtp\\pbtgrp\\pbt\\bnktyp = "1";//1 间接参与者 0 直接参与者
			  Platform.sdbInsert($pbtp\\pbtgrp\\pbt);
			  int errcod = Platform.errorCode();
			  if(errcod != NO_ERROR)
			  {
			  Platform.message(#CT000324,#CT000325);
			  return false;
			  }
			  Platform.mdbCommit();
			  errcod = Platform.errorCode();
			  if(errcod != NO_ERROR)
			  {
			  Platform.message(#CT000350,#CT000351);
			  return false;
			  }
			  else
			  {
			  Platform.message(#CT000352,#CT000353);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\bnkbic);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\bnknam);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\bnkallnam);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\bnkadr);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\nam);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\tel);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\zipcod);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\email);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\pvccod);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\ctycod);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\ptycod);
			  Platform.clearDatafield($pbtp\\pbtgrp\\pbt\\rem);
			  }
			  }
			  else
			  Platform.message(#CT000354,#CT000355+rspcod);
			  */


			return true;
        }

        /**
        *   source:pbtadd.@0020.script
        */
        @Rule(target="pbtp.ccms916",order=100)
        public boolean rulePbtpCcms916N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getPbtp()))
			  return false;
			Map map = new HashMap();
			map.put("msgFlagNo","");
			map.put("sendTm",MdaUtils.format(MdaUtils.today(),"YYYYMMDDHHMmSs"));
			map.put("instgDrctParty","");
			map.put("instgParty","");
			map.put("instdDrctParty","");
			map.put("instdParty","");
			map.put("sysCode","8888");
			map.put("headerRmk","");
			map.put("loginTypeCode","");

			log.info("{}","916 map = "+map);
			String json=(String)MdaUtils.invoke("com.brilliance.eibs.el.CommonFunctionUtils","toJson",map);

			log.debug("{}","[FXPS_916_JSON]"+json);
			//设置数据库
			Platform.setDefaultDB("swd");
			Platform.mdbBegin();
			if(!this.storeMsgFromPlatForFxps(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtadd","CT000365"),MdaUtils.getI18NString("pbtadd","CT000366"));

			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtadd","CT000367"),MdaUtils.getI18NString("pbtadd","CT000368"));
			}


			return true;
        }


        /**
        *   source:pbtadd.@0002.script
        */
        @Check(target="pbtp.bnkbic",order=100)
        public boolean checkPbtpBnkbicN100(){
            IContext ctx = MdaEnv.getContext();
            
			String str=this.getPbtp().getBnkbic();
			if(MdaUtils.isEmpty(this.getPbtp().getBnkbic()))
			{
			  ctx.setFieldError(this,"pbtp.bnkbic",MdaUtils.getI18NString("pbtadd","CT000210"));
			}
			else if(str.length()<11)
			{
			  ctx.setFieldError(this,"pbtp.bnkbic",MdaUtils.getI18NString("pbtadd","CT000358"));
			}


			return true;
        }

        /**
        *   source:pbtadd.@0003.script
        */
        @Check(target="pbtp.bnknam",order=100)
        public boolean checkPbtpBnknamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getBnknam()))
			  ctx.setFieldError(this,"pbtp.bnknam",MdaUtils.getI18NString("pbtadd","CT000214"));

			return true;
        }

        /**
        *   source:pbtadd.@0004.script
        */
        @Check(target="pbtp.bnkallnam",order=100)
        public boolean checkPbtpBnkallnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getBnkallnam()))
			  ctx.setFieldError(this,"pbtp.bnkallnam",MdaUtils.getI18NString("pbtadd","CT000215"));

			return true;
        }

        /**
        *   source:pbtadd.@0005.script
        */
        @Check(target="pbtp.nam",order=100)
        public boolean checkPbtpNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getNam()))
			  ctx.setFieldError(this,"pbtp.nam",MdaUtils.getI18NString("pbtadd","CT000217"));

			return true;
        }

        /**
        *   source:pbtadd.@0006.script
        */
        @Check(target="pbtp.bnkadr",order=100)
        public boolean checkPbtpBnkadrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getBnkadr()))
			  ctx.setFieldError(this,"pbtp.bnkadr",MdaUtils.getI18NString("pbtadd","CT000218"));

			return true;
        }

        /**
        *   source:pbtadd.@0007.script
        */
        @Check(target="pbtp.ctycod",order=100)
        public boolean checkPbtpCtycodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getCtycod()))
			  ctx.setFieldError(this,"pbtp.ctycod",MdaUtils.getI18NString("pbtadd","CT000220"));

			return true;
        }

        /**
        *   source:pbtadd.@0008.script
        */
        @Check(target="pbtp.pvccod",order=100)
        public boolean checkPbtpPvccodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getPvccod()))
			  ctx.setFieldError(this,"pbtp.pvccod",MdaUtils.getI18NString("pbtadd","CT000221"));

			return true;
        }

        /**
        *   source:pbtadd.@0009.script
        */
        @Check(target="pbtp.ptycod",order=100)
        public boolean checkPbtpPtycodN100(){
            IContext ctx = MdaEnv.getContext();
            
			String str=this.getPbtp().getPtycod();
			if(MdaUtils.isEmpty(this.getPbtp().getPtycod()))
			{
			  ctx.setFieldError(this,"pbtp.ptycod",MdaUtils.getI18NString("pbtadd","CT000224"));
			}
			else if(str.length()<12)
			{
			  ctx.setFieldError(this,"pbtp.ptycod",MdaUtils.getI18NString("pbtadd","CT000359"));
			}


			return true;
        }

        /**
        *   source:pbtadd.@0010.script
        */
        @Check(target="pbtp.zipcod",order=100)
        public boolean checkPbtpZipcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			String str=this.getPbtp().getZipcod();
			if(MdaUtils.isEmpty(this.getPbtp().getZipcod()))
			{
			  ctx.setFieldError(this,"pbtp.zipcod",MdaUtils.getI18NString("pbtadd","CT000225"));
			}
			else if(str.length()<6)
			{
			  ctx.setFieldError(this,"pbtp.zipcod",MdaUtils.getI18NString("pbtadd","CT000360"));
			}

			return true;
        }

        /**
        *   source:pbtadd.@0011.script
        */
        @Check(target="pbtp.email",order=100)
        public boolean checkPbtpEmailN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getEmail()))
			  ctx.setFieldError(this,"pbtp.email",MdaUtils.getI18NString("pbtadd","CT000226"));

			return true;
        }

        /**
        *   source:pbtadd.@0012.script
        */
        @Check(target="pbtp.tel",order=100)
        public boolean checkPbtpTelN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getTel()))
			  ctx.setFieldError(this,"pbtp.tel",MdaUtils.getI18NString("pbtadd","CT000229"));

			return true;
        }


        /**
        *   source:pbtadd.@0019.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getPbtp(),"pvccod",this.getPbtp().getProcodList());
			
			/*String ptyp = "";
			  if(!Platform.isEmpty($pbtp\\pvccod))
			  {
			  ptyp = $pbtp\\pvccod;
			  }
			  log.debug("pvccod: " + ptyp);
			  Platform.setValues($pbtp\\ctycod,$pbtp.getCtycodList(ptyp));
			  Platform.setModified($pbtp\\ctycod);
			  String typ = "";
			  if(!Platform.isEmpty($pbtp\\ctycod))
			  {
			  typ = $pbtp\\ctycod;
			  }
			  log.debug("ctycod: " + typ);
			  Platform.setValues($pbtp\\ptycod,$pbtp.getPtycodList(typ,1));
			  Platform.setModified($pbtp\\ptycod);*/

			return true;
        }


        /**
        *   source:pbtadd.@0013.script
        */
        public boolean storeMsgFromPlat(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GB18030"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubjectForMan(is,"AUT","txt","FMT","行号新增待审核报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  log.debug("{}","faatsk smhinr:"+this.getSmpmod().getSmh().getInr());
			  log.debug("{}","mps inr:"+this.getSmpmod().getMps().getInr());
			  String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			  log.debug("{}","fileName:"+fileName);
			  if(!Platform.mfileExists(fileName))
			  { // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			    log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			    this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			    return false;
			  }
			  return (Boolean)this.getSmpmod().txtCreateMessageInformation(fileName,"txt");
			}
		}
        /**
        *   source:pbtadd.@0021.script
        */
        public boolean storeMsgFromPlatForFxps(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			//log.info("[SAVE_903_DOC]");
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GBK"));
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}

			if(!this.getSmpmod().createMessageProcessSubjectForFxps(is,"AUT","jfx","FXP","保存Fxps相关json报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			log.debug("{}","[FXPS_SMH_INR]:"+this.getSmpmod().getSmh().getInr());
			log.debug("{}","[FXPS_MPS_INR]:"+this.getSmpmod().getMps().getInr());
			String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			log.debug("{}","fileName:"+fileName);
			if(!Platform.mfileExists(fileName))
			{ // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			  log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			  this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			  return false;
			}
			return true;
		}





}