package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.PbtameVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Smpmod;
import com.ceb.gjjs.mda.manager.module.Pbtp;
import com.ceb.gjjs.mda.manager.module.Pbtgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 行号信息变更交易
*/
@Transaction(vo= PbtameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Pbtame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Pbtame.class);

		@BDGetter
		private Pbtgrp pbtgrp;

		@BDGetter
		private Pbtp pbtp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Smpmod smpmod;


		public Pbtame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getPbtp().setPbtgrpHolder(()->this.getPbtgrp());
        }

        /**
        *   source:pbtame.@0001.script
        */
        @Rule(target="pbtp.ame",order=100)
        public boolean rulePbtpAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getPbtp()))
			  return false;
			Object[] obj = new Object[8];
			obj[0] = "0083";
			//obj[1] = Platform.sdbCounter("FMT083","000000");
			String inr = Platform.sdbCounter("FMT083","000000");
			int dbInr = MdaUtils.parseInt(inr);
			dbInr = dbInr +1;
			obj[1] = String.format("%06d",dbInr);
			obj[2] = (Object)("F"+MdaUtils.format(MdaUtils.today(),"yyMMddhhmmssSSS"));
			//obj[3] = (Object)Platform.format(Platform.today(),"yyyyMMdd");
			obj[3] = (Object)MdaUtils.format(this.getPbtp().getGendat(),"yyyyMMdd");
			obj[4] = "PSBCCNBJXXX";
			//obj[5] = Platform.sdbCounter("JJCYZHHBGSQ","00000000");//间接参与者行号变更申请
			String bgsInr = Platform.sdbCounter("JJCYZHHBGSQ","00000000");
			int bgInr = MdaUtils.parseInt(bgsInr);
			bgInr = bgInr + 1;
			obj[5] = String.format("%08d",bgInr);
			obj[6] = "1";
			String[][] str = new String[1][13];
			str[0][0] = this.getPbtp().getBnkbic();
			str[0][1] = this.getPbtp().getBnknam();
			str[0][2] = this.getPbtp().getBnkallnam();
			str[0][3] = this.getPbtp().getBnkadr();
			str[0][4] = this.getPbtp().getTel();
			str[0][5] = this.getPbtp().getNam();
			str[0][6] = this.getPbtp().getZipcod();
			str[0][7] = this.getPbtp().getEmail();
			str[0][8] = "3";//1 新增 ，2 撤销，3 变更
			str[0][9] = this.getPbtp().getPvccod();
			str[0][10] = this.getPbtp().getCtycod();
			str[0][11] = this.getPbtp().getPtycod();
			if(!MdaUtils.isEmpty(this.getPbtp().getRem()))
			{
			  str[0][12] = this.getPbtp().getRem();
			}
			else
			  str[0][12] = "";
			obj[7] = str;

			Object rtnMsg = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","PackageFmt","083",obj);
			Boolean msg = (Boolean)MdaUtils.invoke(rtnMsg,"isSuccess");
			log.debug("{}","msg-------"+msg);
			if(!msg)
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtame","CT000034"),MdaUtils.getI18NString("pbtame","CT000035"));
			  Platform.mdbRollback();
			  return false;
			}
			Platform.mdbBegin();
			//获取接口平台返回的内容
			Object data = MdaUtils.invoke(rtnMsg,"getContent");//报文内容
			log.debug("{}","data========"+data);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			if(!this.storeMsgFromPlat(data))
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtame","CT000036"),MdaUtils.getI18NString("pbtame","CT000037"));
			  return false;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtame","CT000056"),MdaUtils.getI18NString("pbtame","CT000057"));
			  //Platform.returnToCaller();
			}
			this.getPbtgrp().getFxbank().setBic( this.getPbtp().getBnkbic());
			this.getPbtgrp().getFxbank().setBnktyp( "4");//4 间接参与者
			this.getPbtgrp().getFxbank().setHbcod( this.getPbtp().getHbcod());
			this.getPbtgrp().getFxbank().setDirectbic( "PSBCCNBJXXX");
			this.getPbtgrp().getFxbank().setProvcod( this.getPbtp().getPvccod());
			this.getPbtgrp().getFxbank().setCitycod( this.getPbtp().getCtycod());
			this.getPbtgrp().getFxbank().setBnkcod( this.getPbtp().getPtycod());
			this.getPbtgrp().getFxbank().setHafnam( this.getPbtp().getBnknam());
			this.getPbtgrp().getFxbank().setFulnam( this.getPbtp().getBnkallnam());
			this.getPbtgrp().getFxbank().setAddress( this.getPbtp().getBnkadr());
			this.getPbtgrp().getFxbank().setPoscod( this.getPbtp().getZipcod());
			this.getPbtgrp().getFxbank().setPhone( this.getPbtp().getTel());
			this.getPbtgrp().getFxbank().setEmail( this.getPbtp().getEmail());
			this.getPbtgrp().getFxbank().setLnkman( this.getPbtp().getNam());
			this.getPbtgrp().getFxbank().setTime( MdaUtils.today());
			if(!MdaUtils.isEmpty(this.getPbtp().getRem()))
			{
			  this.getPbtgrp().getFxbank().setPostscript( this.getPbtp().getRem());
			}
			if(!MdaUtils.isEmpty(this.getPbtgrp().getFxbank().getRelinr()))
			{
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMpi().getInr()))
			  {
			    this.getPbtgrp().getFxbank().setRelinr( this.getPbtgrp().getFxbank().getRelinr()+" ,pbtame:"+this.getSmpmod().getMpi().getInr());
			  }
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMpi().getInr()))
			  {
			    this.getPbtgrp().getFxbank().setRelinr( "pbtame:"+this.getSmpmod().getMpi().getInr());
			  }
			}
			this.getPbtgrp().getFxbank().setLstupdate( "3");
			this.getPbtgrp().getFxbank().setSta( "00");//未审核
			Platform.mdbUpdate(this.getPbtgrp().getFxbank());
			Platform.mdbCommit();
			int errcod = ctx.getErrorCode();
			if(errcod != NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtame","CT000066"),MdaUtils.getI18NString("pbtame","CT000067"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  //Platform.message(#CT000076,#CT000077);
			  log.debug("{}","间接参与者行号变更信息存储成功");
			  String pbtinr = this.getPbtgrp().getFxbank().getInr();
			  ctx.storeData("pbtinr",pbtinr);
			  
			}
			/*Object[] sndMap = new Object[1];
			  sndMap[0] = data;
			
			  Object rtn = Platform.invoke("com.brilliance.eibs.main.Client","scall","SendFmt","SendFmt",sndMap);
			  Boolean obt = (Boolean)Platform.invoke(rtn,"isSuccess");
			  log.debug("obt-------"+obt);
			  if(!obt)
			  {
			  Platform.message(#CT000106,#CT000107);
			  return false;
			  }
			  //获取接口平台返回的内容
			  Object code = Platform.invoke(rtn,"getContent");//报文内容
			  log.debug("code========"+code);
			  Object[] strcod = (Object[])code;
			  String rspcod = (String)strcod[0];//返回码
			  if(!Platform.isEmpty(rspcod)&&"0000".equals(rspcod))
			  {
			  Platform.mdbBegin();
			  Platform.mdbUpdate($pbtp\\pbtgrp\\pbt);
			  Platform.mdbCommit();
			  int errcod = Platform.errorCode();
			  if(errcod != NO_ERROR)
			  {
			  Platform.message(#CT000108,#CT000109);
			  return false;
			  }
			  else
			  {
			  Platform.message(#CT000110,#CT000111);
			  String pbtinr = $pbtp\\pbtgrp\\pbt\\inr.getValue();
			  Platform.storeData("pbtinr",pbtinr);
			  Platform.returnToCaller();
			  }
			  }
			  else
			  Platform.message(#CT000112,#CT000113+rspcod);
			  */


			return true;
        }

        /**
        *   source:pbtame.@0002.script
        */
        @Rule(target="pbtp.ret",order=100)
        public boolean rulePbtpRetN100(){
            IContext ctx = MdaEnv.getContext();
            
			String pbtinr = this.getPbtgrp().getFxbank().getInr();
			ctx.storeData("pbtinr",pbtinr);
			

			return true;
        }

        /**
        *   source:pbtame.@0017.script
        */
        @Rule(target="pbtp.ccms916",order=100)
        public boolean rulePbtpCcms916N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getPbtp()))
			  return false;
			Map map = new HashMap();
			map.put("msgFlagNo","");
			map.put("sendTm",MdaUtils.format(MdaUtils.today(),"YYYYMMDDHHMmSs"));
			map.put("instgDrctParty","");
			map.put("instgParty","");
			map.put("instdDrctParty","");
			map.put("instdParty","");
			map.put("sysCode","8888");
			map.put("headerRmk",this.getPbtp().getRem());
			map.put("totalNum","");
			map.put("startNum","");
			map.put("endNum","");
			map.put("changeNum","");
			map.put("changeRecordNum","");
			map.put("chngInfList","");
			map.put("bankCode",this.getPbtp().getBnkbic());
			map.put("partType","");
			map.put("dirBkCode","");
			map.put("partShortName",this.getPbtp().getBnknam());
			map.put("partName",this.getPbtp().getBnkallnam());
			map.put("address",this.getPbtp().getBnkadr());
			map.put("telPhone",this.getPbtp().getTel());
			map.put("name",this.getPbtp().getNam());
			map.put("postcode",this.getPbtp().getZipcod());
			map.put("email",this.getPbtp().getEmail());
			map.put("changeType","");
			map.put("effDate",MdaUtils.format(MdaUtils.today(),"YYYYMMDD"));
			map.put("provCode",this.getPbtp().getPvccod());
			map.put("cityCode",this.getPbtp().getCtycod());
			map.put("mmbId",this.getPbtp().getPtycod());
			map.put("addtInfo",this.getPbtp().getRem());

			log.info("{}","916 map = "+map);
			String json=(String)MdaUtils.invoke("com.brilliance.eibs.el.CommonFunctionUtils","toJson",map);

			log.debug("{}","[FXPS_916_JSON]"+json);
			//设置数据库
			Platform.setDefaultDB("swd");
			Platform.mdbBegin();
			if(!storeMsgFromPlatForFxps(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtame","CT000118"),MdaUtils.getI18NString("pbtame","CT000119"));

			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtame","CT000120"),MdaUtils.getI18NString("pbtame","CT000121"));
			}


			return true;
        }


        /**
        *   source:pbtame.@0005.script
        */
        @Check(target="pbtp.bnkbic",order=100)
        public boolean checkPbtpBnkbicN100(){
            IContext ctx = MdaEnv.getContext();
            
			String str=this.getPbtp().getBnkbic();
			if(MdaUtils.isEmpty(this.getPbtp().getBnkbic()))
			{
			  ctx.setFieldError(this,"pbtp.bnkbic",MdaUtils.getI18NString("pbtame","CT000210"));
			}
			else if(str.length()<11)
			{
			  ctx.setFieldError(this,"pbtp.bnkbic",MdaUtils.getI18NString("pbtame","CT000114"));
			}


			return true;
        }

        /**
        *   source:pbtame.@0006.script
        */
        @Check(target="pbtp.bnknam",order=100)
        public boolean checkPbtpBnknamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getBnknam()))
			  ctx.setFieldError(this,"pbtp.bnknam",MdaUtils.getI18NString("pbtame","CT000214"));

			return true;
        }

        /**
        *   source:pbtame.@0007.script
        */
        @Check(target="pbtp.bnkallnam",order=100)
        public boolean checkPbtpBnkallnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getBnkallnam()))
			  ctx.setFieldError(this,"pbtp.bnkallnam",MdaUtils.getI18NString("pbtame","CT000215"));

			return true;
        }

        /**
        *   source:pbtame.@0008.script
        */
        @Check(target="pbtp.nam",order=100)
        public boolean checkPbtpNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getNam()))
			  ctx.setFieldError(this,"pbtp.nam",MdaUtils.getI18NString("pbtame","CT000217"));

			return true;
        }

        /**
        *   source:pbtame.@0009.script
        */
        @Check(target="pbtp.bnkadr",order=100)
        public boolean checkPbtpBnkadrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getBnkadr()))
			  ctx.setFieldError(this,"pbtp.bnkadr",MdaUtils.getI18NString("pbtame","CT000218"));

			return true;
        }

        /**
        *   source:pbtame.@0010.script
        */
        @Check(target="pbtp.ctycod",order=100)
        public boolean checkPbtpCtycodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getCtycod()))
			  ctx.setFieldError(this,"pbtp.ctycod",MdaUtils.getI18NString("pbtame","CT000220"));

			return true;
        }

        /**
        *   source:pbtame.@0011.script
        */
        @Check(target="pbtp.pvccod",order=100)
        public boolean checkPbtpPvccodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getPvccod()))
			  ctx.setFieldError(this,"pbtp.pvccod",MdaUtils.getI18NString("pbtame","CT000221"));

			return true;
        }

        /**
        *   source:pbtame.@0012.script
        */
        @Check(target="pbtp.ptycod",order=100)
        public boolean checkPbtpPtycodN100(){
            IContext ctx = MdaEnv.getContext();
            
			String str=this.getPbtp().getPtycod();
			if(MdaUtils.isEmpty(this.getPbtp().getPtycod()))
			{
			  ctx.setFieldError(this,"pbtp.ptycod",MdaUtils.getI18NString("pbtame","CT000224"));
			}
			else if(str.length()<12)
			{
			  ctx.setFieldError(this,"pbtp.ptycod",MdaUtils.getI18NString("pbtame","CT000115"));
			}

			return true;
        }

        /**
        *   source:pbtame.@0013.script
        */
        @Check(target="pbtp.zipcod",order=100)
        public boolean checkPbtpZipcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			String str=this.getPbtp().getZipcod();
			if(MdaUtils.isEmpty(this.getPbtp().getZipcod()))
			{
			  ctx.setFieldError(this,"pbtp.zipcod",MdaUtils.getI18NString("pbtame","CT000225"));
			}
			else
			  if(str.length()<6)
			{
			  ctx.setFieldError(this,"pbtp.zipcod",MdaUtils.getI18NString("pbtame","CT000117"));
			}

			return true;
        }

        /**
        *   source:pbtame.@0014.script
        */
        @Check(target="pbtp.email",order=100)
        public boolean checkPbtpEmailN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getEmail()))
			  ctx.setFieldError(this,"pbtp.email",MdaUtils.getI18NString("pbtame","CT000226"));

			return true;
        }

        /**
        *   source:pbtame.@0015.script
        */
        @Check(target="pbtp.tel",order=100)
        public boolean checkPbtpTelN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPbtp().getTel()))
			  ctx.setFieldError(this,"pbtp.tel",MdaUtils.getI18NString("pbtame","CT000229"));

			return true;
        }


        /**
        *   source:pbtame.@0000.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getPbtgrp().getFxbank());
			String pbtinr = (String)ctx.restoreData("pbtinr");
			Platform.mdbRead(this.getPbtgrp().getFxbank(),new Argument("inr",pbtinr));

			this.getPbtp().setBnkbic( this.getPbtgrp().getFxbank().getBic());
			this.getPbtp().setBnknam( this.getPbtgrp().getFxbank().getHafnam());
			this.getPbtp().setBnkallnam( this.getPbtgrp().getFxbank().getFulnam());
			this.getPbtp().setBnkadr( this.getPbtgrp().getFxbank().getAddress());
			this.getPbtp().setHbcod( this.getPbtgrp().getFxbank().getHbcod());
			this.getPbtp().setTel( this.getPbtgrp().getFxbank().getPhone());
			this.getPbtp().setNam( this.getPbtgrp().getFxbank().getLnkman());
			this.getPbtp().setZipcod( this.getPbtgrp().getFxbank().getPoscod());
			this.getPbtp().setEmail( this.getPbtgrp().getFxbank().getEmail());
			this.getPbtp().setPvccod( this.getPbtgrp().getFxbank().getProvcod());
			this.getPbtp().setCtycod( this.getPbtgrp().getFxbank().getCitycod());
			this.getPbtp().setPtycod( this.getPbtgrp().getFxbank().getBnkcod());
			if(!MdaUtils.isEmpty(this.getPbtgrp().getFxbank().getPostscript()))
			{
			  this.getPbtp().setRem( this.getPbtgrp().getFxbank().getPostscript());
			}
			
			
			
			
			
			
			
			
			
			
			
			
			


			return true;
        }

        /**
        *   source:pbtame.@0004.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getPbtp(),"pvccod",this.getPbtp().getProcodList());
			
			String ptyp = "";
			if(!MdaUtils.isEmpty(this.getPbtp().getPvccod()))
			{
			  ptyp = this.getPbtp().getPvccod();
			}
			log.debug("{}","pvccod: " + ptyp);
			MdaUtils.setValues(this.getPbtp(),"ctycod",this.getPbtp().getCtycodList(ptyp));
			
			String typ = "";
			if(!MdaUtils.isEmpty(this.getPbtp().getCtycod()))
			{
			  typ = this.getPbtp().getCtycod();
			}
			log.debug("{}","ctycod: " + typ);
			MdaUtils.setValues(this.getPbtp(),"ptycod",this.getPbtp().getPtycodList(typ));
			

			return true;
        }


        /**
        *   source:pbtame.@0003.script
        */
        public boolean storeMsgFromPlat(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GB18030"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubjectForMan(is,"AUT","txt","FMT","行号新增待审核报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  log.debug("{}","faatsk smhinr:"+this.getSmpmod().getSmh().getInr());
			  log.debug("{}","mps inr:"+this.getSmpmod().getMps().getInr());
			  String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			  log.debug("{}","fileName:"+fileName);
			  if(!Platform.mfileExists(fileName))
			  { // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			    log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			    this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			    return false;
			  }
			  return (Boolean)this.getSmpmod().txtCreateMessageInformation(fileName,"txt");
			}
		}
        /**
        *   source:pbtame.@0016.script
        */
        public boolean storeMsgFromPlatForFxps(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			//log.info("[SAVE_903_DOC]");
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GBK"));
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}

			if(!this.getSmpmod().createMessageProcessSubjectForFxps(is,"AUT","jfx","FXP","保存Fxps相关json报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			log.debug("{}","[FXPS_SMH_INR]:"+this.getSmpmod().getSmh().getInr());
			log.debug("{}","[FXPS_MPS_INR]:"+this.getSmpmod().getMps().getInr());
			String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			log.debug("{}","fileName:"+fileName);
			if(!Platform.mfileExists(fileName))
			{ // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			  log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			  this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			  return false;
			}
			return true;
		}





}