package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.PbtdtlVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Smpmod;
import com.ceb.gjjs.mda.manager.module.Pbtp;
import com.ceb.gjjs.mda.manager.module.Pbtgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 行号信息详情
*/
@Transaction(vo= PbtdtlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Pbtdtl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Pbtdtl.class);

		@BDGetter
		private Pbtgrp pbtgrp;

		@BDGetter
		private Pbtp pbtp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Smpmod smpmod;


		public Pbtdtl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getPbtp().setPbtgrpHolder(()->this.getPbtgrp());
        }

        /**
        *   source:pbtdtl.@0001.script
        */
        @Rule(target="pbtp.ret",order=100)
        public boolean rulePbtpRetN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:pbtdtl.@0002.script
        */
        @Rule(target="pbtp.drp",order=100)
        public boolean rulePbtpDrpN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getPbtp()))
			  return false;
			if(MdaUtils.prompt(MdaUtils.getI18NString("pbtdtl","CT000162"),MdaUtils.getI18NString("pbtdtl","CT000163")))
			{
			  return false;
			}
			Object[] obj = new Object[8];
			obj[0] = "0083";
			//obj[1] = Platform.sdbCounter("FMT083","000000");
			String inr = Platform.sdbCounter("FMT083","000000");
			int dbInr = MdaUtils.parseInt(inr);
			dbInr = dbInr +1;
			obj[1] = String.format("%06d",dbInr);
			obj[2] = (Object)("F"+MdaUtils.format(MdaUtils.today(),"yyMMddhhmmssSSS"));
			//obj[3] = (Object)Platform.format(Platform.today(),"yyyyMMdd");
			obj[3] = (Object)MdaUtils.format(this.getPbtp().getGendat(),"yyyyMMdd");
			obj[4] = "PSBCCNBJXXX";
			//obj[5] = Platform.sdbCounter("JJCYZHHBGSQ","00000000");//间接参与者行号变更申请
			String bgsInr = Platform.sdbCounter("JJCYZHHBGSQ","00000000");
			int bgInr = MdaUtils.parseInt(bgsInr);
			bgInr = bgInr +1;
			obj[5] = String.format("%08d",bgInr);
			obj[6] = "1";
			String[][] str = new String[1][13];
			str[0][0] = this.getPbtp().getBnkbic();
			str[0][1] = this.getPbtp().getBnknam();
			str[0][2] = this.getPbtp().getBnkallnam();
			str[0][3] = this.getPbtp().getBnkadr();
			str[0][4] = this.getPbtp().getTel();
			str[0][5] = this.getPbtp().getNam();
			str[0][6] = this.getPbtp().getZipcod();
			str[0][7] = this.getPbtp().getEmail();
			str[0][8] = "2";//1 新增 ，2 撤销，3 变更
			str[0][9] = this.getPbtp().getPvccod();
			str[0][10] = this.getPbtp().getCtycod();
			str[0][11] = this.getPbtp().getPtycod();
			if(!MdaUtils.isEmpty(this.getPbtp().getRem()))
			{
			  str[0][12] = this.getPbtp().getRem();
			}
			else
			  str[0][12] = "";
			obj[7] = str;

			Object rtnMsg = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","PackageFmt","083",obj);
			Boolean msg = (Boolean)MdaUtils.invoke(rtnMsg,"isSuccess");
			log.debug("{}","msg-------"+msg);
			if(!msg)
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtdtl","CT000164"),MdaUtils.getI18NString("pbtdtl","CT000165"));
			  return false;
			}
			Platform.mdbBegin();
			//获取接口平台返回的报文信息
			Object data = MdaUtils.invoke(rtnMsg,"getContent");//报文内容
			log.debug("{}","code========"+data);

			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			if(!this.storeMsgFromPlat(data))
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtdtl","CT000178"),MdaUtils.getI18NString("pbtdtl","CT000179"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtdtl","CT000212"),MdaUtils.getI18NString("pbtdtl","CT000213"));
			  //Platform.returnToCaller();
			}
			int errcod = ctx.getErrorCode();
			if(!MdaUtils.isEmpty(this.getPbtgrp().getFxbank().getRelinr()))
			{
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMpi().getInr()))
			  {
			    this.getPbtgrp().getFxbank().setRelinr( this.getPbtgrp().getFxbank().getRelinr()+" ,pbtdel:"+this.getSmpmod().getMpi().getInr());
			  }
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMpi().getInr()))
			  {
			    this.getPbtgrp().getFxbank().setRelinr( "pbtdel:"+this.getSmpmod().getMpi().getInr());
			  }
			}
			this.getPbtgrp().getFxbank().setLstupdate( "2");
			this.getPbtgrp().getFxbank().setSta( "00");
			//Platform.mdbDelete($pbtp\\pbtgrp\\pbt);
			Platform.mdbUpdate(this.getPbtgrp().getFxbank());//更新状态为撤销
			Platform.mdbCommit();
			errcod = ctx.getErrorCode();
			if(errcod != NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("pbtdtl","CT000234"),MdaUtils.getI18NString("pbtdtl","CT000235"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  //Platform.message(#CT000254,#CT000255);
			  log.debug("{}","间接参与者行号撤销存储信息成功");
			  
			}

			/*Object[] sndMap = new Object[1];
			  sndMap[0] = data;
			  Object rtn = Platform.invoke("com.brilliance.eibs.main.Client","scall","SendFmt","SendFmt",sndMap);
			  Boolean obt = (Boolean)Platform.invoke(rtn,"isSuccess");
			  log.debug("obt-------"+obt);
			  if(!obt)
			  {
			  Platform.message(#CT000272,#CT000273);
			  return false;
			  }
			  //获取接口平台返回的内容
			  Object code = Platform.invoke(rtn,"getContent");//返回内容
			  log.debug("code========"+code);
			  Object[] strcod = (Object[])code;
			  String rspcod = (String)strcod[0];//返回码
			  int errcod = Platform.errorCode();
			  if(!Platform.isEmpty(rspcod)&&"0000".equals(rspcod))
			  {
			  Platform.mdbBegin();
			  Platform.mdbDelete($pbtp\\pbtgrp\\pbt);
			  Platform.mdbCommit();
			  errcod = Platform.errorCode();
			  if(errcod != NO_ERROR)
			  {
			  Platform.message(#CT000274,#CT000275);
			  return false;
			  }
			  else
			  {
			  Platform.message(#CT000284,#CT000285);
			  Platform.returnToCaller();
			  }
			  }
			  else
			  Platform.message(#CT000286,#CT000287+rspcod);
			  */


			return true;
        }

        /**
        *   source:pbtdtl.@0003.script
        */
        @Rule(target="pbtp.ame",order=100)
        public boolean rulePbtpAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			String pbtinr = this.getPbtgrp().getFxbank().getInr();
			ctx.storeData("pbtinr",pbtinr);
			Platform.mchain("pbtame");

			return true;
        }



        /**
        *   source:pbtdtl.@0000.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getPbtgrp().getFxbank());
			String pbtinr = (String)ctx.restoreData("pbtinr");
			Platform.mdbRead(this.getPbtgrp().getFxbank(),new Argument("inr",pbtinr));

			this.getPbtp().setBnkbic( this.getPbtgrp().getFxbank().getBic());
			this.getPbtp().setBnknam( this.getPbtgrp().getFxbank().getHafnam());
			this.getPbtp().setBnkallnam( this.getPbtgrp().getFxbank().getFulnam());
			this.getPbtp().setBnkadr( this.getPbtgrp().getFxbank().getAddress());
			this.getPbtp().setHbcod( this.getPbtgrp().getFxbank().getHbcod());
			this.getPbtp().setTel( this.getPbtgrp().getFxbank().getPhone());
			this.getPbtp().setNam( this.getPbtgrp().getFxbank().getLnkman());
			this.getPbtp().setZipcod( this.getPbtgrp().getFxbank().getPoscod());
			this.getPbtp().setEmail( this.getPbtgrp().getFxbank().getEmail());
			this.getPbtp().setPvccod( this.getPbtgrp().getFxbank().getProvcod());
			this.getPbtp().setCtycod( this.getPbtgrp().getFxbank().getCitycod());
			this.getPbtp().setPtycod( this.getPbtgrp().getFxbank().getBnkcod());
			if(!MdaUtils.isEmpty(this.getPbtgrp().getFxbank().getPostscript()))
			{
			  this.getPbtp().setRem( this.getPbtgrp().getFxbank().getPostscript());
			}
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"bnkbic"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"bnknam"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"bnkallnam"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"bnkadr"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"hbcod"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"tel"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"nam"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"zipcod"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"email"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"pvccod"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"ctycod"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"ptycod"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getPbtp(),"rem"));

			return true;
        }

        /**
        *   source:pbtdtl.@0005.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getPbtp(),"pvccod",this.getPbtp().getProcodList());
			
			String ptyp = "";
			if(!MdaUtils.isEmpty(this.getPbtp().getPvccod()))
			{
			  ptyp = this.getPbtp().getPvccod();
			}
			log.debug("{}","pvccod: " + ptyp);
			MdaUtils.setValues(this.getPbtp(),"ctycod",this.getPbtp().getCtycodList(ptyp));
			
			String typ = "";
			if(!MdaUtils.isEmpty(this.getPbtp().getCtycod()))
			{
			  typ = this.getPbtp().getCtycod();
			}
			log.debug("{}","ctycod: " + typ);
			MdaUtils.setValues(this.getPbtp(),"ptycod",this.getPbtp().getPtycodList(typ));
			

			return true;
        }


        /**
        *   source:pbtdtl.@0004.script
        */
        public boolean storeMsgFromPlat(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GB18030"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubjectForMan(is,"AUT","txt","FMT","行号注销待审核报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  log.debug("{}","faatsk smhinr:"+this.getSmpmod().getSmh().getInr());
			  log.debug("{}","mps inr:"+this.getSmpmod().getMps().getInr());
			  String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			  log.debug("{}","fileName:"+fileName);
			  if(!Platform.mfileExists(fileName))
			  { // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			    log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			    this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			    return false;
			  }
			  return (Boolean)this.getSmpmod().txtCreateMessageInformation(fileName,"txt");
			}
		}





}