package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.RectskVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Msgmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Smpmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 收报服务
*/
@Transaction(vo= RectskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rectsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Rectsk.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Smpmod smpmod;

		@BDGetter
		private Msgmod msgmod;


		public Rectsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:rectsk.@0000.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","mq收报服务开始...");

			ICallback  callback=new ICallback() {
				@Override
				public Object invoke(Object... paramVarArgs) {
					processIncoming(paramVarArgs);
					return null;
				}
			};
			MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","recTask","pollTask",new Object[]{state,callback});

			log.debug("{}","mq收报服务结束！");
		}
        /**
        *   source:rectsk.@0001.script
        */
        public boolean processIncoming(Object ... obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始执行processIncoming...");
			String content = (String) obj[0];
			log.info("{}","content:" + content);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			try
			{
			  is.getOutputStream().write(content.getBytes("UTF-8"));//将报文存入流
			}
			catch (java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if (!this.getSmpmod().createMessageProcessSubject(is, "CPX","xml","HWE", "系统管理报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  com.brilliance.jrxx.framework.Result result = (com.brilliance.jrxx.framework.Result) MdaUtils.invoke("com.brilliance.jrxx.utils.MsgUtil","unPackMessage",content);
			  String json = result.getElcsModelForJson();
			  Map map = com.alibaba.fastjson.JSON.parseObject(json, Map.class);
			  if("cfad.990.001.01".equals((String)map.get("MesgType")))
			  {
			    log.info("{}","收到990报文...");
			    return true;
			  }
			  log.info("{}","发送990应答报文...");
			  // 发送990报文
			  String msg_990 = this.getMsgmod().create_msg_990(map);
			  if ("".equals(msg_990))
			  {
			    return false;
			  }

			  MdaUtils.clear(this.getSmpmod().getFilstm());
			  IStream is_990 = this.getSmpmod().getFilstm();
			  try
			  {
			    is_990.getOutputStream().write(msg_990.getBytes("UTF-8"));//将报文存入流
			  }
			  catch (java.io.IOException e)
			  {
			    return false;
			  }
			  if (!this.getSmpmod().createMessageProcessSubject(is_990, "HWE", "json","CPX",  "990应答报文"))
			  {
			    log.debug("{}","990报文保存失败");
			    return false;
			  }
			  return true;
			}
		}




}