package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.UsrmsgVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Msgmod;
import com.ceb.gjjs.mda.manager.module.Usrmsggrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Usrmsgp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 境内外币系统管理
*/
@Transaction(vo= UsrmsgVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Usrmsg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Usrmsg.class);

		@BDGetter
		private Usrmsggrp usrmsggrp;

		@BDGetter
		private Usrmsgp usrmsgp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Msgmod msgmod;


		public Usrmsg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getUsrmsgp().setUsrmsggrpHolder(()->this.getUsrmsggrp());
           this.getUsrmsgp().setMtabutHolder(()->this.getMtabut());
           this.getMtabut().setMtagrpHolder(()->this.getUsrmsggrp());
        }

        /**
        *   source:usrmsg.@0005.script
        */
        @Rule(target="usrmsgp.lgiccms805",order=100)
        public boolean ruleUsrmsgpLgiccms805N100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> ct = new ArrayList<CodetableItem>();
			ct.add(new CodetableItem("登录","0"));
			ct.add(new CodetableItem("退出","1"));
			MdaUtils.setValues(this.getUsrmsgp(),"typecode",ct);
			//
			this.getUsrmsgp().setMsgflagno( "F"+MdaUtils.format(MdaUtils.today(),"yyMMddhhmmssSSS"));
			this.getUsrmsgp().setSendtm( MdaUtils.today());
			this.getUsrmsgp().setInstgdrctparty( "PSBCCNBJXXX");
			this.getUsrmsgp().setInstgparty( "PSBCCNBJXXX");
			this.getUsrmsgp().setInstddrctparty( "8888");
			this.getUsrmsgp().setInstdparty( "8888");
			this.getUsrmsgp().setTypecode("0");
			//设为默认
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"msgflagno"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"instgdrctparty"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"instgparty"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"instddrctparty"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"instdparty"));
			//
			
			

			return true;
        }

        /**
        *   source:usrmsg.@0006.script
        */
        @Rule(target="usrmsgp.lgoccms805",order=100)
        public boolean ruleUsrmsgpLgoccms805N100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> ct = new ArrayList<CodetableItem>();
			ct.add(new CodetableItem("登录","0"));
			ct.add(new CodetableItem("退出","1"));
			MdaUtils.setValues(this.getUsrmsgp(),"typecode",ct);
			//
			this.getUsrmsgp().setMsgflagno( "F"+MdaUtils.format(MdaUtils.today(),"yyMMddhhmmssSSS"));
			this.getUsrmsgp().setSendtm( MdaUtils.today());
			this.getUsrmsgp().setInstgdrctparty( "PSBCCNBJXXX");
			this.getUsrmsgp().setInstgparty( "PSBCCNBJXXX");
			this.getUsrmsgp().setInstddrctparty( "8888");
			this.getUsrmsgp().setInstdparty( "8888");
			this.getUsrmsgp().setTypecode("1");
			//设为默认
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"msgflagno"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"instgdrctparty"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"instgparty"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"instddrctparty"));
			Platform.disableDatafield(MdaDriver.getDatafield(this.getUsrmsgp(),"instdparty"));
			//
			

			return true;
        }

        /**
        *   source:usrmsg.@0007.script
        */
        @Rule(target="usrmsgp.submit805",order=100)
        public boolean ruleUsrmsgpSubmit805N100(){
            IContext ctx = MdaEnv.getContext();
            
			Map map = new HashMap();
			map.put("serviceId","99306000068");
			map.put("msgFlagNo",this.getUsrmsgp().getMsgflagno());
			//map.put("sendTm",Platform.format(Platform.today(),"YYYYMMDDHHMmSs"));
			map.put("sendTm",MdaUtils.format(MdaUtils.today(),"YYYY-MM-dd")+ "T" +MdaUtils.format(MdaUtils.today(),"HH:MM:ss"));
			map.put("instgDrctParty",this.getUsrmsgp().getInstgdrctparty());
			map.put("instgParty",this.getUsrmsgp().getInstgparty());
			map.put("instdDrctParty",this.getUsrmsgp().getInstddrctparty());
			map.put("instdParty",this.getUsrmsgp().getInstdparty());
			map.put("sysCode","FXPS");
			if(!MdaUtils.isEmpty(this.getUsrmsgp().getHeaderrmk()))
			{
			  map.put("headerRmk",this.getUsrmsgp().getHeaderrmk());
			}
			if("0".equals(this.getUsrmsgp().getTypecode()))
			{
			  map.put("loginTypeCode","OT00");
			}
			else if("1".equals(this.getUsrmsgp().getTypecode()))
			{
			  map.put("loginTypeCode","OT01");
			}

			log.info("{}","805 map = "+map);
			String json=(String)MdaUtils.invoke("com.brilliance.eibs.el.CommonFunctionUtils","toJson",map);

			log.debug("{}","[FXPS_805_JSON]"+json);
			//设置数据库
			Platform.setDefaultDB("swd");
			Platform.mdbBegin();
			if(!this.getUsrmsgp().storeMsgFromPlatForFxps(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsg","CT000214"),MdaUtils.getI18NString("usrmsg","CT000215"));

			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsg","CT000216"),MdaUtils.getI18NString("usrmsg","CT000217"));
			}

			

			return true;
        }

        /**
        *   source:usrmsg.@0008.script
        */
        @Rule(target="usrmsgp.submit805off",order=100)
        public boolean ruleUsrmsgpSubmit805offN100(){
            IContext ctx = MdaEnv.getContext();
            
			Map map = new HashMap();
			map.put("serviceId","99306000068");
			map.put("msgFlagNo",this.getUsrmsgp().getMsgflagno());
			//map.put("sendTm",Platform.format(Platform.today(),"YYYYMMDDHHMmSs"));
			map.put("sendTm",MdaUtils.format(MdaUtils.today(),"YYYY-MM-dd")+ "T" +MdaUtils.format(MdaUtils.today(),"HH:MM:ss"));
			map.put("instgDrctParty",this.getUsrmsgp().getInstgdrctparty());
			map.put("instgParty",this.getUsrmsgp().getInstgparty());
			map.put("instdDrctParty",this.getUsrmsgp().getInstddrctparty());
			map.put("instdParty",this.getUsrmsgp().getInstdparty());
			map.put("sysCode","FXPS");
			if(!MdaUtils.isEmpty(this.getUsrmsgp().getHeaderrmk()))
			{
			  map.put("headerRmk",this.getUsrmsgp().getHeaderrmk());
			}
			if("0".equals(this.getUsrmsgp().getTypecode()))
			{
			  map.put("loginTypeCode","OT00");
			}
			else if("1".equals(this.getUsrmsgp().getTypecode()))
			{
			  map.put("loginTypeCode","OT01");
			}

			log.info("{}","805 map = "+map);
			String json=(String)MdaUtils.invoke("com.brilliance.eibs.el.CommonFunctionUtils","toJson",map);

			log.debug("{}","[FXPS_805_JSON]"+json);
			//设置数据库
			Platform.setDefaultDB("swd");
			Platform.mdbBegin();
			if(!this.getUsrmsgp().storeMsgFromPlatForFxps(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsg","CT000226"),MdaUtils.getI18NString("usrmsg","CT000227"));

			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsg","CT000228"),MdaUtils.getI18NString("usrmsg","CT000229"));
			}

			

			return true;
        }

        /**
        *   source:usrmsg.@0009.script
        */
        @Rule(target="usrmsgp.close805on",order=100)
        public boolean ruleUsrmsgpClose805onN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:usrmsg.@0010.script
        */
        @Rule(target="usrmsgp.close805off",order=100)
        public boolean ruleUsrmsgpClose805offN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }










}