package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.XxxtskVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Tskmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Dtrmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 自动清分处理服务交易
*/
@Transaction(vo= XxxtskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xxxtsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Xxxtsk.class);

		@BDGetter
		private Dtrmod dtrmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Tskmod tskmod;


		public Xxxtsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:xxxtsk.@0000.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 报文自动清分处理服务
			  - state:IState 服务状态控制变量
			  * SWIFT库和境内外币库中的数据分别处理
			  */
			int swdRtn = 0;
			int fxdRtn = 0;
			while(state.getContinued() && this.getTskmod().isEnable2())
			{
			  swdRtn = this.getDtrmod().distributeMessageAutomaticWithResult(">");
			  // 防止解锁未成功
			  if(state.getContinued())
			    Platform.mdbUnlock(MdaEnv.getLoginUser());

			  if (swdRtn == 0)
			  {
			    log.info("{}","errorCode:"+ctx.getErrorCode());
			    log.info("{}","mps inr:"+this.getDtrmod().getSmpmod().getMps().getInr());
			    log.info("{}","mpe txt:"+this.getDtrmod().getSmpmod().getMpe().getTxt());
			    if (!MdaUtils.isEmpty(this.getDtrmod().getSmpmod().getMps().getInr()) && !(this.getDtrmod().getSmpmod().getMpe().getTxt().contains("同步文件")))
			    {
			      Platform.mdbBegin();
			      this.getDtrmod().getSmpmod().getMps().setSta("E");
			      Platform.mdbUpdate(this.getDtrmod().getSmpmod().getMps());
			      Platform.mdbCommit();
			      log.info("{}","异常处理数据状态已更新，mps inr:"+this.getDtrmod().getSmpmod().getMps().getInr());
			    }
			  }
			  /*if(Platform.checkFlgWithBussiness("fxd"))
			    {
			    fxdRtn = $dtrmod.distributeMessageAutomaticWithResult(">");
			    // 防止解锁未成功
			    if(state.getContinued())
			    Platform.mdbUnlock(Platform.getLoginUser());
			
			    if (fxdRtn == 0)
			    {
			    log.info("errorCode:"+Platform.errorCode());
			    log.info("mps inr:"+$dtrmod\\smpmod\\mps\\inr.getValue());
			    log.info("mpe txt:"+$dtrmod\\smpmod\\mpe\\txt.getValue());
			    if (!Platform.isEmpty($dtrmod\\smpmod\\mps\\inr.getValue()) && !($dtrmod\\smpmod\\mpe\\txt.getValue().contains("同步文件")))
			    {
			    Platform.mdbBegin();
			    $dtrmod\\smpmod\\mps\\sta="E";
			    Platform.mdbUpdate($dtrmod\\smpmod\\mps);
			    Platform.mdbCommit();
			    log.info("异常处理数据状态已更新，mps inr:"+$dtrmod\\smpmod\\mps\\inr.getValue());
			    }
			    }
			    }*/
			  if(state.getContinued())
			    state.sleep();
			}
		}




}