package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Actreqpho extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Actreqpho.class);

        //查询
        private IControl query;

        //返回
        private IControl rtn;

        //账号
        private String act;

        //收汇人电话
        private String pyepho;

        //描述
        private String desc;

        //电话查询
        private IControl panpop;

        //手机号码
        private String mobile;


        @JsonIgnore
        @BDGetter
        private transient IPanel actphoreq;



		public Actreqpho()
        {
            super();
            setArgument();
        }

        public Actreqpho(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:actreqpho.@0000.script
        */
        @Rule(target="query",order=100)
        public boolean ruleQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getAct()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("actreqpho","CT000009"),MdaUtils.getI18NString("actreqpho","CT000010"));
			  return false;
			}
			query();

			return true;
        }

        /**
        *   source:actreqpho.@0004.script
        */
        @Rule(target="panpop",order=100)
        public boolean rulePanpopN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:actreqpho.@0005.script
        */
        @Rule(target="rtn",order=100)
        public boolean ruleRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.clearDatafield(MdaDriver.getDatafield(this,"act"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"pyepho"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"mobile"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"desc"));
			

			return true;
        }




        /**
        *   source:actreqpho.@0001.script
        */
        public void query()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Platform.clearDatafield(MdaDriver.getDatafield(this,"pyepho"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"mobile"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"desc"));

			Map<String,Object> map = this.getReturnMessage(this.getAct());
			if(MdaUtils.isEmpty(map))
			  this.setDesc( "收汇人账号为空，缺少向客户信息平台查询的必要条件.");
			else
			{
			  try
			  {
			    Map<String,Object> ecifReturnMap = (Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.psbc.util.TexudoEcifUtil","SendMessage",map);
			    if((!MdaUtils.isEmpty(ecifReturnMap))&&"000000".equals(ecifReturnMap.get("code").toString()))
			    {
			      this.setDesc( "查询完毕，成功从客户信息平台获取到返回结果");
			      if(!MdaUtils.isEmpty(ecifReturnMap.get("PHONE")))
			      {
			        this.setPyepho( ecifReturnMap.get("PHONE").toString());
			      }
			      if(!MdaUtils.isEmpty(ecifReturnMap.get("MOBILENUM")))
			      {
			        this.setMobile( ecifReturnMap.get("MOBILENUM").toString());
			      }
			    }
			    else
			    {
			      this.setDesc( ecifReturnMap.get("desc").toString());
			    }
			  }
			  catch(Exception e)
			  {
			    this.setDesc( "接口调用失败");
			    log.debug("{}","TexudoEcifUtil.SendMessage接口调用失败");
			  }
			}
			
			
			
		}
        /**
        *   source:actreqpho.@0002.script
        */
        public Map<String,Object> getReturnMessage(String act)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,Object> sendToEcifMap = null;
			if(!MdaUtils.isEmpty(act))
			{
			  //根据20190408个人银邮国际汇款收汇流程优化讨论会内容，在接收到境外银邮汇款报文后，根据报文账号从客户信息平台取其对应中英文名称并入库
			  sendToEcifMap = new HashMap<String,Object>();
			  //ecif请求报文头
			  //发信系统代码
			  sendToEcifMap.put("send_inst","99306000000");
			  //交易系统代码
			  sendToEcifMap.put("tran_inst","99306000000");
			  //目标系统代码
			  sendToEcifMap.put("dest_inst","99420000000");
			  //交易流水号(ECIF+15位交易唯一识别号)
			  String ownSystemCode = "99306";
			  String month = MdaUtils.format(MdaUtils.today(),"yyMM");
			  String ecifId = ownSystemCode + "KH" + month;
			  String ecifIdNo = Platform.sdbCounter(ecifId,"0000");
			  String seqNum = ecifId + ecifIdNo;
			  String ecifSn = Platform.getLogicInterfaceSequence("EC");
			  sendToEcifMap.put("transaction_sn",ecifSn);
			  //交易码（客户信息平台交易码）
			  sendToEcifMap.put("transaction_id","P001");
			  //请求方渠道号
			  sendToEcifMap.put("requester_id","ZZ");
			  //请求方机构代码，默认送总行机构码
			  sendToEcifMap.put("transaction_inst","11005293");
			  //柜员号,默认送11位数字（机构号，柜员号同发往逻辑集中部分）
			  sendToEcifMap.put("transaction_opr","99311005293");
			  //请求方交易授权柜员代码
			  sendToEcifMap.put("transaction_auth","99311005293");
			  //请求方交易日期
			  sendToEcifMap.put("transaction_date",MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			  //请求方交易时间
			  sendToEcifMap.put("transaction_time",MdaUtils.format(MdaUtils.today(),"HHmmss"));

			  //客户基本信息查询请求报文体
			  //查询类别码，暂定为3（按帐/卡号查询）
			  sendToEcifMap.put("FUN_CODE","3");
			  //卡折标志（为符合接口规范要求，暂定为0-无关）
			  sendToEcifMap.put("CARD_BOOK_FLG","0");
			  //客户账号/卡号
			  sendToEcifMap.put("ACCOUNT_NO",act);
			}
			else
			{
			  log.info("{}","收汇人账号为空，缺少向客户信息平台查询的必要条件");
			}
			return sendToEcifMap;
		}
        /**
        *   source:actreqpho.@0003.script
        */
        public void getAccountFromMessage(String message)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(! MdaUtils.isEmpty(message))
			{
			  int index = message.indexOf("59:/");
			  if(index > -1)
			  {
			    message = message.substring(index + 4);
			    index = message.indexOf("\r\n");
			    if(index > -1)
			    {
			      message = message.substring(0,index);
			      if(!MdaUtils.isEmpty(message))
			      {
			        this.setAct( message.replaceAll("[^a-zA-Z0-9]", ""));
			        
			        log.debug("{}",this.getAct());
			      }
			    }
			  }
			}
		}















}