package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.bo.Adr;
import com.ceb.gjjs.mda.bo.Pta;
import com.ceb.gjjs.mda.bo.Agb;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 代理行维护数据集合
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Agbgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Agbgrp.class);

        //是否包含mt1系列
        private String mt1;

        //是否包含mt2系列
        private String mt2;

        //是否包含mt3系列
        private String mt3;

        //是否包含mt4系列
        private String mt4;

        //是否包含mt5系列
        private String mt5;

        //是否包含mt6系列
        private String mt6;

        //是否包含mt7系列
        private String mt7;

        //是否包含mt8系列
        private String mt8;

        //是否包含mt9系列
        private String mt9;

        //是否为全密押
        private String ascflg;

        //银行BIC
        private String extkey;

        //银行英文名称
        private String engnam;

        //银行中文名称
        private String chnnam;

        //代理行
        private String bnktyp;

        //BIC
        private String bic;

        //发报比例(%):
        private String lblper;

        //币种
        private String abkcur;

        //操作结果
        private Object curres;

        //国家
        private String contry;

        //代理行的账户行优先级
        private String abkseq;

        //查询
        private IControl sel;

        //清空
        private IControl clr;

        //返回
        private IControl ret;

        //新增代理行关系
        private IControl add;

        //代理行信息修改
        private IControl ame;

        //解除代理行关系
        private IControl del;

        //提交
        private IControl submit;

        //查询
        private IControl abksel;

        //+
        private IControl abkadd;

        //-
        private IControl abkdel;

        //发报比例检验
        private IControl perchk;

        //确定
        private IControl cursur;

        //取消
        private IControl curcel;



	    @BDGetter
		private Agb rec;

	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Pta pta;

	    @BDGetter
		private Adr adr;

	    @BDGetter
		private Agbshw agbshw;

		@BDGetter
		private ModuleList<Pty> agbabk;

	    @BDGetter
		private Ptpmod ptpmod;

		@BDGetter
		private ModuleList<Pta> ptalst;

	    @BDGetter
		private Act act;


		public Agbgrp()
        {
            super();
            setArgument();
        }

        public Agbgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getPtpmod().setFlgHolder(new FieldConstantHolder<>("abk"));
        }




        /**
        *   source:agbgrp.@0000.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	代理行关系新增（代理行特有信息的维护）
			  */
			///数据域检查
			log.debug("{}","agb insert...");
			/*if(!Platform.checkAll($rec))
			  {
			  log.debug("check rec...");
			  return false;
			  }*/
			/* if(Platform.isEmpty($rec\\blkflg))
			  {
			  Platform.error($rec\\blkflg,#CT000180);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\chaflg))
			  {
			  Platform.error($rec\\chaflg,#CT000181);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\selflg))
			  {
			  Platform.error($rec\\selflg,#CT000182);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\mtaflg))
			  {
			  Platform.error($rec\\mtaflg,#CT000183);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\atmflg))
			  {
			  Platform.error($rec\\atmflg,#CT000184);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\ascflg))
			  {
			  Platform.error($rec\\ascflg,#CT000185);
			  return false;
			  }*/
			///添加代理行信息
			//Platform.mdbBegin();
			// $rec\\sceret =getTestKeyRelation();
			this.getRec().setSceret(getTestKeyRelation());
			this.getRec().setFlg( "1");
			this.getRec().setCredat( MdaUtils.today());
			String recinr = Platform.sdbCounter("rec");
			this.getRec().setInr( recinr);

			//关联所属实体
			ctx.absGet(Sysmod.class).setEtyAndPty(this.getRec());
			this.getRec().setPtyinr(this.getPty().getInr());

			Platform.mdbInsert(this.getRec());
			log.debug("{}","recinr:"+this.getRec().getInr());
			String ptytyp = this.getPty().getPtytyp();
			if(!ptytyp.contains("M"))
			{
			  ptytyp += "M";
			  this.getPty().setPtytyp( ptytyp);
			  Platform.mdbUpdate(this.getPty());
			  log.debug("{}","pty chnnam:"+this.getPty().getChnnam());
			  log.debug("{}","Errorcode:"+ctx.getErrorCode());
			  log.debug("{}","ptytyp:"+ptytyp);
			  ///添加关联代理行相关信息
			  MdaUtils.clear(this.getPta());
			  this.getPta().setInr( Platform.sdbCounter("pta"));
			  this.getPta().setPtyinr( this.getPty().getInr());
			  this.getPta().setObjinr( recinr);
			  log.debug("{}","agbgrp objinr:"+this.getPta().getObjinr());
			  this.getPta().setObjtyp( "agb");
			  log.debug("{}","agbgrp objtyp:"+this.getPta().getObjtyp());
			  log.debug("{}","rec...");
			  this.getPta().setPtatyp( "M");
			  Platform.mdbInsert(this.getPta());
			  ///添加代理行账户行信息
			  for(int i=0;i<this.getAgbabk().fullSize();i++)
			  {
			    log.info("{}","添加代理账户行信息。。。");
			    MdaUtils.clear(this.getPta());
			    this.getPta().setInr( Platform.sdbCounter("pta"));
			    this.getPta().setPtyinr( this.getPty().getInr());
			    this.getPta().setObjinr( this.getAgbabk().getElement(i).getInr());
			    this.getPta().setObjtyp( "pty");
			    this.getPta().setObjkey( this.getAgbabk().getElement(i).getNcid());//账户行币种
			    this.getPta().setPtyextkey( this.getAgbabk().getElement(i).getPntinr());
			    this.getPta().setPtatyp( "C");
			    Platform.mdbInsert(this.getPta());
			  }
			}
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.debug("{}","no error..");
			  ctx.storeData("ptyinr",this.getPty().getInr());
			  return true;
			}
			else
			{
			  return false;
			}
			/*if(Platform.errorCode() == NO_ERROR)
			  {
			  //Platform.mdbCommit();
			  // Platform.message(#CT000186,#CT000187);
			  Platform.storeData("ptyinr",$pty\\inr.getValue());
			  //Platform.returnToCaller();
			  return true;
			  }
			  else
			  {
			  Platform.mdbRollback();
			  //Platform.message(#CT000188,#CT000189);
			  return false;
			  }*/
		}
        /**
        *   source:agbgrp.@0003.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","agb update...");
			if(!ctx.checkAll(this.getRec()))
			{
			  log.debug("{}","check rec...");
			  return false;
			}
			/*if(Platform.isEmpty($rec\\blkflg))
			  {
			  Platform.error($rec\\blkflg,#CT000240);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\chaflg))
			  {
			  Platform.error($rec\\chaflg,#CT000241);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\selflg))
			  {
			  Platform.error($rec\\selflg,#CT000242);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\mtaflg))
			  {
			  Platform.error($rec\\mtaflg,#CT000243);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\atmflg))
			  {
			  Platform.error($rec\\atmflg,#CT000244);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\ascflg))
			  {
			  Platform.error($rec\\ascflg,#CT000245);
			  return false;
			  }*/
			//Platform.mdbBegin();
			this.getRec().setSceret(getTestKeyRelation());
			Platform.mdbUpdate(this.getRec());
			Platform.mdbUpdate(this.getPty());
			log.debug("{}","pty chnnam:"+this.getPty().getChnnam());
			log.debug("{}","Errorcode:"+ctx.getErrorCode());
			///代理行的账户行信息修改
			for(int i=0;i<this.getPtalst().fullSize();i++)
			{
			  Platform.mdbRead(this.getPtpmod().getPta(),new Argument<String>("inr",this.getPtalst().getElement(i).getInr()));
			  Platform.mdbDelete(this.getPtpmod().getPta());
			}
			for(int i=0;i<this.getAgbabk().fullSize();i++)
			{
			  MdaUtils.clear(this.getPtpmod().getPta());
			  this.getPtpmod().getPta().setInr( Platform.sdbCounter("pta"));
			  this.getPtpmod().getPta().setPtyinr( this.getPty().getInr());
			  this.getPtpmod().getPta().setObjinr( this.getAgbabk().getElement(i).getInr());
			  this.getPtpmod().getPta().setObjtyp( "pty");
			  this.getPtpmod().getPta().setObjkey( this.getAgbabk().getElement(i).getNcid());//账户行币种
			  this.getPtpmod().getPta().setPtyextkey( this.getAgbabk().getElement(i).getPntinr());
			  this.getPtpmod().getPta().setPtatyp( "C");
			  Platform.mdbInsert(this.getPtpmod().getPta());
			}
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  ctx.storeData("ptyinr",this.getPty().getInr());
			  return true;
			}
			else
			{
			  return false;
			}
			/*if(Platform.errorCode() == NO_ERROR)
			  {
			  Platform.mdbCommit();
			  //Platform.message(#CT000246,#CT000247);
			  Platform.storeData("ptyinr",$pty\\inr.getValue());
			  //Platform.returnToCaller();
			  return true;
			  }
			  else
			  {
			  Platform.mdbRollback();
			  //Platform.message(#CT000248,#CT000249);
			  return false;
			  }*/
		}
        /**
        *   source:agbgrp.@0004.script
        */
        public boolean delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.mdbBegin();
			log.debug("{}","agbgrp delete...");
			String ptytyp = this.getPty().getPtytyp();
			this.getPty().setPtytyp( removeAgencyOfPtytyp(ptytyp));
			Platform.mdbUpdate(this.getPty());
			this.getRec().setFlg( "0");
			log.debug("{}","delete rec:"+this.getRec().getInr());
			Platform.mdbUpdate(this.getRec());
			//代理行的账户行信息删除
			log.debug("{}","delete pta...");
			for(int i=0;i<this.getPtalst().fullSize();i++)
			{
			  log.debug("{}"," for delete pta...");
			  Platform.mdbRead(this.getPtpmod().getPta(),new Argument<String>("inr",this.getPtalst().getElement(i).getInr()));
			  Platform.mdbDelete(this.getPtpmod().getPta());
			}
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  // Platform.mdbCommit();
			  // Platform.message(#CT000254,#CT000255);
			  ctx.storeData("ptyinr",this.getPty().getInr());
			  //Platform.returnToCaller();
			  return true;
			}
			else
			{
			  // Platform.mdbRollback();
			  // Platform.message(#CT000256,#CT000257);
			  return false;
			}
		}
        /**
        *   source:agbgrp.@0005.script
        */
        public String removeAgencyOfPtytyp(String ptytyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(ptytyp))
			{
			  return ptytyp;
			}
			else
			{
			  if(ptytyp.contains("M"))
			  {
			    int index = ptytyp.indexOf("M");
			    String headStr = ptytyp.substring(0,index);
			    String tailStr = ptytyp.substring(index + 1,ptytyp.length());
			    return (headStr + tailStr);
			  }
			  else
			  {
			    return ptytyp;
			  }
			}
		}
        /**
        *   source:agbgrp.@0007.script
        */
        public String getTestKeyRelation()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	获取密押关系情况
			  *	根据checkbox的选择情况组装密押关系字段（选中为1，未选中为0）
			  */
			if(MdaUtils.isEmpty(this.getRec().getAscflg()))
			{
			  return null;
			}
			else
			{
			  String ascflg = this.getRec().getAscflg();
			  if("Y".equals(ascflg))
			  {
			    return "111111111";
			  }
			  else
			  {
			    String sceret = "";
			    String[] mtnames = {"mt1","mt2","mt3","mt4","mt5","mt6","mt7","mt8","mt9"};
			    for(int i=0;i<mtnames.length;i++)
			    {
			      String dfname = mtnames[i];
			      IDatafield<String> df = MdaDriver.getDatafield(this,dfname);
			      String value = df.getValue();
			      if("X".equals(value))
			      {
			        sceret += "1";
			      }
			      else
			      {
			        sceret += "0";
			      }
			    }
			    return sceret;
			  }
			}
		}
        /**
        *   source:agbgrp.@0008.script
        */
        public void setTestKeyRelation(String sceret)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	根据记录的密押关系值还原checkbox的状态
			  */
			String[] mtnames = {"mt1","mt2","mt3","mt4","mt5","mt6","mt7","mt8","mt9"};
			for(int i=0;i<mtnames.length;i++)
			{
			  String dfname = mtnames[i];
			  IDatafield<String> df = MdaDriver.getDatafield(this,dfname);
			  if('1' == sceret.charAt(i))
			  {
			    df.setValue("X");
			    
			  }
			}
		}












































































}