package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Adr;
import com.ceb.gjjs.mda.bo.Pta;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Bch;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Brcgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Brcgrp.class);



	    @BDGetter
		private Pty rec;

	    @BDGetter
		private Adr adr;

	    @BDGetter
		private Pta pta;

	    @BDGetter
		private Bch bch;


		public Brcgrp()
        {
            super();
            setArgument();
        }

        public Brcgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:brcgrp.@0000.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","提交");
			/*if("0".equals($rec\\brhlvl.getValue()) && checkRootBranchIsExists())
			  {
			  Platform.error($rec\\brhlvl,#CT000029);
			  return false;
			  }*/
			if(!dataChecked())
			  return false;
			this.getRec().setInr( Platform.sdbCounter("pty"));
			log.debug("{}","@@@@ pty-inr:" + this.getRec().getInr() + " @@@@");
			this.getRec().setStatus("0");
			this.getRec().setPtytyp("A");
			String adrinr = Platform.sdbCounter("adr");
			this.getAdr().setInr(adrinr);
			//log.debug("@@@@ adr-inr:" + adrinr + " @@@@");
			String ptainr = Platform.sdbCounter("pta");
			this.getPta().setInr(ptainr);
			//log.debug("@@@@ pta-inr:" + ptainr + " @@@@");
			this.getPta().setPtyinr(this.getRec().getInr());
			this.getPta().setPtytyp("2");
			this.getPta().setPtyextkey(this.getRec().getExtkey());
			this.getPta().setObjinr(adrinr);
			this.getPta().setObjtyp("adr");
			//==============设置BCH表的值==================
			setBranchData();
			//===========================================
			int errorcode = ctx.getErrorCode();
			//Platform.mdbBegin();
			Platform.mdbInsert(this.getRec());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  //Platform.message(#CT000030,#CT000031);
			  //Platform.mdbRollback();
			  return false;
			}
			Platform.mdbInsert(this.getAdr());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  //Platform.message(#CT000032,#CT000033);
			  //Platform.mdbRollback();
			  return false;
			}
			Platform.mdbInsert(this.getPta());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  //Platform.message(#CT000034,#CT000035);
			  //Platform.mdbRollback();
			  return false;
			}
			Platform.mdbInsert(this.getBch());
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			{
			  //Platform.mdbCommit();
			  //Platform.message(#CT000036,#CT000037);
			  //Platform.mchain("dblbrc");
			  return true;
			}
			else
			{
			  //Platform.message(#CT000038,#CT000039);
			  //Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:brcgrp.@0001.script
        */
        public boolean dataChecked()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean ischecked = true;
			if(MdaUtils.isEmpty(this.getRec().getCid()))
			{
			  ctx.setFieldError(this,"rec.cid",MdaUtils.getI18NString("brcgrp","CT000012"));
			  ischecked = false;
			}
			if(MdaUtils.isEmpty(this.getRec().getChnnam()))
			{
			  ctx.setFieldError(this,"rec.chnnam",MdaUtils.getI18NString("brcgrp","CT000013"));
			  ischecked = false;
			}
			//if(Platform.isEmpty($brcgrp\\rec\\brhlvl))
			//{
			//  Platform.error($brcgrp\\rec\\brhlvl,#CT000014);
			//  ischecked = false;
			//}
			if(MdaUtils.isEmpty(this.getBch().getPntbchinr()))
			{
			  //Platform.error($brcgrp\\bch\\pntbchkey,#CT000015);
			  //ischecked = false;
			}
			if(MdaUtils.isEmpty(this.getBch().getCnadr1()))
			{
			  ctx.setFieldError(this,"bch.cnadr1",MdaUtils.getI18NString("brcgrp","CT000016"));
			  ischecked = false;
			}
			if(MdaUtils.isEmpty(this.getAdr().getAdr()))
			{
			  ctx.setFieldError(this,"adr.adr",MdaUtils.getI18NString("brcgrp","CT000017"));
			  ischecked = false;
			}
			return ischecked;
		}
        /**
        *   source:brcgrp.@0002.script
        */
        public void setBranchData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getBch().getInr()))
			  this.getBch().setInr( Platform.sdbCounter("bch"));
			this.getBch().setBchkey( this.getRec().getCid());
			this.getBch().setNam( this.getRec().getChnnam());
			this.getBch().setLev( this.getRec().getBrhlvl());
			this.getBch().setTel( this.getAdr().getTel());
			this.getBch().setPtyinr( this.getRec().getInr());
			this.getBch().setSta( this.getRec().getStatus());
		}
        /**
        *   source:brcgrp.@0003.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!dataChecked())
			  return false;
			boolean insertBch = false;
			if(MdaUtils.isEmpty(this.getBch().getInr()))
			  insertBch = true;
			setBranchData();
			int errorcode = ctx.getErrorCode();
			//Platform.mdbBegin();
			Platform.mdbUpdate(this.getRec());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","update pty with errorcode:" + errorcode);
			  //Platform.message(#CT000048,#CT000049);
			  //Platform.mdbRollback();
			  return false;
			}
			Platform.mdbUpdate(this.getAdr());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","update adr with errorcode:" + errorcode);
			  //Platform.message(#CT000050,#CT000051);
			  //Platform.mdbRollback();
			  return false;
			}

			if(insertBch)
			  Platform.mdbInsert(this.getBch());
			else
			  Platform.mdbUpdate(this.getBch());
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			{
			  //Platform.message(#CT000052,#CT000053);
			  //Platform.mdbCommit();
			  //Platform.mchain("dblbrc");
			  return true;
			}
			else
			{
			  //Platform.message(#CT000054,#CT000055);
			  //Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:brcgrp.@0004.script
        */
        public boolean delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getRec().setStatus("1");
			int errorcode = ctx.getErrorCode();
			//Platform.mdbBegin();
			Platform.mdbUpdate(this.getRec());
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			{
			  if(!MdaUtils.isEmpty(this.getBch().getInr()))
			  {
			    this.getBch().setSta( this.getRec().getStatus());
			    Platform.mdbUpdate(this.getBch());
			    errorcode = ctx.getErrorCode();
			    if(errorcode != NO_ERROR)
			    {
			      //Platform.message(#CT000086,#CT000087);
			      //Platform.mdbRollback();
			      return false;
			    }
			  }
			  //Platform.mdbCommit();
			  //Platform.message(#CT000088,#CT000089);
			  //Platform.mchain("dblbrc");
			  //Platform.returnToCaller();
			  return true;
			}
			else
			{
			  //Platform.message(#CT000090,#CT000091);
			  //Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:brcgrp.@0005.script
        */
        public boolean checkRootBranchIsExists()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument<String> inr = new Argument<String>("inr");
			Platform.mdbExecuteSQL("select inr from bch where lev = '0'");
			Platform.mdbFetchFields(inr);
			Platform.mdbCloseCursor();
			log.debug("{}","inr:" + inr.value);
			if(!MdaUtils.isEmpty(inr))
			  return true;
			else
			  return false;
		}





}