package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ety;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Brcp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Brcp.class);

        //提交
        private IControl submit;

        //清空
        private IControl clr;

        //查询
        private IControl sel;

        //上级机构
        private String pntinr;

        //机构代码
        private String cid;

        //BIC
        private String extkey;

        //标题
        private String tit;

        //机构名称
        private String nam;

        //机构注册
        private IControl add;

        //机构修改
        private IControl ame;

        //机构注销
        private IControl del;

        //返回
        private IControl cancel;

        //详情
        private IControl inf;

        //导入
        private IStream imp = new StreamImpl();

        //测试
        private IControl txt;

        //类型
        private String ptytyp;

        //下一步
        private IControl next;


        @JsonIgnore
        @BDGetter
        private transient IPanel ptyp;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptylstp;

        @JsonIgnore
        @BDGetter
        private transient IPanel serp;

        @JsonIgnore
        @BDGetter
        private transient IPanel inqp;

        @JsonIgnore
        @BDGetter
        private transient IPanel edip;

        @JsonIgnore
        @BDGetter
        private transient IPanel brcp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel brcp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel brcp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel brcp04;


		@BDGetter
		private ModuleList<Pty> ptylst;

	    @BDGetter
		private Ptyshw ptyshw;

		@BDGetter
		private ModuleList<Ptyshw> ptyshwlst;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Ptygrp> ptygrp;

		@BDGetter
		private ModuleList<Ety> etylst;


		public Brcp()
        {
            super();
            setArgument();
        }

        public Brcp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:brcp.@0011.script
        */
        @Rule(target="mtabut.htymod.hty",order=100)
        public boolean ruleMtabutHtymodHtyN100(){
            IContext ctx = MdaEnv.getContext();
            

			MdaUtils.clear(this.getMtabut().getHtymod().getLst());
			String objinr="";
			ctx.getDaoSession().dbConnect();
			if(!MdaUtils.isEmpty(this.getPtygrp().getRec().getInr()))
			{
			  objinr = this.getPtygrp().getRec().getInr();
			}
			Argument<Date> dattim =new Argument<Date>("dattim");
			Argument<String> usr =new Argument<String>("usr");
			Argument<String> txt =new Argument<String>("txt");
			String sql="";
			sql="select dattim,usr,dbms_lob.substr(txt) txt from sme where (frmnam='dbebrc' or frmnam='dbabrc') and objinr=? order by dattim ";
			log.debug("{}","[objinr] "+objinr);
			ctx.getDaoSession().dbExecuteSQL(sql,objinr);

			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(dattim,usr,txt);
			  int error =ctx.getErrorCode();
			  if(error==NO_ERROR)
			  {
			    this.getMtabut().getHtymod().getLst().add(dattim,usr,txt);
			  }

			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			ctx.getDaoSession().dbDisconnect();
			
			

			return true;
        }

        /**
        *   source:brcp.@0013.script
        */
        @Rule(target="mtabut.submit",order=1001)
        public boolean ruleMtabutSubmitN1001(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","submit 1001");
			Map lstbrcMap = new HashMap();
			lstbrcMap.put("inr", this.getPtygrp().getRec().getInr());
			lstbrcMap.put("cid", this.getPtygrp().getRec().getCid());
			lstbrcMap.put("extkey", this.getPtygrp().getRec().getExtkey());
			lstbrcMap.put("chnnam", this.getPtygrp().getRec().getChnnam());
			//lstbrcMap.put("brhlvl", $ptygrp\\rec\\brhlvl.getValue());
			lstbrcMap.put("lnknam", this.getPtygrp().getAdr().getLnknam());
			//lstbrcMap.put("pntbchinr", $ptygrp\\bch\\pntbchinr.getValue());
			lstbrcMap.put("fax", this.getPtygrp().getBch().getFax());
			lstbrcMap.put("tel", this.getPtygrp().getAdr().getTel());
			lstbrcMap.put("decnum", this.getPtygrp().getBch().getDecnum());
			lstbrcMap.put("branch", this.getPtygrp().getBch().getBranch());
			lstbrcMap.put("poscod", this.getPtygrp().getBch().getPoscod());
			//lstbrcMap.put("etyinr", $ptygrp\\rec\\etyinr.getValue());
			lstbrcMap.put("cnadr1", this.getPtygrp().getBch().getCnadr1());
			lstbrcMap.put("adr", this.getPtygrp().getAdr().getAdr());

			ctx.storeData("lstbrcMap",lstbrcMap);


			return true;
        }


        /**
        *   source:brcp.@0004.script
        */
        @Check(target="extkey",order=100)
        public boolean checkExtkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getExtkey()))
			  return true;
			String bak = this.getExtkey();
			bak = bak.toUpperCase();
			if(!bak.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"extkey",MdaUtils.getI18NString("brcp","CT000120"));
			}
			this.setExtkey( bak);
			

			return true;
        }

        /**
        *   source:brcp.@0009.script
        */
        @Check(target="ptygrp.rec.brhlvl",order=100)
        public boolean checkPtygrpRecBrhlvlN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPtygrp().getBch().setPntbchinr(NULLSTR);
			MdaUtils.setValues(this.getPtygrp().getBch(),"pntbchinr",getPntInr(this.getPtygrp().getRec().getBrhlvl()));
			

			return true;
        }

        /**
        *   source:brcp.@0012.script
        */
        @Check(target="cid",order=100)
        public boolean checkCidN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCid()))
			  return true;
			String bak = this.getCid();
			bak = bak.toUpperCase();
			if(!bak.matches("[A-Z0-9]*"))
			{
			  ctx.setFieldError(this,"cid",MdaUtils.getI18NString("brcp","CT000237"));
			}
			this.setCid( bak);
			

			return true;
        }

        /**
        *   source:brcp.@0014.script
        */
        @Check(target="ptygrp.adr.lnknam",order=100)
        public boolean checkPtygrpAdrLnknamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getAdr().getLnknam()))
			{
			  ctx.setFieldError(this,"ptygrp.adr.lnknam",MdaUtils.getI18NString("brcp","CT000238"));
			  return false;
			}

			return true;
        }

        /**
        *   source:brcp.@0015.script
        */
        @Check(target="ptygrp.bch.fax",order=100)
        public boolean checkPtygrpBchFaxN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getFax()))
			{
			  ctx.setFieldError(this,"ptygrp.bch.fax",MdaUtils.getI18NString("brcp","CT000239"));
			  return false;
			}

			return true;
        }

        /**
        *   source:brcp.@0016.script
        */
        @Check(target="ptygrp.bch.decnum",order=100)
        public boolean checkPtygrpBchDecnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getDecnum()))
			{
			  ctx.setFieldError(this,"ptygrp.bch.decnum",MdaUtils.getI18NString("brcp","CT000240"));
			  return false;
			}

			return true;
        }

        /**
        *   source:brcp.@0017.script
        */
        @Check(target="ptygrp.bch.poscod",order=100)
        public boolean checkPtygrpBchPoscodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getPoscod()))
			{
			  ctx.setFieldError(this,"ptygrp.bch.poscod",MdaUtils.getI18NString("brcp","CT000241"));
			  return false;
			}

			return true;
        }

        /**
        *   source:brcp.@0018.script
        */
        @Check(target="ptygrp.bch.pntbchinr",order=100)
        public boolean checkPtygrpBchPntbchinrN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:brcp.@0019.script
        */
        @Check(target="ptygrp.adr.tel",order=100)
        public boolean checkPtygrpAdrTelN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPtygrp().getAdr().getTel()))
			{
			  ctx.setFieldError(this,"ptygrp.adr.tel",MdaUtils.getI18NString("brcp","CT000243"));
			  return false;
			}

			return true;
        }


        /**
        *   source:brcp.@0008.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Map brcMap = new HashMap();
			brcMap.put("inr", this.getPtygrp().getRec().getInr());
			brcMap.put("cid", this.getPtygrp().getRec().getCid());
			brcMap.put("extkey", this.getPtygrp().getRec().getExtkey());
			brcMap.put("chnnam", this.getPtygrp().getRec().getChnnam());
			//brcMap.put("brhlvl", $ptygrp\\rec\\brhlvl.getValue());
			brcMap.put("lnknam", this.getPtygrp().getAdr().getLnknam());
			//brcMap.put("pntbchinr", $ptygrp\\bch\\pntbchinr.getValue());
			brcMap.put("fax", this.getPtygrp().getBch().getFax());
			brcMap.put("tel", this.getPtygrp().getAdr().getTel());
			brcMap.put("decnum", this.getPtygrp().getBch().getDecnum());
			brcMap.put("branch", this.getPtygrp().getBch().getBranch());
			brcMap.put("poscod", this.getPtygrp().getBch().getPoscod());
			//brcMap.put("etyinr", $ptygrp\\rec\\etyinr.getValue());
			brcMap.put("cnadr1", this.getPtygrp().getBch().getCnadr1());
			brcMap.put("adr", this.getPtygrp().getAdr().getAdr());

			ctx.storeData("brcMap",brcMap);
			//Platform.setValues($brcgrp\\bch\\pntbchinr,items)
			if(!MdaUtils.isEmpty(this.getPtygrp().getRec().getBrhlvl()))
			  MdaUtils.setValues(this.getPtygrp().getBch(),"pntbchinr",getPntInr(this.getPtygrp().getRec().getBrhlvl()));

			//初始化所属实体码表
			List<CodetableItem> cts = getEtyCT();
			MdaUtils.setValues(this.getPtygrp().getRec(),"etyinr",cts);
			this.getPtygrp().getRec().setEtyinr(ctx.absGet(Sysmod.class).getEty().getInr());
			//Platform.disable($ptygrp\\rec\\etyinr);
			/*
			  if(!"dbabrc".equals(Platform.sgetTransName()))
			  {
			  Platform.disable($ptygrp\\rec\\etyinr);
			  }
			  */
			Object obj=ctx.restoreData("handleTemp");
			if(obj!=null)
			{
			  ctx.postRule(this,"sel");
			}

			return true;
        }


        /**
        *   source:brcp.@0000.script
        */
        public List<CodetableItem> getPtyCT()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> cts = new ArrayList<CodetableItem>();
			Platform.mdbReadset(this.getPtylst(),new Argument<String>("ptytyp","A"));
			//log.debug("@@@@ ptylst-size:" + $ptylst.fullSize() + " @@@@");
			for(int i=0;i<this.getPtylst().fullSize();i++)
			{
			  String inr = this.getPtylst().getElement(i).getInr();
			  String nam = this.getPtylst().getElement(i).getNam();
			  CodetableItem cti = new CodetableItem(nam,inr);
			  cts.add(cti);
			}
			//log.debug("@@@@ codetable-size:"+cts.size() + " @@@@");
			return cts;
		}
        /**
        *   source:brcp.@0005.script
        */
        public boolean dataChecked()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean ischecked = true;
			if(MdaUtils.isEmpty(this.getPtygrp().getRec().getCid()))
			{
			  ctx.setFieldError(this,"ptygrp.rec.cid",MdaUtils.getI18NString("brcp","CT000148"));
			  ischecked = false;
			}
			if(MdaUtils.isEmpty(this.getPtygrp().getRec().getChnnam()))
			{
			  ctx.setFieldError(this,"ptygrp.rec.chnnam",MdaUtils.getI18NString("brcp","CT000149"));
			  ischecked = false;
			}
			//if(Platform.isEmpty($brcgrp\\rec\\brhlvl))
			//{
			//  Platform.error($brcgrp\\rec\\brhlvl,#CT000150);
			//  ischecked = false;
			//}
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getPntbchinr()))
			{
			  //Platform.error($brcgrp\\bch\\pntbchkey,#CT000151);
			  //ischecked = false;
			}
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getCnadr1()))
			{
			  ctx.setFieldError(this,"ptygrp.bch.cnadr1",MdaUtils.getI18NString("brcp","CT000156"));
			  ischecked = false;
			}
			if(MdaUtils.isEmpty(this.getPtygrp().getAdr().getAdr()))
			{
			  ctx.setFieldError(this,"ptygrp.adr.adr",MdaUtils.getI18NString("brcp","CT000162"));
			  ischecked = false;
			}
			return ischecked;
		}
        /**
        *   source:brcp.@0006.script
        */
        public void setBranchData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getPtygrp().getBch().getInr()))
			  this.getPtygrp().getBch().setInr( Platform.sdbCounter("bch"));
			this.getPtygrp().getBch().setBchkey( this.getPtygrp().getRec().getCid());
			this.getPtygrp().getBch().setNam( this.getPtygrp().getRec().getChnnam());
			this.getPtygrp().getBch().setLev( this.getPtygrp().getRec().getBrhlvl());
			this.getPtygrp().getBch().setTel( this.getPtygrp().getAdr().getTel());
			this.getPtygrp().getBch().setPtyinr( this.getPtygrp().getRec().getInr());
			this.getPtygrp().getBch().setSta( this.getPtygrp().getRec().getStatus());
		}
        /**
        *   source:brcp.@0007.script
        */
        public List<CodetableItem> getPntInr(String level)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sqlQuery = "SELECT INR,BCHKEY,NAM FROM BCH WHERE STA = '0' AND LEV = ? ";
			String targetLevel = "0";
			List<CodetableItem> ct = new ArrayList<CodetableItem>();
			if("2".equals(level))
			  targetLevel = "1";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> branch = new Argument<String>("bchkey");
			Argument<String> nam = new Argument<String>("nam");
			int errorcode = ctx.getErrorCode();
			Platform.mdbExecuteSQL(sqlQuery,targetLevel);
			while(true)
			{
			  Platform.mdbFetchFields(inr,branch,nam);
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			    break;
			  log.debug("{}",inr.value);
			  log.debug("{}",branch.value);
			  log.trace("{}",nam.value);
			  CodetableItem c = new CodetableItem(branch.value.toString().trim() + "-" + nam.value.toString().trim(),inr.value);
			  ct.add(c);
			}
			Platform.mdbCloseCursor();
			return ct;
		}
        /**
        *   source:brcp.@0010.script
        */
        public List<CodetableItem> getEtyCT()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> cts = new ArrayList<CodetableItem>();
			MdaUtils.clear(this.getEtylst());
			Platform.mdbReadset(this.getEtylst(),new Argument<String>("sta",EQ,"0"));
			log.debug("{}","@@@@ etylst-size:" + this.getEtylst().fullSize() + " @@@@");
			for(int i=0;i<this.getEtylst().fullSize();i++)
			{
			  String inr = this.getEtylst().getElement(i).getInr();
			  String ref = this.getEtylst().getElement(i).getRef();
			  String etynam = this.getEtylst().getElement(i).getEtynam();
			  CodetableItem cti = new CodetableItem(ref+" "+etynam,inr);
			  cts.add(cti);
			}
			log.debug("{}","@@@@ codetable-size:"+cts.size() + " @@@@");
			return cts;
		}





        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }


        public void setPtygrpHolder(ModuleHolder<Ptygrp> ptygrp)
        {
            this.ptygrp = ptygrp;
        }

        public Ptygrp getPtygrp()
        {
           return this.ptygrp.get();
        }




































}