package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Csnp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Csnp.class);

        //查询
        private IControl sel;

        //清除
        private IControl del;

        //关系绑定
        private IControl relbud;

        //发起节点代码
        private String bnkbic;

        //证书CN
        private String cn;

        //证书SN
        private String sn;

        //证书变更类型
        private String csntyp;

        //提交
        private IControl submit;

        //返回
        private IControl rtn;

        //删除
        private IControl shanchu;

        //修改
        private IControl ame;

        //增加
        private IControl add;

        //业务参考号
        private String ownref;

        //报文类型
        private String subtyp;

        //委托日期
        private Date gendat;

        //附言
        private String rem;

        //起始时间
        private Date begdat;

        //截止时间
        private Date enddat;

        //主键
        private String inr;

        //当前日期
        private Date valdat;

        //变更参与机构行号
        private String chgbic;

        //变更机构文本
        private String chgtxt;

        //业务类型
        private String typ;

        //报文标识号
        private String msgcod;

        //报文参考号
        private String msgref;

        //报文发起方
        private String sndnam;

        //报文接收方
        private String rcvnam;

        //确定
        private IControl qur;

        //下载申请
        private IControl dwnreq;

        //报文标识号
        private String dwnref;

        //报文类型
        private String dwntyp;

        //直接参与者行号
        private String dwnbic;

        //收报行
        private String dwnrcvbic;

        //确认
        private IControl dwnqur;

        //返回
        private IControl dwnrtn;

        //报文发起日期
        private Date dwnsnddat;

        //发起直接参与机构
        private String snddirpty;

        //发起参与机构
        private String sndpty;

        //接收直接参与机构
        private String rcvdirpty;

        //接收参与机构
        private String rcvpty;

        //电证证书绑定
        private IControl comfirm;

        //电证返回
        private IControl elcrtn;

        //电证证书类型
        private String chgtp;

        //动态面板
        private IPanel dypanel;

        //证书同步
        private IControl upload;

        //福费廷新增
        private IControl fftadd;

        //福费廷证书确认
        private IControl fftqur;

        //福费廷证书返回
        private IControl fftrtn;

        //919证书申请
        private IControl certreq;

        //确定
        private IControl sure919;

        //开通902
        private IControl kt902;

        //取消902
        private IControl qx902;

        //权限类型
        private String qxxtyp;

        //确定
        private IControl sure902;

        //qxxflg
        private String qxxflg;

        //下载类型
        private String dwn919typ;

        //903证书申请
        private IControl kt903;

        //报文标识号
        private String msgid;

        //发起直接参与机构
        private String instgdrctpty;

        //发起参与机构
        private String instgpty;

        //接收直接参与机构
        private String instddrctpty;

        //接收参与机构
        private String instdpty;

        //报文类型
        private String type;

        //确定
        private IControl submit903;

        //返回
        private IControl cancel903;

        //备注
        private String rmk;

        //变更类型
        private String chgtyp;

        //下载类型
        private String down919typ;

        //确定
        private IControl submit919;

        //919证书下载申请
        private IControl kt919;

        //系统编号
        private String syscd;

        //直接参与机构编号
        private String mmbcd;

        //下载申请
        private IControl dwn919;

        //接入机构标识码
        private String cfixbankcode;

        //cfix证书申请按钮
        private IControl cfixzssqbtn;

        //变更类型
        private String cfixchgtp;

        //证书广播按钮
        private IControl cfixgbbtn;


        @JsonIgnore
        @BDGetter
        private transient IPanel mainpl;

        @JsonIgnore
        @BDGetter
        private transient IPanel lftpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgtpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel addpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel subpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel lowpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgman;

        @JsonIgnore
        @BDGetter
        private transient IPanel shwpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpspnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel dwnreqpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel elcpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel elclst;

        @JsonIgnore
        @BDGetter
        private transient IPanel csnlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel lcfshpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel qxxpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel fmtpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel apply919;

        @JsonIgnore
        @BDGetter
        private transient IPanel cfixzssq;

        @JsonIgnore
        @BDGetter
        private transient IPanel cfixgbp;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Csngrp> csngrp;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;

	    @BDGetter
		private Smpmod smpmod;

	    @BDGetter
		private Msgmod msgmod;


		public Csnp()
        {
            super();
            setArgument();
        }

        public Csnp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:csnp.@0001.script
        */
        @Rule(target="rtn",order=100)
        public boolean ruleRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:csnp.@0003.script
        */
        @Rule(target="rtn",order=50)
        public boolean ruleRtnN50(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:csnp.@0004.script
        */
        @Rule(target="add",order=100)
        public boolean ruleAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			//数据库更新
			//判断变更类型
			if(this.getCsngrp().getCsn().getCsntyp().equals("3"))
			{
			  ctx.getDaoSession().dbBegin();
			  this.setValdat( this.getValdat());
			  ctx.getDaoSession().dbUpdate(this.getCsngrp().getCsn());
			  ctx.getDaoSession().dbCommit();
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000056"),MdaUtils.getI18NString("csnp","CT000057"));
			}
			/*
			  Object[] csn = new Object[7];
			  csn[0] = "0088";//任务号
			  String inr = Platform.sdbCounter("FMT088","000000");
			  int dbInr = Platform.parseInt(inr);
			  dbInr = dbInr + 1;
			  csn[1] = String.format("%06d",dbInr);
			  csn[2] = $ownref.getValue();//申请序号
			  csn[3] = Platform.format($valdat.getValue(),"yyyyMMdd");//委托日期，8位String
			  csn[4] = $csngrp\\csn\\bnkbic.getValue();//发送节点代码，默认本行BIC
			  csn[5] = $csngrp\\csn\\csntyp.getValue();//变更类型，1-新增，2-撤销，3-变更
			  csn[6] = $csngrp\\csn\\rem.getValue();
			  Object obj = Platform.invoke("com.brilliance.eibs.main.Client","scall","PackageFmt","088",csn);
			  Boolean obt = (Boolean)Platform.invoke(obj,"isSuccess");
			  log.debug("obt-------"+obt);
			  */
			/*
			  if(!obt)
			  {
			  Platform.message(#CT000058,#CT000059);
			  return false;
			  }
			  //获取接口平台返回的内容
			  Object data = Platform.invoke(obj,"getContent");//报文内容
			  log.debug("088rtndata========"+data);
			  Platform.mdbBegin();
			  */
			/*if(!$this.storeMsgFromPlat(json))
			  {
			  Platform.message(#CT000060,#CT000061);
			  Platform.mdbRollback();
			  return false;
			  }
			  else
			  {
			  Platform.message(#CT000062,#CT000063);
			  }*/
			/*
			  log.debug("1.csn inr "+$inr.getValue());
			  //Platform.clear($csngrp\\csn);
			  int errorcode = Platform.errorCode();
			  //Platform.mdbBegin();
			  if("23".contains($csngrp\\csn\\csntyp.getValue()))
			  {
			  Platform.clear($csngrp\\csn);
			  Platform.mdbRead($csngrp\\csn,new Argument<String>("inr",$inr.getValue()));
			  log.debug("2.csn inr "+$csngrp\\csn\\inr.getValue());
			  $csngrp\\csn\\csntyp = (String)csn[5];
			  $csngrp\\csn\\sta = "00";//未审核
			  $csngrp\\csn\\gendat = Platform.today();
			  log.debug("rel mpiinr:"+$smpmod\\mpi\\inr.getValue());
			  */
			/*if(!Platform.isEmpty($csngrp\\csn\\relinr.getValue()))
			  {
			  if(!Platform.isEmpty($smpmod\\mpi\\inr.getValue()))
			  {
			  $csngrp\\csn\\relinr = $csngrp\\csn\\relinr +" ,chginr:"+$smpmod\\mpi\\inr;//关联mpi主键
			  }
			  }
			  else
			  {
			  if(!Platform.isEmpty($smpmod\\mpi\\inr.getValue()))
			  {
			  $csngrp\\csn\\relinr = "chginr:"+$smpmod\\mpi\\inr;//关联mpi主键
			  }
			  }*/
			/*
			  if(!Platform.isEmpty($smpmod\\mpi\\inr.getValue()))
			  {
			  $csngrp\\csn\\relinr = $smpmod\\mpi\\inr;//关联mpi主键
			  //$csngrp\\csn\\relinr = "chginr:"+$smpmod\\mpi\\inr;//关联mpi主键
			  }
			  $csngrp\\csn\\rem = (String)csn[6];
			  Platform.mdbUpdate($csngrp\\csn);
			  }
			  else
			  {
			  Platform.clear($csngrp\\csn);
			  $csngrp\\csn\\csntyp = (String)csn[5];
			  $csngrp\\csn\\sta = "00";//未审核
			  $csngrp\\csn\\bnkbic = (String)csn[4];
			  $csngrp\\csn\\gendat = Platform.today();
			  $csngrp\\csn\\subtyp = "088";
			  if(!Platform.isEmpty($smpmod\\mpi\\inr.getValue()))
			  {
			  //$csngrp\\csn\\relinr = "addinr:"+$smpmod\\mpi\\inr;//关联mpi主键
			  $csngrp\\csn\\relinr = $smpmod\\mpi\\inr;//关联mpi主键
			  }
			  //$csngrp\\csn\\relinr = "addinr:"+$smpmod\\mpi\\inr;
			  $csngrp\\csn\\rem = (String)csn[6];
			  Platform.sdbInsert($csngrp\\csn);
			  }
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT000064,#CT000065);
			  return false;
			  }
			  Platform.mdbCommit();
			  errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT000585,#CT000586);
			  Platform.mdbRollback();
			  return false;
			  }
			  else
			  {
			  log.debug("Number Certificate Change Successfully");
			  Platform.returnToCaller();
			  }
			  */

			return true;
        }

        /**
        *   source:csnp.@0007.script
        */
        @Rule(target="add",order=50)
        public boolean ruleAddN50(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(ctx.getRoot()))
			{
			  return false;
			}


			return true;
        }

        /**
        *   source:csnp.@0009.script
        */
        @Rule(target="rtn",order=70)
        public boolean ruleRtnN70(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:csnp.@0010.script
        */
        @Rule(target="qur",order=100)
        public boolean ruleQurN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mdbBegin();
			String result = null;
			Map map = new HashMap();
			map.put("MsgId",this.getMsgcod());      //报文标识号
			map.put("HMsgRef",this.getMsgref());    //报文参考号
			map.put("HSender",this.getSndnam());    //报文发起方
			map.put("HReceiver",this.getRcvnam());  //报文接收方
			map.put("HSendDate",this.getValdat());  //报文发起日期
			String dattim = MdaUtils.format(MdaUtils.today(),"yyyy-MM-ddhh:mm:ss");
			map.put("CreDtTm",dattim.substring(0,10)+"T"+dattim.substring(10));//报文发送时间
			map.put("Tp",this.getSubtyp());         //报文类型
			map.put("ChgTp",this.getCsntyp());      //变更类型
			map.put("MmbId",this.getSndnam());      //变更参与机构行号
			Object[] obj = new Object[1];
			obj[0] = map;
			//调用接口平台
			//interfaceName(接口平台文件名,接口名)+transactionName(接口下的交易名)
			Object msg = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","cipsloginout","loginout",obj);
			log.info("{}","[CIPS_INVOKE_CLASS]:"+msg);
			Boolean obt = (Boolean)MdaUtils.invoke(msg,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000145"),MdaUtils.getI18NString("csnp","CT000146"));
			  return false;
			}
			//获取接口平台返回的内容
			Object[] data = (Object[])MdaUtils.invoke(msg,"getContent");//报文内容
			String jsonMessage = (String)data[0];//转换后的json串
			log.debug("{}","CIPS json:"+jsonMessage);
			if(!storeMsgFromPlatForCips(jsonMessage))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000147"),MdaUtils.getI18NString("csnp","CT000148"));
			  return false;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000149"),MdaUtils.getI18NString("csnp","CT000150"));
			}
			int errorcode = ctx.getErrorCode();
			Platform.mdbBegin();
			MdaUtils.clear(this.getCsngrp().getCsn());
			this.getCsngrp().getCsn().setCsntyp( this.getCsntyp());
			this.getCsngrp().getCsn().setSta( "00");//未审核
			this.getCsngrp().getCsn().setBnkbic( this.getSndnam());
			this.getCsngrp().getCsn().setGendat( MdaUtils.today());
			this.getCsngrp().getCsn().setSubtyp( "903");
			this.getCsngrp().getCsn().setRem( "数字证书新增操作");
			this.getCsngrp().getCsn().setChgbic( this.getSndnam());
			if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getInr()))
			{
			  this.getCsngrp().getCsn().setRelinr( this.getSmpmod().getMps().getInr());//关联mpi主键
			}
			this.getCsngrp().getCsn().setTyp( "1");
			Platform.sdbInsert(this.getCsngrp().getCsn());
			log.debug("{}","1.csn inr "+this.getCsngrp().getCsn().getInr());
			if(errorcode != NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000151"),MdaUtils.getI18NString("csnp","CT000152"));
			  return false;
			}
			Platform.mdbCommit();
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000153"),MdaUtils.getI18NString("csnp","CT000154"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.debug("{}","Number Certificate Change Successfully");
			  
			}

			return true;
        }

        /**
        *   source:csnp.@0011.script
        */
        @Rule(target="qur",order=50)
        public boolean ruleQurN50(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRcvnam()))
			{
			  ctx.setFieldError(this,"rcvnam",MdaUtils.getI18NString("csnp","CT000157"));
			  return false;
			}
			String bic = this.getRcvnam();
			bic = bic.toUpperCase();
			if(!bic.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"rcvnam",MdaUtils.getI18NString("csnp","CT000158"));
			  return false;
			}
			this.setRcvnam( bic);
			

			return true;
        }

        /**
        *   source:csnp.@0013.script
        */
        @Rule(target="dwnreq",order=100)
        public boolean ruleDwnreqN100(){
            IContext ctx = MdaEnv.getContext();
            
			String own = "C" + MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			this.setDwnref( own);
			this.setDwntyp( "cips.914.001.01");
			this.setDwnsnddat( MdaUtils.parseDate(MdaUtils.format(MdaUtils.today(),"yyyyMMdd"),"yyyyMMdd"));
			Platform.disableDatafield(MdaDriver.getDatafield(this,"dwnref"));
			Platform.disableDatafield(MdaDriver.getDatafield(this,"dwntyp"));
			


			return true;
        }

        /**
        *   source:csnp.@0014.script
        */
        @Rule(target="dwnrtn",order=100)
        public boolean ruleDwnrtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:csnp.@0015.script
        */
        @Rule(target="dwnqur",order=100)
        public boolean ruleDwnqurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDwnrcvbic()))
			{
			  ctx.setFieldError(this,"dwnrcvbic",MdaUtils.getI18NString("csnp","CT000168"));
			  return false;
			}
			String bic = this.getDwnrcvbic();
			bic = bic.toUpperCase();
			if(!bic.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"dwnrcvbic",MdaUtils.getI18NString("csnp","CT000169"));
			  return false;
			}
			this.setDwnrcvbic( bic);
			

			if(MdaUtils.isEmpty(this.getDwnbic()))
			{
			  ctx.setFieldError(this,"dwnbic",MdaUtils.getI18NString("csnp","CT000170"));
			  return false;
			}
			String bic1 = this.getDwnbic();
			bic1 = bic1.toUpperCase();
			if(!bic1.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"dwnbic",MdaUtils.getI18NString("csnp","CT000171"));
			  return false;
			}
			this.setDwnbic( bic1);
			

			return true;
        }

        /**
        *   source:csnp.@0016.script
        */
        @Rule(target="dwnqur",order=200)
        public boolean ruleDwnqurN200(){
            IContext ctx = MdaEnv.getContext();
            
			String result = null;
			Map map = new HashMap();
			map.put("MsgId",this.getDwnref());      //报文标识号
			map.put("HMsgRef","NONE");    //报文参考号
			map.put("HSender","PSBCCNBJXXX");    //报文发起方
			map.put("HReceiver",this.getDwnrcvbic());  //报文接收方
			map.put("HSendDate",MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));  //报文发起日期
			map.put("Tp",this.getDwntyp());         //报文类型
			/* String dattim = Platform.format(Platform.today(),"yyyy-MM-ddhh:mm:ss");
			  map.put("CreDtTm",dattim.substring(0,10)+"T"+dattim.substring(10));//报文发送时间,yyyy-mm-ddTHH:MM:SS
			  */
			map.put("CertfctnCnt","1");      //申请数字证书数目
			String[] str = new String[1];
			str[0] = this.getDwnbic();
			map.put("MmbCd",str);  //直接参与机构号
			Object[] obj = new Object[1];
			obj[0] = map;
			Object msg = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","cipsloginout","loginout",obj);
			Boolean obt = (Boolean)MdaUtils.invoke(msg,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000196"),MdaUtils.getI18NString("csnp","CT000197"));
			  return false;
			}
			//获取接口平台返回的内容
			Object[] data = (Object[])MdaUtils.invoke(msg,"getContent");//报文内容
			String jsonMessage = (String)data[0];//转换后的json串
			log.debug("{}","CIPS json:"+jsonMessage);
			if(!storeMsgFromPlatCips(jsonMessage))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000198"),MdaUtils.getI18NString("csnp","CT000199"));
			  return false;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000200"),MdaUtils.getI18NString("csnp","CT000201"));
			  
			}

			return true;
        }

        /**
        *   source:csnp.@0019.script
        */
        @Rule(target="elcrtn",order=100)
        public boolean ruleElcrtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			String s ="{\"OrigSendTime\":"
			  +"\""+MdaUtils.format(MdaUtils.today(),"HHmmss")+"\""
			  +",\"CertNtfctnInf\":{\"ChgTp\":"+"\""+this.getChgtp()+"\""
			  +"},\"GrpHdr\":{";
			if(!MdaUtils.isEmpty(this.getRem()))
			{
			  s+="\"Rmk\":"+"\""+this.getRem()+"\",";
			}
			s+="\"SysCd\":\"ELCS\",\"CreDtTm\":"
			  +"\""+MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd")+"T"
			  +MdaUtils.format(MdaUtils.today(),"HH:mm:ss")+"\""
			  +",\"InstdPty\":{\"InstdDrctPty\":"+"\""+this.getRcvdirpty()+"\""
			  +",\"InstdPty\":"+"\""+this.getRcvpty()+"\""
			  +"},\"InstgPty\":{\"InstgPty\":"+"\""+this.getSndpty()+"\""
			  +",\"InstgDrctPty\":"+"\""+this.getSnddirpty()+"\""
			  +"},\"MsgId\":"+"\""+this.getMsgcod()+"\""
			  +"},\"OrigSender\":\""+"403100000004"+"\""
			  +",\"MesgType\":\""+"ccms.903.001.02"+"\""
			  +",\"OrigReceiver\":\""+this.getRcvdirpty()+"\""
			  +",\"OrigSendDate\":\""+MdaUtils.format(MdaUtils.today(),"yyyyMMdd")+"\""
			  +",\"MesgDirection\":\"U\""
			  +",\"MesgRefID\":\""+this.getMsgcod()+"\""
			  +",\"MesgID\":\""+this.getRcvdirpty()+"\"}";

			log.debug("{}","[903_JSON]"+s);

			return true;
        }

        /**
        *   source:csnp.@0020.script
        */
        @Rule(target="comfirm",order=100)
        public boolean ruleComfirmN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.parseDate("","");
			log.debug("{}","[DB_BEGIN]");
			Platform.mdbBegin();
			log.debug("{}","[CREATE_903]");
			/*
			  //测试代码,测试后删除
			  String elcsMsg ="{\\"OrigSendTime\\":"
			  +"\\""+"010000"+"\\""
			  +",\\"CertNtfctnInf\\":{\\"ChgTp\\":"+"\\""+$chgtp+"\\""
			  +"},\\"GrpHdr\\":{\\"Rmk\\":"+"\\""+"TTTT"+"\\""
			  +",\\"SysCd\\":\\"ELCS\\",\\"CreDtTm\\":"
			  +"\\""+"2020-10-11"+"T"
			  +"14:10:00"+"\\""
			  +",\\"InstdPty\\":{\\"InstdDrctPty\\":"+"\\""+"testpty"+"\\""
			  +",\\"InstdPty\\":"+"\\""+"testpty"+"\\""
			  +"},\\"InstgPty\\":{\\"InstgPty\\":"+"\\""+"testpty"+"\\""
			  +",\\"InstgDrctPty\\":"+"\\""+"testpty"+"\\""
			  +"},\\"MsgId\\":"+"\\""+$msgcod.getValue()+"\\""
			  +"},\\"OrigSender\\":\\""+"testpty"+"\\""
			  +",\\"MesgType\\":\\""+"ccms.903.001.02"+"\\""
			  +",\\"OrigReceiver\\":\\""+"testpty"+"\\""
			  +",\\"OrigSendDate\\":\\""+"20201011"+"\\""
			  +",\\"MesgDirection\\":\\"U\\""
			  +",\\"MesgRefID\\":\\""+$msgcod.getValue()+"\\""
			  +",\\"MesgID\\":\\""+"testpty"+"\\"}";
			  */

			//正式代码,测试后恢复
			String s ="{\"OrigSendTime\":"
			  +"\""+MdaUtils.format(MdaUtils.today(),"HHmmss")+"\""
			  +",\"CertNtfctnInf\":{\"ChgTp\":"+"\""+this.getChgtp()+"\""
			  +"},\"GrpHdr\":{";
			if(!MdaUtils.isEmpty(this.getRem()))
			{
			  s+="\"Rmk\":"+"\""+this.getRem()+"\",";
			}
			s+="\"SysCd\":\"ELCS\",\"CreDtTm\":"
			  +"\""+MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd")+"T"
			  +MdaUtils.format(MdaUtils.today(),"HH:mm:ss")+"\""
			  +",\"InstdPty\":{\"InstdDrctPty\":"+"\""+this.getRcvdirpty()+"\""
			  +",\"InstdPty\":"+"\""+this.getRcvpty()+"\""
			  +"},\"InstgPty\":{\"InstgPty\":"+"\""+this.getSndpty()+"\""
			  +",\"InstgDrctPty\":"+"\""+this.getSnddirpty()+"\""
			  +"},\"MsgId\":"+"\""+this.getMsgcod()+"\""
			  +"},\"OrigSender\":\""+"403100000004"+"\""
			  +",\"MesgType\":\""+"ccms.903.001.02"+"\""
			  +",\"OrigReceiver\":\""+this.getRcvdirpty()+"\""
			  +",\"OrigSendDate\":\""+MdaUtils.format(MdaUtils.today(),"yyyyMMdd")+"\""
			  +",\"MesgDirection\":\"U\""
			  +",\"MesgRefID\":\""+this.getMsgcod()+"\""
			  +",\"MesgID\":\""+this.getRcvdirpty()+"\"}";

			log.debug("{}","[903_JSON]"+s);
			MdaUtils.clear(this.getSmpmod().getMps());
			MdaUtils.clear(this.getSmpmod().getSmh());
			if(!storeMsgFromPlatForElcs(s))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000320"),MdaUtils.getI18NString("csnp","CT000321"));
			  return false;
			}
			int errorcode = ctx.getErrorCode();
			log.debug("{}","[SAV_CSN]");
			Platform.mdbBegin();
			MdaUtils.clear(this.getCsngrp().getCsn());
			if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getInr()))
			{
			  this.getCsngrp().getCetcsn().setRelinr( this.getSmpmod().getMps().getInr());//关联mpi主键
			}

			Argument<String> subtyp = new Argument<String>("subtyp");
			String sql="select subtyp from cetcsn where bnkcod = ? and  syscd= ? ";
			Platform.mdbExecuteSQL(sql,"403100000004","ELCS");
			Platform.mdbFetchFields(subtyp);
			Platform.mdbCloseCursor();
			log.info("{}","333");
			if(subtyp.value==null)
			{
			  if("CC00".equals(this.getChgtp()))
			  {
			    //$csngrp\\cetcsn\\inr=
			    this.getCsngrp().getCetcsn().setBnkcod( "403100000004");
			    this.getCsngrp().getCetcsn().setCsntyp( this.getChgtp());
			    this.getCsngrp().getCetcsn().setSta( "00");//未审核
			    this.getCsngrp().getCetcsn().setSnddirpty( this.getSnddirpty());
			    this.getCsngrp().getCetcsn().setGendat( MdaUtils.today());
			    this.getCsngrp().getCetcsn().setSubtyp( "903");
			    this.getCsngrp().getCetcsn().setRem( "ELCS数字证书新增绑定操作");
			    this.getCsngrp().getCetcsn().setSndpty(this.getSndpty());
			    this.getCsngrp().getCetcsn().setRcvdirpty(this.getRcvdirpty());
			    this.getCsngrp().getCetcsn().setRcvpty(this.getRcvpty());
			    this.getCsngrp().getCetcsn().setSyscd( "ELCS");
			    this.getCsngrp().getCetcsn().setFlg( "Y");

			    Platform.sdbInsert(this.getCsngrp().getCetcsn());

			  }
			  //如果选择解绑的时候是空的话，可能需要插入
			}
			else//已有绑定证书的，点击绑定为更新
			{
			  Platform.mdbRead(this.getCsngrp().getCetcsn(),new Argument<String>("bnkcod","403100000004"),new Argument<String>("syscd","ELCS"));
			  log.info("{}","cetcsn inr="+this.getCsngrp().getCetcsn().getInr());
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getInr()))
			  {
			    this.getCsngrp().getCetcsn().setRelinr( this.getSmpmod().getMps().getInr());//关联mpi主键
			  }
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.info("{}","111");
			    if("CC02".equals(this.getChgtp()))
			    {
			      this.getCsngrp().getCetcsn().setFlg( "N");
			      this.getCsngrp().getCetcsn().setRem( "ELCS数字证书解绑操作");
			      this.getCsngrp().getCetcsn().setCsntyp( "CC02");
			      Platform.mdbUpdate(this.getCsngrp().getCetcsn());
			    }
			    else
			    {
			      this.getCsngrp().getCetcsn().setCsntyp( this.getChgtp());
			      this.getCsngrp().getCetcsn().setSnddirpty( this.getSnddirpty());
			      this.getCsngrp().getCetcsn().setGendat( MdaUtils.today());
			      this.getCsngrp().getCetcsn().setSndpty(this.getSndpty());
			      this.getCsngrp().getCetcsn().setRcvdirpty(this.getRcvdirpty());
			      this.getCsngrp().getCetcsn().setRcvpty(this.getRcvpty());
			      this.getCsngrp().getCetcsn().setFlg( "Y");
			      if("CC01".equals(this.getChgtp()))
			      {
			        this.getCsngrp().getCetcsn().setCsntyp( "CC01");
			        this.getCsngrp().getCetcsn().setRem( "ELCS数字证书变更操作");
			      }
			      else
			      {
			        this.getCsngrp().getCetcsn().setCsntyp( "CC00");
			        this.getCsngrp().getCetcsn().setRem( "ELCS数字证书重新绑定操作");
			      }

			      log.info("{}","222");
			      Platform.mdbUpdate(this.getCsngrp().getCetcsn());
			    }
			  }
			}

			//Platform.mdbUpdate($csngrp\\cetcsn);
			log.debug("{}","2.csn inr "+this.getCsngrp().getCetcsn().getInr());
			errorcode=ctx.getErrorCode();

			Platform.mdbCommit();
			errorcode = ctx.getErrorCode();
			ctx.setMessage(MdaUtils.getI18NString("csnp","CT000322"),MdaUtils.getI18NString("csnp","CT000323"));
			


			return true;
        }

        /**
        *   source:csnp.@0021.script
        */
        @Rule(target="comfirm",order=50)
        public boolean ruleComfirmN50(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSndpty()))
			{
			  ctx.setFieldError(this,"sndpty",MdaUtils.getI18NString("csnp","CT000246"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getRcvpty()))
			{
			  ctx.setFieldError(this,"rcvpty",MdaUtils.getI18NString("csnp","CT000247"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getRcvdirpty()))
			{
			  ctx.setFieldError(this,"rcvdirpty",MdaUtils.getI18NString("csnp","CT000248"));
			  return false;
			}
			String sndpty=this.getSndpty();
			String rcvpty=this.getRcvpty();
			String rcvdirpty=this.getRcvdirpty();
			sndpty = sndpty.toUpperCase();
			rcvpty = rcvpty.toUpperCase();
			rcvdirpty = rcvdirpty.toUpperCase();
			if(!isIllegalCharacter(sndpty))
			{
			  ctx.setFieldError(this,"sndpty",MdaUtils.getI18NString("csnp","CT000249"));
			  return false;
			}
			if(!isIllegalCharacter(rcvpty))
			{
			  ctx.setFieldError(this,"rcvpty",MdaUtils.getI18NString("csnp","CT000250"));
			  return false;
			}
			if(!isIllegalCharacter(rcvdirpty))
			{
			  ctx.setFieldError(this,"rcvdirpty",MdaUtils.getI18NString("csnp","CT000251"));
			  return false;
			}
			this.setSndpty(sndpty);
			this.setRcvpty(rcvpty);
			this.setRcvdirpty( rcvdirpty);
			
			
			

			return true;
        }

        /**
        *   source:csnp.@0027.script
        */
        @Rule(target="upload",order=100)
        public boolean ruleUploadN100(){
            IContext ctx = MdaEnv.getContext();
            
			//查询数据库存储的对手行发送的903证书
			/*Platform.clear($smpmod\\mpslst);
			  Platform.clear($smpmod\\mpilst);
			  Platform.clear($smpmod\\smh);
			  Platform.setDefaultDB("fxd");
			  List sqlData = new ArrayList();
			  String sql = "";
			  int count = 0;
			  sql = " WHERE m1.inr=m2.inr AND m1.dir = '>' and m2.subtyp = '903' AND m1.srcchncod = 'ELC' order by m1.rcvdattim ASC";
			  log.info("sql:"+sql);
			  Platform.mdbReadset(new IModuleList[]{$smpmod\\mpslst, $smpmod\\mpilst}, 0, sql, sqlData.toArray());
			  int error =Platform.errorCode();
			  log.info("[SQL ERROR CODE]:"+error);
			  log.info("[DB]:"+Platform.getDefaultDB());
			  if(error==NO_ERROR)
			  {
			  log.info("待同步电子独立证书总笔数：" +$smpmod\\mpslst.fullSize());
			  for(int i=0; i<$smpmod\\mpslst.fullSize(); i++)
			  {
			  try
			  {
			  if(!Platform.isEmpty($smpmod\\mpslst[i]\\smhinr.getValue()))
			  {
			  Platform.mdbRead($smpmod\\smh, new Argument<String>("inr", EQ, $smpmod\\mpslst[i]\\smhinr));
			  if (Platform.errorCode() == NO_ERROR)
			  {
			  //获取电证903证书报文的路径
			  String fileName = $smpmod.getElcsStoreFileFullPathName($smpmod\\smh\\docfil.getValue(),$smpmod\\smh\\docfxt.getValue());
			  java.io.File file = new java.io.File(fileName);
			  if (!file.exists())
			  {
			  if (Platform.mfileExists(fileName))
			  {
			  Platform.fsDownload(fileName);
			  //不存在调用文件服务器
			  deal903Upload(fileName);
			  }
			  }
			  else
			  {
			  deal903Upload(fileName);
			  }
			  }
			  }
			  }
			  catch (Exception e)
			  {
			  log.info("报文处理异常,异常报文mps inr:" +$smpmod\\mpslst[i]\\inr.getValue());
			  continue;
			  }
			  count++;
			  }
			  log.info("同步电子独立证书总笔数：" +count);
			  Platform.message(#CT000332,#CT000333);
			  }
			  else
			  {
			  Platform.message(#CT000334,#CT000335);
			  }*/
			

			return true;
        }

        /**
        *   source:csnp.@0029.script
        */
        @Rule(target="fftqur",order=50)
        public boolean ruleFftqurN50(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSndpty()))
			{
			  ctx.setFieldError(this,"sndpty",MdaUtils.getI18NString("csnp","CT000318"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getRcvpty()))
			{
			  ctx.setFieldError(this,"rcvpty",MdaUtils.getI18NString("csnp","CT000319"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getRcvdirpty()))
			{
			  ctx.setFieldError(this,"rcvdirpty",MdaUtils.getI18NString("csnp","CT000320"));
			  return false;
			}
			String sndpty=this.getSndpty();
			String rcvpty=this.getRcvpty();
			String rcvdirpty=this.getRcvdirpty();
			sndpty = sndpty.toUpperCase();
			rcvpty = rcvpty.toUpperCase();
			rcvdirpty = rcvdirpty.toUpperCase();
			if(!isIllegalCharacter(sndpty))
			{
			  ctx.setFieldError(this,"sndpty",MdaUtils.getI18NString("csnp","CT000321"));
			  return false;
			}
			if(!isIllegalCharacter(rcvpty))
			{
			  ctx.setFieldError(this,"rcvpty",MdaUtils.getI18NString("csnp","CT000322"));
			  return false;
			}
			if(!isIllegalCharacter(rcvdirpty))
			{
			  ctx.setFieldError(this,"rcvdirpty",MdaUtils.getI18NString("csnp","CT000323"));
			  return false;
			}
			this.setSndpty(sndpty);
			this.setRcvpty(rcvpty);
			this.setRcvdirpty( rcvdirpty);
			
			
			

			return true;
        }

        /**
        *   source:csnp.@0030.script
        */
        @Rule(target="fftqur",order=100)
        public boolean ruleFftqurN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.parseDate("","");
			log.debug("{}","[DB_BEGIN]");
			log.debug("{}","[CREATE_903]");
			ctx.getErrorCode();
			Platform.setDefaultDB("fxd");
			Platform.mdbBegin();
			/*
			  //测试代码,测试后删除
			  String elcsMsg ="{\\"OrigSendTime\\":"
			  +"\\""+"010000"+"\\""
			  +",\\"CertNtfctnInf\\":{\\"ChgTp\\":"+"\\""+$chgtp+"\\""
			  +"},\\"GrpHdr\\":{\\"Rmk\\":"+"\\""+"TTTT"+"\\""
			  +",\\"SysCd\\":\\"LCFS\\",\\"CreDtTm\\":"
			  +"\\""+"2020-10-11"+"T"
			  +"14:10:00"+"\\""
			  +",\\"InstdPty\\":{\\"InstdDrctPty\\":"+"\\""+"testpty"+"\\""
			  +",\\"InstdPty\\":"+"\\""+"testpty"+"\\""
			  +"},\\"InstgPty\\":{\\"InstgPty\\":"+"\\""+"testpty"+"\\""
			  +",\\"InstgDrctPty\\":"+"\\""+"testpty"+"\\""
			  +"},\\"MsgId\\":"+"\\""+$msgcod.getValue()+"\\""
			  +"},\\"OrigSender\\":\\""+"testpty"+"\\""
			  +",\\"MesgType\\":\\""+"ccms.903.001.02"+"\\""
			  +",\\"OrigReceiver\\":\\""+"testpty"+"\\""
			  +",\\"OrigSendDate\\":\\""+"20201011"+"\\""
			  +",\\"MesgDirection\\":\\"U\\""
			  +",\\"MesgRefID\\":\\""+$msgcod.getValue()+"\\""
			  +",\\"MesgID\\":\\""+"testpty"+"\\"}";
			  */

			//正式代码,测试后恢复
			String s ="{\"OrigSendTime\":"
			  +"\""+MdaUtils.format(MdaUtils.today(),"HHmmss")+"\""
			  +",\"CertNtfctnInf\":{\"ChgTp\":"+"\""+this.getChgtp()+"\""
			  +"},\"GrpHdr\":{";
			if(!MdaUtils.isEmpty(this.getRem()))
			{
			  s+="\"Rmk\":"+"\""+this.getRem()+"\",";
			}
			s+="\"SysCd\":\"LCFS\",\"CreDtTm\":"
			  +"\""+MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd")+"T"
			  +MdaUtils.format(MdaUtils.today(),"HH:mm:ss")+"\""
			  +",\"InstdPty\":{\"InstdDrctPty\":"+"\""+this.getRcvdirpty()+"\""
			  +",\"InstdPty\":"+"\""+this.getRcvpty()+"\""
			  +"},\"InstgPty\":{\"InstgPty\":"+"\""+this.getSndpty()+"\""
			  +",\"InstgDrctPty\":"+"\""+this.getSnddirpty()+"\""
			  +"},\"MsgId\":"+"\""+this.getMsgcod()+"\""
			  +"},\"OrigSender\":\""+"403100000004"+"\""
			  +",\"MesgType\":\""+"ccms.903.001.02"+"\""
			  +",\"OrigReceiver\":\""+this.getRcvdirpty()+"\""
			  +",\"OrigSendDate\":\""+MdaUtils.format(MdaUtils.today(),"yyyyMMdd")+"\""
			  +",\"MesgDirection\":\"U\""
			  +",\"MesgRefID\":\""+this.getMsgcod()+"\""
			  +",\"OrigSenderSID\":\"LCFS\""
			  +",\"OrigReceiverSID\":\"LCFS\""
			  +",\"MesgID\":\""+this.getMsgcod()+"\"}";
			//+",\\"MesgID\\":\\""+$rcvdirpty.getValue()+"\\"}";
			
			log.debug("{}","[903_JSON1]"+s);
			MdaUtils.clear(this.getSmpmod().getMps());
			MdaUtils.clear(this.getSmpmod().getSmh());
			if(!storeMsgFromPlatForElcs(s))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000324"),MdaUtils.getI18NString("csnp","CT000325"));
			  return false;
			}
			else
			{
			  // Platform.message(#CT000326,#CT000327);
			}
			int errorcode = ctx.getErrorCode();
			log.debug("{}","[SAV_CSN]");
			Platform.setDefaultDB("fxd");
			Platform.mdbBegin();
			MdaUtils.clear(this.getCsngrp().getCsn());

			Argument<String> subtyp = new Argument<String>("subtyp");
			String sql="select subtyp from cetcsn where bnkcod = ? and  syscd= ? ";
			Platform.mdbExecuteSQL(sql,"403100000004","LCFS");
			Platform.mdbFetchFields(subtyp);
			Platform.mdbCloseCursor();
			if(subtyp.value==null)
			{
			  if("CC00".equals(this.getChgtp()))
			  {
			    //$csngrp\\cetcsn\\inr=
			    this.getCsngrp().getCetcsn().setBnkcod( "403100000004");
			    this.getCsngrp().getCetcsn().setCsntyp( this.getChgtp());
			    this.getCsngrp().getCetcsn().setSta( "00");//未审核
			    this.getCsngrp().getCetcsn().setSnddirpty( this.getSnddirpty());
			    this.getCsngrp().getCetcsn().setGendat( MdaUtils.today());
			    this.getCsngrp().getCetcsn().setSubtyp( "903");
			    this.getCsngrp().getCetcsn().setRem( "LCFS数字证书新增绑定操作");
			    this.getCsngrp().getCetcsn().setSndpty(this.getSndpty());
			    this.getCsngrp().getCetcsn().setRcvdirpty(this.getRcvdirpty());
			    this.getCsngrp().getCetcsn().setRcvpty(this.getRcvpty());
			    this.getCsngrp().getCetcsn().setSyscd( "LCFS");
			    this.getCsngrp().getCetcsn().setFlg( "Y");
			    if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getInr()))
			    {
			      this.getCsngrp().getCetcsn().setRelinr( this.getSmpmod().getMps().getInr());//关联mpi主键
			    }

			    Platform.sdbInsert(this.getCsngrp().getCetcsn());
			  }
			  //如果选择解绑的时候是空的话，可能需要插入
			}
			else//已有绑定证书的，点击绑定为更新
			{
			  Platform.mdbRead(this.getCsngrp().getCetcsn(),new Argument<String>("bnkcod","403100000004"),new Argument<String>("syscd","LCFS"));
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getInr()))
			  {
			    this.getCsngrp().getCetcsn().setRelinr( this.getSmpmod().getMps().getInr());//关联mpi主键
			  }
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if("CC02".equals(this.getChgtp()))
			    {
			      this.getCsngrp().getCetcsn().setFlg( "N");
			      this.getCsngrp().getCetcsn().setRem( "LCFS数字证书解绑操作");
			      this.getCsngrp().getCetcsn().setCsntyp( "CC02");
			      Platform.mdbUpdate(this.getCsngrp().getCetcsn());
			    }
			    else
			    {
			      this.getCsngrp().getCetcsn().setCsntyp( this.getChgtp());
			      this.getCsngrp().getCetcsn().setSnddirpty( this.getSnddirpty());
			      this.getCsngrp().getCetcsn().setGendat( MdaUtils.today());
			      this.getCsngrp().getCetcsn().setSndpty(this.getSndpty());
			      this.getCsngrp().getCetcsn().setRcvdirpty(this.getRcvdirpty());
			      this.getCsngrp().getCetcsn().setRcvpty(this.getRcvpty());
			      this.getCsngrp().getCetcsn().setFlg( "Y");
			      if("CC01".equals(this.getChgtp()))
			      {
			        this.getCsngrp().getCetcsn().setCsntyp( "CC01");
			        this.getCsngrp().getCetcsn().setRem( "LCFS数字证书变更操作");
			      }
			      else
			      {
			        this.getCsngrp().getCetcsn().setCsntyp( "CC00");
			        this.getCsngrp().getCetcsn().setRem( "LCFS数字证书重新绑定操作");
			      }

			      Platform.mdbUpdate(this.getCsngrp().getCetcsn());
			    }
			  }
			}

			Platform.mdbCommit();
			errorcode = ctx.getErrorCode();
			ctx.setMessage(MdaUtils.getI18NString("csnp","CT000328"),MdaUtils.getI18NString("csnp","CT000329"));
			
			//log.debug(errorcode);
			

			return true;
        }

        /**
        *   source:csnp.@0031.script
        */
        @Rule(target="fftrtn",order=100)
        public boolean ruleFftrtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			String s ="{\"OrigSendTime\":"
			  +"\""+MdaUtils.format(MdaUtils.today(),"HHmmss")+"\""
			  +",\"CertNtfctnInf\":{\"ChgTp\":"+"\""+this.getChgtp()+"\""
			  +"},\"GrpHdr\":{";
			if(!MdaUtils.isEmpty(this.getRem()))
			{
			  s+="\"Rmk\":"+"\""+this.getRem()+"\",";
			}
			s+="\"SysCd\":\"LCFS\",\"CreDtTm\":"
			  +"\""+MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd")+"T"
			  +MdaUtils.format(MdaUtils.today(),"HH:mm:ss")+"\""
			  +",\"InstdPty\":{\"InstdDrctPty\":"+"\""+this.getRcvdirpty()+"\""
			  +",\"InstdPty\":"+"\""+this.getRcvpty()+"\""
			  +"},\"InstgPty\":{\"InstgPty\":"+"\""+this.getSndpty()+"\""
			  +",\"InstgDrctPty\":"+"\""+this.getSnddirpty()+"\""
			  +"},\"MsgId\":"+"\""+this.getMsgcod()+"\""
			  +"},\"OrigSender\":\""+"403100000004"+"\""
			  +",\"MesgType\":\""+"ccms.903.001.02"+"\""
			  +",\"OrigReceiver\":\""+this.getRcvdirpty()+"\""
			  +",\"OrigSendDate\":\""+MdaUtils.format(MdaUtils.today(),"yyyyMMdd")+"\""
			  +",\"MesgDirection\":\"U\""
			  +",\"MesgRefID\":\""+this.getMsgcod()+"\""

			  +",\"MesgID\":\""+this.getRcvdirpty()+"\"}";

			log.debug("{}","[903_JSON]"+s);

			return true;
        }

        /**
        *   source:csnp.@0033.script
        */
        @Rule(target="certreq",order=100)
        public boolean ruleCertreqN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getSmpmod().getMps());
			MdaUtils.clear(this.getSmpmod().getSmh());
			this.setRcvdirpty(NULLSTR);
			this.setDwn919typ("ELCS");
			

			return true;
        }

        /**
        *   source:csnp.@0034.script
        */
        @Rule(target="kt902",order=100)
        public boolean ruleKt902N100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getSmpmod().getMps());
			MdaUtils.clear(this.getSmpmod().getSmh());
			this.setQxxflg("A");
			this.setQxxtyp(NULLSTR);
			
			//handle902("REGT");
			

			return true;
        }

        /**
        *   source:csnp.@0038.script
        */
        @Rule(target="qx902",order=100)
        public boolean ruleQx902N100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getSmpmod().getMps());
			MdaUtils.clear(this.getSmpmod().getSmh());
			this.setQxxflg("B");
			this.setQxxtyp(NULLSTR);
			

			return true;
        }

        /**
        *   source:csnp.@0039.script
        */
        @Rule(target="sure919",order=100)
        public boolean ruleSure919N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRcvdirpty()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000381"),MdaUtils.getI18NString("csnp","CT000382"));
			  return true;
			}
			Map map=new HashMap();
			String dwnTyp=this.getDwn919typ();
			String refId=MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmssSSS");
			map.put("OrigSendTime",MdaUtils.format(MdaUtils.today(),"HHmmss"));
			map.put("OrigSender","403100000004");
			map.put("MesgType","ccms.919.001.01");
			map.put("OrigReceiver","000000000000");
			map.put("OrigSendDate",MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			map.put("MesgDirection","U");
			map.put("MesgRefID",refId);
			map.put("OrigSenderSID",dwnTyp);
			map.put("OrigReceiverSID",dwnTyp);
			map.put("MesgID",refId);

			Map grpHdr=new HashMap();
			grpHdr.put("MsgId",refId);
			grpHdr.put("CreDtTm",MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd")+"T"
			  +MdaUtils.format(MdaUtils.today(),"HH:mm:ss"));
			grpHdr.put("SysCd",dwnTyp);
			grpHdr.put("Rmk",dwnTyp+"919");

			Map instgAgt=new HashMap();
			Map brnchId=new HashMap();
			brnchId.put("Id","403100000004");
			instgAgt.put("InstgDrctPty","403100000004");
			instgAgt.put("InstgPty","403100000004");
			grpHdr.put("InstgPty",instgAgt);

			Map instdAgt=new HashMap();
			brnchId=new HashMap();
			brnchId.put("Id","0000");
			instdAgt.put("InstdDrctPty","0000");
			instdAgt.put("InstdPty","0000");
			grpHdr.put("InstdPty",instdAgt);
			map.put("GrpHdr",grpHdr);

			List mmbCdList=new  ArrayList();
			mmbCdList.add(this.getRcvdirpty());
			Map mmbcMap=new HashMap();
			mmbcMap.put("MmbCd",mmbCdList);
			map.put("CertfctnList",mmbcMap);
			log.info("{}","919 map="+map);
			String json=(String)MdaUtils.invoke("com.brilliance.eibs.el.CommonFunctionUtils","toJson",map);
			log.info("{}","919 json:"+json);

			ctx.getErrorCode();
			Platform.setDefaultDB("fxd");
			Platform.mdbBegin();
			if(storeMsgFromPlatForElcs(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000408"),MdaUtils.getI18NString("csnp","CT000409"));

			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000410"),MdaUtils.getI18NString("csnp","CT000411"));
			}

			


			return true;
        }

        /**
        *   source:csnp.@0041.script
        */
        @Rule(target="sure902",order=100)
        public boolean ruleSure902N100(){
            IContext ctx = MdaEnv.getContext();
            

			String flg=this.getQxxflg();
			if("A".equals(flg))
			{
			  handle902("REGT",this.getQxxtyp());
			}
			else
			{
			  handle902("CANL",this.getQxxtyp());
			}

			

			return true;
        }

        /**
        *   source:csnp.@0044.script
        */
        @Rule(target="submit903",order=100)
        public boolean ruleSubmit903N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","[DB_BEGIN]");
			Platform.mdbBegin();
			log.debug("{}","[CREATE_903]");

			Map map = new HashMap();
			map.put("msgFlagNo",this.getMsgid());
			map.put("sendTm",MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd")+"T"
			  +MdaUtils.format(MdaUtils.today(),"HH:mm:ss"));
			map.put("instgDrctParty",this.getInstgdrctpty());
			map.put("instgParty",this.getInstgpty());
			map.put("instdDrctParty",this.getInstddrctpty());
			map.put("instdParty",this.getInstdpty());
			map.put("sysCode",this.getSyscd());
			if(!MdaUtils.isEmpty(this.getRmk()))
			{
			  map.put("fmtRmk",this.getRmk());
			}
			map.put("changeType",this.getChgtyp());
			map.put("serviceId","99306000014");

			log.info("{}","903 map = "+map);
			String json=(String)MdaUtils.invoke("com.brilliance.eibs.el.CommonFunctionUtils","toJson",map);

			log.debug("{}","[903_JSON]"+json);
			MdaUtils.clear(this.getSmpmod().getMps());
			MdaUtils.clear(this.getSmpmod().getSmh());
			if(!storeMsgFromPlatForFxps(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000441"),MdaUtils.getI18NString("csnp","CT000442"));
			  return false;
			}

			String xmlMsg = (String)MdaUtils.invoke("com.psbc.zfqz.jnwb.FxpsMesgPack","jsnToXml",json);
			log.debug("{}","xmlMsg="+xmlMsg);
			Object obj = MdaUtils.invoke("com.brilliance.jnwb.utils.MsgUtil","unPackNoSignMessage",xmlMsg);   //String->Result
			obj = MdaUtils.invoke("com.brilliance.jnwb.utils.MsgUtil","packMessage",MdaUtils.invoke(obj,"getElcsModel"));    //加签
			xmlMsg = MdaUtils.invoke(obj,"getMessage").toString();
			log.debug("{}","xmlMsg="+xmlMsg);
			obj = MdaUtils.invoke("com.brilliance.jnwb.utils.MsgUtil","unPackNoSignMessage",new Object[]{xmlMsg});  //解签
			String signstr =MdaUtils.invoke(obj,"getSignatureInfo").toString();

			log.debug("{}","signstr="+signstr);
			String orgstr = this.getInstgpty()+this.getMsgid()+"|"+map.get("sendTm").toString()+"|"+this.getInstgdrctpty()+"|"+this.getSyscd()+"|"+this.getChgtyp()+"|";
			//String orgstr = instgPty+orgnum+"|"+creDtTm+"|"+instgDrctPty+"|"+sysCd+"|"+chgTp+"|";
			log.debug("{}","orgstr="+orgstr);
			String chgTp = this.getChgtyp();
			String result =(String)MdaUtils.invoke("com.psbc.zfqz.jnwb.NetSignSignatureStd","handVerifyAndDeal903",orgstr,signstr,chgTp);
			log.debug("{}","result="+result);
			//int errorcode = Platform.errorCode();
			String[] str = result.split("\\|");
			log.debug("{}","str[1]="+str[1]);
			log.debug("{}","str[2]="+str[2]);
			log.debug("{}","str[3]="+str[3]);
			log.debug("{}","str[4]="+str[4]);
			log.debug("{}","str[5]="+str[5]);
			log.debug("{}","str[6]="+str[6]);

			int errorcode = ctx.getErrorCode();
			log.debug("{}","[SAV_CSN]");
			Platform.mdbBegin();
			MdaUtils.clear(this.getCsngrp().getCsn());
			if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getInr()))
			{
			  this.getCsngrp().getCetcsn().setRelinr( this.getSmpmod().getMps().getInr());//关联mpi主键
			}

			Argument<String> subtyp = new Argument<String>("subtyp");
			String sql="select subtyp from cetcsn where bnkcod = ? and  syscd= ? ";
			Platform.mdbExecuteSQL(sql,"PSBCCNBJXXX","FXPS");
			Platform.mdbFetchFields(subtyp);
			Platform.mdbCloseCursor();

			log.info("{}","333");

			if(subtyp.value==null)//ccms.903.001.02 只有 CC00 和  CC02
			{
			  if("CC00".equals(this.getChgtyp()))
			  {

			    this.getCsngrp().getCetcsn().setBnkcod( "PSBCCNBJXXX");
			    this.getCsngrp().getCetcsn().setCsntyp( this.getChgtyp());
			    this.getCsngrp().getCetcsn().setSta( "00");//未审核
			    this.getCsngrp().getCetcsn().setSnddirpty( this.getInstgdrctpty());
			    this.getCsngrp().getCetcsn().setGendat( MdaUtils.today());
			    this.getCsngrp().getCetcsn().setSubtyp( "903");
			    this.getCsngrp().getCetcsn().setRem( "FXPS数字证书新增绑定操作");
			    this.getCsngrp().getCetcsn().setSndpty(this.getInstgpty());
			    this.getCsngrp().getCetcsn().setRcvdirpty(this.getInstddrctpty());
			    this.getCsngrp().getCetcsn().setRcvpty(this.getInstdpty());
			    this.getCsngrp().getCetcsn().setSyscd( "FXPS");
			    this.getCsngrp().getCetcsn().setFlg( "Y");

			    this.getCsngrp().getCetcsn().setCertdn( str[2]);
			    this.getCsngrp().getCetcsn().setCertsn( str[3]);
			    this.getCsngrp().getCetcsn().setCertefdat( str[4]);
			    this.getCsngrp().getCetcsn().setCertindat( str[5]);
			    this.getCsngrp().getCetcsn().setCerbdy( str[6]);

			    Platform.sdbInsert(this.getCsngrp().getCetcsn());

			  }
			  //如果选择解绑的时候是空的话，可能需要插入
			}
			else//已有绑定证书的，点击绑定为更新
			{
			  Platform.mdbRead(this.getCsngrp().getCetcsn(),new Argument<String>("bnkcod","PSBCCNBJXXX"),new Argument<String>("syscd","FXPS"));
			  log.info("{}","cetcsn inr="+this.getCsngrp().getCetcsn().getInr());
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getInr()))
			  {
			    this.getCsngrp().getCetcsn().setRelinr( this.getSmpmod().getMps().getInr());//关联mpi主键
			  }
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.info("{}","111");
			    if("CC02".equals(this.getChgtyp()))
			    {
			      this.getCsngrp().getCetcsn().setFlg( "N");
			      this.getCsngrp().getCetcsn().setRem( "FXPS数字证书解绑操作");
			      this.getCsngrp().getCetcsn().setCsntyp( "CC02");
			      Platform.mdbUpdate(this.getCsngrp().getCetcsn());
			    }
			    else
			    {
			      this.getCsngrp().getCetcsn().setCsntyp( this.getChgtyp());
			      this.getCsngrp().getCetcsn().setSnddirpty( this.getInstgdrctpty());
			      this.getCsngrp().getCetcsn().setGendat( MdaUtils.today());
			      this.getCsngrp().getCetcsn().setSndpty(this.getInstgpty());
			      this.getCsngrp().getCetcsn().setRcvdirpty(this.getInstddrctpty());
			      this.getCsngrp().getCetcsn().setRcvpty(this.getInstdpty());
			      this.getCsngrp().getCetcsn().setFlg( "Y");
			      if("CC01".equals(this.getChgtyp()))
			      {
			        this.getCsngrp().getCetcsn().setCsntyp( "CC01");
			        this.getCsngrp().getCetcsn().setRem( "FXPS数字证书变更操作");
			      }
			      else
			      {
			        this.getCsngrp().getCetcsn().setCsntyp( "CC00");
			        this.getCsngrp().getCetcsn().setRem( "FXPS数字证书重新绑定操作");

			        this.getCsngrp().getCetcsn().setCertdn( str[2]);
			        this.getCsngrp().getCetcsn().setCertsn( str[3]);
			        this.getCsngrp().getCetcsn().setCertefdat( str[4]);
			        this.getCsngrp().getCetcsn().setCertindat( str[5]);
			        this.getCsngrp().getCetcsn().setCerbdy( str[6]);
			      }

			      log.info("{}","222");
			      Platform.mdbUpdate(this.getCsngrp().getCetcsn());
			    }
			  }
			}

			//Platform.mdbUpdate($csngrp\\cetcsn);
			log.debug("{}","2.csn inr "+this.getCsngrp().getCetcsn().getInr());
			errorcode=ctx.getErrorCode();

			Platform.mdbCommit();
			ctx.setMessage(MdaUtils.getI18NString("csnp","CT000443"),MdaUtils.getI18NString("csnp","CT000444"));
			


			return true;
        }

        /**
        *   source:csnp.@0048.script
        */
        @Rule(target="submit903",order=50)
        public boolean ruleSubmit903N50(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getInstgpty()))
			{
			  ctx.setFieldError(this,"instgpty",MdaUtils.getI18NString("csnp","CT000451"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getInstdpty()))
			{
			  ctx.setFieldError(this,"instdpty",MdaUtils.getI18NString("csnp","CT000452"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getInstddrctpty()))
			{
			  ctx.setFieldError(this,"instddrctpty",MdaUtils.getI18NString("csnp","CT000453"));
			  return false;
			}
			String sndpty=this.getInstgpty();
			String rcvpty=this.getInstdpty();
			String rcvdirpty=this.getInstddrctpty();
			sndpty = sndpty.toUpperCase();
			rcvpty = rcvpty.toUpperCase();
			rcvdirpty = rcvdirpty.toUpperCase();
			if(!isIllegalCharacter(sndpty))
			{
			  ctx.setFieldError(this,"instgpty",MdaUtils.getI18NString("csnp","CT000454"));
			  return false;
			}
			if(!isIllegalCharacter(rcvpty))
			{
			  ctx.setFieldError(this,"instdpty",MdaUtils.getI18NString("csnp","CT000455"));
			  return false;
			}
			if(!isIllegalCharacter(rcvdirpty))
			{
			  ctx.setFieldError(this,"instddrctpty",MdaUtils.getI18NString("csnp","CT000456"));
			  return false;
			}
			this.setInstgpty(sndpty);
			this.setInstdpty(rcvpty);
			this.setInstddrctpty( rcvdirpty);
			
			
			

			return true;
        }

        /**
        *   source:csnp.@0049.script
        */
        @Rule(target="cancel903",order=100)
        public boolean ruleCancel903N100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:csnp.@0051.script
        */
        @Rule(target="submit919",order=100)
        public boolean ruleSubmit919N100(){
            IContext ctx = MdaEnv.getContext();
            

			Map map = new HashMap();
			map.put("msgFlagNo",this.getMsgid());
			map.put("sendTm",MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd")+"T"
			  +MdaUtils.format(MdaUtils.today(),"HH:mm:ss"));
			map.put("instgDrctParty",this.getInstgdrctpty());
			map.put("instgParty",this.getInstgpty());
			map.put("instdDrctParty",this.getInstddrctpty());
			map.put("instdParty",this.getInstdpty());
			map.put("sysCode",this.getSyscd());
			map.put("fmtRmk",this.getRmk());
			map.put("memberCode",this.getMmbcd());
			map.put("serviceId","99306000015");

			log.info("{}","919 map="+map);
			String json=(String)MdaUtils.invoke("com.brilliance.eibs.el.CommonFunctionUtils","toJson",map);
			log.info("{}","919 json:"+json);

			ctx.getErrorCode();
			Platform.setDefaultDB("swd");
			Platform.mdbBegin();
			if(!storeMsgFromPlatForFxps(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000470"),MdaUtils.getI18NString("csnp","CT000471"));

			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000472"),MdaUtils.getI18NString("csnp","CT000473"));
			}

			

			return true;
        }

        /**
        *   source:csnp.@0052.script
        */
        @Rule(target="kt919",order=100)
        public boolean ruleKt919N100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getSmpmod().getMps());
			MdaUtils.clear(this.getSmpmod().getSmh());

			this.setMsgid(NULLSTR);

			String s =MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmssSS");

			this.setMsgid( s.substring(0,16));
			log.debug("{}","919 msgid = "+ this.getMsgid());
			this.setInstgdrctpty( "PSBCCNBJXXX");
			this.setInstgpty("PSBCCNBJXXX");
			this.setInstddrctpty( "8888");
			this.setInstdpty( "8888");
			this.setSyscd( "FXPS");

			this.setMmbcd( "8888");

			
			
			
			
			
			

			

			return true;
        }

        /**
        *   source:csnp.@0053.script
        */
        @Rule(target="dwn919",order=100)
        public boolean ruleDwn919N100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("lmtsel,dwn");

			return true;
        }

        /**
        *   source:csnp.@0058.script
        */
        @Rule(target="cfixzssqbtn",order=100)
        public boolean ruleCfixzssqbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			String code=(String)this.getCfixbankcode();
			if(MdaUtils.isEmpty(code) || code.length() < 8)
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000529"),MdaUtils.getI18NString("csnp","CT000530"));
			  return true;
			}

			List lst=java.util.Arrays.asList(code.split(","));
			log.debug("{}","code=="+code+",lst="+lst.size());
			String json=this.createcfad_041_001_01(lst);

			if(!this.storeMsgFromPlatWithoutChk(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000531"),MdaUtils.getI18NString("csnp","CT000532"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.info("{}","签到成功");
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000533"),MdaUtils.getI18NString("csnp","CT000534"));
			  for(Object str:lst)
			  {
			    String cfixbankcode = str+"";
			    //根据行号查找
			    MdaUtils.clear(this.getCsngrp().getCsn());
			    //Argument argument = new Argument("cfixbankcode",cfixbankcode);
			    ctx.getErrorCode();
			    Platform.mdbRead(this.getCsngrp().getCsn(),new Argument<String>("cfixbankcode",cfixbankcode),new Argument<String>("csntyp","3"));
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      //数据库插入
			      ctx.getDaoSession().dbBegin();
			      this.getCsngrp().getCsn().setCfixbankcode( str+"");
			      this.getCsngrp().getCsn().setGendat(  MdaUtils.today());
			      this.getCsngrp().getCsn().setTyp( "0");
			      this.getCsngrp().getCsn().setCsntyp( "3");
			      this.getCsngrp().getCsn().setSta( "48");
			      this.getCsngrp().getCsn().setRem( "数字证书下载申请");
			      Platform.sdbInsert(this.getCsngrp().getCsn());
			      ctx.getDaoSession().dbCommit();
			    }
			    else
			    {
			      ctx.setMessage(MdaUtils.getI18NString("csnp","CT000577"),MdaUtils.getI18NString("csnp","CT000578"));
			      ctx.getDaoSession().dbBegin();
			      this.getCsngrp().getCsn().setGendat(  MdaUtils.today());
			      //Platform.sdbInsert($csngrp\\csn);
			      ctx.getDaoSession().dbUpdate(this.getCsngrp().getCsn());
			      ctx.getDaoSession().dbCommit();
			    }
			  }
			}

			return true;
        }

        /**
        *   source:csnp.@0060.script
        */
        @Rule(target="cfixgbbtn",order=100)
        public boolean ruleCfixgbbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//String chgtp = $cfixchgtp.getValue();
			String json=this.createcfad_040_001_01(this.getCfixchgtp());
			if(!(this.storeMsgFromPlatWithoutChk(json)))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000550"),MdaUtils.getI18NString("csnp","CT000551"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  if(this.getCfixchgtp().equals("ADDD"))
			  {
			    log.info("{}","添加成功");
			    ctx.setMessage(MdaUtils.getI18NString("csnp","CT000552"),MdaUtils.getI18NString("csnp","CT000553"));
			    String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			    String propertyPath = MdaUtils.catPath(path,"rcvsndmsg.properties");
			    String cfixbankcode = MdaUtils.getPropertyValue(propertyPath,"OrigSender");
			    MdaUtils.clear(this.getCsngrp().getCsn());
			    ctx.getErrorCode();
			    //查询数据库
			    Platform.mdbRead(this.getCsngrp().getCsn(),new Argument<String>("cfixbankcode",cfixbankcode),new Argument<String>("csntyp","1"));
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      //数据库插入
			      ctx.getDaoSession().dbBegin();
			      this.getCsngrp().getCsn().setCfixbankcode( cfixbankcode+"");
			      this.getCsngrp().getCsn().setGendat(  MdaUtils.today());
			      this.getCsngrp().getCsn().setTyp( "0");
			      this.getCsngrp().getCsn().setCsntyp( "1");
			      this.getCsngrp().getCsn().setSta( "02");
			      this.getCsngrp().getCsn().setRem( "数字证书新增操作");
			      Platform.sdbInsert(this.getCsngrp().getCsn());
			      ctx.getDaoSession().dbCommit();
			    }
			    else
			    {
			      ctx.getDaoSession().dbBegin();
			      this.getCsngrp().getCsn().setGendat(  MdaUtils.today());
			      ctx.getDaoSession().dbUpdate(this.getCsngrp().getCsn());
			      ctx.getDaoSession().dbCommit();
			    }
			  }
			  else if(this.getCfixchgtp().equals("DELE"))
			  {
			    log.info("{}","撤销成功");
			    ctx.setMessage(MdaUtils.getI18NString("csnp","CT000554"),MdaUtils.getI18NString("csnp","CT000555"));
			    String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			    String propertyPath = MdaUtils.catPath(path,"rcvsndmsg.properties");
			    String cfixbankcode = MdaUtils.getPropertyValue(propertyPath,"OrigSender");
			    MdaUtils.clear(this.getCsngrp().getCsn());
			    ctx.getErrorCode();
			    //查询数据库
			    Platform.mdbRead(this.getCsngrp().getCsn(),new Argument<String>("cfixbankcode",cfixbankcode),new Argument<String>("csntyp","2"));
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      //数据库插入
			      ctx.getDaoSession().dbBegin();
			      this.getCsngrp().getCsn().setCfixbankcode( cfixbankcode+"");
			      this.getCsngrp().getCsn().setGendat(  MdaUtils.today());
			      this.getCsngrp().getCsn().setTyp( "0");
			      this.getCsngrp().getCsn().setCsntyp( "2");
			      this.getCsngrp().getCsn().setSta( "02");
			      this.getCsngrp().getCsn().setRem( "数字证书撤销操作");
			      Platform.sdbInsert(this.getCsngrp().getCsn());
			      ctx.getDaoSession().dbCommit();
			    }
			    else
			    {
			      ctx.getDaoSession().dbBegin();
			      this.getCsngrp().getCsn().setGendat(  MdaUtils.today());
			      ctx.getDaoSession().dbUpdate(this.getCsngrp().getCsn());
			      ctx.getDaoSession().dbCommit();
			    }
			  }
			  /*
			    log.info("证书变更成功");
			    Platform.message(#CT000571,#CT000572);
			    */
			}

			return true;
        }


        /**
        *   source:csnp.@0005.script
        */
        @Check(target="valdat",order=100)
        public boolean checkValdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getValdat()))
			{
			  ctx.setFieldError(this,"valdat",MdaUtils.getI18NString("csnp","CT000081"));
			}

			return true;
        }

        /**
        *   source:csnp.@0006.script
        */
        @Check(target="csngrp.csn.rem",order=100)
        public boolean checkCsngrpCsnRemN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCsngrp().getCsn().getRem()))
			{
			  ctx.setFieldError(this,"csngrp.csn.rem",MdaUtils.getI18NString("csnp","CT000086"));
			}

			return true;
        }



        /**
        *   source:csnp.@0002.script
        */
        public boolean storeMsgFromPlat(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("UTF-8"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubjectForMan(is,"HWE","json","CPX","证书变更待审核报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  log.debug("{}","faatsk smhinr:"+this.getSmpmod().getSmh().getInr());
			  log.debug("{}","mps inr:"+this.getSmpmod().getMps().getInr());
			  String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			  log.debug("{}","fileName:"+fileName);
			  if(!Platform.mfileExists(fileName))
			  { // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			    log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			    this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			    return false;
			  }
			  return (Boolean)this.getSmpmod().txtCreateMessageInformation(fileName,"txt");
			}
		}
        /**
        *   source:csnp.@0012.script
        */
        public boolean storeMsgFromPlatForCips(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("UTF-8"));
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubjectForMan(is,"CWE","xml","CPS","证书新增待审核报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			Platform.mdbCommit();
			Platform.mdbBegin();
			log.debug("{}","csnselcps smhinr:"+this.getSmpmod().getSmh().getInr());
			log.debug("{}","mps inr:"+this.getSmpmod().getMps().getInr());
			String fileName = this.getSmpmod().getCipsStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			log.debug("{}","fileName:"+fileName);
			if(!Platform.mfileExists(fileName))
			{ // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			  log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			  this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			  return false;
			}
			if(this.getSmpmod().xmlCreateMessageInformation(fileName,"xml"))
			{
			  int errorcode = ctx.getErrorCode();
			  if(errorcode == NO_ERROR)
			  {
			    Platform.mdbCommit();
			    return true;
			  }
			}
			else
			{
			  Platform.mdbRollback();
			  return false;
			}
			return true;
		}
        /**
        *   source:csnp.@0017.script
        */
        public boolean storeMsgFromPlatCips(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			Platform.mdbBegin();
			MdaUtils.clear(this.getSmpmod().getMps());
			MdaUtils.clear(this.getSmpmod().getMpi());
			MdaUtils.clear(this.getSmpmod().getSmh());
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = obj.toString();
			try
			{
			  is.getOutputStream().write(str.getBytes("UTF-8"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubjectForMan(is,"HWE","xml","CPX","待复核证书下载申请报文"))//创建消息处理
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  log.debug("{}","csnsnd smhinr:"+this.getSmpmod().getSmh().getInr());
			  log.debug("{}","mps inr:"+this.getSmpmod().getMps().getInr());
			  String fileName = this.getSmpmod().getCipsStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			  log.debug("{}","fileName:"+fileName);
			  if(!Platform.mfileExists(fileName))
			  { // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			    log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			    this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			    return false;
			  }
			  if(this.getSmpmod().xmlCreateMessageInformation(fileName,"xml"))
			  {
			    int errorcode = ctx.getErrorCode();
			    if(errorcode == NO_ERROR)
			    {
			      Platform.mdbCommit();
			      return true;
			    }
			  }
			  else
			  {
			    Platform.mdbRollback();
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:csnp.@0022.script
        */
        public boolean isIllegalCharacter(String s)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return s.matches("[A-Z0-9]+");
		}
        /**
        *   source:csnp.@0023.script
        */
        public boolean storeMsgFromPlatForElcs(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			//log.info("[SAVE_903_DOC]");
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("UTF-8"));
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}

			if(!createMessageProcessSubjectForElcs(is,"AEL","elcs","ELC","保存电证或者福费廷相关json报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			log.debug("{}","[ELCS_SMH_INR]:"+this.getSmpmod().getSmh().getInr());
			log.debug("{}","[ELCS_MPS_INR]:"+this.getSmpmod().getMps().getInr());
			String fileName = this.getSmpmod().getElcsStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			log.debug("{}","fileName:"+fileName);
			if(!Platform.mfileExists(fileName))
			{ // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			  log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			  this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			  return false;
			}
			return true;
		}
        /**
        *   source:csnp.@0024.script
        */
        public boolean createMessageProcessSubjectForElcs(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			log.info("{}","[SAV_DOC_MPS_SMH]");
			/// 系统处理时间
			Date processDate = new Date();
			// Platform.clear($smpmod\\mps);
			MdaUtils.clear(this.getSmpmod().getMpe());
			//Platform.clear($smpmod\\smh);
			MdaUtils.clear(this.getSmpmod().getChn());
			MdaUtils.clear(this.getSmpmod().getTgtchn());
			//Platform.mdbCommit();
			//Platform.mdbBegin();
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			/*
			  Platform.esdbRead($smpmod\\chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			this.getSmpmod().readChn(this.getSmpmod().getChn(),channel);
			if(MdaUtils.isEmpty(this.getSmpmod().getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getSmpmod().getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($smpmod\\tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  this.getSmpmod().readChn(this.getSmpmod().getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getSmpmod().getTgtchn()))
			    targetChannel = null;
			}
			/*
			  /// 更新当前渠道最近接收报文时间
			  $smpmod\\chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($smpmod\\chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }
			  Platform.mdbBegin();*/
			int errorcode = ctx.getErrorCode();
			/// 获取报文记录inr
			String smhinr = null;
			log.debug("{}","msgedt smpmod smhinr:"+this.getSmpmod().getSmh().getInr());
			if(!MdaUtils.isEmpty(this.getSmpmod().getSmh().getInr()))
			{
			  smhinr = this.getSmpmod().getSmh().getInr();
			  this.getSmpmod().setEdtflg( "ame");
			}
			else
			{
			  MdaUtils.clear(this.getSmpmod().getMps());
			  MdaUtils.clear(this.getSmpmod().getSmh());
			  smhinr = Platform.sdbCounter("smh");
			  this.getSmpmod().setEdtflg( "new");
			}
			log.debug("{}","smpmod edtflg:"+this.getSmpmod().getEdtflg());
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getSmpmod().getChn().getTyp()))
			  this.getSmpmod().getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getSmpmod().getTgtchn().getTyp()))
			  this.getSmpmod().getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getSmpmod().getMps().setSrcchncod( channel);
			this.getSmpmod().getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getSmpmod().getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getSmpmod().getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getSmpmod().getMps().setSmhinr( smhinr);
			this.getSmpmod().getMps().setSta( "A"); // 待自动清分状态
			this.getSmpmod().getMps().setNxtsta( "A"); // 待自动清分状态
			this.getSmpmod().getMps().setRspsta( "W"); //未核销状态
			this.getSmpmod().getMps().setRcvdattim( processDate); // 接收报文时间
			this.getSmpmod().getMps().setLstdattim( processDate); // 最近处理时间
			this.getSmpmod().getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getSmpmod().getChn().getDlytim())); // 开始处理时间
			if("new".equals(this.getSmpmod().getEdtflg()))
			{
			  log.debug("{}","[smpmod insert mps...]");
			  Platform.sdbInsert(this.getSmpmod().getMps());
			}
			else if("ame".equals(this.getSmpmod().getEdtflg()))
			{
			  log.debug("{}","[smpmod update mps]:"+this.getSmpmod().getMps().getInr());
			  Platform.mdbUpdate(this.getSmpmod().getMps());
			}
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert&dbUpdate mps with errorcode:" + errorcode);
			  //Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getSmpmod().getMpe().setMpsinr( this.getSmpmod().getMps().getInr());
			this.getSmpmod().getMpe().setChncod( channel);
			this.getSmpmod().getMpe().setNxtchncod( "XXX");
			this.getSmpmod().getMpe().setSmhinr( smhinr);
			this.getSmpmod().getMpe().setNxtsmhinr( smhinr);
			this.getSmpmod().getMpe().setDattim( processDate);
			if("ame".equals(this.getSmpmod().getEdtflg()))
			  this.getSmpmod().getMpe().setPrvsta( "C");
			else if("new".equals(this.getSmpmod().getEdtflg()))
			  this.getSmpmod().getMpe().setPrvsta( ""); // 处理前状态
			this.getSmpmod().getMpe().setSta( "A"); // 处理后状态
			this.getSmpmod().getMpe().setTxt( processDetail);
			this.getSmpmod().getMpe().setFrmnam( ctx.getTransName());
			this.getSmpmod().getMpe().setUsr( MdaEnv.getLoginUser());
			log.debug("{}","[MPE_INSERT]");
			Platform.sdbInsert(this.getSmpmod().getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","[dbInsert mpe with errorcode]:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			if("new".equals(this.getSmpmod().getEdtflg()))
			{
			  this.getSmpmod().getSmh().setInr( smhinr);
			}
			this.getSmpmod().getSmh().setObjtyp( "mpe");
			this.getSmpmod().getSmh().setObjinr( this.getSmpmod().getMpe().getInr());
			this.getSmpmod().getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmpmod().getSmh().setDattim( processDate);
			this.getSmpmod().getSmh().setDocpth( this.getSmpmod().getDatapath());
			this.getSmpmod().getSmh().setDocfil( smhinr);
			this.getSmpmod().getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;
			if("elcs|exl".contains(messageType))
			{
			  fileName = this.getSmpmod().getElcsStoreFileFullPathName(smhinr, messageType);
			  this.getSmpmod().getSmh().setDocpth( this.getSmpmod().getElcsdatapath());
			}
			else
			  fileName = this.getSmpmod().getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			log.debug("{}","[DOC_UPLOAD]");
			Platform.mstreamSave(is,fileName);
			this.getSmpmod().getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmpmod().getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmpmod().getSmh().setXxxcnt( 0);
			if("ame".equals(this.getSmpmod().getEdtflg()))
			{
			  Platform.mdbUpdate(this.getSmpmod().getSmh());
			  log.debug("{}","[SMH_UPDATE]");
			}
			else if("new".equals(this.getSmpmod().getEdtflg()))
			{
			  Platform.mdbInsert(this.getSmpmod().getSmh());
			  log.debug("{}","[SMH_INSERT]");
			}
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR && errorcode != NO_MORE_ROW)
			{
			  log.debug("{}","[dbInsert smh with errorcode]:" + errorcode);
			  log.debug("{}","[DB_ROLLBACK]");
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.debug("{}","[DB_COMMIT]");
			  Platform.mdbCommit();
			}
			return true;
		}
        /**
        *   source:csnp.@0025.script
        */
        public String addSpace(String s,int len)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<len;i++){
			  s+=" ";
			}
			return s;
		}
        /**
        *   source:csnp.@0026.script
        */
        public void searchCetcsn()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getCsngrp().getCetcsnlst());
			String sql = "SELECT * FROM CETCSN WHERE 1=1";
			if(!MdaUtils.isEmpty(this.getChgtp()))
			{
			  sql +=" AND csntyp = '"+this.getChgtp()+"'";
			}
			int datflg = 0;
			if(!MdaUtils.isEmpty(this.getBegdat()))
			{
			  sql +=" AND gendat >= ?";
			  datflg += 1;
			}
			if(!MdaUtils.isEmpty(this.getEnddat()))
			{
			  sql +=" AND gendat <= ?";
			  datflg += 2;
			}
			if(!MdaUtils.isEmpty(this.getCsngrp().getCsn().getSubtyp()))
			{
			  sql += " AND subtyp = '"+this.getCsngrp().getCsn().getSubtyp()+"'";
			}
			if(!MdaUtils.isEmpty(this.getBnkbic()))
			{
			  sql += " AND bnkcod like '%"+this.getBnkbic()+"%'";
			}
			sql +=" ORDER BY gendat DESC";
			if(datflg == 0)
			  Platform.mdbExecuteSQL(sql);
			else if(datflg == 1)
			  Platform.mdbExecuteSQL(sql,Platform.formatDateTime(this.getBegdat(),null));
			else if(datflg == 2)
			  Platform.mdbExecuteSQL(sql,Platform.formatDateTime(this.getEnddat(),"235959"));
			else
			  Platform.mdbExecuteSQL(sql,Platform.formatDateTime(this.getBegdat(),null),Platform.formatDateTime(this.getEnddat(),"235959"));
			Argument<String>  inr = new Argument<String>("inr");
			Argument<String>  csntyp = new Argument<String>("csntyp");
			Argument<String>  sndpty = new Argument<String>("sndpty");
			Argument<String>  snddirpty = new Argument<String>("snddirpty");
			Argument<String>  rcvdirpty = new Argument<String>("rcvdirpty");
			Argument<String>  rcvpty = new Argument<String>("rcvpty");
			Argument<String>  certdn = new Argument<String>("certdn");
			Argument<String>  certsn = new Argument<String>("certsn");
			Argument<String>  sta = new Argument<String>("sta");
			Argument<String>  relinr = new Argument<String>("relinr");
			Argument<String>  subtyp = new Argument<String>("subtyp");
			Argument<Date>  gendat = new Argument<Date>("gendat");
			Argument<String>  rem = new Argument<String>("rem");
			Argument<Date> certefdat = new Argument<Date>("certefdat");
			Argument<Date>  certindat = new Argument<Date>("certindat");
			log.info("{}","csntyp!!!!!!!"+csntyp.value);
			while(true)
			{
			  Platform.mdbFetchFields(inr,csntyp,sndpty,snddirpty,rcvdirpty,certdn,rcvpty,certsn,sta,relinr,subtyp,gendat,rem,certefdat,certindat);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getCsngrp().getCetcsnlst().add(inr,csntyp,sndpty,snddirpty,rcvdirpty,certdn,rcvpty,certsn,sta,relinr,subtyp,gendat,rem,certefdat,certindat);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			
			if(this.getCsngrp().getCetcsnlst().size() == 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000300"),MdaUtils.getI18NString("csnp","CT000301"));
			  return;
			}
		}
        /**
        *   source:csnp.@0028.script
        */
        public void deal903Upload(String fileName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			java.io.File file = new java.io.File(fileName);
			Object obj = MdaUtils.invoke("com.brilliance.dzxt.utils.MsgUtil","unPackMessage",new Object[]{file});
			String elcsMessage = MdaUtils.invoke(obj,"getElcsModelForJson").toString();
			log.info("{}","elcsMessage：" +elcsMessage);
			Map map = new com.google.gson.Gson().fromJson(elcsMessage, Map.class);
			String orgnum = null;
			String subtyp = null;
			String responeCode = null;
			Map<String,Object> dmap = null;
			dmap = (Map<String,Object>)map.get("GrpHdr");

			String creDtTm = null;
			String instgDrctPty = null;
			String instgPty = null;
			String sysCd = null;
			String chgTp = null;
			if(!MdaUtils.isEmpty(dmap.get("MsgId")))
			{
			  orgnum = dmap.get("MsgId").toString();
			}
			if(!MdaUtils.isEmpty(dmap.get("CreDtTm")))
			{
			  creDtTm = dmap.get("CreDtTm").toString();
			}
			Map<String,Object> ddmap = (Map<String,Object>)dmap.get("InstgPty");
			if(!MdaUtils.isEmpty(ddmap.get("InstgDrctPty")))
			{
			  instgDrctPty = ddmap.get("InstgDrctPty").toString();
			}
			if(!MdaUtils.isEmpty(ddmap.get("InstgPty")))
			{
			  instgPty = ddmap.get("InstgPty").toString();
			}
			if(!MdaUtils.isEmpty(dmap.get("SysCd")))
			{
			  sysCd = dmap.get("SysCd").toString();
			}

			Map<String,Object> cmap = (Map<String,Object>)map.get("CertNtfctnInf");
			if(!MdaUtils.isEmpty(cmap.get("ChgTp")))
			{
			  chgTp = cmap.get("ChgTp").toString();
			}
			String orgstr = instgPty+orgnum+"|"+creDtTm+"|"+instgDrctPty+"|"+sysCd+"|"+chgTp+"|";
			log.info("{}","orgstr:" +orgstr);
			String signstr = MdaUtils.invoke(obj,"getSignatureInfo").toString();
			log.info("{}","signstr:" +signstr);
			String result =(String)MdaUtils.invoke("com.brilliance.dzxt.framework.signature.eLCSignature","verify903",orgstr,signstr,chgTp);
			int errorcode = ctx.getErrorCode();
			String[] str = result.split("\\|");
			if(str.length!=1)
			{
			  Platform.mdbBegin();
			  MdaUtils.clear(this.getCsngrp().getCetcsn());
			  if("CC00".equals(chgTp))
			  {
			    Argument<String> certdn = new Argument<String>("certdn");
			    String sql1="select certdn from cetcsn where bnkcod = ? and syscd = ?";
			    Platform.mdbExecuteSQL(sql1,str[1],"ELCS");
			    Platform.mdbFetchFields(certdn);
			    Platform.mdbCloseCursor();
			    if("ELCS".equals(sysCd))
			    {
			      if(certdn.value==null)
			      {
			        this.getCsngrp().getCetcsn().setBnkcod( str[1]);
			        this.getCsngrp().getCetcsn().setCertdn( str[2]);
			        this.getCsngrp().getCetcsn().setCertsn( str[3]);
			        this.getCsngrp().getCetcsn().setCertefdat( str[4]);
			        this.getCsngrp().getCetcsn().setCertindat( str[5]);
			        this.getCsngrp().getCetcsn().setCerbdy( str[6]);
			        this.getCsngrp().getCetcsn().setSubtyp( "903");
			        this.getCsngrp().getCetcsn().setCsntyp( chgTp);
			        this.getCsngrp().getCetcsn().setGendat( new Date());

			        this.getCsngrp().getCetcsn().setSyscd( sysCd);
			        this.getCsngrp().getCetcsn().setFlg( "Y");
			        this.getCsngrp().getCetcsn().setCsntyp( "CC00");
			        Platform.sdbInsert(this.getCsngrp().getCetcsn());
			        errorcode = ctx.getErrorCode();
			        log.debug("{}",errorcode);
			        log.info("{}","错误信息："+ errorcode);
			        if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			        {
			          log.info("{}","elcs证书信息新增成功");
			        }
			        else
			        {
			          log.info("{}","elcs证书信息新增失败");
			        }
			      }
			      else
			      {
			        Platform.mdbRead(this.getCsngrp().getCetcsn(),new Argument<String>("bnkcod",str[1]),new Argument<String>("syscd","ELCS"));
			        errorcode = ctx.getErrorCode();
			        if(errorcode == NO_ERROR )
			        {
			          this.getCsngrp().getCetcsn().setCertdn( str[2]);
			          this.getCsngrp().getCetcsn().setCertsn( str[3]);
			          this.getCsngrp().getCetcsn().setCertefdat( str[4]);
			          this.getCsngrp().getCetcsn().setCertindat( str[5]);
			          this.getCsngrp().getCetcsn().setCerbdy( str[6]);
			          this.getCsngrp().getCetcsn().setSubtyp( "903");
			          this.getCsngrp().getCetcsn().setCsntyp( chgTp);
			          this.getCsngrp().getCetcsn().setGendat( new Date());

			          this.getCsngrp().getCetcsn().setSyscd( sysCd);
			          this.getCsngrp().getCetcsn().setFlg( "Y");
			          this.getCsngrp().getCetcsn().setCsntyp( "CC00");
			          Platform.mdbUpdate(this.getCsngrp().getCetcsn());
			          errorcode = ctx.getErrorCode();
			          if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			          {
			            log.info("{}","已有elcs证书更新成功");
			          }
			          else
			          {
			            log.info("{}","已有elcs证书更新失败");
			          }
			        }
			        else
			        {
			          log.info("{}","未找到对应的银行证书信息"+str[1]);
			        }
			      }
			    }
			  }
			  else if("CC01".equals(chgTp))
			  {
			    Platform.mdbRead(this.getCsngrp().getCetcsn(),new Argument<String>("bnkcod",str[1]),new Argument<String>("syscd","ELCS"));
			    errorcode = ctx.getErrorCode();
			    if(errorcode == NO_ERROR)
			    {
			      this.getCsngrp().getCetcsn().setCertdn( str[2]);
			      this.getCsngrp().getCetcsn().setCertsn( str[3]);
			      this.getCsngrp().getCetcsn().setCertefdat( str[4]);
			      this.getCsngrp().getCetcsn().setCertindat( str[5]);
			      this.getCsngrp().getCetcsn().setCerbdy( str[6]);
			      this.getCsngrp().getCetcsn().setSubtyp( "903");
			      this.getCsngrp().getCetcsn().setCsntyp( chgTp);
			      this.getCsngrp().getCetcsn().setGendat( new Date());
			      this.getCsngrp().getCetcsn().setCsntyp( "CC01");
			      Platform.mdbUpdate(this.getCsngrp().getCetcsn());
			      errorcode = ctx.getErrorCode();
			      if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			      {
			        log.info("{}","证书信息更新成功");
			      }
			      else
			      {
			        log.info("{}","证书信息更新失败");
			      }
			    }
			    else
			    {
			      log.info("{}","未找到对应的银行证书信息"+str[1]);
			    }
			  }
			  else if("CC02".equals(chgTp))
			  {
			    Platform.mdbRead(this.getCsngrp().getCetcsn(),new Argument<String>("bnkcod",str[1]),new Argument<String>("syscd","ELCS"));
			    errorcode = ctx.getErrorCode();
			    if(errorcode == NO_ERROR )
			    {
			      if("ELCS".equals(sysCd))
			      {
			        this.getCsngrp().getCetcsn().setFlg( "N");
			        this.getCsngrp().getCetcsn().setCsntyp( "CC02");
			        Platform.mdbUpdate(this.getCsngrp().getCetcsn());
			      }
			      errorcode = ctx.getErrorCode();
			      if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			      {
			        log.info("{}","ELCS证书解绑信息更新成功");
			      }
			      else
			      {
			        log.info("{}","ELCS证书解绑信息更新失败");
			      }
			    }
			    else
			    {
			      log.info("{}","未找到对应的银行证书信息"+str[1]);
			    }
			  }
			}
			Platform.mdbCommit();
		}
        /**
        *   source:csnp.@0036.script
        */
        public Map fillMap(String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map msgTp=new HashMap();
			msgTp.put("MsgTp",value);
			return msgTp;
		}
        /**
        *   source:csnp.@0037.script
        */
        public void handle902(String rigstFlag,String qxxtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map map=new HashMap();
			String refId=MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmssSSS");
			map.put("OrigSendTime",MdaUtils.format(MdaUtils.today(),"HHmmss"));
			map.put("OrigSender","403100000004");
			map.put("MesgType","elcs.902.001.01");
			map.put("OrigReceiver","0000");
			map.put("OrigSendDate",MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			map.put("MesgDirection","U");
			map.put("MesgRefID",refId);
			map.put("OrigSenderSID","ELCS");
			map.put("OrigReceiverSID","ELCS");
			map.put("RigstFlag",rigstFlag);
			map.put("PtcptBk","403100000004");
			map.put("MesgID",refId);

			Map grpHdr=new HashMap();
			grpHdr.put("MsgId",refId);
			grpHdr.put("CreDtTm",MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd")+"T"
			  +MdaUtils.format(MdaUtils.today(),"HH:mm:ss"));
			// grpHdr.put("SysCd","LCFS");
			grpHdr.put("Rmk","yzcx");
			Map instgAgt=new HashMap();
			Map brnchId=new HashMap();
			brnchId.put("Id","403100000004");
			instgAgt.put("MmbId","403100000004");
			instgAgt.put("BrnchId",brnchId);
			grpHdr.put("InstgAgt",instgAgt);

			Map instdAgt=new HashMap();
			brnchId=new HashMap();
			brnchId.put("Id","0000");
			instdAgt.put("MmbId","0000");
			instdAgt.put("BrnchId",brnchId);
			grpHdr.put("InstdAgt",instdAgt);
			map.put("GrpHdr",grpHdr);

			Map authrtyInf=new HashMap();
			Map sndBizAuthrtyInf=new HashMap();
			List sendList=new ArrayList();

			Map rcvBizAuthrtyInf=new HashMap();
			List recvList=new ArrayList();

			if("A".equals(qxxtyp))
			{
			  grpHdr.put("SysCd","LCFS");

			  sendList.add("lcfs.101.001.01");
			  sendList.add("lcfs.103.001.01");
			  sendList.add("lcfs.104.001.01");
			  sendList.add("lcfs.105.001.01");
			  sendList.add("lcfs.106.001.01");
			  sendList.add("lcfs.201.001.01");
			  sendList.add("lcfs.211.001.01");
			  sendList.add("lcfs.212.001.01");
			  sendList.add("lcfs.213.001.01");
			  sendList.add("lcfs.214.001.01");
			  sendList.add("lcfs.221.001.01");
			  sendList.add("lcfs.223.001.01");
			  sendList.add("lcfs.231.001.01");
			  sendList.add("lcfs.232.001.01");
			  sendList.add("lcfs.241.001.01");
			  sendList.add("lcfs.301.001.01");
			  sendList.add("lcfs.303.001.01");
			  sendList.add("lcfs.311.001.01");
			  sendList.add("lcfs.313.001.01");
			  sendList.add("lcfs.351.001.01");
			  sendList.add("lcfs.352.001.01");

			  recvList.add("lcfs.106.001.01");
			  recvList.add("lcfs.201.001.01");
			  recvList.add("lcfs.211.001.01");
			  recvList.add("lcfs.212.001.01");
			  recvList.add("lcfs.213.001.01");
			  recvList.add("lcfs.214.001.01");
			  recvList.add("lcfs.221.001.01");
			  recvList.add("lcfs.222.001.01");
			  recvList.add("lcfs.223.001.01");
			  recvList.add("lcfs.231.001.01");
			  recvList.add("lcfs.301.001.01");
			  recvList.add("lcfs.303.001.01");
			  recvList.add("lcfs.313.001.01");
			  recvList.add("lcfs.331.001.01");
			  recvList.add("lcfs.351.001.01");
			  recvList.add("lcfs.352.001.01");
			}

			//lcfs321
			else if ("B".equals(qxxtyp))
			{
			  grpHdr.put("SysCd","LCFS");
			  sendList.add("elcs.321.001.01");
			}
			//lcfs321 322
			else if ("C".equals(qxxtyp))
			{
			  grpHdr.put("SysCd","ELCS");
			  sendList.add("elcs.232.001.01");

			  recvList.add("elcs.231.001.01");
			  recvList.add("elcs.232.001.01");
			}
			//ccms999
			else if ("D".equals(qxxtyp))
			{
			  grpHdr.put("SysCd","LCFS");
			  recvList.add("ccms.999.001.01");
			}
			else if ("E".equals(qxxtyp))
			{
			  grpHdr.put("SysCd","ELCS");
			  recvList.add("ccms.999.001.01");
			}

			sndBizAuthrtyInf.put("MsgTp",sendList);

			rcvBizAuthrtyInf.put("MsgTp",recvList);

			authrtyInf.put("SndBizAuthrtyInf",sndBizAuthrtyInf);
			authrtyInf.put("RcvBizAuthrtyInf",rcvBizAuthrtyInf);
			map.put("AuthrtyInf",authrtyInf);

			String json=(String)MdaUtils.invoke("com.brilliance.eibs.el.CommonFunctionUtils","toJson",map);
			log.info("{}","json:"+json);

			ctx.getErrorCode();
			Platform.setDefaultDB("fxd");
			Platform.mdbBegin();
			if(!storeMsgFromPlatForElcs(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000365"),MdaUtils.getI18NString("csnp","CT000366"));
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("csnp","CT000375"),MdaUtils.getI18NString("csnp","CT000376"));
			}
			return;
		}
        /**
        *   source:csnp.@0040.script
        */
        public Map fillMap(String key,String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map msgTp=new HashMap();
			msgTp.put(key,value);
			return msgTp;
		}
        /**
        *   source:csnp.@0045.script
        */
        public boolean storeMsgFromPlatForFxps(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			//log.info("[SAVE_903_DOC]");
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GBK"));
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}

			if(!createMessageProcessSubjectForFxps(is,"AUT","jfx","FXP","保存Fxps相关json报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			log.debug("{}","[FXPS_SMH_INR]:"+this.getSmpmod().getSmh().getInr());
			log.debug("{}","[FXPS_MPS_INR]:"+this.getSmpmod().getMps().getInr());
			String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			log.debug("{}","fileName:"+fileName);
			if(!Platform.mfileExists(fileName))
			{ // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			  log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			  this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			  return false;
			}
			return true;
		}
        /**
        *   source:csnp.@0046.script
        */
        public boolean createMessageProcessSubjectForFxps(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			log.info("{}","[SAV_DOC_MPS_SMH]");
			/// 系统处理时间
			Date processDate = new Date();
			// Platform.clear($smpmod\\mps);
			MdaUtils.clear(this.getSmpmod().getMpe());
			//Platform.clear($smpmod\\smh);
			MdaUtils.clear(this.getSmpmod().getChn());
			MdaUtils.clear(this.getSmpmod().getTgtchn());
			//Platform.mdbCommit();
			//Platform.mdbBegin();
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			/*
			  Platform.esdbRead($smpmod\\chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			this.getSmpmod().readChn(this.getSmpmod().getChn(),channel);
			if(MdaUtils.isEmpty(this.getSmpmod().getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getSmpmod().getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{

			  this.getSmpmod().readChn(this.getSmpmod().getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getSmpmod().getTgtchn()))
			    targetChannel = null;
			}

			int errorcode = ctx.getErrorCode();
			/// 获取报文记录inr
			String smhinr = null;
			log.debug("{}","msgedt smpmod smhinr:"+this.getSmpmod().getSmh().getInr());
			if(!MdaUtils.isEmpty(this.getSmpmod().getSmh().getInr()))
			{
			  smhinr = this.getSmpmod().getSmh().getInr();
			  this.getSmpmod().setEdtflg( "ame");
			}
			else
			{
			  MdaUtils.clear(this.getSmpmod().getMps());
			  MdaUtils.clear(this.getSmpmod().getSmh());
			  smhinr = Platform.sdbCounter("smh");
			  this.getSmpmod().setEdtflg( "new");
			}
			log.debug("{}","smpmod edtflg:"+this.getSmpmod().getEdtflg());
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getSmpmod().getChn().getTyp()))
			  this.getSmpmod().getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getSmpmod().getTgtchn().getTyp()))
			  this.getSmpmod().getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getSmpmod().getMps().setSrcchncod( channel);
			this.getSmpmod().getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getSmpmod().getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getSmpmod().getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getSmpmod().getMps().setSmhinr( smhinr);
			this.getSmpmod().getMps().setSta( "A"); // 待自动清分状态
			this.getSmpmod().getMps().setNxtsta( "A"); // 待自动清分状态
			this.getSmpmod().getMps().setRspsta( "W"); //未核销状态
			this.getSmpmod().getMps().setRcvdattim( processDate); // 接收报文时间
			this.getSmpmod().getMps().setLstdattim( processDate); // 最近处理时间
			this.getSmpmod().getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getSmpmod().getChn().getDlytim())); // 开始处理时间
			if("new".equals(this.getSmpmod().getEdtflg()))
			{
			  log.debug("{}","[smpmod insert mps...]");
			  Platform.sdbInsert(this.getSmpmod().getMps());
			}
			else if("ame".equals(this.getSmpmod().getEdtflg()))
			{
			  log.debug("{}","[smpmod update mps]:"+this.getSmpmod().getMps().getInr());
			  Platform.mdbUpdate(this.getSmpmod().getMps());
			}
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert&dbUpdate mps with errorcode:" + errorcode);
			  //Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getSmpmod().getMpe().setMpsinr( this.getSmpmod().getMps().getInr());
			this.getSmpmod().getMpe().setChncod( channel);
			this.getSmpmod().getMpe().setNxtchncod( "XXX");
			this.getSmpmod().getMpe().setSmhinr( smhinr);
			this.getSmpmod().getMpe().setNxtsmhinr( smhinr);
			this.getSmpmod().getMpe().setDattim( processDate);
			if("ame".equals(this.getSmpmod().getEdtflg()))
			  this.getSmpmod().getMpe().setPrvsta( "C");
			else if("new".equals(this.getSmpmod().getEdtflg()))
			  this.getSmpmod().getMpe().setPrvsta( ""); // 处理前状态
			this.getSmpmod().getMpe().setSta( "A"); // 处理后状态
			this.getSmpmod().getMpe().setTxt( processDetail);
			this.getSmpmod().getMpe().setFrmnam( ctx.getTransName());
			this.getSmpmod().getMpe().setUsr( MdaEnv.getLoginUser());
			log.debug("{}","[MPE_INSERT]");
			Platform.sdbInsert(this.getSmpmod().getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","[dbInsert mpe with errorcode]:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			if("new".equals(this.getSmpmod().getEdtflg()))
			{
			  this.getSmpmod().getSmh().setInr( smhinr);
			}
			this.getSmpmod().getSmh().setObjtyp( "mpe");
			this.getSmpmod().getSmh().setObjinr( this.getSmpmod().getMpe().getInr());
			this.getSmpmod().getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmpmod().getSmh().setDattim( processDate);
			this.getSmpmod().getSmh().setDocpth( this.getSmpmod().getDatapath());
			this.getSmpmod().getSmh().setDocfil( smhinr);
			this.getSmpmod().getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;

			if("jfx|fxl".contains(messageType))
			{
			  fileName = this.getSmpmod().getStoreFileFullPathName(smhinr, messageType);
			}
			else
			{
			  log.debug("{}","messageTypeError");
			  return false;
			}

			// 保存文件并记录MD5值和文件大小信息
			log.debug("{}","[DOC_UPLOAD]");
			Platform.mstreamSave(is,fileName);
			this.getSmpmod().getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmpmod().getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmpmod().getSmh().setXxxcnt( 0);
			if("ame".equals(this.getSmpmod().getEdtflg()))
			{
			  Platform.mdbUpdate(this.getSmpmod().getSmh());
			  log.debug("{}","[SMH_UPDATE]");
			}
			else if("new".equals(this.getSmpmod().getEdtflg()))
			{
			  Platform.mdbInsert(this.getSmpmod().getSmh());
			  log.debug("{}","[SMH_INSERT]");
			}
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR && errorcode != NO_MORE_ROW)
			{
			  log.debug("{}","[dbInsert smh with errorcode]:" + errorcode);
			  log.debug("{}","[DB_ROLLBACK]");
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.debug("{}","[DB_COMMIT]");
			  Platform.mdbCommit();
			}
			return true;
		}
        /**
        *   source:csnp.@0054.script
        */
        public String createcfad_041_001_01(List banklst)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//组装报文
			com.brilliance.jrxx.packet.model.cfad_041_001_01.Cfad_041_001_01 cfad_041_001_01 = new com.brilliance.jrxx.packet.model.cfad_041_001_01.Cfad_041_001_01();

			// 组装报文头
			this.getMsgmod().fillHead(cfad_041_001_01, "cfad.041.001.01");
			// 组装报文体
			com.brilliance.jrxx.packet.model.cfad_041_001_01.AdminInfo adminInfo = new com.brilliance.jrxx.packet.model.cfad_041_001_01.AdminInfo();
			com.brilliance.jrxx.packet.model.cfad_041_001_01.MsgComData msgComData = this.createcfad_041_001_01MsgComData(cfad_041_001_01);
			com.brilliance.jrxx.packet.model.cfad_041_001_01.CertfctnList certfctnList = new com.brilliance.jrxx.packet.model.cfad_041_001_01.CertfctnList();
			cfad_041_001_01.MsgComData = msgComData;
			cfad_041_001_01.AdminInfo = adminInfo;
			adminInfo.SvrGrpInfo = "CFIX";
			adminInfo.CertfctnList = certfctnList;
			//log.info("选择:"+index);
			certfctnList.MmbCd = banklst;
			adminInfo.CertfctnCnt = banklst.size()+"";
			String json = com.alibaba.fastjson.JSON.toJSONString(cfad_041_001_01);
			log.debug("{}",json);
			com.brilliance.jrxx.framework.Result result1 = com.brilliance.jrxx.utils.MsgUtil.packMessage(json);
			String msg1=result1.getMessage();
			log.debug("{}",msg1);
			return json;
		}
        /**
        *   source:csnp.@0055.script
        */
        public com.brilliance.jrxx.packet.model.cfad_041_001_01.MsgComData createcfad_041_001_01MsgComData(com.brilliance.jrxx.packet.model.com.Elcs elcs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			com.brilliance.jrxx.packet.model.cfad_041_001_01.MsgComData msgComData = new com.brilliance.jrxx.packet.model.cfad_041_001_01.MsgComData();
			msgComData.InstgPty = elcs.OrigSender;
			msgComData.InstdPty = elcs.OrigReceiver;
			msgComData.SndDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd HH:mm:ss");
			msgComData.MsgId = elcs.MesgID;
			return msgComData;
		}
        /**
        *   source:csnp.@0059.script
        */
        public boolean storeMsgFromPlatWithoutChk(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("UTF-8"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubject(is,"HWE","json","CPX","系统管理报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  // Platform.message(#CT000493,#CT000494);
			  return true;
			}
		}
        /**
        *   source:csnp.@0061.script
        */
        public String createcfad_040_001_01(String changeCode)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//组装报文
			com.brilliance.jrxx.packet.model.cfad_040_001_01.Cfad_040_001_01 cfad_040_001_01 = new com.brilliance.jrxx.packet.model.cfad_040_001_01.Cfad_040_001_01();
			// 组装报文头
			this.getMsgmod().fillHead(cfad_040_001_01, "cfad.040.001.01");
			// 组装报文体
			com.brilliance.jrxx.packet.model.cfad_040_001_01.AdminInfo adminInfo = new com.brilliance.jrxx.packet.model.cfad_040_001_01.AdminInfo();
			com.brilliance.jrxx.packet.model.cfad_040_001_01.CertNtfctnInf certNtfctnInf = new com.brilliance.jrxx.packet.model.cfad_040_001_01.CertNtfctnInf();
			cfad_040_001_01.AdminInfo = adminInfo;
			cfad_040_001_01.MsgId = this.getMsgmod().mkMsgId();
			cfad_040_001_01.SndDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd'T'HH:mm:ss");
			adminInfo.SvrGrpInfo = "CFIX";
			adminInfo.CertNtfctnInf = certNtfctnInf;
			certNtfctnInf.MmbId = cfad_040_001_01.OrigSender;
			//ADDD 新增 DELE 撤销
			certNtfctnInf.ChgTp = changeCode;
			String json = com.alibaba.fastjson.JSON.toJSONString(cfad_040_001_01);
			log.debug("{}",json);
			com.brilliance.jrxx.framework.Result result1 = com.brilliance.jrxx.utils.MsgUtil.packMessage(json);
			String msg1=result1.getMessage();
			log.debug("{}",msg1);
			return json;
		}


        public void setCsngrpHolder(ModuleHolder<Csngrp> csngrp)
        {
            this.csngrp = csngrp;
        }

        public Csngrp getCsngrp()
        {
           return this.csngrp.get();
        }


        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }





























































































































































}