package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Ptyaut;
import com.ceb.gjjs.mda.bo.Aut;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbxmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Dbxmod.class);

        //标题
        private String sub;

        //详细信息
        private String dtl;

        //保存交易数据流对象
        private IStream savstm = new StreamImpl();



		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;

	    @BDGetter
		private Aut aut;

	    @BDGetter
		private Ptyaut ptyaut;


		public Dbxmod()
        {
            super();
            setArgument();
        }

        public Dbxmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:dbxmod.@0000.script
        */
        @Rule(target="mtabut.submit",order=300)
        public boolean ruleMtabutSubmitN300(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","submit 300");
			if(MdaUtils.isEmpty(this.getAut().getInr()))
			{
			  return Platform.falseAndRollback();
			}
			String autinr = this.getAut().getInr();
			// 保存交易dat文件
			log.debug("{}","保存交易dat文件");
			MdaUtils.clear(this.getSavstm());
			IStream os = this.getSavstm();
			MdaUtils.saveData(this.getMtabut().getMtagrp(),os);
			if(MdaUtils.isEmpty(os))
			{
			  log.warn("{}",ctx.getTransName() + ": os is empty");
			}
			log.debug("{}","构建PATH");
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			path = MdaUtils.catPath(path,"grant");
			String dfile = autinr + ".dat";
			path = MdaUtils.catPath(path,dfile);
			log.debug("{}","save "+path);
			Platform.mstreamSave(os,path);
			log.debug("{}","submit 300 with errorcode:"+ctx.getErrorCode());

			return true;
        }

        /**
        *   source:dbxmod.@0002.script
        */
        @Rule(target="mtabut.submit",order=800)
        public boolean ruleMtabutSubmitN800(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","submit 800");
			/**校验是否要主管授权**/
			// 如果需要授权返回
			boolean needAuth = checkTransAuthflg();
			if(needAuth)
			{
			  this.getMtabut().setParautflg("X");
			  return true;// 这里返回是表示要继续执行后续 submit代码
			}
			/**如果无需授权则直接将.dat 文件中的内容保存到数据库**/
			grantAut(this.getMtabut().getMtagrp());
			log.debug("{}"," submit 800 errorcode:"+ctx.getErrorCode());

			return true;
        }




        /**
        *   source:dbxmod.@0001.script
        */
        public String setAut()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String autinr = Platform.sdbCounter("aut");
			this.getAut().setInr(autinr);
			this.getAut().setDattim(MdaUtils.today());
			this.getAut().setUsrinr(ctx.absGet(Sysmod.class).getUsr().getInr());
			this.getAut().setSub(this.getSub());
			this.getAut().setPtyinr(ctx.absGet(Sysmod.class).getPty().getInr());
			this.getAut().setFrm(ctx.getTransName());
			this.getAut().setSta("W");//W 待授权
			this.getAut().setFilenam(autinr+".dat");
			String typ=null;
			typ=MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp"));
			log.debug("{}","typ="+typ+"|inr="+autinr);
			this.getAut().setObjtyp(typ);
			IModule rec = MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp\\rec");
			if(MdaUtils.isEmpty(rec))
			{
			  log.debug("{}","rec is null");
			}
			else
			{
			  IDatafield inr =  MdaDriver.getDatafield(rec,"inr");
			  log.debug("{}","objinr null? "+MdaUtils.isEmpty(inr));
			  log.debug("{}","objinr="+inr.getValue());
			  if(!MdaUtils.isEmpty(inr))
			    this.getAut().setObjinr(inr.getValue().toString());
			}
			this.getAut().setDtl(this.getDtl());
			Platform.mdbInsert(this.getAut());
			return autinr;
		}
        /**
        *   source:dbxmod.@0003.script
        */
        public void savAutDsp(IPanel p,String inrnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  String path = Platform.catPath(Platform.getRootPath(),"data");
			  path = Platform.catPath(path,"grant");
			  path = Platform.catPath(path,"dsp");
			  log.debug("save dsp "+path);
			  if(!Platform.mfileExists(path))
			  {
			  log.debug("not  exist");
			  return;
			  }
			  inrnam = inrnam + ".zul";
			  log.debug("save file "+inrnam);
			  path = Platform.catPath(path,inrnam);
			  Platform.saveDisplay(p,path);*/
		}
        /**
        *   source:dbxmod.@0004.script
        */
        public void grantAut(IModule grpModule)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//if(Platform.isEmpty(grpModule))
			//{
			//  log.info("grpModule is Null");
			//  return;ssssss
			//}
			// load 数据文件
			String autinr = this.getAut().getInr();
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			path = MdaUtils.catPath(path,"grant");
			String dfile = autinr + ".dat";
			path = MdaUtils.catPath(path,dfile);
			log.debug("{}","load "+path);
			if(!Platform.mfileExists(path))
			{
			  log.error("{}","数据文件不存在"+dfile);
			  return ;
			}
			IStream is = this.getSavstm();
			log.debug("{}","Load stream...");
			Platform.mstreamLoad(is,path);
			log.debug("{}","load Data...");
			MdaUtils.loadData(grpModule,is);
			log.debug("{}","@@@@ 1 @@@@");
			IModule rec = MdaDriver.getModule(this,grpModule,"rec");
			log.debug("{}","rec is empty？ "+MdaUtils.isEmpty(rec));
			if(!MdaUtils.isEmpty(rec))
			{
			  log.debug("{}","@@@@ rec 非空 @@@@");
			  IDatafield flg = MdaDriver.getDatafield(grpModule,"recsavflg");
			  if(!MdaUtils.isEmpty(flg))
			  {
			    String sflg = flg.getValue().toString();
			    log.debug("{}","rec flg is "+sflg);
			    if("save".equals(sflg))
			    {
			      //更新rec
			      Platform.mdbUpdate(rec);
			    }
			    else if("new".equals(sflg))
			    {//或新增rec
			      Platform.mdbInsert(rec);
			    }
			    else if("delete".equals(sflg))
			    {
			      //或删除rec
			      Platform.mdbDelete(rec);
			    }
			  }
			}
			IModule rec1 = MdaDriver.getModule(this,grpModule,"rec1");
			log.debug("{}","rec1 is empty？ "+MdaUtils.isEmpty(rec));
			if(!MdaUtils.isEmpty(rec1))
			{
			  log.debug("{}","@@@@ rec1 非空 @@@@");
			  IDatafield flg1 = MdaDriver.getDatafield(grpModule,"rec1savflg");
			  if(!MdaUtils.isEmpty(flg1))
			  {
			    String sflg1 = flg1.getValue().toString();
			    log.debug("{}","rec1 flg is "+sflg1);
			    if("save".equals(sflg1))
			    {
			      //更新rec
			      Platform.mdbUpdate(rec1);
			    }
			    else if("new".equals(sflg1))
			    {//或新增rec
			      Platform.mdbInsert(rec1);
			    }
			    else if("delete".equals(sflg1))
			    {
			      //或删除rec
			      Platform.mdbDelete(rec1);
			    }
			  }
			}
			IModuleList oldlst = (IModuleList)MdaDriver.getBaseObject(grpModule,"oldlst");
			log.debug("{}","oldlst is empty？ "+MdaUtils.isEmpty(oldlst));
			IModuleList newlst = (IModuleList)MdaDriver.getBaseObject(grpModule,"newlst");
			log.debug("{}","newlst is empty？ "+MdaUtils.isEmpty(newlst));
			// 循环删除并更新列表
			if(!MdaUtils.isEmpty(oldlst))
			{
			  log.debug("{}","oldlst size="+oldlst.fullSize());
			  for(int i=0;i<oldlst.fullSize();i++)
			  {
			    IModule o = (IModule)oldlst.get(i);
			    log.debug("{}","@@@@ 1 Module: " + o + "@@@@");
			    IDatafield oinr = MdaDriver.getDatafield(o,"inr");
			    log.debug("{}","@@@@ 2 oinr: "+oinr+" @@@@");
			    if(oinr==null || oinr.getValue()==null)
			      continue;
			    String soinr = oinr.getValue().toString();
			    log.debug("{}","old "+i+" inr="+soinr);
			    Platform.mdbRead(o,new Argument<String>("inr",soinr));
			    Platform.mdbDelete(o);
			  }
			}
			if(!MdaUtils.isEmpty(newlst))
			{
			  log.debug("{}","newlst size="+newlst.fullSize());
			  for(int i=0;i<newlst.fullSize();i++)
			  {
			    IModule n = (IModule)newlst.get(i);
			    IDatafield ninr = MdaDriver.getDatafield(n,"inr");
			    if(ninr==null || ninr.getValue()==null)
			      continue;
			    log.debug("{}","new "+i+" inr="+ninr.getValue());
			    Platform.mdbInsert(n);
			  }
			}

			//oldlst1和newlst1处理逻辑
			IModuleList oldlst1 = (IModuleList)MdaDriver.getBaseObject(grpModule,"oldlst1");
			log.debug("{}","oldlst1 is empty？ "+MdaUtils.isEmpty(oldlst1));
			IModuleList newlst1 = (IModuleList)MdaDriver.getBaseObject(grpModule,"newlst1");
			log.debug("{}","newlst1 is empty？ "+MdaUtils.isEmpty(newlst1));
			// 循环删除并更新列表
			if(!MdaUtils.isEmpty(oldlst1))
			{
			  log.debug("{}","oldlst1 size="+oldlst1.fullSize());
			  for(int i=0;i<oldlst1.fullSize();i++)
			  {
			    IModule o = (IModule)oldlst1.get(i);
			    log.debug("{}","@@@@ 1 Module: " + o + "@@@@");
			    IDatafield oinr = MdaDriver.getDatafield(o,"inr");
			    log.debug("{}","@@@@ 2 oinr: "+oinr+" @@@@");
			    if(oinr==null || oinr.getValue()==null)
			      continue;
			    String soinr = oinr.getValue().toString();
			    log.debug("{}","old1 "+i+" inr="+soinr);
			    Platform.mdbRead(o,new Argument<String>("inr",soinr));
			    Platform.mdbDelete(o);
			  }
			}
			if(!MdaUtils.isEmpty(newlst1))
			{
			  log.debug("{}","newlst1 size="+newlst1.fullSize());
			  for(int i=0;i<newlst1.fullSize();i++)
			  {
			    IModule n = (IModule)newlst1.get(i);
			    IDatafield ninr = MdaDriver.getDatafield(n,"inr");
			    if(ninr==null || ninr.getValue()==null)
			      continue;
			    log.debug("{}","new1 "+i+" inr="+ninr.getValue());
			    Platform.mdbInsert(n);
			  }
			}

			// 保存后置授权状态为已经授权 'D'one
			this.getAut().setSta("D");
			Platform.mdbUpdate(this.getAut());
		}
        /**
        *   source:dbxmod.@0005.script
        */
        public boolean checkTransAuthflg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String trnnam = ctx.getTransName();
			MdaUtils.clear(this.getPtyaut());
			Platform.mdbRead(this.getPtyaut(),new Argument("frm",trnnam));
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  log.debug("{}",trnnam+" ptyaut inr="+this.getPtyaut().getInr());
			  if(MdaUtils.isEmpty(this.getPtyaut())||MdaUtils.isEmpty(this.getPtyaut().getChkflg()))
			    return false;
			}
			/*log.debug(trnnam+" ptyaut inr="+$ptyaut\\inr);
			  if(Platform.isEmpty($ptyaut)||Platform.isEmpty($ptyaut\\chkflg))
			  return false;*/
			if("0".equals(this.getPtyaut().getChkflg()))
			  return true;
			return false;
		}


        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }









}