package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Etg;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Etggrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Etggrp.class);



	    @BDGetter
		private Etg rec;


		public Etggrp()
        {
            super();
            setArgument();
        }

        public Etggrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:etggrp.@0001.script
        */
        public boolean insert(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tansaction insert...");
			log.debug("{}","framname :"+framname);
			if("dbaetg".equals(framname))
			{
			  log.debug("{}","dbaetg begin....");
			  /*if(!dataChecked())
			    return false;*/
			  this.getRec().setInr( Platform.sdbCounter("etg"));
			  log.debug("{}","@@@@ etg-inr:" + this.getRec().getInr() + " @@@@");
			  this.getRec().setSta( "0");

			  log.debug("{}","etg insert...");
			  Platform.mdbInsert(this.getRec());
			  int errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:etggrp.@0002.script
        */
        public boolean update(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tansaction update..");
			log.debug("{}","framname :"+framname);
			if ("dbeetg".equals(framname))
			{
			  log.debug("{}","dbeetg update...");
			  Platform.mdbUpdate(this.getRec());
			  int errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    log.debug("{}","update etg with errorcode:" + errorcode);
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:etggrp.@0003.script
        */
        public boolean delete(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tansaction delete....");
			log.debug("{}","framname :"+framname);

			if ("dbdetg".equals(framname))
			{
			  this.getRec().setSta( "1");
			  log.debug("{}","sta="+this.getRec().getSta()+",dbdetg update...");
			  Platform.mdbUpdate(this.getRec());
			  int errorcode = ctx.getErrorCode();
			  if(errorcode == NO_ERROR)
			  {
			    return true;
			  }
			  else
			  {
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:etggrp.@0004.script
        */
        public boolean checkEtgIsExists(IDatafield namIDatafield)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String nam = (String)namIDatafield.getValue();
			Argument<String> inr = new Argument<String>("inr");
			String sql="select inr from etg where nam = '"+nam+"'  AND sta <> '1'";
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(inr);
			Platform.mdbCloseCursor();
			log.debug("{}","inr:" + inr.value);
			if(!MdaUtils.isEmpty(inr.value))
			  return true;
			else
			  return false;
		}
        /**
        *   source:etggrp.@0005.script
        */
        public boolean checkEtgIsExists(IDatafield namIDatafield,IDatafield inrIDatafield)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String nam = (String)namIDatafield.getValue();
			String inr = (String)inrIDatafield.getValue();
			Argument<String> etginr = new Argument<String>("inr");
			String sql="select inr from etg where nam = '"+nam+"' AND sta <> '1' ";
			if(!MdaUtils.isEmpty(inr))
			{
			  sql = sql + " AND inr <> '"+inr+"'";
			}
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(etginr);
			Platform.mdbCloseCursor();
			log.debug("{}","inr:" + etginr.value);
			if(!MdaUtils.isEmpty(etginr.value))
			  return true;
			else
			  return false;
		}
        /**
        *   source:etggrp.@0006.script
        */
        public boolean isEtgIsUsed(IDatafield etginrIDatafield)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String etginr = (String)etginrIDatafield.getValue();
			Argument<String> inr = new Argument<String>("inr");
			String sql="select inr from ety where etginr = '"+etginr+"' and sta <> '1' ";
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(inr);
			Platform.mdbCloseCursor();
			log.debug("{}","inr:" + inr.value);
			if(!MdaUtils.isEmpty(inr.value))
			  return true;
			else
			  return false;
		}


}