package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Etg;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Etgp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Etgp.class);

        //标题
        private String tit;

        //实体组名称
        private String nam;

        //清空
        private IControl clr;

        //查询
        private IControl sel;

        //实体组注册
        private IControl add;

        //实体组描述
        private String des;

        //修改
        private IControl ame;

        //注销
        private IControl del;

        //返回
        private IControl cancel;


        @JsonIgnore
        @BDGetter
        private transient IPanel edip;

        @JsonIgnore
        @BDGetter
        private transient IPanel etgp;

        @JsonIgnore
        @BDGetter
        private transient IPanel inqp;

        @JsonIgnore
        @BDGetter
        private transient IPanel serp;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel etglstp;

        @JsonIgnore
        @BDGetter
        private transient IPanel etgp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel etgp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp03;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Etggrp> etggrp;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;

		@BDGetter
		private ModuleList<Etg> etglst;

		@BDGetter
		private ModuleList<Etg> etgshwlst;


		public Etgp()
        {
            super();
            setArgument();
        }

        public Etgp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:etgp.@0000.script
        */
        @Rule(target="mtabut.htymod.hty",order=100)
        public boolean ruleMtabutHtymodHtyN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMtabut().getHtymod().getLst());
			String objinr="";
			ctx.getDaoSession().dbConnect();
			if(!MdaUtils.isEmpty(this.getEtggrp().getRec().getInr()))
			{
			  objinr = this.getEtggrp().getRec().getInr();
			}
			String sql="";
			Argument<Date> dattim =new Argument<Date>("dattim");
			Argument<String> usr =new Argument<String>("usr");
			Argument<String> txt =new Argument<String>("txt");
			sql="select dattim,usr,dbms_lob.substr(txt) txt from sme where (frmnam='dbeetg' or frmnam='dbaetg') and objinr=?  order by dattim ";
			log.debug("{}","[objinr] "+objinr);
			ctx.getDaoSession().dbExecuteSQL(sql,objinr);

			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(dattim,usr,txt);
			  int error =ctx.getErrorCode();
			  if(error==NO_ERROR)
			  {
			    this.getMtabut().getHtymod().getLst().add(dattim,usr,txt);
			  }

			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			ctx.getDaoSession().dbDisconnect();
			
			

			return true;
        }

        /**
        *   source:etgp.@0003.script
        */
        @Rule(target="cancel",order=100)
        public boolean ruleCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			//刷新查询界面并返回
			String key="handleTemp";
			ctx.storeData(key,key);
			MdaUtils.returnToFirst();

			return true;
        }

        /**
        *   source:etgp.@0004.script
        */
        @Rule(target="mtabut.submit",order=1001)
        public boolean ruleMtabutSubmitN1001(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","submit 1001");
			Map lstetgMap = new HashMap();
			lstetgMap.put("inr", this.getEtggrp().getRec().getInr());
			lstetgMap.put("nam", this.getEtggrp().getRec().getNam());
			lstetgMap.put("des", this.getEtggrp().getRec().getDes());
			ctx.storeData("lstetgMap",lstetgMap);

			return true;
        }


        /**
        *   source:etgp.@0005.script
        */
        @Check(target="etggrp.rec.nam",order=100)
        public boolean checkEtggrpRecNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtggrp().getRec().getNam()))
			{
			  ctx.setFieldError(this,"etggrp.rec.nam",MdaUtils.getI18NString("etgp","CT000032"));
			  return false;
			}

			return true;
        }

        /**
        *   source:etgp.@0006.script
        */
        @Check(target="etggrp.rec.des",order=100)
        public boolean checkEtggrpRecDesN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtggrp().getRec().getDes()))
			{
			  ctx.setFieldError(this,"etggrp.rec.des",MdaUtils.getI18NString("etgp","CT000034"));
			  return false;
			}

			return true;
        }


        /**
        *   source:etgp.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Map etgMap = new HashMap();
			etgMap.put("inr", this.getEtggrp().getRec().getInr());
			etgMap.put("nam", this.getEtggrp().getRec().getNam());
			etgMap.put("des", this.getEtggrp().getRec().getDes());
			ctx.storeData("etgMap",etgMap);
			Object obj=ctx.restoreData("handleTemp");
			if(obj!=null)
			{
			  ctx.postRule(this,"sel");
			}

			return true;
        }




        public void setEtggrpHolder(ModuleHolder<Etggrp> etggrp)
        {
            this.etggrp = etggrp;
        }

        public Etggrp getEtggrp()
        {
           return this.etggrp.get();
        }


        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }





















}