package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ety;
import com.ceb.gjjs.mda.bo.Etg;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Etygrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Etygrp.class);



	    @BDGetter
		private Ety rec;

	    @BDGetter
		private Etg etg;


		public Etygrp()
        {
            super();
            setArgument();
        }

        public Etygrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:etygrp.@0000.script
        */
        public boolean insert(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tansaction insert...");
			log.debug("{}","framname :"+framname);
			if("dbaety".equals(framname))
			{
			  log.debug("{}","dbaety begin....");
			  this.getRec().setInr( Platform.sdbCounter("ety"));
			  log.debug("{}","@@@@ ety-inr:" + this.getRec().getInr() + " @@@@");
			  this.getRec().setSta( "0");

			  log.debug("{}","ety insert...");
			  Platform.mdbInsert(this.getRec());
			  int errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:etygrp.@0001.script
        */
        public boolean update(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tansaction update..");
			log.debug("{}","framname :"+framname);
			if ("dbeety".equals(framname))
			{
			  log.debug("{}","dbeety update...");
			  Platform.mdbUpdate(this.getRec());
			  int errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    log.debug("{}","update ety with errorcode:" + errorcode);
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:etygrp.@0002.script
        */
        public boolean delete(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tansaction delete....");
			log.debug("{}","framname :"+framname);

			if ("dbdety".equals(framname))
			{
			  this.getRec().setSta( "1");
			  log.debug("{}","sta="+this.getRec().getSta()+",dbdety update...");
			  Platform.mdbUpdate(this.getRec());
			  int errorcode = ctx.getErrorCode();
			  if(errorcode == NO_ERROR)
			  {
			    return true;
			  }
			  else
			  {
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:etygrp.@0003.script
        */
        public boolean checkEtyIsExists(IDatafield refIDatafield)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ref = (String)refIDatafield.getValue();
			Argument<String> inr = new Argument<String>("inr");
			String sql="select inr from ety where ref = '"+ref+"' AND sta <> '1' ";
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(inr);
			Platform.mdbCloseCursor();
			log.debug("{}","inr:" + inr.value);
			if(!MdaUtils.isEmpty(inr.value))
			  return true;
			else
			  return false;
		}
        /**
        *   source:etygrp.@0004.script
        */
        public boolean checkEtyIsExists(IDatafield refIDatafield,IDatafield inrIDatafield)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ref = (String)refIDatafield.getValue();
			String inr = (String)inrIDatafield.getValue();
			Argument<String> etyinr = new Argument<String>("inr");
			String sql="select inr from ety where ref = '"+ref+"' AND inr <> '"+inr+"' AND sta <> '1' ";
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(etyinr);
			Platform.mdbCloseCursor();
			log.debug("{}","inr:" + etyinr.value);
			if(!MdaUtils.isEmpty(etyinr.value))
			  return true;
			else
			  return false;
		}
        /**
        *   source:etygrp.@0005.script
        */
        public boolean isEtyIsUsed(IDatafield etyinrIDatafield)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String etyinr = (String)etyinrIDatafield.getValue();
			Argument<String> inr = new Argument<String>("inr");
			String sql="select inr from pty where etyinr = '"+etyinr+"' and status <> '1' ";
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(inr);
			Platform.mdbCloseCursor();
			log.debug("{}","inr:" + inr.value);
			if(!MdaUtils.isEmpty(inr.value))
			  return true;
			else
			  return false;
		}



}