package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ety;
import com.ceb.gjjs.mda.bo.Etg;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Etyp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Etyp.class);

        //标题
        private String tit;

        //清空
        private IControl clr;

        //查询
        private IControl sel;

        //注册
        private IControl add;

        //实体描述
        private String des;

        //修改
        private IControl ame;

        //注销
        private IControl del;

        //返回
        private IControl cancel;

        //实体中文名称
        private String etynam;

        //实体编号
        private String ref;

        //实体英文名称
        private String etyeng;

        //所属实体组
        private String etginr;


        @JsonIgnore
        @BDGetter
        private transient IPanel edip;

        @JsonIgnore
        @BDGetter
        private transient IPanel etyp;

        @JsonIgnore
        @BDGetter
        private transient IPanel inqp;

        @JsonIgnore
        @BDGetter
        private transient IPanel serp;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel etylstp;

        @JsonIgnore
        @BDGetter
        private transient IPanel etyp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel etyp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp03;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Etygrp> etygrp;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;

		@BDGetter
		private ModuleList<Ety> etylst;

		@BDGetter
		private ModuleList<Ety> etyshwlst;

		@BDGetter
		private ModuleList<Etg> etglst;


		public Etyp()
        {
            super();
            setArgument();
        }

        public Etyp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:etyp.@0004.script
        */
        @Rule(target="mtabut.htymod.hty",order=100)
        public boolean ruleMtabutHtymodHtyN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMtabut().getHtymod().getLst());
			String objinr="";
			ctx.getDaoSession().dbConnect();
			if(!MdaUtils.isEmpty(this.getEtygrp().getRec().getInr()))
			  objinr = this.getEtygrp().getRec().getInr();
			String sql="";
			Argument<Date> dattim =new Argument<Date>("dattim");
			Argument<String> usr =new Argument<String>("usr");
			Argument<String> txt =new Argument<String>("txt");
			sql="select dattim,usr,dbms_lob.substr(txt) txt from sme where( frmnam='dbeety' or frmnam='dbaety') and objinr=?  order by dattim ";
			log.debug("{}","[objinr] "+objinr);
			ctx.getDaoSession().dbExecuteSQL(sql,objinr);

			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(dattim,usr,txt);
			  int error =ctx.getErrorCode();
			  if(error==NO_ERROR)
			  {
			    this.getMtabut().getHtymod().getLst().add(dattim,usr,txt);
			  }

			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			ctx.getDaoSession().dbDisconnect();
			
			

			return true;
        }

        /**
        *   source:etyp.@0006.script
        */
        @Rule(target="mtabut.submit",order=101)
        public boolean ruleMtabutSubmitN101(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","submit 101");
			Map lstetyMap = new HashMap();
			lstetyMap.put("inr", this.getEtygrp().getRec().getInr());
			lstetyMap.put("ref", this.getEtygrp().getRec().getRef());
			lstetyMap.put("etginr", this.getEtygrp().getRec().getEtginr());
			lstetyMap.put("etynam", this.getEtygrp().getRec().getEtynam());
			lstetyMap.put("etyeng", this.getEtygrp().getRec().getEtyeng());
			lstetyMap.put("des", this.getEtygrp().getRec().getDes());
			ctx.storeData("lstetyMap",lstetyMap);

			return true;
        }


        /**
        *   source:etyp.@0007.script
        */
        @Check(target="etygrp.rec.ref",order=100)
        public boolean checkEtygrpRecRefN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtygrp().getRec().getRef()))
			{
			  ctx.setFieldError(this,"etygrp.rec.ref",MdaUtils.getI18NString("etyp","CT000054"));
			  return false;
			}

			return true;
        }

        /**
        *   source:etyp.@0008.script
        */
        @Check(target="etygrp.rec.etginr",order=100)
        public boolean checkEtygrpRecEtginrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtygrp().getRec().getEtginr()))
			{
			  ctx.setFieldError(this,"etygrp.rec.etginr",MdaUtils.getI18NString("etyp","CT000055"));
			  return false;
			}

			return true;
        }

        /**
        *   source:etyp.@0009.script
        */
        @Check(target="etygrp.rec.etynam",order=100)
        public boolean checkEtygrpRecEtynamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtygrp().getRec().getEtynam()))
			{
			  ctx.setFieldError(this,"etygrp.rec.etynam",MdaUtils.getI18NString("etyp","CT000056"));
			  return false;
			}

			return true;
        }

        /**
        *   source:etyp.@0010.script
        */
        @Check(target="etygrp.rec.etyeng",order=100)
        public boolean checkEtygrpRecEtyengN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtygrp().getRec().getEtyeng()))
			{
			  ctx.setFieldError(this,"etygrp.rec.etyeng",MdaUtils.getI18NString("etyp","CT000058"));
			  return false;
			}

			return true;
        }

        /**
        *   source:etyp.@0011.script
        */
        @Check(target="etygrp.rec.des",order=100)
        public boolean checkEtygrpRecDesN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEtygrp().getRec().getDes()))
			{
			  ctx.setFieldError(this,"etygrp.rec.des",MdaUtils.getI18NString("etyp","CT000059"));
			  return false;
			}

			return true;
        }


        /**
        *   source:etyp.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Map etyMap = new HashMap();
			etyMap.put("inr", this.getEtygrp().getRec().getInr());
			etyMap.put("ref", this.getEtygrp().getRec().getRef());
			etyMap.put("etginr", this.getEtygrp().getRec().getEtginr());
			etyMap.put("etynam", this.getEtygrp().getRec().getEtynam());
			etyMap.put("etyeng", this.getEtygrp().getRec().getEtyeng());
			etyMap.put("des", this.getEtygrp().getRec().getDes());
			ctx.storeData("etyMap",etyMap);
			List<CodetableItem> cts = getEtgCT();
			log.debug("{}","*******"+cts.size()+"*******");
			MdaUtils.setValues(this.getEtygrp().getRec(),"etginr",cts);
			if("dbdety".equals(Platform.sgetTransName()))
			{
			  
			}
			Object obj=ctx.restoreData("handleTemp");
			if(obj!=null)
			{
			  ctx.postRule(this,"sel");
			}

			return true;
        }


        /**
        *   source:etyp.@0000.script
        */
        public List<CodetableItem> getEtgCT()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> cts = new ArrayList<CodetableItem>();
			MdaUtils.clear(this.getEtglst());
			Map<String,String> etymap=new HashMap<String,String>();
			Platform.mdbReadset(this.getEtglst(),new Argument<String>("sta",EQ,"0"));
			log.debug("{}","@@@@ etglst-size:" + this.getEtglst().fullSize() + " @@@@");
			for(int i=0;i<this.getEtglst().fullSize();i++)
			{
			  String inr = this.getEtglst().getElement(i).getInr();
			  String nam = this.getEtglst().getElement(i).getNam();
			  CodetableItem cti = new CodetableItem(nam,inr);
			  //记录操作
			  etymap.put(inr,nam);
			  cts.add(cti);
			}
			log.debug("{}","@@@@ codetable-size:"+cts.size() + " @@@@");
			this.getMtabut().getHtymod().setEtgmap(etymap);
			return cts;
		}
        /**
        *   source:etyp.@0002.script
        */
        public Map<String,String> getEtgMap()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,String> map = new HashMap<String,String>();
			MdaUtils.clear(this.getEtglst());
			Platform.mdbReadset(this.getEtglst(),new Argument<String>("sta",EQ,"0"));
			log.debug("{}","@@@@ etglst-size:" + this.getEtglst().fullSize() + " @@@@");
			for(int i=0;i<this.getEtglst().fullSize();i++)
			{
			  String inr = this.getEtglst().getElement(i).getInr();
			  String nam = this.getEtglst().getElement(i).getNam();
			  map.put(inr,nam);
			}
			log.debug("{}","@@@@ codetable-size:"+map.size() + " @@@@");
			return map;
		}


        public void setEtygrpHolder(ModuleHolder<Etygrp> etygrp)
        {
            this.etygrp = etygrp;
        }

        public Etygrp getEtygrp()
        {
           return this.etygrp.get();
        }


        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }




























}