package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Chn;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fmpp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Fmpp.class);

        //起始时间
        private Date statim;

        //截止时间
        private Date endtim;

        //我方编号
        private String ownref;

        //对方编码
        private String othref;

        //消息类型(如:sf2)
        private String msgtyp;

        //消息格式类型(如:MT103)
        private String subtyp;

        //币种
        private String cur;

        //账号
        private String act;

        //金额下限
        private BigDecimal amtsta = new BigDecimal("0.00");

        //金额上限
        private BigDecimal amtend = new BigDecimal("0.00");

        //查询
        private IControl sel;

        //返回
        private IControl rtn;

        //清除
        private IControl clear;

        //处理状态
        private String sta;

        //导出
        private IStream exp = new StreamImpl();

        //放行
        private IControl snd;

        //退回编辑
        private IControl rtnedt;

        //丢弃
        private IControl giv;

        //数字签名查询
        private IControl sigsel;

        //数字签名查复
        private IControl sigrtn;

        //重新发送
        private IControl resend;

        //数字签名标志
        private String flg;

        //核对签名
        private IControl chksig;

        //原100报签名
        private String oldtxt;

        //查复024签名内容
        private String newtxt;

        //确认
        private IControl qur;

        //对账
        private String lbl;

        //对账状态
        private String actsta;

        //收发方向
        private String dir;

        //报文详情
        private String msgdtl;

        //确定
        private IControl sur;

        //组报信息MAP
        private Map map;

        //取消
        private IControl cancel;


        @JsonIgnore
        @BDGetter
        private transient IPanel mainpl;

        @JsonIgnore
        @BDGetter
        private transient IPanel lftpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgtpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel chksigpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgshwpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnp;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Fmtgrp> fmtgrp;

	    @BDGetter
		private Chn chnxor;

	    @BDGetter
		private Mdtmod mdtmod;

	    @BDGetter
		private Ldtmod ldtmod;


		public Fmpp()
        {
            super();
            setArgument();
        }

        public Fmpp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:fmpp.@0002.script
        */
        @Rule(target="cancel",order=100)
        public boolean ruleCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }


        /**
        *   source:fmpp.@0000.script
        */
        @Check(target="ownref",order=100)
        public boolean checkOwnrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.transAndCheckRef(MdaDriver.getDatafield(this,"ownref"));

			return true;
        }


        /**
        *   source:fmpp.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setStatim( Platform.formatDateTime(MdaUtils.add(MdaUtils.today(),-3),"0"));
			this.setEndtim( Platform.formatDateTime(MdaUtils.today(),"235959"));

			return true;
        }




        public void setFmtgrpHolder(ModuleHolder<Fmtgrp> fmtgrp)
        {
            this.fmtgrp = fmtgrp;
        }

        public Fmtgrp getFmtgrp()
        {
           return this.fmtgrp.get();
        }






































































}