package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Frm;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Frmgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Frmgrp.class);



	    @BDGetter
		private Frm rec;

		@BDGetter
		private ModuleList<Frm> frmlst;


		public Frmgrp()
        {
            super();
            setArgument();
        }

        public Frmgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:frmgrp.@0000.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getErrorCode();
			this.getRec().setInr( Platform.sdbCounter("frm"));
			log.debug("{}","生成的inr:"+this.getRec().getInr());
			Platform.mdbInsert(this.getRec());
			int errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:frmgrp.@0001.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getErrorCode();
			Platform.mdbUpdate(this.getRec());
			int errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:frmgrp.@0002.script
        */
        public boolean delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","frm inr:"+this.getRec().getInr());
			log.debug("{}","frm frm:"+this.getRec().getFrm());
			ctx.getErrorCode();
			if(!MdaUtils.isEmpty(this.getRec().getInr()))
			  Platform.mdbDelete(this.getRec(),new Argument("inr",this.getRec().getInr()));
			int errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}



}