package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Frm;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Frr;
import com.ceb.gjjs.mda.bo.Mpi;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Frrgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Frrgrp.class);

        //未分配菜单
        private StreamGrid lftgrd;

        //已分配菜单
        private StreamGrid rgtgrd;

        //新增菜单
        private StreamGrid addgrd;

        //减少菜单
        private StreamGrid rmvgrd;

        //角色名称
        private String rolnam;

        //菜单分配类型
        private String oprtyp;

        //临时未分配菜单
        private StreamGrid lfttmpgrd;

        //临时已分配菜单
        private StreamGrid rgttmpgrd;



	    @BDGetter
		private Frr rec;

	    @BDGetter
		private Frm frm;

		@BDGetter
		private ModuleList<Frr> frrlst1;

		@BDGetter
		private ModuleList<Frr> frrlst2;

		@BDGetter
		private ModuleList<Frr> frrlst;

		@BDGetter
		private ModuleList<Frr> lfttmplst;

		@BDGetter
		private ModuleList<Frr> rgttmplst;

	    @BDGetter
		private Grdmod grdmod;

	    @BDGetter
		private Mpi mpi;


		public Frrgrp()
        {
            super();
            setArgument();
        }

        public Frrgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:frrgrp.@0000.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","update frr...");
			int errorcode = ctx.getErrorCode();
			StreamGrid lftgrd = this.getLftgrd();
			StreamGrid rgtgrd = this.getRgtgrd();
			log.debug("{}","oprtyp:"+this.getOprtyp());
			//记录操作
			log.debug("{}","ROL_INR "+this.getRolnam());
			String operationRecord="角色:"+getRolNam(this.getRolnam())+" ";
			String objinr=this.getRolnam();
			int countTrans=0;
			if("false".equals(this.getOprtyp()))
			{
			  for(int i=0 ; i<lftgrd.size() ; i++)//未分配菜单
			  {
			    AttributeValue lftval = (AttributeValue)lftgrd.get(i)[1];
			    String flg = (String) lftval.getAttribute("flg");
			    String frm = (String) lftval.getAttribute("frm");
			    String frminr = (String) lftval.getAttribute("frminr");
			    String frrinr = (String) lftval.getAttribute("frrinr");
			    log.debug("{}","dbefrr frrinr:"+frrinr);
			    log.debug("{}","dbefrr frm:"+frm);
			    log.debug("{}","dbefrr frminr:"+frminr);
			    log.debug("{}","errorcode:"+errorcode);
			    MdaUtils.clear(this.getRec());
			    Platform.sdbRead(this.getRec(),frrinr);
			    if("D".equals(flg))
			    {
			      if(MdaUtils.isEmpty(this.getRec()))
			      {
			        this.getRec().setFrminr( frminr);
			        this.getRec().setObjinr( this.getRolnam());
			        this.getRec().setObjtyp( "rol");
			        this.getRec().setTyp( "1");
			        Platform.sdbInsert(this.getRec());
			        //记录操作
			        String key = "menu."+frm;
			        String nam = MdaUtils.getI18nValue("eibs",key);
			        //operationRecord+="删除交易"+nam+" ";
			        countTrans++;
			        log.debug("{}","MENU_NAME"+nam);
			      }
			      else
			      {
			        log.debug("{}","dbefrr lft update frminr:"+frminr);
			        this.getRec().setTyp( "1");
			        Platform.mdbUpdate(this.getRec());
			        //记录操作
			        String key = "menu."+frm;
			        String nam = MdaUtils.getI18nValue("eibs",key);
			        //operationRecord+="删除交易"+nam+" ";
			        countTrans++;
			        log.debug("{}","MENU_NAME"+nam);
			      }
			    }
			    errorcode = ctx.getErrorCode();
			    if(errorcode != NO_ERROR)
			      return false;
			  }
			  for(int i=0 ; i<rgtgrd.size() ; i++)
			  {
			    AttributeValue rgtval = (AttributeValue)rgtgrd.get(i)[1];
			    String flg = (String) rgtval.getAttribute("flg");
			    String frm = (String) rgtval.getAttribute("frm");
			    String frminr = (String) rgtval.getAttribute("frminr");
			    String frrinr = (String) rgtval.getAttribute("frrinr");
			    log.debug("{}","dbefrr frrinr:"+frrinr);
			    log.debug("{}","dbefrr frm:"+frm);
			    log.debug("{}","dbefrr frminr:"+frminr);
			    log.debug("{}","errorcode:"+errorcode);
			    MdaUtils.clear(this.getRec());
			    Platform.sdbRead(this.getRec(),frrinr);
			    if("A".equals(flg))
			    {
			      if(MdaUtils.isEmpty(this.getRec()))
			      {
			        log.debug("{}","dbefrr rgt insert frminr:"+frminr);
			        this.getRec().setFrminr( frminr);
			        this.getRec().setObjinr( this.getRolnam());
			        this.getRec().setObjtyp( "rol");
			        this.getRec().setTyp( "0");
			        Platform.sdbInsert(this.getRec());
			        //记录操作
			        String key = "menu."+frm;
			        String nam = MdaUtils.getI18nValue("eibs",key);
			        //operationRecord+="新增交易"+nam+" ";
			        countTrans++;
			        log.debug("{}","MENU_NAME"+nam);
			      }
			      else
			      {
			        log.debug("{}","dbefrr rgt update frminr:"+frminr);
			        this.getRec().setTyp( "0");
			        Platform.mdbUpdate(this.getRec());
			        //记录操作
			        String key = "menu."+frm;
			        String nam = MdaUtils.getI18nValue("eibs",key);
			        //operationRecord+="新增交易"+nam+" ";
			        countTrans++;
			        log.debug("{}","MENU_NAME"+nam);
			      }
			    }
			    errorcode = ctx.getErrorCode();
			    if(errorcode != NO_ERROR)
			      return false;
			  }
			}
			if("true".equals(this.getOprtyp()))
			{
			  for(int i=0 ; i<lftgrd.size() ; i++)
			  {
			    AttributeValue lftval = (AttributeValue)lftgrd.get(i)[1];
			    String flg = (String) lftval.getAttribute("flg");
			    String frm = (String) lftval.getAttribute("frm");
			    String frminr = (String) lftval.getAttribute("frminr");
			    String frrinr = (String) lftval.getAttribute("frrinr");
			    log.debug("{}","dbefrr frrinr:"+frrinr);
			    log.debug("{}","dbefrr frm:"+frm);
			    log.debug("{}","dbefrr frminr:"+frminr);
			    log.debug("{}","errorcode:"+errorcode);
			    MdaUtils.clear(this.getRec());
			    this.getRec().setFrminr( frminr);
			    this.getRec().setObjinr( this.getRolnam());
			    this.getRec().setObjtyp( "rol");
			    this.getRec().setTyp( "1");
			    Platform.sdbInsert(this.getRec());
			    //记录操作
			    String key = "menu."+frm;
			    String nam = MdaUtils.getI18nValue("eibs",key);
			    //operationRecord+="删除交易"+nam+" ";
			    countTrans++;
			    log.debug("{}","MENU_NAME"+nam);
			  }
			  for(int i=0 ; i<rgtgrd.size() ; i++)
			  {
			    AttributeValue rgtval = (AttributeValue)rgtgrd.get(i)[1];
			    String flg = (String) rgtval.getAttribute("flg");
			    String frm = (String) rgtval.getAttribute("frm");
			    String frminr = (String) rgtval.getAttribute("frminr");
			    String frrinr = (String) rgtval.getAttribute("frrinr");
			    log.debug("{}","dbefrr frrinr:"+frrinr);
			    log.debug("{}","dbefrr frm:"+frm);
			    log.debug("{}","dbefrr frminr:"+frminr);
			    log.debug("{}","errorcode:"+errorcode);
			    MdaUtils.clear(this.getRec());
			    this.getRec().setFrminr( frminr);
			    this.getRec().setObjinr( this.getRolnam());
			    this.getRec().setObjtyp( "rol");
			    this.getRec().setTyp( "0");
			    Platform.sdbInsert(this.getRec());
			    //记录操作
			    String key = "menu."+frm;
			    String nam = MdaUtils.getI18nValue("eibs",key);
			    //operationRecord+="新增交易"+nam+" ";
			    countTrans++;
			    log.debug("{}","MENU_NAME"+nam);
			  }
			}
			operationRecord+="定制交易变更数量:";
			operationRecord+=""+countTrans;
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Mtabut.class).getHtymod().insertHistoryWithoutDbOp(operationRecord,"eibs","frr","新增",objinr);
			return true;
		}
        /**
        *   source:frrgrp.@0001.script
        */
        public String getRolNam(String roleInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,String> map=new HashMap<String,String>();
			String rolName="";
			String sql = "SELECT nam FROM rol WHERE FLG = '0' and inr = ? ";
			//增加实体查询条件
			sql = sql+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtySql();
			Platform.mdbExecuteSQL(sql,roleInr);
			log.debug("{}","inr="+roleInr);
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  Platform.mdbFetchFields(nam);
			  int errorcode = ctx.getErrorCode();
			  if(errorcode == NO_ERROR)
			  {
			    if( nam.value != null)
			    {
			      rolName=(String)nam.value;
			    }
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return rolName;
		}


























}