package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Frrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Frrp.class);

        //>
        private IControl add;

        //>>
        private IControl addall;

        //<
        private IControl rev;

        //<<
        private IControl revall;

        //角色名称
        private String rolnam;

        //已分配交易数
        private String numral;

        //未分配交易数
        private String numyet;

        //复制菜单
        private IControl copmnu;

        //复制菜单源角色
        private String coprolnam;

        //复制菜单源角色标签
        private String coprollbl;

        //确认复制
        private IControl coprol;


        @JsonIgnore
        @BDGetter
        private transient IPanel northp;

        @JsonIgnore
        @BDGetter
        private transient IPanel lftlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgtlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel cntbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel btmbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbefrr;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbilftlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbirgtlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbifrr;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbibtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel mdifrr;

        @JsonIgnore
        @BDGetter
        private transient IPanel lftgrdlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgtgrdlst;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Frrgrp> frrgrp;

	    @BDGetter
		private Htymod htymod;


		public Frrp()
        {
            super();
            setArgument();
        }

        public Frrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:frrp.@0005.script
        */
        @Rule(target="htymod.hty",order=100)
        public boolean ruleHtymodHtyN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getHtymod().getLst());
			String objinr="未获取原记录INR";
			ctx.getDaoSession().dbConnect();
			if(!MdaUtils.isEmpty(this.getFrrgrp().getRolnam()))
			{
			  objinr = this.getFrrgrp().getRolnam();
			}
			String sql="";
			Argument<Date> dattim =new Argument<Date>("dattim");
			Argument<String> usr =new Argument<String>("usr");
			Argument<String> txt =new Argument<String>("txt");
			sql="select dattim,usr,dbms_lob.substr(txt) txt from sme where frmnam='dbefrr' and objinr=? order by dattim ";
			log.debug("{}","[objinr] "+objinr);
			ctx.getDaoSession().dbExecuteSQL(sql,objinr);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(dattim,usr,txt);
			  int error =ctx.getErrorCode();
			  if(error==NO_ERROR)
			  {
			    this.getHtymod().getLst().add(dattim,usr,txt);
			  }

			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			ctx.getDaoSession().dbDisconnect();
			
			

			return true;
        }



        /**
        *   source:frrp.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getFrrgrp(),"rolnam",getRolnamList());

			return true;
        }


        /**
        *   source:frrp.@0000.script
        */
        public List<CodetableItem> getRolnamList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> rollst = new ArrayList<CodetableItem>();
			String sql = "SELECT inr,nam FROM rol WHERE FLG = '0' and inr <> ? ";

			//增加实体查询条件
			sql = sql+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtySql();

			Platform.mdbExecuteSQL(sql,Platform.getDefaultRoleInr());
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  Platform.mdbFetchFields(inr,nam);
			  int errorcode = ctx.getErrorCode();
			  if(errorcode == NO_ERROR)
			  {
			    if(inr.value !=null && nam.value != null)
			    {
			      CodetableItem rolnam = new CodetableItem(nam.value,inr.value);
			      rollst.add(rolnam);
			    }
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return rollst;
		}
        /**
        *   source:frrp.@0001.script
        */
        public void addVisibleFrm()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<this.getFrrgrp().getFrrlst2().fullSize();i++)
			{
			  if(!"0".equals(this.getFrrgrp().getFrrlst2().getElement(i).getTyp()))
			  {
			    this.getFrrgrp().getFrrlst2().getElement(i).setTyp( "0");
			    Platform.sdbInsert(this.getFrrgrp().getFrrlst2().getElement(i));
			  }
			}
		}


        public void setFrrgrpHolder(ModuleHolder<Frrgrp> frrgrp)
        {
            this.frrgrp = frrgrp;
        }

        public Frrgrp getFrrgrp()
        {
           return this.frrgrp.get();
        }
























}