package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Frm;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Frs;
import com.ceb.gjjs.mda.bo.Bch;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Frsgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Frsgrp.class);



	    @BDGetter
		private Frs rec;

	    @BDGetter
		private Frm frm;

	    @BDGetter
		private Bch bch;

		@BDGetter
		private ModuleList<Frs> frslst;


		public Frsgrp()
        {
            super();
            setArgument();
        }

        public Frsgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:frsgrp.@0000.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","frs update...");
			ctx.getErrorCode();
			int errorcode = ctx.getErrorCode();
			for(int i = 0 ;i < this.getFrslst().fullSize(); i++)
			{
			  if(!MdaUtils.isEmpty(this.getFrslst().getElement(i).getInr()))
			  {
			    Platform.mdbUpdate(this.getFrslst().getElement(i));
			    //log.debug("inr:"+$$frs\\inr.getValue());
			    log.debug("{}","SIGREQ:"+this.getFrslst().getElement(i).getSigreq());
			    errorcode = ctx.getErrorCode();
			    log.debug("{}","update frs:" + errorcode);
			    if(errorcode != NO_ERROR)
			      return false;
			  }
			  else
			  {
			    Platform.sdbInsert(this.getFrslst().getElement(i));
			    log.debug("{}","insert frs:" + errorcode);
			    errorcode = ctx.getErrorCode();
			    if(errorcode != NO_ERROR)
			      return false;
			  }
			}
			return true;
		}





}