package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Grdmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Grdmod.class);




		public Grdmod()
        {
            super();
            setArgument();
        }

        public Grdmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:grdmod.@0000.script
        */
        public void addAllChildrenNodesFromMap(LinkedHashMap<String,IValue[]> extendMap,StreamGrid sourceGrid,String newNodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}",extendMap);
			if(extendMap.size() > 0)
			{
			  Object [] keyset = extendMap.keySet().toArray();
			  int index = this.getNodeIndex(sourceGrid,newNodePath);
			  for(int i = keyset.length - 1 ; i >= 0 ;i--)
			  {
			    String nodePath = keyset[i].toString();
			    IValue [] nodeValues = extendMap.get(nodePath);
			    sourceGrid.add(index+1,nodeValues);
			  }
			}
		}
        /**
        *   source:grdmod.@0001.script
        */
        public void addAllChildrenNodesIntoMap(LinkedHashMap<String,IValue[]> extendMap,StreamGrid sourceGrid,String newNodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,IValue[]> childrenNodes = this.getNodeChildrenNodes(sourceGrid,newNodePath);
			log.debug("{}",childrenNodes);
			if(childrenNodes.size() > 0)
			{
			  Object [] keyset = childrenNodes.keySet().toArray();
			  for(int i = 0 ; i < keyset.length;i++)
			  {
			    String nodePath = keyset[i].toString();
			    //addAllChildrenNodesIntoMap(extendMap,sourceGrid,nodePath);
			    IValue [] nodeValues = childrenNodes.get(nodePath);
			    extendMap.put(nodePath,nodeValues);
			    int index = this.getNodeIndex(sourceGrid,nodePath);
			    sourceGrid.remove(index);
			  }
			}
		}
        /**
        *   source:grdmod.@0002.script
        */
        public String getLastKeyString(String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String [] nodes = getPathNodes(nodePath);
			if(MdaUtils.isEmpty(nodes))
			  return null;
			else
			  return nodes[nodes.length - 1];
		}
        /**
        *   source:grdmod.@0003.script
        */
        public String getLastLevelNodePath(StreamGrid targetGrid,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,IValue[]> childrenNodeMap = getNodeChildrenNodes(targetGrid,nodePath);
			if(childrenNodeMap.size() == 0)
			  return nodePath;
			else
			{
			  Object [] keyset = childrenNodeMap.keySet().toArray();
			  String lastKey = keyset[keyset.length - 1].toString();
			  return getLastLevelNodePath(targetGrid,lastKey);
			}
		}
        /**
        *   source:grdmod.@0004.script
        */
        public LinkedHashMap<String,IValue[]> getNodeChildrenNodes(StreamGrid targetGrid,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,IValue[]> valueMap = new LinkedHashMap<String,IValue[]>();
			//log.debug("targetGrid size:" + targetGrid.size());
			//log.debug(targetGrid);
			for(int i=0;i<targetGrid.size();i++)
			{
			  AttributeValue val = (AttributeValue)targetGrid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if( !key.equals(nodePath) && key.startsWith(nodePath))
			    valueMap.put(key,targetGrid.get(i));
			}
			return valueMap;
		}
        /**
        *   source:grdmod.@0005.script
        */
        public int getNodeIndex(StreamGrid grid,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<grid.size();i++)
			{
			  AttributeValue val = (AttributeValue)grid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if(key.equals(nodePath))
			    return i;
			}
			return -1;
		}
        /**
        *   source:grdmod.@0006.script
        */
        public String getParentNodePath(String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!nodePath.contains("/"))
			  return null;

			String [] nodes = getPathNodes(nodePath);
			String parentNodePath = "";
			if(nodes == null)
			  return null;
			else
			{
			  for(int i = 0;i < nodes.length - 1; i++)
			  {
			    if(i != nodes.length - 2)
			      parentNodePath += nodes[i] + "/";
			    else
			      parentNodePath += nodes[i];
			  }
			}
			return parentNodePath;
		}
        /**
        *   source:grdmod.@0007.script
        */
        public int getPathNodeLevel(String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String [] nodes = getPathNodes(nodePath);
			if(nodes == null)
			  return -1;
			else
			  return nodes.length - 1;
		}
        /**
        *   source:grdmod.@0008.script
        */
        public LinkedHashMap<String,IValue[]> getRootNodes(StreamGrid targetGrid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,IValue[]> valueMap = new LinkedHashMap<String,IValue[]>();
			for(int i=0;i<targetGrid.size();i++)
			{
			  AttributeValue val = (AttributeValue)targetGrid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if( !key.contains("/") )
			    valueMap.put(key,targetGrid.get(i));
			}
			return valueMap;
		}
        /**
        *   source:grdmod.@0009.script
        */
        public String [] getPathNodes(String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(nodePath))
			  return null;
			else
			  return nodePath.split("/");
		}
        /**
        *   source:grdmod.@0010.script
        */
        public IValue[] getSourceNodeValue(StreamGrid srcGrid,String nodePath,String oprType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<srcGrid.size();i++)
			{
			  AttributeValue val = (AttributeValue)srcGrid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if(key.equals(nodePath))
			  {
			    String frminr = (String)val.getAttribute("frminr");
			    String frm = (String)val.getAttribute("frm");
			    AttributeValue newchk = new AttributeValue("");
			    if(MdaUtils.isEmpty(frm))
			    {
			      newchk.setValue("-");
			      
			      
			    }
			    else
			    {
			      
			      
			      val.setAttribute("flg",oprType);
			      if("A".equals(oprType))
			        val.setAttribute("typ","0");
			      else if("D".equals(oprType))
			        val.setAttribute("typ","1");
			    }
			    IValue[] nodeValue = new IValue[]{newchk,val};
			    return nodeValue;
			  }
			}
			return null;
		}
        /**
        *   source:grdmod.@0011.script
        */
        public void gridInsertNode(StreamGrid srcGrid,StreamGrid targetGrid,String nodePath,IValue[] nodeValue,String oprType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  - nodePath 交易菜单路径
			  - grd 已分配菜单
			  - srcgrd 未分配菜单
			  @ 无返回值 在已分配菜单中生成要分配的交易的父菜单
			  */
			//先获取父节点的层级路径
			String parentNodePath = this.getParentNodePath(nodePath);

			//如果当前菜单没有父级，否则就是0级根菜单，0级根菜单不需要做父级处理
			if(parentNodePath != null)
			{
			  //判断父级菜单是否存在
			  if( !this.isNodePathExist(targetGrid,parentNodePath) )
			  {
			    //如果父级菜单不存在，则递归操作父级菜单
			    IValue[] parentNodeValue = getSourceNodeValue(srcGrid,parentNodePath,oprType);
			    //log.debug("parentNodeValue:");
			    //log.debug(parentNodeValue);
			    this.gridInsertNode(srcGrid,targetGrid,parentNodePath,parentNodeValue,oprType);
			  }
			}

			LinkedHashMap<String,IValue[]> parentChildrenNodeMap = null;
			if(parentNodePath != null)
			{
			  parentChildrenNodeMap = this.getNodeChildrenNodes(targetGrid,parentNodePath);
			  if(parentChildrenNodeMap.size() == 0)
			  {
			    //如果父菜单没有子节点，则直接插入
			    int nodeIndex = this.getNodeIndex(targetGrid,parentNodePath);
			    targetGrid.add(nodeIndex+1,nodeValue);
			  }
			  else
			  {
			    //如果父菜单有子节点，则需要排序
			    String preKey = this.sortNodes(parentChildrenNodeMap,nodePath);
			    //如果节点是排序第一个,则加在父菜单下面的第一个菜单位
			    if(preKey.equals(nodePath))
			      targetGrid.add(this.getNodeIndex(targetGrid,parentNodePath) + 1,nodeValue);
			    else
			    {
			      //否则获取要跟在后面的根节点的最后一个子节点位置
			      String lastKey = getLastLevelNodePath(targetGrid,preKey);
			      if(lastKey != null)
			        targetGrid.add(this.getNodeIndex(targetGrid,lastKey) + 1,nodeValue);
			    }
			  }
			}
			else
			{
			  log.debug("{}","gridInsert nodePath:"+nodePath);
			  LinkedHashMap<String,IValue[]> rootNodeMap = this.getRootNodes(targetGrid);
			  //如果没有根菜单，随便加
			  if(rootNodeMap.size() == 0)
			    targetGrid.add(targetGrid.size(),nodeValue);
			  else
			  {
			    //排序
			    String preKey = this.sortNodes(rootNodeMap,nodePath);
			    //如果节点是排序第一个,则加在第一个菜单位
			    if(preKey.equals(nodePath))
			      targetGrid.add(0,nodeValue);
			    else
			    {
			      //否则获取要跟在后面的根节点的最后一个子节点位置
			      String lastKey = getLastLevelNodePath(targetGrid,preKey);
			      if(lastKey != null)
			        targetGrid.add(this.getNodeIndex(targetGrid,lastKey) + 1,nodeValue);
			    }
			  }
			}
		}
        /**
        *   source:grdmod.@0012.script
        */
        public boolean isNodePathExist(StreamGrid grid,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<grid.size();i++)
			{
			  AttributeValue val = (AttributeValue)grid.get(i)[1];
			  String key = (String)val.getAttribute("path");
			  if(key.equals(nodePath))
			    return true;
			}
			return false;
		}
        /**
        *   source:grdmod.@0013.script
        */
        public void addBeforeAddAndRemove(StreamGrid grd,Map<String,LinkedHashMap<String,IValue[]> > extendMap,int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","left grid selected index:" + index);
			if(index > -1)
			{
			  AttributeValue attr0 = (AttributeValue)grd.get(index)[0];
			  String str = attr0.getValue().toString().trim();
			  log.debug("{}","str:" + str);
			  if("-".equals(str) || "+".equals(str))
			  {
			    AttributeValue attr1 = (AttributeValue)grd.get(index)[1];
			    String nodePath = (String)attr1.getAttribute("path");
			    //Map<String,LinkedHashMap<String,IValue[]> > lftExtendMap = $lftmap.getValue();
			    //收缩菜单
			    if("-".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = new LinkedHashMap<String,IValue[]>();
			      addAllChildrenNodesIntoMap(addExtendMap,grd,nodePath);
			      extendMap.put(nodePath,addExtendMap);
			      attr0.setValue("+");
			    }
			    else if("+".equals(str))
			    {
			      LinkedHashMap<String,IValue[]> addExtendMap = extendMap.get(nodePath);
			      addAllChildrenNodesFromMap(addExtendMap,grd,nodePath);
			      extendMap.remove(nodePath);
			      attr0.setValue("-");
			    }
			  }
			  //Platform.setModified($frrp\\lftgrd);
			}
		}
        /**
        *   source:grdmod.@0014.script
        */
        public String sortNodes(LinkedHashMap<String,IValue[]> sameLevelNodesMap,String nodePath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object [] keyset = sameLevelNodesMap.keySet().toArray();
			List<String> keys = new ArrayList<String>();
			String key = this.getLastKeyString(nodePath);
			log.debug("{}","sortNodes key:"+key);
			keys.add(key);
			for(int i = 0 ; i < keyset.length;i++)
			  keys.add(this.getLastKeyString(keyset[i].toString()));

			log.debug("{}",keys);
			Collections.sort(keys);
			log.debug("{}",keys);

			String preKey = "";
			for(int i = 0; i < keys.size(); i++)
			{
			  if(keys.get(i).equals(key))
			  {
			    if(MdaUtils.isEmpty(preKey))
			      preKey = key;
			    break;
			  }
			  else
			    preKey = keys.get(i);
			}
			log.debug("{}","preKey:" + preKey);

			if(preKey.equals(key))
			  preKey = nodePath;
			else
			{
			  for(int i = 0 ; i < keyset.length;i++)
			  {
			    if(preKey.equals(this.getLastKeyString(keyset[i].toString())))
			    {
			      preKey = keyset[i].toString();
			      break;
			    }
			  }
			}
			log.debug("{}","preKey:" + preKey);
			return preKey;
		}
        /**
        *   source:grdmod.@0015.script
        */
        public void generGrid(LinkedHashMap<String,Map> map,StreamGrid grid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IAttributeValue h = new AttributeValue("菜单名称");
			
			grid.setHeaders(new IAttributeValue[]{h});
			LinkedHashMap<String,Map> rmvmap=new LinkedHashMap();
			for(String key : map.keySet())
			{
			  if(!key.contains("/"))
			  {
			    log.debug("{}","key0:"+map.get(key));
			    AttributeValue val1= new AttributeValue(map.get(key).get("2"));
			    val1.setAttribute("path",key);
			    val1.setAttribute("frminr",map.get(key).get("1"));
			    val1.setAttribute("frm",map.get(key).get("3"));
			    val1.setAttribute("pntinr",map.get(key).get("4"));
			    val1.setAttribute("flg",map.get(key).get("5"));
			    val1.setAttribute("typ",map.get(key).get("6"));
			    val1.setAttribute("inr",map.get(key).get("7"));
			    val1.setAttribute("objinr",map.get(key).get("8"));
			    val1.setAttribute("objtyp",map.get(key).get("9"));
			    
			    
			    grid.add(new IValue[]{val1});
			  }
			  else
			  {
			    String[] str = key.split("/");
			    if(str.length == 2)
			    {
			      AttributeValue val2 = new AttributeValue(map.get(key).get("2"));
			      val2.setAttribute("path",key);
			      val2.setAttribute("frminr",map.get(key).get("1"));
			      val2.setAttribute("frm",map.get(key).get("3"));
			      val2.setAttribute("pntinr",map.get(key).get("4"));
			      val2.setAttribute("flg",map.get(key).get("5"));
			      val2.setAttribute("typ",map.get(key).get("6"));
			      val2.setAttribute("inr",map.get(key).get("7"));
			      val2.setAttribute("objinr",map.get(key).get("8"));
			      val2.setAttribute("objtyp",map.get(key).get("9"));
			      
			      
			      grid.add(new IValue[]{val2});
			    }
			    if(str.length == 3)
			    {
			      log.debug("{}","key2:"+map.get(key));
			      AttributeValue val3 = new AttributeValue(map.get(key).get("2"));
			      val3.setAttribute("path",key);
			      val3.setAttribute("frminr",map.get(key).get("1"));
			      val3.setAttribute("frm",map.get(key).get("3"));
			      val3.setAttribute("pntinr",map.get(key).get("4"));
			      val3.setAttribute("flg",map.get(key).get("5"));
			      val3.setAttribute("typ",map.get(key).get("6"));
			      val3.setAttribute("inr",map.get(key).get("7"));
			      val3.setAttribute("objinr",map.get(key).get("8"));
			      val3.setAttribute("objtyp",map.get(key).get("9"));
			      
			      
			      grid.add(new IValue[]{val3});
			    }
			  }
			}
		}
        /**
        *   source:grdmod.@0016.script
        */
        public LinkedHashMap<String,Map> checkGridMenu(LinkedHashMap<String,Map> map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			LinkedHashMap<String,Map> rmvmap=new LinkedHashMap();
			for(String key : map.keySet())
			{
			  if(MdaUtils.isEmpty(map.get(key).get("3")))
			  {
			    int a=0;
			    for(String key0 : map.keySet())
			    {
			      if(!key0.equals(key))
			      {
			        if(key0.startsWith(key) && !MdaUtils.isEmpty(map.get(key0).get("3")))
			          a++;
			      }
			    }
			    if(a<=0)
			    {
			      Map<String,String> val = map.get(key);
			      rmvmap.put(key,val);
			    }
			  }
			}
			log.debug("{}","check menu rmvmap size:"+rmvmap.size());
			for(String key1 : rmvmap.keySet())
			{
			  map.remove(key1);
			}
			return rmvmap;
		}
        /**
        *   source:grdmod.@0017.script
        */
        public void initLeftRightGrid(StreamGrid grd,StreamGrid tmpgrd)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//StreamGrid lftgrd = $frrp\\lftgrd;
			//StreamGrid rgtgrd = $frrp\\rgtgrd;
			//StreamGrid lfttmpgrd = (StreamGrid)Platform.restoreData("lftgrd");
			//StreamGrid rgttmpgrd = (StreamGrid)Platform.restoreData("rgtgrd");
			AttributeValue h0 = new AttributeValue("");
			
			AttributeValue h1 = new AttributeValue("菜单名称");
			
			grd.setHeaders(new IAttributeValue[]{h0,h1});
			//rgtgrd.setHeaders(new IAttributeValue[]{h0,h1});
			for(int i=0;i<tmpgrd.size();i++)
			{
			  AttributeValue keyval = (AttributeValue)tmpgrd.get(i)[0];
			  String key0 = (String)keyval.getAttribute("path");
			  AttributeValue frmval = (AttributeValue)tmpgrd.get(i)[0];
			  String frm = (String)frmval.getAttribute("frm");
			  AttributeValue frminrval = (AttributeValue)tmpgrd.get(i)[0];
			  String frminr = (String)frminrval.getAttribute("frminr");
			  AttributeValue pntinrval = (AttributeValue)tmpgrd.get(i)[0];
			  String pntinr = (String)pntinrval.getAttribute("pntinr");
			  AttributeValue flgval = (AttributeValue)tmpgrd.get(i)[0];
			  String flg = (String)flgval.getAttribute("flg");
			  AttributeValue typval = (AttributeValue)tmpgrd.get(i)[0];
			  String typ = (String)typval.getAttribute("typ");
			  AttributeValue frrinrval = (AttributeValue)tmpgrd.get(i)[0];
			  String frrinr = (String)frrinrval.getAttribute("inr");
			  AttributeValue objinrval = (AttributeValue)tmpgrd.get(i)[0];
			  String objinr = (String)objinrval.getAttribute("objinr");
			  AttributeValue objtypval = (AttributeValue)tmpgrd.get(i)[0];
			  String objtyp = (String)objtypval.getAttribute("objtyp");
			  AttributeValue chk0 = new AttributeValue("");
			  
			  
			  AttributeValue chk1 = new AttributeValue("-");
			  
			  if(MdaUtils.isEmpty(frm))
			  {
			    if(!key0.contains("/"))
			    {
			      AttributeValue val0 = new AttributeValue(tmpgrd.get(i)[0].getValue());
			      val0.setAttribute("path",key0);
			      val0.setAttribute("frminr",frminr);
			      val0.setAttribute("frm",frm);
			      val0.setAttribute("pntinr",pntinr);
			      val0.setAttribute("flg",flg);
			      val0.setAttribute("typ",typ);
			      val0.setAttribute("frrinr",frrinr);
			      val0.setAttribute("objinr",objinr);
			      val0.setAttribute("objtyp",objtyp);
			      
			      
			      grd.add(new IValue[]{chk1,val0});
			    }
			    else
			    {
			      AttributeValue val1 = new AttributeValue(tmpgrd.get(i)[0].getValue());
			      val1.setAttribute("path",key0);
			      val1.setAttribute("frminr",frminr);
			      val1.setAttribute("frm",frm);
			      val1.setAttribute("pntinr",pntinr);
			      val1.setAttribute("flg",flg);
			      val1.setAttribute("typ",typ);
			      val1.setAttribute("frrinr",frrinr);
			      val1.setAttribute("objinr",objinr);
			      val1.setAttribute("objtyp",objtyp);
			      
			      
			      grd.add(new IValue[]{chk1,val1});
			    }
			  }
			  else
			  {
			    String[] str = key0.split("/");
			    if(java.lang.reflect.Array.getLength(str) == 2)
			    {
			      AttributeValue val2 = new AttributeValue(tmpgrd.get(i)[0].getValue());
			      val2.setAttribute("path",key0);
			      val2.setAttribute("frminr",frminr);
			      val2.setAttribute("frm",frm);
			      val2.setAttribute("pntinr",pntinr);
			      val2.setAttribute("flg",flg);
			      val2.setAttribute("typ",typ);
			      val2.setAttribute("frrinr",frrinr);
			      val2.setAttribute("objinr",objinr);
			      val2.setAttribute("objtyp",objtyp);
			      
			      
			      grd.add(new IValue[]{chk0,val2});
			    }
			    if(java.lang.reflect.Array.getLength(str) == 3)
			    {
			      AttributeValue val3 = new AttributeValue(tmpgrd.get(i)[0].getValue());
			      val3.setAttribute("path",key0);
			      val3.setAttribute("frminr",frminr);
			      val3.setAttribute("frm",frm);
			      val3.setAttribute("pntinr",pntinr);
			      val3.setAttribute("flg",flg);
			      val3.setAttribute("typ",typ);
			      val3.setAttribute("frrinr",frrinr);
			      val3.setAttribute("objinr",objinr);
			      val3.setAttribute("objtyp",objtyp);
			      
			      
			      grd.add(new IValue[]{chk0,val3});
			    }
			  }
			}
		}
        /**
        *   source:grdmod.@0018.script
        */
        public String caculatetransaction(StreamGrid grid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			int a=0;
			for(int i=0;i<grid.size();i++)
			{
			  AttributeValue val = (AttributeValue)grid.get(i)[1];
			  String frm = (String)val.getAttribute("frm");
			  if(!MdaUtils.isEmpty(frm))
			    a++;
			}
			return String.valueOf(a);
		}
        /**
        *   source:grdmod.@0019.script
        */
        public void checkGridMenu(StreamGrid grd)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i=0;i<grd.size();i++)
			{
			  AttributeValue val1 = (AttributeValue)grd.get(i)[1];
			  String frm1 = (String)val1.getAttribute("frm");
			  if(MdaUtils.isEmpty(frm1))
			  {
			    int a=0;
			    String pth1 = (String)val1.getAttribute("path");
			    for(int j=0;j<grd.size();j++)
			    {
			      AttributeValue val2 = (AttributeValue)grd.get(j)[1];
			      String pth2 = (String)val2.getAttribute("path");
			      String frm2 = (String)val2.getAttribute("frm");
			      if(!MdaUtils.isEmpty(frm2) && pth2.startsWith(pth1))
			        a++;
			    }
			    if(a<=0)
			    {
			      grd.remove(i);
			      i--;
			    }
			  }
			}
		}

}