package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Sme;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ety;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Htymod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Htymod.class);

        //历史记录查询
        private IControl hty;

        //返回
        private IControl rtn;

        //修改前原有记录
        private Map orgmapbef;

        //删除前原有记录
        private Map orgmapbefdel;

        //TmpMap
        private Map map1;

        //tmpmap
        private Map map2;

        //Tmpmap
        private Map map3;

        //临时变量
        private String tmppar;

        //etgmap
        private Map etgmap;


        @JsonIgnore
        @BDGetter
        private transient IPanel htylist;

        @JsonIgnore
        @BDGetter
        private transient IPanel htypnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel htybut;


	    @BDGetter
		private Sme sme;

		@BDGetter
		private ModuleList<Sme> lst;

	    @BDGetter
		private Ety lstety;


		public Htymod()
        {
            super();
            setArgument();
        }

        public Htymod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:htymod.@0004.script
        */
        public void insertHistory(String txt,String dbName,String tableName,String oprtyp,String objinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//相关内容插入数据库
			log.info("{}","***********************************************");
			log.info("{}","进入insertHistory");
			log.debug("{}","txt信息:"+txt);
			//插入历史记录
			Platform.mdbBegin();
			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getSme());

			this.getSme().setDattim(MdaUtils.today());
			this.getSme().setUsr(MdaEnv.getLoginUser());
			this.getSme().setFrmnam(ctx.getTransName());
			this.getSme().setDbnam(dbName);
			this.getSme().setTabnam(tableName);
			this.getSme().setOprtyp(oprtyp);
			this.getSme().setTxt(txt);
			this.getSme().setObjinr(objinr);
			log.debug("{}","insertHistory objinr value:"+objinr);
			Platform.sdbInsert(this.getSme());
			int err=ctx.getErrorCode();
			log.debug("{}","errorCode为:"+err);
			if(err == NO_ERROR)
			{
			  Platform.mdbCommit();
			  log.debug("{}","数据库插入成功");
			  //Platform.message(#CT000016,#CT000017);
			}
			else
			{
			  log.debug("{}","数据库插入失败");
			  Platform.mdbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("htymod","CT000018"),MdaUtils.getI18NString("htymod","CT000019"));
			}
			MdaUtils.clear(this.getSme());

		}
        /**
        *   source:htymod.@0007.script
        */
        public Map<String,Object> getOrgMapBefore(IModule m,String dbName,String tableName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 2019.08.02新增
			  * 用于添加数据库更新(前)操作历史记录
			  * @parameter m BD数据模组
			  * @parameter tableName 数据模组对应的数据表名
			  */
			//获取修改前或者删除前（即bdbegain前数据库中存储的内容），返回一个map
			log.debug("{}","***********************************************");
			log.debug("{}","进入getOrgMapBefore");

			Platform.mdbBegin();
			//具体新增数据内容,MAP格式
			Map<String,Object> historyMap=new HashMap<String,Object>();
			//Argument对象表
			List<Argument> argList=new ArrayList<Argument>();

			//获取列名list
			List<String> columnList=this.getColumnList(tableName);
			log.debug("{}","列名表ColumnList: "+columnList);
			log.debug("{}","列名表ColumnList大小: "+columnList.size());

			//构建SQL语句
			String sqlForValue="select * from ";
			sqlForValue+=tableName;
			sqlForValue+=" where inr=?";
			//获取INR
			IDatafield idfInr=(IDatafield)(m.get("inr"));
			String inr=(String)(idfInr.getValue());
			log.debug("{}","执行:"+sqlForValue+","+inr);
			//生成Argument列表
			for(String column:columnList)
			{
			  argList.add(new Argument<String>(column));
			}
			//执行SQL
			Platform.mdbExecuteSQL(sqlForValue,inr);
			//生成Argument数组
			Argument[] argArray=new Argument[argList.size()];
			Argument[] arguments=argList.toArray(argArray);
			log.debug("{}","参数数组长度:"+arguments.length);
			while(true)
			{
			  Platform.mdbFetchFields(arguments);
			  int aa=ctx.getErrorCode();
			  log.debug("{}","errorcode信息"+aa);
			  if(aa == NO_ERROR)
			  {
			    for(int i=0;i<argList.size();i++)
			    {
			      log.debug("{}","第"+i+"组数据");
			      String column=columnList.get(i);
			      log.debug("{}","Column列名:"+column);
			      Argument a=arguments[i];
			      Object value=a.value;
			      log.debug("{}","Value列值:"+value);
			      historyMap.put(column,value);
			    }
			  }
			  else
			  {
			    log.error("{}","执行失败/跳出循环");
			    break;
			  }
			}
			log.debug("{}","map为"+historyMap);
			Platform.mdbCloseCursor();
			Platform.mdbCommit();
			return historyMap;

			//调用JAVA程序,将MAP转化为JSON
			//historyJoson=(String)Platform.invoke("cn.com.brilliance.operation.History","createHistoryJson",historyMap);
			//log.debug("***********************************************");
			//log.info("json字符串信息:"+historyJoson);
			//Platform.clear($sme);
			//$sme\\txtupdatebefore=historyJoson;
					}
        /**
        *   source:htymod.@0014.script
        */
        public void loadSql(String[] args)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//拼接查询sql,用于历史记录表的初始化。args数组存储此表要展示历史记录相关的交易名
			log.info("{}","***********************************************");
			log.info("{}","进入loadSql");
			log.debug("{}","相关交易:"+args);
			//构建sql
			String sql="select inr,dattim,usr,txt,frmnam from sme where frmnam in ";
			sql+="(";
			for(int i=0;i<args.length;i++)
			{
			  if(i==(args.length)-1)
			  {
			    sql+="'"+args[i]+"'";
			  }
			  else
			  {
			    sql+="'"+args[i]+"'"+",";
			  }
			}
			sql+=")";
			log.debug("{}","sql语句"+sql);
			Argument<String> inr=new Argument<String>("inr");
			Argument<Date> dattim=new Argument<Date>("dattim");
			Argument<String> usr=new Argument<String>("usr");
			Argument<String> txt=new Argument<String>("txt");
			Argument<String> frmnam=new Argument<String>("frmnam");
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,dattim,usr,txt,frmnam);
			  if(ctx.getErrorCode()==NO_ERROR)
			    this.getLst().add(inr,dattim,usr,txt,frmnam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:htymod.@0015.script
        */
        public Map<String,Object> compareMapRtnBef(Map<String,Object> filtrateMapBef,Map<String,Object> filtrateMapLat,List<String> mapKeyList1)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//对比修改前后的map内容是否发生修改，找出修改过的字段，存入simpleMapBef
			log.debug("{}","***********************************************");
			log.debug("{}","进入compareMapRtnBef");
			log.debug("{}","列名表ColumnList: "+mapKeyList1);
			log.debug("{}","filtrateMapBef: "+filtrateMapBef);
			log.debug("{}","filtrateMapLat"+filtrateMapLat);

			Map<String,Object> simpleMapBef=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList1.size();i++)
			{
			  log.debug("{}","进入for循环");
			  log.debug("{}","i的值为:"+i);
			  String column_name=mapKeyList1.get(i);
			  log.debug("{}","column_name:"+column_name);

			  Object bef=filtrateMapBef.get(column_name);
			  Object lat=filtrateMapLat.get(column_name);
			  if(bef==null && lat==null)
			    continue;
			  if(bef==null && lat !=null)
			    bef="无数据";
			  if(bef!=null && lat ==null)
			    lat="无数据";

			  log.debug("{}","bef内容:"+bef.toString());
			  log.debug("{}","lat内容:"+lat.toString());

			  if(!(bef.equals(lat)))
			  {
			    log.debug("{}","进入if条件判断");
			    String key=mapKeyList1.get(i);
			    Object value=filtrateMapBef.get(key);
			    simpleMapBef.put(key,value);
			  }
			}
			log.debug("{}","simpleMapBef信息:"+simpleMapBef);
			return simpleMapBef;
		}
        /**
        *   source:htymod.@0016.script
        */
        public Map<String,Object> compareMapRtnLat(Map<String,Object> filtrateMapBef,Map<String,Object> filtrateMapLat,List<String> mapKeyList1)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//同compareMapRtnBef方法，仅返回值不同
			log.debug("{}","***********************************************");
			log.debug("{}","进入compareMapRtnLat");
			log.debug("{}","列名表ColumnList: "+mapKeyList1);
			log.debug("{}","filtrateMapBef: "+filtrateMapBef);
			log.debug("{}","filtrateMapLat"+filtrateMapLat);

			Map<String,Object> simpleMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList1.size();i++)
			{
			  log.debug("{}","进入for循环");
			  log.debug("{}","i的值为:"+i);
			  String column_name=mapKeyList1.get(i);

			  Object bef=filtrateMapBef.get(column_name);
			  Object lat=filtrateMapLat.get(column_name);
			  if(bef==null && lat==null)
			    continue;
			  if(bef==null && lat !=null)
			    bef="无数据";
			  if(bef!=null && lat ==null)
			    lat="无数据";

			  if(!(bef.equals(lat)))
			  {
			    log.debug("{}","进入if条件判断");
			    String key=mapKeyList1.get(i);
			    Object value=filtrateMapLat.get(key);
			    simpleMapLat.put(key,value);
			  }
			}
			log.debug("{}","simpleMapLat信息:"+simpleMapLat);
			return simpleMapLat;
		}
        /**
        *   source:htymod.@0017.script
        */
        public Map<String,Object> getOrgMapUpdateLater(IModule m,List<String> columnList)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 2019.08.02新增
			  * 用于添加数据库更新(后)操作历史记录
			  * @parameter m BD数据模组
			  * @parameter tableName 数据模组对应的数据表名
			  */
			//获取dbcommit之后表的内容
			log.debug("{}","***********************************************");
			log.debug("{}","进入getOrgMapUpdateLater");

			Map<String,Object> orgMapLat=new HashMap<String,Object>();//具体新增数据内容,MAP格式
			//从m模块中取出数据，组成map
			for(int i=0;i<columnList.size();i++)
			{
			  String column=columnList.get(i);
			  log.info("{}","Column列名:"+column);
			  IDatafield idf=(IDatafield)(m.get(column));
			  Object value=idf.getValue();
			  orgMapLat.put(column,value);
			  log.info("{}","Value列值:"+value);
			}
			log.debug("{}","map信息:"+orgMapLat);
			return orgMapLat;

			//调用JAVA程序,将MAP转化为JSON
			//注:这里java程序还未编写 2019.08.02 Jinzhao
			//historyJoson=(String)Platform.invoke("cn.com.brilliance.operation.History","createHistoryJson",historyMap);
			//log.debug("***********************************************");
			//log.debug("json字符串信息:"+historyJoson);
			//return historyJoson;
					}
        /**
        *   source:htymod.@0018.script
        */
        public String txtForUpdate(IModule m,Map orgMapBef,String dbName,String tableName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成修改操作的历史记录说明，在修改操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForUpdate");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//获取orgMapLat
			Map<String,Object> orgMapLat=this.getOrgMapUpdateLater(m,columnList);
			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			Map<String,Object> filtrateMapLat=this.filtrateMap(orgMapLat,args);
			//获取筛选后map的列名
			List<String> mapKeyList1 = new ArrayList<String>();
			Set<String> keys1 = filtrateMapBef.keySet();
			Iterator<String> iter1 = keys1.iterator();
			while (iter1.hasNext())
			{
			  String key1 = iter1.next();
			  mapKeyList1.add(key1);
			}

			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=this.compareMapRtnBef(filtrateMapBef,filtrateMapLat,mapKeyList1);
			Map<String,Object> simpleMapLat=this.compareMapRtnLat(filtrateMapBef,filtrateMapLat,mapKeyList1);
			log.info("{}","simpleMapBef"+simpleMapBef);
			log.info("{}","simpleMapLat"+simpleMapLat);
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			Map<String,Object> chineseMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  chineseMapBef.put(key1,value1);

			  String key2=chineseMap.get(column_name);
			  Object value2=simpleMapLat.get(column_name);
			  chineseMapLat.put(key2,value2);
			}

			//将汉化后的map拼接成字符串txt
			String txtbef=chineseMapBef.toString();
			String txtlat=chineseMapLat.toString();

			//判断是否为空
			int length=txtbef.length();
			log.debug("{}","length value:"+length);
			if(length<=2)
			{
			  log.debug("{}","txtbef is null,don't insert");
			  return "null";
			}

			//并插入数据库
			String txt="将  "+txtbef+"  修改为  "+txtlat;
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","修改操作txt内容:"+txt);
			String oprtyp="修改";
			String objinr=(String)orgMapBef.get("inr");
			this.insertHistory(txt,dbName,tableName,oprtyp,objinr);
			return txt;
		}
        /**
        *   source:htymod.@0019.script
        */
        public Map<String,Object> filtrateMap(Map orgMap,String[] args)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//args数组中存储的是需要统计的字段，该方法将原始map中的字段按照args中的字段进行筛选，返回筛选后的map
			log.debug("{}","***********************************************");
			log.debug("{}","进入filtrateMap");
			//筛选args数组中指定字段的值，并存入filtrateMap
			Map<String,Object> filtrateMap=new HashMap<String,Object>();
			for(int i=0;i<args.length;i++)
			{
			  String column_name=args[i];
			  filtrateMap.put(column_name,orgMap.get(column_name));
			}
			log.debug("{}","筛选后的字段:"+filtrateMap);
			return filtrateMap;
		}
        /**
        *   source:htymod.@0020.script
        */
        public List<String> getColumnList(String tableName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//获取表“tableName”中的所有列字段。返回存储了所有列名的list
			log.debug("{}","***********************************************");
			log.debug("{}","进入getColumnList");
			List<String> columnList=new ArrayList<String>();//列名列表
			
			//获取中英文map和列名list
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}
			log.debug("{}","列名表ColumnList: "+columnList);
			log.debug("{}","列名表ColumnList大小: "+columnList.size());
			return columnList;
		}
        /**
        *   source:htymod.@0021.script
        */
        public String txtForAdd(IModule m,String dbName,String tableName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成新增操作的历史记录说明，并插入数据库。在新增操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForAdd");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//获取orgMapLat
			Map<String,Object> orgMapLat=this.getOrgMapUpdateLater(m,columnList);
			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapLat=this.filtrateMap(orgMapLat,args);
			//对比筛选出的字段修改前后值是否有变化,增加操作不需要对比，直接赋值
			Map<String,Object> simpleMapLat=filtrateMapLat;

			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapLat.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}
			log.debug("{}","对比后的map:"+simpleMapLat);

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  //获取列名字段
			  String column_name=mapKeyList.get(i);

			  String key2=chineseMap.get(column_name);
			  Object value2=simpleMapLat.get(column_name);

			  if(value2==null||value2.equals(""))
			  {
			    continue;
			  }
			  chineseMapLat.put(key2,value2);
			}
			log.debug("{}","汉化后的map:"+chineseMapLat);
			//将汉化后的map拼接成字符串txt
			String txtlat=chineseMapLat.toString();

			//判断是否为空
			int length=txtlat.length();
			log.debug("{}","length value:"+length);
			if(length<=2)
			{
			  log.debug("{}","txtbef is null,don't insert");
			  return "null";
			}

			//并插入数据库
			String txt="新增参数: "+txtlat;
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","新增操作txt内容:"+txt);
			String oprtyp="新增";
			IDatafield idf=(IDatafield)(m.get("inr"));
			String objinr=(String)idf.getValue();
			this.insertHistory(txt,dbName,tableName,oprtyp,objinr);
			return txt;
		}
        /**
        *   source:htymod.@0022.script
        */
        public String txtForDelete(Map orgMapBef,String dbName,String tableName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成删除操作的历史记录说明，在删除操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForDelete");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=filtrateMapBef;
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  chineseMapBef.put(key1,value1);
			}

			//将汉化后的map拼接成字符串txt
			String txtbef=chineseMapBef.toString();
			//并插入数据库
			String txt="删除参数: "+txtbef;
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","删除操作txt内容:"+txt);
			String oprtyp="删除";
			this.insertHistory(txt,dbName,tableName,oprtyp);
			return txt;
		}
        /**
        *   source:htymod.@0023.script
        */
        public String txtForAdd(IModule m,String dbName,String tableName,Map<String,Object> valueName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成新增操作的历史记录说明，并插入数据库。在新增操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForAdd");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//获取orgMapLat
			Map<String,Object> orgMapLat=this.getOrgMapUpdateLater(m,columnList);
			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapLat=this.filtrateMap(orgMapLat,args);
			//对比筛选出的字段修改前后值是否有变化,增加操作不需要对比，直接赋值
			Map<String,Object> simpleMapLat=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",filtrateMapLat,valueName);
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapLat.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}
			log.debug("{}","对比后的map:"+simpleMapLat);

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  //获取列名字段
			  String column_name=mapKeyList.get(i);

			  String key2=chineseMap.get(column_name);
			  Object value2=simpleMapLat.get(column_name);
			  if(value2==null||value2.equals(""))
			  {
			    continue;
			  }
			  chineseMapLat.put(key2,value2);

			}
			log.debug("{}","汉化后的map:"+chineseMapLat);
			//将汉化后的map拼接成字符串txt
			String txtlat=chineseMapLat.toString();

			//判断是否为空
			int length=txtlat.length();
			log.debug("{}","length value:"+length);
			if(length<=2)
			{
			  log.debug("{}","txtbef is null,don't insert");
			  return "null";
			}

			//并插入数据库
			String txt="新增参数: "+txtlat;
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","新增操作txt内容:"+txt);
			String oprtyp="新增";
			IDatafield idf=(IDatafield)(m.get("inr"));
			String objinr=(String)idf.getValue();
			this.insertHistory(txt,dbName,tableName,oprtyp,objinr);
			return txt;
		}
        /**
        *   source:htymod.@0026.script
        */
        public String txtForDelete(Map orgMapBef,String dbName,String tableName,Map<String,Object> valueName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成删除操作的历史记录说明，在删除操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForDelete");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",filtrateMapBef,valueName);
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  chineseMapBef.put(key1,value1);
			}

			//将汉化后的map拼接成字符串txt
			String txtbef=chineseMapBef.toString();
			//并插入数据库
			String txt="删除参数: "+txtbef;
			//替换字符串中的} { =
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","删除操作txt内容:"+txt);
			String oprtyp="删除";
			this.insertHistory(txt,dbName,tableName,oprtyp);
			return txt;
		}
        /**
        *   source:htymod.@0027.script
        */
        public String txtForUpdate(IModule m,Map orgMapBef,String dbName,String tableName,Map<String,Object> valueName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成修改操作的历史记录说明，在修改操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForUpdate");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//获取orgMapLat
			Map<String,Object> orgMapLat=this.getOrgMapUpdateLater(m,columnList);
			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			Map<String,Object> filtrateMapLat=this.filtrateMap(orgMapLat,args);
			//获取筛选后map的列名
			List<String> mapKeyList1 = new ArrayList<String>();
			Set<String> keys1 = filtrateMapBef.keySet();
			Iterator<String> iter1 = keys1.iterator();
			while (iter1.hasNext())
			{
			  String key1 = iter1.next();
			  mapKeyList1.add(key1);
			}

			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=this.compareMapRtnBef(filtrateMapBef,filtrateMapLat,mapKeyList1);
			Map<String,Object> simpleMapLat=this.compareMapRtnLat(filtrateMapBef,filtrateMapLat,mapKeyList1);
			//将vaule的值转换为中文
			simpleMapBef=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapBef,valueName);
			simpleMapLat=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapLat,valueName);
			log.info("{}","simpleMapBef"+simpleMapBef.toString());
			log.info("{}","simpleMapLat"+simpleMapLat.toString());
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			Map<String,Object> chineseMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  chineseMapBef.put(key1,value1);

			  String key2=chineseMap.get(column_name);
			  Object value2=simpleMapLat.get(column_name);
			  chineseMapLat.put(key2,value2);
			}

			//将汉化后的map拼接成字符串txt
			String txtbef=chineseMapBef.toString();
			String txtlat=chineseMapLat.toString();

			//判断是否为空
			int length=txtbef.length();
			log.debug("{}","length value:"+length);
			if(length<=2)
			{
			  log.debug("{}","txtbef is null,don't insert");
			  return "null";
			}

			//并插入数据库
			String txt="将  "+txtbef+"  修改为  "+txtlat;
			//替换txt中的特殊字符}、{、：
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","修改操作txt内容:"+txt);
			String oprtyp="修改";
			String objinr=(String)orgMapBef.get("inr");
			this.insertHistory(txt,dbName,tableName,oprtyp,objinr);
			return txt;
		}
        /**
        *   source:htymod.@0028.script
        */
        public String txtForUpdate(IModule m,Map orgMapBef,String dbName,String tableName,Map<String,Object> valueName,String[] ownKey )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成修改操作的历史记录说明，在修改操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForUpdate");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//获取orgMapLat
			Map<String,Object> orgMapLat=this.getOrgMapUpdateLater(m,columnList);
			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			Map<String,Object> filtrateMapLat=this.filtrateMap(orgMapLat,args);
			//获取筛选后map的列名
			List<String> mapKeyList1 = new ArrayList<String>();
			Set<String> keys1 = filtrateMapBef.keySet();
			Iterator<String> iter1 = keys1.iterator();
			while (iter1.hasNext())
			{
			  String key1 = iter1.next();
			  mapKeyList1.add(key1);
			}

			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=this.compareMapRtnBef(filtrateMapBef,filtrateMapLat,mapKeyList1);
			Map<String,Object> simpleMapLat=this.compareMapRtnLat(filtrateMapBef,filtrateMapLat,mapKeyList1);
			//将vaule的值转换为中文
			simpleMapBef=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapBef,valueName);
			simpleMapLat=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapLat,valueName);
			log.info("{}","simpleMapBef"+simpleMapBef.toString());
			log.info("{}","simpleMapLat"+simpleMapLat.toString());
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			Map<String,Object> chineseMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  chineseMapBef.put(key1,value1);

			  String key2=chineseMap.get(column_name);
			  Object value2=simpleMapLat.get(column_name);
			  chineseMapLat.put(key2,value2);
			}

			//将汉化后的map拼接成字符串txt
			String txtbef=chineseMapBef.toString();
			String txtlat=chineseMapLat.toString();

			//判断是否为空
			int length=txtbef.length();
			log.debug("{}","length value:"+length);
			if(length<=2)
			{
			  log.debug("{}","txtbef is null,don't insert");
			  return "null";
			}

			//拼接主语
			String txt1=ownKey[0]+":"+ownKey[1];
			//并插入数据库
			String txt="将  "+txt1+" 的 "+txtbef+"  修改为  "+txtlat;
			//替换txt中的特殊字符}、{、：
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","修改操作txt内容:"+txt);
			String oprtyp="修改";
			String objinr=(String)orgMapBef.get("inr");
			this.insertHistory(txt,dbName,tableName,oprtyp,objinr);
			return txt;
		}
        /**
        *   source:htymod.@0029.script
        */
        public String txtForUpdate(IModule m,Map orgMapBef,String dbName,String tableName,String[] ownKey)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成修改操作的历史记录说明，在修改操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForUpdate");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//获取orgMapLat
			Map<String,Object> orgMapLat=this.getOrgMapUpdateLater(m,columnList);
			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			Map<String,Object> filtrateMapLat=this.filtrateMap(orgMapLat,args);
			//获取筛选后map的列名
			List<String> mapKeyList1 = new ArrayList<String>();
			Set<String> keys1 = filtrateMapBef.keySet();
			Iterator<String> iter1 = keys1.iterator();
			while (iter1.hasNext())
			{
			  String key1 = iter1.next();
			  mapKeyList1.add(key1);
			}

			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=this.compareMapRtnBef(filtrateMapBef,filtrateMapLat,mapKeyList1);
			Map<String,Object> simpleMapLat=this.compareMapRtnLat(filtrateMapBef,filtrateMapLat,mapKeyList1);
			log.info("{}","simpleMapBef"+simpleMapBef);
			log.info("{}","simpleMapLat"+simpleMapLat);
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			Map<String,Object> chineseMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  chineseMapBef.put(key1,value1);

			  String key2=chineseMap.get(column_name);
			  Object value2=simpleMapLat.get(column_name);
			  chineseMapLat.put(key2,value2);
			}

			//将汉化后的map拼接成字符串txt
			String txtbef=chineseMapBef.toString();
			String txtlat=chineseMapLat.toString();

			//判断是否为空
			int length=txtbef.length();
			log.debug("{}","length value:"+length);
			if(length<=2)
			{
			  log.debug("{}","txtbef is null,don't insert");
			  return "null";
			}

			//拼接主语
			String txt1=ownKey[0]+":"+ownKey[1];
			//并插入数据库
			String txt="将  "+txt1+" 的 "+txtbef+"  修改为  "+txtlat;
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","修改操作txt内容:"+txt);
			String oprtyp="修改";
			String objinr=(String)orgMapBef.get("inr");
			this.insertHistory(txt,dbName,tableName,oprtyp,objinr);
			return txt;
		}
        /**
        *   source:htymod.@0030.script
        */
        public String txtForAddWithoutInsert(IModule m,String dbName,String tableName,Map<String,Object> valueName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成新增操作的历史记录说明，并插入数据库。在新增操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForAdd");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//获取orgMapLat
			Map<String,Object> orgMapLat=this.getOrgMapUpdateLater(m,columnList);
			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapLat=this.filtrateMap(orgMapLat,args);
			//对比筛选出的字段修改前后值是否有变化,增加操作不需要对比，直接赋值
			Map<String,Object> simpleMapLat=filtrateMapLat;
			//将vaule的值转换为中文
			if(valueName!=null)
			{
			  simpleMapLat=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapLat,valueName);
			}
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapLat.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}
			log.debug("{}","对比后的map:"+simpleMapLat);
			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  //获取列名字段
			  String column_name=mapKeyList.get(i);
			  String key2=chineseMap.get(column_name);
			  Object value2=simpleMapLat.get(column_name);
			  if(value2==null||value2.equals(""))
			  {
			    continue;
			  }
			  chineseMapLat.put(key2,value2);
			}
			log.debug("{}","汉化后的map:"+chineseMapLat);
			//将汉化后的map拼接成字符串txt
			String txtlat=chineseMapLat.toString();
			//并插入数据库
			String txt=" 新增: "+txtlat;
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","新增操作txt内容:"+txt);
			String oprtyp="新增";
			return txt;
		}
        /**
        *   source:htymod.@0031.script
        */
        public String txtForUpdateWithoutInsert(IModule m,Map orgMapBef,String dbName,String tableName,Map<String,Object> valueName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成修改操作的历史记录说明，在修改操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForUpdate");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//获取orgMapLat
			Map<String,Object> orgMapLat=this.getOrgMapUpdateLater(m,columnList);
			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			Map<String,Object> filtrateMapLat=this.filtrateMap(orgMapLat,args);
			//获取筛选后map的列名
			List<String> mapKeyList1 = new ArrayList<String>();
			Set<String> keys1 = filtrateMapBef.keySet();
			Iterator<String> iter1 = keys1.iterator();
			while (iter1.hasNext())
			{
			  String key1 = iter1.next();
			  mapKeyList1.add(key1);
			}

			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=this.compareMapRtnBef(filtrateMapBef,filtrateMapLat,mapKeyList1);
			Map<String,Object> simpleMapLat=this.compareMapRtnLat(filtrateMapBef,filtrateMapLat,mapKeyList1);
			//将vaule的值转换为中文
			simpleMapBef=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapBef,valueName);
			simpleMapLat=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapLat,valueName);
			log.info("{}","simpleMapBef"+simpleMapBef.toString());
			log.info("{}","simpleMapLat"+simpleMapLat.toString());
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			Map<String,Object> chineseMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  chineseMapBef.put(key1,value1);
			  String key2=chineseMap.get(column_name);
			  Object value2=simpleMapLat.get(column_name);
			  chineseMapLat.put(key2,value2);
			}

			//将汉化后的map拼接成字符串txt
			String txtbef=chineseMapBef.toString();
			String txtlat=chineseMapLat.toString();

			//判断是否为空
			int length=txtbef.length();
			log.debug("{}","length value:"+length);
			if(length<=2)
			{
			  log.debug("{}","txtbef is null,don't insert");
			  return "null";
			}

			//并插入数据库
			String txt="将"+txtbef+" 修改为了  "+txtlat+";";
			//替换txt中的特殊字符}、{、：
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","修改操作txt内容:"+txt);
			String oprtyp="修改";
			return txt;
		}
        /**
        *   source:htymod.@0032.script
        */
        public String txtForDeleteWithoutInsert(Map orgMapBef,String dbName,String tableName,Map<String,Object> valueName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成删除操作的历史记录说明，在删除操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForDelete");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=filtrateMapBef;
			//将vaule的值转换为中文
			simpleMapBef=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapBef,valueName);
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  if(value1==null)
			  {
			    continue;
			  }
			  chineseMapBef.put(key1,value1);
			}

			//将汉化后的map拼接成字符串txt
			String txtbef=chineseMapBef.toString();
			//并插入数据库
			String txt="删除 : "+txtbef+";";
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","删除操作txt内容:"+txt);
			String oprtyp="删除";
			return txt;
		}
        /**
        *   source:htymod.@0033.script
        */
        public String txtForDeleteWithoutInsert(Map orgMapBef,String dbName,String tableName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成删除操作的历史记录说明，在删除操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForDelete");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=filtrateMapBef;
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  if(value1==null)
			  {
			    continue;
			  }
			  chineseMapBef.put(key1,value1);
			}

			//将汉化后的map拼接成字符串txt
			String txtbef=chineseMapBef.toString();
			//并插入数据库
			String txt="删除 : "+txtbef+";";
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","删除操作txt内容:"+txt);
			String oprtyp="删除";
			return txt;
		}
        /**
        *   source:htymod.@0034.script
        */
        public void insertHistoryWithoutDbOp(String txt,String dbName,String tableName,String oprtyp,String objinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//相关内容插入数据库
			log.info("{}","进入insertHistory");
			log.debug("{}","txt信息:"+txt);
			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getSme());
			this.getSme().setDattim(MdaUtils.today());
			this.getSme().setUsr(MdaEnv.getLoginUser());
			this.getSme().setFrmnam(ctx.getTransName());
			this.getSme().setDbnam(dbName);
			this.getSme().setTabnam(tableName);
			this.getSme().setOprtyp(oprtyp);
			this.getSme().setTxt(txt);
			this.getSme().setObjinr(objinr);
			Platform.sdbInsert(this.getSme());
			int err=ctx.getErrorCode();
			log.debug("{}","errorCode为:"+err);
			MdaUtils.clear(this.getSme());
		}
        /**
        *   source:htymod.@0035.script
        */
        public Map<String,Object> getOrgMapBeforeNoDbConnection(IModule m,String dbName,String tableName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 2019.08.02新增
			  * 用于添加数据库更新(前)操作历史记录
			  * @parameter m BD数据模组
			  * @parameter tableName 数据模组对应的数据表名
			  */
			//获取修改前或者删除前（即bdbegain前数据库中存储的内容），返回一个map
			log.debug("{}","进入getOrgMapBeforeNoDbConnection");
			//具体新增数据内容,MAP格式
			Map<String,Object> historyMap=new HashMap<String,Object>();
			//Argument对象表
			List<Argument> argList=new ArrayList<Argument>();
			//获取列名list
			List<String> columnList=this.getColumnList(tableName);
			log.debug("{}","列名表ColumnList: "+columnList);
			log.debug("{}","列名表ColumnList大小: "+columnList.size());
			//构建SQL语句
			String sqlForValue="select * from ";
			sqlForValue+=tableName;
			sqlForValue+=" where cod=?";
			//获取INR
			IDatafield idfInr=(IDatafield)(m.get("cod"));
			String inr=(String)(idfInr.getValue());
			log.debug("{}","执行:"+sqlForValue+","+inr);
			//生成Argument列表
			for(String column:columnList)
			{
			  argList.add(new Argument<String>(column));
			}
			//执行SQL
			Platform.mdbExecuteSQL(sqlForValue,inr);
			//生成Argument数组
			Argument[] argArray=new Argument[argList.size()];
			Argument[] arguments=argList.toArray(argArray);
			log.debug("{}","参数数组长度:"+arguments.length);
			while(true)
			{
			  Platform.mdbFetchFields(arguments);
			  int aa=ctx.getErrorCode();
			  log.debug("{}","errorcode信息"+aa);
			  if(aa == NO_ERROR)
			  {
			    for(int i=0;i<argList.size();i++)
			    {
			      log.debug("{}","第"+i+"组数据");
			      String column=columnList.get(i);
			      log.debug("{}","Column列名:"+column);
			      Argument a=arguments[i];
			      Object value=a.value;
			      log.debug("{}","Value列值:"+value);
			      historyMap.put(column,value);
			    }
			  }
			  else
			  {
			    log.error("{}","执行失败/跳出循环");
			    break;
			  }
			}
			log.debug("{}","map为"+historyMap);
			Platform.mdbCloseCursor();
			return historyMap;
		}
        /**
        *   source:htymod.@0036.script
        */
        public String smtadjtxtForUpdate(IModule m,Map orgMapBef,String dbName,String tableName,String[] ownKey )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//生成修改操作的历史记录说明，在修改操作的commit之后调用。
			log.debug("{}","***********************************************");
			log.debug("{}","进入txtForUpdate");

			String trans=ctx.getTransName();
			String trans_tableName=trans+"_"+tableName;

			//获取中英文map和列名list
			List<String> columnList=new ArrayList<String>();
			Map<String,String> chineseMap=new HashMap<String,String>();
			chineseMap=(Map<String,String>)MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","loadCfgProPerty",tableName);
			Set<String> column = chineseMap.keySet();
			Iterator<String> iter_column = column.iterator();
			while (iter_column.hasNext())
			{
			  String key = iter_column.next();
			  columnList.add(key);
			}

			//获取orgMapLat
			Map<String,Object> orgMapLat=this.getOrgMapUpdateLater(m,columnList);
			//筛选出有用的字段信息
			String[] args=(String[])MdaUtils.invoke("cn.com.brilliance.operation.ColNameConverter","getHistoryArguments",trans_tableName);
			Map<String,Object> filtrateMapBef=this.filtrateMap(orgMapBef,args);
			Map<String,Object> filtrateMapLat=this.filtrateMap(orgMapLat,args);
			//获取筛选后map的列名
			List<String> mapKeyList1 = new ArrayList<String>();
			Set<String> keys1 = filtrateMapBef.keySet();
			Iterator<String> iter1 = keys1.iterator();
			while (iter1.hasNext())
			{
			  String key1 = iter1.next();
			  mapKeyList1.add(key1);
			}

			//对比筛选出的字段修改前后值是否有变化
			Map<String,Object> simpleMapBef=this.compareMapRtnBef(filtrateMapBef,filtrateMapLat,mapKeyList1);
			Map<String,Object> simpleMapLat=this.compareMapRtnLat(filtrateMapBef,filtrateMapLat,mapKeyList1);

			//将errtype转换成errmsg
			String errtypeBef=(String)simpleMapBef.get("errtyp");
			String errtypeLat=(String)simpleMapLat.get("errtyp");
			String errmsgBef=this.smtadjGetErrorTypeMessage(errtypeBef,"\r");
			String errmsgLat=this.smtadjGetErrorTypeMessage(errtypeLat,"\r");
			simpleMapBef.replace("errtyp",errmsgBef);
			simpleMapLat.replace("errtyp",errmsgLat);
			log.debug("{}","simpleMapBef的errmsg为:"+simpleMapBef.toString());
			log.debug("{}","simpleMapLat的errmsg为:"+simpleMapLat.toString());

			//将vaule的值转换为中文
			//simpleMapBef=(Map<String,Object>)Platform.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapBef,valueName);
			//simpleMapLat=(Map<String,Object>)Platform.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceValue",simpleMapLat,valueName);
			log.info("{}","simpleMapBef"+simpleMapBef.toString());
			log.info("{}","simpleMapLat"+simpleMapLat.toString());
			//获取筛选后map的列名
			List<String> mapKeyList = new ArrayList<String>();
			Set<String> keys = simpleMapBef.keySet();
			Iterator<String> iter = keys.iterator();
			while (iter.hasNext())
			{
			  String key = iter.next();
			  mapKeyList.add(key);
			}

			//将对比完后的字段替换为中文
			Map<String,Object> chineseMapBef=new HashMap<String,Object>();
			Map<String,Object> chineseMapLat=new HashMap<String,Object>();
			for(int i=0;i<mapKeyList.size();i++)
			{
			  String column_name=mapKeyList.get(i);
			  String key1=chineseMap.get(column_name);
			  Object value1=simpleMapBef.get(column_name);
			  chineseMapBef.put(key1,value1);

			  String key2=chineseMap.get(column_name);
			  Object value2=simpleMapLat.get(column_name);
			  chineseMapLat.put(key2,value2);
			}

			//将汉化后的map拼接成字符串txt
			if(chineseMapBef.isEmpty() || chineseMapLat.isEmpty())
			{
			  String str="修改前后没有变化.";
			  return  str;
			}
			String txtbef=chineseMapBef.toString();
			String txtlat=chineseMapLat.toString();
			//拼接主语
			String txt1=ownKey[0]+":"+ownKey[1];
			//并插入数据库
			String txt="将  "+txt1+" 的 "+txtbef+"  修改为  "+txtlat;
			//替换txt中的特殊字符}、{、：
			Map<String,String> stringName=new HashMap<String, String>();
			stringName.put("{","");
			stringName.put("}","");
			stringName.put("=",":");
			txt=(String)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","replaceKeyString",txt,stringName);
			log.debug("{}","修改操作txt内容:"+txt);
			String oprtyp="修改";
			String objinr=(String)orgMapBef.get("inr");
			this.insertHistory(txt,dbName,tableName,oprtyp,objinr);
			return txt;
		}
        /**
        *   source:htymod.@0037.script
        */
        public String smtadjGetErrorTypeMessage(String errtyp,String token)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String errmsgStr = "";
			if(MdaUtils.isEmpty(errtyp))
			  return errmsgStr;
			if(MdaUtils.isEmpty(token))
			  token="/";
			int len = errtyp.length();
			for(int i=0;i<len;i++)
			{
			  String err = MdaUtils.getCodetableLabel("errtyp",String.valueOf(errtyp.charAt(i)));
			  if(err == null)
			  {
			    if(errtyp.contains("00"))
			    {
			      err = "强制正确";
			      i++;
			    }
			    else
			      err = "正常";
			  }
			  errmsgStr = errmsgStr+err + token;
			}
			errmsgStr = errmsgStr.substring(0,errmsgStr.length() - token.length());
			//log.debug("errmsgStr = "+errmsgStr);
			return errmsgStr;
		}
        /**
        *   source:htymod.@0038.script
        */
        public Map<String,Object> getChnOrgMapBefore(IModule m,String dbName,String tableName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 2019.08.02新增
			  * 用于添加数据库更新(前)操作历史记录
			  * @parameter m BD数据模组
			  * @parameter tableName 数据模组对应的数据表名
			  */
			//获取修改前或者删除前（即bdbegain前数据库中存储的内容），返回一个map
			log.debug("{}","***********************************************");
			log.debug("{}","进入getOrgMapBefore");

			Platform.mdbBegin();
			//具体新增数据内容,MAP格式
			Map<String,Object> historyMap=new HashMap<String,Object>();
			//Argument对象表
			List<Argument> argList=new ArrayList<Argument>();

			//获取列名list
			List<String> columnList=this.getColumnList(tableName);
			log.debug("{}","列名表ColumnList: "+columnList);
			log.debug("{}","列名表ColumnList大小: "+columnList.size());

			//构建SQL语句
			String sqlForValue="select * from ";
			sqlForValue+=tableName;
			sqlForValue+=" where cod=?";
			//获取INR
			IDatafield idfInr=(IDatafield)(m.get("cod"));
			String inr=(String)(idfInr.getValue());
			log.debug("{}","执行:"+sqlForValue+","+inr);
			//生成Argument列表
			for(String column:columnList)
			{
			  argList.add(new Argument<String>(column));
			}
			//执行SQL
			ctx.getDaoSession().dbExecuteSQL(sqlForValue,inr);
			//生成Argument数组
			Argument[] argArray=new Argument[argList.size()];
			Argument[] arguments=argList.toArray(argArray);
			log.debug("{}","参数数组长度:"+arguments.length);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(arguments);
			  int aa=ctx.getErrorCode();
			  log.debug("{}","errorcode信息"+aa);
			  if(aa == NO_ERROR)
			  {
			    for(int i=0;i<argList.size();i++)
			    {
			      log.debug("{}","第"+i+"组数据");
			      String column=columnList.get(i);
			      log.debug("{}","Column列名:"+column);
			      Argument a=arguments[i];
			      Object value=a.value;
			      log.debug("{}","Value列值:"+value);
			      historyMap.put(column,value);
			    }
			  }
			  else
			  {
			    log.error("{}","执行失败/跳出循环");
			    break;
			  }
			}
			historyMap.put("inr",inr);
			log.debug("{}","map为"+historyMap);
			ctx.getDaoSession().dbCloseCursor();
			Platform.mdbCommit();
			return historyMap;
		}
        /**
        *   source:htymod.@0039.script
        */
        public void insertHistory(String txt,String dbName,String tableName,String oprtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//相关内容插入数据库
			log.info("{}","***********************************************");
			log.info("{}","进入insertHistory");
			log.debug("{}","txt信息:"+txt);
			//插入历史记录
			Platform.mdbBegin();
			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getSme());

			this.getSme().setDattim(MdaUtils.today());
			this.getSme().setUsr(MdaEnv.getLoginUser());
			this.getSme().setFrmnam(ctx.getTransName());
			this.getSme().setDbnam(dbName);
			this.getSme().setTabnam(tableName);
			this.getSme().setOprtyp(oprtyp);
			this.getSme().setTxt(txt);
			Platform.sdbInsert(this.getSme());
			int err=ctx.getErrorCode();
			log.debug("{}","errorCode为:"+err);
			if(err == NO_ERROR)
			{
			  Platform.mdbCommit();
			  log.debug("{}","数据库插入成功");
			  //Platform.message(#CT000022,#CT000023);
			}
			else
			{
			  log.debug("{}","数据库插入失败");
			  Platform.mdbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("htymod","CT000024"),MdaUtils.getI18NString("htymod","CT000025"));
			}
			MdaUtils.clear(this.getSme());

		}






















}