package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Jgx;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jgxgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Jgxgrp.class);



	    @BDGetter
		private Jgx rec;

		@BDGetter
		private ModuleList<Jgx> jgxlst;


		public Jgxgrp()
        {
            super();
            setArgument();
        }

        public Jgxgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:jgxgrp.@0000.script
        */
        public boolean update(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tansaction update..");
			log.debug("{}","framname :"+framname);
			if ("dbejgx".equals(framname))
			{
			  log.debug("{}","dbejgx update...");
			  Platform.mdbUpdate(this.getRec());
			  int errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    log.debug("{}","update jgx with errorcode:" + errorcode);
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:jgxgrp.@0001.script
        */
        public boolean delete(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tansaction delete....");
			log.debug("{}","framname :"+framname);

			if ("dbdjgx".equals(framname))
			{
			  //$rec\\sta = "1";
			  //log.debug("sta="+$rec\\sta.getValue()+",dbdjgx update...");
			  Platform.mdbDelete(this.getRec());
			  int errorcode = ctx.getErrorCode();
			  if(errorcode == NO_ERROR)
			  {
			    return true;
			  }
			  else
			  {
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:jgxgrp.@0002.script
        */
        public boolean insert(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tansaction insert...");
			log.debug("{}","framname :"+framname);
			if("dbajgx".equals(framname))
			{
			  log.debug("{}","dbajgx begin....");
			  /*if(!dataChecked())
			    return false;*/
			  this.getRec().setInr( Platform.sdbCounter("jgx"));
			  //log.debug("@@@@ etg-inr:" + $rec\\inr.getValue() + " @@@@");
			  //$rec\\sta = "0";
			
			  log.debug("{}","jgx insert...");
			  Platform.mdbInsert(this.getRec());
			  int errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    return false;
			  }
			}
			return true;

		}



}