package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Jgx;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jgxp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Jgxp.class);

        //清除按钮
        private IControl clrbtn;

        //机构编号
        private String jgxxid;

        //机构名称
        private String jgxnam;

        //导出按钮
        private IControl exportbtn;

        //查询按钮
        private IControl selbtn;

        //机构层级
        private String brhlvl;

        //导出
        private IStream expexl = new StreamImpl();

        //注册
        private IControl add;

        //修改
        private IControl ame;

        //注销
        private IControl del;

        //返回
        private IControl cancel;

        //标题
        private String tit;


        @JsonIgnore
        @BDGetter
        private transient IPanel mainpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel leftpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel rightpanl;

        @JsonIgnore
        @BDGetter
        private transient IPanel butnpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel right;

        @JsonIgnore
        @BDGetter
        private transient IPanel jgxp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel jgxp;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel jgxp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel edip;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Jgxgrp> jgxgrp;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;

		@BDGetter
		private ModuleList<Jgx> jgxlst;

		@BDGetter
		private ModuleList<Jgx> jgxshwlst;


		public Jgxp()
        {
            super();
            setArgument();
        }

        public Jgxp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:jgxp.@0000.script
        */
        @Rule(target="selbtn",order=100)
        public boolean ruleSelbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getJgxgrp().getJgxlst());
			Argument args = new Argument();
			if(!MdaUtils.isEmpty(this.getJgxxid()))
			  args = args.and(new Argument<String>("brhcod",LIKE,"%"+this.getJgxxid()+"%"));

			if(!MdaUtils.isEmpty(this.getJgxnam()))
			  args = args.and(new Argument<String>("brhshtnam",LIKE,"%"+this.getJgxnam()+"%"));

			if(!MdaUtils.isEmpty(this.getBrhlvl()))
			  args = args.and(new Argument<String>("brhlvl",this.getBrhlvl()));
			Platform.mdbReadset(this.getJgxgrp().getJgxlst(),0,args);
			if(this.getJgxgrp().getJgxlst().size() == 0)
			  ctx.setMessage(MdaUtils.getI18NString("jgxp","CT000010"),MdaUtils.getI18NString("jgxp","CT000011"));
			

			return true;
        }

        /**
        *   source:jgxp.@0002.script
        */
        @Rule(target="clrbtn",order=100)
        public boolean ruleClrbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setJgxxid(NULLSTR);
			this.setJgxnam(NULLSTR);
			this.setBrhlvl(NULLSTR);
			
			
			

			return true;
        }

        /**
        *   source:jgxp.@0003.script
        */
        @Rule(target="exportbtn",order=100)
        public boolean ruleExportbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream is = this.getExpexl();
			is.setType("xls");
			is.setName("Org"+MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss")+".xls");
			List<Object[]> lst = new ArrayList<Object[]>();
			String [] title= new String[13];
			title[0]=MdaUtils.getI18NString("jgxp","CT000096");
			title[1]=MdaUtils.getI18NString("jgxp","CT000097");
			title[2]=MdaUtils.getI18NString("jgxp","CT000098");
			title[3]=MdaUtils.getI18NString("jgxp","CT000099");
			title[4]=MdaUtils.getI18NString("jgxp","CT000100");
			title[5]=MdaUtils.getI18NString("jgxp","CT000101");
			title[6]=MdaUtils.getI18NString("jgxp","CT000102");
			title[7]=MdaUtils.getI18NString("jgxp","CT000103");
			title[8]=MdaUtils.getI18NString("jgxp","CT000104");
			title[9]=MdaUtils.getI18NString("jgxp","CT000105");
			title[10]=MdaUtils.getI18NString("jgxp","CT000106");
			title[11]=MdaUtils.getI18NString("jgxp","CT000107");
			title[12]=MdaUtils.getI18NString("jgxp","CT000108");
			lst.add(title);
			for(int i=0;i<this.getJgxgrp().getJgxlst().fullSize();i++)
			{
			  Object [] line = new Object[13];

			  line[0]=this.getJgxgrp().getJgxlst().getElement(i).getBrhcod();
			  line[1]=this.getJgxgrp().getJgxlst().getElement(i).getBrhshtnam();
			  line[2]=this.getJgxgrp().getJgxlst().getElement(i).getBrhnam();
			  line[3]=this.getJgxgrp().getJgxlst().getElement(i).getBrhadr();

			  line[4]=MdaUtils.getCodetableLabel("jgxbrhabl",this.getJgxgrp().getJgxlst().getElement(i).getBrhlvl());
			  line[5]=MdaUtils.getCodetableLabel("jgxbrhabl",this.getJgxgrp().getJgxlst().getElement(i).getBrhabl());
			  line[6]=MdaUtils.getCodetableLabel("jgxbrhatr",this.getJgxgrp().getJgxlst().getElement(i).getBrhatr());
			  line[7]=MdaUtils.getCodetableLabel("jgxbrhsta",this.getJgxgrp().getJgxlst().getElement(i).getBrhsta());
			  line[8]=MdaUtils.getCodetableLabel("jgxblgflg",this.getJgxgrp().getJgxlst().getElement(i).getBlgflg());

			  line[9]=this.getJgxgrp().getJgxlst().getElement(i).getRglcod();

			  line[10]=MdaUtils.getCodetableLabel("jgxareaat",this.getJgxgrp().getJgxlst().getElement(i).getAreaat());
			  line[11]=this.getJgxgrp().getJgxlst().getElement(i).getDutnam();
			  log.debug("{}","负责人姓名"+this.getJgxgrp().getJgxlst().getElement(i).getDutnam());
			  line[12]=this.getJgxgrp().getJgxlst().getElement(i).getDuttel();

			  lst.add(line);
			}
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }

        /**
        *   source:jgxp.@0004.script
        */
        @Rule(target="expexl",order=100)
        public boolean ruleExpexlN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream is = this.getExpexl();
			is.setType("xls");
			is.setName("Org"+MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss")+".xls");
			List<Object[]> lst = new ArrayList<Object[]>();

			if(this.getJgxgrp().getJgxlst().fullSize() > 66534)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jgxp","CT000110"),MdaUtils.getI18NString("jgxp","CT000111"));
			  return true;
			}
			String [] title= new String[13];
			title[0]=MdaUtils.getI18NString("jgxp","CT000112");
			title[1]=MdaUtils.getI18NString("jgxp","CT000113");
			title[2]=MdaUtils.getI18NString("jgxp","CT000114");
			title[3]=MdaUtils.getI18NString("jgxp","CT000115");
			title[4]=MdaUtils.getI18NString("jgxp","CT000116");
			title[5]=MdaUtils.getI18NString("jgxp","CT000117");
			title[6]=MdaUtils.getI18NString("jgxp","CT000118");
			title[7]=MdaUtils.getI18NString("jgxp","CT000119");
			title[8]=MdaUtils.getI18NString("jgxp","CT000120");
			title[9]=MdaUtils.getI18NString("jgxp","CT000121");
			title[10]=MdaUtils.getI18NString("jgxp","CT000122");
			title[11]=MdaUtils.getI18NString("jgxp","CT000123");
			title[12]=MdaUtils.getI18NString("jgxp","CT000124");
			lst.add(title);
			for(int i=0;i<this.getJgxgrp().getJgxlst().fullSize();i++)
			{
			  Object [] line = new Object[13];

			  line[0]=this.getJgxgrp().getJgxlst().getElement(i).getBrhcod();
			  line[1]=this.getJgxgrp().getJgxlst().getElement(i).getBrhshtnam();
			  line[2]=this.getJgxgrp().getJgxlst().getElement(i).getBrhnam();
			  line[3]=this.getJgxgrp().getJgxlst().getElement(i).getBrhadr();

			  line[4]=MdaUtils.getCodetableLabel("jgxbrhabl",this.getJgxgrp().getJgxlst().getElement(i).getBrhlvl());
			  line[5]=MdaUtils.getCodetableLabel("jgxbrhabl",this.getJgxgrp().getJgxlst().getElement(i).getBrhabl());
			  line[6]=MdaUtils.getCodetableLabel("jgxbrhatr",this.getJgxgrp().getJgxlst().getElement(i).getBrhatr());
			  line[7]=MdaUtils.getCodetableLabel("jgxbrhsta",this.getJgxgrp().getJgxlst().getElement(i).getBrhsta());
			  line[8]=MdaUtils.getCodetableLabel("jgxblgflg",this.getJgxgrp().getJgxlst().getElement(i).getBlgflg());

			  line[9]=this.getJgxgrp().getJgxlst().getElement(i).getRglcod();

			  line[10]=MdaUtils.getCodetableLabel("jgxareaat",this.getJgxgrp().getJgxlst().getElement(i).getAreaat());
			  line[11]=this.getJgxgrp().getJgxlst().getElement(i).getDutnam();
			  line[12]=this.getJgxgrp().getJgxlst().getElement(i).getDuttel();

			  lst.add(line);
			}
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }

        /**
        *   source:jgxp.@0005.script
        */
        @Rule(target="cancel",order=100)
        public boolean ruleCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			//刷新查询界面并返回
			String key="handleTemp";
			ctx.storeData(key,key);
			MdaUtils.returnToFirst();

			return true;
        }


        /**
        *   source:jgxp.@0006.script
        */
        @Check(target="jgxgrp.rec.brhcod",order=100)
        public boolean checkJgxgrpRecBrhcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getBrhcod()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.brhcod",MdaUtils.getI18NString("jgxp","CT000176"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0007.script
        */
        @Check(target="jgxgrp.rec.brhshtnam",order=100)
        public boolean checkJgxgrpRecBrhshtnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getBrhshtnam()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.brhshtnam",MdaUtils.getI18NString("jgxp","CT000177"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0008.script
        */
        @Check(target="jgxgrp.rec.brhnam",order=100)
        public boolean checkJgxgrpRecBrhnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getBrhnam()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.brhnam",MdaUtils.getI18NString("jgxp","CT000178"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0009.script
        */
        @Check(target="jgxgrp.rec.brhadr",order=100)
        public boolean checkJgxgrpRecBrhadrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getBrhadr()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.brhadr",MdaUtils.getI18NString("jgxp","CT000179"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0010.script
        */
        @Check(target="jgxgrp.rec.brhlvl",order=100)
        public boolean checkJgxgrpRecBrhlvlN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getBrhlvl()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.brhlvl",MdaUtils.getI18NString("jgxp","CT000180"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0011.script
        */
        @Check(target="jgxgrp.rec.brhabl",order=100)
        public boolean checkJgxgrpRecBrhablN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getBrhabl()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.brhabl",MdaUtils.getI18NString("jgxp","CT000181"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0012.script
        */
        @Check(target="jgxgrp.rec.brhatr",order=100)
        public boolean checkJgxgrpRecBrhatrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getBrhatr()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.brhatr",MdaUtils.getI18NString("jgxp","CT000182"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0013.script
        */
        @Check(target="jgxgrp.rec.brhsta",order=100)
        public boolean checkJgxgrpRecBrhstaN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getBrhsta()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.brhsta",MdaUtils.getI18NString("jgxp","CT000183"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0014.script
        */
        @Check(target="jgxgrp.rec.blgflg",order=100)
        public boolean checkJgxgrpRecBlgflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getBlgflg()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.blgflg",MdaUtils.getI18NString("jgxp","CT000185"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0015.script
        */
        @Check(target="jgxgrp.rec.areaat",order=100)
        public boolean checkJgxgrpRecAreaatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getAreaat()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.areaat",MdaUtils.getI18NString("jgxp","CT000186"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0016.script
        */
        @Check(target="jgxgrp.rec.rglcod",order=100)
        public boolean checkJgxgrpRecRglcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getRglcod()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.rglcod",MdaUtils.getI18NString("jgxp","CT000187"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0017.script
        */
        @Check(target="jgxgrp.rec.dutnam",order=100)
        public boolean checkJgxgrpRecDutnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getDutnam()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.dutnam",MdaUtils.getI18NString("jgxp","CT000188"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jgxp.@0018.script
        */
        @Check(target="jgxgrp.rec.duttel",order=100)
        public boolean checkJgxgrpRecDuttelN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJgxgrp().getRec().getDuttel()))
			{
			  ctx.setFieldError(this,"jgxgrp.rec.duttel",MdaUtils.getI18NString("jgxp","CT000189"));
			  return false;
			}
			else
			{
			  String duttel = this.getJgxgrp().getRec().getDuttel();
			  if(!(duttel.matches("^1(3\\d|4[5-9]|5[0-35-9]|6[567]|7[0-8]|8\\d|9[0-35-9])\\d{8}")) && !(duttel.matches("0\\d{2,3}[-]?\\d{7,8}|0\\d{2,3}\\s?\\d{7,8}")))
			  {
			    ctx.setFieldError(this,"jgxgrp.rec.duttel",MdaUtils.getI18NString("jgxp","CT000190"));
			    return false;
			  }

			}

			return true;
        }


        /**
        *   source:jgxp.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> lst = new ArrayList<CodetableItem>();
			lst.add(new CodetableItem("",""));
			lst.add(new CodetableItem("总行","01"));
			lst.add(new CodetableItem("一级分行","02"));
			lst.add(new CodetableItem("二级分行","03"));
			lst.add(new CodetableItem("一级支行","04"));
			lst.add(new CodetableItem("网点","05"));
			MdaUtils.setValues(this,"brhlvl",lst);
			//设置初始值
			this.setBrhlvl( "");

			if("dbdjgx".equals(Platform.sgetTransName()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			Object obj=ctx.restoreData("handleTemp");
			if(obj!=null)
			{
			  ctx.postRule(this,"selbtn");
			}

			return true;
        }




        public void setJgxgrpHolder(ModuleHolder<Jgxgrp> jgxgrp)
        {
            this.jgxgrp = jgxgrp;
        }

        public Jgxgrp getJgxgrp()
        {
           return this.jgxgrp.get();
        }


        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }



























}