package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Krf;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Krfgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Krfgrp.class);



	    @BDGetter
		private Krf rec;


		public Krfgrp()
        {
            super();
            setArgument();
        }

        public Krfgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:krfgrp.@0000.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getErrorCode();
			String inr = Platform.sdbCounter("krf");
			this.getRec().setInr( inr);
			Platform.mdbInsert(this.getRec());
			if(ctx.getErrorCode()==NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:krfgrp.@0001.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getErrorCode();
			Platform.mdbUpdate(this.getRec());
			if(ctx.getErrorCode()==NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:krfgrp.@0002.script
        */
        public boolean delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","delete krf");
			log.debug("{}","krf inr:"+this.getRec().getInr());
			ctx.getErrorCode();
			Platform.mdbDelete(this.getRec(),new Argument("inr",this.getRec().getInr()));
			if(ctx.getErrorCode()==NO_ERROR)
			  return true;
			else
			  return false;
		}


}