package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Ktl;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ktlgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ktlgrp.class);

        //对应记账类型
        private String iskpa;

        //记账状态
        private String sta;

        //无需记账类型
        private String autocredit;

        //记账附言
        private String infs;

        //记账类型
        private String kpas;

        //记账类型
        private String kpas2;

        //记账机构
        private String suborg2;

        //记账机构
        private String suborg;



	    @BDGetter
		private Ktl rec;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Ptpmod> ptpmod;


		public Ktlgrp()
        {
            super();
            setArgument();
        }

        public Ktlgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:ktlgrp.@0003.script
        */
        public boolean delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			ctx.getErrorCode();
			//<--LF注释   上为源代码
			
			//$rec\\optdat=Platform.today();
			//$rec\\nam=Platform.getLoginUser();
			//$rec\\delsta="失效";
			//log.info("------------------rec--------------");
			
			//-->下为原代码
			Platform.mdbUpdate(this.getRec());
			if(ctx.getErrorCode()==NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:ktlgrp.@0004.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getErrorCode();
			String inr = Platform.sdbCounter("ktl");
			this.getRec().setInr( inr);
			//log.debug("crd inr:"+$rec\\inr.getValue());
			//Platform.setValues($rec\\ktpno,$\\ktlp.getKtpLst());
			//Platform.mdbRead($\\ktlp\\ktp,new Argument("ktpnam",$rec\\ktpno));
			//$rec\\ktpno = $\\ktlp\\ktp\\ktpno.getValue();
			if("X".equals(this.getIskpa()))
			{
			  this.getRec().setSta("自动记账");
			  //Platform.mdbRead($ktlp\\ktp,new Argument("ktpnam",$ktlgrp\\kpas));
			  
			  this.getRec().setKtpno(this.getKpas());
			  
			  this.getRec().setPtycod(this.getSuborg());
			  
			}
			else
			{
			  this.getRec().setSta("无需记账");
			  //Platform.mdbRead($ktlp\\ktp,new Argument("ktpnam",$ktlgrp\\kpas));
			  

			  this.getRec().setKtpno(this.getKpas2());
			  

			  //Platform.mdbRead($sysmod\\pty,new Argument("nam",$ktlgrp\\suborg));
			  this.getRec().setPtycod(this.getSuborg2());
			  
			}
			this.getRec().setNam( MdaEnv.getLoginUser());
			this.getRec().setOptdat( MdaUtils.today());
			this.getRec().setDelsta( "正常");

			this.getRec().setBic( this.getPtpmod().getPty().getExtkey());
			log.info("{}","actbic "+this.getPtpmod().getPty().getExtkey());

			//20190117添加
			
			/*
			  if("X".equals($dbappp\\autocredit))//$\\ktlgrp\\autocredit.getValue()
			  {
			  $rec\\sta = "自动记账";//对应记账类型
			  $rec\\ktpno =$dbappp\\kpas.getValue();// $\\ktlgrp\\kpas.getValue()
			  $rec\\ktpnam =$dbappp\\subrog.getValue();//$\\ktlgrp\\subrog.getValue();
			  }
			  else
			  {
			  $rec\\sta = "无需记账";//无需记账类型
			  $rec\\ktpno = $dbappp\\kpas2.getValue();
			  $rec\\ktpnam =$dbappp\\subrog2.getValue();
			  }
			  */

			//关联所属实体
			ctx.absGet(Sysmod.class).setEtyAndPty(this.getRec());
			Platform.mdbInsert(this.getRec());
			if(ctx.getErrorCode()==NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:ktlgrp.@0005.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getErrorCode();
			this.getRec().setBic( this.getPtpmod().getPty().getExtkey());
			log.info("{}","actbic "+this.getPtpmod().getPty().getExtkey());
			//20190117新增代码-->
			if("X".equals(this.getIskpa()))
			{
			  this.getRec().setSta("自动记账");
			  
			  this.getRec().setKtpno(this.getKpas());
			  
			  this.getRec().setPtycod(this.getSuborg());
			  
			}
			else
			{
			  this.getRec().setSta("无需记账");
			  
			  this.getRec().setKtpno(this.getKpas2());
			  
			  this.getRec().setPtycod(this.getSuborg2());
			  
			}

			this.getRec().setNam( MdaEnv.getLoginUser());
			this.getRec().setOptdat( MdaUtils.today());
			
			Platform.mdbUpdate(this.getRec());

			if(ctx.getErrorCode()==NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:ktlgrp.@0006.script
        */
        public Map<String,Object> getMapKtpno()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","进入getMapKtpno");
			//获取记账类型下拉框
			Map<String,Object> map_ktpno=new HashMap<String, Object>();
			String sql = "SELECT ktpno,ktpnam FROM ktp WHERE 1=1 ";
			Argument<String> ktpno = new Argument<String>("ktpno");
			Argument<String> ktpnam = new Argument<String>("ktpnam");

			sql = sql + ctx.absGet(Sysmod.class).getEtySql();

			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(ktpno,ktpnam);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    map_ktpno.put(ktpno.value,ktpnam.value);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			log.debug("{}","getMapKtpno的值为:"+map_ktpno.toString());
			return map_ktpno;
		}



        public void setPtpmodHolder(ModuleHolder<Ptpmod> ptpmod)
        {
            this.ptpmod = ptpmod;
        }

        public Ptpmod getPtpmod()
        {
           return this.ptpmod.get();
        }

















}