package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Mpe;
import com.ceb.gjjs.mda.bo.Frm;
import com.ceb.gjjs.mda.bo.Mps;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.bo.Gpe;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Mdtmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Mdtmod.class);

        //报文展示
        private String msgdtl;

        //翻译电报码
        private IControl tnsbtn;

        //返回
        private IControl rtnbtn;

        //原文
        private IControl orgmsg;

        //展开
        private IControl expmsg;

        //保存报文Message的OBJ
        private String msg;

        //保存展开的报文
        private String emsg;

        //打印
        private IControl prt;

        //电报码
        private String src;

        //中文
        private String dst;

        //翻译
        private IControl trscod;

        //历史记录
        private IControl hisbtn;

        //查看错误
        private IControl lokerrcod;

        //gpi报文历史记录
        private IControl gpihisbtn;

        //存储交易名称
        private String frmnam;

        //展示UETR关联信息
        private IControl utrhisbtn;

        //G930报文
        private IControl g930btn;

        //G900报文
        private IControl g900btn;

        //应急报文流
        private IStream swemsgstm = new StreamImpl();

        //应急报文原报
        private String swemsg;

        //应急报文密文
        private String sweencmsg;

        //报文路径
        private String msgpth;

        //cips报文展开
        private IControl shwcipsdtl;

        //保存展开的cips报文
        private String cipsmsg;

        //cips报文展示页
        private String cipsdtl;

        //G990报文
        private IControl g990btn;

        //文件流
        private IStream filstm = new StreamImpl();

        //FXPS报文展开
        private IControl fxpsshow;

        //FXPS报文内容
        private String fxpsdtl;


        @JsonIgnore
        @BDGetter
        private transient IPanel orgexpbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel mdp;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgplft;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgt;

        @JsonIgnore
        @BDGetter
        private transient IPanel cipsmsgdtl;

        @JsonIgnore
        @BDGetter
        private transient IPanel cipsmsgshw;

        @JsonIgnore
        @BDGetter
        private transient IPanel gispmsgshwp;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxpsmsgdtl;


	    @BDGetter
		private Smpmod smpmod;

	    @BDGetter
		private Smh smh;

		@BDGetter
		private ModuleList<Mpe> mpelst;

	    @BDGetter
		private Frm frm;

		@BDGetter
		private ModuleList<Gpe> gpelst;

	    @BDGetter
		private Mps mps;

		@BDGetter
		private ModuleList<Gpe> gpe192lst;

		@BDGetter
		private ModuleList<Gpe> gpeutrlst;


		public Mdtmod()
        {
            super();
            setArgument();
        }

        public Mdtmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:mdtmod.@0000.script
        */
        @Rule(target="rtnbtn",order=100)
        public boolean ruleRtnbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:mdtmod.@0009.script
        */
        @Rule(target="orgmsg",order=100)
        public boolean ruleOrgmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			if(!MdaUtils.isEmpty(this.getMsg()))
			{
			  this.setMsgdtl((String)this.getMsg());
			  
			}
			/* else
			  {
			  String path = $smpmod.getStoreFileFullPathName(
			  $smh\\docfil.getValue(),$smh\\docfxt.getValue());
			  String msg = getSwfMsg(path);
			  $msgdtl.setValue(msg);
			  $emsg.setValue(msg);//保存获取到的报文原文
			  }*/

			return true;
        }

        /**
        *   source:mdtmod.@0010.script
        */
        @Rule(target="expmsg",order=100)
        public boolean ruleExpmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			this.setEmsg(NULLSTR);
			MdaUtils.clear(this.getMps());

			//mt报文展开
			String msg = (String)this.getMsg();
			if(MdaUtils.isEmpty(msg))
			{
			  ctx.setMessage(MdaUtils.getI18NString("mdtmod","CT000194"),MdaUtils.getI18NString("mdtmod","CT000195"));
			  return false;
			}
			com.brilliance.jrxx.framework.Result result = (com.brilliance.jrxx.framework.Result)MdaUtils.invoke("com.brilliance.jrxx.utils.MsgUtil","unPackMessage",msg);
			String json = result.getElcsModelForJson();
			Map<String, Object> map = com.alibaba.fastjson.JSON.parseObject(json, Map.class);
			String msgType = (String)map.get("MesgType");
			String propertyPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			log.info("{}","map="+map);
			log.info("{}","propertyPath="+propertyPath);
			Map<String, Object> bodyMap = new HashMap();
			String headFilePath = MdaUtils.catPath(propertyPath,"msghead.properties");
			StringBuffer buffer = new StringBuffer();
			buffer.append("报文头信息").append("\r\n");
			for(String key : map.keySet())
			{
			  String keyCn = MdaUtils.getPropertyValue(headFilePath,key);
			  if(keyCn != null)
			  {
			    String value = (String)map.get(key);
			    buffer.append(keyCn).append(":").append(value).append("\r\n");
			  }
			  String bodyKey = key;
			  this.getBodyMap(map,key,bodyMap,bodyKey);
			}
			log.debug("{}","bodyMap="+bodyMap);
			// 展开报文体
			String bodyPath = MdaUtils.catPath(propertyPath,"bodycfg");
			String bodyFilePath = MdaUtils.catPath(bodyPath,msgType+".msgbody.properties");
			log.debug("{}","bodyFilePath="+bodyFilePath);
			buffer.append("报文体信息").append("\r\n");
			for(String bkey : bodyMap.keySet())
			{
			  String bKeyCn = MdaUtils.getPropertyValue(bodyFilePath,bkey);
			  if(bKeyCn != null)
			  {
			    String bValue = (String)bodyMap.get(bkey);
			    buffer.append(bKeyCn).append(":").append(bValue).append("\r\n");
			  }
			}

			log.info("{}","buffer="+buffer.toString());
			this.setEmsg( buffer.toString());
			this.setMsgdtl((String)this.getEmsg());

			

			return true;
        }

        /**
        *   source:mdtmod.@0011.script
        */
        @Rule(target="tnsbtn",order=100)
        public boolean ruleTnsbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			String code = "";
			if(!MdaUtils.isEmpty(this.getMsg()))
			{
			  code = transCode(this.getMsg());
			}
			this.setMsgdtl( code);
			

			return true;
        }

        /**
        *   source:mdtmod.@0012.script
        */
        @Rule(target="trscod",order=100)
        public boolean ruleTrscodN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setDst( transfChinese(this.getSrc()));
			

			return true;
        }

        /**
        *   source:mdtmod.@0015.script
        */
        @Rule(target="hisbtn",order=100)
        public boolean ruleHisbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			String mpsinr = this.getSmpmod().getMps().getInr();
			log.info("{}","mpsinr="+mpsinr);
			Platform.mdbRead(this.getSmpmod().getMps(),new Argument<String>("inr",EQ,mpsinr));
			log.info("{}","[MPS INR]"+this.getSmpmod().getMps().getInr());
			log.info("{}","[MPI INR]"+this.getSmpmod().getMpi().getInr());
			//读取mpe记录
			Argument mpearg = new Argument<String>("mpsinr",EQ,mpsinr);
			if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getPntinr()))
			{
			  mpearg = mpearg.or("mpsinr",EQ,this.getSmpmod().getMps().getPntinr());
			}
			Platform.mdbReadset(this.getMpelst(),mpearg,new Argument<Date>("dattim",ASC));

			log.debug("{}","mpelst长度"+this.getMpelst().fullSize());
			


			return true;
        }

        /**
        *   source:mdtmod.@0019.script
        */
        @Rule(target="lokerrcod",order=100)
        public boolean ruleLokerrcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*如果报文被NCK，则根据错误码查找错误信息*/
			StringBuilder dspval = new StringBuilder();//错误翻译值缓冲区
			if(MdaUtils.isEmpty(this.getSmpmod().getMpi().getRpscod()))
			{
			  this.setMsgdtl("正常报文！");
			  return true;
			}
			String ecod = this.getSmpmod().getMpi().getRpscod();
			dspval.append(ecod);
			dspval.append("\r\n\r\n");
			String mty = this.getSmpmod().getMpi().getSubtyp();
			String sql = "SELECT chsdsp,engdsp FROM errcod WHERE ecod=? AND (mty LIKE ? OR mty ='ALL')";
			Platform.mdbExecuteSQL(sql,ecod,"'%"+mty+"%'");
			Argument<String> chsdsp = new Argument<String>("chsdsp");
			Argument<String> engdsp = new Argument<String>("engdsp");
			Platform.mdbFetchFields(chsdsp,engdsp);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  dspval.append("中文错误信息：");
			  dspval.append(chsdsp.value);
			  dspval.append("\r\n\r\n");
			  dspval.append("The English Error Message：");
			  dspval.append(engdsp.value);
			  this.setMsgdtl(dspval.toString());
			}
			else
			{
			  dspval.append("错误信息读取失败，请再试一次！");
			  this.setMsgdtl(dspval.toString());
			}
			Platform.mdbCloseCursor();
			

			return true;
        }

        /**
        *   source:mdtmod.@0022.script
        */
        @Rule(target="gpihisbtn",order=100)
        public boolean ruleGpihisbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","hislst");
			
			
			
			
			
			String frmnam = this.getFrmnam();
			if("gcvsel".equals(frmnam) || "gndsel".equals(frmnam) )
			{
			  
			  Platform.mdbReadset(this.getGpelst(),new Argument<Date>("credattim",ASC),new Argument<String>("orimpsinr",EQ,this.getSmpmod().getMpi().getInr()));
			  log.info("{}","gpelst长度为"+this.getGpelst().size());

			  
			  log.info("{}","gpelst");
			}
			else if("ggvsel".equals(frmnam) || "pndsel".equals(frmnam))
			{
			  
			  Platform.mdbReadset(this.getGpe192lst(),new Argument<Date>("credattim",ASC),new Argument<String>("orimpsinr",EQ,this.getSmpmod().getMpi().getInr()));
			  log.info("{}","gpe192lst长度为"+this.getGpe192lst().size());
			  
			  log.info("{}","gpe192lst");
			}

			return true;
        }

        /**
        *   source:mdtmod.@0023.script
        */
        @Rule(target="utrhisbtn",order=100)
        public boolean ruleUtrhisbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","uetrlst");
			
			
			
			
			
			Platform.mdbReadset(this.getGpeutrlst(),new Argument<Date>("credattim",ASC),new Argument<String>("uetr",EQ,this.getSmpmod().getMpi().getUetr()));
			log.info("{}","gpeutrlst长度为"+this.getGpeutrlst().size());
			
			log.info("{}","uetrlst");


			return true;
        }

        /**
        *   source:mdtmod.@0028.script
        */
        @Rule(target="shwcipsdtl",order=100)
        public boolean ruleShwcipsdtlN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCipsmsg()))
			{
			  ctx.setMessage("提示","该报文类型暂时不支持此功能");
			  return false;
			}
			this.setCipsdtl(this.getCipsmsg());
			
			//页面不可编辑
			//页面不可编辑
			

			return true;
        }

        /**
        *   source:mdtmod.@0042.script
        */
        @Rule(target="fxpsshow",order=100)
        public boolean ruleFxpsshowN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("fxl".equals(this.getSmpmod().getMpi().getMsgtyp()))
			{
			  if("111|112|301|302|303|307|308|314|315|318|319|320|321|351|601".contains(this.getSmpmod().getMpi().getSubtyp()))
			  {
			    String msg = this.getMsg();
			    log.info("{}","滴滴滴滴" + msg);
			    log.info("{}","message" + this.getSmpmod().getMpi().getSubtyp());

			    String jsonMsg = null;
			    if("601|610|707|915".contains(this.getSmpmod().getMpi().getSubtyp()))
			    {
			      jsonMsg = (String)MdaUtils.invoke("com.psbc.zfqz.jnwb.FxpsMesgPack","xmlToJsn2",msg);
			    }
			    else if("111|112|301".contains(this.getSmpmod().getMpi().getSubtyp()))
			    {
			      jsonMsg = (String)MdaUtils.invoke("com.psbc.zfqz.jnwb.FxpsMesgPack","xmlToJsn3",msg);
			    }
			    else
			    {
			      jsonMsg = (String)MdaUtils.invoke("com.psbc.zfqz.jnwb.FxpsMesgPack","xmlToJsn",msg);
			    }

			    Map map = new com.google.gson.Gson().fromJson(jsonMsg, Map.class);

			    log.info("{}","message" + map);
			    log.info("{}","message" + map.get("msgFlagNo"));

			    String path = "/weblogic/resource/eIBS.ear/eIBS.war/cfg/fxps" + this.getSmpmod().getMpi().getSubtyp() + ".properties";
			    String str = dealCIPSMap(map,path,"","");
			    log.info("{}","呵呵" + str);

			    this.setFxpsdtl(str);
			    
			    
			    
			  }
			  else
			  {
			    ctx.setMessage(MdaUtils.getI18NString("mdtmod","CT000180"),MdaUtils.getI18NString("mdtmod","CT000181"));
			  }
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("mdtmod","CT000182"),MdaUtils.getI18NString("mdtmod","CT000183"));
			}


			return true;
        }



        /**
        *   source:mdtmod.@0018.script
        */
        @Init(order=1000)
        public boolean	init1000(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			

			return true;
        }


        /**
        *   source:mdtmod.@0002.script
        */
        public void expain()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

		}
        /**
        *   source:mdtmod.@0003.script
        */
        public List getTagLst(String subtyp,String msgtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(msgtyp == null || "".equals(msgtyp)||"".equals(subtyp))
			  return null;
			List tagList = new ArrayList();
			if("sf2".equals(msgtyp))
			{
			  if (!msgtyp.startsWith("MT"))
			    subtyp = "MT " + subtyp;
			}
			else if("txt".equals(msgtyp))
			{
			  if (!msgtyp.startsWith("FMT"))
			    subtyp = "FMT " + subtyp;
			}
			/*if (msgtyp.charAt(4) == '9')
			  msgtyp = "MT n" + msgtyp.substring(4);*/
			String sql = "SELECT inr,tag,fldnam,sta,cyc,mty,tno,midnam,msgdsp,chsdsp FROM mfd WHERE mty=? ORDER BY tno ASC";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> tag = new Argument<String>("tag");
			Argument<String> fldnam = new Argument<String>("fldnam");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> cyc = new Argument<String>("cyc");
			Argument<String> mty = new Argument<String>("mty");
			Argument<Integer> tno = new Argument<Integer>("tno");
			Argument<String> midnam = new Argument<String>("midnam");
			Argument<String> msgdsp = new Argument<String>("msgdsp");
			Argument<String> chsdsp = new Argument<String>("chsdsp");
			Platform.esdbExecuteSQL(sql,subtyp);
			while(true)
			{
			  Platform.esdbFetchFields(tag,fldnam,sta,cyc,mty,tno,midnam,msgdsp,chsdsp);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    Map<String,String> tagMap = new HashMap<String,String>();
			    tagMap.put("inr", inr.value);
			    if(tag != null && !MdaUtils.isEmpty(tag))
			    {
			      if(tag.value.contains("79")&&mty.value.startsWith("FMT"))
			      {
			        tag.value = "79";
			      }
			    }
			    tagMap.put("tag", tag.value);
			    tagMap.put("fldnam",fldnam.value);
			    tagMap.put("sta", sta.value);
			    tagMap.put("cyc", cyc.value);
			    tagMap.put("mty", mty.value);
			    tagMap.put("tno", tno.value.toString());
			    tagMap.put("midnam", midnam.value);
			    tagMap.put("msgdsp",msgdsp.value);
			    tagMap.put("chsdsp",chsdsp.value);
			    tagList.add(tagMap);
			  }
			  else
			    break;
			}
			Platform.esdbCloseCursor();
			return tagList;
		}
        /**
        *   source:mdtmod.@0004.script
        */
        public String expansion(String arg,String subTyp,String msgTyp,boolean isFile)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  arg:传入参数，文件路径或直接为报文
			  msgTyp:报文类型
			  isFile:是否为文件，如是则为true，否则为false
			  */
			Object em = null;
			List tagLst = getTagLst(subTyp,msgTyp);
			if(tagLst == null || tagLst.size()==0)
			  return null;
			String funNam = null;
			if(isFile)
			  funNam = "expansionViaFile";
			else
			  funNam = "expansionViaMsg";
			em = MdaUtils.invoke("com.brilliance.swift.MessageReader",funNam,arg,tagLst);
			if(em != null)
			  return em.toString();
			else
			  return null;
		}
        /**
        *   source:mdtmod.@0006.script
        */
        public void initMdt(String smhinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.invoke("com.brilliance.swift.MessageReader","initTagCallback",new ICallback() {
				@Override
				public Object invoke(Object... paramVarArgs) {
					getTagPattern(paramVarArgs);
					return null;
				}
			});
			log.debug("{}","init 1st");
			Platform.mdbRead(this.getSmh(),new Argument<String>("inr",EQ,smhinr));
			log.debug("{}","init 2nd");
			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  log.debug("{}","init 3rd");
			  Platform.mdbRead(this.getSmpmod().getMpi(),new Argument<String>("inr",this.getSmh().getMpiinr()));
			  log.debug("{}","init 4th");
			  log.debug("{}",this.getSmh().getDocfil());
			  log.debug("{}",this.getSmh().getDocfxt());
			  log.debug("{}",this.getSmpmod().getFulldatapath());
			  log.info("{}","fullpath "+this.getSmpmod().getFulldatapath());
			  log.info("{}","5th");
			  String path = null;
			  if("cips|xml".contains(this.getSmh().getDocfxt()))
			    path = this.getSmpmod().getCipsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  else if("b2e|jsh".contains(this.getSmh().getDocfxt()))
			  {
			    path = this.getSmpmod().getB2eStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  }
			  else if("exl|elcs".contains(this.getSmh().getDocfxt()))
			  {
			    path = this.getSmpmod().getElcsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  }
			  else
			    path = this.getSmpmod().getStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  log.debug("{}","[MESSAGE PATH]:"+path);
			  if(MdaUtils.isEmpty(path))
			    ctx.setMessage(MdaUtils.getI18NString("mdtmod","CT000079"),MdaUtils.getI18NString("mdtmod","CT000080"));
			  else
			  {
			    log.debug("{}","path is not null..");
			    //$msgpth = path;
			    this.setMsgpth(path);
			    log.info("{}","msgpth:"+this.getMsgpth());
			    String msg = getSwfMsg(path);
			    if("cips|xml".contains(this.getSmh().getDocfxt()))
			    {
			      msg = null;
			      msg = getCipsMsg(path);
			      String cipsdtl = getCipsDtl(path,this.getSmpmod().getMpi().getSubtyp());
			      this.setCipsmsg(cipsdtl);
			    }
			    if("exl|elcs".contains(this.getSmh().getDocfxt()))
			    {
			      msg = null;
			      msg = getElcsMsg(path);
			    }
			    if("fxl".contains(this.getSmh().getDocfxt()))
			    {
			      msg = null;
			      msg = getElcsMsg(path);
			    }
			    if(MdaUtils.isEmpty(msg) || (msg == null))
			    {
			      //调用接口平台或JAVA方法获取文件服务器上对应目录的文件
			      log.debug("{}","getMessageFromFileServer...");
			      msg = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getMessageFromFileTransfer(path);
			    }
			    this.setMsgdtl(msg);
			    this.setMsg(msg);//保存获取到的报文原文
			    log.trace("{}",msg);
			  }
			}
		}
        /**
        *   source:mdtmod.@0008.script
        */
        public String getSwfMsg(String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(pth == null)
			  return null;
			log.info("{}","smh.mpiinr = " + this.getSmh().getMpiinr());
			Object obj = MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsg",pth);
			if(obj == null)
			  return null;
			else
			  return obj.toString();
		}
        /**
        *   source:mdtmod.@0013.script
        */
        public String transfChinese(String codeStr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//String rts = new String(byte[],"GBK");
			//检查电报码格式
			if(codeStr.length()<4||codeStr.length()%4 != 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("mdtmod","CT000034"),MdaUtils.getI18NString("mdtmod","CT000035"));
			  return "";
			}
			byte codeadd = Byte.parseByte("80",16);
			byte[] codebyte = new byte[2];
			codebyte[0] = Byte.parseByte(codeStr.substring(0,2),16);
			codebyte[0] = codebyte[0];
			codebyte[1] = Byte.parseByte(codeStr.substring(2,4),16);
			codebyte[1] = codebyte[1];
			log.debug("{}",Byte.toString(codebyte[0]));
			log.debug("{}",Byte.toString(codebyte[1]));
			return stringtrycatch(codebyte);
		}
        /**
        *   source:mdtmod.@0014.script
        */
        public String stringtrycatch(byte[] codebyte)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			try
			{
			  return new String(codebyte,"GBK");
			}
			catch(Exception e)
			{
			  return "";
			}
		}
        /**
        *   source:mdtmod.@0016.script
        */
        public String[] getTagPattern(Object... tagNamArr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(tagNamArr == null || tagNamArr.length == 0)
			  return null;
			String tagNam = (String)tagNamArr[0];
			if(tagNam == null)
			  return null;
			String sql = "SELECT ptn,adj,desptn FROM tfi WHERE tag = ?";
			String ptnStr= null;
			Platform.esdbExecuteSQL(sql,tagNam);
			Argument<String> ptn = new Argument<String>("ptn");
			Argument<String> adj = new Argument<String>("adj");
			Argument<String> desptn = new Argument<String>("desptn");
			String[] ptnsArr = null;
			Platform.esdbFetchFields(ptn,adj,desptn);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  ptnsArr = new String[]{ptn.value,adj.value,desptn.value};
			}
			Platform.esdbCloseCursor();
			return ptnsArr;
		}
        /**
        *   source:mdtmod.@0017.script
        */
        public String transCode(String msg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String tmsg = (String)MdaUtils.invoke("com.brilliance.swift.MessageReader","transMsg",msg);
			return tmsg;
		}
        /**
        *   source:mdtmod.@0021.script
        */
        public String getCipsMsg(String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(pth == null)
			  return null;
			Object obj = MdaUtils.invoke("com.brilliance.swift.MessageReader","getCipsMsg",pth);
			if(obj == null)
			  return null;
			else
			  return obj.toString();
		}
        /**
        *   source:mdtmod.@0024.script
        */
        public String getElcsMsg(String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(pth == null)
			  return null;
			Object obj = MdaUtils.invoke("com.brilliance.swift.MessageReader","getElcsMsg",pth);
			if(obj == null)
			  return null;
			else
			  return obj.toString();
		}
        /**
        *   source:mdtmod.@0025.script
        */
        public String loadSweMessage(boolean origMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String path = this.getMsgpth();
			log.debug("{}","[SF2 MESSAGE PATH]:"+path);
			if(origMsg)
			{
			  path = path.replace(".sf2",".gisp");
			}
			else
			{
			  path = path.replace(".sf2",".gispx");
			}
			log.debug("{}","[MESSAGE PATH]:"+path);
			IStream is = this.getSwemsgstm();
			MdaUtils.streamClear(is);
			Platform.mstreamLoad(is,path);
			return Platform.convertIStream2String(is);
		}
        /**
        *   source:mdtmod.@0026.script
        */
        public String getCipsDtl(String path,String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*if(!"111|112|135|301|302|303|304|309|356|357|601".contains(type))
			  {
			  return "";
			  }
			  String propertiespath = Platform.catPath(Platform.getRootPath(),"cfg");
			  log.info("propertiespath="+propertiespath);
			  String propertiesname = "cips"+601+".properties";
			  log.info("propertiesname="+propertiesname);
			  String filenam = Platform.catPath(propertiespath,propertiesname);
			  log.debug("CIPS detail properties:"+filenam);
			  Object[] paths = new Object[1];
			  paths[0] = path;
			  Object object = Platform.invoke("com.brilliance.eibs.main.Client","scall","cipsmsgfromcips","msgfromcips",paths);
			  Boolean obt = (Boolean)Platform.invoke(object,"isSuccess");
			  log.debug("obt-------"+obt);
			  if(!obt)
			  {
			  Platform.message(#CT000113,#CT000114);
			  return "";
			  }
			  //获取接口平台返回的内容
			  Object[] obj = (Object[])Platform.invoke(object,"getContent");//报文内容
			  log.debug("CIPS报文内容:"+obj);
			  Map<String,Object> map = (Map<String,Object>)obj[1];//解析的map信息
			  log.debug("CIPS map:"+map);
			  String str = dealCIPSMap(map,filenam,"",type);
			  log.debug("str:"+str);*/
			return null;
		}
        /**
        *   source:mdtmod.@0027.script
        */
        public String dealCIPSMap(Map<String,Object> map,String path,String value,String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer str = new StringBuffer("");
			String strmap="";
			String ordernam = MdaUtils.getPropertyValue(path,value+"order");
			if(MdaUtils.isEmpty(ordernam))
			{
			  return str.toString();
			}
			String[] orders= ordernam.split(",");
			Object obj = null;
			for(int i=0;i<orders.length;i++)
			{
			  String label = orders[i];
			  log.debug("{}",label);
			  int index = label.indexOf(".");
			  if(index>0)
			  {
			    obj = map.get(label.substring(0,index));
			  }
			  else
			  {
			    obj = map.get(label);
			  }
			  if(obj == null)
			  {
			    continue;
			  }
			  if(obj instanceof String)
			  {
			    String objstr = (String)obj;
			    strmap = dealCIPSString(label,objstr,path);

			  }
			  if(obj instanceof ArrayList)
			  {
			    ArrayList objlst = (ArrayList)obj;
			    strmap = dealCIPSLst(label,objlst,path);
			  }
			  if(obj instanceof Map)
			  {
			    Map objmap = (Map<String,Object>)obj;
			    String key = MdaUtils.getPropertyValue(path,label);
			    str.append(key).append(" : ").append("\r\n");
			    log.info("{}","cips label is:"+label);
			    strmap = dealCIPSMap(objmap,path,label,"");
			  }
			  str.append(strmap);
			  //给111报文添加主体部分添加一行间隔
			  if("Ustrd".equals(label) && "111".equals(type) )
			  {
			    str.append("\r\n");
			  }
			  //给301、302、303、304、309报文添加主体部分添加一行间隔
			  if("Cntt".equals(label) && "301".equals(type) )
			  {
			    str.append("\r\n");
			  }
			  if("Rsn".equals(label) && "302".equals(type) )
			  {
			    str.append("\r\n");
			  }
			  if("HMsgRef".equals(label) && "303|304".contains(type))
			  {
			    str.append("\r\n");
			  }
			  if("MsgCntt".equals(label) && "309".equals(type) )
			  {
			    str.append("\r\n");
			  }
			}
			return str.toString();
		}
        /**
        *   source:mdtmod.@0029.script
        */
        public String dealCIPSString(String label,String obj,String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer str = new StringBuffer("");
			String key = MdaUtils.getPropertyValue(path,label);
			str.append(key).append(" : ").append((String)obj).append("\r\n");
			return str.toString();
		}
        /**
        *   source:mdtmod.@0030.script
        */
        public String dealCIPSLst(String label,ArrayList obj,String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer str = new StringBuffer("");
			String key = MdaUtils.getPropertyValue(path,label);
			int length = obj.size();
			String strlst = "";
			for(int i=0;i<length;i++)
			{
			  if(obj.get(i) instanceof String)
			  {
			    strlst = (String)obj.get(i);
			    str.append(key).append(String.valueOf((i+1))).append(" : ").append(strlst).append("\r\n");
			  }
			  if(obj.get(i) instanceof Map)
			  {
			    Map lstmap = (Map<String,Object>)obj.get(i);
			    strlst = dealCIPSMap(lstmap,path,label,"");
			    str.append(key).append(String.valueOf((i+1))).append(" : ").append("\r\n");
			    str.append(strlst);
			  }
			}
			return str.toString();
		}
        /**
        *   source:mdtmod.@0031.script
        */
        public String getMxDtl(Map<String,Object> mxMap,String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","开始执行getMxDtl()");
			log.debug("{}","type值为: " + type);

			if(!"camt.053.001|pacs.008.001|pacs.009.001".contains(type))
			{
			  log.debug("{}","该类型报文无法展开");
			  return "";
			}
			StringBuffer str = new StringBuffer("");
			String strmap="";
			Map<String,Object> mxDtlMap = new HashMap<String,Object>();

			if("camt.053.001".equals(type))
			{

			  log.debug("{}","camt053所接收的map" + mxMap);
			  mxDtlMap.putAll(mxMap);//将接收到map赋给mxDTLMAP
			}
			else
			{
			  //将mxMap的key转为大写
			  Map<String,Object> mxMapUp = new HashMap<String,Object>();

			  for(String key : mxMap.keySet())
			  {
			    log.debug("{}",key + ":" + mxMap.get(key));
			    String upKey = key.toUpperCase();
			    Object obj = null;
			    obj = mxMap.get(key);//从所返回mxMap中获取对应的value
			    mxMapUp.put(upKey,obj);
			  }

			  Map<String,String> apdMap = new HashMap<String,String>();
			  apdMap = getApdMap();
			  for(String key : apdMap.keySet())
			  {
			    log.debug("{}",key + ":" + apdMap.get(key));
			    String label = apdMap.get(key);//获取配置文件对应字段的中文名
			    Object obj = mxMapUp.get(key);//从所返回mxMap中获取对应的value
			    mxDtlMap.put(label,obj);
			  }
			  log.debug("{}","获取apdMap后: "+mxDtlMap);

			  Map<String,String> proMap = new HashMap<String,String>();
			  proMap = getProMap(type);

			  for(String prokey : proMap.keySet())
			  {
			    if(prokey.contains("*"))
			    {
			      log.debug("{}",prokey+"包含*");
			      String label = proMap.get(prokey);
			      prokey = prokey.replace("*", "(\\([0-9]{1}\\)){0,1}");
			      ArrayList<Object> objList = new ArrayList<Object>();
			      for(String mxKey : mxMapUp.keySet())
			      {
			        if(mxKey.matches(prokey))
			        {
			          Object mxValue = mxMapUp.get(mxKey);
			          objList.add(mxValue);
			        }
			      }
			      log.debug("{}",prokey+":"+objList);
			      mxDtlMap.put(label,objList);
			    }
			    else
			    {
			      String label = proMap.get(prokey);
			      Object obj1 = mxMapUp.get(prokey);
			      log.debug("{}",label + ":" + obj1);
			      mxDtlMap.put(label,obj1);
			    }
			  }
			  log.debug("{}","获取proMap后: "+mxDtlMap);
			}
			//解析新mxDtlMap，获取页面展示信息
			log.debug("{}","开始遍历mxDtlMap");
			for(String label : mxDtlMap.keySet())
			{
			  log.debug("{}",label + ":" + mxDtlMap.get(label));
			  Object obj = mxDtlMap.get(label);//根据key从mxDtlMap中获取对应的值
			  if(obj == null)
			  {
			    continue;
			  }
			  if(obj instanceof String)
			  {
			    String objstr = (String)obj;
			    log.debug("{}",obj + ":" +objstr);
			    strmap = dealMxString(label,objstr);
			  }
			  if(obj instanceof ArrayList)
			  {
			    ArrayList objlst = (ArrayList)obj;
			    strmap = dealMxLst(label,objlst);
			  }
			  str.append(strmap);
			}

			//dealMxMap()
			String mxDtlStr = str.toString();

			log.debug("{}","页面展示信息mxDtlStr:"+mxDtlStr);
			return mxDtlStr;

		}
        /**
        *   source:mdtmod.@0033.script
        */
        public String dealMxMap(Map<String,Object> mxMap,String path,String value,String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			StringBuffer str = new StringBuffer("");
			String strmap="";

			//获取配置文件中order的值
			String ordernam = MdaUtils.getPropertyValue(path,value+"order");
			//String ordernam = "identifier,fiToFICstmrCdtTrf.grpHdr.msgId,fiToFICstmrCdtTrf.cdtTrfTxInf.intrBkSttlmDt,fiToFICstmrCdtTrf.cdtTrfTxInf.intrBkSttlmAmt.ccy,fiToFICstmrCdtTrf.cdtTrfTxInf.intrBkSttlmAmt.value,appHdr.fr.fiId.finInstnId.bicfi,fiToFICstmrCdtTrf.grpHdr.creDtTm";
			
			if(MdaUtils.isEmpty(ordernam))
			{
			  return str.toString();
			}
			log.debug("{}","配置文件中ordernam :" +ordernam);
			//得到配置文件中的每一个KEY
			String[] orders= ordernam.split(",");
			Object obj = null;
			String label = null;
			Map<String,Object> mxDtlMap = new HashMap<String,Object>();
			log.debug("{}","开始根据配置文件的key获取对应值");

			for(int i=0;i<orders.length;i++)
			{
			  label = orders[i];
			  obj = mxMap.get(label);
			  log.debug("{}","mx_label:"+label);
			  log.debug("{}","mx_obj:"+obj);

			  if(obj == null)
			  {
			    continue;
			  }
			  if(obj instanceof String)
			  {
			    String objstr = (String)obj;
			    strmap = dealCIPSString(label,objstr,path);
			  }
			  if(obj instanceof ArrayList)
			  {
			    ArrayList objlst = (ArrayList)obj;
			    strmap = dealCIPSLst(label,objlst,path);
			  }
			  /*  if(obj instanceof Map)
			    {
			    Map objmap = (Map<String,Object>)obj;
			    String key = Platform.getPropertyValue(path,label);
			    str.append(key).append(" : ").append("\\r\\n");
			    log.info("mx label is:"+label);
			    strmap = dealMxMap(objmap,path,label,"");
			    }
			    */
			  str.append(strmap);
			}
			return str.toString();
		}
        /**
        *   source:mdtmod.@0034.script
        */
        public void initMdt(String smhinr,int ismx)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.invoke("com.brilliance.swift.MessageReader","initTagCallback",new ICallback() {
				@Override
				public Object invoke(Object... paramVarArgs) {
					getTagPattern(paramVarArgs);
					return null;
				}
			});
			log.debug("{}","init 1st");
			Platform.mdbRead(this.getSmh(),new Argument<String>("inr",EQ,smhinr));
			log.debug("{}","init 2nd");
			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  log.debug("{}","init 3rd");
			  Platform.mdbRead(this.getSmpmod().getMpi(),new Argument<String>("inr",this.getSmh().getMpiinr()));
			  log.debug("{}","init 4th");
			  log.debug("{}",this.getSmh().getDocfil());
			  log.debug("{}",this.getSmh().getDocfxt());
			  log.debug("{}",this.getSmpmod().getFulldatapath());
			  log.info("{}","fullpath "+this.getSmpmod().getFulldatapath());
			  log.info("{}","5th");
			  String path = null;
			  if("cips|xml".contains(this.getSmh().getDocfxt()))
			    path = this.getSmpmod().getCipsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  else if("b2e|jsh".contains(this.getSmh().getDocfxt()))
			  {
			    path = this.getSmpmod().getB2eStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  }
			  else if("exl|elcs".contains(this.getSmh().getDocfxt()))
			  {
			    path = this.getSmpmod().getElcsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  }
			  else
			    path = this.getSmpmod().getStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  log.debug("{}","[MESSAGE PATH]:"+path);
			  if(MdaUtils.isEmpty(path))
			    ctx.setMessage(MdaUtils.getI18NString("mdtmod","CT000177"),MdaUtils.getI18NString("mdtmod","CT000178"));
			  else
			  {
			    log.debug("{}","path is not null..");
			    if(1 == ismx)
			    {
			      path = path.replaceAll(".sf2",".xml");//获取存放MX报文的文件路径
			      log.info("{}","mxPath = " + path);
			    }
			    //$msgpth = path;
			    this.setMsgpth(path);
			    String msg = null;
			    if(1 != ismx)
			    {
			      msg = getSwfMsg(path);
			    }
			    if("cips|xml".contains(this.getSmh().getDocfxt()))
			    {
			      msg = null;
			      msg = getCipsMsg(path);
			      log.info("{}","path="+path);
			      log.info("{}","msg="+msg);
			      String cipsdtl = getCipsDtl(path,this.getSmpmod().getMpi().getSubtyp());
			      log.info("{}","cipsdtl="+cipsdtl);
			      this.setCipsmsg(cipsdtl);
			    }
			    if("exl|elcs".contains(this.getSmh().getDocfxt()))
			    {
			      msg = null;
			      msg = getElcsMsg(path);
			    }
			    if("fxl".contains(this.getSmh().getDocfxt()))
			    {
			      msg = null;
			      msg = getElcsMsg(path);
			    }
			    if(MdaUtils.isEmpty(msg) || (msg == null))
			    {
			      //调用接口平台或JAVA方法获取文件服务器上对应目录的文件
			      log.debug("{}","getMessageFromFileServer...");
			      msg = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getMessageFromFileTransfer(path);
			    }
			    this.setMsgdtl(msg);
			    this.setMsg(msg);//保存获取到的报文原文
			    log.trace("{}",msg);
			  }
			}
		}
        /**
        *   source:mdtmod.@0038.script
        */
        public String dealMxString(String label,String obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer str = new StringBuffer("");
			str.append(label).append(" : ").append((String)obj).append("\r\n");
			return str.toString();
		}
        /**
        *   source:mdtmod.@0039.script
        */
        public String dealMxLst(String label,ArrayList obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer str = new StringBuffer("");
			int length = obj.size();
			String strlst = "";
			for(int i=0;i<length;i++)
			{
			  if(obj.get(i) instanceof String)
			  {
			    strlst = (String)obj.get(i);
			    str.append(label).append(String.valueOf((i+1))).append(" : ").append(strlst).append("\r\n");
			  }
			}
			return str.toString();
		}
        /**
        *   source:mdtmod.@0040.script
        */
        public Map<String,String> getApdMap()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String propertiespath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/translation/mx");
			String propertiesname = "AppHdr.properties";
			//获取AppHdr.properties所在路径
			String filenam = MdaUtils.catPath(propertiespath,propertiesname);
			log.debug("{}","MX AppHdr properties:"+filenam);

			Map<String,String> apdMap = new HashMap<String,String>();
			//获取配置文件中的显示顺序
			String ordernam = MdaUtils.getPropertyValue(filenam,"order");

			log.debug("{}","AppHdr配置文件中ordernam :" +ordernam);
			if(MdaUtils.isEmpty(ordernam))
			{
			  log.debug("{}","配置文件中ordernam为空");
			  apdMap.put("error","AppHdr.properties.order为空");
			  return apdMap;
			}
			//得到配置文件中的每一个KEY
			String[] orders= ordernam.split(",");
			for(int i=0;i<orders.length; i++)
			{
			  String key = orders[i];
			  String value = MdaUtils.getPropertyValue(filenam,key);
			  if(MdaUtils.isEmpty(value))
			  {
			    continue;
			  }
			  String upKey = key.toUpperCase();//将key转为大写
			  apdMap.put(upKey,value);
			}
			log.debug("{}","AppHdr配置文件:" + apdMap);
			return apdMap;
		}
        /**
        *   source:mdtmod.@0041.script
        */
        public Map<String,String> getProMap(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","MX报文类型dettyp："+type);
			String propertiespath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/translation/mx");
			String propertiesname = type+".properties";
			//获取配置文件所在路径
			String filenam = MdaUtils.catPath(propertiespath,propertiesname);
			log.debug("{}","MX detail properties:"+filenam);

			Map<String,String> proMap = new HashMap<String,String>();

			//获取配置文件中的显示顺序
			String ordernam = MdaUtils.getPropertyValue(filenam,"order");
			log.debug("{}","配置文件中ordernam :" +ordernam);
			if(MdaUtils.isEmpty(ordernam))
			{
			  log.debug("{}","配置文件中ordernam为空");
			  proMap.put("error",type+".properties.order为空");
			  return proMap;
			}
			//得到配置文件中的每一个KEY
			String[] orders= ordernam.split(",");

			for(int i=0;i<orders.length; i++)
			{
			  String key = orders[i];
			  String proValue = MdaUtils.getPropertyValue(filenam,key);
			  if(MdaUtils.isEmpty(proValue))
			  {
			    continue;
			  }
			  String upKey = key.toUpperCase();//将key转为大写
			  proMap.put(upKey,proValue);
			}
			log.debug("{}","配置文件Map:" + proMap);
			return proMap;
		}
        /**
        *   source:mdtmod.@0043.script
        */
        public void getBodyMap(Map map, String key, Map bodyMap, String bodyKey)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","key="+key);
			log.debug("{}","bodyKey="+bodyKey);
			log.debug("{}","class="+map.get(key).getClass());
			if(map.get(key) instanceof Map)
			{
			  log.debug("{}","instanceof Map");
			  Map<String, Object> tempMap = (Map)map.get(key);
			  for(String tkey : tempMap.keySet())
			  {
			    if(tempMap.get(tkey) instanceof Map)
			    {
			      this.getBodyMap(tempMap,tkey,bodyMap, bodyKey+"."+tkey);
			    }
			    else if(tempMap.get(tkey) instanceof List)
			    {
			      log.debug("{}","instanceof List");
			      List<Object> tList = (List)tempMap.get(tkey);
			      String tbodyValue = "";
			      for(Object obj : tList)
			      {
			        if(obj instanceof Map)
			        {
			          Map<String, Object> ttMap = (Map)obj;
			          for(String ttKey : ttMap.keySet())
			          {
			            this.getBodyMap(ttMap,ttKey,bodyMap, bodyKey+"."+tkey+"."+ttKey);
			          }
			        }
			        else
			        {
			          tbodyValue += obj.toString()+",";
			        }
			      }
			      if(!MdaUtils.isEmpty(tbodyValue))
			      {
			        tbodyValue = tbodyValue.substring(0, tbodyValue.length() - 1);
			        bodyMap.put(bodyKey+"."+tkey, tbodyValue);
			      }
			    }
			    else
			    {
			      if(!MdaUtils.isEmpty(bodyMap.get(bodyKey+"."+tkey)))
			      {
			        // list的标签处理
			        bodyMap.put(bodyKey+"."+tkey, bodyMap.get(bodyKey+"."+tkey) + "," + tempMap.get(tkey));
			      }
			      else
			      {
			        bodyMap.put(bodyKey+"."+tkey, tempMap.get(tkey));
			      }
			    }
			  }
			}
			else
			{
			  bodyMap.put(bodyKey, map.get(key));
			}
		}



































































}