package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Mdtp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Mdtp.class);

        //返回
        private IControl rtnbtn;

        //重新发送
        private IControl resend;

        //显示转会前报文
        private String shwpremsg;

        //转发前原报文smhinr
        private String presmhinr;

        //展示199s信息
        private String tx199s;

        //关闭
        private IControl cls199;


        @JsonIgnore
        @BDGetter
        private transient IPanel msgdtlp;

        @JsonIgnore
        @BDGetter
        private transient IPanel dtlmsgp;

        @JsonIgnore
        @BDGetter
        private transient IPanel ctxp;

        @JsonIgnore
        @BDGetter
        private transient IPanel btmp;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgtp;

        @JsonIgnore
        @BDGetter
        private transient IPanel shwpnl;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Msggrp> msggrp;

	    @BDGetter
		private Mdtmod mdtmod;


		public Mdtp()
        {
            super();
            setArgument();
        }

        public Mdtp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:mdtp.@0000.script
        */
        @Rule(target="rtnbtn",order=100)
        public boolean ruleRtnbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:mdtp.@0018.script
        */
        @Rule(target="resend",order=100)
        public boolean ruleResendN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("E".equals(this.getMsggrp().getMps().getSta()))
			{
			  Platform.mdbBegin();
			  this.getMsggrp().getMps().setSta( "W");
			  Platform.mdbUpdate(this.getMsggrp().getMps());
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    Platform.mdbCommit();
			    if(ctx.getErrorCode() != NO_ERROR)
			      ctx.setMessage(MdaUtils.getI18NString("mdtp","CT000138"),MdaUtils.getI18NString("mdtp","CT000139"));
			    else
			    {
			      
			      MdaUtils.resetModified(this,"resend");
			      ctx.setMessage(MdaUtils.getI18NString("mdtp","CT000140"),MdaUtils.getI18NString("mdtp","CT000141"));
			    }
			  }
			  else
			  {
			    Platform.mdbRollback();
			    ctx.setMessage(MdaUtils.getI18NString("mdtp","CT000142"),MdaUtils.getI18NString("mdtp","CT000143"));
			  }
			}
			else
			  ctx.setMessage(MdaUtils.getI18NString("mdtp","CT000144"),MdaUtils.getI18NString("mdtp","CT000145"));

			return true;
        }

        /**
        *   source:mdtp.@0020.script
        */
        @Rule(target="shwpremsg",order=100)
        public boolean ruleShwpremsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getShwpremsg()))
			{
			  this.getMdtmod().initMdt(this.getMsggrp().getSmh().getInr());
			  
			}
			else
			{
			  this.getMdtmod().initMdt(this.getPresmhinr());
			  
			}
			

			return true;
        }

        /**
        *   source:mdtp.@0022.script
        */
        @Rule(target="mdtmod.gpelst",order=100)
        public boolean ruleMdtmodGpelstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			//记下选择项
			String mpsinr = this.getMdtmod().getGpelst().getElement(index).getMpsinr();
			Platform.mdbRead(this.getMdtmod().getMps(),new Argument<String>("inr",EQ,mpsinr));
			String smhinr = this.getMdtmod().getMps().getSmhinr();
			log.debug("{}","smhinr:"+smhinr);
			Platform.mdbRead(this.getMdtmod().getSmh(),new Argument<String>("inr",EQ,smhinr));
			if(!MdaUtils.isEmpty(this.getMdtmod().getSmh().getInr()))
			{
			  String path = this.getMdtmod().getSmpmod().getStoreFileFullPathName(this.getMdtmod().getSmh().getDocfil(),this.getMdtmod().getSmh().getDocfxt());
			  log.debug("{}",path);
			  if(MdaUtils.isEmpty(path))
			    ctx.setMessage(MdaUtils.getI18NString("mdtp","CT000150"),MdaUtils.getI18NString("mdtp","CT000151"));
			  else
			  {
			    log.debug("{}","path is not null..");
			    String msg = getSwfMsg(path);
			    if(MdaUtils.isEmpty(msg) || (msg == null))
			    {
			      //调用接口平台或JAVA方法获取文件服务器上对应目录的文件
			      log.debug("{}","getMessageFromFileServer...");
			      msg = ctx.absGet(Sysmod.class).getMessageFromFileTransfer(path);
			    }
			    this.setTx199s(msg);
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:mdtp.@0023.script
        */
        @Rule(target="cls199",order=100)
        public boolean ruleCls199N100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:mdtp.@0024.script
        */
        @Rule(target="mdtmod.gpe192lst",order=100)
        public boolean ruleMdtmodGpe192lstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			//记下选择项
			String mpsinr = this.getMdtmod().getGpe192lst().getElement(index).getMpsinr();
			Platform.mdbRead(this.getMdtmod().getMps(),new Argument<String>("inr",EQ,mpsinr));
			String smhinr = this.getMdtmod().getMps().getSmhinr();
			log.debug("{}","smhinr:"+smhinr);
			Platform.mdbRead(this.getMdtmod().getSmh(),new Argument<String>("inr",EQ,smhinr));
			if(!MdaUtils.isEmpty(this.getMdtmod().getSmh().getInr()))
			{
			  String path = this.getMdtmod().getSmpmod().getStoreFileFullPathName(this.getMdtmod().getSmh().getDocfil(),this.getMdtmod().getSmh().getDocfxt());
			  log.debug("{}",path);
			  if(MdaUtils.isEmpty(path))
			    ctx.setMessage(MdaUtils.getI18NString("mdtp","CT000157"),MdaUtils.getI18NString("mdtp","CT000158"));
			  else
			  {
			    log.debug("{}","path is not null..");
			    String msg = getSwfMsg(path);
			    if(MdaUtils.isEmpty(msg) || (msg == null))
			    {
			      //调用接口平台或JAVA方法获取文件服务器上对应目录的文件
			      log.debug("{}","getMessageFromFileServer...");
			      msg = ctx.absGet(Sysmod.class).getMessageFromFileTransfer(path);
			    }
			    this.setTx199s(msg);
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:mdtp.@0025.script
        */
        @Rule(target="mdtmod.gpeutrlst",order=100)
        public boolean ruleMdtmodGpeutrlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			//记下选择项
			String mpsinr = this.getMdtmod().getGpeutrlst().getElement(index).getMpsinr();
			Platform.mdbRead(this.getMdtmod().getMps(),new Argument<String>("inr",EQ,mpsinr));
			String smhinr = this.getMdtmod().getMps().getSmhinr();
			log.debug("{}","smhinr:"+smhinr);
			Platform.mdbRead(this.getMdtmod().getSmh(),new Argument<String>("inr",EQ,smhinr));
			if(!MdaUtils.isEmpty(this.getMdtmod().getSmh().getInr()))
			{
			  String path = this.getMdtmod().getSmpmod().getStoreFileFullPathName(this.getMdtmod().getSmh().getDocfil(),this.getMdtmod().getSmh().getDocfxt());
			  log.debug("{}",path);
			  if(MdaUtils.isEmpty(path))
			    ctx.setMessage(MdaUtils.getI18NString("mdtp","CT000159"),MdaUtils.getI18NString("mdtp","CT000160"));
			  else
			  {
			    log.debug("{}","path is not null..");
			    String msg = getSwfMsg(path);
			    if(MdaUtils.isEmpty(msg) || (msg == null))
			    {
			      //调用接口平台或JAVA方法获取文件服务器上对应目录的文件
			      log.debug("{}","getMessageFromFileServer...");
			      msg = ctx.absGet(Sysmod.class).getMessageFromFileTransfer(path);
			    }
			    this.setTx199s(msg);
			    
			    
			  }
			}

			return true;
        }



        /**
        *   source:mdtp.@0016.script
        */
        @Init(order=300)
        public boolean	init300(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMdtmod().initMdt(this.getMsggrp().getSmh().getInr(),this.getMsggrp().getMps().getIsmx());

			return true;
        }

        /**
        *   source:mdtp.@0019.script
        */
        @Init(order=400)
        public boolean	init400(){
            IContext ctx = MdaEnv.getContext();
            

			setrPresmhinr(this.getMsggrp().getMpi().getOthref());
			if(!MdaUtils.isEmpty(this.getPresmhinr()))
			{
			  log.debug("{}","本行其他机构转发报文");
			  
			}
			else
			{
			  
			}

			return true;
        }


        /**
        *   source:mdtp.@0007.script
        */
        public String expansion(String arg,String msgTyp,boolean isFile)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  arg:传入参数，文件路径或直接为报文
			  msgTyp:报文类型
			  isFile:是否为文件，如是则为true，否则为false
			  */
			Object em = null;
			List tagLst = getTagLst(msgTyp);
			if(tagLst == null || tagLst.size()==0)
			  return null;
			String funNam = null;
			if(isFile)
			  funNam = "expansionViaFile";
			else
			  funNam = "expansionViaMsg";
			em = MdaUtils.invoke("com.brilliance.swift.MessageReader",funNam,arg,tagLst);
			if(em != null)
			  return em.toString();
			else
			  return null;
		}
        /**
        *   source:mdtp.@0008.script
        */
        public List getTagLst(String msgtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(msgtyp == null || "".equals(msgtyp))
			  return null;
			List tagList = new ArrayList();
			if (!msgtyp.startsWith("MT"))
			  msgtyp = "MT " + msgtyp;
			if (msgtyp.charAt(4) == '9')
			  msgtyp = "MT n" + msgtyp.substring(4);
			String sql = "SELECT inr,tag,fldnam,sta,cyc,mty,tno,midnam,msgdsp FROM mfd WHERE mty=? ORDER BY tno ASC";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> tag = new Argument<String>("tag");
			Argument<String> fldnam = new Argument<String>("fldnam");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> cyc = new Argument<String>("cyc");
			Argument<String> mty = new Argument<String>("mty");
			Argument<BigDecimal> tno = new Argument<BigDecimal>("tno");
			Argument<String> midnam = new Argument<String>("midnam");
			Argument<String> msgdsp = new Argument<String>("msgdsp");
			Platform.mdbExecuteSQL(sql,msgtyp);
			while(true)
			{
			  Platform.mdbFetchFields(tag,fldnam,sta,cyc,mty,tno,midnam);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    Map<String,String> tagMap = new HashMap<String,String>();
			    tagMap.put("inr", inr.value);
			    tagMap.put("tag", tag.value);
			    tagMap.put("fldnam",fldnam.value);
			    tagMap.put("sta", sta.value);
			    tagMap.put("cyc", cyc.value);
			    tagMap.put("mty", mty.value);
			    tagMap.put("tno", tno.value.toString());
			    tagMap.put("midnam", midnam.value);
			    tagMap.put("msgdsp",msgdsp.value);
			    tagList.add(tagMap);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return tagList;
		}
        /**
        *   source:mdtp.@0009.script
        */
        public String getSwfMsg(String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(pth == null)
			  return null;
			Object obj = MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsg",pth);
			if(obj == null)
			  return null;
			else
			  return obj.toString();
		}
        /**
        *   source:mdtp.@0021.script
        */
        public void setrPresmhinr(String ownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(ownref))
			  return;
			String sql = "SELECT smhinr FROM mps,mpi WHERE mps.inr=mpi.inr";
			sql += " AND (mpi.fwdref='"+ownref+"' OR mpi.fwdref2='"+ownref+"' ) ";
			Argument<String> smhinr = new Argument<String>("smhinr");
			ctx.getErrorCode();
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(smhinr);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  this.setPresmhinr( smhinr.value);
			}
			Platform.mdbCloseCursor();
		}


        public void setMsggrpHolder(ModuleHolder<Msggrp> msggrp)
        {
            this.msggrp = msggrp;
        }

        public Msggrp getMsggrp()
        {
           return this.msggrp.get();
        }














}