package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Mpe;
import com.ceb.gjjs.mda.bo.Mps;
import com.ceb.gjjs.mda.bo.Csn;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Chn;
import com.ceb.gjjs.mda.bo.Mpi;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Msgmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Msgmod.class);

        //文件数据流（类似格式转换使用）
        private IStream fil = new StreamImpl();

        //报文保存相对路径
        private String datapath;

        //保存文件完整目录
        private String fulldatapath;

        //chnmap
        private Map chnmap;

        //CIPS报文存储路径
        private String cipsdatapath;

        //CIPS报文全存储路径
        private String cipsfulldatapath;

        //报文保存根路径（配置文件读取）
        private String rootpath;



	    @BDGetter
		private Mpi mpi;

	    @BDGetter
		private Csn csn;

	    @BDGetter
		private Mps mps;

	    @BDGetter
		private Mpe mpe;

	    @BDGetter
		private Smh smh;

	    @BDGetter
		private Chn chn;

	    @BDGetter
		private Chn tgtchn;


		public Msgmod()
        {
            super();
            setArgument();
        }

        public Msgmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:msgmod.@0000.script
        */
        public String create_msg_990(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			com.brilliance.jrxx.packet.model.cfad_990_001_01.Cfad_990_001_01 cfad_990_001_01 = new com.brilliance.jrxx.packet.model.cfad_990_001_01.Cfad_990_001_01();
			com.brilliance.jrxx.packet.model.cfad_990_001_01.ConfInf confInf = new com.brilliance.jrxx.packet.model.cfad_990_001_01.ConfInf();

			confInf.OrigSndr = (String)map.get("OrigSender");
			confInf.OrigSndDt =(String)map.get("OrigSendDate");
			confInf.MT = (String)map.get("MesgType");
			confInf.MsgId = (String)map.get("MesgID");
			confInf.MsgPrcCd = "CU0I0000";
			confInf.Prcresdsc = "处理成功";
			cfad_990_001_01.ConfInf = confInf;
			// 头部
			this.fillHead(cfad_990_001_01, "cfad.990.001.01");

			String json_990 = com.alibaba.fastjson.JSON.toJSONString(cfad_990_001_01);
			log.info("{}","990json:"+json_990);
			return json_990;
		}
        /**
        *   source:msgmod.@0001.script
        */
        public void fillHead(com.brilliance.jrxx.packet.model.com.Elcs elcs,String mesgType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			String propertyPath = MdaUtils.catPath(path,"rcvsndmsg.properties");
			String origSender = MdaUtils.getPropertyValue(propertyPath,"OrigSender");
			String origSenderSID = MdaUtils.getPropertyValue(propertyPath,"OrigSenderSID");
			elcs.OrigSender = origSender;
			elcs.OrigReceiver = "0000";
			elcs.OrigSendDate = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			elcs.OrigSendTime = MdaUtils.format(MdaUtils.today(),"HHmmss");
			elcs.MesgType = mesgType;
			elcs.MesgID = this.mkMsgId();
			elcs.MesgRefID = "00000000000000000000";
			elcs.MesgDirection = "U";
			elcs.OrigSenderSID = origSenderSID;
			elcs.OrigReceiverSID = "CFIX";
		}
        /**
        *   source:msgmod.@0002.script
        */
        public String mkMsgId()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String inr = Platform.sdbCounter("cfixmsgid","00000000");
			String day=MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			return "CFIX"+day+inr;
		}
        /**
        *   source:msgmod.@0005.script
        */
        public void handle_cfad_019_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理019报文map:"+map);
			Map adminInfoMap = (Map)map.get("AdminInfo");
			Map stsInfMap = (Map)adminInfoMap.get("StsInf");
			Map mmbStsInfoMap = (Map)stsInfMap.get("MmbStsInfo");
			// 接入机构行号
			String bnkcod=(String)mmbStsInfoMap.get("MmbId");
			// 根据行号查找
			MdaUtils.clear(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty());
			Argument argument = new Argument("bnkcod",bnkcod);
			ctx.getErrorCode();
			Platform.mdbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty(),argument);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.info("{}","查出cpxpty表的inr:"+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().getInr());
			  ctx.getDaoSession().dbBegin();
			  // 办理业务状态
			  String status=(String)mmbStsInfoMap.get("Sts");
			  // 登录状态
			  String logSts=(String)mmbStsInfoMap.get("LoginSts");
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setStatus(status);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setLogsts(logSts);
			  ctx.getDaoSession().dbUpdate(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty());
			  ctx.getDaoSession().dbCommit();
			}
			else
			{
			  log.info("{}","未查出对应的接入结构,接入结构行号bnkcod:"+bnkcod);
			}

		}
        /**
        *   source:msgmod.@0006.script
        */
        public String getFileContent(String smhinr,String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","smhinr=="+smhinr+"fileType"+fileType);
			String fileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			fileName = MdaUtils.catPath(fileName,"rcvsndmsg.properties");
			String rootPath=MdaUtils.getPropertyValue(fileName,"rootpath");
			String datapath = MdaUtils.getPropertyValue(fileName,"datapath");
			String fullDataPath = MdaUtils.catPath(rootPath,datapath);
			fullDataPath=MdaUtils.catPath(fullDataPath,smhinr.substring(0,4)+"/"+smhinr+"." + fileType);
			java.io.File file = new java.io.File(fullDataPath);
			try
			{
			  return org.apache.commons.io.FileUtils.readFileToString(file,"utf-8");
			}
			catch (Exception e)
			{
			  log.error("{}","readFile Error:",e);
			}

			return null;

		}
        /**
        *   source:msgmod.@0007.script
        */
        public boolean handle_cfad_021_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理021报文map:"+map);
			Map adminInfoMap = (Map)map.get("AdminInfo");
			List stsInfList = (List)adminInfoMap.get("StsInf");
			for(Object obj:stsInfList)
			{
			  try
			  {
			    Map stsInfMap = (Map)obj;
			    Map mmbStsInfoMap =(Map) stsInfMap.get("MmbStsInfo");
			    // 接入机构行号
			    String bnkcod=(String)mmbStsInfoMap.get("MmbId");
			    // 根据行号查找
			    MdaUtils.clear(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty());
			    Argument argument = new Argument("bnkcod",bnkcod);
			    ctx.getErrorCode();
			    Platform.mdbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty(),argument);
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      log.info("{}","查出cpxpty表的inr:"+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().getInr());
			      ctx.getDaoSession().dbBegin();
			      // 办理业务状态
			      String status=(String)mmbStsInfoMap.get("Sts");
			      // 登录状态
			      String logSts=(String)mmbStsInfoMap.get("LoginSts");
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setStatus(status);
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setLogsts(logSts);
			      ctx.getDaoSession().dbUpdate(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty());
			      ctx.getDaoSession().dbCommit();
			    }
			    else
			    {
			      log.info("{}","未查出对应的接入结构,接入结构行号bnkcod:"+bnkcod);
			      continue;
			    }
			  }
			  catch(Exception e)
			  {
			    log.error("{}",e);
			    continue;
			  }
			}
			return true;
		}
        /**
        *   source:msgmod.@0008.script
        */
        public void handle_cfad_026_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理026报文map:"+map);
			Map adminInfoMap = (Map)map.get("AdminInfo");
			List list=(List)adminInfoMap.get("ChngInf");
			for(Object obj:list)
			{
			  try
			  {
			    Map chngInfMap = (Map)obj;
			    String chngTp = (String)chngInfMap.get("ChngTp");
			    String mmbId = (String)chngInfMap.get("MmbId");
			    String mmbNmChn = (String)chngInfMap.get("MmbNmChn");
			    String mmbNmEng = (String)chngInfMap.get("MmbNmEng");
			    String cntyAndRgCd = (String)chngInfMap.get("CntyAndRgCd");
			    String dmtFlag = (String)chngInfMap.get("DmtFlag");
			    String lei = (String)chngInfMap.get("Lei");
			    String certId = (String)chngInfMap.get("CertId");
			    Date fctvDt = MdaUtils.parseDate((String)chngInfMap.get("FctvDt"),"yyyy-MM-dd");
			    String tel = (String)chngInfMap.get("Tel");
			    String adrLine = (String)chngInfMap.get("AdrLine");
			    String zipCode = (String)chngInfMap.get("ZipCode");
			    String mail = (String)chngInfMap.get("Mail");
			    String contact = (String)chngInfMap.get("Contact");

			    MdaUtils.clear(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty());
			    Argument argument = new Argument("bnkcod",mmbId);
			    ctx.getErrorCode();
			    Platform.mdbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty(),argument);
			    String inr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().getInr();

			    // 赋值
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setBnkcod(mmbId);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setChngtp(chngTp);
			    if(!MdaUtils.isEmpty(mmbNmChn))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setChnnam(mmbNmChn);
			    }
			    if(!MdaUtils.isEmpty(mmbNmEng))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setEngnam(mmbNmEng);
			    }
			    if(!MdaUtils.isEmpty(cntyAndRgCd))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setCty(cntyAndRgCd);
			    }
			    if(!MdaUtils.isEmpty(dmtFlag))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setDmtflg(dmtFlag);
			    }
			    if(!MdaUtils.isEmpty(lei))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setLei(lei);
			    }
			    if(!MdaUtils.isEmpty(certId))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setCertid(certId);
			    }
			    if(!MdaUtils.isEmpty(fctvDt))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setFctvdt(fctvDt);
			    }
			    if(!MdaUtils.isEmpty(tel))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setPtypho(tel);
			    }
			    if(!MdaUtils.isEmpty(adrLine))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setAdrlin(adrLine);
			    }
			    if(!MdaUtils.isEmpty(zipCode))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setZipcod(zipCode);
			    }
			    if(!MdaUtils.isEmpty(mail))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setMal(mail);
			    }
			    if(!MdaUtils.isEmpty(contact))
			    {
			      ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty().setContac(contact);
			    }

			    if("ADDD".equals(chngTp))
			    {
			      // 新增
			      log.info("{}","新增接入结构");
			      if(!MdaUtils.isEmpty(inr))
			      {
			        log.info("{}","该接入机构已存在，不能重复添加！");
			        continue;
			      }
			      ctx.getDaoSession().dbBegin();
			      Platform.sdbInsert(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty());
			      ctx.getDaoSession().dbCommit();

			    }

			    else if("MODI".equals(chngTp))
			    {
			      // 变更
			      log.info("{}","变更接入结构");
			      if(MdaUtils.isEmpty(inr))
			      {
			        log.info("{}","该接入机构不存在，插入数据");
			        ctx.getDaoSession().dbBegin();
			        Platform.sdbInsert(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty());
			        ctx.getDaoSession().dbCommit();
			        continue;
			      }
			      ctx.getDaoSession().dbBegin();
			      Platform.mdbUpdate(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty());
			      ctx.getDaoSession().dbCommit();
			    }

			    else if("DELE".equals(chngTp))
			    {
			      // 撤销
			      log.info("{}","撤销接入结构");
			      if(MdaUtils.isEmpty(inr))
			      {
			        log.info("{}","该接入机构不存在，不能撤销!");
			        continue;
			      }
			      ctx.getDaoSession().dbBegin();
			      Platform.mdbDelete(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpxpty(),new Argument("inr",inr));
			      ctx.getDaoSession().dbCommit();
			    }
			  }
			  catch(Exception e)
			  {
			    log.error("{}",e);
			    continue;
			  }

			}
		}
        /**
        *   source:msgmod.@0009.script
        */
        public void handle_cfad_011_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理011报文map:"+map);
			Map msgComDataMap = (Map)map.get("MsgComData");
			Map adminInfoMap=(Map)map.get("AdminInfo");
			//原系统状态
			Map sysStsInfoMap=(Map)adminInfoMap.get("SysStsInfo");

			log.info("{}","系统状态信息组件map:"+sysStsInfoMap);

			//发起机构号
			String instgPty=(String)msgComDataMap.get("InstgPty");
			//接收机构号
			String instdPty=(String)msgComDataMap.get("InstdPty");
			//报文发起时间
			Date sndDtTm=MdaUtils.parseDate((String)msgComDataMap.get("SndDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			//报文标识号
			String msgId=(String)msgComDataMap.get("MsgId");

			//系统当前状态
			String curSysSt=(String)sysStsInfoMap.get("CurSysSts");

			//公共参数变更期数
			String paramChngNb=(String)sysStsInfoMap.get("ParamChngNb");
			//附言
			String ustrd=(String)sysStsInfoMap.get("Ustrd");

			Argument argument  = new Argument("syscod","CFIX");
			ctx.getErrorCode();
			Platform.mdbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf(),argument);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.getDaoSession().dbBegin();
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setInstgpty(instgPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setInstdpty(instdPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setSndttm(sndDtTm);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setMsgid(msgId);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setCursyssts(curSysSt);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setParamchngnb(paramChngNb);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setUstrd(ustrd);
			  ctx.getDaoSession().dbUpdate(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf());
			  ctx.getDaoSession().dbCommit();
			}
			else
			{
			  ctx.getDaoSession().dbBegin();
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setInstgpty(instgPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setInstdpty(instdPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setSndttm(sndDtTm);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setMsgid(msgId);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setCursyssts(curSysSt);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setParamchngnb(paramChngNb);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setUstrd(ustrd);
			  Platform.sdbInsert(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf());
			  ctx.getDaoSession().dbCommit();
			}
		}
        /**
        *   source:msgmod.@0010.script
        */
        public boolean handle_cfad_013_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理013报文map:"+map);
			Map msgComDataMap = (Map)map.get("MsgComData");
			Map adminInfoMap = (Map)map.get("AdminInfo");
			Map sysStsInfoMap=(Map)adminInfoMap.get("SysStsInfo");
			Map orgnlGrpHdrMap=(Map)adminInfoMap.get("OrgnlGrpHdr");

			log.info("{}","系统状态信息组件map:"+sysStsInfoMap);
			log.info("{}","原报文信息组件map:"+orgnlGrpHdrMap);

			//发起机构号
			String instgPty=(String)msgComDataMap.get("InstgPty");
			//接收机构号
			String instdPty=(String)msgComDataMap.get("InstdPty");
			//报文发起时间
			//Date sndDtTm=(Date)msgComDataMap.get("SndDtTm");
			Date sndDtTm=MdaUtils.parseDate((String)msgComDataMap.get("SndDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			//报文标识号
			String msgId=(String)msgComDataMap.get("MsgId");

			//原报文标识号
			String orgnlMsgId=(String)orgnlGrpHdrMap.get("OrgnlMsgId");
			//原发起参与机构
			String orgnlInstgPty=(String)orgnlGrpHdrMap.get("OrgnlInstgPty");
			//原报文机构
			String orgnlMT=(String)orgnlGrpHdrMap.get("OrgnlMT");

			//系统当前状态
			String curSysSt=(String)sysStsInfoMap.get("CurSysSts");
			//公共参数变更期数
			String paramChngNb=(String)sysStsInfoMap.get("ParamChngNb");
			//附言
			String ustrd=(String)sysStsInfoMap.get("Ustrd");

			Argument argument  = new Argument("syscod","CFIX");
			ctx.getErrorCode();
			Platform.mdbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf(),argument);
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.getDaoSession().dbBegin();
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setInstgpty(instgPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setInstdpty(instdPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setSndttm(sndDtTm);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setMsgid(msgId);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setOrgnlmsgid(orgnlMsgId);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setOrgnlinstgpty(orgnlInstgPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setOrgnlmt(orgnlMT);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setCursyssts(curSysSt);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setParamchngnb(paramChngNb);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setUstrd(ustrd);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setSyscod("CFIX");
			  Platform.sdbInsert(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf());
			  ctx.getDaoSession().dbCommit();
			  return true;
			}
			else
			{
			  ctx.getDaoSession().dbBegin();
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setInstgpty(instgPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setInstdpty(instdPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setSndttm(sndDtTm);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setMsgid(msgId);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setOrgnlmsgid(orgnlMsgId);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setOrgnlinstgpty(orgnlInstgPty);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setOrgnlmt(orgnlMT);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setCursyssts(curSysSt);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setParamchngnb(paramChngNb);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setUstrd(ustrd);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf().setSyscod("CFIX");
			  ctx.getDaoSession().dbUpdate(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSysinf());
			  ctx.getDaoSession().dbCommit();
			  return true;
			}
		}
        /**
        *   source:msgmod.@0011.script
        */
        public String create_msg_998(String instgpty, String instdpty, String msgid, String ref, String msgcntt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 组装自由格式报文
			com.brilliance.jrxx.packet.model.cfcm_998_001_01.Cfcm_998_001_01 cfcm_998_001_01 = new com.brilliance.jrxx.packet.model.cfcm_998_001_01.Cfcm_998_001_01();
			// 组装报文头
			this.fillHead(cfcm_998_001_01, "cfcm.998.001.01");
			// 组装报文体
			com.brilliance.jrxx.packet.model.cfcm_998_001_01.MsgComData msgComData = new com.brilliance.jrxx.packet.model.cfcm_998_001_01.MsgComData();
			msgComData.InstgPty = instgpty;
			msgComData.InstdPty = instdpty;
			msgComData.SndDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd HH:mm:ss");
			msgComData.MsgId = msgid;
			cfcm_998_001_01.MsgComData = msgComData;
			com.brilliance.jrxx.packet.model.cfcm_998_001_01.FreeFrmtInf freeFrmtInf = new com.brilliance.jrxx.packet.model.cfcm_998_001_01.FreeFrmtInf();
			freeFrmtInf.MsgCntt = msgcntt;
			com.brilliance.jrxx.packet.model.cfcm_998_001_01.AdminInfo adminInfo = new com.brilliance.jrxx.packet.model.cfcm_998_001_01.AdminInfo();
			adminInfo.Ref = ref;
			adminInfo.FreeFrmtInf = freeFrmtInf;
			cfcm_998_001_01.AdminInfo = adminInfo;
			String json998 = com.alibaba.fastjson.JSON.toJSONString(cfcm_998_001_01);
			return json998;
		}
        /**
        *   source:msgmod.@0012.script
        */
        public String create_cfad_020_001_01(List list,String instgpaty)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理020报文bnkcodlist:"+list);
			// 组装报文
			com.brilliance.jrxx.packet.model.cfad_020_001_01.Cfad_020_001_01  cfad_020_001_01 = new com.brilliance.jrxx.packet.model.cfad_020_001_01.Cfad_020_001_01();

			// 组装报文头
			this.fillHead(cfad_020_001_01, "cfad.020.001.01");
			// 组装报文体
			com.brilliance.jrxx.packet.model.cfad_020_001_01.MsgComData msgComData = new com.brilliance.jrxx.packet.model.cfad_020_001_01.MsgComData();
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			String propertyPath = MdaUtils.catPath(path,"rcvsndmsg.properties");
			msgComData.InstgPty =MdaUtils.getPropertyValue(propertyPath,"OrigSender");
			msgComData.InstdPty = instgpaty;
			msgComData.SndDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd HH:mm:ss");
			msgComData.MsgId = this.mkMsgId();
			cfad_020_001_01.MsgComData = msgComData;

			com.brilliance.jrxx.packet.model.cfad_020_001_01.AdminInfo adminInfo = new com.brilliance.jrxx.packet.model.cfad_020_001_01.AdminInfo();
			com.brilliance.jrxx.packet.model.cfad_020_001_01.InqMmbList inqMmbList = new com.brilliance.jrxx.packet.model.cfad_020_001_01.InqMmbList();
			adminInfo.InqMmbCnt=String.valueOf(list.size());
			inqMmbList.MmbCd=list;
			adminInfo.InqMmbList=inqMmbList;

			cfad_020_001_01.AdminInfo = adminInfo;
			String json020 = com.alibaba.fastjson.JSON.toJSONString(cfad_020_001_01);
			log.info("{}","组装的json020:"+json020);
			return json020;
		}
        /**
        *   source:msgmod.@0013.script
        */
        public boolean handle_cfcm_002_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理002报文map:"+map);
			Map msgComDataMap = (Map)map.get("MsgComData");
			String instgPty=(String)msgComDataMap.get("InstgPty");
			String instdPty=(String)msgComDataMap.get("InstdPty");
			Date sndDtTm=MdaUtils.parseDate((String)msgComDataMap.get("SndDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			String msgId=(String)msgComDataMap.get("MsgId");

			Map prtryDataMap = (Map)map.get("PrtryData");

			Map msgBizDataMap = (Map)prtryDataMap.get("MsgBizData");
			String sID = (String)msgBizDataMap.get("SID");
			String msgTp = (String)msgBizDataMap.get("MsgTp");
			String txTpCd = (String)msgBizDataMap.get("TxTpCd");
			String ctgyPurpCd = (String)msgBizDataMap.get("CtgyPurpCd");

			Map orgnSndInfoMap = (Map)prtryDataMap.get("OrgnSndInfo");
			String orgnlMsgId = (String)orgnSndInfoMap.get("OrgnlMsgId");
			String orgnlInstgPty = (String)orgnSndInfoMap.get("OrgnlInstgPty");
			String orgnInstdPty = (String)orgnSndInfoMap.get("OrgnInstdPty");
			Date orgnSndDtTm = MdaUtils.parseDate((String)orgnSndInfoMap.get("OrgnSndDtTm"),"yyyy-MM-dd'T'HH:mm:ss");

			String stsCd = (String)prtryDataMap.get("StsCd");
			String prcMsgDig = (String)prtryDataMap.get("PrcMsgDig");
			String pspMsg = (String)prtryDataMap.get("RspMsg");

			MdaUtils.clear(this.getMpi());
			Argument argument = new Argument("msgid",orgnlMsgId);
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.info("{}","查出mpi表的inr:"+this.getMpi().getInr());
			  ctx.getDaoSession().dbBegin();
			  this.getMpi().setSid( sID);
			  this.getMpi().setMtp( msgTp);
			  this.getMpi().setTxtpcd( txTpCd);
			  this.getMpi().setCtgpcd( ctgyPurpCd);
			  this.getMpi().setOrgmid( orgnlMsgId);
			  this.getMpi().setOrginspty( orgnlInstgPty);
			  this.getMpi().setOrginapty( orgnInstdPty);
			  this.getMpi().setOrgsnddat( orgnSndDtTm);
			  this.getMpi().setStscod( stsCd);
			  this.getMpi().setPrcmsgdig( prcMsgDig);
			  this.getMpi().setRspmsg( pspMsg);
			  ctx.getDaoSession().dbUpdate(this.getMpi());
			  ctx.getDaoSession().dbCommit();
			  return true;
			}
			else
			{
			  ctx.getDaoSession().dbRollback();
			  log.info("{}","未查出对应的原报文msgId:"+orgnlMsgId);
			  return false;
			}

		}
        /**
        *   source:msgmod.@0014.script
        */
        public boolean handle_cfcm_302_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理302报文map:"+map);
			Map grpHdrMap = (Map)map.get("GrpHdr");
			String msgId = (String)grpHdrMap.get("MsgId");
			Date creDtTm = MdaUtils.parseDate((String)grpHdrMap.get("CreDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			Map instgPtyMap = (Map)grpHdrMap.get("InstgPty");
			String instgDrctPty = (String)instgPtyMap.get("InstgDrctPty");
			String instgDrctPtyLei = (String)instgPtyMap.get("InstgDrctPtyLei");
			String instgPty = (String)instgPtyMap.get("InstgPty");
			String instgPtyLei = (String)instgPtyMap.get("InstgPtyLei");
			Map instdPtyMap = (Map)grpHdrMap.get("InstdPty");
			String instdDrctPty = (String)instdPtyMap.get("InstdDrctPty");
			String instdDrctPtyLei = (String)instdPtyMap.get("InstdDrctPtyLei");
			String instdPty = (String)instdPtyMap.get("InstdPty");
			String instdPtyLei = (String)instdPtyMap.get("InstdPtyLei");
			String sysCd = (String)grpHdrMap.get("SysCd");
			String rmk = (String)grpHdrMap.get("Rmk");

			Map orgnlGrpHdrMap = (Map)map.get("OrgnlGrpHdr");
			String orgnlMsgId = (String)orgnlGrpHdrMap.get("OrgnlMsgId");
			String orgnlInstgPty = (String)orgnlGrpHdrMap.get("OrgnlInstgPty");
			String orgnlMT = (String)orgnlGrpHdrMap.get("OrgnlMT");

			Map rspnInfMap = (Map)map.get("RspnInf");
			String prcSts = (String)rspnInfMap.get("PrcSts");
			String prcCd = (String)rspnInfMap.get("PrcCd");
			String rjctInf = (String)rspnInfMap.get("RjctInf");
			Date sttlmDt = MdaUtils.parseDate((String)rspnInfMap.get("SttlmDt"),"yyyy-MM-dd");
			Date rcvTm = MdaUtils.parseDate((String)rspnInfMap.get("RcvTm"),"yyyy-MM-dd'T'HH:mm:ss");
			Date trnsmtTm = MdaUtils.parseDate((String)rspnInfMap.get("TrnsmtTm"),"yyyy-MM-dd'T'HH:mm:ss");

			Map bizStsQryRspnInfMap = (Map)map.get("BizStsQryRspnInf");
			Map orgnlInfMap = (Map)bizStsQryRspnInfMap.get("OrgnlInf");
			Map orgnlQrpGrpHdrMap = (Map)orgnlInfMap.get("OrgnlQrpGrpHdr");
			String orgnlQrpMsgId = (String)orgnlQrpGrpHdrMap.get("OrgnlMsgId");
			String orgnlQrpInstgPty = (String)orgnlQrpGrpHdrMap.get("OrgnlInstgPty");
			String orgnlQrpMT = (String)orgnlQrpGrpHdrMap.get("OrgnlMT");

			Map dvpRspnInfMap = (Map)bizStsQryRspnInfMap.get("DvpRspnInf");
			String oribiztype = (String)dvpRspnInfMap.get("Oribiztype");
			Date oriAcctdate = MdaUtils.parseDate((String)dvpRspnInfMap.get("OriAcctdate"),"yyyy-MM-dd");
			String msgprcsts = (String)dvpRspnInfMap.get("Msgprcsts");
			String opInfo = (String)dvpRspnInfMap.get("OpInfo");
			Date acctdate = MdaUtils.parseDate((String)dvpRspnInfMap.get("Acctdate"),"yyyy-MM-dd");

			Map pubInstnMpmtRspnInfMap = (Map)bizStsQryRspnInfMap.get("PubInstnMpmtRspnInf");
			String txSts = (String)pubInstnMpmtRspnInfMap.get("TxSts");
			String bllPaySts = (String)pubInstnMpmtRspnInfMap.get("BllPaySts");

			String remarmk = (String)bizStsQryRspnInfMap.get("Rmk");

			MdaUtils.clear(this.getMpi());
			Argument argument = new Argument("msgid",orgnlMsgId);
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.info("{}","查出mpi表的inr:"+this.getMpi().getInr());
			  ctx.getDaoSession().dbBegin();
			  this.getMpi().setMid( msgId);
			  this.getMpi().setCredat( creDtTm);
			  this.getMpi().setInsgdp( instgDrctPty);
			  this.getMpi().setInsdpl( instgDrctPtyLei);
			  this.getMpi().setInsgty( instgPty);
			  this.getMpi().setInsgpl( instgPtyLei);
			  this.getMpi().setInsddp( instdDrctPty);
			  this.getMpi().setInsddl( instdDrctPtyLei);
			  this.getMpi().setInsdty( instdPty);
			  this.getMpi().setInspdl( instdPtyLei);
			  this.getMpi().setSyscod( sysCd);
			  this.getMpi().setRmk( rmk);
			  this.getMpi().setOrgmid( orgnlMsgId);
			  this.getMpi().setOrginspty( orgnlInstgPty);
			  this.getMpi().setOrgmsgtyp( orgnlMT);

			  this.getMpi().setPrcsts( prcSts);
			  this.getMpi().setProccd( prcCd);
			  this.getMpi().setRjcinf( rjctInf);
			  this.getMpi().setSstdat( sttlmDt);
			  this.getMpi().setRcvdat( rcvTm);
			  this.getMpi().setTrndat( trnsmtTm);
			  this.getMpi().setOrpmid( orgnlQrpMsgId);
			  this.getMpi().setOrpinspty( orgnlQrpInstgPty);
			  this.getMpi().setOrpinapty( orgnlQrpMT);
			  this.getMpi().setOrityp( oribiztype);
			  this.getMpi().setOridat( oriAcctdate);
			  this.getMpi().setOrists( msgprcsts);
			  this.getMpi().setOpinfo( opInfo);
			  this.getMpi().setOriaccdat( acctdate);
			  this.getMpi().setTrasts( txSts);
			  this.getMpi().setBllpaysts( bllPaySts);
			  this.getMpi().setRemark( remarmk);
			  ctx.getDaoSession().dbUpdate(this.getMpi());
			  ctx.getDaoSession().dbCommit();
			  return true;
			}
			else
			{
			  ctx.getDaoSession().dbRollback();
			  log.info("{}","未查出对应的原报文msgId:"+orgnlMsgId);
			  return false;
			}

		}
        /**
        *   source:msgmod.@0015.script
        */
        public boolean handle_cfad_042_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理042报文map:"+map);
			Map adminInfoMap = (Map)map.get("AdminInfo");
			List list = (List)adminInfoMap.get("CertfctnInfo");
			for(Object obj:list)
			{
			  try
			  {
			    Map certfctnInfoMap = (Map)obj;
			    //接入机构行号
			    String cfixbankcode = (String)certfctnInfoMap.get("MmbCd");
			    //根据行号查找
			    MdaUtils.clear(this.getCsn());
			    //Argument argument = new Argument("cfixbankcode",cfixbankcode);
			    ctx.getErrorCode();
			    Platform.mdbRead(this.getCsn(),new Argument<String>("cfixbankcode",cfixbankcode),new Argument<String>("csntyp","3"));
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      log.info("{}","查出csn表的inr:"+this.getCsn().getInr());
			      //证书签名
			      String certfctnSgntr = (String)certfctnInfoMap.get("CertfctnSgntr");
			      //Base64
			      String sql = "select docbase64 from (select t3.docbase64 from mps t1 inner join mpi t2 on t1.inr = t2.inr and t2.SUBTYP = 'cfad.040.001.01' inner join smh t3 on t1.smhinr = t3.inr where t1.dir = '<' and t1.sta = 'D' order by t1.LSTDATTIM desc ) re where rownum = 1";
			      Argument docbase64Arg = new Argument<String>("docbase64");
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      if(ctx.getErrorCode() != NO_ERROR)
			      {
			        log.debug("{}","没有绑定证书");
			      }
			      ctx.getDaoSession().dbFetchFields(docbase64Arg);
			      // 最新发送成功的040的xml报文经过base64加密后的值
			      String sendedInfo040 = (String)docbase64Arg.getValue();
			      ctx.getDaoSession().dbCloseCursor();
			      // com.brilliance.jrxx.framework.Result result040 = com.brilliance.jrxx.utils.MsgUtil.unPackMessage(certfctnSgntr);
			      log.info("{}","sendedInfo040=========="+sendedInfo040);
			      log.info("{}","certfctnSgntr=========="+certfctnSgntr);
			      boolean flag = (sendedInfo040.trim()).equals(certfctnSgntr.trim());
			      log.info("{}","flag========"+flag);
			      com.brilliance.jrxx.framework.Result result040 = com.brilliance.jrxx.utils.MsgUtil.unPackMessage(certfctnSgntr);
			      if(result040.isSuccess())
			      {
			        //成功，sta=02
			        ctx.getDaoSession().dbBegin();
			        this.getCsn().setSta( "02");
			        ctx.getDaoSession().dbUpdate(this.getCsn());
			        ctx.getDaoSession().dbCommit();

			      }
			      else
			      {
			        //失败，sta=49
			        ctx.getDaoSession().dbBegin();
			        this.getCsn().setSta( "49");
			        ctx.getDaoSession().dbUpdate(this.getCsn());
			        ctx.getDaoSession().dbCommit();
			      }
			    }
			    else
			    {
			      log.info("{}","未查出对应的接入结构,接入结构行号cfixbankcode:"+cfixbankcode);
			      continue;
			    }
			  }
			  catch(Exception e)
			  {
			    log.error("{}",e);
			    continue;
			  }
			}
			return true;
		}
        /**
        *   source:msgmod.@0016.script
        */
        public boolean handle_cfad_051_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理051报文Map：" + map);
			Map admininfoMap = (Map)map.get("AdminInfo");
			Map loginRspInfMap = (Map)admininfoMap.get("LoginRspnInf");
			String curSysStaStr = (String)loginRspInfMap.get("CurSysSts");
			String prcStsStr = (String)loginRspInfMap.get("PrcSts");
			String prcCodeNInfStr = (String)loginRspInfMap.get("PrcCdAndInf");
			Map orgnlGrpInf = (Map)admininfoMap.get("OrgnlGrpInf");
			String orgnlMsgId=(String)orgnlGrpInf.get("OrgnlMsgId");

			MdaUtils.clear(this.getMpi());
			Argument argument = new Argument("msgid",orgnlMsgId);
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.info("{}","查出mpi表的inr:"+this.getMpi().getInr());
			  ctx.getDaoSession().dbBegin();

			  this.getMpi().setSubtyp( "cfad.051.001.01");
			  this.getMpi().setCursyssts( curSysStaStr);
			  this.getMpi().setPrcsts( prcStsStr);
			  this.getMpi().setPrccod( prcCodeNInfStr);
			  Platform.mdbUpdate(this.getMpi());
			  ctx.getDaoSession().dbCommit();
			  return true;

			}
			else
			{
			  log.info("{}","未查出mpi表的数据msgId:"+orgnlMsgId);
			  return false;
			}
		}
        /**
        *   source:msgmod.@0017.script
        */
        public void handle_cfad_040_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理040报文map"+map);
			Map adminInfomap = (Map)map.get("AdminInfo");
			Map certNtfctnInfmap = (Map)adminInfomap.get("CertNtfctnInf");

			//获取变更接入机构行号
			String cfixbankcode = (String)certNtfctnInfmap.get("MmbId");
			//获取变更类型
			String chgTp = (String)certNtfctnInfmap.get("ChgTp");

			//判断变更类型
			if(chgTp.equals("ADDD"))
			{
			  ctx.getDaoSession().dbBegin();
			  this.getCsn().setCfixbankcode( cfixbankcode);
			  this.getCsn().setCsntyp( "1");
			  this.getCsn().setSta( "48");
			  this.getCsn().setGendat( MdaUtils.today());
			  this.getCsn().setRem( "接收数字证书行号绑定关系变更通知报文");
			  this.getCsn().setTyp( "0");
			  Platform.sdbInsert(this.getCsn());
			  ctx.getDaoSession().dbCommit();
			}
			else if(chgTp.equals("DELE"))
			{
			  ctx.getDaoSession().dbBegin();
			  this.getCsn().setCfixbankcode( cfixbankcode);
			  this.getCsn().setCsntyp( "2");
			  this.getCsn().setSta( "48");
			  this.getCsn().setGendat( MdaUtils.today());
			  this.getCsn().setRem( "接收数字证书行号绑定关系变更通知报文");
			  this.getCsn().setTyp( "0");
			  Platform.sdbInsert(this.getCsn());
			  ctx.getDaoSession().dbCommit();
			}

		}
        /**
        *   source:msgmod.@0018.script
        */
        public void handle_cfcm_003_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理003报文map:"+map);
			Map msgComDataMap = (Map)map.get("MsgComData");
			String instgPty=(String)msgComDataMap.get("InstgPty");
			String instdPty=(String)msgComDataMap.get("InstdPty");
			Date sndDtTm=MdaUtils.parseDate((String)msgComDataMap.get("SndDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			String msgId=(String)msgComDataMap.get("MsgId");

			Map prtryDataMap = (Map)map.get("PrtryData");
			String envMsgTp = (String)prtryDataMap.get("EnvMsgTp");
			String msgCont = (String)prtryDataMap.get("MsgCont");

			MdaUtils.clear(this.getMpi());
			Argument argument = new Argument("msgid",msgId);
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.info("{}","查出mpi表的inr:"+this.getMpi().getInr());
			  ctx.getDaoSession().dbBegin();
			  this.getMpi().setEnvmsgtyp( envMsgTp);
			  this.getMpi().setMsgcnt( msgCont);
			  ctx.getDaoSession().dbUpdate(this.getMpi());
			  ctx.getDaoSession().dbCommit();
			}
			else
			{
			  ctx.getDaoSession().dbRollback();
			  log.info("{}","未查出对应的报文msgId:"+msgId);
			}

		}
        /**
        *   source:msgmod.@0019.script
        */
        public void handle_cfcm_001_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理001报文map:"+map);
			Map msgComDataMap = (Map)map.get("MsgComData");
			String instgPty=(String)msgComDataMap.get("InstgPty");
			String instdPty=(String)msgComDataMap.get("InstdPty");
			Date sndDtTm=MdaUtils.parseDate((String)msgComDataMap.get("SndDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			String msgId=(String)msgComDataMap.get("MsgId");

			Map prtryDataMap = (Map)map.get("PrtryData");
			Map msgBizDataMap = (Map)prtryDataMap.get("MsgBizData");
			String sID = (String)msgBizDataMap.get("SID");
			String msgTp = (String)msgBizDataMap.get("MsgTp");
			String txTpCd = (String)msgBizDataMap.get("TxTpCd");
			String ctgyPurpCd = (String)msgBizDataMap.get("CtgyPurpCd");

			String msgCont = (String)prtryDataMap.get("MsgCont");

			MdaUtils.clear(this.getMpi());
			Argument argument = new Argument("msgid",msgId);
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument);
			log.info("{}","发送002应答报文...");
			// 发送002报文
			String cfcm_002_001_01 = this.create_cfcm_002_001_01(map);
			if ("".equals(cfcm_002_001_01))
			{
			  return;
			}
			MdaUtils.clear(this.getFil());
			IStream is_002 = this.getFil();
			try
			{
			  is_002.getOutputStream().write(cfcm_002_001_01.getBytes("UTF-8"));//将报文存入流
			}
			catch (java.io.IOException e)
			{
			  return;
			}
			if (!this.createMessageProcessSubject(is_002, "HWE", "json","CPX",  "002应答报文"))
			{
			  log.debug("{}","002报文保存失败");
			  return;
			}
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.info("{}","查出mpi表的inr:"+this.getMpi().getInr());
			  ctx.getDaoSession().dbBegin();
			  this.getMpi().setSid( sID);
			  this.getMpi().setMtp( msgTp);
			  this.getMpi().setTxtpcd( txTpCd);
			  this.getMpi().setCtgpcd( ctgyPurpCd);
			  this.getMpi().setMsgcnt( msgCont);
			  ctx.getDaoSession().dbUpdate(this.getMpi());
			  ctx.getDaoSession().dbCommit();
			}
			else
			{
			  ctx.getDaoSession().dbRollback();
			  log.info("{}","未查出对应的报文msgId:"+msgId);
			}

		}
        /**
        *   source:msgmod.@0020.script
        */
        public void handle_cfcm_301_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始处理301报文map:"+map);
			Map grpHdrMap = (Map)map.get("GrpHdr");
			String msgId = (String)grpHdrMap.get("MsgId");
			Date creDtTm=MdaUtils.parseDate((String)grpHdrMap.get("CreDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			Map instgPtyMap = (Map)grpHdrMap.get("InstgPty");
			String instgDrctPty = (String)instgPtyMap.get("InstgDrctPty");
			String instgDrctPtyLei = (String)instgPtyMap.get("InstgDrctPtyLei");
			String instgPty = (String)instgPtyMap.get("InstgPty");
			String instgPtyLei = (String)instgPtyMap.get("InstgPtyLei");
			Map instdPtyMap = (Map)grpHdrMap.get("InstdPty");
			String instdDrctPty = (String)instdPtyMap.get("InstdDrctPty");
			String instdDrctPtyLei = (String)instdPtyMap.get("InstdDrctPtyLei");
			String instdPty = (String)instdPtyMap.get("InstdPty");
			String instdPtyLei = (String)instdPtyMap.get("InstdPtyLei");
			String sysCd = (String)grpHdrMap.get("SysCd");
			String rmk = (String)grpHdrMap.get("Rmk");

			Map orgnlGrpHdrMap = (Map)map.get("OrgnlGrpHdr");
			String orgnlMsgId = (String)orgnlGrpHdrMap.get("OrgnlMsgId");
			String orgnlInstgPty = (String)orgnlGrpHdrMap.get("OrgnlInstgPty");
			String orgnlMT = (String)orgnlGrpHdrMap.get("OrgnlMT");

			MdaUtils.clear(this.getMpi());
			Argument argument = new Argument("msgid",msgId);
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument);
			log.info("{}","发送302应答报文...");
			// 发送302报文
			String cfcm_302_001_01 = this.create_cfcm_302_001_01(map);
			if ("".equals(cfcm_302_001_01))
			{
			  return;
			}
			MdaUtils.clear(this.getFil());
			IStream is_302 = this.getFil();
			try
			{
			  is_302.getOutputStream().write(cfcm_302_001_01.getBytes("UTF-8"));//将报文存入流
			}
			catch (java.io.IOException e)
			{
			  return;
			}
			if (!this.createMessageProcessSubject(is_302, "HWE", "json","CPX",  "302应答报文"))
			{
			  log.debug("{}","302报文保存失败");
			  return;
			}
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.info("{}","查出mpi表的inr:"+this.getMpi().getInr());
			  ctx.getDaoSession().dbBegin();
			  this.getMpi().setCredat( creDtTm);
			  this.getMpi().setInsgdp( instgDrctPty);
			  this.getMpi().setInsdpl( instgDrctPtyLei);
			  this.getMpi().setInsgty( instgPty);
			  this.getMpi().setInsgpl( instgPtyLei);
			  this.getMpi().setInsddp( instdDrctPty);
			  this.getMpi().setInsddl( instdDrctPtyLei);
			  this.getMpi().setInsdty( instdPty);
			  this.getMpi().setInspdl( instdPtyLei);
			  this.getMpi().setSyscod( sysCd);
			  this.getMpi().setRmk( rmk);
			  this.getMpi().setOrgmid( orgnlMsgId);
			  this.getMpi().setOrginspty( orgnlInstgPty);
			  this.getMpi().setOrgmsgtyp( orgnlMT);
			  ctx.getDaoSession().dbUpdate(this.getMpi());
			  ctx.getDaoSession().dbCommit();
			}
			else
			{
			  ctx.getDaoSession().dbRollback();
			  log.info("{}","未查出对应的报文msgId:"+msgId);
			}
		}
        /**
        *   source:msgmod.@0021.script
        */
        public String create_cfcm_002_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始发送即时信息应答报文");
			com.brilliance.jrxx.packet.model.cfcm_002_001_01.Cfcm_002_001_01 cfcm_002_001_01 = new com.brilliance.jrxx.packet.model.cfcm_002_001_01.Cfcm_002_001_01();
			// 组装报文头
			this.fillHead(cfcm_002_001_01, "cfcm.002.001.01");
			// 组装报文体
			com.brilliance.jrxx.packet.model.cfcm_002_001_01.MsgComData msgComData = this.createMsgComData(cfcm_002_001_01);
			cfcm_002_001_01.MsgComData = msgComData;

			com.brilliance.jrxx.packet.model.cfcm_002_001_01.PrtryData prtryData = new com.brilliance.jrxx.packet.model.cfcm_002_001_01.PrtryData();

			com.brilliance.jrxx.packet.model.cfcm_002_001_01.MsgBizData msgBizData = new com.brilliance.jrxx.packet.model.cfcm_002_001_01.MsgBizData();
			//空值暂定
			msgBizData.SID = "";
			msgBizData.MsgTp = "";
			msgBizData.TxTpCd = "";
			msgBizData.CtgyPurpCd = "";
			prtryData.MsgBizData = msgBizData;

			com.brilliance.jrxx.packet.model.cfcm_002_001_01.OrgnSndInfo orgnSndInfo = new com.brilliance.jrxx.packet.model.cfcm_002_001_01.OrgnSndInfo();
			orgnSndInfo.OrgnlMsgId = "";
			orgnSndInfo.OrgnlInstgPty = "";
			orgnSndInfo.OrgnInstdPty = "";
			orgnSndInfo.OrgnSndDtTm = "";
			prtryData.OrgnSndInfo = orgnSndInfo;

			prtryData.StsCd = "SUCD";
			prtryData.PrcMsgDig = "STD/PM4I0000";
			prtryData.RspMsg = "";

			cfcm_002_001_01.PrtryData = prtryData;
			String json = com.alibaba.fastjson.JSON.toJSONString(cfcm_002_001_01);
			log.debug("{}",json);
			return json;
		}
        /**
        *   source:msgmod.@0022.script
        */
        public String create_cfcm_302_001_01(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始发送业务状态查询应答报文");
			//组装报文
			com.brilliance.jrxx.packet.model.cfcm_302_001_01.Cfcm_302_001_01 cfcm_302_001_01 = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.Cfcm_302_001_01();
			//组装报文头
			this.fillHead(cfcm_302_001_01, "cfcm_302_001_01");
			//组装报文体
			com.brilliance.jrxx.packet.model.cfcm_302_001_01.GrpHdr grpHdr = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.GrpHdr();
			cfcm_302_001_01.GrpHdr = grpHdr;
			grpHdr.MsgId = "";
			grpHdr.CreDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd'T'HH:mm:ss");

			com.brilliance.jrxx.packet.model.cfcm_302_001_01.InstgPty instgPty = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.InstgPty();
			//空值暂定
			grpHdr.InstgPty = instgPty;
			instgPty.InstgDrctPty = "";
			instgPty.InstgDrctPtyLei = "";
			instgPty.InstgPty = "";
			instgPty.InstgPtyLei = "";

			com.brilliance.jrxx.packet.model.cfcm_302_001_01.InstdPty instdPty = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.InstdPty();
			grpHdr.InstdPty = instdPty;
			instdPty.InstdDrctPty = "";
			instdPty.InstdDrctPtyLei = "";
			instdPty.InstdPty = "";
			instdPty.InstdPtyLei = "";
			grpHdr.SysCd = "CFIX";
			grpHdr.Rmk = "";

			com.brilliance.jrxx.packet.model.cfcm_302_001_01.OrgnlGrpHdr orgnlGrpHdr = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.OrgnlGrpHdr();
			cfcm_302_001_01.OrgnlGrpHdr = orgnlGrpHdr;
			orgnlGrpHdr.OrgnlMsgId = "";
			orgnlGrpHdr.OrgnlInstgPty = "";
			orgnlGrpHdr.OrgnlMT = "";

			com.brilliance.jrxx.packet.model.cfcm_302_001_01.RspnInf rspnInf = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.RspnInf();
			cfcm_302_001_01.RspnInf = rspnInf;
			rspnInf.PrcSts = "";
			rspnInf.PrcCd = "";
			rspnInf.RjctInf = "";
			rspnInf.SttlmDt = "";
			rspnInf.RcvTm = "";
			rspnInf.TrnsmtTm = "";

			com.brilliance.jrxx.packet.model.cfcm_302_001_01.BizStsQryRspnInf bizStsQryRspnInf = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.BizStsQryRspnInf();
			cfcm_302_001_01.BizStsQryRspnInf = bizStsQryRspnInf;

			com.brilliance.jrxx.packet.model.cfcm_302_001_01.OrgnlInf orgnlInf = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.OrgnlInf();
			bizStsQryRspnInf.OrgnlInf = orgnlInf;
			com.brilliance.jrxx.packet.model.cfcm_302_001_01.OrgnlQrpGrpHdr orgnlQrpGrpHdr = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.OrgnlQrpGrpHdr();
			orgnlInf.OrgnlQrpGrpHdr = orgnlQrpGrpHdr;
			orgnlQrpGrpHdr.OrgnlMsgId = "";
			orgnlQrpGrpHdr.OrgnlInstgPty = "";
			orgnlQrpGrpHdr.OrgnlMT = "";

			com.brilliance.jrxx.packet.model.cfcm_302_001_01.DvpRspnInf dvpRspnInf = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.DvpRspnInf();
			bizStsQryRspnInf.DvpRspnInf = dvpRspnInf;
			dvpRspnInf.Oribiztype = "";
			dvpRspnInf.OriAcctdate = "";
			dvpRspnInf.Msgprcsts = "";
			dvpRspnInf.OpInfo = "";
			dvpRspnInf.Acctdate = "";

			com.brilliance.jrxx.packet.model.cfcm_302_001_01.PubInstnMpmtRspnInf pubInstnMpmtRspnInf = new com.brilliance.jrxx.packet.model.cfcm_302_001_01.PubInstnMpmtRspnInf();
			bizStsQryRspnInf.PubInstnMpmtRspnInf = pubInstnMpmtRspnInf;
			pubInstnMpmtRspnInf.TxSts = "";
			pubInstnMpmtRspnInf.BllPaySts = "";

			bizStsQryRspnInf.Rmk = "";
			String json = com.alibaba.fastjson.JSON.toJSONString(cfcm_302_001_01);
			log.debug("{}",json);
			return json;
		}
        /**
        *   source:msgmod.@0023.script
        */
        public boolean createMessageProcessSubject(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			log.info("{}","smpmod test log");
			/*
			  Platform.esdbRead($chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			readChn(this.getChn(),channel);

			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}
			/*
			  Platform.mdbBegin();
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }*/
			int errorcode = ctx.getErrorCode();
			log.debug("{}","before mdbBegin");
			Platform.mdbBegin();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");
			/// 保存收发报处理主记录信息(MPS)
			log.info("{}","chn\typ="+this.getChn().getTyp());
			log.info("{}","tgtchn\typ="+this.getTgtchn().getTyp());
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "A"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			Platform.sdbInsert(this.getMps());
			errorcode = ctx.getErrorCode();
			log.info("{}","mps insert error code="+errorcode);
			if(errorcode != NO_ERROR)
			{
			  log.info("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "A"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;
			if("cfix|xml".contains(messageType))
			{
			  fileName = getCipsStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getCipsdatapath());
			}
			else
			  fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			log.info("{}","smpmod dbCommit...");
			Platform.mdbCommit();
			return true;
		}
        /**
        *   source:msgmod.@0024.script
        */
        public String getStoreFileFullPathName(String fileName, String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(fileName==null||fileType==null) return null;
			else
			{
			  return MdaUtils.catPath(this.getFulldatapath(),fileName.substring(0,4)+"/"+fileName+"." + fileType);
			}
		}
        /**
        *   source:msgmod.@0025.script
        */
        public void readChn(com.ceb.gjjs.mda.bo.Chn chn,String channel)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map chnmap = null;
			com.ceb.gjjs.mda.bo.Chn tmpchn = null;
			synchronized(this)
			{
			  if(MdaUtils.isEmpty(this.getChnmap()))
			  {
			    chnmap=new HashMap();
			  }
			  else
			  {
			    chnmap=this.getChnmap();
			    tmpchn=(com.ceb.gjjs.mda.bo.Chn)chnmap.get(channel);
			  }
			  if(tmpchn==null)
			  {
			    tmpchn = new Chn();
			    Platform.esdbRead(tmpchn,new Argument("cod",channel));
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      MdaUtils.clear(chn);
			      return;
			    }
			    chnmap.put(channel,tmpchn);
			    this.setChnmap(chnmap);
			  }
			}
			chn.copyValues(tmpchn);
		}
        /**
        *   source:msgmod.@0026.script
        */
        public String getCipsStoreFileFullPathName(String fileName, String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(fileName==null||fileType==null) return null;
			else
			{
			  return MdaUtils.catPath(this.getCipsfulldatapath(),fileName.substring(0,4)+"/"+fileName+"." + fileType);
			}
		}
        /**
        *   source:msgmod.@0027.script
        */
        public com.brilliance.jrxx.packet.model.cfcm_002_001_01.MsgComData createMsgComData(com.brilliance.jrxx.packet.model.com.Elcs elcs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			com.brilliance.jrxx.packet.model.cfcm_002_001_01.MsgComData msgComData = new com.brilliance.jrxx.packet.model.cfcm_002_001_01.MsgComData();
			msgComData.InstgPty = elcs.OrigSender;
			msgComData.InstdPty = elcs.OrigReceiver;
			msgComData.SndDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd'T'HH:mm:ss");
			msgComData.MsgId = elcs.MesgID;
			return msgComData;
		}






















}