package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Mtabut extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Mtabut.class);

        //提交
        private IControl sav;

        //暂存
        private IControl ped;

        //提交
        private IControl submit;

        //交易数据流
        private IStream trnstm = new StreamImpl();

        //授权
        private IControl release;

        //退回更正
        private IControl repair;

        //导出
        private IStream exp = new StreamImpl();

        //主页
        private IControl home;

        //删除
        private IControl delete;

        //刷新
        private IControl refresh;

        //返回
        private IControl rtn;

        //查询
        private IControl sel;

        //清除
        private IControl reset;

        //参数交易授权标志
        private String parautflg;

        //明细
        private IControl detail;

        //机构
        private String bch;

        //审批意见
        private IControl remark;

        //审批记录
        private IControl relhis;

        //撤销
        private IControl undo;

        //经办
        private IControl take;

        //新增
        private IControl add;

        //修改
        private IControl ame;

        //全选
        private IControl allsel;

        //反选
        private IControl ressel;

        //数据库名称
        private String dbsnam;


        @JsonIgnore
        @BDGetter
        private transient IPanel dbxsav;

        @JsonIgnore
        @BDGetter
        private transient IPanel trnsav;

        @JsonIgnore
        @BDGetter
        private transient IPanel releas;

        @JsonIgnore
        @BDGetter
        private transient IPanel bakpen;

        @JsonIgnore
        @BDGetter
        private transient IPanel rtnp;

        @JsonIgnore
        @BDGetter
        private transient IPanel selres;

        @JsonIgnore
        @BDGetter
        private transient IPanel fncpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel bchp;

        @JsonIgnore
        @BDGetter
        private transient IPanel sptbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbibtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel aedbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel amdrtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel addrtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel schbtm;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbip;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<IModule> mtagrp;

	    @BDGetter
		private Argbut argbut;

	    @BDGetter
		private Htymod htymod;


		public Mtabut()
        {
            super();
            setArgument();
        }

        public Mtabut(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:mtabut.@0000.script
        */
        @Rule(target="sav",order=100)
        public boolean ruleSavN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","save 100");
			if(!ctx.checkAll(this.getMtagrp()))
			{
			  log.warn("{}","页面校验未通过，退出！");
			  return false;
			}
			if(!MdaUtils.isEmpty(this.getDbsnam()))
			{
			  Platform.mdbBegin();
			}
			else
			{
			  Platform.mdbBegin();
			}

			return true;
        }

        /**
        *   source:mtabut.@0001.script
        */
        @Rule(target="sav",order=1200)
        public boolean ruleSavN1200(){
            IContext ctx = MdaEnv.getContext();
            
			/**/

			return true;
        }

        /**
        *   source:mtabut.@0002.script
        */
        @Rule(target="sav",order=3000)
        public boolean ruleSavN3000(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","sav 3000");
			int errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  Platform.mdbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000000"),MdaUtils.getI18NString("mtabut","CT000001"));
			  return false;
			}
			Platform.mdbCommit();
			//log.info("commit db ");
			//Platform.message(#CT000002,#CT000003);
			errorcode = ctx.getErrorCode();
			log.info("{}","db commit with errorcode:" + errorcode);
			if(errorcode != NO_ERROR)
			{
			  Platform.mdbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000038"),MdaUtils.getI18NString("mtabut","CT000039"));
			  return false;
			}
			ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000052"),MdaUtils.getI18NString("mtabut","CT000053"));
			//记录操作
			if("dbafxd".equals(ctx.getTransName()))
			{
			  log.debug("{}",ctx.getTransName());
			  IModule fxdModule = MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp\\fxd");
			  IDatafield idf=(IDatafield)(fxdModule.get("inr"));
			  String objinr=(String)idf.getValue();
			  this.getHtymod().insertHistory("导入基础数据","fxd","fxd","add",objinr);
			}
			//根据不同交易，进行具体的解锁和返回状态操作返回手工勾销状态,用来判断是否删除已经手工勾销的记录
			String trnnam=ctx.getTransName();
			if("oftopm".equals(trnnam))
			{
			  String isoff="yes";
			  ctx.storeData("ismanoffed",isoff);
			}
			else if("oftamf".equals(trnnam))
			{
			  String caloff="caloff";
			  ctx.storeData("caloff",caloff);
			}
			// $\\sysmod\\flg 决定是否返回主页面
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getFlg()))
			{
			  log.debug("{}","返回主页面:"+ctx.absGet(Sysmod.class).getFlg());
			  Platform.mchain("office");
			}
			else
			{
			  //设置为X停留在当前页面
			  if("X".equals(ctx.absGet(Sysmod.class).getFlg()))
			  {
			  }
			  //设置为Y跳转到上一交易（且能保存上一交易数据状态）
			  else if("Y".equals(ctx.absGet(Sysmod.class).getFlg()))
			  {
			    
			  }
			  else
			  {
			    String tra = ctx.absGet(Sysmod.class).getFlg();
			    Platform.mchain(tra);
			  }
			}


			return true;
        }

        /**
        *   source:mtabut.@0003.script
        */
        @Rule(target="ped",order=100)
        public boolean rulePedN100(){
            IContext ctx = MdaEnv.getContext();
            

			Platform.mdbBegin();

			return true;
        }

        /**
        *   source:mtabut.@0004.script
        */
        @Rule(target="ped",order=3000)
        public boolean rulePedN3000(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mdbCommit();
			Platform.mchain("office");

			return true;
        }

        /**
        *   source:mtabut.@0005.script
        */
        @Rule(target="submit",order=100)
        public boolean ruleSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","submit 100");
			ctx.getErrorCode();
			if(!"telupd".equals(ctx.getTransName()))
			{
			  //telupd交易使用mtabut的通用提交按钮时，页面校验会无法通过。
			  //暂时先做特殊处理跳过，在后续方法中独立校验。
			  if(!ctx.checkAll(this.getMtagrp()))
			  {
			    log.warn("{}","页面校验未通过，退出！");
			    //Platform.message(#CT000183,#CT000184);
			    return false;
			  }
			}

			/*if(!Platform.checkAll($mtagrp))
			  {
			  log.warn("页面校验未通过，退出！");
			  Platform.message(#CT000185,#CT000186);
			  return false;
			  }
			  */
			log.debug("{}","pre errorcode:" + ctx.getErrorCode());
			//preparingOperationRecord();
			
			Platform.mdbBegin();


			return true;
        }

        /**
        *   source:mtabut.@0006.script
        */
        @Rule(target="submit",order=3000)
        public boolean ruleSubmitN3000(){
            IContext ctx = MdaEnv.getContext();
            
			/*log.debug("sumbit 3000");
			  Platform.mdbCommit();
			  // Platform.mchain("office");
			  log.info("db commit with errorcode:" + Platform.errorCode());
			  Platform.message(#CT000017,#CT000018);*/
			log.debug("{}","submit 3000");
			int errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  Platform.mdbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000046"),MdaUtils.getI18NString("mtabut","CT000047"));
			  return false;
			}
			Platform.mdbCommit();
			errorcode = ctx.getErrorCode();
			log.info("{}","[DB_COMMIT_ERROR]" + errorcode);
			if(errorcode != NO_ERROR)
			{
			  Platform.mdbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000048"),MdaUtils.getI18NString("mtabut","CT000049"));
			  return false;
			}
			else
			{
			  //operationRecord();
			  addHistory();
			  sendFML();
			}
			if(!"dbesrl".equals(Platform.sgetTransName()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000050"),MdaUtils.getI18NString("mtabut","CT000051"));
			}
			//用于返回时重新加载数据
			String frameName = Platform.sgetTransName();
			IModule recModule = MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp\\rec");
			String objType = MdaDriver.getModuleType(recModule);
			IDatafield objInr = MdaDriver.getDatafield(recModule,"inr");
			if(!MdaUtils.isEmpty(objType) && !MdaUtils.isEmpty(objInr))
			  ctx.storeData(objType + "inr",objInr.getValue());

			if("dbeabk".equals(frameName) || "dbaabk".equals(frameName))
			{
			  IModule actModule = MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp\\act");
			  IDatafield actid = MdaDriver.getDatafield(actModule,"actid");
			  ctx.storeData("actid",actid.getValue());
			}
			if(frameName.startsWith("dbd") || "dbeusm".equals(frameName) || "dbuusm".equals(frameName))
			{
			  //如果是删除交易，直接返回第一个交易界面
			  String key="handleTemp";
			  ctx.storeData(key,key);
			  MdaUtils.returnToFirst();
			}
			else if("dbesrl".equals(frameName))
			{
			  // frameName = frameName.substring(3);
			  //  Platform.mchain("dbi" + frameName);
			  IModule usrModule = MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp\\usr");
			  IDatafield inrIDF=(IDatafield)(usrModule.get("inr"));
			  String usrinr = (String)inrIDF.getValue();//获取选中的用户惟一编
			  log.info("{}"," 行柜员INR : "+usrinr);
			  ctx.storeData("usrinr",usrinr);//将此编号存入session
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000181"),MdaUtils.getI18NString("mtabut","CT000182"));
			  MdaUtils.returnToFirst();//跳转回第一个交易界面
			  //Platform.mchain("telinf");//跳转到详情查看交易telinf
			}
			else if(frameName.endsWith("del"))
			{
			  frameName = frameName.substring(0,3);
			  Platform.mchain(frameName + "sel");
			}
			else
			{
			  String key="handleTemp";
			  ctx.storeData(key,key);
			  MdaUtils.returnToFirst();
			}

			return true;
        }

        /**
        *   source:mtabut.@0008.script
        */
        @Rule(target="rtn",order=100)
        public boolean ruleRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("dblsrl".equals(ctx.getTransName()))
			{
			  IModule usrModule = MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp\\usr");
			  IDatafield inrIDF=(IDatafield)(usrModule.get("inr"));
			  String usrinr = (String)inrIDF.getValue();//获取选中的用户惟一编
			  log.info("{}"," 行柜员INR : "+usrinr);
			  ctx.storeData("usrinr",usrinr);//将此编号存入session
			  MdaUtils.returnToFirst();
			  //Platform.mchain("telinf");//跳转到详情查看交易sbiusr
			}
			else
			{
			  
			}

			return true;
        }



        /**
        *   source:mtabut.@0012.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.invisible($htymod\\hty);
			String tralst = "cftsel";
			String tranam = Platform.sgetTransName();
			if(tralst.contains(tranam))
			{
			  List<CodetableItem> bchcod = new ArrayList<CodetableItem>();
			  String sql = "SELECT inr,nam,bchkey FROM bch";
			  Argument<String> inrarg = new Argument<String>("inr");
			  Argument<String> namarg = new Argument<String>("nam");
			  Argument<String> keyarg = new Argument<String>("bchkey");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			    Platform.mdbFetchFields(inrarg,namarg,keyarg);
			    if(ctx.getErrorCode() == NO_ERROR)
			    {
			      bchcod.add(new CodetableItem(
			        keyarg.value + "-" + namarg.value,inrarg.value));
			    }
			    else
			    {
			      break;
			    }
			  }
			  MdaUtils.setValues(this,"bch",bchcod);
			  Platform.mdbCloseCursor();
			}

			return true;
        }


        /**
        *   source:mtabut.@0019.script
        */
        public void operationRecord()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//记账参数管理
			if(ctx.getTransName().equals("dbaktl"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> valueName=new HashMap<String, Object>();
			  Map<String,Object> map_ktpno=(Map<String,Object>)MdaUtils.invoke(this.getMtagrp(),"getMapKtpno");
			  Map<String,Object> map_ptycod=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","getMapFromCtl","area_en_US.ctl");
			  valueName.put("ktpno",map_ktpno);
			  valueName.put("ptycod",map_ptycod);
			  String txt=this.getHtymod().txtForAdd(actModule,"eibs","ktl",valueName);
			  log.debug("{}","历史记录txt信息:"+txt);
			}

			if(ctx.getTransName().equals("dbdktl"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {
			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    Map<String,Object> valueName=new HashMap<String, Object>();
			    Map<String,Object> map_ktpno=(Map<String,Object>)MdaUtils.invoke(this.getMtagrp(),"getMapKtpno");
			    Map<String,Object> map_ptycod=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","getMapFromCtl","area_en_US.ctl");
			    valueName.put("ktpno",map_ktpno);
			    valueName.put("ptycod",map_ptycod);
			    String txt=this.getHtymod().txtForDelete(orgMapBef,"eibs","ktl",valueName);
			    log.debug("{}","历史记录txt信息:"+txt);
			  }
			}
			if(ctx.getTransName().equals("dbektl"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {

			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    Map<String,Object> valueName=new HashMap<String, Object>();
			    Map<String,Object> map_ktpno=(Map<String,Object>)MdaUtils.invoke(this.getMtagrp(),"getMapKtpno");
			    Map<String,Object> map_ptycod=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.operation.ReplaceKeyString","getMapFromCtl","area_en_US.ctl");
			    valueName.put("ktpno",map_ktpno);
			    valueName.put("ptycod",map_ptycod);
			    String[] ownKey={"原始账户行BIC为",orgMapBef.get("bic").toString()};
			    String txt=this.getHtymod().txtForUpdate(actModule,orgMapBef,"eibs","ktl",valueName,ownKey);
			    log.debug("{}","历史记录txt信息:"+txt);
			  }
			}
			//
			if(ctx.getTransName().equals("dbeotl"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {

			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    String[] ownKey={"原始参数名称为",orgMapBef.get("chsnam").toString()};
			    String txt=this.getHtymod().txtForUpdate(actModule,orgMapBef,"eibs","otl",ownKey);
			    log.debug("{}","历史记录txt信息:"+txt);
			  }
			}

			//代理行联系表历史记录
			if(ctx.getTransName().equals("dbdptt"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {
			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    String txt=this.getHtymod().txtForDelete(orgMapBef,"eibs","ptt");
			    log.debug("{}","历史记录txt信息:"+txt);
			  }
			}
			if(ctx.getTransName().equals("dbeptt"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {

			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    String txt=this.getHtymod().txtForUpdate(actModule,orgMapBef,"eibs","ptt");
			    log.debug("{}","历史记录txt信息:"+txt);
			  }
			}
			if(ctx.getTransName().equals("dbaptt"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  String txt=this.getHtymod().txtForAdd(actModule,"eibs","ptt");
			  log.debug("{}","历史记录txt信息:"+txt);
			}

			//常用语句回复历史记录
			if(ctx.getTransName().equals("dbdcrt"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {
			    Map<String,Object> valueName=new HashMap<String, Object>();
			    Map<String,Object> map_typ=new HashMap<String, Object>();
			    map_typ.put("0","退汇语句");
			    map_typ.put("1","退汇语句");
			    map_typ.put("2","查询语句");
			    map_typ.put("3","其它");
			    valueName.put("typ",map_typ);
			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    String txt=this.getHtymod().txtForDelete(orgMapBef,"eibs","crd",valueName);
			    log.debug("{}","历史记录txt信息:"+txt);
			  }
			}
			if(ctx.getTransName().equals("dbecrt"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {
			    Map<String,Object> valueName=new HashMap<String, Object>();
			    Map<String,Object> map_typ=new HashMap<String, Object>();
			    map_typ.put("0","退汇语句");
			    map_typ.put("1","改汇语句");
			    map_typ.put("2","查询语句");
			    map_typ.put("3","其它");
			    valueName.put("typ",map_typ);
			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    String[] ownKey={"原始序号为",orgMapBef.get("ordnum").toString()};
			    String txt=this.getHtymod().txtForUpdate(actModule,orgMapBef,"eibs","crd",valueName,ownKey);
			    log.debug("{}","历史记录txt信息:"+txt);
			  }
			}
			if(ctx.getTransName().equals("dbacrt"))
			{
			  Map<String,Object> valueName=new HashMap<String, Object>();
			  Map<String,Object> map_typ=new HashMap<String, Object>();
			  map_typ.put("0","退汇语句");
			  map_typ.put("1","退汇语句");
			  map_typ.put("2","查询语句");
			  map_typ.put("3","其它");
			  valueName.put("typ",map_typ);
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  String txt=this.getHtymod().txtForAdd(actModule,"eibs","crd",valueName);
			  log.debug("{}","历史记录txt信息:"+txt);
			}

			//********************************
			if(ctx.getTransName().equals("dbaact"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"actp\\ptpmod\\pty");
			  Map<String,Object> valueName=new HashMap<String,Object>();
			  Map<String,Object> map_actcls=new HashMap<String,Object>();
			  map_actcls.put("A","主账户");
			  map_actcls.put("B","其他清算账户");
			  valueName.put("actcls",map_actcls);
			  String s1 =this.getHtymod().txtForAddWithoutInsert(actModule,"swd","act",valueName);
			  String s2 =this.getHtymod().txtForAddWithoutInsert(ptyModule,"swd","pty",valueName);
			  IDatafield idf=(IDatafield)(actModule.get("inr"));
			  String objinr=(String)idf.getValue();
			  this.getHtymod().insertHistory(s1+s2,"swd","act","新增",objinr);
			}
			if(ctx.getTransName().equals("dbeact"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null&&this.getHtymod().getMap1()!=null)
			  {
			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"actp\\ptpmod\\pty");
			    IDatafield chnnam=MdaDriver.getDatafield(ptyModule,"chnnam");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    String[] ss={"原账户行",(String)chnnam.getValue()};
			    log.debug("{}","原账户行:"+(String)chnnam.getValue());
			    Map<String,Object> valueName=new HashMap<String,Object>();
			    Map<String,Object> map_actcls=new HashMap<String,Object>();
			    map_actcls.put("A","主账户");
			    map_actcls.put("B","其他清算账户");
			    valueName.put("actcls",map_actcls);
			    String s1 =this.getHtymod().txtForUpdateWithoutInsert(actModule,orgMapBef,"swd","act",valueName);
			    //Objinr
			    String objinr=(String)orgMapBef.get("inr");
			    log.debug("{}","[Objinr] "+objinr+"[Text]"+s1);
			    if(!s1.equals("null"))
			    {
			      this.getHtymod().insertHistory(s1,"swd","act","修改",objinr);
			    }
			  }
			}
			if(ctx.getTransName().equals("dbdact"))
			{
			  if(this.getHtymod().getOrgmapbefdel()!=null&&this.getHtymod().getMap1()!=null)
			  {
			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"actp\\ptpmod\\pty");
			    Map<String,Object> orgMapBefDel=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    Map<String,Object> orgMapBefDel1=(Map<String,Object>)this.getHtymod().getMap1();
			    Map<String,Object> valueName=new HashMap<String,Object>();
			    Map<String,Object> map_actcls=new HashMap<String,Object>();
			    map_actcls.put("A","主账户");
			    map_actcls.put("B","其他清算账户");
			    valueName.put("actcls",map_actcls);
			    String s1 =this.getHtymod().txtForDeleteWithoutInsert(orgMapBefDel,"swd","act",valueName);
			    String s2 =this.getHtymod().txtForDeleteWithoutInsert(orgMapBefDel1,"swd","pty",valueName);
			    this.getHtymod().insertHistory(s1+s2,"swd","act&pty","删除");
			  }
			}
			if(ctx.getTransName().equals("dbabrc"))
			{
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> valueName=new HashMap<String,Object>();
			  Map<String,Object> map_ptytyp=new HashMap<String,Object>();
			  map_ptytyp.put("A","机构");
			  map_ptytyp.put("B","银行");
			  valueName.put("ptytyp",map_ptytyp);
			  String s1 =this.getHtymod().txtForAddWithoutInsert(ptyModule,"swd","pty",valueName);
			  IDatafield idf=(IDatafield)(ptyModule.get("inr"));
			  String objinr=(String)idf.getValue();
			  this.getHtymod().insertHistory(s1,"swd","pty","新增",objinr);
			}
			if(ctx.getTransName().equals("dbebrc"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null&&this.getHtymod().getMap1()!=null&&this.getHtymod().getMap2()!=null&&this.getHtymod().getMap3()!=null)
			  {
			    IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    IModule adrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\adr");
			    IModule ptaModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\pta");
			    IModule bchModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\bch");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    Map<String,Object> orgMapBef1=(Map<String,Object>)this.getHtymod().getMap1();
			    Map<String,Object> orgMapBef2=(Map<String,Object>)this.getHtymod().getMap2();
			    Map<String,Object> orgMapBef3=(Map<String,Object>)this.getHtymod().getMap3();
			    Map<String,Object> valueName=new HashMap<String,Object>();
			    Map<String,Object> map_actcls=new HashMap<String,Object>();
			    Map<String,Object> map_brhlvl=new HashMap<String,Object>();
			    map_actcls.put("A","主账户");
			    map_actcls.put("B","其他清算账户");
			    map_brhlvl.put("0","总行");
			    map_brhlvl.put("1","分行");
			    map_brhlvl.put("2","支行");
			    valueName.put("actcls",map_actcls);
			    valueName.put("brhlvl",map_brhlvl);
			    String s1 =this.getHtymod().txtForUpdateWithoutInsert(ptyModule,orgMapBef,"swd","pty",valueName);
			    String s2 =this.getHtymod().txtForUpdateWithoutInsert(adrModule,orgMapBef1,"swd","adr",valueName);
			    String s3 =this.getHtymod().txtForUpdateWithoutInsert(ptaModule,orgMapBef2,"swd","pta",valueName);
			    String s4 =this.getHtymod().txtForUpdateWithoutInsert(bchModule,orgMapBef3,"swd","bch",valueName);
			    boolean sb1,sb2,sb3,sb4;
			    sb1=!(s1.equals("null"));
			    sb2=!(s2.equals("null"));
			    sb3=!(s3.equals("null"));
			    sb4=!(s4.equals("null"));
			    String s="";
			    if(sb1)
			    {
			      s+=s1;
			    }
			    else if (sb2)
			    {
			      s+=s2;
			    }
			    else if(sb3)
			    {
			      s+=s3;
			    }
			    else if(sb4)
			    {
			      s+=s4;
			    }
			    if(!s.equals(""))
			    {
			      String objinr =(String)orgMapBef.get("inr");
			      this.getHtymod().insertHistory(s,"swd","","修改",objinr);
			    }
			  }
			}
			if(ctx.getTransName().equals("dbdbrc"))
			{
			  if(this.getHtymod().getOrgmapbefdel()!=null&&this.getHtymod().getMap1()!=null&&this.getHtymod().getMap2()!=null&&this.getHtymod().getMap3()!=null)
			  {
			    Map<String,Object> orgMapBefDel=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    Map<String,Object> valueName=new HashMap<String,Object>();
			    Map<String,Object> map_ptytyp=new HashMap<String,Object>();
			    map_ptytyp.put("A","机构");
			    map_ptytyp.put("B","银行");
			    valueName.put("ptytyp",map_ptytyp);
			    String s1 =this.getHtymod().txtForDeleteWithoutInsert(orgMapBefDel,"swd","pty",valueName);
			    this.getHtymod().insertHistory(s1,"swd","act&pty","删除");
			  }
			}
			if(ctx.getTransName().equals("dbaety"))
			{
			  IModule etyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> valueName=new HashMap<String,Object>();
			  Map<String,String> map_etginr=new HashMap<String,String>();
			  map_etginr=(Map<String,String>)this.getHtymod().getEtgmap();
			  log.debug("{}","MAP:"+map_etginr);
			  valueName.put("etginr",map_etginr);
			  this.getHtymod().txtForAdd(etyModule,"eibs","ety",valueName);
			}
			if(ctx.getTransName().equals("dbeety"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {
			    IModule etyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    this.getHtymod().txtForUpdate(etyModule,orgMapBef,"eibs","ety");
			  }
			}
			if(ctx.getTransName().equals("dbdety"))
			{
			  if(this.getHtymod().getOrgmapbefdel()!=null)
			  {
			    IModule etyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBefDel=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    this.getHtymod().txtForDelete(orgMapBefDel,"eibs","ety");
			  }
			}
			if(ctx.getTransName().equals("dbaetg"))
			{
			  IModule etgModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  this.getHtymod().txtForAdd(etgModule,"eibs","etg");
			}
			if(ctx.getTransName().equals("dbeetg"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {
			    IModule etgModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    this.getHtymod().txtForUpdate(etgModule,orgMapBef,"eibs","etg");
			  }
			}
			if(ctx.getTransName().equals("dbdetg"))
			{
			  if(this.getHtymod().getOrgmapbefdel()!=null)
			  {
			    IModule etgModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBefDel=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    this.getHtymod().txtForDelete(orgMapBefDel,"eibs","etg");
			  }
			}
			if(ctx.getTransName().equals("dbausr"))
			{
			  IModule usrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  this.getHtymod().txtForAdd(usrModule,"eibs","usr");
			}
			if(ctx.getTransName().equals("dbeusr"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {
			    IModule usrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    this.getHtymod().txtForUpdate(usrModule,orgMapBef,"eibs","usr");
			  }
			}
			if(ctx.getTransName().equals("dbdusr"))
			{
			  if(this.getHtymod().getOrgmapbefdel()!=null)
			  {
			    IModule usrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBefDel=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    this.getHtymod().txtForDelete(orgMapBefDel,"eibs","usr");
			  }
			}
			if(ctx.getTransName().equals("dbrusr"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {
			    IModule usrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    this.getHtymod().txtForUpdate(usrModule,orgMapBef,"eibs","usr");
			  }
			}
			/*
			  //用户角色定制
			  if(Platform.getTransName().equals("dbesrl"))
			  {
			  if($htymod\\orgmapbefdel!=null)
			  {
			  IModule urlModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec");
			  Map<String,Object> orgMapBefDel=(Map<String,Object>)$htymod\\orgmapbefdel;
			  String s1=$htymod.txtForDeleteWithoutInsert(orgMapBefDel,"eibs","url");
			  $htymod.txtForAdd(urlModule,"eibs","url");
			  }
			  }*/
			/*
			  if(Platform.getTransName().equals("dbefrr"))
			  {
			  IModule frrModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec");
			  $htymod.txtForAdd(frrModule,"eibs","frr");
			  }
			  if(Platform.getTransName().equals("dbuusm"))
			  {
			  IModule frrModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\frr");
			  $htymod.txtForAdd(frrModule,"eibs","frr");
			  }
			  */
			//账户行联系表
			if(ctx.getTransName().equals("dbaatt"))
			{
			  IModule pttModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  this.getHtymod().txtForAdd(pttModule,"eibs","ptt");
			}
			if(ctx.getTransName().equals("dbeatt"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null)
			  {
			    IModule pttModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    this.getHtymod().txtForUpdate(pttModule,orgMapBef,"eibs","ptt");
			  }
			}
			if(ctx.getTransName().equals("dbdatt"))
			{
			  if(this.getHtymod().getOrgmapbefdel()!=null)
			  {
			    IModule pttModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBefDel=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    this.getHtymod().txtForDelete(orgMapBefDel,"eibs","ptt");
			  }
			}
			//账户行信息
			if(ctx.getTransName().equals("dbeabk"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null&&this.getHtymod().getMap1()!=null)
			  {
			    IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\act");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    Map<String,Object> orgMapBef1=(Map<String,Object>)this.getHtymod().getMap1();
			    this.getHtymod().txtForUpdate(ptyModule,orgMapBef,"swd","pty");
			    this.getHtymod().txtForUpdate(actModule,orgMapBef1,"swd","act");
			  }
			}
			if(ctx.getTransName().equals("dbdabk"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\act");
			  IDatafield actid=MdaDriver.getDatafield(actModule,"actid") ;
			  String actId=(String)actid.getValue();
			  String s="删除账户行,ID为:"+actId;
			  this.getHtymod().insertHistory(s,"swd","act","删除");
			}
			//代理行信息
			if(ctx.getTransName().equals("dbaagb"))
			{
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\pty");
			  IModule agbModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> valueName=new HashMap<String, Object>();
			  Map<String,Object> map_blkflg=new HashMap<String, Object>();
			  map_blkflg.put("Y","是");
			  map_blkflg.put("N","否");
			  valueName.put("blkflg",map_blkflg);
			  Map<String,Object> map_mtaflg=new HashMap<String, Object>();
			  map_mtaflg.put("Y","是");
			  map_mtaflg.put("N","否");
			  valueName.put("mtaflg",map_mtaflg);
			  Map<String,Object> map_atmflg=new HashMap<String, Object>();
			  map_atmflg.put("Y","是");
			  map_atmflg.put("N","否");
			  valueName.put("selflg",map_atmflg);
			  this.getHtymod().txtForAdd(ptyModule,"swd","pty");
			  this.getHtymod().txtForAdd(agbModule,"swd","agb",valueName);
			}
			if(ctx.getTransName().equals("dbeagb"))
			{
			  if(this.getHtymod().getOrgmapbef()!=null&&this.getHtymod().getMap1()!=null)
			  {
			    IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\pty");
			    IModule agbModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			    Map<String,Object> orgMapBef=(Map<String,Object>)this.getHtymod().getOrgmapbef();
			    Map<String,Object> orgMapBef1=(Map<String,Object>)this.getHtymod().getMap1();
			    Map<String,Object> valueName=new HashMap<String, Object>();
			    Map<String,Object> map_blkflg=new HashMap<String, Object>();
			    map_blkflg.put("Y","是");
			    map_blkflg.put("N","否");
			    valueName.put("blkflg",map_blkflg);
			    Map<String,Object> map_mtaflg=new HashMap<String, Object>();
			    map_mtaflg.put("Y","是");
			    map_mtaflg.put("N","否");
			    valueName.put("mtaflg",map_mtaflg);
			    Map<String,Object> map_atmflg=new HashMap<String, Object>();
			    map_atmflg.put("Y","是");
			    map_atmflg.put("N","否");
			    valueName.put("selflg",map_atmflg);
			    this.getHtymod().txtForUpdate(ptyModule,orgMapBef,"swd","pty");
			    this.getHtymod().txtForUpdate(agbModule,orgMapBef1,"swd","agb",valueName);
			  }
			}
			if(ctx.getTransName().equals("dbdagb"))
			{
			  if(this.getHtymod().getOrgmapbefdel()!=null&&this.getHtymod().getMap1()!=null)
			  {
			    IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\pty");
			    Map<String,Object> orgMapBefDel=(Map<String,Object>)this.getHtymod().getOrgmapbefdel();
			    this.getHtymod().txtForDelete(orgMapBefDel,"swd","pty");
			  }
			}
		}
        /**
        *   source:mtabut.@0020.script
        */
        public void preparingOperationRecord()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//新增操作记录
			log.debug("{}","dbektl时的交易名:"+ctx.getTransName());
			log.debug("{}","dbektl时的交易名:"+ctx.getTransName().equals("dbektl"));
			log.debug("{}","dbdktl时的交易名:"+ctx.getTransName());
			log.debug("{}","dbdktl时的交易名:"+ctx.getTransName().equals("dbdktl"));
			if(ctx.getTransName().equals("dbdktl"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(actModule,"eibs","ktl");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			}
			if(ctx.getTransName().equals("dbektl"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(actModule,"eibs","ktl");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}

			//
			if(ctx.getTransName().equals("dbeotl"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(actModule,"eibs","otl");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}
			//代理行联系表
			if(ctx.getTransName().equals("dbdptt"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(actModule,"eibs","ptt");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			}
			if(ctx.getTransName().equals("dbeptt"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(actModule,"eibs","ptt");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}

			//常用回复语句历史记录
			if(ctx.getTransName().equals("dbdcrt"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(actModule,"eibs","crd");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			}
			if(ctx.getTransName().equals("dbecrt"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(actModule,"eibs","crd");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}
			//**********************************************************
			if(ctx.getTransName().equals("dbdact"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"actp\\ptpmod\\pty");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(actModule,"swd","act");
			  Map<String,Object> orgMapBefDel1=this.getHtymod().getOrgMapBefore(ptyModule,"swd","pty");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			  this.getHtymod().setMap1((Map<String,Object>)orgMapBefDel1);
			}
			if(ctx.getTransName().equals("dbeact"))
			{
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"actp\\ptpmod\\pty");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(actModule,"swd","act");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}
			if(ctx.getTransName().equals("dbebrc"))
			{
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  IModule adrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\adr");
			  IModule ptaModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\pta");
			  IModule bchModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\bch");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(ptyModule,"swd","pty");
			  Map<String,Object> orgMapBef1=this.getHtymod().getOrgMapBefore(adrModule,"swd","adr");
			  Map<String,Object> orgMapBef2=this.getHtymod().getOrgMapBefore(ptaModule,"swd","pta");
			  Map<String,Object> orgMapBef3=this.getHtymod().getOrgMapBefore(bchModule,"swd","bch");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			  this.getHtymod().setMap1((Map<String,Object>)orgMapBef1);
			  this.getHtymod().setMap2((Map<String,Object>)orgMapBef2);
			  this.getHtymod().setMap3((Map<String,Object>)orgMapBef3);
			}
			if(ctx.getTransName().equals("dbdbrc"))
			{
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  IModule adrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\adr");
			  IModule ptaModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\pta");
			  IModule bchModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\bch");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(ptyModule,"swd","pty");
			  Map<String,Object> orgMapBefDel1=this.getHtymod().getOrgMapBefore(ptyModule,"swd","adr");
			  Map<String,Object> orgMapBefDel2=this.getHtymod().getOrgMapBefore(ptyModule,"swd","pta");
			  Map<String,Object> orgMapBefDel3=this.getHtymod().getOrgMapBefore(ptyModule,"swd","bch");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			  this.getHtymod().setMap1((Map<String,Object>)orgMapBefDel1);
			  this.getHtymod().setMap2((Map<String,Object>)orgMapBefDel2);
			  this.getHtymod().setMap3((Map<String,Object>)orgMapBefDel3);
			}
			if(ctx.getTransName().equals("dbeety"))
			{
			  IModule etyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(etyModule,"eibs","ety");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}
			if(ctx.getTransName().equals("dbdety"))
			{
			  IModule etyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(etyModule,"eibs","ety");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			}
			if(ctx.getTransName().equals("dbdetg"))
			{
			  IModule etgModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(etgModule,"eibs","etg");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			}
			if(ctx.getTransName().equals("dbeetg"))
			{
			  IModule etgModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(etgModule,"eibs","etg");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}
			if(ctx.getTransName().equals("dbdusr"))
			{
			  IModule usrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(usrModule,"eibs","usr");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			}
			if(ctx.getTransName().equals("dbeusr"))
			{
			  IModule usrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(usrModule,"eibs","usr");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}
			if(ctx.getTransName().equals("dbrusr"))
			{
			  IModule usrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(usrModule,"eibs","usr");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}
			/*
			  //用户角色定制
			  if(Platform.getTransName().equals("dbesrl"))
			  {
			  IModule urlModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec");
			  Map<String,Object> orgMapBefDel=$htymod.getOrgMapBefore(urlModule,"eibs","url");
			  $htymod\\orgmapbefdel=(Map<String,Object>)orgMapBefDel;
			  }*/
			/*
			  if(Platform.getTransName().equals("dbefrr"))
			  {
			  IModule frrModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec");
			  Map<String,Object> orgMapBef=$htymod.getOrgMapBefore(frrModule,"eibs","frr");
			  $htymod\\orgmapbef=(Map<String,Object>)orgMapBef;
			  }
			  */
			/*
			  //用户交易定制
			  if(Platform.getTransName().equals("dbuusm"))
			  {
			  IModule frrModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\frr");
			  Map<String,Object> orgMapBef=$htymod.getOrgMapBefore(frrModule,"eibs","frr");
			  $htymod\\orgmapbef=(Map<String,Object>)orgMapBef;
			  }
			  */
			//账户行联系表
			if(ctx.getTransName().equals("dbdatt"))
			{
			  IModule pttModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(pttModule,"eibs","ptt");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			}
			if(ctx.getTransName().equals("dbeatt"))
			{
			  IModule pttModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(pttModule,"eibs","ptt");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			}
			//账户行关系
			if(ctx.getTransName().equals("dbeabk"))
			{
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  IModule actModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\act");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(ptyModule,"swd","pty");
			  Map<String,Object> orgMapBef1=this.getHtymod().getOrgMapBefore(actModule,"swd","act");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			  this.getHtymod().setMap1((Map<String,Object>)orgMapBef1);
			}
			//代理行信息
			if(ctx.getTransName().equals("dbeagb"))
			{
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\pty");
			  IModule agbModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  Map<String,Object> orgMapBef=this.getHtymod().getOrgMapBefore(ptyModule,"swd","pty");
			  Map<String,Object> orgMapBef1=this.getHtymod().getOrgMapBefore(agbModule,"swd","agb");
			  this.getHtymod().setOrgmapbef((Map<String,Object>)orgMapBef);
			  this.getHtymod().setMap1((Map<String,Object>)orgMapBef1);
			}
			if(ctx.getTransName().equals("dbdagb"))
			{
			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\pty");
			  Map<String,Object> orgMapBefDel=this.getHtymod().getOrgMapBefore(ptyModule,"swd","pty");
			  this.getHtymod().setOrgmapbefdel((Map<String,Object>)orgMapBefDel);
			}
		}
        /**
        *   source:mtabut.@0022.script
        */
        public void sendFML()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(ctx.getTransName().equals("dbesrl"))
			{
			  Platform.mdbBegin();
			  IModule usrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\usr");
			  IDatafield instIDF=(IDatafield)(usrModule.get("tinst"));
			  IDatafield rolesIDF=(IDatafield)(usrModule.get("troleset"));
			  IDatafield tchgnoIDF=(IDatafield)(usrModule.get("tchgno"));
			  Map<String,Object> map=new HashMap<String,Object>();
			  //交易类型码
			  map.put("PCODE", "612020");
			  //交易流水号
			  String sqnum="12020"+MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			  map.put("SEQNO",sqnum);
			  //柜员业务机构
			  map.put("TELLERINST", instIDF.getValue());
			  //交易系统代码
			  map.put("TRANSINST", "99306000000");
			  //操作柜员号
			  map.put("TELLERCODE", MdaEnv.getLoginUser());
			  //被操
			  map.put("CHGTELLERNO", tchgnoIDF.getValue());
			  //分配角色
			  String roles=getRoles();
			  map.put("TELLERROLESET", roles);
			  rolesIDF.setValue(roles);
			  //本地时间
			  String localTime=MdaUtils.format(MdaUtils.today(),"HHmmss");
			  map.put("LOCALTIME", localTime);
			  //本地日期
			  String localDate=MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  map.put("LOCALDATE",localDate);
			  //是否授权 01 非授权, 02 授权
			  map.put("ISAUTH","01");
			  //发送交易系统代码
			  map.put("SENDINST","99306000000");
			  //接受交易系统代吗
			  map.put("DESTINST","99700060000");
			  //系统跟踪号 - 11位系统号+8位日期+15位流水号
			  String date=MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			  String seqno=MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			  map.put("SYSTRACENO","99306000000"+date+seqno);
			  map.put("MessageType", "Register");
			  log.info("{}","MESSAGE MAP : "+map);
			  Platform.mdbUpdate(usrModule);

			  /*Map<String,Object> replyMap=(Map<String,Object>)Platform.invoke("cn.com.brilliance.teller.utils.TellerUtils","handleRoleChange",map);
			    log.info("REPLY MAP:"+replyMap);
			    if("000000".equals(replyMap.get("RESPCODE")))
			    {
			    Platform.mdbCommit();
			    if(Platform.errorCode()==NO_ERROR)
			    {
			    Platform.message(#CT000147,#CT000148);
			    }
			    else
			    {
			    Platform.mdbRollback();
			    Platform.message(#CT000149,#CT000150);
			    }
			    }
			    else
			    {
			    Platform.message(#CT000151,#CT000152);
			    }*/
			}
		}
        /**
        *   source:mtabut.@0023.script
        */
        public String getRoles()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			java.lang.StringBuilder sb=new java.lang.StringBuilder();
			IModule usrModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\usr");
			IDatafield inrIDF=(IDatafield)(usrModule.get("inr"));
			String sql="select rolinr from url where usrinr = ? ";
			Argument<String> rolinr=new Argument<String>("rolinr");
			log.info("{}","Execute SQL "+sql);
			ctx.getDaoSession().dbExecuteSQL(sql,inrIDF);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(rolinr);
			  log.info("{}","Fetching "+rolinr.getValue());
			  int error=ctx.getErrorCode();
			  log.info("{}","Fetch complete "+error);

			  if(error==NO_ERROR)
			  {
			    if(!MdaUtils.isEmpty(rolinr.getValue()))
			    {
			      sb.append(rolinr.getValue());
			      sb.append("|");
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			log.info("{}","closing cursor for usr");
			ctx.getDaoSession().dbCloseCursor();
			return sb.toString();
		}
        /**
        *   source:mtabut.@0025.script
        */
        public void addHistory()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(ctx.getTransName().equals("dbaety"))
			{
			  log.info("{}","获取新增数据");
			  Map lstetymap = (Map)ctx.restoreData("lstetyMap");
			  String lstInr = (String)lstetymap.get("inr");
			  String lstRef = (String)lstetymap.get("ref");
			  String lstEtginr = (String)lstetymap.get("etginr");
			  String lstEtynam = (String)lstetymap.get("etynam");
			  String lstEtyeng = (String)lstetymap.get("etyeng");
			  String lstDes = (String)lstetymap.get("des");

			  String txt = "新增参数:" + "实体编号:" + lstRef + ";" + "所属实体组:" + lstEtginr + ";" + "实体中文名称:" + lstEtynam + ";" + "实体英文名称:" + lstEtyeng + ";" + "实体描述:" + lstDes + "。";

			  IModule etyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  IDatafield idf=(IDatafield)(etyModule.get("inr"));
			  String objinr=(String)idf.getValue();

			  ctx.getDaoSession().dbBegin();
			  this.getHtymod().getSme().setUsr( MdaEnv.getLoginUser());
			  this.getHtymod().getSme().setFrmnam( "dbaety");
			  this.getHtymod().getSme().setOprtyp( "新增");
			  this.getHtymod().getSme().setDattim( MdaUtils.today());
			  this.getHtymod().getSme().setTabnam( "ety");
			  this.getHtymod().getSme().setDbnam( "eibs");
			  this.getHtymod().getSme().setTxt( txt);
			  this.getHtymod().getSme().setObjinr( objinr);
			  Platform.sdbInsert(this.getHtymod().getSme());
			  ctx.getDaoSession().dbCommit();
			}
			if(ctx.getTransName().equals("dbeety"))
			{
			  log.info("{}","获取修改前数据");
			  Map etymap = (Map)ctx.restoreData("etyMap");
			  String befInr = (String)etymap.get("inr");
			  String befRef = (String)etymap.get("ref");
			  String befEtginr = (String)etymap.get("etginr");
			  String befEtynam = (String)etymap.get("etynam");
			  String befEtyeng = (String)etymap.get("etyeng");
			  String befDes = (String)etymap.get("des");

			  log.info("{}","获取修改后数据");
			  Map lstetymap = (Map)ctx.restoreData("lstetyMap");
			  String lstInr = (String)lstetymap.get("inr");
			  String lstRef = (String)lstetymap.get("ref");
			  String lstEtginr = (String)lstetymap.get("etginr");
			  String lstEtynam = (String)lstetymap.get("etynam");
			  String lstEtyeng = (String)lstetymap.get("etyeng");
			  String lstDes = (String)lstetymap.get("des");

			  String txt = "";

			  if(!befRef.equals(lstRef))
			  {
			    txt += "实体编号（" + befRef + "->" + lstRef + ");";
			  }
			  if(!befEtginr.equals(lstEtginr))
			  {
			    txt += "所属实体组（" + befEtginr + "->" + lstEtginr + ");";
			  }
			  if(!befEtynam.equals(lstEtynam))
			  {
			    txt += "实体中文名称（" + befEtynam + "->" + lstEtynam + ");";
			  }
			  if(!befEtyeng.equals(lstEtyeng))
			  {
			    txt += "实体英文名称（" + befEtyeng + "->" + lstEtyeng + ");";
			  }
			  if(!befDes.equals(lstDes))
			  {
			    txt += "实体描述（" + befDes + "->" + lstDes + ");";
			  }

			  ctx.getDaoSession().dbBegin();
			  this.getHtymod().getSme().setUsr( MdaEnv.getLoginUser());
			  this.getHtymod().getSme().setFrmnam( "dbeety");
			  this.getHtymod().getSme().setOprtyp( "修改");
			  this.getHtymod().getSme().setDattim( MdaUtils.today());
			  this.getHtymod().getSme().setTabnam( "ety");
			  this.getHtymod().getSme().setDbnam( "eibs");
			  this.getHtymod().getSme().setTxt( txt);
			  this.getHtymod().getSme().setObjinr( lstInr);
			  Platform.sdbInsert(this.getHtymod().getSme());
			  ctx.getDaoSession().dbCommit();

			}
			if(ctx.getTransName().equals("dbdety"))
			{
			  log.info("{}","获取删除数据");
			  Map lstetymap = (Map)ctx.restoreData("lstetyMap");
			  String lstInr = (String)lstetymap.get("inr");
			  String lstRef = (String)lstetymap.get("ref");
			  String lstEtginr = (String)lstetymap.get("etginr");
			  String lstEtynam = (String)lstetymap.get("etynam");
			  String lstEtyeng = (String)lstetymap.get("etyeng");
			  String lstDes = (String)lstetymap.get("des");

			  String txt = "删除参数:" + "实体编号:" + lstRef + ";" + "所属实体组:" + lstEtginr + ";" + "实体中文名称:" + lstEtynam + ";" + "实体英文名称:" + lstEtyeng + ";" + "实体描述:" + lstDes + "。";

			  ctx.getDaoSession().dbBegin();
			  this.getHtymod().getSme().setUsr( MdaEnv.getLoginUser());
			  this.getHtymod().getSme().setFrmnam( "dbdety");
			  this.getHtymod().getSme().setOprtyp( "删除");
			  this.getHtymod().getSme().setDattim( MdaUtils.today());
			  this.getHtymod().getSme().setTabnam( "ety");
			  this.getHtymod().getSme().setDbnam( "eibs");
			  this.getHtymod().getSme().setTxt( txt);
			  this.getHtymod().getSme().setObjinr( lstInr);
			  Platform.sdbInsert(this.getHtymod().getSme());
			  ctx.getDaoSession().dbCommit();

			}
			if(ctx.getTransName().equals("dbaetg"))
			{
			  log.info("{}","获取新增数据");
			  Map lstetgmap = (Map)ctx.restoreData("lstetgMap");
			  String lstInr = (String)lstetgmap.get("inr");
			  String lstNam = (String)lstetgmap.get("nam");
			  String lstDes = (String)lstetgmap.get("des");

			  String txt = "新增参数:" + "实体组名称:" + lstNam + ";" + "实体组描述:" + lstDes + "。";

			  IModule etgModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  IDatafield idf=(IDatafield)(etgModule.get("inr"));
			  String objinr=(String)idf.getValue();

			  ctx.getDaoSession().dbBegin();
			  this.getHtymod().getSme().setUsr( MdaEnv.getLoginUser());
			  this.getHtymod().getSme().setFrmnam( "dbaetg");
			  this.getHtymod().getSme().setOprtyp( "新增");
			  this.getHtymod().getSme().setDattim( MdaUtils.today());
			  this.getHtymod().getSme().setTabnam( "etg");
			  this.getHtymod().getSme().setDbnam( "eibs");
			  this.getHtymod().getSme().setTxt( txt);
			  this.getHtymod().getSme().setObjinr( objinr);
			  Platform.sdbInsert(this.getHtymod().getSme());
			  ctx.getDaoSession().dbCommit();

			}
			if(ctx.getTransName().equals("dbeetg"))
			{
			  log.info("{}","获取修改前数据");
			  Map etgmap = (Map)ctx.restoreData("etgMap");
			  String befInr = (String)etgmap.get("inr");
			  String befNam = (String)etgmap.get("nam");
			  String befDes = (String)etgmap.get("des");

			  log.info("{}","获取修改后数据");
			  Map lstetgmap = (Map)ctx.restoreData("lstetgMap");
			  String lstInr = (String)lstetgmap.get("inr");
			  String lstNam = (String)lstetgmap.get("nam");
			  String lstDes = (String)lstetgmap.get("des");

			  String txt = "";

			  if(!befNam.equals(lstNam))
			  {
			    txt += "实体组名称（" + befNam + "->" + lstNam + ");";
			  }
			  if(!befDes.equals(lstDes))
			  {
			    txt += "实体组描述（" + befDes + "->" + lstDes + ");";
			  }

			  ctx.getDaoSession().dbBegin();
			  this.getHtymod().getSme().setUsr( MdaEnv.getLoginUser());
			  this.getHtymod().getSme().setFrmnam( "dbeetg");
			  this.getHtymod().getSme().setOprtyp( "修改");
			  this.getHtymod().getSme().setDattim( MdaUtils.today());
			  this.getHtymod().getSme().setTabnam( "etg");
			  this.getHtymod().getSme().setDbnam( "eibs");
			  this.getHtymod().getSme().setTxt( txt);
			  this.getHtymod().getSme().setObjinr( lstInr);
			  Platform.sdbInsert(this.getHtymod().getSme());
			  ctx.getDaoSession().dbCommit();

			}
			if(ctx.getTransName().equals("dbdetg"))
			{
			  log.info("{}","获取删除数据");
			  Map lstetgmap = (Map)ctx.restoreData("lstetgMap");
			  String lstInr = (String)lstetgmap.get("inr");
			  String lstNam = (String)lstetgmap.get("nam");
			  String lstDes = (String)lstetgmap.get("des");

			  String txt = "删除参数:" + "实体组名称:" + lstNam + ";" + "实体组描述:" + lstDes + "。";

			  ctx.getDaoSession().dbBegin();
			  this.getHtymod().getSme().setUsr( MdaEnv.getLoginUser());
			  this.getHtymod().getSme().setFrmnam( "dbdetg");
			  this.getHtymod().getSme().setOprtyp( "删除");
			  this.getHtymod().getSme().setDattim( MdaUtils.today());
			  this.getHtymod().getSme().setTabnam( "etg");
			  this.getHtymod().getSme().setDbnam( "eibs");
			  this.getHtymod().getSme().setTxt( txt);
			  this.getHtymod().getSme().setObjinr( lstInr);
			  Platform.sdbInsert(this.getHtymod().getSme());
			  ctx.getDaoSession().dbCommit();

			}
			//dbabrc
			if(ctx.getTransName().equals("dbabrc"))
			{
			  log.info("{}","获取新增数据");
			  Map lstbrcMap = (Map)ctx.restoreData("lstbrcMap");
			  String lstInr = (String)lstbrcMap.get("inr");
			  String lstCid = (String)lstbrcMap.get("cid");
			  String lstExtkey = (String)lstbrcMap.get("extkey");
			  String lstChnnam = (String)lstbrcMap.get("chnnam");
			  //String lstBrhlvl = (String)lstbrcMap.get("brhlvl");
			  String lstLnknam = (String)lstbrcMap.get("lnknam");
			  //String lstPntbchinr = (String)lstbrcMap.get("pntbchinr");
			  String lstFax = (String)lstbrcMap.get("fax");
			  String lstTel = (String)lstbrcMap.get("tel");
			  String lstDecnum = (String)lstbrcMap.get("decnum");
			  String lstBranch = (String)lstbrcMap.get("branch");
			  String lstPoscod = (String)lstbrcMap.get("poscod");
			  //String lstEtyinr = (String)lstbrcMap.get("etyinr");
			  String lstCnadr1 = (String)lstbrcMap.get("cnadr1");
			  String lstAdr = (String)lstbrcMap.get("adr");

			  String txt = "新增参数:" + "机构代码:" + lstCid + ";" + "BIC码:" + lstExtkey +";" + "机构中文名称:" + lstChnnam +";"  + "联系人名称:" + lstLnknam +";"+ "传真:" + lstFax +";" + "联系电话:" + lstTel +";" + "金融机构识别码:" + lstDecnum +";" + "系统机构码:" + lstBranch +";" + "邮编:" + lstPoscod +";" + "中文地址:" + lstCnadr1 +";" + "机构地址:" + lstAdr + "。";

			  IModule ptyModule = MdaDriver.getModule(ctx.getRoot(),"mtabut\\mtagrp\\rec");
			  IDatafield idf=(IDatafield)(ptyModule.get("inr"));
			  String objinr=(String)idf.getValue();

			  ctx.getDaoSession().dbBegin();
			  this.getHtymod().getSme().setUsr( MdaEnv.getLoginUser());
			  this.getHtymod().getSme().setFrmnam( "dbabrc");
			  this.getHtymod().getSme().setOprtyp( "新增");
			  this.getHtymod().getSme().setDattim( MdaUtils.today());
			  this.getHtymod().getSme().setTabnam( "act&pty");
			  this.getHtymod().getSme().setDbnam( "swd");
			  this.getHtymod().getSme().setTxt( txt);
			  this.getHtymod().getSme().setObjinr( objinr);
			  Platform.sdbInsert(this.getHtymod().getSme());
			  ctx.getDaoSession().dbCommit();
			}

			if(ctx.getTransName().equals("dbebrc"))
			{
			  log.info("{}","获取修改前数据");
			  Map brcMap = (Map)ctx.restoreData("brcMap");
			  String befInr = (String)brcMap.get("inr");
			  String befCid = (String)brcMap.get("cid");
			  String befExtkey = (String)brcMap.get("extkey");
			  String befChnnam = (String)brcMap.get("chnnam");
			  //String befBrhlvl = (String)brcMap.get("brhlvl");
			  String befLnknam = (String)brcMap.get("lnknam");
			  //String befPntbchinr = (String)brcMap.get("pntbchinr");
			  String befFax = (String)brcMap.get("fax");
			  String befTel = (String)brcMap.get("tel");
			  String befDecnum = (String)brcMap.get("decnum");
			  String befBranch = (String)brcMap.get("branch");
			  String befPoscod = (String)brcMap.get("poscod");
			  //String befEtyinr = (String)brcMap.get("etyinr");
			  String befCnadr1 = (String)brcMap.get("cnadr1");
			  String befAdr = (String)brcMap.get("adr");

			  log.info("{}","获取修改后数据");
			  Map lstbrcMap = (Map)ctx.restoreData("lstbrcMap");
			  String lstInr = (String)lstbrcMap.get("inr");
			  String lstCid = (String)lstbrcMap.get("cid");
			  String lstExtkey = (String)lstbrcMap.get("extkey");
			  String lstChnnam = (String)lstbrcMap.get("chnnam");
			  //String lstBrhlvl = (String)lstbrcMap.get("brhlvl");
			  String lstLnknam = (String)lstbrcMap.get("lnknam");
			  //String lstPntbchinr = (String)lstbrcMap.get("pntbchinr");
			  String lstFax = (String)lstbrcMap.get("fax");
			  String lstTel = (String)lstbrcMap.get("tel");
			  String lstDecnum = (String)lstbrcMap.get("decnum");
			  String lstBranch = (String)lstbrcMap.get("branch");
			  String lstPoscod = (String)lstbrcMap.get("poscod");
			  //String lstEtyinr = (String)lstbrcMap.get("etyinr");
			  String lstCnadr1 = (String)lstbrcMap.get("cnadr1");
			  String lstAdr = (String)lstbrcMap.get("adr");

			  String txt = "";

			  if(!befCid.equals(lstCid))
			  {
			    txt += "机构代码（" + befCid + "->" + lstCid + ");";
			  }
			  if(!befExtkey.equals(lstExtkey))
			  {
			    txt += "BIC码（" + befExtkey + "->" + lstExtkey + ");";
			  }
			  if(!befChnnam.equals(lstChnnam))
			  {
			    txt += "机构中文名称（" + befChnnam + "->" + lstChnnam + ");";
			  }
			  if(!befLnknam.equals(lstLnknam))
			  {
			    txt += "联系人名称（" + befLnknam + "->" + lstLnknam + ");";
			  }
			  if(!befFax.equals(lstFax))
			  {
			    txt += "传真（" + befFax + "->" + lstFax + ");";
			  }
			  if(!befTel.equals(lstTel))
			  {
			    txt += "联系电话（" + befTel + "->" + lstTel + ");";
			  }
			  if(!befDecnum.equals(lstDecnum))
			  {
			    txt += "金融机构标识码（" + befDecnum + "->" + lstDecnum + ");";
			  }
			  if(!befBranch.equals(lstBranch))
			  {
			    txt += "系统机构码（" + befBranch + "->" + lstBranch + ");";
			  }
			  if(!befPoscod.equals(lstPoscod))
			  {
			    txt += "邮编（" + befPoscod + "->" + lstPoscod + ");";
			  }
			  if(!befCnadr1.equals(lstCnadr1))
			  {
			    txt += "中文地址（" + befCnadr1 + "->" + lstCnadr1 + ");";
			  }
			  if(!befAdr.equals(lstAdr))
			  {
			    txt += "机构地址（" + befAdr + "->" + lstAdr + ");";
			  }

			  ctx.getDaoSession().dbBegin();
			  this.getHtymod().getSme().setUsr( MdaEnv.getLoginUser());
			  this.getHtymod().getSme().setFrmnam( "dbebrc");
			  this.getHtymod().getSme().setOprtyp( "修改");
			  this.getHtymod().getSme().setDattim( MdaUtils.today());
			  this.getHtymod().getSme().setTabnam( "act&pty");
			  this.getHtymod().getSme().setDbnam( "swd");
			  this.getHtymod().getSme().setTxt( txt);
			  this.getHtymod().getSme().setObjinr( lstInr);
			  Platform.sdbInsert(this.getHtymod().getSme());
			  ctx.getDaoSession().dbCommit();

			}
			if(ctx.getTransName().equals("dbdbrc"))
			{
			  log.info("{}","获取删除数据");
			  Map lstbrcMap = (Map)ctx.restoreData("lstbrcMap");
			  String lstInr = (String)lstbrcMap.get("inr");
			  String lstCid = (String)lstbrcMap.get("cid");
			  String lstExtkey = (String)lstbrcMap.get("extkey");
			  String lstChnnam = (String)lstbrcMap.get("chnnam");
			  //String lstBrhlvl = (String)lstbrcMap.get("brhlvl");
			  String lstLnknam = (String)lstbrcMap.get("lnknam");
			  //String lstPntbchinr = (String)lstbrcMap.get("pntbchinr");
			  String lstFax = (String)lstbrcMap.get("fax");
			  String lstTel = (String)lstbrcMap.get("tel");
			  String lstDecnum = (String)lstbrcMap.get("decnum");
			  String lstBranch = (String)lstbrcMap.get("branch");
			  String lstPoscod = (String)lstbrcMap.get("poscod");
			  //String lstEtyinr = (String)lstbrcMap.get("etyinr");
			  String lstCnadr1 = (String)lstbrcMap.get("cnadr1");
			  String lstAdr = (String)lstbrcMap.get("adr");

			  String txt = "删除参数:" + "机构代码:" + lstCid + ";" + "BIC码:" + lstExtkey +";" + "机构中文名称:" + lstChnnam +";"+ "联系人名称:" + lstLnknam +";"+ "传真:" + lstFax +";" + "联系电话:" + lstTel +";" + "金融机构识别码:" + lstDecnum +";" + "系统机构码:" + lstBranch +";" + "邮编:" + lstPoscod +";" + "中文地址:" + lstCnadr1 +";" + "机构地址:" + lstAdr + "。";
			  ctx.getDaoSession().dbBegin();
			  this.getHtymod().getSme().setUsr( MdaEnv.getLoginUser());
			  this.getHtymod().getSme().setFrmnam( "dbdbrc");
			  this.getHtymod().getSme().setOprtyp( "删除");
			  this.getHtymod().getSme().setDattim( MdaUtils.today());
			  this.getHtymod().getSme().setTabnam( "act&pty");
			  this.getHtymod().getSme().setDbnam( "swd");
			  this.getHtymod().getSme().setTxt( txt);
			  this.getHtymod().getSme().setObjinr( lstInr);
			  Platform.sdbInsert(this.getHtymod().getSme());
			  ctx.getDaoSession().dbCommit();

			}
		}


        public void setMtagrpHolder(ModuleHolder<IModule> mtagrp)
        {
            this.mtagrp = mtagrp;
        }

        public IModule getMtagrp()
        {
           return this.mtagrp.get();
        }





















































}