package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.bo.Cur;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Hkz;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Odtgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Odtgrp.class);



	    @BDGetter
		private Hkz rec;

	    @BDGetter
		private Act act;

		@BDGetter
		private ModuleList<Hkz> hkzlst;

	    @BDGetter
		private Cur cur;


		public Odtgrp()
        {
            super();
            setArgument();
        }

        public Odtgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }


        /**
        *   source:odtgrp.@0000.script
        */
        @Check(target="rec.inswif",order=100)
        public boolean checkRecInswifN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRec().getInswif()))
			{
			  ctx.setFieldError(this,"rec.inswif",MdaUtils.getI18NString("odtgrp","CT000001"));
			  return false;
			}

			return true;
        }

        /**
        *   source:odtgrp.@0001.script
        */
        @Check(target="rec.ouswif",order=100)
        public boolean checkRecOuswifN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRec().getOuswif()))
			{
			  ctx.setFieldError(this,"rec.ouswif",MdaUtils.getI18NString("odtgrp","CT000002"));
			  return false;
			}

			return true;
        }

        /**
        *   source:odtgrp.@0003.script
        */
        @Check(target="rec.cur",order=100)
        public boolean checkRecCurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRec().getCur()))
			{
			  ctx.setFieldError(this,"rec.cur",MdaUtils.getI18NString("odtgrp","CT000005"));
			  return false;
			}

			return true;
        }

        /**
        *   source:odtgrp.@0004.script
        */
        @Check(target="rec.valdat",order=100)
        public boolean checkRecValdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRec().getValdat()))
			{
			  ctx.setFieldError(this,"rec.valdat",MdaUtils.getI18NString("odtgrp","CT000008"));
			  return false;
			}

			return true;
        }



        /**
        *   source:odtgrp.@0005.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","odt insert....");
			String inr=Platform.sdbCounter("hkz");
			log.debug("{}","odt inr:"+inr);
			this.getRec().setInr(inr);
			this.getRec().setCredat(MdaUtils.today());
			this.getRec().setSta("0");
			Platform.mdbInsert(this.getRec());
			//log.debug($rec);
			if(ctx.getErrorCode()==NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:odtgrp.@0006.script
        */
        public void delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","执行删除");
			String inr = this.getRec().getInr();
			ctx.storeData("rol",inr);
		}
        /**
        *   source:odtgrp.@0007.script
        */
        public void update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","odt update....");
			Platform.mdbUpdate(this.getRec());
		}





}