package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Pbtp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Pbtp.class);

        //查询
        private IControl sel;

        //清除
        private IControl del;

        //新增
        private IControl add;

        //变更
        private IControl ame;

        //撤销
        private IControl drp;

        //导出
        private IStream exp = new StreamImpl();

        //返回
        private IControl ret;

        //参与行行号
        private String bnkbic;

        //参与行简称
        private String bnknam;

        //联系电话
        private String tel;

        //联系人
        private String nam;

        //邮编
        private String zipcod;

        //email地址
        private String email;

        //省属代码
        private String pvccod;

        //地市代码
        private String ctycod;

        //金融机构代码
        private String ptycod;

        //参与行类型
        private String bnktyp;

        //参与行全称
        private String bnkallnam;

        //参与行地址
        private String bnkadr;

        //备注
        private String rem;

        //行别代码
        private String hbcod;

        //委托日期
        private Date gendat;

        //行号变更
        private IControl ccms916;


        @JsonIgnore
        @BDGetter
        private transient IPanel mainpl;

        @JsonIgnore
        @BDGetter
        private transient IPanel lftpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgtpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel addpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel upadd;

        @JsonIgnore
        @BDGetter
        private transient IPanel addbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel amepnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel amebtn;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Pbtgrp> pbtgrp;


		public Pbtp()
        {
            super();
            setArgument();
        }

        public Pbtp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:pbtp.@0002.script
        */
        @Rule(target="pvccod",order=300)
        public boolean rulePvccodN300(){
            IContext ctx = MdaEnv.getContext();
            
			this.setCtycod(NULLSTR);
			String typ = "";
			if(!MdaUtils.isEmpty(this.getPvccod()))
			{
			  typ = this.getPvccod();
			}
			log.debug("{}","pvccod: " + typ);
			MdaUtils.setValues(this,"ctycod",this.getCtycodList(typ));
			


			return true;
        }

        /**
        *   source:pbtp.@0006.script
        */
        @Rule(target="ctycod",order=300)
        public boolean ruleCtycodN300(){
            IContext ctx = MdaEnv.getContext();
            
			this.setPtycod(NULLSTR);
			String typ = "";
			if(!MdaUtils.isEmpty(this.getCtycod()))
			{
			  typ = this.getCtycod();
			}
			log.debug("{}","ctycod: " + typ);
			MdaUtils.setValues(this,"ptycod",this.getPtycodList(typ));
			


			return true;
        }


        /**
        *   source:pbtp.@0008.script
        */
        @Check(target="gendat",order=100)
        public boolean checkGendatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGendat()))
			{
			  ctx.setFieldError(this,"gendat",MdaUtils.getI18NString("pbtp","CT000101"));
			}

			return true;
        }



        /**
        *   source:pbtp.@0003.script
        */
        public List<CodetableItem> getProcodList()//获取系统维护的国家下拉列表
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//得到所有省缩写
			List<CodetableItem> sipList = new ArrayList<CodetableItem>();//构造码表List
			Platform.mdbExecuteSQL("SELECT pronam,procod FROM fxdpro ORDER BY inr asc");//执行sql语句查询记录
			Argument<String> nam = new Argument<String>("pronam");//构造Label列
			Argument<String> val = new Argument<String>("procod");
			while(true)
			{
			  Platform.mdbFetchFields(nam,val);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    String codnam = nam.value;
			    String codval = val.value;
			    if(!MdaUtils.isEmpty(codnam))
			      sipList.add(new CodetableItem(codnam,codval));
			    //codval为页面展示的值，codnam为实际存储的值
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return sipList;
		}
        /**
        *   source:pbtp.@0005.script
        */
        public List<CodetableItem> getCtycodList(String procod)//获取系统维护的国家下拉列表
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//得到所有省缩写
			List<CodetableItem> sipList = new ArrayList<CodetableItem>();//构造码表List
			if(!MdaUtils.isEmpty(procod))
			{
			  Platform.mdbExecuteSQL("SELECT ctynam,ctycod FROM fxdcty WHERE procod = '"+procod+"' ORDER BY inr asc");//执行sql语句查询记录
			}
			else
			{
			  Platform.mdbExecuteSQL("SELECT ctynam,ctycod FROM fxdcty ORDER BY inr asc");//执行sql语句查询记录
			}
			Argument<String> nam = new Argument<String>("ctynam");//构造Label列
			Argument<String> val = new Argument<String>("ctycod");
			while(true)
			{
			  Platform.mdbFetchFields(nam,val);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    String codnam = nam.value;
			    String codval = val.value;
			    if(!MdaUtils.isEmpty(codnam))
			      sipList.add(new CodetableItem(codnam,codval));
			    //codval为页面展示的值，codnam为实际存储的值
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return sipList;
		}
        /**
        *   source:pbtp.@0007.script
        */
        public List<CodetableItem> getPtycodList(String ctycod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//得到所有省缩写
			List<CodetableItem> sipList = new ArrayList<CodetableItem>();//构造码表List
			if((!MdaUtils.isEmpty(ctycod)))
			{
			  Platform.mdbExecuteSQL("SELECT hafnam,bnkcod FROM fxbank WHERE citycod = '"+ctycod+"' ORDER BY inr asc");//执行sql语句查询记录
			}
			else
			{
			  Platform.mdbExecuteSQL("SELECT hafnam,bnkcod FROM fxbank ORDER BY inr asc");//执行sql语句查询记录
			}
			Argument<String> nam = new Argument<String>("hafnam");//构造Label列
			Argument<String> val = new Argument<String>("bnkcod");
			while(true)
			{
			  Platform.mdbFetchFields(nam,val);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    String codnam = nam.value;
			    String codval = val.value;
			    if(!MdaUtils.isEmpty(codnam))
			      sipList.add(new CodetableItem(codnam,codval));
			    //codval为页面展示的值，codnam为实际存储的值
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return sipList;
		}


        public void setPbtgrpHolder(ModuleHolder<Pbtgrp> pbtgrp)
        {
            this.pbtgrp = pbtgrp;
        }

        public Pbtgrp getPbtgrp()
        {
           return this.pbtgrp.get();
        }















































}