package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ptmack extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ptmack.class);



	    @BDGetter
		private Smpmod smpmod;


		public Ptmack()
        {
            super();
            setArgument();
        }

        public Ptmack(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:ptmack.@0000.script
        */
        public boolean createMessageProcessSubjectForFxps(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			log.info("{}","[SAV_DOC_MPS_SMH]");
			/// 系统处理时间
			Date processDate = new Date();
			// Platform.clear($smpmod\\mps);
			MdaUtils.clear(this.getSmpmod().getMpe());
			//Platform.clear($smpmod\\smh);
			MdaUtils.clear(this.getSmpmod().getChn());
			MdaUtils.clear(this.getSmpmod().getTgtchn());
			//Platform.mdbCommit();
			//Platform.mdbBegin();
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");

			targetChannel = "FXP";

			int errorcode = ctx.getErrorCode();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");

			this.getSmpmod().getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getSmpmod().getMps().setSrcchncod( channel);
			this.getSmpmod().getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getSmpmod().getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getSmpmod().getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getSmpmod().getMps().setSmhinr( smhinr);
			this.getSmpmod().getMps().setSta( "A"); // 待自动清分状态
			this.getSmpmod().getMps().setNxtsta( "A"); // 待自动清分状态
			this.getSmpmod().getMps().setRspsta( "W"); //未核销状态
			this.getSmpmod().getMps().setRcvdattim( processDate); // 接收报文时间
			this.getSmpmod().getMps().setLstdattim( processDate); // 最近处理时间
			this.getSmpmod().getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getSmpmod().getChn().getDlytim())); // 开始处理时间
			log.debug("{}","[smpmod insert mps...]");
			Platform.sdbInsert(this.getSmpmod().getMps());

			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert&dbUpdate mps with errorcode:" + errorcode);
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getSmpmod().getMpe().setMpsinr( this.getSmpmod().getMps().getInr());
			this.getSmpmod().getMpe().setChncod( channel);
			this.getSmpmod().getMpe().setNxtchncod( "XXX");
			this.getSmpmod().getMpe().setSmhinr( smhinr);
			this.getSmpmod().getMpe().setNxtsmhinr( smhinr);
			this.getSmpmod().getMpe().setDattim( processDate);
			if("ame".equals(this.getSmpmod().getEdtflg()))
			  this.getSmpmod().getMpe().setPrvsta( "C");
			else if("new".equals(this.getSmpmod().getEdtflg()))
			  this.getSmpmod().getMpe().setPrvsta( ""); // 处理前状态
			this.getSmpmod().getMpe().setSta( "A"); // 处理后状态
			this.getSmpmod().getMpe().setTxt( processDetail);
			this.getSmpmod().getMpe().setFrmnam( ctx.getTransName());
			this.getSmpmod().getMpe().setUsr( MdaEnv.getLoginUser());
			log.debug("{}","[MPE_INSERT]");
			Platform.sdbInsert(this.getSmpmod().getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","[dbInsert mpe with errorcode]:" + errorcode);
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmpmod().getSmh().setInr( smhinr);
			this.getSmpmod().getSmh().setObjtyp( "mpe");
			this.getSmpmod().getSmh().setObjinr( this.getSmpmod().getMpe().getInr());
			this.getSmpmod().getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmpmod().getSmh().setDattim( processDate);
			this.getSmpmod().getSmh().setDocpth( this.getSmpmod().getDatapath());
			this.getSmpmod().getSmh().setDocfil( smhinr);
			this.getSmpmod().getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;

			if("jfx|fxl".contains(messageType))
			{
			  fileName = this.getSmpmod().getStoreFileFullPathName(smhinr, messageType);
			}
			else
			{
			  log.debug("{}","messageTypeError");
			  return false;
			}

			// 保存文件并记录MD5值和文件大小信息
			log.debug("{}","[DOC_UPLOAD]");
			Platform.mstreamSave(is,fileName);
			this.getSmpmod().getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmpmod().getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmpmod().getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmpmod().getSmh());
			log.debug("{}","[SMH_INSERT]");
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR && errorcode != NO_MORE_ROW)
			{
			  log.debug("{}","[dbInsert smh with errorcode]:" + errorcode);
			  return false;
			}
			return true;
		}
        /**
        *   source:ptmack.@0001.script
        */
        public boolean storeMsgFromPlatForFxps(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			//log.info("[SAVE_903_DOC]");
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GBK"));
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}

			if(!createMessageProcessSubjectForFxps(is,"AUT","jfx","FXP","保存Fxps相关json报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			log.debug("{}","[FXPS_SMH_INR]:"+this.getSmpmod().getSmh().getInr());
			log.debug("{}","[FXPS_MPS_INR]:"+this.getSmpmod().getMps().getInr());
			String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			log.debug("{}","fileName:"+fileName);
			if(!Platform.mfileExists(fileName))
			{ // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			  log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			  this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			  return false;
			}
			return true;
		}


}