package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.bo.Adr;
import com.ceb.gjjs.mda.bo.Innact;
import com.ceb.gjjs.mda.bo.Pta;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* snd
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ptpmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ptpmod.class);

        //+
        private IControl sel;

        //确定
        private IControl sure;

        //取消
        private IControl cancel;

        //是否弹出
        private String ispoup;

        //flg
        @Module(getter = false, setter = false)
		private FieldHolder<String> flg = new FieldConstantHolder<>("");

        //存储流
        private IStream is = new StreamImpl();

        //银行名称
        private String chnnam;

        //SWIFT CODE
        private String extkey;

        //内部账号机构码选择查询按钮
        private IControl sel2;

        //内部账号机构码选择确定按钮
        private IControl sure2;

        //内部账号机构码选择取消按钮
        private IControl cancel2;

        //BIC
        private String bic;

        //查询
        private IControl abksel;

        //是否选择
        private Object issel;

        //取消
        private IControl agbcel;

        //币种
        private String abkcur;

        //确定
        private IControl curqur;

        //取消
        private IControl curcel;

        //优先级
        private String abkseq;

        //确定
        private IControl seqsur;


        @JsonIgnore
        @BDGetter
        private transient IPanel ptylstp;

        @JsonIgnore
        @BDGetter
        private transient IPanel engnamp;

        @JsonIgnore
        @BDGetter
        private transient IPanel actptysel;

        @JsonIgnore
        @BDGetter
        private transient IPanel engnamp2;

        @JsonIgnore
        @BDGetter
        private transient IPanel actlstp;

        @JsonIgnore
        @BDGetter
        private transient IPanel actsel;

        @JsonIgnore
        @BDGetter
        private transient IPanel swfpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel addpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel innp;

        @JsonIgnore
        @BDGetter
        private transient IPanel abklstp;

        @JsonIgnore
        @BDGetter
        private transient IPanel abkcurp;

        @JsonIgnore
        @BDGetter
        private transient IPanel abkseqp;

        @JsonIgnore
        @BDGetter
        private transient IPanel perp;


	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Pta pta;

	    @BDGetter
		private Adr adr;

		@BDGetter
		private ModuleList<Pty> ptylst;

	    @BDGetter
		private Act act;

		@BDGetter
		private ModuleList<Act> actlst;

		@BDGetter
		private ModuleList<Innact> innlst;

	    @BDGetter
		private Innact inn;

		@BDGetter
		private ModuleList<Pty> abklst;

		@BDGetter
		private ModuleList<Pershw> perlst;


		public Ptpmod()
        {
            super();
            setArgument();
        }

        public Ptpmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:ptpmod.@0001.script
        */
        @Rule(target="sure",order=100)
        public boolean ruleSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int idx = 0;
			if(idx <0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ptpmod","CT000035"),MdaUtils.getI18NString("ptpmod","CT000036"));
			  return true;
			}
			selectAndBackFill();
			opnOrClsPanel(-1);

			return true;
        }

        /**
        *   source:ptpmod.@0005.script
        */
        @Rule(target="cancel",order=100)
        public boolean ruleCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			opnOrClsPanel(-1);
			//Platform.closePanel($actptysel);
			
			return true;
        }

        /**
        *   source:ptpmod.@0006.script
        */
        @Rule(target="sel",order=200)
        public boolean ruleSelN200(){
            IContext ctx = MdaEnv.getContext();
            
			opnOrClsPanel(1);//开Panel，如果已经开了，则不再开启
			//Platform.clear($pty\\chnnam);
			//Platform.clear($pty\\extkey);
			//Platform.setModified($pty\\chnnam);
			//Platform.setModified($pty\\extkey);
			//Platform.popupOnly($actptysel);
			
			return true;
        }

        /**
        *   source:ptpmod.@0007.script
        */
        @Rule(target="sel",order=100)
        public boolean ruleSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			//查询并初始化 PTY List
			if("abk".equals(this.getFlg()))
			{
			  iniAbkLst();
			  
			}
			else if("bnk".equals(this.getFlg()))
			{
			  iniBnkLst();
			  
			}
			else if("act".equals(this.getFlg()))
			{
			  iniActLst();
			  
			}
			else if("agb".equals(this.getFlg()))//20181221新加
			{
			  iniAgbLst();
			  
			}
			else if(1!=1)
			{
			}

			return true;
        }

        /**
        *   source:ptpmod.@0009.script
        */
        @Rule(target="actptysel",order=100)
        public boolean ruleActptyselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setIspoup("0");//关闭标志
			
			return true;
        }

        /**
        *   source:ptpmod.@0012.script
        */
        @Rule(target="actsel",order=100)
        public boolean ruleActselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setIspoup("0");//关闭标志
			
			return true;
        }

        /**
        *   source:ptpmod.@0013.script
        */
        @Rule(target="sure",order=200)
        public boolean ruleSureN200(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:ptpmod.@0022.script
        */
        @Rule(target="ptylst",order=100)
        public boolean rulePtylstN100(){
            IContext ctx = MdaEnv.getContext();
            
			selectAndBackFill();
			log.debug("{}",this.getPty().getExtkey());
			log.debug("{}",this.getPty().getChnnam());
			String key = this.getPty().getExtkey();
			String nam = this.getPty().getChnnam();
			this.getPty().setExtkey(NULLSTR);
			this.getPty().setChnnam(NULLSTR);
			
			
			log.debug("{}",this.getPty().getExtkey());
			log.debug("{}",this.getPty().getChnnam());
			this.getPty().setExtkey( key);
			this.getPty().setChnnam( nam);
			log.debug("{}",this.getPty().getExtkey());
			log.debug("{}",this.getPty().getChnnam());
			
			
			//opnOrClsPanel(-1);
			
			return true;
        }

        /**
        *   source:ptpmod.@0025.script
        */
        @Rule(target="ptylst",order=200)
        public boolean rulePtylstN200(){
            IContext ctx = MdaEnv.getContext();
            

			return true;
        }

        /**
        *   source:ptpmod.@0026.script
        */
        @Rule(target="sure2",order=100)
        public boolean ruleSure2N100(){
            IContext ctx = MdaEnv.getContext();
            
			/*使用的是innact里面已经有的机构码，实际上是不合理的，但是现在因为要提供机构码来选择，而PTY暂时没数据，所以使用innact表里面
			  *已经存在的机构来提供选择
			  */
			int idx = 0;
			if(idx > -1)
			{
			  this.getInn().copyValue(this.getInnlst().getElement(idx));
			  
			  
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("ptpmod","CT000140"),MdaUtils.getI18NString("ptpmod","CT000141"));
			}

			return true;
        }

        /**
        *   source:ptpmod.@0027.script
        */
        @Rule(target="cancel2",order=100)
        public boolean ruleCancel2N100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:ptpmod.@0028.script
        */
        @Rule(target="sel2",order=100)
        public boolean ruleSel2N100(){
            IContext ctx = MdaEnv.getContext();
            
			String sql = "SELECT distinct ptycod ,area FROM innact ORDER BY area";
			Argument ptycod = new Argument("ptycod");
			Argument area = new Argument("area");
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(ptycod,area);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    if(area.value == null || "".equals(area.value.toString().trim()))
			      continue;
			    this.getInnlst().add(ptycod,area);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			

			return true;
        }

        /**
        *   source:ptpmod.@0030.script
        */
        @Rule(target="abklst",order=100)
        public boolean ruleAbklstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setIssel( true);
			

			return true;
        }

        /**
        *   source:ptpmod.@0031.script
        */
        @Rule(target="agbcel",order=100)
        public boolean ruleAgbcelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setIssel( false);
			

			return true;
        }

        /**
        *   source:ptpmod.@0032.script
        */
        @Rule(target="abksel",order=100)
        public boolean ruleAbkselN100(){
            IContext ctx = MdaEnv.getContext();
            
			Argument arg = new Argument();
			if(!MdaUtils.isEmpty(this.getBic()))
			{
			  String bic = this.getBic();
			  bic = bic.toUpperCase();
			  arg = arg.and("extkey",LIKE,bic + "%");
			}
			Platform.mdbReadset(this.getAbklst(),arg);
			

			return true;
        }

        /**
        *   source:ptpmod.@0037.script
        */
        @Rule(target="curqur",order=100)
        public boolean ruleCurqurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getAbkcur()))
			{
			  ctx.setFieldError(this,"abkcur",MdaUtils.getI18NString("ptpmod","CT000253"));
			  ctx.setMessage(MdaUtils.getI18NString("ptpmod","CT000254"),MdaUtils.getI18NString("ptpmod","CT000277"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getAbkseq()))
			{
			  ctx.setFieldError(this,"abkseq",MdaUtils.getI18NString("ptpmod","CT000278"));
			  ctx.setMessage(MdaUtils.getI18NString("ptpmod","CT000279"),MdaUtils.getI18NString("ptpmod","CT000280"));
			  return true;
			}
			this.setIssel( true);
			

			return true;
        }

        /**
        *   source:ptpmod.@0038.script
        */
        @Rule(target="curcel",order=100)
        public boolean ruleCurcelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setIssel( false);
			

			return true;
        }

        /**
        *   source:ptpmod.@0040.script
        */
        @Rule(target="abkseq",order=100)
        public boolean ruleAbkseqN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getAbkseq()))
			{
			  ctx.setFieldError(this,"abkseq",MdaUtils.getI18NString("ptpmod","CT000215"));
			  return true;
			}
			String seq = this.getAbkseq();
			int seqnum = MdaUtils.parseInt(seq);
			if(seqnum > 100)
			{
			  ctx.setFieldError(this,"abkseq",MdaUtils.getI18NString("ptpmod","CT000216"));
			}
			this.setAbkseq( "" + seqnum);
			

			return true;
        }


        /**
        *   source:ptpmod.@0020.script
        */
        @Check(target="pty.extkey",order=100)
        public boolean checkPtyExtkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getPty().getExtkey()))
			{
			  String scd = this.getPty().getExtkey();
			  this.getPty().setExtkey( scd.toUpperCase());
			  
			}

			return true;
        }

        /**
        *   source:ptpmod.@0023.script
        */
        @Check(target="extkey",order=100)
        public boolean checkExtkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getExtkey()))
			{
			  String scd = this.getExtkey();
			  this.setExtkey( scd.toUpperCase());
			  
			}

			return true;
        }


        /**
        *   source:ptpmod.@0011.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getAct(),"cur",getSysCurLst());

			return true;
        }


        /**
        *   source:ptpmod.@0002.script
        */
        public List<CodetableItem> getSysCurLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> curLst = new ArrayList<CodetableItem>();
			String sql = "SELECT cur,curnam FROM cur WHERE flg='1'";
			Platform.mdbExecuteSQL(sql);
			Argument<String> cur = new Argument<String>("cur");
			Argument<String> curnam = new Argument<String>("curnam");
			while(true)
			{
			  Platform.mdbFetchFields(cur,curnam);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if(curnam.value != null && cur.value != null)
			    {
			      CodetableItem c = new CodetableItem(cur.value,cur.value);
			      curLst.add(c);
			    }
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return curLst;
		}
        /**
        *   source:ptpmod.@0004.script
        */
        public void opnOrClsPanel(int oc)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			/*
			  oc = -1 表示关闭Panel
			  oc = 1 表示开启Panel
			  */
			String ispoup = this.getIspoup();
			boolean canopn = "0".equals(ispoup) || ispoup== null;
			if("abk".equals(this.getFlg()))
			{
			  //用于账户行机构选择
			  if(oc > 0)
			  {
			    if(canopn)
			    {
			      this.getPty().setChnnam(NULLSTR);
			      this.getPty().setExtkey(NULLSTR);
			      
			      
			      
			      //Platform.popupOnly($actptysel);
			      this.setIspoup("1");
			    }
			  }
			  else if(oc < 0)
			  {
			    if(!canopn)
			    {
			      //Platform.setModified($pty);
			      
			      this.setIspoup("0");
			    }
			  }
			}
			else if("act".equals(this.getFlg()))
			{
			  //用于账户选择
			  if(oc > 0)
			  {
			    if(canopn)
			    {
			      
			      this.setIspoup("1");
			    }
			  }
			  else if(oc < 0)
			  {
			    if(!canopn)
			    {
			      
			      this.setIspoup("0");
			    }
			  }
			}
			else if("bnk".equals(this.getFlg()))
			{
			  //用于账户选择
			  if(oc > 0)
			  {
			    if(canopn)
			    {
			      
			      this.setIspoup("1");
			    }
			  }
			  else if(oc < 0)
			  {
			    if(!canopn)
			    {
			      
			      this.setIspoup("0");
			    }
			  }
			}
			else if("agb".equals(this.getFlg()))//20181221新加
			{
			  //用于账户选择
			  if(oc > 0)
			  {
			    if(canopn)
			    {
			      
			      this.setIspoup("1");
			    }
			  }
			  else if(oc < 0)
			  {
			    if(!canopn)
			    {
			      
			      this.setIspoup("0");
			    }
			  }
			}
			else if (1 != 1)
			{

			}

		}
        /**
        *   source:ptpmod.@0008.script
        */
        public void iniAbkLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//用户账户行选择
			MdaUtils.clear(this.getPtylst());
			String psbInr = ctx.absGet(Sysmod.class).getPty().getInr();
			// String sql = "SELECT y.inr inr,y.extkey extkey,y.chnnam chnnam,y.engnam engnam FROM pty y,pta a WHERE y.inr = a.objinr AND a.objtyp = 'pty' AND a.ptyinr = '" + psbInr + "' AND a.ptatyp ='C' ";
			String sql = "SELECT y.inr inr,y.extkey extkey,y.chnnam chnnam,y.engnam engnam FROM pty y WHERE y.ptytyp LIKE '%T%' ";
			if(!MdaUtils.isEmpty(this.getPty().getChnnam()))
			{
			  String egn = this.getPty().getChnnam();
			  sql = sql + " AND (y.engnam LIKE '%" + egn + "%' OR y.chnnam LIKE '%" +egn+"%') ";
			}
			if(!MdaUtils.isEmpty(this.getPty().getExtkey()))
			{
			  String scd = this.getPty().getExtkey();
			  sql = sql + " AND y.extkey LIKE '%" + scd + "%'";
			}

			//增加实体查询条件
			sql = sql+ctx.absGet(Sysmod.class).getEtySql("y");

			log.info("{}",sql);
			Platform.mdbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> extkey = new Argument<String>("extkey");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			while(true)
			{
			  Platform.mdbFetchFields(inr,extkey,chnnam,engnam);
			  if(ctx.getErrorCode() ==NO_ERROR)
			  {
			    this.getPtylst().add(inr,extkey,chnnam,engnam);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
		}
        /**
        *   source:ptpmod.@0010.script
        */
        public void iniActLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getActlst());
			String sql = "SELECT a.inr inr,a.actid actid ,a.innerid innerid,a.cur cur,a.actcls actcls,p.extkey scd,p.chnnam chsnam,p.engnam engnam FROM pty p,act a WHERE p.inr = a.actbnkinr AND ";//其后加限制为 账户行
			if(!MdaUtils.isEmpty(this.getPty().getChnnam()))
			{
			  String cnStr = this.getPty().getChnnam();
			  cnStr = cnStr.trim();
			  String likStr = "'%"+cnStr+"%'";
			  sql = sql + "p.chnnam LIKE " + likStr + " OR p.engnam LIKE " +likStr+" AND ";
			}
			if(!MdaUtils.isEmpty(this.getAct().getCur()))
			{
			  String cur = this.getAct().getCur();
			  sql = sql + "a.cur = '"+cur+"' AND ";
			}
			sql = sql + " 1=1 ";

			//增加实体查询条件
			sql = sql+ctx.absGet(Sysmod.class).getEtySql("a");

			sql = sql + " ORDER BY a.inr ASC";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> actid = new Argument<String>("actid");
			Argument<String> innerid = new Argument<String>("innerid");
			Argument<String> cur = new Argument<String>("cur");
			Argument<String> actcls = new Argument<String>("actcls");
			Argument<String> scd = new Argument<String>("scd");
			Argument<String> chsnam = new Argument<String>("chsnam");
			Argument<String> engnam = new Argument<String>("engnam");
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(inr,actid,innerid,cur,actcls,scd,chsnam,engnam);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    this.getActlst().add(inr,actid,innerid,cur,actcls,scd,chsnam,engnam);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
		}
        /**
        *   source:ptpmod.@0014.script
        */
        public boolean storeStr(String str,String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IStream is = this.getIs();
			byte[] data = str.getBytes();
			try
			{
			  is.getOutputStream().write(data);
			  is.getOutputStream().flush();
			  Platform.mstreamSave(is,pth);
			  return true;
			}
			catch(Exception e)
			{
			  return false;
			}
		}
        /**
        *   source:ptpmod.@0015.script
        */
        public String loadStr(String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IStream is= this.getIs();
			if(Platform.mfileExists(pth))
			{
			  Platform.mstreamLoad(is,pth);
			  StringBuilder strBuf = new StringBuilder();
			  char[] cBuf = new char[1024];
			  try
			  {
			    java.io.BufferedReader buff = new java.io.BufferedReader(new java.io.InputStreamReader(is.getInputStream()));
			    int len = -1;
			    while((len = buff.read(cBuf,0,1024)) > -1)
			    {
			      strBuf.append(cBuf,0,len);
			    }
			    return cBuf.toString();
			  }
			  catch(Exception e)
			  {
			    return null;
			  }
			}
			else
			  return null;
		}
        /**
        *   source:ptpmod.@0016.script
        */
        public void iniBnkLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getPtylst());
			Argument tj = new Argument("ptytyp",LIKE,"%B%");
			boolean canSel = false;//如果条件过于宽松，则不予查询
			if(!MdaUtils.isEmpty(this.getPty().getChnnam()))
			{
			  String egn = this.getPty().getChnnam();
			  egn = "%"+egn+"%";
			  Argument sTj = new Argument("engnam",LIKE,egn);
			  sTj = sTj.or("chnnam",LIKE,egn);
			  tj = tj.and(sTj);
			  canSel = true;
			}
			//对于普通银行的查询，因为数据量太大，不提供太短的BIC查询
			if(!MdaUtils.isEmpty(this.getPty().getExtkey()))
			{
			  String scd = this.getPty().getExtkey();
			  if(scd.length() >= 4)
			  {
			    tj = tj.and("extkey",LIKE,scd+"%");
			    canSel = true;
			  }
			}

			//增加实体查询条件
			tj=tj.and(ctx.absGet(Sysmod.class).getEtyArg());

			if(canSel)
			  Platform.mdbReadset(this.getPtylst(),0,tj);
		}
        /**
        *   source:ptpmod.@0017.script
        */
        public List<CodetableItem>  getSysCurLst(boolean isContainNull)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*可返回有空选项的币种列表*/
			List<CodetableItem> lst = getSysCurLst();
			if(isContainNull)
			{
			  /*允许有空选项*/
			  lst.add(0,new CodetableItem("",""));
			}
			return lst;
		}
        /**
        *   source:ptpmod.@0018.script
        */
        public void expExcel(String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*  IStream is = $is.getValue();
			  is.setType("xls");
			  is.setName("test.xls");
			  List<String[]>  list = new ArrayList<String[]>();
			  String[] row1 = {"收到日期","起息日","账户行","BIC","币种","借贷标识",
			  "金额","业务类型标识","业务参考号","相关参考号","详细信息","勾销状态","记账状态",
			  "记账类型","所属页码","所属单编号","对账单参考号"
			  };
			  list.add(row1);
			  for(#smd smd:);
			  Platform.unloadExcel(list,is,false);
			  */
		}
        /**
        *   source:ptpmod.@0019.script
        */
        public List<CodetableItem> getAllCurLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> curLst = new ArrayList<CodetableItem>();
			String sql = "SELECT cur,curnam FROM cur ";
			Platform.mdbExecuteSQL(sql);
			Argument<String> cur = new Argument<String>("cur");
			Argument<String> curnam = new Argument<String>("curnam");
			while(true)
			{
			  Platform.mdbFetchFields(cur,curnam);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if(curnam.value != null && cur.value != null)
			    {
			      CodetableItem c = new CodetableItem(curnam.value,cur.value);
			      curLst.add(c);
			    }
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return curLst;
		}
        /**
        *   source:ptpmod.@0024.script
        */
        public void selectAndBackFill()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			int idx = 0;
			if(idx <0)
			  return;
			log.debug("{}","flg = "+this.getFlg());
			if("abk".equals(this.getFlg()) || "bnk".equals(this.getFlg()) || "agb".equals(this.getFlg()))
			{
			  this.getPty().copyValue(this.getPtylst().getElement(idx));
			  String ptyInr = this.getPty().getInr();
			  log.debug("{}","ptyinr="+this.getPty().getInr());
			  Platform.mdbRead(this.getPta(),new Argument<String>("ptyinr",ptyInr),new Argument<String>("objtyp","adr"));
			  log.debug("{}","ptainr="+this.getPta().getInr());
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    String adrInr = this.getPta().getObjinr();
			    Platform.mdbRead(this.getAdr(),new Argument<String>("inr",adrInr));//获取adr
			    if(ctx.getErrorCode() == NO_ERROR)
			    {
			      
			    }
			  }
			  
			  
			  log.info("{}","ptpmod--extkey:"+this.getPty().getExtkey());
			  MdaUtils.showMainPanel();
			  //opnOrClsPanel(-1);//关闭Panel
			}
			else if("act".equals(this.getFlg()))
			{
			  this.getAct().copyValue(this.getActlst().getElement(idx));
			  
			  opnOrClsPanel(-1);//关闭Panel
			}
		}
        /**
        *   source:ptpmod.@0029.script
        */
        public void selectAgbAbk(IDatafield df,IDatafield curdf,IDatafield seqdf)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	代理行账户行选择
			  */
			this.setAbkcur(NULLSTR);
			this.setAbkseq(NULLSTR);
			
			
			Argument arg = new Argument();
			if(!MdaUtils.isEmpty(df))
			{
			  String bic = (String)df.getValue();
			  bic = bic.toUpperCase();
			  arg = arg.and("extkey",LIKE,bic + "%");
			}
			arg = arg.and("ptytyp",LIKE,"%B%");
			Platform.mdbReadset(this.getAbklst(),arg);
			this.setIssel( false);
			
			Boolean issel = (Boolean)this.getIssel();
			if(issel)
			{
			  //有选择
			  int index = 0;
			  if(index < 0)
			  {
			    MdaUtils.clear(df);
			  }
			  else
			  {
			    String bic = this.getAbklst().getElement(index).getExtkey();
			    df.setValue(bic);
			    this.setIssel( false);
			    
			    issel = (Boolean)this.getIssel();
			    if(issel)
			    {
			      //TODO:币种维护
			      String cur = this.getAbkcur();
			      String seq = this.getAbkseq();
			      curdf.setValue(cur);
			      seqdf.setValue(seq);
			    }
			    else
			    {
			      MdaUtils.clear(df);
			      MdaUtils.clear(curdf);
			      MdaUtils.clear(seqdf);
			    }
			  }
			}
			else
			{
			  MdaUtils.clear(df);
			}
			
			
			
		}
        /**
        *   source:ptpmod.@0034.script
        */
        public String selectMinFeeBnk(List<String> ptylst,List<String> actlst,BigDecimal amt,String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	从指定银行账户列表选出针对此笔汇款扣费最少的银行
			  -	ptylst 指定银行列表
			  - actlst 指定账户列表（和ptylst一一对应）
			  - amt 汇款金额
			  @	返回符合条件的银行BIC
			  */
			String selectedPtyinr = "";
			///查询计算各银行对此笔汇款的扣费
			List<BigDecimal> feelst = new ArrayList<BigDecimal>();
			for(int i = 0;i < ptylst.size();i++)
			{
			  String ptyinr = ptylst.get(i);
			  String actid  = actlst.get(i);
			  Argument<BigDecimal> feearg = new Argument<BigDecimal>();
			  String sql = "SELECT fee FROM fee WHERE ptyinr = '" + ptyinr + "' " +
			    "AND actid = '" + actid + "' " +
			    "AND minamt <= ? AND maxamt > ? ";
			  Platform.mdbExecuteSQL(sql);
			  Platform.mdbFetchFields(feearg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    feelst.add(feearg.value);
			  }
			  else
			  {
			    feelst.add(new BigDecimal(-1));
			  }
			}
			Platform.mdbCloseCursor();
			///选择扣费最少的银行
			int index = 0;
			BigDecimal minfee = new BigDecimal(99999999);//TODO:扣费上限待确定
			for(int i = 0;i < feelst.size();i++)
			{
			  BigDecimal t = feelst.get(i);
			  if(t.compareTo(new BigDecimal(0)) < 0)
			  {
			    continue;
			  }
			  if(minfee.compareTo(t) >= 0)
			  {
			    minfee = t;
			    index = i;
			  }
			}
			///判断属否有相同扣费情况，并进行处理
			List<String> eqlst = new ArrayList<String>();//具有相同扣费情况的银行列表
			for(int i = 0;i < feelst.size();i++)
			{
			  if(i == index)
			  {
			    continue;
			  }
			  BigDecimal t = feelst.get(i);
			  if(t.compareTo(minfee) == 0)
			  {
			    eqlst.add(ptylst.get(i));
			  }
			}
			if(eqlst.size() == 0)
			{
			  selectedPtyinr = ptylst.get(index);
			}
			else
			{
			  //TODO:从列表中的银行中选出发报比例最多的那家银行
			  selectedPtyinr = this.selectMaxPerBnk(eqlst,cur);
			}
			///查询选中银行的BIC
			String selectedBIC = "";
			Argument<String> bicarg = new Argument<String>("extkey");
			String sql = "SELECT extkey FROM pty WHERE inr = '" + selectedPtyinr + "'";
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(bicarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  selectedBIC = bicarg.value;
			}
			else
			{
			  selectedBIC = null;//未查询到返回null，进入异常处理
			}
			return selectedBIC;
		}
        /**
        *   source:ptpmod.@0035.script
        */
        public String selectActbnk(String cur,BigDecimal amt,String flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	根据汇款币种和金额，从己方清算行中选择出适合发报的清算行
			  - cur	汇款币种
			  - 汇款金额
			  - DJS-国结，GHD-国际汇兑
			  @	返回适合银行的BIC
			  */
			String subWhere = "";
			if("GJS".equals(flg))
			{
			  //参与国结清算
			  subWhere = "act.gjsactflg = 'X'";
			}
			else if("GHD".equals(flg))
			{
			  //参与国际汇兑清算
			  subWhere = "act.ghdactflg = 'X'";
			}
			List<String> ptylst = new ArrayList<String>();
			List<String> actlst = new ArrayList<String>();
			Argument<String> inrarg = new Argument<String>("inr");
			Argument<String> actidarg = new Argument<String>("actid");
			String sql = "SELECT pty.inr,act.actid FROM pty,act WHERE " +
			  "pty.ptytyp LIKE '%T%' AND " +
			  "pty.inr = act.actbnkinr AND act.cur = '" + cur + "' AND " +
			  subWhere;//参与清算
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(inrarg,actidarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    ptylst.add(inrarg.value);
			    actlst.add(actidarg.value);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			String bnkbic = this.selectMinFeeBnk(ptylst,actlst,amt,cur);
			return bnkbic;
		}
        /**
        *   source:ptpmod.@0036.script
        */
        public String selectMaxPerBnk(List<String> ptylst,String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			/*
			  *	从指定银行列表中选出指定币种账户下发报比例最多的那家银行
			  - ptylst 指定的银行列表
			  - cur		 指定币种
			  @ 返回符合条件的银行ptyinr
			  */
			BigDecimal maxper = new BigDecimal(-1);
			int maxindex = 0;
			for(int i = 0;i < ptylst.size();i++)
			{
			  Argument<BigDecimal> perarg = new Argument<BigDecimal>("per");
			  String sql = "SELECT act.per FROM act,pty WHERE " +
			    "pty.inr = act.actbnkinr AND pty.inr = '" +
			    ptylst.get(i) + "' AND " +
			    "act.cur = '" + cur + "'";
			  Platform.mdbExecuteSQL(sql);
			  Platform.mdbFetchFields(perarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    BigDecimal t = perarg.value;
			    if(!MdaUtils.isEmpty(t))
			    {
			      if(t.compareTo(maxper) >= 0)
			      {
			        maxindex = i;
			        maxper = t;
			      }
			    }
			  }
			  Platform.mdbCloseCursor();
			}
			return ptylst.get(maxindex);
		}
        /**
        *   source:ptpmod.@0039.script
        */
        public BigDecimal perCheck(String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	账户行发报比例验证（综合为100%）
			  */
			String sql = "SELECT per FROM act,pty" +
			  " WHERE pty.ptytyp LIKE '%T%'" + //账户行
			  " AND act.actbnkinr = pty.inr" +
			  " AND act.cur = '" + cur + "'";
			Argument<BigDecimal> perarg = new Argument<BigDecimal>("per");
			BigDecimal persum = new BigDecimal(0);
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(perarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    BigDecimal argval = perarg.value;
			    log.debug("{}","argval: " + argval);
			    if(!MdaUtils.isEmpty(argval))
			    {
			      persum = persum.add(argval);
			      log.debug("{}","persum+argval: " + persum);
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			log.debug("{}","final persum: " + persum);
			return persum;
		}
        /**
        *   source:ptpmod.@0041.script
        */
        public void perShow(String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getPerlst());
			String sql = "SELECT act.per,act.cur,pty.chnnam,pty.extkey FROM act,pty" +
			  " WHERE pty.ptytyp LIKE '%T%'" + //账户行
			  " AND act.actbnkinr = pty.inr" +
			  " AND act.cur = '" + cur + "'";
			Argument<String> curarg = new Argument<String>("cur");
			Argument<BigDecimal> perarg = new Argument<BigDecimal>("per");
			Argument<String> namarg = new Argument<String>("chnnam");
			Argument<String> bicarg = new Argument<String>("extkey");
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(perarg,curarg,namarg,bicarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    this.getPerlst().add(curarg,perarg,namarg,bicarg);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			
			
		}
        /**
        *   source:ptpmod.@0044.script
        */
        public CodetableItem registReport()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return null;
		}
        /**
        *   source:ptpmod.@0045.script
        */
        public void iniAgbLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getPtylst());
			Argument tj = new Argument("ptytyp",LIKE,"%M%");
			boolean canSel = false;//如果条件过于宽松，则不予查询
			if(!MdaUtils.isEmpty(this.getPty().getChnnam()))
			{
			  String egn = this.getPty().getChnnam();
			  egn = "%"+egn+"%";
			  Argument sTj = new Argument("engnam",LIKE,egn);
			  sTj = sTj.or("chnnam",LIKE,egn);
			  tj = tj.and(sTj);
			  canSel = true;
			}
			//对于普通银行的查询，因为数据量太大，不提供太短的BIC查询
			if(!MdaUtils.isEmpty(this.getPty().getExtkey()))
			{
			  String scd = this.getPty().getExtkey();
			  if(scd.length() >= 4)
			  {
			    tj = tj.and("extkey",LIKE,scd+"%");
			    canSel = true;
			  }
			}

			//增加实体查询条件
			tj=tj.and(ctx.absGet(Sysmod.class).getEtyArg());

			if(canSel)
			  Platform.mdbReadset(this.getPtylst(),0,tj);
		}






















        public void setFlgHolder(FieldHolder<String> flg)
        {
           this.flg = (flg);
        }

        public void setFlg(String flg)
        {
            this.flg.setValue(flg);
        }

        public String getFlg()
        {
            return this.flg.getValue();
        }































}