package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Ptt;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Pttgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Pttgrp.class);



	    @BDGetter
		private Ptt rec;

		@BDGetter
		private ModuleList<Ptt> pttlst;


		public Pttgrp()
        {
            super();
            setArgument();
        }

        public Pttgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }


        /**
        *   source:pttgrp.@0003.script
        */
        @Check(target="rec.eml",order=100)
        public boolean checkRecEmlN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(!Platform.isEmpty($rec\\eml))
			  {
			  String eml = $rec\\eml.getValue().trim();
			  String reg = "(\\\\w+-?_?)+\\\\w?@(\\\\w+\\\\.)+[a-zA-Z]+";
			  if(!eml.matches(reg))
			  {
			  Platform.error($rec\\eml,#CT000002);
			  return;
			  }
			  }*/

			return true;
        }



        /**
        *   source:pttgrp.@0000.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","ENTER DBAPTT INSERT...");
			ctx.getErrorCode();
			//Platform.checkAll($rec);
			this.getRec().setInr( Platform.sdbCounter("ptt"));
			log.debug("{}","新增PTT记录INR："+this.getRec().getInr());
			log.debug("{}","新增PTT记录PTYNAM："+this.getRec().getPtybic());

			//关联所属实体
			ctx.absGet(Sysmod.class).setEtyAndPty(this.getRec());

			Platform.mdbInsert(this.getRec());
			if(ctx.getErrorCode() == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:pttgrp.@0001.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","ENTER DBEPTT UPDATE...");
			ctx.getErrorCode();
			//Platform.checkAll($rec);
			Platform.mdbUpdate(this.getRec());
			log.debug("{}","Update PTYNAM:"+this.getRec().getPtynam());
			if(ctx.getErrorCode() ==NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:pttgrp.@0002.script
        */
        public boolean delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","ENTER DBDPTT DELETE...");
			ctx.getErrorCode();
			Platform.mdbDelete(this.getRec());
			if(ctx.getErrorCode() == NO_ERROR)
			  return true;
			else
			  return false;
		}



}