package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.bo.Adr;
import com.ceb.gjjs.mda.bo.Pta;
import com.ceb.gjjs.mda.bo.Agb;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Bch;
import com.ceb.gjjs.mda.bo.Fee;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ptygrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ptygrp.class);

        //数据处理标志
        private String recsavflg;



	    @BDGetter
		private Pty rec;

	    @BDGetter
		private Act act;

	    @BDGetter
		private Act newlst;

	    @BDGetter
		private Act oldlst;

	    @BDGetter
		private Fee fee;

	    @BDGetter
		private Agb agb;

		@BDGetter
		private ModuleList<Fee> feelst;

		@BDGetter
		private ModuleList<Fee> oldlst1;

	    @BDGetter
		private Adr adr;

	    @BDGetter
		private Pta pta;

	    @BDGetter
		private Bch bch;

		@BDGetter
		private ModuleList<Fee> orilst;


		public Ptygrp()
        {
            super();
            setArgument();
        }

        public Ptygrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:ptygrp.@0005.script
        */
        @Rule(target="act.per",order=100)
        public boolean ruleActPerN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getAct().getPer()))
			{
			  return true;
			}
			BigDecimal per = this.getAct().getPer();
			if(per.doubleValue() > 100)
			{
			  ctx.setFieldError(this,"act.per",MdaUtils.getI18NString("ptygrp","CT000045"));
			}

			return true;
        }




        /**
        *   source:ptygrp.@0000.script
        */
        public boolean insert(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*if(!infoCheck())
			  {
			  log.debug("infoCheck false.");
			  return false;
			  }*/
			log.debug("{}","tansaction insert...");
			log.debug("{}","framname :"+framname);
			if("dbaabk".equals(framname))
			{
			  log.debug("{}","abk insert...");
			  //Platform.mdbBegin();
			  ///账户信息添加
			  this.getAct().setInr( Platform.sdbCounter("act"));
			  log.debug("{}","act inr:"+this.getAct().getInr());
			  this.getAct().setActbnkinr( this.getRec().getInr());
			  this.getAct().setFormid(
			    Platform.format4Equals(this.getAct().getActid(),false));

			  //关联所属实体
			  ctx.absGet(Sysmod.class).setEtyAndPty(this.getAct());

			  Platform.mdbInsert(this.getAct());
			  if(ctx.getErrorCode()!=NO_ERROR)
			    return false;
			  ///扣费信息添加
			  if(!this.submitFee())
			    return false;
			  ///银行标识修改
			  String typ = this.getRec().getPtytyp();
			  if(!typ.contains("T"))
			  {
			    typ += "T";
			  }
			  this.getRec().setPtytyp( typ);
			  log.debug("{}","pty type:"+this.getRec().getPtytyp());
			  Platform.mdbUpdate(this.getRec());
			  if(ctx.getErrorCode() != NO_ERROR)
			  {
			    //Platform.mdbCommit();
			    //Platform.message(#CT000004,#CT000005);
			    //Platform.mchain("dblabk");
			    //Platform.storeData("ptyinr",$rec\\inr.getValue());
			    //Platform.returnToCaller();
			    //return true;
			    //}
			    //else
			    //{
			    //Platform.mdbRollback();
			    //Platform.message(#CT000006,#CT000007);
			    return false;
			  }
			}
			else if("dbabrc".equals(framname))
			{
			  log.debug("{}","dbabrc begin....");
			  /*if(!dataChecked())
			    return false;*/
			  this.getRec().setInr( Platform.sdbCounter("pty"));
			  log.debug("{}","@@@@ pty-inr:" + this.getRec().getInr() + " @@@@");
			  this.getRec().setStatus("0");
			  this.getRec().setPtytyp("A");
			  String adrinr = Platform.sdbCounter("adr");
			  this.getAdr().setInr(adrinr);
			  //log.debug("@@@@ adr-inr:" + adrinr + " @@@@");
			  String ptainr = Platform.sdbCounter("pta");
			  this.getPta().setInr(ptainr);
			  //log.debug("@@@@ pta-inr:" + ptainr + " @@@@");
			  this.getPta().setPtyinr(this.getRec().getInr());
			  this.getPta().setPtytyp("2");
			  this.getPta().setPtyextkey(this.getRec().getExtkey());
			  this.getPta().setObjinr(adrinr);
			  this.getPta().setObjtyp("adr");
			  //==============设置BCH表的值==================
			  setBranchData();
			  //===========================================
			  int errorcode = ctx.getErrorCode();
			  //Platform.mdbBegin();
			  log.debug("{}","brc insert...");

			  //关联所属实体
			  ctx.absGet(Sysmod.class).setEtyAndPty(this.getRec());
			  this.getRec().setPtyinr(this.getRec().getInr());

			  Platform.mdbInsert(this.getRec());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    //Platform.message(#CT000046,#CT000047);
			    //Platform.mdbRollback();
			    return false;
			  }
			  Platform.mdbInsert(this.getAdr());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    //Platform.message(#CT000048,#CT000049);
			    //Platform.mdbRollback();
			    return false;
			  }
			  Platform.mdbInsert(this.getPta());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    //Platform.message(#CT000050,#CT000051);
			    //Platform.mdbRollback();
			    return false;
			  }
			  Platform.mdbInsert(this.getBch());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    //Platform.mdbCommit();
			    //Platform.message(#CT000052,#CT000053);
			    //Platform.mchain("dblbrc");
			    //return true;
			    //}
			    //else
			    //{
			    //Platform.message(#CT000054,#CT000055);
			    //Platform.mdbRollback();
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:ptygrp.@0001.script
        */
        public boolean infoCheck()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean result = true;
			if(MdaUtils.isEmpty(this.getAct().getActid()))
			{
			  ctx.setFieldError(this,"act.actid",MdaUtils.getI18NString("ptygrp","CT000013"));
			  result = false;
			}
			if(MdaUtils.isEmpty(this.getAct().getCur()))
			{
			  ctx.setFieldError(this,"act.cur",MdaUtils.getI18NString("ptygrp","CT000014"));
			  result = false;
			}
			/*
			  if(Platform.isEmpty($abkgrp\\act\\per))
			  {
			  Platform.error($abkgrp\\act\\per,#CT000015);
			  result = false;
			  }
			  */
			if(MdaUtils.isEmpty(this.getAct().getActflg()))
			{
			  ctx.setFieldError(this,"act.actflg",MdaUtils.getI18NString("ptygrp","CT000016"));
			  result = false;
			}
			if(MdaUtils.isEmpty(this.getAct().getDrcflg()))
			{
			  ctx.setFieldError(this,"act.drcflg",MdaUtils.getI18NString("ptygrp","CT000017"));
			  result = false;
			}
			return result;
		}
        /**
        *   source:ptygrp.@0002.script
        */
        public boolean update(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*if(!infoCheck())
			  {
			  log.debug("infoCheck false.");
			  return false;
			  }*/
			log.debug("{}","tansaction update..");
			log.debug("{}","framname :"+framname);
			if("dbeabk".equals(framname))
			{
			  log.debug("{}","act actid:"+this.getAct().getActid());
			  log.debug("{}","pty inr:"+this.getRec().getInr());
			  this.getAct().setFormid(
			    Platform.format4Equals(this.getAct().getActid(),false));
			  Platform.mdbUpdate(this.getAct());
			  Platform.mdbUpdate(this.getRec());
			  if(ctx.getErrorCode() != NO_ERROR)
			    return false;
			  if(!this.submitFee())
			  {
			    log.debug("{}","fee submit ERROR");
			    return false;
			  }
			}
			else if ("dbebrc".equals(framname))
			{
			  log.debug("{}","dbebrc update...");
			  /*if(!dataChecked())
			    return false;*/
			  boolean insertBch = false;
			  if(MdaUtils.isEmpty(this.getBch().getInr()))
			    insertBch = true;
			  setBranchData();
			  int errorcode = ctx.getErrorCode();
			  //Platform.mdbBegin();
			  Platform.mdbUpdate(this.getRec());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    log.debug("{}","update pty with errorcode:" + errorcode);
			    //Platform.message(#CT000022,#CT000023);
			    //Platform.mdbRollback();
			    return false;
			  }
			  Platform.mdbUpdate(this.getAdr());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    log.debug("{}","update adr with errorcode:" + errorcode);
			    //Platform.message(#CT000024,#CT000025);
			    //Platform.mdbRollback();
			    return false;
			  }

			  if(insertBch)
			    Platform.mdbInsert(this.getBch());
			  else
			    Platform.mdbUpdate(this.getBch());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    //Platform.message(#CT000076,#CT000077);
			    //Platform.mdbCommit();
			    //Platform.mchain("dblbrc");
			    //Platform.message(#CT000078,#CT000079);
			    //Platform.mdbRollback();
			    return false;
			  }
			}

			return true;
		}
        /**
        *   source:ptygrp.@0003.script
        */
        public boolean delete(String framname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*if(Platform.prompt(#CT000038,#CT000039))
			  {
			  return false;
			  }*/
			log.debug("{}","tansaction delete....");
			log.debug("{}","framname :"+framname);

			if("dbdabk".equals(framname))
			{
			  for(int i=0;i<this.getOrilst().size();i++)
			  {
			    Platform.sdbRead(this.getFee(),this.getOrilst().getElement(i).getInr());
			    Platform.mdbDelete(this.getFee());
			    if(ctx.getErrorCode()!=NO_ERROR)
			      return false;
			  }
			  String typ = this.getRec().getPtytyp();
			  this.getRec().setPtytyp( typ.replace("T", ""));
			  log.debug("{}","pty inr:"+this.getRec().getInr());
			  Platform.mdbUpdate(this.getRec());
			  if(ctx.getErrorCode() != NO_ERROR)
			    return false;

			  this.getAct().setActbnkinr(NULLSTR);
			  Platform.mdbUpdate(this.getAct());
			  if(ctx.getErrorCode() != NO_ERROR)
			    return false;
			}
			else if ("dbdbrc".equals(framname))
			{
			  this.getRec().setStatus("1");//0-正常，1-注销，2-锁定
			  int errorcode = ctx.getErrorCode();
			  //Platform.mdbBegin();
			  Platform.mdbUpdate(this.getRec());
			  errorcode = ctx.getErrorCode();
			  if(errorcode == NO_ERROR)
			  {
			    if(!MdaUtils.isEmpty(this.getBch().getInr()))
			    {
			      this.getBch().setSta( this.getRec().getStatus());
			      Platform.mdbUpdate(this.getBch());
			      errorcode = ctx.getErrorCode();
			      if(errorcode != NO_ERROR)
			      {
			        //Platform.message(#CT000040,#CT000041);
			        //Platform.mdbRollback();
			        return false;
			      }
			    }
			    //Platform.mdbCommit();
			    //Platform.message(#CT000042,#CT000043);
			    //Platform.mchain("dblbrc");
			    //Platform.returnToCaller();
			    return true;
			  }
			  else
			  {
			    //Platform.message(#CT000084,#CT000085);
			    //Platform.mdbRollback();
			    return false;
			  }
			}
			if(ctx.getErrorCode() != NO_ERROR)
			  return false;
			else
			  return true;
		}
        /**
        *   source:ptygrp.@0004.script
        */
        public String typCancel(String otyp,String ctyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	从组合类型中剔除指定类型
			  -	otyp	原组合类型字符串
			  -	ctyp	指定剔除的类型
			  @	返回剔除之后的类型字符出
			  */
			int i = otyp.indexOf(ctyp);
			String f = otyp.substring(0,i);
			String s = otyp.substring(i+1,otyp.length());
			return f+s;
		}
        /**
        *   source:ptygrp.@0007.script
        */
        public void setBranchData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getBch().getInr()))
			  this.getBch().setInr( Platform.sdbCounter("bch"));
			this.getBch().setBchkey( this.getRec().getCid());
			this.getBch().setNam( this.getRec().getChnnam());
			this.getBch().setLev( this.getRec().getBrhlvl());
			this.getBch().setTel( this.getAdr().getTel());
			this.getBch().setPtyinr( this.getRec().getInr());
			this.getBch().setSta( this.getRec().getStatus());
		}
        /**
        *   source:ptygrp.@0008.script
        */
        public boolean checkRootBranchIsExists()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument<String> inr = new Argument<String>("inr");
			Platform.mdbExecuteSQL("select inr from bch where lev = '0'");
			Platform.mdbFetchFields(inr);
			Platform.mdbCloseCursor();
			log.debug("{}","inr:" + inr.value);
			if(!MdaUtils.isEmpty(inr))
			  return true;
			else
			  return false;
		}
        /**
        *   source:ptygrp.@0010.script
        */
        public boolean submitFee()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//扣费信息提交
			ctx.getErrorCode();
			if(this.getOrilst().size()>0)
			{
			  for(int i=0;i<this.getOrilst().size();i++)
			  {
			    log.debug("{}","fee submit del");
			    MdaUtils.clear(this.getFee());
			    Platform.sdbRead(this.getFee(),this.getOrilst().getElement(i).getInr());
			    if("D".equals(this.getOrilst().getElement(i).getOprtyp()))
			      Platform.mdbDelete(this.getFee());
			    if(ctx.getErrorCode() != NO_ERROR)
			      return false;
			  }
			}
			if(this.getFeelst().size()>0)
			{
			  for(int j=0;j<this.getFeelst().size();j++)
			  {
			    MdaUtils.clear(this.getFee());
			    Platform.sdbRead(this.getFee(),this.getFeelst().getElement(j).getInr());
			    if("A".equals(this.getFeelst().getElement(j).getOprtyp()))
			    {
			      log.debug("{}","fee submit add");
			      this.getFee().setCur( this.getFeelst().getElement(j).getCur());
			      this.getFee().setMinamt( this.getFeelst().getElement(j).getMinamt());
			      this.getFee().setMaxamt( this.getFeelst().getElement(j).getMaxamt());
			      this.getFee().setFee( this.getFeelst().getElement(j).getFee());
			      this.getFee().setActid( this.getFeelst().getElement(j).getActid());
			      this.getFee().setPtyinr( this.getFeelst().getElement(j).getPtyinr());
			      Platform.sdbInsert(this.getFee());
			      if(ctx.getErrorCode() != NO_ERROR)
			        return false;
			    }
			    if("E".equals(this.getFeelst().getElement(j).getOprtyp()))
			    {
			      log.debug("{}","fee submit ame");
			      this.getFee().setMinamt( this.getFeelst().getElement(j).getMinamt());
			      this.getFee().setMaxamt( this.getFeelst().getElement(j).getMaxamt());
			      this.getFee().setFee( this.getFeelst().getElement(j).getFee());
			      Platform.mdbUpdate(this.getFee());
			      if(ctx.getErrorCode() != NO_ERROR)
			        return false;
			    }
			  }
			}
			return true;
		}















}