package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rcvlst extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Rcvlst.class);

        //MPS表主键
        private String inr;

        //收发方向
        private String dir;

        //源渠道代码
        private String srcchncod;

        //当前渠道代码
        private String chncod;

        //下一渠道代码
        private String nxtchncod;

        //最终渠道代码
        private String tgtchncod;

        //当前报文
        private String smhinr;

        //消息处理状态
        private String sta;

        //消息回执状态
        private String rspsta;

        //消息接收时间
        private Date rcvdattim;

        //最近处理时间
        private Date lstdattim;

        //开始处理时间（需要延迟处理）
        private Date sttdattim;

        //最迟处理时间
        private Date tgtdattime;

        //发送时间
        private Date snddattim;

        //回执时间
        private Date rspdattim;

        //我方编号
        private String ownref;

        //对方编码
        private String othref;

        //发报机构代码
        private String sndbic;

        //收报机构代码
        private String rcvbic;

        //发报行的代理行
        private String t53bic;

        //清算行BIC
        private String actbic;

        //账号
        private String act;

        //币种
        private String cur;

        //金额
        private BigDecimal amt = new BigDecimal("0.00");

        //有效期
        private Date valdat;

        //消息类型(如:sf2)
        private String msgtyp;

        //消息格式类型(如:MT103)
        private String subtyp;

        //操作员
        private String usrnam;

        //处理附言
        private String excmsg;

        //费用明细
        private String dtlchg;

        //数字签名标志
        private String flg;

        //选择框
        private String chk;

        //gpi报文标识
        private String gpi;

        //uetr
        private String uetr;

        //信用证编号
        private String lcnb;

        //G渠道标志
        private String sweflg;

        //参与机构行号
        private String ptcbnk;

        //参与机构权限清单
        private String atrinf;

        //发送业务权限清单
        private String sndbns;

        //接收业务权限清单
        private String rcvbns;

        //NewField
        private String mif;

        //case编号
        private String casnum;

        //是否新核心标志
        private String xhxflg;

        //登录状态
        private String loginoprtp;

        //系统编号
        private String sid;

        //报文编号
        private String mtp;

        //业务类型编码
        private String txtpcd;

        //业务种类编码
        private String ctgpcd;

        //报文标识号
        private String mid;

        //报文发送时间
        private Date credat;

        //发起直接参与机构
        private String insgdp;

        //发起直接参与机构LEI码
        private String insdpl;

        //发起参与机构
        private String insgty;

        //发起参与机构LEI码
        private String insgpl;

        //接收直接参与机构
        private String insddp;

        //接收直接参与机构LEI码
        private String insddl;

        //接收参与机构
        private String insdty;

        //接收参与机构LEI码
        private String inspdl;

        //系统编号
        private String syscod;

        //备注
        private String rmk;

        //原申请报文标识号
        private String orgmid;

        //原申请发起参与机构
        private String orginspty;

        //原申请接收机构标识
        private String orginapty;

        //原报文类型
        private String orgmsgtyp;

        //原报文发起时间
        private Date orgsnddat;

        //业务状态
        private String stscod;

        //处理信息摘要
        private String prcmsgdig;

        //应答信息
        private String rspmsg;

        //处理状态
        private String prcsts;

        //处理码
        private String proccd;

        //拒绝信息
        private String rjcinf;

        //终态日期
        private Date sstdat;

        //接收时间
        private Date rcvdat;

        //转发时间
        private Date trndat;

        //原被查询报文标识号
        private String orpmid;

        //原被查询发起参与机构
        private String orpinspty;

        //原被查询报文类型
        private String orpinapty;

        //原业务类型代码
        private String orityp;

        //原账务日期
        private Date oridat;

        //原账务处理状态
        private String orists;

        //处理描述
        private String opinfo;

        //账务日期
        private Date oriaccdat;

        //被查询业务状态
        private String trasts;

        //订单状态
        private String bllpaysts;

        //附言
        private String remark;




		public Rcvlst()
        {
            super();
            setArgument();
        }

        public Rcvlst(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }















































































































































































}