package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Wanrec;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Chn;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rcvp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Rcvp.class);

        //查询
        private IControl schbtn;

        //清空
        private IControl clrbtn;

        //导出
        private IStream expexl = new StreamImpl();

        //接收起始时间
        private Date rcvdatsta;

        //接收截止时间
        private Date rcvdatend;

        //境外渠道
        private String chn;

        //行内系统
        private String chnipt;

        //报文标准
        private String msgtyp;

        //报文类型
        private String subtyp;

        //服务类型
        private String sty;

        //发报行BIC
        private String sndbak;

        //收报行BIC
        private String revbak;

        //清算行BIC
        private String actbic;

        //20域编号
        private String othref;

        //21域编号
        private String ownref;

        //币种
        private String cur;

        //帐号
        private String act;

        //金额下限
        private BigDecimal amtmin = new BigDecimal("0.00");

        //金额上限
        private BigDecimal amtmax = new BigDecimal("0.00");

        //行内系统标签
        private String tblvis;

        //活动标签
        private String tblvim;

        //所选择的该项
        private String selidx;

        //黑名单状态
        private String blksta;

        //账户黑名单维护
        private IControl actblk;

        //费用明细
        private String dtlchg;

        //户名黑名单维护
        private IControl namblk;

        //消息处理状态
        private String sta;

        //gpi报文标识
        private String gpi;

        //生成202报文
        private IControl gener202;

        //起息日
        private Date valdat;

        //金额
        private BigDecimal amt = new BigDecimal("0.00");

        //生成202报文
        private IControl gen202;

        //关闭页面
        private IControl close202;

        //关闭
        private IControl close;

        //账户行
        private String rcvactbic;

        //保存202报文
        private IControl sav202;

        //保存202报文
        private String msg202;

        //202报文展示
        private String msgdtl202;

        //202报文流
        private IStream stm202 = new StreamImpl();

        //报文验证信息
        private String valinf;

        //uetr
        private String uetr;

        //退报
        private IControl gjsbak;

        //确认
        private IControl gjsbakbtn;

        //批量发送
        private IControl batchsendbtn;

        //返回
        private IControl rtnbtn;

        //发送起始日期
        private Date lstdatsta;

        //发送截止日期
        private Date lstdatend;

        //行内收报起始日期标签
        private String ldsvis;

        //行内收报截止日期标签
        private String ldevis;

        //起始日期活动标签
        private String ldsvim;

        //截止日期活动标签
        private String ldevim;

        //信用证编号
        private String lcnb;

        //RETURN
        private IControl rtn;

        //新建CASE
        private IControl casebtn;

        //批量忽略
        private IControl ignorebtn;

        //全选忽略
        private IControl ignchkbtn;

        //全选CASE
        private IControl caschkbtn;

        //casflg
        private String casflg;

        //ignflg
        private String ignflg;

        //拦截类型
        private String blktyp;

        //拦截类型标签
        private String blktyplab;

        //拦截类型符号
        private String blktypvim;

        //MX报文类型
        private String dettyp;


        @JsonIgnore
        @BDGetter
        private transient IPanel schall;

        @JsonIgnore
        @BDGetter
        private transient IPanel schlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel schpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel gener202pnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel msg202pnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel gjsbakpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel xydpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel xydlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel blkpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel blkbtnpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel blkrightpnl;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Msggrp> msggrp;

	    @BDGetter
		private Chn chnxor;

	    @BDGetter
		private Mdtmod mdtmod;

	    @BDGetter
		private Maxmod maxmod;

	    @BDGetter
		private Qrtmod qrtmod;

	    @BDGetter
		private Smpmod smpmod;

	    @BDGetter
		private Wanrec wanrec;

	    @BDGetter
		private Msgmod msgmod;


		public Rcvp()
        {
            super();
            setArgument();
        }

        public Rcvp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:rcvp.@0001.script
        */
        @Rule(target="clrbtn",order=100)
        public boolean ruleClrbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//清空
			this.setChnipt(NULLSTR);
			//$rcvdatsta = Platform.formatDateTime(Platform.today(),"0");
			//$rcvdatend = Platform.formatDateTime(Platform.today(),"235959");
			//Platform.clear($msgtyp);
			this.setSubtyp(NULLSTR);
			this.setSndbak(NULLSTR);
			this.setRevbak(NULLSTR);
			this.setActbic(NULLSTR);
			this.setOthref(NULLSTR);
			this.setOwnref(NULLSTR);
			this.setUetr(NULLSTR);
			this.setCur(NULLSTR);
			this.setAct(NULLSTR);
			this.setAmtmin(new BigDecimal(0));
			this.setAmtmax(new BigDecimal(0));
			this.setBlksta(NULLSTR);
			this.setDtlchg(NULLSTR);
			this.setGpi(NULLSTR);
			this.setLcnb(NULLSTR);
			this.setSta(NULLSTR);

			//显示
			
			//Platform.setModified($rcvdatsta);
			//Platform.setModified($rcvdatend);
			//Platform.setModified($msgtyp);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			Platform.clearDatafield(MdaDriver.getDatafield(this,"lstdatsta"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"lstdatend"));


			return true;
        }

        /**
        *   source:rcvp.@0010.script
        */
        @Rule(target="expexl",order=100)
        public boolean ruleExpexlN100(){
            IContext ctx = MdaEnv.getContext();
            

			IStream is = this.getExpexl();
			is.setType("xls");
			is.setName("Msg"+MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss")+".xls");
			List<Object[]> lst = new ArrayList<Object[]>();
			String [] title= new String[57];
			title[0]="起息日";
			title[1]="20域编号";
			title[2]="21域编号";
			title[3]="币种";
			title[4]="金额";
			title[5]="账号";
			title[6]="子系统";
			title[7]="行内系统";
			title[8]="处理状态";
			title[9]="发报行BIC";
			title[10]="收报行BIC";
			title[11]="报文标准";
			title[12]="报文类型";
			title[13]="接收时间";
			title[14]="行内系统收报时间";
			title[15]="登录状态";
			title[16]="系统编号";
			title[17]="报文编号";
			title[18]="业务类型编码";
			title[19]="业务种类编码";
			title[20]="报文标识号";
			title[21]="报文发送时间";
			title[22]="发起直接参与机构";
			title[23]="发起直接参与机构LEI码";
			title[24]="发起参与机构";
			title[25]="发起参与机构LEI码";
			title[26]="接收直接参与机构";
			title[27]="接收直接参与机构LEI码";
			title[28]="接受参与机构";
			title[29]="接受参与机构LEI码";
			title[30]="系统编号";
			title[31]="备注";
			title[32]="原申请报文标识号";
			title[33]="原申请发起参与机构";
			title[34]="原申请接收机构标识";
			title[35]="原报文类型";
			title[36]="原报文发起时间";
			title[37]="业务状态";
			title[38]="处理信息摘要";
			title[39]="应答信息";
			title[40]="处理状态";
			title[41]="处理码";
			title[42]="拒绝信息";
			title[43]="终态日期";
			title[44]="接收时间";
			title[45]="转发时间";
			title[46]="原被查询报文标识号";
			title[47]="原被查询发起参与机构";
			title[48]="原被查询报文类型";
			title[49]="原业务类型代码";
			title[50]="原账务日期";
			title[51]="原账务处理状态";
			title[52]="处理描述";
			title[53]="账务日期";
			title[54]="被查询业务状态";
			title[55]="订单状态";
			title[56]="附言";
			lst.add(title);
			if(!"blksel".equals(ctx.getTransName()))
			{
			  for(int i=0;i<this.getMsggrp().getRcvlst().fullSize();i++)
			  {
			    Object [] line = new Object[57];
			    Date vludat = this.getMsggrp().getRcvlst().getElement(i).getValdat();
			    line[0]=MdaUtils.format(vludat,"yyyy-MM-dd");
			    line[1]=this.getMsggrp().getRcvlst().getElement(i).getOthref();
			    line[2]=this.getMsggrp().getRcvlst().getElement(i).getOwnref();
			    line[3]=this.getMsggrp().getRcvlst().getElement(i).getCur();
			    BigDecimal amt = this.getMsggrp().getRcvlst().getElement(i).getAmt();
			    amt = amt.setScale(2);
			    line[4]=amt.toString();
			    line[5]=this.getMsggrp().getRcvlst().getElement(i).getAct();
			    String nxtchncod = this.getMsggrp().getRcvlst().getElement(i).getNxtchncod();
			    if(MdaUtils.isEmpty(nxtchncod))
			      line[6]="";
			    else
			      line[6]=MdaUtils.getCodetableLabel("chncod",nxtchncod);
			    String chncod = this.getMsggrp().getRcvlst().getElement(i).getChncod();
			    if(MdaUtils.isEmpty(chncod))
			      line[7]="";
			    else
			      line[7]=MdaUtils.getCodetableLabel("chncod",chncod);
			    String sta = this.getMsggrp().getRcvlst().getElement(i).getSta();
			    line[8]=MdaUtils.getCodetableLabel("stacod",sta);
			    line[9]=this.getMsggrp().getRcvlst().getElement(i).getSndbic();
			    line[10]=this.getMsggrp().getRcvlst().getElement(i).getRcvbic();
			    String msgtyp = this.getMsggrp().getRcvlst().getElement(i).getMsgtyp();
			    line[11]=MdaUtils.getCodetableLabel("msgmst",msgtyp);
			    line[12]=this.getMsggrp().getRcvlst().getElement(i).getSubtyp();
			    Date rcvdattim =this.getMsggrp().getRcvlst().getElement(i).getRcvdattim();
			    line[13]=MdaUtils.format(rcvdattim,"yyyy-MM-dd HH:mm:ss");
			    Date lstdattim =this.getMsggrp().getRcvlst().getElement(i).getLstdattim();
			    line[14]=MdaUtils.format(lstdattim,"yyyy-MM-dd HH:mm:ss");
			    String loginoprtp = this.getMsggrp().getRcvlst().getElement(i).getLoginoprtp();
			    line[15]=MdaUtils.getCodetableLabel("loginoprtp",loginoprtp);
			    line[16]=this.getMsggrp().getRcvlst().getElement(i).getSid();
			    line[17]=this.getMsggrp().getRcvlst().getElement(i).getMtp();
			    line[18]=this.getMsggrp().getRcvlst().getElement(i).getTxtpcd();
			    line[19]=this.getMsggrp().getRcvlst().getElement(i).getCtgpcd();
			    line[20]=this.getMsggrp().getRcvlst().getElement(i).getMid();
			    Date credat = this.getMsggrp().getRcvlst().getElement(i).getCredat();
			    if(credat != null)
			    {
			      line[21]=MdaUtils.format(credat,"yyyy-MM-dd HH:mm:ss");
			    }
			    else
			    {
			      line[21]="";
			    }
			    line[22]=this.getMsggrp().getRcvlst().getElement(i).getInsgdp();
			    line[23]=this.getMsggrp().getRcvlst().getElement(i).getInsdpl();
			    line[24]=this.getMsggrp().getRcvlst().getElement(i).getInsgty();
			    line[25]=this.getMsggrp().getRcvlst().getElement(i).getInsgpl();
			    line[26]=this.getMsggrp().getRcvlst().getElement(i).getInsddp();
			    line[27]=this.getMsggrp().getRcvlst().getElement(i).getInsddl();
			    line[28]=this.getMsggrp().getRcvlst().getElement(i).getInsdty();
			    line[29]=this.getMsggrp().getRcvlst().getElement(i).getInspdl();
			    line[30]=this.getMsggrp().getRcvlst().getElement(i).getSyscod();
			    line[31]=this.getMsggrp().getRcvlst().getElement(i).getRmk();
			    line[32]=this.getMsggrp().getRcvlst().getElement(i).getOrgmid();
			    line[33]=this.getMsggrp().getRcvlst().getElement(i).getOrginspty();
			    line[34]=this.getMsggrp().getRcvlst().getElement(i).getOrginapty();
			    line[35]=this.getMsggrp().getRcvlst().getElement(i).getOrgmsgtyp();
			    Date orgsnddat = this.getMsggrp().getRcvlst().getElement(i).getOrgsnddat();
			    if(orgsnddat != null)
			    {
			      line[36]=MdaUtils.format(orgsnddat,"yyyy-MM-dd HH:mm:ss");
			    }
			    else
			    {
			      line[36]="";
			    }
			    line[37]=this.getMsggrp().getRcvlst().getElement(i).getStscod();
			    line[38]=this.getMsggrp().getRcvlst().getElement(i).getPrcmsgdig();
			    line[39]=this.getMsggrp().getRcvlst().getElement(i).getRspmsg();
			    line[40]=this.getMsggrp().getRcvlst().getElement(i).getPrcsts();
			    line[41]=this.getMsggrp().getRcvlst().getElement(i).getProccd();
			    line[42]=this.getMsggrp().getRcvlst().getElement(i).getRjcinf();
			    Date sstdat = this.getMsggrp().getRcvlst().getElement(i).getSstdat();
			    if(sstdat != null)
			    {
			      line[43]=MdaUtils.format(sstdat,"yyyy-MM-dd HH:mm:ss");
			    }
			    else
			    {
			      line[43]="";
			    }
			    Date rcvdat = this.getMsggrp().getRcvlst().getElement(i).getRcvdat();
			    if(rcvdat != null)
			    {
			      line[44]=MdaUtils.format(rcvdat,"yyyy-MM-dd HH:mm:ss");
			    }
			    else
			    {
			      line[44]="";
			    }
			    Date trndat = this.getMsggrp().getRcvlst().getElement(i).getTrndat();
			    if(trndat != null)
			    {
			      line[45]=MdaUtils.format(trndat,"yyyy-MM-dd HH:mm:ss");
			    }
			    else
			    {
			      line[45]="";
			    }
			    line[46]=this.getMsggrp().getRcvlst().getElement(i).getOrpmid();
			    line[47]=this.getMsggrp().getRcvlst().getElement(i).getOrpinspty();
			    line[48]=this.getMsggrp().getRcvlst().getElement(i).getOrpinapty();
			    line[49]=this.getMsggrp().getRcvlst().getElement(i).getOrityp();
			    Date oridat = this.getMsggrp().getRcvlst().getElement(i).getOridat();
			    if(oridat != null)
			    {
			      line[50]=MdaUtils.format(oridat,"yyyy-MM-dd HH:mm:ss");
			    }
			    else
			    {
			      line[50]="";
			    }
			    line[51]=this.getMsggrp().getRcvlst().getElement(i).getOrists();
			    line[52]=this.getMsggrp().getRcvlst().getElement(i).getOpinfo();
			    Date oriaccdat = this.getMsggrp().getRcvlst().getElement(i).getOriaccdat();
			    if(oriaccdat != null)
			    {
			      line[53]=MdaUtils.format(oriaccdat,"yyyy-MM-dd HH:mm:ss");
			    }
			    else
			    {
			      line[53]="";
			    }
			    line[54]=this.getMsggrp().getRcvlst().getElement(i).getTrasts();
			    line[55]=this.getMsggrp().getRcvlst().getElement(i).getBllpaysts();
			    line[56]=this.getMsggrp().getRcvlst().getElement(i).getRemark();

			    lst.add(line);
			  }
			}
			else
			{

			  for(int i=0;i<this.getMsggrp().getBlklst().fullSize();i++)
			  {
			    Object [] line = new Object[22];
			    Date vludat = this.getMsggrp().getBlklst().getElement(i).getValdat();
			    line[0]=MdaUtils.format(vludat,"yyyy-MM-dd");
			    line[1]=this.getMsggrp().getBlklst().getElement(i).getOthref();
			    line[2]=this.getMsggrp().getBlklst().getElement(i).getOwnref();
			    line[3]=this.getMsggrp().getBlklst().getElement(i).getUetr();
			    line[4]=this.getMsggrp().getBlklst().getElement(i).getGpi();
			    if("SWE".equals(this.getMsggrp().getBlklst().getElement(i).getSrcchncod()) || "SWE".equals(this.getMsggrp().getBlklst().getElement(i).getTgtchncod()))
			    {
			      line[5]="X";
			    }
			    else
			    {
			      line[5]="";
			    }
			    line[6]=this.getMsggrp().getBlklst().getElement(i).getCur();
			    BigDecimal amt = this.getMsggrp().getBlklst().getElement(i).getAmt();
			    amt = amt.setScale(2);
			    line[7]=amt.toString();
			    line[8]=this.getMsggrp().getBlklst().getElement(i).getAct();
			    line[9]=this.getMsggrp().getBlklst().getElement(i).getLcnb();
			    line[10]=this.getMsggrp().getBlklst().getElement(i).getDtlchg();
			    String nxtchncod = this.getMsggrp().getBlklst().getElement(i).getNxtchncod();
			    if(MdaUtils.isEmpty(nxtchncod))
			      line[11]="";
			    else
			      line[11]=MdaUtils.getCodetableLabel("chncod",nxtchncod);
			    String chncod = this.getMsggrp().getBlklst().getElement(i).getChncod();
			    if(MdaUtils.isEmpty(chncod))
			      line[12]="";
			    else
			      line[12]=MdaUtils.getCodetableLabel("chncod",chncod);

			    String sta = this.getMsggrp().getBlklst().getElement(i).getSta();
			    line[13]=MdaUtils.getCodetableLabel("stacod",sta);
			    line[14]=this.getMsggrp().getBlklst().getElement(i).getT53bic();
			    line[15]=this.getMsggrp().getBlklst().getElement(i).getActbic();
			    line[16]=this.getMsggrp().getBlklst().getElement(i).getSndbic();
			    line[17]=this.getMsggrp().getBlklst().getElement(i).getRcvbic();
			    String msgtyp = this.getMsggrp().getBlklst().getElement(i).getMsgtyp();
			    line[18]=MdaUtils.getCodetableLabel("msgmst",msgtyp);

			    line[19]=this.getMsggrp().getBlklst().getElement(i).getSubtyp();
			    Date rcvdattim =this.getMsggrp().getBlklst().getElement(i).getRcvdattim();
			    line[20]=MdaUtils.format(rcvdattim,"yyyy-MM-dd HH:mm:ss");
			    //lst.add(line);
			    Date lstdattim =this.getMsggrp().getBlklst().getElement(i).getLstdattim();
			    line[21]=MdaUtils.format(lstdattim,"yyyy-MM-dd HH:mm:ss");
			    lst.add(line);
			  }
			}
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }

        /**
        *   source:rcvp.@0011.script
        */
        @Rule(target="msggrp.rcvlst",order=100)
        public boolean ruleMsggrpRcvlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			//双击根据交易来跳转
			int index = 0;
			//记下选择项
			this.setSelidx( ""+index);
			log.info("{}","index:"+index);
			String mpsinr = this.getMsggrp().getRcvlst().getElement(index).getInr();
			log.debug("{}","mpsinr跳转前"+mpsinr);
			ctx.storeData("mpsinr",mpsinr);
			ctx.storeData("namecaller",ctx.getTransName());
			String blacklist = "";
			ctx.storeData("blacklist",blacklist);
			//黑名单跳转
			if("rcvsel,bl".equals(ctx.getTransName()))
			{
			  blacklist = "X";
			  ctx.storeData("blacklist",blacklist);
			  Platform.mchain("msgrtm");
			}
			//跳转到手工清分
			else if("rcvsel,rt".equals(ctx.getTransName())||"rcvsel,fm,rt".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrtm");
			}
			//跳转到收报疑似重复处理
			else if("rcvsel,rs".equals(ctx.getTransName())||"rcvsel,fm,rs".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrsm");
			}
			//跳转到无需清分再清分
			else if("rcvsel,ra".equals(ctx.getTransName()))
			{
			  //Platform.mchain("msgrtm");
			  //20190103修改，无需清分跳转至退回清分处理
			  Platform.mchain("msgrbk");
			}
			//跳转到转汇或手工清分
			else if("rcvsel,dzf".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrtm,dzf");
			}
			//跳转到国际结算退报
			else if("rcvsel,bk,GJS".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrbk");
			}
			//跳转到国际汇兑退报
			else if("rcvsel,bk,GHD".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrbk");
			}
			//跳转到资金清算退报
			else if("rcvsel,bk,ZQS".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrbk");
			}
			//20190516新增 跳转到新一代资金业务退报
			else if("rcvsel,apbk,ZYW".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrbk");
			}

			//20190516新增 跳转到新一代资金业务退报审核
			else if("rcvsel,adbk,ZYW".equals(ctx.getTransName()))
			{
			  Platform.mchain("aporbk");
			}
			//跳转到发送异常报文重发交易
			else if("exemsg".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrbk");
			}
			//20220308新增 跳转到查询查复子系统退报
			else if("rcvsel,zx".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrbk");
			}
			//跳转到查看报文交易
			else
			{
			  Platform.mchain("msgdtl");
			}

			return true;
        }

        /**
        *   source:rcvp.@0016.script
        */
        @Rule(target="schbtn",order=200)
        public boolean ruleSchbtnN200(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMsggrp().getBlklst());
			//对时间的约束
			if(MdaUtils.isEmpty(this.getRcvdatsta()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000200"),MdaUtils.getI18NString("rcvp","CT000201"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getRcvdatend()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000427"),MdaUtils.getI18NString("rcvp","CT000428"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getLstdatsta())&&!MdaUtils.isEmpty(this.getLstdatend()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000429"),MdaUtils.getI18NString("rcvp","CT000430"));
			  return true;
			}

			if(!MdaUtils.isEmpty(this.getLstdatsta())&&MdaUtils.isEmpty(this.getLstdatend()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000431"),MdaUtils.getI18NString("rcvp","CT000432"));
			  return true;
			}

			//仅允许查询半年内的报文
			if(!MdaUtils.isEmpty(this.getRcvdatend()) && !MdaUtils.isEmpty(this.getRcvdatsta()))
			{
			  long quot = 0;
			  String s1 = MdaUtils.format(this.getRcvdatend(),"yyyyMMdd");
			  Date dd = MdaUtils.parseDate(s1,"yyyyMMdd");

			  String dattim = MdaUtils.format(this.getRcvdatsta(),"yyyyMMdd");
			  Date d = MdaUtils.parseDate(dattim,"yyyyMMdd");

			  quot = dd.getTime() - d.getTime();
			  quot = quot / 1000 / 60 / 60 / 24;

			  if(quot > 180)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000441"),MdaUtils.getI18NString("rcvp","CT000442"));
			    return true;
			  }
			}

			//仅允许查询半年内的报文
			if(!MdaUtils.isEmpty(this.getLstdatend()) && !MdaUtils.isEmpty(this.getLstdatsta()))
			{
			  long quot = 0;
			  String s1 = MdaUtils.format(this.getLstdatend(),"yyyyMMdd");
			  Date dd = MdaUtils.parseDate(s1,"yyyyMMdd");

			  String dattim = MdaUtils.format(this.getLstdatsta(),"yyyyMMdd");
			  Date d = MdaUtils.parseDate(dattim,"yyyyMMdd");

			  quot = dd.getTime() - d.getTime();
			  quot = quot / 1000 / 60 / 60 / 24;

			  if(quot > 180)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000459"),MdaUtils.getI18NString("rcvp","CT000460"));
			    return true;
			  }
			}

			MdaUtils.clear(this.getMsggrp().getRcvlst());
			//组成查询用的SQL语句
			String sql = "";
			log.debug("{}","[MESSAGE_TYPE]"+this.getMsgtyp());
			log.debug("{}","transname的值:"+ctx.getTransName());
			log.debug("{}","chnipt的值:"+this.getChnipt());
			if("sf2".equals(this.getMsgtyp()))
			{
			  sql = " WHERE m1.inr=m2.inr AND m1.dir='>' AND m1.ismx = 0 and m1.pntinr IS NULL AND m2.subtyp<>'NCK' AND m2.subtyp<>'ACK' ";
			  log.debug("{}","MTSql:"+sql);
			}
			else if("mx".equals(this.getMsgtyp()))
			{
			  sql = " WHERE m1.inr=m2.inr AND m1.dir='>' AND m1.ismx = 1 AND m1.pntinr IS NULL AND m2.subtyp<>'NCK' AND m2.subtyp<>'ACK' ";
			  log.debug("{}","MXSql:"+sql);
			}
			else if("txt".equals(this.getMsgtyp()))
			{
			  sql = " WHERE m1.inr=m2.inr AND m1.dir='>' AND m1.pntinr IS NULL AND m2.subtyp<>'010' AND m2.subtyp<>'020' ";
			  //sql = " WHERE m1.inr=m2.inr AND m1.dir='>' AND m1.pntinr IS NULL ";
			}
			//20190827新增电子信用证查询语句
			else if("exl".equals(this.getMsgtyp()))
			{
			  // sql = " WHERE m1.inr=m2.inr AND m1.dir='>' AND m1.pntinr IS NULL AND m2.subtyp<>'990' and m2.subtyp<>'900'";
			  sql = " WHERE m1.inr=m2.inr AND m1.dir='>' AND m1.pntinr IS NULL AND m2.subtyp<>'990'";
			}
			else
			{
			  //sql = " WHERE m1.inr=m2.inr AND m1.dir='>' AND m1.pntinr IS NULL AND m2.subtyp<>'601' AND m2.subtyp<>'900' ";
			  sql = " WHERE m1.inr=m2.inr AND m1.dir='>' AND m1.pntinr IS NULL AND m2.subtyp<>'NCK' AND m2.subtyp<>'ACK' AND m2.subtyp<>'010' AND m2.subtyp<>'020' ";
			}
			//String  sql = " WHERE m1.inr=m2.inr AND m1.dir='>' AND m1.pntinr IS NULL AND m2.subtyp<>'NCK' AND m2.subtyp<>'ACK' AND m2.subtyp<>'010' AND m2.subtyp<>'020'";
			List sqldata = new ArrayList();
			String transname = ctx.getTransName();
			//201908 新增信用证编号
			if("exl".equals(this.getMsgtyp())&&!MdaUtils.isEmpty(this.getLcnb()))
			{
			  sql+=" AND m2.lcnb=?";
			  sqldata.add(this.getLcnb());
			}
			if("rcvsel,bl".equals(transname)||"blksel".equals(transname))
			{
			  if(MdaUtils.isEmpty(this.getBlksta()))
			  {
			    sql = sql + " AND (m1.isblk = 'C' OR m1.nxtchncod = 'BLK') ";
			  }
			  else
			  {
			    if("C".equals(this.getBlksta()))
			    {
			      sql = sql + " AND m1.isblk = 'C' ";
			    }
			    else
			    {
			      sql = sql + " AND m1.nxtchncod = 'BLK' ";
			      sql = sql + " AND m1.sta = ? ";
			      sqldata.add(this.getBlksta());
			    }
			  }
			}
			else
			{
			  if(!"rcvsel".equals(transname))
			    sql = sql + " AND m1.nxtchncod <> 'BLK' ";
			}
			//手工清分
			if("rcvsel,rt".equals(transname)||"rcvsel,fm,rt".equals(transname))
			{
			  sql = sql+" AND m1.sta='X' AND (m1.tgtchncod='XXX' OR m1.tgtchncod IS NULL)";
			}
			//需转发报文处理
			if("rcvsel,dzf".equals(transname))
			{
			  sql = sql+" AND ( m1.sta<>'D' AND m1.tgtchncod='DZF' ) ";
			}
			//疑似重复
			else if("rcvsel,rs".equals(transname)||"rcvsel,fm,rs".equals(transname))
			{
			  sql = sql+" AND m1.sta<>'F' AND m1.nxtchncod='ZZZ'";
			}
			//无需清分再清分
			else if("rcvsel,ra".equals(transname))
			{
			  sql = sql+" AND m1.sta<>'F' AND m1.nxtchncod='OOO'";
			}
			//各种退报
			else if(transname.startsWith("rcvsel,bk"))
			{
			  sql = sql+" AND m1.nxtchncod='"+transname.substring(10,13)+"' AND (m1.sta='D' OR m1.sta='W')";
			}
			// 20190517 新增退报申请查询
			else if(transname.startsWith("rcvsel,apbk"))
			{
			  sql = sql+" AND m1.nxtchncod='"+transname.substring(12,15)+"' AND (m1.sta='D' OR m1.sta='W')";
			}
			//20190517 新增退报审核查询逻辑
			else if(transname.startsWith("rcvsel,adbk"))
			{
			  sql = sql+" AND m1.nxtchncod='"+transname.substring(12,15)+"' AND m1.sta='T' ";
			}
			//20190906 新增验签失败报文查询
			else if(transname.startsWith("rcvsel,fs"))
			{
			  sql = sql+" AND m1.flg='1'";
			}
			//20220308 新增子系统退报
			else if("rcvsel,zx".equals(transname))
			{
			  sql = sql+" AND m1.nxtchncod in ('QAA','FAA')  AND (m1.sta='D' OR m1.sta='W')";
			}
			//行内系统
			if(!MdaUtils.isEmpty(this.getChnipt()))
			{
			  if("BLK".equals(this.getChnipt()))
			  {
			    sql = sql+" AND m1.nxtchncod=?";
			    sqldata.add(this.getChnipt());
			  }
			  else
			  {
			    if("wu".equals(this.getChnipt()))
			    {
			      sql = sql+" AND m1.tgtchncod IS NULL";
			    }
			    else
			    {
			      sql = sql+" AND m1.tgtchncod=?";
			      sqldata.add(this.getChnipt());
			    }
			  }
			}

			//时间开始
			if(!MdaUtils.isEmpty(this.getRcvdatsta()))
			{
			  sql = sql+" AND m1.rcvdattim>=?";
			  sqldata.add(this.getRcvdatsta());
			}
			//时间结束
			if(!MdaUtils.isEmpty(this.getRcvdatend()))
			{
			  sql = sql+" AND m1.rcvdattim<=?";
			  sqldata.add(this.getRcvdatend());
			}

			//发送时间开始
			if(!MdaUtils.isEmpty(this.getLstdatsta()))
			{
			  sql = sql+" AND m1.lstdattim>=?";
			  sqldata.add(this.getLstdatsta());
			}
			//发送时间结束
			if(!MdaUtils.isEmpty(this.getLstdatend()))
			{
			  sql = sql+" AND m1.lstdattim<=?";
			  sqldata.add(this.getLstdatend());
			}

			//报文标准
			log.info("{}","msgtyp="+this.getMsgtyp());
			if(!MdaUtils.isEmpty(this.getMsgtyp()))
			{
			  sql = sql+" AND m2.msgtyp=?";
			  sqldata.add(this.getMsgtyp());
			}
			//报文类型
			if(!MdaUtils.isEmpty(this.getSubtyp()))
			{
			  if("mx".equals(this.getMsgtyp()))
			  {
			    sql = sql + "and m2.dettyp = ?";
			  }
			  else
			  {
			    sql = sql+" AND m2.subtyp = ? ";
			  }
			  sqldata.add(this.getSubtyp());
			}
			//GPI标识
			if(!MdaUtils.isEmpty(this.getGpi()))
			{
			  //20190114 SSF 新加，‘非GPI’ 查询条件
			  if("GPI".equals(this.getGpi()))
			  {
			    sql = sql+" AND m2.gpi=?";
			    sqldata.add(this.getGpi());
			  }
			  else
			  {
			    sql = sql+" AND m2.gpi is null ";

			  }

			}
			//服务类型
			//发报行BIC
			if(!MdaUtils.isEmpty(this.getSndbak()))
			{
			  sql = sql+" AND m2.sndbic LIKE'"+"%"+this.getSndbak()+"%"+"'";
			}
			//收报行BIC
			if(!MdaUtils.isEmpty(this.getRevbak()))
			{
			  sql = sql+" AND m2.rcvbic LIKE'"+"%"+this.getRevbak()+"%"+"'";
			}
			if(!"exl".equals(this.getMsgtyp()))
			{
			  //20域编号
			  if(!MdaUtils.isEmpty(this.getOthref()))
			  {
			    sql = sql+" AND m2.othref LIKE'"+"%"+this.getOthref()+"%"+"'";
			  }
			  //21域编号
			  if(!MdaUtils.isEmpty(this.getOwnref()))
			  {
			    sql = sql+" AND m2.ownref LIKE'"+"%"+this.getOwnref()+"%"+"'";
			  }
			}
			//电子信用证
			if("exl".equals(this.getMsgtyp()))
			{
			  String s=this.getOthref();
			  String s1=this.getOwnref();
			  //20域编号
			  if(!MdaUtils.isEmpty(this.getOthref()))
			  {
			    sql = sql+" AND ( m2.othref LIKE'"+"%"+s+"%"+"'";
			    sql = sql+" OR  m2.othref LIKE'"+"%"+s.toLowerCase()+"%"+"')";
			  }
			  //21域编号
			  if(!MdaUtils.isEmpty(this.getOwnref()))
			  {
			    sql = sql+" AND ( m2.othref LIKE'"+"%"+s1+"%"+"'";
			    sql = sql+" OR  m2.othref LIKE'"+"%"+s1.toLowerCase()+"%"+"')";
			  }
			}
			//UETR
			if(!MdaUtils.isEmpty(this.getUetr()))
			{
			  sql = sql+" AND m2.uetr LIKE'"+"%"+this.getUetr()+"%"+"'";
			}
			//币种
			if(!MdaUtils.isEmpty(this.getCur()))
			{
			  sql = sql+" AND m2.cur=?";
			  sqldata.add(this.getCur());
			}
			//帐号
			if(!MdaUtils.isEmpty(this.getAct()))
			{
			  sql = sql+" AND m2.act LIKE'"+"%"+this.getAct()+"%"+"'";
			}
			//费用明细
			if(!MdaUtils.isEmpty(this.getDtlchg()))
			{
			  sql = sql+" AND m2.dtlchg=?";
			  sqldata.add(this.getDtlchg());
			}
			//金额
			if(!MdaUtils.isEmpty(this.getAmtmin()))
			{
			  sql = sql+" AND m2.amt>=?";
			  sqldata.add(this.getAmtmin());
			}
			if(!MdaUtils.isEmpty(this.getAmtmax()))
			{
			  sql = sql+" AND m2.amt<=?";
			  sqldata.add(this.getAmtmax());
			}
			//账户行BIC
			if(!MdaUtils.isEmpty(this.getActbic()))
			{
			  sql = sql+" AND (m2.actbic LIKE'"+"%"+this.getActbic()+"%"+"'"+" OR m2.t53bic LIKE'"+"%"+this.getActbic()+"%"+"')";
			}
			//处理状态
			if(!MdaUtils.isEmpty(this.getSta()))
			{
			  sql = sql+" AND m1.sta=?";
			  sqldata.add(this.getSta());
			}

			//拦截类型
			if(!MdaUtils.isEmpty(this.getBlktyp()))
			{
			  sql = sql+" AND m1.blktyp=?";
			  sqldata.add(this.getBlktyp());
			}

			//增加实体查询条件
			// sql = sql + $\\sysmod.getEtySql("m2");
			
			String maxsql="SELECT count(*) maxnum FROM mps m1,mpi m2 "+sql;
			log.info("{}","select rcv maxsql="+maxsql);

			sql = sql+" ORDER BY m1.lstdattim DESC";

			log.debug("{}","[SQL]:"+sql);
			log.debug("{}","[SQL DATA]:"+sqldata);

			// int maxcount1=$maxmod.getMaxCounterOfSelect();
			// long maxcount2=$maxmod.getCounterOfMpi(Platform.getDefaultDB(),maxsql,sqldata.toArray());
			// log.info("maxcount2="+maxcount2+" , maxcount1="+maxcount1);
			// if(maxcount2 >= maxcount1)
			// {
			//   Platform.setModified($msggrp\\rcvlst);
			//   Platform.message(#CT000461,"查询的数据总量查过:"+maxcount1+"笔,请注意查询条件!");
			//   return;
			// }
			
			Platform.mdbReadset(new IModuleList[]{this.getMsggrp().getMpss(),this.getMsggrp().getMpis()},0,sql,sqldata.toArray());
			//组合成为rcvlst
			int error =ctx.getErrorCode();
			log.info("{}","[SQL ERROR CODE]:"+error);
			log.info("{}","[DB]:"+Platform.getDefaultDB());
			if(error==NO_ERROR)
			{
			  for(int i=0;i<this.getMsggrp().getMpss().fullSize();i++)
			  {
			    //子系统和行内系统置位
			    if(!MdaUtils.isEmpty(this.getMsggrp().getMpss().getElement(i).getNxtchncod()))
			    {
			      Platform.mdbRead(this.getChnxor(),new Argument<String>("cod",EQ,this.getMsggrp().getMpss().getElement(i).getNxtchncod()));
			      if("B".equals(this.getChnxor().getTyp()) || "S".equals(this.getChnxor().getTyp()))
			      {
			        this.getMsggrp().getMpss().getElement(i).setChncod( this.getMsggrp().getMpss().getElement(i).getNxtchncod());
			        this.getMsggrp().getMpss().getElement(i).setNxtchncod(NULLSTR);
			      }
			      else if("N".equals(this.getChnxor().getTyp()))
			      {
			        this.getMsggrp().getMpss().getElement(i).setChncod(NULLSTR);
			      }
			      else
			      {
			        this.getMsggrp().getMpss().getElement(i).setChncod(NULLSTR);
			        this.getMsggrp().getMpss().getElement(i).setNxtchncod(NULLSTR);
			      }
			    }

			    if("SWE".equals(this.getMsggrp().getMpss().getElement(i).getSrcchncod()) || "SWE".equals(this.getMsggrp().getMpss().getElement(i).getTgtchncod()))
			    {
			      this.getMsggrp().getMpss().getElement(i).setSweflg( "X");
			    }

			    else
			    {
			      this.getMsggrp().getMpss().getElement(i).setSweflg(NULLSTR);
			    }

			    //20210902修改
			    if(!"blksel".equals(ctx.getTransName()))
			    {
			      log.debug("{}","将查询结果添加至rcvlst中");
					
				//	this.getMsggrp().getRcvlst().add( this.getMsggrp().getMpss().getElement(i).getDatafields().toArray(new IDatafield[0]));

					this.getMsggrp().getRcvlst().add(MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"inr"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"dir"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"srcchncod"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"chncod"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"nxtchncod"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"tgtchncod"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"smhinr"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"sta"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"rspsta"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"rcvdattim"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"lstdattim"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"tgtdattime"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"sttdattim"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"snddattim"),
							MdaDriver.getDatafield(this.getMsggrp().getMpss().getElement(i),"rspdattim"),
							MdaDriver.getDatafield(this.getMsggrp().getMpis().getElement(i),"ownref"),
							MdaDriver.getDatafield(this.getMsggrp().getMpis().getElement(i),"othref")
							);

			      //$msggrp\\rcvlst.add($msggrp\\mpss[i]\\inr,$msggrp\\mpss[i]\\dir,$msggrp\\mpss[i]\\srcchncod
			   //     ,$msggrp\\mpss[i]\\chncod,$msggrp\\mpss[i]\\nxtchncod,$msggrp\\mpss[i]\\tgtchncod
			    //    ,$msggrp\\mpss[i]\\smhinr,$msggrp\\mpss[i]\\sta,$msggrp\\mpss[i]\\rspsta
			    //    ,$msggrp\\mpss[i]\\rcvdattim,$msggrp\\mpss[i]\\lstdattim,$msggrp\\mpss[i]\\sttdattim
			    //    ,$msggrp\\mpss[i]\\tgtdattime,$msggrp\\mpss[i]\\snddattim,$msggrp\\mpss[i]\\rspdattim
			    //    ,$msggrp\\mpis[i]\\ownref,$msggrp\\mpis[i]\\othref,$msggrp\\mpis[i]\\sndbic,$msggrp\\mpis[i]\\rcvbic
			    //    ,$msggrp\\mpis[i]\\act,$msggrp\\mpis[i]\\dtlchg,$msggrp\\mpis[i]\\cur,$msggrp\\mpis[i]\\amt,$msggrp\\mpis[i]\\valdat
			     //   ,$msggrp\\mpis[i]\\msgtyp,$msggrp\\mpis[i]\\subtyp,$msggrp\\mpis[i]\\actbic,$msggrp\\mpis[i]\\t53bic,$msggrp\\mpis[i]\\gpi
			     //   ,$msggrp\\mpis[i]\\uetr,$msggrp\\mpss[i]\\lstdattim,$msggrp\\mpis[i]\\lcnb, $msggrp\\mpss[i]\\sweflg,$msggrp\\mpss[i]\\blktyp,$msggrp\\mpss[i]\\xhxflg
			     //   ,$msggrp\\mpis[i]\\loginoprtp,$msggrp\\mpis[i]\\sid,$msggrp\\mpis[i]\\mtp,$msggrp\\mpis[i]\\txtpcd,$msggrp\\mpis[i]\\ctgpcd
			     //   ,$msggrp\\mpis[i]\\mid,$msggrp\\mpis[i]\\credat,$msggrp\\mpis[i]\\insgdp,$msggrp\\mpis[i]\\insdpl,$msggrp\\mpis[i]\\insgty
			     //   ,$msggrp\\mpis[i]\\insgpl,$msggrp\\mpis[i]\\insddp,$msggrp\\mpis[i]\\insddl,$msggrp\\mpis[i]\\insdty,$msggrp\\mpis[i]\\inspdl
			     //   ,$msggrp\\mpis[i]\\syscod,$msggrp\\mpis[i]\\rmk,$msggrp\\mpis[i]\\orgmid,$msggrp\\mpis[i]\\orginspty,$msggrp\\mpis[i]\\orginapty
			     //   ,$msggrp\\mpis[i]\\orgmsgtyp,$msggrp\\mpis[i]\\orgsnddat,$msggrp\\mpis[i]\\stscod,$msggrp\\mpis[i]\\prcmsgdig,$msggrp\\mpis[i]\\rspmsg
			     //   ,$msggrp\\mpis[i]\\prcsts,$msggrp\\mpis[i]\\proccd,$msggrp\\mpis[i]\\rjcinf,$msggrp\\mpis[i]\\sstdat,$msggrp\\mpis[i]\\rcvdat
			     //   ,$msggrp\\mpis[i]\\trndat,$msggrp\\mpis[i]\\orpmid,$msggrp\\mpis[i]\\orpinspty,$msggrp\\mpis[i]\\orpinapty,$msggrp\\mpis[i]\\orityp
			      //  ,$msggrp\\mpis[i]\\oridat,$msggrp\\mpis[i]\\orists,$msggrp\\mpis[i]\\opinfo,$msggrp\\mpis[i]\\oriaccdat,$msggrp\\mpis[i]\\trasts
			      //  ,$msggrp\\mpis[i]\\bllpaysts,$msggrp\\mpis[i]\\remark);
			      if("mx".equals(this.getMsgtyp()))
			      {
			        this.getMsggrp().getRcvlst().getElement(i).setMsgtyp( this.getMsgtyp());
			        this.getMsggrp().getRcvlst().getElement(i).setSubtyp( this.getMsggrp().getMpis().getElement(i).getDettyp());
			      }
			    }
			    else
			    {
			      MdaUtils.clear(this.getQrtmod().getQrdtmp());
			      Platform.mdbRead(this.getQrtmod().getQrdtmp(),new Argument("otht20",this.getMsggrp().getMpis().getElement(i).getOthref()).and(new Argument("relref",this.getMsggrp().getMpss().getElement(i).getSmhinr())));
			      MdaUtils.clear(this.getWanrec());
			      Platform.mdbRead(this.getWanrec(),new Argument("dbs","swd"),new Argument("mpsinr",this.getMsggrp().getMpss().getElement(i).getInr()),new Argument("typ","BLK"));
			      if(!MdaUtils.isEmpty(this.getWanrec().getInr()))
			      {
			        this.getMsggrp().getMpis().getElement(i).setFlg("D");
			      }
			      else
			      {
			        this.getMsggrp().getMpis().getElement(i).setFlg("E");
			      }

			      this.getMsggrp().getBlklst().add(this.getMsggrp().getMpss().getElement(i).getInr(),this.getMsggrp().getMpss().getElement(i).getDir(),this.getMsggrp().getMpss().getElement(i).getSrcchncod(),this.getMsggrp().getMpss().getElement(i).getChncod(),this.getMsggrp().getMpss().getElement(i).getNxtchncod(),this.getMsggrp().getMpss().getElement(i).getTgtchncod(),this.getMsggrp().getMpss().getElement(i).getSmhinr(),this.getMsggrp().getMpss().getElement(i).getSta(),this.getMsggrp().getMpss().getElement(i).getRspsta(),this.getMsggrp().getMpss().getElement(i).getRcvdattim(),this.getMsggrp().getMpss().getElement(i).getLstdattim(),this.getMsggrp().getMpss().getElement(i).getSttdattim(),this.getMsggrp().getMpss().getElement(i).getTgtdattime(),this.getMsggrp().getMpss().getElement(i).getSnddattim(),this.getMsggrp().getMpss().getElement(i).getRspdattim(),this.getMsggrp().getMpis().getElement(i).getOwnref(),this.getMsggrp().getMpis().getElement(i).getOthref(),this.getMsggrp().getMpis().getElement(i).getSndbic(),this.getMsggrp().getMpis().getElement(i).getRcvbic(),this.getMsggrp().getMpis().getElement(i).getAct(),this.getMsggrp().getMpis().getElement(i).getDtlchg(),this.getMsggrp().getMpis().getElement(i).getCur(),this.getMsggrp().getMpis().getElement(i).getAmt(),this.getMsggrp().getMpis().getElement(i).getValdat(),this.getMsggrp().getMpis().getElement(i).getMsgtyp(),this.getMsggrp().getMpis().getElement(i).getSubtyp(),this.getMsggrp().getMpis().getElement(i).getActbic(),this.getMsggrp().getMpis().getElement(i).getT53bic(),this.getMsggrp().getMpis().getElement(i).getGpi(),this.getMsggrp().getMpis().getElement(i).getUetr(),this.getMsggrp().getMpss().getElement(i).getLstdattim(),this.getMsggrp().getMpis().getElement(i).getLcnb(), this.getMsggrp().getMpss().getElement(i).getSweflg(),this.getMsggrp().getMpss().getElement(i).getBlktyp(),this.getMsggrp().getMpis().getElement(i).getFlg(),this.getQrtmod().getQrdtmp().getCasnum());

			    }
			  }

			}

			if(!"blksel".equals(ctx.getTransName()))
			{
			  log.debug("{}","查出rcvlst记录"+this.getMsggrp().getRcvlst().fullSize());
			  
			  if(this.getMsggrp().getRcvlst().fullSize() == 0)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000462"),MdaUtils.getI18NString("rcvp","CT000520"));
			  }
			}
			else
			{
			  log.debug("{}","查出blklst记录"+this.getMsggrp().getBlklst().fullSize());
			  
			  if(this.getMsggrp().getBlklst().fullSize() == 0)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000624"),MdaUtils.getI18NString("rcvp","CT000625"));
			  }
			}


			return true;
        }

        /**
        *   source:rcvp.@0017.script
        */
        @Rule(target="actblk",order=100)
        public boolean ruleActblkN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("dbldta");

			return true;
        }

        /**
        *   source:rcvp.@0025.script
        */
        @Rule(target="gener202",order=100)
        public boolean ruleGener202N100(){
            IContext ctx = MdaEnv.getContext();
            
			//20180704新加方法，供业务手工生成发往账户行的202报文
			//需查找未转发前的报文信息
			this.setValdat(null);
			this.setCur(NULLSTR);
			this.setRcvactbic(NULLSTR);
			this.setOwnref(NULLSTR);
			this.setOthref(NULLSTR);
			Date dat = MdaUtils.today();
			this.setValdat(dat);
			this.setCur("USD");
			this.setRcvactbic("CITIUS33XXX");
			String sndbic = "";
			if("00000002".equals(ctx.absGet(Sysmod.class).getPty().getEtyinr()))
			{
			  sndbic = "PSBCCNBJZSH";
			}
			else
			{
			  sndbic = "PSBCCNBJXXX";
			}
			String preownref202 = "PSBC" + sndbic.substring(8) + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			String dbc = Platform.sdbCounter(preownref202,"000");
			if("000".equals(dbc))
			  dbc = Platform.sdbCounter(preownref202,"000");
			String ownref202 = preownref202 + dbc;
			this.setOwnref( ownref202);
			
			

			return true;
        }

        /**
        *   source:rcvp.@0026.script
        */
        @Rule(target="gen202",order=100)
        public boolean ruleGen202N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getOthref()) && this.getOthref().length() > 16)
			{
			  ctx.setFieldError(this,"othref",MdaUtils.getI18NString("rcvp","CT001002"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getValdat()))
			{
			  ctx.setFieldError(this,"valdat",MdaUtils.getI18NString("rcvp","CT001003"));
			  return true;
			}
			String strToday = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String s = MdaUtils.format(this.getValdat(),"yyyyMMdd");
			if(s.compareTo(strToday)>0)
			{
			  ctx.setFieldError(this,"valdat",MdaUtils.getI18NString("rcvp","CT001006"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getCur()) )
			{
			  ctx.setFieldError(this,"cur",MdaUtils.getI18NString("rcvp","CT001013"));
			  return true;
			}

			if(MdaUtils.isEmpty(this.getAmt()))
			{
			  ctx.setFieldError(this,"amt",MdaUtils.getI18NString("rcvp","CT001055"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getRcvactbic()))
			{
			  ctx.setFieldError(this,"rcvactbic",MdaUtils.getI18NString("rcvp","CT000316"));
			  return true;
			}
			this.setMsg202(NULLSTR);
			this.setMsgdtl202(NULLSTR);
			
			if(generOther202Message())//生成转汇报文
			{
			  
			  
			}

			return true;
        }

        /**
        *   source:rcvp.@0027.script
        */
        @Rule(target="close202",order=100)
        public boolean ruleClose202N100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:rcvp.@0028.script
        */
        @Rule(target="sav202",order=100)
        public boolean ruleSav202N100(){
            IContext ctx = MdaEnv.getContext();
            
			/******************************
			  *        保存202报文
			  ******************************/
			if(!validateMsg(this.getMsg202()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT001139"),this.getValinf());
			  return false;
			}
			Platform.mdbBegin();
			IStream stream202 = this.getStm202();
			if(!this.getMdtmod().getSmpmod().sf2CreateMpsAndMpiForManual(stream202,"DZF","SWT","202报文发送至账户行"))
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT001140"),MdaUtils.getI18NString("rcvp","CT001141"));
			  Platform.mdbRollback();
			  log.debug("{}","message2 save error...");
			  return false;
			}
			Platform.mdbCommit();
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT001142"),MdaUtils.getI18NString("rcvp","CT001143"));
			  Platform.mdbRollback();
			  log.debug("{}","mdbCommit error...");
			  return false;
			}
			log.debug("{}","message save successfull...");
			ctx.setMessage(MdaUtils.getI18NString("rcvp","CT001144"),MdaUtils.getI18NString("rcvp","CT001145"));
			//Platform.sdbUnLock($mdtmod\\smpmod\\mps);
			

			return true;
        }

        /**
        *   source:rcvp.@0029.script
        */
        @Rule(target="close",order=100)
        public boolean ruleCloseN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:rcvp.@0034.script
        */
        @Rule(target="gjsbak",order=100)
        public boolean ruleGjsbakN100(){
            IContext ctx = MdaEnv.getContext();
            

			int index = 0;
			log.debug("{}","index:"+index);
			if(index < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000324"),MdaUtils.getI18NString("rcvp","CT000325"));
			  return false;
			}
			MdaUtils.clear(this.getMsggrp().getGjsmsg());

			//$msggrp\\gjsmsg\\inr = $msggrp\\rcvlst[index]\\uetr.getValue();//请求报文的唯一标识
			//$msggrp\\gjsmsg\\inr = Platform.sdbCounter("TB0001","00000000000000000000000000000000");
			
			this.getMsggrp().getGjsmsg().setCod( "TB0001");//业务代码，退报
			this.getMsggrp().getGjsmsg().setOthref( this.getMsggrp().getRcvlst().getElement(index).getOthref());//报文业务编号
			this.getMsggrp().getGjsmsg().setOwnref( this.getMsggrp().getRcvlst().getElement(index).getOwnref());//报文相关业务编号
			this.getMsggrp().getGjsmsg().setSubtyp( this.getMsggrp().getRcvlst().getElement(index).getSubtyp());//报文类型
			//$msggrp\\gjsmsg\\sndbic = $msggrp\\rcvlst[index]\\sndbic.getValue();//报文发报行
			this.getMsggrp().getGjsmsg().setSnddat( this.getMsggrp().getRcvlst().getElement(index).getSnddattim());//原报文发送时间
			String msgtyp = this.getMsggrp().getRcvlst().getElement(index).getMsgtyp(); //报文格式
			String subtyp = this.getMsggrp().getRcvlst().getElement(index).getSubtyp();//报文类型
			if("sf2|txt".indexOf(msgtyp) != -1)
			{
			  Platform.setDefaultDB("swd");
			}
			else if("xml|exl".indexOf(msgtyp) != -1)
			{
			  Platform.setDefaultDB("fxd");
			}
			else
			{
			  MdaUtils.prompt(MdaUtils.getI18NString("rcvp","CT001170"),MdaUtils.getI18NString("rcvp","CT001171"));
			  return false;
			}
			MdaUtils.clear(this.getMsggrp().getMps());
			MdaUtils.clear(this.getMsggrp().getMpi());
			String othref = this.getMsggrp().getGjsmsg().getOthref();
			log.info("{}","退报报文20域编号："+ othref);
			Platform.mdbRead(this.getMsggrp().getMpi(),new Argument("othref", othref).and("msgtyp",msgtyp).and("subtyp",subtyp));
			String mpiInr = this.getMsggrp().getMpi().getInr();
			Platform.mdbRead(this.getMsggrp().getMps(),new Argument("inr", mpiInr));
			this.getMsggrp().getGjsmsg().setMessageid( this.getMsggrp().getMps().getMessageid()); //原报文标识号
			log.info("{}","退报报文messageid："+ this.getMsggrp().getMps().getMessageid());
			this.getMsggrp().getGjsmsg().setMessagechannel( this.getMsggrp().getMps().getSrcchncod());//报文渠道
			log.info("{}","退报报文messagechannel："+ this.getMsggrp().getMps().getSrcchncod());

			

			return true;
        }

        /**
        *   source:rcvp.@0036.script
        */
        @Rule(target="rtnbtn",order=100)
        public boolean ruleRtnbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:rcvp.@0037.script
        */
        @Rule(target="gjsbakbtn",order=100)
        public boolean ruleGjsbakbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.message(#CT000383,#CT000384);
			
			if(MdaUtils.isEmpty(this.getMsggrp().getGjsmsg().getBakdat()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000395"),MdaUtils.getI18NString("rcvp","CT000396"));
			  return false;
			}

			//退报请求内容，有序
			List<String> lst = new ArrayList<String>();
			String inr = Platform.sdbCounter("TB0001","00000000000000000000000000000000");
			lst.add(inr);//请求报文唯一标识
			lst.add(this.getMsggrp().getGjsmsg().getCod());//业务代码
			
			String bakdat = "";//退报请求发送时间
			if(!MdaUtils.isEmpty(this.getMsggrp().getGjsmsg().getBakdat()))
			  bakdat = MdaUtils.format(this.getMsggrp().getGjsmsg().getBakdat(),"yyyy-MM-dd");
			lst.add(bakdat);

			String messageId = this.getMsggrp().getGjsmsg().getMessageid();//原报文标识号
			log.info("{}","原报文标识号："+ messageId);
			lst.add(messageId);

			String subtyp = "";//报文类型
			if(!MdaUtils.isEmpty(this.getMsggrp().getGjsmsg().getSubtyp()))
			{
			  if("202COV".equals(this.getMsggrp().getGjsmsg().getSubtyp()))
			    subtyp = "202";
			  else
			    subtyp = this.getMsggrp().getGjsmsg().getSubtyp();
			}
			lst.add(subtyp);

			String messageChannel = this.getMsggrp().getGjsmsg().getMessagechannel();//报文渠道
			log.info("{}","报文渠道："+ this.getMsggrp().getGjsmsg().getMessagechannel());
			if(!MdaUtils.isEmpty(messageChannel))
			{
			  if("SWT".equals(messageChannel))
			  {
			    messageChannel = "MT";
			  }
			  else if("FMT".equals(messageChannel))
			  {
			    messageChannel = "FMT";
			  }
			  else if("CPS".equals(messageChannel))
			  {
			    messageChannel = "CIPS";
			  }
			  else
			  {
			    messageChannel = "ELCS";
			  }
			}
			lst.add(messageChannel);

			String othref = "";//报文业务编号
			if(!MdaUtils.isEmpty(this.getMsggrp().getGjsmsg().getOthref()))
			  othref = this.getMsggrp().getGjsmsg().getOthref();
			lst.add(othref);

			String ownref = "";//报文相关业务编号
			if(!MdaUtils.isEmpty(this.getMsggrp().getGjsmsg().getOwnref()))
			  ownref = this.getMsggrp().getGjsmsg().getOwnref();
			lst.add(ownref);

			String sndbic = "";//报文发报行
			if(!MdaUtils.isEmpty(this.getMsggrp().getGjsmsg().getSndbic()))
			{
			  sndbic = this.getMsggrp().getGjsmsg().getSndbic();
			  String bic = (String)sndbic.substring(0,8);
			  lst.add(bic);
			}
			else
			  lst.add(sndbic);

			String snddat = MdaUtils.format(this.getMsggrp().getGjsmsg().getSnddat(),"yyyy-MM-dd");
			lst.add(snddat);//原报发送时间
			
			String rmk = "";
			if(!MdaUtils.isEmpty(this.getMsggrp().getGjsmsg().getRmk()))
			  rmk = this.getMsggrp().getGjsmsg().getRmk();
			lst.add(rmk);//备注
			
			Boolean success = (Boolean)MdaUtils.invoke("cn.com.brilliance.psbc.service.gjjs.SendTBFileToGjjs","generateAndSendFile",lst);

			if(success)
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000419"),MdaUtils.getI18NString("rcvp","CT000420"));
			else
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000529"),MdaUtils.getI18NString("rcvp","CT000530"));

			

			return true;
        }

        /**
        *   source:rcvp.@0042.script
        */
        @Rule(target="rtn",order=100)
        public boolean ruleRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:rcvp.@0046.script
        */
        @Rule(target="batchsendbtn",order=100)
        public boolean ruleBatchsendbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//判断查询的列表是否为空
			if(this.getMsggrp().getRcvlst().size() <= 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000523"),MdaUtils.getI18NString("rcvp","CT000524"));
			}
			else
			{
			  int index = 0;
			  int successCount = 0;
			  for(int i=0;i<this.getMsggrp().getRcvlst().size();i++)
			  {
			    MdaUtils.clear(this.getMsggrp().getMps());
			    MdaUtils.clear(this.getMsggrp().getMpe());
			    //判断选中的每一条记录的nxtchncod 是否为空
			    if(!MdaUtils.isEmpty(this.getMsggrp().getRcvlst().getElement(i).getChk()))
			    {
			      index++;
			      log.info("{}","下一渠道："+ this.getMsggrp().getRcvlst().getElement(i).getNxtchncod());
			      if(MdaUtils.isEmpty(this.getMsggrp().getRcvlst().getElement(i).getNxtchncod()))
			      {
			        //String message = "第" + (i+1) + "条记录的下一渠道为空，无法重新发送！";
			        ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000525"),MdaUtils.getI18NString("rcvp","CT000526") + (i+1) + MdaUtils.getI18NString("rcvp","CT000527"));
			        continue;
			      }
			      else
			      {
			        Platform.mdbBegin();
			        //下一渠道不为空，并且发送状态为E的可以直接进行重新发送 ;  修改mps状态
			        this.getMsggrp().getMps().copyValue(this.getMsggrp().getMpss().getElement(i));
			        this.getMsggrp().getMps().setSta( "W");

			        /*//页面初始化时，为了页面上能正常展示报文的20 21域以及原/目标渠道，执行了下方代码将20 21域以及
			        //目标渠道  原渠道进行了交换，所以在更新rcvlst集合中每一条记录时，将数据还原
			        String srcchn = this.getMsggrp().getRcvlst().getElement(i).getTgtchncod();
			        this.getMsggrp().getRcvlst().getElement(i).setTgtchncod( this.getMsggrp().getRcvlst().getElement(i).getSrcchncod());
			        this.getMsggrp().getRcvlst().getElement(i).setSrcchncod( srcchn);
			        String othref = this.getMsggrp().getRcvlst().getElement(i).getOwnref();
			        this.getMsggrp().getRcvlst().getElement(i).setOwnref( this.getMsggrp().getRcvlst().getElement(i).getOthref());
			        this.getMsggrp().getRcvlst().getElement(i).setOthref( othref);
			        */
			        Platform.mdbUpdate(this.getMsggrp().getMps());

			        //新增mpe记录
			        this.getMsggrp().getMpe().setUsr( MdaEnv.getLoginUser());
			        this.getMsggrp().getMpe().setFrmnam( ctx.getTransName());
			        this.getMsggrp().getMpe().setMpsinr( this.getMsggrp().getRcvlst().getElement(i).getInr());
			        this.getMsggrp().getMpe().setChncod( this.getMsggrp().getRcvlst().getElement(i).getChncod());
			        this.getMsggrp().getMpe().setNxtchncod( this.getMsggrp().getRcvlst().getElement(i).getNxtchncod());
			        this.getMsggrp().getMpe().setSmhinr( this.getMsggrp().getRcvlst().getElement(i).getSmhinr());
			        this.getMsggrp().getMpe().setDattim( MdaUtils.today());
			        this.getMsggrp().getMpe().setPrvsta( this.getMsggrp().getRcvlst().getElement(i).getSta());
			        this.getMsggrp().getMpe().setSta( "W");
			        Platform.sdbInsert(this.getMsggrp().getMpe());

			        int errorCode =ctx.getErrorCode();
			        if(errorCode == NO_ERROR)
			        {
			          ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000528"),MdaUtils.getI18NString("rcvp","CT000529"));
			          Platform.mdbCommit();
			          
			          //成功，计数+1
			          successCount++;
			        }
			        else
			        {
			          ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000530"),MdaUtils.getI18NString("rcvp","CT000531"));
			          Platform.mdbRollback();
			        }
			      }
			    }
			    //index++;
			  }
			  //移除重发成功的记录，更新rcvlst 列表
			  

			  String info = "选中" + index + "条记录,成功发送" + successCount + "条,发送失败" + (index - successCount) + "条." ;
			  MdaUtils.prompt(MdaUtils.getI18NString("rcvp","CT000532"),info);
			}

			return true;
        }

        /**
        *   source:rcvp.@0047.script
        */
        @Rule(target="msggrp.blklst",order=100)
        public boolean ruleMsggrpBlklstN100(){
            IContext ctx = MdaEnv.getContext();
            
			//双击根据交易来跳转
			int index = 0;
			//记下选择项
			this.setSelidx( ""+index);
			log.info("{}","index:"+index);
			String mpsinr = this.getMsggrp().getBlklst().getElement(index).getInr();
			log.debug("{}","mpsinr跳转前"+mpsinr);
			ctx.storeData("mpsinr",mpsinr);
			ctx.storeData("namecaller",ctx.getTransName());
			String blacklist = "";
			ctx.storeData("blacklist",blacklist);

			blacklist = "X";
			ctx.storeData("blacklist",blacklist);
			Platform.mchain("msgrtm");


			return true;
        }

        /**
        *   source:rcvp.@0048.script
        */
        @Rule(target="casebtn",order=100)
        public boolean ruleCasebtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(this.getMsggrp().getBlklst().size() <= 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000857"),MdaUtils.getI18NString("rcvp","CT000858"));
			}
			else
			{
			  int index = 1;
			  int checkCount = 0;
			  int heCha = 0;
			  int uncheckCount = 0;
			  for(int i=0; i<this.getMsggrp().getBlklst().size();i++)
			  {
			    if(! MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(i).getCaschk()))
			    {
			      heCha++;
			      if(! MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(i).getCasnum()))
			      {
			        uncheckCount++;
			        String message = "第" + heCha + "行记录已创建CASE，不可再次新建.";
			        ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000859"),message);
			        return true;
			      }
			      else
			        checkCount++;
			    }
			  }

			  String message = "已选中CASE有" + heCha+ "条记录.";
			  message += "批量新建CASE" + checkCount + "条,不新建CASE" + uncheckCount + "条\r\n";
			  message += "是否确定要手动批量新建CASE?";
			  if(MdaUtils.prompt(MdaUtils.getI18NString("rcvp","CT000860"),message))
			    return false;

			  log.info("{}","begin....");

			  List<String> inrList = new ArrayList<String>();

			  Platform.mdbBegin();
			  for(int j = this.getMsggrp().getBlklst().size() - 1 ; j >=0 ; j-- )
			  {

			    if((MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(j).getCasnum())) && (!MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(j).getCaschk())))
			    {

			      String baks="";
			      if("D".equals(this.getMsggrp().getBlklst().getElement(j).getBlktyp()))
			      {
			        baks="户名";
			      }
			      else  if("E".equals(this.getMsggrp().getBlklst().getElement(j).getBlktyp()))
			      {
			        baks="账户";
			      }
			      if("F".equals(this.getMsggrp().getBlklst().getElement(j).getBlktyp()))
			      {
			        baks="炒汇";
			      }
			      MdaUtils.clear(this.getQrtmod().getQrd());
			      MdaUtils.clear(this.getQrtmod().getRof());
			      MdaUtils.clear(this.getQrtmod().getWtd());
			      MdaUtils.clear(this.getSmpmod().getMps());
			      MdaUtils.clear(this.getSmpmod().getMpi());
			      MdaUtils.clear(this.getSmpmod().getSmh());

			      /* int errorcode = Platform.errorCode();
			        if(errorcode != NO_ERROR)
			        {
			        Platform.message(#CT000861,#CT000862);
			        return Platform.falseAndRollback();
			        }*/
			      ///通过则继续新建CASE的处理
			      String casnum = this.getQrtmod().createCaseNumber();
			      log.info("{}","yypbat-casnum:"+casnum);
			      this.getQrtmod().getQrd().setCasnum(casnum);
			      this.getQrtmod().getQrd().setCassta("A");
			      this.getQrtmod().getQrd().setSettim(MdaUtils.today());
			      this.getQrtmod().getQrd().setAmdtim(MdaUtils.today());
			      this.getQrtmod().getQrd().setCurusr( MdaEnv.getLoginUser());
			      this.getQrtmod().getQrd().setRelrfn( this.getMsggrp().getBlklst().getElement(j).getOthref());//???
			      this.getQrtmod().getQrd().setOtht20( this.getMsggrp().getBlklst().getElement(j).getOthref());//???
			
			      this.getQrtmod().getQrd().setDes( "灰名单-"+ baks+"：手动批量新建CASE");
			      String dir = ">";
			      this.getQrtmod().getQrd().setRevbak( this.getMsggrp().getBlklst().getElement(j).getRcvbic());
			      this.getQrtmod().getQrd().setSedbak( this.getMsggrp().getBlklst().getElement(j).getSndbic());
			      this.getQrtmod().getQrd().setActbak( this.getMsggrp().getBlklst().getElement(j).getT53bic());
			      this.getQrtmod().getQrd().setDrfnum("");//???
			      this.getQrtmod().getQrd().setSweflg( this.getMsggrp().getBlklst().getElement(j).getSweflg());
			      String msginr =this.getMsggrp().getBlklst().getElement(j).getSmhinr();
			      this.getQrtmod().getQrd().setMsgtyp(  this.getMsggrp().getBlklst().getElement(j).getMsgtyp());
			      this.getQrtmod().getQrd().setRelref( msginr);

			      this.getQrtmod().getRof().setInr( Platform.sdbCounter("rof"));
			      this.getQrtmod().getRof().setCasnum( casnum);
			      this.getQrtmod().getRof().setMegnum( msginr);
			      this.getQrtmod().getRof().setTyp( this.getMsggrp().getBlklst().getElement(j).getSubtyp());
			      String dir1 = "";

			      dir1 = this.getMsggrp().getBlklst().getElement(j).getDir();
			      String ownref = "";
			      if(!MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(j).getOwnref()))
			        ownref = this.getMsggrp().getBlklst().getElement(j).getOwnref();
			      String othref = "";
			      if(!MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(j).getOthref()))
			        othref = this.getMsggrp().getBlklst().getElement(j).getOthref();
			      this.getQrtmod().getRof().setSevref( this.getSmpmod().getTag20(ownref,othref,dir));
			      this.getQrtmod().getRof().setRelref( this.getSmpmod().getTag21(ownref,othref,dir));
			      //灰名单不存ljd记录
			      //$qrtmod\\rof\\ljdinr = ljdinr;
			      this.getQrtmod().getRof().setObjtyp( "mpi");
			      this.getQrtmod().getRof().setObjinr( this.getMsggrp().getBlklst().getElement(j).getInr());
			      this.getQrtmod().getRof().setTrncod("633040");
			      this.getQrtmod().getRof().setSedbak(  this.getMsggrp().getBlklst().getElement(j).getSndbic());
			      this.getQrtmod().getRof().setRevbak( this.getMsggrp().getBlklst().getElement(j).getRcvbic());
			      this.getQrtmod().getRof().setRevtim( MdaUtils.today());
			      this.getQrtmod().getRof().setSweflg( this.getMsggrp().getBlklst().getElement(j).getSweflg());
			      if(!MdaUtils.isEmpty(this.getQrtmod().getQrd().getDes()))
			      {
			        String txt = this.getQrtmod().getQrd().getDes();
			        this.getQrtmod().getRof().setRem( txt);
			      }

			      this.getQrtmod().getRof().setGpi( this.getMsggrp().getBlklst().getElement(j).getGpi());

			      Platform.mdbInsert(this.getQrtmod().getRof());

			      MdaUtils.clear(this.getQrtmod().getWtd());
			      Platform.mdbRead(this.getQrtmod().getWtd(),new Argument("msginr",msginr));
			      ctx.getErrorCode();//清除查询产生的errorcode
			      if(MdaUtils.isEmpty(this.getQrtmod().getWtd().getInr()))
			      {
			        //$qrtmod\\wtd\\drfnum = "";
			        this.getQrtmod().getWtd().setCasnum( casnum);
			        this.getQrtmod().getWtd().setMsginr( msginr);

			        this.getQrtmod().getWtd().setSevref( this.getMsggrp().getBlklst().getElement(j).getOthref());
			        this.getQrtmod().getWtd().setRelref( this.getMsggrp().getBlklst().getElement(j).getOwnref());

			        this.getQrtmod().getWtd().setCur( this.getMsggrp().getBlklst().getElement(j).getCur());
			        this.getQrtmod().getWtd().setAmt( this.getMsggrp().getBlklst().getElement(j).getAmt());
			        this.getQrtmod().getWtd().setVludat( this.getMsggrp().getBlklst().getElement(j).getValdat());
			        this.getQrtmod().getWtd().setSeddat( this.getMsggrp().getBlklst().getElement(j).getRcvdattim());
			        this.getQrtmod().getWtd().setSedbak( this.getMsggrp().getBlklst().getElement(j).getSndbic());
			        this.getQrtmod().getWtd().setRevbak( this.getMsggrp().getBlklst().getElement(j).getRcvbic());
			        this.getQrtmod().getWtd().setMegrevdrt(this.getMsggrp().getBlklst().getElement(j).getDir());
			        this.getQrtmod().getWtd().setSta( "N");
			        this.getQrtmod().getWtd().setTyp( this.getMsggrp().getBlklst().getElement(j).getSubtyp());
			        //$qrtmod\\wtd\\ljdinr = ljdinr;
			        this.getQrtmod().getWtd().setSweflg( this.getMsggrp().getBlklst().getElement(j).getSweflg());
			        if(!MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(j).getUetr()))
			          this.getQrtmod().getWtd().setUetr( this.getMsggrp().getBlklst().getElement(j).getUetr());
			        if(!MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(j).getGpi()))
			          this.getQrtmod().getWtd().setGpi( this.getMsggrp().getBlklst().getElement(j).getGpi());
			        //关联所属实体
			        ctx.absGet(Sysmod.class).setEtyAndPty(this.getQrtmod().getWtd());
			        Platform.sdbInsert(this.getQrtmod().getWtd());
			      }

			      ///保存业务数据
			      String inr = Platform.sdbCounter("qrd");
			      this.getQrtmod().getQrd().setOrirofinr( this.getQrtmod().getRof().getInr());
			      this.getQrtmod().getQrd().setInr( inr);

			      if(!MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(j).getUetr()))
			        this.getQrtmod().getQrd().setUetr( this.getMsggrp().getBlklst().getElement(j).getUetr());
			      //关联所属实体
			      ctx.absGet(Sysmod.class).setEtyAndPty(this.getQrtmod().getQrd());

			      Platform.mdbInsert(this.getQrtmod().getQrd());
			      this.getQrtmod().createQreInfo(casnum, "灰名单-"+baks+"：手动批量新建CASE","X");
			      if(!MdaUtils.isEmpty(this.getQrtmod().getQrd().getRelref()))
			      {
			        this.getQrtmod().createQreInfo(casnum, "灰名单-"+ baks+"：批量新建CASE报文归档","X");
			      }
			      // inrList.add($yypgrp\\yydgrd[j]\\inr.getValue());
			      this.getMsggrp().getBlklst().getElement(j).setCasnum(casnum);
			    }
			  }
			  Platform.mdbCommit();

			  
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT000863"),MdaUtils.getI18NString("rcvp","CT000864"));
			}


			return true;
        }

        /**
        *   source:rcvp.@0049.script
        */
        @Rule(target="ignchkbtn",order=100)
        public boolean ruleIgnchkbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//全部忽略CASE
			if(this.getMsggrp().getBlklst().size()<=0)
			  return true;
			log.info("{}","ignchkbtn flg="+this.getIgnflg());
			if("1".equals(this.getIgnflg()))
			{
			  for(int i=0; i<this.getMsggrp().getBlklst().size();i++)
			  {
			    this.getMsggrp().getBlklst().getElement(i).setIgnflg("X");
			  }
			  this.setIgnflg("2");
			}
			else  if("2".equals(this.getIgnflg()))
			{
			  for(int i=0; i<this.getMsggrp().getBlklst().size();i++)
			  {
			    this.getMsggrp().getBlklst().getElement(i).setIgnflg("");
			  }
			  this.setIgnflg("1");
			}
			

			return true;
        }

        /**
        *   source:rcvp.@0050.script
        */
        @Rule(target="caschkbtn",order=100)
        public boolean ruleCaschkbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//全部选中CASE
			if(this.getMsggrp().getBlklst().size()<=0)
			  return true;
			log.info("{}","casflgbtn flg="+this.getCasflg());
			if("1".equals(this.getCasflg()))
			{
			  for(int i=0; i<this.getMsggrp().getBlklst().size();i++)
			  {
			    this.getMsggrp().getBlklst().getElement(i).setCaschk("X");
			  }
			  this.setCasflg("2");
			}
			else if("2".equals(this.getCasflg()))
			{
			  for(int i=0; i<this.getMsggrp().getBlklst().size();i++)
			  {
			    this.getMsggrp().getBlklst().getElement(i).setCaschk("");
			  }
			  this.setCasflg("1");
			}
			

			//log.info("pagesize="+$msggrp\\blklst.getPageSize());
			//  log.info("Page="+$msggrp\\blklst.getPage());
			

			return true;
        }

        /**
        *   source:rcvp.@0051.script
        */
        @Rule(target="ignorebtn",order=100)
        public boolean ruleIgnorebtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//批量忽略操作；
			if(this.getMsggrp().getBlklst().size() <= 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT001164"),MdaUtils.getI18NString("rcvp","CT001165"));
			}
			else
			{
			  int index = 1;
			  int checkCount = 0;
			  int heCha = 0;
			  int uncheckCount = 0;
			  for(int i=0; i<this.getMsggrp().getBlklst().size();i++)
			  {
			    if(! MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(i).getIgnflg()))
			    {
			      heCha++;
			    }
			  }

			  String message = "已选中忽略有" + heCha+ "条记录.\r\n是否确定忽略 ?";
			  if(MdaUtils.prompt(MdaUtils.getI18NString("rcvp","CT001166"),message))
			    return false;

			  for(int j = this.getMsggrp().getBlklst().size() - 1 ; j >=0 ; j-- )
			  {
			    if(!MdaUtils.isEmpty(this.getMsggrp().getBlklst().getElement(j).getIgnflg()))
			    {

			      MdaUtils.clear(this.getMsggrp().getMpstmp());

			      Platform.mdbRead(this.getMsggrp().getMpstmp(),new Argument("inr",this.getMsggrp().getBlklst().getElement(j).getInr()));
			      log.info("{}","blklst inr...="+this.getMsggrp().getBlklst().getElement(j).getInr());
			      ctx.getErrorCode();
			      if(!MdaUtils.isEmpty(this.getMsggrp().getMpstmp().getInr()))
			      {
			        log.info("{}","忽略INR="+this.getMsggrp().getMpstmp().getInr());
			        Platform.mdbBegin();
			        this.getMsggrp().getMpstmp().setSta("F");
			        Platform.mdbUpdate(this.getMsggrp().getMpstmp());
			        Platform.mdbCommit();
			      }
			    }
			  }
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT001167"),MdaUtils.getI18NString("rcvp","CT001168"));
			  //Platform.postEventRule($schbtn,onClick,"");
			}

			return true;
        }


        /**
        *   source:rcvp.@0007.script
        */
        @Check(target="sndbak",order=100)
        public boolean checkSndbakN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSndbak()))
			  return true;
			String sndbak = this.getSndbak();
			sndbak = sndbak.toUpperCase();
			if(!sndbak.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"sndbak",MdaUtils.getI18NString("rcvp","CT000096"));
			}
			this.setSndbak( sndbak);
			

			return true;
        }

        /**
        *   source:rcvp.@0008.script
        */
        @Check(target="revbak",order=100)
        public boolean checkRevbakN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRevbak()))
			  return true;
			String revbak = this.getRevbak();
			revbak = revbak.toUpperCase();
			if(!revbak.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"revbak",MdaUtils.getI18NString("rcvp","CT000103"));
			}
			this.setRevbak( revbak);
			

			return true;
        }

        /**
        *   source:rcvp.@0009.script
        */
        @Check(target="msgtyp",order=100)
        public boolean checkMsgtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(Platform.isEmpty($msgtyp.getValue()))
			  {
			  Platform.error($msgtyp,#CT000221);
			  return false;
			  }
			  else if("sf2".equals($msgtyp.getValue()))
			  {
			  Platform.setDefaultDB("swd");
			  Platform.setValues($subtyp,getMtyList());
			  Platform.setModified($subtyp);
			  Platform.enable($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  Platform.enable($gpi);
			  Platform.enable($uetr);
			  Platform.disable($lcnb);
			  }
			  else if("mx".equals($msgtyp.getValue()))
			  {
			  Platform.setDefaultDB("swd");
			  Platform.setValues($subtyp,getMxList());//将码表的值动态绑定给subtyp
			  Platform.setModified($subtyp);
			  Platform.enable($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  Platform.enable($gpi);
			  Platform.enable($uetr);
			  Platform.disable($lcnb);
			  }
			  else if("txt".equals($msgtyp.getValue()))
			  {
			  //境内外币业务数据库更换为swd
			  Platform.setDefaultDB("swd");
			  Platform.setValues($subtyp,getFmtList());
			  Platform.setModified($subtyp);
			  Platform.enable($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  Platform.disable($gpi);
			  Platform.clear($gpi);
			  Platform.setModified($gpi);
			  Platform.enable($uetr);
			  Platform.disable($lcnb);
			  }
			  else if("fxl".equals($msgtyp.getValue()))
			  {
			  //境内外币业务数据库更换为swd
			  Platform.setDefaultDB("swd");
			  Platform.setValues($subtyp,getFxpsList());
			  Platform.setModified($subtyp);
			  Platform.enable($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  Platform.disable($gpi);
			  Platform.clear($gpi);
			  Platform.setModified($gpi);
			  Platform.enable($uetr);
			  Platform.disable($lcnb);
			  }
			  else if("xml".equals($msgtyp.getValue()))
			  {
			  Platform.setDefaultDB("fxd");
			  Platform.setValues($subtyp,getCipsList());
			  Platform.setModified($subtyp);
			  Platform.enable($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  Platform.disable($gpi);
			  Platform.clear($gpi);
			  Platform.setModified($gpi);
			  Platform.enable($uetr);
			  Platform.disable($lcnb);
			  }
			  //20190827CCJ新增 电子信用证报文查询
			  else if("exl".equals($msgtyp.getValue()))
			  {
			  $this.elcsCfg();
			  }
			  else
			  {
			  Platform.clear($subtyp);
			  Platform.setModified($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  Platform.disable($gpi);
			  Platform.clear($gpi);
			  Platform.setModified($gpi);
			  Platform.disable($lcnb);
			  }*/

			return true;
        }

        /**
        *   source:rcvp.@0014.script
        */
        @Check(target="othref",order=100)
        public boolean checkOthrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.transAndCheckRef(MdaDriver.getDatafield(this,"othref"));

			return true;
        }

        /**
        *   source:rcvp.@0015.script
        */
        @Check(target="ownref",order=100)
        public boolean checkOwnrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.transAndCheckRef(MdaDriver.getDatafield(this,"ownref"));

			return true;
        }

        /**
        *   source:rcvp.@0023.script
        */
        @Check(target="rcvactbic",order=100)
        public boolean checkRcvactbicN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRcvactbic()))
			{
			  String scd = this.getRcvactbic();
			  this.setRcvactbic( scd.toUpperCase());
			  
			}

			return true;
        }

        /**
        *   source:rcvp.@0024.script
        */
        @Check(target="rcvactbic",order=150)
        public boolean checkRcvactbicN150(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.transAndCheckBIC(MdaDriver.getDatafield(this,"rcvactbic"));

			return true;
        }

        /**
        *   source:rcvp.@0040.script
        */
        @Check(target="uetr",order=100)
        public boolean checkUetrN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.transAndCheckUetr(MdaDriver.getDatafield(this,"uetr"));

			return true;
        }


        /**
        *   source:rcvp.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//检验是否应当重新初始化并查询
			//禁用行内系统，初始查询
			if(MdaUtils.isReturnCall())
			  return true;
			this.setTblvis( "行内系统");
			this.setTblvim( "：");

			this.setLdsvis( "行内收报起始日期");
			this.setLdsvim( "：");

			this.setLdevis( "行内收报截止日期");
			this.setLdevim( "：");

			//除了新一代异常/发送失败报文，其他均不显示
			

			if(!"rcvsel".equals(ctx.getTransName()))
			{
			  //灰显行内系统
			  
			  
			  
			  //灰显行内收报起始日期
			  
			  
			  
			  //灰显行内收报截止日期
			  
			  
			  
			  

			  ///如果某条已处理，在此处删除该条
			  String pcdsta = (String)ctx.restoreData("pcdsta");
			  if("Y".equals(pcdsta)&&MdaUtils.isReturnCall())
			  {
			    this.getMsggrp().getRcvlst().remove(MdaUtils.parseInt(this.getSelidx()));
			    return true;
			  }
			}

			//20181121新增国结退报功能
			//Platform.invisible($gjsbak);
			if("rcvsel,bk,GJS".equals(ctx.getTransName()))
			  

			//20190426新增发送异常报文重新发送交易
			if("exemsg".equals(ctx.getTransName()))
			{
			  List<CodetableItem> staList = new ArrayList<CodetableItem>();
			  staList.add(new CodetableItem("发送异常","E"));
			  staList.add(new CodetableItem("发送失败","S"));
			  MdaUtils.setValues(this,"sta",staList);
			  //设置初始值
			  this.setSta( "E");
			  
			  
			  
			  MdaUtils.setValues(this,"chnipt",getChnList());
			  this.setChnipt( "ZYW");
			  
			  
			  
			  //拦截类型灰显
			  
			  
			  
			}
			//20190516 新增新一代退报申请交易
			if("rcvsel,apbk,ZYW".equals(ctx.getTransName()))
			{
			  this.setSta( "D");
			  
			  
			  
			  MdaUtils.setValues(this,"chnipt",getChnList());
			  this.setSubtyp( "910");
			  this.setChnipt( "ZYW");
			  
			  
			  
			  //拦截类型灰显
			  
			  
			  
			}
			//20190516 新增新一代退报审核交易
			if("rcvsel,adbk,ZYW".equals(ctx.getTransName()))
			{
			  this.setSta( "T");
			  this.setSubtyp( "910");
			  
			  
			  
			  MdaUtils.setValues(this,"chnipt",getChnList());
			  this.setChnipt( "ZYW");
			  
			  
			  
			  //拦截类型灰显
			  
			  
			  
			}
			//黑名单
			// if("rcvsel,bl".equals(Platform.getTransName()))
			if("blksel".equals(ctx.getTransName())||"rcvsel,bl".equals(ctx.getTransName()))
			{
			  this.setTblvis( "黑名单状态");
			  
			  
			  
			  
			  
			  
			  
			  
			  //拦截类型显示
			  
			  
			  
			  this.setBlktyplab( "拦截类型");
			  this.setBlktypvim( "：");
			  //20210902
			  //$subtyp.setValue("103");
			
			  //Platform.visible($namblk);
			  this.setBlksta( "B");	//默认只查在黑名单状态的
			  ///如果某条已处理，在此处删除该条
			  String pcdsta = (String)ctx.restoreData("pcdsta");
			  if("Y".equals(pcdsta)&&MdaUtils.isReturnCall())
			  {
			    this.getMsggrp().getRcvlst().remove(MdaUtils.parseInt(this.getSelidx()));
			    return true;
			  }
			}
			else if("rcvsel,dzf".equals(ctx.getTransName()))
			{
			  
			  
			  
			  
			  //拦截类型灰显
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  //Platform.invisible($namblk);
			  //拦截类型灰显
			  
			  
			  
			}
			if(MdaUtils.isReturnCall())
			{
			  return true;
			}
			//暂时禁掉sty
			
			//动态列表
			/*if("sf2".equals($msgtyp.getValue()))
			  {
			  Platform.setValues($subtyp,getMtyList());
			  Platform.setModified($subtyp);
			  }
			  else if("txt".equals($msgtyp.getValue()))
			  {
			  Platform.setValues($subtyp,getFmtList());
			  Platform.setModified($subtyp);
			  }*/
			MdaUtils.setValues(this,"cur",getSysCurList());
			MdaUtils.setValues(this,"chnipt",getChnList());

			//$msgtyp = "sf2";//L改动
			List<CodetableItem> lst = new ArrayList<CodetableItem>();
			lst.add(new CodetableItem("CFIX","xml"));

			MdaUtils.setValues(this,"msgtyp",lst);
			//设置初始值
			this.setMsgtyp( "xml");
			Platform.setDefaultDB("swd");
			MdaUtils.setValues(this,"subtyp",getMtyList());
			
			String transname = ctx.getTransName();
			if("rcvsel,ra".equals(transname)||"rcvsel,dzf".equals(transname))
			{
			  
			}
			// if("rcvsel,bl".equals(Platform.getTransName()))
			if("blksel".equals(ctx.getTransName())||"rcvsel,bl".equals(ctx.getTransName()))
			{
			  this.setMsgtyp( "");
			}
			if("rcvsel,fs".equals(ctx.getTransName()))
			{
			  this.setMsgtyp( "exl");
			  
			  this.elcsCfg();
			}
			List<CodetableItem> gpilst = new ArrayList<CodetableItem>();
			gpilst.add(new CodetableItem("GPI","GPI"));
			gpilst.add(new CodetableItem("非GPI","NoGpi"));
			MdaUtils.setValues(this,"gpi",gpilst);
			if(!"sf2".equals(this.getMsgtyp()))
			{
			  
			}
			/*String frm = Platform.getTransName();
			  String[] str = frm.split(",");
			  String typ = "";
			  int len = java.lang.reflect.Array.getLength(str);
			  if( (len == 2) ||(len == 3))
			  typ = str[1];
			  log.debug("rcvsel type:"+typ);
			  if(!Platform.isEmpty(typ)&&"fm".equals(typ))
			  {
			  $msgtyp = "txt";
			  Platform.setValues($subtyp,getFmtList());
			  Platform.setModified($subtyp);
			  }
			  else
			  {
			  $msgtyp = "sf2";
			  Platform.setValues($subtyp,getMtyList());
			  Platform.setModified($subtyp);
			  }
			  Platform.disable($msgtyp);
			  Platform.setModified($msgtyp);*/

			//$chn = "SWT";
			this.setRcvdatsta( Platform.formatDateTime(MdaUtils.add(MdaUtils.today(),-3),"0"));
			this.setRcvdatend( Platform.formatDateTime(MdaUtils.today(),"235959"));
			//$lstdatsta = Platform.formatDateTime(Platform.add(Platform.today(),-3),"0");
			//$lstdatend = Platform.formatDateTime(Platform.today(),"235959");
			
			//清空显示列表
			if(this.getMsggrp().getRcvlst().fullSize() == 1 &&MdaUtils.isEmpty(this.getMsggrp().getRcvlst().getElement(0).getRcvdattim()))
			{
			  MdaUtils.clear(this.getMsggrp().getRcvlst());
			}

			return true;
        }


        /**
        *   source:rcvp.@0000.script
        */
        public List<CodetableItem> getMtyList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*//得到所有报文类型名称
			List<CodetableItem> mtyList = new ArrayList<CodetableItem>();//构造码表mtyList
			Platform.mdbExecuteSQL("SELECT mty FROM mfd WHERE tno=1 AND mty like 'MT%' AND mty not like '%s' ORDER BY mty");//执行sql语句查询记录
			Argument<String> nam = new Argument<String>("mty");//构造Label列nam
			while(true)
			{
			Platform.mdbFetchFields(nam);//逐条取出记录
			int errorCode = ctx.getErrorCode();//取出记录的执行结果
			if(errorCode == NO_ERROR)
			{
			String mtyval = nam.value;
			if(!MdaUtils.isEmpty(mtyval)&&mtyval.length()>4)
			{
			mtyval = mtyval.substring(3);
			mtyList.add(new CodetableItem(mtyval,mtyval));
			}
			}
			else
			{
			break;
			}
			}
			Platform.mdbCloseCursor();*/
			List<CodetableItem> mtyList = new ArrayList<CodetableItem>();
			mtyList.add(new CodetableItem("cfad.011.001.01","cfad.011.001.01"));
			mtyList.add(new CodetableItem("cfad.012.001.01","cfad.012.001.01"));
			mtyList.add(new CodetableItem("cfad.013.001.01","cfad.013.001.01"));
			mtyList.add(new CodetableItem("cfad.019.001.01","cfad.019.001.01"));
			mtyList.add(new CodetableItem("cfad.020.001.01","cfad.020.001.01"));
			mtyList.add(new CodetableItem("cfad.021.001.01","cfad.021.001.01"));
			mtyList.add(new CodetableItem("cfad.026.001.01","cfad.026.001.01"));
			mtyList.add(new CodetableItem("cfad.040.001.01","cfad.040.001.01"));
			mtyList.add(new CodetableItem("cfad.041.001.01","cfad.041.001.01"));
			mtyList.add(new CodetableItem("cfad.042.001.01","cfad.042.001.01"));
			mtyList.add(new CodetableItem("cfad.050.001.01","cfad.050.001.01"));
			mtyList.add(new CodetableItem("cfad.051.001.01","cfad.051.001.01"));
			mtyList.add(new CodetableItem("cfad.052.001.01","cfad.052.001.01"));
			mtyList.add(new CodetableItem("cfad.990.001.01","cfad.990.001.01"));
			mtyList.add(new CodetableItem("cfcm.001.001.01","cfcm.001.001.01"));
			mtyList.add(new CodetableItem("cfcm.002.001.01","cfcm.002.001.01"));
			mtyList.add(new CodetableItem("cfcm.003.001.01","cfcm.003.001.01"));
			mtyList.add(new CodetableItem("cfcm.101.001.01","cfcm.101.001.01"));
			mtyList.add(new CodetableItem("cfcm.102.001.01","cfcm.102.001.01"));
			mtyList.add(new CodetableItem("cfcm.301.001.01","cfcm.301.001.01"));
			mtyList.add(new CodetableItem("cfcm.302.001.01","cfcm.302.001.01"));
			mtyList.add(new CodetableItem("cfcm.900.001.01","cfcm.900.001.01"));
			mtyList.add(new CodetableItem("cfcm.998.001.01","cfcm.998.001.01"));
			return mtyList;
		}
        /**
        *   source:rcvp.@0004.script
        */
        public List<CodetableItem> getSysCurList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> curLst = new ArrayList<CodetableItem>();
			String sql = "SELECT cur,curnam FROM cur";
			Platform.mdbExecuteSQL(sql);
			Argument<String> cur = new Argument<String>("cur");
			Argument<String> curnam = new Argument<String>("curnam");
			while(true)
			{
			  Platform.mdbFetchFields(cur,curnam);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if(curnam.value != null && cur.value != null)
			    {
			      CodetableItem c = new CodetableItem(cur.value,cur.value);
			      curLst.add(c);
			    }
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return curLst;
		}
        /**
        *   source:rcvp.@0012.script
        */
        public List<CodetableItem> getChnList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//构造码表chnList
			List<CodetableItem> chnList = new ArrayList<CodetableItem>();
			Platform.mdbExecuteSQL("SELECT cod,nam FROM chn WHERE typ='B'");//执行sql语句查询记录
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  Platform.mdbFetchFields(cod,nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    chnList.add(new CodetableItem(nam.value,cod.value));
			  }
			  else
			  {
			    break;
			  }
			}
			chnList.add(new CodetableItem("无","wu"));
			Platform.mdbCloseCursor();
			return chnList;
		}
        /**
        *   source:rcvp.@0013.script
        */
        public List<CodetableItem> getAllChnList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//构造码表chnList
			List<CodetableItem> chnList = new ArrayList<CodetableItem>();
			Platform.mdbExecuteSQL("SELECT cod,nam FROM chn");//执行sql语句查询记录
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  Platform.mdbFetchFields(cod,nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    chnList.add(new CodetableItem(nam.value,cod.value));
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return chnList;
		}
        /**
        *   source:rcvp.@0019.script
        */
        public List<CodetableItem> getFmtList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//得到所有报文类型名称
			List<CodetableItem> mtyList = new ArrayList<CodetableItem>();//构造码表fmty
			Platform.mdbExecuteSQL("SELECT mty FROM mfd WHERE tno=1 AND mty like 'FMT%' ORDER BY mty");//执行sql语句查询记录
			Argument<String> nam = new Argument<String>("mty");//构造Label列nam
			while(true)
			{
			  Platform.mdbFetchFields(nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    String mtyval = nam.value;
			    if(!MdaUtils.isEmpty(mtyval)&&mtyval.length()>5)
			    {
			      mtyval = mtyval.substring(4);
			      mtyList.add(new CodetableItem(mtyval,mtyval));
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return mtyList;
		}
        /**
        *   source:rcvp.@0020.script
        */
        public List<CodetableItem> getCipsList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//得到所有报文类型名称
			List<CodetableItem> mtyList = new ArrayList<CodetableItem>();//构造码表mtyList
			Platform.mdbExecuteSQL("SELECT mty FROM mfd WHERE tno=1 AND mty like 'cips%' ORDER BY mty");//执行sql语句查询记录
			Argument<String> nam = new Argument<String>("mty");//构造Label列nam
			while(true)
			{
			  Platform.mdbFetchFields(nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  //log.error(errorCode);
			  if(errorCode==NO_ERROR)
			  {
			    String mtyval = nam.value;
			    //log.info(mtyval);
			    if(!MdaUtils.isEmpty(mtyval)&&mtyval.length()>4)
			    {
			      mtyval = mtyval.substring(5);
			      mtyList.add(new CodetableItem(mtyval,mtyval));
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return mtyList;
		}
        /**
        *   source:rcvp.@0021.script
        */
        public boolean generOther202Message()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,String> msgMap = new HashMap<String,String>();
			String sndbic = "",rcvbic = "",etyinr1 = "",etyinr2 = "";
			if("00000002".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getEtyinr()))
			{
			  etyinr1 = "00000002";
			  etyinr2 = "00000001";
			  sndbic = "PSBCCNBJZSH";
			  rcvbic = "PSBCCNBJXXX";
			}
			else
			{
			  etyinr1 = "00000001";
			  etyinr2 = "00000002";
			  sndbic = "PSBCCNBJXXX";
			  rcvbic = "PSBCCNBJZSH";
			}
			//发报行
			msgMap.put("SNDBIC",sndbic);
			String valdat = MdaUtils.format((Date)this.getValdat(),"yyMMdd");
			String amt = this.formatAmount((BigDecimal)this.getAmt());
			String tag32A = valdat + this.getCur() + amt;
			msgMap.put("32A",tag32A);
			//收报行，即账户行
			msgMap.put("RCVBIC",this.getRcvactbic());
			//发报行的代理行
			msgMap.put("53BACT",getOtherBankAccount(this.getRcvactbic(),this.getCur(),etyinr1));
			msgMap.put("OWNREF",this.getOwnref());
			if(!MdaUtils.isEmpty(this.getOthref()))
			{
			  msgMap.put("OTHREF",this.getOthref());
			}
			msgMap.put("57A",this.getRcvactbic());
			msgMap.put("58A",rcvbic);
			//收款行信息
			msgMap.put("58AACT",getOtherBankAccount(this.getRcvactbic(),this.getCur(),etyinr2));
			IStream stm202 = this.getStm202();
			MdaUtils.clear(stm202);
			String result202 = (String)MdaUtils.invoke("com.brilliance.swift.MT1XXMessageReader","generOther202MessageAndSave2",msgMap,stm202);
			if(result202==null||result202.length()<=1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT001056"),MdaUtils.getI18NString("rcvp","CT001057"));
			  return false;
			}
			String flg202 = result202.substring(0, 1);
			String msg202 = result202.substring(1);
			if("E".equals(flg202))
			{
			  ctx.setMessage(MdaUtils.getI18NString("rcvp","CT001058"),MdaUtils.getI18NString("rcvp","CT001059")+msg202);
			  return false;
			}
			this.setMsg202( msg202);
			this.setMsgdtl202( this.getMsg202());
			
			return true;
		}
        /**
        *   source:rcvp.@0022.script
        */
        public String  getOtherBankAccount(String bic,String cur,String etyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","query actid");
			if(MdaUtils.isEmpty(bic)||MdaUtils.isEmpty(cur))
			  return null;
			String act = null;
			String sql = "SELECT a.formid id FROM pty p,act a WHERE ptytyp LIKE '%T%' AND EXTKEY='"+bic+"' AND p.inr=a.actbnkinr ";
			sql = sql + " AND a.cur = '"+cur+"' ";
			if("00000001".equals(etyinr))
			{
			  sql = sql + " AND ( p.etyinr = '"+etyinr+"' OR p.etyinr is null ) ";
			}
			else
			  sql = sql +" AND p.etyinr = '"+etyinr+"' ";
			Platform.esdbExecuteSQL(sql);//执行sql语句查询记录
			Argument<String> id = new Argument<String>("id");
			while(true)
			{
			  Platform.esdbFetchFields(id);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    act = id.value;
			    log.info("{}","actid..."+act);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.esdbCloseCursor();
			return act;
		}
        /**
        *   source:rcvp.@0030.script
        */
        public String formatAmount(BigDecimal amt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	按照报文格式转化金额格式
			  - amt 待转化金额
			  @ 返回转化后的金额数据字符串
			  */
			String amtStr = amt.toString();
			///将'.'符号转化为','
			if(amtStr.contains("."))
			{
			  amtStr = amtStr.replace(".",",");
			}
			///没有'.'的在结尾添上','
			else
			{
			  amtStr += ",";
			}
			return amtStr;
		}
        /**
        *   source:rcvp.@0031.script
        */
        public Boolean validateMsg(String msg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean isFit = true;
			StringBuffer valBuf = new StringBuffer();
			Map<Integer,String> map = (Map<Integer,String>)MdaUtils.invoke("com.brilliance.swift.MessageReader","anlyMsgHead",msg);
			String two = map.get(2);
			String regex1 = "null";
			Matcher keyMatcher1 = Pattern.compile(regex1).matcher(two);
			if(keyMatcher1.find())
			{
			  valBuf.append("报文2域有缺失，请检查！");
			  isFit = false;
			}
			List<String[]> four = (List<String[]>)MdaUtils.invoke("com.brilliance.swift.MessageReader","msgTxtAnly",map.get(4));
			for(int i=0; i<four.size();i++)
			{
			  Object[] tags = four.get(i);
			  String tagnam = tags[0].toString();
			  String tagval = tags[1].toString();
			  String reg = this.getValidateReg(tagnam);
			  log.debug("{}","getValidateReg tagnam:"+tagnam);
			  log.debug("{}","getValidateReg reg:"+reg);
			  if(reg == null)
			    valBuf.append(String.format("警告：%s没有找到格式；\r\n",tagnam));
			  else if(!tagval.matches(reg))
			  {
			    valBuf.append(String.format("错误：%s的值：%s不符合格式；\r\n",tagnam,tagval));
			    isFit = false;
			  }
			}
			String valinf = valBuf.toString();
			if(MdaUtils.isEmpty(valinf))
			  valBuf.append("报文验证格式正确！");
			this.setValinf( valBuf.toString());
			return isFit;
		}
        /**
        *   source:rcvp.@0032.script
        */
        public String getValidateReg(String tagNam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return (String)MdaUtils.invoke("com.brilliance.swift.MessageReader","generValidateTagReg",tagNam);
		}
        /**
        *   source:rcvp.@0041.script
        */
        public List<CodetableItem> getElcsList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//20190827CCJ新增电子信用证查询
			//得到所有报文类型名称
			List<CodetableItem> mtyList = new ArrayList<CodetableItem>();//构造码表mtyList
			Platform.mdbExecuteSQL("SELECT mty FROM mfd WHERE tno=1 AND mty like 'elcs%' ORDER BY mty");//执行sql语句查询记录
			Argument<String> nam = new Argument<String>("mty");//构造Label列nam
			while(true)
			{
			  Platform.mdbFetchFields(nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  //log.error(errorCode);
			  if(errorCode==NO_ERROR)
			  {
			    String mtyval = nam.value;
			    //log.info(mtyval);
			    if(!MdaUtils.isEmpty(mtyval)&&mtyval.length()>4)
			    {
			      mtyval = mtyval.substring(5);
			      mtyList.add(new CodetableItem(mtyval,mtyval));
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return mtyList;
		}
        /**
        *   source:rcvp.@0043.script
        */
        public void elcsCfg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Platform.setDefaultDB("fxd");
			MdaUtils.setValues(this,"subtyp",getElcsList());
			
			
			
			this.setSty(NULLSTR);
			
			
			this.setGpi(NULLSTR);
			
			
			
		}
        /**
        *   source:rcvp.@0052.script
        */
        public List<CodetableItem> getFxpsList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//手动插入Fxps收报列表
			List<CodetableItem> fxpsList = new ArrayList<CodetableItem>();
			fxpsList.add(new CodetableItem("",""));
			fxpsList.add(new CodetableItem("141","141"));
			fxpsList.add(new CodetableItem("346","346"));
			fxpsList.add(new CodetableItem("371","371"));
			fxpsList.add(new CodetableItem("373","373"));
			fxpsList.add(new CodetableItem("604","604"));
			fxpsList.add(new CodetableItem("900","900"));
			fxpsList.add(new CodetableItem("903","903"));
			fxpsList.add(new CodetableItem("911","911"));
			fxpsList.add(new CodetableItem("921","921"));
			fxpsList.add(new CodetableItem("928","928"));
			fxpsList.add(new CodetableItem("931","931"));
			fxpsList.add(new CodetableItem("933","933"));
			fxpsList.add(new CodetableItem("990","990"));
			fxpsList.add(new CodetableItem("992","992"));

			//20220513 by tc 境内外币二阶段新增的报文类型列表  111,112,301,302,303,308,314,315，318，319，320，321，351，601，317，323，325，327，354，357，361，362，612，705，707，709，801，802，806，807，907，915，916，951，953，999
			fxpsList.add(new CodetableItem("111","111"));
			fxpsList.add(new CodetableItem("112","112"));
			fxpsList.add(new CodetableItem("301","301"));
			fxpsList.add(new CodetableItem("302","302"));
			fxpsList.add(new CodetableItem("303","303"));
			fxpsList.add(new CodetableItem("308","308"));
			fxpsList.add(new CodetableItem("314","314"));
			fxpsList.add(new CodetableItem("315","315"));
			fxpsList.add(new CodetableItem("317","317"));
			fxpsList.add(new CodetableItem("318","318"));
			fxpsList.add(new CodetableItem("319","319"));
			fxpsList.add(new CodetableItem("320","320"));
			fxpsList.add(new CodetableItem("321","321"));
			fxpsList.add(new CodetableItem("323","323"));
			fxpsList.add(new CodetableItem("325","325"));
			fxpsList.add(new CodetableItem("327","327"));
			fxpsList.add(new CodetableItem("351","351"));
			fxpsList.add(new CodetableItem("354","354"));
			fxpsList.add(new CodetableItem("357","357"));
			fxpsList.add(new CodetableItem("361","361"));
			fxpsList.add(new CodetableItem("362","362"));
			fxpsList.add(new CodetableItem("601","601"));
			fxpsList.add(new CodetableItem("612","612"));
			fxpsList.add(new CodetableItem("705","705"));
			fxpsList.add(new CodetableItem("707","707"));
			fxpsList.add(new CodetableItem("709","709"));
			fxpsList.add(new CodetableItem("801","801"));
			fxpsList.add(new CodetableItem("802","802"));
			fxpsList.add(new CodetableItem("806","806"));
			fxpsList.add(new CodetableItem("807","807"));
			fxpsList.add(new CodetableItem("907","907"));
			fxpsList.add(new CodetableItem("915","915"));
			fxpsList.add(new CodetableItem("916","916"));
			fxpsList.add(new CodetableItem("951","951"));
			fxpsList.add(new CodetableItem("953","953"));
			fxpsList.add(new CodetableItem("999","999"));
			return fxpsList;
		}
        /**
        *   source:rcvp.@0053.script
        */
        public List<CodetableItem> getMxList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//手动插入MX收报报文列表
			List<CodetableItem> mxList = new ArrayList<CodetableItem>();
			mxList.add(new CodetableItem("",""));
			mxList.add(new CodetableItem("pacs.008.001","pacs.008.001"));
			mxList.add(new CodetableItem("pacs.009.001","pacs.009.001"));
			mxList.add(new CodetableItem("camt.053.001","camt.053.001"));
			return mxList;
			/*
			  //得到所有报文类型名称
			  List<CodetableItem> mtyList = new ArrayList<CodetableItem>();//构造码表mtyList
			  Platform.mdbExecuteSQL("SELECT mty FROM mfd WHERE tno=1 AND mty like 'pacs%' ORDER BY mty");//执行sql语句查询记录
			  Argument<String> nam = new Argument<String>("mty");//构造Label列nam
			  while(true)
			  {
			  Platform.mdbFetchFields(nam);//逐条取出记录
			  int errorCode = Platform.errorCode();//取出记录的执行结果
			  //log.error(errorCode);
			  if(errorCode==NO_ERROR)
			  {
			  String mtyval = nam.value;
			  //log.info(mtyval);
			  //  if(!Platform.isEmpty(mtyval)&&mtyval.length()>4)
			  //{
			  //mtyval = mtyval.substring(5);
			  // mtyList.add(new CodetableItem(mtyval,mtyval));
			  // }
			
			  mtyList.add(new CodetableItem(mtyval,mtyval));
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  return mtyList;
			  */
		}


        public void setMsggrpHolder(ModuleHolder<Msggrp> msggrp)
        {
            this.msggrp = msggrp;
        }

        public Msggrp getMsggrp()
        {
           return this.msggrp.get();
        }






































































































































}