package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.bo.Mps;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Doe;
import com.ceb.gjjs.mda.bo.Dot;
import com.ceb.gjjs.mda.bo.Rel;
import com.ceb.gjjs.mda.bo.Rmb;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Relgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Relgrp.class);

        //记账类型
        private String typ;

        //存储3xx信息
        private Map map;

        //操作类型
        private String optyp;



	    @BDGetter
		private Dot dot;

	    @BDGetter
		private Mps mps;

	    @BDGetter
		private Rmb rmb;

		@BDGetter
		private ModuleList<Dot> dotlst;

	    @BDGetter
		private Act act;

	    @BDGetter
		private Rel rec;

	    @BDGetter
		private Smh smh;

	    @BDGetter
		private Rmb rmb320;

	    @BDGetter
		private Dot dot300;

	    @BDGetter
		private Doe doe;


		public Relgrp()
        {
            super();
            setArgument();
        }

        public Relgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:relgrp.@0008.script
        */
        public String getKpatyp(String chncod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//返回报文记账信息类型
			//输入渠道名，获得报文记账类型
			String kpatyp="0";
			if("GHD".equals(chncod))
			  kpatyp="1";
			if("GJS".equals(chncod))
			  kpatyp="2";
			if("ZQS".equals(chncod))
			  kpatyp="3";
			//还差一个资金营运，待添加
			//添加资金营运对账标志
			//2019 11 05 改动  去掉新一代记账类型
			/* if("ZYS".equals(chncod))
			  {
			  kpatyp = "4" ;
			  }*/
			/*
			  if("".equals(chncod))
			  kpatyp="4";
			  */
			return kpatyp;
		}
        /**
        *   source:relgrp.@0027.script
        */
        public String formatActbic(String tmp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//对于两行表示的5x域,获得去除账户的部分
			if(MdaUtils.isEmpty(tmp))return null;
			int secondLine =this.getLinePos(tmp);
			if (secondLine > -1)
			{
			  tmp = tmp.substring(secondLine);
			  tmp = tmp.replaceAll("\\r|\\n", "");// 去除遗留的\\r\\n
			}
			return tmp;
		}
        /**
        *   source:relgrp.@0028.script
        */
        public int getLinePos(String str)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if (str == null)
			  return -1;
			int idxr = str.indexOf("\r");
			int idxn = str.indexOf("\n");
			if (idxr > -1 && idxn > -1)// \\r\\n连接在一起
			{
			  return idxr < idxn ? idxr :
			  idxn;
			}
			else
			{
			  return idxr <= idxn ? idxn :
			  idxr;// 单个\\r或者\\n的情况，返回较大的
			}
		}
        /**
        *   source:relgrp.@0041.script
        */
        public boolean createDot()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getDot());
			MdaUtils.clear(this.getRmb());
			MdaUtils.clear(this.getDoe());
			String kpatyp=this.getTyp();//存报文记账类型
			log.info("{}","@@@@dxztsk  create dot;typ :"+kpatyp);
			String sndnum=this.getRec().getSndnum();//存报文流水号
			String mty=this.getRec().getMsgtyp();
			String objinr=this.getRec().getInr();
			Date accdat=MdaUtils.parseDate(Platform.getAccountDate(),"yyyyMMdd");
			if("103|202|202COV".indexOf(mty)>=0)
			  this.getDot().setObjtyp("rel");
			else
			  this.getDot().setObjtyp("bak");
			char dc='X';
			if("D".equals(this.getRec().getDcflg()))dc='D';
			if("C".equals(this.getRec().getDcflg()))dc='C';
			switch(dc)
			{
			  //发报，开户行参考的编号
			  case 'D':
			  this.getDot().setOwnref( this.getRec().getOthref());
			  this.getDot().setOthref( this.getRec().getOwnref());
			  this.getRmb().setOwnref( this.getRec().getOthref());
			  this.getRmb().setOthref( this.getRec().getOwnref());
			  break;
			  //收报，帐户行的编号
			  case 'C':
			  this.getDot().setOwnref( this.getRec().getOwnref());
			  this.getDot().setOthref( this.getRec().getOthref());
			  this.getRmb().setOwnref( this.getRec().getOwnref());
			  this.getRmb().setOthref( this.getRec().getOthref());
			  break;
			}
			this.getDot().setEndtid( this.getRec().getEndtid());
			this.getDot().setMty( mty);
			this.getDot().setTradat( accdat);
			this.getDot().setSndnum(sndnum);
			this.getDot().setSta( "1");
			this.getDot().setOffsta( "2");
			this.getDot().setRecsta( "2");
			this.getDot().setCredat( MdaUtils.today());
			this.getDot().setObjinr(objinr);
			this.getDot().setSedbak( this.getRec().getSedbak());
			this.getDot().setRevbak( this.getRec().getRevbak());
			this.getDot().setRsptim(this.getRec().getRsptim());
			this.getDot().setTyp(kpatyp);
			this.getDot().setMsgtyp("sf2");
			this.getDot().setLstdat(new Date());
			this.getDot().setDir(this.getMps().getDir());
			//rmb
			this.getRmb().setObjinr(objinr);
			if("103|202|202COV".indexOf(mty)>=0)
			  this.getRmb().setObjtyp("rel");
			else
			  this.getRmb().setObjtyp("bak");
			this.getRmb().setSedbak(this.getRec().getSedbak());
			this.getRmb().setRevbak(this.getRec().getRevbak());
			this.getRmb().setMty(mty);
			this.getRmb().setRsptim(this.getRec().getRsptim());
			this.getRmb().setTradat( accdat);
			this.getRmb().setCur("CNY");
			this.getRmb().setCredat(MdaUtils.today());
			this.getRmb().setTyp(kpatyp);
			this.getRmb().setSndnum(sndnum);
			//非300和320报文关联
			if(!(mty.equals("300")||mty.equals("320")))
			{
			  this.getDot().setCur( this.getRec().getCur());
			  this.getDot().setAmt( this.getRec().getAmt());
			  this.getDot().setValdat( this.getRec().getValdat());
			  this.getDot().setActbic( this.getRec().getActbic());
			  this.getDot().setAccpty( this.getRec().getAccpty());
			  if("900".equals(mty))this.getDot().setDcflg("D");
			  else this.getDot().setDcflg(this.getRec().getDcflg());
			  String dotinr = Platform.sdbCounter("dot");
			  this.getDot().setInr( dotinr);

			  //关联所属实体
			  ctx.absGet(Sysmod.class).setEtyAndPty(this.getDot(),this.getRec());

			  Platform.mdbInsert(this.getDot());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    log.info("{}","@@@@dxztsk  inset dot error,return");
			    return false;
			  }
			  if("103|202|202COV".indexOf(mty)>=0)
			    this.updateAct();
			  log.debug("{}","@@@@dxztsk  new dotinr: " + dotinr);
			}
			else
			{
			  if(!this.creDot3xx(mty))
			  {
			    log.info("{}","@@@@dxztsk  create MT3XX dot error,return");
			    return false;
			  }
			}
			log.info("{}","@@@@dxztsk  generate dots done");
			return true;
		}
        /**
        *   source:relgrp.@0042.script
        */
        public List getAllTags(String msgtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//获得报文全部的域
			if(msgtyp == null || "".equals(msgtyp))
			  return null;
			List tagList = new ArrayList();
			if (!msgtyp.startsWith("MT"))
			  msgtyp = "MT " + msgtyp;
			if (msgtyp.charAt(4) == '9')
			  msgtyp = "MT n" + msgtyp.substring(4);
			String sql = "SELECT inr,tag,fldnam,sta,cyc,mty,tno,midnam,msgdsp FROM mfd WHERE mty=? ORDER BY tno ASC";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> tag = new Argument<String>("tag");
			Argument<String> fldnam = new Argument<String>("fldnam");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> cyc = new Argument<String>("cyc");
			Argument<String> mty = new Argument<String>("mty");
			Argument<Integer> tno = new Argument<Integer>("tno");
			Argument<String> midnam = new Argument<String>("midnam");
			Argument<String> msgdsp = new Argument<String>("msgdsp");
			Platform.esdbExecuteSQL(sql,msgtyp);
			while(true)
			{
			  Platform.esdbFetchFields(tag,fldnam,sta,cyc,mty,tno,midnam);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    Map<String,String> tagMap = new HashMap<String,String>();
			    tagMap.put("inr", inr.value);
			    tagMap.put("tag", tag.value);
			    tagMap.put("fldnam",fldnam.value);
			    tagMap.put("sta", sta.value);
			    tagMap.put("cyc", cyc.value);
			    tagMap.put("mty", mty.value);
			    tagMap.put("tno", ((Integer)tno.value).toString());
			    tagMap.put("midnam", midnam.value);
			    tagMap.put("msgdsp",msgdsp.value);
			    tagList.add(tagMap);
			  }
			  else
			    break;
			}
			Platform.esdbCloseCursor();
			return tagList;
		}
        /**
        *   source:relgrp.@0043.script
        */
        public boolean creDot3xx(String mty)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//解析300的32b和33b，320的32b和34e，生成两条待对账记录
			Platform.mdbRead(this.getSmh(),new Argument<String>("inr",this.getMps().getSmhinr()));//读入smh，获取当前消息路径
			Map<String,String> map =(Map<String,String>)this.getMap();
			log.info("{}","message info "+map);
			String dc=this.getRec().getDcflg();
			String comref = map.get("comref");
			String m3xValDate=map.get("valdate"); //valdate
			String act53a=map.get("act53a");
			String act57a=map.get("act57a");
			String act53b=map.get("act53b");
			String act57b=map.get("act57b");
			if("300".equals(mty))
			{
			  String inamt= map.get("inamt");//B,1,B2,1,32B  inamt
			  String buyamt=inamt.substring(3).replace(",",".");
			  String buycur=inamt.substring(0,3);
			  String outamt=map.get("outamt");
			  String sellamt=outamt.substring(3).replace(",",".");
			  String sellcur=outamt.substring(0,3);
			  //生成出款纪录dot
			  if("CNY".equals(sellcur))
			  {
			    this.getRmb().setInr(Platform.sdbCounter("rmb"));
			    this.getRmb().setAmt(sellamt);
			    this.getRmb().setValdat(MdaUtils.parseDate(m3xValDate,"yyyyMMdd"));
			    this.getRmb().setDcflg(dc);
			    //发报流水号
			    this.getRmb().setSupdlt("卖出");
			    this.getRmb().setIsbak("1");
			    this.getRmb().setActbic(this.getRec().getActbic());
			    String inr=Platform.sdbCounter("rmb");
			    this.getRmb().setInr(inr);
			    log.info("{}","gen rmb inr="+this.getRmb().getInr());

			    //关联所属实体
			    ctx.absGet(Sysmod.class).setEtyAndPty(this.getRmb(),this.getRec());

			    Platform.mdbInsert(this.getRmb());
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      log.info("{}","rmb insert error "+mty);
			      return false;
			    }
			  }
			  else
			  {
			    this.getDot().setCur(sellcur);
			    this.getDot().setAmt(sellamt);
			    this.getDot().setValdat(MdaUtils.parseDate(m3xValDate,"yyyyMMdd"));
			    this.getDot().setDcflg(dc);
			    if(!MdaUtils.isEmpty(dc)&&"D".equals(dc))
			    {
			      if(!MdaUtils.isEmpty(act53b)&& act53b.length()<12)
			      {
			        this.getDot().setActbic( act53b);
			        log.info("{}","rec bic:"+ act53b);
			      }
			    }
			    if(!MdaUtils.isEmpty(dc)&&"C".equals(dc))
			    {
			      this.getDot().setOwnref( this.getRec().getOwnref());
			      this.getDot().setOthref( comref);
			      if(!MdaUtils.isEmpty(act57b) && act57b.length()<12)
			      {
			        this.getDot().setActbic( act57b);
			        log.info("{}","rec bic:"+ act57b);
			      }
			    }
			    this.getDot().setAccpty(  ctx.absGet(Sysmod.class).getPtyinrForBIC(this.getDot().getActbic()));
			    this.getDot().setSupdlt("卖出");
			    String dotinr=Platform.sdbCounter("dot");
			    log.info("{}","dotinr is "+dotinr);
			    this.getDot().setInr(dotinr);
			    log.info("{}","gen dot inr="+this.getDot().getInr());

			    //关联所属实体
			    ctx.absGet(Sysmod.class).setEtyAndPty(this.getDot(),this.getRec());

			    Platform.mdbInsert(this.getDot());
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      log.info("{}","dot insert error "+mty);
			      return false;
			    }
			  }
			}
			else if("320".equals(mty))
			{
			  String trnamt=map.get("trnamt"); //B,1,32B
			  String buyamt=trnamt.substring(3).replace(",",".");
			  String buycur=trnamt.substring(0,3);
			  String borl=map.get("LorB");
			  String bakdate=map.get("bakdate");
			  String interest=map.get("intamt").substring(3).replace(",",".");  //intamt
			  if("CNY".equals(buycur))
			  {
			    this.getRmb().setInr(Platform.sdbCounter("rmb"));
			    //B 借出，拆借
			    if("B".equals(borl))
			    {
			      BigDecimal total=MdaUtils.parseDecimal(buyamt);
			      BigDecimal intamt=new BigDecimal(interest);
			      total=total.add(intamt);
			      this.getRmb().setAmt(total);
			      this.getRmb().setValdat(MdaUtils.parseDate(bakdate,"yyyyMMdd"));
			      this.getRmb().setSupdlt("拆入，借入");
			    }
			    //L 借入，拆入
			    if("L".equals(borl))
			    {
			      this.getRmb().setAmt(buyamt);
			      this.getRmb().setValdat(MdaUtils.parseDate(m3xValDate,"yyyyMMdd"));
			      this.getRmb().setSupdlt("拆借，借出");
			    }
			    this.getRmb().setDcflg(dc);
			    this.getRmb().setIsbak("1");
			    this.getRmb().setActbic( this.getRec().getActbic());

			    //关联所属实体
			    ctx.absGet(Sysmod.class).setEtyAndPty(this.getRmb(),this.getRec());

			    Platform.sdbInsert(this.getRmb());
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      log.info("{}","rmb insert error "+mty);
			      return false;
			    }
			    log.info("{}","gen rmb inr :"+this.getRmb().getInr());
			  }
			  else
			  {
			    this.getDot().setCur(buycur);
			    this.getDot().setDcflg( dc);
			    //300和320的对账金额处理不同，320的借出和借入也不同
			    if("B".equals(borl))
			    {
			      BigDecimal total=MdaUtils.parseDecimal(buyamt);
			      BigDecimal intamt=new BigDecimal(interest);
			      total=total.add(intamt);
			      this.getDot().setAmt(total);
			      this.getDot().setValdat(MdaUtils.parseDate(bakdate,"yyyyMMdd"));
			      this.getDot().setSupdlt("拆入，借入");

			    }
			    if("L".equals(borl))
			    {
			      this.getDot().setAmt(buyamt);
			      this.getDot().setValdat( MdaUtils.parseDate(m3xValDate,"yyyyMMdd"));
			      this.getDot().setSupdlt("拆借，借出");
			    }
			    if(!MdaUtils.isEmpty(dc)&&"D".equals(dc))
			    {
			      if(!MdaUtils.isEmpty(act53a)&& act53a.length()<12)
			      {
			        this.getDot().setActbic( act53a);
			        log.info("{}","rec bic:"+ act53a);
			      }
			    }
			    if(!MdaUtils.isEmpty(dc)&&"C".equals(dc))
			    {
			      this.getDot().setOwnref( this.getRec().getOwnref());
			      this.getDot().setOthref( comref);
			      if(!MdaUtils.isEmpty(act57a) && act57a.length()<12)
			      {
			        this.getDot().setActbic( act57a);
			        log.info("{}","rec bic:"+ act57a);
			      }
			    }
			    this.getDot().setAccpty( ctx.absGet(Sysmod.class).getPtyinrForBIC(this.getDot().getActbic()));
			    String dotinr = Platform.sdbCounter("dot");
			    this.getDot().setInr( dotinr);
			    log.debug("{}","gen dot inr :" + dotinr);

			    //关联所属实体
			    ctx.absGet(Sysmod.class).setEtyAndPty(this.getDot(),this.getRec());

			    Platform.mdbInsert(this.getDot());
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      log.info("{}","dot insert error "+mty);
			      return false;
			    }
			  }
			}
			return true;
		}
        /**
        *   source:relgrp.@0045.script
        */
        public boolean getMap(String submty,String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//提取需要用到的各个域
			//log.info("解析，获得map");
			MdaUtils.clear(this.getMap());
			String mdir=submty.substring(0,1);
			String mty=submty.substring(1);
			String objName="com.brilliance.swift.MessageReader";
			String getDetail="splitViaFile";
			String[] sub=null;
			String tmp=null;
			Map<String,String> map=new HashMap();
			List msgpn=this.getAllTags(mty);
			List<String[]> details=(List<String[]>)MdaUtils.invoke(objName,getDetail,path,msgpn);
			if(details==null||!(details instanceof List))
			{
			  log.info("{}","@@@@dxztsk get details error,return");
			  return false;
			}
			for(int i=0;i<details.size();i++)
			{
			  sub=details.get(i);
			  if(sub[0].indexOf("A,1,82")>=0)
			  {
			    tmp=sub[1];
			    map.put("pa",tmp);
			    continue;
			  }
			  if(sub[0].indexOf("A,1,87")>=0)
			  {
			    tmp=sub[1];
			    map.put("qb",tmp);
			    continue;
			  }
			  if("A,1,21".equals(sub[0]))
			  {
			    tmp=sub[1];
			    map.put("othref",tmp);
			    continue;
			  }
			  if("A,1,22A".equals(sub[0]))
			  {
			    tmp=sub[1];
			    map.put("optyp",tmp);
			    continue;
			  }
			  if("A,1,22C".equals(sub[0]))
			  {
			    tmp=sub[1];
			    map.put("comref",tmp);
			    continue;
			  }
			  if("B,1,30V".equals(sub[0]))
			  {
			    tmp=sub[1];
			    map.put("valdate",tmp);
			    continue;
			  }
			  if("B,1,30P".equals(sub[0]))
			  {
			    tmp=sub[1];
			    map.put("bakdate",tmp);
			    continue;
			  }

			  if("B,1,B1,1,32B".equals(sub[0]))
			  {
			    tmp=sub[1];
			    if("N".equals(tmp.substring(0,1)))tmp=tmp.substring(1);
			    map.put("inamt",tmp);
			    continue;
			  }
			  if("B,1,B2,1,33B".equals(sub[0]))
			  {
			    tmp=sub[1];
			    if("N".equals(tmp.substring(0,1)))tmp=tmp.substring(1);
			    map.put("outamt",tmp);
			    continue;
			  }
			  if("B,1,32B".equals(sub[0]))
			  {
			    tmp=sub[1];
			    if("N".equals(tmp.substring(0,1)))tmp=tmp.substring(1);
			    map.put("trnamt",tmp);
			    continue;
			  }

			  if("B,1,34E".equals(sub[0]))
			  {
			    tmp=sub[1];
			    if("N".equals(tmp.substring(0,1)))tmp=tmp.substring(1);
			    map.put("intamt",tmp);
			    continue;
			  }
			  if("B,1,17R".equals(sub[0]))
			  {
			    tmp=sub[1];
			    map.put("LorB",tmp);
			    continue;
			  }
			  //300账户行问题
			  if(sub[0].indexOf("B,1,B1,1,53")>=0)
			  {
			    tmp=sub[1];
			    tmp=this.formatActbic(tmp);
			    if(!MdaUtils.isEmpty(tmp)&&tmp.length()<=8)
			    {
			      tmp=tmp+"XXX";
			    }
			    map.put("act53a",tmp);
			    continue;
			  }
			  if(sub[0].indexOf("B,1,B2,1,53")>=0)
			  {
			    tmp=sub[1];
			    tmp=this.formatActbic(tmp);
			    if(!MdaUtils.isEmpty(tmp)&&tmp.length()<=8)
			    {
			      tmp=tmp+"XXX";
			    }
			    map.put("act53b",tmp);
			    continue;
			  }
			  if(sub[0].indexOf("B,1,B1,1,57")>=0)
			  {
			    tmp=sub[1];
			    tmp=this.formatActbic(tmp);
			    if(!MdaUtils.isEmpty(tmp)&&tmp.length()<=8)
			    {
			      tmp=tmp+"XXX";
			    }
			    map.put("act57a",tmp);
			    continue;
			  }
			  if(sub[0].indexOf("B,1,B2,1,57")>=0)
			  {
			    tmp=sub[1];
			    tmp=this.formatActbic(tmp);
			    if(MdaUtils.isEmpty(tmp))
			    {
			      tmp=sub[1];
			      tmp=sub[1].replaceAll("\\n|\\r","");
			      if(!MdaUtils.isEmpty(tmp)&&tmp.length()<=8)
			        tmp=tmp+"XXX";
			    }
			    else
			    {
			      if(tmp.length()<=8)
			        tmp=tmp+"XXX";
			    }
			    map.put("act57b",tmp);
			    continue;
			  }
			  //320账户行问题
			  if(sub[0].indexOf("C,1,53")>=0)
			  {
			    tmp=sub[1];
			    tmp=this.formatActbic(tmp);
			    if(!MdaUtils.isEmpty(tmp)&&tmp.length()<=8)
			    {
			      tmp=tmp+"XXX";
			    }
			    map.put("act53a",tmp);
			    continue;
			  }
			  if(sub[0].indexOf("D,1,53")>=0)
			  {
			    tmp=sub[1];
			    tmp=this.formatActbic(tmp);
			    if(!MdaUtils.isEmpty(tmp)&&tmp.length()<=8)
			    {
			      tmp=tmp+"XXX";
			    }
			    map.put("act53b",tmp);
			    continue;
			  }
			  if(sub[0].indexOf("C,1,57")>=0)
			  {
			    tmp=sub[1];
			    tmp=this.formatActbic(tmp);
			    if(!MdaUtils.isEmpty(tmp)&&tmp.length()<=8)
			    {
			      tmp=tmp+"XXX";
			    }
			    map.put("act57a",tmp);
			    continue;
			  }
			  if(sub[0].indexOf("D,1,57")>=0)
			  {
			    tmp=sub[1];
			    tmp=this.formatActbic(tmp);
			    if(MdaUtils.isEmpty(tmp))
			    {
			      tmp=sub[1];
			      tmp=sub[1].replaceAll("\\n|\\r","");
			      if(!MdaUtils.isEmpty(tmp)&&tmp.length()<=8)
			        tmp=tmp+"XXX";
			    }
			    else
			    {
			      if(tmp.length()<=8)
			        tmp=tmp+"XXX";
			    }
			    map.put("act57b",tmp);
			    continue;
			  }
			}
			this.setMap(map);
			this.setOptyp(NULLSTR);
			this.setOptyp(map.get("optyp"));
			return true;
		}
        /**
        *   source:relgrp.@0046.script
        */
        public void updateAct()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//实时更新ACT
			log.debug("{}","进入实时更新账户");
			if(!MdaUtils.isEmpty(this.getDot().getActbic()) && !MdaUtils.isEmpty(this.getDot().getAccpty()))
			{
			  String actbicinr = this.getDot().getAccpty();
			  String cur = this.getDot().getCur();
			  Platform.esdbRead(this.getAct(),new Argument("actbnkinr",actbicinr),new Argument("cur",cur));
			  if(ctx.getErrorCode() == NO_ERROR && !MdaUtils.isEmpty(this.getAct().getInr()))
			  {
			    String db = (String)Platform.getStoredData("DefaultDB."+Platform.getModuleRoot());
			    if(!"swd".equals(db))
			    {
			      Platform.mdbCommit();
			      Platform.mdbBegin();
			    }
			    BigDecimal curBln =	this.getAct().getBln();
			    BigDecimal chgAmt = this.getDot().getAmt();
			    if("D".equals(this.getDot().getDcflg()))
			      chgAmt = chgAmt.negate();
			    curBln = curBln.add(chgAmt);
			    this.getAct().setBln(curBln);
			    Platform.mdbUpdate(this.getAct());
			    log.debug("{}","更新了账户余额");
			    if(!"swd".equals(db))
			    {
			      Platform.mdbCommit();
			      Platform.mdbBegin();
			    }
			  }
			}
		}
        /**
        *   source:relgrp.@0047.script
        */
        public boolean createFmtDot()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getDot());
			MdaUtils.clear(this.getRmb());
			MdaUtils.clear(this.getDoe());
			String kpatyp=this.getTyp();//存报文记账类型
			log.info("{}","@@@@dxztsk create fmtdot;typ :"+kpatyp);
			String sndnum=this.getRec().getSndnum();//存报文流水号
			String mty=this.getRec().getMsgtyp();
			String objinr=this.getRec().getInr();
			Date accdat=MdaUtils.parseDate(Platform.getAccountDate(),"yyyyMMdd");
			//20220614 by  tc  新增境内外币二期 111，112，301报文
			if("100|101|102|103|104|200|201|202|204|111|112|301".indexOf(mty)>=0)
			  this.getDot().setObjtyp("rel");
			else
			  this.getDot().setObjtyp("bak");
			char dc='X';
			if("D".equals(this.getRec().getDcflg())) dc='D';
			if("C".equals(this.getRec().getDcflg())) dc='C';
			switch(dc)
			{
			  //发报，开户行参考的编号
			  case 'D':
			  this.getDot().setOwnref( this.getRec().getOthref());
			  this.getDot().setOthref( this.getRec().getOwnref());
			  this.getRmb().setOwnref( this.getRec().getOthref());
			  this.getRmb().setOthref( this.getRec().getOwnref());
			  break;
			  //收报，帐户行的编号
			  case 'C':
			  this.getDot().setOwnref( this.getRec().getOwnref());
			  this.getDot().setOthref( this.getRec().getOthref());
			  this.getRmb().setOwnref( this.getRec().getOwnref());
			  this.getRmb().setOthref( this.getRec().getOthref());
			  break;
			}

			this.getDot().setMty( mty);
			this.getDot().setTradat( accdat);
			this.getDot().setSndnum( sndnum);
			this.getDot().setSta( "1");
			this.getDot().setOffsta( "2");
			this.getDot().setRecsta( "2");
			this.getDot().setCredat( MdaUtils.today());
			this.getDot().setObjinr( objinr);
			this.getDot().setSedbak( this.getRec().getSedbak());
			this.getDot().setRevbak( this.getRec().getRevbak());
			this.getDot().setRsptim(this.getRec().getRsptim());
			this.getDot().setTyp(kpatyp);

			this.getDot().setLstdat( new Date());
			this.getDot().setDir( this.getMps().getDir());

			//20220614 by  tc  做一下判断 境内外币FMT报文类型对应txt  境内外币XML报文类型对fxl
			if("100|101|102|103|104|200|201|202|204".indexOf(mty)>=0)
			{
			  this.getDot().setMsgtyp("txt");
			}
			else
			{
			  this.getDot().setMsgtyp("fxl");
			}

			//rmb
			this.getRmb().setObjinr( objinr);
			//20220614 by  tc  新增境内外币二期 111，112，301报文
			if("100|101|102|103|104|200|201|202|204|111|112|301".indexOf(mty)>=0)
			  this.getRmb().setObjtyp( "rel");
			else
			  this.getRmb().setObjtyp( "bak");
			this.getRmb().setSedbak( this.getRec().getSedbak());
			this.getRmb().setRevbak( this.getRec().getRevbak());
			this.getRmb().setMty( mty);
			this.getRmb().setRsptim( this.getRec().getRsptim());
			this.getRmb().setTradat( accdat);
			this.getRmb().setCur( "CNY");
			this.getRmb().setCredat( MdaUtils.today());
			this.getRmb().setTyp(kpatyp);
			this.getRmb().setSndnum( sndnum);

			//20160128
			this.getDot().setCur( this.getRec().getCur());
			this.getDot().setAmt( this.getRec().getAmt());
			this.getDot().setValdat( this.getRec().getValdat());
			this.getDot().setActbic( this.getRec().getActbic());
			this.getDot().setAccpty( this.getRec().getAccpty());
			this.getDot().setDcflg( this.getRec().getDcflg());
			String dotinr = Platform.sdbCounter("dot");
			this.getDot().setInr( dotinr);
			Platform.mdbInsert(this.getDot());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.info("{}","@@@@dxztsk insert fmtdot error,return");
			  return false;
			}
			//20220614 by  tc  新增境内外币二期 111，112，301报文
			if("100|101|102|103|104|200|201|202|204|111|112|301".indexOf(mty)>=0)
			  this.updateAct();
			log.debug("{}","@@@@dxztsk new fmtdotinr: " + dotinr);
			//非300和320报文关联
			/*if(!(mty.equals("300")||mty.equals("320")))
			  {
			  $dot\\cur = $rec\\cur;
			  $dot\\amt = $rec\\amt;
			  $dot\\valdat = $rec\\valdat;
			  $dot\\actbic = $rec\\actbic;
			  $dot\\accpty = $rec\\accpty;
			  if("900".equals(mty))$dot\\dcflg="D";
			  else $dot\\dcflg=$rec\\dcflg;
			  String dotinr = Platform.sdbCounter("dot");
			  $dot\\inr = dotinr;
			  Platform.mdbInsert($dot);
			  if(Platform.errorCode()!=NO_ERROR)
			  {
			  log.info("@@@@dxztsk  inset dot error,return");
			  return false;
			  }
			  if("103|202|202COV".indexOf(mty)>=0)
			  $this.updateAct();
			  log.debug("@@@@dxztsk  new dotinr: " + dotinr);
			  }
			  else
			  {
			  if(!$this.creDot3xx(mty))
			  {
			  log.info("@@@@dxztsk  create MT3XX dot error,return");
			  return false;
			  }
			  }*/
			log.info("{}","@@@@dxztsk generate fmtdots done");
			return true;
		}

















}