package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Rmk;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rmkmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Rmkmod.class);

        //htext
        private String htext;

        //ntext
        private String ntext;


        @JsonIgnore
        @BDGetter
        private transient IPanel rmkp;

        @JsonIgnore
        @BDGetter
        private transient IPanel markp;


	    @BDGetter
		private Rmk rmk;


		public Rmkmod()
        {
            super();
            setArgument();
        }

        public Rmkmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }



        /**
        *   source:rmkmod.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }


        /**
        *   source:rmkmod.@0001.script
        */
        public void saveRmk(String ordinr,String trninr,String step)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","saveRmk ordinr="+ordinr+"|trninr="+trninr+"|step="+step);
			boolean newrmk = false;//是否新增
			String txt="";
			// 如果没有rmk模块就按输入条件查询，如果已有就修改原备注
			if(MdaUtils.isEmpty(this.getRmk().getInr()))
			{
			  if(MdaUtils.isEmpty(ordinr)||MdaUtils.isEmpty(trninr))
			    return;
			  Platform.mdbRead(this.getRmk(),new Argument<String>("ordinr",ordinr),new Argument<String>("trninr",trninr));
			}
			// 如果查询后inr依然为空则 rmk视为新增
			if(MdaUtils.isEmpty(this.getRmk().getInr()))
			  newrmk=true;
			this.getRmk().setOrdinr(ordinr);
			this.getRmk().setTrninr(trninr);
			log.debug("{}","new rmk?"+newrmk);
			if(!MdaUtils.isEmpty(this.getHtext()))
			{
			  txt=this.getHtext()+"\r\n";
			}
			log.debug("{}","his  txt= "+ txt);
			// 新增当前操作的备注
			String usr=MdaEnv.getLoginUser();
			String time=MdaUtils.format(MdaUtils.today(),"yyyyMMdd HH:mm");
			String action="";
			if(MdaUtils.isEmpty(step))
			  step="0";
			action=MdaUtils.getCodetableLabel("lev",step);
			txt=txt+usr+" "+time+" "+action;
			if(!MdaUtils.isEmpty(this.getNtext()))
			{
			  log.debug("{}","info to ntxt="+this.getNtext());
			  txt=txt+"\r\n"+this.getNtext();
			}
			log.debug("{}","new txt="+txt);
			this.getRmk().setTxt(txt);
			this.getRmk().setFlg("");
			this.getRmk().setDattim(new Date());
			if(newrmk)
			{
			  this.getRmk().setInr(Platform.sdbCounter("rmk"));
			  log.debug("{}","create rmk.inr="+this.getRmk().getInr());
			  Platform.mdbInsert(this.getRmk());
			}
			else
			{
			  Platform.mdbUpdate(this.getRmk());
			  log.debug("{}","update rmk.inr="+this.getRmk().getInr());
			  this.setNtext(NULLSTR);
			}
		}






}