package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Frm;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Frr;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rolgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Rolgrp.class);

        //rec
        private String recsavflg;

        //flg
        private int flg;

        //操作柜员号
        private String operationcode;



	    @BDGetter
		private Rol rec;

	    @BDGetter
		private Frm frm;

	    @BDGetter
		private Frr frr;

		@BDGetter
		private ModuleList<Frr> oldlst;

		@BDGetter
		private ModuleList<Frr> newlst;

		@BDGetter
		private ModuleList<Frm> frmlst1;

		@BDGetter
		private ModuleList<Frm> frmlst2;

		@BDGetter
		private ModuleList<Frm> oftlst;

		@BDGetter
		private ModuleList<Rol> rollst;


		public Rolgrp()
        {
            super();
            setArgument();
        }

        public Rolgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }


        /**
        *   source:rolgrp.@0000.script
        */
        @Check(target="rec.nam",order=100)
        public boolean checkRecNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($rec\\nam.getValue()))
			  {
			  Platform.error($rec\\nam,#CT000000);
			  return false;
			  }
			  if($flg.getValue()==0)
			  {
			  String rolnam=$rec\\nam.getValue();
			  String rolnam1=rolnam.trim();
			  String sql="SELECT inr FROM rol WHERE nam='"+rolnam1+"' AND flg='0'";
			  Argument<String>inr=new Argument<String>("inr");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  Platform.error($rec\\nam,#CT000001);
			  break;
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  return false;
			  }
			  else if($flg.getValue()==1)
			  {
			  int flag = 0;
			  String rolnam=$rec\\nam.getValue();
			  rolnam=rolnam.trim();
			  String sql="SELECT inr FROM rol WHERE nam='"+rolnam+"' AND inr!='"+$rec\\inr.getValue()+"' AND flg='0'";
			  Argument<String>inr=new Argument<String>("inr");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  flag++;
			  if(flag > 0)
			  {
			  break;
			  }
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  if(flag>0)
			  {
			  Platform.error($rec\\nam,#CT000002);
			  return false;
			  }
			  }
			  else if($flg.getValue()==2)
			  {
			  }
			  */

			return true;
        }



        /**
        *   source:rolgrp.@0001.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			ctx.getErrorCode();
			this.getRec().setInr( Platform.sdbCounter("rol"));
			log.debug("{}","insert rol 生成的inr:"+this.getRec().getInr());
			log.debug("{}","rol nam:"+this.getRec().getNam());
			log.debug("{}","rol lev"+this.getRec().getLev());
			log.debug("{}","rol rellev"+this.getRec().getRellev());
			log.debug("{}","rol flg"+this.getRec().getFlg());
			Map<String,Object> map=new HashMap<String,Object>();
			//交易类型码
			map.put("PCODE", "612050");
			//交易流水号
			String sqnum="12050"+MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SEQNO",sqnum);
			//交易系统代码
			map.put("TRANSINST", "99306000000");
			//角色代码
			map.put("ROLEID", this.getRec().getInr());
			//角色名
			map.put("ROLENAME",this.getRec().getNam());
			//角色变更类型  01 c 02 u 03 d
			map.put("ROLECHGTYPE","01");
			//操作柜员号
			map.put("TELLERCODE",MdaEnv.getLoginUser());
			//本地时间
			String localTime=MdaUtils.format(MdaUtils.today(),"HHmmss");
			map.put("LOCALTIME", localTime);
			//本地日期
			String localDate=MdaUtils.format(MdaUtils.today(),"yyMMdd");
			map.put("LOCALDATE",localDate);
			//是否授权 01 非授权, 02 授权
			map.put("ISAUTH","01");
			//发送交易系统代码
			map.put("SENDINST", "99306000000");
			//接受交易系统代吗
			map.put("DESTINST","99700060000");
			//系统跟踪号 - 11位系统号+8位日期+15位流水号
			String date=MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String seqno=MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SYSTRACENO","99306000000"+date+seqno);
			map.put("MessageType", "Register");
			log.info("{}","MESSAGE MAP : "+map);
			// Map<String,Object> replyMap=(Map<String,Object>)Platform.invoke("cn.com.brilliance.teller.utils.TellerUtils","handleIFRoleChange",map);
			//  log.info("REPLY MAP:"+replyMap);
			//if("000000".equals(replyMap.get("RESPCODE")))
			// {
			//关联所属实体
			ctx.absGet(Sysmod.class).setEtyAndPty(this.getRec());

			Platform.mdbInsert(this.getRec());
			int errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			{
			  log.debug("{}","rolgrp insert rol success.");
			  return true;
			}
			else
			{
			  return false;
			}
			//}
			// else
			//{
			// Platform.message(#CT000173,#CT000174);
			//}
			//return false;
					}
        /**
        *   source:rolgrp.@0002.script
        */
        public boolean addVisibleFrm(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  角色可视交易
			  **/
			/*  for(int i=0;i<$frmlst2.fullSize();i++)
			  {
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frminr=new Argument<String>("frminr");
			  Argument<String>objinr=new Argument<String>("objinr");
			  Argument<String>objtyp=new Argument<String>("objtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  //非0的全部置为0状态，表示可视
			  if(!"0".equals($frmlst2[i]\\typ.getValue()))
			  {
			  inr.setValue(Platform.sdbCounter("frr"));
			  frminr.setValue($frmlst2[i]\\inr.getValue());
			  objinr.setValue(rolinr);
			  objtyp.setValue("rol");
			  typ.setValue("0");
			  $newlst.add(inr,frminr,objinr,objtyp,typ);
			  }
			  }*/
			if(ctx.getErrorCode() == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:rolgrp.@0003.script
        */
        public boolean addOftenFrm(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  添加到常用列表
			  **/
			/* for(int i=0;i<$oftlst.fullSize();i++)
			  {
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frminr=new Argument<String>("frminr");
			  Argument<String>objinr=new Argument<String>("objinr");
			  Argument<String>objtyp=new Argument<String>("objtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  //将非2的状态全部保存为常用状态2
			  if(!"2".equals($oftlst[i]\\typ.getValue()))
			  {
			  inr.setValue(Platform.sdbCounter("frr"));
			  frminr.setValue($oftlst[i]\\inr.getValue());
			  objinr.setValue(rolinr);
			  objtyp.setValue("rol");
			  typ.setValue("2");
			  $newlst.add(inr,frminr,objinr,objtyp,typ);
			  }
			  }*/
			if(ctx.getErrorCode() == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:rolgrp.@0004.script
        */
        public boolean addOriList(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  添加到不可见列表
			  **/
			/* for(int i=0;i<$frmlst1.fullSize();i++)
			  {
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frminr=new Argument<String>("frminr");
			  Argument<String>objinr=new Argument<String>("objinr");
			  Argument<String>objtyp=new Argument<String>("objtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  String typvalue=$frmlst1[i]\\typ.getValue();
			  //非1的状态全部保存为不可视状态
			  if(!"1".equals(typvalue))
			  {
			  inr.setValue(Platform.sdbCounter("frr"));
			  frminr.setValue($frmlst1[i]\\inr.getValue());
			  objinr.setValue(rolinr);
			  objtyp.setValue("rol");
			  typ.setValue("1");
			  $newlst.add(inr,frminr,objinr,objtyp,typ);
			  }
			  }*/
			if(ctx.getErrorCode() == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:rolgrp.@0005.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			log.debug("{}","rol update...");
			ctx.getErrorCode();
			Platform.mdbUpdate(this.getRec());
			log.debug("{}","rec inr :"+this.getRec().getInr());

			Map<String,Object> map=new HashMap<String,Object>();
			//交易类型码
			map.put("PCODE", "612050");
			//交易流水号
			String sqnum="12050"+MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SEQNO",sqnum);
			//交易系统代码
			map.put("TRANSINST", "99306000000");
			//角色代码
			map.put("ROLEID", this.getRec().getInr());
			//角色名
			map.put("ROLENAME",this.getRec().getNam());
			//角色变更类型  01 c 02 u 03 d
			map.put("ROLECHGTYPE","02");
			//操作柜员号
			map.put("TELLERCODE",MdaEnv.getLoginUser());
			//本地时间
			String localTime=MdaUtils.format(MdaUtils.today(),"HHmmss");
			map.put("LOCALTIME", localTime);
			//本地日期
			String localDate=MdaUtils.format(MdaUtils.today(),"yyMMdd");
			map.put("LOCALDATE",localDate);
			//是否授权 01 非授权, 02 授权
			map.put("ISAUTH","01");
			//发送交易系统代码
			map.put("SENDINST", "99306000000");
			//接受交易系统代吗
			map.put("DESTINST","99700060000");
			//系统跟踪号 - 11位系统号+8位日期+15位流水号
			String date=MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String seqno=MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SYSTRACENO","99306000000"+date+seqno);
			map.put("MessageType", "Register");
			log.info("{}","MESSAGE MAP : "+map);
			//Map<String,Object> replyMap=(Map<String,Object>)Platform.invoke("cn.com.brilliance.teller.utils.TellerUtils","handleIFRoleChange",map);
			//log.info("REPLY MAP:"+replyMap);
			//if("000000".equals(replyMap.get("RESPCODE")))
			//{
			int errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
			//}
			//else
			//{
			//  Platform.message(#CT000077,#CT000078);
			//}
			//return false;
					}
        /**
        *   source:rolgrp.@0006.script
        */
        public boolean delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			ctx.getErrorCode();
			Platform.mdbUpdate(this.getRec());//角色删除将FLG置为1
			Map<String,Object> map=new HashMap<String,Object>();
			//交易类型码
			map.put("PCODE", "612050");
			//交易流水号
			String sqnum="12050"+MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SEQNO",sqnum);
			//交易系统代码
			map.put("TRANSINST", "99306000000");
			//角色代码
			map.put("ROLEID", this.getRec().getInr());
			//角色名
			map.put("ROLENAME",this.getRec().getNam());
			//角色变更类型  01 c 02 u 03 d
			map.put("ROLECHGTYPE","03");
			//操作柜员号
			map.put("TELLERCODE",MdaEnv.getLoginUser());
			//本地时间
			String localTime=MdaUtils.format(MdaUtils.today(),"HHmmss");
			map.put("LOCALTIME", localTime);
			//本地日期
			String localDate=MdaUtils.format(MdaUtils.today(),"yyMMdd");
			map.put("LOCALDATE",localDate);
			//是否授权 01 非授权, 02 授权
			map.put("ISAUTH","01");
			//发送交易系统代码
			map.put("SENDINST", "99306000000");
			//接受交易系统代吗
			map.put("DESTINST","99700060000");
			//系统跟踪号 - 11位系统号+8位日期+15位流水号
			String date=MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String seqno=MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SYSTRACENO","99306000000"+date+seqno);
			map.put("MessageType", "Register");
			log.info("{}","MESSAGE MAP : "+map);
			// Map<String,Object> replyMap=(Map<String,Object>)Platform.invoke("cn.com.brilliance.teller.utils.TellerUtils","handleIFRoleChange",map);
			// log.info("REPLY MAP:"+replyMap);
			// if("000000".equals(replyMap.get("RESPCODE")))
			//{
			int errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;

			//}
			//else
			//{
			//  Platform.message(#CT000191,#CT000192);
			//}
			//return false;
					}
















}