package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Frm;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Frr;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rolp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Rolp.class);

        //角色名称
        private String nam;

        //清空
        private IControl clr;

        //角色状态
        private String flg;

        //角色所属机构级次
        private String lev;

        //角色复核授权级别
        private String rellev;

        //  >>
        private IControl addall;

        //  <
        private IControl rev;

        //  <<
        private IControl revall;

        //rolinr
        private String rolinr;

        //角色名称
        private String getrol;

        //查询
        private IControl search;

        //返回
        private IControl back;

        //取消
        private IControl cls;

        //角色
        private String rolnam;

        //修改
        private IControl ame;

        //删除
        private IControl del;

        //角色名称
        private String dberol;

        //保存
        private IControl sav;

        //添加
        private IControl oftadd;

        //  >>
        private IControl oftadl;

        //删除
        private IControl oftrev;

        //  <<
        private IControl oftrel;

        //未分配数量
        private String number1;

        //已分配数量
        private String number2;

        //   >
        private IControl add;

        //导出
        private IStream exp = new StreamImpl();

        //操作柜员号
        private String operationcode;


        @JsonIgnore
        @BDGetter
        private transient IPanel schpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel rampanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolamep;

        @JsonIgnore
        @BDGetter
        private transient IPanel roldtlp;

        @JsonIgnore
        @BDGetter
        private transient IPanel oftpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel canpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbepnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel labelpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel editpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbirolpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbarolpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbdrolpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel editdelpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel submitretpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel retpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp1;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp2;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp3;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp4;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp5;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp6;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp7;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp8;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp9;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp12a;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp13i;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp14d;

        @JsonIgnore
        @BDGetter
        private transient IPanel dblp1;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp15;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp16;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp17;

        @JsonIgnore
        @BDGetter
        private transient IPanel rolp18;

        @JsonIgnore
        @BDGetter
        private transient IPanel edip;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbarol;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbirol;

        @JsonIgnore
        @BDGetter
        private transient IPanel amerol;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbdrol;

        @JsonIgnore
        @BDGetter
        private transient IPanel schlft;

        @JsonIgnore
        @BDGetter
        private transient IPanel schrgt;

        @JsonIgnore
        @BDGetter
        private transient IPanel schbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel dblrol;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Rolgrp> rolgrp;

		@BDGetter
		private ModuleList<Rol> rollst;

		@BDGetter
		private ModuleList<Frm> frmlstadd;

		@BDGetter
		private ModuleList<Frm> frmlstdel;

		@BDGetter
		private ModuleList<Frr> tmplst;

		@BDGetter
		private ModuleList<Frm> alllst;

		@BDGetter
		private ModuleList<Frr> urllst;

		@BDGetter
		private ModuleList<Frm> biglst;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;


		public Rolp()
        {
            super();
            setArgument();
        }

        public Rolp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:rolp.@0000.script
        */
        @Rule(target="ame",order=500)
        public boolean ruleAmeN500(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  for(int i=$rolgrp\\frmlst1.fullSize() - 1;i>=0;i--)
			  {
			  if("X".equals($rolgrp\\frmlst1[i]\\chk.getValue()))
			  {
			  $rolgrp\\frmlst1[i]\\chk.setValue("");
			  $rolgrp\\frmlst2.add($rolgrp\\frmlst1[i]);
			  $rolgrp\\frmlst1.remove(i);
			  }
			  }
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  //未分配
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $number1=number1;
			  $number2=number2;
			  Platform.setModified($number1);
			  Platform.setModified($number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  */

			return true;
        }

        /**
        *   source:rolp.@0001.script
        */
        @Rule(target="amerol",order=100)
        public boolean ruleAmerolN100(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  * 添加所有交易列表
			  **/
			/*
			  for(int i=0;i<$rolgrp\\frmlst1.fullSize();i++)
			  {
			  $rolgrp\\frmlst2.add($rolgrp\\frmlst1[i]);
			  }
			  Platform.clear($rolgrp\\frmlst1);
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $number1=number1;
			  $number2=number2;
			  Platform.setModified($number1);
			  Platform.setModified($number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  */

			return true;
        }

        /**
        *   source:rolp.@0003.script
        */
        @Rule(target="rev",order=100)
        public boolean ruleRevN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  for(int i=$rolgrp\\frmlst2.fullSize() - 1;i>=0;i--)
			  {
			  if("X".equals($rolgrp\\frmlst2[i]\\chk.getValue()))
			  {
			  $rolgrp\\frmlst2[i]\\chk.setValue("");
			  $rolgrp\\frmlst1.add($rolgrp\\frmlst2[i]);
			  $rolgrp\\frmlst2.remove(i);
			  }
			  }
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  //未分配
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $number1=number1;
			  $number2=number2;
			  Platform.setModified($number1);
			  Platform.setModified($number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  */

			return true;
        }

        /**
        *   source:rolp.@0004.script
        */
        @Rule(target="revall",order=100)
        public boolean ruleRevallN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  *删除所有交易列表
			  */
			/*
			  Platform.clear($rolgrp\\newlst);
			  for(int i=0;i<$rolgrp\\frmlst2.fullSize();i++)
			  {
			  $rolgrp\\frmlst1.add($rolgrp\\frmlst2[i]);
			  }
			  Platform.clear($rolgrp\\frmlst2);
			  //未分配
			  String number1=String.valueOf($rolgrp\\frmlst1.fullSize());
			  String number2=String.valueOf($rolgrp\\frmlst2.fullSize());
			  $number1=number1;
			  $number2=number2;
			  Platform.setModified($number1);
			  Platform.setModified($number2);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  */

			return true;
        }

        /**
        *   source:rolp.@0006.script
        */
        @Rule(target="back",order=100)
        public boolean ruleBackN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.mchain("dblrol");*/

			return true;
        }

        /**
        *   source:rolp.@0007.script
        */
        @Rule(target="rollst",order=100)
        public boolean ruleRollstN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  int index = Platform.getSelectedRowIndex($rollst);
			  if (index >= 0)
			  {
			  String inr = $rollst[index]\\inr;
			  Platform.storeData("rol",inr);
			  Platform.mchain("dbirol");
			  }*/

			return true;
        }

        /**
        *   source:rolp.@0008.script
        */
        @Rule(target="ame",order=100)
        public boolean ruleAmeN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  String inr = $rolgrp\\rec\\inr;
			  Platform.storeData("rol",inr);*/
			//Platform.mchain("dberol");
			
			return true;
        }

        /**
        *   source:rolp.@0009.script
        */
        @Rule(target="del",order=100)
        public boolean ruleDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  log.debug("执行删除");
			  String inr = $rolgrp\\rec\\inr;
			  Platform.storeData("rol",inr);
			  Platform.mchain("dbdrol");*/

			return true;
        }

        /**
        *   source:rolp.@0010.script
        */
        @Rule(target="rolgrp.frmlst1",order=100)
        public boolean ruleRolgrpFrmlst1N100(){
            IContext ctx = MdaEnv.getContext();
            
			// Platform.postEventRule($add,onClick,null);
			
			return true;
        }

        /**
        *   source:rolp.@0012.script
        */
        @Rule(target="rolgrp.frmlst2",order=100)
        public boolean ruleRolgrpFrmlst2N100(){
            IContext ctx = MdaEnv.getContext();
            
			// Platform.postEventRule($rev,onClick,null);
			
			return true;
        }

        /**
        *   source:rolp.@0013.script
        */
        @Rule(target="oftadd",order=100)
        public boolean ruleOftaddN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  int index=Platform.getSelectedRowIndex($rolgrp\\frmlst2);
			  if(index>-1)
			  {
			  $rolgrp\\oftlst.add($rolgrp\\frmlst2[index]);
			  $rolgrp\\frmlst2.remove(index);
			  Platform.setModified($rolgrp\\oftlst);
			  Platform.setModified($rolgrp\\frmlst2);
			  }*/

			return true;
        }

        /**
        *   source:rolp.@0014.script
        */
        @Rule(target="oftadl",order=100)
        public boolean ruleOftadlN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  for(int i=0;i<$rolgrp\\frmlst1.fullSize();i++)
			  {
			  $rolgrp\\oftlst.add($rolgrp\\frmlst1[i]);
			  $rolgrp\\frmlst2.add($rolgrp\\frmlst1[i]);
			  }
			  Platform.clear($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  Platform.setModified($rolgrp\\oftlst);*/

			return true;
        }

        /**
        *   source:rolp.@0015.script
        */
        @Rule(target="oftrev",order=100)
        public boolean ruleOftrevN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  int index=Platform.getSelectedRowIndex($rolgrp\\oftlst);
			  if(index>-1)
			  {
			  $rolgrp\\frmlst2.add($rolgrp\\oftlst[index]);
			  $rolgrp\\oftlst.remove(index);
			  Platform.setModified($rolgrp\\oftlst);
			  Platform.setModified($rolgrp\\frmlst2);
			  }*/

			return true;
        }

        /**
        *   source:rolp.@0016.script
        */
        @Rule(target="oftrel",order=100)
        public boolean ruleOftrelN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.clear($rolgrp\\oftlst);
			  Platform.setModified($rolgrp\\oftlst);*/

			return true;
        }

        /**
        *   source:rolp.@0029.script
        */
        @Rule(target="lev",order=100)
        public boolean ruleLevN100(){
            IContext ctx = MdaEnv.getContext();
            
			//log.debug("@@@@@@@@"+$rellev);
			//Platform.clear($rellev);
			//Platform.setModified($rellev);
			//log.debug("rellev:" + $rellev);
			if("0".equals(this.getLev()))
			  MdaUtils.setValues(this,"rellev",MdaUtils.getCodetable("rellev0"));
			else if("1".equals(this.getLev()))
			  MdaUtils.setValues(this,"rellev",MdaUtils.getCodetable("rellev1"));
			else if("2".equals(this.getLev()))
			  MdaUtils.setValues(this,"rellev",MdaUtils.getCodetable("rellev2"));

			return true;
        }

        /**
        *   source:rolp.@0033.script
        */
        @Rule(target="clr",order=100)
        public boolean ruleClrN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setNam(NULLSTR);
			this.setFlg(NULLSTR);
			this.setLev(NULLSTR);
			this.setRellev(NULLSTR);
			
			
			
			

			return true;
        }


        /**
        *   source:rolp.@0025.script
        */
        @Check(target="rolgrp.rec.lev",order=100)
        public boolean checkRolgrpRecLevN100(){
            IContext ctx = MdaEnv.getContext();
            
			//在选择所属机构级次后重新激活复核授权级别下拉框。
			
			if(MdaUtils.isEmpty(this.getRolgrp().getRec().getLev()))
			{
			  ctx.setFieldError(this,"rolgrp.rec.lev",MdaUtils.getI18NString("rolp","CT000315"));
			  return true;
			}
			else if("0".equals(this.getRolgrp().getRec().getLev()))
			  MdaUtils.setValues(this.getRolgrp().getRec(),"rellev",MdaUtils.getCodetable("rellev0"));
			else if("1".equals(this.getRolgrp().getRec().getLev()))
			  MdaUtils.setValues(this.getRolgrp().getRec(),"rellev",MdaUtils.getCodetable("rellev1"));
			else if("2".equals(this.getRolgrp().getRec().getLev()))
			  MdaUtils.setValues(this.getRolgrp().getRec(),"rellev",MdaUtils.getCodetable("rellev2"));

			return true;
        }

        /**
        *   source:rolp.@0026.script
        */
        @Check(target="rolgrp.rec.rellev",order=100)
        public boolean checkRolgrpRecRellevN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRolgrp().getRec().getLev()))
			{
			  ctx.setFieldError(this,"rolgrp.rec.rellev",MdaUtils.getI18NString("rolp","CT000316"));
			  return true;
			}

			return true;
        }

        /**
        *   source:rolp.@0027.script
        */
        @Check(target="rolgrp.rec.nam",order=100)
        public boolean checkRolgrpRecNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if (MdaUtils.isEmpty(this.getRolgrp().getRec().getNam()))
			{
			  ctx.setFieldError(this,"rolgrp.rec.nam",MdaUtils.getI18NString("rolp","CT000317"));
			  return true;
			}

			return true;
        }

        /**
        *   source:rolp.@0028.script
        */
        @Check(target="rolgrp.rec.flg",order=100)
        public boolean checkRolgrpRecFlgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if (MdaUtils.isEmpty(this.getRolgrp().getRec().getFlg()))
			{
			  ctx.setFieldError(this,"rolgrp.rec.flg",MdaUtils.getI18NString("rolp","CT000321"));
			  return true;
			}

			return true;
        }


        /**
        *   source:rolp.@0032.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			Object obj=ctx.restoreData("handleTemp");
			log.info("{}","***dblrol init***");
			log.info("{}","***" + obj + "***");
			log.info("{}",obj!=null);
			if(obj!=null)
			{
			  ctx.postRule(this,"search");
			}

			return true;
        }


        /**
        *   source:rolp.@0017.script
        */
        public boolean addVisibleFrm(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  角色可视交易
			  **/
			/*  for(int i=0;i<$rolgrp\\frmlst2.fullSize();i++)
			  {
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frminr=new Argument<String>("frminr");
			  Argument<String>objinr=new Argument<String>("objinr");
			  Argument<String>objtyp=new Argument<String>("objtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  //非0的全部置为0状态，表示可视
			  if(!"0".equals($rolgrp\\frmlst2[i]\\typ.getValue()))
			  {
			  inr.setValue(Platform.sdbCounter("frr"));
			  frminr.setValue($rolgrp\\frmlst2[i]\\inr.getValue());
			  objinr.setValue(rolinr);
			  objtyp.setValue("rol");
			  typ.setValue("0");
			  $rolgrp\\newlst.add(inr,frminr,objinr,objtyp,typ);
			  }
			  }*/
			if(ctx.getErrorCode() == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:rolp.@0018.script
        */
        public void addOftenFrm(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  添加到常用列表
			  **/
			/* for(int i=0;i<$rolgrp\\oftlst.fullSize();i++)
			  {
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frminr=new Argument<String>("frminr");
			  Argument<String>objinr=new Argument<String>("objinr");
			  Argument<String>objtyp=new Argument<String>("objtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  //将非2的状态全部保存为常用状态2
			  if(!"2".equals($rolgrp\\oftlst[i]\\typ.getValue()))
			  {
			  inr.setValue(Platform.sdbCounter("frr"));
			  frminr.setValue($rolgrp\\oftlst[i]\\inr.getValue());
			  objinr.setValue(rolinr);
			  objtyp.setValue("rol");
			  typ.setValue("2");
			  $rolgrp\\newlst.add(inr,frminr,objinr,objtyp,typ);
			  }
			  }*/
		}
        /**
        *   source:rolp.@0019.script
        */
        public void initFrmlst2()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/* List<String> oldlist = new ArrayList<String>();
			  String sql=null;
			  sql="SELECT inr,frm,nam,typ,frmtyp FROM frm where frm IN (SELECT frm from frr WHERE typ='0' AND objinr='"+$rolgrp\\rec\\inr.getValue()+"')";
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frminr=new Argument<String>("frminr");
			  Argument<String>nam=new Argument<String>("nam");
			  Argument<String>typ=new Argument<String>("typ");
			  Argument<String>frmtyp=new Argument<String>("frmtyp");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr,frm,nam,typ,frmtyp);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  $rolgrp\\frmlst2.add(inr,frminr,nam,typ,frmtyp);
			  oldlist.add(frm.getValue());
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  Platform.storeData("oldlist",oldlist);
			  Platform.setModified($rolgrp\\frmlst2);
			  log.debug("frmlist2 size is:"+$rolgrp\\frmlst2.size());*/
		}
        /**
        *   source:rolp.@0020.script
        */
        public void initOftList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/* List<String> templst=new ArrayList<String>();
			  String sql=null;
			  sql="SELECT  inr, frm, nam, typ, frmtyp FROM frm where frm IN (SELECT frm from frr WHERE typ='2' AND objinr='"+$rolgrp\\rec\\inr.getValue()+"')";
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frm=new Argument<String>("frm");
			  Argument<String>nam=new Argument<String>("nam");
			  Argument<String>typ=new Argument<String>("typ");
			  Argument<String>frmtyp=new Argument<String>("frmtyp");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr,frm,nam,typ,frmtyp);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  $rolgrp\\oftlst.add(inr,frm,nam,typ,frmtyp);
			  templst.add(frm.getValue());
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  Platform.setModified($rolgrp\\oftlst);
			  Platform.storeData("templst",templst);
			  log.debug("oftlst size:"+$rolgrp\\oftlst.size());*/
		}
        /**
        *   source:rolp.@0021.script
        */
        public void initFrmlst1()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*Platform.clear($rolgrp\\frmlst1);
			  String sql=null;
			  sql="SELECT inr,frm,nam,typ,frmtyp FROM frm f "
			  +" WHERE  f.frm NOT IN (SELECT frm FROM frr WHERE objinr='"+$rolgrp\\rec\\inr.getValue()+"' AND objtyp='rol')";
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frm=new Argument<String>("frm");
			  Argument<String>nam=new Argument<String>("nam");
			  Argument<String>typ=new Argument<String>("typ");
			  Argument<String>frmtyp=new Argument<String>("frmtyp");
			  Platform.mdbExecuteSQL(sql);
			  while(true)
			  {
			  Platform.mdbFetchFields(inr,frm,nam,typ,frmtyp);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  {
			  $rolgrp\\frmlst1.add(inr,frm,nam,typ,frmtyp);
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  Platform.setModified($rolgrp\\frmlst1);*/
		}
        /**
        *   source:rolp.@0022.script
        */
        public void addOriList(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  添加到不可见列表
			  **/
			/* for(int i=0;i<$rolgrp\\frmlst1.fullSize();i++)
			  {
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frminr=new Argument<String>("frminr");
			  Argument<String>objinr=new Argument<String>("objinr");
			  Argument<String>objtyp=new Argument<String>("objtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  String typvalue=$rolgrp\\frmlst1[i]\\typ.getValue();
			  //非1的状态全部保存为不可视状态
			  if(!"1".equals(typvalue))
			  {
			  inr.setValue(Platform.sdbCounter("frr"));
			  frminr.setValue($rolgrp\\frmlst1[i]\\inr.getValue());
			  objinr.setValue(rolinr);
			  objtyp.setValue("rol");
			  typ.setValue("1");
			  $rolgrp\\newlst.add(inr,frminr,objinr,objtyp,typ);
			  }
			  }*/
		}
        /**
        *   source:rolp.@0023.script
        */
        public void addLeft(List<String> tmplist,List<String> alllist)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  for(int i=0;i<alllist.size();i++)
			  {
			  String str=alllist.get(i);
			  for(int j=0;j<tmplist.size();j++)
			  {
			  if(str.equals(tmplist.get(j)))
			  {
			  alllist.remove(i);
			  i--;
			  break;
			  }
			  }
			  }
			  //得到剩余的交易
			  log.debug("left all size is :"+alllist.size());
			  for(int i=0;i<alllist.size();i++)
			  {
			  Platform.mdbRead($rolgrp\\frm,new Argument<String>("inr",alllist.get(i)));
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frm=new Argument<String>("frm");
			  Argument<String>frmtyp=new Argument<String>("frmtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  Argument<String>dsp=new Argument<String>("dsp");
			  inr.setValue($rolgrp\\frm\\inr.getValue());
			  frm.setValue($rolgrp\\frm\\frm.getValue());
			  frmtyp.setValue($rolgrp\\frm\\frmtyp.getValue());
			  typ.setValue($rolgrp\\frm\\typ.getValue());
			  dsp.setValue($rolgrp\\frm\\dsp.getValue());
			  if("1".equals($rolgrp\\frm\\typ.getValue()))
			  {
			  $rolgrp\\frmlst1.add(inr,frm,frmtyp,typ,dsp);
			  }
			  else if("0".equals($rolgrp\\frm\\typ.getValue()))
			  {
			  $rolgrp\\frmlst2.add(inr,frm,frmtyp,typ,dsp);
			  }
			  else if("2".equals($rolgrp\\frm\\typ.getValue()))
			  {
			  $rolgrp\\oftlst.add(inr,frm,frmtyp,typ,dsp);
			  }
			  }
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  Platform.setModified($rolgrp\\oftlst);*/
		}
        /**
        *   source:rolp.@0024.script
        */
        public void leftisExit(List<String> tmplist,List<String> alllist)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  for(int i=0;i<alllist.size();i++)
			  {
			  String str=alllist.get(i);
			  for(int j=0;j<tmplist.size();j++)
			  {
			  if(str.equals(tmplist.get(j)))
			  {
			  alllist.remove(i);
			  i--;
			  break;
			  }
			  }
			  }
			  //得到剩余的交易
			  for(int i=0;i<alllist.size();i++)
			  {
			  Platform.mdbRead($rolgrp\\frm,new Argument<String>("inr",alllist.get(i)));
			  Argument<String>inr=new Argument<String>("inr");
			  Argument<String>frm=new Argument<String>("frm");
			  Argument<String>frmtyp=new Argument<String>("frmtyp");
			  Argument<String>typ=new Argument<String>("typ");
			  Argument<String>dsp=new Argument<String>("dsp");
			  inr.setValue($rolgrp\\frm\\inr.getValue());
			  frm.setValue($rolgrp\\frm\\frm.getValue());
			  frmtyp.setValue($rolgrp\\frm\\frmtyp.getValue());
			  typ.setValue($rolgrp\\frm\\typ.getValue());
			  dsp.setValue($rolgrp\\frm\\dsp.getValue());
			  if("1".equals($rolgrp\\frm\\typ.getValue()))
			  {
			  String inr1=inr.getValue();
			  int number=0;
			  for(int k=0;k<$rolgrp\\frmlst1.fullSize();k++)
			  {
			  if(!inr1.equals($rolgrp\\frmlst1[k]\\inr.getValue()))
			  {
			  number++;
			  }
			  }
			  if(number==$rolgrp\\frmlst1.fullSize())
			  {
			  $rolgrp\\frmlst1.add(inr,frm,frmtyp,typ,dsp);
			  }
			  }
			  else if("0".equals($rolgrp\\frm\\typ.getValue()))
			  {
			  String inr0=inr.getValue();
			  int number=0;
			  for(int k=0;k<$rolgrp\\frmlst2.fullSize();k++)
			  {
			  if(!inr0.equals($rolgrp\\frmlst2[k]\\inr.getValue()))
			  {
			  number++;
			  }
			  }
			  if(number==$rolgrp\\frmlst2.fullSize())
			  {
			  $rolgrp\\frmlst2.add(inr,frm,frmtyp,typ,dsp);
			  }
			  }
			  else if("2".equals($rolgrp\\frm\\typ.getValue()))
			  {
			  String inr2=inr.getValue();
			  int number=0;
			  for(int k=0;k<$rolgrp\\oftlst.fullSize();k++)
			  {
			  if(!inr2.equals($rolgrp\\oftlst[k]\\inr.getValue()))
			  {
			  number++;
			  }
			  }
			  if(number==$rolgrp\\oftlst.fullSize())
			  {
			  $rolgrp\\oftlst.add(inr,frm,frmtyp,typ,dsp);
			  }
			  }
			  }
			  Platform.setModified($rolgrp\\frmlst1);
			  Platform.setModified($rolgrp\\frmlst2);
			  Platform.setModified($rolgrp\\oftlst);*/
		}


        public void setRolgrpHolder(ModuleHolder<Rolgrp> rolgrp)
        {
            this.rolgrp = rolgrp;
        }

        public Rolgrp getRolgrp()
        {
           return this.rolgrp.get();
        }









        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }























































}