package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Smd;
import com.ceb.gjjs.mda.bo.Doe;
import com.ceb.gjjs.mda.bo.Smt;
import com.ceb.gjjs.mda.bo.Dot;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Smdsub extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Smdsub.class);



	    @BDGetter
		private Smd smd;

		@BDGetter
		private ModuleList<Smd> lst;

	    @BDGetter
		private Dot dot;

		@BDGetter
		private ModuleList<Smd> prelst;

	    @BDGetter
		private Doe doe;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Smt> smt;


		public Smdsub()
        {
            super();
            setArgument();
        }

        public Smdsub(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:smdsub.@0000.script
        */
        public void createDotRecsFormSmdList(String accpty,String bic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getLst()) || this.getLst().fullSize()<=0)
			  return;
			// 生成对账单明细待对账记录、、
			// 读取对账单明细列表
			log.debug("{}","smd create dot by lst");
			for(int i=0;i<this.getLst().fullSize();i++)
			{
			  // TODO 生成dot记录
			  MdaUtils.clear(this.getDot());
			  MdaUtils.clear(this.getDoe());
			  this.getDot().setObjtyp("smd");
			  this.getDot().setAccpty(accpty);
			  this.getDot().setAcc( this.getLst().getElement(i).getAct());
			  this.getDot().setEntdat( this.getLst().getElement(i).getAccdat());
			  this.getDot().setActbic(bic);
			  this.getDot().setCur(this.getLst().getElement(i).getCur());
			  this.getDot().setAmt(this.getLst().getElement(i).getAmt());
			  this.getDot().setValdat(this.getLst().getElement(i).getValdat());
			  this.getDot().setDcflg(this.getLst().getElement(i).getDcflg());
			  this.getDot().setOwnref(this.getLst().getElement(i).getOwnref());
			  this.getDot().setOthref(this.getLst().getElement(i).getOthref());
			  this.getDot().setSta("1");
			  this.getDot().setOffsta("2");
			  this.getDot().setCredat(MdaUtils.today());
			  this.getDot().setObjinr(this.getLst().getElement(i).getInr());
			  this.getDot().setRsptim(this.getLst().getElement(i).getRecdat());
			  this.getDot().setStanum(this.getLst().getElement(i).getSmtno());
			  this.getDot().setSeqnum(this.getLst().getElement(i).getPagnum());
			  this.getDot().setStaref(this.getLst().getElement(i).getSmtref());
			  log.info("{}","smd dot staref "+this.getDot().getStaref());
			  this.getDot().setBusflg(this.getLst().getElement(i).getBusflg());
			  this.getDot().setInf(this.getLst().getElement(i).getInf());
			  this.getDot().setMty("950");
			  this.getDot().setLstdat(new Date());
			  this.getDot().setIsdone("1");//used by module offsvr :argoff()
			  this.getDot().setRecsta("2");
			  String dotinr = Platform.sdbCounter("dot");
			  this.getDot().setInr(dotinr);
			  //log.debug("new dotinr: " + dotinr+" objinr"+$dot\\objinr);
			
			  //关联所属实体
			  ctx.absGet(Sysmod.class).setEtyAndPty(this.getDot(),this.getSmt());

			  Platform.mdbInsert(this.getDot());
			  this.getDoe().setDotinr(this.getDot().getInr());
			  this.getDoe().setFrmnam(ctx.getTransName());
			  this.getDoe().setUsr(MdaEnv.getLoginUser());
			  this.getDoe().setOpdate(new Date());
			  this.getDoe().setBak("自动生成待对账记录");
			  Platform.sdbInsert(this.getDoe());
			}
		}







        public void setSmtHolder(ModuleHolder<Smt> smt)
        {
            this.smt = smt;
        }

        public Smt getSmt()
        {
           return this.smt.get();
        }

}