package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Mps;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Mpi;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Smegrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Smegrp.class);



	    @BDGetter
		private Mpi mpi;

	    @BDGetter
		private Mps mps;

	    @BDGetter
		private Smh smh;

		@BDGetter
		private ModuleList<Mpi> lst;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Smtsvr> smtsvr;


		public Smegrp()
        {
            super();
            setArgument();
        }

        public Smegrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:smegrp.@0000.script
        */
        public boolean loadData(String objinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Platform.sdbRead(this.getSmtsvr().getMpi(),objinr);
			Platform.mdbRead(this.getSmtsvr().getSmpsub().getSmp(),new Argument("msdinr",objinr));
			Platform.mdbRead(this.getSmtsvr().getSmtsub().getSmt(),new Argument("inr",this.getSmtsvr().getSmpsub().getSmp().getSmtinr()));
			Platform.mdbRead(this.getSmtsvr().getSmdsub().getSmd(),new Argument("smtinr",this.getSmtsvr().getSmpsub().getSmp().getSmtinr()),new Argument("smpinr",this.getSmtsvr().getSmpsub().getSmp().getInr()));
			return true;
		}






        public void setSmtsvrHolder(ModuleHolder<Smtsvr> smtsvr)
        {
            this.smtsvr = smtsvr;
        }

        public Smtsvr getSmtsvr()
        {
           return this.smtsvr.get();
        }

}