package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Smt;
import com.ceb.gjjs.mda.bo.Hkz;
import com.ceb.gjjs.mda.bo.Smp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Smpsub extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Smpsub.class);

        //需要额外记录的页错误类型
        private String errtyp;

        //原有页错误类型列表
        private Object errmap;



	    @BDGetter
		private Smp smp;

		@BDGetter
		private ModuleList<Smp> lst;

	    @BDGetter
		private Smp pre;

	    @BDGetter
		private Act act;

	    @BDGetter
		private Hkz hkz;

	    @BDGetter
		private Act mat;

	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Pty opty;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Smt> smt;


		public Smpsub()
        {
            super();
            setArgument();
        }

        public Smpsub(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:smpsub.@0000.script
        */
        public String getPagnum(String pagnum,int step)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 根据传入的页码和加减值，返回长度为5的页码字符串
			  * - String pagnum 传入的页码
			  * - int step 页码加减值
			  * @ 格式化以后的新页码
			  */
			if(MdaUtils.isEmpty(pagnum))
			  pagnum="00000";
			if(step==0)
			  return pagnum;
			int curno = Integer.valueOf(pagnum);
			curno = curno +step ;
			String newpagnum = String.valueOf(curno);
			newpagnum = Platform.sfixPreToken(newpagnum,"0",5);
			return newpagnum;
		}
        /**
        *   source:smpsub.@0001.script
        */
        public boolean checkAndSetPageAmt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getPre()))
			{
			  return false;
			}
			if(MdaUtils.isEmpty(this.getPre().getInr())&&MdaUtils.isEmpty(this.getPre().getPagamt()))
			{
			  return false;
			}

			log.debug("{}","chk  "+this.getPre().getInr());
			this.getPre().setPagamt(queryAndCalDetailAmt(this.getPre().getInr()));
			BigDecimal d =this.getPre().getPagamt();
			log.trace("{}"," amt="+d);
			BigDecimal b = this.getPre().getNewbegamt();//页初金额、、
			BigDecimal e = this.getPre().getNewendamt();//页末金额
			if(e.subtract(b).compareTo(d)!=0)
			{
			  this.getPre().setSta("1");//问题
			  Platform.addError(MdaDriver.getDatafield(this.getPre(),"errtyp"),"6");// 页内试算不平衡
			  return false;
			}
			Platform.removeError(MdaDriver.getDatafield(this.getPre(),"errtyp"),"6");
			return true;
		}
        /**
        *   source:smpsub.@0002.script
        */
        public BigDecimal queryAndCalDetailAmt(String smpinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(smpinr))
			{
			  return new BigDecimal(0);
			}
			String sql = "SELECT coalesce(SUM(amt),0) amt FROM ("
			  +"SELECT  case(dcflg,'C',SUM(amt),'D',-SUM(amt),'RC',-SUM(amt),'RD',SUM(amt)) AS amt FROM smd WHERE"
			  +" smpinr='"+smpinr+"' "
			  +" GROUP BY dcflg)";
			// 将查询结果赋值、、
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(amt);
			int err = ctx.getErrorCode();
			Platform.mdbCloseCursor();
			if(err==NO_ERROR)
			{
			  return amt.value;
			}
			return new BigDecimal(0);
		}
        /**
        *   source:smpsub.@0003.script
        */
        public boolean checkAndSetPage()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 校验当前页信息 $smp 是否正确，并将校验结果set回$smp中
			  * @ return boolean 成功返回true 失败返回false.
			  */
			log.debug("{}","into checkAndSetPage");
			this.setErrtyp(NULLSTR);
			this.setErrmap( null);
			if(MdaUtils.isEmpty(this.getSmp()))
			{
			  return false;
			}
			/// 记录并保存当前单的所有状态
			String sql = "SELECT inr,errtyp FROM smp WHERE smtinr='"+this.getSmp().getSmtinr()+"'";
			Platform.mdbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> errtypa = new Argument<String>("errtyp");
			Map<String,String> map = new HashMap<String,String>();
			while(true)
			{
			  Platform.mdbFetchFields(inr,errtypa);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    map.put(inr.value,errtypa.value);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			this.setErrmap(map);
			/// 校验当前页面
			checkAndSetCurrentPage();
			/// 如果当前是页是重复或疑似重复将不做后续校验返回
			String errtyp = this.getSmp().getErrtyp();
			if("1".equals(errtyp) || "2".equals(errtyp))
			  return false;
			/// 校验下一页面
			//log.info("************************");
			checkAndSetNextPage();
			//log.info("************************");
			/// 校验前页
			checkAndCreatePreviousPage();
			/// 返回校验结果 如果sta是1说明页校验失败
			return !"1".equals(this.getSmp().getSta());
		}
        /**
        *   source:smpsub.@0004.script
        */
        public void creatLoseSmps(int begin ,int end)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 如果当前对账单页状态为不连续时，向下顺次新增全部缺失对账单页信息
			  * int begin 从此页号开始新增>=
			  * int end  到此页号新增结束<=
			  */
			if(begin<=0||end<begin)
			  return;
			if(MdaUtils.isEmpty(this.getSmp()))
			{
			  log.error("{}","当前对账单页信息为空");
			  return;
			}
			for(int i=begin;i<=end;i++)
			{
			  MdaUtils.clear(this.getPre());
			  Platform.sdbCounter(this.getPre());
			  this.getPre().setSmtinr( this.getSmp().getSmtinr());
			  this.getPre().setSmtno( this.getSmp().getSmtno());
			  this.getPre().setSta( "1");
			  Platform.addError(MdaDriver.getDatafield(this.getPre(),"errtyp"),"4");//4 缺页
			  String losepagnum = Platform.sfixPreToken(String.valueOf(i),"0",5);
			  this.getPre().setPagnum( losepagnum);
			  this.getPre().setPagamenum( losepagnum);

			  //关联所属实体
			  ctx.absGet(Sysmod.class).setEtyAndPty(this.getPre(),this.getSmt());

			  Platform.mdbInsert(this.getPre());
			  Platform.addError(MdaDriver.getDatafield(this,"errtyp"),"4");
			  log.debug("{}","add losed smp "+this.getPre().getInr()+" smtinr "+this.getPre().getSmtinr()+" losepagnum "+losepagnum);
			}
		}
        /**
        *   source:smpsub.@0005.script
        */
        public boolean checkAndSetCurrentPage()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 查询当前页
			MdaUtils.clear(this.getLst());
			Platform.mdbReadset(this.getLst(),new Argument("smtinr",this.getSmp().getSmtinr()).and("pagamenum",this.getSmp().getPagamenum()));
			if(MdaUtils.isEmpty(this.getLst()) || this.getLst().fullSize()==0)
			{
			  return true;
			}
			Map<String,String> map = (Map<String,String>)this.getErrmap();
			for(com.ceb.gjjs.mda.bo.Smp smp :this.getLst())
			{
			  /// 如果查询到原记录判断其状态
			  log.debug("{}","存在当前页 "+smp.getInr()+" pagamenum "+smp.getPagamenum()+ "errtyp "+smp.getErrtyp());
			  String errtyp = smp.getErrtyp();
			  if(errtyp==null)errtyp="";
			  /// 如果包含4 缺页状态
			  if(errtyp.contains("4"))
			  {
			    /// 删除缺页记录
			    log.debug("{}","remove inr"+smp.getInr());
			    map.remove(smp.getInr());
			    this.setErrmap(map);
			    Platform.mdbDelete(smp);
			    continue;
			  }
			  // 如果不包含4 缺页状态  则视为重页异常,分为疑似重复和完全重复
			  this.getSmp().setSta( "1");//问题
			  //如果期初期末金额一致，则判断为2 完全重复，
			  if(this.getSmp().getNewbegamt().compareTo(smp.getNewbegamt())==0
			    && this.getSmp().getNewendamt().compareTo(smp.getNewendamt())==0)
			  {
			    Platform.addError(MdaDriver.getDatafield(this.getSmp(),"errtyp"),"2");
			  }
			  else
			  {//否则为1 疑似重复
			    Platform.addError(MdaDriver.getDatafield(this.getSmp(),"errtyp"),"1");
			  }
			  log.error("{}","对账单页 "+this.getSmp().getPagamenum()+" 页码重复");
			  return false;
			}
			return true;
		}
        /**
        *   source:smpsub.@0006.script
        */
        public boolean checkAndCreatePreviousPage()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 如果当前页是首页,返回不查询前页
			if(this.getSmp().getChk().contains("O"))
			{
			  log.debug("{}","当前页是首页");
			  return true;
			}
			// 查找非重页状态最大页码的前页
			String sql = "SELECT MAX(pagamenum) pagamenum FROM smp WHERE  smtinr='"+this.getSmp().getSmtinr()+"' AND smtno='"+this.getSmp().getSmtno()+"' AND  pagamenum <'"+this.getSmp().getPagamenum()+"' AND errtyp NOT IN('1','2')";
			Argument<String> pagamenum = new Argument<String>("pagamenum");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(pagamenum);
			String prepagnum = null;
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  prepagnum = Platform.sfixPreToken(pagamenum.value,"0",5);
			  log.debug("{}","pagnum.value="+pagamenum.value+" preinr="+prepagnum);
			}
			Platform.mdbCloseCursor();
			int preno = 0;
			int curno = Integer.valueOf(this.getSmp().getPagamenum());
			log.debug("{}","curno = "+curno);
			if(prepagnum!=null)
			{
			  MdaUtils.clear(this.getPre());
			  Platform.mdbRead(this.getPre(),new Argument("smtinr",this.getSmp().getSmtinr()).and("pagamenum",prepagnum)
			    .and("errtyp",NE,"1").and("errtyp",NE,"2"));
			  if(!MdaUtils.isEmpty(this.getPre().getPagamenum()))
			  {
			    preno = Integer.valueOf(this.getPre().getPagamenum());
			  }
			}
			log.debug("{}","preno = "+preno);
			/// 页码不连续则新增缺页信息
			if(curno-preno!=1)
			{
			  this.getSmp().setSta("1");//问题
			  Platform.addError(MdaDriver.getDatafield(this.getSmp(),"errtyp"),"3");// 页码不连续
			  log.error("{}","对账单页 "+this.getSmp().getInr()+" 页码不连续");
			  creatLoseSmps(preno + 1,curno - 1);// 补充preno+1 到curno-1页共 curno-preno - 1页的缺页信息
			  return false;
			}
			log.debug("{}","存在前页"+this.getPre().getInr()+" pagamenum "+this.getPre().getPagamenum()+ "errtyp "+this.getPre().getErrtyp());
			// 如果前页虽然存在但是状态是4缺页当前页页置状态不连续
			if(this.getPre().getErrtyp().contains("4"))
			{
			  this.getSmp().setSta("1");//问题
			  Platform.addError(MdaDriver.getDatafield(this.getSmp(),"errtyp"),"3");// 页码不连续
			  log.error("{}","对账单页 "+this.getSmp().getInr()+" 页码不连续");
			  return false;
			}
			/// 页间金额不连续
			BigDecimal e = this.getPre().getNewendamt();
			BigDecimal b = this.getSmp().getNewbegamt();
			if(e.compareTo(b)!=0)
			{
			  this.getSmp().setSta("1");//问题
			  Platform.addError(MdaDriver.getDatafield(this.getSmp(),"errtyp"),"5");
			  log.error("{}","对账单页 "+this.getSmp().getInr()+" 页间金额不连续");
			  return false;
			}
			return true;
		}
        /**
        *   source:smpsub.@0008.script
        */
        public boolean checkAndSetNextPage()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 如果当前页是末页,返回不查询后页
			if(this.getSmp().getChk().contains("X"))
			{
			  log.debug("{}","当前页是末页");
			  return true;
			}
			/// 查询任意状态的下一页
			MdaUtils.clear(this.getLst());
			Platform.mdbReadset(this.getLst(),new Argument("smtinr",this.getSmp().getSmtinr()).and("pagamenum",getPagnum(this.getSmp().getPagamenum(),1)));
			/// 如果无后页新增后页
			if(MdaUtils.isEmpty(this.getLst()) || this.getLst().fullSize()==0)
			{
			  int curno = Integer.valueOf(this.getSmp().getPagamenum());
			  creatLoseSmps(curno+1,curno+1);
			  return false;
			}
			Map<String,String> map = (Map<String,String>)this.getErrmap();
			for(com.ceb.gjjs.mda.bo.Smp smp :this.getLst())
			{
			  log.debug("{}","找到下页"+smp.getInr()+" pagamenum "+smp.getPagamenum()+ "errtyp "+smp.getErrtyp());
			  String errtyp = smp.getErrtyp();
			  if(errtyp==null)errtyp="";
			  /// 如果下页是重页缺页不处理返回
			  if(errtyp.contains("1") || errtyp.contains("2") || errtyp.contains("4"))
			    continue;
			  if(!errtyp.contains("3"))
			    continue;
			  /// 如果下页状态为 3不连续 则需要校验下页金额等信息
			  Platform.removeError(MdaDriver.getDatafield(smp,"errtyp"),"3");
			  /// 校验与后页是否金额连续
			  BigDecimal endamt = this.getSmp().getNewendamt();
			  BigDecimal begamt = smp.getNewbegamt();
			  if(endamt.compareTo(begamt)!=0)
			  {
			    smp.setSta("1");//问题
			    Platform.addError(MdaDriver.getDatafield(smp,"errtyp"),"5");// 页间金额不连续
			    log.error("{}","对账单页 "+smp.getInr()+" 页间金额不连续");
			  }
			  else
			  {
			    Platform.removeError(MdaDriver.getDatafield(smp,"errtyp"),"5");
			  }
			  /// 如果经过检验只有不连续的问题 则将对账单页改为正常
			  if("".equals(smp.getErrtyp()))
			  {
			    smp.setSta( "0");
			    smp.setErrtyp( "0");
			  }
			  Platform.mdbUpdate(smp);
			  map.put(smp.getInr(),smp.getErrtyp());
			}
			this.setErrmap(map);
			return true;
		}
        /**
        *   source:smpsub.@0009.script
        */
        public String getErrorMessageFroType(String errtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(errtyp)||"0".equals(errtyp))
			  return "正常";
			String errmsgStr = "";
			int len = errtyp.length();
			for(int i =0;i< len;i++)
			{
			  String errlbl = MdaUtils.getCodetableLabel("errtyp",String.valueOf(errtyp.charAt(i)));
			  errmsgStr = errmsgStr + errlbl+"\r\n";
			}
			errmsgStr = errmsgStr.substring(0,errmsgStr.length() - 2);
			return errmsgStr;
		}
        /**
        *   source:smpsub.@0011.script
        */
        public String getSmhInr(String mpiinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(mpiinr))
			  return null;
			String sql = "SELECT inr FROM smh WHERE mpiinr = '"+mpiinr+"'";
			Platform.mdbExecuteSQL(sql);
			Argument<String> smhinr =  new Argument<String>("inr");
			Platform.mdbFetchFields(smhinr);
			int errorcode = ctx.getErrorCode();
			Platform.mdbCloseCursor();
			if(errorcode == NO_ERROR)
			{
			  return smhinr.value;
			}
			return null;
		}
        /**
        *   source:smpsub.@0012.script
        */
        public String getMpsInr(String mpiinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(mpiinr))
			  return null;
			String sql = "SELECT inr FROM smh WHERE mpiinr = '"+mpiinr+"'";
			Platform.mdbExecuteSQL(sql);
			Argument<String> smhinr =  new Argument<String>("inr");
			Platform.mdbFetchFields(smhinr);
			int errorcode = ctx.getErrorCode();
			Platform.mdbCloseCursor();
			if(errorcode == NO_ERROR)
			{
			  return smhinr.value;
			}
			return null;
		}
        /**
        *   source:smpsub.@0013.script
        */
        public boolean checkAmtAndSetErrtypToBorderPage(int step)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getSmp()))
			{
			  return false;
			}
			if(step!=1 && step!= -1)
			  return false;
			MdaUtils.clear(this.getPre());
			Platform.mdbRead(this.getPre(),new Argument("smtinr",this.getSmp().getSmtinr()).and("pagamenum",getPagnum(this.getSmp().getPagamenum(),step)));
			if(MdaUtils.isEmpty(this.getPre())||MdaUtils.isEmpty(this.getPre().getInr()))
			  return true;
			if(step==1)
			{
			  log.debug("{}","查询到后页 errtyp "+this.getPre().getErrtyp());
			  /// 校验与后页是否金额连续
			  BigDecimal endamt = this.getSmp().getNewendamt();
			  BigDecimal begamt = this.getPre().getNewbegamt();
			  log.trace("{}","endamt "+endamt+" begamt" +begamt);
			  if(endamt.compareTo(begamt)!=0)
			  {
			    this.getPre().setSta("1");//问题
			    Platform.addError(MdaDriver.getDatafield(this.getPre(),"errtyp"),"5");// 页间金额不连续
			    log.error("{}","对账单页 "+this.getPre().getInr()+" 与后页间金额不连续");
			  }
			  else
			  {
			    Platform.removeError(MdaDriver.getDatafield(this.getPre(),"errtyp"),"5");
			  }

			  if(!"0".equals(this.getPre().getSta()) && "".equals(this.getPre().getErrtyp()))
			  {
			    this.getPre().setSta( "0");
			    this.getPre().setErrtyp( "0");
			  }
			  Platform.mdbUpdate(this.getPre());
			}
			else
			{
			  log.debug("{}","查询到前页 errtyp "+this.getPre().getErrtyp());
			  /// 页间金额不连续
			  BigDecimal endamt = this.getPre().getNewendamt();
			  BigDecimal begamt = this.getSmp().getNewbegamt();
			  log.trace("{}","endamt "+endamt+" begamt" +begamt);
			  if(endamt.compareTo(begamt)!=0)
			  {
			    this.getSmp().setSta("1");//问题
			    Platform.addError(MdaDriver.getDatafield(this.getSmp(),"errtyp"),"5");
			    log.error("{}","对账单页 "+this.getSmp().getInr()+" 与前页页间金额不连续");
			  }
			  else
			  {
			    Platform.removeError(MdaDriver.getDatafield(this.getSmp(),"errtyp"),"5");
			  }
			  if(!"0".equals(this.getSmp().getSta()) && "".equals(this.getSmp().getErrtyp()))
			  {
			    this.getSmp().setSta( "0");
			    this.getSmp().setErrtyp( "0");
			  }
			}
			return true;
		}
        /**
        *   source:smpsub.@0014.script
        */
        public String getErrorTypeMessage(String errtyp,String token)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String errmsgStr = "";
			if(MdaUtils.isEmpty(errtyp))
			  return errmsgStr;
			if(MdaUtils.isEmpty(token))
			  token="/";
			int len = errtyp.length();
			for(int i=0;i<len;i++)
			{
			  String err = MdaUtils.getCodetableLabel("errtyp",String.valueOf(errtyp.charAt(i)));
			  if(err == null)
			  {
			    if(errtyp.contains("00"))
			    {
			      err = "强制正确";
			      i++;
			    }
			    else
			      err = "正常";
			  }
			  errmsgStr = errmsgStr+err + token;
			}
			errmsgStr = errmsgStr.substring(0,errmsgStr.length() - token.length());
			//log.debug("errmsgStr = "+errmsgStr);
			return errmsgStr;
		}










        public void setSmtHolder(ModuleHolder<Smt> smt)
        {
            this.smt = smt;
        }

        public Smt getSmt()
        {
           return this.smt.get();
        }





}