package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Chn;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sndp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Sndp.class);

        //查询
        private IControl schbtn;

        //清空
        private IControl clrbtn;

        //即时信息
        private IControl lnsmsg;

        //导出
        private IStream expexl = new StreamImpl();

        //新增
        private IControl newmsg;

        //接收起始时间
        private Date rcvdatsta;

        //接收截止时间
        private Date rcvdatend;

        //境外渠道
        private String chn;

        //行内系统
        private String chnipt;

        //报文标准
        private String msgtyp;

        //报文类型
        private String subtyp;

        //服务类型
        private String sty;

        //发报行BIC
        private String sndbak;

        //收报行BIC
        private String revbak;

        //清算行BIC
        private String actbic;

        //20域编号
        private String othref;

        //21域编号
        private String ownref;

        //币种
        private String cur;

        //帐号
        private String act;

        //金额下限
        private BigDecimal amtmin = new BigDecimal("0.00");

        //金额上限
        private BigDecimal amtmax = new BigDecimal("0.00");

        //回执状态
        private String rspsta;

        //回执状态标签
        private String tblrsp;

        //回执状态标签
        private String tblrsm;

        //记录所选择的某项
        private String selidx;

        //新建
        private IControl add;

        //修改
        private IControl ame;

        //操作员
        private String usrnam;

        //处理状态
        private String sta;

        //处理状态标签
        private String starsp;

        //处理状态标签
        private String starsm;

        //费用明细
        private String dtlchg;

        //返回
        private IControl rtn;

        //UETR
        private String uetr;

        //gpi报文标识
        private String gpi;

        //信用证编号
        private String lcnb;

        //业务类型编码
        private String txtpcd;

        //业务种类编码
        private String ctgpcd;

        //发送
        private IControl send;

        //退出
        private IControl logout;

        //原报
        private String rawmsg;

        //业务状态查询
        private IControl servicesq;

        //发起直接参与机构
        private String insgdp;

        //发起直接参与机构LEI码
        private String insdpl;

        //发起参与机构LEI码
        private String insgpl;

        //接收直接参与机构
        private String insddp;

        //接收直接参与机构LEI码
        private String insddl;

        //接收参与机构LEI码
        private String inspdl;

        //系统编号
        private String syscod;

        //备注
        private String rmk;

        //申请
        private IControl applyf;


        @JsonIgnore
        @BDGetter
        private transient IPanel schall;

        @JsonIgnore
        @BDGetter
        private transient IPanel schlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel schpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel sndtls;

        @JsonIgnore
        @BDGetter
        private transient IPanel msglst;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel lnspnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel ssqpnl;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Msggrp> msggrp;

	    @BDGetter
		private Chn chnxor;

	    @BDGetter
		private Chn chntmp;

	    @BDGetter
		private Maxmod maxmod;

	    @BDGetter
		private Msgmod msgmod;

	    @BDGetter
		private Smpmod smpmod;

	    @BDGetter
		private Smh smhtmp;


		public Sndp()
        {
            super();
            setArgument();
        }

        public Sndp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:sndp.@0000.script
        */
        @Rule(target="clrbtn",order=100)
        public boolean ruleClrbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//清空
			this.setChnipt(NULLSTR);
			//$rcvdatsta = Platform.formatDateTime(Platform.today(),"0");
			//$rcvdatend = Platform.formatDateTime(Platform.today(),"235959");
			//Platform.clear($msgtyp);
			this.setSubtyp(NULLSTR);
			this.setSndbak(NULLSTR);
			this.setRevbak(NULLSTR);
			this.setActbic(NULLSTR);
			this.setOthref(NULLSTR);
			this.setOwnref(NULLSTR);
			this.setUetr(NULLSTR);
			this.setCur(NULLSTR);
			this.setAct(NULLSTR);
			this.setAmtmin(new BigDecimal(0));
			this.setAmtmax(new BigDecimal(0));
			this.setRspsta(NULLSTR);
			this.setUsrnam(NULLSTR);
			this.setSta(NULLSTR);
			this.setDtlchg(NULLSTR);
			this.setLcnb(NULLSTR);

			//显示
			
			//Platform.setModified($rcvdatsta);
			//Platform.setModified($rcvdatend);
			//Platform.setModified($msgtyp);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			


			return true;
        }

        /**
        *   source:sndp.@0002.script
        */
        @Rule(target="expexl",order=100)
        public boolean ruleExpexlN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream is = this.getExpexl();
			is.setType("xls");
			is.setName("Msg"+MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss")+".xls");
			List<Object[]> lst = new ArrayList<Object[]>();
			String [] title= new String[57];
			title[0]="起息日";
			title[1]="20域编号";
			title[2]="21域编号";
			title[3]="币种";
			title[4]="金额";
			title[5]="账号";
			title[6]="子系统";
			title[7]="行内系统";
			title[8]="发报行BIC";
			title[9]="收报行BIC";
			title[10]="报文标准";
			title[11]="报文类型";
			title[12]="发送时间";
			title[13]="处理状态";
			title[14]="回执状态";
			title[15]="登录状态";
			title[16]="系统编号";
			title[17]="报文编号";
			title[18]="业务类型编码";
			title[19]="业务种类编码";
			title[20]="报文标识号";
			title[21]="报文发送时间";
			title[22]="发起直接参与机构";
			title[23]="发起直接参与机构LEI码";
			title[24]="发起参与机构";
			title[25]="发起参与机构LEI码";
			title[26]="接收直接参与机构";
			title[27]="接收直接参与机构LEI码";
			title[28]="接受参与机构";
			title[29]="接受参与机构LEI码";
			title[30]="系统编号";
			title[31]="备注";
			title[32]="原申请报文标识号";
			title[33]="原申请发起参与机构";
			title[34]="原申请接收机构标识";
			title[35]="原报文类型";
			title[36]="原报文发起时间";
			title[37]="业务状态";
			title[38]="处理信息摘要";
			title[39]="应答信息";
			title[40]="处理状态";
			title[41]="处理码";
			title[42]="拒绝信息";
			title[43]="终态日期";
			title[44]="接收时间";
			title[45]="转发时间";
			title[46]="原被查询报文标识号";
			title[47]="原被查询发起参与机构";
			title[48]="原被查询报文类型";
			title[49]="原业务类型代码";
			title[50]="原账务日期";
			title[51]="原账务处理状态";
			title[52]="处理描述";
			title[53]="账务日期";
			title[54]="被查询业务状态";
			title[55]="订单状态";
			title[56]="附言";
			lst.add(title);
			for(int i=0;i<this.getMsggrp().getRcvlst().fullSize();i++)
			{
			  Object [] line = new Object[57];
			  Date vludat = this.getMsggrp().getRcvlst().getElement(i).getValdat();
			  line[0]=MdaUtils.format(vludat,"yyyy-MM-dd");
			  line[1]=this.getMsggrp().getRcvlst().getElement(i).getOthref();
			  line[2]=this.getMsggrp().getRcvlst().getElement(i).getOwnref();
			  line[3]=this.getMsggrp().getRcvlst().getElement(i).getCur();
			  BigDecimal amt = this.getMsggrp().getRcvlst().getElement(i).getAmt();
			  amt = amt.setScale(2);
			  line[4]=amt.toString();
			  line[5]=this.getMsggrp().getRcvlst().getElement(i).getAct();
			  String nxtchncod = this.getMsggrp().getRcvlst().getElement(i).getNxtchncod();
			  if(MdaUtils.isEmpty(nxtchncod))
			    line[6]="";
			  else
			    line[6]=MdaUtils.getCodetableLabel("chncod",nxtchncod);
			  String chncod = this.getMsggrp().getRcvlst().getElement(i).getChncod();
			  if(MdaUtils.isEmpty(chncod))
			    line[7]="";
			  else
			    line[7]=MdaUtils.getCodetableLabel("chncod",chncod);
			  String sta = this.getMsggrp().getRcvlst().getElement(i).getSta();
			  line[8]=this.getMsggrp().getRcvlst().getElement(i).getSndbic();
			  line[9]=this.getMsggrp().getRcvlst().getElement(i).getRcvbic();
			  String msgtyp = this.getMsggrp().getRcvlst().getElement(i).getMsgtyp();
			  line[10]=MdaUtils.getCodetableLabel("msgmst",msgtyp);
			  line[11]=this.getMsggrp().getRcvlst().getElement(i).getSubtyp();
			  Date snddattim =this.getMsggrp().getRcvlst().getElement(i).getSnddattim();
			  line[12]=MdaUtils.format(snddattim,"yyyy-MM-dd HH:mm:ss");
			  line[13]=MdaUtils.getCodetableLabel("stacod",sta);
			  line[14]=this.getMsggrp().getRcvlst().getElement(i).getRspsta();
			  String loginoprtp = this.getMsggrp().getRcvlst().getElement(i).getLoginoprtp();
			  line[15]=MdaUtils.getCodetableLabel("loginoprtp",loginoprtp);
			  line[16]=this.getMsggrp().getRcvlst().getElement(i).getSid();
			  line[17]=this.getMsggrp().getRcvlst().getElement(i).getMtp();
			  line[18]=this.getMsggrp().getRcvlst().getElement(i).getTxtpcd();
			  line[19]=this.getMsggrp().getRcvlst().getElement(i).getCtgpcd();
			  line[20]=this.getMsggrp().getRcvlst().getElement(i).getMid();
			  Date credat = this.getMsggrp().getRcvlst().getElement(i).getCredat();
			  if(credat != null)
			  {
			    line[21]=MdaUtils.format(credat,"yyyy-MM-dd HH:mm:ss");
			  }
			  else
			  {
			    line[21]="";
			  }
			  line[22]=this.getMsggrp().getRcvlst().getElement(i).getInsgdp();
			  line[23]=this.getMsggrp().getRcvlst().getElement(i).getInsdpl();
			  line[24]=this.getMsggrp().getRcvlst().getElement(i).getInsgty();
			  line[25]=this.getMsggrp().getRcvlst().getElement(i).getInsgpl();
			  line[26]=this.getMsggrp().getRcvlst().getElement(i).getInsddp();
			  line[27]=this.getMsggrp().getRcvlst().getElement(i).getInsddl();
			  line[28]=this.getMsggrp().getRcvlst().getElement(i).getInsdty();
			  line[29]=this.getMsggrp().getRcvlst().getElement(i).getInspdl();
			  line[30]=this.getMsggrp().getRcvlst().getElement(i).getSyscod();
			  line[31]=this.getMsggrp().getRcvlst().getElement(i).getRmk();
			  line[32]=this.getMsggrp().getRcvlst().getElement(i).getOrgmid();
			  line[33]=this.getMsggrp().getRcvlst().getElement(i).getOrginspty();
			  line[34]=this.getMsggrp().getRcvlst().getElement(i).getOrginapty();
			  line[35]=this.getMsggrp().getRcvlst().getElement(i).getOrgmsgtyp();
			  Date orgsnddat = this.getMsggrp().getRcvlst().getElement(i).getOrgsnddat();
			  if(orgsnddat != null)
			  {
			    line[36]=MdaUtils.format(orgsnddat,"yyyy-MM-dd HH:mm:ss");
			  }
			  else
			  {
			    line[36]="";
			  }
			  line[37]=this.getMsggrp().getRcvlst().getElement(i).getStscod();
			  line[38]=this.getMsggrp().getRcvlst().getElement(i).getPrcmsgdig();
			  line[39]=this.getMsggrp().getRcvlst().getElement(i).getRspmsg();
			  line[40]=this.getMsggrp().getRcvlst().getElement(i).getPrcsts();
			  line[41]=this.getMsggrp().getRcvlst().getElement(i).getProccd();
			  line[42]=this.getMsggrp().getRcvlst().getElement(i).getRjcinf();
			  Date sstdat = this.getMsggrp().getRcvlst().getElement(i).getSstdat();
			  if(sstdat != null)
			  {
			    line[43]=MdaUtils.format(sstdat,"yyyy-MM-dd HH:mm:ss");
			  }
			  else
			  {
			    line[43]="";
			  }
			  Date rcvdat = this.getMsggrp().getRcvlst().getElement(i).getRcvdat();
			  if(rcvdat != null)
			  {
			    line[44]=MdaUtils.format(rcvdat,"yyyy-MM-dd HH:mm:ss");
			  }
			  else
			  {
			    line[44]="";
			  }
			  Date trndat = this.getMsggrp().getRcvlst().getElement(i).getTrndat();
			  if(trndat != null)
			  {
			    line[45]=MdaUtils.format(trndat,"yyyy-MM-dd HH:mm:ss");
			  }
			  else
			  {
			    line[45]="";
			  }
			  line[46]=this.getMsggrp().getRcvlst().getElement(i).getOrpmid();
			  line[47]=this.getMsggrp().getRcvlst().getElement(i).getOrpinspty();
			  line[48]=this.getMsggrp().getRcvlst().getElement(i).getOrpinapty();
			  line[49]=this.getMsggrp().getRcvlst().getElement(i).getOrityp();
			  Date oridat = this.getMsggrp().getRcvlst().getElement(i).getOridat();
			  if(oridat != null)
			  {
			    line[50]=MdaUtils.format(oridat,"yyyy-MM-dd HH:mm:ss");
			  }
			  else
			  {
			    line[50]="";
			  }
			  line[51]=this.getMsggrp().getRcvlst().getElement(i).getOrists();
			  line[52]=this.getMsggrp().getRcvlst().getElement(i).getOpinfo();
			  Date oriaccdat = this.getMsggrp().getRcvlst().getElement(i).getOriaccdat();
			  if(oriaccdat != null)
			  {
			    line[53]=MdaUtils.format(oriaccdat,"yyyy-MM-dd HH:mm:ss");
			  }
			  else
			  {
			    line[53]="";
			  }
			  line[54]=this.getMsggrp().getRcvlst().getElement(i).getTrasts();
			  line[55]=this.getMsggrp().getRcvlst().getElement(i).getBllpaysts();
			  line[56]=this.getMsggrp().getRcvlst().getElement(i).getRemark();
			  lst.add(line);
			}
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }

        /**
        *   source:sndp.@0003.script
        */
        @Rule(target="msggrp.rcvlst",order=100)
        public boolean ruleMsggrpRcvlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			//记下选择项
			this.setSelidx( ""+index);
			String mpsinr = this.getMsggrp().getRcvlst().getElement(index).getInr();
			String msgtyp = this.getMsggrp().getRcvlst().getElement(index).getMsgtyp();
			ctx.storeData("mpsinr",mpsinr);
			ctx.storeData("msgtyp",msgtyp);
			//发报疑似重复处理
			log.info("{}","getTransName=======" + ctx.getTransName());
			if("sndsel,rs".equals(ctx.getTransName())||"sndsel,fm,rs".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgrsm");
			}
			else if("sndsel,ac".equals(ctx.getTransName()))
			{
			  Platform.mchain("manack");
			}
			else if("sndsel,er".equals(ctx.getTransName()))
			{
			  Platform.mchain("emgame");
			}
			else if("sndsel,se".equals(ctx.getTransName()))
			{
			  if("E".equals(this.getMsggrp().getRcvlst().getElement(index).getSta()))
			  {
			    Platform.mchain("msgsep");
			  }
			  else if("0".equals(this.getMsggrp().getRcvlst().getElement(index).getSta()))
			  {
			    Platform.mchain("msgsta");
			  }
			  else
			  {
			    ctx.setMessage(MdaUtils.getI18NString("sndp","CT000204"),MdaUtils.getI18NString("sndp","CT000205"));
			  }
			}
			//状态为0的报文处理，已废弃
			else if("sndsel,sta".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgsta");
			}
			//报文编辑
			else if("sndsel,ame".equals(ctx.getTransName()))
			{
			  Platform.mchain("msgame");
			}
			else if("msgsel".equals(ctx.getTransName()) || "fhesel".equals(ctx.getTransName()))
			{
			  if("B".equals(this.getMsggrp().getRcvlst().getElement(index).getSta()))
			  {
			    String user = MdaEnv.getLoginUser();
			    log.debug("{}","msgsel user:"+user);
			    log.debug("{}","msgsel rcvlst usrnam:"+this.getMsggrp().getRcvlst().getElement(index).getUsrnam());
			    if(!user.equals(this.getMsggrp().getRcvlst().getElement(index).getUsrnam()))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("sndp","CT000245"),MdaUtils.getI18NString("sndp","CT000246"));
			      return true;
			    }
			  }
			  Platform.mchain("msgchk");
			}
			else
			{
			  Platform.mchain("msgdtl");
			}

			return true;
        }

        /**
        *   source:sndp.@0015.script
        */
        @Rule(target="schbtn",order=200)
        public boolean ruleSchbtnN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRcvdatsta()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000202"),MdaUtils.getI18NString("sndp","CT000203"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getRcvdatend()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000284"),MdaUtils.getI18NString("sndp","CT000285"));
			  return true;
			}
			//仅允许查询半年内的报文
			if(!MdaUtils.isEmpty(this.getRcvdatend()) && !MdaUtils.isEmpty(this.getRcvdatsta()))
			{
			  long quot = 0;
			  String s1 = MdaUtils.format(this.getRcvdatend(),"yyyyMMdd");
			  Date dd = MdaUtils.parseDate(s1,"yyyyMMdd");

			  String dattim = MdaUtils.format(this.getRcvdatsta(),"yyyyMMdd");
			  Date d = MdaUtils.parseDate(dattim,"yyyyMMdd");

			  quot = dd.getTime() - d.getTime();
			  quot = quot / 1000 / 60 / 60 / 24;

			  /*if(quot > 180)
			    {
			    Platform.message(#CT000286,#CT000287);
			    return;
			    }
			    */
			}

			MdaUtils.clear(this.getMsggrp().getRcvlst());
			String sql = "WHERE m1.inr=m2.inr AND m1.dir='<' AND m1.pntinr IS NULL ";
			sql += "AND (subtyp <>'990' OR msgtyp <>'fxl')";    //20211215排除fxps990报文
			List sqldata = new ArrayList();
			sqldata.clear();
			String transname = ctx.getTransName();
			//201908 新增信用证编号
			if("exl".equals(this.getMsgtyp())&&!MdaUtils.isEmpty(this.getLcnb()))
			{
			  sql+=" AND m2.lcnb=?";
			  sqldata.add(this.getLcnb());
			}
			if("sndsel,rs".equals(transname))//疑似重复
			{
			  sql = sql + " AND m1.nxtchncod='ZZZ' AND m1.sta<>'F'";
			}
			else if("sndsel,ac".equals(transname))//疑似BIC或账号错误
			{
			  sql = sql + " AND m1.nxtchncod<>'ZZZ' AND m1.sta='D' AND m1.rspsta='W'";
			}
			else if("sndsel,er".equals(transname))//NCK报文处理
			{
			  sql = sql + " AND m1.rspsta='N' AND m1.nxtchncod<>'MAN'";
			}
			else if("sndsel,se".equals(transname))//发报失败处理
			{
			  //sql = sql + " AND m1.sta='E'";
			  //sql = "WHERE m1.inr=m2.inr AND m1.pntinr IS NULL AND (( m1.dir='<' AND m1.sta='E' ) OR ( m1.sta='0' AND m1.lstdattim<? ))";
			  //收发报失败处理调整
			  //20211111
			  //SmileKid
			  sql = "WHERE m1.inr=m2.inr AND m1.pntinr IS NULL AND ( m1.sta='E'  OR ( m1.sta='0' AND m1.lstdattim<? ))";
			  Date today = MdaUtils.today();
			  long time = today.getTime();
			  time = time - 10800000;
			  today.setTime(time);
			  sqldata.add(today);
			}
			//报文编辑查询，查询待编辑报文
			else if("sndsel,ame".equals(transname))
			{
			  sql = sql + " AND m1.nxtchncod='MAN' AND m1.sta='W'";
			}
			//修改报文状态，查询状态为0的，提供改为W和D的功能
			else if("sndsel,sta".equals(transname))
			{
			  sql = "WHERE m1.inr=m2.inr AND m1.pntinr IS NULL AND m1.sta='0'";
			}
			//查询待人工复查的报文
			else if("msgsel".equals(transname))
			{
			  //sql = "WHERE m1.inr=m2.inr AND m1.pntinr IS NULL AND (m1.srcchncod='HWE' OR m1.srcchncod='FWE' OR m1.srcchncod='AUT')";
			  sql = "WHERE m1.inr=m2.inr AND m1.pntinr IS NULL AND m1.srcchncod IN ('HWE','FWE','CWE','AUT','DZF') ";
			}
			//查询报文丢弃
			else if("sndsel,dq".equals(ctx.getTransName()))
			{
			  sql += " AND m1.rspsta = 'G' ";
			}
			if(!MdaUtils.isEmpty(this.getSta()))
			{
			  sql = sql + " AND m1.sta=?";
			  sqldata.add(this.getSta());
			}
			if(!MdaUtils.isEmpty(this.getChnipt()))
			{
			  //20190507改动：当选中渠道为ZYW时，默认查询ZYW OR ZYS两个渠道的报文
			  if(!MdaUtils.isEmpty(this.getChnipt()) && "ZYW".equals(this.getChnipt()))
			  {
			    sql = sql + " AND (m1.srcchncod=? or m1.srcchncod= 'ZYS')";
			  }
			  else
			  {
			    sql = sql + " AND m1.srcchncod=?";
			  }
			  //sql = sql + " AND m1.srcchncod=?";
			  sqldata.add(this.getChnipt());
			}
			if(!MdaUtils.isEmpty(this.getRcvdatsta()))
			{
			  sql = sql + " AND m1.rcvdattim>=?";
			  sqldata.add(this.getRcvdatsta());
			}
			if(!MdaUtils.isEmpty(this.getRcvdatend()))
			{
			  sql = sql + " AND m1.rcvdattim<=?";
			  sqldata.add(this.getRcvdatend());
			}
			if(!MdaUtils.isEmpty(this.getRspsta()))
			{
			  if("L".equals(this.getRspsta()))
			  {
			    sql = sql + " AND m1.rspsta<>'A'";
			  }
			  else
			  {
			    sql = sql + " AND m1.rspsta=?";
			    sqldata.add(this.getRspsta());
			  }
			}
			if(!MdaUtils.isEmpty(this.getUsrnam()))
			{
			  sql = sql + " AND m2.usrnam LIKE'"+"%"+this.getUsrnam()+"%"+"'";
			}
			//报文标准
			if(!MdaUtils.isEmpty(this.getMsgtyp()))
			{
			  if("gisp".equals(this.getMsgtyp()))
			  {
			    sql = sql+" AND (m1.tgtchncod = ? or m1.swetyp = 'E') ";
			    sqldata.add("SWE");
			  }
			  else
			  {
			    sql = sql+" AND m2.msgtyp=?";
			    sqldata.add(this.getMsgtyp());
			  }
			}
			//报文类型
			if(!MdaUtils.isEmpty(this.getSubtyp()))
			{
			  sql = sql+" AND m2.subtyp=?";
			  sqldata.add(this.getSubtyp());
			}
			//GPI标识
			if(!MdaUtils.isEmpty(this.getGpi()))
			{
			  //sql = sql+" AND m2.gpi=?";
			  //sqldata.add($gpi.getValue());
			  //20190114 SSF 新加，‘非GPI’ 查询条件
			  if("GPI".equals(this.getGpi()))
			  {
			    sql = sql+" AND m2.gpi=?";
			    sqldata.add(this.getGpi());
			  }
			  else
			  {
			    sql = sql+" AND m2.gpi is null ";

			  }
			}

			//服务类型
			//发报行BIC
			if(!MdaUtils.isEmpty(this.getSndbak()))
			{
			  sql = sql+" AND m2.sndbic LIKE'"+"%"+this.getSndbak()+"%"+"'";
			}
			//收报行BIC
			if(!MdaUtils.isEmpty(this.getRevbak()))
			{
			  sql = sql+" AND m2.rcvbic LIKE'"+"%"+this.getRevbak()+"%"+"'";
			}

			//20域编号
			if(!MdaUtils.isEmpty(this.getOthref()))
			{
			  sql = sql+" AND m2.othref LIKE'"+"%"+this.getOthref()+"%"+"'";
			}
			//21域编号
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  sql = sql+" AND m2.ownref LIKE'"+"%"+this.getOwnref()+"%"+"'";
			}
			//UETR
			if(!MdaUtils.isEmpty(this.getUetr()))
			{
			  sql = sql+" AND m2.uetr LIKE'"+"%"+this.getUetr()+"%"+"'";
			}
			//币种
			if(!MdaUtils.isEmpty(this.getCur()))
			{
			  sql = sql+" AND m2.cur=?";
			  sqldata.add(this.getCur());
			}
			//帐号
			if(!MdaUtils.isEmpty(this.getAct()))
			{
			  sql = sql+" AND m2.act LIKE'"+"%"+this.getAct()+"%"+"'";
			}
			//费用明细
			if(!MdaUtils.isEmpty(this.getDtlchg()))
			{
			  sql = sql+" AND m2.dtlchg=?";
			  sqldata.add(this.getDtlchg());
			}
			//金额
			if(!MdaUtils.isEmpty(this.getAmtmin()))
			{
			  sql = sql+" AND m2.amt>=?";
			  sqldata.add(this.getAmtmin());
			}
			if(!MdaUtils.isEmpty(this.getAmtmax()))
			{
			  sql = sql+" AND m2.amt<=?";
			  sqldata.add(this.getAmtmax());
			}
			//账户行BIC
			if(!MdaUtils.isEmpty(this.getActbic()))
			{
			  sql = sql+" AND (m2.actbic LIKE'"+"%"+this.getActbic()+"%"+"'"+" OR m2.t53bic LIKE'"+this.getActbic()+"%"+"')";
			}

			//增加实体查询条件
			// sql = sql+$\\sysmod.getEtySql("m2");
			
			String maxsql="SELECT count(*) maxnum FROM mps m1,mpi m2 "+sql;
			log.info("{}","select snd maxsql="+maxsql);

			if("msgsel".equals(transname))
			  sql = sql + " ORDER BY m1.inr DESC";
			else
			  sql = sql+" ORDER BY m1.lstdattim DESC";

			log.debug("{}","sql ="+sql);
			log.debug("{}","sqldata ="+sqldata.toArray());
			log.debug("{}","[SQL]:"+sql);
			log.debug("{}","[SQL DATA]:"+sqldata);

			/*int maxcount1=$maxmod.getMaxCounterOfSelect();
			  long maxcount2=$maxmod.getCounterOfMpi(Platform.getDefaultDB(),maxsql,sqldata.toArray());
			  log.info("maxcount2="+maxcount2+" , maxcount1="+maxcount1);
			  if(maxcount2 >= maxcount1)
			  {
			  Platform.setModified( $msggrp\\rcvlst);
			  Platform.message(#CT000288,"查询的数据总量查过:"+maxcount1+"笔,请注意查询条件!");
			  return;
			  }*/

			Platform.mdbReadset(new IModuleList[]{this.getMsggrp().getMpss(),this.getMsggrp().getMpis()},0,sql,sqldata.toArray());
			//组合成为rcvlst
			int errorCode = ctx.getErrorCode();
			log.info("{}","[SQL ERROR CODE]:"+errorCode);
			log.info("{}","[DB]:"+Platform.getDefaultDB());
			log.info("{}","errorcode="+errorCode);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  for(int i=0;i<this.getMsggrp().getMpss().fullSize();i++)
			  {
			    if("<".equals(this.getMsggrp().getMpss().getElement(i).getDir()))
			    {
			      //子系统和行内系统置位
			      this.getMsggrp().getMpss().getElement(i).setChncod( this.getMsggrp().getMpss().getElement(i).getSrcchncod());
			      //20190115新加，如srcchncod是前置子系统，则放置nxtchncod信息
			      if(!MdaUtils.isEmpty(this.getMsggrp().getMpss().getElement(i).getChncod()))
			      {
			        Platform.mdbRead(this.getChntmp(),new Argument<String>("cod",EQ,this.getMsggrp().getMpss().getElement(i).getChncod()));
			        if("N".equals(this.getChntmp().getTyp()))
			        {
			          this.getMsggrp().getMpss().getElement(i).setNxtchncod( this.getMsggrp().getMpss().getElement(i).getChncod());
			          this.getMsggrp().getMpss().getElement(i).setChncod(NULLSTR);
			        }
			      }
			      if(!MdaUtils.isEmpty(this.getMsggrp().getMpss().getElement(i).getNxtchncod()))
			      {
			        Platform.mdbRead(this.getChnxor(),new Argument<String>("cod",EQ,this.getMsggrp().getMpss().getElement(i).getNxtchncod()));
			        if(!"N".equals(this.getChnxor().getTyp()))
			        {
			          this.getMsggrp().getMpss().getElement(i).setNxtchncod(NULLSTR);
			        }
			      }
			    }
			    else if(">".equals(this.getMsggrp().getMpss().getElement(i).getDir()))
			    {
			      //子系统和行内系统置位
			      if(!MdaUtils.isEmpty(this.getMsggrp().getMpss().getElement(i).getNxtchncod()))
			      {
			        Platform.mdbRead(this.getChnxor(),new Argument<String>("cod",EQ,this.getMsggrp().getMpss().getElement(i).getNxtchncod()));
			        if("B".equals(this.getChnxor().getTyp()))
			        {
			          this.getMsggrp().getMpss().getElement(i).setChncod( this.getMsggrp().getMpss().getElement(i).getNxtchncod());
			          this.getMsggrp().getMpss().getElement(i).setNxtchncod(NULLSTR);
			        }
			        else if("N".equals(this.getChnxor().getTyp()))
			        {
			          this.getMsggrp().getMpss().getElement(i).setChncod(NULLSTR);
			        }
			        else
			        {
			          this.getMsggrp().getMpss().getElement(i).setChncod(NULLSTR);
			          this.getMsggrp().getMpss().getElement(i).setNxtchncod(NULLSTR);
			        }
			      }
			    }
			    if("SWE".equals(this.getMsggrp().getMpss().getElement(i).getSrcchncod()) || "SWE".equals(this.getMsggrp().getMpss().getElement(i).getTgtchncod()) || "E".equals(this.getMsggrp().getMpss().getElement(i).getSwetyp()))
			    {
			      this.getMsggrp().getMpss().getElement(i).setSweflg( "X");
			    }
			    else
			    {
			      this.getMsggrp().getMpss().getElement(i).setSweflg(NULLSTR);
			    }
			    //log.debug("msgsel mps sta:"+$msggrp\\mpss[i]\\sta.getValue());
			    this.getMsggrp().getRcvlst().add(this.getMsggrp().getMpss().getElement(i).getInr(),this.getMsggrp().getMpss().getElement(i).getDir(),this.getMsggrp().getMpss().getElement(i).getSrcchncod(),this.getMsggrp().getMpss().getElement(i).getChncod(),this.getMsggrp().getMpss().getElement(i).getNxtchncod(),this.getMsggrp().getMpss().getElement(i).getTgtchncod(),this.getMsggrp().getMpss().getElement(i).getSmhinr(),this.getMsggrp().getMpss().getElement(i).getSta(),this.getMsggrp().getMpss().getElement(i).getRspsta(),this.getMsggrp().getMpss().getElement(i).getRcvdattim(),this.getMsggrp().getMpss().getElement(i).getLstdattim(),this.getMsggrp().getMpss().getElement(i).getSttdattim(),this.getMsggrp().getMpss().getElement(i).getTgtdattime(),this.getMsggrp().getMpss().getElement(i).getSnddattim(),this.getMsggrp().getMpss().getElement(i).getRspdattim(),this.getMsggrp().getMpis().getElement(i).getOwnref(),this.getMsggrp().getMpis().getElement(i).getOthref(),this.getMsggrp().getMpis().getElement(i).getSndbic(),this.getMsggrp().getMpis().getElement(i).getRcvbic(),this.getMsggrp().getMpis().getElement(i).getAct(),this.getMsggrp().getMpis().getElement(i).getDtlchg(),this.getMsggrp().getMpis().getElement(i).getCur(),this.getMsggrp().getMpis().getElement(i).getAmt(),this.getMsggrp().getMpis().getElement(i).getValdat(),this.getMsggrp().getMpis().getElement(i).getMsgtyp(),this.getMsggrp().getMpis().getElement(i).getSubtyp(),this.getMsggrp().getMpis().getElement(i).getActbic(),this.getMsggrp().getMpis().getElement(i).getT53bic(),this.getMsggrp().getMpis().getElement(i).getGpi(),this.getMsggrp().getMpis().getElement(i).getUsrnam(),this.getMsggrp().getMpis().getElement(i).getUetr(),this.getMsggrp().getMpis().getElement(i).getLcnb(), this.getMsggrp().getMpss().getElement(i).getSweflg(), this.getMsggrp().getMpss().getElement(i).getXhxflg(),this.getMsggrp().getMpis().getElement(i).getLoginoprtp(),this.getMsggrp().getMpis().getElement(i).getSid(),this.getMsggrp().getMpis().getElement(i).getMtp(),this.getMsggrp().getMpis().getElement(i).getTxtpcd(),this.getMsggrp().getMpis().getElement(i).getCtgpcd(),this.getMsggrp().getMpis().getElement(i).getMid(),this.getMsggrp().getMpis().getElement(i).getCredat(),this.getMsggrp().getMpis().getElement(i).getInsgdp(),this.getMsggrp().getMpis().getElement(i).getInsdpl(),this.getMsggrp().getMpis().getElement(i).getInsgty(),this.getMsggrp().getMpis().getElement(i).getInsgpl(),this.getMsggrp().getMpis().getElement(i).getInsddp(),this.getMsggrp().getMpis().getElement(i).getInsddl(),this.getMsggrp().getMpis().getElement(i).getInsdty(),this.getMsggrp().getMpis().getElement(i).getInspdl(),this.getMsggrp().getMpis().getElement(i).getSyscod(),this.getMsggrp().getMpis().getElement(i).getRmk(),this.getMsggrp().getMpis().getElement(i).getOrgmid(),this.getMsggrp().getMpis().getElement(i).getOrginspty(),this.getMsggrp().getMpis().getElement(i).getOrginapty(),this.getMsggrp().getMpis().getElement(i).getOrgmsgtyp(),this.getMsggrp().getMpis().getElement(i).getOrgsnddat(),this.getMsggrp().getMpis().getElement(i).getStscod(),this.getMsggrp().getMpis().getElement(i).getPrcmsgdig(),this.getMsggrp().getMpis().getElement(i).getRspmsg(),this.getMsggrp().getMpis().getElement(i).getPrcsts(),this.getMsggrp().getMpis().getElement(i).getProccd(),this.getMsggrp().getMpis().getElement(i).getRjcinf(),this.getMsggrp().getMpis().getElement(i).getSstdat(),this.getMsggrp().getMpis().getElement(i).getRcvdat(),this.getMsggrp().getMpis().getElement(i).getTrndat(),this.getMsggrp().getMpis().getElement(i).getOrpmid(),this.getMsggrp().getMpis().getElement(i).getOrpinspty(),this.getMsggrp().getMpis().getElement(i).getOrpinapty(),this.getMsggrp().getMpis().getElement(i).getOrityp(),this.getMsggrp().getMpis().getElement(i).getOridat(),this.getMsggrp().getMpis().getElement(i).getOrists(),this.getMsggrp().getMpis().getElement(i).getOpinfo(),this.getMsggrp().getMpis().getElement(i).getOriaccdat(),this.getMsggrp().getMpis().getElement(i).getTrasts(),this.getMsggrp().getMpis().getElement(i).getBllpaysts(),this.getMsggrp().getMpis().getElement(i).getRemark());
			  }
			}
			log.debug("{}","查出rcvlst记录"+this.getMsggrp().getRcvlst().fullSize());
			
			if(this.getMsggrp().getRcvlst().fullSize() == 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000289"),MdaUtils.getI18NString("sndp","CT000335"));
			}

			return true;
        }

        /**
        *   source:sndp.@0016.script
        */
        @Rule(target="newmsg",order=100)
        public boolean ruleNewmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("mpsinr","");
			Platform.mchain("msgame");

			return true;
        }

        /**
        *   source:sndp.@0022.script
        */
        @Rule(target="rtn",order=100)
        public boolean ruleRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:sndp.@0033.script
        */
        @Rule(target="lnsmsg",order=100)
        public boolean ruleLnsmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			log.debug("{}","index:"+index);
			if(index < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000343"),MdaUtils.getI18NString("sndp","CT000344"));
			  return false;
			}
			String subtyp =(String)this.getMsggrp().getRcvlst().getElement(index).getSubtyp();
			log.info("{}","报文类型"+ subtyp);
			if(!"cfcm.003.001.01".equals(subtyp))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000349"),MdaUtils.getI18NString("sndp","CT000350"));
			  return true;
			}
			MdaUtils.clear(this.getMsggrp().getGjsmsg());
			String smhinr=(String)this.getMsggrp().getRcvlst().getElement(index).getSmhinr();
			Platform.mdbRead(this.getSmhtmp(),new Argument<String>("inr",smhinr));
			String fileType=(String )this.getSmhtmp().getDocfxt();
			this.setRawmsg(this.getMsgmod().getFileContent(smhinr,fileType));
			


			return true;
        }

        /**
        *   source:sndp.@0034.script
        */
        @Rule(target="logout",order=100)
        public boolean ruleLogoutN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			this.setTxtpcd(null);
			this.setCtgpcd(null);

			
			this.setInsgdp(null);
			this.setInsdpl(null);
			this.setInsgpl(null);
			this.setInsddp(null);
			this.setInsddl(null);
			this.setInspdl(null);
			this.setSyscod(null);
			this.setRmk(null);

			return true;
        }

        /**
        *   source:sndp.@0035.script
        */
        @Rule(target="send",order=100)
        public boolean ruleSendN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getTxtpcd()))
			{
			  ctx.setFieldError(this,"txtpcd",MdaUtils.getI18NString("sndp","CT000345"));
			}
			if(MdaUtils.isEmpty(this.getCtgpcd()))
			{
			  ctx.setFieldError(this,"ctgpcd",MdaUtils.getI18NString("sndp","CT000346"));
			}
			if(MdaUtils.isEmpty(this.getTxtpcd())||MdaUtils.isEmpty(this.getCtgpcd()))
			{
			  return false;
			}
			String rawmsg = this.getRawmsg();
			String txtpcd = this.getTxtpcd();
			String ctgpcd = this.getCtgpcd();
			String json = this.createcfcm_001_001_01(rawmsg,txtpcd,ctgpcd);
			if(!this.storeMsgFromPlatWithoutChk(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000347"),MdaUtils.getI18NString("sndp","CT000348"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.info("{}","发报成功");
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000450"),MdaUtils.getI18NString("sndp","CT000451"));
			}
			
			this.setTxtpcd(null);
			this.setCtgpcd(null);


			return true;
        }

        /**
        *   source:sndp.@0037.script
        */
        @Rule(target="servicesq",order=100)
        public boolean ruleServicesqN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			log.debug("{}","index:"+index);
			if(index < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000363"),MdaUtils.getI18NString("sndp","CT000364"));
			  return false;
			}
			String subtyp =(String)this.getMsggrp().getRcvlst().getElement(index).getSubtyp();
			log.info("{}","报文类型"+ subtyp);
			MdaUtils.clear(this.getMsggrp().getGjsmsg());
			

			return true;
        }

        /**
        *   source:sndp.@0038.script
        */
        @Rule(target="applyf",order=100)
        public boolean ruleApplyfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getInsgdp()))
			{
			  ctx.setFieldError(this,"insgdp",MdaUtils.getI18NString("sndp","CT000369"));
			}
			if(MdaUtils.isEmpty(this.getInsdpl()))
			{
			  ctx.setFieldError(this,"insdpl",MdaUtils.getI18NString("sndp","CT000370"));
			}
			if(MdaUtils.isEmpty(this.getInsgpl()))
			{
			  ctx.setFieldError(this,"insgpl",MdaUtils.getI18NString("sndp","CT000371"));
			}
			if(MdaUtils.isEmpty(this.getInsddp()))
			{
			  ctx.setFieldError(this,"insddp",MdaUtils.getI18NString("sndp","CT000372"));
			}
			if(MdaUtils.isEmpty(this.getInsddl()))
			{
			  ctx.setFieldError(this,"insddl",MdaUtils.getI18NString("sndp","CT000443"));
			}
			if(MdaUtils.isEmpty(this.getInspdl()))
			{
			  ctx.setFieldError(this,"inspdl",MdaUtils.getI18NString("sndp","CT000444"));
			}
			if(MdaUtils.isEmpty(this.getSyscod()))
			{
			  ctx.setFieldError(this,"syscod",MdaUtils.getI18NString("sndp","CT000445"));
			}

			if(MdaUtils.isEmpty(this.getInsgdp())||MdaUtils.isEmpty(this.getInsdpl())||MdaUtils.isEmpty(this.getInsgpl())||MdaUtils.isEmpty(this.getInsddp())||MdaUtils.isEmpty(this.getInsddl())||MdaUtils.isEmpty(this.getInspdl())||MdaUtils.isEmpty(this.getSyscod()))
			{
			  return false;
			}
			String insgdp = this.getInsgdp();
			String insdpl = this.getInsdpl();
			String insgpl = this.getInsgpl();
			String insddp = this.getInsddp();
			String insddl = this.getInsddl();
			String inspdl = this.getInspdl();
			String syscod = this.getSyscod();
			String rmk = this.getRmk();

			int index = 0;
			String othref =(String)this.getMsggrp().getRcvlst().getElement(index).getOthref();//原报文标识号
			String sndbic =(String)this.getMsggrp().getRcvlst().getElement(index).getSndbic();//原报文发起参与机构
			String subtyp =(String)this.getMsggrp().getRcvlst().getElement(index).getSubtyp();//原报文类型
			
			String json = this.createcfcm_301_001_01(insgdp,insdpl,insgpl,insddp,insddl,inspdl,syscod,rmk,othref,sndbic,subtyp);
			if(!this.storeMsgFromPlatWithoutChk(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000446"),MdaUtils.getI18NString("sndp","CT000447"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.info("{}","发报成功");
			  ctx.setMessage(MdaUtils.getI18NString("sndp","CT000448"),MdaUtils.getI18NString("sndp","CT000449"));
			}
			
			this.setInsgdp(null);
			this.setInsdpl(null);
			this.setInsgpl(null);
			this.setInsddp(null);
			this.setInsddl(null);
			this.setInspdl(null);
			this.setSyscod(null);
			this.setRmk(null);

			return true;
        }


        /**
        *   source:sndp.@0007.script
        */
        @Check(target="sndbak",order=100)
        public boolean checkSndbakN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSndbak()))
			  return true;
			String sndbak = this.getSndbak();
			sndbak = sndbak.toUpperCase();
			if(!sndbak.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"sndbak",MdaUtils.getI18NString("sndp","CT000042"));
			}
			this.setSndbak( sndbak);
			

			return true;
        }

        /**
        *   source:sndp.@0008.script
        */
        @Check(target="revbak",order=100)
        public boolean checkRevbakN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRevbak()))
			  return true;
			String revbak = this.getRevbak();
			revbak = revbak.toUpperCase();
			if(!revbak.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"revbak",MdaUtils.getI18NString("sndp","CT000043"));
			}
			this.setRevbak( revbak);
			

			return true;
        }

        /**
        *   source:sndp.@0009.script
        */
        @Check(target="msgtyp",order=100)
        public boolean checkMsgtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(Platform.isEmpty($msgtyp.getValue()))
			  {
			  Platform.error($msgtyp,#CT000258);
			  return false;
			  }
			  else
			  if("sf2".equals($msgtyp.getValue()))
			  {
			  Platform.setDefaultDB("swd");
			  Platform.setValues($subtyp,getMtyList());
			  Platform.setModified($subtyp);
			  Platform.enable($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  setRspsta("sf2");
			  Platform.enable($gpi);
			  Platform.enable($uetr);
			  Platform.disable($lcnb);
			  }
			  else if("txt".equals($msgtyp.getValue()))
			  {
			  //将境内外币业务的数据库更改为swd
			  Platform.setDefaultDB("swd");
			  Platform.setValues($subtyp,getFmtList());
			  Platform.setModified($subtyp);
			  Platform.enable($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  setRspsta("txt");
			  Platform.disable($gpi);
			  Platform.clear($gpi);
			  Platform.setModified($gpi);
			  Platform.enable($uetr);
			  Platform.disable($lcnb);
			  }
			  else if("fxl".equals($msgtyp.getValue()))
			  {
			  //将境内外币业务的数据库更改为swd
			  Platform.setDefaultDB("swd");
			  Platform.setValues($subtyp,getFxpsList());
			  Platform.setModified($subtyp);
			  Platform.enable($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  //TODO暂时定为与fmt的保持一致
			  setRspsta("txt");
			  Platform.disable($gpi);
			  Platform.clear($gpi);
			  Platform.setModified($gpi);
			  Platform.enable($uetr);
			  Platform.disable($lcnb);
			  }
			  //cips
			  else if("xml".equals($msgtyp.getValue()))
			  {
			  //log.info("进入cips列表");
			  Platform.setDefaultDB("fxd");
			  Platform.setValues($subtyp,getCipsList());
			  Platform.setModified($subtyp);
			  Platform.enable($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  setRspsta("xml");
			  Platform.disable($gpi);
			  Platform.clear($gpi);
			  Platform.setModified($gpi);
			  Platform.enable($uetr);
			  Platform.disable($lcnb);
			  }
			  //20190827新增电子信用证报文查询
			  //20190827CCJ新增 电子信用证报文查询
			  else if("exl".equals($msgtyp.getValue()))
			  {
			  $this.elcsCfg();
			  }
			  else if("mx".equals($msgtyp.getValue()))
			  {
			  Platform.setDefaultDB("swd");
			  Platform.disable($subtyp);
			  Platform.clear($subtyp);
			  Platform.setModified($subtyp);
			  Platform.enable($sty);
			  setRspsta("sf2");
			  Platform.enable($gpi);
			  }
			  else
			  {
			  Platform.disable($subtyp);
			  Platform.clear($subtyp);
			  Platform.setModified($subtyp);
			  Platform.disable($sty);
			  Platform.clear($sty);
			  Platform.setModified($sty);
			  Platform.disable($gpi);
			  Platform.clear($gpi);
			  Platform.setModified($gpi);
			  }*/

			return true;
        }

        /**
        *   source:sndp.@0013.script
        */
        @Check(target="othref",order=100)
        public boolean checkOthrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.transAndCheckRef(MdaDriver.getDatafield(this,"othref"));

			return true;
        }

        /**
        *   source:sndp.@0014.script
        */
        @Check(target="ownref",order=100)
        public boolean checkOwnrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.transAndCheckRef(MdaDriver.getDatafield(this,"ownref"));

			return true;
        }

        /**
        *   source:sndp.@0019.script
        */
        @Check(target="actbic",order=100)
        public boolean checkActbicN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getActbic()))
			  return true;
			String actbic = this.getActbic();
			actbic = actbic.toUpperCase();
			if(!actbic.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"actbic",MdaUtils.getI18NString("sndp","CT000255"));
			}
			this.setActbic( actbic);
			

			return true;
        }

        /**
        *   source:sndp.@0026.script
        */
        @Check(target="uetr",order=100)
        public boolean checkUetrN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.transAndCheckUetr(MdaDriver.getDatafield(this,"uetr"));

			return true;
        }


        /**
        *   source:sndp.@0004.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//隐藏按钮
			if(!"sndsel,ame".equals(ctx.getTransName()))
			  
			//禁用回执状态，初始查询
			this.setTblrsp( "回执状态");
			this.setTblrsm( "：");
			this.setStarsp( "行内系统");
			this.setStarsm( "：");

			
			
			if((!"sndsel".equals(ctx.getTransName()))&&(!"sndsel,fm".equals(ctx.getTransName())))
			{
			  
			  
			  
			  if("msgsel".equals(ctx.getTransName()) || "fhesel".equals(ctx.getTransName()))
			  {
			    this.setTblrsp( "操 作 员");
			    this.setStarsp( "处理状态");
			    
			    
			    
			    
			    
			    
			    this.setSta( "V");
			    
			  }
			  //报文丢弃处理
			  if("sndsel,dq".equals(ctx.getTransName()))
			  {
			    
			    
			    
			    this.setRspsta( "G");
			    Platform.disableDatafield(MdaDriver.getDatafield(this,"rspsta"));
			  }
			  ///如果某条已处理，在此处删除该条
			  String pcdsta = (String)ctx.restoreData("pcdsta");
			  ctx.storeData("pcdsta",pcdsta);
			  if("Y".equals(pcdsta)&&MdaUtils.isReturnCall())
			  {
			    log.debug("{}","selidx="+this.getSelidx());
			    if(!MdaUtils.isEmpty(this.getSelidx()))
			      this.getMsggrp().getRcvlst().remove(MdaUtils.parseInt(this.getSelidx()));
			    return true;
			  }
			}
			/*if("msgsel".equals(Platform.getTransName()))
			  {
			  List<CodetableItem> codtbl = new ArrayList<CodetableItem>();
			  codtbl.add(new CodetableItem(#CT000207,"ZQS"));
			  Platform.setValues($chnipt,codtbl);
			  }*/
			/*if(Platform.isReturnCall())
			  {
			  return;
			  }
			  //暂时禁掉sty
			  Platform.disable($sty);
			  //动态列表
			  Platform.setValues($subtyp,getMtyList());
			  Platform.setValues($cur,getSysCurList());
			  Platform.setValues($chnipt,getChnList());
			  $msgtyp = "sf2";
			  $chn = "SWT";
			  $rcvdatsta = Platform.formatDateTime(Platform.add(Platform.today(),-3),"0");
			  $rcvdatend = Platform.formatDateTime(Platform.today(),"235959");
			  Platform.disable($sty);
			  //清空显示列表
			  if($msggrp\\rcvlst.fullSize() == 1 &&Platform.isEmpty($msggrp\\rcvlst[0]\\rcvdattim))
			  {
			  Platform.clear($msggrp\\rcvlst);
			  }*/

			return true;
        }

        /**
        *   source:sndp.@0017.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isReturnCall())
			{
			  return true;
			}
			//暂时禁掉sty
			
			//20190916 禁用LCNB 电子信用证编号
			
			//动态列表
			/*if("sf2".equals($msgtyp.getValue()))
			  {
			  Platform.setValues($subtyp,getMtyList());
			  Platform.setModified($subtyp);
			  }
			  else if("txt".equals($msgtyp.getValue()))
			  {
			  Platform.setValues($subtyp,getFmtList());
			  Platform.setModified($subtyp);
			  }*/
			MdaUtils.setValues(this,"cur",getSysCurList());
			MdaUtils.setValues(this,"chnipt",getChnList());

			List<CodetableItem> lst = new ArrayList<CodetableItem>();
			lst.add(new CodetableItem("CFIX","xml"));
			// 设置默认值
			this.setMsgtyp( "xml");
			MdaUtils.setValues(this,"msgtyp",lst);
			
			MdaUtils.setValues(this,"subtyp",getMtyList());
			
			//$msgtyp = "sf2";
			/*if(!"sndsel,dq".equals(Platform.getTransName()))
			  {
			  List<CodetableItem> lst = new ArrayList<CodetableItem>();
			  /*lst.add(new CodetableItem("MT","sf2"));
			  lst.add(new CodetableItem("FMT","txt"));
			  lst.add(new CodetableItem("CIPS","xml"));
			  //20190827新增电子信用证报文查询
			  lst.add(new CodetableItem("ELCS","exl"));
			  //20211028新增境内外币1.7规范
			  lst.add(new CodetableItem("FXPS","fxl"));
			  lst.add(new CodetableItem("G渠道","gisp"));*/
			// lst.add(new CodetableItem("CFIX","xml"));
			/*Platform.setValues($msgtyp,lst);
			  //20190311新加，报文复核时去除报文类型查询条件控制
			  if(!"msgsel".equals(Platform.getTransName()) || !"fhesel".equals(Platform.getTransName()))
			  $msgtyp = "sf2";
			  Platform.setDefaultDB("swd");
			  Platform.setValues($subtyp,getMtyList());
			  Platform.setModified($subtyp);
			  }
			  else
			  {
			  List<CodetableItem> lst = new ArrayList<CodetableItem>();
			  lst.add(new CodetableItem("CIPS","xml"));
			  Platform.setValues($msgtyp,lst);
			  $msgtyp = "xml";
			  Platform.setValues($subtyp,getCipsList());
			  Platform.setModified($subtyp);
			  }*/

			/*List<CodetableItem> gpilst = new ArrayList<CodetableItem>();
			  gpilst.add(new CodetableItem("GPI","GPI"));
			  gpilst.add(new CodetableItem("非GPI","NoGpi"));
			  Platform.setValues($gpi,gpilst);
			  if(!"sf2".equals($msgtyp.getValue()))
			  {
			  Platform.disable($gpi);
			  }
			
			  String transname = Platform.getTransName();
			  //if("sndsel,ac".equals(transname)||"sndsel,er".equals(transname)||"sndsel,se".equals(transname))
			  if("sndsel,ac".equals(transname)||"sndsel,er".equals(transname))
			  {
			  Platform.disable($msgtyp);
			  }
			  if("sndsel,se".equals(transname))
			  {
			  List<CodetableItem> lst = new ArrayList<CodetableItem>();
			  lst.add(new CodetableItem("MT","sf2"));
			  lst.add(new CodetableItem("FMT","txt"));
			  lst.add(new CodetableItem("CIPS","xml"));
			  //20190827新增电子信用证报文查询
			  lst.add(new CodetableItem("ELCS","exl"));
			  //20211028新增境内外币1.7规范
			  //lst.add(new CodetableItem("FXPS","fxl"));
			  lst.add(new CodetableItem("G渠道","gisp"));
			  Platform.setValues($msgtyp,lst);
			  }*/
			/* String frm = Platform.getTransName();
			  String[] str = frm.split(",");
			  String typ = "";
			  int len = java.lang.reflect.Array.getLength(str);
			  if(( len == 2 )||( len == 3 ))
			  typ = str[1];
			  log.debug("sndsel type:"+typ);
			  if(!Platform.isEmpty(typ)&&"fm".equals(typ))
			  {
			  $msgtyp = "txt";
			  Platform.setValues($subtyp,getFmtList());
			  Platform.setModified($subtyp);
			  Platform.disable($msgtyp);
			  Platform.setModified($msgtyp);
			  }
			  else if("msgsel".equals(frm))
			  {
			  }
			  else
			  {
			  $msgtyp = "sf2";
			  Platform.setValues($subtyp,getMtyList());
			  Platform.setModified($subtyp);
			  Platform.disable($msgtyp);
			  Platform.setModified($msgtyp);
			  }*/

			this.setChn( "SWT");
			this.setRcvdatsta( Platform.formatDateTime(MdaUtils.add(MdaUtils.today(),-3),"0"));
			this.setRcvdatend( Platform.formatDateTime(MdaUtils.today(),"235959"));
			
			//清空显示列表
			if(this.getMsggrp().getRcvlst().fullSize() == 1 &&MdaUtils.isEmpty(this.getMsggrp().getRcvlst().getElement(0).getRcvdattim()))
			{
			  MdaUtils.clear(this.getMsggrp().getRcvlst());
			}

			return true;
        }


        /**
        *   source:sndp.@0010.script
        */
        public List<CodetableItem> getMtyList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//得到所有报文类型名称
			/*List<CodetableItem> mtyList = new ArrayList<CodetableItem>();//构造码表mtyList
			  Platform.mdbExecuteSQL("SELECT mty FROM mfd WHERE tno=1 AND mty like 'MT%' AND mty not like '%s' ORDER BY mty");//执行sql语句查询记录
			  Argument<String> nam = new Argument<String>("mty");//构造Label列nam
			  while(true)
			  {
			  Platform.mdbFetchFields(nam);//逐条取出记录
			  int errorCode = Platform.errorCode();//取出记录的执行结果
			  //log.info(errorCode);
			  if(errorCode == NO_ERROR)
			  {
			  String mtyval = nam.value;
			  if(!Platform.isEmpty(mtyval)&&mtyval.length()>4)
			  {
			  mtyval = mtyval.substring(3);
			  mtyList.add(new CodetableItem(mtyval,mtyval));
			  }
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();*/
			List<CodetableItem> mtyList = new ArrayList<CodetableItem>();
			mtyList.add(new CodetableItem("cfad.011.001.01","cfad.011.001.01"));
			mtyList.add(new CodetableItem("cfad.012.001.01","cfad.012.001.01"));
			mtyList.add(new CodetableItem("cfad.013.001.01","cfad.013.001.01"));
			mtyList.add(new CodetableItem("cfad.019.001.01","cfad.019.001.01"));
			mtyList.add(new CodetableItem("cfad.020.001.01","cfad.020.001.01"));
			mtyList.add(new CodetableItem("cfad.021.001.01","cfad.021.001.01"));
			mtyList.add(new CodetableItem("cfad.026.001.01","cfad.026.001.01"));
			mtyList.add(new CodetableItem("cfad.040.001.01","cfad.040.001.01"));
			mtyList.add(new CodetableItem("cfad.041.001.01","cfad.041.001.01"));
			mtyList.add(new CodetableItem("cfad.042.001.01","cfad.042.001.01"));
			mtyList.add(new CodetableItem("cfad.050.001.01","cfad.050.001.01"));
			mtyList.add(new CodetableItem("cfad.051.001.01","cfad.051.001.01"));
			mtyList.add(new CodetableItem("cfad.052.001.01","cfad.052.001.01"));
			mtyList.add(new CodetableItem("cfad.990.001.01","cfad.990.001.01"));
			mtyList.add(new CodetableItem("cfcm.001.001.01","cfcm.001.001.01"));
			mtyList.add(new CodetableItem("cfcm.002.001.01","cfcm.002.001.01"));
			mtyList.add(new CodetableItem("cfcm.003.001.01","cfcm.003.001.01"));
			mtyList.add(new CodetableItem("cfcm.101.001.01","cfcm.101.001.01"));
			mtyList.add(new CodetableItem("cfcm.102.001.01","cfcm.102.001.01"));
			mtyList.add(new CodetableItem("cfcm.301.001.01","cfcm.301.001.01"));
			mtyList.add(new CodetableItem("cfcm.302.001.01","cfcm.302.001.01"));
			mtyList.add(new CodetableItem("cfcm.900.001.01","cfcm.900.001.01"));
			mtyList.add(new CodetableItem("cfcm.998.001.01","cfcm.998.001.01"));
			return mtyList;
		}
        /**
        *   source:sndp.@0011.script
        */
        public List<CodetableItem> getSysCurList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> curLst = new ArrayList<CodetableItem>();
			String sql = "SELECT cur,curnam FROM cur";
			Platform.mdbExecuteSQL(sql);
			Argument<String> cur = new Argument<String>("cur");
			Argument<String> curnam = new Argument<String>("curnam");
			while(true)
			{
			  Platform.mdbFetchFields(cur,curnam);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if(curnam.value != null && cur.value != null)
			    {
			      CodetableItem c = new CodetableItem(cur.value,cur.value);
			      curLst.add(c);
			    }
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return curLst;
		}
        /**
        *   source:sndp.@0012.script
        */
        public List<CodetableItem> getChnList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//构造码表chnList
			List<CodetableItem> chnList = new ArrayList<CodetableItem>();
			Platform.mdbExecuteSQL("SELECT cod,nam FROM chn WHERE typ='B'");//执行sql语句查询记录
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  Platform.mdbFetchFields(cod,nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    chnList.add(new CodetableItem(nam.value,cod.value));
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return chnList;
		}
        /**
        *   source:sndp.@0018.script
        */
        public List<CodetableItem> getFmtList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//得到所有报文类型名称
			List<CodetableItem> mtyList = new ArrayList<CodetableItem>();//构造码表mtyList
			Platform.mdbExecuteSQL("SELECT mty FROM mfd WHERE tno=1 AND mty like 'FMT%' ORDER BY mty");//执行sql语句查询记录
			Argument<String> nam = new Argument<String>("mty");//构造Label列nam
			while(true)
			{
			  Platform.mdbFetchFields(nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    String mtyval = nam.value;
			    if(!MdaUtils.isEmpty(mtyval)&&mtyval.length()>5)
			    {
			      mtyval = mtyval.substring(4);
			      mtyList.add(new CodetableItem(mtyval,mtyval));
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return mtyList;
		}
        /**
        *   source:sndp.@0020.script
        */
        public List<CodetableItem> getCipsList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//得到所有报文类型名称
			List<CodetableItem> mtyList = new ArrayList<CodetableItem>();//构造码表mtyList
			Platform.mdbExecuteSQL("SELECT mty FROM mfd WHERE tno=1 AND mty like 'cips%' ORDER BY mty");//执行sql语句查询记录
			Argument<String> nam = new Argument<String>("mty");//构造Label列nam
			while(true)
			{
			  Platform.mdbFetchFields(nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  //log.error(errorCode);
			  if(errorCode==NO_ERROR)
			  {
			    String mtyval = nam.value;
			    //log.info(mtyval);
			    if(!MdaUtils.isEmpty(mtyval)&&mtyval.length()>4)
			    {
			      mtyval = mtyval.substring(5);
			      mtyList.add(new CodetableItem(mtyval,mtyval));
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return mtyList;
		}
        /**
        *   source:sndp.@0023.script
        */
        public void setRspsta(String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//20190114 SSF修改  回执状态修改
			this.setRspsta(NULLSTR);
			if("sf2".equals(typ))
			{
			  List<CodetableItem> hzList = new ArrayList<CodetableItem>();
			  hzList.add(new CodetableItem("",""));
			  hzList.add(new CodetableItem("ACK","A"));
			  hzList.add(new CodetableItem("NCK","N"));
			  hzList.add(new CodetableItem("非ACK","L"));
			  MdaUtils.setValues(this,"rspsta",hzList);
			  this.setRspsta( "");
			}
			else if("txt".equals(typ))
			{
			  List<CodetableItem> hzList = new ArrayList<CodetableItem>();
			  hzList.add(new CodetableItem("",""));
			  hzList.add(new CodetableItem("FXCC拒绝","1"));
			  hzList.add(new CodetableItem("已排队","2"));
			  hzList.add(new CodetableItem("已清算","3"));
			  hzList.add(new CodetableItem("已退回","4"));
			  hzList.add(new CodetableItem("已撤销","5"));
			  hzList.add(new CodetableItem("收报行收妥","6"));
			  hzList.add(new CodetableItem("收报行拒绝","7"));
			  hzList.add(new CodetableItem("成功发往PMTS-MBFE","P"));
			  MdaUtils.setValues(this,"rspsta",hzList);
			  this.setRspsta( "");
			}
			else if("xml".equals(typ))
			{
			  List<CodetableItem> hzList = new ArrayList<CodetableItem>();
			  hzList.add(new CodetableItem("",""));
			  hzList.add(new CodetableItem("已拒绝","R"));
			  hzList.add(new CodetableItem("结算排队","Q"));
			  hzList.add(new CodetableItem("已结算","C"));
			  hzList.add(new CodetableItem("日终退回","T"));
			  hzList.add(new CodetableItem("已撤销","5"));
			  hzList.add(new CodetableItem("已成功","S"));
			  hzList.add(new CodetableItem("已转发","8"));
			  hzList.add(new CodetableItem("已处理","D"));
			  hzList.add(new CodetableItem("已丢弃","G"));
			  hzList.add(new CodetableItem("成功发往PMTS-MBFE","P"));
			  MdaUtils.setValues(this,"rspsta",hzList);
			  this.setRspsta( "");
			}
			else if("exl".equals(typ))
			{
			  List<CodetableItem> hzList = new ArrayList<CodetableItem>();
			  hzList.add(new CodetableItem("",""));
			  hzList.add(new CodetableItem("已拒绝","R"));
			  hzList.add(new CodetableItem("已撤销","5"));
			  hzList.add(new CodetableItem("已成功","S"));
			  hzList.add(new CodetableItem("已转发","8"));
			  hzList.add(new CodetableItem("已处理","D"));
			  hzList.add(new CodetableItem("已丢弃","G"));
			  hzList.add(new CodetableItem("已清算","3"));
			  hzList.add(new CodetableItem("待处理","W"));
			  hzList.add(new CodetableItem("已同意","Y"));
			  hzList.add(new CodetableItem("待认证","r"));
			  hzList.add(new CodetableItem("已付款","F"));
			  hzList.add(new CodetableItem("已轧差","9"));
			  hzList.add(new CodetableItem("已确认","a"));
			  hzList.add(new CodetableItem("轧差排队","B"));
			  hzList.add(new CodetableItem("清算排队","H"));
			  hzList.add(new CodetableItem("已超期（逾期退回）","U"));
			  hzList.add(new CodetableItem("已部分退回","V"));
			  hzList.add(new CodetableItem("NPC未受理","O"));
			  hzList.add(new CodetableItem("已整包退回","n"));
			  hzList.add(new CodetableItem("已冲正","M"));
			  hzList.add(new CodetableItem("已止付","K"));
			  hzList.add(new CodetableItem("已划回","J"));
			  hzList.add(new CodetableItem("已冻结待清算","I"));
			  hzList.add(new CodetableItem("清算异常，待重新清算","b"));
			  hzList.add(new CodetableItem("成功发往PMTS-MBFE","P"));
			  hzList.add(new CodetableItem("ELCS待处理","Z"));
			  hzList.add(new CodetableItem("已同意","Y"));
			  hzList.add(new CodetableItem("待清算","X"));
			  MdaUtils.setValues(this,"rspsta",hzList);
			  this.setRspsta( "");
			}
		}
        /**
        *   source:sndp.@0027.script
        */
        public List<CodetableItem> getElcsList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//得到所有报文类型名称
			List<CodetableItem> mtyList = new ArrayList<CodetableItem>();//构造码表mtyList
			Platform.mdbExecuteSQL("SELECT mty FROM mfd WHERE tno=1 AND mty like 'elcs%' or mty like 'ccms%' ORDER BY mty");//执行sql语句查询记录
			Argument<String> nam = new Argument<String>("mty");//构造Label列nam
			while(true)
			{
			  Platform.mdbFetchFields(nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  //log.error(errorCode);
			  if(errorCode==NO_ERROR)
			  {
			    String mtyval = nam.value;
			    //log.info(mtyval);
			    if(!MdaUtils.isEmpty(mtyval)&&mtyval.length()>4)
			    {
			      mtyval = mtyval.substring(5);
			      mtyList.add(new CodetableItem(mtyval,mtyval));
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return mtyList;
		}
        /**
        *   source:sndp.@0028.script
        */
        public void elcsCfg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Platform.setDefaultDB("fxd");
			MdaUtils.setValues(this,"subtyp",getElcsList());
			
			
			
			this.setSty(NULLSTR);
			
			
			this.setGpi(NULLSTR);
			
			
			
			setRspsta("exl");
		}
        /**
        *   source:sndp.@0029.script
        */
        public List<CodetableItem> getFxpsList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//手动插入Fxps发报列表
			List<CodetableItem> fxpsList = new ArrayList<CodetableItem>();
			fxpsList.add(new CodetableItem("",""));
			fxpsList.add(new CodetableItem("132","132"));
			fxpsList.add(new CodetableItem("345","345"));
			fxpsList.add(new CodetableItem("372","372"));

			fxpsList.add(new CodetableItem("903","903"));
			fxpsList.add(new CodetableItem("919","919"));
			fxpsList.add(new CodetableItem("928","928"));
			fxpsList.add(new CodetableItem("929","929"));
			fxpsList.add(new CodetableItem("932","932"));
			fxpsList.add(new CodetableItem("991","991"));

			//20220513 by tc 二阶段新增的报文类型列表
			fxpsList.add(new CodetableItem("111","111"));
			fxpsList.add(new CodetableItem("112","112"));
			fxpsList.add(new CodetableItem("301","301"));
			fxpsList.add(new CodetableItem("302","302"));
			fxpsList.add(new CodetableItem("303","303"));
			fxpsList.add(new CodetableItem("307","307"));
			fxpsList.add(new CodetableItem("314","314"));
			fxpsList.add(new CodetableItem("315","315"));
			fxpsList.add(new CodetableItem("316","316"));
			fxpsList.add(new CodetableItem("318","318"));
			fxpsList.add(new CodetableItem("319","319"));
			fxpsList.add(new CodetableItem("320","320"));
			fxpsList.add(new CodetableItem("321","321"));
			fxpsList.add(new CodetableItem("322","322"));
			fxpsList.add(new CodetableItem("324","324"));
			fxpsList.add(new CodetableItem("326","326"));
			fxpsList.add(new CodetableItem("350","350"));
			fxpsList.add(new CodetableItem("360","360"));
			fxpsList.add(new CodetableItem("704","704"));
			fxpsList.add(new CodetableItem("706","706"));
			fxpsList.add(new CodetableItem("708","708"));
			fxpsList.add(new CodetableItem("805","805"));
			return fxpsList;
		}
        /**
        *   source:sndp.@0030.script
        */
        public String createcfcm_001_001_01(String rawMsg,String txTpCd,String ctgyPurpCd)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始发送即时信息报文");
			com.brilliance.jrxx.framework.Result result = com.brilliance.jrxx.utils.MsgUtil.unPackNoSignMessage(rawMsg);
			com.brilliance.jrxx.packet.model.com.Elcs elcs=result.getElcsModel();
			com.brilliance.jrxx.packet.model.cfcm_001_001_01.Cfcm_001_001_01 cfcm_001_001_01 = new com.brilliance.jrxx.packet.model.cfcm_001_001_01.Cfcm_001_001_01();
			// 组装报文头
			this.getMsgmod().fillHead(cfcm_001_001_01, "cfcm.001.001.01");
			// 组装报文体
			com.brilliance.jrxx.packet.model.cfcm_001_001_01.MsgComData msgComData = this.createcfcm_001_001_01MsgComData(cfcm_001_001_01);
			cfcm_001_001_01.MsgComData = msgComData;

			com.brilliance.jrxx.packet.model.cfcm_001_001_01.PrtryData prtryData = new com.brilliance.jrxx.packet.model.cfcm_001_001_01.PrtryData();
			com.brilliance.jrxx.packet.model.cfcm_001_001_01.MsgBizData msgBizData = new com.brilliance.jrxx.packet.model.cfcm_001_001_01.MsgBizData();
			msgBizData.SID = elcs.OrigSender;
			msgBizData.MsgTp = elcs.MesgID;
			msgBizData.TxTpCd = txTpCd;
			msgBizData.CtgyPurpCd = ctgyPurpCd;
			prtryData.MsgBizData = msgBizData;
			prtryData.MsgCont = rawMsg;

			cfcm_001_001_01.PrtryData = prtryData;

			String json = com.alibaba.fastjson.JSON.toJSONString(cfcm_001_001_01);
			log.debug("{}",json);
			return json;
		}
        /**
        *   source:sndp.@0031.script
        */
        public com.brilliance.jrxx.packet.model.cfcm_001_001_01.MsgComData createcfcm_001_001_01MsgComData(com.brilliance.jrxx.packet.model.com.Elcs elcs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			com.brilliance.jrxx.packet.model.cfcm_001_001_01.MsgComData msgComData = new com.brilliance.jrxx.packet.model.cfcm_001_001_01.MsgComData();
			msgComData.InstgPty = elcs.OrigSender;
			msgComData.InstdPty = elcs.OrigReceiver;
			msgComData.SndDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd'T'HH:mm:ss");
			msgComData.MsgId = elcs.MesgID;
			return msgComData;
		}
        /**
        *   source:sndp.@0032.script
        */
        public boolean storeMsgFromPlatWithoutChk(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("UTF-8"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubject(is,"HWE","json","CPX","系统管理报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  // Platform.message(#CT001181,#CT001182);
			  return true;
			}
		}
        /**
        *   source:sndp.@0036.script
        */
        public String createcfcm_301_001_01(String insgdp,String insdpl,String insgpl,String insddp,String insddl,String inspdl,String syscod,String rmk,String othref,String sndbic,String subtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始发送业务状态查询申请报文");
			com.brilliance.jrxx.packet.model.cfcm_301_001_01.Cfcm_301_001_01 cfcm_301_001_01 = new com.brilliance.jrxx.packet.model.cfcm_301_001_01.Cfcm_301_001_01();
			com.brilliance.jrxx.packet.model.com.Elcs elcs = cfcm_301_001_01;
			// 组装报文头
			this.getMsgmod().fillHead(cfcm_301_001_01, "cfcm.301.001.01");
			// 组装报文体
			com.brilliance.jrxx.packet.model.cfcm_301_001_01.GrpHdr grpHdr = new com.brilliance.jrxx.packet.model.cfcm_301_001_01.GrpHdr();
			grpHdr.MsgId = elcs.MesgID;
			grpHdr.CreDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd'T'HH:mm:ss");

			com.brilliance.jrxx.packet.model.cfcm_301_001_01.InstgPty instgPty = new com.brilliance.jrxx.packet.model.cfcm_301_001_01.InstgPty();
			instgPty.InstgDrctPty = insgdp;
			instgPty.InstgDrctPtyLei = insdpl;
			instgPty.InstgPty = elcs.OrigSender;
			instgPty.InstgPtyLei = insgpl;
			grpHdr.InstgPty = instgPty;

			com.brilliance.jrxx.packet.model.cfcm_301_001_01.InstdPty instdPty = new com.brilliance.jrxx.packet.model.cfcm_301_001_01.InstdPty();
			instdPty.InstdDrctPty = insddp;
			instdPty.InstdDrctPtyLei = insddl;
			instdPty.InstdPty = elcs.OrigReceiver;
			instdPty.InstdPtyLei = inspdl;
			grpHdr.InstdPty = instdPty;

			grpHdr.SysCd = syscod;
			grpHdr.Rmk = rmk;
			cfcm_301_001_01.GrpHdr = grpHdr;

			com.brilliance.jrxx.packet.model.cfcm_301_001_01.OrgnlGrpHdr orgnlGrpHdr = new com.brilliance.jrxx.packet.model.cfcm_301_001_01.OrgnlGrpHdr();
			orgnlGrpHdr.OrgnlMsgId = othref;
			orgnlGrpHdr.OrgnlInstgPty = sndbic;
			orgnlGrpHdr.OrgnlMT = subtyp;
			cfcm_301_001_01.OrgnlGrpHdr = orgnlGrpHdr;

			String json = com.alibaba.fastjson.JSON.toJSONString(cfcm_301_001_01);
			log.debug("{}",json);
			return json;
		}


        public void setMsggrpHolder(ModuleHolder<Msggrp> msggrp)
        {
            this.msggrp = msggrp;
        }

        public Msggrp getMsggrp()
        {
           return this.msggrp.get();
        }













































































































}