package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Srlp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Srlp.class);

        //lognam
        private String lognam;

        //oprnam
        private String oprnam;

        //    >
        private IControl add;

        //    >>
        private IControl addall;

        //    <
        private IControl rev;

        //    <<
        private IControl revall;

        //修改
        private IControl sav;

        //返回
        private IControl ret;

        //未分配列表
        private String number1;

        //已分配列表
        private String number2;


        @JsonIgnore
        @BDGetter
        private transient IPanel usrrolpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel editpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel rol1pnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel rol2pnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel dslp1;

        @JsonIgnore
        @BDGetter
        private transient IPanel dslp2;

        @JsonIgnore
        @BDGetter
        private transient IPanel midbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel dslp4;

        @JsonIgnore
        @BDGetter
        private transient IPanel lfturllst;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgturllst;

        @JsonIgnore
        @BDGetter
        private transient IPanel toppnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel botpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel dslp7;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep1;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbp2;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep3;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbp4;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep5;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep6;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep7;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep8;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep9;

        @JsonIgnore
        @BDGetter
        private transient IPanel mainpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep10;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep11;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbep12;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbelftlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbergtlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbebtn;


		@BDGetter
		private ModuleList<Rol> detlst;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Urlgrp> urlgrp;

	    @BDGetter
		private Htymod htymod;


		public Srlp()
        {
            super();
            setArgument();
        }

        public Srlp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:srlp.@0000.script
        */
        @Rule(target="add",order=100)
        public boolean ruleAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  *给当前用户添加新的角色
			  */
			/*for(int i=$urlgrp\\rollst1.fullSize() - 1;i>=0;i--)
			  {
			  if("X".equals($urlgrp\\rollst1[i]\\chk.getValue()))
			  {
			  $urlgrp\\rollst1[i]\\chk.setValue("");
			  $urlgrp\\rollst2.add($urlgrp\\rollst1[i]);
			  $urlgrp\\rollst1.remove(i);
			  }
			  }
			  $number1=String.valueOf($urlgrp\\rollst1.fullSize());
			  $number2=String.valueOf($urlgrp\\rollst2.fullSize());
			  Platform.setModified($number1);
			  Platform.setModified($number2);
			  Platform.setModified($urlgrp\\rollst1);
			  Platform.setModified($urlgrp\\rollst2);*/
			for(int i=this.getUrlgrp().getUrllst1().fullSize() - 1;i>=0;i--)
			{
			  if("X".equals(this.getUrlgrp().getUrllst1().getElement(i).getChk()))
			  {
			    this.getUrlgrp().getUrllst1().getElement(i).setChk("");
			    this.getUrlgrp().getUrllst2().add(this.getUrlgrp().getUrllst1().getElement(i));
			    this.getUrlgrp().getUrllst1().remove(i);
			  }
			}
			this.setNumber1(String.valueOf(this.getUrlgrp().getUrllst1().fullSize()));
			this.setNumber2(String.valueOf(this.getUrlgrp().getUrllst2().fullSize()));
			
			
			
			

			return true;
        }

        /**
        *   source:srlp.@0001.script
        */
        @Rule(target="addall",order=100)
        public boolean ruleAddallN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  *给当前用户分配所有角色
			  */
			/*for(int i=0;i<$urlgrp\\rollst1.fullSize();i++)
			  {
			  $urlgrp\\rollst2.add($urlgrp\\rollst1[i]);
			  }
			  Platform.clear($urlgrp\\rollst1);
			  $number1=String.valueOf($urlgrp\\rollst1.fullSize());
			  $number2=String.valueOf($urlgrp\\rollst2.fullSize());
			  Platform.setModified($number1);
			  Platform.setModified($number2);
			  Platform.setModified($urlgrp\\rollst1);
			  Platform.setModified($urlgrp\\rollst2);*/
			for(int i=0;i<this.getUrlgrp().getUrllst1().fullSize();i++)
			{
			  this.getUrlgrp().getUrllst2().add(this.getUrlgrp().getUrllst1().getElement(i));
			}
			Platform.clears(this.getUrlgrp().getUrllst1());
			this.setNumber1(String.valueOf(this.getUrlgrp().getUrllst1().fullSize()));
			this.setNumber2(String.valueOf(this.getUrlgrp().getUrllst2().fullSize()));
			
			
			
			

			return true;
        }

        /**
        *   source:srlp.@0002.script
        */
        @Rule(target="rev",order=100)
        public boolean ruleRevN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  *给当前用户移除选中角色
			  */
			/*for(int i=$urlgrp\\rollst2.fullSize() - 1;i>=0;i--)
			  {
			  if("X".equals($urlgrp\\rollst2[i]\\chk.getValue()))
			  {
			  $urlgrp\\rollst2[i]\\chk.setValue("");
			  $urlgrp\\rollst1.add($urlgrp\\rollst2[i]);
			  $urlgrp\\rollst2.remove(i);
			  }
			  }
			  $number1=String.valueOf($urlgrp\\rollst1.fullSize());
			  $number2=String.valueOf($urlgrp\\rollst2.fullSize());
			  Platform.setModified($number1);
			  Platform.setModified($number2);
			  Platform.setModified($urlgrp\\rollst1);
			  Platform.setModified($urlgrp\\rollst2);*/
			for(int i=this.getUrlgrp().getUrllst2().fullSize() - 1;i>=0;i--)
			{
			  if("X".equals(this.getUrlgrp().getUrllst2().getElement(i).getChk()))
			  {
			    this.getUrlgrp().getUrllst2().getElement(i).setChk("");
			    this.getUrlgrp().getUrllst1().add(this.getUrlgrp().getUrllst2().getElement(i));
			    this.getUrlgrp().getUrllst2().remove(i);
			  }
			}
			this.setNumber1(String.valueOf(this.getUrlgrp().getUrllst1().fullSize()));
			this.setNumber2(String.valueOf(this.getUrlgrp().getUrllst2().fullSize()));
			
			
			
			

			return true;
        }

        /**
        *   source:srlp.@0003.script
        */
        @Rule(target="revall",order=100)
        public boolean ruleRevallN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  * 删除用户所有的角色
			  */
			/*Platform.clear($urlgrp\\newlst);
			  for(int i=0;i<$urlgrp\\rollst2.fullSize();i++)
			  {
			  $urlgrp\\rollst1.add($urlgrp\\rollst2[i]);//rollst1保存用户当前所有角色
			  }
			  Platform.clear($urlgrp\\rollst2);
			  $number1=String.valueOf($urlgrp\\rollst1.fullSize());
			  $number2=String.valueOf($urlgrp\\rollst2.fullSize());
			  Platform.setModified($number1);
			  Platform.setModified($number2);
			  Platform.setModified($urlgrp\\rollst1);
			  Platform.setModified($urlgrp\\rollst2);*/
			//Platform.clear($urlgrp\\newlst);
			for(int i=0;i<this.getUrlgrp().getUrllst2().fullSize();i++)
			{
			  this.getUrlgrp().getUrllst1().add(this.getUrlgrp().getUrllst2().getElement(i));//rollst1保存用户当前所有角色
			}
			Platform.clears(this.getUrlgrp().getUrllst2());
			this.setNumber1(String.valueOf(this.getUrlgrp().getUrllst1().fullSize()));
			this.setNumber2(String.valueOf(this.getUrlgrp().getUrllst2().fullSize()));
			
			
			
			

			return true;
        }

        /**
        *   source:srlp.@0005.script
        */
        @Rule(target="htymod.hty",order=100)
        public boolean ruleHtymodHtyN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getHtymod().getLst());
			String objinr="";
			ctx.getDaoSession().dbConnect();
			if(!MdaUtils.isEmpty(this.getUrlgrp().getUsr().getInr()))
			  objinr = this.getUrlgrp().getUsr().getInr();
			String sql="";
			Argument<Date> dattim =new Argument<Date>("dattim");
			Argument<String> usr =new Argument<String>("usr");
			Argument<String> txt =new Argument<String>("txt");
			sql="select dattim,usr,txt from sme where frmnam='dbesrl' and objinr=? order by dattim ";
			log.debug("{}","[objinr] "+objinr);
			ctx.getDaoSession().dbExecuteSQL(sql,objinr);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(dattim,usr,txt);
			  int error =ctx.getErrorCode();
			  if(error==NO_ERROR)
			  {
			    this.getHtymod().getLst().add(dattim,usr,txt);
			  }

			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			ctx.getDaoSession().dbDisconnect();
			
			

			return true;
        }




        /**
        *   source:srlp.@0004.script
        */
        public void oprNewLst(String usrinr1,int index,int flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//flg为1，代表newlst添加， flg为2，代表newlst删除
			Argument<String>inr=new Argument<String>("inr");
			Argument<String>usrinr=new Argument<String>("usrinr");
			Argument<String>rolinr=new Argument<String>("rolinr");
			if(flg==1)
			{
			  inr.setValue(Platform.sdbCounter("usrrol"));
			  usrinr.setValue(usrinr1);
			  rolinr.setValue(this.getUrlgrp().getRollst1().getElement(index).getInr());
			  this.getUrlgrp().getNewlst().add(inr,usrinr,rolinr);
			}
			else if(flg==2)
			{
			  for(int i=this.getUrlgrp().getNewlst().size() - 1;i>=0;i--)
			  {
			    String rolinr1=this.getUrlgrp().getRollst2().getElement(index).getInr();
			    if(rolinr1.equals(this.getUrlgrp().getNewlst().getElement(i).getRolinr())
			      &&usrinr1.equals(this.getUrlgrp().getNewlst().getElement(i).getUsrinr()))
			    {
			      log.debug("{}","euqsldfsfsdfasdads");
			      this.getUrlgrp().getNewlst().remove(i);
			    }
			  }

			}

		}



        public void setUrlgrpHolder(ModuleHolder<Urlgrp> urlgrp)
        {
            this.urlgrp = urlgrp;
        }

        public Urlgrp getUrlgrp()
        {
           return this.urlgrp.get();
        }






















}