package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Url;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Telp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Telp.class);

        //Teller Name
        private String tname;

        //Teller Personcode
        private String tpersoncode;

        //HR State
        private String thrsta;

        //search button
        private IControl searchbutton;

        //RegisterButton
        private IControl registerbut;

        //Confirm Button
        private IControl confirm;

        //Cancel Button
        private IControl cancel;

        //Edit Role  Button
        private IControl eidtrole;

        //Cancel Teller
        private IControl cancelteller;

        //Reactive Teller
        private IControl reactive;

        //Return1
        private IControl return1;

        //Edit Role Confirm
        private IControl editcfm;

        //EditCancel
        private IControl editcancel;

        //机构
        private String tinst;

        //操作柜员号
        private String operationcode;

        //rolechange
        private IControl rolechange;

        //logout
        private IControl logout;

        //ERROR
        private String error;

        //ERROR OFF 
        private String erooroff;

        //PASSWORD
        private String pass;

        //signoffbutton
        private IControl signoffbutton;

        //returnoff
        private IControl returnoff;

        //initrole
        private String initrole;

        //auttteller
        private String auttteller;

        //联系电话
        private String tel;

        //修改柜员信息
        private IControl change;

        //修改确认
        private IControl updconfirm;

        //修改取消
        private IControl updcancel;

        //柜员号
        private String tchgno;

        //密码
        private String pwd;


        @JsonIgnore
        @BDGetter
        private transient IPanel main;

        @JsonIgnore
        @BDGetter
        private transient IPanel info;

        @JsonIgnore
        @BDGetter
        private transient IPanel search;

        @JsonIgnore
        @BDGetter
        private transient IPanel register;

        @JsonIgnore
        @BDGetter
        private transient IPanel maininfo;

        @JsonIgnore
        @BDGetter
        private transient IPanel eidtpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel signoff;

        @JsonIgnore
        @BDGetter
        private transient IPanel updanel;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Telgrp> telgrp;

	    @BDGetter
		private Url rec;


		public Telp()
        {
            super();
            setArgument();
        }

        public Telp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:telp.@0000.script
        */
        @Rule(target="registerbut",order=100)
        public boolean ruleRegisterbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.clearDatafield(MdaDriver.getDatafield(this.getTelgrp().getUsr(),"tname"));
			Platform.clearDatafield(MdaDriver.getDatafield(this.getTelgrp().getUsr(),"tpersoncode"));
			Platform.clearDatafield(MdaDriver.getDatafield(this.getTelgrp().getUsr(),"tinst"));
			Platform.clearDatafield(MdaDriver.getDatafield(this.getTelgrp().getUsr(),"tel"));

			Platform.clearDatafield(MdaDriver.getDatafield(this,"initrole"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"tchgno"));

			Platform.clearDatafield(MdaDriver.getDatafield(this,"pwd"));
			//由于浏览器的自动补全机制，需要在弹出页面后再清除内容。
			Platform.clearDatafield(MdaDriver.getDatafield(this,"tel"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"error"));

			this.getTelgrp().getUsr().setTchgno(NULLSTR);
			this.getTelgrp().getUsr().setPwd(NULLSTR);
			


			return true;
        }

        /**
        *   source:telp.@0001.script
        */
        @Rule(target="telgrp.usrlst",order=100)
        public boolean ruleTelgrpUsrlstN100(){
            IContext ctx = MdaEnv.getContext();
            

			int i = 0;
			log.info("{}","[INDEX]: "+i);
			if(i < 0)
			{
			  return true;
			}
			else
			{
			  String usrinr = this.getTelgrp().getUsrlst().getElement(i).getInr();//获取选中的用户惟一编
			  log.info("{}","选中第 "+i+" 行柜员INR : "+usrinr);
			  ctx.storeData("usrinr",usrinr);//将此编号存入session
			  Platform.mchain("dbitel");//跳转到详情查看交易sbiusr
			}


			return true;
        }

        /**
        *   source:telp.@0004.script
        */
        @Rule(target="searchbutton",order=100)
        public boolean ruleSearchbuttonN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.query();

			return true;
        }

        /**
        *   source:telp.@0005.script
        */
        @Rule(target="confirm",order=100)
        public boolean ruleConfirmN100(){
            IContext ctx = MdaEnv.getContext();
            
			/* if(Platform.isEmpty($telgrp\\usr\\tname) ||
			  Platform.isEmpty($telgrp\\usr\\tpersoncode) ||
			  Platform.isEmpty($telgrp\\usr\\tinst) ||
			  Platform.isEmpty($initrole) ||
			  Platform.isEmpty($tel) ||
			  Platform.isEmpty($telgrp\\usr\\tchgno) ||
			  Platform.isEmpty($telgrp\\usr\\pwd))
			  {
			  Platform.message("提示","有数据未填，请重新填写");
			  return false;
			  }*/
			this.getTelgrp().getUsr().setTchgno( this.getTchgno());
			this.getTelgrp().getUsr().setPwd( this.getPwd());
			this.getTelgrp().getUsr().setTel( this.getTel());
			if(!ctx.checkAll(this))
			{
			  return false;
			}

			Map<String,Object> map=new HashMap<String,Object>();
			//交易类型码
			map.put("PCODE", "612010");
			//交易流水号
			String sqnum="12010"+MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SEQNO",sqnum);
			//柜员姓名
			map.put("TELLERNAME",this.getTelgrp().getUsr().getTname());
			//身份证
			map.put("PERSONCODE",this.getTelgrp().getUsr().getTpersoncode());
			//柜员业务机构
			map.put("TELLERINST", this.getTelgrp().getUsr().getTinst());
			//交易系统代码
			map.put("TRANSINST", "99306000000");
			//操作柜员号
			map.put("TELLERCODE", MdaEnv.getLoginUser());
			//本地时间
			String localTime=MdaUtils.format(MdaUtils.today(),"HHmmss");
			map.put("LOCALTIME", localTime);
			//本地日期
			String localDate=MdaUtils.format(MdaUtils.today(),"yyMMdd");
			map.put("LOCALDATE",localDate);
			//是否授权 01 非授权, 02 授权
			map.put("ISAUTH","01");
			//初始角色
			String rolnamstr = "";
			if(!MdaUtils.isEmpty(this.getInitrole()))
			{
			  String role=this.getInitrole()+"|";
			  map.put("TELLERROLESET",role);
			  String rolsql = "select nam from rol where inr = " + this.getInitrole();
			  Argument<String> rolnam = new Argument<String>("nam");
			  ctx.getDaoSession().dbExecuteSQL(rolsql);
			  ctx.getDaoSession().dbFetchFields(rolnam);

			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    rolnamstr = rolnam.getValue();
			  }
			  Platform.mdbCloseCursor();
			}
			//柜员号
			map.put("CHGTELLERNO",this.getTelgrp().getUsr().getTchgno());
			//发送交易系统代码
			map.put("SENDINST","99306000000");
			//接受交易系统代码
			map.put("DESTINST","99700060000");
			//接收密码
			map.put("PASSWORD",MdaUtils.encryptPassword("1"));
			//系统跟踪号 - 11位系统号+8位日期+15位流水号
			String date=MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String seqno=MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SYSTRACENO","99306000000"+date+seqno);
			map.put("MessageType", "Register");
			log.info("{}","MESSAGE MAP : "+map);
			log.info("{}","REPLY MAP:"+map);

			Platform.mdbBegin();
			this.setError((String)map.get("RESPINFO"));
			

			int errorcode;
			MdaUtils.clear(this.getTelgrp().getUsr());
			String tellerInr="";
			//读取文件信息
			this.getTelgrp().getUsr().setRolinf((String)map.get("TELLERROLESET"));

			this.getTelgrp().getUsr().setTname((String)map.get("TELLERNAME"));
			this.getTelgrp().getUsr().setTpersoncode((String)map.get("PERSONCODE"));
			this.getTelgrp().getUsr().setTchgtyp((String)map.get("TELRCHGTYPE"));
			this.getTelgrp().getUsr().setTchgno((String)map.get("CHGTELLERNO"));
			this.getTelgrp().getUsr().setThrsta((String)map.get("TELRHRSTAT"));
			this.getTelgrp().getUsr().setTtransinst((String)map.get("TRANSINST"));
			this.getTelgrp().getUsr().setTsyssta((String)map.get("TELRSYSSTAT"));
			this.getTelgrp().getUsr().setTinst((String)map.get("TELLERINST"));
			this.getTelgrp().getUsr().setNam((String)map.get("CHGTELLERNO"));
			this.getTelgrp().getUsr().setDspnam((String)map.get("CHGTELLERNO"));
			this.getTelgrp().getUsr().setPwd((String)map.get("PASSWORD"));
			// $telgrp\\usr\\ptynam.setValue("台州银行总行");
			this.getTelgrp().getUsr().setSta("0");
			//$telgrp\\usr\\tchgno.setValue("01");
			
			if("11005293".equals((String)map.get("TELLERINST")))
			{
			  this.getTelgrp().getUsr().setEtyinr("00000001");
			  //关联所属实体
			  String ptyinr = "FI079709";
			  // $\\sysmod.setEtyAndPty($telgrp\\usr);
			  this.getTelgrp().getUsr().setPtyinr(ptyinr);
			}
			else
			{
			  this.getTelgrp().getUsr().setEtyinr("00000002");
			  //关联所属实体
			  String ptyinr = "00200016";
			  // $\\sysmod.setEtyAndPty($telgrp\\usr);
			  this.getTelgrp().getUsr().setPtyinr(ptyinr);
			}
			this.getTelgrp().getUsr().setTel( this.getTel());
			this.getTelgrp().getUsr().setTsyssta( "01");
			this.getTelgrp().getUsr().setThrsta( "01");
			log.debug("{}","******tchgno=" + this.getTelgrp().getUsr().getTchgno());
			tellerInr=getTellerInr(this.getTelgrp().getUsr().getTchgno());
			log.debug("{}","******tellerInr=" + tellerInr);
			if(!MdaUtils.isEmpty(tellerInr))
			{
			  ctx.getErrorCode();
			  this.getTelgrp().getUsr().setInr(tellerInr);
			  log.info("{}","更新柜员: "+tellerInr);
			  Platform.mdbUpdate(this.getTelgrp().getUsr());
			  Platform.mdbCommit();
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    log.info("{}","数据库更新失败");
			  }
			  ctx.setMessage(MdaUtils.getI18NString("telp","CT000468"),MdaUtils.getI18NString("telp","CT000469"));
			  
			  return true;
			}
			else
			{//插入
			  String inr = Platform.sdbCounter("usr");
			  log.debug("{}","插入新柜员usr inr: "+inr);
			  this.getTelgrp().getUsr().setInr(inr);
			  Platform.mdbInsert(this.getTelgrp().getUsr());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    log.info("{}","数据库插入失败");
			  }
			  String roles=(String)map.get("TELLERROLESET");
			  String[] roles2=roles.split("\\|");
			  for(String role : roles2)
			  {

			    this.getRec().setInr( Platform.sdbCounter("url"));
			    this.getRec().setUsrinr( this.getTelgrp().getUsr().getInr());
			    this.getRec().setRolinr(role);
			    this.getRec().setRolnam(rolnamstr);
			    Platform.mdbInsert(this.getRec());
			    errorcode = ctx.getErrorCode();
			    if(errorcode != NO_ERROR)
			    {
			      log.info("{}","数据库插入失败");
			    }
			  }
			}

			String urlinr=Platform.sdbCounter("url");
			this.getTelgrp().getRec().setInr(urlinr);
			this.getTelgrp().getRec().setUsrinr(tellerInr);
			this.getTelgrp().getRec().setRolinr((String)this.getInitrole());
			ctx.getDaoSession().dbInsert(this.getTelgrp().getRec());

			Platform.mdbCommit();
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.info("{}","数据库插入失败");
			  Platform.mdbRollback();
			}

			

			return true;
        }

        /**
        *   source:telp.@0006.script
        */
        @Rule(target="cancel",order=100)
        public boolean ruleCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:telp.@0007.script
        */
        @Rule(target="cancelteller",order=100)
        public boolean ruleCanceltellerN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mdbBegin();
			Map<String,Object> map=new HashMap<String,Object>();
			//交易类型码
			map.put("PCODE", "612030");
			//交易流水号
			String sqnum="12030"+MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SEQNO",sqnum);
			//被操作柜员号
			map.put("CHGTELLERNO",this.getTelgrp().getUsr().getTchgno());
			//操作柜员号
			map.put("TELLERCODE", MdaEnv.getLoginUser());
			//交易系统代码
			map.put("TRANSINST", "99306000000");
			//柜员业务机构
			map.put("TELLERINST", this.getTelgrp().getUsr().getTinst());
			//本地时间
			String localTime=MdaUtils.format(MdaUtils.today(),"HHmmss");
			map.put("LOCALTIME", localTime);
			//本地日期
			String localDate=MdaUtils.format(MdaUtils.today(),"yyMMdd");
			map.put("LOCALDATE",localDate);
			//是否授权 01 非授权, 02 授权
			map.put("ISAUTH","01");
			//发送交易系统代码
			map.put("SENDINST", "99306000000");
			//接受交易系统代吗
			map.put("DESTINST","99700060000");
			//系统跟踪号 - 11位系统号+8位日期+15位流水号
			String date=MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String seqno=MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SYSTRACENO","99306000000"+date+seqno);
			map.put("MessageType", "Register");
			log.info("{}","MESSAGE MAP : "+map);
			Map<String,Object> replyMap=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.teller.utils.TellerUtils","handleCancellation",map);
			log.info("{}","REPLY MAP:"+replyMap);
			if("000000".equals(replyMap.get("RESPCODE")))
			{
			  this.getTelgrp().getUsr().setTsyssta("02");
			  Platform.mdbUpdate(this.getTelgrp().getUsr());
			  Platform.mdbCommit();
			  int error=ctx.getErrorCode();
			  if(error==NO_ERROR)
			  {
			    this.query();
			    ctx.setMessage(MdaUtils.getI18NString("telp","CT000075"),MdaUtils.getI18NString("telp","CT000076"));
			  }
			  else
			  {
			    Platform.mdbRollback();
			    ctx.setMessage(MdaUtils.getI18NString("telp","CT000163"),MdaUtils.getI18NString("telp","CT000164"));
			  }
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("telp","CT000165"),MdaUtils.getI18NString("telp","CT000166"));
			}

			return true;
        }

        /**
        *   source:telp.@0008.script
        */
        @Rule(target="reactive",order=100)
        public boolean ruleReactiveN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mdbBegin();
			Map<String,Object> map=new HashMap<String,Object>();
			//交易类型码
			map.put("PCODE", "612040");
			//交易流水号
			String sqnum="12040"+MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SEQNO",sqnum);
			//被操作柜员号
			map.put("CHGTELLERNO",this.getTelgrp().getUsr().getTchgno());
			//操作柜员号
			map.put("TELLERCODE", MdaEnv.getLoginUser());
			//柜员业务机构
			map.put("TELLERINST", this.getTelgrp().getUsr().getTinst());
			//交易系统代码
			map.put("TRANSINST", "99306000000");
			//操作柜员号
			map.put("TELLERCODE", MdaEnv.getLoginUser());
			//本地时间
			String localTime=MdaUtils.format(MdaUtils.today(),"HHmmss");
			map.put("LOCALTIME", localTime);
			//本地日期
			String localDate=MdaUtils.format(MdaUtils.today(),"yyMMdd");
			map.put("LOCALDATE",localDate);
			//拟分配业务角色
			map.put("TELLERROLESET", "");
			//是否授权 01 非授权, 02 授权
			map.put("ISAUTH","01");
			//发送交易系统代码
			map.put("SENDINST", "99306000000");
			//接受交易系统代吗
			map.put("DESTINST","99700060000");
			//系统跟踪号 - 11位系统号+8位日期+15位流水号
			String date=MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String seqno=MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			map.put("SYSTRACENO","99306000000"+date+seqno);
			map.put("MessageType", "Register");
			log.info("{}","MESSAGE MAP : "+map);
			Map<String,Object> replyMap=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.teller.utils.TellerUtils","handleReactivation",map);
			log.info("{}","REPLY MAP:"+replyMap);
			log.info("{}","RESPCODE:"+replyMap.get("RESPCODE"));
			log.info("{}","000000".equals(replyMap.get("RESPCODE")));
			if("000000".equals(replyMap.get("RESPCODE")))
			{
			  this.getTelgrp().getUsr().setTsyssta("01");
			  Platform.mdbUpdate(this.getTelgrp().getUsr());
			  Platform.mdbCommit();
			  int error=ctx.getErrorCode();
			  log.info("{}","ERORR CODE"+error);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.query();
			    ctx.setMessage(MdaUtils.getI18NString("telp","CT000069"),MdaUtils.getI18NString("telp","CT000070"));
			  }
			  else
			  {
			    Platform.mdbRollback();
			    ctx.setMessage(MdaUtils.getI18NString("telp","CT000111"),MdaUtils.getI18NString("telp","CT000112"));
			  }
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("telp","CT000113"),MdaUtils.getI18NString("telp","CT000114"));
			}


			return true;
        }

                    /**
        *   source:telp.@0010.script
        */
        @Rule(target="eidtrole",order=100)
        public boolean ruleEidtroleN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:telp.@0011.script
        */
        @Rule(target="editcancel",order=100)
        public boolean ruleEditcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:telp.@0021.script
        */
        @Rule(target="rolechange",order=100)
        public boolean ruleRolechangeN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","SYSSTA"+this.getTelgrp().getUsr().getTsyssta());
			if(("注销".equals(this.getTelgrp().getUsr().getTsyssta()))
			  ||("02".equals(this.getTelgrp().getUsr().getTsyssta())))
			{
			  ctx.setMessage(MdaUtils.getI18NString("telp","CT000405"),MdaUtils.getI18NString("telp","CT000406"));
			}
			else
			{
			  ctx.storeData("usrinr",this.getTelgrp().getUsr().getInr());
			  Platform.mchain("dblsrl");
			}

			return true;
        }

        /**
        *   source:telp.@0023.script
        */
        @Rule(target="logout",order=100)
        public boolean ruleLogoutN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:telp.@0024.script
        */
        @Rule(target="signoffbutton",order=100)
        public boolean ruleSignoffbuttonN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPass()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("telp","CT000314"),MdaUtils.getI18NString("telp","CT000315"));
			}
			else
			{
			  Map<String,Object> map=new HashMap<String,Object>();
			  log.trace("{}","PASS1: "+this.getPass().toString());
			  String pass = this.getPass().toString();
			  log.trace("{}","PASS2: "+pass);
			  map.put("PASS",pass);
			  map.put("TELLERCODE", MdaEnv.getLoginUser());
			  map.put("TRANBRANCH",this.getTelgrp().getUsr().getTinst());
			  //Map<String,Object> replyMap = (Map<String,Object>)Platform.invoke("cn.com.brilliance.teller.utils.TellerUtils","handleLogout",map);
			  //log.info("REPLY MAP:"+replyMap);
			  //if("00000000".equals(replyMap.get("RESPCODE")))
			  //{
			  this.setErooroff((String)map.get("RESPINFO"));
			  
			  ctx.setMessage(MdaUtils.getI18NString("telp","CT000379"),MdaUtils.getI18NString("telp","CT000380"));
			  
			  //}
			  ///*else
			  //{
			  //  $erooroff.setValue((String)replyMap.get("RESPINFO"));
			  //  Platform.setModified($erooroff);
			  //  Platform.message(#CT000381,#CT000382);
			  //}
			}

			return true;
        }

        /**
        *   source:telp.@0025.script
        */
        @Rule(target="returnoff",order=100)
        public boolean ruleReturnoffN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:telp.@0031.script
        */
        @Rule(target="change",order=100)
        public boolean ruleChangeN100(){
            IContext ctx = MdaEnv.getContext();
            
			//保存柜员信息inr
			ctx.storeData("usrinr",this.getTelgrp().getUsr().getInr());
			Platform.mchain("dbetel");

			return true;
        }

        /**
        *   source:telp.@0032.script
        */
        @Rule(target="updcancel",order=100)
        public boolean ruleUpdcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:telp.@0033.script
        */
        @Rule(target="updconfirm",order=100)
        public boolean ruleUpdconfirmN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:telp.@0045.script
        */
        @Rule(target="editcfm",order=100)
        public boolean ruleEditcfmN100(){
            IContext ctx = MdaEnv.getContext();
            
			/* if(!"telupd".equals(Platform.getTransName()))
			  {
			  //交易不是telupd时终止。
			  return;
			  }
			  else
			  {
			
			  // 1.查询输入数据在数据库是否存在，不存在则直接返回，页面提示
			  IModule a = Platform.getModule($\\,"telgrp\\\\usr");
			
			  Platform.dbRead($\\telgrp\\rec,new Argument("usrinr",inr));
			  String rolinr=$\\telgrp\\rec\\rolinr;
			  IDatafield inrField = Platform.getDatafield(a, "inr");
			  String inr = inrField.getValue().toString();
			  // 获取页面输入
			  IDatafield tnameField = Platform.getDatafield(a, "tname");
			  IDatafield tchgnoField = Platform.getDatafield(a, "tchgno");
			  IDatafield tpersoncodeField = Platform.getDatafield(a, "tpersoncode");
			  //IDatafield trolesetField = Platform.getDatafield(a, "troleset");
			  IDatafield tinstField = Platform.getDatafield(a, "tinst");
			  IDatafield tsysstaField = Platform.getDatafield(a, "tsyssta");
			  IDatafield tchgtypField = Platform.getDatafield(a, "tchgtyp");
			  IDatafield thrstaField = Platform.getDatafield(a, "thrsta");
			  IDatafield telField = Platform.getDatafield(a, "tel");
			  IDatafield pwdField = Platform.getDatafield(a,"pwd");
			  IDatafield staField = Platform.getDatafield(a,"sta");
			
			  if(Platform.isEmpty(tnameField.getValue()) ||
			  Platform.isEmpty(tchgnoField.getValue()) ||
			  Platform.isEmpty(tpersoncodeField.getValue()) ||
			  Platform.isEmpty(trolesetField.getValue()) ||
			  Platform.isEmpty(tinstField.getValue()) ||
			  Platform.isEmpty(tsysstaField.getValue()) ||
			  Platform.isEmpty(tchgtypField.getValue()) ||
			  Platform.isEmpty(thrstaField.getValue()) ||
			  Platform.isEmpty(telField.getValue()) ||
			  Platform.isEmpty(pwdField.getValue()) ||
			  Platform.isEmpty(staField.getValue()))
			  {
			  Platform.message(#CT000463,#CT000464);
			  return false;
			  }
			
			  String tname = tnameField.getValue().toString();
			  String tchgno = tchgnoField.getValue().toString();
			  String tpersoncode = tpersoncodeField.getValue().toString();
			  String troleset = rolinr;
			  String tinst = tinstField.getValue().toString();
			  String tsyssta = tsysstaField.getValue().toString();
			  String tchgtyp = tchgtypField.getValue().toString();
			  String thrsta = thrstaField.getValue().toString();
			  String tel = telField.getValue().toString();
			  String pwd = pwdField.getValue().toString();
			  String sta = staField.getValue().toString();
			
			  log.debug("inr="+inr);
			  log.debug("pwd="+pwd);
			  Platform.dbRead(a,new Argument<String>("inr", inr));
			  IDatafield inrResultField = Platform.getDatafield(a, "inr");
			  if(Platform.isEmpty(inrResultField))
			  {
			  Platform.message(#CT000465,#CT000466);
			  return false;
			  }
			  else
			  {
			  // 2.存在，更新数据
			  Platform.clear(a);
			  String sql = "UPDATE usr t SET t.TNAME= ?, t.TCHGNO = ? , t.TPERSONCODE = ?,  t.TINST = ?, t.TSYSSTA = ?, t.TCHGTYP = ?, t.THRSTA = ?, t.TEL = ? , t.PWD= ?, t.STA = ? WHERE t.INR = ?";
			  Platform.dbExecuteSQL(sql , tname , tchgno , tpersoncode , tinst, tsyssta, tchgtyp, thrsta, tel, pwd, sta, inr);
			  String sql2="UPDATE url set rolinr=? where usrinr=?";
			  Platform.dbExecuteSQL(sql2,troleset,inr);
			  Platform.dbCloseCursor();
			  }
			  // String resultInr = inrResultField.getValue().toString();
			  // log.debug("resultInr="+resultInr);
			  }*/

			return true;
        }


        /**
        *   source:telp.@0035.script
        */
        @Check(target="telgrp.usr.tname",order=100)
        public boolean checkTelgrpUsrTnameN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getTelgrp().getUsr().getTname()))
			{
			  ctx.setFieldError(this,"telgrp.usr.tname",MdaUtils.getI18NString("telp","CT000425"));
			  return false;
			}
			log.info("{}","check usr tname");

			return true;
        }

        /**
        *   source:telp.@0036.script
        */
        @Check(target="telgrp.usr.tpersoncode",order=100)
        public boolean checkTelgrpUsrTpersoncodeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getTelgrp().getUsr().getTpersoncode()))
			{
			  ctx.setFieldError(this,"telgrp.usr.tpersoncode",MdaUtils.getI18NString("telp","CT000426"));
			  return false;
			}
			else
			{
			  String tpersoncode = this.getTelgrp().getUsr().getTpersoncode();
			  if(!tpersoncode.matches("^[1-9]\\d{5}(18|19|20)\\d{2}((0[1-9])|(1[0-2]))(([0-2][1-9])|10|20|30|31)\\d{3}[0-9Xx]")
			    && !tpersoncode.matches("([1-9][0-9]{5}[0-9]{2}((0[1-9])|(10|11|12))(([0-2][1-9])|10|20|30|31)[0-9]{3})"))
			  {
			    ctx.setFieldError(this,"telgrp.usr.tpersoncode","身份证号格式不正确");
			    return false;
			  }
			}
			log.info("{}","check usr tpersoncode");

			return true;
        }

        /**
        *   source:telp.@0037.script
        */
        @Check(target="telgrp.usr.tinst",order=100)
        public boolean checkTelgrpUsrTinstN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getTelgrp().getUsr().getTinst()))
			{
			  ctx.setFieldError(this,"telgrp.usr.tinst",MdaUtils.getI18NString("telp","CT000427"));
			  return false;
			}
			log.info("{}","check usr tinst");

			return true;
        }

        /**
        *   source:telp.@0038.script
        */
        @Check(target="initrole",order=100)
        public boolean checkInitroleN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getInitrole()))
			{
			  ctx.setFieldError(this,"initrole",MdaUtils.getI18NString("telp","CT000428"));
			  return false;
			}
			log.info("{}","check usr initrole");

			return true;
        }

        /**
        *   source:telp.@0039.script
        */
        @Check(target="tchgno",order=100)
        public boolean checkTchgnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			if( MdaUtils.isEmpty(this.getTchgno()))
			{
			  ctx.setFieldError(this,"tchgno",MdaUtils.getI18NString("telp","CT000429"));
			  return false;
			}
			log.info("{}","check usr tchgno");

			return true;
        }

        /**
        *   source:telp.@0040.script
        */
        @Check(target="pwd",order=100)
        public boolean checkPwdN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($pwd.getValue()))
			  {
			  Platform.error($pwd,#CT000430);
			  return false;
			  }
			  log.info("check usr pwd");
			  */

			return true;
        }

        /**
        *   source:telp.@0042.script
        */
        @Check(target="tel",order=100)
        public boolean checkTelN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getTel()))
			{
			  ctx.setFieldError(this,"tel",MdaUtils.getI18NString("telp","CT000435"));
			  return false;
			}
			else
			{
			  String tel = this.getTel();
			  if(!(tel.matches("^1(3\\d|4[5-9]|5[0-35-9]|6[567]|7[0-8]|8\\d|9[0-35-9])\\d{8}")))
			  {
			    ctx.setFieldError(this,"tel",MdaUtils.getI18NString("telp","CT000436"));
			    return false;
			  }
			}
			log.info("{}","check usr tel");

			return true;
        }



        /**
        *   source:telp.@0015.script
        */
        public String instConvert(String tinstSting)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("11005293".equals(tinstSting))
			{
			  tinstSting="台州银行总行";
			}
			else if("31005006".equals(tinstSting))
			{
			  tinstSting="上海自贸区分行区分";
			}
			else if("1100529F".equals(tinstSting))
			{
			  tinstSting="自贸区总行";
			}
			return tinstSting;
		}
        /**
        *   source:telp.@0016.script
        */
        public String  systemStateConvert(String tsysstaString)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("01".equals(tsysstaString))
			{
			  tsysstaString="启用";
			}
			else if("02".equals(tsysstaString))
			{
			  tsysstaString="注销";
			}
			return tsysstaString;
		}
        /**
        *   source:telp.@0017.script
        */
        public String  thrstaConvert(String thrstaString)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("01".equals(thrstaString))
			{
			  thrstaString="正常";
			}
			else if("02".equals(thrstaString))
			{
			  thrstaString="停用";
			}
			return thrstaString;
		}
        /**
        *   source:telp.@0018.script
        */
        public String  tchgtypConvert(String tchgtypString)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("01".equals(tchgtypString))
			{
			  tchgtypString="不变";
			}
			else if("02".equals(tchgtypString))
			{
			  tchgtypString="修改";
			}
			return tchgtypString;
		}
        /**
        *   source:telp.@0019.script
        */
        public String  trolesetConvert(String trolesetString)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","Starting convert ROLE SET");
			String[] roles=trolesetString.split("\\|");
			java.lang.StringBuilder sb=new java.lang.StringBuilder();
			for(String role:roles)
			{
			  log.debug("{}","role="+role);
			  //sb.append(convertRole(role)+"|");
			  sb.append(convertRole(role));
			}
			return sb.toString();
		}
        /**
        *   source:telp.@0020.script
        */
        public String convertRole(String role)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="select nam from rol where inr=?";
			Argument<String> nam=new Argument<String>("nam");
			log.info("{}","Executing SQL :"+sql);
			ctx.getDaoSession().dbExecuteSQL(sql,role);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(nam);
			  int error=ctx.getErrorCode();
			  if(error==NO_ERROR)
			  {
			    role=(String)nam.getValue();
			  }
			  else
			  {
			    break;
			  }
			}
			log.info("{}","closing cursor for rol");
			ctx.getDaoSession().dbCloseCursor();
			return role;
		}
        /**
        *   source:telp.@0022.script
        */
        public void query()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> tinstLst = new ArrayList<CodetableItem>();
			Argument<String> tininr = new Argument<String>("inr");
			Argument<String> tinnam = new Argument<String>("brhnam");
			String tinsql = "select inr ,brhnam from jgx";
			ctx.getDaoSession().dbExecuteSQL(tinsql);
			Map tinnammap = new HashMap();
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(tininr,tinnam);
			  int error=ctx.getErrorCode();

			  if(error==NO_ERROR)
			  {
			    tinnammap.put(tininr.getValue(),tinnam.getValue());
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			ctx.storeData("tinnammap",tinnammap);
			tinnammap = (Map)ctx.restoreData("tinnammap");

			this.getTelgrp().getUsrlst().clear();
			List<Object> sqlData=new ArrayList<Object>();
			String sql="select usr.inr,usr.tname,usr.tpersoncode,usr.tinst,url.rolinr as rolinr,usr.sta,usr.tchgtyp,usr.tchgno,rol.nam from usr,url,rol where tname is not null and usr.inr=url.usrinr and rol.inr=url.rolinr";
			if(!MdaUtils.isEmpty(this.getTname()))
			{
			  sql+=" and tname like '%"+this.getTname()+"%' ";

			  // sqlData.add($tname.getValue());
			}
			if(!MdaUtils.isEmpty(this.getTpersoncode()))
			{
			  sql+=" and tchgno like '%"+this.getTpersoncode()+"%' ";
			  //  sqlData.add($tpersoncode.getValue());
			}
			String etyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEty().getInr();
			if(!MdaUtils.isEmpty(etyinr))
			{
			  sql+=" and etyinr='"+etyinr+"' ";
			}

			// Object[] values=new Object[sqlData.size()];
			//sqlData.toArray(values);
			Argument<String> inr=new Argument<String>("inr");
			Argument<String> tname=new Argument<String>("tname");
			Argument<String> tpersoncode=new Argument<String>("tpersoncode");
			Argument<String> tinst=new Argument<String>("tinst");
			Argument<String> rolinr=new Argument<String>("rolinr");
			//Argument<String> tsyssta=new Argument<String>("tsyssta");
			//Argument<String> thrsta=new Argument<String>("thrsta");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> tchgtyp=new Argument<String>("tchgtyp");
			Argument<String> tchgno=new Argument<String>("tchgno");
			Argument<String> nam=new Argument<String>("nam");

			ctx.getDaoSession().dbConnect();
			log.info("{}","Execute SQL "+sql);
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,tname,tpersoncode,tinst,rolinr,sta,tchgtyp,tchgno,nam);
			  int error=ctx.getErrorCode();
			  log.info("{}","Fetch complete "+error);
			  if(error==NO_ERROR)
			  {
			    if(null!=tinnammap)
			    {
			      String tinstSting=(String)tinst.getValue();
			      tinstSting=(String)tinnammap.get(tinstSting);
			      tinst.setValue(tinstSting);
			    }

			    /*String tsysstaString=(String)tsyssta.getValue();
			      tsysstaString=$this.systemStateConvert(tsysstaString);
			      tsyssta.setValue(tsysstaString);
			
			      String thrstaString=(String)thrsta.getValue();
			      thrstaString=$this.thrstaConvert(thrstaString);
			      thrsta.setValue(thrstaString);*/

			    String tchgtypString=(String)tchgtyp.getValue();
			    tchgtypString=this.tchgtypConvert(tchgtypString);
			    tchgtyp.setValue(tchgtypString);

			    Argument<String> rolinf=new Argument<String>("rolinf");

			    rolinf.setValue(nam.getValue());
			    this.getTelgrp().getUsrlst().add(inr,tname,tpersoncode,tinst,rolinf,sta,tchgtyp,tchgno);
			  }
			  else
			  {
			    break;
			  }
			}
			log.info("{}","closing cursor for usr");
			ctx.getDaoSession().dbCloseCursor();

			
			ctx.getDaoSession().dbDisconnect();
		}
        /**
        *   source:telp.@0026.script
        */
        public void setRoles()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbConnect();
			List<CodetableItem> lst = new ArrayList<CodetableItem>();
			String sql="select inr,nam from rol  ";
			Argument<String> inr=new Argument<String>("inr");
			Argument<String> nam=new Argument<String>("nam");
			log.info("{}","Execute SQL "+sql);
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,nam);
			  log.info("{}","Fetching "+nam.getValue());
			  int error=ctx.getErrorCode();
			  log.info("{}","Fetch complete "+error);

			  if(error==NO_ERROR)
			  {
			    lst.add(new CodetableItem(nam.getValue(),inr.getValue()));
			  }
			  else
			  {
			    break;
			  }
			}
			log.info("{}","closing cursor for usr");
			ctx.getDaoSession().dbCloseCursor();
			MdaUtils.setValues(this,"initrole",lst);
			
			ctx.getDaoSession().dbDisconnect();
		}
        /**
        *   source:telp.@0027.script
        */
        public String getTellerInr(String tellCode)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tellCode="+tellCode);
			String inrString="";
			String sql="select inr from usr where tchgno =?";
			Argument inr=new Argument<String>("inr");
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  log.debug("{}","有错误7");
			}
			ctx.getDaoSession().dbExecuteSQL(sql,tellCode);
			log.debug("{}","errorCode8="+ctx.getErrorCode());
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  log.debug("{}","有错误8");
			}
			ctx.getDaoSession().dbFetchFields(inr);
			log.debug("{}","errorCode9="+ctx.getErrorCode());
			log.debug("{}","inr="+inr.getValue());
			inrString= (String)inr.getValue();
			log.debug("{}","inrString="+inrString);
			ctx.getDaoSession().dbCloseCursor();
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  log.debug("{}","有错误10");
			}
			return inrString;
		}
        /**
        *   source:telp.@0046.script
        */
        public String  getRolName(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			// Platform.dbRead($telgrp\\rec,new Argument("rolinr",rolinr));
			ctx.getDaoSession().dbRead(this.getTelgrp().getRol(),new Argument("inr",rolinr));
			return this.getTelgrp().getRol().getNam();
			// 查询角色下拉框
			/* List<CodetableItem> rolLst = new ArrayList<CodetableItem>();
			  String sql="select inr,nam from rol  ";
			  Argument<String> inr=new Argument<String>("inr");
			  Argument<String> nam=new Argument<String>("nam");
			  log.info("Execute SQL "+sql);
			  Platform.dbExecuteSQL(sql);
			  // String rolinr="";
			  while(true)
			  {
			  Platform.dbFetchFields(inr,nam);
			  log.info("Fetching "+nam.getValue());
			  int error=Platform.errorCode();
			  log.info("Fetch complete "+error);
			
			  if(error==NO_ERROR)
			  {
			  // rolinr=inr.getValue();
			  rolLst.add(new CodetableItem(nam.getValue(),inr.getValue()));
			  }
			  else
			  {
			  break;
			  }
			  }
			  return rolLst;*/
		}


        public void setTelgrpHolder(ModuleHolder<Telgrp> telgrp)
        {
            this.telgrp = telgrp;
        }

        public Telgrp getTelgrp()
        {
           return this.telgrp.get();
        }






























































}