package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Ore;
import com.ceb.gjjs.mda.bo.Ord;
import com.ceb.gjjs.mda.bo.Ptyaut;
import com.ceb.gjjs.mda.bo.Frm;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Rmk;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Frs;
import com.ceb.gjjs.mda.bo.Usrsig;
import com.ceb.gjjs.mda.bo.Frr;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Trnmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Trnmod.class);

        //objinr
        @Module(getter = false, setter = false)
		private FieldHolder<String> objinr = new FieldConstantHolder<>("");

        //保存DAT文件流
        private IStream datstm = new StreamImpl();

        //报文交易是否进行权限控制
        private String messageallow;

        //静态数据是否进行权限控制
        private String staticallow;

        //业务交易是否进行权限控制
        private String trnallow;

        //trndata stream
        private IStream trndatstm = new StreamImpl();

        //bimdata stream
        private IStream bimdatstm = new StreamImpl();

        //审批意见
        private String newdet;

        //新增意见
        private IControl newdetbut;

        //提示信息
        private String infmsg;


        @JsonIgnore
        @BDGetter
        private transient IPanel sigp;

        @JsonIgnore
        @BDGetter
        private transient IPanel rmkp;


	    @BDGetter
		private Trn trn;

	    @BDGetter
		private Ord ord;

	    @BDGetter
		private Ore ore;

	    @BDGetter
		private Wfmmod wfmmod;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;

	    @BDGetter
		private Spt spt;

	    @BDGetter
		private Ptyaut ptyaut;

	    @BDGetter
		private Usrsig usrsig;

	    @BDGetter
		private Trn wrktrn;

	    @BDGetter
		private Frm frm;

	    @BDGetter
		private Frr frr;

	    @BDGetter
		private Frs frs;

	    @BDGetter
		private Rol rol;

	    @BDGetter
		private Rmk rmk;

		@BDGetter
		private ModuleList<Usrsig> siglst;

	    @BDGetter
		private Congrp congrp;

	    @BDGetter
		private Stagrp stagrp;


		public Trnmod()
        {
            super();
            setArgument();
        }

        public Trnmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:trnmod.@0000.script
        */
        @Rule(target="mtabut.sav",order=50)
        public boolean ruleMtabutSavN50(){
            IContext ctx = MdaEnv.getContext();
            
			/*log.info("业务提交  机构名称["+$\\sysmod\\pty\\nam+"]");
			  log.info("操作员登陆名["+$\\sysmod\\usr\\nam+"]");
			  //检查是否有经办权限
			  if(!checkUserRight(Platform.sgetTransName(),"O"))
			  {
			  log.warn("当前用户没有经办权限，退出！");
			  // 此时没有dbbegin 直接返回.
			  // Platform.message(#CT000000,#CT000001);
			  //return false;
			  }
			  log.debug("pre errorcode:" + Platform.errorCode());*/

			return true;
        }

        /**
        *   source:trnmod.@0008.script
        */
        @Rule(target="mtabut.sav",order=1000)
        public boolean ruleMtabutSavN1000(){
            IContext ctx = MdaEnv.getContext();
            
			/*//插入trn 存数据文件
			log.info("{}","sav 1000");
			//log.debug("trninr="+$trn\\inr);
			Platform.mdbInsert(this.getTrn());
			if(!MdaUtils.isEmpty(this.getSpt().getInr()))
			{
			log.debug("{}","删除 spt...");
			String filename=this.getSpt().getInr()+".bak";
			String sptpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/delete");
			filename=MdaUtils.catPath(sptpath,filename);
			if(Platform.mfileExists(filename))
			Platform.mfileDelete(filename);
			Platform.mdbDelete(this.getSpt());
			MdaUtils.clear(this.getSpt());
			}
			ctx.absGet(Sysmod.class).setOrdinr(NULLSTR);
			String modpath=MdaDriver.getModuleType(this.getMtabut().getMtagrp());
			log.debug("{}","提交完毕 保存数据文件"+modpath);
			MdaUtils.clear(this.getMtabut().getTrnstm());
			IStream os=this.getMtabut().getTrnstm();
			MdaUtils.streamClear(os);
			MdaUtils.saveData(this.getMtabut().getMtagrp(),os);
			if(MdaUtils.isEmpty(os))
			{
			log.info("{}","save data is empty.rollback and exit.");
			Platform.mdbRollback();
			return false;
			}
			String filename = this.getTrn().getInr()+".dat";
			String file=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/trndata/"+filename);
			Platform.mstreamSave(os,file);*/

			return true;
        }

        /**
        *   source:trnmod.@0009.script
        */
        @Rule(target="mtabut.ped",order=1000)
        public boolean ruleMtabutPedN1000(){
            IContext ctx = MdaEnv.getContext();
            
			/*String typ=Platform.getModuleType(Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec"));
			  $spt\\objtyp.setValue(typ);
			  $spt\\objinr.setValue($objinr.getValue());
			  $spt\\objnam.setValue("tttt");
			  $spt\\nam.setValue("");
			  String sptinr=$spt\\inr.getValue();
			  log.debug("group typ---"+typ );
			  String inr="";
			  $spt\\objtyp.setValue(typ);
			  $spt\\objinr.setValue(inr);
			  $spt\\sta.setValue("P");//状态 P 暂存
			  $spt\\ptyinr.setValue($\\sysmod\\pty\\inr.getValue());
			  $spt\\oprogninr.setValue($\\sysmod\\pty\\inr.getValue());
			  $spt\\dattim.setValue(new Date());
			  $spt\\frm.setValue(Platform.getTransName());
			  if(Platform.isEmpty($spt\\inr))
			  {
			  $spt\\scr.setValue("I");//业务来源 I 录入
			  Platform.sdbCounter($spt);
			  Platform.mdbInsert($spt);
			  }
			  else
			  {
			  Platform.mdbUpdate($spt);
			  }
			  saveOrdNewOre("P");
			  //end
			  IStream os=$mtabut\\trnstm.getValue();
			  Platform.streamClear(os);
			  Platform.saveData($mtabut\\mtagrp,os);
			  String file=Platform.catPath(Platform.getRootPath(),"data/delete/"+$spt\\inr.getValue()+".bak");
			  Platform.mstreamSave(os,file);
			  Platform.clear($spt);
			  Platform.clear($\\sysmod\\ordinr);*/

			return true;
        }

        /**
        *   source:trnmod.@0017.script
        */
        @Rule(target="mtabut.submit",order=1000)
        public boolean ruleMtabutSubmitN1000(){
            IContext ctx = MdaEnv.getContext();
            
			//插入trn 存数据文件
			/*log.info("submit 1000");
			  Platform.mdbInsert($trn);
			  log.info("insert trn with errorcode:" + Platform.errorCode());
			  if(!Platform.isEmpty($spt\\inr))
			  {
			  log.debug("删除 spt...");
			  String filename=$spt\\inr.getValue()+".bak";
			  String sptpath=Platform.catPath(Platform.getRootPath(),"data/delete");
			  filename=Platform.catPath(sptpath,filename);
			  if(Platform.mfileExists(filename))
			  Platform.mfileDelete(filename);
			  Platform.mdbDelete($spt);
			  Platform.clear($spt);
			  }
			  Platform.clear($\\sysmod\\ordinr);
			  String modpath=Platform.getModuleType($mtabut\\mtagrp);
			  log.debug("提交完毕 保存数据文件"+modpath);
			  Platform.clear($mtabut\\trnstm);
			  IStream os=$mtabut\\trnstm.getValue();
			  Platform.streamClear(os);
			  Platform.saveData($mtabut\\mtagrp,os);
			  if(Platform.isEmpty(os))
			  {
			  log.info("save data is empty.rollback and exit.");
			  //Platform.falseAndRollback();
			  Platform.mdbRollback();
			  return false;
			  }
			  String filename = $trn\\inr.getValue()+".dat";
			  String file=Platform.catPath(Platform.getRootPath(),"data/trndata/"+filename);
			  Platform.mstreamSave(os,file);*/

			return true;
        }

        /**
        *   source:trnmod.@0020.script
        */
        @Rule(target="mtabut.submit",order=2000)
        public boolean ruleMtabutSubmitN2000(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","submit 2000 报文静态数据");
			/* if("R".equals($trn\\sta))
			  {
			  log.info("save data into database");
			  saveStaticTransaction($mtabut\\mtagrp);
			  }*/
			//保存静态数据
			if(!storeStaticDataInTransaction())
			{
			  return false;
			}

			return true;
        }

        /**
        *   source:trnmod.@0022.script
        */
        @Rule(target="mtabut.argbut.ame",order=1)
        public boolean ruleMtabutArgbutAmeN1(){
            IContext ctx = MdaEnv.getContext();
            
			/*log.info("argbut ame order 1");
			  Platform.clear($wrktrn);
			  String objtyp = Platform.getModuleType(Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec"));
			  log.debug("objtyp is " + objtyp);
			  log.debug("objinr is " + $objinr);
			  Argument arg = new Argument();
			  String [] nams = {"objinr"};
			  arg = Platform.addArgumentNotEmpty(nams,$objinr);
			  Argument<String> argAnd = new Argument<String>("objtyp",objtyp);
			  arg = arg.and(argAnd);
			  argAnd = new Argument<String>("sta","W");
			  arg = arg.and(argAnd);
			  //log.debug("search trn with argument:" + arg.value);
			  Platform.mdbRead($wrktrn,arg);
			  Platform.setModified($wrktrn);
			  log.info("read trn with errorcode:" + Platform.errorCode());
			  if(!Platform.isEmpty($wrktrn\\inr))
			  {
			  Platform.prompt(#CT000018,#CT000019);
			  return false;
			  }*/

			return true;
        }

        /**
        *   source:trnmod.@0031.script
        */
        @Rule(target="mtabut.sav",order=499)
        public boolean ruleMtabutSavN499(){
            IContext ctx = MdaEnv.getContext();
            
			/*$trn\\inr = Platform.sdbCounter($trn);
			  log.debug("trninr:" + $trn\\inr.getValue());*/

			return true;
        }

        /**
        *   source:trnmod.@0032.script
        */
        @Rule(target="mtabut.sav",order=505)
        public boolean ruleMtabutSavN505(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(!Platform.isEmpty($\\sysmod\\spt\\inr))
			  {
			  log.debug("删除spt...");
			  $\\sysmod\\spt\\sta = "S";
			  Platform.mdbUpdate($\\sysmod\\spt);
			  }*/

			return true;
        }

        /**
        *   source:trnmod.@0033.script
        */
        @Rule(target="mtabut.sav",order=2000)
        public boolean ruleMtabutSavN2000(){
            IContext ctx = MdaEnv.getContext();
            
			//判断是否直接保存静态数据
			storeStaticDataInTransaction();

			return true;
        }

        /**
        *   source:trnmod.@0034.script
        */
        @Rule(target="mtabut.sav",order=2999)
        public boolean ruleMtabutSavN2999(){
            IContext ctx = MdaEnv.getContext();
            
			//保存BIMDATA,用于业务回滚
			//storeBimData();
			//保存TRNDATA,用于业务复核
			//storeTrnData($mtabut\\mtagrp);
			
			return true;
        }

        /**
        *   source:trnmod.@0035.script
        */
        @Rule(target="mtabut.submit",order=499)
        public boolean ruleMtabutSubmitN499(){
            IContext ctx = MdaEnv.getContext();
            
			/*log.debug("submit 499");
			  $trn\\inr = Platform.sdbCounter($trn);
			  log.debug("trninr:" + $trn\\inr.getValue());*/

			return true;
        }

        /**
        *   source:trnmod.@0036.script
        */
        @Rule(target="mtabut.submit",order=505)
        public boolean ruleMtabutSubmitN505(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(!Platform.isEmpty($\\sysmod\\spt\\inr))
			  {
			  log.debug("删除spt...");
			  $\\sysmod\\spt\\sta = "S";
			  Platform.mdbUpdate($\\sysmod\\spt);
			  }*/

			return true;
        }

        /**
        *   source:trnmod.@0037.script
        */
        @Rule(target="mtabut.submit",order=2999)
        public boolean ruleMtabutSubmitN2999(){
            IContext ctx = MdaEnv.getContext();
            
			/*Platform.errorCode();
			  //保存BIMDATA,用于业务回滚
			  storeBimData();
			  //保存TRNDATA,用于业务复核
			  storeTrnData($mtabut\\mtagrp);*/

			return true;
        }



        /**
        *   source:trnmod.@0010.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(Platform.isEmpty($\\sysmod\\ordinr))
			  return;
			  //  如果交易下ord为空 sysmod的ordinr不为空
			  //  表示当前交易是退回或暂存后提取的读取ord信息
			  if(Platform.isEmpty($ord\\inr))
			  Platform.mdbRead($ord,new Argument<String>("inr",$\\sysmod\\ordinr.getValue()));
			  // 读取备注信息
			  log.info("init trnmod 20:ordinr="+$\\sysmod\\ordinr.getValue());
			  Platform.mdbRead($\\rmkmod\\rmk,new Argument<String>("ordinr",$\\sysmod\\ordinr.getValue()));
			  $\\rmkmod\\htext.setValue($\\rmkmod\\rmk\\txt.getValue());
			  Platform.clear($\\sysmod\\ordinr);*/

			return true;
        }

        /**
        *   source:trnmod.@0013.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(Platform.isEmpty($\\sysmod\\sptinr))
			  return ;
			  log.info("init trnmod 50:sptinr="+$\\sysmod\\sptinr.getValue());
			  Platform.mdbRead($spt,new Argument<String>("inr",$\\sysmod\\sptinr.getValue()));
			  String filename=Platform.catPath(Platform.getRootPath(),"data/delete/" +$spt\\inr.getValue()+".bak");
			  if(!Platform.mfileExists(filename))
			  return;
			  IStream is=$mtabut\\trnstm.getValue();
			  Platform.mstreamLoad(is,filename);
			  Platform.loadData($mtabut\\mtagrp,is);
			  Platform.streamClear(is);
			  Platform.clear($mtabut\\trnstm);*/

			return true;
        }

        /**
        *   source:trnmod.@0023.script
        */
        @Init(order=500)
        public boolean	init500(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  String propertiesFile = Platform.catPath(Platform.getRootPath(),"cfg");
			  propertiesFile = Platform.catPath(propertiesFile,"office.properties");
			  String messageallow = Platform.getPropertyValue(propertiesFile,"messageallow");
			  if(! Platform.isEmpty(messageallow))
			  $messageallow = "X";
			  String staticallow = Platform.getPropertyValue(propertiesFile,"staticallow");
			  if(! Platform.isEmpty(staticallow))
			  $staticallow = "X";
			  String trnallow = Platform.getPropertyValue(propertiesFile,"trnallow");
			  if(! Platform.isEmpty(trnallow))
			  $trnallow = "X";
			  */

			return true;
        }

        /**
        *   source:trnmod.@0041.script
        */
        @Init(order=10)
        public boolean	init10(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getErrorCode();
			MdaUtils.clear(this.getFrm());
			int errorcode = ctx.getErrorCode();
			Platform.mdbRead(this.getFrm(),new Argument<String>("frm",Platform.sgetTransName()));
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","未读取到" + Platform.sgetTransName() + "的FRM表记录.");
			  ctx.setMessage(MdaUtils.getI18NString("trnmod","CT000048"),MdaUtils.getI18NString("trnmod","CT000049"));
			  
			  return false;
			}

			return true;
        }

        /**
        *   source:trnmod.@0042.script
        */
        @Init(order=9999)
        public boolean	init9999(){
            IContext ctx = MdaEnv.getContext();
            
			//保存BIMDATA数据，存盘前快照
			MdaUtils.clear(this.getBimdatstm());
			IStream os = this.getBimdatstm();
			MdaUtils.clear(os);
			if(ctx.absGet(Sysmod.class).isSptCorrectLoaded())
			{
			  //如果是REPAIR的交易，则不能用当前的数据作为BIMDATA
			  if(!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getTrninr()))
			    loadBimData(os,ctx.absGet(Sysmod.class).getSpt().getTrninr());
			}
			else
			  MdaUtils.saveData(this.getMtabut().getMtagrp(),os);

			return true;
        }


        /**
        *   source:trnmod.@0001.script
        */
        public void checkUserRight(String frm,String flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*if(Platform.isEmpty(frm))
			  return false;
			  if(Platform.isEmpty(flg))
			  flg= "O";
			  flg=flg.trim();
			  // frm 交易名
			  // flg 权限标志  O 经办 B复核  A1 A2 A3授权
			  // 先查询USRAUT表是否包含权限
			  String usrinr=$\\sysmod\\usr\\inr.getValue();
			  String sql = "SELECT inr FROM usraut WHERE frm='"+frm+"'";
			  sql = sql+" AND OBJINR = '"+usrinr+"' AND OBJTYP = 'usr'";
			  // flg1 经办标志 0有1无
			  if(flg.equals("O"))
			  sql = sql+" AND flg1 = '0'";
			  // flg2 复核标志 0有1无
			  else if(flg.equals("B"))
			  sql = sql+" AND flg2 = '0'";
			  // lvl 授权级别   1一级……
			  else if(flg.indexOf("A")>=0)
			  {
			  String lvl = flg.substring(1);
			  sql = sql+" AND lvl >='"+lvl+"'";
			  }
			  log.debug("chk aut sql="+sql);
			  Platform.mdbExecuteSQL(sql);
			  Argument inr=new Argument("inr");
			  Platform.mdbFetchFields(inr);
			  Platform.mdbCloseCursor();
			  // 如果没有该交易的操作权限
			  int err = Platform.errorCode();
			  if(err==NO_ERROR)
			  return true;
			  if(err==NO_MORE_ROW&&!flg.equals("O"))
			  return false;
			  //如果usraut表没有记录则通过角色交易配置检查是否有经办权限
			  //sql = "SELECT p.frm FROM usr,usrrol r,frr p WHERE ";
			  // LCG 2012.08.07修改,USRROL表被更名为URL,调整SQL
			  sql = "SELECT m.frm FROM usr,url r,frr p,frm m WHERE ";
			  sql = sql + " p.frminr = m.inr AND ";
			  sql = sql + " m.frm = '"+frm+"' AND ";
			  sql = sql + " usr.inr = r.usrinr AND p.objinr = r.rolinr AND p.objtyp = 'rol' GROUP BY m.frm";
			  log.debug("chk rolfrm sql="+sql);
			  Platform.mdbExecuteSQL(sql);
			  Argument frminr=new Argument("frminr");
			  Platform.mdbFetchFields(frminr);
			  Platform.mdbCloseCursor();
			  // 如果没有该交易的操作权限
			  if(Platform.errorCode()==NO_ERROR)
			  return true;
			  return false;*/
		}
        /**
        *   source:trnmod.@0002.script
        */
        public void setFrmTrn(String title,String oprType,String oprName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 如果是退回的交易先读原trn
			/*if(isSptSta("B"))
			  {
			  log.debug("load back trn"+$spt\\scrtxt);
			  Platform.mdbRead($trn,new Argument<String>("inr",$spt\\scrtxt.getValue()));
			  }
			  // set trn
			  String typ=null;
			  typ=Platform.getModuleType(Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec"));
			  $trn\\objtyp.setValue(typ);
			  $trn\\objinr.setValue($objinr.getValue());
			  // trn原始币种金额
			  // 授权币种金额 $trn\\relcur $trn\\relamt暂不处理
			  //$trn\\reloricur.setValue($cur.getValue());
			  //$trn\\reloriamt.setValue($amt.getValue());
			  //$trn\\ownref.setValue($ownref.getValue());
			  //这个函数的oprName传递业务交易的业务编号
			  $trn\\ownref = oprName;
			  $trn\\nam = title + "/" + oprType;
			  $trn\\objnam = title + "/" + oprType + " " + oprName;
			  $trn\\inidattim.setValue(Platform.today());
			  $trn\\inifrm.setValue(Platform.getTransName());
			  $trn\\iniusr.setValue($\\sysmod\\usr\\inr.getValue());
			  $trn\\sta.setValue("W");
			  $trn\\ptyinr.setValue($\\sysmod\\pty\\inr.getValue());
			  $trn\\etyinr.setValue($\\sysmod\\ety\\inr.getValue());
			  $trn\\etginr.setValue($\\sysmod\\etg\\inr.getValue());
			  $trn\\usrnam = $\\sysmod\\usr\\nam + "(" + $\\sysmod\\usr\\dspnam + ")";
			  $trn\\trntyp = "B";
			  // 除暂存状态外trn都生成新的
			  String inr = Platform.sdbCounter("trn");
			  log.debug("new trninr="+inr);
			  $trn\\inr.setValue(inr);
			  return true;*/
		}
        /**
        *   source:trnmod.@0004.script
        */
        public void saveOrdNewOre(String sta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*String ordinr = null;
			  $ord\\optptyinr.setValue($\\sysmod\\pty\\inr.getValue());
			  $ord\\optetyinr.setValue($\\sysmod\\ety\\inr.getValue());
			  $ord\\optetginr.setValue($\\sysmod\\etg\\inr.getValue());
			  $ord\\objtyp.setValue($trn\\objtyp.getValue());
			  $ord\\objinr.setValue($trn\\objinr.getValue());
			  $ord\\sta.setValue(sta);
			  Date d = Platform.today();
			  $ord\\stadattim.setValue(d);
			  String frm = Platform.getTransName();
			  if(Platform.isEmpty($ord\\inr))
			  {
			  //新增ord记录
			  $ord\\inifrm.setValue(frm);
			  $ord\\inidattim.setValue(d);
			  $ord\\bnkinr.setValue("");
			  $ord\\etyinr.setValue($\\sysmod\\ety\\inr.getValue());
			  $ord\\etginr.setValue($\\sysmod\\etg\\inr.getValue());
			  $ord\\ptyinr.setValue($\\sysmod\\pty\\inr.getValue());
			  ordinr=Platform.sdbCounter("ord");
			  log.debug("insert ord="+ordinr);
			  $ord\\inr.setValue(ordinr);
			  Platform.mdbInsert($ord);
			  }
			  else
			  {
			  //修改ord记录
			  ordinr = $ord\\inr.getValue();
			  log.debug("update ord="+ordinr);
			  Platform.mdbUpdate($ord);
			  }
			  $ore\\ordinr.setValue($ord\\inr.getValue());
			  $ore\\objtyp.setValue($ord\\objtyp.getValue());
			  $ore\\objinr.setValue($ord\\objinr.getValue());
			  $ore\\typ.setValue($ord\\sta.getValue());
			  $ore\\frm.setValue(frm);
			  $ore\\usrinr.setValue($\\sysmod\\usr\\inr.getValue());
			  $ore\\ptyinr.setValue($\\sysmod\\pty\\inr.getValue());
			  String oreinr=Platform.sdbCounter("ore");
			  log.debug("Insert ore="+oreinr);
			  $ore\\inr.setValue(oreinr);
			  Platform.mdbInsert($ore);
			  return ordinr;*/
		}
        /**
        *   source:trnmod.@0005.script
        */
        public void isSptSta(String sta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*if(Platform.isEmpty($spt\\inr)||Platform.isEmpty(sta))
			  return false;
			  return sta.equals($spt\\sta.getValue());*/
		}
        /**
        *   source:trnmod.@0006.script
        */
        public void loadPtyaut(String transname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//1 NOTFOUND 2 OTHERERROR
			//#CT000005
			/*BigDecimal relamt=$\\trnmod\\trn\\relamt.getValue();
			  log.trace(transname+" relamt="+relamt);
			  String[] qtyp = new String[]{"pty","ety","etg"};
			  //String ptyinr=$\\sysmod\\pty\\inr.getValue();
			  String ptyinr=$\\sysmod\\pty\\inr.getValue();
			  String etyinr= $\\sysmod\\ety\\inr.getValue();
			  String etginr=$\\sysmod\\ety\\inr.getValue();
			  String[] qinr = new String[]{ptyinr,etyinr,etginr};
			  String sql = null;
			  Argument<String> inr=new Argument<String>("inr");
			  Argument<String> flg=new Argument<String>("flg");
			  for(int i=0;i<qtyp.length;i++)
			  {
			  // 从pty到etg按金额查询交易所需授权 级别
			  sql="SELECT inr,flg FROM ptyaut WHERE objtyp='"+qtyp[i]+"' AND objinr='"+qinr[i];
			  sql=sql+"' AND frm='"+transname+"' ";
			  // 所需授权级别大于0时查询金额对应的授权级别  =0时不用查询金额
			  //sql=sql+" AND (lvl>'0' AND lowamt<="+relamt+" AND uppamt>"+relamt+" OR lvl='0')";
			  log.debug("load ptyaut sql="+sql);
			  Platform.mdbExecuteSQL(sql);
			  Platform.mdbFetchFields(inr,flg);
			  if(Platform.errorCode()==NO_ERROR)
			  {
			  //Platform.mdbRead($\\trnmod\\ptyaut,new Argument<String>("inr",inr.value));
			  log.debug(qtyp[i]+"|"+qinr[i]+"|ptyaut="+inr.value+"|flg="+flg.value);
			  Platform.mdbCloseCursor();
			  break;
			  }
			  }
			  Platform.mdbCloseCursor();
			  if(Platform.isEmpty(flg.value))
			  {
			  flg.value = "O";
			  }
			  $ptyaut\\inr.setValue(inr.value);
			  $ptyaut\\flg.setValue(flg.value);
			  return flg.value;*/
		}
        /**
        *   source:trnmod.@0007.script
        */
        public void sigWrite(String sig,String sta,String lvl)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*$usrsig\\dattim.setValue(new Date());
			  $usrsig\\frm.setValue(Platform.getTransName());
			  $usrsig\\sig.setValue(sig);
			  $usrsig\\sta.setValue(sta);
			  $usrsig\\ownref.setValue($trn\\ownref.getValue());
			  $usrsig\\trninr.setValue($trn\\inr.getValue());
			  $usrsig\\usrinr.setValue($\\sysmod\\usr\\inr.getValue());
			  if(Platform.isEmpty(lvl))
			  lvl="0";
			  $usrsig\\lvl.setValue(lvl);
			  Platform.sdbCounter($usrsig);
			  Platform.mdbInsert($usrsig);*/
		}
        /**
        *   source:trnmod.@0012.script
        */
        public void savTrnDsp(IPanel p,String inrnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// IPanel p 是要保存的页面panel inrnam是trn.inr
			/*String path = Platform.catPath(Platform.getRootPath(),"data");
			  path = Platform.catPath(path,"dsp");
			  log.debug("save dsp "+path);
			  if(!Platform.mfileExists(path))
			  {
			  log.debug("path not  exist");
			  return;
			  }
			  inrnam = inrnam + ".zul";
			  log.debug("save file "+inrnam);
			  path = Platform.catPath(path,inrnam);
			  Platform.saveDisplay(p,path);*/
		}
        /**
        *   source:trnmod.@0018.script
        */
        public void saveStaticTransaction(IModule grpModule)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*log.info("begin saveStaticTransaction");
			  //if(Platform.isEmpty(grpModule))
			  //  return;
			  // load 数据文件
			  String filename = $trn\\inr.getValue()+".dat";
			  String file = Platform.catPath(Platform.getRootPath(),"data/trndata/"+filename);
			  log.debug("load " + file);
			  if(!Platform.mfileExists(file))
			  {
			  log.error("数据文件不存在" + file);
			  return ;
			  }
			  IStream is = $datstm.getValue();
			  log.debug("Load stream...");
			  Platform.mstreamLoad(is,file);
			  log.debug("load Data...");
			  Platform.loadData(grpModule,is);
			  log.debug("step 1");
			  IModule rec = Platform.getModule(grpModule,"rec");
			  log.debug("rec is empty？ "+Platform.isEmpty(rec));
			  if(!Platform.isEmpty(rec))
			  {
			  log.debug("@@@@ rec 非空 @@@@");
			  IDatafield flg = Platform.getDatafield(grpModule,"recsavflg");
			  if(!Platform.isEmpty(flg))
			  {
			  log.debug("rec flg is " + flg);
			  if("save".equals(flg.getValue()))
			  {
			  log.debug("update static table");
			  //更新rec
			  Platform.mdbUpdate(rec);
			  }
			  else if("new".equals(flg.getValue()))
			  {
			  log.debug("insert static table");
			  //或新增rec
			  Platform.mdbInsert(rec);
			  }
			  else if("delete".equals(flg.getValue()))
			  {
			  log.debug("delete static table");
			  //或删除rec
			  Platform.mdbDelete(rec);
			  }
			  log.debug("db execute with errorcode:" + Platform.errorCode());
			  }
			  }
			  IModule rec1 = Platform.getModule(grpModule,"rec1");
			  log.debug("rec1 is empty？ "+Platform.isEmpty(rec));
			  if(!Platform.isEmpty(rec1))
			  {
			  log.debug("@@@@ rec1 非空 @@@@");
			  IDatafield flg1 = Platform.getDatafield(grpModule,"rec1savflg");
			  if(!Platform.isEmpty(flg1))
			  {
			  log.debug("rec1 flg is " + flg1);
			  if("save".equals(flg1.getValue()))
			  {
			  log.debug("update static table");
			  //更新rec
			  Platform.mdbUpdate(rec1);
			  }
			  else if("new".equals(flg1.getValue()))
			  {
			  log.debug("insert static table");
			  //或新增rec
			  Platform.mdbInsert(rec1);
			  }
			  else if("delete".equals(flg1.getValue()))
			  {
			  log.debug("delete static table");
			  //或删除rec
			  Platform.mdbDelete(rec1);
			  }
			  log.debug("db execute with errorcode:" + Platform.errorCode());
			  }
			  }
			  IModuleList oldlst = (IModuleList)Platform.getBaseObject(grpModule,"oldlst");
			  log.debug("oldlst is empty？ "+Platform.isEmpty(oldlst));
			  IModuleList newlst = (IModuleList)Platform.getBaseObject(grpModule,"newlst");
			  log.debug("newlst is empty？ "+Platform.isEmpty(newlst));
			  // 循环删除并更新列表
			  if(!Platform.isEmpty(oldlst))
			  {
			  log.debug("oldlst size="+oldlst.fullSize());
			  for(int i=0;i<oldlst.fullSize();i++)
			  {
			  IModule o = (IModule)oldlst.get(i);
			  log.debug("@@@@ 1 Module: " + o + "@@@@");
			  IDatafield oinr = Platform.getDatafield(o,"inr");
			  log.debug("@@@@ 2 oinr: "+oinr+" @@@@");
			  if(oinr==null || oinr.getValue()==null)
			  continue;
			  String soinr = oinr.getValue().toString();
			  log.debug("old "+i+" inr="+soinr);
			  Platform.mdbRead(o,new Argument<String>("inr",soinr));
			  Platform.mdbDelete(o);
			  }
			  }
			  if(!Platform.isEmpty(newlst))
			  {
			  log.debug("newlst size="+newlst.fullSize());
			  for(int i=0;i<newlst.fullSize();i++)
			  {
			  IModule n = (IModule)newlst.get(i);
			  IDatafield ninr = Platform.getDatafield(n,"inr");
			  if(ninr==null || ninr.getValue()==null)
			  continue;
			  log.debug("new "+i+" inr="+ninr.getValue());
			  Platform.mdbInsert(n);
			  }
			  }
			  //oldlst1和newlst1处理逻辑
			  IModuleList oldlst1 = (IModuleList)Platform.getBaseObject(grpModule,"oldlst1");
			  log.debug("oldlst1 is empty？ "+Platform.isEmpty(oldlst1));
			  IModuleList newlst1 = (IModuleList)Platform.getBaseObject(grpModule,"newlst1");
			  log.debug("newlst1 is empty？ "+Platform.isEmpty(newlst1));
			  // 循环删除并更新列表
			  if(!Platform.isEmpty(oldlst1))
			  {
			  log.debug("oldlst1 size="+oldlst1.fullSize());
			  for(int i=0;i<oldlst1.fullSize();i++)
			  {
			  IModule o = (IModule)oldlst1.get(i);
			  log.debug("@@@@ 1 Module: " + o + "@@@@");
			  IDatafield oinr = Platform.getDatafield(o,"inr");
			  log.debug("@@@@ 2 oinr: "+oinr+" @@@@");
			  if(oinr==null || oinr.getValue()==null)
			  continue;
			  String soinr = oinr.getValue().toString();
			  log.debug("old1 "+i+" inr="+soinr);
			  Platform.mdbRead(o,new Argument<String>("inr",soinr));
			  Platform.mdbDelete(o);
			  }
			  }
			  if(!Platform.isEmpty(newlst1))
			  {
			  log.debug("newlst1 size="+newlst1.fullSize());
			  for(int i=0;i<newlst1.fullSize();i++)
			  {
			  IModule n = (IModule)newlst1.get(i);
			  IDatafield ninr = Platform.getDatafield(n,"inr");
			  if(ninr==null || ninr.getValue()==null)
			  continue;
			  log.debug("new1 "+i+" inr="+ninr.getValue());
			  Platform.mdbInsert(n);
			  }
			  }*/
		}
        /**
        *   source:trnmod.@0021.script
        */
        public void trnSetFromStaticContract(String title,String oprType,String oprName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//静态数据交易设置TRN数据函数
			// 如果是退回的交易先读原trn
			/*if(isSptSta("B"))
			  {
			  log.debug("load back trn"+$spt\\scrtxt);
			  Platform.mdbRead($trn,new Argument<String>("inr",$spt\\scrtxt.getValue()));
			  }
			  // set trn
			  $trn\\objtyp = Platform.getModuleType(Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec"));
			  $trn\\objinr = $objinr;
			  $trn\\nam = title + "/" + oprType;
			  $trn\\objnam = title + "/" + oprType + " " + oprName;
			  $trn\\inidattim = Platform.today();
			  $trn\\inifrm = Platform.sgetTransName();
			  $trn\\iniusr = $\\sysmod\\usr\\inr;
			  $trn\\sta = "W";
			  $trn\\optptyinr = $\\sysmod\\pty\\inr;
			  $trn\\ptyinr = $\\sysmod\\pty\\inr;
			  $trn\\etyinr = $\\sysmod\\ety\\inr;
			  $trn\\etginr = $\\sysmod\\etg\\inr;
			  $trn\\usrnam = $\\sysmod\\usr\\nam + "(" + $\\sysmod\\usr\\dspnam + ")";
			  $trn\\trntyp = "A";
			  // 除暂存状态外trn都生成新的
			  String inr = Platform.sdbCounter("trn");
			  log.debug("new trninr="+inr);
			  $trn\\inr = inr;
			  return true;*/
		}
        /**
        *   source:trnmod.@0024.script
        */
        public boolean trnSetFromContract(String title,String oprType,String oprName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			int errorcode = ctx.getErrorCode();
			if(!MdaUtils.isEmpty(this.getFrm().getInr()))
			{
			  //20180608注释
			  //设置公共部分TRN的数据
			
			  /*$trn\\ownref = oprName;
			    $trn\\bchinr = $\\sysmod\\ownbch\\inr; //经办机构主键
			    $trn\\bchkeyinr = $\\sysmod\\ownbch\\inr; //业务所属机构主键
			    $trn\\ptyinr = $\\sysmod\\pty\\inr;
			    $trn\\etyinr = $\\sysmod\\ety\\inr;
			    $trn\\etginr = $\\sysmod\\etg\\inr;
			    $trn\\inidattim = Platform.today();  //交易创建时间
			    $trn\\inifrm = frameName;  //交易名称
			    $trn\\iniusr = $\\sysmod\\usr\\nam;  //创建用户
			    $trn\\nam = title +"/" + oprType;  //交易名称
			    $trn\\objnam = title + "/" + oprType + " " + oprName;*/
			  String frameName = Platform.sgetTransName();  //
			  this.getTrn().setSta( "R");   //业务状态
			  this.getTrn().setFrmsubtyp( this.getFrm().getSubtyp());
			  this.getTrn().setInifrm( frameName);  //交易名称
			  //授权相关代码，20161024屏蔽
			  /*String sigreq = getTransactionSignRequest($trn\\inifrm.getValue(),$trn\\bchinr.getValue());
			    log.debug("sigreq:"+sigreq);
			    if(!Platform.isEmpty(sigreq))
			    {
			    $trn\\sta = "W";
			    $trn\\sigreq = sigreq; //需要授权的标识码，目标状态
			    }*/
			  //20180608注释
			  /*log.debug("sta:"+$trn\\sta.getValue());
			    if("R".equals($trn\\sta.getValue()))
			    $trn\\cpldattim = Platform.today();  //交易完成时间
			    IModule recModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec"); //获取路径为$\\mtabut\\mtagrp\\rec的模块
			    if(recModule == null)
			    recModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\mpi");
			    if("smtexe".equals(frameName))
			    $trn\\objtyp = "sme";
			    else
			    {
			    String type = Platform.getModuleType(recModule);  //获取模块recModule的类名
			    $trn\\objtyp = type; //对象类型
			    }
			    $trn\\objinr = $objinr;  //对象编号
			    if(!Platform.isEmpty($frm\\subtyp))
			
			    log.debug("@@objinr@@"+$objinr.getValue());*/
			  //静态数据类交易
			  if("A".equals(this.getFrm().getFrmtyp()))
			  {
			    if(!trnSetFromStatic())
			    {
			      ctx.setMessage(MdaUtils.getI18NString("trnmod","CT000030"),MdaUtils.getI18NString("trnmod","CT000031"));
			      return Platform.falseAndRollback();
			    }
			  }
			  //业务类交易
			  if("B".equals(this.getFrm().getFrmtyp()))
			  {
			    if(MdaUtils.isEmpty(this.getFrm().getSubtyp()) || !"BS".equals(this.getFrm().getSubtyp()))
			    {
			      if(!trnSetFromBusiness())
			      {
			        ctx.setMessage(MdaUtils.getI18NString("trnmod","CT000032"),MdaUtils.getI18NString("trnmod","CT000033"));
			        return Platform.falseAndRollback();
			      }
			    }
			    else
			      this.getTrn().setTrntyp( "B");
			  }
			  //报文类交易
			  if("M".equals(this.getFrm().getFrmtyp()))
			  {
			    if(!trnSetFromMessage())
			    {
			      ctx.setMessage(MdaUtils.getI18NString("trnmod","CT000034"),MdaUtils.getI18NString("trnmod","CT000035"));
			      return Platform.falseAndRollback();
			    }
			  }
			  if(frameName.startsWith("db"))
			    this.getTrn().setOprtyp( frameName.substring(2,3).toUpperCase());  //操作类型
			  else
			    this.getTrn().setOprtyp( "A");
			  /* log.debug("trninr:"+$trn\\inr.getValue());
			    Platform.mdbInsert($trn);
			    errorcode = Platform.errorCode();
			    if(errorcode == NO_ERROR)
			    flg = writeSignatureHistory($trn\\iniusr.getValue(),$\\sysmod\\usr\\dspnam.getValue(),"Z","Z",$trn\\inr.getValue());
			    else
			    {
			    //Platform.mdbRollback();
			    flg = false;
			    }*/
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("trnmod","CT000036"),MdaUtils.getI18NString("trnmod","CT000037"));
			  return false;
			}
			return true;
		}
        /**
        *   source:trnmod.@0025.script
        */
        public String getTransactionSignRequest(String frameCode,String branchInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 根据当前的交易名称和机构主键，获取当前交易的签字规则
			  - frameCode 交易代码
			  - branchInr 机构主键
			  @ String 签字规则
			  */
			String sigreq = null;
			int errorcode = ctx.getErrorCode();
			Argument<String> frmInr = new Argument<String>("inr");
			Platform.mdbExecuteSQL("SELECT INR FROM FRM WHERE FRM = ? ",frameCode);
			log.debug("{}","frame code:"+frameCode);
			Platform.mdbFetchFields(frmInr);
			errorcode = ctx.getErrorCode();
			Platform.mdbCloseCursor();
			log.debug("{}","Read table frm where field frm:" + frameCode + " with errorcode:" + errorcode);
			if(!MdaUtils.isEmpty(frmInr.value))
			{
			  Argument<String> sig = new Argument<String>("sigreq");
			  Platform.mdbExecuteSQL("SELECT SIGREQ FROM FRS WHERE FRMINR = ? and bchinr = ? ",frmInr.value,branchInr);
			  Platform.mdbFetchFields(sig);
			  errorcode = ctx.getErrorCode();
			  log.debug("{}","Read table frs where field frminr:" + frmInr.value + " and bchinr:" + branchInr + " with errorcode:" +errorcode);
			  if(MdaUtils.isEmpty(sig.value))
			    sigreq = "";
			  else
			  {
			    sigreq = sig.value;
			    //经办权限不用放到复核里面
			    if(sigreq.startsWith("Z"))
			      sigreq = sigreq.substring(1);
			  }
			}
			Platform.mdbCloseCursor();
			log.debug("{}","getTransactionSignRequest:" + sigreq);
			return sigreq;

		}
        /**
        *   source:trnmod.@0026.script
        */
        public boolean trnSetFromStatic()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IModule recModule = MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp\\rec");
			this.getTrn().setTrntyp( "S");  //业务种类类型  S-静态(参数)数据类型
			return true;
		}
        /**
        *   source:trnmod.@0027.script
        */
        public boolean trnSetFromBusiness()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//20180608注释
			/*IModule recModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\rec");
			  if(recModule == null)
			  recModule = Platform.getModule($\\,"mtabut\\\\mtagrp\\\\mpi");
			  String modType = Platform.getModuleType(recModule);
			  IDatafield<String> cur = Platform.getDatafield(recModule,"cur");
			  if(Platform.isEmpty(cur))
			  {
			  cur = Platform.getDatafield(recModule,"offcur");
			  if(!Platform.isEmpty(cur))
			  $trn\\reloricur = cur.getValue();
			  else
			  $trn\\reloricur = null;
			  }
			  else
			  $trn\\reloricur = cur.getValue();
			  IDatafield<BigDecimal> amount = Platform.getDatafield(recModule,"amt");
			  if(Platform.isEmpty(amount))
			  {
			  log.debug("amt is empty...");
			  amount = Platform.getDatafield(recModule,"bln");
			  if(Platform.isEmpty(amount))
			  {
			  log.debug("bln is empty...");
			  amount = Platform.getDatafield(recModule,"offamt");
			  if(Platform.isEmpty(amount))
			  {
			  log.debug("offamt is empty...");
			  amount = Platform.getDatafield(recModule,"endamt");
			  if(!Platform.isEmpty(amount))
			  $trn\\reloriamt = amount.getValue();
			  else
			  $trn\\reloriamt = 0.0;
			  }
			  else
			  $trn\\reloriamt = amount.getValue();
			  }
			  else
			  $trn\\reloriamt = amount.getValue();
			  }
			  else
			  $trn\\reloriamt = amount.getValue();*/
			/*if(modType.startsWith("qrd"))
			  {
			  IDatafield<String> ownref = Platform.getDatafield(recModule,"relrfn");
			  if(Platform.isEmpty(ownref))
			  $trn\\ownref = null;
			  else
			  $trn\\ownref = ownref.getValue();
			  }*/
			/*IDatafield<String> ownref = Platform.getDatafield(recModule,"ref");
			  if(!Platform.isEmpty(ownref))
			  $trn\\ownref = ownref.getValue();  //参考号
			  IDatafield<String> cur = Platform.getDatafield(recModule,"cur");
			  //if(Platform.isEmpty(cur))
			  //{
			  //cur = Platform.getDatafield(recModule,"payercny");
			  if(!Platform.isEmpty(cur))
			  $trn\\reloricur = cur.getValue();  //交易原始币种
			  //}
			  //else
			  //$trn\\reloricur = cur.getValue();
			  IDatafield<BigDecimal> amount = Platform.getDatafield(recModule,"amt");
			  if(!Platform.isEmpty(amount))
			  $trn\\reloriamt = amount.getValue(); */
			//交易原始金额
			this.getTrn().setTrntyp( "B");  //业务种类类型  B-业务数据类型
			return true;
		}
        /**
        *   source:trnmod.@0028.script
        */
        public boolean trnSetFromMessage()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IModule recModule = MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp\\mpi");
			this.getTrn().setTrntyp( "M");  //业务种类类型  M-报文数据类型
			return true;
		}
        /**
        *   source:trnmod.@0029.script
        */
        public boolean writeSignatureHistory(String userKey,String userName,String rellev,String type,String trnInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 签字记录历史
			  - userKey 创建交易的用户
			  - userName 操作员名称
			  - rellev 角色复核授权级别
			  - type 签字类型
			  - trnInr trn表对应记录的inr
			  @ 生成该笔交易的历史签字记录
			  */
			MdaUtils.clear(this.getUsrsig()); //usrsig-(系统表)操作员签字记录表
			int errorcode = ctx.getErrorCode();
			this.getUsrsig().setNam( userKey.trim());  //登录名称
			this.getUsrsig().setUsrnam( userName.trim() + "(" + userKey.trim() + ")");  //交易用户名称
			this.getUsrsig().setRellev( rellev);  //角色复核授权级别
			this.getUsrsig().setTyp( type);   //签字类型
			this.getUsrsig().setDattim( MdaUtils.today());  //签字时间
			this.getUsrsig().setTrninr( trnInr);  //交易流水号
			Platform.sdbInsert(this.getUsrsig());
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:trnmod.@0030.script
        */
        public void savePanelDisplay(IPanel p,String trnInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 保存业务截图
			  - p 要保存的PANEL界面
			  - trnInr TRN表的INR主键
			  @ 无
			  */
			/*String path = Platform.catPath(Platform.getRootPath(),"data");
			  path = Platform.catPath(path,"display");
			  if(!Platform.mfileExists(path))
			  {
			  if(!Platform.mfileMkdirs(path))
			  log.error("创建display路径：" + path + "失败");
			  else
			  log.error("创建display路径：" + path + "成功");
			  }
			  path = Platform.catPath(path,trnInr + ".zul");
			  log.debug("保存display文件："+path);
			  Platform.saveDisplay(p,path);*/
		}
        /**
        *   source:trnmod.@0038.script
        */
        public boolean storeStaticDataInTransaction()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//如果是静态数据交易，且无需复核
			log.info("{}","trn_sta====="+this.getTrn().getSta()+"trn_trntyp====="+this.getTrn().getTrntyp());
			if("R".equals(this.getTrn().getSta()) && "S".equals(this.getTrn().getTrntyp()))
			{
			  String methodName = "";
			  if("A".equals(this.getTrn().getOprtyp()))
			    methodName = "insert";
			  if("E".equals(this.getTrn().getOprtyp()))
			    methodName = "update";
			  if("D".equals(this.getTrn().getOprtyp()))
			    methodName = "delete";
			  if("R".equals(this.getTrn().getOprtyp()))
			    methodName = "reset";
			  if(MdaUtils.isEmpty(methodName))
			    return false;
			  else
			  {
			    log.debug("{}","storeStaticDataInTransaction Invoke xxxgrp...");
			    log.debug("{}","mtabut mtagrp:"+MdaDriver.getModuleType(this.getMtabut().getMtagrp()));
			    Boolean success = true;
			    if("AP".equals(this.getTrn().getFrmsubtyp()))
			    {
			      log.debug("{}","method1 name:"+methodName);
			      success = (Boolean)MdaUtils.invoke(this.getMtabut().getMtagrp(),methodName,this.getTrn().getInifrm());
			    }
			    else
			    {
			      log.debug("{}","method name:"+methodName);
			      success = (Boolean)MdaUtils.invoke(this.getMtabut().getMtagrp(),methodName);
			    }
			    //Boolean success = (Boolean)Platform.invoke($mtabut\\mtagrp,methodName);
			    return success.booleanValue();
			  }
			}
			else
			  return true;
		}
        /**
        *   source:trnmod.@0039.script
        */
        public boolean storeTrnData(IModule recGrpModule)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			int errorcode = ctx.getErrorCode();
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			path = MdaUtils.catPath(path,"trndata");
			if(!Platform.mfileExists(path))
			{
			  if(!Platform.mfileMkdirs(path))
			  {
			    log.error("{}","创建trndata路径：" + path + "失败");
			    return false;
			  }
			  else
			    log.error("{}","创建trndata路径：" + path + "成功");
			}
			path = MdaUtils.catPath(path,this.getTrn().getInr() + ".dat");
			log.debug("{}","保存trndata文件：" + path);
			MdaUtils.clear(this.getTrndatstm());    //trndata stream
			IStream os = this.getTrndatstm();
			MdaUtils.clear(os);
			MdaUtils.saveData(recGrpModule,os);
			Platform.mstreamSave(os,path);
			errorcode = ctx.getErrorCode();
			log.debug("{}","errorcode trn = "+errorcode);
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:trnmod.@0040.script
        */
        public boolean storeBimData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			int errorcode = ctx.getErrorCode();
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			path = MdaUtils.catPath(path,"bimdata");
			if(!Platform.mfileExists(path))
			{
			  if(!Platform.mfileMkdirs(path))
			  {
			    log.error("{}","创建bimdata路径：" + path + "失败");
			    return false;
			  }
			  else
			    log.error("{}","创建bimdata路径：" + path + "成功");
			}
			path = MdaUtils.catPath(path,this.getTrn().getInr() + ".dat");
			log.debug("{}","保存bimdata文件：" + path);
			//BIMDATA在INIT中已经存入STREAM
			IStream os = this.getBimdatstm();
			Platform.mstreamSave(os,path);
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:trnmod.@0043.script
        */
        public boolean checkUsersRight(String sigreq,String rellev)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","sigreq:" + sigreq);
			log.debug("{}","rellev:" + rellev);
			if(MdaUtils.isEmpty(sigreq) || MdaUtils.isEmpty(rellev))
			  return false;
			else
			{
			  if(sigreq.startsWith(rellev))
			    return true;
			  else
			    return false;
			}
		}
        /**
        *   source:trnmod.@0044.script
        */
        public void getSignatureHistory(String trnInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getSiglst());
			Platform.mdbReadset(this.getSiglst(),0,new Argument("trninr",trnInr));
			
		}
        /**
        *   source:trnmod.@0045.script
        */
        public void getReleaseDetail(String trnInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getRmk());
			int errorcode = ctx.getErrorCode();
			Platform.mdbRead(this.getRmk(),new Argument("trninr",trnInr));
			errorcode = ctx.getErrorCode();
			log.debug("{}","load rmk with errorcode:" + errorcode);
		}
        /**
        *   source:trnmod.@0046.script
        */
        public boolean releaseHandle(String releaseStatus)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 复核授权处理函数
			  - releaseStatus 复核状态R - 复核，C - 退回，U - 撤销
			  @ 处理成功返回true,否则返回false
			  */
			this.setInfmsg(NULLSTR);
			//其中有加载TRN的操作，必须为第一个函数，后续处理请都在此函数之后调用
			if(!checkBeforeHandle(releaseStatus))
			  return false;
			//检测签字权限
			if(!checkSignatureHandle(releaseStatus))
			  return false;
			//检测前后手交易是否已处理
			//if(!checkBeforeAfterTransaction(releaseStatus))
			//  return false;
			//开始复核授权/退回修改/撤销
			if(!doRelease(releaseStatus))
			  return false;
			if("R".equals(releaseStatus))
			{
			  String s = "复核";
			  if("R".equals(this.getWrktrn().getSta()))
			    s = "授权";
			  this.setInfmsg("业务编号为" + this.getWrktrn().getOwnref() + "的业务已被成功" + s);
			}
			if("C".equals(releaseStatus))
			  this.setInfmsg("业务编号为" + this.getWrktrn().getOwnref() + "的业务已被成功退回");
			if("U".equals(releaseStatus))
			  this.setInfmsg("业务编号为" + this.getWrktrn().getOwnref() + "的业务已被成功撤销");
			return true;
		}
        /**
        *   source:trnmod.@0047.script
        */
        public boolean checkBeforeHandle(String releaseStatus)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getWrktrn().getInr()))
			  this.getWrktrn().copyValue(MdaDriver.getModule(this,this.getMtabut(),"mtagrp\\rec"));
			if(MdaUtils.isEmpty(this.getWrktrn().getInr()))
			{
			  this.setInfmsg("加载交易流水记录失败");
			  return false;
			}
			if("W".equals(this.getWrktrn().getSta()))
			{
			  if("U".equals(releaseStatus))
			  {
			    this.setInfmsg("待授权状态下，不允许做撤销操作，请尝试使用退回修改.");
			    return false;
			  }
			}
			if("C".equals(this.getWrktrn().getSta()))
			{
			  this.setInfmsg("该笔业务已被退回修改.");
			  return false;
			}
			if("U".equals(this.getWrktrn().getSta()))
			{
			  this.setInfmsg("该笔业务已被撤销.");
			  return false;
			}
			if("R".equals(this.getWrktrn().getSta()))
			{
			  if("R".equals(releaseStatus))
			  {
			    this.setInfmsg("该笔业务已授权，无需授权操作.");
			    return false;
			  }
			  if("U".equals(releaseStatus))
			  {
			    this.setInfmsg("该笔业务未完结，不允许做撤销操作，请尝试使用退回修改.");
			    return false;
			  }
			}
			if("F".equals(this.getWrktrn().getSta()))
			{
			  log.debug("{}","状态"+this.getWrktrn().getSta());
			  log.debug("{}","撤销"+releaseStatus);
			  if(!"U".equals(releaseStatus))
			  {
			    this.setInfmsg("该笔业务已完结，只允许进行撤销操作.");
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:trnmod.@0048.script
        */
        public boolean checkBeforeAfterTransaction(String releaseStatus)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检测前后手交易状态
			if("R".equals(releaseStatus))
			{
			  Argument<String> inr = new Argument<String>("inr");
			  Platform.mdbExecuteSQL("SELECT INR FROM TRN WHERE OBJTYP = ? AND OBJINR = ? AND INIDATTIM < ? AND STA = 'w'",this.getWrktrn().getObjtyp(),this.getWrktrn().getObjinr(),this.getWrktrn().getInidattim());
			  log.debug("{}","检测前后手交易：objtyp = " + this.getWrktrn().getObjtyp() + ",objinr = " + this.getWrktrn().getObjinr());
			  Platform.mdbFetchFields(inr);
			  Platform.mdbCloseCursor();
			  if(!MdaUtils.isEmpty(inr))
			  {
			    this.setInfmsg("当前交易存在前手交易待复核，请待前手交易处理完成后再处理当前交易.");
			    return false;
			  }
			}
			if("U".equals(releaseStatus) || "C".equals(releaseStatus))
			{
			  Argument<String> inr = new Argument<String>("inr");
			  Platform.mdbExecuteSQL("SELECT INR FROM TRN WHERE OBJTYP = ? AND OBJINR = ? AND INIDATTIM > ?",this.getWrktrn().getObjtyp(),this.getWrktrn().getObjinr(),this.getWrktrn().getInidattim());
			  Platform.mdbFetchFields(inr);
			  Platform.mdbCloseCursor();
			  if(!MdaUtils.isEmpty(inr))
			  {
			    this.setInfmsg("当前交易存在后手交易待处理，请先处理后手交易.");
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:trnmod.@0049.script
        */
        public boolean checkSignatureHandle(String releaseStatus)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//复核授权
			if("R".equals(releaseStatus))
			{
			  if(checkUsersRight(this.getWrktrn().getSigreq(),ctx.absGet(Sysmod.class).getRol().getRellev()))
			  {
			    if(this.getWrktrn().getIniusr().equals(ctx.absGet(Sysmod.class).getUsr().getNam()))
			    {
			      this.setInfmsg("您没有权限复核自己经办的交易.");
			      return false;
			    }
			  }
			  else
			  {
			    this.setInfmsg("您没有权限复核当前交易，请检查签字规则是否到达您的级次.");
			    return false;
			  }
			}
			//退回修改
			if("C".equals(releaseStatus))
			{
			  if(!checkUsersRight(this.getWrktrn().getSigreq(),ctx.absGet(Sysmod.class).getRol().getRellev()))
			  {
			    //经办可以退回自己的交易
			    if(!this.getWrktrn().getIniusr().equals(ctx.absGet(Sysmod.class).getUsr().getNam()))
			    {
			      this.setInfmsg("您没有权限退回当前交易，请检查签字规则是否到达您的级次.");
			      return false;
			    }
			  }
			}
			//撤销
			if("U".equals(releaseStatus))
			{
			  if(MdaUtils.isEmpty(this.getWrktrn().getSigres()))
			  {
			    //如果没有签字要求，则经办用户可以UNDO
			    if(!this.getWrktrn().getIniusr().equals(ctx.absGet(Sysmod.class).getUsr().getNam()))
			    {
			      this.setInfmsg("您没有权限撤销当前交易，当前交易需要经办用户撤销.");
			      return false;
			    }
			  }
			  else
			  {
			    //否则只有授权用户可以UNDO
			    String sigres = this.getWrktrn().getSigres().toString().trim();
			    if(!sigres.endsWith(ctx.absGet(Sysmod.class).getRol().getRellev()))
			    {
			      this.setInfmsg("您没有权限撤销当前交易，当前交易需要最终授权用户撤销.");
			      return false;
			    }
			  }
			}
			return true;
		}
        /**
        *   source:trnmod.@0050.script
        */
        public boolean doRelease(String releaseStatus)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//清除errorcode
			int errorcode = ctx.getErrorCode();
			Platform.mdbBegin();
			String sigreq = "";
			if(!MdaUtils.isEmpty(this.getWrktrn().getSigreq()))
			  sigreq = this.getWrktrn().getSigreq().toString().trim();
			String sigres = "";
			if(!MdaUtils.isEmpty(this.getWrktrn().getSigres()))
			  sigres = this.getWrktrn().getSigres().toString().trim();
			//复核授权
			if("R".equals(releaseStatus))
			{
			  log.debug("{}","release start...");
			  String sigtyp = "R";
			  if(!MdaUtils.isEmpty(sigreq))
			  {
			    String sig = sigreq.substring(0,1);
			    sigres +=sig;
			    sigreq = sigreq.substring(1);
			    this.getWrktrn().setSigreq( sigreq);
			    this.getWrktrn().setSigres( sigres);
			  }
			  if(MdaUtils.isEmpty(sigreq))
			  {
			    this.getWrktrn().setSta( "R");
			    this.getWrktrn().setCpldattim( MdaUtils.today());
			    sigtyp = "F";
			  }
			  if(!writeSignatureHistory(ctx.absGet(Sysmod.class).getUsr().getNam(),ctx.absGet(Sysmod.class).getUsr().getDspnam(),
			    ctx.absGet(Sysmod.class).getRol().getRellev(),sigtyp,this.getWrktrn().getInr()))
			  {
			    this.setInfmsg("更新审批记录表失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  Platform.mdbUpdate(this.getWrktrn());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    this.setInfmsg("更新记录流水表失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  //如果是数据交易，还要使用数据快照更新数据表
			  if("S".equals(this.getWrktrn().getTrntyp()))
			  {
			    log.debug("{}","update database...");
			    IModule recGrpModule = MdaDriver.getModule(this,this.getStagrp(),this.getWrktrn().getObjtyp()+ "grp");
			    log.debug("{}","objtyp:"+this.getWrktrn().getObjtyp());
			    if(recGrpModule == null)
			    {
			      this.setInfmsg("未找到数据模型，请联系系统管理员.");
			      log.debug("{}","infmsg:"+this.getInfmsg());
			      return Platform.falseAndRollback();
			    }
			    else
			    {
			      MdaUtils.clear(recGrpModule);
			      String methodName = "";
			      if("A".equals(this.getWrktrn().getOprtyp()))
			        methodName = "insert";
			      if("E".equals(this.getWrktrn().getOprtyp()))
			        methodName = "update";
			      if("D".equals(this.getWrktrn().getOprtyp()))
			        methodName = "delete";
			      if("R".equals(this.getWrktrn().getOprtyp()))
			        methodName = "reset";
			      if(MdaUtils.isEmpty(methodName))
			      {
			        this.setInfmsg("未找到操作类型，请联系系统管理员.");
			        log.debug("{}","infmsg:"+this.getInfmsg());
			        return Platform.falseAndRollback();
			      }
			      else
			      {
			        log.debug("{}","load DATA...");
			        String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/trndata/"+this.getWrktrn().getInr() + ".dat");
			        log.debug("{}","trndata path:"+path);
			        MdaUtils.clear(this.getTrndatstm());
			        IStream is = this.getTrndatstm();
			        Platform.mstreamLoad(is,path);
			        MdaUtils.loadData(recGrpModule,is);
			        Boolean success = false;
			        if("AP".equals(this.getWrktrn().getFrmsubtyp()))
			        {
			          success = (Boolean)MdaUtils.invoke(recGrpModule,methodName,this.getWrktrn().getInifrm());
			        }
			        else
			        {
			          log.debug("{}","method name:"+methodName);
			          success = (Boolean)MdaUtils.invoke(recGrpModule,methodName);
			        }
			        log.debug("{}","error:"+ctx.getErrorCode());
			        //log.debug("It's success?"+success.booleanValue());
			        if(!success.booleanValue())
			        {
			          log.debug("{}","update static data failed...");
			          this.setInfmsg("更新静态数据失败，请联系系统管理员.");
			          log.debug("{}","infmsg:"+this.getInfmsg());
			          return Platform.falseAndRollback();
			        }
			      }
			    }
			  }
			}
			//退回修改
			if("C".equals(releaseStatus))
			{
			  this.getWrktrn().setSta( "C");
			  this.getWrktrn().setCpldattim( MdaUtils.today());
			  if(!writeSignatureHistory(ctx.absGet(Sysmod.class).getUsr().getNam(),ctx.absGet(Sysmod.class).getUsr().getDspnam(),
			    ctx.absGet(Sysmod.class).getRol().getRellev(),"C",this.getWrktrn().getInr()))
			  {
			    this.setInfmsg("更新审批记录表失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  Platform.mdbUpdate(this.getWrktrn());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    this.setInfmsg("更新记录流水表失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  //还原业务表并保持暂存业务
			  IStream bimstm = this.getBimdatstm();
			  if(!loadBimData(bimstm,this.getWrktrn().getInr()))
			  {
			    this.setInfmsg("加载业务存盘前数据快照失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  IStream trnstm = this.getTrndatstm();
			  if(!loadTrnData(trnstm,this.getWrktrn().getInr()))
			  {
			    this.setInfmsg("加载业务存盘数据快照失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  //业务交易需要回滚数据表，数据交易部需要
			  if("B".equals(this.getWrktrn().getTrntyp()))
			  {
			    if(!rollbackBusinessTransaction(bimstm,this.getWrktrn().getObjtyp(),this.getWrktrn().getObjinr(),this.getWrktrn().getFrmsubtyp()))
			    {
			      this.setInfmsg("回滚业务数据表失败，请联系系统管理员.");
			      return Platform.falseAndRollback();
			    }
			  }
			  String sptInr = ctx.absGet(Sysmod.class).createSptEntry(this.getWrktrn(),"C","",this.getWrktrn().getInr());
			  if(MdaUtils.isEmpty(sptInr))
			  {
			    this.setInfmsg("更新待办任务表失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  if(!ctx.absGet(Sysmod.class).storeSptData(sptInr,trnstm))
			  {
			    this.setInfmsg("更新待办任务数据文件失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			}
			//撤销
			if("U".equals(releaseStatus))
			{
			  this.getWrktrn().setSta( "U");
			  this.getWrktrn().setCpldattim( MdaUtils.today());
			  if(!writeSignatureHistory(ctx.absGet(Sysmod.class).getUsr().getNam(),ctx.absGet(Sysmod.class).getUsr().getDspnam(),
			    ctx.absGet(Sysmod.class).getRol().getRellev(),"U",this.getWrktrn().getInr()))
			  {
			    this.setInfmsg("更新审批记录表失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  Platform.mdbUpdate(this.getWrktrn());
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    this.setInfmsg("更新记录流水表失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  //还原业务表并保存暂存业务
			  IStream bimstm = this.getBimdatstm();
			  if(! loadBimData(bimstm,this.getWrktrn().getInr()))
			  {
			    this.setInfmsg("加载业务存盘前数据快照失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  IStream trnstm = this.getTrndatstm();
			  if(!loadTrnData(trnstm,this.getWrktrn().getInr()))
			  {
			    this.setInfmsg("加载业务存盘数据快照失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  //业务交易需要回滚数据表，数据交易不需要
			  if("B".equals(this.getWrktrn().getTrntyp()))
			  {
			    if(!rollbackBusinessTransaction(bimstm,this.getWrktrn().getObjtyp(),this.getWrktrn().getObjinr(),this.getWrktrn().getFrmsubtyp()))
			    {
			      this.setInfmsg("回滚业务数据表失败，请联系系统管理员.");
			      return Platform.falseAndRollback();
			    }
			  }
			  String sptInr = ctx.absGet(Sysmod.class).createSptEntry(this.getWrktrn(),"C","",this.getWrktrn().getInr());
			  if(MdaUtils.isEmpty(sptInr))
			  {
			    this.setInfmsg("更新待办任务表失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			  if(!ctx.absGet(Sysmod.class).storeSptData(sptInr,trnstm))
			  {
			    this.setInfmsg("更新待办任务数据文件失败，请联系系统管理员.");
			    return Platform.falseAndRollback();
			  }
			}
			Platform.mdbCommit();
			errorcode = ctx.getErrorCode();
			log.info("{}","db commit with errorcode:" + errorcode);
			if(errorcode != NO_ERROR)
			{
			  Platform.mdbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("trnmod","CT000050"),MdaUtils.getI18NString("trnmod","CT000051"));
			  return false;
			}
			return true;
		}
        /**
        *   source:trnmod.@0051.script
        */
        public boolean loadBimData(IStream os,String trnInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(trnInr))
			  return false;
			MdaUtils.clear(os);
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			path = MdaUtils.catPath(path,"bimdata");
			path = MdaUtils.catPath(path,trnInr + ".dat");
			if(!Platform.mfileExists(path))
			{
			  log.debug("{}","加载BIMDATA:" + path);
			  return false;
			}
			log.debug("{}","加载BIMDATA："+path);
			int errorcode = ctx.getErrorCode();
			Platform.mstreamLoad(os,path);
			errorcode = ctx.getErrorCode();
			log.debug("{}","error code:"+errorcode);
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:trnmod.@0052.script
        */
        public boolean loadTrnData(IStream os,String trnInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(trnInr))
			  return false;
			MdaUtils.clear(os);
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			path = MdaUtils.catPath(path,"trndata");
			path = MdaUtils.catPath(path,trnInr + ".dat");
			if(!Platform.mfileExists(path))
			  return false;
			log.debug("{}","加载TRNDATA："+path);
			int errorcode = ctx.getErrorCode();
			Platform.mstreamLoad(os,path);
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:trnmod.@0053.script
        */
        public boolean rollbackBusinessTransaction(IStream bimstm,String objtyp,String objInr,String frmsubtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(objtyp))
			  return false;
			int errorcode = ctx.getErrorCode();
			if("off".equals(objtyp))
			  objtyp = "oft";
			IModule recGrpModule = MdaDriver.getModule(this,this.getCongrp(),objtyp.trim() + "grp");
			if(recGrpModule == null)
			  return false;
			MdaUtils.loadData(recGrpModule,bimstm);
			IModule recModule = null;
			if("sme".equals(objtyp))
			  recModule = MdaDriver.getModule(this,recGrpModule,"mpi");
			else
			  recModule = MdaDriver.getModule(this,recGrpModule,"rec");
			String modTyp = MdaDriver.getModuleType(recModule);
			log.debug("{}","module type:"+modTyp);
			if(recModule == null)
			  return false;
			IDatafield inrField = MdaDriver.getDatafield(recModule,"inr");
			log.debug("{}","module inr:"+inrField.getValue());
			if(MdaUtils.isEmpty(inrField))
			{
			  //新增的数据,在回滚时应该删除该表数据,其实也可以通过TRN的TYP去判断
			  //空的话,就要通过OBJINR去加载所有表的数据
			  Boolean success = (Boolean)MdaUtils.invoke(recGrpModule,"loadData",objInr);
			  if(!success.booleanValue())
			    return false;
			  else
			  {
			    //加载完成后，删除所有表数据
			    /*Boolean succ = (Boolean)Platform.invoke(recGrpModule,"deleteData");
			      if(!succ.booleanValue())
			      return false;*/
			    errorcode = ctx.getErrorCode();
			    IBaseObject[] im = recGrpModule.getModules().toArray(new IBaseObject[0]);
			    for(IBaseObject ibo:im)
			    {
			      if(ibo instanceof IModuleList)
			        continue;
			      IModule subModule = (IModule)ibo;
			      IDatafield inr = MdaDriver.getDatafield(subModule,"inr");
			      if(!MdaUtils.isEmpty(inr))
			      {
			        log.debug("{}","回滚删除业务表");
			        Platform.mdbDelete(subModule);
			        errorcode = ctx.getErrorCode();
			        if(errorcode != NO_ERROR)
			          return false;
			      }
			    }
			  }
			}
			else
			{
			  //不是新增的数据
			  errorcode = ctx.getErrorCode();
			  IBaseObject[] im = recGrpModule.getModules().toArray(new IBaseObject[0]);
			  for(IBaseObject ibo:im)
			  {
			    if(ibo instanceof IModuleList)
			      continue;
			    IModule subModule = (IModule)ibo;
			    IDatafield inr = MdaDriver.getDatafield(subModule,"inr");
			    if(!MdaUtils.isEmpty(inr))
			    {
			      //这里不能sdbUpdate,会额外增加VER的值
			      if("D".equals(this.getWrktrn().getTrntyp()))
			      {
			        log.debug("{}","回滚插入业务表");
			        Platform.mdbInsert(subModule);
			      }
			      else
			      {
			        log.debug("{}","回滚更新业务表");
			        Platform.mdbUpdate(subModule);
			      }
			      errorcode = ctx.getErrorCode();
			      if(errorcode != NO_ERROR)
			        return false;
			      /*String subModuleTyp = Platform.getModuleType(subModule);
			        if("submskrecoffmodsvr".contains(subModuleTyp.substring(3)))
			        {
			        IBaseObject[] subIm = subModule.getModules().toArray(new IBaseObject[0]);
			        for(IBaseObject subIbo:subIm)
			        {
			        if(subIbo instanceof IModuleList)
			        continue;
			        IModule minModule = (IModule)subIbo;
			        String minModuleTyp = Platform.getModuleType(minModule);
			        if(minModuleTyp.endsWith("sub"))
			        {
			        IBaseObject[] subMin = minModule.getModules().toArray(new IBaseObject[0]);
			        for(IBaseObject minIbo:subMin)
			        {
			        if(minIbo instanceof IModuleList)
			        continue;
			        IModule subMinModule = (IModule)minIbo;
			        if(!subNotEmptyRollback(subMinModule))
			        return false;
			        }
			        }
			        else
			        {
			        if(!subNotEmptyRollback(minModule))
			        return false;
			        }
			        }
			        }
			        else
			        {
			        if(!subNotEmptyRollback(subModule))
			        return false;
			        }*/
			    }
			  }
			}
			return true;
		}
        /**
        *   source:trnmod.@0057.script
        */
        public boolean subNotEmptyRollback(IModule recModule)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String typ = MdaDriver.getModuleType(recModule);
			IDatafield inr = null;
			if("chn".equals(typ))
			  inr = MdaDriver.getDatafield(recModule,"cod");
			else
			  inr = MdaDriver.getDatafield(recModule,"inr");
			if(!MdaUtils.isEmpty(inr))
			{
			  //这里不能sdbUpdate,会额外增加VER的值
			  if("D".equals(this.getWrktrn().getOprtyp()))
			  {
			    log.debug("{}","回滚插入业务表");
			    Platform.mdbInsert(recModule);
			  }
			  else
			  {
			    log.debug("{}","回滚更新业务表");
			    Platform.mdbUpdate(recModule);
			  }
			  int errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			    return false;
			}
			return true;
		}






        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }
















        public void setObjinrHolder(FieldHolder<String> objinr)
        {
           this.objinr = (objinr);
        }

        public void setObjinr(String objinr)
        {
            this.objinr.setValue(objinr);
        }

        public String getObjinr()
        {
            return this.objinr.getValue();
        }



















}