package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Url;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Urlgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Urlgrp.class);

        //recsavflg
        private String recsavflg;



	    @BDGetter
		private Url rec;

	    @BDGetter
		private Usr usr;

	    @BDGetter
		private Rol rol;

		@BDGetter
		private ModuleList<Url> oldlst;

		@BDGetter
		private ModuleList<Url> newlst;

		@BDGetter
		private ModuleList<Rol> rollst1;

		@BDGetter
		private ModuleList<Rol> rollst2;

		@BDGetter
		private ModuleList<Url> urllst;

		@BDGetter
		private ModuleList<Url> urllst1;

		@BDGetter
		private ModuleList<Url> urllst2;


		public Urlgrp()
        {
            super();
            setArgument();
        }

        public Urlgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:urlgrp.@0000.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			log.debug("{}","submit 500");
			//java.lang.String roles=$usr\\troleset.getValue();
			ctx.getErrorCode();
			String operationRecord="用户:"+this.getUsr().getDspnam()+" ";
			String objinr=this.getUsr().getInr();
			boolean flag=false;
			for(com.ceb.gjjs.mda.bo.Url  url1 : this.getUrllst1())
			{
			  log.debug("{}","urllst1 size:"+this.getUrllst1().fullSize());
			  if(!MdaUtils.isEmpty(url1.getInr()))
			  {
			    log.debug("{}","未分配rol name:"+url1.getRolnam());
			    MdaUtils.clear(this.getRec());
			    Platform.sdbRead(this.getRec(),url1.getInr());
			    Platform.mdbDelete(this.getRec());
			    //记录操作
			    operationRecord=" "+operationRecord+"删除角色:"+url1.getRolnam();

			    flag=true;
			    if(ctx.getErrorCode()!=NO_ERROR)
			      return false;
			  }
			}
			if(flag)
			{
			  //$\\mtabut\\htymod.insertHistoryWithoutDbOp(operationRecord,"eibs","url","删除",objinr);
			}
			operationRecord="用户:"+this.getUsr().getDspnam()+" ";
			for(com.ceb.gjjs.mda.bo.Url url2 : this.getUrllst2())
			{
			  log.debug("{}","urllst2 size:"+this.getUrllst2().fullSize());
			  if(MdaUtils.isEmpty(url2.getInr()))
			  {
			    log.debug("{}","已分配rol name:"+url2.getRolnam());
			    this.getRec().setInr( Platform.sdbCounter("url"));
			    //Platform.mdbRead($usr,new Argument("nam",.getValue()))
			    this.getRec().setUsrinr( this.getUsr().getInr());
			    this.getRec().setRolinr( url2.getRolinr());
			    this.getRec().setRolnam( url2.getRolnam());
			    Platform.mdbInsert(this.getRec());
			    //记录操作
			    operationRecord=" "+operationRecord+"新增角色:"+url2.getRolnam();
			    flag=false;
			    log.debug("{}","usr inr:"+this.getUsr().getInr());
			    if(ctx.getErrorCode()!=NO_ERROR)
			      return false;
			  }
			}
			if(!flag)
			{
			  // $\\mtabut\\htymod.insertHistoryWithoutDbOp(operationRecord,"eibs","url","新增",objinr);
			}

			return true;

		}
        /**
        *   source:urlgrp.@0001.script
        */
        public String getRoles()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			java.lang.StringBuilder sb=new java.lang.StringBuilder();
			String sql="select rolinr from url where usrinr = ? ";
			Argument<String> rolinr=new Argument<String>("rolinr");
			log.info("{}","Execute SQL "+sql);
			ctx.getDaoSession().dbExecuteSQL(sql,this.getUsr().getInr());
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(rolinr);
			  log.info("{}","Fetching "+rolinr.getValue());
			  int error=ctx.getErrorCode();
			  log.info("{}","Fetch complete "+error);

			  if(error==NO_ERROR)
			  {
			    sb.append(rolinr.getValue());
			    sb.append("|");
			  }
			  else
			  {
			    break;
			  }
			}
			log.info("{}","closing cursor for usr");
			ctx.getDaoSession().dbCloseCursor();
			return sb.toString();
		}













}