package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Usdgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Usdgrp.class);

        //rec操作标志
        private String recsavflg;



	    @BDGetter
		private Usr rec;

	    @BDGetter
		private Rol rol;

	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Pty ptyext;

	    @BDGetter
		private Usr usr;


		public Usdgrp()
        {
            super();
            setArgument();
        }

        public Usdgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:usdgrp.@0001.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			/* if(!Platform.checkAll($rec))
			  {
			  return false;
			  }
			  if(Platform.isEmpty($rec\\usridn))
			  {
			  Platform.error($rec\\usridn,#CT000216);
			  return false;
			  }
			  if(Platform.isEmpty($rec\\nam))
			  {
			  Platform.error($rec\\nam,#CT000217);
			  return false;
			  }
			  else
			  {
			  String lgnnam = $rec\\nam.getValue();
			  if(isUserExist(lgnnam))
			  {
			  Platform.error($rec\\nam,#CT000218);
			  return false;
			  }
			  }
			  if(Platform.isEmpty($rec\\dspnam))
			  {
			  Platform.error($rec\\dspnam,#CT000219);
			  return false;
			  }*/
			if(!MdaUtils.isEmpty(this.getRec().getPtyinr()))
			{
			  String ptyinr = this.getRec().getPtyinr();
			  String nam = getPtynam(ptyinr);
			  if(!MdaUtils.isEmpty(nam))
			  {
			    this.getRec().setPtynam(nam);
			  }
			}
			else
			{
			  ctx.setFieldError(this,"rec.ptyinr",MdaUtils.getI18NString("usdgrp","CT000220"));
			  return false;
			}
			String pas = MdaUtils.encryptPassword("1");
			this.getRec().setPwd(pas);
			this.getRec().setSta("0");
			String inr = Platform.sdbCounter("usr");
			log.debug("{}","usr inr: "+inr);
			this.getRec().setInr(inr);
			//$usdgrp\\rec\\dn.setValue(dn);
			
			// Platform.mdbBegin();
			
			Platform.mdbInsert(this.getRec());
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  //Platform.mdbCommit();
			  // Platform.message(#CT000221,"用户注册成功");
			  //Platform.clear($rec);
			  //Platform.returnToCaller();
			  return true;
			}
			else
			{
			  // Platform.mdbRollback();
			  return false;
			}

		}
        /**
        *   source:usdgrp.@0002.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			/*if(!Platform.checkAll($rec))
			  {
			  return false;
			  }
			  if(Platform.isEmpty($rec\\dspnam))
			  {
			  Platform.error($rec\\dspnam,#CT000024);
			  return false;
			  }*/
			if(!MdaUtils.isEmpty(this.getRec().getPtyinr()))
			{
			  String nam = getPtynam(this.getRec().getPtyinr());
			  if(!MdaUtils.isEmpty(nam))
			  {
			    this.getRec().setPtynam(nam);
			  }
			}
			else
			{
			  ctx.setFieldError(this,"rec.ptyinr",MdaUtils.getI18NString("usdgrp","CT000025"));
			  return false;
			}
			//Platform.mdbBegin();
			Platform.mdbUpdate(this.getRec());
			if(ctx.getErrorCode() == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:usdgrp.@0003.script
        */
        public boolean delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//先调用柜员单笔注销交易接口，成功，则入库。
			Map<String,Object> sendmap=new HashMap<String,Object>();
			String inr=Platform.sdbCounter("usr");
			//20位系统流水号
			String seqno="99306"+MdaUtils.format(MdaUtils.today(),"yyMMdd")+inr;
			sendmap.put("SEQNO",seqno);
			sendmap.put("CHG_TELLER_NO",this.getRec().getUsrnum());
			sendmap.put("TELLER_CODE",this.getUsr().getUsrnum());
			sendmap.put("IS_AUTH","01");
			//34位系统跟踪号  11位平台号+ "0" +日期8位 +时间6位 + 8位inr
			String trnnum="993060000000"+MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss")+inr;
			sendmap.put("SYS_TRACE_NO",trnnum);
			Map<String,Object> returnmap=(Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.psbc.service.jolt.JoltClientUtil","sendUserLoginOut",sendmap);
			String responseCode=(String)returnmap.get("RESPCODE");
			if(!"000000".equals(responseCode.trim()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usdgrp","CT000237"),(String)returnmap.get("RESPINFO"));
			  return false;
			}
			Boolean res = MdaUtils.prompt(MdaUtils.getI18NString("usdgrp","CT000238"),MdaUtils.getI18NString("usdgrp","CT000239"));
			log.debug("{}","@@@@ 注销?:"+res + " @@@@");
			if(!res)
			{
			  this.getRec().setSta("1");
			  // Platform.mdbBegin();
			  Platform.mdbUpdate(this.getRec());
			  //Platform.mdbCommit();
			  ctx.setMessage(MdaUtils.getI18NString("usdgrp","CT000240"),MdaUtils.getI18NString("usdgrp","CT000241"));
			  //Platform.returnToCaller();
			  //Platform.mchain("dblusr");
			  return true;
			}
			else
			  return false;
		}
        /**
        *   source:usdgrp.@0006.script
        */
        public String getPtynam(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Platform.mdbRead(this.getPty(),new Argument<String>("inr",ptyinr));
			return this.getPty().getChnnam();
		}
        /**
        *   source:usdgrp.@0007.script
        */
        public boolean isUserExist(String lgnnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean res = true;
			String sql = "SELECT inr FROM usr WHERE nam = '" + lgnnam + "'";
			Argument<String> inrarg = new Argument<String>("inr");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(inrarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  res = true;
			}
			else
			{
			  res = false;
			}
			Platform.mdbCloseCursor();
			return res;
		}








}