package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Frm;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Frr;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Usmgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Usmgrp.class);

        //未分配菜单
        private StreamGrid lftgrd;

        //已分配菜单
        private StreamGrid rgtgrd;

        //增加菜单
        private StreamGrid addgrd;

        //移除菜单
        private StreamGrid rmvgrd;



	    @BDGetter
		private Usr rec;

	    @BDGetter
		private Frm frm;

	    @BDGetter
		private Frr frr;

		@BDGetter
		private ModuleList<Frr> frrlst1;

		@BDGetter
		private ModuleList<Frr> frrlst2;

		@BDGetter
		private ModuleList<Frr> frrlst;

		@BDGetter
		private ModuleList<Frr> lfttmplst;

		@BDGetter
		private ModuleList<Frr> rgttmplst;

	    @BDGetter
		private Grdmod grdmod;

		@BDGetter
		private ModuleList<Frr> usrlst;


		public Usmgrp()
        {
            super();
            setArgument();
        }

        public Usmgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:usmgrp.@0001.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","dbuusm update frr...");
			int errorcode = ctx.getErrorCode();
			StreamGrid lftgrd = this.getLftgrd();
			StreamGrid rgtgrd = this.getRgtgrd();
			//记录操作
			String operationRecord="用户:"+this.getRec().getNam()+" ";
			int countTrans=0;
			String objinr=this.getRec().getInr();
			for(int i=0 ; i<lftgrd.size() ; i++)
			{
			  AttributeValue lftval = (AttributeValue)lftgrd.get(i)[1];
			  String flg = (String) lftval.getAttribute("flg");
			  //记录操作
			  String frm = (String) lftval.getAttribute("frm");
			  String frrinr = (String) lftval.getAttribute("frrinr");
			  String frminr = (String) lftval.getAttribute("frminr");
			  if("D".equals(flg))
			  {
			    MdaUtils.clear(this.getFrr());
			    this.getFrr().setFrminr( frminr);
			    this.getFrr().setObjinr( this.getRec().getInr());
			    this.getFrr().setObjtyp( "usr");
			    this.getFrr().setTyp( "1");
			    Platform.sdbInsert(this.getFrr());
			    //记录操作
			    String key = "menu."+frm;
			    String nam = MdaUtils.getI18nValue("eibs",key);
			    //operationRecord+="删除交易"+nam+" ";
			    countTrans++;
			    log.debug("{}","MENU_NAME  "+nam);
			    errorcode = ctx.getErrorCode();
			    if(errorcode != NO_ERROR)
			      return false;
			  }
			}

			for(int i=0 ; i<rgtgrd.size() ; i++)
			{
			  AttributeValue rgtval = (AttributeValue)rgtgrd.get(i)[1];
			  String flg = (String) rgtval.getAttribute("flg");
			  //记录操作
			  String frm = (String) rgtval.getAttribute("frm");
			  String frrinr = (String) rgtval.getAttribute("frrinr");
			  if("A".equals(flg))
			  {
			    MdaUtils.clear(this.getFrr());
			    Platform.sdbRead(this.getFrr(),frrinr);
			    Platform.mdbDelete(this.getFrr());
			    //记录操作
			    String key = "menu."+frm;
			    String nam = MdaUtils.getI18nValue("eibs",key);
			    //operationRecord+="新增交易"+nam+" ";
			    countTrans++;
			    log.debug("{}","MENU_NAME"+nam);
			    errorcode = ctx.getErrorCode();
			    if(errorcode != NO_ERROR)
			      return false;
			  }
			}
			operationRecord+="定制交易修改数量:";
			operationRecord+=""+countTrans;
			ctx.absGet(Mtabut.class).getHtymod().insertHistoryWithoutDbOp(operationRecord,"eibs","frr","新增",objinr);
			return true;
		}



















}