package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Usrgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Usrgrp.class);

        //rec操作标志
        private String recsavflg;



	    @BDGetter
		private Usr rec;

	    @BDGetter
		private Rol rol;

	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Pty ptyext;

	    @BDGetter
		private Usr usr;


		public Usrgrp()
        {
            super();
            setArgument();
        }

        public Usrgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:usrgrp.@0000.script
        */
        public boolean insert()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," usr insert... ");
			String pas = MdaUtils.encryptPassword("1");
			this.getRec().setPwd(pas);
			this.getRec().setSta("0");
			String inr = Platform.sdbCounter("usr");
			log.debug("{}","usr inr: "+inr);
			this.getRec().setInr(inr);
			//$usdgrp\\rec\\dn.setValue(dn);
			//先调用柜员单笔注册交易接口，成功，则入库。
			//柜员信息入库之前，需要检查该柜员号在系统内部是否存在
			/*Map<String,Object> sendmap=new HashMap<String,Object>();
			  //20位系统流水号
			  String seqno="99306"+Platform.format(Platform.today(),"yyMMdd")+inr;
			  sendmap.put("SEQNO",seqno);
			  sendmap.put("TELLER_NAME",$rec\\dspnam.getValue());
			  sendmap.put("PERSONCODE",$rec\\usridn.getValue());
			  sendmap.put("TELLER_CODE",$\\sysmod\\usr\\usrnum.getValue());
			  //机构号
			  sendmap.put("TELLER_INST",getBranchCode($rec\\ptyinr.getValue()));
			  sendmap.put("IS_AUTH","01");
			  //34位系统跟踪号  11位平台号+ "0" +日期8位 +时间6位 + 8位inr
			  String trnnum="993060000000"+Platform.format(Platform.today(),"yyyyMMddHHmmss")+inr;
			  sendmap.put("SYS_TRACE_NO",trnnum);
			  Map<String,Object> returnmap=(Map<String,Object>)Platform.invoke("cn.com.brilliance.psbc.service.jolt.JoltClientUtil","sendUserRegister",sendmap);
			  String usrcid=(String)returnmap.get("CHG_TELLER_NO");
			  log.debug("returnmap CHG_TELLER_NO:"+usrcid);
			  if(exitUserBycid(usrcid))
			  {
			  Platform.message(#CT000006,"柜员号为["+usrcid+"]的用户已经存在");
			  return false;
			  }
			  String responseCode=(String)returnmap.get("RESPCODE");
			  if(!"000000".equals(responseCode.trim()))
			  {
			  Platform.message(#CT000007,(String)returnmap.get("RESPINFO"));
			  return false;
			  }*/
			// Platform.mdbBegin();
			

			//关联所属实体
			String ptyinr = this.getRec().getPtyinr();
			ctx.absGet(Sysmod.class).setEtyAndPty(this.getRec());
			this.getRec().setPtyinr(ptyinr);

			Platform.mdbInsert(this.getRec());
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  //Platform.mdbCommit();
			  // Platform.message(#CT000008,"用户注册成功");
			  //Platform.clear($rec);
			  //Platform.returnToCaller();
			  return true;
			}
			else
			{
			  // Platform.mdbRollback();
			  return false;
			}

		}
        /**
        *   source:usrgrp.@0001.script
        */
        public boolean update()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			/*if(!Platform.checkAll($rec))
			  {
			  return false;
			  }
			  if(Platform.isEmpty($rec\\dspnam))
			  {
			  Platform.error($rec\\dspnam,#CT000014);
			  return false;
			  }
			  if(!Platform.isEmpty($rec\\ptyinr))
			  {
			  String nam = getPtynam($rec\\ptyinr.getValue());
			  if(!Platform.isEmpty(nam))
			  {
			  $rec\\ptynam.setValue(nam);
			  }
			  }
			  else
			  {
			  Platform.error($rec\\ptyinr,#CT000015);
			  return false;
			  }*/
			//Platform.mdbBegin();
			Platform.mdbUpdate(this.getRec());
			if(ctx.getErrorCode() == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:usrgrp.@0002.script
        */
        public boolean delete()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//先调用柜员单笔注销交易接口，成功，则入库。
			/*Map<String,Object> sendmap=new HashMap<String,Object>();
			  String inr=Platform.sdbCounter("usr");
			  //20位系统流水号
			  String seqno="99306"+Platform.format(Platform.today(),"yyMMdd")+inr;
			  sendmap.put("SEQNO",seqno);
			  sendmap.put("CHG_TELLER_NO",$rec\\usrnum.getValue());
			  sendmap.put("TELLER_CODE",$\\sysmod\\usr\\usrnum.getValue());
			  sendmap.put("IS_AUTH","01");
			  //34位系统跟踪号  11位平台号+ "0" +日期8位 +时间6位 + 8位inr
			  String trnnum="993060000000"+Platform.format(Platform.today(),"yyyyMMddHHmmss")+inr;
			  sendmap.put("SYS_TRACE_NO",trnnum);
			  Map<String,Object> returnmap=(Map<String,Object>)Platform.invoke("cn.com.brilliance.psbc.service.jolt.JoltClientUtil","sendUserLoginOut",sendmap);
			  String responseCode=(String)returnmap.get("RESPCODE");
			  if(!"000000".equals(responseCode.trim()))
			  {
			  Platform.message(#CT000021,(String)returnmap.get("RESPINFO"));
			  return false;
			  }*/
			Boolean res = MdaUtils.prompt(MdaUtils.getI18NString("usrgrp","CT000022"),MdaUtils.getI18NString("usrgrp","CT000023"));
			log.debug("{}","@@@@ 注销?:"+res + " @@@@");
			if(!res)
			{
			  this.getRec().setSta("1");
			  // Platform.mdbBegin();
			  log.debug("{}","usr inr:"+this.getRec().getInr());
			  Platform.mdbUpdate(this.getRec());
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    //Platform.mdbCommit();
			    //Platform.message(#CT000024,#CT000025);
			    //Platform.returnToCaller();
			    //Platform.mchain("dblusr");
			    return true;
			  }
			  else
			    return false;
			}
			else
			  return false;
		}
        /**
        *   source:usrgrp.@0003.script
        */
        public String getPtynam(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Platform.mdbRead(this.getPty(),new Argument<String>("inr",ptyinr));
			return this.getPty().getChnnam();
		}
        /**
        *   source:usrgrp.@0008.script
        */
        public boolean isUserExist(String lgnnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//log.debug("is User Exist?");
			boolean res = true;
			String sql = "SELECT inr FROM usr WHERE nam = '" + lgnnam + "'";
			Argument<String> inrarg = new Argument<String>("inr");
			log.debug("{}","user is not exist?"+MdaUtils.isEmpty(inrarg));
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(inrarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  res = true;
			}
			else
			{
			  res = false;
			}
			Platform.mdbCloseCursor();
			return res;
		}
        /**
        *   source:usrgrp.@0009.script
        */
        public boolean reset()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.mdbBegin();
			String pws = MdaUtils.encryptPassword("1");
			this.getRec().setPwd(pws);
			Platform.mdbUpdate(this.getRec());
			//Platform.mdbCommit();
			//Platform.message(#CT000045,#CT000046);
			//Platform.returnToCaller();
			Platform.mchain("dblusr");
			if (ctx.getErrorCode() == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:usrgrp.@0010.script
        */
        public String getBranchCode(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String bchcode=null;
			MdaUtils.clear(this.getPtyext());
			Platform.mdbRead(this.getPtyext(),new Argument<String>("inr",ptyinr));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  bchcode=this.getPtyext().getCid();
			}
			return bchcode;
		}
        /**
        *   source:usrgrp.@0011.script
        */
        public boolean exitUserBycid(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Boolean res = true;
			String sql = "SELECT inr FROM usr WHERE usrnum = '" + cid + "' AND (sta=? OR sta=?)";
			Argument<String> inrarg = new Argument<String>("inr");
			Platform.mdbExecuteSQL(sql,"0","2");
			Platform.mdbFetchFields(inrarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  res = true;
			}
			else
			{
			  res = false;
			}
			Platform.mdbCloseCursor();
			return res;
		}








}