package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 用户登录信息pnl
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Usrmsgp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Usrmsgp.class);

        //起始时间
        private Date begtim;

        //结束时间
        private Date endtim;

        //登录
        private IControl dlpnl;

        //退出
        private IControl tuichu;

        //申请序号
        private String reqnum;

        //报文子类型号
        private String subtyp;

        //发起节点代码
        private String sndcod;

        //接收节点代码
        private String rcvcod;

        //报文处理码
        private String mancod;

        //原识别信息
        private String oriinf;

        //新识别信息
        private String newinf;

        //登录状态
        private String sta;

        //证书绑定
        private IControl cerbng;

        //行号变更
        private IControl bnkchg;

        //数字签名管理
        private IControl numsig;

        //确定
        private IControl qur;

        //返回
        private IControl rtn;

        //签退确定
        private IControl lgoqur;

        //登录
        private IControl lgiccms805;

        //退出
        private IControl lgoccms805;

        //报文标识号
        private String msgflagno;

        //报文发送时间
        private Date sendtm;

        //发起直接参与机构
        private String instgdrctparty;

        //发起参与机构
        private String instgparty;

        //接收直接参与机构
        private String instddrctparty;

        //接收参与机构
        private String instdparty;

        //系统编号
        private String syscode;

        //备注
        private String headerrmk;

        //操作类型
        private String typecode;

        //登录确认
        private IControl submit805;

        //退出确认
        private IControl submit805off;

        //关闭登录页面
        private IControl close805on;

        //关闭登出页面
        private IControl close805off;

        //系统状态查询
        private IControl syssta;

        //接入机构状态下载申请
        private IControl sysapply;

        //接入机构唯一标识
        private String bnkcod;

        //接入机构状态下载申请确认按钮
        private IControl sysapplycfm;

        //接收机构行号
        private String instgpaty;

        //系统当前状态
        private String cursyssts;

        //获取系统状态
        private IControl getsyssts;

        //返回
        private IControl quitbt;


        @JsonIgnore
        @BDGetter
        private transient IPanel lftpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgtpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel btmpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgtmpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel mainpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel shwpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel lgopnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel lgipnl805;

        @JsonIgnore
        @BDGetter
        private transient IPanel lgopnl805;

        @JsonIgnore
        @BDGetter
        private transient IPanel sysapplypnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel stapnl;


		@Module(getter = false, setter = false)
		private transient ModuleHolder<Usrmsggrp> usrmsggrp;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;

	    @BDGetter
		private Smpmod smpmod;

	    @BDGetter
		private Msgmod msgmod;


		public Usrmsgp()
        {
            super();
            setArgument();
        }

        public Usrmsgp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:usrmsgp.@0001.script
        */
        @Rule(target="mtabut.rtn",order=100)
        public boolean ruleMtabutRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:usrmsgp.@0002.script
        */
        @Rule(target="mtabut.sel",order=100)
        public boolean ruleMtabutSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.query();

			return true;
        }

        /**
        *   source:usrmsgp.@0003.script
        */
        @Rule(target="mtabut.reset",order=100)
        public boolean ruleMtabutResetN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.clearDatafield(MdaDriver.getDatafield(this,"reqnum"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"subtyp"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"rcvcod"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"sndcod"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"oriinf"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"newinf"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"begtim"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"endtim"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"sta"));

			return true;
        }

        /**
        *   source:usrmsgp.@0008.script
        */
        @Rule(target="mtabut.exp",order=100)
        public boolean ruleMtabutExpN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream is = this.getMtabut().getExp();
			is.setType("xls");
			is.setName("Usrtab"+MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss")+".xls");
			List<Object[]> lst = new ArrayList<Object[]>();
			String [] title= new String[10];
			title[0]=MdaUtils.getI18NString("usrmsgp","CT000080");
			title[1]=MdaUtils.getI18NString("usrmsgp","CT000081");
			title[2]=MdaUtils.getI18NString("usrmsgp","CT000082");
			title[3]=MdaUtils.getI18NString("usrmsgp","CT000083");
			title[4]=MdaUtils.getI18NString("usrmsgp","CT000084");
			title[5]=MdaUtils.getI18NString("usrmsgp","CT000085");
			title[6]=MdaUtils.getI18NString("usrmsgp","CT000086");
			title[7]=MdaUtils.getI18NString("usrmsgp","CT000087");
			title[8]=MdaUtils.getI18NString("usrmsgp","CT000088");
			title[9]=MdaUtils.getI18NString("usrmsgp","CT000089");
			lst.add(title);
			for(int i=0;i<this.getUsrmsggrp().getUsrlst().fullSize();i++)
			{
			  Object [] line = new Object[10];
			  line[0] = this.getUsrmsggrp().getUsrlst().getElement(i).getReqnum();
			  line[1] = this.getUsrmsggrp().getUsrlst().getElement(i).getSndcod();
			  line[2] = this.getUsrmsggrp().getUsrlst().getElement(i).getRcvcod();
			  line[3] = this.getUsrmsggrp().getUsrlst().getElement(i).getOriinf();
			  line[4] = this.getUsrmsggrp().getUsrlst().getElement(i).getNewinf();
			  line[5] = this.getUsrmsggrp().getUsrlst().getElement(i).getSubtyp();
			  Date curdat = this.getUsrmsggrp().getUsrlst().getElement(i).getCurdat();
			  line[6] = MdaUtils.format(curdat,"yyyy/MM/dd");
			  Date dattim = this.getUsrmsggrp().getUsrlst().getElement(i).getRsptim();
			  line[7] = MdaUtils.format(dattim,"yyyy/MM/dd HH:mm:ss");
			  line[8] = this.getUsrmsggrp().getUsrlst().getElement(i).getMancod();
			  String sta = this.getUsrmsggrp().getUsrlst().getElement(i).getSta();
			  if(MdaUtils.isEmpty(sta))
			    line[9]="";
			  else
			    line[9]=MdaUtils.getCodetableLabel("bnksta",sta);
			  String logsta = this.getUsrmsggrp().getUsrlst().getElement(i).getLogsta();
			  lst.add(line);
			}
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }

        /**
        *   source:usrmsgp.@0011.script
        */
        @Rule(target="dlpnl",order=100)
        public boolean ruleDlpnlN100(){
            IContext ctx = MdaEnv.getContext();
            
			String json=this.createcfad_050_001_01("LOGN");
			if(!this.storeMsgFromPlatWithoutChk(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT000135"),MdaUtils.getI18NString("usrmsgp","CT000136"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.info("{}","签到成功");
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001203"),MdaUtils.getI18NString("usrmsgp","CT001204"));

			}


			return true;
        }

        /**
        *   source:usrmsgp.@0012.script
        */
        @Rule(target="tuichu",order=100)
        public boolean ruleTuichuN100(){
            IContext ctx = MdaEnv.getContext();
            
			String json=this.createcfad_050_001_01("LOGF");
			if(!this.storeMsgFromPlatWithoutChk(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT000510"),MdaUtils.getI18NString("usrmsgp","CT000511"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.info("{}","签退成功");
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001201"),MdaUtils.getI18NString("usrmsgp","CT001202"));
			}

			/*
			  Platform.clear($usrmsggrp\\usrtab);
			  Platform.clear($usrmsggrp\\usrtabs);
			  $usrmsggrp\\usrtab\\reqnum = "F" + Platform.format(Platform.today(), "yyMMddHHmmssSSS");//申请序号
			  $usrmsggrp\\usrtab\\subtyp = "065";
			  $usrmsggrp\\usrtab\\sndcod = "PSBCCNBJXXX";//发起节点代码
			  Platform.mdbReadset($usrmsggrp\\usrtabs,new Argument("newinf",DESC));
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT001203,#CT001204);
			  return false;
			  }
			  if($usrmsggrp\\usrtabs.size()==0)
			  {
			  $usrmsggrp\\usrtab\\newinf = String.format("%020d",0);
			  }
			  else
			  $usrmsggrp\\usrtab\\newinf = $usrmsggrp\\usrtabs[0]\\newinf.getValue();//原识别信息,等于最新一条记录新识别信息
			  Platform.disableDatafield($usrmsggrp\\usrtab\\reqnum);
			  Platform.disableDatafield($usrmsggrp\\usrtab\\subtyp);
			  Platform.disableDatafield($usrmsggrp\\usrtab\\sndcod);
			  //Platform.disableDatafield($usrmsggrp\\usrtab\\newinf);
			  Platform.setModified($usrmsggrp\\usrtab\\newinf);
			  Platform.popup($lgopnl);
			  */

			return true;
        }

        /**
        *   source:usrmsgp.@0014.script
        */
        @Rule(target="cerbng",order=100)
        public boolean ruleCerbngN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("csnsel");

			return true;
        }

        /**
        *   source:usrmsgp.@0015.script
        */
        @Rule(target="bnkchg",order=100)
        public boolean ruleBnkchgN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("pbtsel");

			return true;
        }

        /**
        *   source:usrmsgp.@0016.script
        */
        @Rule(target="numsig",order=100)
        public boolean ruleNumsigN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("fmtsel,sig");

			return true;
        }

        /**
        *   source:usrmsgp.@0017.script
        */
        @Rule(target="qur",order=100)
        public boolean ruleQurN100(){
            IContext ctx = MdaEnv.getContext();
            

			/*
			  //
			  //调用接口平台，传递参数类型Object[]
			  String result = null;
			  Object[] usr = new Object[6];
			  usr[0] = "0063";//任务号
			  String inr = Platform.sdbCounter("FMT063","000000");
			  int dbInr = Platform.parseInt(inr);
			  dbInr = dbInr +1;
			  usr[1] = String.format("%06d",dbInr);
			  log.debug("序列号："+(String)usr[1]);
			  //usr[2] = (Object)("F" + Platform.format(Platform.today(), "yyMMddHHmmssSSS"));//申请序号
			  usr[2] = $usrmsggrp\\usrtab\\reqnum.getValue();
			  log.debug("申请序号："+(String)usr[2]);
			  //usr[3] = "PSBCCNBJXXX";//发送节点代码
			  usr[3] = $usrmsggrp\\usrtab\\sndcod.getValue();
			  usr[4] = $usrmsggrp\\usrtab\\oriinf.getValue();
			  usr[5] = $usrmsggrp\\usrtab\\newinf.getValue();
			  */
			/*Platform.mdbReadset($usrmsggrp\\usrtabs,0,new Argument<String>("newinf",DESC));
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT000809,#CT000810);
			  return false;
			  }
			  if($usrmsggrp\\usrtabs.size()==0)
			  {
			  usr[4] = String.format("%020d",0);
			  }
			  else usr[4] = $usrmsggrp\\usrtabs[0]\\newinf.getValue();//原识别信息,等于上一条记录新识别信息
			  int i = Platform.parseInt(usr[4]);
			  i++;
			  usr[5] = String.format("%020d",i);//新识别信息，(原识别信息加1)
			  */
			/*Object msg = Platform.invoke("com.brilliance.eibs.main.Client","scall","PackageFmt","063",usr);
			  Boolean obtf = (Boolean)Platform.invoke(msg,"isSuccess");
			  log.debug("obtf-------"+obtf);
			  if(!obtf)
			  {
			  Platform.message(#CT000811,#CT000812);
			  return false;
			  }
			  //获取接口平台返回的报文信息
			  Object data = Platform.invoke(msg,"getContent");//报文内容
			  log.debug("login rtnmsg: "+data);
			
			  if(!$this.storeMsgFromPlatWithoutChk(json))
			  {
			  Platform.message(#CT000813,#CT000814);
			  Platform.mdbRollback();
			  return false;
			  }
			  else
			  {
			  Platform.message(#CT000815,#CT000816);
			
			  //Platform.mdbCommit();
			  Platform.clear($usrmsggrp\\usrtab);
			  int errorcode = Platform.errorCode();
			  //获取接口平台返回的内容
			  // Platform.mdbBegin();
			  $usrmsggrp\\usrtab\\reqnum = (String)usr[2];
			  $usrmsggrp\\usrtab\\subtyp = "063";
			  $usrmsggrp\\usrtab\\sndcod = (String)usr[3];
			  $usrmsggrp\\usrtab\\rcvcod = $smpmod\\mpi\\rcvbic;
			  $usrmsggrp\\usrtab\\oriinf = (String)usr[4];
			  $usrmsggrp\\usrtab\\newinf = (String)usr[5];
			  String dattim = Platform.format(Platform.today(),"yyyyMMddHHmmss");
			  $usrmsggrp\\usrtab\\rsptim = Platform.parseDate(dattim,"yyyyMMddHHmmss");
			  $usrmsggrp\\usrtab\\curdat = Platform.parseDate(dattim.substring(0,8),"yyyyMMdd");
			  $usrmsggrp\\usrtab\\sta = "00";//待审核
			  $usrmsggrp\\usrtab\\mpiinr = $smpmod\\mpi\\inr;
			  /* $usrmsggrp\\usrtab\\rspcod = rspcod;
			  if(!Platform.isEmpty(rspinf))
			  $usrmsggrp\\usrtab\\rspinf = rspinf;
			  Platform.sdbInsert($usrmsggrp\\usrtab);
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT000817,#CT000818);
			  return false;
			  }
			  Platform.mdbCommit();
			  errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT000833,#CT000834);
			  Platform.mdbRollback();
			  return false;
			  }
			  else
			  {
			  Platform.message(#CT001199,#CT001200);
			  $this.query();
			  log.debug("login successfully!");
			  }
			  //}
			
			  }*/
			

			return true;
        }

        /**
        *   source:usrmsgp.@0019.script
        */
        @Rule(target="rtn",order=100)
        public boolean ruleRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:usrmsgp.@0020.script
        */
        @Rule(target="rtn",order=150)
        public boolean ruleRtnN150(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:usrmsgp.@0021.script
        */
        @Rule(target="lgoqur",order=100)
        public boolean ruleLgoqurN100(){
            IContext ctx = MdaEnv.getContext();
            
			//组装报文
			/*com.brilliance.jrxx.packet.model.cfad_050_001_01.Cfad_050_001_01 cfad_050_001_01 = new com.brilliance.jrxx.packet.model.cfad_050_001_01.Cfad_050_001_01();
			  com.brilliance.jrxx.packet.model.cfad_050_001_01.MsgComData msgComData = new com.brilliance.jrxx.packet.model.cfad_050_001_01.MsgComData();
			  com.brilliance.jrxx.packet.model.cfad_050_001_01.AdminInfo adminInfo = new com.brilliance.jrxx.packet.model.cfad_050_001_01.AdminInfo();
			  com.brilliance.jrxx.packet.model.cfad_050_001_01.LoginInf loginInf = new com.brilliance.jrxx.packet.model.cfad_050_001_01.LoginInf();
			  //组装报文头
			  Platform.fillHead(cfad_050_001_01, "GDBKMOMXXXX", "GDBKCN22XXX", "20210521", "141045", "cfad.050.001.01", "2021052114104569620", "2021052114104597481", "U");
			  //组装报文体
			  msgComData.InstgPty = "1";
			  msgComData.InstdPty = "2";
			  msgComData.SndDtTm = "2001-12-17T09:30:47Z";
			  msgComData.MsgId = "a";
			  cfad_050_001_01.MsgComData = msgComData;
			  loginInf.LoginOprTp = "LOGN";
			  adminInfo.SvrGrpInfo = "b";
			  adminInfo.LoginInf = loginInf;
			  cfad_050_001_01.AdminInfo = adminInfo;
			  String json = com.alibaba.fastjson.JSON.toJSONString(cfad_050_001_01);
			  log.debug(json);
			  com.brilliance.jrxx.framework.Result result1 = com.brilliance.jrxx.utils.MsgUtil.packMessage(json);
			  String msg1=result1.getMessage();
			  log.debug(msg1);*/

			String result = null;
			Object[] usr = new Object[5];
			usr[0] = "0065";//任务号
			String inr = Platform.sdbCounter("FMT065","000000");
			int dbInr = MdaUtils.parseInt(inr);
			dbInr = dbInr +1;
			usr[1] = String.format("%06d",dbInr);
			usr[2] = this.getUsrmsggrp().getUsrtab().getReqnum();
			//usr[2] = (Object)("F" + Platform.format(Platform.today(), "yyMMddHHmmssSSS"));//申请序号
			log.debug("{}","申请序号："+(String)usr[2]);
			usr[3] = this.getUsrmsggrp().getUsrtab().getSndcod();
			//usr[3] = (Object)"PSBCCNBJXXX";//发去节点代码
			usr[4] = this.getUsrmsggrp().getUsrtab().getNewinf();

			/*Platform.mdbReadset($usrmsggrp\\usrtabs,new Argument("newinf",DESC));
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  Platform.message(#CT001094,#CT001095);
			  return false;
			  }
			  if($usrmsggrp\\usrtabs.size()==0)
			  {
			  usr[4] = String.format("%020d",0);
			  }
			  else usr[4] = $usrmsggrp\\usrtabs[0]\\newinf.getValue();//原识别信息,等于最新一条记录新识别信息
			  */
			Object msg = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","PackageFmt","065",usr);//组报
			Boolean obtf = (Boolean)MdaUtils.invoke(msg,"isSuccess");
			log.debug("{}","obtf-------"+obtf);
			if(!obtf)
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001096"),MdaUtils.getI18NString("usrmsgp","CT001097"));
			  return false;
			}
			//获取接口平台返回的报文信息
			Object data = MdaUtils.invoke(msg,"getContent");//报文内容
			log.debug("{}","logout msg========"+data);

			if(!this.storeMsgFromPlatWithoutChk(data))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001098"),MdaUtils.getI18NString("usrmsgp","CT001099"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  /*Object[] sndMap = new Object[1];
			    sndMap[0] = data;
			    Object obj = Platform.invoke("com.brilliance.eibs.main.Client","scall","SendFmt","SendFmt",sndMap);//发报
			    Boolean obt = (Boolean)Platform.invoke(obj,"isSuccess");
			    log.debug("logout obt-------"+obt);
			    if(!obt)
			    {
			    Platform.message(#CT001100,#CT001101);
			    return false;
			    }*/
			  MdaUtils.clear(this.getUsrmsggrp().getUsrtab());
			  int errorcode = ctx.getErrorCode();
			  //获取接口平台返回的内容
			  /*Object[] code = (Object[])Platform.invoke(obj,"getContent");
			    log.debug("logout return code: "+code);
			    Object[] str = (Object[])code;
			    String rspcod = (String)str[0];
			    String rspinf = (String)str[1];
			    int errorcode = Platform.errorCode();
			    if(!Platform.isEmpty(rspcod)&&"0000".equals(rspcod))
			    {*/
			  //Platform.mdbBegin();
			  this.getUsrmsggrp().getUsrtab().setReqnum( (String)usr[2]);
			  this.getUsrmsggrp().getUsrtab().setSubtyp( "065");
			  this.getUsrmsggrp().getUsrtab().setSndcod( (String)usr[3]);
			  this.getUsrmsggrp().getUsrtab().setRcvcod( this.getSmpmod().getMpi().getRcvbic());
			  this.getUsrmsggrp().getUsrtab().setOriinf( (String)usr[4]);
			  this.getUsrmsggrp().getUsrtab().setNewinf( (String)usr[4]);
			  String dattim = MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss");
			  this.getUsrmsggrp().getUsrtab().setRsptim( MdaUtils.parseDate(dattim,"yyyyMMddHHmmss"));
			  this.getUsrmsggrp().getUsrtab().setCurdat( MdaUtils.parseDate(dattim.substring(0,8),"yyyyMMdd"));
			  this.getUsrmsggrp().getUsrtab().setSta( "00");//待审核
			  //$usrmsggrp\\usrtab\\rspcod = rspcod;
			  this.getUsrmsggrp().getUsrtab().setMpiinr( this.getSmpmod().getMpi().getInr());
			  /* if(!Platform.isEmpty(rspinf))
			    $usrmsggrp\\usrtab\\rspinf = rspinf.trim();*/
			  Platform.sdbInsert(this.getUsrmsggrp().getUsrtab());
			  if(errorcode != NO_ERROR)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001102"),MdaUtils.getI18NString("usrmsgp","CT001103"));
			    return false;
			  }
			  Platform.mdbCommit();
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001104"),MdaUtils.getI18NString("usrmsgp","CT001105"));
			    Platform.mdbRollback();
			    return false;
			  }
			  else
			  {
			    ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001127"),MdaUtils.getI18NString("usrmsgp","CT001128"));
			    this.query();
			    log.debug("{}","logout save successfully!");
			  }
			}
			//}
			

			return true;
        }

        /**
        *   source:usrmsgp.@0022.script
        */
        @Rule(target="usrmsggrp.usrlst",order=100)
        public boolean ruleUsrmsggrpUsrlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			if(index > -1)
			{
			  String mpiinr = this.getUsrmsggrp().getUsrlst().getElement(index).getMpiinr();
			  ctx.storeData("mpsinr",mpiinr);
			  Platform.mchain("msgdtl");
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001117"),MdaUtils.getI18NString("usrmsgp","CT001118"));
			  return true;
			}

			return true;
        }

        /**
        *   source:usrmsgp.@0026.script
        */
        @Rule(target="qur",order=50)
        public boolean ruleQurN50(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getUsrmsggrp().getUsrtab().getNewinf()))
			{
			  ctx.setFieldError(this,"usrmsggrp.usrtab.newinf",MdaUtils.getI18NString("usrmsgp","CT001159"));
			  return false;
			}
			else if(MdaUtils.isEmpty(this.getUsrmsggrp().getUsrtab().getOriinf()))
			{
			  ctx.setFieldError(this,"usrmsggrp.usrtab.oriinf",MdaUtils.getI18NString("usrmsgp","CT001160"));
			  return false;
			}

			return true;
        }

        /**
        *   source:usrmsgp.@0027.script
        */
        @Rule(target="lgoqur",order=50)
        public boolean ruleLgoqurN50(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getUsrmsggrp().getUsrtab().getNewinf()))
			{
			  ctx.setFieldError(this,"usrmsggrp.usrtab.newinf",MdaUtils.getI18NString("usrmsgp","CT001171"));
			  return false;
			}

			return true;
        }

        /**
        *   source:usrmsgp.@0033.script
        */
        @Rule(target="sysapply",order=100)
        public boolean ruleSysapplyN100(){
            IContext ctx = MdaEnv.getContext();
            

			Platform.clearDatafield(MdaDriver.getDatafield(this,"bnkcod"));
			Platform.clearDatafield(MdaDriver.getDatafield(this,"instgpaty"));

			

			return true;
        }

        /**
        *   source:usrmsgp.@0034.script
        */
        @Rule(target="sysapplycfm",order=100)
        public boolean ruleSysapplycfmN100(){
            IContext ctx = MdaEnv.getContext();
            
			String code=(String)this.getBnkcod();
			String instgpaty=(String)this.getInstgpaty();
			if(MdaUtils.isEmpty(code)||MdaUtils.isEmpty(instgpaty))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001281"),MdaUtils.getI18NString("usrmsgp","CT001282"));
			  return true;
			}

			List lst=java.util.Arrays.asList(code.split(","));
			String json=this.getMsgmod().create_cfad_020_001_01(lst,instgpaty);

			if(!this.storeMsgFromPlatWithoutChk(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001283"),MdaUtils.getI18NString("usrmsgp","CT001284"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.info("{}","申请下载接入机构状态成功");
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001285"),MdaUtils.getI18NString("usrmsgp","CT001286"));
			  
			}


			return true;
        }

        /**
        *   source:usrmsgp.@0035.script
        */
        @Rule(target="syssta",order=100)
        public boolean ruleSysstaN100(){
            IContext ctx = MdaEnv.getContext();
            
			String json=this.createcfad_012_001_01();
			if(!this.storeMsgFromPlatWithoutChk(json))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001290"),MdaUtils.getI18NString("usrmsgp","CT001291"));
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.info("{}","发报成功");
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT001292"),MdaUtils.getI18NString("usrmsgp","CT001293"));
			  //Platform.popup($stapnl);
			
			}

			return true;
        }

        /**
        *   source:usrmsgp.@0038.script
        */
        @Rule(target="getsyssts",order=100)
        public boolean ruleGetsysstsN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:usrmsgp.@0039.script
        */
        @Rule(target="quitbt",order=100)
        public boolean ruleQuitbtN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			this.setCursyssts(null);


			return true;
        }


        /**
        *   source:usrmsgp.@0023.script
        */
        @Check(target="sndcod",order=100)
        public boolean checkSndcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSndcod()))
			  return true;
			String bic = this.getSndcod();
			bic = bic.toUpperCase();
			if(!bic.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"sndcod",MdaUtils.getI18NString("usrmsgp","CT001140"));
			}
			this.setSndcod( bic);
			

			return true;
        }

        /**
        *   source:usrmsgp.@0024.script
        */
        @Check(target="rcvcod",order=100)
        public boolean checkRcvcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRcvcod()))
			  return true;
			String bic = this.getRcvcod();
			bic = bic.toUpperCase();
			if(!bic.matches("[A-Z0-9]+"))
			{
			  ctx.setFieldError(this,"rcvcod",MdaUtils.getI18NString("usrmsgp","CT001139"));
			}
			this.setRcvcod( bic);
			

			return true;
        }

        /**
        *   source:usrmsgp.@0025.script
        */
        @Check(target="reqnum",order=100)
        public boolean checkReqnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.transAndCheckRef(MdaDriver.getDatafield(this,"reqnum"));

			return true;
        }


        /**
        *   source:usrmsgp.@0010.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","获取当前系统状态");
			// 获取msgid
			//log.debug("msgid="+msgid);
			// 根据msgid查询数据
			String sql = "select cursyssts from sysinf t where t.syscod = ? ";
			ctx.getDaoSession().dbExecuteSQL(sql,"CFIX");
			Argument<String> cursyssts = new Argument<String>("cursyssts");
			ctx.getDaoSession().dbFetchFields(cursyssts);
			ctx.getDaoSession().dbCloseCursor();
			String syssts = cursyssts.getValue();
			String sts="";
			if("STARTUP".equals(syssts.trim()))
			{
			  sts="启运";
			}
			else
			{
			  sts="停运";
			}

			//log.debug("syssts="+syssts);
			// 页面赋值
			//Platform.setModified($cursyssts);
			
			this.setCursyssts(sts);
			

			if(!MdaUtils.isReturnCall())
			{
			  this.setBegtim( Platform.formatDateTime(MdaUtils.add(MdaUtils.today(),-3),"0"));
			  this.setEndtim( Platform.formatDateTime(MdaUtils.today(),"235959"));
			  //$usrmsggrp\\usrtab\\sta = "0";
			  //Platform.setModified($usrmsggrp\\usrtab\\sta);
			  //Platform.disable($usrmsggrp\\usrtab\\sta);
			  List<CodetableItem> list = new ArrayList<CodetableItem>();
			  list.add(new CodetableItem("待审核","00"));
			  list.add(new CodetableItem("审核失败","01"));
			  list.add(new CodetableItem("审核成功","02"));
			  MdaUtils.setValues(this,"sta",list);

			  List<CodetableItem> lst = new ArrayList<CodetableItem>();
			  lst.add(new CodetableItem("063","063"));//登录申请
			  lst.add(new CodetableItem("065","065"));//退出申请
			  MdaUtils.setValues(this,"subtyp",lst);
			}

			return true;
        }


        /**
        *   source:usrmsgp.@0004.script
        */
        public void query()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getUsrmsggrp().getUsrlst());
			String sql ="select * from usrtab where ";
			List args = new ArrayList();//建立一个List的写法。
			//申请序号
			if(!MdaUtils.isEmpty(this.getReqnum()))
			{
			  //val = val +" reqnum like '"+"%"+$usrmsggrp\\usrtab\\reqnum.getValue()+"%"+"' AND";
			  sql+=" reqnum LIKE ? AND ";
			  args.add("%"+this.getReqnum()+"%");
			}
			//报文子类型
			if(!MdaUtils.isEmpty(this.getSubtyp()))
			{
			  //val = val +" rsubtyp LIKE '"+"%"+$usrmsggrp\\usrtab\\subtyp+"%"+"' AND";
			  sql+=" subtyp LIKE ? AND ";
			  args.add("%"+this.getSubtyp()+"%");
			}
			//发送节点代码
			if(!MdaUtils.isEmpty(this.getSndcod()))
			{
			  //val = val +" sndcod like '"+"%"+$usrmsggrp\\usrtab\\sndcod.getValue()+"%"+"' AND";
			  sql+=" sndcod LIKE ? AND ";
			  args.add("%"+this.getSndcod()+"%");
			}
			//接收节点代码
			if(!MdaUtils.isEmpty(this.getRcvcod()))
			{
			  //val = val +" rcvcod like '"+"%"+$usrmsggrp\\usrtab\\rcvcod.getValue()+"%"+"' AND";
			  sql+=" rcvcod LIKE ? AND ";
			  args.add("%"+this.getRcvcod()+"%");
			}
			//报文处理码
			/*if(!Platform.isEmpty($mancod))
			  {
			  //val = val +" mancod like '"+"%"+$usrmsggrp\\usrtab\\mancod.getValue()+"%"+"' AND";
			  sql+=" mancod LIKE ? AND ";
			  args.add("%"+$mancod.getValue()+"%");
			  }*/
			//原识别信息
			if(!MdaUtils.isEmpty(this.getOriinf()))
			{
			  //val = val +"  oriinf like '"+"%"+$usrmsggrp\\usrtab\\oriinf.getValue()+"%"+"' AND";
			  sql+=" oriinf LIKE ? AND ";
			  args.add("%"+this.getOriinf()+"%");
			}
			//新识别信息
			if(!MdaUtils.isEmpty(this.getNewinf()))
			{
			  //val = val +" newinf like '"+"%"+$usrmsggrp\\usrtab\\newinf.getValue()+"%"+"' AND";
			  sql+=" newinf LIKE ? AND ";
			  args.add("%"+this.getNewinf()+"%");
			}
			//起始时间
			if(!MdaUtils.isEmpty(this.getBegtim()))
			{
			  //val = val +"rsptim >= "+$begtim.getValue()+" AND ";
			  sql+=" curdat>= ? AND ";
			  args.add(this.getBegtim());
			}
			//截止时间
			if(!MdaUtils.isEmpty(this.getEndtim()))
			{
			  //val = val +"rsptim < "+$endtim.getValue()+" AND ";
			  sql+=" curdat<= ? AND ";
			  args.add(this.getEndtim());
			}
			//a状态
			if(!MdaUtils.isEmpty(this.getSta()))
			{
			  //val = val +"rsptim < "+$endtim.getValue()+" AND ";
			  sql+=" sta= ? AND ";
			  args.add(this.getSta());
			}
			sql = sql +"typ is null or typ = '0' AND ";
			sql = sql +" 1=1 ORDER BY INR DESC";
			Platform.mdbExecuteSQL(sql,args.toArray());
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> reqnum = new Argument<String>("reqnum");
			Argument<String> subtyp = new Argument<String>("subtyp");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> sndcod = new Argument<String>("sndcod");
			Argument<String> rcvcod = new Argument<String>("rcvcod");
			Argument<String> mancod = new Argument<String>("mancod");
			Argument<String> oriinf = new Argument<String>("oriinf");
			Argument<String> newinf = new Argument<String>("newinf");
			Argument<String> rspcod = new Argument<String>("rspcod");
			Argument<String> rspinf = new Argument<String>("rspinf");
			Argument<Date> curdat = new Argument<Date>("curdat");
			Argument<Date> rsptim = new Argument<Date>("rsptim");
			Argument<String> mpiinr = new Argument<String>("mpiinr");
			while(true)
			{
			  Platform.mdbFetchFields(inr,reqnum,sta,subtyp,sndcod,rcvcod,mancod,oriinf,newinf,rspcod,rspinf,curdat,rsptim,mpiinr);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getUsrmsggrp().getUsrlst().add(inr,reqnum,sta,subtyp,sndcod,rcvcod,mancod,oriinf,newinf,rspcod,rspinf,curdat,rsptim,mpiinr);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			
			if(this.getUsrmsggrp().getUsrlst().fullSize() == 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrmsgp","CT000045"),MdaUtils.getI18NString("usrmsgp","CT000046"));
			  return;
			}
		}
        /**
        *   source:usrmsgp.@0013.script
        */
        public boolean storeMsgFromPlat(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GB18030"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubjectForMan(is,"HWE","txt","FMT","用户登录待审核报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  log.debug("{}","usrmsg smhinr:"+this.getSmpmod().getSmh().getInr());
			  log.debug("{}","mps inr:"+this.getSmpmod().getMps().getInr());
			  String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			  log.debug("{}","fileName:"+fileName);
			  if(!Platform.mfileExists(fileName))
			  { // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			    log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			    this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			    return false;
			  }
			  return (Boolean)this.getSmpmod().txtCreateMessageInformation(fileName,"txt");
			}
		}
        /**
        *   source:usrmsgp.@0018.script
        */
        public boolean storeMsgFromPlatWithoutChk(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("UTF-8"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}
			if(!this.getSmpmod().createMessageProcessSubject(is,"HWE","json","CPX","系统管理报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			else
			{
			  // Platform.message(#CT001195,#CT001196);
			  return true;
			}
		}
        /**
        *   source:usrmsgp.@0028.script
        */
        public boolean storeMsgFromPlatForFxps(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//存储报文内容至指定目录，并生成mps，mpi，smh信息
			//log.info("[SAVE_903_DOC]");
			MdaUtils.clear(this.getSmpmod().getFilstm());
			IStream is = this.getSmpmod().getFilstm();
			String str = (String)obj;
			try
			{
			  is.getOutputStream().write(str.getBytes("GBK"));
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","加载报文信息失败");
			  return false;
			}

			if(!this.getSmpmod().createMessageProcessSubjectForFxps(is,"AUT","jfx","FXP","保存Fxps相关json报文"))
			{
			  log.debug("{}","报文保存失败");
			  return false;
			}
			log.debug("{}","[FXPS_SMH_INR]:"+this.getSmpmod().getSmh().getInr());
			log.debug("{}","[FXPS_MPS_INR]:"+this.getSmpmod().getMps().getInr());
			String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			log.debug("{}","fileName:"+fileName);
			if(!Platform.mfileExists(fileName))
			{ // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			  log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			  this.getSmpmod().getMps().setSttdattim( MdaUtils.add(this.getSmpmod().getMps().getSttdattim(),DATE_SECOND,5));
			  return false;
			}
			return true;
		}
        /**
        *   source:usrmsgp.@0031.script
        */
        public String createcfad_050_001_01(String logininf)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			com.brilliance.jrxx.packet.model.cfad_050_001_01.Cfad_050_001_01 cfad_050_001_01 = new com.brilliance.jrxx.packet.model.cfad_050_001_01.Cfad_050_001_01();
			// 组装报文头
			this.getMsgmod().fillHead(cfad_050_001_01, "cfad.050.001.01");
			// 组装报文体
			com.brilliance.jrxx.packet.model.cfad_050_001_01.AdminInfo adminInfo = new com.brilliance.jrxx.packet.model.cfad_050_001_01.AdminInfo();
			com.brilliance.jrxx.packet.model.cfad_050_001_01.LoginInf loginInf = new com.brilliance.jrxx.packet.model.cfad_050_001_01.LoginInf();

			com.brilliance.jrxx.packet.model.cfad_050_001_01.MsgComData msgComData = this.createcfad_050_001_01MsgComData(cfad_050_001_01);
			cfad_050_001_01.MsgComData = msgComData;
			loginInf.LoginOprTp = logininf;
			adminInfo.SvrGrpInfo = "CFIX";
			adminInfo.LoginInf = loginInf;
			cfad_050_001_01.AdminInfo = adminInfo;
			String json = com.alibaba.fastjson.JSON.toJSONString(cfad_050_001_01);
			com.brilliance.jrxx.framework.Result result = (com.brilliance.jrxx.framework.Result)MdaUtils.invoke("com.brilliance.jrxx.utils.MsgUtil","packMessage",json);
			log.info("{}","xml="+result.getMessage());
			log.debug("{}",json);
			return json;
		}
        /**
        *   source:usrmsgp.@0032.script
        */
        public com.brilliance.jrxx.packet.model.cfad_050_001_01.MsgComData createcfad_050_001_01MsgComData(com.brilliance.jrxx.packet.model.com.Elcs elcs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			com.brilliance.jrxx.packet.model.cfad_050_001_01.MsgComData msgComData = new com.brilliance.jrxx.packet.model.cfad_050_001_01.MsgComData();
			msgComData.InstgPty = elcs.OrigSender;
			msgComData.InstdPty = elcs.OrigReceiver;
			msgComData.SndDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd'T'HH:mm:ss");
			msgComData.MsgId = elcs.MesgID;
			return msgComData;

		}
        /**
        *   source:usrmsgp.@0036.script
        */
        public String createcfad_012_001_01()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			com.brilliance.jrxx.packet.model.cfad_012_001_01.Cfad_012_001_01 cfad_012_001_01 = new com.brilliance.jrxx.packet.model.cfad_012_001_01.Cfad_012_001_01();

			// 组装报文头
			this.getMsgmod().fillHead(cfad_012_001_01, "cfad.012.001.01");
			// 组装报文体
			com.brilliance.jrxx.packet.model.cfad_012_001_01.MsgComData msgComData = this.createcfad_012_001_01MsgComData(cfad_012_001_01);
			com.brilliance.jrxx.packet.model.cfad_012_001_01.AdminInfo adminInfo = new com.brilliance.jrxx.packet.model.cfad_012_001_01.AdminInfo();

			cfad_012_001_01.MsgComData = msgComData;
			adminInfo.SysCd ="CFIX";
			cfad_012_001_01.AdminInfo = adminInfo;

			String json = com.alibaba.fastjson.JSON.toJSONString(cfad_012_001_01);
			log.debug("{}",json);
			ctx.storeData("msgid012",cfad_012_001_01.MesgID);
			return json;
		}
        /**
        *   source:usrmsgp.@0037.script
        */
        public com.brilliance.jrxx.packet.model.cfad_012_001_01.MsgComData createcfad_012_001_01MsgComData(com.brilliance.jrxx.packet.model.com.Elcs elcs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			com.brilliance.jrxx.packet.model.cfad_012_001_01.MsgComData msgComData = new com.brilliance.jrxx.packet.model.cfad_012_001_01.MsgComData();
			msgComData.InstgPty = elcs.OrigSender;
			msgComData.InstdPty = elcs.OrigReceiver;
			msgComData.SndDtTm = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd'T'HH:mm:ss");
			msgComData.MsgId = elcs.MesgID;
			return msgComData;
		}


        public void setUsrmsggrpHolder(ModuleHolder<Usrmsggrp> usrmsggrp)
        {
            this.usrmsggrp = usrmsggrp;
        }

        public Usrmsggrp getUsrmsggrp()
        {
           return this.usrmsggrp.get();
        }


        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }





















































































}