package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.bo.Url;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Usrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Usrp.class);

        //密码重置
        private IControl rst;

        //提交
        private IControl submit;

        //用户注销
        private IControl anl;

        //原密码
        private String oldpas;

        //新密码
        private String newpas1;

        //重复密码
        private String newpas2;

        //关联
        private IControl userol;

        //标题
        private String tit;

        //用户注册
        private IControl add;

        //用户修改
        private IControl ame;

        //返回
        private IControl cancel;

        //客户号
        private String dn;

        //查询
        private IControl sel;

        //级别
        private String lev;

        //详情
        private IControl inf;

        //登录名
        private String nam;

        //操作员名称
        private String dspnam;

        //用户状态
        private String sta;

        //解锁
        private IControl unl;

        //修改密码
        private IControl amepas;

        //个人信息修改
        private IControl ameinf;

        //常用交易配置
        private IControl comtra;

        //返回
        private IControl retdbp;

        //角色信息
        private String rolinf;

        //密码强弱图片
        private String mmp;

        //确认
        private IControl confirm;


        @JsonIgnore
        @BDGetter
        private transient IPanel pasp;

        @JsonIgnore
        @BDGetter
        private transient IPanel usrp;

        @JsonIgnore
        @BDGetter
        private transient IPanel logoffp;

        @JsonIgnore
        @BDGetter
        private transient IPanel edip;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel usrp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel usrp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel usrp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel usrp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel usrdel;

        @JsonIgnore
        @BDGetter
        private transient IPanel usrp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel usrp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel ediinfp;


		@BDGetter
		private ModuleList<Rol> rollst;

		@BDGetter
		private ModuleList<Rol> orirollst;

		@BDGetter
		private ModuleList<Usr> usrlst;

		@BDGetter
		private ModuleList<Pty> ptylst;

	    @BDGetter
		private Usrshw usrshw;

		@BDGetter
		private ModuleList<Usrshw> usrshwlst;

		@BDGetter
		private ModuleList<Url> urllst;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Mtabut> mtabut;

		@Module(getter = false, setter = false)
		private transient ModuleHolder<Usrgrp> usrgrp;


		public Usrp()
        {
            super();
            setArgument();
        }

        public Usrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:usrp.@0001.script
        */
        @Rule(target="cancel",order=100)
        public boolean ruleCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			String usrinr = this.getUsrgrp().getRec().getInr();//获取用户的唯一编号
			ctx.storeData("usrinr",usrinr);//将用户编号存入session
			

			return true;
        }

        /**
        *   source:usrp.@0014.script
        */
        @Rule(target="mtabut.rtn",order=100)
        public boolean ruleMtabutRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			String inr = this.getUsrgrp().getRec().getInr();
			ctx.storeData("usrinr",inr);
			//Platform.mchain("dbiusr");
			
			return true;
        }

        /**
        *   source:usrp.@0015.script
        */
        @Rule(target="mtabut.htymod.hty",order=100)
        public boolean ruleMtabutHtymodHtyN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMtabut().getHtymod().getLst());
			// 获取当前用户
			String userName = MdaEnv.getLoginUser();
			String sql1 = "SELECT pwd, inr FROM usr t WHERE t.nam = ?";
			Argument<String> md5PwdArgument = new Argument<String>("pwd");
			Argument<String> inrArgument = new Argument<String>("inr");
			ctx.getDaoSession().dbExecuteSQL(sql1,userName);
			String objinr = "";
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  ctx.getDaoSession().dbFetchFields(md5PwdArgument,inrArgument);
			  objinr = inrArgument.getValue();
			}
			ctx.getDaoSession().dbCloseCursor();
			Argument<Date> dattim =new Argument<Date>("dattim");
			Argument<String> usr =new Argument<String>("usr");
			Argument<String> txt =new Argument<String>("txt");
			String sql="select dattim,usr,dbms_lob.substr(txt) txt from sme where frmnam='dbpusr' and objinr=?  order by dattim desc";
			log.debug("{}","[objinr] "+objinr);
			ctx.getDaoSession().dbExecuteSQL(sql,objinr);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(dattim,usr,txt);
			  int error =ctx.getErrorCode();
			  if(error==NO_ERROR)
			  {
			    this.getMtabut().getHtymod().getLst().add(dattim,usr,txt);
			  }

			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
			

			return true;
        }

        /**
        *   source:usrp.@0016.script
        */
        @Rule(target="submit",order=100)
        public boolean ruleSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrp","CT000339"),MdaUtils.getI18NString("usrp","CT000340"));
			  return false;
			}
			String md5NewPwd1 = this.getNewpas1();
			String md5NewPwd2 = this.getNewpas2();
			if(!md5NewPwd1.equals(md5NewPwd2))
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrp","CT000349"),MdaUtils.getI18NString("usrp","CT000350"));
			  return false;
			}
			ctx.getDaoSession().dbBegin();
			//修改密码提交按钮
			// 获取当前用户
			String userName = MdaEnv.getLoginUser();
			log.debug("{}","usrName="+userName);
			// 根据用户名获取原密码（修改前密码）
			String sql = "SELECT pwd, inr FROM usr t WHERE t.nam = ?";
			Argument<String> md5PwdArgument = new Argument<String>("pwd");
			Argument<String> inrArgument = new Argument<String>("inr");
			ctx.getDaoSession().dbExecuteSQL(sql,userName);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  ctx.getDaoSession().dbFetchFields(md5PwdArgument,inrArgument);
			  String inr = inrArgument.getValue();
			  // 原密码的md5加密后的值
			  String md5Pwd = md5PwdArgument.getValue();
			  if(MdaUtils.isEmpty(md5Pwd))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("usrp","CT000363"),MdaUtils.getI18NString("usrp","CT000364"));
			    ctx.getDaoSession().dbCloseCursor();
			    ctx.getDaoSession().dbRollback();
			    return false;
			  }
			  log.debug("{}","md5Pwd="+md5Pwd);
			  // 校验原密码是否输入正确
			  String oldPwd = this.getOldpas();
			  if(!md5Pwd.equals(oldPwd))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("usrp","CT000398"),MdaUtils.getI18NString("usrp","CT000399"));
			    ctx.getDaoSession().dbCloseCursor();
			    ctx.getDaoSession().dbRollback();
			    return false;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  // 获取新密码
			  String md5NewPwd = this.getNewpas1();
			  log.debug("{}","md5NewPwd="+md5NewPwd);
			  if(md5Pwd.equals(md5NewPwd))
			  {
			    // 新旧密码一样，不允许修改
			    ctx.setMessage(MdaUtils.getI18NString("usrp","CT000421"),MdaUtils.getI18NString("usrp","CT000422"));
			    ctx.getDaoSession().dbRollback();
			    return false;
			  }
			  else
			  {
			    // 修改密码
			    String updateSql = "update usr t set t.pwd = ? where t.inr = ?";
			    ctx.getDaoSession().dbExecuteSQL(updateSql,md5NewPwd,inr);
			    ctx.getDaoSession().dbCloseCursor();
			    // 记录操作日志
			    MdaUtils.clear(this.getMtabut().getHtymod().getSme());
			    this.getMtabut().getHtymod().getSme().setUsr( userName);
			    this.getMtabut().getHtymod().getSme().setFrmnam( "dbpusr");
			    this.getMtabut().getHtymod().getSme().setOprtyp( "修改密码");
			    this.getMtabut().getHtymod().getSme().setDattim( MdaUtils.today());
			    this.getMtabut().getHtymod().getSme().setTabnam( "usr");
			    this.getMtabut().getHtymod().getSme().setTxt( "修改用户"+userName+"密码成功");
			    this.getMtabut().getHtymod().getSme().setObjinr( inr);
			    Platform.sdbInsert(this.getMtabut().getHtymod().getSme());
			    ctx.getDaoSession().dbCommit();
			    if(ctx.getErrorCode() == NO_ERROR)
			    {
			      ctx.setMessage(MdaUtils.getI18NString("usrp","CT000445"),MdaUtils.getI18NString("usrp","CT000446"));
			      // 退出登录
			      ctx.logout();
			      // 跳转到登录页面
			      
			    }
			    else
			    {
			      ctx.setMessage(MdaUtils.getI18NString("usrp","CT000447"),MdaUtils.getI18NString("usrp","CT000448"));
			      ctx.getDaoSession().dbRollback();
			      return false;
			    }

			  }
			}

			return true;
        }

        /**
        *   source:usrp.@0020.script
        */
        @Rule(target="confirm",order=100)
        public boolean ruleConfirmN100(){
            IContext ctx = MdaEnv.getContext();
            
			// 获取主键
			String usrinr = (String)ctx.restoreData("usrinr");
			// 获取页面输入
			// 用户号
			String usrnum = this.getUsrgrp().getRec().getUsrnum();
			// 身份证
			String usridn = this.getUsrgrp().getRec().getUsridn();
			// 登录名称
			String nam = this.getUsrgrp().getRec().getNam();
			// 操作员
			String dspnam = this.getUsrgrp().getRec().getDspnam();
			// 联系电话
			String tel = this.getUsrgrp().getRec().getTel();
			// 隶属机构
			String ptyinr = this.getUsrgrp().getRec().getPtyinr();
			// 电子邮件
			String eml = this.getUsrgrp().getRec().getEml();
			// 根据主键更新
			String sql = "update usr t set t.usrnum=?,t.usridn=?,t.nam=?,t.dspnam=?,t.tel=?,t.ptyinr=?,t.eml=? where t.inr = ?";
			ctx.getDaoSession().dbExecuteSQL(sql,usrnum,usridn,nam,dspnam,tel,ptyinr,eml,usrinr);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrp","CT000487"),MdaUtils.getI18NString("usrp","CT000488"));
			  
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("usrp","CT000489"),MdaUtils.getI18NString("usrp","CT000490"));
			}
			ctx.getDaoSession().dbCloseCursor();

			return true;
        }


        /**
        *   source:usrp.@0018.script
        */
        @Check(target="newpas1",order=100)
        public boolean checkNewpas1N100(){
            IContext ctx = MdaEnv.getContext();
            
			String newPwd1 = this.getNewpas1();
			if(MdaUtils.isEmpty(newPwd1))
			{
			  ctx.setFieldError(this,"newpas1",MdaUtils.getI18NString("usrp","CT000400"));
			  return false;
			}

			return true;
        }

        /**
        *   source:usrp.@0019.script
        */
        @Check(target="newpas2",order=100)
        public boolean checkNewpas2N100(){
            IContext ctx = MdaEnv.getContext();
            
			String newPwd1 = this.getNewpas2();
			if(MdaUtils.isEmpty(newPwd1))
			{
			  ctx.setFieldError(this,"newpas2",MdaUtils.getI18NString("usrp","CT000406"));
			  return false;
			}

			return true;
        }


        /**
        *   source:usrp.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> cts = getPtyCT();
			MdaUtils.setValues(this.getUsrgrp().getRec(),"ptyinr",cts);

			return true;
        }


        /**
        *   source:usrp.@0000.script
        */
        public Boolean isUserExist(String lgnnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Boolean res = true;
			String sql = "SELECT inr FROM usr WHERE nam = '" + lgnnam + "'";
			Argument<String> inrarg = new Argument<String>("inr");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(inrarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  res = true;
			}
			else
			{
			  res = false;
			}
			Platform.mdbCloseCursor();
			return res;
		}
        /**
        *   source:usrp.@0002.script
        */
        public List<CodetableItem> getPtyCT()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//获取邮储自身机构，ptytyp含'A'
			List<CodetableItem> cts = new ArrayList<CodetableItem>();
			Argument<String> arg = new Argument<String>("ptytyp",LIKE,"%A%");

			//增加实体查询条件
			arg=arg.and(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtyArg());

			arg=arg.and("status",EQ,"0");
			Platform.mdbReadset(this.getPtylst(),arg);
			log.debug("{}","@@@@ ptylst-size:" + this.getPtylst().fullSize() + " @@@@");
			for(int i=0;i<this.getPtylst().fullSize();i++)
			{
			  String inr = this.getPtylst().getElement(i).getInr();
			  String nam = this.getPtylst().getElement(i).getChnnam();
			  CodetableItem cti = new CodetableItem(nam,inr);
			  cts.add(cti);
			}
			log.debug("{}","@@@@ codetable-size:"+cts.size() + " @@@@");
			return cts;
		}
        /**
        *   source:usrp.@0005.script
        */
        public String getPtynam(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Platform.mdbRead(this.getUsrgrp().getPty(),new Argument<String>("inr",ptyinr));
			return this.getUsrgrp().getPty().getChnnam();
		}
        /**
        *   source:usrp.@0008.script
        */
        public String getRolinf(String usrinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rolinf = "";
			Platform.mdbReadset(this.getUrllst(),new Argument<String>("usrinr",usrinr));
			for(com.ceb.gjjs.mda.bo.Url url : this.getUrllst())
			{
			  String rolinr = url.getRolinr();
			  Platform.mdbRead(this.getUsrgrp().getRol(),new Argument<String>("inr",rolinr),new Argument<String>("flg","0"));
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    String rolnam = this.getUsrgrp().getRol().getNam();
			    rolinf += rolnam + ",";
			  }
			}
			if(!MdaUtils.isEmpty(rolinf))
			{
			  rolinf = rolinf.substring(0,rolinf.length() - 1);
			}
			return rolinf;
		}
        /**
        *   source:usrp.@0009.script
        */
        public int getPasswordLevel(String password)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 判断密码强弱性
			  @ password 密码字符
			  - int 0 - 弱, 1 - 中, 2 - 强
			  */
			if(password.length() < 8)
			  return 0;
			else
			{
			  //全数字 或 全连续字母 或 全部相同字符
			  if(password.matches("\\d+") || checkIsAllContinuousChar(password) || checkIsAllSameChar(password))
			    return 0 ;
			  else if(password.matches("([a-z]{6,})|([A-Z]{6,})"))
			    return 1;
			}
			return 2;
		}
        /**
        *   source:usrp.@0010.script
        */
        public boolean checkIsAllSameChar(String str)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 判断字符是否都由通一个字符组成
			  @ str 要判断的字符串
			  - boolean 是返回TRUE,否则返回FALSE
			  */
			char [] chars = str.toCharArray();
			char preChar = ' ';
			for(int i = 0;i < chars.length;i++)
			{
			  if(i == 0)
			    preChar = chars[0];
			  else
			    preChar = chars[i - 1];
			  if(preChar != chars[i])
			    return false;
			}
			return true;
		}
        /**
        *   source:usrp.@0011.script
        */
        public boolean checkIsAllContinuousChar(String str)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 检测字符串是否全是连续字符
			  @ str 需要检测的字符串
			  - boolean 是返回TRUE,否则返回FALSE
			  */
			char [] chars = str.toCharArray();
			char preChar = ' ';
			boolean isAsc = true;
			boolean isDesc = true;
			for(int i=0;i< chars.length; i++)
			{
			  char c = chars[i];
			  //判断ASCII是否是字母
			  if((c >=65 && c<= 90) || (c>=97 && c<=122))
			  {
			    if(i == 0)
			      continue;
			    else
			    {
			      preChar = chars[i - 1];
			      if(c - preChar != 1)
			        isAsc = false;	//不是升序连续字符
			    }
			  }
			  else
			    return false;	//有非字母 则不用比较是否连续字母
			}
			for(int i=0;i< chars.length; i++)
			{
			  char c = chars[i];
			  //判断ASCII是否是字母
			  if((c >=65 && c<= 90) || (c>=97 && c<=122))
			  {
			    if(i == 0)
			      continue;
			    else
			    {
			      preChar = chars[i - 1];
			      if(c - preChar != -1)
			        isDesc = false;	//不是降序连续字符
			    }
			  }
			  else
			    return false;	//有非字母 则不用比较是否连续字母
			}
			if(isAsc || isDesc)
			  return true;
			else
			  return false;
		}
        /**
        *   source:usrp.@0012.script
        */
        public String getBranchCode(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String bchcode=null;
			MdaUtils.clear(this.getUsrgrp().getPtyext());
			Platform.mdbRead(this.getUsrgrp().getPtyext(),new Argument<String>("inr",ptyinr));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  bchcode=this.getUsrgrp().getPtyext().getCid();
			}
			return bchcode;
		}
        /**
        *   source:usrp.@0013.script
        */
        public boolean exitUserBycid(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Boolean res = true;
			String sql = "SELECT inr FROM usr WHERE usrnum = '" + cid + "' AND (sta=? OR sta=?)";
			Argument<String> inrarg = new Argument<String>("inr");
			Platform.mdbExecuteSQL(sql,"0","2");
			Platform.mdbFetchFields(inrarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  res = true;
			}
			else
			{
			  res = false;
			}
			Platform.mdbCloseCursor();
			return res;
		}









        public void setMtabutHolder(ModuleHolder<Mtabut> mtabut)
        {
            this.mtabut = mtabut;
        }

        public Mtabut getMtabut()
        {
           return this.mtabut.get();
        }


        public void setUsrgrpHolder(ModuleHolder<Usrgrp> usrgrp)
        {
            this.usrgrp = usrgrp;
        }

        public Usrgrp getUsrgrp()
        {
           return this.usrgrp.get();
        }





















































}