package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CsndtlVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="csnp.cfixbankcode",dir= DirType.BOTH)
    private String csnp_cfixbankcode;

    @RelPath(value="csnp.cn",dir=DirType.BOTH)
    private String csnp_cn;

    @RelPath(value="csnp.gendat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date csnp_gendat;

    @RelPath(value="csnp.rem",dir=DirType.BOTH)
    private String csnp_rem;

    @RelPath(value="csnp.sn",dir=DirType.BOTH)
    private String csnp_sn;

    @RelPath(value="csnp.subtyp",dir=DirType.BOTH)
    private String csnp_subtyp;


}