package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CsnselVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="csngrp.csn.csntyp",dir= DirType.BOTH)
    private String csngrp_csn_csntyp;

    @RelPath(value="csngrp.csntmp.cfixbankcode",dir=DirType.BOTH)
    private String csngrp_csntmp_cfixbankcode;

    @RelPath(value="csnp.begdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date csnp_begdat;

    @RelPath(value="csnp.bnkbic",dir=DirType.BOTH)
    private String csnp_bnkbic;

    @RelPath(value="csnp.cfixbankcode",dir=DirType.BOTH)
    private String csnp_cfixbankcode;

    @RelPath(value="csnp.enddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date csnp_enddat;

    @RelPath(value="csnp.typ",dir=DirType.BOTH)
    private String csnp_typ;


}