package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.ceb.gjjs.mda.manager.module.Rcvlst;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FmtselVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="fmpp.act",dir= DirType.BOTH)
    private String fmpp_act;

    @RelPath(value="fmpp.actsta",dir=DirType.BOTH)
    private String fmpp_actsta;

    @RelPath(value="fmpp.amtend",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    private BigDecimal fmpp_amtend;

    @RelPath(value="fmpp.amtsta",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    private BigDecimal fmpp_amtsta;

    @RelPath(value="fmpp.cur",dir=DirType.BOTH)
    private String fmpp_cur;

    @RelPath(value="fmpp.dir",dir=DirType.BOTH)
    private String fmpp_dir;

    @RelPath(value="fmpp.endtim",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fmpp_endtim;

    @RelPath(value="fmpp.flg",dir=DirType.BOTH)
    private String fmpp_flg;

    @RelPath(value="fmpp.lbl",dir=DirType.BOTH)
    private String fmpp_lbl;

    @RelPath(value="fmpp.msgtyp",dir=DirType.BOTH)
    private String fmpp_msgtyp;

    @RelPath(value="fmpp.othref",dir=DirType.BOTH)
    private String fmpp_othref;

    @RelPath(value="fmpp.ownref",dir=DirType.BOTH)
    private String fmpp_ownref;

    @RelPath(value="fmpp.sta",dir=DirType.BOTH)
    private String fmpp_sta;

    @RelPath(value="fmpp.statim",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fmpp_statim;

    @RelPath(value="fmpp.subtyp",dir=DirType.BOTH)
    private String fmpp_subtyp;

    @RelPath(value="fmtgrp.rcvlst",dir=DirType.OUT)
    private ModuleList<Rcvlst> fmtgrp_rcvlst;


}