package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;

import com.ceb.gjjs.mda.manager.module.Rcvlst;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class RcvselVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="msggrp.rcvlst",dir= DirType.OUT)
    private ModuleList<Rcvlst> msggrp_rcvlst;

    @RelPath(value="rcvp.act",dir=DirType.BOTH)
    private String rcvp_act;

    @RelPath(value="rcvp.blktyp",dir=DirType.BOTH)
    private String rcvp_blktyp;

    @RelPath(value="rcvp.blktyplab",dir=DirType.BOTH)
    private String rcvp_blktyplab;

    @RelPath(value="rcvp.blktypvim",dir=DirType.BOTH)
    private String rcvp_blktypvim;

    @RelPath(value="rcvp.chnipt",dir=DirType.BOTH)
    private String rcvp_chnipt;

    @RelPath(value="rcvp.cur",dir=DirType.BOTH)
    private String rcvp_cur;

    @RelPath(value="rcvp.msgtyp",dir=DirType.BOTH)
    private String rcvp_msgtyp;

    @RelPath(value="rcvp.othref",dir=DirType.BOTH)
    private String rcvp_othref;

    @RelPath(value="rcvp.ownref",dir=DirType.BOTH)
    private String rcvp_ownref;

    @RelPath(value="rcvp.rcvdatend",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date rcvp_rcvdatend;

    @RelPath(value="rcvp.rcvdatsta",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date rcvp_rcvdatsta;

    @RelPath(value="rcvp.revbak",dir=DirType.BOTH)
    private String rcvp_revbak;

    @RelPath(value="rcvp.sndbak",dir=DirType.BOTH)
    private String rcvp_sndbak;

    @RelPath(value="rcvp.sta",dir=DirType.BOTH)
    private String rcvp_sta;

    @RelPath(value="rcvp.subtyp",dir=DirType.BOTH)
    private String rcvp_subtyp;

    @RelPath(value="rcvp.tblvim",dir=DirType.BOTH)
    private String rcvp_tblvim;

    @RelPath(value="rcvp.tblvis",dir=DirType.BOTH)
    private String rcvp_tblvis;


}