package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;

import com.ceb.gjjs.mda.manager.module.Rcvlst;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class SndselVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="msggrp.rcvlst",dir= DirType.OUT)
    private ModuleList<Rcvlst> msggrp_rcvlst;

    @RelPath(value="sndp.act",dir=DirType.BOTH)
    private String sndp_act;

    @RelPath(value="sndp.chnipt",dir=DirType.BOTH)
    private String sndp_chnipt;

    @RelPath(value="sndp.cur",dir=DirType.BOTH)
    private String sndp_cur;

    @RelPath(value="sndp.msgtyp",dir=DirType.BOTH)
    private String sndp_msgtyp;

    @RelPath(value="sndp.othref",dir=DirType.BOTH)
    private String sndp_othref;

    @RelPath(value="sndp.ownref",dir=DirType.BOTH)
    private String sndp_ownref;

    @RelPath(value="sndp.rcvdatend",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date sndp_rcvdatend;

    @RelPath(value="sndp.rcvdatsta",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date sndp_rcvdatsta;

    @RelPath(value="sndp.revbak",dir=DirType.BOTH)
    private String sndp_revbak;

    @RelPath(value="sndp.rspsta",dir=DirType.BOTH)
    private String sndp_rspsta;

    @RelPath(value="sndp.sndbak",dir=DirType.BOTH)
    private String sndp_sndbak;

    @RelPath(value="sndp.subtyp",dir=DirType.BOTH)
    private String sndp_subtyp;

    @RelPath(value="sndp.tblrsm",dir=DirType.BOTH)
    private String sndp_tblrsm;

    @RelPath(value="sndp.tblrsp",dir=DirType.BOTH)
    private String sndp_tblrsp;


}