package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pthlst;
import com.ceb.gjjs.mda.bo.Cetcsn;
import com.ceb.gjjs.mda.bo.Xhxact;
import com.ceb.gjjs.mda.bo.Mpe;
import com.ceb.gjjs.mda.bo.Stc;
import com.ceb.gjjs.mda.bo.Csn;
import com.ceb.gjjs.mda.bo.Gpe;
import com.ceb.gjjs.mda.bo.Mcr;
import com.ceb.gjjs.mda.bo.Icr;
import com.ceb.gjjs.mda.bo.Dat;
import com.ceb.gjjs.mda.bo.Swepty;
import com.ceb.gjjs.mda.bo.Yss;
import com.ceb.gjjs.mda.bo.Cpstim;
import com.ceb.gjjs.mda.bo.Sed;
import com.ceb.gjjs.mda.bo.Dta;
import com.ceb.gjjs.mda.bo.Mps;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.bo.Fxdrig;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Chn;
import com.ceb.gjjs.mda.bo.Xhxdta;
import com.ceb.gjjs.mda.bo.Gss;
import com.ceb.gjjs.mda.bo.Mpi;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Structured Message Process Module
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Smpmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Smpmod.class);

        //报文保存根路径（配置文件读取）
        private String rootpath;

        //报文保存相对路径
        private String datapath;

        //保存文件完整目录
        private String fulldatapath;

        //文件数据流（类似格式转换使用）
        private IStream filstm = new StreamImpl();

        //新建或退回报文标志
        private String edtflg;

        //存储smh主键
        private String smhinr;

        //存储临时MAP
        private Map maptmp;

        //chnmap
        private Map chnmap;

        //CIPS报文存储路径
        private String cipsdatapath;

        //CIPS报文存储全路径
        private String cipsfulldatapath;

        //上划下拨报文存储路径
        private String b2edatapath;

        //上划下拨报文存储全路径
        private String b2efulldatapath;

        //新一代资金业务报文存储路径
        private String zywdatapath;

        //新一代资金业务报文存储全路径
        private String zywfulldatapath;

        //电证报文存储全路径
        private String elcsfulldatapath;

        //电证报文存储路径
        private String elcsdatapath;

        //应急报文流
        private IStream swestm = new StreamImpl();

        //新核心白名单验证开关
        private String xflag;

        //新核心切换过渡开关
        private String qflag;

        //新核心反欺诈开关
        private String fqzflag;

        //新核心CIPS切换过渡开关
        private String qflag1;

        //新核心CIPS白名单验证开关
        private String xflag1;

        //cisp校验失败反馈接口
        private String cipsflg;



	    @BDGetter
		private Mps mps;

	    @BDGetter
		private Mps nxtmps;

	    @BDGetter
		private Mpi mpi;

	    @BDGetter
		private Mpe mpe;

		@BDGetter
		private ModuleList<Mpe> mpelst;

	    @BDGetter
		private Smh smh;

	    @BDGetter
		private Smh nxtsmh;

	    @BDGetter
		private Chn chn;

	    @BDGetter
		private Chn nxtchn;

	    @BDGetter
		private Chn tgtchn;

		@BDGetter
		private ModuleList<Mps> mpslst;

	    @BDGetter
		private Dat dat;

	    @BDGetter
		private Csn csn;

		@BDGetter
		private ModuleList<Smh> smhlst;

	    @BDGetter
		private Smh smhtmp;

		@BDGetter
		private ModuleList<Pthlst> pthlst;

		@BDGetter
		private ModuleList<Mpe> mpetmplst;

		@BDGetter
		private ModuleList<Smh> smhtmplst;

	    @BDGetter
		private Mpi mpitmp;

	    @BDGetter
		private Mps mpstmp;

	    @BDGetter
		private Gpe gpe;

		@BDGetter
		private ModuleList<Gpe> gpelst;

	    @BDGetter
		private Mpe mpetmp;

	    @BDGetter
		private Qrtmod qrtmod;

	    @BDGetter
		private Yss yss;

	    @BDGetter
		private Cetcsn cetcsn;

	    @BDGetter
		private Mcr mcr;

	    @BDGetter
		private Icr icr;

		@BDGetter
		private ModuleList<Cpstim> cpstimlst;

	    @BDGetter
		private Sed sed;

	    @BDGetter
		private Cpstim cpstim;

	    @BDGetter
		private Swemod swemod;

		@BDGetter
		private ModuleList<Mpi> mpilst;

	    @BDGetter
		private Gss gss;

	    @BDGetter
		private Swepty swepty;

	    @BDGetter
		private Fxdrig fxdrig;

	    @BDGetter
		private Stc stc;

		@BDGetter
		private ModuleList<Stc> stclst;

	    @BDGetter
		private Dta dta;

	    @BDGetter
		private Actreqpho actreqpho;

	    @BDGetter
		private Xhxdta xhxdta;

	    @BDGetter
		private Xhxact xhxact;

	    @BDGetter
		private Msgmod msgmod;

	    @BDGetter
		private Mps mpsorg;

	    @BDGetter
		private Mpi mpiorg;


		public Smpmod()
        {
            super();
            setArgument();
        }

        public Smpmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }



        /**
        *   source:smpmod.@0009.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  * 从配置文件读取相关设置信息
			  */
			String fileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			fileName = MdaUtils.catPath(fileName,"rcvsndmsg.properties");
			this.setRootpath( MdaUtils.getPropertyValue(fileName,"rootpath"));
			this.getMsgmod().setRootpath( MdaUtils.getPropertyValue(fileName,"rootpath"));
			if(MdaUtils.isEmpty(this.getRootpath()))
			  this.setRootpath( ctx.getEnvConfig().getRootPath());
			log.debug("{}","rootpath:"+this.getRootpath());
			this.setDatapath( MdaUtils.getPropertyValue(fileName,"datapath"));
			this.getMsgmod().setDatapath( MdaUtils.getPropertyValue(fileName,"datapath"));
			if(MdaUtils.isEmpty(this.getDatapath()))
			  this.setDatapath( "data/rcvmsg");
			log.info("{}","datapath:"+this.getDatapath());
			String fullDataPath = MdaUtils.catPath(this.getRootpath(),this.getDatapath());
			this.setFulldatapath( fullDataPath);
			this.getMsgmod().setFulldatapath( MdaUtils.catPath(this.getMsgmod().getRootpath(),this.getMsgmod().getDatapath()));
			log.info("{}","fulldatapath:"+fullDataPath);
			if(!Platform.mfileExists(fullDataPath))
			  Platform.mfileMkdirs(fullDataPath);
			//20170901新加，CIPS报文另行存储
			this.setCipsdatapath( MdaUtils.getPropertyValue(fileName,"cipsdatapath"));
			this.getMsgmod().setCipsdatapath( MdaUtils.getPropertyValue(fileName,"cipsdatapath"));
			if(MdaUtils.isEmpty(this.getCipsdatapath()))
			  this.setCipsdatapath( "data/cipsmsg");
			log.info("{}","cipsdatapath:"+this.getCipsdatapath());
			String cipsFullDataPath = MdaUtils.catPath(this.getRootpath(),this.getCipsdatapath());
			this.setCipsfulldatapath( cipsFullDataPath);
			this.getMsgmod().setCipsfulldatapath( MdaUtils.catPath(this.getMsgmod().getRootpath(),this.getMsgmod().getCipsdatapath()));
			log.info("{}","cipsfulldatapath:"+cipsFullDataPath);
			if(!Platform.mfileExists(cipsFullDataPath))
			  Platform.mfileMkdirs(cipsFullDataPath);
			//20171214新加，清算上划下拨报文另行存储
			this.setB2edatapath( MdaUtils.getPropertyValue(fileName,"b2edatapath"));
			if(MdaUtils.isEmpty(this.getB2edatapath()))
			  this.setB2edatapath( "b2emsg");
			log.info("{}","b2edatapath:"+this.getB2edatapath());
			String b2eFullDataPath = MdaUtils.catPath(this.getRootpath(),this.getB2edatapath());
			this.setB2efulldatapath( b2eFullDataPath);
			log.info("{}","b2efulldatapath:"+b2eFullDataPath);
			if(!MdaUtils.fileExists(b2eFullDataPath))
			  MdaUtils.fileMkdirs(b2eFullDataPath);

			//20180820新加，新一代资金业务报文另行存储
			this.setZywdatapath( MdaUtils.getPropertyValue(fileName,"zywdatapath"));
			if(MdaUtils.isEmpty(this.getZywdatapath()))
			  this.setZywdatapath( "zywmsg");
			log.info("{}","zywdatapath:"+this.getZywdatapath());
			String zywFullDataPath = MdaUtils.catPath(this.getRootpath(),this.getZywdatapath());
			this.setZywfulldatapath( zywFullDataPath);
			log.info("{}","zywfulldatapath:"+zywFullDataPath);
			if(!MdaUtils.fileExists(zywFullDataPath))
			  MdaUtils.fileMkdirs(zywFullDataPath);

			//20190830新加电证
			this.setElcsdatapath( MdaUtils.getPropertyValue(fileName,"elcsdatapath"));
			if(MdaUtils.isEmpty(this.getElcsdatapath()))
			  this.setElcsdatapath( "data/elcsmsg");
			log.info("{}","elcsdatapath:"+this.getElcsdatapath());
			String elcsFullDataPath = MdaUtils.catPath(this.getRootpath(),this.getElcsdatapath());
			this.setElcsfulldatapath( elcsFullDataPath);
			log.info("{}","elcsfulldatapath:"+elcsFullDataPath);
			if(!Platform.mfileExists(elcsFullDataPath))
			  Platform.mfileMkdirs(elcsFullDataPath);

			//新核心白名单开关 Y:开  X:关
			this.setXflag( MdaUtils.getPropertyValue(fileName,"xflag"));
			//新核心切换过渡开关 Y:开  X:关
			this.setQflag( MdaUtils.getPropertyValue(fileName,"qflag"));
			//新核心反欺诈开关 Y:开  X:关
			this.setFqzflag( MdaUtils.getPropertyValue(fileName,"fqzflag"));
			//新核心CIPS切换过渡开关 Y:开  X:关
			this.setQflag1( MdaUtils.getPropertyValue(fileName,"qflag_cips"));
			//新核心CIPS白名单验证开关 Y:开  X:关
			this.setXflag1( MdaUtils.getPropertyValue(fileName,"xflag_cips"));

			return true;
        }


        /**
        *   source:smpmod.@0000.script
        */
        public boolean createMessageProcessSubject(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			log.info("{}","smpmod test log");
			/*
			  Platform.esdbRead($chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			readChn(this.getChn(),channel);

			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}
			/*
			  Platform.mdbBegin();
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }*/
			int errorcode = ctx.getErrorCode();
			log.debug("{}","before mdbBegin");
			Platform.mdbBegin();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");
			/// 保存收发报处理主记录信息(MPS)
			log.info("{}","chn\typ="+this.getChn().getTyp());
			log.info("{}","tgtchn\typ="+this.getTgtchn().getTyp());
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "A"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			Platform.sdbInsert(this.getMps());
			errorcode = ctx.getErrorCode();
			log.info("{}","mps insert error code="+errorcode);
			if(errorcode != NO_ERROR)
			{
			  log.info("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "A"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;
			if("cfix|xml".contains(messageType))
			{
			  fileName = getCipsStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getCipsdatapath());
			}
			else
			  fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			log.info("{}","smpmod dbCommit...");
			Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0001.script
        */
        public boolean fetchAndLockMessage(String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			  {
			    log.debug("{}","锁定mps记录失败，inr="+mps.getInr());
			    continue;
			  }
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  //20180608新建，监控需要获取mpi相关记录信息
			  MdaUtils.clear(this.getMpi());
			  if(!MdaUtils.isEmpty(this.getMps().getPntinr()))
			  {
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getPntinr()));
			  }
			  else
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  if(!MdaUtils.isEmpty(this.getMpi().getInr()))
			    log.info("{}","mpiinr:"+this.getMpi().getInr());
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  if(ctx.getErrorCode()!=NO_ERROR)
			    continue;
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0003.script
        */
        public boolean getOrCreateMessageInformation(String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取或新建报文的处理信息
			  */

			MdaUtils.clear(this.getMpi());
			log.info("{}","getOrCreateMessageInformation mpsinr="+this.getMps().getInr());
			// 错误次数达到3次置E状态在返回的函数中进行处理判断(作为创建信息，均必须由XXXTSK完成)
			if(MdaUtils.isEmpty(this.getMps().getPntinr()))
			{
			  Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  log.info("{}","getOrCreateMessageInformation mpiinr="+this.getMpi().getInr());
			}
			else
			  Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getPntinr()));

			if(ctx.getErrorCode()==NO_ERROR)
			{
			  return true;
			}

			log.info("{}",this.getSmh().getDocfil());
			log.info("{}",this.getSmh().getDocfxt());
			// 未读取到MPI信息则重新生成(不同报文动态调用指定类型的方法)
			String fileName = null;
			if("cips|xml".contains(messageType))
			  fileName = getCipsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			else if("b2e|jsh".contains(messageType))
			{
			  fileName = getB2eStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			}
			else if("nxl".contains(messageType))
			{
			  fileName = getZywStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			}
			//20190830新加电证
			else if("elcs|exl".contains(messageType))
			{
			  fileName = getElcsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			}
			else
			  fileName = getStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());

			if(this.getMps().getIsmx()== 1)
			{
			  String xmlFileName = fileName.replaceAll(".sf2",".xml");
			  if(!Platform.mfileExists(xmlFileName))
			  { // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			    log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + xmlFileName);
			    this.getMps().setSttdattim( MdaUtils.add(this.getMps().getSttdattim(),DATE_SECOND,5));
			    return false;
			  }
			}
			else
			{
			  if(!Platform.mfileExists(fileName))
			  { // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			    log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			    this.getMps().setSttdattim( MdaUtils.add(this.getMps().getSttdattim(),DATE_SECOND,5));
			    return false;
			  }
			}

			boolean isSWE = false;
			if("SWE".equalsIgnoreCase(this.getMps().getSrcchncod()) && "xxxtsk".equalsIgnoreCase(ctx.getTransName().trim()))
			{
			  isSWE = true;
			  log.debug("{}","db before gisp:" + Platform.getDefaultDB());
			  if(!gispCreateMessageInformation(fileName, messageType))
			  {
			    log.debug("{}","解析SWE报文失败");
			    return false;
			  }
			  else
			  {
			    if("E".equals(this.getMps().getSta()))
			    {
			      log.debug("{}","NCK GISP报文,退出处理");
			      return true;
			    }
			  }
			  log.debug("{}","db after gisp:" + Platform.getDefaultDB());
			}

			String methodName = messageType;
			if(this.getMps().getIsmx()== 1)
			{
			  methodName += "MxCreateMessageInformation";
			}
			else
			{
			  methodName += "CreateMessageInformation";
			}
			log.debug("{}","methodName:"+methodName);
			try
			{
			  /*if("xml".equals(messageType))
			    {
			    String chncod = $mps\\srcchncod.getValue();
			    Boolean succ = (Boolean)Platform.invoke($this,methodName,fileName,messageType,chncod);
			    if(isSWE)
			    {
			    if(!succ)
			    return succ;
			    else
			    {
			    return $swemod.updateSedEntryInformation($mps,$mpi);
			    }
			    }
			    else
			    return succ;
			    }
			    else*/
			  log.info("{}","methodName="+methodName+"-fileName="+fileName+"-messageType="+messageType);
			  return (Boolean)MdaUtils.invoke(this,methodName,fileName,messageType);
			}
			catch(Exception e)
			{
			  log.error("{}","rxxtsk exception :",e);
			}
			return false;
		}
        /**
        *   source:smpmod.@0006.script
        */
        public boolean sf2CreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");
			Object object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsgInfo",fileName);
			if(object==null||!(object instanceof Map))
			  return false;
			Map<String,String> map = (Map)object;
			log.trace("{}","map:"+map);

			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getMpi(),map);
			log.debug("{}","inr :"+this.getMpi().getEtyinr());

			//20171026新加，gpi标识
			if(!MdaUtils.isEmpty(map.get("gpiFlg")))
			{
			  this.getMpi().setGpi( map.get("gpiFlg"));
			}
			//20181022新加，UETR信息
			if(!MdaUtils.isEmpty(map.get("UETR")))
			{
			  this.getMpi().setUetr( map.get("UETR"));
			}
			//20181221新加，GPI的值信息
			if(!MdaUtils.isEmpty(map.get("gpiVal")))
			{
			  this.getMpi().setGpival( map.get("gpiVal"));
			}
			//20181228新加，GPI相关收费信息
			if(!MdaUtils.isEmpty(map.get("sellamt")))
			{
			  this.getMpi().setSelamt( MdaUtils.parseDecimal(map.get("sellamt")));
			}
			if(!MdaUtils.isEmpty(map.get("sellcur")))
			{
			  this.getMpi().setSelcur( map.get("sellcur"));
			}
			if(!MdaUtils.isEmpty(map.get("71Fmsg")))
			{
			  this.getMpi().setMsg71f( map.get("71Fmsg"));
			}

			//20181129新增系统跟踪号字段
			// Object sysTrackNo = Platform.invoke("cn.com.brilliance.psbc.service.zjyw.handle.AbsYWServiceHandler","getSysTrackNo");
			//20190102更新系统跟踪号生成规则  11位发起系统码+8位时间+15随机数
			/*String  sys_Track_No = "99306000000"+Platform.format(new Date(),"yyyyMMdd")+Platform.sdbCounter("rad","000000000000000");
			  log.info("系统跟踪号：" + sys_Track_No);
			  if(!Platform.isEmpty(sys_Track_No))
			  {
			  $mpi\\systrackn = sys_Track_No;
			  }*/
			//20181227新增会计日期，用于日后对账使用
			this.getMpi().setAccdat( Platform.getAccountDate());
			log.info("{}","会计日期："+this.getMpi().getAccdat());
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","sf2 nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map.get("mty"));
			this.getMpi().setSndnum( map.get("sndnum"));
			if(">".equals(this.getMps().getDir()))
			{
			  this.getMpi().setOwnref( map.get("tscref"));
			  this.getMpi().setOthref( map.get("ref"));
			}
			else
			{
			  this.getMpi().setOwnref( map.get("ref"));
			  this.getMpi().setOthref( map.get("tscref"));
			  if(MdaUtils.isEmpty(this.getMpi().getSndnum()))
			  {
			    /// 注：这里很特殊，非正常的格式转换（正常格式转换通过相应状态变迁实现）
			    String nextSmhInr = Platform.sdbCounter("smh");
			    String sendNumber = "GJZFQZ" + nextSmhInr;
			    String orgFileName = getMessageFullPathName();
			    log.debug("{}","sf2 orgFileName:"+orgFileName);
			    MdaUtils.clear(this.getFilstm());
			    Object result=MdaUtils.invoke("cn.com.brilliance.eibs.SwiftUtils","insertSendNumber",orgFileName,this.getFilstm(),sendNumber);
			    if(result instanceof Boolean && (Boolean)result)
			    {
			      /// 记录MPE处理信息
			      MdaUtils.clear(this.getMpe());
			      this.getMpe().setMpsinr( this.getMps().getInr());
			      this.getMpe().setChncod( this.getMps().getChncod());
			      this.getMpe().setNxtchncod( this.getMps().getChncod());
			      this.getMpe().setSmhinr( this.getSmh().getInr());
			      this.getMpe().setNxtsmhinr( nextSmhInr);
			      this.getMpe().setDattim( new Date());
			      this.getMpe().setPrvsta( this.getMps().getSta());
			      this.getMpe().setSta(  this.getMps().getSta());
			      this.getMpe().setTxt( "自动添加SWIFT报文发送流水号.");
			      this.getMpe().setUsr( MdaEnv.getLoginUser());
			      this.getMpe().setFrmnam( ctx.getTransName());
			      Platform.sdbInsert(this.getMpe());
			      /// 记录SMH信息
			      this.getNxtsmh().setInr( nextSmhInr);
			      this.getNxtsmh().setObjtyp( "mpe");
			      this.getNxtsmh().setObjinr( this.getMpe().getInr());
			      this.getNxtsmh().setCrtfrm( ctx.getTransName());
			      this.getNxtsmh().setDattim( new Date());
			      this.getNxtsmh().setDocpth( this.getDatapath());
			      this.getNxtsmh().setDocfil( nextSmhInr);
			      this.getNxtsmh().setDocfxt( "sf2");
			      String nextFileName = getStoreFileFullPathName(nextSmhInr,"sf2");
			      Platform.mstreamSave(this.getFilstm(),nextFileName);
			      this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			      this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			      this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			      Platform.mdbInsert(this.getNxtsmh());
			      /// 更新MPS信息（Update在unlock为执行）
			      this.getMps().setSmhinr( nextSmhInr);
			      /// 更新MPI信息
			      this.getMpi().setSndnum( sendNumber);

			      if(!MdaUtils.isEmpty(this.getMpi().getUetr()) && "192|196|199".contains(this.getMpi().getSubtyp()) && !MdaUtils.isEmpty(this.getMpi().getGpi()))
			      {
			        log.info("{}","更新对应的rof记录");
			        MdaUtils.clear(this.getQrtmod().getRof());
			        Platform.mdbRead(this.getQrtmod().getRof(),new Argument("megnum",EQ,this.getSmh().getInr()));
			        if(!MdaUtils.isEmpty(this.getQrtmod().getRof().getInr()))
			        {
			          this.getQrtmod().createQreInfo(this.getQrtmod().getRof().getCasnum(),"报文复核通过","X");
			          String rem = this.getQrtmod().getRof().getRem();
			          String newrem = rem + ";报文复核通过";
			          log.debug("{}","msgchk.更新rof"+newrem);
			          this.getQrtmod().getRof().setRem( newrem);
			          this.getQrtmod().getRof().setMegnum( this.getMps().getSmhinr());//经过格式转化后，最终发出报文的smhinr
			          Platform.mdbUpdate(this.getQrtmod().getRof());
			        }
			        else
			        {
			          ctx.getErrorCode();//清除dbRead查询无记录时的errorcode:228
			        }
			      }
			    }
			  }
			}
			log.debug("{}","sf2 mpi sndnum:"+this.getMpi().getSndnum());
			this.getMpi().setSndbic( formatBIC(map.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map.get("rcvbic")));
			this.getMpi().setActbic( formatBIC(map.get("actbic")));
			this.getMpi().setT53bic( formatBIC(map.get("t53bic")));
			this.getMpi().setAct( map.get("act"));
			this.getMpi().setCur( map.get("cur"));
			this.getMpi().setRpscod( map.get("errcod"));
			this.getMpi().setAmt( MdaUtils.parseDecimal(map.get("amt")));
			this.getMpi().setValdat( MdaUtils.parseDate(map.get("vludat"),"yyMMdd"));
			this.getMpi().setGendat( new Date());
			this.getMpi().setDtlchg( map.get("dtlchg"));
			List<String> noTags = new ArrayList();
			noTags.add("20");
			object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "sf2");
			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());

			if("103|192|202COV".contains(this.getMpi().getSubtyp()) && !MdaUtils.isEmpty(this.getMpi().getUetr()))
			  saveMsg103ToGpe(map.get("addinfo"));

			return true;
		}
        /**
        *   source:smpmod.@0017.script
        */
        public boolean jsnCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( "sf2");
			//生成报文，返回资金清算的发报流水号
			String nextSmhInr = Platform.sdbCounter("smh");
			String srcnum = null;
			//20170821修改，将原202报文内容附加值292COPY域
			Object mapObject = MdaUtils.invoke("com.brilliance.swift.MessageReader","getMapFromJsonFile",fileName);
			if(mapObject==null||!(mapObject instanceof Map))
			{
			  log.error("{}","从Json获取Map失败");
			  return false;
			}
			//@20220128 sulike 清空流，生产出现不同报文放在同一文件中
			MdaUtils.clear(this.getFilstm());
			Map msgMap = (Map)mapObject;
			String pcode = (String) msgMap.get("PCODE");
			if("001292".equals(pcode) && !MdaUtils.isEmpty(msgMap.get("ORGSEQNO")))
			{
			  log.debug("{}","开始处理MT292报文...");
			  String relref = (String)msgMap.get("ORGSEQNO");
			  String orgfilnam = null;
			  MdaUtils.clear(this.getMpitmp());
			  MdaUtils.clear(this.getMpstmp());
			  MdaUtils.clear(this.getSmhtmp());
			  Platform.mdbRead(this.getMpitmp(),new Argument("ownref",relref).and("subtyp","202").and("msgtyp","sf2"));
			  if(!MdaUtils.isEmpty(this.getMpitmp().getInr()))
			    Platform.mdbRead(this.getMpstmp(),new Argument("inr",this.getMpitmp().getInr()));
			  log.debug("{}","mpitmp-inr:"+this.getMpitmp().getInr());
			  if(!MdaUtils.isEmpty(this.getMpstmp().getSmhinr()))
			    Platform.mdbRead(this.getSmhtmp(),new Argument("inr",this.getMpstmp().getSmhinr()));
			  log.debug("{}","mpstmp-inr:"+this.getMpstmp().getInr());
			  if(!MdaUtils.isEmpty(this.getSmhtmp().getInr()))
			    orgfilnam = getStoreFileFullPathName(this.getSmhtmp().getDocfil(),this.getSmhtmp().getDocfxt());
			  log.debug("{}","smhtmp-inr:"+this.getSmhtmp().getInr());
			  log.debug("{}","orgfilnam:"+orgfilnam);
			  //开始根据json信息和原202报文内容组装292报文
			  log.debug("{}","调用外部函数生成MT292报文...");
			  if(!MdaUtils.isEmpty(orgfilnam))
			    srcnum = (String)MdaUtils.invoke("com.brilliance.swift.MessageReader","gener292MessageAndSave",fileName,orgfilnam,nextSmhInr,this.getFilstm());
			  else
			    srcnum = (String)MdaUtils.invoke("com.brilliance.swift.MessageReader","gener202MessageAndSave",fileName,nextSmhInr,this.getFilstm());//开始转换报文
			}
			else
			  srcnum = (String)MdaUtils.invoke("com.brilliance.swift.MessageReader","gener202MessageAndSave",fileName,nextSmhInr,this.getFilstm());//开始转换报文
			if(srcnum == null)
			  return false;
			String nextFileName = getStoreFileFullPathName(nextSmhInr,"sf2");//对新报文命名
			Platform.mstreamSave(this.getFilstm(),nextFileName);	//保存新sf2报文
			Object object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsgInfo",nextFileName);
			if(object==null||!(object instanceof Map))
			  return false;
			Map<String,String> map = (Map)object;
			log.trace("{}","map:"+map);

			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getMpi(),map);

			this.getMpi().setSubtyp( map.get("mty"));
			this.getMpi().setSndnum( map.get("sndnum"));
			this.getMpi().setOwnref( map.get("ref"));
			this.getMpi().setOthref( map.get("tscref"));
			this.getMpi().setSrcnum( srcnum);
			/// 记录新的MPE处理信息
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "JSON转换的SWFIT报文.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			log.debug("{}","插入JSON转换报文MPE");
			Platform.sdbInsert(this.getMpe());
			log.debug("{}","插入JSON转换报文MPE后");
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getDatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "sf2");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			/// 更新MPS信息（Update在unlock为执行）
			this.getMps().setSmhinr( nextSmhInr);
			/// 更新MPI信息
			this.getMpi().setSndnum( map.get("sndnum"));
			this.getMpi().setSndbic( formatBIC(map.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map.get("rcvbic")));
			this.getMpi().setActbic( formatBIC(map.get("actbic")));
			this.getMpi().setT53bic( formatBIC(map.get("t53bic")));
			this.getMpi().setAct( map.get("act"));
			this.getMpi().setCur( map.get("cur"));
			this.getMpi().setRpscod( map.get("errcod"));
			this.getMpi().setAmt( MdaUtils.parseDecimal(map.get("amt")));
			this.getMpi().setValdat( MdaUtils.parseDate(map.get("vludat"),"yyMMdd"));
			this.getMpi().setGendat( new Date());
			this.getMpi().setDtlchg( map.get("dtlchg"));
			//20181023新加，UETR信息
			if(!MdaUtils.isEmpty(map.get("UETR")))
			{
			  this.getMpi().setUetr( map.get("UETR"));
			}
			//20171026新加，gpi标识
			if(!MdaUtils.isEmpty(map.get("gpiFlg")))
			{
			  this.getMpi().setGpi( map.get("gpiFlg"));
			}
			//20181221新加，GPI的值信息
			if(!MdaUtils.isEmpty(map.get("gpiVal")))
			{
			  this.getMpi().setGpival( map.get("gpiVal"));
			}

			List<String> noTags = new ArrayList();
			noTags.add("20");
			object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			Platform.mdbInsert(this.getMpi());
			log.debug("{}","插入了MPI");
			this.getSmh().setMpiinr( this.getMpi().getInr());
			Platform.mdbUpdate(this.getSmh());
			return true;
		}
        /**
        *   source:smpmod.@0036.script
        */
        public Boolean qakCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	查询查复业务要素文件处理
			  */
			this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			String typ = MdaUtils.getPropertyValue(fileName,"typ");
			this.getMpi().setSubtyp( typ);
			String relref = MdaUtils.getPropertyValue(fileName,"relref");
			this.getMpi().setOwnref( relref);
			this.getMpi().setOthref( relref);
			this.getMpi().setGendat( MdaUtils.today());
			Platform.mdbInsert(this.getMpi());
			this.getSmh().setMpiinr( this.getMpi().getInr());
			Platform.mdbUpdate(this.getSmh());
			return true;
		}
        /**
        *   source:smpmod.@0004.script
        */
        public String getStoreFileFullPathName(String fileName, String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(fileName==null||fileType==null) return null;
			else
			{
			  return MdaUtils.catPath(this.getFulldatapath(),fileName.substring(0,4)+"/"+fileName+"." + fileType);
			}
		}
        /**
        *   source:smpmod.@0002.script
        */
        public String getMessageFullPathName()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("cips|xml".contains(this.getSmh().getDocfxt()))
			  return getCipsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			else if("b2e|jsh".contains(this.getSmh().getDocfxt()))
			{
			  return getB2eStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			}
			else if("nxl".contains(this.getSmh().getDocfxt()))
			{
			  return getZywStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			}
			else if("elcs|exl".contains(this.getSmh().getDocfxt()))
			{
			  return getElcsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			}
			else
			  return getStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
		}
        /**
        *   source:smpmod.@0007.script
        */
        public boolean updatekWithUnlock(String channel,String nextChannel,String targetChannel,String state,String message)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 更新以记录状态并解锁
			  - channal:String 当前渠道名
			  - nextChannal:String 下一渠道名
			  - targetChannal:String 目标渠道名
			  - state:String 报文状态
			  - message:String 处理信息
			  - flag:boolean 返回值（为flag时当前处理失败需要这里就提交事务）
			  @ boolean 返回处理是否成功
			  */
			//Platform.mdbCommit();
			// int errorCode = Platform.errorCode();
			/// 如果渠道处理状态为空，则需要通过下一渠道判断应该置的状态
			if(MdaUtils.isEmpty(state))
			{
			  if(!MdaUtils.isEmpty(nextChannel))
			  {
			    log.debug("{}","nextChannel is not empty="+nextChannel);
			    Platform.esdbRead(this.getNxtchn(),new Argument("cod",nextChannel));
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      log.debug("{}","nxtchn-mpssta="+this.getNxtchn().getMpssta());
			      state = this.getNxtchn().getMpssta();
			    }
			  }
			  if(MdaUtils.isEmpty(state))
			    state = "X";
			}
			// Platform.mdbBegin();
			/// 清空记录准备处理(注：在已知道下一渠道，后续先后处理目标渠道时不再保存MPE的nextChannel，仅更新MPE的txt信息)
			MdaUtils.clear(this.getMpe());
			String inr = (String)this.getMps().getInr();
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( nextChannel);
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( null);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			if(!MdaUtils.isEmpty(state))
			  this.getMpe().setSta( state);
			this.getMpe().setTxt( message);
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			/// 判断是否需要进行报文的格式转换
			if(!MdaUtils.isEmpty(this.getMpi().getMsgtyp()) && !MdaUtils.isEmpty(this.getNxtchn().getCod())
			  && !MdaUtils.isEmpty(this.getNxtchn().getFmt()) && !this.getMpi().getMsgtyp().equals(this.getNxtchn().getFmt()))
			{
			  /*String methodName = "format_" + $mpi\\msgtyp.getValue() + "_" + $nxtchn\\fmt.getValue();
			    if((Boolean)Platform.invoke($this,methodName))
			    {
			    /// 注更新mpi在对应函数中已完成
			    $mpe\\nxtsmhinr = $smh\\inr;
			    $mps\\smhinr = $smh\\inr;
			    }*/
			}
			Platform.sdbInsert(this.getMpe());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  return false;
			}
			/*log.debug("state="+state);
			  String sql = "select sta from mps t where t.inr = "+inr;
			  Platform.dbExecuteSQL(sql);
			  Argument sta = new Argument<String>("sta");
			  Platform.dbFetchFields(sta);
			  log.debug("sta="+sta.getValue());
			  Platform.dbCloseCursor();*/

			/// 设置渠道状态
			if(!MdaUtils.isEmpty(nextChannel))
			  this.getMps().setNxtchncod( nextChannel);
			/// 目标渠道仅在为空或等于XXX时才可以进行更新
			if(!MdaUtils.isEmpty(targetChannel)&&(MdaUtils.isEmpty(this.getMps().getTgtchncod())||"XXX".equals(this.getMps().getTgtchncod())))
			  this.getMps().setTgtchncod( targetChannel);
			this.getMps().setLstdattim( this.getMpe().getDattim());
			this.getMps().setSta( state); /// 这里注意可能需要做格式转换
			this.getMps().setNxtsta( state);
			log.debug("{}","state="+state);
			Platform.mdbUpdate(this.getMps());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			/// 对MPS记录进行解锁
			Platform.sdbUnLock(this.getMps());
			// Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0005.script
        */
        public String formatBIC(String bic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(bic!=null && bic.length()>11)
			  return bic.substring(0,8) + bic.substring(9,12);
			return bic;
		}
        /**
        *   source:smpmod.@0008.script
        */
        public String getTagValue(String tagName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 注：这里保证返回域必须不为null
			if(MdaUtils.isEmpty(tagName))
			  return "";
			String value = "";
			if("20".equals(tagName))
			{
			  if(">".equals(this.getMps().getDir()))
			    value = this.getMpi().getOthref();
			  else
			    value = this.getMpi().getOwnref();
			}
			else if("21".equals(tagName))
			{
			  if(">".equals(this.getMps().getDir()))
			    value = this.getMpi().getOwnref();
			  else
			    value = this.getMpi().getOthref();
			}
			else if("^20".equals(tagName))
			  value = this.getMpi().getN20sha();
			else if("sndbic".equals(tagName))
			  value = this.getMpi().getSndbic();
			else if("rcvbic".equals(tagName))
			  value = this.getMpi().getRcvbic();
			else if("act".equals(tagName))//改动
			{
			  String val=this.getMpi().getAct();
			  if(!MdaUtils.isEmpty(val))
			  {
			    if(val.startsWith("FT"))
			    {
			      log.debug("{}","1.自贸区取tag对应act的值："+val);
			      return val.replaceAll("[^a-zA-Z0-9]", "").toUpperCase();
			    }
			    else
			      value = Platform.format4Equals(this.getMpi().getAct(),true);
			    log.debug("{}","2.取tag对应act的值"+value);
			  }
			}
			else if("typ".equals(tagName))
			  value = this.getMpi().getSubtyp();
			else if("rpscod".equals(tagName))
			  value = this.getMpi().getRpscod();
			else if("dir".equals(tagName))
			  value = this.getMpi().getDir();
			else if("sndnum".equals(tagName))
			  value = this.getMpi().getSndnum();
			else if("uetr".equals(tagName))
			  value = this.getMpi().getUetr();
			else if("cur".equals(tagName))//20201105新加
			value = this.getMpi().getCur();
			else if("rcvindbic".equals(tagName))//20201105新加
			value = this.getMpi().getRcvindbic();
			if(value==null)
			  return "";
			log.debug("{}","tag/value:("+tagName+")\t("+value+")");
			return value;
		}
        /**
        *   source:smpmod.@0010.script
        */
        public Argument t20Argument(String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument a1 = new Argument("ownref",EQ,value);
			a1 = a1.and("dir",EQ,"<");
			Argument a2 = new Argument("othref",EQ,value);
			a2 = a2.and("dir",EQ,">");
			return a1.or(a2);
		}
        /**
        *   source:smpmod.@0011.script
        */
        public Argument t21Argument(String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument a1 = new Argument("ownref",value);
			a1 = a1.and("dir",EQ,">");
			Argument a2 = new Argument("othref",value);
			a2 = a2.and("dir",EQ,"<");
			return a1.or(a2);
		}
        /**
        *   source:smpmod.@0012.script
        */
        public String getTag20(String ownref,String othref,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return "<".equals(dir)?ownref:
			othref;
		}
        /**
        *   source:smpmod.@0013.script
        */
        public String getTag21(String ownref,String othref,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return ">".equals(dir)?ownref:
			othref;
		}
        /**
        *   source:smpmod.@0014.script
        */
        public Argument t20ArgLike(String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument a1 = new Argument("ownref",LIKE,"%"+value+"%");
			a1 = a1.and("dir",EQ,"<");
			Argument a2 = new Argument("othref",LIKE,"%"+value+"%");
			a2 = a2.and("dir",EQ,">");
			return a1.or(a2);
		}
        /**
        *   source:smpmod.@0015.script
        */
        public Argument t21ArgLike(String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument a1 = new Argument("ownref",LIKE,"%"+value+"%");
			a1 = a1.and("dir",EQ,">");
			Argument a2 = new Argument("othref",LIKE,"%"+value+"%");
			a2 = a2.and("dir",EQ,"<");
			return a1.or(a2);
		}
        /**
        *   source:smpmod.@0016.script
        */
        public String getPropertyValues(String propertyPath,String key)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String value = "";
			value = MdaUtils.getPropertyValue(propertyPath,key);
			if(MdaUtils.isEmpty(value))
			  value = "";
			log.debug("{}",key + ":" + value);
			return value;
		}
        /**
        *   source:smpmod.@0020.script
        */
        public boolean updateStateForInterface(String channelCode)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 此方法为外部接口发送准备，发送前将接口状态设置为E错误状态；
			  * 若接口处理不成功或未知是否成功，需要通过人工干预方可进行重新发送或核销
			  * 若接口处理成功，后续将更新状态为D
			  */
			int errorCode = ctx.getErrorCode();
			Platform.mdbBegin();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			Date date = new Date();
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channelCode);
			this.getMpe().setSmhinr( this.getMps().getSmhinr());
			this.getMpe().setDattim( date);
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta( "0");
			this.getMpe().setTxt( "调用接口发送数据");
			Platform.sdbInsert(this.getMpe());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			this.getMps().setLstdattim( date);
			this.getMps().setSta( "0"); // 中间状态，准备发送数据
			Platform.mdbUpdate(this.getMps());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			//20190703新增，用于将新生成的系统跟踪号更新回MPI表
			if("ZYW".equals(channelCode))
			{
			  Platform.mdbUpdate(this.getMpi());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    log.info("{}","新一代资金业务---->更新MPI系统跟踪号失败！");
			    return false;
			  }
			  else
			  {
			    log.info("{}","新一代资金业务---->更新MPI系统跟踪号成功！");
			  }
			}
			Platform.mdbCommit();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			return true;
		}
        /**
        *   source:smpmod.@0035.script
        */
        public boolean noticeToZQS(String sta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *当收到ACK或则NCK的时候，给资金清算发送异步响应
			  */
			ctx.getErrorCode();//清除ERROR CODE
			Map<String,String> ds = new HashMap<String,String>();
			String mpiinr = this.getMpi().getInr();
			log.info("{}","mpi:"+mpiinr);
			String sql = "SELECT docfil,docfxt FROM smh WHERE mpiinr = '"+mpiinr+"' AND (docfxt='jsn' OR docfxt='jsn')";
			Argument<String> docfil = new Argument<String>("docfil");
			Argument<String> docfxt = new Argument<String>("docfxt");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(docfil,docfxt);
			log.info("{}","docfil:"+docfil.value);
			log.info("{}","docfxt:"+docfxt.value);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  String jsnpth = this.getStoreFileFullPathName(docfil.value,docfxt.value);//原报路径
			  ds.put("jsnpth",jsnpth);//返回原报给外部代码填充要发送的响应报文
			  String ref20 = this.getMpi().getOwnref();//返回20域编号
			  ds.put("ref20",ref20);
			  /*String datStr = String.valueOf(Platform.today().getTime());
			    ds.put("seqno",datStr.substring(datStr.length() - 17));*/
			  ds.put("sta",sta);//告知资金清算状态
			  ds.put("msgtyp",docfxt.value);
			  Platform.mdbRead(this.getDat(),new Argument("inr","00000000"));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    String accdat=this.getDat().getAccdat();
			    ds.put("accdat",accdat);
			    log.info("{}","异步返回的状态:"+sta);
			    MdaUtils.invoke("cn.com.brilliance.psbc.service.zjqs.handle.QSSendServiceHandler","dealPCODE020780",ds);//发送异步相应
			    Platform.mdbCloseCursor();
			    return true;
			  }
			}
			else
			{
			  Platform.mdbCloseCursor();
			  log.debug("{}","返回异步响应失败");
			  return false;
			}
			return false;
		}
        /**
        *   source:smpmod.@0037.script
        */
        public boolean checkNeedValidate()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*log.debug("验证该渠道报文是否需要人工复查");
			  String srcchncod = $mps\\srcchncod;
			  //Platform.mdbCommit();
			  String ctlval = Platform.getControlValue(srcchncod);//获取对该渠道的报文的控制阀门，看是否需要检查
			  if(ctlval == null || "0".equals(ctlval))
			  {
			    //无需人工检查\\
			    log.debug("无需人工复查");
			    return false;
			  }
			  // Platform.mdbBegin();
			  //检查最新MPE的状态，如果prvsta = V sta=A,则是复查通过的报文
			  String mpsinr = $mps\\inr;
			  Platform.mdbReadset($mpelst,new Argument("mpsinr",mpsinr),new Argument("inr",DESC));
			  log.debug("MPE SIZE:"+$mpelst.size());
			  if($mpelst.size()>0)
			  {
			    if("V".equals($mpelst[0]\\prvsta) && "A".equals($mpelst[0]\\sta))//已经进行过了复查，则不再进行复查
			    {
			      log.debug("已经被复查通过");
			      return false;
			    }
			  }
			  //Platform.mdbRead($mpe,new Argument);
			  //需要人工验证，更改MPS状态，插入mpe记录
			  $mps\\sta = "V";//待验证状态
			  log.debug("MPS STA:"+$mps\\sta.getValue());
			  Platform.clear($mpe);
			  $mpe\\mpsinr = $mps\\inr;
			  $mpe\\chncod = $mps\\chncod;
			  $mpe\\nxtchncod = $mps\\chncod;
			  if(Platform.isEmpty($nxtsmh\\inr))
			    $mpe\\smhinr = $smh\\inr;
			  else
			    $mpe\\smhinr = $nxtsmh\\inr;
			  $mpe\\dattim = new Date();
			  $mpe\\prvsta = "A";
			  $mpe\\sta =  "V";
			  $mpe\\txt = srcchncod+"渠道报文进入人工复查";
			  $mpe\\usr = Platform.getLoginUser();
			  $mpe\\frmnam = Platform.getTransName();
			  Platform.sdbInsert($mpe);
			  Platform.mdbUpdate($mps);
			  //Platform.mdbCommit();
			  log.debug("进入人工复查");*/
			return false;
		}
        /**
        *   source:smpmod.@0038.script
        */
        public void rmtCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			///生成报文基本信息
			this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( "sf2");
			///TODO:根据收款银行，汇款币种选择汇款路径（是否拆双报，收报行是谁）
			//生成103先,202暂不处理
			String nextSmhInr = MdaUtils.format(Platform.mdbCounter("smh"),"00000000");//转化之后的报文smhinr
			String nextFileName = this.getStoreFileFullPathName(nextSmhInr,"sf2");//转化之后的报文存放路径
			///TODO:外部方法编写
			Object obj = MdaUtils.invoke("","",nextFileName,new ICallback() {
				@Override
				public Object invoke(Object... paramVarArgs) {
					getRmt103Rcvbnk(paramVarArgs);
					return null;
				}
			});
			Map<String,String> map = new HashMap<String,String>();
			if(obj instanceof Map)
			{
			  map = (Map)obj;
			}
			this.getMpi().setSubtyp( map.get("mty"));
			this.getMpi().setSndnum( map.get("sndnum"));
			this.getMpi().setOwnref( map.get("ref"));
			this.getMpi().setOthref( map.get("tscref"));
			this.getMpi().setSrcnum( "");
			/// 记录新的MPE处理信息
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "发汇要素转化的103报文");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			log.debug("{}","插入发汇要素转换报文MPE");
			Platform.sdbInsert(this.getMpe());
			log.debug("{}","插入发汇要素转换转换报文MPE后");
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getDatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "sf2");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			/// 更新MPS信息（Update在unlock为执行）
			this.getMps().setSmhinr( nextSmhInr);
			/// 更新MPI信息
			this.getMpi().setSndnum( map.get("sndnum"));
			this.getMpi().setSndbic( formatBIC(map.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map.get("rcvbic")));
			this.getMpi().setActbic( formatBIC(map.get("actbic")));
			this.getMpi().setT53bic( formatBIC(map.get("t53bic")));
			this.getMpi().setAct( map.get("act"));
			this.getMpi().setCur( map.get("cur"));
			this.getMpi().setRpscod( map.get("errcod"));
			this.getMpi().setAmt( MdaUtils.parseDecimal(map.get("amt")));
			this.getMpi().setValdat( MdaUtils.parseDate(map.get("vludat"),"yyMMdd"));
			this.getMpi().setGendat( new Date());
			this.getMpi().setDtlchg( map.get("dtlchg"));
			List<String> noTags = new ArrayList();
			noTags.add("20");
			obj=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(obj != null && obj instanceof String)
			{
			  String noTag20Block4 = (String)obj;
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			Platform.mdbInsert(this.getMpi());
			log.debug("{}","插入了MPI");
			this.getSmh().setMpiinr( this.getMpi().getInr());
			Platform.mdbUpdate(this.getSmh());
		}
        /**
        *   source:smpmod.@0039.script
        */
        public String getRmt103Rcvbnk(Object... args)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rcvbnk = "";
			String bnfbnk = (String)args[0];//收款行
			String bnfbnkinr = "";//收款行pty主键inr
			String amt 		= (String)args[1];//金额
			String cur 		= (String)args[2];//币种
			String srcchn = (String)args[3];//渠道来源（GJS-国结，GHD-国际汇兑）
			String actbnk = (String)args[4];//指定清算行
			String minfeeactbnk = "";//己方清算行中最合适的银行
			String maxperactbnk = "";//己方账户行中发报比例最多的银行
			String maxpersambnk = "";//与收款行的共同账户行中发报比例最多的银行
			Boolean actflg = false;//收款行是否参与双报
			Boolean isagb = false; //收款行是否是代理行
			Boolean isactbnk = true;//是否指定清算行
			Boolean isSameBnk = false;//是否有相同账户行
			if(MdaUtils.isEmpty(actbnk))
			{
			  isactbnk = false;
			}
			///判断是否参与双报
			String sql = "SELECT agb.chaflg,agb.selflg FROM agb,pty,pta WHERE "+
			  " pty.inr = pta.objinr AND pty.extkey = '" + bnfbnk + "'" +
			  " AND pta.objtyp = 'agb' AND pta.ptatyp = 'M' AND pta.objinr = agb.inr ";
			Argument<String> gjsarg = new Argument<String>("chaflg");
			Argument<String> ghdarg = new Argument<String>("selflg");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(gjsarg,ghdarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  isagb = true;
			}
			Platform.mdbCloseCursor();
			if(isagb)
			{
			  if("GJS".equals(srcchn))
			  {
			    if("Y".equals(gjsarg.value))
			    {
			      actflg = true;
			    }
			  }
			  else if("GHD".equals(srcchn))
			  {
			    if("Y".equals(ghdarg.value))
			    {
			      actflg = true;
			    }
			  }
			}
			///判断和收款行是否有相同账户行
			sql = "SELECT inr FROM pty WHERE extkey = " + bnfbnk + "'";
			Argument<String> inrarg = new Argument<String>("inr");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(inrarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  bnfbnkinr = inrarg.value;
			}
			else
			{
			  log.warn("{}","收款行信息不存在");
			  return null;
			}
			Platform.mdbCloseCursor();
			List<String> samptylst = new ArrayList<String>();
			sql = "SELECT pty.inr FROM pty,pta WHERE " +
			  "pta.ptyinr = '" + bnfbnkinr + "' " +
			  "AND pta.objtyp = 'pty' AND pta.ptatyp = 'C' AND pta.objkey = '" + cur + "'" +
			  "pta.objinr = pty.inr AND pty.ptytyp LIKE '%T%'";
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(inrarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    isSameBnk = true;
			    samptylst.add(inrarg.value);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			///己方清算行中最合适银行
			minfeeactbnk = this.selectActbnk(cur,new BigDecimal(amt),srcchn);
			///己方账户行中发报比例最多的银行(103不用)
			List<String> ptylst = new ArrayList<String>();
			sql = "SELECT inr FROM pty WHERE ptytyp LIKE '%T%'";
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(inrarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    ptylst.add(inrarg.value);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			maxperactbnk = this.selectMaxPerBnk(ptylst,cur);
			///与收款行相同的账户行中发报比例最大的银行(103不用)
			if(isSameBnk)
			{
			  maxpersambnk = this.selectMaxPerBnk(samptylst,cur);
			}
			else
			{
			  maxpersambnk = null;
			}
			///103报文收报行
			if(isagb)
			{
			  rcvbnk = bnfbnk;
			}
			else
			{
			  if(actflg)
			  {
			    if(isactbnk)
			    {
			      rcvbnk = actbnk;
			    }
			    else
			    {
			      if(isSameBnk)
			      {
			        rcvbnk = minfeeactbnk;
			      }
			      else
			      {
			        rcvbnk = actbnk;
			      }
			    }
			  }
			  else
			  {
			    rcvbnk = minfeeactbnk;
			  }
			}
			return rcvbnk;
		}
        /**
        *   source:smpmod.@0040.script
        */
        public String selectMaxPerBnk(List<String> ptylst,String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			/*
			  *	从指定银行列表中选出指定币种账户下发报比例最多的那家银行
			  - ptylst 指定的银行列表
			  - cur		 指定币种
			  @ 返回符合条件的银行ptyinr
			  */
			BigDecimal maxper = new BigDecimal(-1);
			int maxindex = 0;
			for(int i = 0;i < ptylst.size();i++)
			{
			  Argument<BigDecimal> perarg = new Argument<BigDecimal>("per");
			  String sql = "SELECT act.per FROM act,pty WHERE " +
			    "pty.inr = act.actbnkinr AND pty.inr = '" +
			    ptylst.get(i) + "' AND " +
			    "act.cur = '" + cur + "'";
			  Platform.mdbExecuteSQL(sql);
			  Platform.mdbFetchFields(perarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    BigDecimal t = perarg.value;
			    if(!MdaUtils.isEmpty(t))
			    {
			      if(t.compareTo(maxper) >= 0)
			      {
			        maxindex = i;
			        maxper = t;
			      }
			    }
			  }
			  Platform.mdbCloseCursor();
			}
			return ptylst.get(maxindex);
		}
        /**
        *   source:smpmod.@0041.script
        */
        public String selectMinFeeBnk(List<String> ptylst,List<String> actlst,BigDecimal amt,String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	从指定银行账户列表选出针对此笔汇款扣费最少的银行
			  -	ptylst 指定银行列表
			  - actlst 指定账户列表（和ptylst一一对应）
			  - amt 汇款金额
			  @	返回符合条件的银行BIC
			  */
			String selectedPtyinr = "";
			///查询计算各银行对此笔汇款的扣费
			List<BigDecimal> feelst = new ArrayList<BigDecimal>();
			for(int i = 0;i < ptylst.size();i++)
			{
			  String ptyinr = ptylst.get(i);
			  String actid  = actlst.get(i);
			  Argument<BigDecimal> feearg = new Argument<BigDecimal>();
			  String sql = "SELECT fee FROM fee WHERE ptyinr = '" + ptyinr + "' " +
			    "AND actid = '" + actid + "' " +
			    "AND minamt <= ? AND maxamt > ? ";
			  Platform.mdbExecuteSQL(sql);
			  Platform.mdbFetchFields(feearg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    feelst.add(feearg.value);
			  }
			  else
			  {
			    feelst.add(new BigDecimal(-1));
			  }
			}
			Platform.mdbCloseCursor();
			///选择扣费最少的银行
			int index = 0;
			BigDecimal minfee = new BigDecimal(99999999);//TODO:扣费上限待确定
			for(int i = 0;i < feelst.size();i++)
			{
			  BigDecimal t = feelst.get(i);
			  if(t.compareTo(new BigDecimal(0)) < 0)
			  {
			    continue;
			  }
			  if(minfee.compareTo(t) >= 0)
			  {
			    minfee = t;
			    index = i;
			  }
			}
			///判断属否有相同扣费情况，并进行处理
			List<String> eqlst = new ArrayList<String>();//具有相同扣费情况的银行列表
			for(int i = 0;i < feelst.size();i++)
			{
			  if(i == index)
			  {
			    continue;
			  }
			  BigDecimal t = feelst.get(i);
			  if(t.compareTo(minfee) == 0)
			  {
			    eqlst.add(ptylst.get(i));
			  }
			}
			if(eqlst.size() == 0)
			{
			  selectedPtyinr = ptylst.get(index);
			}
			else
			{
			  //TODO:从列表中的银行中选出发报比例最多的那家银行
			  selectedPtyinr = this.selectMaxPerBnk(eqlst,cur);
			}
			///查询选中银行的BIC
			String selectedBIC = "";
			Argument<String> bicarg = new Argument<String>("extkey");
			String sql = "SELECT extkey FROM pty WHERE inr = '" + selectedPtyinr + "'";
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(bicarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  selectedBIC = bicarg.value;
			}
			else
			{
			  selectedBIC = null;//未查询到返回null，进入异常处理
			}
			return selectedBIC;
		}
        /**
        *   source:smpmod.@0042.script
        */
        public String selectActbnk(String cur,BigDecimal amt,String flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	根据汇款币种和金额，从己方清算行中选择出适合发报的清算行
			  - cur	汇款币种
			  - 汇款金额
			  - DJS-国结，GHD-国际汇兑
			  @	返回适合银行的BIC
			  */
			String subWhere = "";
			if("GJS".equals(flg))
			{
			  //参与国结清算
			  subWhere = "act.gjsactflg = 'X'";
			}
			else if("GHD".equals(flg))
			{
			  //参与国际汇兑清算
			  subWhere = "act.ghdactflg = 'X'";
			}
			List<String> ptylst = new ArrayList<String>();
			List<String> actlst = new ArrayList<String>();
			Argument<String> inrarg = new Argument<String>("inr");
			Argument<String> actidarg = new Argument<String>("actid");
			String sql = "SELECT pty.inr,act.actid FROM pty,act WHERE " +
			  "pty.ptytyp LIKE '%T%' AND " +
			  "pty.inr = act.actbnkinr AND act.cur = '" + cur + "' AND " +
			  subWhere;//参与清算
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(inrarg,actidarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    ptylst.add(inrarg.value);
			    actlst.add(actidarg.value);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			String bnkbic = this.selectMinFeeBnk(ptylst,actlst,amt,cur);
			return bnkbic;
		}
        /**
        *   source:smpmod.@0043.script
        */
        public boolean createMessageProcessSubjectWithoutCommit(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			//Platform.mdbCommit();
			//Platform.mdbBegin();
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			Platform.esdbRead(this.getChn(),new Argument("cod",channel));
			/// 未知渠道或当前渠道状态非接收状态
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  Platform.esdbRead(this.getTgtchn(),new Argument("cod",targetChannel));
			  /// 未知目标渠道则将其设置为空
			  if(ctx.getErrorCode()!=NO_ERROR)
			    targetChannel = null;
			}
			/*
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }*/
			int errorcode = ctx.getErrorCode();
			Platform.mdbBegin();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "A"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			Platform.sdbInsert(this.getMps());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  //Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "A"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  //Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  //Platform.mdbRollback();
			  return false;
			}
			//
			//Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0046.script
        */
        public boolean createMessageProcessSubjectForMan(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			return createMessageProcessSubjectForSweMan(is, channel, messageType, targetChannel, processDetail, "");
		}
        /**
        *   source:smpmod.@0047.script
        */
        public boolean sf2CreateMessageInformationForMan(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");
			Object object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsgInfo",fileName);
			if(object==null||!(object instanceof Map))
			  return false;
			Map<String,String> map = (Map)object;
			log.debug("{}","sf2 map:"+map);
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","sf2 nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map.get("mty"));
			this.getMpi().setSndnum( map.get("sndnum"));
			if(">".equals(this.getMps().getDir()))
			{
			  this.getMpi().setOwnref( map.get("tscref"));
			  this.getMpi().setOthref( map.get("ref"));
			}
			else
			{
			  this.getMpi().setOwnref( map.get("ref"));
			  this.getMpi().setOthref( map.get("tscref"));
			  /*if(Platform.isEmpty($mpi\\sndnum))
			    {
			    /// 注：这里很特殊，非正常的格式转换（正常格式转换通过相应状态变迁实现）
			    String nextSmhInr = Platform.sdbCounter("smh");
			    String sendNumber = "GJZFQZ" + nextSmhInr;
			    String orgFileName = getMessageFullPathName();
			    log.debug("sf2 orgFileName:"+orgFileName);
			    Platform.clear($filstm);
			    Object result=Platform.invoke(
			    "cn.com.brilliance.eibs.SwiftUtils","insertSendNumber",orgFileName,$filstm.getValue(),sendNumber);
			    if(result instanceof Boolean && (Boolean)result)
			    {
			    /// 记录MPE处理信息
			    Platform.clear($mpe);
			    $mpe\\mpsinr = $mps\\inr;
			    $mpe\\chncod = $mps\\chncod;
			    $mpe\\nxtchncod = $mps\\chncod;
			    $mpe\\smhinr = $smh\\inr;
			    $mpe\\nxtsmhinr = nextSmhInr;
			    $mpe\\dattim = new Date();
			    $mpe\\prvsta = $mps\\sta;
			    $mpe\\sta =  $mps\\sta;
			    $mpe\\txt = "自动添加SWIFT报文发送流水号.";
			    $mpe\\usr = Platform.getLoginUser();
			    $mpe\\frmnam = Platform.getTransName();
			    Platform.sdbInsert($mpe);
			    /// 记录SMH信息
			    $nxtsmh\\inr = nextSmhInr;
			    $nxtsmh\\objtyp = "mpe";
			    $nxtsmh\\objinr = $mpe\\inr;
			    $nxtsmh\\crtfrm = Platform.getTransName();
			    $nxtsmh\\dattim = new Date();
			    $nxtsmh\\docpth = $datapath;
			    $nxtsmh\\docfil = nextSmhInr;
			    $nxtsmh\\docfxt = "sf2";
			    String nextFileName = getStoreFileFullPathName(nextSmhInr,"sf2");
			    Platform.mstreamSave($filstm.getValue(),nextFileName);
			    $nxtsmh\\docmd5 = Platform.fileMD5Value(nextFileName);
			    $nxtsmh\\doclen = Platform.fileSize(nextFileName);
			    $nxtsmh\\mpiinr = $mpi\\inr;
			    Platform.mdbInsert($nxtsmh);
			    /// 更新MPS信息（Update在unlock为执行）
			    $mps\\smhinr = nextSmhInr;
			    /// 更新MPI信息
			    $mpi\\sndnum = sendNumber;
			    }
			    }*/
			}
			log.debug("{}","sf2 mpi sndnum:"+this.getMpi().getSndnum());
			this.getMpi().setSndbic( formatBIC(map.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map.get("rcvbic")));
			this.getMpi().setActbic( formatBIC(map.get("actbic")));
			this.getMpi().setT53bic( formatBIC(map.get("t53bic")));
			this.getMpi().setAct( map.get("act"));
			this.getMpi().setCur( map.get("cur"));
			this.getMpi().setRpscod( map.get("errcod"));
			this.getMpi().setAmt( MdaUtils.parseDecimal(map.get("amt")));
			this.getMpi().setValdat( MdaUtils.parseDate(map.get("vludat"),"yyMMdd"));
			this.getMpi().setGendat( new Date());
			this.getMpi().setDtlchg( map.get("dtlchg"));
			//20181025新加，gpi标识
			if(!MdaUtils.isEmpty(map.get("gpiFlg")))
			{
			  this.getMpi().setGpi( map.get("gpiFlg"));
			}
			//20181025新加，UETR信息
			if(!MdaUtils.isEmpty(map.get("UETR")))
			{
			  this.getMpi().setUetr( map.get("UETR"));
			}
			//20181221新加，GPI的值信息
			if(!MdaUtils.isEmpty(map.get("gpiVal")))
			{
			  this.getMpi().setGpival( map.get("gpiVal"));
			}
			//20181228新加，GPI相关收费信息
			if(!MdaUtils.isEmpty(map.get("sellamt")))
			{
			  this.getMpi().setSelamt( MdaUtils.parseDecimal(map.get("sellamt")));
			}
			if(!MdaUtils.isEmpty(map.get("sellcur")))
			{
			  this.getMpi().setSelcur( map.get("sellcur"));
			}
			if(!MdaUtils.isEmpty(map.get("71Fmsg")))
			{
			  this.getMpi().setMsg71f( map.get("71Fmsg"));
			}
			//20181129新增系统跟踪号字段
			// Object sysTrackNo = Platform.invoke("cn.com.brilliance.psbc.service.zjyw.handle.AbsYWServiceHandler","getSysTrackNo");
			String sysTrackNo = "99306000000"+MdaUtils.format(new Date(),"yyyyMMdd")+Platform.sdbCounter("rad","000000000000000");
			log.info("{}","系统跟踪号：" + sysTrackNo);
			//20181227新增会计日期，用于日后对账使用
			this.getMpi().setAccdat( Platform.getAccountDate());
			log.info("{}","会计日期："+this.getMpi().getAccdat());
			if(!MdaUtils.isEmpty(sysTrackNo))
			{
			  this.getMpi().setSystrackn( sysTrackNo);
			}
			List<String> noTags = new ArrayList();
			noTags.add("20");
			object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");

			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getMpi());

			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());

			if("103|192|202COV".contains(this.getMpi().getSubtyp()) && !MdaUtils.isEmpty(this.getMpi().getUetr()))
			  saveMsg103ToGpe(map.get("addinfo"));

			return true;
		}
        /**
        *   source:smpmod.@0048.script
        */
        public String insertSndnumBeforeSend()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 注：这里很特殊，非正常的格式转换（正常格式转换通过相应状态变迁实现）
			String nextSmhInr = Platform.sdbCounter("smh");
			String sendNumber = "GJZFQZ" + nextSmhInr;
			String orgFileName = getMessageFullPathName();
			log.debug("{}","sf2 orgFileName:"+orgFileName);
			MdaUtils.clear(this.getFilstm());
			Object result=MdaUtils.invoke("cn.com.brilliance.eibs.SwiftUtils","insertSendNumber",orgFileName,this.getFilstm(),sendNumber);
			if(result instanceof Boolean && (Boolean)result)
			{
			  /// 记录MPE处理信息
			  /*
			    Platform.clear($mpe);
			    $mpe\\mpsinr = $mps\\inr;
			    $mpe\\chncod = $mps\\chncod;
			    $mpe\\nxtchncod = $mps\\chncod;
			    $mpe\\smhinr = $smh\\inr;
			    $mpe\\nxtsmhinr = nextSmhInr;
			    $mpe\\dattim = new Date();
			    $mpe\\prvsta = $mps\\sta;
			    $mpe\\sta =  "A";
			    $mpe\\txt = "自动添加SWIFT报文发送流水号.";
			    $mpe\\usr = Platform.getLoginUser();
			    $mpe\\frmnam = Platform.getTransName();
			    Platform.sdbInsert($mpe);
			    */
			  /// 记录SMH信息
			  MdaUtils.clear(this.getNxtsmh());
			  this.getNxtsmh().setInr( nextSmhInr);
			  this.getNxtsmh().setObjtyp( "mpe");
			  this.getNxtsmh().setObjinr( this.getMpe().getInr());
			  this.getNxtsmh().setCrtfrm( ctx.getTransName());
			  this.getNxtsmh().setDattim( new Date());
			  this.getNxtsmh().setDocpth( this.getDatapath());
			  this.getNxtsmh().setDocfil( nextSmhInr);
			  this.getNxtsmh().setDocfxt( "sf2");
			  String nextFileName = getStoreFileFullPathName(nextSmhInr,"sf2");
			  Platform.mstreamSave(this.getFilstm(),nextFileName);
			  this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			  this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			  this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			  Platform.mdbInsert(this.getNxtsmh());
			  /// 更新MPS信息（Update在unlock为执行）
			  //$mps\\smhinr = nextSmhInr;
			  //Platform.mdbUpdate($mps);
			  /// 更新MPI信息
			  this.getMpi().setSndnum( sendNumber);
			  log.debug("{}","mpi sndnum:"+this.getMpi().getSndnum());
			  Platform.mdbUpdate(this.getMpi());
			}
			/*if(Platform.errorCode() == NO_ERROR)
			  {
			  log.debug("insertSndnumBeforeSend commit no error...");
			  return true;
			  }
			  else
			  {
			  log.debug("insertSndnumBeforeSend commit error...");
			  return false;
			  }*/
			log.debug("{}","insertSndnumBeforeSend errorcode:"+ctx.getErrorCode());
			return nextSmhInr;
		}
        /**
        *   source:smpmod.@0050.script
        */
        public String getAccountBank(Object ... objects)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return "CITIUS33XXX";
			//return selectActbnk((String)objects[0],(BigDecimal)objects[1],(String)objects[2]);
					}
        /**
        *   source:smpmod.@0055.script
        */
        public boolean txtCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析FMT报文，该方法需要在跟接口平台商议解析内容，目前是按解析SWIFT方法实现
			  */
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");
			Object[] filname = new Object[1];
			filname[0] = fileName;
			Object object = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","HandleFmt","HandleFmt",filname);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("smpmod","CT000004"),MdaUtils.getI18NString("smpmod","CT000005"));
			  return false;
			}
			//获取接口平台返回的内容
			Object[] objs = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			log.debug("{}","报文内容"+objs);
			Object[] objs1 = (Object[])objs;
			Map<String,String> map0 = (Map<String,String>)objs1[0];
			log.debug("{}","map0:"+map0);
			Map<String,String> map1 = (Map<String,String>)objs1[1];
			log.debug("{}","map1:"+map1);
			ctx.storeData("map1",map1);
			Map<String,String> map2 = (Map<String,String>)objs1[2];
			log.debug("{}","map2:"+map2);
			ctx.storeData("map2",map2);
			List<List> lst = (List<List>)objs1[3];
			log.debug("{}","lst:"+lst);
			//IStream is = (IStream) objs1[4];//map转json报文
			
			/*L160325
			  String keystore=(String)Platform.restoreData("keystore");
			  if(!Platform.isEmpty(keystore)&& "1".equals(keystore))
			  $mpi\\flg="1";
			  else
			  $mpi\\flg="0";*/
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","fmt txt nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map0.get("FMT"));
			this.getMpi().setSndnum(map0.get("sendNumber"));
			if(">".equals(this.getMps().getDir()))
			{
			  if("023".equals(map0.get("FMT")))
			  {
			    this.getMpi().setOwnref( map2.get("/D90/"));
			  }
			  else if("024".equals(map0.get("FMT")))
			  {
			    this.getMpi().setOwnref( map2.get("/D91/"));
			  }
			  else if("103|204".indexOf(map0.get("FMT"))>=0)
			  {
			    this.getMpi().setOwnref( map0.get("D90"));
			  }
			  else
			  {
			    this.getMpi().setOwnref( map1.get("21"));
			  }
			  this.getMpi().setOthref( map1.get("20"));
			  if("100|200".indexOf(map0.get("FMT"))>=0)
			  {
			    this.getMpi().setActbic( formatBIC(map1.get("54A")));
			    this.getMpi().setT53bic( formatBIC(map1.get("53A")));
			  }
			  else if("101|102|201|202".indexOf(map0.get("FMT"))>=0)
			  {
			    this.getMpi().setActbic( formatBIC(map0.get("A11")));
			    this.getMpi().setT53bic( formatBIC(map0.get("A12")));
			  }
			  else
			  {
			    if("103|204".indexOf(map0.get("FMT"))>=0 && "100|200".indexOf(map0.get("F31"))>=0 )
			    {
			      this.getMpi().setActbic( formatBIC(map1.get("54A")));
			      this.getMpi().setT53bic( formatBIC(map1.get("53A")));
			    }
			    else
			    {
			      this.getMpi().setActbic( formatBIC(map0.get("A11")));
			      this.getMpi().setT53bic( formatBIC(map0.get("A12")));
			    }
			  }
			}
			else
			{
			  if("023".equals(map0.get("FMT")))
			  {
			    this.getMpi().setOthref( map2.get("/D90/"));
			  }
			  else if("024".equals(map0.get("FMT")))
			  {
			    this.getMpi().setOthref( map2.get("/D91/"));
			  }
			  else if("103|204".indexOf(map0.get("FMT"))>=0)
			  {
			    this.getMpi().setOthref( map0.get("D90"));
			  }
			  else
			  {
			    this.getMpi().setOthref( map1.get("21"));
			  }
			  this.getMpi().setOwnref( map1.get("20"));
			  this.getMpi().setActbic( formatBIC(map1.get("53A")));
			}
			this.getMpi().setSndbic( formatBIC(map0.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map0.get("rcvbic")));

			String act59 = null;
			String act59A = null;
			if(!MdaUtils.isEmpty(map1.get("59")) && !"986".equals(map0.get("FMT")) && !"985".equals(map0.get("FMT")))
			  act59 = map1.get("59");
			else if(!MdaUtils.isEmpty(map1.get("59A")))
			  act59A = map1.get("59A");
			if(!MdaUtils.isEmpty(act59)&&act59.startsWith("/"))
			{
			  log.debug("{}","FMT 59:"+act59);
			  if("100".equals(map0.get("FMT"))||!MdaUtils.isEmpty(map0.get("F31"))&&"103".equals(map0.get("FMT"))&&"100".equals(map0.get("F31")))
			  {
			    String mact[] = act59.split("/");
			    this.getMpi().setAct( mact[1].trim());
			  }
			  if("101|102|104".contains(map0.get("FMT"))||!MdaUtils.isEmpty(map0.get("F31"))&&"103".equals(map0.get("FMT"))&&"101|102|104".contains(map0.get("F31")))
			  {
			    int strtag1 = act59.indexOf("\r\n");
			    if(strtag1 > -1)
			      this.getMpi().setAct( act59.substring(1,strtag1).trim());
			  }
			  /*String mact[] = act.split("/");
			    if(mact[1].length()>34)
			    {
			    $mpi\\act = mact[1].substring(0,34).trim();
			    }
			    else
			    $mpi\\act = mact[1].trim();*/
			}
			if(!MdaUtils.isEmpty(act59A)&&act59A.startsWith("/"))
			{
			  log.debug("{}","FMT 59A:"+act59A);
			  if("101|102|104".contains(map0.get("FMT"))||!MdaUtils.isEmpty(map0.get("F31"))&&"103".equals(map0.get("FMT"))&&"101|102|104".contains(map0.get("F31")))
			  {
			    int strtag1 = act59A.indexOf("\r\n");
			    if(strtag1 > -1)
			      this.getMpi().setAct( act59A.substring(1,strtag1).trim());
			  }
			}

			String str32 = map1.get("32A");
			if(!MdaUtils.isEmpty(str32))
			{
			  this.getMpi().setCur( str32.substring(6,9));
			  //$mpi\\rpscod = map.get("errcod");-发报时存库
			  this.getMpi().setAmt( MdaUtils.parseDecimal(str32.substring(9).replace(",",".")));
			  //$mpi\\valdat = Platform.parseDate(str32.substring(0,6),"yyMMdd");
			}
			if("100".equals(map0.get("FMT"))||"103".equals(map0.get("FMT"))&&"100".equals(map0.get("F31")))
			{
			  String str72 = map1.get("72");
			  int str72tag = str72.indexOf("\r\n");
			  log.debug("{}","str72tag= "+str72tag);
			  this.getMpi().setValdat( MdaUtils.parseDate(str72.substring(5,str72tag),"yyyyMMdd"));
			  log.debug("{}","mpi valudat= "+str72.substring(5,str72tag));
			}
			else if("200".equals(map0.get("FMT"))||"204".equals(map0.get("FMT"))&&"200".equals(map0.get("F31")))
			{
			  this.getMpi().setValdat( MdaUtils.parseDate(str32.substring(0,6),"yyMMdd"));
			}
			else
			{
			  this.getMpi().setValdat( MdaUtils.parseDate(map0.get("B00"),"yyyyMMdd"));
			}
			this.getMpi().setGendat( new Date());
			if(!MdaUtils.isEmpty(map1.get("71A")))
			{
			  this.getMpi().setDtlchg(map1.get("71A").substring(0,3));
			}
			log.debug("{}","mpi dtlchg="+this.getMpi().getDtlchg());
			List<String> noTags = new ArrayList();
			noTags.add("20");
			object = MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  log.debug("{}","object"+object);
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "txt");
			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());
			return true;
		}
        /**
        *   source:smpmod.@0056.script
        */
        public boolean jsfCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析发给人行的FMT报文
			  */

			if(!"<".equals(this.getMps().getDir()))
			{
			  log.error("{}","报文方向错误，dir="+this.getMps().getDir());
			  return false;
			}

			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");

			String nextSmhInr = Platform.sdbCounter("smh");

			//从文件中获取Map
			Object mapObject=MdaUtils.invoke("com.brilliance.swift.MessageReader","getMapFromJsonFile",fileName);
			if(mapObject==null||!(mapObject instanceof Map))
			{
			  log.error("{}","从Json获取Map失败");
			  return false;
			}
			Map m = (Map)mapObject;
			String fmtMessange = packageFmt(m);//组装FMT报文
			if(MdaUtils.isEmpty(fmtMessange))
			{
			  log.error("{}","组报失败");
			  return false;

			}

			//将组装好的报文存成临时文件
			MdaUtils.clear(this.getFilstm());
			transfromStringToStream(fmtMessange,this.getFilstm());//将fmtMessange写入filstm
			String nextFileName = getStoreFileFullPathName(nextSmhInr,"txt");
			Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新txt报文
			
			//解析报文
			Object[] filname=new Object[1];
			filname[0]=nextFileName;
			Object object=MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","HandleFmt","HandleFmt",filname);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  log.error("{}","调用接口失败");
			  return false;
			}
			//获取接口平台返回的内容
			//Map<String,String> map = (Map)Platform.invoke(object,"getContent");//报文内容
			//log.debug("map:"+map);
			Object obj3 = MdaUtils.invoke(object,"getContent");//报文内容
			log.trace("{}","obj3-------"+obj3);
			Object[] objs = (Object[])obj3;
			//Object[] objs = (Object[])Platform.invoke(object,"getContent");//报文内容
			Map<String,String> map0 = (Map<String,String>)objs[0];
			log.trace("{}","map0:"+map0);
			Map<String,String> map1 = (Map<String,String>)objs[1];
			log.trace("{}","map1:"+map1);
			Map<String,String> map2 = (Map<String,String>)objs[2];
			log.trace("{}","map2:"+map2);
			List<List> lst = (List<List>)objs[3];
			log.trace("{}","lst:"+lst);

			String nam = MdaEnv.getLoginUser();
			log.debug("{}","fmt txt nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map0.get("FMT"));
			this.getMpi().setOwnref( map1.get("20"));
			if("103|204".indexOf(map0.get("FMT"))>=0)
			{
			  this.getMpi().setOthref( map0.get("D90"));
			}
			else
			{
			  this.getMpi().setOthref( map1.get("21"));
			}
			//$mpi\\othref = map1.get("21");
			
			//   $mpi\\actbic = formatBIC(map1.get("54A"));
			//   $mpi\\t53bic = formatBIC(map1.get("53A"));
			
			if("100|200".indexOf(map0.get("FMT"))>=0)
			{
			  this.getMpi().setActbic( formatBIC(map1.get("54A")));
			  this.getMpi().setT53bic( formatBIC(map1.get("53A")));
			}
			else if("101|102|201|202|104".indexOf(map0.get("FMT"))>=0)
			{
			  this.getMpi().setActbic( formatBIC(map0.get("A11")));
			  this.getMpi().setT53bic( formatBIC(map0.get("A12")));
			}
			else
			{
			  if("103|204".indexOf(map0.get("FMT"))>=0 && "100|200".indexOf(map0.get("F31"))>=0 )
			  {
			    this.getMpi().setActbic( formatBIC(map1.get("54A")));
			    this.getMpi().setT53bic( formatBIC(map1.get("53A")));
			  }
			  else
			  {
			    this.getMpi().setActbic( formatBIC(map0.get("A11")));
			    this.getMpi().setT53bic( formatBIC(map0.get("A12")));
			  }
			}
			/// 记录MPE处理信息
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "境内外币Json转FMT.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getDatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "txt");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			/// 更新MPS信息（Update在unlock为执行）
			this.getMps().setSmhinr( nextSmhInr);
			/// 更新MPI信息
			this.getMpi().setSndnum( map0.get("sendNumber"));

			log.debug("{}","txt mpi sndnum:"+this.getMpi().getSndnum());

			this.getMpi().setSndbic( formatBIC(map0.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map0.get("rcvbic")));

			/*String act = map1.get("59");
			  if(!Platform.isEmpty(act))
			  {
			  String mact[] = act.split("/");
			  $mpi\\act = mact[1].trim();
			  }*/
			/*String act=null;
			  if(!Platform.isEmpty(map1.get("59")) && !"986".equals(map0.get("FMT")) && !"985".equals(map0.get("FMT")))
			  act = map1.get("59");
			  else if(!Platform.isEmpty(map1.get("59A")))
			  act = map1.get("59A");
			  if(!Platform.isEmpty(act))
			  {
			  String[] mact = act.split("/");
			  String mact1 = mact[1] ;
			  String[] mact2 = mact1.split("\\r\\n");
			  $mpi\\act = mact2[0].trim();
			  }*/

			String act59 = null;
			String act59A = null;
			if(!MdaUtils.isEmpty(map1.get("59")) && !"986".equals(map0.get("FMT")) && !"985".equals(map0.get("FMT")))
			  act59 = map1.get("59");
			else if(!MdaUtils.isEmpty(map1.get("59A")))
			  act59A = map1.get("59A");
			if(!MdaUtils.isEmpty(act59)&&act59.startsWith("/"))
			{
			  log.debug("{}","SENDFMT 59:"+act59);
			  if("100".equals(map0.get("FMT"))||!MdaUtils.isEmpty(map0.get("F31"))&&"103".equals(map0.get("FMT"))&&"100".equals(map0.get("F31")))
			  {
			    String mact[] = act59.split("/");
			    this.getMpi().setAct( mact[1].trim());
			  }
			  if("101|102|104".contains(map0.get("FMT"))||!MdaUtils.isEmpty(map0.get("F31"))&&"103".equals(map0.get("FMT"))&&"101|102|104".contains(map0.get("F31")))
			  {
			    int strtag1 = act59.indexOf("\r\n");
			    if(strtag1 > -1)
			      this.getMpi().setAct( act59.substring(1,strtag1).trim());
			  }
			}
			if(!MdaUtils.isEmpty(act59A)&&act59A.startsWith("/"))
			{
			  log.debug("{}","SENDFMT 59A:"+act59A);
			  if("101|102|104".contains(map0.get("FMT"))||!MdaUtils.isEmpty(map0.get("F31"))&&"103".equals(map0.get("FMT"))&&"101|102|104".contains(map0.get("F31")))
			  {
			    int strtag1 = act59A.indexOf("\r\n");
			    if(strtag1 > -1)
			      this.getMpi().setAct( act59A.substring(1,strtag1).trim());
			  }
			}
			String str32 = map1.get("32A");
			if(!MdaUtils.isEmpty(str32))
			{
			  this.getMpi().setCur( str32.substring(6,9));
			  //$mpi\\rpscod = map0.get("errcod");-发报时存库
			  this.getMpi().setAmt( MdaUtils.parseDecimal(str32.substring(9).replace(",",".")));
			  //$mpi\\valdat = Platform.parseDate(str32.substring(0,6),"yyMMdd");
			}
			if("100".equals(map0.get("FMT"))||"103".equals(map0.get("FMT"))&&"100".equals(map0.get("F31")))
			{
			  String str72 = map1.get("72");
			  int str72tag = str72.indexOf("\r\n");
			  log.debug("{}","SENDstr72tag= "+str72tag);
			  this.getMpi().setValdat( MdaUtils.parseDate(str72.substring(5,str72tag),"yyyyMMdd"));
			  log.debug("{}","SENDmpi valudat= "+str72.substring(5,str72tag));
			}
			else if("200".equals(map0.get("FMT"))||"204".equals(map0.get("FMT"))&&"200".equals(map0.get("F31")))
			{
			  this.getMpi().setValdat( MdaUtils.parseDate(str32.substring(0,6),"yyMMdd"));
			}
			else
			{
			  this.getMpi().setValdat( MdaUtils.parseDate(map0.get("B00"),"yyyyMMdd"));
			}
			this.getMpi().setGendat( new Date());
			if(!MdaUtils.isEmpty(map1.get("71A")))
			{
			  this.getMpi().setDtlchg(map1.get("71A").substring(0,3));
			}
			log.debug("{}","mpi dtlchg"+this.getMpi().getDtlchg());

			List<String> noTags = new ArrayList();
			noTags.add("20");
			object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  log.debug("{}","object"+object);
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");

			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "txt");

			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());
			return true;
		}
        /**
        *   source:smpmod.@0057.script
        */
        public boolean updateStateForInterface(String channelCode,String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 此方法用于更新MPS状态
			  */
			if("ZHQ".equals(channelCode) && "D".equals(state) )
			{
			  //新增向海南自贸区报送数据接口
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sendMessageToHaiNanFTA(this.getMpi(),this.getMps());
			}
			int errorCode = ctx.getErrorCode();
			Platform.mdbBegin();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			Date date = new Date();
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channelCode);
			this.getMpe().setSmhinr( this.getMps().getSmhinr());
			this.getMpe().setDattim( date);
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta( state);
			this.getMpe().setTxt( "更新mps状态");
			Platform.sdbInsert(this.getMpe());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			this.getMps().setLstdattim( date);
			this.getMps().setSta( state);
			Platform.mdbUpdate(this.getMps());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			Platform.mdbCommit();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			return true;
		}
        /**
        *   source:smpmod.@0058.script
        */
        public boolean fetchAndLockMessageSf2(String srcchannel,String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("srcchncod",srcchannel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  //20180608新建，监控需要获取mpi相关记录信息
			  MdaUtils.clear(this.getMpi());
			  if(!MdaUtils.isEmpty(this.getMps().getPntinr()))
			  {
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getPntinr()));
			  }
			  else
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  if(!MdaUtils.isEmpty(this.getMpi().getInr()))
			    log.info("{}","mpiinr:"+this.getMpi().getInr());
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));

			  //存储原sf2报文smhinr
			  this.setSmhinr( this.getSmh().getInr());

			  if(ctx.getErrorCode()!=NO_ERROR)
			    continue;
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0059.script
        */
        public boolean fetchAndLockMessageFmt(String srcchannel,String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("srcchncod",srcchannel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  //20180608新建，监控需要获取mpi相关记录信息
			  MdaUtils.clear(this.getMpi());
			  if(!MdaUtils.isEmpty(this.getMps().getPntinr()))
			  {
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getPntinr()));
			  }
			  else
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  if(!MdaUtils.isEmpty(this.getMpi().getInr()))
			    log.info("{}","mpiinr:"+this.getMpi().getInr());
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  //存储原txt报文smhinr
			  this.setSmhinr( this.getSmh().getInr());
			  //Platform.storeData("oldsmhinr",$mps\\smhinr.getValue());
			  //String oldsmhinr=(String)Platform.restoreData("oldsmhinr");
			  log.debug("{}","oldsmhinr test1: "+this.getSmh().getInr());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  String fileName = getStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  if(Platform.mfileExists(fileName))
			  {
			    //FXP不用接口平台handleFmt做处理，而FMT转JSON是历史版本即有的
			    if("FMT".equals(srcchannel))
			    {
			      this.getJsonContect(fileName);
			    }
			  }
			  else
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  //FMT读取新文件，FXP不用
			  if("FMT".equals(srcchannel))
			  {
			    Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));

			    log.debug("{}","new mps smhinr: "+this.getMps().getSmhinr());
			    int errorcode = ctx.getErrorCode();
			    log.debug("{}","errorcode= "+errorcode);
			    if(errorcode!=NO_ERROR)
			    {
			      Platform.sdbUnLock(mps);
			      continue;
			    }
			  }
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0060.script
        */
        public boolean getJsonContect( String fileName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *fmt报文转换为json报文通过国际结算收报接口发送
			  *fileName文件路径
			  */
			log.debug("{}","fmt报文转换json报文发给国际结算/资金清算........");
			Object[] filname=new Object[1];
			filname[0]=fileName;
			//调用接口平台获取转换后的json报文
			Object object=MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","HandleFmt","HandleFmt",filname);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("smpmod","CT000108"),MdaUtils.getI18NString("smpmod","CT000109"));
			  return false;
			}
			//获取接口平台返回的json报文内容
			Object[] objs = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			Object[] objs1 = (Object[])objs;
			String jsonstr=(String)objs1[4];
			log.debug("{}","fmt转json报文内容"+jsonstr);
			String nextSmhInr = Platform.sdbCounter("smh");
			log.debug("{}","new smhinr ="+nextSmhInr);
			MdaUtils.clear(this.getFilstm());
			IStream msgStream = this.getFilstm();
			try
			{
			  msgStream.getOutputStream().write(jsonstr.getBytes("GB18030"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.error("{}","报文保存失败");
			  return false;
			}

			String nextFileName = getStoreFileFullPathName(nextSmhInr,"json");
			Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新json报文
			/// 记录MPE处理信息
			Platform.mdbBegin();
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "境内外币FMT转json.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			int errorcode=ctx.getErrorCode();
			log.debug("{}","insertmpe errorcode"+errorcode);
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getDatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "json");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMps().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","insert smh errorcode"+ctx.getErrorCode());
			  Platform.mdbRollback();
			  return false;
			}
			Platform.mdbCommit();
			/// 更新MPS信息
			this.getMps().setSmhinr( nextSmhInr);

			return true;
		}
        /**
        *   source:smpmod.@0061.script
        */
        public Boolean txtCreateMpsAndMpiForManual(IStream is,String channel,String othref,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 境内外币发送073报文时使用
			  * 用于创建MPS、SMH、MPI等信息
			  - msgMap:Map 报文要素
			  - channal:String 报文源渠道名
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			String messageType = "txt";// 报文类型，固定为txt
			String targetChannel = "FMT";// 报文目标渠道,固定为FMT
			Date processDate = new Date();// 系统处理时间
			
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			Platform.mdbCommit();
			// 获取当前渠道信息（当前渠道必须不为空）
			ctx.getErrorCode();
			log.info("{}","@@@......................channel:"+channel+"............");
			Platform.mdbRead(this.getChn(),new Argument("cod",channel));
			// 未知渠道或当前渠道状态非接收状态
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  Platform.mdbRead(this.getTgtchn(),new Argument("cod",targetChannel));
			  /// 未知目标渠道则将其设置为空
			  if(ctx.getErrorCode()!=NO_ERROR)
			    targetChannel = null;
			}
			Platform.mdbBegin();
			String smhinr = Platform.sdbCounter("smh");
			Platform.sdbCounter(this.getMpe());
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "V"); // 待审核
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			this.getSmh().setInr( smhinr);// 保存报文信息(SMH)
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);

			//解析报文
			Object[] filname=new Object[1];
			filname[0]=fileName;
			Object object=MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","HandleFmt","HandleFmt",filname);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  log.error("{}","调用接口失败");
			  return false;
			}
			//获取接口平台返回的内容
			//Map<String,String> map = (Map)Platform.invoke(object,"getContent");//报文内容
			//log.debug("map:"+map);
			Object obj3 = MdaUtils.invoke(object,"getContent");//报文内容
			log.trace("{}","obj3-------"+obj3);
			Object[] objs = (Object[])obj3;
			//Object[] objs = (Object[])Platform.invoke(object,"getContent");//报文内容
			Map<String,String> map0 = (Map<String,String>)objs[0];
			log.trace("{}","map0:"+map0);
			Map<String,String> map1 = (Map<String,String>)objs[1];
			log.trace("{}","map1:"+map1);
			Map<String,String> map2 = (Map<String,String>)objs[2];
			log.trace("{}","map2:"+map2);
			List<List> lst = (List<List>)objs[3];
			log.trace("{}","lst:"+lst);

			String nam = MdaEnv.getLoginUser();
			log.debug("{}","fmt txt nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map0.get("FMT"));
			this.getMpi().setOwnref( map1.get("20"));
			if(MdaUtils.isEmpty(othref))
			{
			  if("023".equals(map0.get("FMT")))
			  {
			    this.getMpi().setOthref( map2.get("/D90/"));
			  }
			  else if("024".equals(map0.get("FMT")))
			  {
			    this.getMpi().setOthref( map2.get("/D91/"));
			  }
			  else if("103|204".indexOf(map0.get("FMT"))>=0)
			  {
			    this.getMpi().setOthref( map0.get("/D90/"));
			  }
			  else
			  {
			    this.getMpi().setOthref( map1.get("21"));
			  }
			}
			else
			  this.getMpi().setOthref( othref);

			this.getMpi().setActbic( formatBIC(map1.get("54A")));
			this.getMpi().setT53bic( formatBIC(map1.get("53A")));
			/// 更新MPI信息
			this.getMpi().setSndnum( map0.get("sendNumber"));
			log.debug("{}","txt mpi sndnum:"+this.getMpi().getSndnum());
			this.getMpi().setSndbic( formatBIC(map0.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map0.get("rcvbic")));
			String act = map1.get("59");
			if(!MdaUtils.isEmpty(act))
			{
			  String mact[] = act.split("/");
			  this.getMpi().setAct( mact[1].trim());
			}
			String str32 = map1.get("32A");
			if(!MdaUtils.isEmpty(str32))
			{
			  this.getMpi().setCur( str32.substring(6,9));
			  //$mpi\\rpscod = map0.get("errcod");-发报时存库
			  this.getMpi().setAmt( MdaUtils.parseDecimal(str32.substring(9).replace(",",".")));
			  this.getMpi().setValdat( MdaUtils.parseDate(str32.substring(0,5),"yyMMdd"));
			}
			this.getMpi().setGendat( new Date());
			if(!MdaUtils.isEmpty(map1.get("71A")))
			{
			  this.getMpi().setDtlchg(map1.get("71A").substring(0,3));
			}
			log.debug("{}","mpi dtlchg"+this.getMpi().getDtlchg());

			List<String> noTags = new ArrayList();
			noTags.add("20");
			object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  log.debug("{}","object"+object);
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");

			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( messageType);

			log.debug("{}","smpmod insert mps...");
			Platform.sdbInsert(this.getMps());
			int errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			this.getSmh().setMpiinr( this.getMps().getInr());
			log.debug("{}","smpmod insert smh...");
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			this.getMpi().setInr( this.getMps().getInr());
			log.debug("{}","smpmod insert mpi...");
			Platform.mdbInsert(this.getMpi());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpi with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "V"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.mdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			return true;
		}
        /**
        *   source:smpmod.@0062.script
        */
        public Boolean transfromStringToStream(String str,IStream is)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			try
			{
			  is.getOutputStream().write(str.getBytes("GB18030"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.error("{}","报文保存失败");
			  return false;
			}
			return true;
		}
        /**
        *   source:smpmod.@0063.script
        */
        public String packageFmt(Map<String,Object> m)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			/****************************
			  * 组装FMT报文
			  ****************************/
			String fmtType = (String)m.get("FMTTYP");
			if(MdaUtils.isEmpty(fmtType))
			  fmtType=(String)m.get("FMT");

			Object[] arg = null;
			if("073".equals(fmtType))
			{
			  arg = new Object[4];
			  String[] detail073 = (String[])m.get("DETAIL");
			  if(detail073==null)
			  {
			    log.error("{}","073报文map无DETAIL");
			    return null;
			  }
			  arg[3] = detail073;
			  m.remove("DETAIL");
			}
			else
			{
			  arg = new Object[3];
			}
			arg[0] = "0"+fmtType;
			String seqnum = Platform.sdbCounter(fmtType,"000000");
			if("000000".equals(seqnum))
			  seqnum = Platform.sdbCounter(fmtType,"000000");
			arg[1] = seqnum;
			arg[2] = m;
			Object msgObject = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","PackageFmt",fmtType,arg);
			Boolean rstObj = (Boolean)MdaUtils.invoke(msgObject,"isSuccess");
			log.debug("{}","rstObj-------"+rstObj);
			if(rstObj==null||!rstObj)
			{
			  log.error("{}","调用接口失败");
			  return null;
			}
			//获取接口平台返回的内容
			String fmtMessange = (String)MdaUtils.invoke(msgObject,"getContent");//报文内容
			return fmtMessange;
		}
        /**
        *   source:smpmod.@0064.script
        */
        public boolean updatekFmtWithUnlock(String channel,String nextChannel,String targetChannel,String state,String message)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 更新以记录状态并解锁
			  - channal:String 当前渠道名
			  - nextChannal:String 下一渠道名
			  - targetChannal:String 目标渠道名
			  - state:String 报文状态
			  - message:String 处理信息
			  - flag:boolean 返回值（为flag时当前处理失败需要这里就提交事务）
			  @ boolean 返回处理是否成功
			  */
			//国际结算境内外币报文回执状态更新
			int errorCode = ctx.getErrorCode();
			/// 如果渠道处理状态为空，则需要通过下一渠道判断应该置的状态
			if(MdaUtils.isEmpty(state))
			{
			  if(!MdaUtils.isEmpty(nextChannel))
			  {
			    Platform.mdbRead(this.getNxtchn(),new Argument("cod",nextChannel));
			    if(ctx.getErrorCode()==NO_ERROR)
			      state = this.getNxtchn().getMpssta();
			  }
			  if(MdaUtils.isEmpty(state))
			    state = "X";
			}
			/// 清空记录准备处理(注：在已知道下一渠道，后续先后处理目标渠道时不再保存MPE的nextChannel，仅更新MPE的txt信息)
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( nextChannel);
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( null);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			if(!MdaUtils.isEmpty(state))
			  this.getMpe().setSta( state);
			this.getMpe().setTxt( message);
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			/// 判断是否需要进行报文的格式转换
			if(!MdaUtils.isEmpty(this.getMpi().getMsgtyp()) && !MdaUtils.isEmpty(this.getNxtchn().getCod())
			  && !MdaUtils.isEmpty(this.getNxtchn().getFmt()) && !this.getMpi().getMsgtyp().equals(this.getNxtchn().getFmt()))
			{
			  /*String methodName = "format_" + $mpi\\msgtyp.getValue() + "_" + $nxtchn\\fmt.getValue();
			    if((Boolean)Platform.invoke($this,methodName))
			    {
			    /// 注更新mpi在对应函数中已完成
			    $mpe\\nxtsmhinr = $smh\\inr;
			    $mps\\smhinr = $smh\\inr;
			    }*/
			}
			Platform.sdbInsert(this.getMpe());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			/// 设置渠道状态
			if(!MdaUtils.isEmpty(nextChannel))
			  this.getMps().setNxtchncod( nextChannel);
			/// 目标渠道仅在为空或等于XXX时才可以进行更新
			if(!MdaUtils.isEmpty(targetChannel)&&(MdaUtils.isEmpty(this.getMps().getTgtchncod())||"XXX".equals(this.getMps().getTgtchncod())))
			  this.getMps().setTgtchncod( targetChannel);
			this.getMps().setLstdattim( this.getMpe().getDattim());
			this.getMps().setSta( state); /// 这里注意可能需要做格式转换
			this.getMps().setNxtsta( state);
			//$mps\\smhinr = (String)Platform.restoreData("oldsmhinr");
			log.debug("{}","smhinr before back: "+this.getSmhinr());
			this.getMps().setSmhinr( this.getSmhinr());
			log.debug("{}","mps old smhinr is "+this.getMps().getSmhinr());
			Platform.mdbUpdate(this.getMps());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			/// 对MPS记录进行解锁
			Platform.sdbUnLock(this.getMps());
			return true;
		}
        /**
        *   source:smpmod.@0065.script
        */
        public boolean createMessageProcessSubject(IStream is,String channel,String messageType,String targetChannel,String processDetail,String key)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			if(MdaUtils.isEmpty(key))
			{
			  log.info("{}","核签标志为空");
			  return false;
			}
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());

			Platform.setDefaultDB("swd");
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			log.info("{}","test log ....");
			/*
			  Platform.esdbRead($chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			readChn(this.getChn(),channel);
			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			log.info("{}","targetChannel="+targetChannel);
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}
			/*
			  Platform.mdbBegin();
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }*/
			int errorcode = ctx.getErrorCode();
			Platform.mdbBegin();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");
			/// 保存收发报处理主记录信息(MPS)
			log.info("{}","chn\typ="+this.getChn().getTyp());
			log.info("{}","tgtchn\typ="+this.getTgtchn().getTyp());
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "A"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			if("SWT".equals(targetChannel))
			{
			  this.getMps().setSwetyp( "A");
			}
			if(!MdaUtils.isEmpty(key))
			{
			  this.getMps().setFlg( key);
			}
			Platform.sdbInsert(this.getMps());
			errorcode = ctx.getErrorCode();
			log.info("{}","mps insert error code="+errorcode);
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "A"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			log.info("{}","before smpmod commit ");
			Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0066.script
        */
        public Boolean txtCreateMpsAndMpiForAuto(IStream is,String channel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 境内外币发送023,024报文时使用
			  * 用于创建MPS、SMH、MPI等信息
			  - msgMap:Map 报文要素
			  - channal:String 报文源渠道名
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			String messageType = "txt";// 报文类型，固定为txt
			String targetChannel = "FMT";// 报文目标渠道,固定为FMT
			Date processDate = new Date();// 系统处理时间
			
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			Platform.mdbCommit();
			// 获取当前渠道信息（当前渠道必须不为空）
			ctx.getErrorCode();
			log.info("{}","@@@......................channel:"+channel+"............");
			Platform.mdbRead(this.getChn(),new Argument("cod",channel));
			// 未知渠道或当前渠道状态非接收状态
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  Platform.mdbRead(this.getTgtchn(),new Argument("cod",targetChannel));
			  /// 未知目标渠道则将其设置为空
			  if(ctx.getErrorCode()!=NO_ERROR)
			    targetChannel = null;
			}
			Platform.mdbBegin();
			String smhinr = Platform.sdbCounter("smh");
			Platform.sdbCounter(this.getMpe());
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "V"); // 待审核
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			this.getSmh().setInr( smhinr);// 保存报文信息(SMH)
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);

			//解析报文
			Object[] filname=new Object[1];
			filname[0]=fileName;
			Object object=MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","HandleFmt","HandleFmt",filname);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  log.error("{}","调用接口失败");
			  return false;
			}
			//获取接口平台返回的内容
			//Map<String,String> map = (Map)Platform.invoke(object,"getContent");//报文内容
			//log.debug("map:"+map);
			Object obj3 = MdaUtils.invoke(object,"getContent");//报文内容
			log.trace("{}","obj3-------"+obj3);
			Object[] objs = (Object[])obj3;
			//Object[] objs = (Object[])Platform.invoke(object,"getContent");//报文内容
			Map<String,String> map0 = (Map<String,String>)objs[0];
			log.trace("{}","map0:"+map0);
			Map<String,String> map1 = (Map<String,String>)objs[1];
			log.trace("{}","map1:"+map1);
			Map<String,String> map2 = (Map<String,String>)objs[2];
			log.trace("{}","map2:"+map2);
			List<List> lst = (List<List>)objs[3];
			log.trace("{}","lst:"+lst);

			String nam = MdaEnv.getLoginUser();
			log.debug("{}","fmt txt nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map0.get("FMT"));
			this.getMpi().setOwnref( map1.get("20"));
			if("023".equals(map0.get("FMT")))
			{
			  this.getMpi().setOthref( map2.get("/D90/"));
			}
			else if("024".equals(map0.get("FMT")))
			{
			  this.getMpi().setOthref( map2.get("/D91/"));
			}
			else if("103|204".indexOf(map0.get("FMT"))>=0)
			{
			  this.getMpi().setOthref( map0.get("D90"));
			}
			else
			{
			  this.getMpi().setOthref( map1.get("21"));
			}
			this.getMpi().setActbic( formatBIC(map1.get("54A")));
			this.getMpi().setT53bic( formatBIC(map1.get("53A")));
			/// 更新MPI信息
			this.getMpi().setSndnum( map0.get("sendNumber"));
			log.debug("{}","txt mpi sndnum:"+this.getMpi().getSndnum());
			this.getMpi().setSndbic( formatBIC(map0.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map0.get("rcvbic")));
			String act = map1.get("59");
			if(!MdaUtils.isEmpty(act))
			{
			  String mact[] = act.split("/");
			  this.getMpi().setAct( mact[1].trim());
			}
			String str32 = map1.get("32A");
			if(!MdaUtils.isEmpty(str32))
			{
			  this.getMpi().setCur( str32.substring(6,9));
			  //$mpi\\rpscod = map0.get("errcod");-发报时存库
			  this.getMpi().setAmt( MdaUtils.parseDecimal(str32.substring(9).replace(",",".")));
			  this.getMpi().setValdat( MdaUtils.parseDate(str32.substring(0,5),"yyMMdd"));
			}
			this.getMpi().setGendat( new Date());
			if(!MdaUtils.isEmpty(map1.get("71A")))
			{
			  this.getMpi().setDtlchg(map1.get("71A").substring(0,3));
			}
			log.debug("{}","mpi dtlchg"+this.getMpi().getDtlchg());

			List<String> noTags = new ArrayList();
			noTags.add("20");
			object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  log.debug("{}","object"+object);
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");

			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( messageType);

			log.debug("{}","smpmod insert mps...");
			Platform.sdbInsert(this.getMps());
			int errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			this.getSmh().setMpiinr( this.getMps().getInr());
			log.debug("{}","smpmod insert smh...");
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			this.getMpi().setInr( this.getMps().getInr());
			log.debug("{}","smpmod insert mpi...");
			Platform.mdbInsert(this.getMpi());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpi with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "V"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.mdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			return true;
		}
        /**
        *   source:smpmod.@0067.script
        */
        public boolean fetchAndLockMessageFmt2(String srcchannel,String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			MdaUtils.clear(this.getPthlst());
			MdaUtils.clear(this.getMpetmplst());
			MdaUtils.clear(this.getSmhtmplst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("srcchncod",srcchannel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  //存储原txt报文smhinr
			  this.setSmhinr( this.getSmh().getInr());
			  log.debug("{}","oldsmhinr..."+this.getSmh().getInr());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  String fileName = getStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  MdaUtils.clear(this.getMpi());
			  if(!MdaUtils.isEmpty(this.getMps().getPntinr()))
			  {
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getPntinr()));
			  }
			  else
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  //若是FMT080报文，需作特殊处理，拆分报文，依次发送
			  if(!MdaUtils.isEmpty(this.getMpi().getSubtyp())&&"080".equals(this.getMpi().getSubtyp()))
			  {
			    Platform.mdbReadset(this.getMpetmplst(),new Argument("mpsinr",this.getMps().getInr()),new Argument("prvsta","0"));
			    if(MdaUtils.isEmpty(this.getMpetmplst()))
			    {//未获取到发资金清算记录
			      if(Platform.mfileExists(fileName))
			      {
			        this.getJsonContect2(fileName);
			      }
			      else
			      {
			        Platform.sdbUnLock(mps);
			        continue;
			      }
			    }
			    else
			    {
			      MdaUtils.clear(this.getMpetmplst());
			      Platform.mdbReadset(this.getMpetmplst(),new Argument("mpsinr",this.getMps().getInr()),new Argument("prvsta","0"),new Argument("sta","E"));
			      if(MdaUtils.isEmpty(this.getMpetmplst()))
			      {
			        log.debug("{}","已成功发送至资金清算，无需重发....");
			        Platform.sdbUnLock(mps);
			        continue;
			      }
			      else
			      {
			        List smhinrLst = new ArrayList();
			        for(com.ceb.gjjs.mda.bo.Mpe mpe : this.getMpetmplst())
			        {
			          smhinrLst.add(mpe.getSmhinr());
			          //更新原MPE的STA状态为0
			          Platform.mdbBegin();
			          mpe.setSta( "W");
			          Platform.mdbUpdate(mpe);
			          if(ctx.getErrorCode()!=NO_ERROR)
			          {
			            log.debug("{}","更新原MPE记录失败...");
			            Platform.sdbUnLock(mps);
			            return false;
			          }
			          Platform.mdbCommit();
			          if(ctx.getErrorCode()!=NO_ERROR)
			          {
			            log.debug("{}","提交失败...");
			            Platform.sdbUnLock(mps);
			            return false;
			          }
			        }
			        if(!MdaUtils.isEmpty(smhinrLst))
			        {
			          //读取待发送SMH记录
			          Platform.mdbReadset(this.getSmhtmplst(),new Argument("inr",IN,smhinrLst.toArray()));
			          MdaUtils.clear(this.getPthlst());
			          /*for(int i=0;i<$smhtmplst.size();i++)
			            {
			            $pthlst.add($smhtmplst[i]\\inr,$smhtmplst[i]\\docfil,$smhtmplst[i]\\docfxt);
			            }*/
			          for(com.ceb.gjjs.mda.bo.Smh smh : this.getSmhtmplst())
			          {
			            this.getPthlst().add(smh.getInr(),smh.getDocfil(),smh.getDocfxt());
			          }
			          
			        }
			        else
			        {
			          log.debug("{}","未获取到待发送至资金清算的记录...");
			          Platform.sdbUnLock(mps);
			          continue;
			        }
			      }
			    }
			  }
			  else
			  {

			    if(Platform.mfileExists(fileName))
			    {
			      //FXP不用接口平台handleFmt做处理，而FMT转JSON是历史版本即有的
			      if("FMT".equals(srcchannel))
			      {
			        this.getJsonContect(fileName);
			      }
			    }
			    else
			    {
			      Platform.sdbUnLock(mps);
			      continue;
			    }
			    //FMT读取新文件，FXP不用
			    if("FMT".equals(srcchannel))
			    {
			      Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			      log.debug("{}","new mps smhinr"+this.getMps().getSmhinr());
			      int errorcode=ctx.getErrorCode();
			      log.debug("{}","errorcode="+errorcode);
			      if(errorcode!=NO_ERROR)
			      {
			        Platform.sdbUnLock(mps);
			        continue;
			      }
			    }
			  }
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0068.script
        */
        public boolean getJsonContect2(String fileName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *fmt报文转换为json报文通过国际结算收报接口发送
			  *fileName文件路径
			  */
			log.debug("{}","fmt报文转换json报文发给国际结算/资金清算........");
			Object[] filname = new Object[1];
			filname[0] = fileName;
			//调用接口平台获取转换后的json报文
			Object object=MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","HandleFmt","HandleFmt",filname);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("smpmod","CT000112"),MdaUtils.getI18NString("smpmod","CT000113"));
			  return false;
			}
			//获取接口平台返回的json报文内容
			Object[] objs = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			Object[] objs1 = (Object[])objs;
			String jsonstr=(String)objs1[4];
			log.debug("{}","fmt转json报文内容"+jsonstr);
			//将json转换成MAP，并将77E截取重新赋值
			Map<String,Object> map = (Map<String,Object>)MdaUtils.invoke("com.brilliance.eibs.interfaceWork.json.JsonConvertor","stringToMap",jsonstr,Map.class);
			log.info("{}","map:"+map);
			/*String strH00 = map.get("/H00/").toString();
			  String[] tags =  strH00.split("\\\\r\\\\n\\\\/1\\\\/");
			  for(int i=1;i<tags.length;i++){
			  map.put("77E","");
			  map.put("/D00/","1");
			  map.put("/H00/","\\r\\n/1/"+tags[i]);*/
			//获取080报文的77E，并根据'\\r\\n/1/'截取报文
			//同时将新生成的json串进行存库操作
			String str77E = map.get("77E").toString();
			String[] tags = str77E.split("\\r\\n\\/1\\/");
			for(int i=1;i<tags.length;i++){
			  map.put("/H00/","");
			map.put("/D00/","1");
			map.put("77E",tags[0]+"\r\n/1/"+tags[i]);
			this.setMaptmp(map);
			byte[] byt = (byte[])MdaUtils.invoke("com.brilliance.eibs.interfaceWork.json.JsonConvertor","mapToByte",this.getMaptmp());
			//存储smh,mpe记录
			if(!this.storeJsonSmhMessage(byt))
			  return false;
			}
			
			/// 更新MPS信息
			//$mps\\smhinr = nextSmhInr;
			return true;
		}
        /**
        *   source:smpmod.@0069.script
        */
        public boolean storeJsonSmhMessage(byte[] byt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String nextSmhInr = Platform.sdbCounter("smh");
			log.debug("{}","next smhinr..."+nextSmhInr);
			MdaUtils.clear(this.getFilstm());
			IStream msgStream = this.getFilstm();
			try
			{
			  msgStream.getOutputStream().write(byt);//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.error("{}","报文保存失败");
			  return false;
			}

			String nextFileName = getStoreFileFullPathName(nextSmhInr,"json");
			Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新json报文
			/// 记录MPE处理信息
			Platform.mdbBegin();
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "境内外币FMT转json.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			int errorcode=ctx.getErrorCode();
			log.debug("{}","insert mpe errorcode..."+errorcode);
			/// 记录SMH信息
			MdaUtils.clear(this.getNxtsmh());
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getDatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "json");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMps().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","insert smh errorcode..."+ctx.getErrorCode());
			  Platform.mdbRollback();
			  return false;
			}
			Platform.mdbCommit();
			//将存库的SMH记录中主键、文件名、文件类型存放至pthlst，用于向外部Java函数传送路径LIST信息
			this.getPthlst().add(this.getNxtsmh().getInr(),this.getNxtsmh().getDocfil(),this.getNxtsmh().getDocfxt());
			for(int i=0;i<this.getPthlst().size();i++)
			  log.debug("{}","smhinr..."+this.getPthlst().getElement(i).getInr());
			return true;
		}
        /**
        *   source:smpmod.@0070.script
        */
        public boolean updateStateForInterfaceFmt(String channelCode)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 此方法为外部接口发送准备，发送前将接口状态设置为E错误状态；
			  * 若接口处理不成功或未知是否成功，需要通过人工干预方可进行重新发送或核销
			  * 若接口处理成功，后续将更新状态为D
			  *
			  * 新增FXP复用此函数
			  */
			int errorCode = ctx.getErrorCode();
			Platform.mdbBegin();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			Date date = new Date();
			//pthlst存放截取FMT080报文的SMH记录的主键和文件名等信息
			//若当前处理的为FMT080报文，需存储每条操作记录
			//否则只需存储一条操作记录
			if(!MdaUtils.isEmpty(this.getPthlst()))
			{
			  for(int i=0;i<this.getPthlst().size();i++)
			  {
			    log.debug("{}","nxtsmhinr..."+this.getPthlst().getElement(i).getInr());
			    MdaUtils.clear(this.getMpe());
			    this.getMpe().setMpsinr( this.getMps().getInr());
			    this.getMpe().setChncod( channelCode);
			    this.getMpe().setSmhinr( this.getPthlst().getElement(i).getInr());
			    log.debug("{}","mpesmhinr..."+this.getMpe().getSmhinr());
			    this.getMpe().setDattim( date);
			    this.getMpe().setUsr( MdaEnv.getLoginUser());
			    this.getMpe().setFrmnam( ctx.getTransName());
			    this.getMpe().setPrvsta( this.getMps().getSta());
			    this.getMpe().setSta( "0");
			    this.getMpe().setTxt( "调用接口发送数据");
			    Platform.sdbInsert(this.getMpe());
			    if(ctx.getErrorCode()!=NO_ERROR)
			      return false;
			  }
			}
			else
			{
			  MdaUtils.clear(this.getMpe());
			  this.getMpe().setMpsinr( this.getMps().getInr());
			  this.getMpe().setChncod( channelCode);
			  this.getMpe().setSmhinr( this.getMps().getSmhinr());
			  this.getMpe().setDattim( date);
			  this.getMpe().setUsr( MdaEnv.getLoginUser());
			  this.getMpe().setFrmnam( ctx.getTransName());
			  this.getMpe().setPrvsta( this.getMps().getSta());
			  this.getMpe().setSta( "0");
			  this.getMpe().setTxt( "调用接口发送数据");
			  Platform.sdbInsert(this.getMpe());
			  if(ctx.getErrorCode()!=NO_ERROR)
			    return false;
			}
			this.getMps().setLstdattim( date);
			this.getMps().setSta( "0"); // 中间状态，准备发送数据
			Platform.mdbUpdate(this.getMps());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			Platform.mdbCommit();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			return true;
		}
        /**
        *   source:smpmod.@0071.script
        */
        public Boolean sf2CreateMpsAndMpiForManual(IStream is,String channel,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 自贸区汇入转汇出专用
			  * 用于创建MPS、SMH、MPI
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			String messageType = "sf2";//报文类型，固定为sf2
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			Platform.mdbCommit();
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			Platform.mdbRead(this.getChn(),new Argument("cod",channel));
			/// 未知渠道或当前渠道状态非接收状态
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  Platform.mdbRead(this.getTgtchn(),new Argument("cod",targetChannel));
			  /// 未知目标渠道则将其设置为空
			  if(ctx.getErrorCode()!=NO_ERROR)
			    targetChannel = null;
			}
			Platform.mdbBegin();
			String smhinr = Platform.sdbCounter("smh");
			Platform.sdbCounter(this.getMpe());
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( channel); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "V"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);

			Object object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsgInfo",fileName);
			if(object==null||!(object instanceof Map))
			  return false;
			Map<String,String> map = (Map)object;
			log.trace("{}","map:"+map);
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","sf2 nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map.get("mty"));
			this.getMpi().setSndnum( map.get("sndnum"));
			if(">".equals(this.getMps().getDir()))
			{
			  this.getMpi().setOwnref( map.get("tscref"));
			  this.getMpi().setOthref( map.get("ref"));
			}
			else
			{
			  this.getMpi().setOwnref( map.get("ref"));
			  this.getMpi().setOthref( map.get("tscref"));
			}
			log.debug("{}","sf2 mpi sndnum:"+this.getMpi().getSndnum());
			this.getMpi().setSndbic( formatBIC(map.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map.get("rcvbic")));
			this.getMpi().setActbic( formatBIC(map.get("actbic")));
			this.getMpi().setT53bic( formatBIC(map.get("t53bic")));
			this.getMpi().setAct( map.get("act"));
			this.getMpi().setCur( map.get("cur"));
			this.getMpi().setRpscod( map.get("errcod"));
			this.getMpi().setAmt( MdaUtils.parseDecimal(map.get("amt")));
			this.getMpi().setValdat( MdaUtils.parseDate(map.get("vludat"),"yyMMdd"));
			this.getMpi().setGendat( new Date());
			this.getMpi().setDtlchg( map.get("dtlchg"));

			//20181025新加，gpi标识
			if(!MdaUtils.isEmpty(map.get("gpiFlg")))
			{
			  this.getMpi().setGpi( map.get("gpiFlg"));
			}
			//20181025新加，UETR信息
			if(!MdaUtils.isEmpty(map.get("UETR")))
			{
			  this.getMpi().setUetr( map.get("UETR"));
			}

			//20181221新加，GPI的值信息
			if(!MdaUtils.isEmpty(map.get("gpiVal")))
			{
			  this.getMpi().setGpival( map.get("gpiVal"));
			}
			//20181228新加，GPI相关收费信息
			if(!MdaUtils.isEmpty(map.get("sellamt")))
			{
			  this.getMpi().setSelamt( MdaUtils.parseDecimal(map.get("sellamt")));
			}
			if(!MdaUtils.isEmpty(map.get("sellcur")))
			{
			  this.getMpi().setSelcur( map.get("sellcur"));
			}
			if(!MdaUtils.isEmpty(map.get("71Fmsg")))
			{
			  this.getMpi().setMsg71f( map.get("71Fmsg"));
			}

			//20181129新增系统跟踪号字段
			String sysTrackNo = "99306000000"+MdaUtils.format(new Date(),"yyyyMMdd")+Platform.sdbCounter("rad","000000000000000");
			log.info("{}","系统跟踪号：" + sysTrackNo);
			//20181227新增会计日期，用于日后对账使用
			this.getMpi().setAccdat( Platform.getAccountDate());
			log.info("{}","会计日期："+this.getMpi().getAccdat());
			if(!MdaUtils.isEmpty(sysTrackNo))
			{
			  this.getMpi().setSystrackn( sysTrackNo);
			}
			List<String> noTags = new ArrayList();
			noTags.add("20");
			object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");

			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getMpi());

			log.debug("{}","smpmod insert mps...");
			Platform.sdbInsert(this.getMps());
			int errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			this.getSmh().setMpiinr( this.getMps().getInr());
			log.debug("{}","smpmod insert smh...");
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			this.getMpi().setInr( this.getMps().getInr());

			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getMpi());

			log.debug("{}","smpmod insert mpi...");
			Platform.mdbInsert(this.getMpi());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpi with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "V"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.mdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			if("103|192|202COV".contains(this.getMpi().getSubtyp()) && !MdaUtils.isEmpty(this.getMpi().getUetr()))
			  saveMsg103ToGpe(map.get("addinfo"));

			return true;
		}
        /**
        *   source:smpmod.@0073.script
        */
        public boolean fetchAndLockMessageSf2(String[] srcchannel,String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("srcchncod",IN,srcchannel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  //20180608新建，监控需要获取mpi相关记录信息
			  MdaUtils.clear(this.getMpi());
			  if(!MdaUtils.isEmpty(this.getMps().getPntinr()))
			  {
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getPntinr()));
			  }
			  else
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  if(!MdaUtils.isEmpty(this.getMpi().getInr()))
			    log.info("{}","mpiinr:"+this.getMpi().getInr());

			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));

			  //存储原sf2报文smhinr
			  this.setSmhinr( this.getSmh().getInr());

			  if(ctx.getErrorCode()!=NO_ERROR)
			    continue;
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0074.script
        */
        public boolean cipsCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析发给人行的CIPS报文
			  */

			if(!"<".equals(this.getMps().getDir()))
			{
			  log.error("{}","报文方向错误，dir="+this.getMps().getDir());
			  return false;
			}
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");

			String nextSmhInr = Platform.sdbCounter("smh");

			//到cpstim取出当前系统状态
			MdaUtils.clear(this.getCpstimlst());
			Platform.mdbReadset(this.getCpstimlst(),new Argument("inr",DESC));
			if(ctx.getErrorCode()!= NO_ERROR || this.getCpstimlst().isEmpty())
			{
			  log.debug("{}","取出当前系统状态有误！");
			  return false;
			}
			Object[] filnam = new Object[2];
			filnam[0] = fileName;
			log.debug("{}","#####" + this.getCpstimlst().size());
			log.debug("{}","++++++" + this.getCpstimlst().getElement(0).getSyssta());

			String syssta= this.getCpstimlst().getElement(0).getSyssta();
			String bsh="NITT";
			if("ACTV".equals(syssta))
			{
			  bsh="DAYT";
			}
			else  if("NTAC".equals(syssta))
			{
			  bsh="NITT";
			}
			filnam[1]=bsh;
			//filnam[1]=$cpstimlst[0]\\syssta;
			log.debug("{}","cipsmsgtocips接口调用");
			Object msgObject = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","cipsmsgtocips","msgtocips",filnam);
			Boolean obt = (Boolean)MdaUtils.invoke(msgObject,"isSuccess");
			log.debug("{}","cipsmsgtocips接口的msgObject值:"+msgObject);
			log.debug("{}","cipsmsgtocips接口的返回值:"+obt);
			if(!obt)
			{
			  if("rxxtsk".equals(ctx.getTransName())&&"GJS".equals(this.getMps().getSrcchncod()))
			  {
			    //  cipsScheamError();
			    log.debug("{}","cips的scheam校验失败处理");
			  }
			  else
			  {
			    log.error("{}","组报失败");
			    return false;
			  }
			}
			Object[] objs = (Object[])MdaUtils.invoke(msgObject,"getContent");
			String cipsMessage = (String)objs[0];//组好的CIPS报文
			log.debug("{}","CIPS message:"+cipsMessage);
			Map<String,Object> map = (Map<String,Object>)objs[1];//Map对象
			log.debug("{}","CIPS MAP:"+map);
			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPtyCIPS(this.getMpi(),map);

			//将组装好的报文存成临时文件
			MdaUtils.clear(this.getFilstm());
			transfromStringToStreamUTF(cipsMessage,this.getFilstm());//将cipsMessange写入filstm
			//20170904修改，CIPS报文另行目录存储
			String nextFileName = getCipsStoreFileFullPathName(nextSmhInr,"xml");
			Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新xml报文
			//存储报文
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","cips-xml nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			if(!MdaUtils.isEmpty(map.get("Tp")))
			{
			  String subtyp = (String)map.get("Tp");
			  this.getMpi().setSubtyp( subtyp.substring(5,8));
			}
			if(!MdaUtils.isEmpty(map.get("OrgNumber")))
			{
			  String subtyp = (String)map.get("OrgNumber");
			  this.getMpi().setBranch( subtyp);
			}
			//20201028新增会计日期，用于日后对账使用
			this.getMpi().setAccdat( Platform.getAccountDate());
			log.info("{}","会计日期："+this.getMpi().getAccdat());
			if(!MdaUtils.isEmpty(map.get("TxId")))
			  this.getMpi().setOwnref( (String)map.get("TxId")); //cips 135
			else if(!MdaUtils.isEmpty(map.get("AcctOwnrTxId")))
			  this.getMpi().setOwnref( (String)map.get("AcctOwnrTxId")); //cips 136
			else
			  this.getMpi().setOwnref( (String)map.get("MsgId"));
			// $mpi\\ownref = (String)map.get("MsgId");
			String oriref = null;
			String ref = null;

			if(!MdaUtils.isEmpty(map.get("Case")))
			{
			  Map<String,Object> cas = (Map<String,Object>)map.get("Case"); //cips 301/302/714/715
			  if(!MdaUtils.isEmpty(cas))
			  {
			    ref = (String)cas.get("OrgnlMsgId");
			  }
			}
			if(!MdaUtils.isEmpty(map.get("OrgnlMsgId")))
			{
			  oriref = (String)map.get("OrgnlMsgId"); //cips 601/303/304/308/900/912/305/306/357/352/713/806
			}
			if(!MdaUtils.isEmpty(map.get("Ref")))
			{
			  oriref = (String)map.get("Ref"); //cips 309
			}
			if(!MdaUtils.isEmpty(map.get("EndToEndId")))
			{
			  oriref = (String)map.get("EndToEndId"); //cips 111
			  log.debug("{}","oriref-end:"+oriref);
			}
			if(!MdaUtils.isEmpty(map.get("InstrId")))
			{
			  oriref = (String)map.get("InstrId"); //cips 112
			  log.debug("{}","oriref-str:"+oriref);
			}
			if(!MdaUtils.isEmpty(ref))
			  this.getMpi().setOthref( ref);
			else if(!MdaUtils.isEmpty(oriref))
			  this.getMpi().setOthref( oriref);
			else if(!MdaUtils.isEmpty(map.get("HMsgRef")))
			  this.getMpi().setOthref( (String)map.get("HMsgRef"));

			/// 记录MPE处理信息
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "跨境人民币Json转CIPS.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getCipsdatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "xml");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			/// 更新MPS信息（Update在unlock为执行）
			this.getMps().setSmhinr( nextSmhInr);
			/// 更新MPI信息
			String sndbic1 = (String)map.get("HSender");
			String rcvbic1 = (String)map.get("HReceiver");
			this.getMpi().setSndbic( formatBIC(sndbic1.trim()));
			this.getMpi().setRcvbic( formatBIC(rcvbic1.trim()));

			String subtyp = (String)map.get("Tp");
			if(!MdaUtils.isEmpty(subtyp)&&("cips.111.001.01|cips.112.001.01|cips.111.001.02|cips.112.001.02".contains(subtyp)))
			{

			  if(!MdaUtils.isEmpty(map.get("Prtry")))
			  {
			    String ywzl=(String)map.get("Prtry");
			    if("WMCS".equals(ywzl))
			    {
			      this.getMpi().setFlg("W");
			    }
			  }
			  String act = null;
			  if(("cips.111.001.01|cips.111.001.02").contains(subtyp)&&!MdaUtils.isEmpty(map.get("RecId")))
			  {
			    act = (String)map.get("RecId");
			    this.getMpi().setAct( act.trim());
			    log.debug("{}","CIPS ACT:"+this.getMpi().getAct());
			  }
			  if(("cips.112.001.01|cips.112.001.02").contains(subtyp)&&!MdaUtils.isEmpty(map.get("CdtrAcct")))
			  {
			    Map<String,Object> pyeact = (Map<String,Object>)map.get("CdtrAcct");//收汇人账号
			    if(!MdaUtils.isEmpty(pyeact.get("Id")))
			    {
			      act = (String)pyeact.get("Id");
			      this.getMpi().setAct( act.trim());
			      log.debug("{}","CIPS ACT:"+this.getMpi().getAct());
			    }
			  }
			  if(!MdaUtils.isEmpty(map.get("IntrBkSttlmAmt")))
			  {
			    String curamt = (String)map.get("IntrBkSttlmAmt");
			    this.getMpi().setCur( curamt.substring(0,3));//币种，固定为CNY
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.substring(3)));
			  }
			  if(!MdaUtils.isEmpty(map.get("IntrBkSttlmDt")))
			  {
			    String valdat = (String)map.get("IntrBkSttlmDt");
			    this.getMpi().setValdat( MdaUtils.parseDate(valdat,"yyyy-MM-dd"));
			  }
			}
			if(!MdaUtils.isEmpty(map.get("XpctdSttlmDt")))//期望结算日期
			{
			  String valdat = (String)map.get("XpctdSttlmDt");
			  this.getMpi().setExpsetdat( MdaUtils.parseDate(valdat,"yyyy-MM-dd"));
			}
			if(MdaUtils.isEmpty(this.getMpi().getExpsetdat()))
			{
			  String valdat = this.getCurrentDate();
			  this.getMpi().setExpsetdat( MdaUtils.parseDate(valdat,"yyyy-MM-dd"));
			}
			if(!MdaUtils.isEmpty(subtyp)&&subtyp.equals("cips.350.001.01"))
			{
			  if(!MdaUtils.isEmpty(map.get("AmtWthCcy")))
			  {
			    String curamt = (String)map.get("AmtWthCcy");
			    log.debug("{}","cips.350.curamt:"+curamt);
			    this.getMpi().setCur( curamt.substring(0,3));//币种，固定为CNY
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.substring(3)));
			  }
			}
			if(!MdaUtils.isEmpty(subtyp) && ("cips.133.001.01|cips.135.001.01".contains(subtyp)) && !MdaUtils.isEmpty(map.get("AmtSign")))//133/135报文
			{
			  String curamt = (String)map.get("AmtSign");
			  this.getMpi().setCur( curamt.substring(0,3));//币种，固定为CNY
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.substring(3)));
			}
			if(!MdaUtils.isEmpty(subtyp) && subtyp.equals("cips.113.001.01") &&!MdaUtils.isEmpty(map.get("TtlIntrBkSttlmAmt")))//113报文
			{
			  String curamt = (String)map.get("TtlIntrBkSttlmAmt");
			  this.getMpi().setCur( curamt.substring(0,3));//币种，固定为CNY
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.substring(3)));
			}
			if(!MdaUtils.isEmpty(subtyp) && subtyp.equals("cips.153.001.01") &&!MdaUtils.isEmpty(map.get("DetAmt")))//153报文
			{
			  String curamt = (String)map.get("DetAmt");
			  this.getMpi().setCur( curamt.substring(0,3));//币种，固定为CNY
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.substring(3)));
			}
			if(!MdaUtils.isEmpty(subtyp) && subtyp.equals("cips.621.001.01") &&!MdaUtils.isEmpty(map.get("CAmt")))//621报文
			{
			  String curamt = (String)map.get("CAmt");
			  this.getMpi().setCur( curamt.substring(0,3));//币种，固定为CNY
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.substring(3)));
			}
			if(!MdaUtils.isEmpty(subtyp) && subtyp.equals("cips.622.001.01") &&!MdaUtils.isEmpty(map.get("Amt1")))//622报文
			{
			  String curamt = (String)map.get("Amt1");
			  this.getMpi().setCur( curamt.substring(0,3));//币种，固定为CNY
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.substring(3)));
			}
			if(!MdaUtils.isEmpty(subtyp) && ("cips.136.001.01|cips.154.001.01".contains(subtyp)))
			  this.getMpi().setCur( "CNY");

			//IntrBkSttlmDt起息日，111/112/303/305
			//IntrBkSttlmAmt货币符号金额 111/112/301/302/305
			this.getMpi().setGendat( new Date());
			if(!MdaUtils.isEmpty(map.get("ChrgBr")))
			{
			  String dtlchg = (String)map.get("ChrgBr");
			  this.getMpi().setDtlchg( dtlchg.trim());//费用承担方
			}
			//20200929新加，存储日间、夜间标志
			if(!MdaUtils.isEmpty(map.get("BizPhs")))
			{
			  //String biztyp = (String)map.get("BizPhs");
			  // $mpi\\biztyp = biztyp;
			  this.getMpi().setBiztyp(bsh);
			}
			//20201108新加，收发报间参行
			if("111".equals(this.getMpi().getSubtyp()))
			{
			  if(!MdaUtils.isEmpty(map.get("PayIndMmbId")))
			    this.getMpi().setSndindbic( (String)map.get("PayIndMmbId"));
			  if(!MdaUtils.isEmpty(map.get("RecIndMmbId")))
			    this.getMpi().setRcvindbic( (String)map.get("RecIndMmbId"));

			  //为了统计全链路报文新增
			  this.getMpi().setPaybic( (String) map.get("PayerMmbId"));
			  this.getMpi().setRecbic( (String) map.get("RecMmbId"));
			}
			if("112".equals(this.getMpi().getSubtyp()))
			{
			  if(!MdaUtils.isEmpty(map.get("InstgAgt")))
			  {
			    Map<String,Object> agtmap = ( Map<String,Object> )map.get("InstdAgt");
			    if(!MdaUtils.isEmpty(agtmap.get("Id")))
			      this.getMpi().setSndindbic( (String)agtmap.get("Id"));
			  }
			  if(!MdaUtils.isEmpty(map.get("InstdAgt")))
			  {
			    Map<String,Object> agtmap = ( Map<String,Object> )map.get("InstdAgt");
			    if(!MdaUtils.isEmpty(agtmap.get("Id")))
			      this.getMpi().setRcvindbic( (String)agtmap.get("Id"));
			  }

			  //为了统计全链路报文新增
			  if(!MdaUtils.isEmpty(map.get("Dbtr")))
			  {
			    Map<String,Object> agtmap = ( Map<String,Object> )map.get("Dbtr");
			    this.getMpi().setPaybic( (String)agtmap.get("MmbId"));
			  }
			  if(!MdaUtils.isEmpty(map.get("Cdtr")))
			  {
			    Map<String,Object> agtmap = ( Map<String,Object> )map.get("Cdtr");
			    this.getMpi().setRecbic( (String)agtmap.get("MmbId"));
			  }
			}
			if("113".equals(this.getMpi().getSubtyp()))
			{
			  //为了统计全链路报文新增
			  if(!MdaUtils.isEmpty(map.get("Dbtr")))
			  {
			    Map<String,Object> agtmap = ( Map<String,Object> )map.get("Dbtr");
			    this.getMpi().setPaybic( (String)agtmap.get("MmbId"));
			  }
			  if(!MdaUtils.isEmpty(map.get("Cdtr")))
			  {
			    Map<String,Object> agtmap = ( Map<String,Object> )map.get("Cdtr");
			    this.getMpi().setRecbic( (String)agtmap.get("MmbId"));
			  }
			}
			log.debug("{}","mpi dtlchg"+this.getMpi().getDtlchg());
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "xml");

			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());

			//$swemod.createOrUpdateSedEntryForCips(subtyp,$mps,$mpi,map);
			if(!obt)
			{

			  //国结cpisschema校验失败，新增接口处理
			  log.debug("{}","cips的scheam校验失败处理");
			  if("rxxtsk".equals(ctx.getTransName())&&"GJS".equals(this.getMps().getSrcchncod()))
			  {
			    cipsScheamError("CIPS");
			    log.debug("{}","111111");
			  }
			  log.error("{}","组报失败");
			  return false;
			}
			return true;
		}
        /**
        *   source:smpmod.@0075.script
        */
        public boolean xmlCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 读取报文
			Object obj = MdaUtils.invoke("com.brilliance.jrxx.utils.CfixUtil","readFileToString",fileName);
			String xml = (String)obj;
			Map map = (Map) MdaUtils.invoke("com.brilliance.jrxx.utils.CfixUtil","xml2Map",fileName);
			log.info("{}","xmlCreateMessageInformation xml="+xml);
			log.info("{}","xmlCreateMessageInformation map="+map);
			log.info("{}","before dbBegin");
			ctx.getDaoSession().dbBegin();
			// insert into mpi
			this.getMpi().setUsrnam( MdaEnv.getLoginUser());

			MdaUtils.clear(this.getMpi());
			this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( "CPX");
			this.getMpi().setSubtyp( (String)map.get("MesgType"));
			this.getMpi().setSndnum( (String)map.get("MesgRefID"));
			this.getMpi().setOthref( (String)map.get("MesgID"));
			String msgType = (String)map.get("MesgType");

			this.getMpi().setMsgtyp( "xml");
			this.getMpi().setSndbic( (String)map.get("OrigSenderSID"));
			this.getMpi().setRecbic( (String)map.get("OrigReceiverSID"));
			this.getMpi().setMsgid( (String)map.get("MesgID"));
			this.getMpi().setEtyinr( ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEty().getInr());
			log.debug("{}","sysmod-ety-inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEty().getInr());
			log.info("{}","xmlCreateMessageInformation before insert");
			ctx.getDaoSession().dbInsert(this.getMpi());
			log.info("{}","xmlCreateMessageInformation after insert");

			// update mps:更新sta，nxtsta字段值为"D",已处理
			this.getMps().setSta( "D");
			this.getMps().setNxtsta( "D");
			ctx.getDaoSession().dbUpdate(this.getMps());

			// update smh
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( MdaUtils.today());
			this.getSmh().setDocfxt( "xml");
			/// 获取待保存文件全名
			String inr = this.getSmh().getDocfil();
			String fullPath = getStoreFileFullPathName(inr, "xml");
			// 保存文件并记录MD5值和文件大小信息
			MdaUtils.clear(this.getFilstm());
			IStream is = this.getFilstm();
			try
			{
			  is.getOutputStream().write(xml.getBytes("utf-8"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","xmlCreateMessageInformation 加载报文信息失败");
			  return false;
			}
			Platform.mstreamSave(is,fullPath);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fullPath));
			this.getSmh().setDoclen( MdaUtils.fileSize(fullPath));
			ctx.getDaoSession().dbUpdate(this.getSmh());

			// insert into mpe
			MdaUtils.clear(this.getMpe());
			this.getMpe().setChncod( "CPX");
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setNxtchncod( "CPX");
			this.getMpe().setNxtsmhinr( this.getMps().getInr());
			this.getMpe().setSta( "A");
			this.getMpe().setTxt( "收报清分");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( "");
			this.getMpe().setDattim( MdaUtils.today());
			Platform.sdbInsert(this.getMpe());
			ctx.getDaoSession().dbCommit();

			// 处理具体报文
			// 应答报文是否处理成功
			boolean isSuccess=false;
			// 原报文标识号msgId
			String orgnlMsgId = "";
			if( "cfad.019.001.01".equals(msgType))
			{
			  // 接入机构状态变更通知报文
			  this.getMsgmod().handle_cfad_019_001_01(map);
			}
			else if("cfad.021.001.01".equals(msgType))
			{
			  // 接入机构状态下载应答报文
			  isSuccess = this.getMsgmod().handle_cfad_021_001_01(map);
			  Map adminInfoMap = (Map)map.get("AdminInfo");
			  Map orgnlGrpHdrMap = (Map)adminInfoMap.get("OrgnlGrpHdr");
			  orgnlMsgId =(String) orgnlGrpHdrMap.get("OrgnlMsgId");
			}
			else if("cfad.026.001.01".equals(msgType))
			{
			  // 接入机构信息变更通知报文
			  this.getMsgmod().handle_cfad_026_001_01(map);
			}
			else if("cfad.011.001.01".equals(msgType))
			{
			  //系统状态变更通知报文
			  this.getMsgmod().handle_cfad_011_001_01(map);
			}
			else if("cfad.040.001.01".equals(msgType))
			{
			  //接收数字证书行号绑定关系变更通知报文
			  this.getMsgmod().handle_cfad_040_001_01(map);
			}
			else if("cfad.013.001.01".equals(msgType))
			{
			  //系统状态查询应答报文
			  isSuccess = this.getMsgmod().handle_cfad_013_001_01(map);
			  Map adminInfoMap = (Map)map.get("AdminInfo");
			  Map orgnlGrpHdrMap= (Map)adminInfoMap.get("OrgnlGrpHdr");
			  orgnlMsgId=(String)orgnlGrpHdrMap.get("OrgnlMsgId");
			}
			else if("cfcm.002.001.01".equals(msgType))
			{
			  // 通用即时信息应答报文
			  isSuccess = this.getMsgmod().handle_cfcm_002_001_01(map);
			  Map prtryDataMap = (Map)map.get("PrtryData");
			  Map orgnSndInfoMap = (Map)prtryDataMap.get("OrgnSndInfo");
			  orgnlMsgId = (String)orgnSndInfoMap.get("OrgnlMsgId");
			}
			else if("cfcm.302.001.01".equals(msgType))
			{
			  // 业务状态查询应答报文
			  isSuccess = this.getMsgmod().handle_cfcm_302_001_01(map);
			  Map orgnlGrpHdrMap = (Map)map.get("OrgnlGrpHdr");
			  orgnlMsgId = (String)orgnlGrpHdrMap.get("OrgnlMsgId");
			}
			else if("cfad.042.001.01".equals(msgType))
			{
			  //数字证书下载应答报文
			  isSuccess = this.getMsgmod().handle_cfad_042_001_01(map);
			  Map orgnlMsgInfMap = (Map)map.get("OrgnlMsgInf");
			  orgnlMsgId = (String)orgnlMsgInfMap.get("OrgnlMsgId");
			}
			else if("cfad.051.001.01".equals(msgType))
			{
			  //登录退出应答报文
			  isSuccess = this.getMsgmod().handle_cfad_051_001_01(map);
			  Map admininfoMap = (Map)map.get("AdminInfo");
			  Map orgnlGrpInf = (Map)admininfoMap.get("OrgnlGrpInf");
			  orgnlMsgId=(String)orgnlGrpInf.get("OrgnlMsgId");
			}
			else if("cfcm.003.001.01".equals(msgType))
			{
			  // 通用信封报文
			  this.getMsgmod().handle_cfcm_003_001_01(map);
			}
			else if("cfcm.001.001.01".equals(msgType))
			{
			  // 通用即时信息报文
			  this.getMsgmod().handle_cfcm_001_001_01(map);
			}
			else if("cfcm.301.001.01".equals(msgType))
			{
			  // 通用业务状态查询报文
			  this.getMsgmod().handle_cfcm_301_001_01(map);
			}

			if(MdaUtils.isEmpty(orgnlMsgId))
			{
			  return true;
			}
			// 应答报文更新mps表状态
			// Platform.clear($mpi);
			// Platform.clear($mps);
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpiorg(),new Argument("msgid",orgnlMsgId));
			log.debug("{}","xmlCreateMessageInformation mpsorg inr="+this.getMpsorg());
			Platform.mdbRead(this.getMpsorg(),new Argument("inr",this.getMpiorg().getInr()));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  if(isSuccess)
			  {
			    // update mps:更新rspsta字段值为"D"
			    this.getMpsorg().setRspsta( "D");
			  }
			  else
			  {
			    this.getMpsorg().setRspsta( "E");
			  }
			  ctx.getDaoSession().dbBegin();
			  ctx.getDaoSession().dbUpdate(this.getMpsorg());
			  ctx.getDaoSession().dbCommit();
			}
			log.debug("{}","xmlCreateMessageInformation mpi inr="+this.getMpi().getInr());
			log.debug("{}","xmlCreateMessageInformation mpi subtype="+this.getMpi().getSubtyp());
			return true;
		}
        /**
        *   source:smpmod.@0076.script
        */
        public boolean fetchAndLockMessageXml(String[] srcchannel,String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			log.debug("{}","获取待发送CIPS报文...");
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("srcchncod",IN,srcchannel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  //20180608新建，监控需要获取mpi相关记录信息
			  MdaUtils.clear(this.getMpi());
			  if(!MdaUtils.isEmpty(this.getMps().getPntinr()))
			  {
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getPntinr()));
			  }
			  else
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  if(!MdaUtils.isEmpty(this.getMpi().getInr()))
			    log.info("{}","mpiinr:"+this.getMpi().getInr());

			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  //存储原xml报文smhinr
			  this.setSmhinr( this.getSmh().getInr());
			  log.debug("{}","CIPS oldsmhinr:"+this.getSmh().getInr());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  String fileName = getCipsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  if(Platform.mfileExists(fileName))
			  {
			    this.getJsonContectXml(fileName);
			  }
			  else
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  log.debug("{}","CIPS newsmhinr:"+this.getMps().getSmhinr());
			  int errorcode = ctx.getErrorCode();
			  log.debug("{}","errorcode="+errorcode);
			  if(errorcode!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0077.script
        */
        public boolean getJsonContectXml(String fileName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *cips报文转换为json报文通过国际结算收报接口发送
			  *fileName文件路径
			  */
			log.debug("{}","cips报文转换json报文发给国际结算/资金清算...");
			Object[] filnam = new Object[1];
			filnam[0] = fileName;
			//调用接口平台获取转换后的json报文
			Object object = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","cipsmsgfromcips","msgfromcips",filnam);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("smpmod","CT000140"),MdaUtils.getI18NString("smpmod","CT000141"));
			  return false;
			}
			//获取接口平台返回的json报文内容
			Object[] obj = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			String jsonstr = (String)obj[0];
			log.debug("{}","cips转json报文内容:"+jsonstr);
			String nextSmhInr = Platform.sdbCounter("smh");
			log.debug("{}","newsmhinr="+nextSmhInr);
			MdaUtils.clear(this.getFilstm());
			IStream msgStream = this.getFilstm();
			try
			{
			  msgStream.getOutputStream().write(jsonstr.getBytes("GB18030"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.error("{}","报文保存失败");
			  return false;
			}

			String nextFileName = getCipsStoreFileFullPathName(nextSmhInr,"cips");
			Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新json报文
			/// 记录MPE处理信息
			Platform.mdbBegin();
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "跨境人民币XML转cips.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			int errorcode = ctx.getErrorCode();
			log.debug("{}","insert mpe errorcode:"+errorcode);
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getCipsdatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "cips");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMps().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","insert smh errorcode:"+ctx.getErrorCode());
			  Platform.mdbRollback();
			  return false;
			}
			Platform.mdbCommit();
			/// 更新MPS信息,20171023添加
			this.getMps().setSmhinr( nextSmhInr);
			return true;
		}
        /**
        *   source:smpmod.@0078.script
        */
        public Boolean transfromStringToStreamUTF(String str,IStream is)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			try
			{
			  //byte[] byt = str.getBytes("ISO-8859-1");
			  //String str1 = new String(byt,"UTF-8");
			  //is.getOutputStream().write(str1.getBytes());//将报文存入流
			  is.getOutputStream().write(str.getBytes("UTF-8"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.error("{}","报文保存失败");
			  return false;
			}
			return true;
		}
        /**
        *   source:smpmod.@0080.script
        */
        public String getCipsStoreFileFullPathName(String fileName, String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(fileName==null||fileType==null) return null;
			else
			{
			  return MdaUtils.catPath(this.getCipsfulldatapath(),fileName.substring(0,4)+"/"+fileName+"." + fileType);
			}
		}
        /**
        *   source:smpmod.@0082.script
        */
        public boolean sf2CreateMessageInformation(String fileName,String messageType,String chncod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","db in sf2:" + Platform.getDefaultDB());
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");
			Object object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsgInfo",fileName);
			if(object==null||!(object instanceof Map))
			  return false;
			Map<String,String> map = (Map)object;
			log.info("{}","map:"+map);

			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getMpi(),map,chncod);
			log.debug("{}","inr :"+this.getMpi().getEtyinr());

			//20171026新加，gpi标识
			if(!MdaUtils.isEmpty(map.get("gpiFlg")))
			{
			  this.getMpi().setGpi( map.get("gpiFlg"));
			}
			//20181022新加，UETR信息
			if(!MdaUtils.isEmpty(map.get("UETR")))
			{
			  this.getMpi().setUetr( map.get("UETR"));
			}
			//20181221新加，GPI的值信息
			if(!MdaUtils.isEmpty(map.get("gpiVal")))
			{
			  this.getMpi().setGpival( map.get("gpiVal"));
			}
			//20181228新加，GPI相关收费信息
			if(!MdaUtils.isEmpty(map.get("sellamt")))
			{
			  this.getMpi().setSelamt( MdaUtils.parseDecimal(map.get("sellamt")));
			}
			if(!MdaUtils.isEmpty(map.get("sellcur")))
			{
			  this.getMpi().setSelcur( map.get("sellcur"));
			}
			if(!MdaUtils.isEmpty(map.get("71Fmsg")))
			{
			  this.getMpi().setMsg71f( map.get("71Fmsg"));
			}

			//20190102更新系统跟踪号生成规则  11位发起系统码+8位时间+15随机数
			/*String  sys_Track_No = "99306000000"+Platform.format(new Date(),"yyyyMMdd")+Platform.sdbCounter("rad","000000000000000");
			  log.info("系统跟踪号：" + sys_Track_No);
			  if(!Platform.isEmpty(sys_Track_No))
			  {
			  $mpi\\systrackn = sys_Track_No;
			  }*/
			//20181227新增会计日期，用于日后对账使用
			this.getMpi().setAccdat( Platform.getAccountDate());
			log.info("{}","会计日期："+this.getMpi().getAccdat());
			//20190528新增唯一流水号，重发过程中流水号不变
			String counterNum = Platform.sdbCounter("zyw");
			String date = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String seqno = "0"+date+counterNum;
			if(!MdaUtils.isEmpty(seqno))
			{
			  this.getMpi().setSrcnum( seqno );
			}
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","sf2 nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map.get("mty"));
			this.getMpi().setSndnum( map.get("sndnum"));
			//20181212新增 541/543报文将20C内容存放在原存放20域的地方
			String msgType = null;
			if(!MdaUtils.isEmpty(map.get("emty")))//ack情况下
			{
			  log.info("{}","ACK报文类型："+ map.get("emty").toString());
			  msgType = map.get("emty").toString();
			}
			else if(!MdaUtils.isEmpty(map.get("mty")))
			{
			  log.info("{}","报文类型："+ map.get("mty").toString());
			  msgType = map.get("mty").toString();
			}
			String ref20C = null;
			if(!MdaUtils.isEmpty(msgType) && ( msgType.equals("541") || msgType.equals("543") ) )
			{
			  log.info("{}","原报文类型："+msgType+",将原报文20C入库。");
			  if(!MdaUtils.isEmpty(map.get("20CInf")))//ack情况下
			  {
			    ref20C = map.get("20CInf").toString();
			  }
			  if(">".equals(this.getMps().getDir()))
			  {
			    this.getMpi().setOthref( ref20C);
			  }
			  else
			  {
			    this.getMpi().setOwnref( ref20C);
			  }
			}
			else if(">".equals(this.getMps().getDir()))//if(">".equals($mps\\dir))原内容
			{
			  this.getMpi().setOwnref( map.get("tscref"));
			  this.getMpi().setOthref( map.get("ref"));
			}
			else
			{
			  this.getMpi().setOwnref( map.get("ref"));
			  this.getMpi().setOthref( map.get("tscref"));
			  if(MdaUtils.isEmpty(this.getMpi().getSndnum()))
			  {
			    /// 注：这里很特殊，非正常的格式转换（正常格式转换通过相应状态变迁实现）
			    String nextSmhInr = Platform.sdbCounter("smh");
			    String sendNumber = "GJZFQZ" + nextSmhInr;
			    String orgFileName = getMessageFullPathName();
			    log.debug("{}","sf2 orgFileName:"+orgFileName);
			    MdaUtils.clear(this.getFilstm());
			    Object result=MdaUtils.invoke("cn.com.brilliance.eibs.SwiftUtils","insertSendNumber",orgFileName,this.getFilstm(),sendNumber);
			    if(result instanceof Boolean && (Boolean)result)
			    {
			      /// 记录MPE处理信息
			      MdaUtils.clear(this.getMpe());
			      this.getMpe().setMpsinr( this.getMps().getInr());
			      this.getMpe().setChncod( this.getMps().getChncod());
			      this.getMpe().setNxtchncod( this.getMps().getChncod());
			      this.getMpe().setSmhinr( this.getSmh().getInr());
			      this.getMpe().setNxtsmhinr( nextSmhInr);
			      this.getMpe().setDattim( new Date());
			      this.getMpe().setPrvsta( this.getMps().getSta());
			      this.getMpe().setSta(  this.getMps().getSta());
			      this.getMpe().setTxt( "自动添加SWIFT报文发送流水号.");
			      this.getMpe().setUsr( MdaEnv.getLoginUser());
			      this.getMpe().setFrmnam( ctx.getTransName());
			      Platform.sdbInsert(this.getMpe());
			      /// 记录SMH信息
			      this.getNxtsmh().setInr( nextSmhInr);
			      this.getNxtsmh().setObjtyp( "mpe");
			      this.getNxtsmh().setObjinr( this.getMpe().getInr());
			      this.getNxtsmh().setCrtfrm( ctx.getTransName());
			      this.getNxtsmh().setDattim( new Date());
			      this.getNxtsmh().setDocpth( this.getDatapath());
			      this.getNxtsmh().setDocfil( nextSmhInr);
			      this.getNxtsmh().setDocfxt( "sf2");
			      String nextFileName = getStoreFileFullPathName(nextSmhInr,"sf2");
			      Platform.mstreamSave(this.getFilstm(),nextFileName);
			      this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			      this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			      this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			      Platform.mdbInsert(this.getNxtsmh());
			      /// 更新MPS信息（Update在unlock为执行）
			      this.getMps().setSmhinr( nextSmhInr);
			      /// 更新MPI信息
			      this.getMpi().setSndnum( sendNumber);

			      if(!MdaUtils.isEmpty(this.getMpi().getUetr()) && "192|196|199".contains(this.getMpi().getSubtyp()) && !MdaUtils.isEmpty(this.getMpi().getGpi()))
			      {
			        log.info("{}","更新对应的rof记录");
			        MdaUtils.clear(this.getQrtmod().getRof());
			        Platform.mdbRead(this.getQrtmod().getRof(),new Argument("megnum",EQ,this.getSmh().getInr()));
			        if(!MdaUtils.isEmpty(this.getQrtmod().getRof().getInr()))
			        {
			          this.getQrtmod().createQreInfo(this.getQrtmod().getRof().getCasnum(),"更新rof信息","X");
			          String rem = this.getQrtmod().getRof().getRem();
			          String newrem = rem + ";更新rof信息";
			          log.debug("{}","smpmod.更新rof"+newrem);
			          this.getQrtmod().getRof().setRem( newrem);
			          this.getQrtmod().getRof().setMegnum( this.getMps().getSmhinr());//经过格式转化后，最终发出报文的smhinr
			          Platform.mdbUpdate(this.getQrtmod().getRof());
			        }
			        else
			        {
			          ctx.getErrorCode();//清除dbRead查询无记录时的errorcode:228
			        }
			      }
			    }
			  }
			}
			log.debug("{}","sf2 mpi sndnum:"+this.getMpi().getSndnum());
			this.getMpi().setSndbic( formatBIC(map.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map.get("rcvbic")));
			this.getMpi().setActbic( formatBIC(map.get("actbic")));
			this.getMpi().setT53bic( formatBIC(map.get("t53bic")));
			this.getMpi().setAct( map.get("act"));
			this.getMpi().setCur( map.get("cur"));
			this.getMpi().setRpscod( map.get("errcod"));
			this.getMpi().setAmt( MdaUtils.parseDecimal(map.get("amt")));
			this.getMpi().setValdat( MdaUtils.parseDate(map.get("vludat"),"yyMMdd"));
			this.getMpi().setGendat( new Date());
			this.getMpi().setDtlchg( map.get("dtlchg"));
			List<String> noTags = new ArrayList();
			noTags.add("20");
			object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "sf2");
			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());

			if("103|192|202COV".contains(this.getMpi().getSubtyp()) && !MdaUtils.isEmpty(this.getMpi().getUetr()))
			{
			  log.debug("{}","db before save103:" + Platform.getDefaultDB());
			  saveMsg103ToGpe(map.get("addinfo"));
			  log.debug("{}","db after save103:" + Platform.getDefaultDB());
			}

			return true;
		}
        /**
        *   source:smpmod.@0083.script
        */
        public boolean updatekFmtWithUnlock2(String channel,String nextChannel,String targetChannel,String state,String message)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 更新以记录状态并解锁
			  - channal:String 当前渠道名
			  - nextChannal:String 下一渠道名
			  - targetChannal:String 目标渠道名
			  - state:String 报文状态
			  - message:String 处理信息
			  - flag:boolean 返回值（为flag时当前处理失败需要这里就提交事务）
			  @ boolean 返回处理是否成功
			  */
			//国际结算境内外币报文回执状态更新
			int errorCode = ctx.getErrorCode();
			/// 如果渠道处理状态为空，则需要通过下一渠道判断应该置的状态
			if(MdaUtils.isEmpty(state))
			{
			  if(!MdaUtils.isEmpty(nextChannel))
			  {
			    Platform.mdbRead(this.getNxtchn(),new Argument("cod",nextChannel));
			    if(ctx.getErrorCode()==NO_ERROR)
			      state = this.getNxtchn().getMpssta();
			  }
			  if(MdaUtils.isEmpty(state))
			    state = "X";
			}
			/// 清空记录准备处理(注：在已知道下一渠道，后续先后处理目标渠道时不再保存MPE的nextChannel，仅更新MPE的txt信息)
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( nextChannel);
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( null);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			if(!MdaUtils.isEmpty(state))
			  this.getMpe().setSta( state);
			this.getMpe().setTxt( message);
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());

			Platform.sdbInsert(this.getMpe());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			/// 设置渠道状态
			if(!MdaUtils.isEmpty(nextChannel))
			  this.getMps().setNxtchncod( nextChannel);
			/// 目标渠道更新
			if(!MdaUtils.isEmpty(targetChannel))
			  this.getMps().setTgtchncod( targetChannel);
			this.getMps().setLstdattim( this.getMpe().getDattim());
			this.getMps().setSta( state); /// 这里注意可能需要做格式转换
			this.getMps().setNxtsta( state);
			this.getMps().setStp( "XXX");
			log.debug("{}","smhinr before back: "+this.getSmhinr());
			this.getMps().setSmhinr( this.getSmhinr());
			log.debug("{}","mps old smhinr is "+this.getMps().getSmhinr());
			Platform.mdbUpdate(this.getMps());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			/// 对MPS记录进行解锁
			Platform.sdbUnLock(this.getMps());
			return true;
		}
        /**
        *   source:smpmod.@0088.script
        */
        public String getB2eStoreFileFullPathName(String fileName, String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(fileName==null||fileType==null) return null;
			else
			{
			  return MdaUtils.catPath(this.getB2efulldatapath(),fileName.substring(0,4)+"/"+fileName+"." + fileType);
			}
		}
        /**
        *   source:smpmod.@0089.script
        */
        public boolean b2eCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析接收到的上划下拨bocb2e报文，包括：
			  * b2e0019 资金主动调拨
			  * b2e0005 当日余额查询
			  * b2e0073 主动推送-余额变动信息
			  * b2e0001 签到交易
			  */
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");
			Object[] filnam = new Object[1];
			filnam[0] = fileName;
			Object object = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","Parsexmltojson","parse",filnam);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("smpmod","CT000158"),MdaUtils.getI18NString("smpmod","CT000159"));
			  return false;
			}
			//获取接口平台返回的内容
			Object[] obj = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			log.debug("{}","上划下拨报文内容:"+obj);
			String jsonMessage = (String)obj[0];//转换后的json串
			log.debug("{}","b2e json:"+jsonMessage);
			Map<String,Object> map = (Map<String,Object>)obj[1];//解析的map信息
			ctx.storeData("b2emap",map);
			log.debug("{}","b2e map:"+map);

			String nam = MdaEnv.getLoginUser();
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			if(!MdaUtils.isEmpty(map.get("TRNCOD")))//交易代码
			{
			  log.info("{}","交易代码:"+map.get("TRNCOD"));
			  String subtyp = (String)map.get("TRNCOD");
			  this.getMpi().setSubtyp( subtyp.substring(4,7));//取后3位
			}
			String ref = null;
			String relref = null;
			if(!MdaUtils.isEmpty(map.get("MSGID")))
			{
			  log.info("{}","报文标识号:"+map.get("MSGID"));
			  ref = (String)map.get("MSGID");
			}
			if("073".equals(this.getMpi().getSubtyp()))
			{
			  String d = MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  ref="G"+d+Platform.sdbCounter("b2e0073","00000");
			  log.info("{}","b2e0073MSGID"+ref);
			}
			if(!MdaUtils.isEmpty(map.get("OBSSMSGID")))
			{
			  log.info("{}","b2e0073交易流水号:"+map.get("OBSSMSGID"));
			  relref = (String)map.get("OBSSMSGID");
			}
			if(">".equals(this.getMps().getDir()))
			{
			  if(!MdaUtils.isEmpty(ref))
			    this.getMpi().setOthref( ref);
			  if(!MdaUtils.isEmpty(relref))
			    this.getMpi().setOwnref( relref);
			  this.getMpi().setSndbic( "BKCHCNBJXXX");
			  this.getMpi().setRcvbic( "PSBCCNBJXXX");
			}
			else
			{
			  if(!MdaUtils.isEmpty(ref))
			    this.getMpi().setOwnref( ref);
			  this.getMpi().setSndbic( "PSBCCNBJXXX");
			  this.getMpi().setRcvbic( "BKCHCNBJXXX");
			}

			String subtyp = (String)map.get("TRNCOD");
			if(!MdaUtils.isEmpty(subtyp))
			{
			  String act = null;
			  if(subtyp.equals("b2e0019")&&!MdaUtils.isEmpty(map.get("TOACTACN")))//收汇人账号
			  {
			    act = (String)map.get("TOACTACN");
			    this.getMpi().setAct( act.trim());
			    log.debug("{}","b2e0019 ACT:"+this.getMpi().getAct());
			  }
			  else if(subtyp.equals("b2e0005")&&!MdaUtils.isEmpty(map.get("ACTACN")))
			  {
			    act = (String)map.get("ACTACN");//收汇人账号
			    this.getMpi().setAct( act.trim());
			    log.debug("{}","b2e0005 ACT:"+this.getMpi().getAct());
			  }
			  else if(subtyp.equals("b2e0073")&&!MdaUtils.isEmpty(map.get("ACNTNAME")))
			  {
			    act = (String)map.get("ACNTNAME");//收汇人账号
			    this.getMpi().setAct( act.trim());
			    log.debug("{}","b2e0073 ACT:"+this.getMpi().getAct());
			  }
			}
			if(!MdaUtils.isEmpty(map.get("TRNAMT")))//金额
			{
			  String amt = (String)map.get("TRNAMT");
			  this.getMpi().setAmt( MdaUtils.parseDecimal(amt));
			  log.debug("{}","b2e0019 AMT:"+this.getMpi().getAmt());
			}
			else if(!MdaUtils.isEmpty(map.get("TXNAMT")))//金额
			{
			  String amt = (String)map.get("TXNAMT");
			  this.getMpi().setAmt( MdaUtils.parseDecimal(amt));
			  log.debug("{}","b2e0073 AMT:"+this.getMpi().getAmt());
			}
			if(!MdaUtils.isEmpty(map.get("TRNCUR")))//币种
			{
			  String cur = (String)map.get("TRNCUR");
			  this.getMpi().setCur( cur);
			  log.debug("{}","CUR:"+cur);
			}

			if(!MdaUtils.isEmpty(map.get("VALDAT")))//起息日
			{
			  String valdat = (String)map.get("VALDAT");
			  this.getMpi().setValdat( MdaUtils.parseDate(valdat,"yyyy-MM-dd"));
			  log.debug("{}","b2e0073 VALDAT:"+this.getMpi().getValdat());
			}
			this.getMpi().setGendat( new Date());
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setFwdref( Platform.getAccountDate());
			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());
			return true;
		}
        /**
        *   source:smpmod.@0085.script
        */
        public boolean jshCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析发给中行的上划下拨报文
			  */
			if(!"<".equals(this.getMps().getDir()))
			{
			  log.error("{}","报文方向错误，dir="+this.getMps().getDir());
			  return false;
			}
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");

			String nextSmhInr = Platform.sdbCounter("smh");
			Object[] filnam = new Object[1];
			filnam[0] = fileName;
			Object msgObject = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","Packetxmlfromjson","packet",filnam);
			Boolean obt = (Boolean)MdaUtils.invoke(msgObject,"isSuccess");
			if(!obt)
			{
			  log.error("{}","组报失败");
			  return false;
			}
			Object[] objs = (Object[])MdaUtils.invoke(msgObject,"getContent");
			String cipsMessage = (String)objs[0];//组好的上划下拨报文
			log.debug("{}","上划下拨 message:"+cipsMessage);
			Map<String,Object> map = (Map<String,Object>)objs[1];//Map对象
			log.debug("{}","上划下拨 MAP:"+map);
			//关联所属实体
			//sysmod.setEtyAndPtyCIPS($mpi,map);
			//将组装好的报文存成临时文件
			MdaUtils.clear(this.getFilstm());
			transfromStringToStreamUTF(cipsMessage,this.getFilstm());//将cipsMessange写入filstm
			String nextFileName = getB2eStoreFileFullPathName(nextSmhInr,"b2e");
			Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新b2e报文
			//存储报文
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","cips-xml nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			if(!MdaUtils.isEmpty(map.get("TRANBRANCH")))
			{
			  String subtyp = (String)map.get("TRANBRANCH");
			  this.getMpi().setBranch( subtyp);
			}
			if(!MdaUtils.isEmpty(map.get("TRNCOD")))//交易代码
			{
			  log.info("{}","交易代码:"+map.get("TRNCOD"));
			  String subtyp = (String)map.get("TRNCOD");
			  this.getMpi().setSubtyp( subtyp.substring(4,7));//取后3位
			}
			String ref = null;
			if(!MdaUtils.isEmpty(map.get("MSGID")))
			{
			  log.info("{}","报文标识号:"+map.get("MSGID"));
			  ref = (String)map.get("MSGID");
			}
			if(">".equals(this.getMps().getDir()))
			{
			  if(!MdaUtils.isEmpty(ref))
			    this.getMpi().setOthref( ref);
			  this.getMpi().setSndbic( "BKCHCNBJXXX");
			  this.getMpi().setRcvbic( "PSBCCNBJXXX");
			}
			else
			{
			  if(!MdaUtils.isEmpty(ref))
			    this.getMpi().setOwnref( ref);
			  this.getMpi().setSndbic( "PSBCCNBJXXX");
			  this.getMpi().setRcvbic( "BKCHCNBJXXX");
			}

			/// 记录MPE处理信息
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "上划下拨Json转BOCB2E.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getB2edatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "b2e");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			/// 更新MPS信息（Update在unlock为执行）
			this.getMps().setSmhinr( nextSmhInr);
			/// 更新MPI信息
			String subtyp = (String)map.get("TRNCOD");
			if(!MdaUtils.isEmpty(subtyp))
			{
			  String act = null;
			  if(subtyp.equals("b2e0019")&&!MdaUtils.isEmpty(map.get("TOACTACN")))//收汇人账号
			  {
			    act = (String)map.get("TOACTACN");
			    this.getMpi().setAct( act.trim());
			    log.debug("{}","b2e0019 ACT:"+this.getMpi().getAct());
			  }
			  else if(subtyp.equals("b2e0005")&&!MdaUtils.isEmpty(map.get("ACTACN")))
			  {
			    act = (String)map.get("ACTACN");//收汇人账号
			    this.getMpi().setAct( act.trim());
			    log.debug("{}","b2e0005 ACT:"+this.getMpi().getAct());
			  }
			  else if(subtyp.equals("b2e0073")&&!MdaUtils.isEmpty(map.get("ACNTNAME")))
			  {
			    act = (String)map.get("ACNTNAME");//收汇人账号
			    this.getMpi().setAct( act.trim());
			    log.debug("{}","b2e0073 ACT:"+this.getMpi().getAct());
			  }
			}
			if(!MdaUtils.isEmpty(map.get("TRNAMT")))//金额
			{
			  String amt = (String)map.get("TRNAMT");
			  this.getMpi().setAmt( MdaUtils.parseDecimal(amt));
			  log.debug("{}","b2e0019 AMT:"+this.getMpi().getAmt());
			}
			else if(!MdaUtils.isEmpty(map.get("TXNAMT")))//金额
			{
			  String amt = (String)map.get("TXNAMT");
			  this.getMpi().setAmt( MdaUtils.parseDecimal(amt));
			  log.debug("{}","b2e0073 AMT:"+this.getMpi().getAmt());
			}

			if(!MdaUtils.isEmpty(map.get("TRNCUR")))//币种
			{
			  String cur = (String)map.get("TRNCUR");
			  this.getMpi().setCur( cur);
			  log.debug("{}","CUR:"+cur);
			}
			if(!MdaUtils.isEmpty(map.get("VALDAT")))//起息日
			{
			  String valdat = (String)map.get("VALDAT");
			  this.getMpi().setValdat( MdaUtils.parseDate(valdat,"yyyy-MM-dd"));
			  log.debug("{}","b2e0073 VALDAT:"+this.getMpi().getValdat());
			}
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "b2e");
			this.getMpi().setFwdref( Platform.getAccountDate());

			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());
			return true;
		}
        /**
        *   source:smpmod.@0086.script
        */
        public boolean fetchAndLockMessageB2e(String[] srcchannel,String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			log.debug("{}","获取待发送B2E报文...");
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("srcchncod",IN,srcchannel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  //存储原xml报文smhinr
			  this.setSmhinr( this.getSmh().getInr());
			  log.debug("{}","B2E oldsmhinr:"+this.getSmh().getInr());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  String fileName = getB2eStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  log.info("{}","othref"+this.getMpi().getOthref());
			  if(Platform.mfileExists(fileName))
			  {
			    this.getJsonContectB2e(fileName,this.getMpi().getOthref().toString());
			  }
			  else
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  log.debug("{}","B2E newsmhinr:"+this.getMps().getSmhinr());
			  int errorcode = ctx.getErrorCode();
			  log.debug("{}","errorcode="+errorcode);
			  if(errorcode!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0087.script
        */
        public boolean getJsonContectB2e(String fileName,String msgid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *cips报文转换为json报文通过国际结算收报接口发送
			  *fileName文件路径
			  */
			log.debug("{}","b2e报文转换json报文发给资金清算...");
			Object[] filnam = new Object[2];
			filnam[0] = fileName;
			filnam[1] = msgid;
			//调用接口平台获取转换后的json报文
			Object object = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","Parsexmltojson","parse",filnam);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("smpmod","CT000170"),MdaUtils.getI18NString("smpmod","CT000171"));
			  return false;
			}
			//获取接口平台返回的json报文内容
			Object[] obj = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			String jsonstr = (String)obj[0];
			log.debug("{}","B2E转json报文内容:"+jsonstr);
			String nextSmhInr = Platform.sdbCounter("smh");
			log.debug("{}","newsmhinr="+nextSmhInr);
			MdaUtils.clear(this.getFilstm());
			IStream msgStream = this.getFilstm();
			try
			{
			  msgStream.getOutputStream().write(jsonstr.getBytes("GB18030"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.error("{}","报文保存失败");
			  return false;
			}

			String nextFileName = getB2eStoreFileFullPathName(nextSmhInr,"jsh");
			Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新json报文
			/// 记录MPE处理信息
			Platform.mdbBegin();
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "中行前置B2E转JSH");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			int errorcode = ctx.getErrorCode();
			log.debug("{}","insert mpe errorcode:"+errorcode);
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getB2edatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "jsh");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMps().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","insert smh errorcode:"+ctx.getErrorCode());
			  Platform.mdbRollback();
			  return false;
			}
			Platform.mdbCommit();
			/// 更新MPS信息,20171023添加
			this.getMps().setSmhinr( nextSmhInr);
			return true;
		}
        /**
        *   source:smpmod.@0090.script
        */
        public String getZywStoreFileFullPathName(String fileName, String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(fileName==null||fileType==null) return null;
			else
			{
			  return MdaUtils.catPath(this.getZywfulldatapath(),fileName.substring(0,4)+"/"+fileName+"." + fileType);
			}
		}
        /**
        *   source:smpmod.@0091.script
        */
        public boolean fetchAndLockMessageZyw(String[] srcchannel,String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			log.info("{}","获取待发送ZYW报文...");
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("srcchncod",IN,srcchannel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  //存储原xml报文smhinr
			  this.setSmhinr( this.getSmh().getInr());
			  log.info("{}","ZYWXML oldsmhinr:"+this.getMps().getSmhinr());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  String fileName = getStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  log.info("{}","othref:"+this.getMpi().getOthref());
			  log.info("{}","path:"+fileName);
			  if(Platform.mfileExists(fileName))
			  {
			    //getXmlContectSf2(fileName,$mpi\\othref.getValue().toString());
			    getXmlContectSf2(fileName);
			  }
			  else
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  log.debug("{}","ZYWXML newsmhinr:"+this.getMps().getSmhinr());
			  int errorcode = ctx.getErrorCode();
			  log.debug("{}","errorcode="+errorcode);
			  if(errorcode!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0092.script
        */
        public boolean getXmlContectSf2(String fileName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","sf2报文转换xml报文发给资金业务...");
			Object[] filnam = new Object[1];
			filnam[0] = fileName;
			//filnam[1] = msgid;
			//调用接口平台获取转换后的json报文
			Object object = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","SwiftToXml","SwiftToXml",filnam);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  log.info("{}","组报失败！");
			  return false;
			}
			//获取接口平台返回的json报文内容
			Object[] obj = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			String xmlstr = (String)obj[0];
			log.debug("{}","sf2转xml报文内容:"+xmlstr);
			String nextSmhInr = Platform.sdbCounter("smh");
			log.debug("{}","newsmhinr="+nextSmhInr);
			MdaUtils.clear(this.getFilstm());
			IStream msgStream = this.getFilstm();
			try
			{
			  msgStream.getOutputStream().write(xmlstr.getBytes("UTF-8"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.error("{}","报文保存失败");
			  return false;
			}

			String nextFileName = getZywStoreFileFullPathName(nextSmhInr,"nxl");
			Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新xml报文
			/// 记录MPE处理信息
			Platform.mdbBegin();
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "资金业务SF2转XML");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			int errorcode = ctx.getErrorCode();
			log.debug("{}","insert mpe errorcode:"+errorcode);
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getZywdatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "nxl");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMps().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","insert smh errorcode:"+ctx.getErrorCode());
			  Platform.mdbRollback();
			  return false;
			}
			Platform.mdbCommit();
			/// 更新MPS信息,20171023添加
			this.getMps().setSmhinr( nextSmhInr);
			return true;
		}
        /**
        *   source:smpmod.@0095.script
        */
        public boolean nxlCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析接收到的新一代资金业务报文
			  * 暂未修改
			  */
			if(!"<".equals(this.getMps().getDir()))
			{
			  log.error("{}","报文方向错误，dir="+this.getMps().getDir());
			  return false;
			}
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");

			String nextSmhInr = Platform.sdbCounter("smh");
			Object[] filnam = new Object[1];
			filnam[0] = fileName;

			Object object = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","ParseXmlToMap","ParseXmlToMap",filnam);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  log.error("{}","解析失败");
			  return false;
			}
			//获取接口平台返回的内容
			Object[] objs = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			log.debug("{}","报文内容:"+objs);
			String jsonMessage = (String)objs[0];//转换后的json串
			log.debug("{}","json:"+jsonMessage);
			Map<String,Object> map = (Map<String,Object>)objs[1];//解析的map信息
			ctx.storeData("zqszywmap",map);
			log.debug("{}","ZQSZYWMAP:"+map);
			Object msgObject = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","XmlToSwift","parse",filnam);
			Boolean oct = (Boolean)MdaUtils.invoke(msgObject,"isSuccess");
			if(!oct)
			{
			  log.error("{}","组报失败");
			  return false;
			}
			Object[] obj = (Object[])MdaUtils.invoke(msgObject,"getContent");
			String sftMessage = (String)obj[0];//组好的报文
			log.debug("{}","Swift message:"+sftMessage);

			MdaUtils.clear(this.getFilstm());
			transfromStringToStream(sftMessage,this.getFilstm());//将sftMessage写入filstm
			String nextFileName = getStoreFileFullPathName(nextSmhInr,"sf2");
			log.info("{}","资金业务Swift报文存储路径："+nextFileName);
			//Platform.streamSave($filstm.getValue(),nextFileName);//保存新报文
			Platform.mstreamSave(this.getFilstm(),nextFileName);
			//20190620新增关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getMpi(),map);
			log.debug("{}","inr :"+this.getMpi().getEtyinr());
			//存储报文
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","ZQSZYW nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setSrcnum( (String)map.get("SEQNO"));
			log.info("{}","原资金业务流水号："+this.getMpi().getSrcnum());
			this.getMpi().setMsgtyp( messageType);

			String block1 = null;
			if(!MdaUtils.isEmpty(map.get("block1")))
			  block1 = (String)map.get("block1");
			String block2 = null;
			if(!MdaUtils.isEmpty(map.get("block2")))
			  block2 = (String)map.get("block2");

			if(map.containsKey("block3_108") && !MdaUtils.isEmpty(map.get("block3_108")))
			{
			  this.getMpi().setSndnum( (String)map.get("block3_108"));
			}
			//存储UETR信息
			if(map.containsKey("block3_121") && !MdaUtils.isEmpty(map.get("block3_121")))
			{
			  this.getMpi().setUetr( (String)map.get("block3_121"));
			}
			//新一代发送202自动加上GPI标识,非202报文需进行判断
			if(!MdaUtils.isEmpty(block2) && block2.substring(1,4).equals("202"))
			{
			  log.info("{}","报文类型："+block2.substring(1,4)+"新一代202报文，加入GPI信息");
			  this.getMpi().setGpi( "GPI");
			  this.getMpi().setGpival( "004");
			}
			/* if(map.containsKey("block3_111") && !Platform.isEmpty(map.get("block3_111")))
			  {
			  $mpi\\gpi = "GPI";
			  $mpi\\gpival = (String)map.get("block3_111");
			  }*/

			if(!MdaUtils.isEmpty(block1) && !MdaUtils.isEmpty(block2))
			{
			  this.getMpi().setSubtyp( block2.substring(1,4));
			  String str = block2.substring(0,1);
			  if("I".equals(str))
			  {
			    this.getMpi().setSndbic( formatBIC(block1.substring(3,15)));
			    this.getMpi().setRcvbic( formatBIC(block2.substring(4,16)));
			  }
			  else if("O".equals(str))
			  {
			    this.getMpi().setSndbic( formatBIC(block2.substring(14,26)));
			    this.getMpi().setRcvbic( formatBIC(block1.substring(3,15)));
			  }
			}

			//挡板上
			/* String sndtst = $mpi\\sndbic.getValue().toString().substring(7,8);
			  String rcvtst = $mpi\\rcvbic.getValue().toString().substring(7,8);
			  if(!"0".equals(sndtst) || !"0".equals(rcvtst))
			  {
			  log.info("不接受此类报文!");
			  Platform.mdbRead($mps,new Argument<String>("inr",$mpi\\inr));
			  $mps\\sta="E";
			  Platform.dbUpdate($mps);
			  return false;
			  }*/
			//挡板下
			//20181129新增系统跟踪号字段
			// Object sysTrackNo = Platform.invoke("cn.com.brilliance.psbc.service.zjyw.handle.AbsYWServiceHandler","getSysTrackNo");
			//20190102更新系统跟踪号生成规则  11位发起系统码+8位时间+15随机数
			String  sys_Track_No = "99306000000"+MdaUtils.format(new Date(),"yyyyMMdd")+Platform.sdbCounter("rad","000000000000000");
			log.info("{}","系统跟踪号：" + sys_Track_No);
			//20181227新增会计日期，用于对账服务使用
			this.getMpi().setAccdat( Platform.getAccountDate());
			log.info("{}","会计日期："+this.getMpi().getAccdat());
			if(!MdaUtils.isEmpty(sys_Track_No))
			{
			  this.getMpi().setSystrackn( sys_Track_No);
			}
			String ownref = null;
			String othref = null;
			if(!MdaUtils.isEmpty(map.get("block4_20")))
			{
			  ownref = (String)map.get("block4_20");
			}
			if(!MdaUtils.isEmpty(map.get("block4_21")))
			{
			  othref = (String)map.get("block4_21");
			}
			//20181212新增 541/543报文将20C内容存放在原存放20域的地方
			String msgType = null;
			if(!MdaUtils.isEmpty(block2))
			{
			  msgType = block2.substring(1,4);
			}
			String ref20c = null ;
			if(!MdaUtils.isEmpty(map.get("block4_20C")))
			{
			  ref20c = (String)map.get("block4_20C");
			}
			if("541".equals(msgType)||"543".equals(msgType))
			{
			  log.info("{}","原报文类型："+msgType+",将原报文20C入库。");
			  if(">".equals(this.getMps().getDir()))
			  {
			    this.getMpi().setOthref( ref20c);
			  }
			  else
			  {
			    this.getMpi().setOwnref( ref20c);
			  }

			}
			else if(">".equals(this.getMps().getDir()))//if(">".equals($mps\\dir))原内容
			{
			  if(!MdaUtils.isEmpty(ownref))
			    this.getMpi().setOthref( ownref);
			  if(!MdaUtils.isEmpty(othref))
			    this.getMpi().setOwnref( othref);
			}
			else
			{
			  if(!MdaUtils.isEmpty(ownref))
			    this.getMpi().setOwnref( ownref);
			  if(!MdaUtils.isEmpty(othref))
			    this.getMpi().setOthref( othref);
			}
			//币种金额,针对300/320报文
			String curamt = (String)map.get("block4_32B");
			if(!MdaUtils.isEmpty(curamt))
			{
			  String cur = curamt.substring(0,3);
			  this.getMpi().setCur( cur);
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.substring(3).replace(",", ".")));
			}

			//币种金额，针对202报文
			String str32a = (String)map.get("block4_32A");
			if(!MdaUtils.isEmpty(str32a) && str32a.matches("\\d{6}[A-Z]{3}\\d{1,15},\\d*"))
			{
			  String valDat = str32a.substring(0, 6);
			  String cur = str32a.substring(6, 9);
			  String amt = str32a.substring(9);
			  this.getMpi().setCur( cur);
			  //先不存储金额，20190415，后存储金额-20190429
			  log.info("{}","mpi-inr:"+this.getMpi().getInr()+",mpi-amt:"+MdaUtils.parseDecimal(amt.replace(",", ".")));
			  this.getMpi().setAmt( MdaUtils.parseDecimal(amt.replace(",", ".")));
			  this.getMpi().setValdat( MdaUtils.parseDate(valDat,"yyMMdd"));
			}
			/// 记录MPE处理信息
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "资金业务Xml转Swift.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getDatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "sf2");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			ctx.getDaoSession().dbInsert(this.getNxtsmh());
			/// 更新MPS信息（Update在unlock为执行）
			this.getMps().setSmhinr( nextSmhInr);
			//2019-04-30新增s新一代发送wift202，原渠道更新为ZYS
			if(!MdaUtils.isEmpty(this.getMpi().getSubtyp()) && "202".equals(this.getMpi().getSubtyp()))
			{
			  this.getMps().setSrcchncod( "ZYS");
			}
			/// 更新MPI信息
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setGendat( new Date());
			this.getMpi().setMsgtyp( "sf2");

			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());
			return true;
		}
        /**
        *   source:smpmod.@0096.script
        */
        public boolean createMessageProcessSubjectForMan19Ns(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			Platform.esdbRead(this.getChn(),new Argument("cod",channel));
			/// 未知渠道或当前渠道状态非接收状态
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  Platform.esdbRead(this.getTgtchn(),new Argument("cod",targetChannel));
			  /// 未知目标渠道则将其设置为空
			  if(ctx.getErrorCode()!=NO_ERROR)
			    targetChannel = null;
			}
			int errorcode = ctx.getErrorCode();
			/// 获取报文记录inr
			String smhinr = null;
			log.debug("{}","msgedt smpmod smhinr:"+this.getSmh().getInr());
			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  smhinr = this.getSmh().getInr();
			  this.setEdtflg( "ame");
			}
			else
			{
			  MdaUtils.clear(this.getMps());
			  MdaUtils.clear(this.getSmh());
			  smhinr = Platform.sdbCounter("smh");
			  this.setEdtflg( "new");
			}
			log.debug("{}","smpmod edtflg:"+this.getEdtflg());
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "O"); // 中间状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			if("new".equals(this.getEdtflg()))
			{
			  log.debug("{}","smpmod insert mps...");
			  Platform.sdbInsert(this.getMps());
			}
			else if("ame".equals(this.getEdtflg()))
			{
			  log.debug("{}","smpmod update mps:"+this.getMps().getInr());
			  Platform.mdbUpdate(this.getMps());
			}
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert&dbUpdate mps with errorcode:" + errorcode);
			  //Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			if("ame".equals(this.getEdtflg()))
			  this.getMpe().setPrvsta( "C");
			else if("new".equals(this.getEdtflg()))
			  this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "V"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			if("new".equals(this.getEdtflg()))
			{
			  this.getSmh().setInr( smhinr);
			}
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;
			if("cips|xml".contains(messageType))
			{
			  fileName = getCipsStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getCipsdatapath());
			}
			else
			  fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getSmh());
			else if("new".equals(this.getEdtflg()))
			  Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			//Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0097.script
        */
        public boolean saveMsg103ToGpe(Object inf)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getGpe());
			//20191119新加，非gpi报文不存储gpe记录
			if(MdaUtils.isEmpty(this.getMpi().getGpi()))
			{
			  log.info("{}","非gpi报文，不进行处理.");
			  return true;
			}
			//20190108新加，添加UETR相关信息
			if("192".equals(this.getMpi().getSubtyp()) && !MdaUtils.isEmpty(inf))
			{
			  String str76 = (String)inf;
			  int index = getLinePos(str76);
			  if (index > 0)
			  {
			    String frtLin = str76.substring(0, index);// 第一行
			    log.info("{}","frtLin:" + frtLin);
			    if (frtLin.startsWith("/"))
			    {
			      log.info("{}","192报文的79域.");
			      String[] str = frtLin.split("/");
			      if (str.length == 3)
			      {
			        log.info("{}","First状态11: " + str[1] + "," + str[2]);
			        this.getGpe().setRspsta( str[1]);
			        this.getGpe().setRspcod( str[2]);
			      }
			      else if (str.length == 2)
			      {
			        log.info("{}","First状态21: " + str[1]);
			        this.getGpe().setRspsta( str[1]);
			      }
			    }
			    String sndLin = str76.substring(index + 2);// 第二行
			    log.info("{}","sndline:" + sndLin);
			    String[] strbic = sndLin.split("/");
			    if (strbic.length == 2)
			    {
			      log.info("{}","Second银行12: " + strbic[0] + "," + strbic[1]);
			      this.getGpe().setOrgbic( strbic[1].length() > 20 ? (strbic[1].substring(0,20)) :
			      strbic[1] );
			      this.getGpe().setFwdbic( strbic[2].length() > 20 ? (strbic[2].substring(0,20)) :
			      strbic[2]);
			    }
			    else
			    {
			      log.info("{}","Second银行22: " + sndLin);

			      this.getGpe().setOrgbic( sndLin.length() > 20 ? (sndLin.substring(0,20)) :
			      sndLin );
			    }
			  }
			  else
			  {
			    String[] str = str76.split("/");
			    if (str.length == 3)
			    {
			      log.info("{}","First状态12: " + str[1] + "," + str[2]);
			      this.getGpe().setRspsta( str[1]);
			      this.getGpe().setRspcod( str[2]);
			    }
			    else if (str.length == 2)
			    {
			      log.info("{}","First状态22: " + str[1]);
			      this.getGpe().setRspsta( str[1]);
			    }
			  }
			}
			if(!MdaUtils.isEmpty(this.getMps().getPntinr()))
			  this.getGpe().setMpsinr( this.getMps().getPntinr());
			else
			  this.getGpe().setMpsinr( this.getMps().getInr());
			this.getGpe().setDir( this.getMpi().getDir());
			this.getGpe().setSndbic( this.getMpi().getSndbic());
			this.getGpe().setRcvbic( this.getMpi().getRcvbic());
			this.getGpe().setUetr( this.getMpi().getUetr());
			this.getGpe().setUsrnam( MdaEnv.getLoginUser());
			this.getGpe().setSubtyp( this.getMpi().getSubtyp());
			this.getGpe().setCur( this.getMpi().getCur());
			this.getGpe().setAmt( this.getMpi().getAmt());
			this.getGpe().setCredattim( MdaUtils.today());
			this.getGpe().setTxt( "生成"+this.getMpi().getSubtyp()+"报文记录时,存储gpe记录");

			//20190116新增，添加gpe的mpstim字段
			if(!MdaUtils.isEmpty(this.getMps().getDir()))
			{
			  log.debug("{}","新增,添加gpe的mpstim字段");
			  if("<".equals(this.getMps().getDir()))
			    this.getGpe().setMpstim( this.getMps().getSnddattim());
			  else
			    this.getGpe().setMpstim( this.getMps().getRcvdattim());
			}

			Platform.sdbInsert(this.getGpe());
			log.info("{}","gpeinr:"+this.getGpe().getInr());
			int errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpi with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			return true;
		}
        /**
        *   source:smpmod.@0098.script
        */
        public int getLinePos(String str)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 屏蔽不同系统的换行符差异，获取换行符位置
			if (str == null)
			  return -1;
			int idxr = str.indexOf("\r");
			int idxn = str.indexOf("\n");
			if (idxr > -1 && idxn > -1)// \\r\\n连接在一起
			{
			  return idxr < idxn ? idxr : idxn;
			  }
			  else
			  {
			    return idxr <= idxn ? idxn : idxr;// 单个\\r或者\\n的情况，返回较大的
			  }
					}
        /**
        *   source:smpmod.@0099.script
        */
        public void readChn(com.ceb.gjjs.mda.bo.Chn chn,String channel)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map chnmap = null;
			com.ceb.gjjs.mda.bo.Chn tmpchn = null;
			synchronized(this)
			{
			  if(MdaUtils.isEmpty(this.getChnmap()))
			  {
			    chnmap=new HashMap();
			  }
			  else
			  {
			    chnmap=this.getChnmap();
			    tmpchn=(com.ceb.gjjs.mda.bo.Chn)chnmap.get(channel);
			  }
			  if(tmpchn==null)
			  {
			    tmpchn = new Chn();
			    Platform.esdbRead(tmpchn,new Argument("cod",channel));
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      MdaUtils.clear(chn);
			      return;
			    }
			    chnmap.put(channel,tmpchn);
			    this.setChnmap(chnmap);
			  }
			}
			chn.copyValues(tmpchn);
		}
        /**
        *   source:smpmod.@0100.script
        */
        public boolean fetchAndLockMessage(String channel, String state,String dir )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("<".equals(dir))
			{
			  log.info("{}","开始往报清分....");
			}
			else
			{
			  log.info("{}","开始来报清分....");
			}
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			//Platform.setDefaultDB(db);
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			log.info("{}","channel:"+channel+",state:"+state+",dir:"+dir);
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("sta",state).and("dir",dir).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));

			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;

			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  log.info("{}","锁定mps记录为，inr="+mps.getInr());
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			  {
			    log.debug("{}","锁定mps记录失败，inr="+mps.getInr());
			    continue;
			  }
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);

			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  if(ctx.getErrorCode()!=NO_ERROR)
			    continue;
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0101.script
        */
        public String insertSndnumBeforeSend2()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 注：这里很特殊，非正常的格式转换（正常格式转换通过相应状态变迁实现）
			String nextSmhInr = Platform.sdbCounter("smh");
			String sendNumber = "GJZFQZ" + nextSmhInr;
			String orgFileName = getMessageFullPathName2();
			log.debug("{}","sf2 orgFileName:"+orgFileName);
			MdaUtils.clear(this.getFilstm());
			Object result=MdaUtils.invoke("cn.com.brilliance.eibs.SwiftUtils","insertSendNumber",orgFileName,this.getFilstm(),sendNumber);
			if(result instanceof Boolean && (Boolean)result)
			{
			  /// 记录SMH信息
			  MdaUtils.clear(this.getNxtsmh());
			  this.getNxtsmh().setInr( nextSmhInr);
			  this.getNxtsmh().setObjtyp( "mpe");
			  this.getNxtsmh().setObjinr( this.getMpetmp().getInr());
			  this.getNxtsmh().setCrtfrm( ctx.getTransName());
			  this.getNxtsmh().setDattim( new Date());
			  this.getNxtsmh().setDocpth( this.getDatapath());
			  this.getNxtsmh().setDocfil( nextSmhInr);
			  this.getNxtsmh().setDocfxt( "sf2");
			  String nextFileName = getStoreFileFullPathName(nextSmhInr,"sf2");
			  Platform.mstreamSave(this.getFilstm(),nextFileName);
			  this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			  this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			  this.getNxtsmh().setMpiinr( this.getMpitmp().getInr());
			  Platform.mdbInsert(this.getNxtsmh());
			  /// 更新MPI信息
			  this.getMpitmp().setSndnum( sendNumber);
			  log.debug("{}","mpi sndnum:"+this.getMpitmp().getSndnum());
			  Platform.mdbUpdate(this.getMpitmp());
			}
			log.debug("{}","insertSndnumBeforeSend errorcode:"+ctx.getErrorCode());
			return nextSmhInr;
		}
        /**
        *   source:smpmod.@0102.script
        */
        public String getMessageFullPathName2()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("cips|xml".contains(this.getSmhtmp().getDocfxt()))
			  return getCipsStoreFileFullPathName(this.getSmhtmp().getDocfil(),this.getSmhtmp().getDocfxt());
			else if("b2e|jsh".contains(this.getSmhtmp().getDocfxt()))
			{
			  return getB2eStoreFileFullPathName(this.getSmhtmp().getDocfil(),this.getSmhtmp().getDocfxt());
			}
			else if("nxl".contains(this.getSmhtmp().getDocfxt()))
			{
			  return getZywStoreFileFullPathName(this.getSmhtmp().getDocfil(),this.getSmhtmp().getDocfxt());
			}
			else
			  return getStoreFileFullPathName(this.getSmhtmp().getDocfil(),this.getSmhtmp().getDocfxt());
		}
        /**
        *   source:smpmod.@0103.script
        */
        public boolean sf2CreateMessageInformationForMan2(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");
			Object object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsgInfo",fileName);
			if(object==null||!(object instanceof Map))
			  return false;
			Map<String,String> map = (Map)object;
			log.trace("{}","map:"+map);
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","sf2 nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map.get("mty"));
			this.getMpi().setSndnum( map.get("sndnum"));
			if(">".equals(this.getMps().getDir()))
			{
			  this.getMpi().setOwnref( map.get("tscref"));
			  this.getMpi().setOthref( map.get("ref"));
			}
			else
			{
			  this.getMpi().setOwnref( map.get("ref"));
			  this.getMpi().setOthref( map.get("tscref"));
			  if(MdaUtils.isEmpty(this.getMpi().getSndnum()))
			  {
			    /// 注：这里很特殊，非正常的格式转换（正常格式转换通过相应状态变迁实现）
			    String nextSmhInr = Platform.sdbCounter("smh");
			    String sendNumber = "GJZFQZ" + nextSmhInr;
			    String orgFileName = getMessageFullPathName();
			    log.debug("{}","sf2 orgFileName:"+orgFileName);
			    MdaUtils.clear(this.getFilstm());
			    Object result=MdaUtils.invoke("cn.com.brilliance.eibs.SwiftUtils","insertSendNumber",orgFileName,this.getFilstm(),sendNumber);
			    if(result instanceof Boolean && (Boolean)result)
			    {
			      /// 记录MPE处理信息
			      MdaUtils.clear(this.getMpe());
			      this.getMpe().setMpsinr( this.getMps().getInr());
			      this.getMpe().setChncod( this.getMps().getChncod());
			      this.getMpe().setNxtchncod( this.getMps().getChncod());
			      this.getMpe().setSmhinr( this.getSmh().getInr());
			      this.getMpe().setNxtsmhinr( nextSmhInr);
			      this.getMpe().setDattim( new Date());
			      this.getMpe().setPrvsta( this.getMps().getSta());
			      this.getMpe().setSta(  this.getMps().getSta());
			      this.getMpe().setTxt( "自动添加SWIFT报文发送流水号.");
			      this.getMpe().setUsr( MdaEnv.getLoginUser());
			      this.getMpe().setFrmnam( ctx.getTransName());
			      Platform.sdbInsert(this.getMpe());
			      /// 记录SMH信息
			      this.getNxtsmh().setInr( nextSmhInr);
			      this.getNxtsmh().setObjtyp( "mpe");
			      this.getNxtsmh().setObjinr( this.getMpe().getInr());
			      this.getNxtsmh().setCrtfrm( ctx.getTransName());
			      this.getNxtsmh().setDattim( new Date());
			      this.getNxtsmh().setDocpth( this.getDatapath());
			      this.getNxtsmh().setDocfil( nextSmhInr);
			      this.getNxtsmh().setDocfxt( "sf2");
			      String nextFileName = getStoreFileFullPathName(nextSmhInr,"sf2");
			      Platform.mstreamSave(this.getFilstm(),nextFileName);
			      this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			      this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			      this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			      Platform.mdbInsert(this.getNxtsmh());
			      /// 更新MPS信息（Update在unlock为执行）
			      this.getMps().setSmhinr( nextSmhInr);
			      Platform.mdbUpdate(this.getMps());
			      /// 更新MPI信息
			      this.getMpi().setSndnum( sendNumber);
			    }
			  }
			}
			log.debug("{}","sf2 mpi sndnum:"+this.getMpi().getSndnum());
			this.getMpi().setSndbic( formatBIC(map.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map.get("rcvbic")));
			this.getMpi().setActbic( formatBIC(map.get("actbic")));
			this.getMpi().setT53bic( formatBIC(map.get("t53bic")));
			this.getMpi().setAct( map.get("act"));
			this.getMpi().setCur( map.get("cur"));
			this.getMpi().setRpscod( map.get("errcod"));
			this.getMpi().setAmt( MdaUtils.parseDecimal(map.get("amt")));
			this.getMpi().setValdat( MdaUtils.parseDate(map.get("vludat"),"yyMMdd"));
			this.getMpi().setGendat( new Date());
			this.getMpi().setDtlchg( map.get("dtlchg"));
			//20181025新加，gpi标识
			if(!MdaUtils.isEmpty(map.get("gpiFlg")))
			{
			  this.getMpi().setGpi( map.get("gpiFlg"));
			}
			//20181025新加，UETR信息
			if(!MdaUtils.isEmpty(map.get("UETR")))
			{
			  this.getMpi().setUetr( map.get("UETR"));
			}
			//20181221新加，GPI的值信息
			if(!MdaUtils.isEmpty(map.get("gpiVal")))
			{
			  this.getMpi().setGpival( map.get("gpiVal"));
			}
			//20181228新加，GPI相关收费信息
			if(!MdaUtils.isEmpty(map.get("sellamt")))
			{
			  this.getMpi().setSelamt( MdaUtils.parseDecimal(map.get("sellamt")));
			}
			if(!MdaUtils.isEmpty(map.get("sellcur")))
			{
			  this.getMpi().setSelcur( map.get("sellcur"));
			}
			if(!MdaUtils.isEmpty(map.get("71Fmsg")))
			{
			  this.getMpi().setMsg71f( map.get("71Fmsg"));
			}
			//20181129新增系统跟踪号字段
			String sysTrackNo = "99306000000"+MdaUtils.format(new Date(),"yyyyMMdd")+Platform.sdbCounter("rad","000000000000000");
			log.info("{}","系统跟踪号：" + sysTrackNo);
			//20181227新增会计日期，用于日后对账使用
			this.getMpi().setAccdat( Platform.getAccountDate());
			log.info("{}","会计日期："+this.getMpi().getAccdat());
			if(!MdaUtils.isEmpty(sysTrackNo))
			{
			  this.getMpi().setSystrackn( sysTrackNo);
			}
			List<String> noTags = new ArrayList();
			noTags.add("20");
			object=MdaUtils.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			if(object!=null&&object instanceof String)
			{
			  String noTag20Block4 = (String)object;
			  this.getMpi().setN20sha( MdaUtils.decode(noTag20Block4.getBytes(),DECODE_SHA));
			}
			else
			  this.getMpi().setN20sha( "");
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");

			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getMpi());

			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());

			if("103|192|202COV".contains(this.getMpi().getSubtyp()) && !MdaUtils.isEmpty(this.getMpi().getUetr()))
			  saveMsg103ToGpe(map.get("addinfo"));

			return true;
		}
        /**
        *   source:smpmod.@0104.script
        */
        public boolean createMessageProcessSubjectForYYP(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理,只针对银邮发汇做延时发送处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			/*
			  Platform.esdbRead($chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			readChn(this.getChn(),channel);
			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}
			/*
			  Platform.mdbBegin();
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }*/
			int errorcode = ctx.getErrorCode();
			log.debug("{}","before mdbBegin");
			Platform.mdbBegin();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "YSS"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "W"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			String mpsinr = Platform.sdbInsert(this.getMps());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "A"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;
			if("cips|xml".contains(messageType))
			{
			  fileName = getCipsStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getCipsdatapath());
			}
			else if("jsh|b2e".contains(messageType))
			{
			  fileName = getB2eStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getB2edatapath());
			}
			else if("nxl".contains(messageType))
			{
			  fileName = getZywStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getZywdatapath());
			}
			else
			  fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			
			//新增yss延时清分记录
			MdaUtils.clear(this.getYss());
			this.getYss().setMpsinr( mpsinr);
			this.getYss().setSubtyp("103");
			this.getYss().setFrmtyp( "YYP");
			this.getYss().setCredattim( MdaUtils.today());
			this.getYss().setSta( "W");
			Platform.sdbInsert(this.getYss());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert yss with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0105.script
        */
        public String getElcsStoreFileFullPathName(String fileName, String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(fileName==null||fileType==null) return null;
			else
			{
			  return MdaUtils.catPath(this.getElcsfulldatapath(),fileName.substring(0,4)+"/"+fileName+"." + fileType);
			}
		}
        /**
        *   source:smpmod.@0106.script
        */
        public boolean elcsCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *读取对应路径下elcs报文要素
			  *调用api组报
			  *返回报文map，进行存库，mpi、mpe、smh
			  */
			log.info("{}","-----------elcsCreateMessageInformation-------------" );

			if(!"<".equals(this.getMps().getDir()))
			{
			  log.error("{}","报文方向错误，dir="+this.getMps().getDir());
			  return false;
			}
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");

			String nextSmhInr = Platform.sdbCounter("smh");

			IStream is = this.getFilstm();
			Platform.mstreamLoad(is,fileName);
			String filcontent = Platform.convertIStream2String(is);
			log.info("{}","文件内容" + filcontent );

			//String filcontent = (String)Platform.invoke("com.brilliance.swift.MessageReader","getElcsMsg",fileName);
			
			//byte [] bytMsg = (byte [])Platform.invoke("com.brilliance.xml.MessageReader","readToByte",fileName);
			//Object obj = Platform.invoke("com.brilliance.dzxt.utils.MsgUtil","packMessage",bytMsg,"UTF-8");
			
			Object obj = MdaUtils.invoke("com.brilliance.dzxt.utils.MsgUtil","packMessage",filcontent);
			//String elcsMessage = Platform.invoke(obj,"getMessage").toString();
			String elcsMessage ="";
			if(!MdaUtils.isEmpty(obj))
			{
			  log.info("{}","getMessage的值：" + MdaUtils.invoke(obj,"getMessage"));
			  if(!MdaUtils.isEmpty(MdaUtils.invoke(obj,"getMessage")))
			  {
			    elcsMessage = MdaUtils.invoke(obj,"getMessage").toString();
			    //将组装好的报文存成临时文件
			    MdaUtils.clear(this.getFilstm());
			    transfromStringToStreamUTF(elcsMessage,this.getFilstm());
			    String nextFileName = getElcsStoreFileFullPathName(nextSmhInr,"exl");
			    Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新elcs报文
			
			    /// 记录SMH信息
			    this.getNxtsmh().setInr( nextSmhInr);
			    this.getNxtsmh().setObjtyp( "mpe");
			    this.getNxtsmh().setObjinr( this.getMpe().getInr());
			    this.getNxtsmh().setCrtfrm( ctx.getTransName());
			    this.getNxtsmh().setDattim( new Date());
			    this.getNxtsmh().setDocpth( this.getElcsdatapath());
			    this.getNxtsmh().setDocfil( nextSmhInr);
			    this.getNxtsmh().setDocfxt( "exl");
			    this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			    this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			    this.getNxtsmh().setMpiinr( this.getMps().getInr());//0309
			    Platform.mdbInsert(this.getNxtsmh());
			    /// 更新MPS信息（Update在unlock为执行）
			    this.getMps().setSmhinr( nextSmhInr);
			    log.info("{}"," mps smhinr " + this.getMps().getSmhinr() );

			  }

			  else
			  {
			    //国结cpisschema校验失败，新增接口处理
			    log.debug("{}","elcs的scheam校验失败处理");
			    // if("rxxtsk".equals(Platform.getTransName())&&"GJS".equals($mps\\srcchncod.getValue()))
			    cipsScheamError("ELCS");
			    log.error("{}","组报失败");

			  }
			}

			log.info("{}","message :" + elcsMessage );//组报后的xml格式报文
			
			Map map = new com.google.gson.Gson().fromJson(filcontent, Map.class);

			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPtyELCS(this.getMpi(),map);

			//存储报文
			String nam = MdaEnv.getLoginUser();
			this.getMpi().setUsrnam( nam);
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			String subtyp = null;
			if(!MdaUtils.isEmpty(map.get("MesgType")))
			{
			  subtyp = (String)map.get("MesgType");
			  this.getMpi().setSubtyp( subtyp.substring(5,8));
			}
			log.debug("{}","mpi subtyp"+this.getMpi().getSubtyp());

			this.getMpi().setMsgid( (String)map.get("MesgID"));//通讯级标识号
			
			Map hmap = (Map)map.get("GrpHdr");//报文头
			String oref= (String)hmap.get("MsgId");//报文标识号
			this.getMpi().setOwnref(oref);

			String vdate=oref.substring(0,8);
			log.debug("{}","委托日期："+vdate);
			this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));

			if(!MdaUtils.isEmpty(map.get("LCInfo")))
			{
			  Map lmap = (Map)map.get("LCInfo");
			  if(!MdaUtils.isEmpty(lmap.get("LCNb")))
			    this.getMpi().setLcnb( (String)lmap.get("LCNb"));

			  if(!MdaUtils.isEmpty(lmap.get("LCAmt")))
			  {
			    Map curamt = (Map)lmap.get("LCAmt");//信用证金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    log.debug("{}","mpi amount"+this.getMpi().getAmt());
			  }
			}
			else  if(!MdaUtils.isEmpty(map.get("LCId")))
			{
			  Map lmap = (Map)map.get("LCId");//信用证主键组件
			  if(!MdaUtils.isEmpty(lmap.get("LCNb")))
			    this.getMpi().setLcnb( (String)lmap.get("LCNb"));
			}

			String oriref = null;
			String ref = null;

			if(!MdaUtils.isEmpty(map.get("OrgnlGrpHdr")))
			{
			  Map orgmap = (Map)map.get("OrgnlGrpHdr");//原信用证主键组件
			  oriref = (String)orgmap.get("OrgnlMsgId");
			}

			if(!MdaUtils.isEmpty(oriref))
			  this.getMpi().setOthref( oriref);

			/// 记录MPE处理信息
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "电证系统报文json转ELCS.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());

			/// 更新MPI信息
			// pyeact.get("Id")
			this.getMpi().setSndbic( (String)map.get("OrigSender"));
			this.getMpi().setRcvbic( (String)map.get("OrigReceiver"));

			if(!MdaUtils.isEmpty(subtyp))
			{
			  String act = null;
			  if(!MdaUtils.isEmpty(map.get("ApplInfo")))
			  {
			    Map appmap = (Map)map.get("ApplInfo");//申请人信息
			    if(!MdaUtils.isEmpty(appmap.get("DbtrAcct")))
			    {
			      act = (String)appmap.get("DbtrAcct");
			      this.getMpi().setAct( act.trim());
			    }
			  }

			  if(!MdaUtils.isEmpty(map.get("BfcyInfo")))
			  {
			    Map bfcmap = (Map)map.get("BfcyInfo");//受益人信息
			
			    if(!MdaUtils.isEmpty(bfcmap.get("CdtrAcct")))
			    {
			      act =  (String)bfcmap.get("CdtrAcct");
			      this.getMpi().setAct( act.trim());
			    }

			  }

			  //金额处理
			  this.getMpi().setCur("CNY");

			  if(subtyp.equals("elcs.201.001.01")&&!MdaUtils.isEmpty(map.get("PresnInfo")))
			  {
			    Map curmap = (Map)map.get("PresnInfo");
			    Map curmap1 = (Map)curmap.get("DocsInfo");

			    if(!MdaUtils.isEmpty(curmap1.get("DocsAmt")))
			    {
			      Map curamt = (Map)curmap1.get("DocsAmt");//索偿金额
			      this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    }
			  }
			  else if(subtyp.equals("elcs.203.001.01")&&!MdaUtils.isEmpty(map.get("BllArlConfInfo")))
			  {
			    Map curmap = (Map)map.get("BllArlConfInfo");
			    if(!MdaUtils.isEmpty(curmap.get("BllArlAmt")))
			    {
			      Map curamt = (Map)curmap.get("BllArlAmt");//到单金额
			      this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    }
			  }
			  else if(subtyp.equals("elcs.212.001.01")&&!MdaUtils.isEmpty(map.get("PmtsConfInfo")))
			  {
			    Map curmap = (Map)map.get("PmtsConfInfo");
			    if(!MdaUtils.isEmpty(curmap.get("HonAmt")))
			    {
			      Map curamt = (Map)curmap.get("HonAmt");//承付金额
			      this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    }
			  }
			  else if(subtyp.equals("elcs.211.001.01")&&!MdaUtils.isEmpty(map.get("NegoInfo")))
			  {
			    Map curmap = (Map)map.get("NegoInfo");
			    if(!MdaUtils.isEmpty(curmap.get("NegoAmt")))
			    {
			      Map curamt = (Map)curmap.get("NegoAmt");//议付金额
			      this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    }
			  }
			  else if(subtyp.equals("elcs.213.001.01")&&!MdaUtils.isEmpty(map.get("PresnInfo")))
			  {
			    Map curmap = (Map)map.get("PresnInfo");
			    if(!MdaUtils.isEmpty(curmap.get("PresnAmt")))
			    {
			      Map curamt = (Map)curmap.get("PresnAmt");//议付金额
			      this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    }
			  }
			  else if(subtyp.equals("elcs.221.001.01")&&!MdaUtils.isEmpty(map.get("PmtInfo")))
			  {
			    Map curmap = (Map)map.get("PmtInfo");
			    if(!MdaUtils.isEmpty(curmap.get("Amt")))
			    {
			      Map curamt = (Map)curmap.get("Amt");//议付金额
			      this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    }
			  }

			}

			this.getMpi().setGendat( new Date());

			if(!MdaUtils.isEmpty(map.get("PresnInfo")))
			{
			  Map premap = (Map)map.get("PresnInfo");//寄单索款信息
			  if(!MdaUtils.isEmpty(premap.get("PresnBkChrgs")))
			  {
			    String dtlchg = (String)premap.get("PresnBkChrgs");
			    this.getMpi().setDtlchg( dtlchg.trim());//交单行费用
			  }
			}

			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "exl");

			log.debug("{}","edtflg"+this.getEdtflg());

			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());

			if(MdaUtils.isEmpty(MdaUtils.invoke(obj,"getMessage")))
			{
			  return false;
			}

			return true;
		}
        /**
        *   source:smpmod.@0108.script
        */
        public boolean exlCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析接收到的ELCS报文
			  */

			log.info("{}","-----------exlCreateMessageInformation-------------" );

			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");
			log.info("{}","fileName :"+fileName);
			java.io.File file = new java.io.File(fileName);

			Object obj = MdaUtils.invoke("com.brilliance.dzxt.utils.MsgUtil","unPackMessage",new Object[]{file});
			boolean ve=vertifyElcs(obj);
			if(!ve)
			  return false;

			String elcsMessage = MdaUtils.invoke(obj,"getElcsModelForJson").toString();
			log.info("{}","elcsMessage");
			//此处因新版dzxt.jar(报文解析包)解报结果中不包含flatElcs模型,故去除此处逻辑
			/*int i = elcsMessage.indexOf("flatElcs");
			  i = i - 2;//去掉左侧逗号和左引号
			  String elsmsg = elcsMessage.substring(0,i)+"}";*/
			Map map = new com.google.gson.Gson().fromJson(elcsMessage, Map.class);
			log.info("{}","map :" + map );//json完整报文
			ctx.storeData("elcsmap",map);

			String nam = MdaEnv.getLoginUser();
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			log.info("{}","mpi msgtyp :" + messageType);
			this.getMpi().setMsgid( (String)map.get("MesgID"));

			String subtyp=null;
			if(!MdaUtils.isEmpty(map.get("MesgType")))
			{
			  subtyp = (String)map.get("MesgType");
			  this.getMpi().setSubtyp( subtyp.substring(5,8));
			}
			log.info("{}","mpi subtyp :" + this.getMpi().getSubtyp() );
			String oriref = null;
			String ref = "";

			if("903".equals(this.getMpi().getSubtyp()))
			{
			  String signstr = MdaUtils.invoke(obj,"getSignatureInfo").toString();
			  ctx.storeData("signstr",signstr);
			}

			//新增921报文处理 20210504
			if("921".equals(this.getMpi().getSubtyp()))
			{
			  List list903= (List) map.get("CertfctnList");
			  //这里最好只处理一条903，统一走do_CPSNotice(type)函数
			  for(int i=0;i<list903.size();i++)
			  {
			    Map map903= (Map)list903.get(i);
			    String base64Str=map903.get("DgtlSgntr").toString();
			    // String elcs903Str=Platform.decode(base64Str.getBytes(),DECODE_BASE64);
			    obj = MdaUtils.invoke("com.brilliance.dzxt.utils.MsgUtil","unPackMessage",new Object[]{base64Str});
			    ve=vertifyElcs(obj);
			    if(!ve)
			    {
			      log.info("{}","921-903 vertify ="+ve);
			      return false;
			    }

			    elcsMessage = MdaUtils.invoke(obj,"getElcsModelForJson").toString();
			    Map map2 = new com.google.gson.Gson().fromJson(elcsMessage, Map.class);
			    log.info("{}","921-903map :" + map2 );//json完整报文
			    ctx.storeData("elcsmap",map2);
			    String signstr = MdaUtils.invoke(obj,"getSignatureInfo").toString();
			    ctx.storeData("signstr",signstr);
			    break;
			  }
			}

			if (!"911|990".contains(this.getMpi().getSubtyp()))
			{
			  Map hmap = (Map)map.get("GrpHdr");
			  if (!MdaUtils.isEmpty(hmap.get("MsgId")))
			  {
			    ref = (String)hmap.get("MsgId");

			    String vdate=ref.substring(0,8);
			    log.debug("{}","委托日期："+vdate);
			    this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			  }
			}
			if(!MdaUtils.isEmpty(map.get("LCInfo")))
			{
			  Map lmap = (Map)map.get("LCInfo");
			  if(!MdaUtils.isEmpty(lmap.get("LCNb")))
			    this.getMpi().setLcnb( (String)lmap.get("LCNb"));

			  if(!MdaUtils.isEmpty(lmap.get("LCAmt")))
			  {
			    Map curamt = (Map)lmap.get("LCAmt");//信用证金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    log.debug("{}","mpi amount"+this.getMpi().getAmt());
			  }
			}
			else  if(!MdaUtils.isEmpty(map.get("LCId")))
			{
			  Map lmap = (Map)map.get("LCId");//信用证主键组件
			  if(!MdaUtils.isEmpty(lmap.get("LCNb")))
			    this.getMpi().setLcnb( (String)lmap.get("LCNb"));
			}

			this.getMpi().setSndbic( (String)map.get("OrigSender"));
			this.getMpi().setRcvbic( (String)map.get("OrigReceiver"));
			if(!MdaUtils.isEmpty(map.get("OrgnlGrpHdr")))
			{
			  Map orgmap = (Map)map.get("OrgnlGrpHdr");
			  if(!MdaUtils.isEmpty(orgmap.get("OrgnlGrpHdr")))
			    oriref = (String)orgmap.get("OrgnlMsgId");//原报文标识号
			}
			else if(!MdaUtils.isEmpty(map.get("OrgnlMsgInf")))
			{
			  Map orgmap = (Map)map.get("OrgnlMsgInf");
			  if(!MdaUtils.isEmpty(orgmap.get("OrgnlMsgId")))
			    oriref = (String)orgmap.get("OrgnlMsgId");//原报文标识号
			}

			if(">".equals(this.getMps().getDir()))
			{
			  if(!MdaUtils.isEmpty(ref))
			    this.getMpi().setOthref( ref);
			  if(!MdaUtils.isEmpty(oriref))
			    this.getMpi().setOwnref( oriref);
			}

			log.info("{}","subtyp :" + subtyp);

			String act = null;
			if(!MdaUtils.isEmpty(map.get("ApplInfo")))
			{
			  Map appmap = (Map)map.get("ApplInfo");//申请人信息
			  if(!MdaUtils.isEmpty(appmap.get("DbtrAcct")))
			  {
			    act = (String)appmap.get("DbtrAcct");
			    this.getMpi().setAct( act.trim());
			  }
			}

			if(!MdaUtils.isEmpty(map.get("BfcyInfo")))
			{
			  Map bfcmap = (Map)map.get("BfcyInfo");//受益人信息
			
			  if(!MdaUtils.isEmpty(bfcmap.get("CdtrAcct")))
			  {
			    act =  (String)bfcmap.get("CdtrAcct");
			    this.getMpi().setAct( act.trim());
			  }
			}

			//金额处理
			
			this.getMpi().setCur("CNY");

			if(("elcs.201.001.01").equals(subtyp)&&!MdaUtils.isEmpty(map.get("PresnInfo")))
			{
			  Map curmap = (Map)map.get("PresnInfo");
			  if(!MdaUtils.isEmpty(curmap.get("ClmAmt")))
			  {
			    Map curamt = (Map)curmap.get("ClmAmt");//索偿金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			  }
			}
			else if(("elcs.203.001.01").equals(subtyp)&&!MdaUtils.isEmpty(map.get("BllArlConfInfo")))
			{
			  Map curmap = (Map)map.get("BllArlConfInfo");
			  if(!MdaUtils.isEmpty(curmap.get("BllArlAmt")))
			  {
			    Map curamt = (Map)curmap.get("BllArlAmt");//到单金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			  }
			}
			else if(("elcs.212.001.01").equals(subtyp)&&!MdaUtils.isEmpty(map.get("PmtsConfInfo")))
			{
			  Map curmap = (Map)map.get("PmtsConfInfo");
			  if(!MdaUtils.isEmpty(curmap.get("HonAmt")))
			  {
			    Map curamt = (Map)curmap.get("HonAmt");//承付金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			  }
			}
			else if(("elcs.211.001.01").equals(subtyp)&&!MdaUtils.isEmpty(map.get("NegoInfo")))
			{
			  Map curmap = (Map)map.get("NegoInfo");
			  if(!MdaUtils.isEmpty(curmap.get("NegoAmt")))
			  {
			    Map curamt = (Map)curmap.get("NegoAmt");//议付金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			  }
			}
			else if(("elcs.213.001.01").equals(subtyp)&&!MdaUtils.isEmpty(map.get("PresnAmt")))
			{
			  Map curamt = (Map)map.get("PresnAmt");//寄单索款金额
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			}
			else if(("elcs.221.001.01").equals(subtyp)&&!MdaUtils.isEmpty(map.get("PmtInfo")))
			{
			  Map curmap = (Map)map.get("PmtInfo");
			  if(!MdaUtils.isEmpty(curmap.get("Amt")))
			  {
			    Map curamt = (Map)curmap.get("Amt");//议付金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			  }
			}

			/* else if("elcs.938.001.01".equals(subtyp)||"elcs.231.001.01".equals(subtyp)||"elcs.232.001.01".equals(subtyp)||"ccms.999.001.01".equals(subtyp))
			  {
			  log.info("收到["+subtyp+"]报文,更新目标渠道为FFT");
			  $mps\\tgtchncod="FFT";
			  }*/

			this.getMpi().setGendat( new Date());
			if(!MdaUtils.isEmpty(map.get("PresnInfo")))
			{
			  Map premap = (Map)map.get("PresnInfo");//寄单索款信息
			  if(!MdaUtils.isEmpty(premap.get("PresnBkChrgs")))
			  {
			    String dtlchg = (String)premap.get("PresnBkChrgs");
			    this.getMpi().setDtlchg( dtlchg.trim());//交单行费用
			  }
			}
			log.debug("{}","mpi dtlchg="+this.getMpi().getDtlchg());

			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "exl");
			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());

			return true;
		}
        /**
        *   source:smpmod.@0109.script
        */
        public boolean fetchAndLockMessageXyz(String srcchannel,String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","获取待发送信用证报文...");
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("srcchncod",srcchannel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			//  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  //20180608新建，监控需要获取mpi相关记录信息
			  /*Platform.clear($mpi);
			    if(!Platform.isEmpty($mps\\pntinr))
			    {
			    Platform.mdbRead($mpi,new Argument("inr",$mps\\pntinr.getValue()));
			    }
			    else
			    Platform.mdbRead($mpi,new Argument("inr",$mps\\inr.getValue()));
			    if(!Platform.isEmpty($mpi\\inr))
			    log.info("mpiinr:"+$mpi\\inr.getValue());*/

			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  //存储原xml报文smhinr
			  this.setSmhinr( this.getSmh().getInr());
			  log.debug("{}","ELCS oldsmhinr:"+this.getSmh().getInr());
			  int errorcode = ctx.getErrorCode();
			  log.debug("{}","errorcode= "+errorcode);
			  if(errorcode!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  String fileName = getElcsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  if(Platform.mfileExists(fileName))
			  {
			    this.getJsonContectXml2(fileName);
			  }
			  else
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  log.debug("{}","ELCS newsmhinr:"+this.getMps().getSmhinr());
			  int errorcode1 = ctx.getErrorCode();
			  log.debug("{}","errorcode="+errorcode1);
			  if(errorcode1!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }

			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0111.script
        */
        public boolean getJsonContectXml2(String fileName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *信用证报文转换为json报文通过国际结算收报接口发送
			  *fileName文件路径
			  */
			log.debug("{}","信用证报文转换json报文发给国际结算...");
			log.info("{}","fileName :"+fileName);
			java.io.File file = new java.io.File(fileName);

			Object obj = MdaUtils.invoke("com.brilliance.dzxt.utils.MsgUtil","unPackMessage",new Object[]{file});
			Boolean obt = (Boolean)MdaUtils.invoke(obj,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  String errMsg = MdaUtils.invoke(obj,"getErrMsg").toString();
			  String err = errMsg.substring(8,14);
			  if(err.indexOf("数字签名")>=0)
			  {
			    MdaUtils.invoke(obj,"setStrict",false);
			  }
			  else
			  {
			    log.error("{}","解报失败");
			    return false;
			  }
			}
			log.info("{}","解报成功");

			String elcsMessage = MdaUtils.invoke(obj,"getElcsModelForJson").toString();
			log.info("{}","全部json内容 :" + elcsMessage );//解报后的json串
			
			int i = elcsMessage.indexOf("flatElcs");
			i = i - 2;//去掉左侧逗号和左引号
			String jsonstr = elcsMessage;
			log.info("{}","截取后json内容 :" + elcsMessage );//
			
			if(MdaUtils.isEmpty(jsonstr))
			{
			  log.debug("{}","信用证报文转换json失败...");
			  return false;
			}

			String nextSmhInr = Platform.sdbCounter("smh");
			log.debug("{}","newsmhinr="+nextSmhInr);

			MdaUtils.clear(this.getFilstm());

			//新增电子信用证916报文处理
			Map map = new com.google.gson.Gson().fromJson(jsonstr, Map.class);
			log.debug("{}","MesgType="+map.get("MesgType"));
			Platform.mdbBegin();
			if(!MdaUtils.isEmpty(map.get("MesgType"))&&"ccms.916.001.01".equals(map.get("MesgType")))
			{
			  log.debug("{}","开始处理电子信用证916报文");
			  IStream is = this.getFilstm();
			  Date date = MdaUtils.today();
			  boolean status = false;//文件发送状态
			  String storePath = MdaUtils.catPath(this.getElcsfulldatapath(),"elcs916"+"/");
			  String sequence = Platform.esdbCounter("elcs916" + MdaUtils.format(date,"yyyyMMdd"),"0000");
			  //20210809 sulike 调整电证916报文
			  String storeFileName = "99306000000_XGJJS_ELCS_0000_"+MdaUtils.format(date,"yyyyMMdd")+"_I_"+sequence+"_0001.xml";
			  String fullPath = MdaUtils.catPath(storePath,storeFileName);
			  try
			  {
			    is.getOutputStream().write(jsonstr.getBytes("UTF-8"));
			    is.getOutputStream().flush();
			    Platform.mstreamSave(is,fullPath);
			    log.info("{}","在路径[" + fullPath + "]下生成电子信用证916文件成功，开始进行文件上传操作.");
			  }
			  catch(Exception e)
			  {
			    log.info("{}","在路径[" + fullPath + "]下生成电子信用证916文件异常.");
			    log.error("{}",e);
			  }
			  boolean sendStatus=(Boolean)MdaUtils.invoke("cn.com.brilliance.psbc.service.eftp.EFTPManager","eftpInfoUpload",fullPath,"XGJJS_ELCS");
			  log.info("{}","电子信用证916文件发送状态："+String.valueOf(sendStatus));
			  if(sendStatus)
			  {
			    status=true;
			    log.info("{}","发送电子信用证916文件通知到数据共享成功");
			    log.debug("{}","MPSinr="+this.getMps().getInr());
			    boolean flg = updatekFmtWithUnlock("GJS", null, "ELC", "D", "成功发送文件至数据共享");
			    log.debug("{}","更新发送状态:"+flg);
			  }
			  MdaUtils.invoke("cn.com.brilliance.psbc.service.mq.SendMessageToMonitorMQ","invokeSendFile",date,date,"GJS","发送","99711230000",String.valueOf(status),storeFileName,storePath);
			}
			else
			{
			  IStream msgStream = this.getFilstm();
			  try
			  {
			    msgStream.getOutputStream().write(jsonstr.getBytes("GB18030"));//将报文存入流
			  }
			  catch(java.io.IOException ee)
			  {
			    log.error("{}","报文保存失败");
			    return false;
			  }
			  String nextFileName = getElcsStoreFileFullPathName(nextSmhInr,"elcs");
			  Platform.mstreamSave(this.getFilstm(),nextFileName);//保存新json报文
			
			  /// 记录MPE处理信息
			  MdaUtils.clear(this.getMpe());
			  this.getMpe().setMpsinr( this.getMps().getInr());
			  this.getMpe().setChncod( this.getMps().getChncod());
			  this.getMpe().setNxtchncod( this.getMps().getChncod());
			  this.getMpe().setSmhinr( this.getSmh().getInr());
			  this.getMpe().setNxtsmhinr( nextSmhInr);
			  this.getMpe().setDattim( new Date());
			  this.getMpe().setPrvsta( this.getMps().getSta());
			  this.getMpe().setSta(  this.getMps().getSta());
			  this.getMpe().setTxt( "电子信用证XML转json");
			  this.getMpe().setUsr( MdaEnv.getLoginUser());
			  this.getMpe().setFrmnam( ctx.getTransName());
			  Platform.sdbInsert(this.getMpe());
			  int errorcode = ctx.getErrorCode();
			  log.debug("{}","insert mpe errorcode:"+errorcode);
			  /// 记录SMH信息
			  this.getNxtsmh().setInr( nextSmhInr);
			  this.getNxtsmh().setObjtyp( "mpe");
			  this.getNxtsmh().setObjinr( this.getMpe().getInr());
			  this.getNxtsmh().setCrtfrm( ctx.getTransName());
			  this.getNxtsmh().setDattim( new Date());
			  this.getNxtsmh().setDocpth( this.getElcsdatapath());
			  this.getNxtsmh().setDocfil( nextSmhInr);
			  this.getNxtsmh().setDocfxt( "elcs");
			  this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			  this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			  this.getNxtsmh().setMpiinr( this.getMps().getInr());
			  Platform.mdbInsert(this.getNxtsmh());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    log.debug("{}","insert smh errorcode:"+ctx.getErrorCode());
			    Platform.mdbRollback();
			    return false;
			  }
			}
			Platform.mdbCommit();
			/// 更新MPS信息,20171023添加
			this.getMps().setSmhinr( nextSmhInr);
			return true;
		}
        /**
        *   source:smpmod.@0112.script
        */
        public /**
*存储对账信息统计表内容和对账信息详情表内容
*@param mainRecordMap 统计表信息内容
*@param infoRecordMap 详情表信息内容
*@param isCeate       是否为新增操作，如该参数不传，默认为新建操作；否则为更新
*注：当isCeate==false时，infoRecordLst中的map键SEQNUM/BILNUM/REFNUM和refdir必须存在（非空文件），否则无法进行更新详情信息
*参数内容有调用方提供，本方法存储约定好内容
*/
boolean generatorFileRecordInfo(Map<String,String> mainRecordMap,List< Map<String,String> > infoRecordLst,boolean isCeate)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean genstatus = false ;
			if(mainRecordMap.size()==0)
			{
			  log.info("{}","存入/更新对账统计表信息失败！原因：对账统计表信息信息参数不正确。统计表参数总数："+mainRecordMap.size());
			  return genstatus;
			}
			MdaUtils.clear(this.getMcr());
			MdaUtils.clear(this.getIcr());
			int errorcode = ctx.getErrorCode();
			// String mcrinr = "" ;
			Platform.mdbBegin();
			log.info("{}","开启事务");
			try
			{
			  if(isCeate)
			  {
			    //由国际支付前置发起对账申请/接收对账申请时会调用
			    log.info("{}","新增对账统计表信息："+mainRecordMap);
			    String mcrinr = Platform.sdbCounter("mcr");
			    this.getMcr().setInr( mcrinr );
			    this.getMcr().setLcadat(MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			    this.getMcr().setSndsys(String.valueOf(mainRecordMap.get("SNDSYS")));
			    this.getMcr().setSndfin(String.valueOf(mainRecordMap.get("SNDFIN")));
			    this.getMcr().setRcvsys(String.valueOf(mainRecordMap.get("RCVSYS")));
			    this.getMcr().setAccdat(String.valueOf(mainRecordMap.get("ACCDAT")));
			    this.getMcr().setTalnum(String.valueOf(mainRecordMap.get("TALNUM")));

			    if(!MdaUtils.isEmpty(mainRecordMap.get("REDDIR")))
			    {
			      this.getMcr().setReddir(String.valueOf(mainRecordMap.get("REDDIR")));
			    }
			    if(!MdaUtils.isEmpty(mainRecordMap.get("RSTFIN")))        //空值特殊处理
			    {
			      this.getMcr().setRstfin(String.valueOf(mainRecordMap.get("RSTFIN")));
			    }
			    if(!MdaUtils.isEmpty(mainRecordMap.get("SUCNUM")))
			    {
			      this.getMcr().setSucnum(String.valueOf(mainRecordMap.get("SUCNUM")));
			    }
			    if(!MdaUtils.isEmpty(mainRecordMap.get("FAINUM")))
			    {
			      this.getMcr().setFainum(String.valueOf(mainRecordMap.get("FAINUM")));
			    }
			    if(!MdaUtils.isEmpty(mainRecordMap.get("RSDNUM")))
			    {
			      this.getMcr().setRsdnum(String.valueOf(mainRecordMap.get("RSDNUM")));
			    }

			    Platform.mdbInsert(this.getMcr());
			    errorcode = ctx.getErrorCode();
			    if(errorcode != NO_ERROR)
			    {
			      log.debug("{}","dbInsert mcr with errorcode:" + errorcode);
			      Platform.mdbRollback();
			      return genstatus;
			    }
			    //储对账详情表信息信息
			    log.info("{}","新增统计表信息完成，开始新增对账详情表信息"+infoRecordLst);
			    for(Map<String,String> record : infoRecordLst)
			    {
			      String icrinr = Platform.sdbCounter("icr");
			      Date processDate = new Date();
			      this.getIcr().setInr( icrinr );
			      this.getIcr().setMcrinr( this.getMcr().getInr());
			      this.getIcr().setLstdattim( processDate);
			      this.getIcr().setSeqnum( String.valueOf(record.get("SEQNUM")));
			      this.getIcr().setAccdat( String.valueOf(record.get("ACCDAT")));
			      this.getIcr().setReccur( String.valueOf(record.get("RECCUR")));
			      this.getIcr().setRecamt( String.valueOf(record.get("RECAMT")));
			      if(!MdaUtils.isEmpty(record.get("CHKINF")))
			      {
			        this.getIcr().setChkinf( String.valueOf(record.get("CHKINF")));
			      }
			      if(!MdaUtils.isEmpty(record.get("REFNUM")))
			      {
			        this.getIcr().setRefnum( String.valueOf(record.get("REFNUM")));
			      }
			      if(!MdaUtils.isEmpty(record.get("BILNUM")))
			      {
			        this.getIcr().setBilnum( String.valueOf(record.get("BILNUM")));
			      }
			      if(!MdaUtils.isEmpty(record.get("REDDIR")))
			      {
			        this.getIcr().setReddir( String.valueOf(record.get("REDDIR")));
			      }
			      if(!MdaUtils.isEmpty(record.get("CHKSTA")))
			      {
			        this.getIcr().setChksta( String.valueOf(record.get("CHKSTA")));
			      }
			      Platform.mdbInsert(this.getIcr());
			      errorcode = ctx.getErrorCode();
			      if(errorcode != NO_ERROR)
			      {
			        log.debug("{}","dbInsert icr with errorcode:" + errorcode);
			        Platform.mdbRollback();
			        return genstatus;
			      }
			    }
			  }
			  else
			  {
			    log.info("{}","********************"+mainRecordMap.get("SNDFIN")+"*********************************");
			    Platform.mdbRead(this.getMcr(),new Argument("sndfin",EQ,String.valueOf(mainRecordMap.get("SNDFIN"))));
			    log.info("{}","更新对账统计表信息");
			    if(!MdaUtils.isEmpty(this.getMcr().getInr()))
			    {
			      //由国际支付前置接收对账结果时会调用
			      this.getMcr().setRstfin(String.valueOf(mainRecordMap.get("RSTFIN")));//更新结果文件名
			      this.getMcr().setSucnum(String.valueOf(mainRecordMap.get("SUCNUM")));//更新成功记录数
			      this.getMcr().setFainum(String.valueOf(mainRecordMap.get("FAINUM")));//更新失败记录数
			      this.getMcr().setRsdnum(String.valueOf(mainRecordMap.get("RSDNUM")));//更新重发记录数
			      Platform.mdbUpdate(this.getMcr());
			      errorcode = ctx.getErrorCode();
			      if(errorcode != NO_ERROR)
			      {
			        log.debug("{}","dbupdate mcr with errorcode:" + errorcode);
			        Platform.mdbRollback();
			        return genstatus;
			      }
			    }
			    else
			    {
			      log.info("{}","无法获取待原对账统计表信息，更新失败");
			      return genstatus;
			    }
			    log.info("{}","更新统计表信息完成，开始更新对账详情表信息");
			    //更新对账详情表信息
			    for(Map<String,String> record  : infoRecordLst)
			    {
			      if(!MdaUtils.isEmpty(record.get("SEQNUM")))
			      {//优先使用流水号+收发方向+统计表主键进行匹配
			        log.info("{}","mcrinr:" +String.valueOf(this.getMcr().getInr())+"seqnum "+String.valueOf(record.get("SEQNUM"))+ "reddir"+String.valueOf(record.get("REDDIR")));
			        Platform.mdbRead(this.getIcr(),new Argument("mcrinr",String.valueOf(this.getMcr().getInr())).and("seqnum",String.valueOf(record.get("SEQNUM"))).and("reddir",String.valueOf(record.get("REDDIR"))));
			      }
			      else if(!MdaUtils.isEmpty(record.get("BILNUM")))
			      {//使用汇票号+收发方向+统计表主键进行匹配
			        log.info("{}","mcrinr:" +String.valueOf(this.getMcr().getInr())+"bilnum "+String.valueOf(record.get("BILNUM"))+ "reddir"+String.valueOf(record.get("REFDIR")));
			        Platform.mdbRead(this.getIcr(),new Argument("mcrinr",String.valueOf(this.getMcr().getInr())).and("bilnum",String.valueOf(record.get("BILNUM"))).and("reddir",String.valueOf(record.get("REDDIR"))));
			      }
			      else if(!MdaUtils.isEmpty(record.get("REFNUM")))
			      {//使用报文20项+收发方向+统计表主键进行匹配
			        log.info("{}","mcrinr:" +String.valueOf(this.getMcr().getInr())+"REFNUM "+String.valueOf(record.get("REFNUM"))+ "reddir"+String.valueOf(record.get("REFDIR")));
			        Platform.mdbRead(this.getIcr(),new Argument("mcrinr",String.valueOf(this.getMcr().getInr())).and("refnum",String.valueOf(record.get("REFNUM"))).and("reddir",String.valueOf(record.get("REDDIR"))));
			      }
			      if(!MdaUtils.isEmpty(this.getIcr().getInr()))
			      {
			        Date processDate = new Date();
			        this.getIcr().setChkinf( String.valueOf(record.get("CHKINF")));//max length 32
			        if(!MdaUtils.isEmpty(record.get("CHKSTA")))        //max length 2
			        {
			          this.getIcr().setChksta( String.valueOf(record.get("CHKSTA")));
			        }
			        this.getIcr().setLstdattim( processDate);
			        Platform.mdbUpdate(this.getIcr());
			        errorcode = ctx.getErrorCode();
			        if(errorcode != NO_ERROR)
			        {
			          log.debug("{}","dbupdate mcr with errorcode:" + errorcode);
			          Platform.mdbRollback();
			          return genstatus;
			        }
			      }
			      else
			      {
			        log.info("{}","无法获取待原对账详情表信息，更新失败");
			        return genstatus;
			      }
			    }
			    log.info("{}","新增/更新统计表信息完成，提交事务");
			  }
			  Platform.mdbCommit();
			  genstatus = true ;
			}
			catch(Exception e)
			{
			  log.debug("{}","数据插入异常");
			  Platform.mdbRollback();
			  return genstatus;
			}
			return genstatus;
		}
        /**
        *   source:smpmod.@0115.script
        */
        public /**
* <p>该方法目前用于新一代资金业务系统910报文过滤</p>
* <p>方法支持扩展至任何系统注册域字段过滤，方法针对传入参数regCol进行查询表中规则</p>
* <p>注：该方法只支持部分业务需求，如需特殊处理逻辑，则可能本方法不再适用</p>
* <p>根据系统注册规则返回过滤后的结果</p>
* @param sysCod  : 注册系统码
* @param msgTyp  : 报文类型
* @param fieMap  : 报文域字段和值
* @param msgDir  : 报文方向
* @param operator :匹配类型 分为批量匹配和单记录匹配。批量匹配类型分为：ADN/OR;单记录匹配类型为：null
* @return 报文域中值符合注册信息返回true , 否则返回false
*/
boolean  registerFieldIntercepter(String sysCod,String msgTyp,String msgDir , Map<String,String> fieMap ,String operator)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(sysCod))
			{
			  log.info("{}","注册系统不能为空！");
			  return false;
			}
			if(MdaUtils.isEmpty(msgDir))
			{
			  log.info("{}","系统注册报文收发方向不能为空！");
			  return false;
			}
			if(MdaUtils.isEmpty(fieMap))
			{
			  log.info("{}","待匹配注册字段字段为空，立即返回！");
			  return false;
			}
			/* if(Platform.isEmpty(operator))
			  {
			  //作为默认操作符，但默认情况可能造成判断结果不准确
			  log.info("当前 operator 为空,operator 分为两种情况，当 'operator ==  OR' 表示多条规则仅一条符合即可; 当 'operator ==  AND' 时，表示多条规则必须同时符合，默认情况下'OR'.");
			  return false;
			  }
			  */
			log.info("{}","注册系统："+sysCod+" 注册报文类型："+msgTyp+" 注册报文方向："+msgDir+" 待校验报文域对应值："+fieMap+" 待校验报文域关系："+operator);
			StringBuffer sql = new StringBuffer("select regcol,regval,ctrkey from smcreg where recsta = '1' and regsys = '").append(sysCod).append("' and").append(" msgdir='").append(msgDir).append("'");
			if(!MdaUtils.isEmpty(msgTyp))
			{
			  /**确定报文类型：MT910  ； 对所有报文类型有效：ALL**/
			  sql.append(" and msgtyp = '").append(msgTyp).append("'");
			}
			Argument<String> regcol = new Argument<String>("regcol");
			Argument<String> regval = new Argument<String>("regval");
			Argument<String> ctrkey = new Argument<String>("ctrkey");
			Map<String,Map<String,String> > regModel = new HashMap<String,Map<String,String> >();
			log.info("{}","sql : "+sql.toString());
			Platform.mdbExecuteSQLWithDb(sql.toString());
			boolean result = true;
			while(true)
			{
			  Platform.mdbFetchFields(regcol,regval,ctrkey);
			  Map<String,String> regRecord = new HashMap<String,String>();
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    /**将注册信息加入列表**/
			    if(!MdaUtils.isEmpty(regcol.value))
			    {
			      regRecord.put("ctrkey",String.valueOf(ctrkey.value));
			      regRecord.put("regval",String.valueOf(regval.value));
			      regModel.put(String.valueOf(regcol.value),regRecord);
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			/*开始匹配注册信息**/
			int     compCounter = 0 ;   			//比较计数器
			int     noMatchKeyCounter = 0 ;    //无注册信息对应key匹配计数器
			log.info("{}","regModel size：" +regModel.size()+" regModel content:"+regModel);
			for(Map.Entry<String,String> entry : fieMap.entrySet())
			{
			  log.info("{}","begin matching. match field is  "+entry.getKey()+" register model is containsKey result : "+ regModel.containsKey(entry.getKey()));
			  if(regModel.containsKey(entry.getKey()))
			  {
			    boolean compResult = false;   //记录比较结果
			    log.info("{}","begin matching operator.");
			    /**数据库中存在注册规则**/
			    Map<String,String> regRecord = regModel.get(entry.getKey()) ;
			    log.info("{}","begin matching ctrkey. current matching ctrkey is  "+regRecord.get("ctrkey"));
			    if("1".equals(regRecord.get("ctrkey")))
			    {//in
			      log.info("{}","报文"+entry.getKey().substring(1)+"域字段值中需出现与"+regRecord.get("regval")+"以“|”分隔开的任意一条规则相匹配的值");
			      String[] records = String.valueOf(regRecord.get("regval")).split("\\|");//获取注册的域字段信息，可能为多条，可能为一条，以“|”分隔
			      //匹配单条注册规则   注册规则 只能出现in 和  not in两种情况，分别使用 1==in和0==not in来进行处理。当符合该记录注册规则时应返回true,不符合时应返回false。等待后续处理
			      for(int i = 0 ;i < records.length ; i++)
			      {
			        log.info("{}","当前报文域字段值："+entry.getValue()+" 与注册报文域值 ："+records[i]+" 开始进行比对。待比对总数为  "+records.length+" 次，正在比较第 "+ (i+1) +" 次");
			        if((entry.getValue().replaceAll(" ","").replaceAll("\r\n","")).indexOf(records[i].replaceAll(" ","").replaceAll("\r\n","")) >= 0 )//防止因空格 回车造成比较结果不准确
			        {
			          //存在任意一条符合的注册规则，则跳出循环，进行下一个域字段判断
			          compResult = true ;
			          break ;
			        }
			      }
			      log.info("{}"," 报文域字段域注册域字段比较结果为："+compResult);
			    }
			    else
			    {//not in
			      log.info("{}","报文"+entry.getKey().substring(1)+"域字段值中不能出现与"+regRecord.get("regval")+"以“|”分隔开的任意一条规则相匹配的值");
			      String[] records = String.valueOf(regRecord.get("regval")).split("\\|");
			      for(int i = 0 ;i < records.length ; i++)
			      {
			        log.info("{}","当前报文域字段值："+entry.getValue()+" 与注册报文域值 ："+records[i]+" 开始进行比对。待比对总数为  "+records.length+" 次，正在比较第 "+ (i+1) +" 次");
			        if((entry.getValue().replaceAll(" ","").replaceAll("\r\n","")).indexOf(records[i].replaceAll(" ","").replaceAll("\r\n","")) < 0)//防止因空格 回车造成比较结果不准确
			        {
			          //存在任意一条符合的注册规则，则比较下一条，直至所有符合所有注册信息
			          compResult = true ;
			          continue;
			        }
			        else
			        {
			          compResult = false ;
			          break ;
			        }
			      }
			      log.info("{}"," 当前报文域字段与该字段注册规则比较结果为："+compResult);
			    }
			    //匹配操作符  用于判断匹配类型属于批量匹配还是单记录匹配，当operator==null时为单条匹配，当operator==and时为批量需同时成立匹配类型，当operator==or时为批量仅一条成立即可匹配类型
			    //单字段校验注册类型
			    if(compResult && null==operator )
			    {
			      result = true;
			      break ;
			    }
			    if(!compResult && null==operator )
			    {

			      result = false;
			      break ;
			    }
			    //多字段校验，并且需要同时成立  e.g:报文20域  21域应同时符合条件时应使用该操作符
			    if(!compResult && "AND".equals(operator))
			    {
			      result = false;
			      break ;
			    }
			    if(compResult && "AND".equals(operator))
			    {
			      compCounter++ ;			 //增加计数器
			      compResult = false ;//重置比较结果
			      continue ;
			    }
			    //多字段校验，任意一条符合条件即可  e.g:报文52域  72任意一条符合注册值即可
			    if(!compResult && "OR".equals(operator))
			    {
			      compCounter++ ;
			      continue ;
			    }
			    if(compResult && "OR".equals(operator))
			    {//特殊 : 50A 50k 50Z  出现任意一次情况
			      result = true;
			      break ;
			    }
			  }
			  else
			  {
			    /**当前情况可能出现在非动态 匹配时由于编码人员将过期或已删除的字段加入匹配参数中出现**/
			    log.info("{}","域字段"+entry.getKey()+"无注册规则信息信息或规则已被停用");
			    noMatchKeyCounter++ ;
			    compCounter++ ;
			  }
			}
			//校验传入记录是否有不存在注册字段情况  用于删除后或不知道该记录规则是否可用状态保证正确性
			//循环结束
			//特殊情况：当前注册类型中不包括待校验域字段，应使用noMatchKeyCounter作为判断标准。该情况应返回true
			if(noMatchKeyCounter == fieMap.size())
			{
			  return true ;
			}
			if(compCounter == fieMap.size() && operator == "AND")
			{//在AND操作符下全部满足条件
			  return true ;
			}
			if(compCounter == fieMap.size() && operator == "OR")
			{//在or操作符下全部不满足条件
			  return false ;
			}
			return result ;
		}
        /**
        *   source:smpmod.@0116.script
        */
        public boolean updateStateForInterface(String channelCode,String state,String detail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 此方法用于更新MPS状态
			  */
			if("ZHQ".equals(channelCode) && "D".equals(state) )
			{
			  //新增向海南自贸区报送数据接口
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sendMessageToHaiNanFTA(this.getMpi(),this.getMps());
			}
			int errorCode = ctx.getErrorCode();
			Platform.mdbBegin();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			Date date = new Date();
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channelCode);
			this.getMpe().setSmhinr( this.getMps().getSmhinr());
			this.getMpe().setDattim( date);
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta( state);
			this.getMpe().setTxt( detail);
			Platform.sdbInsert(this.getMpe());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			this.getMps().setLstdattim( date);
			this.getMps().setSta( state);
			Platform.mdbUpdate(this.getMps());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			Platform.mdbCommit();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			return true;
		}
        /**
        *   source:smpmod.@0117.script
        */
        public boolean createMessageProcessSubjectForSweMan(IStream is,String channel,String messageType,String targetChannel,String processDetail,String sweType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			//Platform.clear($mps);
			MdaUtils.clear(this.getMpe());
			//Platform.clear($smh);
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			//Platform.mdbCommit();
			//Platform.mdbBegin();
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			/*
			  Platform.esdbRead($chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			readChn(this.getChn(),channel);
			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}
			/*
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }
			  Platform.mdbBegin();*/
			int errorcode = ctx.getErrorCode();
			/// 获取报文记录inr
			String smhinr = null;
			log.debug("{}","msgedt smpmod smhinr:"+this.getSmh().getInr());
			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  smhinr = this.getSmh().getInr();
			  this.setEdtflg( "ame");
			}
			else
			{
			  MdaUtils.clear(this.getMps());
			  MdaUtils.clear(this.getSmh());
			  smhinr = Platform.sdbCounter("smh");
			  this.setEdtflg( "new");
			}
			log.debug("{}","smpmod edtflg:"+this.getEdtflg());
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "V"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			this.getMps().setSwetyp( sweType);
			if("new".equals(this.getEdtflg()))
			{
			  log.debug("{}","smpmod insert mps...");
			  Platform.sdbInsert(this.getMps());
			}
			else if("ame".equals(this.getEdtflg()))
			{
			  log.debug("{}","smpmod update mps:"+this.getMps().getInr());
			  Platform.mdbUpdate(this.getMps());
			}
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert&dbUpdate mps with errorcode:" + errorcode);
			  //Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			if("ame".equals(this.getEdtflg()))
			  this.getMpe().setPrvsta( "C");
			else if("new".equals(this.getEdtflg()))
			  this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "V"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			if("new".equals(this.getEdtflg()))
			{
			  this.getSmh().setInr( smhinr);
			}
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;
			if("cips|xml".contains(messageType))
			{
			  fileName = getCipsStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getCipsdatapath());
			}
			else
			  fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getSmh());
			else if("new".equals(this.getEdtflg()))
			  Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			//Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0118.script
        */
        public boolean gispCreateMessageInformation(String fileName, String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","gispCreateMessageInformation:" + fileName);
			MdaUtils.clear(this.getSed());
			Platform.mdbRead(this.getSed(),new Argument("mpsinr", this.getMps().getInr()),new Argument("msgtyp","930"));
			int error = ctx.getErrorCode();

			IStream is = this.getSwestm();
			Platform.mstreamLoad(is,fileName);
			String msg = Platform.convertIStream2String(is);

			///将文件内容保存至gispx后缀名文件中
			String gispRecvPath = fileName.replace(".sf2",".gispx");
			Platform.mstreamSave(is,gispRecvPath);

			///解析报文
			///Map<String,Object> map = new HashMap();
			///map.put("MesgType", "gisp.930.001.01");
			///map.put("Mesg", msg);
			log.debug("{}","调用接口平台解析GISP报文");
			Object[] arg = new Object[1];
			arg[0] = msg;
			Object object = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","gipssmsgfromgips","gipssmsgfromgips",arg);
			if(object == null)
			{
			  return false;
			}
			Boolean result = (Boolean)MdaUtils.invoke(object,"isSuccess");
			if(!result)
			{
			  return false;
			}
			Object[] contents = (Object[])MdaUtils.invoke(object,"getContent");
			String gispMessage = (String)contents[1];
			log.debug("{}","SWE明文报文:"+gispMessage);
			String sf2Message = (String)contents[2];
			log.debug("{}","SWE转sf2报文:"+sf2Message);

			String gispSavePath = fileName.replace(".sf2",".gisp");
			MdaUtils.streamClear(is);
			Platform.convertString2IStream(gispMessage,is);
			Platform.mstreamSave(is,gispSavePath);

			String orgiSendDate = null;
			String orgiSendTime = null;
			if(!MdaUtils.isEmpty(this.getSed().getSwedattim()))
			{
			  orgiSendDate = MdaUtils.format(this.getSed().getSwedattim(),"yyMMdd");
			  orgiSendTime = MdaUtils.format(this.getSed().getSwedattim(),"HHmm");
			}
			else
			{
			  orgiSendDate = MdaUtils.format(this.getMps().getRcvdattim(),"yyMMdd");
			  orgiSendTime = MdaUtils.format(this.getMps().getRcvdattim(),"HHmm");
			}
			sf2Message = this.getSwemod().handleGispReceiveSf2Message(sf2Message,orgiSendDate,orgiSendTime);
			MdaUtils.streamClear(is);
			Platform.convertString2IStream(sf2Message,is);
			Platform.mstreamSave(is,fileName);

			/// 记录MPE处理信息
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setTxt( "G渠道GISP转sf2");
			if("N".equals(this.getMps().getRspsta()))
			{
			  this.getMps().setSta( "E");
			  this.getMpe().setTxt( "G渠道GISP转sf2,NCK报文,终止处理");
			}
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());

			return true;
		}
        /**
        *   source:smpmod.@0119.script
        */
        public boolean fetchAndLockGispAckMessage(String db, String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			Platform.setDefaultDB(db);
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("srcchncod",NE,"GJS"),new Argument("nxtchncod",channel).and("sweack",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));

			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;

			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  log.info("{}","锁定mps记录为，inr="+mps.getInr());
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			  {
			    log.debug("{}","锁定mps记录失败，inr="+mps.getInr());
			    continue;
			  }
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);

			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSweack())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  /// 读取对应MPI记录，如果出错则处理下一条
			  Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  if(ctx.getErrorCode()!=NO_ERROR)
			    continue;

			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  if(ctx.getErrorCode()!=NO_ERROR)
			    continue;
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0120.script
        */
        public String[] getAvailableCipsqz()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String[] rtn = new String[2];
			String[] ips = null;
			String[] ip1 = null;
			String[] ip2 = null;
			String sql = "SELECT ip FROM fipsta WHERE chncod='CIPS' and status='true' ";
			Argument<String> ip = new Argument<String>("ip");
			ctx.getErrorCode();
			Platform.esdbExecuteSQL(sql);
			Platform.esdbFetchFields(ip);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  String str1 = ip.value;
			  ips= str1.split(";");
			  ip1= ips[0].split(":");
			  ip2= ips[1].split(":");
			}
			Platform.esdbCloseCursor();
			rtn[0]=(String)MdaUtils.invoke("cn.com.brilliance.psbc.cache.checkSocketAvailable","checkSocketAvail",ip1[0],ip2[0],ip1[1]);
			rtn[1] = ip1[1];
			return rtn;
		}
        /**
        *   source:smpmod.@0121.script
        */
        public boolean createMessageProcessSubjectForSweMan19Ns(IStream is,String channel,String messageType,String targetChannel,String processDetail,String sweType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			Platform.esdbRead(this.getChn(),new Argument("cod",channel));
			/// 未知渠道或当前渠道状态非接收状态
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  Platform.esdbRead(this.getTgtchn(),new Argument("cod",targetChannel));
			  /// 未知目标渠道则将其设置为空
			  if(ctx.getErrorCode()!=NO_ERROR)
			    targetChannel = null;
			}
			int errorcode = ctx.getErrorCode();
			/// 获取报文记录inr
			String smhinr = null;
			log.debug("{}","msgedt smpmod smhinr:"+this.getSmh().getInr());
			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  smhinr = this.getSmh().getInr();
			  this.setEdtflg( "ame");
			}
			else
			{
			  MdaUtils.clear(this.getMps());
			  MdaUtils.clear(this.getSmh());
			  smhinr = Platform.sdbCounter("smh");
			  this.setEdtflg( "new");
			}
			log.debug("{}","smpmod edtflg:"+this.getEdtflg());
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "O"); // 中间状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			this.getMps().setSwetyp( sweType);
			if("new".equals(this.getEdtflg()))
			{
			  log.debug("{}","smpmod insert mps...");
			  Platform.sdbInsert(this.getMps());
			}
			else if("ame".equals(this.getEdtflg()))
			{
			  log.debug("{}","smpmod update mps:"+this.getMps().getInr());
			  Platform.mdbUpdate(this.getMps());
			}
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert&dbUpdate mps with errorcode:" + errorcode);
			  //Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			if("ame".equals(this.getEdtflg()))
			  this.getMpe().setPrvsta( "C");
			else if("new".equals(this.getEdtflg()))
			  this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "V"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			if("new".equals(this.getEdtflg()))
			{
			  this.getSmh().setInr( smhinr);
			}
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;
			if("cips|xml".contains(messageType))
			{
			  fileName = getCipsStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getCipsdatapath());
			}
			else
			  fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getSmh());
			else if("new".equals(this.getEdtflg()))
			  Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			//Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0122.script
        */
        public boolean createMessageProcessSubjectSweRef(IStream is,String channel,String messageType,String targetChannel,String processDetail, Map<String,Object> sedMap)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			/*
			  Platform.esdbRead($chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			readChn(this.getChn(),channel);
			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}
			/*
			  Platform.mdbBegin();
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }*/
			int errorcode = ctx.getErrorCode();
			log.debug("{}","before mdbBegin");
			Platform.mdbBegin();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "A"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			this.getMps().setSweack( "W");
			Platform.sdbInsert(this.getMps());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}

			String subType = (String)sedMap.get("Tp");
			if(!MdaUtils.isEmpty(subType))
			{
			  subType = subType.replace("MT","");
			}
			MdaUtils.clear(this.getSed());
			this.getSed().setMpsinr( this.getMps().getInr());
			this.getSed().setSmhinr( this.getMps().getSmhinr());
			this.getSed().setDir( ">");
			this.getSed().setMsgdir( ">");
			this.getSed().setMsgtyp( "930");
			this.getSed().setSubmsgtyp( "MT");
			this.getSed().setSubtyp( subType);
			this.getSed().setSndbic( (String)sedMap.get("InstgPty"));
			this.getSed().setRcvbic( (String)sedMap.get("InstdPty"));
			this.getSed().setSndnum( (String)sedMap.get("MesgId"));
			this.getSed().setRefnum( (String)sedMap.get("MesgRefId"));
			this.getSed().setMsgref( (String)sedMap.get("MsgId"));
			this.getSed().setRcvdattim( processDate);
			this.getSed().setSttdattim( processDate);
			this.getSed().setSndsta( "A");
			this.getSed().setAcksta( "W");
			this.getSed().setSta( "W");
			this.getSed().setSwedattim( MdaUtils.parseDate((String)sedMap.get("OrgiSendDate") + (String)sedMap.get("OrgiSendTime"),"yyyyMMddHHmmss"));
			this.getSed().setLstdattim( processDate);
			this.getSed().setSnddattim( processDate);
			Platform.sdbInsert(this.getSed());

			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "A"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;
			if("cips|xml".contains(messageType))
			{
			  fileName = getCipsStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getCipsdatapath());
			}
			else if("jsh|b2e".contains(messageType))
			{
			  fileName = getB2eStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getB2edatapath());
			}
			else if("nxl".contains(messageType))
			{
			  fileName = getZywStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getZywdatapath());
			}
			else if("elcs|exl".contains(messageType))
			{
			  fileName = getElcsStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getElcsdatapath());
			}
			else
			  fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0123.script
        */
        public boolean fetchAndLockMessageSweAck(String srcchannel,String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("srcchncod",srcchannel).and("tgtchncod","SWE").and("sweack",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSweack())||!srcchannel.equals(this.getMps().getSrcchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }

			  //20180608新建，监控需要获取mpi相关记录信息
			  MdaUtils.clear(this.getMpi());
			  if(!MdaUtils.isEmpty(this.getMps().getPntinr()))
			  {
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getPntinr()));
			  }
			  else
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  if(!MdaUtils.isEmpty(this.getMpi().getInr()))
			    log.info("{}","mpiinr:"+this.getMpi().getInr());

			  MdaUtils.clear(this.getSed());
			  Platform.mdbRead(this.getSed(),new Argument("mpsinr",this.getMps().getInr()).and("msgtyp","930"));
			  if(!MdaUtils.isEmpty(this.getSed().getInr()))
			    log.info("{}","sedinr:"+this.getSed().getInr());

			  if(ctx.getErrorCode()!=NO_ERROR)
			    continue;
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0124.script
        */
        public boolean updateAckStateForSweInterface(String channelCode,String state,String detail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 此方法用于更新MPS状态
			  */
			int errorCode = ctx.getErrorCode();
			Platform.mdbBegin();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			Date date = new Date();
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channelCode);
			this.getMpe().setSmhinr( this.getMps().getSmhinr());
			this.getMpe().setDattim( date);
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta( this.getMps().getSta());
			this.getMpe().setTxt( detail);
			Platform.sdbInsert(this.getMpe());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			this.getMps().setLstdattim( date);
			this.getMps().setSweack( state);
			Platform.mdbUpdate(this.getMps());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			Platform.mdbCommit();
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			return true;
		}
        /**
        *   source:smpmod.@0125.script
        */
        public boolean updatekAckWithUnlock(String state, String acksta, String message)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 更新以记录状态并解锁
			  - channal:String 当前渠道名
			  - nextChannal:String 下一渠道名
			  - targetChannal:String 目标渠道名
			  - state:String 报文状态
			  - message:String 处理信息
			  - flag:boolean 返回值（为flag时当前处理失败需要这里就提交事务）
			  @ boolean 返回处理是否成功
			  */
			//Platform.mdbCommit();
			int errorCode = ctx.getErrorCode();
			//Platform.mdbBegin();
			/// 清空记录准备处理(注：在已知道下一渠道，后续先后处理目标渠道时不再保存MPE的nextChannel，仅更新MPE的txt信息)
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( null);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			if(!MdaUtils.isEmpty(state))
			  this.getMpe().setSta( state);
			this.getMpe().setTxt( message);
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			Platform.sdbInsert(this.getMpe());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;

			this.getSed().setLstdattim( this.getMpe().getDattim());
			this.getSed().setAcksta( "D");
			Platform.mdbUpdate(this.getSed());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;

			this.getMps().setLstdattim( this.getMpe().getDattim());
			this.getMps().setSta( state); /// 这里注意可能需要做格式转换
			this.getMps().setNxtsta( state);
			this.getMps().setSweack( acksta);
			Platform.mdbUpdate(this.getMps());
			if(ctx.getErrorCode()!=NO_ERROR)
			  return false;
			/// 对MPS记录进行解锁
			Platform.sdbUnLock(this.getMps());
			return true;
		}
        /**
        *   source:smpmod.@0126.script
        */
        public String getCurrentDate()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getCpstim());
			int errorcode = ctx.getErrorCode();
			Platform.esdbRead(this.getCpstim(),new Argument<String>("inr",DESC));
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return MdaUtils.format(this.getCpstim().getSysdt(),"yyyyMMdd");
			else
			  return MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
		}
        /**
        *   source:smpmod.@0127.script
        */
        public boolean createMessageProcessSubjectForCips(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			/*
			  Platform.esdbRead($chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			readChn(this.getChn(),channel);
			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}
			/*
			  Platform.mdbBegin();
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }*/
			int errorcode = ctx.getErrorCode();
			Platform.mdbBegin();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "V"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			if("SWT".equals(targetChannel))
			{
			  this.getMps().setSwetyp( "A");
			}
			Platform.sdbInsert(this.getMps());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "V"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = getCipsStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0129.script
        */
        public String[] getAvailableGispQz()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return this.getSwemod().getAvailableGispQz();
		}
        /**
        *   source:smpmod.@0130.script
        */
        public String getGispMessageContent(String type, String sedInr, String smhInr,  boolean isEncMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String fileType = "gisp";
			if(!"930".equals(type))
			{
			  fileType += type;
			}
			if(isEncMsg)
			{
			  fileType += "x";
			}
			String gispMsgPath = null;
			if(!MdaUtils.isEmpty(smhInr))
			{
			  gispMsgPath = getStoreFileFullPathName(smhInr,fileType);
			  log.debug("{}","getGispMessageContent SMHINR:" + smhInr + ",PATH:" + gispMsgPath);
			}
			else
			{
			  gispMsgPath = this.getSwemod().getStoreFileFullPathName(this.getSwemod().getDocpth(),sedInr,fileType);
			  log.debug("{}","getGispMessageContent SEDINR:" + sedInr + ",PATH:" + gispMsgPath);
			}

			if(!MdaUtils.fileExists(gispMsgPath))
			{
			  //调用接口平台或JAVA方法获取文件服务器上;对应目录的文件
			  log.debug("{}","getMessageFromFileServer:" + gispMsgPath);
			  if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getMessageFromFileTransfer(gispMsgPath)))
			  {
			    log.error("{}","报文文件不存在:" + gispMsgPath);
			    return "";
			  }
			}

			IStream is = this.getSwestm();
			MdaUtils.streamClear(is);
			Platform.mstreamLoad(is,gispMsgPath);
			return Platform.convertIStream2String(is);
		}
        /**
        *   source:smpmod.@0131.script
        */
        public boolean fetchAndLockMessageWithTgtChnCod(String db,String channel, String tgtchncod, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			Platform.setDefaultDB(db);
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("tgtchncod",tgtchncod).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));

			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;

			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  log.info("{}","锁定mps记录为，inr="+mps.getInr());
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			  {
			    log.debug("{}","锁定mps记录失败，inr="+mps.getInr());
			    continue;
			  }
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);

			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  if(ctx.getErrorCode()!=NO_ERROR)
			    continue;
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0132.script
        */
        public boolean fetchAndLockDelayMessage(String channel, String state, String delaySrcChn, long delaySecond)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取并加锁待处理报文信息
			  - channal:String 报文源渠道名
			  - state:String 查询状态
			  @ boolean 返回处理是否有可处理记录
			  */
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			///  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  Date now = MdaUtils.today();
			  boolean isSameSrcChn = true;
			  if(!MdaUtils.isEmpty(delaySrcChn))
			  {
			    isSameSrcChn = delaySrcChn.equals(mps.getSrcchncod());
			  }
			  if(isSameSrcChn)
			  {
			    Date rcvdattim = mps.getRcvdattim();
			    if((now.getTime() - rcvdattim.getTime()) < (delaySecond * 1000))
			    {
			      log.debug("{}","mps记录将延迟" + delaySecond + "秒处理，inr="+mps.getInr());
			      continue;
			    }
			  }

			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			  {
			    log.debug("{}","锁定mps记录失败，inr="+mps.getInr());
			    continue;
			  }
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  //20180608新建，监控需要获取mpi相关记录信息
			  MdaUtils.clear(this.getMpi());
			  if(!MdaUtils.isEmpty(this.getMps().getPntinr()))
			  {
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getPntinr()));
			  }
			  else
			    Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  if(!MdaUtils.isEmpty(this.getMpi().getInr()))
			    log.info("{}","mpiinr:"+this.getMpi().getInr());
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  if(ctx.getErrorCode()!=NO_ERROR)
			    continue;
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0133.script
        */
        public String getCurCIPSSysSta()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//获取当前CIPS系统状态
			MdaUtils.clear(this.getCpstim());
			int errorcode = ctx.getErrorCode();
			Platform.esdbRead(this.getCpstim(),new Argument<String>("inr",DESC));
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return this.getCpstim().getSyssta().toString();
			else
			  return "";
		}
        /**
        *   source:smpmod.@0141.script
        */
        public boolean do_actwhitelist(String account)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检测账号是否存在在账号白名单中
			ctx.getErrorCode();
			log.debug("{}","do_actwhitelist, account = " + account);
			Platform.esdbRead(this.getXhxdta(),new Argument("act", account));
			int errorcode = ctx.getErrorCode();
			if(!MdaUtils.isEmpty(this.getXhxdta().getInr()))
			{
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0142.script
        */
        public Map<String,Object> getPublicHeader(String[] data,String globalBusiTrackNo,String subtxNo,String accdate)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//国际支付外呼新核心公共请求报文头组装
			//data[0]:账号
			Map<String,Object> map = new HashMap<String,Object>();
			Map<String,Object> bodyMap = new HashMap<String,Object>();
			Map<String,Object> headMap = new HashMap<String,Object>();
			Map<String,Object> txComni = new HashMap<String,Object>();
			Map<String,Object> txComn2 = new HashMap<String,Object>();
			Map<String,Object> txComn4 = new HashMap<String,Object>();
			Map<String,Object> txComn8 = new HashMap<String,Object>();
			Map<String,Object> txEntity = new HashMap<String,Object>();
			txComni.put("accountingDate",accdate);
			txComn2.put("oprTellerNo","99311005293");
			txComn4.put("batchOnlineTxMode","0");
			//业务发送系统或组件编码
			txComn8.put("busiSendSysOrCmptNo","99306000000");
			bodyMap.put("txComni",txComni);
			bodyMap.put("txComn2",txComn2);
			bodyMap.put("txComn4",txComn4);
			bodyMap.put("txComn8",txComn8);
			bodyMap.put("txEntity",txEntity);
			//发起系统或组件编码
			headMap.put("startSysOrCmptNo","99306000000");
			//发送系统或组件编码
			headMap.put("sendSysOrCmptNo","99306000000");
			//发起渠道标识码
			headMap.put("startChnlFgCd","42");
			//业务发起机构号
			if(data[1] == null || "".equals(data[1]))
			  headMap.put("busiSendInstNo","11005293");
			else
			  headMap.put("busiSendInstNo",data[1]);
			//数据中心代码
			headMap.put("dataCenterCode",Platform.getDataCenterCode());
			//交易发起时间
			headMap.put("txStartTime",MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmssSSS"));
			//交易发送时间
			headMap.put("txSendTime",MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmssSSS"));
			//报文总长度
			headMap.put("msgrptTotalLen","0");
			//报文格式版本号
			headMap.put("msgrptFmtVerNo","1.0.0");
			//报文协议类型
			headMap.put("msgAgrType","1");
			//公共报文头长度
			headMap.put("pubMsgHeadLen","0");
			//嵌入报文长度
			headMap.put("embedMsgrptLen","0");
			//目标系统或组件编码
			headMap.put("targetSysOrCmptNo","1043199");
			//服务类型代码
			//@20220209 sulike 接收注销重发，服务类型代码-8
			if("dyctsk".equals(ctx.getTransName()))
			  headMap.put("servTpCd","8");
			else
			  headMap.put("servTpCd","1");
			//服务编码
			headMap.put("servNo","");
			//服务版本号
			headMap.put("servVerNo","1.0.0");
			//报文鉴别码
			headMap.put("msgrptMac","");
			//全局业务跟踪号
			headMap.put("globalBusiTrackNo",globalBusiTrackNo);
			//子交易序号
			headMap.put("subtxNo",subtxNo);
			//主映射要素信息  20210906 管理类报文不送该字段
			if(data.length == 2)
			{
			  headMap.put("mainMapElemntInfo","05"+data[0].trim());
			}
			else
			{
			  if("628460".equals(data[2])||"628480".equals(data[2])||"628470".equals(data[2]))
			  {
			    headMap.put("mainMapElemntInfo","07"+data[0]);
			  }
			  else if("628590".equals(data[2]))
			  {
			    headMap.put("mainMapElemntInfo","05"+data[0]);
			  }
			  else if("628650".equals(data[2])||"628640".equals(data[2]))
			  {
			    headMap.put("mainMapElemntInfo","04"+data[0]);
			  }
			  else
			  {
			    //628490、628500、628530、628540不用添加此字段
			  }
			}

			//请求系统流水号
			headMap.put("reqSysSriNo","00000000000000000000000000000000");
			//预留输入信息
			headMap.put("resvedInputInfo","0");

			map.put("txHeader",headMap);
			map.put("txBody",bodyMap);

			log.info("{}","新核心请求公共报文头"+map);
			return map;
		}
        /**
        *   source:smpmod.@0134.script
        */
        public boolean fetchAndLockMessageFft(String srcchannel,String channel, String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","获取待发送福费廷报文...");
			ctx.getErrorCode();  // FIXME 临时清空错误信息
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getNxtsmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getNxtchn());
			MdaUtils.clear(this.getTgtchn());
			MdaUtils.clear(this.getMpslst());
			/// 获取可处理记录
			Platform.mdbReadset(this.getMpslst(),new Argument("nxtchncod",channel).and("srcchncod",srcchannel).and("sta",state).and("sttdattim",LE,new Date()),new Argument("sttdattim",ASC));
			//  如果读取错误或记录为空，直接返回
			if(ctx.getErrorCode()!=NO_ERROR || this.getMpslst().isEmpty())
			  return false;
			for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			{
			  /// 锁住记录准备进行处理（已经被锁则处理下一条）
			  if(!Platform.sdbLock(mps))
			    continue;
			  /// 复制记录信息待处理
			  this.getMps().copyValue(mps);
			  /// 检查记录状态发生变化，解锁并处理下一条
			  if(!state.equals(this.getMps().getSta())||!channel.equals(this.getMps().getNxtchncod()))
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  //20180608新建，监控需要获取mpi相关记录信息
			  /*Platform.clear($mpi);
			    if(!Platform.isEmpty($mps\\pntinr))
			    {
			    Platform.mdbRead($mpi,new Argument("inr",$mps\\pntinr.getValue()));
			    }
			    else
			    Platform.mdbRead($mpi,new Argument("inr",$mps\\inr.getValue()));
			    if(!Platform.isEmpty($mpi\\inr))
			    log.info("mpiinr:"+$mpi\\inr.getValue());*/
			  Platform.mdbRead(this.getMpi(),new Argument("inr",this.getMps().getInr()));
			  log.info("{}","ftotsk mpi ="+this.getMpi().getInr());
			  ctx.getErrorCode();
			  /// 读取对应SMH记录，如果出错则处理下一条
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  //存储原xml报文smhinr
			  this.setSmhinr( this.getSmh().getInr());
			  log.debug("{}","FFT oldsmhinr:"+this.getSmh().getInr());
			  int errorcode = ctx.getErrorCode();
			  log.debug("{}","errorcode= "+errorcode);
			  if(errorcode!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  String fileName = getElcsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  if(Platform.mfileExists(fileName))
			  {
			    this.getJsonContectXml2(fileName);
			  }
			  else
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }
			  Platform.mdbRead(this.getSmh(),new Argument("inr",this.getMps().getSmhinr()));
			  log.debug("{}","FFT newsmhinr:"+this.getMps().getSmhinr());
			  int errorcode1 = ctx.getErrorCode();
			  log.debug("{}","errorcode="+errorcode1);
			  if(errorcode1!=NO_ERROR)
			  {
			    Platform.sdbUnLock(mps);
			    continue;
			  }

			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0135.script
        */
        public boolean vertifyElcs(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Boolean obt = (Boolean)MdaUtils.invoke(obj,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  MdaUtils.invoke(obj,"setStrict",false);
			  String errMsg = MdaUtils.invoke(obj,"getErrMsg").toString();
			  String err = errMsg.substring(8,14);
			  if(err.indexOf("数字签名")>=0)
			  {
			    String str = (String)MdaUtils.invoke(obj,"getHead");
			    str = str.substring(5,19).trim();
			    log.debug("{}","str------"+str);
			    String elcsbkcd = "ELCS" + str;
			    Argument<String> certdn = new Argument<String>("certdn");
			    String sql="select certdn from cetcsn where bnkcod = ? and (syscd = ? or syscd = ?) and flg = 'Y'" ;
			    Platform.mdbExecuteSQL(sql,str,"ELCS","LCFS");
			    Platform.mdbFetchFields(certdn);
			    Platform.mdbCloseCursor();
			    log.debug("{}","certdn:" + certdn.value);
			    String orgstr = MdaUtils.invoke(obj,"getRawSignatureInfo").toString();
			    String signstr = MdaUtils.invoke(obj,"getSignatureInfo").toString();
			    String bnkcod = str;

			    log.debug("{}","orgstr:"+orgstr);
			    log.debug("{}","signstr:"+signstr);
			    if(certdn.value==null)
			    {
			      log.debug("{}","没有对应的ELCS证书信息-----");
			      this.getMps().setFlg( "1");
			      log.debug("{}","开始二代证书验签-----");
			      //二代证书验签
			      obt = (Boolean)MdaUtils.invoke("com.brilliance.dzxt.framework.signature.eLCSignature","verify",orgstr,signstr,bnkcod);
			      if(!obt.booleanValue())
			      {
			        log.debug("{}","二代验签失败");
			        this.getMps().setFlg( "1");
			      }
			      else
			      {
			        log.info("{}","二代验签成功");
			        this.getMps().setFlg( "0");
			      }
			    }
			    else
			    {
			      //电证独立证书验签
			      obt = (Boolean)MdaUtils.invoke("com.brilliance.dzxt.framework.signature.eLCSignature","verify",orgstr,signstr,elcsbkcd);
			      log.debug("{}","obt-------"+obt);
			      if(!obt.booleanValue())
			      {
			        log.debug("{}","独立证书签失败");
			        this.getMps().setFlg( "1");

			      }
			      else
			      {
			        log.info("{}","独立证书验签成功");
			        this.getMps().setFlg( "0");
			      }

			      if("1".equals(this.getMps().getFlg()))
			      {
			        //二代证书验签
			        obt = (Boolean)MdaUtils.invoke("com.brilliance.dzxt.framework.signature.eLCSignature","verify",orgstr,signstr,bnkcod);
			        if(!obt.booleanValue())
			        {
			          log.debug("{}","二代验签失败");
			          this.getMps().setFlg( "1");
			        }
			        else
			        {
			          log.info("{}","二代验签成功");
			          this.getMps().setFlg( "0");
			        }
			      }

			    }
			  }
			  else
			  {
			    log.error("{}","解报失败");
			    return false;
			  }
			}
			else
			{
			  log.info("{}","验签成功");
			}
			log.info("{}","解报成功");
			log.info("{}","mps flg :" + this.getMps().getFlg() );
			return true;
		}
        /**
        *   source:smpmod.@0136.script
        */
        public Map<String,Object> getAntfrdBlaGreyLstMarkCdforGH(Map<String,Object> map,Map<String,Object> entityMap,IModule mdl)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//反欺诈黑灰名单标记获取
			Map<String,Object> resultMap = new HashMap<String,Object>();
			Map<String,Object> bodyMap = new HashMap<String,Object>();
			Map<String,Object> jsonMap = new HashMap<String,Object>();
			Map<String,Object> headerMap = (Map<String, Object>) map.get("txHeader");
			String pcode = (String)map.get("PCODE");
			//从客户信息平台获取收汇人证件信息
			Map<String,Object> ecifReqMap = this.getActreqpho().getReturnMessage(entityMap.get("rcverAccno").toString());
			Map<String,Object> ecifReturnMap = new HashMap<String,Object>();
			if(MdaUtils.isEmpty(ecifReqMap))
			{
			  log.debug("{}","收汇人账号为空，缺少向客户信息平台查询的必要条件.");
			  resultMap.put("fqzflg", true);
			  resultMap.put("repinf", "收汇人账号为空，缺少向客户信息平台查询的必要条件.");
			  return resultMap;
			}
			else
			{
			  ecifReturnMap = (Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.psbc.util.TexudoEcifUtil","SendMessage",ecifReqMap);
			  if(!MdaUtils.isEmpty(ecifReturnMap))
			  {
			    log.debug("{}","接收境外汇票信息/接收改汇调用客户信息平台成功.");
			    if("FAIL".equals(ecifReturnMap.get("status").toString()))
			    {
			      log.debug("{}","未查询到收款人对应的证件信息！");
			      resultMap.put("fqzflg", true);
			      resultMap.put("repinf", "未查询到收款人对应的证件信息！");
			    }
			    else
			    {
			      bodyMap.put("PCODE","300201");
			      bodyMap.put("MessageType","fqzquery");
			      //以下要素由map转json放入FILLER1域
			      //个人证件类型代码
			      jsonMap.put("perCertTpCd","");
			      //个人证件号码
			      jsonMap.put("personalCertNo","");
			      //姓名
			      IDatafield name = MdaDriver.getDatafield(mdl,"paynam");
			      if(!Platform.datafieldIsEmpty(name))
			      {
			        jsonMap.put("name",name.getValue().toString());
			      }
			      else
			      {
			        jsonMap.put("name","");
			      }
			      //客户账号
			      IDatafield custAccNo = MdaDriver.getDatafield(mdl,"payact");
			      if(!Platform.datafieldIsEmpty(custAccNo))
			      {
			        jsonMap.put("custAccNo",custAccNo.getValue().toString());
			      }
			      else
			      {
			        jsonMap.put("custAccNo","");
			      }
			      //发汇人国籍代码
			      jsonMap.put("remiterNatonCd","");
			      //发汇国家地区代码
			      IDatafield disrCounCd = MdaDriver.getDatafield(mdl,"paycty");
			      if(!Platform.datafieldIsEmpty(disrCounCd))
			      {
			        jsonMap.put("disrCounCd",disrCounCd.getValue().toString().trim().substring(0,2));
			      }
			      else
			      {
			        jsonMap.put("disrCounCd","");
			      }
			      //发汇人性别代码
			      jsonMap.put("remiterSexCd","");
			      //手机号
			      IDatafield mobileNo = MdaDriver.getDatafield(mdl,"paypho");
			      if(!Platform.datafieldIsEmpty(mobileNo))
			      {
			        jsonMap.put("mobileNo",mobileNo.getValue().toString());
			      }
			      else
			      {
			        jsonMap.put("mobileNo","");
			      }
			      //收汇人证件类型代码     需要2位转4位
			      String propertyPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			      propertyPath = MdaUtils.catPath(propertyPath,"identity.properties");
			      String propertyValue = Platform.getPropertys(propertyPath,ecifReturnMap.get("CERTIFICATE_KIND").toString());
			      jsonMap.put("rcverCertTpCd",propertyValue);
			      //收汇人证件号码
			      jsonMap.put("rcverCertNo",ecifReturnMap.get("CERTIFICATE_NO"));
			      //收汇人姓名
			      jsonMap.put("rcverNm",ecifReturnMap.get("CUSTOMERNAME"));
			      //收汇人账号
			      jsonMap.put("rcverAccno",entityMap.get("rcverAccno"));
			      //收汇人国籍代码
			      jsonMap.put("rcverNatonCd",ecifReturnMap.get("NATIONALITY"));
			      //收汇国家代码
			      jsonMap.put("excCounCd","");
			      //收汇人性别代码
			      jsonMap.put("rcverSexCode",ecifReturnMap.get("SEX"));
			      //收汇人电话
			      jsonMap.put("rcverTel",ecifReturnMap.get("MOBILENUM"));
			      //代理人证件类型代码
			      jsonMap.put("agentCertTpCd","");
			      //代理人证件号码
			      jsonMap.put("agenterCerNo","");
			      //代理人姓名
			      jsonMap.put("agtPersName","");
			      //代理人手机号
			      jsonMap.put("agentPersMobileNo","");
			      //渠道所需信息
			      bodyMap.put("FILLER1",jsonMap);
			      bodyMap.put("filler2","");
			      bodyMap.put("seqno",headerMap.get("globalBusiTrackNo"));
			      bodyMap.put("subtxno",headerMap.get("subtxNo"));
			      bodyMap.put("pcode","300201");
			      bodyMap.put("respcode","");
			      bodyMap.put("accountno","");
			      bodyMap.put("authcode","");
			      bodyMap.put("authmode","");
			      bodyMap.put("authresult","");
			      bodyMap.put("authseqno","");
			      bodyMap.put("authtlrname","");
			      bodyMap.put("busssys","99306000000");
			      bodyMap.put("centauthdata","");
			      bodyMap.put("channeltype","42");
			      bodyMap.put("chnlprocode","10431993017");
			      bodyMap.put("oprcode2","");
			      bodyMap.put("processid","");
			      bodyMap.put("termid","");
			      bodyMap.put("tradeflag","");
			      bodyMap.put("verno","");
			      bodyMap.put("cleardate",Platform.getAccountDate());
			      bodyMap.put("currency","");
			      bodyMap.put("destinst","99710730000");
			      bodyMap.put("equiptype","");
			      bodyMap.put("localdate",MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			      bodyMap.put("localtime",MdaUtils.format(MdaUtils.today(),"HHmmss"));
			      bodyMap.put("timestamp",headerMap.get("txStartTime"));
			      bodyMap.put("respinfo","");
			      bodyMap.put("sendinst","99306000000");
			      bodyMap.put("systraceno","");
			      bodyMap.put("tellercode","");
			      bodyMap.put("tranbranch","");
			      bodyMap.put("transinst",headerMap.get("sendSysOrCmptNo"));
			      try
			      {
			        resultMap = (Map<String,Object>) MdaUtils.invoke("cn.com.brilliance.psbc.service.guiyuan.handle.FQZHandler","StartHandle",bodyMap);
			        log.info("{}","反欺诈返回BD结果"+resultMap);
			        resultMap.put("invokeFlag", true);
			      }
			      catch(Exception e1)
			      {
			        log.debug("{}","调用反欺诈系统失败");
			        resultMap.put("fqzflg", false);
			        resultMap.put("repinf", "调用反欺诈系统失败，交易继续进行");
			      }
			      //@20220601 sulike  添加收汇人国籍赋值
			      resultMap.put("rcverNatonCd", ecifReturnMap.get("NATIONALITY"));
			    }
			  }
			  else
			  {
			    log.debug("{}","TexudoEcifUtil.SendMessage接口调用失败");
			    resultMap.put("fqzflg", true);
			    resultMap.put("repinf", "调用客户信息平台失败");
			  }
			  return resultMap;
			}
		}
        /**
        *   source:smpmod.@0137.script
        */
        public boolean createMessageProcessSubjectForYYPXHX(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理,只针对银邮发汇做延时发送处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			/*
			  Platform.esdbRead($chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			readChn(this.getChn(),channel);
			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}
			/*
			  Platform.mdbBegin();
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }*/
			int errorcode = ctx.getErrorCode();
			log.debug("{}","before mdbBegin");
			Platform.mdbBegin();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "YSS"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "W"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			this.getMps().setXhxflg( "Y"); //是否新核心标志
			String mpsinr = Platform.sdbInsert(this.getMps());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "A"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;
			if("cips|xml".contains(messageType))
			{
			  fileName = getCipsStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getCipsdatapath());
			}
			else if("jsh|b2e".contains(messageType))
			{
			  fileName = getB2eStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getB2edatapath());
			}
			else if("nxl".contains(messageType))
			{
			  fileName = getZywStoreFileFullPathName(smhinr, messageType);
			  this.getSmh().setDocpth( this.getZywdatapath());
			}
			else
			  fileName = getStoreFileFullPathName(smhinr, messageType);
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			
			//新增yss延时清分记录
			MdaUtils.clear(this.getYss());
			this.getYss().setMpsinr( mpsinr);
			this.getYss().setSubtyp("103");
			this.getYss().setFrmtyp( "YYP");
			this.getYss().setCredattim( MdaUtils.today());
			this.getYss().setSta( "W");
			Platform.sdbInsert(this.getYss());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert yss with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0138.script
        */
        public boolean do_actwhitelist1(String account)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//先判断是否白名单期，白名单期间需要验证，否则直接默认返回true
			if ("Y".equals(this.getXflag()))
			{
			  //检测账号是否存在在账号白名单中
			  ctx.getErrorCode();
			  log.debug("{}","do_actwhitelist, account = " + account);
			  Platform.esdbRead(this.getXhxdta(),new Argument("act", account));
			  int errorcode = ctx.getErrorCode();
			  if(!MdaUtils.isEmpty(this.getXhxdta().getInr()))
			  {
			    return true;
			  }
			  return false;
			}
			else
			  return true;
		}
        /**
        *   source:smpmod.@0139.script
        */
        public Map<String,Object> getAntfrdBlaGreyLstMarkCd(Map<String,Object> map,Map<String,Object> entityMap)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//反欺诈黑灰名单标记获取
			Map<String,Object> resultMap = new HashMap<String,Object>();
			Map<String,Object> bodyMap = new HashMap<String,Object>();
			Map<String,Object> jsonMap = new HashMap<String,Object>();
			Map<String,Object> headerMap = (Map<String, Object>) map.get("txHeader");
			String pcode = (String)map.get("PCODE");
			//从客户信息平台获取收汇人证件信息
			Map<String,Object> ecifReqMap = this.getActreqpho().getReturnMessage(entityMap.get("rcverAccno").toString());
			Map<String,Object> ecifReturnMap = new HashMap<String,Object>();
			if(MdaUtils.isEmpty(ecifReqMap))
			{
			  log.debug("{}","收汇人账号为空，缺少向客户信息平台查询的必要条件.");
			  resultMap.put("fqzflg", true);
			  resultMap.put("repinf", "收汇人账号为空，缺少向客户信息平台查询的必要条件.");
			  return resultMap;
			}
			else
			{
			  ecifReturnMap = (Map<String,Object>)MdaUtils.invoke("cn.com.brilliance.psbc.util.TexudoEcifUtil","SendMessage",ecifReqMap);
			  if(!MdaUtils.isEmpty(ecifReturnMap))
			  {
			    if("FAIL".equals(ecifReturnMap.get("status").toString()))
			    {
			      log.debug("{}","未查询到收款人对应的证件信息！");
			      resultMap.put("fqzflg", true);
			      resultMap.put("repinf", "未查询到收款人对应的证件信息！");
			    }
			    else
			    {
			      bodyMap.put("PCODE","300201");
			      bodyMap.put("MessageType","fqzquery");
			      //以下要素由map转json放入FILLER1域
			      if("628430".equals(pcode))
			      {
			        //个人证件类型代码
			        jsonMap.put("perCertTpCd",entityMap.get("remiterCertTpCd"));
			        //个人证件号码
			        jsonMap.put("personalCertNo",entityMap.get("remiterCerNo"));
			        //发汇国家地区代码
			        jsonMap.put("disrCounCd",entityMap.get("remiterLonCounCd"));
			      }
			      else
			      {
			        jsonMap.put("perCertTpCd","");
			        jsonMap.put("personalCertNo","");
			        jsonMap.put("disrCounCd",entityMap.get("disrCounCd"));
			      }
			      //姓名
			      jsonMap.put("name",entityMap.get("remiterNm"));
			      //客户账号
			      jsonMap.put("custAccNo",entityMap.get("remiterAccno"));
			      //发汇人国籍代码
			      jsonMap.put("remiterNatonCd",entityMap.get(""));
			      //发汇人性别代码
			      jsonMap.put("remiterSexCd",entityMap.get(""));
			      //手机号
			      jsonMap.put("mobileNo",entityMap.get("remiterTel"));
			      //收汇人证件类型代码     需要2位转4位
			      String propertyPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			      propertyPath = MdaUtils.catPath(propertyPath,"identity.properties");
			      String propertyValue = Platform.getPropertys(propertyPath,ecifReturnMap.get("CERTIFICATE_KIND").toString());
			      jsonMap.put("rcverCertTpCd",propertyValue);
			      //收汇人证件号码
			      jsonMap.put("rcverCertNo",ecifReturnMap.get("CERTIFICATE_NO"));
			      //收汇人姓名
			      jsonMap.put("rcverNm",ecifReturnMap.get("CUSTOMERNAME"));
			      //收汇人账号
			      jsonMap.put("rcverAccno",entityMap.get("rcverAccno"));
			      //收汇人国籍代码
			      jsonMap.put("rcverNatonCd",ecifReturnMap.get("NATIONALITY"));
			      //收汇国家代码
			      jsonMap.put("excCounCd","");
			      //收汇人性别代码
			      jsonMap.put("rcverSexCode",ecifReturnMap.get("SEX"));
			      //收汇人电话
			      jsonMap.put("rcverTel",ecifReturnMap.get("MOBILENUM"));
			      //代理人证件类型代码
			      jsonMap.put("agentCertTpCd","");
			      //代理人证件号码
			      jsonMap.put("agenterCerNo","");
			      //代理人姓名
			      jsonMap.put("agtPersName","");
			      //代理人手机号
			      jsonMap.put("agentPersMobileNo","");
			      //渠道所需信息
			      bodyMap.put("FILLER1",jsonMap);
			      bodyMap.put("filler2","");
			      bodyMap.put("seqno",headerMap.get("globalBusiTrackNo"));
			      bodyMap.put("subtxno",headerMap.get("subtxNo"));
			      bodyMap.put("pcode","300201");
			      bodyMap.put("respcode","");
			      bodyMap.put("accountno","");
			      bodyMap.put("authcode","");
			      bodyMap.put("authmode","");
			      bodyMap.put("authresult","");
			      bodyMap.put("authseqno","");
			      bodyMap.put("authtlrname","");
			      bodyMap.put("busssys","99306000000");
			      bodyMap.put("centauthdata","");
			      bodyMap.put("channeltype","42");
			      bodyMap.put("chnlprocode","10431993001");//接收境外汇票信息
			      if("628430".equals(pcode))
			      {
			        bodyMap.put("chnlprocode","10431993232");//接收cips汇入汇款
			      }
			      if("628630".equals(pcode) || "628631".equals(pcode))
			      {
			        bodyMap.put("chnlprocode","10431993230");//接收cips改汇
			      }

			      bodyMap.put("oprcode2","");
			      bodyMap.put("processid","");
			      bodyMap.put("termid","");
			      bodyMap.put("tradeflag","");
			      bodyMap.put("verno","");
			      bodyMap.put("cleardate",Platform.getAccountDate());
			      bodyMap.put("currency","");
			      bodyMap.put("destinst","99710730000");
			      bodyMap.put("equiptype","");
			      bodyMap.put("localdate",MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			      bodyMap.put("localtime",MdaUtils.format(MdaUtils.today(),"HHmmss"));
			      bodyMap.put("timestamp",headerMap.get("txStartTime"));
			      bodyMap.put("respinfo","");
			      bodyMap.put("sendinst","99306000000");
			      bodyMap.put("systraceno","");
			      bodyMap.put("tellercode","");
			      bodyMap.put("tranbranch","");
			      bodyMap.put("transinst",headerMap.get("sendSysOrCmptNo"));
			      bodyMap.put("txamount",entityMap.get("dispRemAmt"));
			      try
			      {
			        resultMap = (Map<String,Object>) MdaUtils.invoke("cn.com.brilliance.psbc.service.guiyuan.handle.FQZHandler","StartHandle",bodyMap);
			        log.info("{}","反欺诈返回BD结果"+resultMap);
			        //@20220223 sulike 判断是否命中黑名单，命中黑名单发送短信通知给汇款
			        if(!MdaUtils.isEmpty(resultMap.get("blackFlag")))
			        {
			          String blackFlag = (String)resultMap.get("blackFlag");
			          if("1".equals(blackFlag))
			          {
			            //获取收汇人姓名/手机号/账号信息，任意一项为空则不发送短信通知
			            if(!MdaUtils.isEmpty(ecifReturnMap.get("CUSTOMERNAME")) && !MdaUtils.isEmpty(entityMap.get("rcverAccno")) && !MdaUtils.isEmpty(ecifReturnMap.get("MOBILENUM")))
			            {
			              String rcverNm = ecifReturnMap.get("CUSTOMERNAME").toString();
			              String rcverAccno = entityMap.get("rcverAccno").toString();
			              String rcverPhone = ecifReturnMap.get("MOBILENUM").toString();
			              Map<String,Object> messageMap = new HashMap<String,Object>();
			              Map<String,Object> messageBodyMap = new HashMap<String,Object>();
			              Map<String,Object> messageEntityMap = new HashMap<String,Object>();
			              String accdate = Platform.getAccountDate();
			              String[] data = new String[2];
			              data[0] = rcverAccno;
			              //data[1] = $ljsmod\\yypmod\\yyd\\bchkey.getValue();
			              if("Y".equals(this.getQflag()))
			              {
			                messageMap = getPublicHeader(data,Platform.getLogicInterfaceSequence("YY"),Platform.getSubNum(this.getQflag()),accdate);
			              }
			              else
			              {
			                messageMap = getPublicHeader(data,Platform.getGlobalNum(),Platform.getSubNum(this.getQflag()),accdate);
			              }
			              messageBodyMap = (Map<String,Object>)messageMap.get("txBody");
			              //客户姓名
			              messageEntityMap.put("custName", rcverNm);
			              //我行账号
			              messageEntityMap.put("psbcAccno", rcverAccno);
			              //发送短信手机号
			              messageEntityMap.put("sendSmsMobileNo", rcverPhone);
			              //通知消息编号 固定：104319900000079
			              messageEntityMap.put("msgCd", "104319900000079");
			              //短信通知类别编码 固定：00
			              messageEntityMap.put("smsNoticeCategNo", "00");
			              messageBodyMap.put("txEntity", messageEntityMap);
			              messageMap.put("txBody", messageBodyMap);
			              MdaUtils.invoke("cn.com.brilliance.psbc.util.XhxEsbUtil","msgNotice",messageMap);
			              //清空errorCode,防止
			              //Platform.errorCode();
			            }
			          }
			        }

			      }
			      catch(Exception e2)
			      {
			        log.debug("{}","调用反欺诈系统失败");
			        resultMap.put("fqzflg", false);
			        resultMap.put("repinf", "调用反欺诈系统失败，交易继续进行");
			      }
			      //@20220601 sulike  保存收汇人国籍信息
			      resultMap.put("rcverNatonCd", ecifReturnMap.get("NATIONALITY"));
			    }
			  }
			  else
			  {
			    log.debug("{}","TexudoEcifUtil.SendMessage接口调用失败");
			    resultMap.put("fqzflg", true);
			    resultMap.put("repinf", "调用客户信息平台失败");
			  }
			  return resultMap;
			}
		}
        /**
        *   source:smpmod.@0140.script
        */
        public boolean do_xhxoutactwhitelist(Map<String,Object> map,String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String act = "";
			String certtype = "";
			String certno = "";
			if(!MdaUtils.isEmpty(map.get("ACCOUNT")))
			{
			  act = (String)map.get("ACCOUNT");
			}
			if("629040".equals(type))
			{
			  if(!MdaUtils.isEmpty(map.get("PAYEE_CERKIND")))
			  {
			    certtype = (String)map.get("PAYEE_CERKIND");
			  }
			  if(!MdaUtils.isEmpty(map.get("PAYEE_CERNO")))
			  {
			    certno = (String)map.get("PAYEE_CERNO");
			  }
			}
			else
			{
			  if(!MdaUtils.isEmpty(map.get("PAYER_CERKIND")))
			  {
			    certtype = (String)map.get("PAYER_CERKIND");
			  }
			  if(!MdaUtils.isEmpty(map.get("PAYER_CERNO")))
			  {
			    certno = (String)map.get("PAYER_CERNO");
			  }
			}
			//检测账号是否存在在账号白名单中
			ctx.getErrorCode();
			MdaUtils.clear(this.getXhxdta());
			log.debug("{}","do_xhxoutactwhitelist, account = " + act + ", certtype = " + certtype + ", certno = " + certno + ", type = " + type);
			if("630040".equals(type))
			{
			  log.info("{}","进入银邮发汇白名单校验");
			  Platform.esdbRead(this.getXhxdta(),new Argument("act", act));
			}
			else
			{
			  log.info("{}","进入西联交易白名单校验");
			  Platform.esdbRead(this.getXhxdta(),new Argument("certtype", certtype),new Argument("certno", certno));
			}
			log.info("{}","白名单账号主键：" + this.getXhxdta().getInr());
			int errorcode = ctx.getErrorCode();
			log.info("{}","白名单errorcode" + errorcode);
			if(!MdaUtils.isEmpty(this.getXhxdta().getInr()))
			{
			  return true;
			}
			return false;
		}
        /**
        *   source:smpmod.@0143.script
        */
        public boolean fxlCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析接收到的FXPS报文
			  */

			log.info("{}","-----------fxpsCreateMessageInformation-------------" );

			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");
			log.info("{}","fileName :"+fileName);
			java.io.File file = new java.io.File(fileName);

			Object obj = MdaUtils.invoke("com.brilliance.jnwb.utils.MsgUtil","unPackNoSignMessage",new Object[]{file});
			//暂时屏蔽掉验签
			// boolean ve = true;
			boolean ve=vertifyFxps(obj);
			log.info("{}","----验签是否成功----" +ve);
			if(!ve)
			  return false;

			String elcsMessage = MdaUtils.invoke(obj,"getElcsModelForJson").toString();
			log.info("{}","fxpsMessage");

			Map map = new com.google.gson.Gson().fromJson(elcsMessage, Map.class);
			log.info("{}","map :" + map );//json完整报文
			ctx.storeData("fxpsmap",map);

			String nam = MdaEnv.getLoginUser();
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			log.info("{}","mpi msgtyp :" + messageType);
			this.getMpi().setMsgid( (String)map.get("MesgID"));

			String subtyp=null;
			if(!MdaUtils.isEmpty(map.get("MesgType")))
			{
			  subtyp = (String)map.get("MesgType");
			  this.getMpi().setSubtyp( subtyp.substring(5,8));
			}
			log.info("{}","mpi subtyp :" + this.getMpi().getSubtyp() );
			String oriref = null;
			String ref = "";

			if("903".equals(this.getMpi().getSubtyp()))
			{
			  String signstr = MdaUtils.invoke(obj,"getSignatureInfo").toString();
			  ctx.storeData("signstr",signstr);
			}

			//新增921报文处理 20210504
			if("921".equals(this.getMpi().getSubtyp()))
			{
			  List list903= (List) map.get("CertfctnList");
			  //这里最好只处理一条903，统一走do_CPSNotice(type)函数
			  for(int i=0;i<list903.size();i++)
			  {
			    Map map903= (Map)list903.get(i);
			    String base64Str=map903.get("DgtlSgntr").toString();
			    // String elcs903Str=Platform.decode(base64Str.getBytes(),DECODE_BASE64);
			    obj = MdaUtils.invoke("com.brilliance.jnwb.utils.MsgUtil","unPackNoSignMessage",new Object[]{base64Str});
			    ve=vertifyFxps(obj);
			    if(!ve)
			    {
			      log.info("{}","921-903 vertify ="+ve);
			      return false;
			    }

			    elcsMessage = MdaUtils.invoke(obj,"getElcsModelForJson").toString();
			    Map map2 = new com.google.gson.Gson().fromJson(elcsMessage, Map.class);
			    log.info("{}","921-903map :" + map2 );//json完整报文
			    ctx.storeData("fxpsmap",map2);
			    String signstr = MdaUtils.invoke(obj,"getSignatureInfo").toString();
			    ctx.storeData("signstr",signstr);
			    break;
			  }
			}

			if (!"911|990|317".contains(this.getMpi().getSubtyp()))
			{

			  Map hmap = (Map)map.get("GrpHdr");
			  if (!MdaUtils.isEmpty(hmap.get("MsgId")))
			  {
			    ref = (String)hmap.get("MsgId");

			    String vdate=ref.substring(0,8);
			    log.debug("{}","委托日期："+vdate);
			    this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			  }
			}

			//单独处理317报文标识号
			if ("317".contains(this.getMpi().getSubtyp()))
			{
			  Map smap = (Map)map.get("MsgId");
			  if (!MdaUtils.isEmpty(smap.get("Id")))
			  {
			    ref = (String)smap.get("Id");

			    String vdate=ref.substring(0,8);
			    log.debug("{}","委托日期："+vdate);
			    this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			  }
			}

			this.getMpi().setSndbic( (String)map.get("OrigSender"));
			this.getMpi().setRcvbic( (String)map.get("OrigReceiver"));
			//关联业务参考号处理
			if(!MdaUtils.isEmpty(map.get("OrgnlGrpHdr")))
			{
			  Map orgmap = (Map)map.get("OrgnlGrpHdr");
			  log.info("{}","orgmap :" + orgmap);
			  if(!MdaUtils.isEmpty(orgmap.get("OrgnlMsgId")))
			    oriref = (String)orgmap.get("OrgnlMsgId");//原报文标识号
			  log.info("{}","oriref :" + oriref);
			}
			else if(!MdaUtils.isEmpty(map.get("OrgnlMsgInf")))
			{
			  Map orgmap = (Map)map.get("OrgnlMsgInf");
			  log.info("{}","orgmap :" + orgmap);
			  if(!MdaUtils.isEmpty(orgmap.get("OrgnlMsgId")))
			    oriref = (String)orgmap.get("OrgnlMsgId");//原报文标识号
			  log.info("{}","oriref :" + oriref);
			}
			//911报文
			else if(!MdaUtils.isEmpty(map.get("DscrdInf")))
			{
			  Map orgmap = (Map)map.get("DscrdInf");
			  if(!MdaUtils.isEmpty(orgmap.get("MsgId")))
			    oriref = (String)orgmap.get("MsgId");//原报文标识号
			}
			//132即时转账回执的明细信息
			if(!MdaUtils.isEmpty(map.get("OrgnlGrpInfAndSts")))
			{
			  Map orgnlGrpInfAndSts = (Map)map.get("OrgnlGrpInfAndSts");
			  if(!MdaUtils.isEmpty(orgnlGrpInfAndSts.get("OrgnlMsgId")))
			  {
			    oriref = (String)orgnlGrpInfAndSts.get("OrgnlMsgId");
			  }
			  //顺便把金额补充下
			  if(!MdaUtils.isEmpty(orgnlGrpInfAndSts.get("OrgnlCtrlSum")))
			  {
			    this.getMpi().setAmt( MdaUtils.parseDecimal(orgnlGrpInfAndSts.get("OrgnlCtrlSum")));
			  }
			  //TODO 关联报文去查询币种
			}

			if(!MdaUtils.isEmpty(map.get("BizQryInf")))
			{
			  Map bizQryInf = (Map)map.get("BizQryInf");
			  //314业务查询报文
			  if(!MdaUtils.isEmpty(bizQryInf.get("OrgnlInf")))
			  {
			    Map orgnlInf = (Map)bizQryInf.get("OrgnlInf");
			    if(!MdaUtils.isEmpty(orgnlInf.get("OrgnlGrpHdr")))
			    {
			      Map orgnlGrpHdr = (Map)orgnlInf.get("OrgnlGrpHdr");
			      if(!MdaUtils.isEmpty(orgnlGrpHdr.get("OrgnlMsgId")))
			      {
			        oriref = (String)orgnlGrpHdr.get("OrgnlMsgId");  //原报文标识号
			      }
			    }
			  }
			  //320贷记业务入账状态查询申请报文
			  if(!MdaUtils.isEmpty(bizQryInf.get("OrgnlGrpHdr")))
			  {
			    Map orgnlGrpHdr = (Map)bizQryInf.get("OrgnlGrpHdr");
			    if(!MdaUtils.isEmpty(orgnlGrpHdr.get("OrgnlMsgId")))
			    {
			      oriref = (String)orgnlGrpHdr.get("OrgnlMsgId");   //原报文标识号
			    }
			  }
			}

			//317业务状态查询应答报文 （有原报文标识号就取原报文标识号）
			if(!MdaUtils.isEmpty(map.get("BizRpt")))
			{

			  Map bizRpt = (Map)map.get("BizRpt");
			  if(!MdaUtils.isEmpty(bizRpt.get("TxRef")))
			  {
			    oriref = (String)bizRpt.get("TxRef");
			  }
			}
			//没有则去取原查询报文标识号
			if(!MdaUtils.isEmpty(map.get("BizQryRef")))
			{
			  Map bizQryRef = (Map)map.get("BizQryRef");
			  if(!MdaUtils.isEmpty(bizQryRef.get("QryRef")))
			  {
			    oriref = (String)bizQryRef.get("QryRef");
			  }
			}

			if(">".equals(this.getMps().getDir()))
			{
			  if(!MdaUtils.isEmpty(ref))
			    this.getMpi().setOthref( ref);
			  if(!MdaUtils.isEmpty(oriref))
			    this.getMpi().setOwnref( oriref);
			}

			log.info("{}","subtyp :" + subtyp);
			String act = null;
			//金额、币种、账号处理，以及记账报文的清算日期
			
			//141转账信息
			if(!MdaUtils.isEmpty(map.get("CdtTrfTxInf")))
			{
			  Map cdtTrfTxInf = (Map)map.get("CdtTrfTxInf");
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("IntrBkSttlmAmt")))
			  {
			    Map curamt = (Map)cdtTrfTxInf.get("IntrBkSttlmAmt");//转账金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			  //先取付款人
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("DbtrAcct")))
			  {
			    Map dbtrAcct = (Map)cdtTrfTxInf.get("DbtrAcct");
			    if(!MdaUtils.isEmpty(dbtrAcct.get("ID")))
			    {
			      Map idMap1 = (Map)dbtrAcct.get("ID");
			      if(!MdaUtils.isEmpty(idMap1.get("Othr")))
			      {
			        Map othr = (Map)idMap1.get("Othr");
			        if(!MdaUtils.isEmpty(othr.get("ID")))
			        {
			          act = (String)othr.get("ID");
			          this.getMpi().setAct( act.trim());
			        }
			      }
			    }
			  }
			  //如果有收款人，则取收款人
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("CbtrAcct")))
			  {
			    Map dbtrAcct = (Map)cdtTrfTxInf.get("CbtrAcct");
			    if(!MdaUtils.isEmpty(dbtrAcct.get("ID")))
			    {
			      Map idMap1 = (Map)dbtrAcct.get("ID");
			      if(!MdaUtils.isEmpty(idMap1.get("Othr")))
			      {
			        Map othr = (Map)idMap1.get("Othr");
			        if(!MdaUtils.isEmpty(othr.get("ID")))
			        {
			          act = (String)othr.get("ID");
			          this.getMpi().setAct( act.trim());
			        }
			      }
			    }
			  }

			}
			//345资金调整信息
			if(!MdaUtils.isEmpty(map.get("AcctChgInf")))
			{
			  Map acctChgInf = (Map)map.get("AcctChgInf");
			  if(!MdaUtils.isEmpty(acctChgInf.get("FzeChgFud")))
			  {
			    Map curamt = (Map)acctChgInf.get("FzeChgFud");//调整金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			}
			//346资金调整信息
			if(!MdaUtils.isEmpty(map.get("OrgnFzeChgFud")))
			{
			  Map curamt = (Map)map.get("OrgnFzeChgFud");//资金申请金额
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			  this.getMpi().setCur( (String)curamt.get("Ccy"));
			}
			//371资金管理申请信息
			if(!MdaUtils.isEmpty(map.get("MgmtInf")))
			{
			  Map mgmtInf = (Map)map.get("MgmtInf");
			  if(!MdaUtils.isEmpty(mgmtInf.get("Amt")))
			  {
			    Map curamt = (Map)mgmtInf.get("Amt");//管理申请金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			}
			//372资金管理回执信息、373资金管理通知报文
			if(!MdaUtils.isEmpty(map.get("OrgnlAmt")))
			{
			  Map curamt = (Map)map.get("OrgnlAmt");//管理通知金额
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			  this.getMpi().setCur( (String)curamt.get("Ccy"));
			}
			//617记账报文
			if(!MdaUtils.isEmpty(map.get("AcctBookgNtfctnInf")))
			{
			  Map acctBookgNtfctnInf = (Map)map.get("AcctBookgNtfctnInf");
			  if(!MdaUtils.isEmpty(acctBookgNtfctnInf.get("CdtrAmt")))
			  {
			    Map curamt = (Map)acctBookgNtfctnInf.get("CdtrAmt");//贷方金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));

			  }
			  if(!MdaUtils.isEmpty(acctBookgNtfctnInf.get("SttlmDt")))
			  {
			    String vdate=(String)acctBookgNtfctnInf.get("SttlmDt");
			    log.debug("{}","617清算日期："+vdate);
			    this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			  }
			}
			//618记账报文
			if(!MdaUtils.isEmpty(map.get("AcctMgInf")))
			{
			  Map acctBookgNtfctnInf = (Map)map.get("AcctMgInf");
			  if(!MdaUtils.isEmpty(acctBookgNtfctnInf.get("Amt")))
			  {
			    Map curamt = (Map)acctBookgNtfctnInf.get("Amt");//记账金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			  if(!MdaUtils.isEmpty(acctBookgNtfctnInf.get("SttlmDt")))
			  {
			    String vdate=(String)acctBookgNtfctnInf.get("SttlmDt");
			    log.debug("{}","清算日期："+vdate);
			    this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			  }
			}
			//932直参管理报文
			if(!MdaUtils.isEmpty(map.get("BkCcyInf")))
			{
			  Map bkCcyInf = (Map)map.get("BkCcyInf");
			  if(!MdaUtils.isEmpty(bkCcyInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)bkCcyInf.get("Ccy"));
			  }
			}
			//933直参管理应答报文
			if("933".equals(this.getMpi().getSubtyp()))
			{
			  if(!MdaUtils.isEmpty(map.get("QryInf")))
			  {
			    Map qryInf = (Map)map.get("QryInf");
			    if(!MdaUtils.isEmpty(qryInf.get("Ccy")))
			    {
			      this.getMpi().setCur( (String)qryInf.get("Ccy"));
			    }
			  }
			  else
			  {
			    //TODO 关联上一笔，获取币种
			  }
			}

			//20220510   by tc 境内外币二阶段新增报文处理，取出金额币种以及账户信息    （发报取付款人信息）
			
			//111境内跨行贷记业务报文， 301转汇业务信息报文  ，112银行间资金调拨业务报文        取值参数一样   （备注，之前一阶段取值未取到帐户信息，这个也可以取到141报文）
			
			if(!MdaUtils.isEmpty(map.get("CdtTrfTxInf")))
			{
			  Map cdtTrfTxInf = (Map)map.get("CdtTrfTxInf");
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("IntrBkSttlmAmt")))
			  {
			    Map curamt = (Map)cdtTrfTxInf.get("IntrBkSttlmAmt");//转账金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			  //先取付款人
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("DbtrAcct")))
			  {
			    Map dbtrAcct = (Map)cdtTrfTxInf.get("DbtrAcct");
			    if(!MdaUtils.isEmpty(dbtrAcct.get("Id")))
			    {
			      Map idMap1 = (Map)dbtrAcct.get("Id");
			      if(!MdaUtils.isEmpty(idMap1.get("Othr")))
			      {
			        Map othr = (Map)idMap1.get("Othr");
			        if(!MdaUtils.isEmpty(othr.get("Id")))
			        {
			          act = (String)othr.get("Id");
			          this.getMpi().setAct( act.trim());
			        }
			      }
			    }
			  }
			}

			//302转汇信息确认报文   （  原关联报文业务号信息可以复用132报文的取法）
			if(!MdaUtils.isEmpty(map.get("OrgnlPmtInfAndSts")))
			{
			  Map orgnlPmtInfAndSts = (Map)map.get("OrgnlPmtInfAndSts");
			  if(!MdaUtils.isEmpty(orgnlPmtInfAndSts.get("OrgnlPmtInfId")))
			  {
			    this.getMpi().setCur( (String)orgnlPmtInfAndSts.get("OrgnlPmtInfId"));  //币种信息
			  }
			}

			if(!MdaUtils.isEmpty(map.get("BizQryInf")))
			{
			  Map bizQryInf = (Map)map.get("BizQryInf");

			  //314业务查询报文
			  if(!MdaUtils.isEmpty(bizQryInf.get("OrgnlInf")))
			  {
			    Map orgnlInf = (Map)bizQryInf.get("OrgnlInf");
			    if(!MdaUtils.isEmpty(orgnlInf.get("Amt")))
			    {
			      Map curamt = (Map)orgnlInf.get("Amt");
			      this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));  //查询业务金额
			      this.getMpi().setCur( (String)curamt.get("Ccy"));  //币种信息
			    }
			  }

			  //320贷记业务入账状态查询申请报文
			  if(!MdaUtils.isEmpty(bizQryInf.get("Amt")))
			  {
			    Map bizamt = (Map)bizQryInf.get("Amt");
			    this.getMpi().setAmt( MdaUtils.parseDecimal(bizamt.get("amount")));  //查询业务金额
			    this.getMpi().setCur( (String)bizamt.get("Ccy"));  //币种信息
			  }
			}

			if(!MdaUtils.isEmpty(map.get("BizRspnInf")))
			{
			  Map bizRspnInf = (Map)map.get("BizRspnInf");
			  if(!MdaUtils.isEmpty(bizRspnInf.get("OrgnlInf")))
			  {
			    Map orgnlInf = (Map)bizRspnInf.get("OrgnlInf");

			    //315业务查复报文
			    if(!MdaUtils.isEmpty(orgnlInf.get("OrgnlAmt")))
			    {
			      Map orgnlAmt = (Map)orgnlInf.get("OrgnlAmt");
			      this.getMpi().setAmt( MdaUtils.parseDecimal(orgnlAmt.get("amount")));  //查询业务金额
			      this.getMpi().setCur( (String)orgnlAmt.get("Ccy"));  //币种信息
			    }

			    //321贷记业务入账状态查询应答报文
			    if(!MdaUtils.isEmpty(orgnlInf.get("Amt")))
			    {
			      Map bamt = (Map)orgnlInf.get("Amt");
			      this.getMpi().setAmt( MdaUtils.parseDecimal(bamt.get("amount")));  //查询业务金额
			      this.getMpi().setCur( (String)bamt.get("Ccy"));  //币种信息
			    }
			  }
			}

			//318业务退回申请报文
			if(!MdaUtils.isEmpty(map.get("RtrApplInf")))
			{
			  Map rtrApplInf = (Map)map.get("RtrApplInf");
			  if(!MdaUtils.isEmpty(rtrApplInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)rtrApplInf.get("Ccy"));  //币种信息
			  }
			}

			//319业务退回应答报文
			if(!MdaUtils.isEmpty(map.get("RtrRspnInf")))
			{
			  Map rtrRspnInf = (Map)map.get("RtrRspnInf");
			  if(!MdaUtils.isEmpty(rtrRspnInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)rtrRspnInf.get("Ccy"));  //币种信息
			  }
			}

			//308业务撤销应答报文
			if(!MdaUtils.isEmpty(map.get("TxInfAndSts")))
			{
			  Map txInfAndSts = (Map)map.get("TxInfAndSts");
			  if(!MdaUtils.isEmpty(txInfAndSts.get("AcctSvcrRef")))
			  {
			    this.getMpi().setCur( (String)txInfAndSts.get("AcctSvcrRef"));  //币种信息
			  }
			}

			//351日初资金圈存授信确认报文
			if(!MdaUtils.isEmpty(map.get("InitFundChgRspInf")))
			{
			  Map initFundChgRspInf = (Map)map.get("InitFundChgRspInf");
			  if(!MdaUtils.isEmpty(initFundChgRspInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)initFundChgRspInf.get("Ccy"));  //币种信息
			  }

			  if(!MdaUtils.isEmpty(initFundChgRspInf.get("NPCPrcInf")))
			  {
			    Map nPCPrcInf = (Map)map.get("NPCPrcInf");
			    if(!MdaUtils.isEmpty(nPCPrcInf.get("SttlmDt")))
			    {
			      String vdate=(String)nPCPrcInf.get("SttlmDt");
			      log.debug("{}","清算日期："+vdate);
			      this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			    }
			  }
			}

			//317业务状态查询应答报文 （有原报文标识号就取原报文标识号）
			if(!MdaUtils.isEmpty(map.get("BizRpt")))
			{

			  Map bizRpt = (Map)map.get("BizRpt");
			  if(!MdaUtils.isEmpty(bizRpt.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)bizRpt.get("Ccy"));  //币种
			  }

			  if(!MdaUtils.isEmpty(bizRpt.get("NetgDt")))
			  {
			    String vdate=(String)bizRpt.get("NetgDt");
			    log.debug("{}","清算日期："+vdate);
			    this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			  }

			}

			//323额度信息查询应答报文
			if(!MdaUtils.isEmpty(map.get("QryRslt")))
			{
			  Map qryRslt = (Map)map.get("QryRslt");
			  if(!MdaUtils.isEmpty(qryRslt.get("CdtLd")))
			  {
			    Map cdtLd = (Map)qryRslt.get("CdtLd");
			    this.getMpi().setAmt( MdaUtils.parseDecimal(cdtLd.get("amount")));  //圈存资金金额
			    this.getMpi().setCur( (String)cdtLd.get("Ccy"));  //币种信息
			  }
			}

			//325结算账户余额查询回应报文
			if(!MdaUtils.isEmpty(map.get("AcctQryRspnInf")))
			{
			  Map acctQryRspnInf = (Map)map.get("AcctQryRspnInf");
			  if(!MdaUtils.isEmpty(acctQryRspnInf.get("Bal")))
			  {
			    Map bal = (Map)acctQryRspnInf.get("Bal");
			    this.getMpi().setAmt( MdaUtils.parseDecimal(bal.get("amount")));  //总余额
			    this.getMpi().setCur( (String)bal.get("Ccy"));  //币种信息
			  }
			}

			//327支付业务排队管理应答报文
			if(!MdaUtils.isEmpty(map.get("OrgnlApplInf")))
			{
			  Map orgnlApplInf = (Map)map.get("OrgnlApplInf");
			  if(!MdaUtils.isEmpty(orgnlApplInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)orgnlApplInf.get("Ccy"));  //币种信息
			  }
			}

			//354圈存资金调整通知报文
			if(!MdaUtils.isEmpty(map.get("CdtLdChgNtfctnInf")))
			{
			  Map cdtLdChgNtfctnInf = (Map)map.get("CdtLdChgNtfctnInf");
			  if(!MdaUtils.isEmpty(cdtLdChgNtfctnInf.get("CdtLd")))
			  {
			    Map cdtLd = (Map)cdtLdChgNtfctnInf.get("CdtLd");
			    this.getMpi().setAmt( MdaUtils.parseDecimal(cdtLd.get("amount")));  //圈存资金调整值金额
			    this.getMpi().setCur( (String)cdtLd.get("Ccy"));  //币种信息
			  }
			}

			//取清算日期  354|357
			if(!MdaUtils.isEmpty(map.get("NPCPrcInf")))
			{
			  Map nPCPrcInf = (Map)map.get("NPCPrcInf");
			  if(!MdaUtils.isEmpty(nPCPrcInf.get("SttlmDt")))
			  {
			    String vdate=(String)nPCPrcInf.get("SttlmDt");
			    log.debug("{}","清算日期："+vdate);
			    this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			  }
			}

			//357授信额度调整通知报文
			if(!MdaUtils.isEmpty(map.get("CdtXtnsnLmtChgNtfctnInf")))
			{
			  Map cdtXtnsnLmtChgNtfctnInf = (Map)map.get("CdtXtnsnLmtChgNtfctnInf");
			  if(!MdaUtils.isEmpty(cdtXtnsnLmtChgNtfctnInf.get("CdtXtnsnLmt")))
			  {
			    Map cdtXtnsnLmt = (Map)cdtXtnsnLmtChgNtfctnInf.get("CdtXtnsnLmt");
			    this.getMpi().setAmt( MdaUtils.parseDecimal(cdtXtnsnLmt.get("amount")));  //圈存资金调整值金额
			    this.getMpi().setCur( (String)cdtXtnsnLmt.get("Ccy"));  //币种信息
			  }
			}

			//361可用额度预警管理应答报文
			if(!MdaUtils.isEmpty(map.get("RspnInf")))
			{
			  Map rspnInf = (Map)map.get("RspnInf");
			  if(!MdaUtils.isEmpty(rspnInf.get("WrngVal")))
			  {
			    Map wrngVal = (Map)rspnInf.get("WrngVal");
			    this.getMpi().setAmt( MdaUtils.parseDecimal(wrngVal.get("amount")));  //当前可用额度值值金额
			    this.getMpi().setCur( (String)wrngVal.get("Ccy"));  //币种信息
			  }
			}

			//362可用额度预警通知报文
			if(!MdaUtils.isEmpty(map.get("BalWrngNtfctnInf")))
			{
			  Map balWrngNtfctnInf = (Map)map.get("BalWrngNtfctnInf");
			  if(!MdaUtils.isEmpty(balWrngNtfctnInf.get("AmtWthCcy")))
			  {
			    Map amtWthCcy = (Map)balWrngNtfctnInf.get("AmtWthCcy");
			    this.getMpi().setAmt( MdaUtils.parseDecimal(amtWthCcy.get("amount")));  //可用额度预警值金额
			    this.getMpi().setCur( (String)amtWthCcy.get("Ccy"));  //币种信息
			  }
			}

			//612净额结算通知报文
			if(!MdaUtils.isEmpty(map.get("Stmt")))
			{
			  Map stmt = (Map)map.get("Stmt");
			  if(!MdaUtils.isEmpty(stmt.get("Bal")))
			  {
			    Map bal = (Map)stmt.get("Bal");
			    if(!MdaUtils.isEmpty(bal.get("Amt")))
			    {
			      Map balamt = (Map)bal.get("Amt");
			      this.getMpi().setAmt( MdaUtils.parseDecimal(balamt.get("amount")));  //金额
			      this.getMpi().setCur( (String)balamt.get("Ccy"));  //币种信息
			    }

			    if(!MdaUtils.isEmpty(bal.get("Dt")))
			    {
			      Map dt = (Map)bal.get("Dt");
			      if(!MdaUtils.isEmpty(dt.get("Dt")))
			      {
			        String vdate=(String)dt.get("Dt");
			        log.debug("{}","清算日期："+vdate);
			        this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			      }
			    }
			  }
			}

			//802业务截止告警通知报文
			if(!MdaUtils.isEmpty(map.get("BizdlInf")))
			{
			  Map bizdlInf = (Map)map.get("BizdlInf");
			  if(!MdaUtils.isEmpty(bizdlInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)bizdlInf.get("Ccy"));  //币种信息
			  }
			}

			//951直接参与者币种变更通知报文
			if(!MdaUtils.isEmpty(map.get("DrctBkCcyChngNtfctnInf")))
			{
			  Map drctBkCcyChngNtfctnInf = (Map)map.get("DrctBkCcyChngNtfctnInf");
			  if(!MdaUtils.isEmpty(drctBkCcyChngNtfctnInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)drctBkCcyChngNtfctnInf.get("Ccy"));  //币种信息
			  }
			}

			//953币种变更通知报文
			if(!MdaUtils.isEmpty(map.get("CcyChngNtfctnInf")))
			{
			  Map ccyChngNtfctnInf = (Map)map.get("CcyChngNtfctnInf");
			  if(!MdaUtils.isEmpty(ccyChngNtfctnInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)ccyChngNtfctnInf.get("Ccy"));  //币种信息
			  }
			}

			/* else if("elcs.938.001.01".equals(subtyp)||"elcs.231.001.01".equals(subtyp)||"elcs.232.001.01".equals(subtyp)||"ccms.999.001.01".equals(subtyp))
			  {
			  log.info("收到["+subtyp+"]报文,更新目标渠道为FFT");
			  $mps\\tgtchncod="FFT";
			  }*/

			this.getMpi().setGendat( new Date());

			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "fxl");
			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());
			//发报补充一次加签
			if("<".equals(this.getMps().getDir()))
			{
			  //继续加签处理
			  Object xmlModule = MdaUtils.invoke(obj,"getElcsModel");
			  obj = MdaUtils.invoke("com.brilliance.jnwb.utils.MsgUtil","packMessage",xmlModule);
			  //取出加签报文
			  boolean isSuccess = false;
			  try
			  {
			    isSuccess = (Boolean)MdaUtils.invoke(obj,"isSuccess");
			  }
			  catch(Exception e)
			  {
			    log.error("{}","境内外币加签失败:"+e);
			  }
			  this.getMpe().setMpsinr( this.getMps().getInr());
			  this.getMpe().setChncod( this.getMps().getChncod());
			  this.getMpe().setNxtchncod( this.getMps().getChncod());
			  this.getMpe().setSmhinr( this.getSmh().getInr());
			  this.getMpe().setDattim( new Date());
			  this.getMpe().setPrvsta( this.getMps().getSta());
			  this.getMpe().setSta(  this.getMps().getSta());
			  this.getMpe().setUsr( MdaEnv.getLoginUser());
			  this.getMpe().setFrmnam( ctx.getTransName());
			  if(isSuccess)
			  {
			    String nextSmhInr = Platform.sdbCounter("smh");
			    String nextFileName = getStoreFileFullPathName(nextSmhInr,"fxl");//对新报文命名
			    String xmlMsg = (String)MdaUtils.invoke(obj,"getMessage");
			    MdaUtils.clear(this.getFilstm());
			    Platform.convertString2IStream(xmlMsg,this.getFilstm(),"GB18030");
			    Platform.mstreamSave(this.getFilstm(),nextFileName);	//保存新的加签报文
			    this.getMps().setSmhinr( nextSmhInr);

			    this.getMpe().setNxtsmhinr( nextSmhInr);
			    this.getMpe().setTxt( "完成加签");
			    this.getMpe().setDattim( new Date());
			    Platform.sdbInsert(this.getMpe());

			    //插入新的报文
			    this.getNxtsmh().setInr( nextSmhInr);
			    this.getNxtsmh().setObjtyp( "mpe");
			    this.getNxtsmh().setObjinr( this.getMpe().getInr());
			    this.getNxtsmh().setCrtfrm( ctx.getTransName());
			    this.getNxtsmh().setDattim( new Date());
			    this.getNxtsmh().setDocpth( this.getDatapath());
			    this.getNxtsmh().setDocfil( nextSmhInr);
			    this.getNxtsmh().setDocfxt( "fxl");
			    this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			    this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			    this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			    Platform.mdbInsert(this.getNxtsmh());

			  }
			  else
			  {
			    log.error("{}","境内外币加签失败，但没有抛出异常");
			    this.getMpe().setTxt( "加签失败");
			    this.getMpe().setSta("E");
			    this.getMps().setSta( "E");
			    Platform.sdbInsert(this.getMpe());
			    return true;
			  }
			}

			return true;
		}
        /**
        *   source:smpmod.@0144.script
        */
        public boolean vertifyFxps(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Boolean obt = (Boolean)MdaUtils.invoke(obj,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  MdaUtils.invoke(obj,"setStrict",false);
			  String errMsg = MdaUtils.invoke(obj,"getErrMsg").toString();
			  String err = errMsg.substring(8,14);
			  if(err.indexOf("数字签名")>=0)
			  {
			    String str = (String)MdaUtils.invoke(obj,"getHead");
			    str = str.substring(5,19).trim();
			    log.debug("{}","str------"+str);
			    String elcsbkcd = "FXPS" + str;
			    Argument<String> certdn = new Argument<String>("certdn");
			    String sql="select certdn from cetcsn where bnkcod = ? and (syscd = ?) and flg = 'Y'" ;
			    Platform.mdbExecuteSQL(sql,str,"FXPS");
			    Platform.mdbFetchFields(certdn);
			    Platform.mdbCloseCursor();
			    log.debug("{}","certdn:" + certdn.value);
			    String orgstr = MdaUtils.invoke(obj,"getRawSignatureInfo").toString();
			    String signstr = MdaUtils.invoke(obj,"getSignatureInfo").toString();
			    String bnkcod = str;

			    log.debug("{}","orgstr:"+orgstr);
			    log.debug("{}","signstr:"+signstr);
			    if(certdn.value==null)
			    {
			      log.debug("{}","没有对应的FXPS证书信息-----");
			      this.getMps().setFlg( "1");
			      log.debug("{}","开始二代证书验签-----");
			      //二代证书验签
			      obt = (Boolean)MdaUtils.invoke("com.brilliance.dzxt.framework.signature.eLCSignature","verify",orgstr,signstr,bnkcod);
			      if(!obt.booleanValue())
			      {
			        log.debug("{}","二代验签失败");
			        this.getMps().setFlg( "1");
			      }
			      else
			      {
			        log.info("{}","二代验签成功");
			        this.getMps().setFlg( "0");
			      }
			    }
			    else
			    {
			      //电证独立证书验签
			      obt = (Boolean)MdaUtils.invoke("com.brilliance.dzxt.framework.signature.eLCSignature","verify",orgstr,signstr,elcsbkcd);
			      log.debug("{}","obt-------"+obt);
			      if(!obt.booleanValue())
			      {
			        log.debug("{}","独立证书签失败");
			        this.getMps().setFlg( "1");

			      }
			      else
			      {
			        log.info("{}","独立证书验签成功");
			        this.getMps().setFlg( "0");
			      }

			      if("1".equals(this.getMps().getFlg()))
			      {
			        //二代证书验签
			        obt = (Boolean)MdaUtils.invoke("com.brilliance.dzxt.framework.signature.eLCSignature","verify",orgstr,signstr,bnkcod);
			        if(!obt.booleanValue())
			        {
			          log.debug("{}","二代验签失败");
			          this.getMps().setFlg( "1");
			        }
			        else
			        {
			          log.info("{}","二代验签成功");
			          this.getMps().setFlg( "0");
			        }
			      }

			    }
			  }
			  else
			  {
			    log.error("{}","解报失败");
			    return false;
			  }
			}
			else
			{
			  log.info("{}","验签成功");
			}
			log.info("{}","解报成功");
			log.info("{}","mps flg :" + this.getMps().getFlg() );
			return true;
		}
        /**
        *   source:smpmod.@0145.script
        */
        public boolean jfxCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","jfxCreateMessageInformation");
			//境内外币JSON数据转为XML格式
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");

			MdaUtils.clear(this.getFilstm());
			String xmlMsg = (String)MdaUtils.invoke("com.psbc.zfqz.jnwb.FxpsMesgPack","jsnToXml",fileName,this.getFilstm());
			if(xmlMsg == null)
			{
			  return false;
			}
			String nextSmhInr = Platform.sdbCounter("smh");
			String nextFileName = getStoreFileFullPathName(nextSmhInr,"fxl");//对新报文命名
			Platform.mstreamSave(this.getFilstm(),nextFileName);	//保存新sf2报文
			//先以非加签模式继续解析消息入库
			java.io.File file = new java.io.File(nextFileName);
			Object obj = MdaUtils.invoke("com.brilliance.jnwb.utils.MsgUtil","unPackNoSignMessage",new Object[]{xmlMsg});
			boolean ve=true;

			String elcsMessage = MdaUtils.invoke(obj,"getElcsModelForJson").toString();
			log.info("{}","fxpsMessage");

			Map map = new com.google.gson.Gson().fromJson(elcsMessage, Map.class);
			log.info("{}","map :" + map );//json完整报文
			ctx.storeData("fxpsmap",map);

			String nam = MdaEnv.getLoginUser();
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			log.info("{}","mpi msgtyp :" + messageType);
			this.getMpi().setMsgid( (String)map.get("MesgID"));

			String subtyp=null;
			if(!MdaUtils.isEmpty(map.get("MesgType")))
			{
			  subtyp = (String)map.get("MesgType");
			  this.getMpi().setSubtyp( subtyp.substring(5,8));
			}
			log.info("{}","mpi subtyp :" + this.getMpi().getSubtyp() );
			String oriref = null;
			String ref = this.getMpi().getMsgid();

			if("903".equals(this.getMpi().getSubtyp()))
			{
			  String signstr = MdaUtils.invoke(obj,"getSignatureInfo").toString();
			  ctx.storeData("signstr",signstr);
			}

			this.getMpi().setSndbic( (String)map.get("OrigSender"));
			this.getMpi().setRcvbic( (String)map.get("OrigReceiver"));
			//关联业务参考号处理
			if(!MdaUtils.isEmpty(map.get("OrgnlGrpHdr")))
			{
			  Map orgmap = (Map)map.get("OrgnlGrpHdr");
			  if(!MdaUtils.isEmpty(orgmap.get("OrgnlMsgId")))
			    oriref = (String)orgmap.get("OrgnlMsgId");//原报文标识号
			}
			else if(!MdaUtils.isEmpty(map.get("OrgnlMsgInf")))
			{
			  Map orgmap = (Map)map.get("OrgnlMsgInf");
			  if(!MdaUtils.isEmpty(orgmap.get("OrgnlMsgId")))
			    oriref = (String)orgmap.get("OrgnlMsgId");//原报文标识号
			}
			//911报文
			else if(!MdaUtils.isEmpty(map.get("DscrdInf")))
			{
			  Map orgmap = (Map)map.get("DscrdInf");
			  if(!MdaUtils.isEmpty(orgmap.get("MsgId")))
			    oriref = (String)orgmap.get("MsgId");//原报文标识号
			}
			//132即时转账回执的明细信息
			if(!MdaUtils.isEmpty(map.get("OrgnlGrpInfAndSts")))
			{
			  Map orgnlGrpInfAndSts = (Map)map.get("OrgnlGrpInfAndSts");
			  if(!MdaUtils.isEmpty(orgnlGrpInfAndSts.get("OrgnlMsgId")))
			  {
			    oriref = (String)orgnlGrpInfAndSts.get("OrgnlMsgId");
			  }
			  //顺便把金额补充下
			  if(!MdaUtils.isEmpty(orgnlGrpInfAndSts.get("OrgnlCtrlSum")))
			  {
			    this.getMpi().setAmt( MdaUtils.parseDecimal(orgnlGrpInfAndSts.get("OrgnlCtrlSum")));
			  }
			  //TODO 关联报文去查询币种
			
			}

			//20220510   by tc 境内外币二阶段新增报文处理
			//307业务撤销申请报文
			if(!MdaUtils.isEmpty(map.get("Undrlyg")))
			{
			  Map undrlyg = (Map)map.get("Undrlyg");
			  if(!MdaUtils.isEmpty(undrlyg.get("OrgnlGrpInfAndCxl")))
			  {
			    Map orgnlGrpInfAndCxl = (Map)undrlyg.get("OrgnlGrpInfAndCxl");
			    if(!MdaUtils.isEmpty(orgnlGrpInfAndCxl.get("OrgnlMsgId")))
			    {
			      oriref = (String)orgnlGrpInfAndCxl.get("OrgnlMsgId");  //原报文标识号
			    }
			    //取出币种信息
			    if(!MdaUtils.isEmpty(orgnlGrpInfAndCxl.get("GrpCxlId")))
			    {
			      this.getMpi().setCur( (String)orgnlGrpInfAndCxl.get("GrpCxlId"));
			    }
			  }
			}

			if(!MdaUtils.isEmpty(map.get("BizQryInf")))
			{
			  Map bizQryInf = (Map)map.get("BizQryInf");
			  //314业务查询报文
			  if(!MdaUtils.isEmpty(bizQryInf.get("OrgnlInf")))
			  {
			    Map orgnlInf = (Map)bizQryInf.get("OrgnlInf");
			    if(!MdaUtils.isEmpty(orgnlInf.get("OrgnlGrpHdr")))
			    {
			      Map orgnlGrpHdr = (Map)orgnlInf.get("OrgnlGrpHdr");
			      if(!MdaUtils.isEmpty(orgnlGrpHdr.get("OrgnlMsgId")))
			      {
			        oriref = (String)orgnlGrpHdr.get("OrgnlMsgId");  //原报文标识号
			      }
			    }
			  }
			  //320贷记业务入账状态查询申请报文
			  if(!MdaUtils.isEmpty(bizQryInf.get("OrgnlGrpHdr")))
			  {
			    Map orgnlGrpHdr = (Map)bizQryInf.get("OrgnlGrpHdr");
			    if(!MdaUtils.isEmpty(orgnlGrpHdr.get("OrgnlMsgId")))
			    {
			      oriref = (String)orgnlGrpHdr.get("OrgnlMsgId");   //原报文标识号
			    }
			  }
			}

			//316业务状态查询申请报文
			if(!MdaUtils.isEmpty(map.get("TxQryInf")))
			{
			  Map txQryInf = (Map)map.get("TxQryInf");
			  if(!MdaUtils.isEmpty(txQryInf.get("OrgnlMsgId")))
			  {
			    oriref = (String)txQryInf.get("OrgnlMsgId");  //原报文标识号
			  }
			  if(!MdaUtils.isEmpty(txQryInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)txQryInf.get("Ccy"));  //币种
			  }
			}

			//326支付业务排队管理申请报文
			if(!MdaUtils.isEmpty(map.get("QMgmtApplInf")))
			{
			  Map qMgmtApplInf = (Map)map.get("QMgmtApplInf");
			  if(!MdaUtils.isEmpty(qMgmtApplInf.get("OrgnlGrpHdr")))
			  {
			    Map orgnlGrpHdr = (Map)qMgmtApplInf.get("OrgnlGrpHdr");
			    if(!MdaUtils.isEmpty(orgnlGrpHdr.get("OrgnlMsgId")))
			    {
			      oriref = (String)orgnlGrpHdr.get("OrgnlMsgId");  //原报文标识号
			    }
			  }

			  if(!MdaUtils.isEmpty(qMgmtApplInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)qMgmtApplInf.get("Ccy"));  //币种
			  }
			}

			this.getMpi().setOthref( oriref);
			this.getMpi().setOwnref( ref);

			log.info("{}","subtyp :" + subtyp);
			String act = null;
			//金额、币种、账号处理，以及记账报文的清算日期
			
			//141转账信息
			if(!MdaUtils.isEmpty(map.get("CdtTrfTxInf")))
			{
			  Map cdtTrfTxInf = (Map)map.get("CdtTrfTxInf");
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("IntrBkSttlmAmt")))
			  {
			    Map curamt = (Map)cdtTrfTxInf.get("IntrBkSttlmAmt");//转账金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			  //先取付款人
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("DbtrAcct")))
			  {
			    Map dbtrAcct = (Map)cdtTrfTxInf.get("DbtrAcct");
			    if(!MdaUtils.isEmpty(dbtrAcct.get("ID")))
			    {
			      Map idMap1 = (Map)dbtrAcct.get("ID");
			      if(!MdaUtils.isEmpty(idMap1.get("Othr")))
			      {
			        Map othr = (Map)idMap1.get("Othr");
			        if(!MdaUtils.isEmpty(othr.get("ID")))
			        {
			          act = (String)othr.get("ID");
			          this.getMpi().setAct( act.trim());
			        }
			      }
			    }
			  }
			  //如果有收款人，则取收款人
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("CbtrAcct")))
			  {
			    Map dbtrAcct = (Map)cdtTrfTxInf.get("CbtrAcct");
			    if(!MdaUtils.isEmpty(dbtrAcct.get("ID")))
			    {
			      Map idMap1 = (Map)dbtrAcct.get("ID");
			      if(!MdaUtils.isEmpty(idMap1.get("Othr")))
			      {
			        Map othr = (Map)idMap1.get("Othr");
			        if(!MdaUtils.isEmpty(othr.get("ID")))
			        {
			          act = (String)othr.get("ID");
			          this.getMpi().setAct( act.trim());
			        }
			      }
			    }
			  }

			}
			//345资金调整信息
			if(!MdaUtils.isEmpty(map.get("AcctChgInf")))
			{
			  Map acctChgInf = (Map)map.get("AcctChgInf");
			  if(!MdaUtils.isEmpty(acctChgInf.get("FzeChgFud")))
			  {
			    Map curamt = (Map)acctChgInf.get("FzeChgFud");//调整金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			}
			//346资金调整信息
			if(!MdaUtils.isEmpty(map.get("OrgnFzeChgFud")))
			{
			  Map curamt = (Map)map.get("OrgnFzeChgFud");//资金申请金额
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			  this.getMpi().setCur( (String)curamt.get("Ccy"));
			}
			//371资金管理申请信息
			if(!MdaUtils.isEmpty(map.get("MgmtInf")))
			{
			  Map mgmtInf = (Map)map.get("MgmtInf");
			  if(!MdaUtils.isEmpty(mgmtInf.get("Amt")))
			  {
			    Map curamt = (Map)mgmtInf.get("Amt");//管理申请金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			}
			//372资金管理回执信息、373资金管理通知报文
			if(!MdaUtils.isEmpty(map.get("OrgnlAmt")))
			{
			  Map curamt = (Map)map.get("OrgnlAmt");//管理通知金额
			  this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			  this.getMpi().setCur( (String)curamt.get("Ccy"));
			}
			//617记账报文
			if(!MdaUtils.isEmpty(map.get("AcctBookgNtfctnInf")))
			{
			  Map acctBookgNtfctnInf = (Map)map.get("AcctBookgNtfctnInf");
			  if(!MdaUtils.isEmpty(acctBookgNtfctnInf.get("CdtrAmt")))
			  {
			    Map curamt = (Map)acctBookgNtfctnInf.get("CdtrAmt");//贷方金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));

			  }
			  if(!MdaUtils.isEmpty(acctBookgNtfctnInf.get("SttlmDt")))
			  {
			    String vdate=(String)acctBookgNtfctnInf.get("SttlmDt");
			    log.debug("{}","617清算日期："+vdate);
			    this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			  }
			}
			//618记账报文
			if(!MdaUtils.isEmpty(map.get("AcctMgInf")))
			{
			  Map acctBookgNtfctnInf = (Map)map.get("AcctMgInf");
			  if(!MdaUtils.isEmpty(acctBookgNtfctnInf.get("Amt")))
			  {
			    Map curamt = (Map)acctBookgNtfctnInf.get("Amt");//记账金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			  if(!MdaUtils.isEmpty(acctBookgNtfctnInf.get("SttlmDt")))
			  {
			    String vdate=(String)acctBookgNtfctnInf.get("SttlmDt");
			    log.debug("{}","清算日期："+vdate);
			    this.getMpi().setValdat( MdaUtils.parseDate(vdate,"yyyyMMdd"));
			  }
			}
			//932直参管理报文
			if(!MdaUtils.isEmpty(map.get("BkCcyInf")))
			{
			  Map bkCcyInf = (Map)map.get("BkCcyInf");
			  if(!MdaUtils.isEmpty(bkCcyInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)bkCcyInf.get("Ccy"));
			  }
			}
			//933直参管理应答报文
			if("933".equals(this.getMpi().getSubtyp()))
			{
			  if(!MdaUtils.isEmpty(map.get("QryInf")))
			  {
			    Map bkCcyInf = (Map)map.get("BkCcyInf");
			    if(!MdaUtils.isEmpty(bkCcyInf.get("Ccy")))
			    {
			      this.getMpi().setCur( (String)bkCcyInf.get("Ccy"));
			    }
			  }
			  else
			  {
			    //TODO 关联上一笔，获取币种
			  }
			}

			//20220510   by tc 境内外币二阶段新增报文处理，取出金额币种以及账户信息    （发报取付款人信息）
			
			//111境内跨行贷记业务报文， 301转汇业务信息报文  ，112银行间资金调拨业务报文        取值参数一样   （备注，之前一阶段取值未取到帐户信息，这个也可以取到141报文）
			
			if(!MdaUtils.isEmpty(map.get("CdtTrfTxInf")))
			{
			  Map cdtTrfTxInf = (Map)map.get("CdtTrfTxInf");
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("IntrBkSttlmAmt")))
			  {
			    Map curamt = (Map)cdtTrfTxInf.get("IntrBkSttlmAmt");//转账金额
			    this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));
			    this.getMpi().setCur( (String)curamt.get("Ccy"));
			  }
			  //先取付款人
			  if(!MdaUtils.isEmpty(cdtTrfTxInf.get("DbtrAcct")))
			  {
			    Map dbtrAcct = (Map)cdtTrfTxInf.get("DbtrAcct");
			    if(!MdaUtils.isEmpty(dbtrAcct.get("Id")))
			    {
			      Map idMap1 = (Map)dbtrAcct.get("Id");
			      if(!MdaUtils.isEmpty(idMap1.get("Othr")))
			      {
			        Map othr = (Map)idMap1.get("Othr");
			        if(!MdaUtils.isEmpty(othr.get("Id")))
			        {
			          act = (String)othr.get("Id");
			          this.getMpi().setAct( act.trim());
			        }
			      }
			    }
			  }
			}

			//302转汇信息确认报文   （  原关联报文业务号信息可以复用132报文的取法）
			if(!MdaUtils.isEmpty(map.get("OrgnlPmtInfAndSts")))
			{
			  Map orgnlPmtInfAndSts = (Map)map.get("OrgnlPmtInfAndSts");
			  if(!MdaUtils.isEmpty(orgnlPmtInfAndSts.get("OrgnlPmtInfId")))
			  {
			    this.getMpi().setCur( (String)orgnlPmtInfAndSts.get("OrgnlPmtInfId"));  //币种信息
			  }
			}

			if(!MdaUtils.isEmpty(map.get("BizQryInf")))
			{
			  Map bizQryInf = (Map)map.get("BizQryInf");

			  //314业务查询报文
			  if(!MdaUtils.isEmpty(bizQryInf.get("OrgnlInf")))
			  {
			    Map orgnlInf = (Map)bizQryInf.get("OrgnlInf");
			    if(!MdaUtils.isEmpty(orgnlInf.get("Amt")))
			    {
			      Map curamt = (Map)orgnlInf.get("Amt");
			      this.getMpi().setAmt( MdaUtils.parseDecimal(curamt.get("amount")));  //查询业务金额
			      this.getMpi().setCur( (String)curamt.get("Ccy"));  //币种信息
			    }
			  }

			  //320贷记业务入账状态查询申请报文
			  if(!MdaUtils.isEmpty(bizQryInf.get("Amt")))
			  {
			    Map bizamt = (Map)bizQryInf.get("Amt");
			    this.getMpi().setAmt( MdaUtils.parseDecimal(bizamt.get("amount")));  //查询业务金额
			    this.getMpi().setCur( (String)bizamt.get("Ccy"));  //币种信息
			  }
			}

			if(!MdaUtils.isEmpty(map.get("BizRspnInf")))
			{
			  Map bizRspnInf = (Map)map.get("BizRspnInf");
			  if(!MdaUtils.isEmpty(bizRspnInf.get("OrgnlInf")))
			  {
			    Map orgnlInf = (Map)bizRspnInf.get("OrgnlInf");

			    //315业务查复报文
			    if(!MdaUtils.isEmpty(orgnlInf.get("OrgnlAmt")))
			    {
			      Map orgnlAmt = (Map)orgnlInf.get("OrgnlAmt");
			      this.getMpi().setAmt( MdaUtils.parseDecimal(orgnlAmt.get("amount")));  //查询业务金额
			      this.getMpi().setCur( (String)orgnlAmt.get("Ccy"));  //币种信息
			    }

			    //321贷记业务入账状态查询应答报文
			    if(!MdaUtils.isEmpty(orgnlInf.get("Amt")))
			    {
			      Map bamt = (Map)orgnlInf.get("Amt");
			      this.getMpi().setAmt( MdaUtils.parseDecimal(bamt.get("amount")));  //查询业务金额
			      this.getMpi().setCur( (String)bamt.get("Ccy"));  //币种信息
			    }
			  }
			}

			//318业务退回申请报文
			if(!MdaUtils.isEmpty(map.get("RtrApplInf")))
			{
			  Map rtrApplInf = (Map)map.get("RtrApplInf");
			  if(!MdaUtils.isEmpty(rtrApplInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)rtrApplInf.get("Ccy"));  //币种信息
			  }
			}

			//319业务退回应答报文
			if(!MdaUtils.isEmpty(map.get("RtrRspnInf")))
			{
			  Map rtrRspnInf = (Map)map.get("RtrRspnInf");
			  if(!MdaUtils.isEmpty(rtrRspnInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)rtrRspnInf.get("Ccy"));  //币种信息
			  }
			}

			//322额度信息查询申请报文    324结算账户余额查询请求报文
			if(!MdaUtils.isEmpty(map.get("AcctInf")))
			{
			  Map acctInf = (Map)map.get("AcctInf");
			  if(!MdaUtils.isEmpty(acctInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)acctInf.get("Ccy"));  //币种信息
			  }
			}

			//350日初资金圈存授信报文
			if(!MdaUtils.isEmpty(map.get("InitlFndsChgReqInf")))
			{
			  Map initlFndsChgReqInf = (Map)map.get("InitlFndsChgReqInf");
			  if(!MdaUtils.isEmpty(initlFndsChgReqInf.get("Ccy")))
			  {
			    this.getMpi().setCur( (String)initlFndsChgReqInf.get("Ccy"));  //币种信息
			  }
			  //TODO 金额暂时不取（内部是一个list列表形式）
			}

			//360可用额度预警管理申请报文
			if(!MdaUtils.isEmpty(map.get("NetDbtWrngMgmtInf")))
			{
			  Map netDbtWrngMgmtInf = (Map)map.get("NetDbtWrngMgmtInf");
			  if(!MdaUtils.isEmpty(netDbtWrngMgmtInf.get("WrngVal")))
			  {
			    Map wrngValAmt = (Map)netDbtWrngMgmtInf.get("WrngVal");
			    this.getMpi().setAmt( MdaUtils.parseDecimal(wrngValAmt.get("amount")));  //可用额度预警值金额
			    this.getMpi().setCur( (String)wrngValAmt.get("Ccy"));  //币种信息
			  }
			}

			this.getMpi().setGendat( new Date());

			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "fxl");

			/// 记录新的MPE处理信息
			MdaUtils.clear(this.getMpe());
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( this.getMps().getChncod());
			this.getMpe().setNxtchncod( this.getMps().getChncod());
			this.getMpe().setSmhinr( this.getSmh().getInr());
			this.getMpe().setNxtsmhinr( nextSmhInr);
			this.getMpe().setDattim( new Date());
			this.getMpe().setPrvsta( this.getMps().getSta());
			this.getMpe().setSta(  this.getMps().getSta());
			this.getMpe().setTxt( "JSON转换的FXPS报文.");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			log.debug("{}","插入JSON转换报文MPE");
			Platform.sdbInsert(this.getMpe());
			log.debug("{}","插入JSON转换报文MPE后");
			/// 记录SMH信息
			this.getNxtsmh().setInr( nextSmhInr);
			this.getNxtsmh().setObjtyp( "mpe");
			this.getNxtsmh().setObjinr( this.getMpe().getInr());
			this.getNxtsmh().setCrtfrm( ctx.getTransName());
			this.getNxtsmh().setDattim( new Date());
			this.getNxtsmh().setDocpth( this.getDatapath());
			this.getNxtsmh().setDocfil( nextSmhInr);
			this.getNxtsmh().setDocfxt( "fxl");
			this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			Platform.mdbInsert(this.getNxtsmh());
			/// 更新MPS信息（Update在unlock为执行）
			this.getMps().setSmhinr( nextSmhInr);

			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());

			log.debug("{}","unpack messageType="+messageType);

			//990不加签，直接结束
			if("990".equals(messageType))
			  return true;

			//继续加签处理
			Object xmlModule = MdaUtils.invoke(obj,"getElcsModel");

			boolean isSuccess = false;
			try
			{
			  obj = MdaUtils.invoke("com.brilliance.jnwb.utils.MsgUtil","packMessage",xmlModule);
			  isSuccess = (Boolean)MdaUtils.invoke(obj,"isSuccess");
			}
			catch(Exception e)
			{
			  log.error("{}","境内外币加签失败:"+e);
			}
			if(isSuccess)
			{
			  nextSmhInr = Platform.sdbCounter("smh");
			  nextFileName = getStoreFileFullPathName(nextSmhInr,"fxl");//对新报文命名
			  xmlMsg = (String)MdaUtils.invoke(obj,"getMessage");
			  MdaUtils.clear(this.getFilstm());
			  Platform.convertString2IStream(xmlMsg,this.getFilstm());
			  Platform.mstreamSave(this.getFilstm(),nextFileName);	//保存新的加签报文
			  this.getMps().setSmhinr( nextSmhInr);

			  this.getMpe().setNxtsmhinr( nextSmhInr);
			  this.getMpe().setTxt( "完成加签");
			  this.getMpe().setDattim( new Date());
			  Platform.sdbInsert(this.getMpe());

			  //插入新的报文
			  this.getNxtsmh().setInr( nextSmhInr);
			  this.getNxtsmh().setObjtyp( "mpe");
			  this.getNxtsmh().setObjinr( this.getMpe().getInr());
			  this.getNxtsmh().setCrtfrm( ctx.getTransName());
			  this.getNxtsmh().setDattim( new Date());
			  this.getNxtsmh().setDocpth( this.getDatapath());
			  this.getNxtsmh().setDocfil( nextSmhInr);
			  this.getNxtsmh().setDocfxt( "fxl");
			  this.getNxtsmh().setDocmd5( MdaUtils.fileMD5Value(nextFileName));
			  this.getNxtsmh().setDoclen( MdaUtils.fileSize(nextFileName));
			  this.getNxtsmh().setMpiinr( this.getMpi().getInr());
			  Platform.mdbInsert(this.getNxtsmh());

			}
			else
			{
			  log.error("{}","境内外币加签失败，但没有抛出异常");
			  this.getMpe().setTxt( "加签失败");
			  this.getMpe().setSta("E");
			  this.getMps().setSta( "E");
			  Platform.sdbInsert(this.getMpe());
			  return true;
			}
			return true;
		}
        /**
        *   source:smpmod.@0146.script
        */
        public boolean cipsScheamError(String channel)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//libc updateErrSendState();
			//cips的往报scheam校验失败后，发往新国结错误结果接口
			
			log.debug("{}","mps的messageid:"+ this.getMps().getMessageid());
			if(!MdaUtils.isEmpty(this.getMps().getMessageid()))
			{
			  Map<String,String> map = new HashMap();
			  Date date = MdaUtils.today();
			  boolean cipsflg =false;
			  map.put("inr",this.getMps().getInr());
			  map.put("CHANNEL",channel);
			  map.put("messageId",this.getMps().getMessageid());
			  map.put("errInfo","scheam校验失败!");
			  MdaUtils.invoke("cn.com.brilliance.psbc.service.gjjs.handle.GjjsSendServiceHandler","gjjsSendCispErrService",map,new ICallback() {
				@Override
				public Object invoke(Object... paramVarArgs) {
					updateErrSendState(paramVarArgs);
					return null;
				}
			});
			  log.debug("{}","cipsflg中的值"+this.getCipsflg());
			  if("0".equals(this.getCipsflg()))
			  {
			    log.debug("{}","调用接口返回成功："+cipsflg);
			    cipsflg = false;
			  }
			  else
			  {
			    log.debug("{}","调用接口返回失败："+cipsflg);
			    cipsflg = false;
			  }

			  log.debug("{}","返回cipsflg的值"+cipsflg);
			  return cipsflg;
			}
			else
			{

			  return false;

			}
		}
        /**
        *   source:smpmod.@0147.script
        */
        public boolean updateErrSendState(Object... arguments)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.setCipsflg(NULLSTR);
			String inr = (String)arguments[0];
			boolean flag = (Boolean)arguments[1];
			String detail = (String)arguments[2];
			log.debug("{}","调用接口返回的flag："+flag);
			if(flag)
			  this.setCipsflg("0");
			else
			{
			  this.setCipsflg("1");
			}
			//Platform.mdbBegin();
			
			//String state = "D";
			//if(!flag)
			// {
			//   state = "WS";
			// }
			// $mps\\snddattim = Platform.today();
			//flag = updatekAckWithUnlock("D", state, detail);
			
			//Platform.mdbCommit();
			return flag;
		}
        /**
        *   source:smpmod.@0148.script
        */
        public boolean do_actwhitelist2(String account)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//先判断是否白名单期，白名单期间需要验证，否则直接默认返回true
			if ("Y".equals(this.getXflag1()))
			{
			  //检测账号是否存在在账号白名单中
			  ctx.getErrorCode();
			  log.debug("{}","do_actwhitelist2, account = " + account);
			  Platform.esdbRead(this.getXhxact(),new Argument("act", account));
			  int errorcode = ctx.getErrorCode();
			  if(!MdaUtils.isEmpty(this.getXhxact().getInr()))
			  {
			    return true;
			  }
			  return false;
			}
			else
			  return true;
		}
        /**
        *   source:smpmod.@0149.script
        */
        public Map<String,Object> getPublicHeaderDyc(String[] data,String globalBusiTrackNo,String subtxNo,String accdate)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//国际支付外呼新核心公共请求报文头组装
			//data[0]:账号
			Map<String,Object> map = new HashMap<String,Object>();
			Map<String,Object> bodyMap = new HashMap<String,Object>();
			Map<String,Object> headMap = new HashMap<String,Object>();
			Map<String,Object> txComni = new HashMap<String,Object>();
			Map<String,Object> txComn2 = new HashMap<String,Object>();
			Map<String,Object> txComn4 = new HashMap<String,Object>();
			Map<String,Object> txComn8 = new HashMap<String,Object>();
			Map<String,Object> txEntity = new HashMap<String,Object>();
			txComni.put("accountingDate",accdate);
			txComn2.put("oprTellerNo","99311005293");
			txComn4.put("batchOnlineTxMode","0");
			//业务发送系统或组件编码
			txComn8.put("busiSendSysOrCmptNo","99306000000");
			bodyMap.put("txComni",txComni);
			bodyMap.put("txComn2",txComn2);
			bodyMap.put("txComn4",txComn4);
			bodyMap.put("txComn8",txComn8);
			bodyMap.put("txEntity",txEntity);
			//发起系统或组件编码
			headMap.put("startSysOrCmptNo","99306000000");
			//发送系统或组件编码
			headMap.put("sendSysOrCmptNo","99306000000");
			//发起渠道标识码
			headMap.put("startChnlFgCd","42");
			//业务发起机构号
			if(data[1] == null || "".equals(data[1]))
			  headMap.put("busiSendInstNo","11005293");
			else
			  headMap.put("busiSendInstNo",data[1]);
			//数据中心代码
			headMap.put("dataCenterCode",Platform.getDataCenterCode());
			//交易发起时间
			headMap.put("txStartTime",MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmssSSS"));
			//交易发送时间
			headMap.put("txSendTime",MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmssSSS"));
			//报文总长度
			headMap.put("msgrptTotalLen","0");
			//报文格式版本号
			headMap.put("msgrptFmtVerNo","1.0.0");
			//报文协议类型
			headMap.put("msgAgrType","1");
			//公共报文头长度
			headMap.put("pubMsgHeadLen","0");
			//嵌入报文长度
			headMap.put("embedMsgrptLen","0");
			//目标系统或组件编码
			headMap.put("targetSysOrCmptNo","1043199");
			//服务类型代码
			//@20220209 sulike 重发交易，服务类型代码-8
			headMap.put("servTpCd","8");
			//服务编码
			headMap.put("servNo","");
			//服务版本号
			headMap.put("servVerNo","1.0.0");
			//报文鉴别码
			headMap.put("msgrptMac","");
			//全局业务跟踪号
			headMap.put("globalBusiTrackNo",globalBusiTrackNo);
			//子交易序号
			headMap.put("subtxNo",subtxNo);
			//主映射要素信息  20210906 管理类报文不送该字段
			if(data.length == 2)
			{
			  headMap.put("mainMapElemntInfo","05"+data[0].trim());
			}
			else
			{
			  if("628460".equals(data[2])||"628480".equals(data[2])||"628470".equals(data[2]))
			  {
			    headMap.put("mainMapElemntInfo","07"+data[0]);
			  }
			  else if("628590".equals(data[2]))
			  {
			    headMap.put("mainMapElemntInfo","05"+data[0]);
			  }
			  else if("628650".equals(data[2])||"628640".equals(data[2]))
			  {
			    headMap.put("mainMapElemntInfo","04"+data[0]);
			  }
			  else
			  {

			  }
			}

			//请求系统流水号
			headMap.put("reqSysSriNo","00000000000000000000000000000000");
			//预留输入信息
			headMap.put("resvedInputInfo","0");

			map.put("txHeader",headMap);
			map.put("txBody",bodyMap);

			log.info("{}","新核心请求公共报文头"+map);
			return map;
		}
        /**
        *   source:smpmod.@0151.script
        */
        public boolean createMessageProcessSubjectForSwtMX(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			/// 系统处理时间
			Date processDate = new Date();
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getMpe());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());

			Platform.setDefaultDB("swd");
			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");
			/*
			  Platform.esdbRead($chn,new Argument("cod",channel));
			  /// 未知渠道或当前渠道状态非接收状态
			  if(Platform.errorCode()!=NO_ERROR)
			  */
			readChn(this.getChn(),channel);
			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{
			  /*
			    Platform.esdbRead($tgtchn,new Argument("cod",targetChannel));
			    /// 未知目标渠道则将其设置为空
			    if(Platform.errorCode()!=NO_ERROR)
			    */
			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}
			/*
			  Platform.mdbBegin();
			  /// 更新当前渠道最近接收报文时间
			  $chn\\lstrcvdattim = processDate;
			  Platform.mdbUpdate($chn);
			  Platform.mdbCommit();
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  {
			  log.debug("dbUpdate chn with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			  }*/
			int errorcode = ctx.getErrorCode();
			log.debug("{}","before mdbBegin");
			Platform.mdbBegin();
			/// 获取报文记录inr
			String smhinr = Platform.sdbCounter("smh");
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "A"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			
			this.getMps().setIsmx( 1);
			Platform.sdbInsert(this.getMps());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mps with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "A"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert mpe with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			this.getSmh().setInr( smhinr);
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = getStoreFileFullPathName(smhinr, messageType);
			fileName = fileName.replaceAll(".sf2",".xml");
			// 保存文件并记录MD5值和文件大小信息
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			Platform.mdbInsert(this.getSmh());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert smh with errorcode:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			//
			Platform.mdbCommit();
			return true;
		}
        /**
        *   source:smpmod.@0152.script
        */
        public boolean sf2MxCreateMessageInformation(String fileName,String messageType,String chncod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getMpi().getInr()))
			  this.setEdtflg( "new");
			else
			  this.setEdtflg( "ame");

			String xmlFileName = fileName.replaceAll(".sf2",".xml");
			MdaUtils.clear(this.getSwestm());
			IStream is = this.getSwestm();
			Platform.mstreamLoad(is,xmlFileName);
			String xml = Platform.convertIStream2String(is);
			//log.debug("MX FileName:" + xmlFileName);
			//log.debug("MX FileContent:" + xml);
			
			Object object = MdaUtils.invoke("com.brilliance.swift.SwiftTransfer","mx2Mt",xml,"",new HashMap<String,Object>());
			if(object==null||!(object instanceof String))
			  return false;
			String mt = (String)object;
			//log.debug("MT FileName:" + fileName);
			//log.debug("MT FileContent:" + mt);
			MdaUtils.clear(this.getSwestm());
			is = this.getSwestm();
			Platform.convertString2IStream(mt,is);
			Platform.mstreamSave(is,fileName);

			object = MdaUtils.invoke("com.brilliance.swift.SwiftTransfer","mx2MtMap",xml,new HashMap<String,Object>());
			if(object==null||!(object instanceof Map))
			  return false;
			Map<String,String> map = (Map)object;
			log.trace("{}","map:"+map);

			//关联所属实体
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setEtyAndPty(this.getMpi(),map);
			log.debug("{}","inr :"+this.getMpi().getEtyinr());

			//20171026新加，gpi标识
			if(!MdaUtils.isEmpty(map.get("gpiFlg")))
			{
			  this.getMpi().setGpi( map.get("gpiFlg"));
			}
			//20181022新加，UETR信息
			if(!MdaUtils.isEmpty(map.get("UETR")))
			{
			  this.getMpi().setUetr( map.get("UETR"));
			}
			//20181221新加，GPI的值信息
			if(!MdaUtils.isEmpty(map.get("gpiVal")))
			{
			  this.getMpi().setGpival( map.get("gpiVal"));
			}
			//20181228新加，GPI相关收费信息
			if(!MdaUtils.isEmpty(map.get("sellamt")))
			{
			  this.getMpi().setSelamt( MdaUtils.parseDecimal(map.get("sellamt")));
			}
			if(!MdaUtils.isEmpty(map.get("sellcur")))
			{
			  this.getMpi().setSelcur( map.get("sellcur"));
			}
			if(!MdaUtils.isEmpty(map.get("71Fmsg")))
			{
			  this.getMpi().setMsg71f( map.get("71Fmsg"));
			}

			//20181129新增系统跟踪号字段
			// Object sysTrackNo = Platform.invoke("cn.com.brilliance.psbc.service.zjyw.handle.AbsYWServiceHandler","getSysTrackNo");
			//20190102更新系统跟踪号生成规则  11位发起系统码+8位时间+15随机数
			/*String  sys_Track_No = "99306000000"+Platform.format(new Date(),"yyyyMMdd")+Platform.sdbCounter("rad","000000000000000");
			  log.info("系统跟踪号：" + sys_Track_No);
			  if(!Platform.isEmpty(sys_Track_No))
			  {
			  $mpi\\systrackn = sys_Track_No;
			  }*/
			//20181227新增会计日期，用于日后对账使用
			this.getMpi().setAccdat( Platform.getAccountDate());
			log.info("{}","会计日期："+this.getMpi().getAccdat());
			String nam = MdaEnv.getLoginUser();
			log.debug("{}","sf2 nam:"+nam);
			this.getMpi().setUsrnam( nam);
			log.debug("{}","mpi usrnam:"+this.getMpi().getUsrnam());
			if("new".equals(this.getEdtflg()))
			  this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( messageType);
			this.getMpi().setSubtyp( map.get("mty"));
			this.getMpi().setSndnum( map.get("sndnum"));
			if(">".equals(this.getMps().getDir()))
			{
			  this.getMpi().setOwnref( map.get("tscref"));
			  this.getMpi().setOthref( map.get("ref"));
			}
			else
			{
			  this.getMpi().setOwnref( map.get("ref"));
			  this.getMpi().setOthref( map.get("tscref"));
			  /**if(Platform.isEmpty($mpi\\sndnum))
			    {
			    /// 注：这里很特殊，非正常的格式转换（正常格式转换通过相应状态变迁实现）
			    String nextSmhInr = Platform.sdbCounter("smh");
			    String sendNumber = "GJZFQZ" + nextSmhInr;
			    String orgFileName = getMessageFullPathName();
			    log.debug("sf2 orgFileName:"+orgFileName);
			    Platform.clear($filstm);
			    Object result=Platform.invoke(
			    "cn.com.brilliance.eibs.SwiftUtils","insertSendNumber",orgFileName,$filstm.getValue(),sendNumber);
			    if(result instanceof Boolean && (Boolean)result)
			    {
			    /// 记录MPE处理信息
			    Platform.clear($mpe);
			    $mpe\\mpsinr = $mps\\inr;
			    $mpe\\chncod = $mps\\chncod;
			    $mpe\\nxtchncod = $mps\\chncod;
			    $mpe\\smhinr = $smh\\inr;
			    $mpe\\nxtsmhinr = nextSmhInr;
			    $mpe\\dattim = new Date();
			    $mpe\\prvsta = $mps\\sta;
			    $mpe\\sta =  $mps\\sta;
			    $mpe\\txt = "自动添加SWIFT报文发送流水号.";
			    $mpe\\usr = Platform.getLoginUser();
			    $mpe\\frmnam = Platform.getTransName();
			    Platform.sdbInsert($mpe);
			    /// 记录SMH信息
			    $nxtsmh\\inr = nextSmhInr;
			    $nxtsmh\\objtyp = "mpe";
			    $nxtsmh\\objinr = $mpe\\inr;
			    $nxtsmh\\crtfrm = Platform.getTransName();
			    $nxtsmh\\dattim = new Date();
			    $nxtsmh\\docpth = $datapath;
			    $nxtsmh\\docfil = nextSmhInr;
			    $nxtsmh\\docfxt = "sf2";
			    String nextFileName = getStoreFileFullPathName(nextSmhInr,"sf2");
			    Platform.mstreamSave($filstm.getValue(),nextFileName);
			    $nxtsmh\\docmd5 = Platform.fileMD5Value(nextFileName);
			    $nxtsmh\\doclen = Platform.fileSize(nextFileName);
			    $nxtsmh\\mpiinr = $mpi\\inr;
			    Platform.mdbInsert($nxtsmh);
			    /// 更新MPS信息（Update在unlock为执行）
			    $mps\\smhinr = nextSmhInr;
			    /// 更新MPI信息
			    $mpi\\sndnum = sendNumber;
			
			    if(!Platform.isEmpty($mpi\\uetr.getValue()) && "192|196|199".contains($mpi\\subtyp.getValue()) && !Platform.isEmpty($mpi\\gpi.getValue()))
			    {
			    log.info("更新对应的rof记录");
			    Platform.clear($qrtmod\\rof);
			    Platform.mdbRead($qrtmod\\rof,new Argument("megnum",EQ,$smh\\inr.getValue()));
			    if(!Platform.isEmpty($qrtmod\\rof\\inr))
			    {
			    $qrtmod.createQreInfo($qrtmod\\rof\\casnum.getValue(),"报文复核通过","X");
			    String rem = $qrtmod\\rof\\rem.getValue();
			    String newrem = rem + ";报文复核通过";
			    log.debug("msgchk.更新rof"+newrem);
			    $qrtmod\\rof\\rem = newrem;
			    $qrtmod\\rof\\megnum = $mps\\smhinr;//经过格式转化后，最终发出报文的smhinr
			    Platform.mdbUpdate($qrtmod\\rof);
			    }
			    else
			    {
			    Platform.errorCode();//清除dbRead查询无记录时的errorcode:228
			    }
			    }
			    }
			    }**/
			}
			//log.debug("sf2 mpi sndnum:"+$mpi\\sndnum.getValue());
			this.getMpi().setSndbic( formatBIC(map.get("sndbic")));
			this.getMpi().setRcvbic( formatBIC(map.get("rcvbic")));
			this.getMpi().setActbic( formatBIC(map.get("actbic")));
			this.getMpi().setT53bic( formatBIC(map.get("t53bic")));
			this.getMpi().setAct( map.get("act"));
			this.getMpi().setCur( map.get("cur"));
			this.getMpi().setRpscod( map.get("errcod"));
			this.getMpi().setAmt( MdaUtils.parseDecimal(map.get("amt")));
			this.getMpi().setValdat( MdaUtils.parseDate(map.get("vludat"),"yyMMdd"));
			this.getMpi().setGendat( new Date());
			this.getMpi().setDtlchg( map.get("dtlchg"));
			/**List<String> noTags = new ArrayList();
			  noTags.add("20");
			  object=Platform.invoke("com.brilliance.swift.MessageReader","getTextRem",fileName,noTags);
			  if(object!=null&&object instanceof String)
			  {
			  String noTag20Block4 = (String)object;
			  $mpi\\n20sha = Platform.decode(noTag20Block4.getBytes(),DECODE_SHA);
			  }
			  else**/
			this.getMpi().setN20sha( "");
			this.getMpi().setTagsha( "");
			this.getMpi().setTaglst( "");
			this.getMpi().setMsgtyp( "sf2");
			this.getMpi().setIsmx( 1);
			this.getMpi().setEndtid( map.get("endToEndId"));
			this.getMpi().setDettyp( Platform.getSwiftMxMessageType(map.get("xty")));
			if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getMpi());
			  log.debug("{}","smh mpiinr before:"+this.getSmh().getMpiinr());
			  this.getSmh().setMpiinr( this.getMpi().getInr());
			  log.debug("{}","smh mpiinr after:"+this.getSmh().getMpiinr());
			  Platform.mdbUpdate(this.getSmh());
			}
			else if("ame".equals(this.getEdtflg()))
			  Platform.mdbUpdate(this.getMpi());

			if("103|192|202COV".contains(this.getMpi().getSubtyp()) && !MdaUtils.isEmpty(this.getMpi().getUetr()))
			  saveMsg103ToGpe(map.get("addinfo"));

			return true;
		}
        /**
        *   source:smpmod.@0154.script
        */
        public boolean createMessageProcessSubjectForFxps(IStream is,String channel,String messageType,String targetChannel,String processDetail)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 创建消息处理
			  - is:IStream 原始报文数据流
			  - channal:String 报文源渠道名
			  - messageType:String 报文类型
			  - targetChannel:String 报文目标渠道（可为空）
			  - processDetail:String 处理说明
			  @ boolean 返回处理是否成功
			  */
			log.info("{}","[SAV_DOC_MPS_SMH]");
			/// 系统处理时间
			Date processDate = new Date();
			// Platform.clear($smpmod\\mps);
			MdaUtils.clear(this.getMpe());
			//Platform.clear($smpmod\\smh);
			MdaUtils.clear(this.getChn());
			MdaUtils.clear(this.getTgtchn());

			/// 获取当前渠道信息（当前渠道必须不为空）
			log.info("{}","清除Error Code："+ctx.getErrorCode());
			log.info("{}","@@@......................channel:"+channel+"............");

			readChn(this.getChn(),channel);
			if(MdaUtils.isEmpty(this.getChn()))
			{
			  log.error("{}","无法找到指定渠道的定义记录！请检查数据库配置！");
			  return false;
			}
			else if("X".equals(this.getChn().getSta()))
			{
			  log.error("{}","指定渠道已经关闭接收操作！请检查渠道状态设置！");
			  return false;
			}
			/// 最终目标渠道若不为空获取对应渠道信息
			if(!MdaUtils.isEmpty(targetChannel))
			{

			  readChn(this.getTgtchn(),targetChannel);
			  if(MdaUtils.isEmpty(this.getTgtchn()))
			    targetChannel = null;
			}

			int errorcode = ctx.getErrorCode();
			/// 获取报文记录inr
			String smhinr = null;
			//不清楚smh为何不清空，注释掉20220615
			/**
			  log.debug("msgedt smpmod smhinr:"+$smh\\inr.getValue());
			  if(!Platform.isEmpty($smh\\inr.getValue()))
			  {
			  smhinr = $smh\\inr.getValue();
			  $edtflg = "ame";
			  }
			  else
			  {
			  Platform.clear($mps);
			  Platform.clear($smh);
			  smhinr = Platform.sdbCounter("smh");
			  $edtflg = "new";
			  }
			  */
			//smilekid20220615
			MdaUtils.clear(this.getMps());
			MdaUtils.clear(this.getSmh());
			smhinr = Platform.sdbCounter("smh");
			this.setEdtflg( "new");
			//分割线
			log.debug("{}","smpmod edtflg:"+this.getEdtflg());
			/// 保存收发报处理主记录信息(MPS)
			if("A".equals(this.getChn().getTyp()))
			  this.getMps().setDir( ">"); // 源渠道为境外系统为收报
			else if("A".equals(this.getTgtchn().getTyp()))
			  this.getMps().setDir( "<"); // 目标渠道为境外系统为发报
			this.getMps().setSrcchncod( channel);
			this.getMps().setChncod( "XXX"); // 收发报内部渠道
			this.getMps().setNxtchncod( "XXX"); // 该渠道由清分处理更新
			this.getMps().setTgtchncod( targetChannel); // 目标渠道
			this.getMps().setSmhinr( smhinr);
			this.getMps().setSta( "A"); // 待自动清分状态
			this.getMps().setNxtsta( "A"); // 待自动清分状态
			this.getMps().setRspsta( "W"); //未核销状态
			this.getMps().setRcvdattim( processDate); // 接收报文时间
			this.getMps().setLstdattim( processDate); // 最近处理时间
			this.getMps().setSttdattim( MdaUtils.add(processDate,DATE_SECOND,this.getChn().getDlytim())); // 开始处理时间
			if("new".equals(this.getEdtflg()))
			{
			  log.debug("{}","[smpmod insert mps...]");
			  Platform.sdbInsert(this.getMps());
			}
			else if("ame".equals(this.getEdtflg()))
			{
			  log.debug("{}","[smpmod update mps]:"+this.getMps().getInr());
			  Platform.mdbUpdate(this.getMps());
			}
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","dbInsert&dbUpdate mps with errorcode:" + errorcode);
			  return false;
			}
			/// 保存收发报处理记录信息(MPE)
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( channel);
			this.getMpe().setNxtchncod( "XXX");
			this.getMpe().setSmhinr( smhinr);
			this.getMpe().setNxtsmhinr( smhinr);
			this.getMpe().setDattim( processDate);
			if("ame".equals(this.getEdtflg()))
			  this.getMpe().setPrvsta( "C");
			else if("new".equals(this.getEdtflg()))
			  this.getMpe().setPrvsta( ""); // 处理前状态
			this.getMpe().setSta( "A"); // 处理后状态
			this.getMpe().setTxt( processDetail);
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			log.debug("{}","[MPE_INSERT]");
			Platform.sdbInsert(this.getMpe());
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR)
			{
			  log.debug("{}","[dbInsert mpe with errorcode]:" + errorcode);
			  Platform.mdbRollback();
			  return false;
			}
			/// 保存报文信息(SMH)
			if("new".equals(this.getEdtflg()))
			{
			  this.getSmh().setInr( smhinr);
			}
			this.getSmh().setObjtyp( "mpe");
			this.getSmh().setObjinr( this.getMpe().getInr());
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( processDate);
			this.getSmh().setDocpth( this.getDatapath());
			this.getSmh().setDocfil( smhinr);
			this.getSmh().setDocfxt( messageType);
			/// 获取待保存文件全名
			String fileName = null;

			if("jfx|fxl".contains(messageType))
			{
			  fileName = getStoreFileFullPathName(smhinr, messageType);
			}
			else
			{
			  log.debug("{}","messageTypeError");
			  return false;
			}

			// 保存文件并记录MD5值和文件大小信息
			log.debug("{}","[DOC_UPLOAD]");
			Platform.mstreamSave(is,fileName);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fileName));
			this.getSmh().setDoclen( MdaUtils.fileSize(fileName));
			this.getSmh().setXxxcnt( 0);
			if("ame".equals(this.getEdtflg()))
			{
			  Platform.mdbUpdate(this.getSmh());
			  log.debug("{}","[SMH_UPDATE]");
			}
			else if("new".equals(this.getEdtflg()))
			{
			  Platform.mdbInsert(this.getSmh());
			  log.debug("{}","[SMH_INSERT]");
			}
			errorcode = ctx.getErrorCode();
			if(errorcode != NO_ERROR && errorcode != NO_MORE_ROW)
			{
			  log.debug("{}","[dbInsert smh with errorcode]:" + errorcode);
			  log.debug("{}","[DB_ROLLBACK]");
			  Platform.mdbRollback();
			  return false;
			}
			else
			{
			  log.debug("{}","[DB_COMMIT]");
			  Platform.mdbCommit();
			}
			return true;
		}
        /**
        *   source:smpmod.@0155.script
        */
        public boolean jsonCreateMessageInformation(String fileName,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析接收到的CIPS报文
			  */

			Object obj = MdaUtils.invoke("com.brilliance.jrxx.utils.CfixUtil","json2Xml",fileName);
			com.brilliance.jrxx.framework.Result result = (com.brilliance.jrxx.framework.Result) obj;
			String xml = result.getMessage();
			Map map = (Map) MdaUtils.invoke("com.brilliance.jrxx.utils.CfixUtil","json2Map",fileName);
			log.info("{}","xmlCreateMessageInformation xml="+xml);
			log.info("{}","xmlCreateMessageInformation map="+map);
			log.info("{}","before dbBegin");
			ctx.getDaoSession().dbBegin();
			// insert into mpi
			this.getMpi().setUsrnam( MdaEnv.getLoginUser());

			MdaUtils.clear(this.getMpi());
			this.getMpi().setInr( this.getMps().getInr());
			this.getMpi().setDir( this.getMps().getDir());
			this.getMpi().setMsgtyp( "CPX");
			this.getMpi().setSubtyp( (String)map.get("MesgType"));
			this.getMpi().setSndnum( (String)map.get("MesgRefID"));
			this.getMpi().setOthref( (String)map.get("MesgID"));
			this.getMpi().setOwnref( (String)map.get("MesgID"));
			if("cfad.050.001.01".equals((String)map.get("MesgType")))
			{
			  Map admininfoMap = (Map) map.get("AdminInfo");
			  Map logininfoMap = (Map) admininfoMap.get("LoginInf");
			  this.getMpi().setLoginoprtp( (String)logininfoMap.get("LoginOprTp"));
			}
			if("cfcm.001.001.01".equals((String)map.get("MesgType")))
			{
			  Map prtryDataMap = (Map)map.get("PrtryData");
			  Map msgBizDataMap = (Map)prtryDataMap.get("MsgBizData");
			  String sID = (String)msgBizDataMap.get("SID");
			  String msgTp = (String)msgBizDataMap.get("MsgTp");
			  String txTpCd = (String)msgBizDataMap.get("TxTpCd");
			  String ctgyPurpCd = (String)msgBizDataMap.get("CtgyPurpCd");
			  this.getMpi().setSid( sID);
			  this.getMpi().setMtp( msgTp);
			  this.getMpi().setTxtpcd( txTpCd);
			  this.getMpi().setCtgpcd( ctgyPurpCd);
			}
			if("cfcm.301.001.01".equals((String)map.get("MesgType")))
			{
			  Map grpHdrMap = (Map)map.get("GrpHdr");
			  String msgId = (String)grpHdrMap.get("MsgId");
			  Date creDtTm=MdaUtils.parseDate((String)grpHdrMap.get("CreDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			  Map instgPtyMap = (Map)grpHdrMap.get("InstgPty");
			  String instgDrctPty = (String)instgPtyMap.get("InstgDrctPty");
			  String instgDrctPtyLei = (String)instgPtyMap.get("InstgDrctPtyLei");
			  String instgPty = (String)instgPtyMap.get("InstgPty");
			  String instgPtyLei = (String)instgPtyMap.get("InstgPtyLei");
			  Map instdPtyMap = (Map)grpHdrMap.get("InstdPty");
			  String instdDrctPty = (String)instdPtyMap.get("InstdDrctPty");
			  String instdDrctPtyLei = (String)instdPtyMap.get("InstdDrctPtyLei");
			  String instdPty = (String)instdPtyMap.get("InstdPty");
			  String instdPtyLei = (String)instdPtyMap.get("InstdPtyLei");
			  String sysCd = (String)grpHdrMap.get("SysCd");
			  String rmk = (String)grpHdrMap.get("Rmk");

			  Map orgnlGrpHdrMap = (Map)map.get("OrgnlGrpHdr");
			  String orgnlMsgId = (String)orgnlGrpHdrMap.get("OrgnlMsgId");
			  String orgnlInstgPty = (String)orgnlGrpHdrMap.get("OrgnlInstgPty");
			  String orgnlMT = (String)orgnlGrpHdrMap.get("OrgnlMT");
			  this.getMpi().setMid( msgId);
			  this.getMpi().setCredat( creDtTm);
			  this.getMpi().setInsgdp( instgDrctPty);
			  this.getMpi().setInsdpl( instgDrctPtyLei);
			  this.getMpi().setInsgty( instgPty);
			  this.getMpi().setInsgpl( instgPtyLei);
			  this.getMpi().setInsddp( instdDrctPty);
			  this.getMpi().setInsddl( instdDrctPtyLei);
			  this.getMpi().setInsdty( instdPty);
			  this.getMpi().setInspdl( instdPtyLei);
			  this.getMpi().setSyscod( sysCd);
			  this.getMpi().setRmk( rmk);
			  this.getMpi().setOrgmid( orgnlMsgId);
			  this.getMpi().setOrginspty( orgnlInstgPty);
			  this.getMpi().setOrgmsgtyp( orgnlMT);
			}
			if("cfcm.002.001.01".equals((String)map.get("MesgType")))
			{
			  Map msgComDataMap = (Map)map.get("MsgComData");
			  String instgPty=(String)msgComDataMap.get("InstgPty");
			  String instdPty=(String)msgComDataMap.get("InstdPty");
			  Date sndDtTm=MdaUtils.parseDate((String)msgComDataMap.get("SndDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			  String msgId=(String)msgComDataMap.get("MsgId");

			  Map prtryDataMap = (Map)map.get("PrtryData");

			  Map msgBizDataMap = (Map)prtryDataMap.get("MsgBizData");
			  String sID = (String)msgBizDataMap.get("SID");
			  String msgTp = (String)msgBizDataMap.get("MsgTp");
			  String txTpCd = (String)msgBizDataMap.get("TxTpCd");
			  String ctgyPurpCd = (String)msgBizDataMap.get("CtgyPurpCd");

			  Map orgnSndInfoMap = (Map)prtryDataMap.get("OrgnSndInfo");
			  String orgnlMsgId = (String)orgnSndInfoMap.get("OrgnlMsgId");
			  String orgnlInstgPty = (String)orgnSndInfoMap.get("OrgnlInstgPty");
			  String orgnInstdPty = (String)orgnSndInfoMap.get("OrgnInstdPty");
			  Date orgnSndDtTm = MdaUtils.parseDate((String)orgnSndInfoMap.get("OrgnSndDtTm"),"yyyy-MM-dd'T'HH:mm:ss");

			  String stsCd = (String)prtryDataMap.get("StsCd");
			  String prcMsgDig = (String)prtryDataMap.get("PrcMsgDig");
			  String pspMsg = (String)prtryDataMap.get("RspMsg");

			  this.getMpi().setSid( sID);
			  this.getMpi().setMtp( msgTp);
			  this.getMpi().setTxtpcd( txTpCd);
			  this.getMpi().setCtgpcd( ctgyPurpCd);
			  this.getMpi().setOrgmid( orgnlMsgId);
			  this.getMpi().setOrginspty( orgnlInstgPty);
			  this.getMpi().setOrginapty( orgnInstdPty);
			  this.getMpi().setOrgsnddat( orgnSndDtTm);
			  this.getMpi().setStscod( stsCd);
			  this.getMpi().setPrcmsgdig( prcMsgDig);
			  this.getMpi().setRspmsg( pspMsg);
			}
			if("cfcm.302.001.01".equals((String)map.get("MesgType")))
			{
			  Map grpHdrMap = (Map)map.get("GrpHdr");
			  String msgId = (String)grpHdrMap.get("MsgId");
			  Date creDtTm = MdaUtils.parseDate((String)grpHdrMap.get("CreDtTm"),"yyyy-MM-dd'T'HH:mm:ss");
			  Map instgPtyMap = (Map)grpHdrMap.get("InstgPty");
			  String instgDrctPty = (String)instgPtyMap.get("InstgDrctPty");
			  String instgDrctPtyLei = (String)instgPtyMap.get("InstgDrctPtyLei");
			  String instgPty = (String)instgPtyMap.get("InstgPty");
			  String instgPtyLei = (String)instgPtyMap.get("InstgPtyLei");
			  Map instdPtyMap = (Map)grpHdrMap.get("InstdPty");
			  String instdDrctPty = (String)instdPtyMap.get("InstdDrctPty");
			  String instdDrctPtyLei = (String)instdPtyMap.get("InstdDrctPtyLei");
			  String instdPty = (String)instdPtyMap.get("InstdPty");
			  String instdPtyLei = (String)instdPtyMap.get("InstdPtyLei");
			  String sysCd = (String)grpHdrMap.get("SysCd");
			  String rmk = (String)grpHdrMap.get("Rmk");

			  Map orgnlGrpHdrMap = (Map)map.get("OrgnlGrpHdr");
			  String orgnlMsgId = (String)orgnlGrpHdrMap.get("OrgnlMsgId");
			  String orgnlInstgPty = (String)orgnlGrpHdrMap.get("OrgnlInstgPty");
			  String orgnlMT = (String)orgnlGrpHdrMap.get("OrgnlMT");

			  Map rspnInfMap = (Map)map.get("RspnInf");
			  String prcSts = (String)rspnInfMap.get("PrcSts");
			  String prcCd = (String)rspnInfMap.get("PrcCd");
			  String rjctInf = (String)rspnInfMap.get("RjctInf");
			  Date sttlmDt = MdaUtils.parseDate((String)rspnInfMap.get("SttlmDt"),"yyyy-MM-dd");
			  Date rcvTm = MdaUtils.parseDate((String)rspnInfMap.get("RcvTm"),"yyyy-MM-dd'T'HH:mm:ss");
			  Date trnsmtTm = MdaUtils.parseDate((String)rspnInfMap.get("TrnsmtTm"),"yyyy-MM-dd'T'HH:mm:ss");

			  Map bizStsQryRspnInfMap = (Map)map.get("BizStsQryRspnInf");
			  Map orgnlInfMap = (Map)bizStsQryRspnInfMap.get("OrgnlInf");
			  Map orgnlQrpGrpHdrMap = (Map)orgnlInfMap.get("OrgnlQrpGrpHdr");
			  String orgnlQrpMsgId = (String)orgnlQrpGrpHdrMap.get("OrgnlMsgId");
			  String orgnlQrpInstgPty = (String)orgnlQrpGrpHdrMap.get("OrgnlInstgPty");
			  String orgnlQrpMT = (String)orgnlQrpGrpHdrMap.get("OrgnlMT");

			  Map dvpRspnInfMap = (Map)bizStsQryRspnInfMap.get("DvpRspnInf");
			  String oribiztype = (String)dvpRspnInfMap.get("Oribiztype");
			  Date oriAcctdate = MdaUtils.parseDate((String)dvpRspnInfMap.get("OriAcctdate"),"yyyy-MM-dd");
			  String msgprcsts = (String)dvpRspnInfMap.get("Msgprcsts");
			  String opInfo = (String)dvpRspnInfMap.get("OpInfo");
			  Date acctdate = MdaUtils.parseDate((String)dvpRspnInfMap.get("Acctdate"),"yyyy-MM-dd");

			  Map pubInstnMpmtRspnInfMap = (Map)bizStsQryRspnInfMap.get("PubInstnMpmtRspnInf");
			  String txSts = (String)pubInstnMpmtRspnInfMap.get("TxSts");
			  String bllPaySts = (String)pubInstnMpmtRspnInfMap.get("BllPaySts");

			  String remarmk = (String)bizStsQryRspnInfMap.get("Rmk");

			  this.getMpi().setMid( msgId);
			  this.getMpi().setCredat( creDtTm);
			  this.getMpi().setInsgdp( instgDrctPty);
			  this.getMpi().setInsdpl( instgDrctPtyLei);
			  this.getMpi().setInsgty( instgPty);
			  this.getMpi().setInsgpl( instgPtyLei);
			  this.getMpi().setInsddp( instdDrctPty);
			  this.getMpi().setInsddl( instdDrctPtyLei);
			  this.getMpi().setInsdty( instdPty);
			  this.getMpi().setInspdl( instdPtyLei);
			  this.getMpi().setSyscod( sysCd);
			  this.getMpi().setRmk( rmk);
			  this.getMpi().setOrgmid( orgnlMsgId);
			  this.getMpi().setOrginspty( orgnlInstgPty);
			  this.getMpi().setOrgmsgtyp( orgnlMT);

			  this.getMpi().setPrcsts( prcSts);
			  this.getMpi().setProccd( prcCd);
			  this.getMpi().setRjcinf( rjctInf);
			  this.getMpi().setSstdat( sttlmDt);
			  this.getMpi().setRcvdat( rcvTm);
			  this.getMpi().setTrndat( trnsmtTm);
			  this.getMpi().setOrpmid( orgnlQrpMsgId);
			  this.getMpi().setOrpinspty( orgnlQrpInstgPty);
			  this.getMpi().setOrpinapty( orgnlQrpMT);
			  this.getMpi().setOrityp( oribiztype);
			  this.getMpi().setOridat( oriAcctdate);
			  this.getMpi().setOrists( msgprcsts);
			  this.getMpi().setOpinfo( opInfo);
			  this.getMpi().setOriaccdat( acctdate);
			  this.getMpi().setTrasts( txSts);
			  this.getMpi().setBllpaysts( bllPaySts);
			  this.getMpi().setRemark( remarmk);
			}
			log.info("{}","loginoprtp="+this.getMpi().getLoginoprtp());
			this.getMpi().setMsgtyp( "xml");
			this.getMpi().setSndbic( (String)map.get("OrigSenderSID"));
			this.getMpi().setRecbic( (String)map.get("OrigReceiverSID"));
			if(!MdaUtils.isEmpty(map.get("MsgComData")))
			{
			  Map msgComDataMap = (Map)map.get("MsgComData");
			  this.getMpi().setSndbic( (String)msgComDataMap.get("InstgPty"));
			  this.getMpi().setRecbic( (String)msgComDataMap.get("InstdPty"));
			}
			this.getMpi().setMsgid( (String)map.get("MesgID"));
			this.getMpi().setEtyinr( ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEty().getInr());
			log.debug("{}","sysmod-ety-inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEty().getInr());
			log.info("{}","xmlCreateMessageInformation before insert");
			ctx.getDaoSession().dbInsert(this.getMpi());
			log.info("{}","xmlCreateMessageInformation after insert");

			// update mps:更新sta，nxtsta字段值为"W"
			this.getMps().setSta( "W");
			this.getMps().setNxtsta( "W");
			ctx.getDaoSession().dbUpdate(this.getMps());

			// update smh
			this.getSmh().setCrtfrm( ctx.getTransName().substring(0,6));
			this.getSmh().setDattim( MdaUtils.today());
			if("cfad.040.001.01".equals((String)map.get("MesgType")))
			{
			  this.getSmh().setDocbase64( MdaUtils.decode(xml.getBytes(),DECODE_BASE64));
			}
			this.getSmh().setDocfxt( "xml");
			/// 获取待保存文件全名
			String inr = this.getSmh().getDocfil();
			String fullPath = getStoreFileFullPathName(inr, "xml");
			// 保存文件并记录MD5值和文件大小信息
			MdaUtils.clear(this.getFilstm());
			IStream is = this.getFilstm();
			try
			{
			  is.getOutputStream().write(xml.getBytes("utf-8"));//将报文存入流
			}
			catch(java.io.IOException ee)
			{
			  log.info("{}","xmlCreateMessageInformation 加载报文信息失败:",ee);
			  return false;
			}
			Platform.mstreamSave(is,fullPath);
			this.getSmh().setDocmd5( MdaUtils.fileMD5Value(fullPath));
			this.getSmh().setDoclen( MdaUtils.fileSize(fullPath));
			ctx.getDaoSession().dbUpdate(this.getSmh());

			// insert into mpe
			MdaUtils.clear(this.getMpe());
			this.getMpe().setChncod( "CPX");
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setNxtchncod( "CPX");
			this.getMpe().setNxtsmhinr( this.getMps().getInr());
			this.getMpe().setSta( "A");
			this.getMpe().setTxt( "发报清分");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( "");
			this.getMpe().setDattim( MdaUtils.today());
			Platform.sdbInsert(this.getMpe());
			ctx.getDaoSession().dbCommit();
			log.info("{}","mps\\dir"+this.getMps().getDir());
			String dir = this.getMps().getDir();

			return true;
		}




























































































}